//-----------------------------------------------------------------------------
// Copyright Notice
//
//   Copyright 2002 Sandia Corporation. Under the terms
//   of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
//   Government retains certain rights in this software.
//
//    Xyce(TM) Parallel Electrical Simulator
//    Copyright (C) 2002-2017 Sandia Corporation
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//
// Purpose        : 
//
// Special Notes  : 
//
// Creator        : Lawrence C Musson, SNL
//
// Creation Date  : 04/16/2014
//
//
//
//
//-----------------------------------------------------------------------------

#include <N_DEV_Specie.h>

#include <N_UTL_Math.h>
#include <string>
#include <vector>
#include <iostream>

#include <N_DEV_Const.h>

namespace Xyce {
namespace Device {


//-----------------------------------------------------------------------------
// Function      : Specie::setBCEnhancedDiffusion
// Purpose       : sets up bourgoin corbett enhancement
// Special Notes : 
// Scope         : public
// Creator       : Lawrence C Musson, SNL
// Creation Date : 04/16/2014
//-----------------------------------------------------------------------------

void Specie::setBCEnhancedDiffusion(int cI, double s, int BCCC, double hL)
{
  enhancedDiffusion = true;
  sigma = s;
  BCCarrierCharge = BCCC;
  hopLength = hL;
  carrierIndex = cI;
}

}; //namespace Device
}; //namespace Xyce
