
//-----------------------------------------------------------------------------
// Copyright Notice
//
//   Copyright 2002 Sandia Corporation. Under the terms
//   of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
//   Government retains certain rights in this software.
//
//    Xyce(TM) Parallel Electrical Simulator
//    Copyright (C) 2002-2017 Sandia Corporation
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------------------------

//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file bjt504t.va with ADMS
//                  interface for Xyce 6.6.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.6
//
// Creation Date  : Tue, 07 Mar 2017 09:15:09
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSbjt504tva.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

#include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#if defined(HAVE_UNORDERED_MAP)
#include <unordered_map>
using std::unordered_map;
#elif defined(HAVE_TR1_UNORDERED_MAP)
#include <tr1/unordered_map>
using std::tr1::unordered_map;
#else
#error neither unordered_map or tr1/unordered_map found
#endif

namespace Xyce {
namespace Device {
namespace ADMSbjt504tva {


//This is necessary because the IntPair usage can trip undefined references
const int Instance::admsNodeID_c;
const int Instance::admsNodeID_b;
const int Instance::admsNodeID_e;
const int Instance::admsNodeID_s;
const int Instance::admsNodeID_dt;
const int Instance::admsNodeID_e1;
const int Instance::admsNodeID_b1;
const int Instance::admsNodeID_b2;
const int Instance::admsNodeID_c1;
const int Instance::admsNodeID_c2;
const int Instance::admsNodeID_c3;
const int Instance::admsNodeID_c4;
const int Instance::admsNodeID_noi;
const int Instance::admsNodeID_GND;
// Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSbjt504tva::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSbjt504tva::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("MULT", static_cast<double>(1.0), &ADMSbjt504tva::Instance::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription("Multiplication factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("M", static_cast<double>(1.0), &ADMSbjt504tva::Instance::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription(" Alias for MULT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;


}

void Traits::loadModelParameters(ParametricData<ADMSbjt504tva::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSbjt504tva::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("LEVEL", static_cast<int>(504), &ADMSbjt504tva::Model::LEVEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Model level");
  p.addPar("TREF", static_cast<double>(25.0), &ADMSbjt504tva::Model::TREF)
    .setUnit(U_UNKNOWN)
    .setDescription("Reference temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DTA", static_cast<double>(0.0), &ADMSbjt504tva::Model::DTA)
    .setUnit(U_UNKNOWN)
    .setDescription("Difference between the local and global ambient temperatures")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EXMOD", static_cast<int>(1), &ADMSbjt504tva::Model::EXMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for extended modeling of the reverse current gain");
  p.addPar("EXPHI", static_cast<int>(1), &ADMSbjt504tva::Model::EXPHI)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for the distributed high-frequency effects in transient");
  p.addPar("EXAVL", static_cast<int>(0), &ADMSbjt504tva::Model::EXAVL)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for extended modeling of avalanche currents");
  p.addPar("EXSUB", static_cast<int>(0), &ADMSbjt504tva::Model::EXSUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for extended modelling of substrate currents");
  p.addPar("IS", static_cast<double>(22.0*1.0e-18), &ADMSbjt504tva::Model::IS)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-emitter saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IK", static_cast<double>(0.1), &ADMSbjt504tva::Model::IK)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-emitter high injection knee current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VER", static_cast<double>(2.5), &ADMSbjt504tva::Model::VER)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse Early voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VEF", static_cast<double>(44.0), &ADMSbjt504tva::Model::VEF)
    .setUnit(U_UNKNOWN)
    .setDescription("Forward Early voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BF", static_cast<double>(215.0), &ADMSbjt504tva::Model::BF)
    .setUnit(U_UNKNOWN)
    .setDescription("Ideal forward current gain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBF", static_cast<double>(2.7*1.0e-15), &ADMSbjt504tva::Model::IBF)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation current of the non-ideal forward base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MLF", static_cast<double>(2.0), &ADMSbjt504tva::Model::MLF)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor of the non-ideal forward base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XIBI", static_cast<double>(0.0), &ADMSbjt504tva::Model::XIBI)
    .setUnit(U_UNKNOWN)
    .setDescription("Part of ideal base current that belongs to the sidewall")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IZEB", static_cast<double>(0.0), &ADMSbjt504tva::Model::IZEB)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-factor of emitter-base Zener tunneling current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NZEB", static_cast<double>(22.0), &ADMSbjt504tva::Model::NZEB)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient of emitter-base Zener tunneling current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BRI", static_cast<double>(7.0), &ADMSbjt504tva::Model::BRI)
    .setUnit(U_UNKNOWN)
    .setDescription("Ideal reverse current gain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBR", static_cast<double>(1.0*1.0e-15), &ADMSbjt504tva::Model::IBR)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation current of the non-ideal reverse base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VLR", static_cast<double>(0.2), &ADMSbjt504tva::Model::VLR)
    .setUnit(U_UNKNOWN)
    .setDescription("Cross-over voltage of the non-ideal reverse base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XEXT", static_cast<double>(0.63), &ADMSbjt504tva::Model::XEXT)
    .setUnit(U_UNKNOWN)
    .setDescription("Part of currents and charges that belong to extrinsic region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WAVL", static_cast<double>(1.1*1.0e-6), &ADMSbjt504tva::Model::WAVL)
    .setUnit(U_UNKNOWN)
    .setDescription("Epilayer thickness used in weak-avalanche model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VAVL", static_cast<double>(3.0), &ADMSbjt504tva::Model::VAVL)
    .setUnit(U_UNKNOWN)
    .setDescription("Voltage determining curvature of avalanche current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SFH", static_cast<double>(0.3), &ADMSbjt504tva::Model::SFH)
    .setUnit(U_UNKNOWN)
    .setDescription("Current spreading factor of avalanche model when EXAVL=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RE", static_cast<double>(5.0), &ADMSbjt504tva::Model::RE)
    .setUnit(U_UNKNOWN)
    .setDescription("Emitter resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBC", static_cast<double>(23.0), &ADMSbjt504tva::Model::RBC)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant part of the base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBV", static_cast<double>(18.0), &ADMSbjt504tva::Model::RBV)
    .setUnit(U_UNKNOWN)
    .setDescription("Zero-bias value of the variable part of the base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCC", static_cast<double>(12.0), &ADMSbjt504tva::Model::RCC)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant part of the collector resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCV", static_cast<double>(150.0), &ADMSbjt504tva::Model::RCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance of the un-modulated epilayer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCRCV", static_cast<double>(1250.0), &ADMSbjt504tva::Model::SCRCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Space charge resistance of the epilayer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IHC", static_cast<double>(4.0*1.0e-3), &ADMSbjt504tva::Model::IHC)
    .setUnit(U_UNKNOWN)
    .setDescription("Critical current for velocity saturation in the epilayer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AXI", static_cast<double>(0.3), &ADMSbjt504tva::Model::AXI)
    .setUnit(U_UNKNOWN)
    .setDescription("Smoothness parameter for the onset of quasi-saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJE", static_cast<double>(73.0*1.0e-15), &ADMSbjt504tva::Model::CJE)
    .setUnit(U_UNKNOWN)
    .setDescription("Zero-bias emitter-base depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDE", static_cast<double>(0.95), &ADMSbjt504tva::Model::VDE)
    .setUnit(U_UNKNOWN)
    .setDescription("Emitter-base diffusion voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PE", static_cast<double>(0.4), &ADMSbjt504tva::Model::PE)
    .setUnit(U_UNKNOWN)
    .setDescription("Emitter-base grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCJE", static_cast<double>(0.4), &ADMSbjt504tva::Model::XCJE)
    .setUnit(U_UNKNOWN)
    .setDescription("Sidewall fraction of the emitter-base depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBEO", static_cast<double>(0.0), &ADMSbjt504tva::Model::CBEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Emitter-base overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJC", static_cast<double>(78.0*1.0e-15), &ADMSbjt504tva::Model::CJC)
    .setUnit(U_UNKNOWN)
    .setDescription("Zero-bias collector-base depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDC", static_cast<double>(0.68), &ADMSbjt504tva::Model::VDC)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-base diffusion voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PC", static_cast<double>(0.5), &ADMSbjt504tva::Model::PC)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-base grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XP", static_cast<double>(0.35), &ADMSbjt504tva::Model::XP)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant part of Cjc")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MC", static_cast<double>(0.5), &ADMSbjt504tva::Model::MC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for current modulation of CB depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCJC", static_cast<double>(32.0*1.0e-3), &ADMSbjt504tva::Model::XCJC)
    .setUnit(U_UNKNOWN)
    .setDescription("Fraction of CB depletion capacitance under the emitter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCBLX", static_cast<double>(0.0), &ADMSbjt504tva::Model::RCBLX)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance Collector Buried Layer eXtrinsic")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCBLI", static_cast<double>(0.0), &ADMSbjt504tva::Model::RCBLI)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance Collector Buried Layer Intrinsic")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBCO", static_cast<double>(0.0), &ADMSbjt504tva::Model::CBCO)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-base overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MTAU", static_cast<double>(1.0), &ADMSbjt504tva::Model::MTAU)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor of the emitter stored charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TAUE", static_cast<double>(2.0*1.0e-12), &ADMSbjt504tva::Model::TAUE)
    .setUnit(U_UNKNOWN)
    .setDescription("Minimum transit time of stored emitter charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TAUB", static_cast<double>(4.2*1.0e-12), &ADMSbjt504tva::Model::TAUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Transit time of stored base charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TEPI", static_cast<double>(41.0*1.0e-12), &ADMSbjt504tva::Model::TEPI)
    .setUnit(U_UNKNOWN)
    .setDescription("Transit time of stored epilayer charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TAUR", static_cast<double>(520.0*1.0e-12), &ADMSbjt504tva::Model::TAUR)
    .setUnit(U_UNKNOWN)
    .setDescription("Transit time of reverse extrinsic stored base charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DEG", static_cast<double>(0.0), &ADMSbjt504tva::Model::DEG)
    .setUnit(U_UNKNOWN)
    .setDescription("Bandgap difference over the base")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XREC", static_cast<double>(0.0), &ADMSbjt504tva::Model::XREC)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-factor of the recombination part of Ib1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XQB", static_cast<double>(0.33333333333333333333), &ADMSbjt504tva::Model::XQB)
    .setUnit(U_UNKNOWN)
    .setDescription("Emitter-fraction of base diffusion charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AQBO", static_cast<double>(0.3), &ADMSbjt504tva::Model::AQBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the zero-bias base charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AE", static_cast<double>(0.0), &ADMSbjt504tva::Model::AE)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the resistivity of the emitter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AB", static_cast<double>(1.0), &ADMSbjt504tva::Model::AB)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the resistivity of the base")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AEPI", static_cast<double>(2.5), &ADMSbjt504tva::Model::AEPI)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the resistivity of the epilayer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AEX", static_cast<double>(0.62), &ADMSbjt504tva::Model::AEX)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the resistivity of the extrinsic base")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AC", static_cast<double>(2.0), &ADMSbjt504tva::Model::AC)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the resistivity of the collector contact")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ACBL", static_cast<double>(2.0), &ADMSbjt504tva::Model::ACBL)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the resistivity of the collector buried layer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVGBF", static_cast<double>(50.0*1.0e-3), &ADMSbjt504tva::Model::DVGBF)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage difference of the forward current gain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVGBR", static_cast<double>(45.0*1.0e-3), &ADMSbjt504tva::Model::DVGBR)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage difference of the reverse current gain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGB", static_cast<double>(1.17), &ADMSbjt504tva::Model::VGB)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage of the base")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGC", static_cast<double>(1.18), &ADMSbjt504tva::Model::VGC)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage of the collector")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGJ", static_cast<double>(1.15), &ADMSbjt504tva::Model::VGJ)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage recombination emitter-base junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGZEB", static_cast<double>(1.15), &ADMSbjt504tva::Model::VGZEB)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage at Tref of Zener effect emitter-base junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AVGEB", static_cast<double>(4.73e-4), &ADMSbjt504tva::Model::AVGEB)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient band-gap voltage for Zener effect emitter-base junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TVGEB", static_cast<double>(636.0), &ADMSbjt504tva::Model::TVGEB)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient band-gap voltage for Zener effect emitter-base junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVGTE", static_cast<double>(0.05), &ADMSbjt504tva::Model::DVGTE)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage difference of emitter stored charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DAIS", static_cast<double>(0.0), &ADMSbjt504tva::Model::DAIS)
    .setUnit(U_UNKNOWN)
    .setDescription("Fine tuning of temperature dependence of C-E saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AF", static_cast<double>(2.0), &ADMSbjt504tva::Model::AF)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent of the Flicker-noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KF", static_cast<double>(20.0*1.0e-12), &ADMSbjt504tva::Model::KF)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker-noise coefficient of the ideal base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KFN", static_cast<double>(20.0*1.0e-12), &ADMSbjt504tva::Model::KFN)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker-noise coefficient of the non-ideal base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KAVL", static_cast<int>(0), &ADMSbjt504tva::Model::KAVL)
    .setUnit(U_UNKNOWN)
    .setDescription("Switch for white noise contribution due to avalanche");
  p.addPar("KC", static_cast<int>(0), &ADMSbjt504tva::Model::KC)
    .setUnit(U_UNKNOWN)
    .setDescription("Switch for RF correlation noise model selection");
  p.addPar("KE", static_cast<double>(0.0), &ADMSbjt504tva::Model::KE)
    .setUnit(U_UNKNOWN)
    .setDescription("Fraction of QE in excess phase shift")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FTAUN", static_cast<double>(0.0), &ADMSbjt504tva::Model::FTAUN)
    .setUnit(U_UNKNOWN)
    .setDescription("Fraction of noise transit time to total transit time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ISS", static_cast<double>(48.0*1.0e-18), &ADMSbjt504tva::Model::ISS)
    .setUnit(U_UNKNOWN)
    .setDescription("Base-substrate saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ICSS", static_cast<double>((-1.0)), &ADMSbjt504tva::Model::ICSS)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-substrate ideal saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IKS", static_cast<double>(250.0*1.0e-6), &ADMSbjt504tva::Model::IKS)
    .setUnit(U_UNKNOWN)
    .setDescription("Base-substrate high injection knee current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJS", static_cast<double>(315.0*1.0e-15), &ADMSbjt504tva::Model::CJS)
    .setUnit(U_UNKNOWN)
    .setDescription("Zero-bias collector-substrate depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDS", static_cast<double>(0.62), &ADMSbjt504tva::Model::VDS)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-substrate diffusion voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PS", static_cast<double>(0.34), &ADMSbjt504tva::Model::PS)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-substrate grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGS", static_cast<double>(1.20), &ADMSbjt504tva::Model::VGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage of the substrate")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AS", static_cast<double>(1.58), &ADMSbjt504tva::Model::AS)
    .setUnit(U_UNKNOWN)
    .setDescription("Substrate temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ASUB", static_cast<double>(2.0), &ADMSbjt504tva::Model::ASUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for mobility of minorities in the substrate")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RTH", static_cast<double>(300.0), &ADMSbjt504tva::Model::RTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTH", static_cast<double>(3.0*1.0e-9), &ADMSbjt504tva::Model::CTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ATH", static_cast<double>(0.0), &ADMSbjt504tva::Model::ATH)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MULT", static_cast<double>(1.0), &ADMSbjt504tva::Model::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription("Multiplication factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("M", static_cast<double>(1.0), &ADMSbjt504tva::Model::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription(" Alias for MULT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TYPE", static_cast<int>(1), &ADMSbjt504tva::Model::TYPE)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for NPN (1) or PNP (-1) transistor type");
  p.addPar("GMIN", static_cast<double>(1.0e-13), &ADMSbjt504tva::Model::GMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("Minimum conductance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:
  if (!(given("MULT")))
  {
    MULT = model_.MULT;
  }



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter MULT : ] 0.0,  (+inf) [
  if ( (!((MULT >0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter MULT value " << MULT << " out of range ] 0.0,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  double VGZEB_Tr;
  //Begin block initial_instance
  {
    if (((model_.TYPE)==1))
    {
      An = 7.03e7;
      Bn = 1.23e8;
    }
    else
    {
      An = 1.58e8;
      Bn = 2.04e8;
    }
    Xext1 = (1.0-(model_.XEXT));
    CTH_M = ((model_.CTH)*MULT);
    CBEO_M = ((model_.CBEO)*MULT);
    CBCO_M = ((model_.CBCO)*MULT);
    invMULT = (1.0/MULT);
    SCRCV_M = ((model_.SCRCV)*invMULT);
    KF_M = ((model_.KF)*pow(MULT,(1.0-(model_.AF))));
    KFN_M = ((model_.KFN)*pow(MULT,(1.0-((2.0*((model_.MLF)-1.0))+((model_.AF)*(2.0-(model_.MLF)))))));
    pow2_2mPE = pow(2.0,(2.0-(model_.PE)));
    pow2_PEm2 = (1.0/pow2_2mPE);
    Trk = ((model_.TREF)+273.15);
    Tamb = (admsTemperature+(model_.DTA));
    dxa = ((((model_.VGZEB)+((((model_.AVGEB)*Trk)*Trk)/(Trk+(model_.TVGEB))))-0.05)/0.1);
    if ((((model_.VGZEB)+((((model_.AVGEB)*Trk)*Trk)/(Trk+(model_.TVGEB))))<0.05))
    {
      VGZEBOK = (0.05+(0.1*log((1.0+exp(dxa.val())))));
    }
    else
    {
      VGZEBOK = (((model_.VGZEB)+((((model_.AVGEB)*Trk)*Trk)/(Trk+(model_.TVGEB))))+(0.1*log((1.0+exp((-dxa.val()))))));
    }
    VGZEBOK = VGZEBOK;
    VGZEB_Tr = (model_.VGZEB);
    inv_VGZEB_Tr = (1.0/VGZEB_Tr);
    inv_VDE = (1.0/(model_.VDE));
  }
  // End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
   const Configuration & configuration,
   const InstanceBlock & instance_block,
   Model &               model,
   const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    MULT(1.0),
    An(0.0),
    Bn(0.0),
    Trk(0.0),
    Tamb(0.0),
    pow2_2mPE(0.0),
    pow2_PEm2(0.0),
    inv_VDE(0.0),
    inv_VGZEB_Tr(0.0),
    VGZEBOK(0.0),
    invMULT(0.0),
    SCRCV_M(0.0),
    KF_M(0.0),
    KFN_M(0.0),
    CTH_M(0.0),
    Xext1(0.0),
    CBEO_M(0.0),
    CBCO_M(0.0),
    dxa(0.0),
    li_c(-1),
    li_b(-1),
    li_e(-1),
    li_s(-1),
    li_dt(-1),
    li_e1(-1),
    li_b1(-1),
    li_b2(-1),
    li_c1(-1),
    li_c2(-1),
    li_c3(-1),
    li_c4(-1),
    li_noi(-1),
    li_branch_ic(-1),
    li_branch_ib(-1),
    li_branch_ie(-1),
    li_branch_is(-1),
    li_branch_idt(-1),
    f_c1_Equ_c1_Node_Ptr(0),
    f_c1_Equ_c2_Node_Ptr(0),
    f_c2_Equ_c1_Node_Ptr(0),
    f_c2_Equ_c2_Node_Ptr(0),
    f_c1_Equ_b2_Node_Ptr(0),
    f_c2_Equ_b2_Node_Ptr(0),
    f_c1_Equ_dt_Node_Ptr(0),
    f_c2_Equ_dt_Node_Ptr(0),
    f_e1_Equ_c1_Node_Ptr(0),
    f_e1_Equ_c2_Node_Ptr(0),
    f_e1_Equ_b2_Node_Ptr(0),
    f_c2_Equ_e1_Node_Ptr(0),
    f_e1_Equ_e1_Node_Ptr(0),
    f_e1_Equ_dt_Node_Ptr(0),
    f_b1_Equ_b1_Node_Ptr(0),
    f_b1_Equ_e1_Node_Ptr(0),
    f_e1_Equ_b1_Node_Ptr(0),
    f_b1_Equ_dt_Node_Ptr(0),
    f_b2_Equ_b2_Node_Ptr(0),
    f_b2_Equ_e1_Node_Ptr(0),
    f_b2_Equ_dt_Node_Ptr(0),
    f_b2_Equ_c1_Node_Ptr(0),
    f_b2_Equ_c2_Node_Ptr(0),
    f_b1_Equ_s_Node_Ptr(0),
    f_b1_Equ_c1_Node_Ptr(0),
    f_s_Equ_s_Node_Ptr(0),
    f_s_Equ_c1_Node_Ptr(0),
    f_b1_Equ_c4_Node_Ptr(0),
    f_s_Equ_c4_Node_Ptr(0),
    f_b1_Equ_c2_Node_Ptr(0),
    f_s_Equ_c2_Node_Ptr(0),
    f_b1_Equ_b2_Node_Ptr(0),
    f_s_Equ_b2_Node_Ptr(0),
    f_s_Equ_b1_Node_Ptr(0),
    f_s_Equ_dt_Node_Ptr(0),
    f_b_Equ_s_Node_Ptr(0),
    f_b_Equ_c1_Node_Ptr(0),
    f_b_Equ_c2_Node_Ptr(0),
    f_b_Equ_b2_Node_Ptr(0),
    f_b_Equ_e1_Node_Ptr(0),
    f_s_Equ_e1_Node_Ptr(0),
    f_b_Equ_c3_Node_Ptr(0),
    f_b_Equ_c4_Node_Ptr(0),
    f_s_Equ_c3_Node_Ptr(0),
    f_b_Equ_b1_Node_Ptr(0),
    f_b_Equ_b_Node_Ptr(0),
    f_s_Equ_b_Node_Ptr(0),
    f_b_Equ_c_Node_Ptr(0),
    f_s_Equ_c_Node_Ptr(0),
    f_b_Equ_dt_Node_Ptr(0),
    f_c1_Equ_s_Node_Ptr(0),
    f_b1_Equ_c3_Node_Ptr(0),
    f_b2_Equ_c3_Node_Ptr(0),
    f_b2_Equ_c4_Node_Ptr(0),
    f_b1_Equ_b_Node_Ptr(0),
    f_b2_Equ_b_Node_Ptr(0),
    f_b2_Equ_b1_Node_Ptr(0),
    f_b1_Equ_c_Node_Ptr(0),
    f_b2_Equ_c_Node_Ptr(0),
    f_c2_Equ_c3_Node_Ptr(0),
    f_c2_Equ_c4_Node_Ptr(0),
    f_c2_Equ_b1_Node_Ptr(0),
    f_c2_Equ_b_Node_Ptr(0),
    f_c2_Equ_c_Node_Ptr(0),
    f_e_Equ_dt_Node_Ptr(0),
    f_e_Equ_e_Node_Ptr(0),
    f_e_Equ_e1_Node_Ptr(0),
    f_e1_Equ_e_Node_Ptr(0),
    f_dt_Equ_dt_Node_Ptr(0),
    f_dt_Equ_s_Node_Ptr(0),
    f_dt_Equ_c1_Node_Ptr(0),
    f_dt_Equ_b1_Node_Ptr(0),
    f_dt_Equ_e1_Node_Ptr(0),
    f_dt_Equ_e_Node_Ptr(0),
    f_dt_Equ_c3_Node_Ptr(0),
    f_dt_Equ_c4_Node_Ptr(0),
    f_dt_Equ_b2_Node_Ptr(0),
    f_dt_Equ_b_Node_Ptr(0),
    f_dt_Equ_c_Node_Ptr(0),
    f_dt_Equ_c2_Node_Ptr(0),
    f_e1_Equ_c3_Node_Ptr(0),
    f_e1_Equ_c4_Node_Ptr(0),
    f_e1_Equ_b_Node_Ptr(0),
    f_e1_Equ_c_Node_Ptr(0),
    f_c1_Equ_e1_Node_Ptr(0),
    f_c1_Equ_b1_Node_Ptr(0),
    f_c1_Equ_c4_Node_Ptr(0),
    f_c1_Equ_c3_Node_Ptr(0),
    f_c1_Equ_b_Node_Ptr(0),
    f_c1_Equ_c_Node_Ptr(0),
    f_b_Equ_e_Node_Ptr(0),
    f_e_Equ_b_Node_Ptr(0),
    f_c_Equ_b_Node_Ptr(0),
    f_c_Equ_c_Node_Ptr(0),
    f_c3_Equ_s_Node_Ptr(0),
    f_c3_Equ_c1_Node_Ptr(0),
    f_c3_Equ_c2_Node_Ptr(0),
    f_c3_Equ_b2_Node_Ptr(0),
    f_c3_Equ_e1_Node_Ptr(0),
    f_c3_Equ_c3_Node_Ptr(0),
    f_c3_Equ_c4_Node_Ptr(0),
    f_c3_Equ_b1_Node_Ptr(0),
    f_c3_Equ_b_Node_Ptr(0),
    f_c3_Equ_c_Node_Ptr(0),
    f_c3_Equ_dt_Node_Ptr(0),
    f_c_Equ_dt_Node_Ptr(0),
    f_c_Equ_c3_Node_Ptr(0),
    f_c_Equ_c4_Node_Ptr(0),
    f_c_Equ_c1_Node_Ptr(0),
    f_c_Equ_c2_Node_Ptr(0),
    f_c_Equ_b2_Node_Ptr(0),
    f_c_Equ_b1_Node_Ptr(0),
    f_c4_Equ_dt_Node_Ptr(0),
    f_c4_Equ_c4_Node_Ptr(0),
    f_c4_Equ_c1_Node_Ptr(0),
    f_c4_Equ_b2_Node_Ptr(0),
    f_c4_Equ_e1_Node_Ptr(0),
    f_c4_Equ_c2_Node_Ptr(0),
    f_c4_Equ_b1_Node_Ptr(0),
    f_c4_Equ_c3_Node_Ptr(0),
    f_c4_Equ_s_Node_Ptr(0),
    f_c4_Equ_b_Node_Ptr(0),
    f_c4_Equ_c_Node_Ptr(0),
    f_noi_Equ_c1_Node_Ptr(0),
    f_noi_Equ_c2_Node_Ptr(0),
    f_noi_Equ_b2_Node_Ptr(0),
    f_noi_Equ_e1_Node_Ptr(0),
    f_noi_Equ_dt_Node_Ptr(0),
    f_noi_Equ_noi_Node_Ptr(0),
    f_b2_Equ_noi_Node_Ptr(0),
    f_e1_Equ_noi_Node_Ptr(0),
    f_c2_Equ_noi_Node_Ptr(0),
    q_c1_Equ_c1_Node_Ptr(0),
    q_c1_Equ_c2_Node_Ptr(0),
    q_c2_Equ_c1_Node_Ptr(0),
    q_c2_Equ_c2_Node_Ptr(0),
    q_c1_Equ_b2_Node_Ptr(0),
    q_c2_Equ_b2_Node_Ptr(0),
    q_c1_Equ_dt_Node_Ptr(0),
    q_c2_Equ_dt_Node_Ptr(0),
    q_e1_Equ_c1_Node_Ptr(0),
    q_e1_Equ_c2_Node_Ptr(0),
    q_e1_Equ_b2_Node_Ptr(0),
    q_c2_Equ_e1_Node_Ptr(0),
    q_e1_Equ_e1_Node_Ptr(0),
    q_e1_Equ_dt_Node_Ptr(0),
    q_b1_Equ_b1_Node_Ptr(0),
    q_b1_Equ_e1_Node_Ptr(0),
    q_e1_Equ_b1_Node_Ptr(0),
    q_b1_Equ_dt_Node_Ptr(0),
    q_b2_Equ_b2_Node_Ptr(0),
    q_b2_Equ_e1_Node_Ptr(0),
    q_b2_Equ_dt_Node_Ptr(0),
    q_b2_Equ_c1_Node_Ptr(0),
    q_b2_Equ_c2_Node_Ptr(0),
    q_b1_Equ_s_Node_Ptr(0),
    q_b1_Equ_c1_Node_Ptr(0),
    q_s_Equ_s_Node_Ptr(0),
    q_s_Equ_c1_Node_Ptr(0),
    q_b1_Equ_c4_Node_Ptr(0),
    q_s_Equ_c4_Node_Ptr(0),
    q_b1_Equ_c2_Node_Ptr(0),
    q_s_Equ_c2_Node_Ptr(0),
    q_b1_Equ_b2_Node_Ptr(0),
    q_s_Equ_b2_Node_Ptr(0),
    q_s_Equ_b1_Node_Ptr(0),
    q_s_Equ_dt_Node_Ptr(0),
    q_b_Equ_s_Node_Ptr(0),
    q_b_Equ_c1_Node_Ptr(0),
    q_b_Equ_c2_Node_Ptr(0),
    q_b_Equ_b2_Node_Ptr(0),
    q_b_Equ_e1_Node_Ptr(0),
    q_s_Equ_e1_Node_Ptr(0),
    q_b_Equ_c3_Node_Ptr(0),
    q_b_Equ_c4_Node_Ptr(0),
    q_s_Equ_c3_Node_Ptr(0),
    q_b_Equ_b1_Node_Ptr(0),
    q_b_Equ_b_Node_Ptr(0),
    q_s_Equ_b_Node_Ptr(0),
    q_b_Equ_c_Node_Ptr(0),
    q_s_Equ_c_Node_Ptr(0),
    q_b_Equ_dt_Node_Ptr(0),
    q_c1_Equ_s_Node_Ptr(0),
    q_b1_Equ_c3_Node_Ptr(0),
    q_b2_Equ_c3_Node_Ptr(0),
    q_b2_Equ_c4_Node_Ptr(0),
    q_b1_Equ_b_Node_Ptr(0),
    q_b2_Equ_b_Node_Ptr(0),
    q_b2_Equ_b1_Node_Ptr(0),
    q_b1_Equ_c_Node_Ptr(0),
    q_b2_Equ_c_Node_Ptr(0),
    q_c2_Equ_c3_Node_Ptr(0),
    q_c2_Equ_c4_Node_Ptr(0),
    q_c2_Equ_b1_Node_Ptr(0),
    q_c2_Equ_b_Node_Ptr(0),
    q_c2_Equ_c_Node_Ptr(0),
    q_e_Equ_dt_Node_Ptr(0),
    q_e_Equ_e_Node_Ptr(0),
    q_e_Equ_e1_Node_Ptr(0),
    q_e1_Equ_e_Node_Ptr(0),
    q_dt_Equ_dt_Node_Ptr(0),
    q_dt_Equ_s_Node_Ptr(0),
    q_dt_Equ_c1_Node_Ptr(0),
    q_dt_Equ_b1_Node_Ptr(0),
    q_dt_Equ_e1_Node_Ptr(0),
    q_dt_Equ_e_Node_Ptr(0),
    q_dt_Equ_c3_Node_Ptr(0),
    q_dt_Equ_c4_Node_Ptr(0),
    q_dt_Equ_b2_Node_Ptr(0),
    q_dt_Equ_b_Node_Ptr(0),
    q_dt_Equ_c_Node_Ptr(0),
    q_dt_Equ_c2_Node_Ptr(0),
    q_e1_Equ_c3_Node_Ptr(0),
    q_e1_Equ_c4_Node_Ptr(0),
    q_e1_Equ_b_Node_Ptr(0),
    q_e1_Equ_c_Node_Ptr(0),
    q_c1_Equ_e1_Node_Ptr(0),
    q_c1_Equ_b1_Node_Ptr(0),
    q_c1_Equ_c4_Node_Ptr(0),
    q_c1_Equ_c3_Node_Ptr(0),
    q_c1_Equ_b_Node_Ptr(0),
    q_c1_Equ_c_Node_Ptr(0),
    q_b_Equ_e_Node_Ptr(0),
    q_e_Equ_b_Node_Ptr(0),
    q_c_Equ_b_Node_Ptr(0),
    q_c_Equ_c_Node_Ptr(0),
    q_c3_Equ_s_Node_Ptr(0),
    q_c3_Equ_c1_Node_Ptr(0),
    q_c3_Equ_c2_Node_Ptr(0),
    q_c3_Equ_b2_Node_Ptr(0),
    q_c3_Equ_e1_Node_Ptr(0),
    q_c3_Equ_c3_Node_Ptr(0),
    q_c3_Equ_c4_Node_Ptr(0),
    q_c3_Equ_b1_Node_Ptr(0),
    q_c3_Equ_b_Node_Ptr(0),
    q_c3_Equ_c_Node_Ptr(0),
    q_c3_Equ_dt_Node_Ptr(0),
    q_c_Equ_dt_Node_Ptr(0),
    q_c_Equ_c3_Node_Ptr(0),
    q_c_Equ_c4_Node_Ptr(0),
    q_c_Equ_c1_Node_Ptr(0),
    q_c_Equ_c2_Node_Ptr(0),
    q_c_Equ_b2_Node_Ptr(0),
    q_c_Equ_b1_Node_Ptr(0),
    q_c4_Equ_dt_Node_Ptr(0),
    q_c4_Equ_c4_Node_Ptr(0),
    q_c4_Equ_c1_Node_Ptr(0),
    q_c4_Equ_b2_Node_Ptr(0),
    q_c4_Equ_e1_Node_Ptr(0),
    q_c4_Equ_c2_Node_Ptr(0),
    q_c4_Equ_b1_Node_Ptr(0),
    q_c4_Equ_c3_Node_Ptr(0),
    q_c4_Equ_s_Node_Ptr(0),
    q_c4_Equ_b_Node_Ptr(0),
    q_c4_Equ_c_Node_Ptr(0),
    q_noi_Equ_c1_Node_Ptr(0),
    q_noi_Equ_c2_Node_Ptr(0),
    q_noi_Equ_b2_Node_Ptr(0),
    q_noi_Equ_e1_Node_Ptr(0),
    q_noi_Equ_dt_Node_Ptr(0),
    q_noi_Equ_noi_Node_Ptr(0),
    q_b2_Equ_noi_Node_Ptr(0),
    q_e1_Equ_noi_Node_Ptr(0),
    q_c2_Equ_noi_Node_Ptr(0),
    A_c1_Equ_c1_NodeOffset(-1),
    A_c1_Equ_c2_NodeOffset(-1),
    A_c2_Equ_c1_NodeOffset(-1),
    A_c2_Equ_c2_NodeOffset(-1),
    A_c1_Equ_b2_NodeOffset(-1),
    A_c2_Equ_b2_NodeOffset(-1),
    A_c1_Equ_dt_NodeOffset(-1),
    A_c2_Equ_dt_NodeOffset(-1),
    A_e1_Equ_c1_NodeOffset(-1),
    A_e1_Equ_c2_NodeOffset(-1),
    A_e1_Equ_b2_NodeOffset(-1),
    A_c2_Equ_e1_NodeOffset(-1),
    A_e1_Equ_e1_NodeOffset(-1),
    A_e1_Equ_dt_NodeOffset(-1),
    A_b1_Equ_b1_NodeOffset(-1),
    A_b1_Equ_e1_NodeOffset(-1),
    A_e1_Equ_b1_NodeOffset(-1),
    A_b1_Equ_dt_NodeOffset(-1),
    A_b2_Equ_b2_NodeOffset(-1),
    A_b2_Equ_e1_NodeOffset(-1),
    A_b2_Equ_dt_NodeOffset(-1),
    A_b2_Equ_c1_NodeOffset(-1),
    A_b2_Equ_c2_NodeOffset(-1),
    A_b1_Equ_s_NodeOffset(-1),
    A_b1_Equ_c1_NodeOffset(-1),
    A_s_Equ_s_NodeOffset(-1),
    A_s_Equ_c1_NodeOffset(-1),
    A_b1_Equ_c4_NodeOffset(-1),
    A_s_Equ_c4_NodeOffset(-1),
    A_b1_Equ_c2_NodeOffset(-1),
    A_s_Equ_c2_NodeOffset(-1),
    A_b1_Equ_b2_NodeOffset(-1),
    A_s_Equ_b2_NodeOffset(-1),
    A_s_Equ_b1_NodeOffset(-1),
    A_s_Equ_dt_NodeOffset(-1),
    A_b_Equ_s_NodeOffset(-1),
    A_b_Equ_c1_NodeOffset(-1),
    A_b_Equ_c2_NodeOffset(-1),
    A_b_Equ_b2_NodeOffset(-1),
    A_b_Equ_e1_NodeOffset(-1),
    A_s_Equ_e1_NodeOffset(-1),
    A_b_Equ_c3_NodeOffset(-1),
    A_b_Equ_c4_NodeOffset(-1),
    A_s_Equ_c3_NodeOffset(-1),
    A_b_Equ_b1_NodeOffset(-1),
    A_b_Equ_b_NodeOffset(-1),
    A_s_Equ_b_NodeOffset(-1),
    A_b_Equ_c_NodeOffset(-1),
    A_s_Equ_c_NodeOffset(-1),
    A_b_Equ_dt_NodeOffset(-1),
    A_c1_Equ_s_NodeOffset(-1),
    A_b1_Equ_c3_NodeOffset(-1),
    A_b2_Equ_c3_NodeOffset(-1),
    A_b2_Equ_c4_NodeOffset(-1),
    A_b1_Equ_b_NodeOffset(-1),
    A_b2_Equ_b_NodeOffset(-1),
    A_b2_Equ_b1_NodeOffset(-1),
    A_b1_Equ_c_NodeOffset(-1),
    A_b2_Equ_c_NodeOffset(-1),
    A_c2_Equ_c3_NodeOffset(-1),
    A_c2_Equ_c4_NodeOffset(-1),
    A_c2_Equ_b1_NodeOffset(-1),
    A_c2_Equ_b_NodeOffset(-1),
    A_c2_Equ_c_NodeOffset(-1),
    A_e_Equ_dt_NodeOffset(-1),
    A_e_Equ_e_NodeOffset(-1),
    A_e_Equ_e1_NodeOffset(-1),
    A_e1_Equ_e_NodeOffset(-1),
    A_dt_Equ_dt_NodeOffset(-1),
    A_dt_Equ_s_NodeOffset(-1),
    A_dt_Equ_c1_NodeOffset(-1),
    A_dt_Equ_b1_NodeOffset(-1),
    A_dt_Equ_e1_NodeOffset(-1),
    A_dt_Equ_e_NodeOffset(-1),
    A_dt_Equ_c3_NodeOffset(-1),
    A_dt_Equ_c4_NodeOffset(-1),
    A_dt_Equ_b2_NodeOffset(-1),
    A_dt_Equ_b_NodeOffset(-1),
    A_dt_Equ_c_NodeOffset(-1),
    A_dt_Equ_c2_NodeOffset(-1),
    A_e1_Equ_c3_NodeOffset(-1),
    A_e1_Equ_c4_NodeOffset(-1),
    A_e1_Equ_b_NodeOffset(-1),
    A_e1_Equ_c_NodeOffset(-1),
    A_c1_Equ_e1_NodeOffset(-1),
    A_c1_Equ_b1_NodeOffset(-1),
    A_c1_Equ_c4_NodeOffset(-1),
    A_c1_Equ_c3_NodeOffset(-1),
    A_c1_Equ_b_NodeOffset(-1),
    A_c1_Equ_c_NodeOffset(-1),
    A_b_Equ_e_NodeOffset(-1),
    A_e_Equ_b_NodeOffset(-1),
    A_c_Equ_b_NodeOffset(-1),
    A_c_Equ_c_NodeOffset(-1),
    A_c3_Equ_s_NodeOffset(-1),
    A_c3_Equ_c1_NodeOffset(-1),
    A_c3_Equ_c2_NodeOffset(-1),
    A_c3_Equ_b2_NodeOffset(-1),
    A_c3_Equ_e1_NodeOffset(-1),
    A_c3_Equ_c3_NodeOffset(-1),
    A_c3_Equ_c4_NodeOffset(-1),
    A_c3_Equ_b1_NodeOffset(-1),
    A_c3_Equ_b_NodeOffset(-1),
    A_c3_Equ_c_NodeOffset(-1),
    A_c3_Equ_dt_NodeOffset(-1),
    A_c_Equ_dt_NodeOffset(-1),
    A_c_Equ_c3_NodeOffset(-1),
    A_c_Equ_c4_NodeOffset(-1),
    A_c_Equ_c1_NodeOffset(-1),
    A_c_Equ_c2_NodeOffset(-1),
    A_c_Equ_b2_NodeOffset(-1),
    A_c_Equ_b1_NodeOffset(-1),
    A_c4_Equ_dt_NodeOffset(-1),
    A_c4_Equ_c4_NodeOffset(-1),
    A_c4_Equ_c1_NodeOffset(-1),
    A_c4_Equ_b2_NodeOffset(-1),
    A_c4_Equ_e1_NodeOffset(-1),
    A_c4_Equ_c2_NodeOffset(-1),
    A_c4_Equ_b1_NodeOffset(-1),
    A_c4_Equ_c3_NodeOffset(-1),
    A_c4_Equ_s_NodeOffset(-1),
    A_c4_Equ_b_NodeOffset(-1),
    A_c4_Equ_c_NodeOffset(-1),
    A_noi_Equ_c1_NodeOffset(-1),
    A_noi_Equ_c2_NodeOffset(-1),
    A_noi_Equ_b2_NodeOffset(-1),
    A_noi_Equ_e1_NodeOffset(-1),
    A_noi_Equ_dt_NodeOffset(-1),
    A_noi_Equ_noi_NodeOffset(-1),
    A_b2_Equ_noi_NodeOffset(-1),
    A_e1_Equ_noi_NodeOffset(-1),
    A_c2_Equ_noi_NodeOffset(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
  numIntVars = 8 + 0;
  numExtVars = 5;


  // Right now, we only have store for limited probes...
  setNumStoreVars(4);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 5;

  leadCurrentF.resize(5);
  leadCurrentQ.resize(5);
  
  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
  PairVector jacobianElements;
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_noi));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_noi));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_noi));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_noi));

  

  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_c1)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_c1,admsNodeID_c4));
  }
  if (collapseNode_c4)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_c4,admsNodeID_c3));
  }

  // Now generate the jacstamp from what we already have.
  // This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
  // node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
  // (for devices that have no collapsibles, this will be static, so check that it hasn't already
  // been filled in)
  if (jacStamp.empty())
  {
    int originalSize = 13+0;
    computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
  }

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
  collapseNode_c1 = false;
  collapseNode_c4 = false;
  if (((model_.RCBLX)>0.0))
  {

    if (!(((model_.RCBLI)>0.0)))
    {

      collapseNode_c1 = true;

    }

  }

  else
  {

    collapseNode_c4 = true;

    if (!(((model_.RCBLI)>0.0)))
    {

      collapseNode_c1 = true;

    }

  }


  if (collapseNode_c1)
  {
    numIntVars--;
  }
  if (collapseNode_c4)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local ID's.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;
  
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSbjt504tva::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
  }
    
  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_c = localLIDVec[nodeMap[admsNodeID_c]];
  li_b = localLIDVec[nodeMap[admsNodeID_b]];
  li_e = localLIDVec[nodeMap[admsNodeID_e]];
  li_s = localLIDVec[nodeMap[admsNodeID_s]];
  li_dt = localLIDVec[nodeMap[admsNodeID_dt]];
  li_e1 = localLIDVec[nodeMap[admsNodeID_e1]];
  li_b1 = localLIDVec[nodeMap[admsNodeID_b1]];
  li_b2 = localLIDVec[nodeMap[admsNodeID_b2]];
  li_c1 = localLIDVec[nodeMap[admsNodeID_c1]];
  li_c2 = localLIDVec[nodeMap[admsNodeID_c2]];
  li_c3 = localLIDVec[nodeMap[admsNodeID_c3]];
  li_c4 = localLIDVec[nodeMap[admsNodeID_c4]];
  li_noi = localLIDVec[nodeMap[admsNodeID_noi]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
    Xyce::dout() << "\nli_c = " << li_c << std::endl;
    Xyce::dout() << "\nli_b = " << li_b << std::endl;
    Xyce::dout() << "\nli_e = " << li_e << std::endl;
    Xyce::dout() << "\nli_s = " << li_s << std::endl;
    Xyce::dout() << "\nli_dt = " << li_dt << std::endl;
    Xyce::dout() << "\nli_e1 = " << li_e1 << std::endl;
    Xyce::dout() << "\nli_b1 = " << li_b1 << std::endl;
    Xyce::dout() << "\nli_b2 = " << li_b2 << std::endl;
    Xyce::dout() << "\nli_c1 = " << li_c1 << std::endl;
    Xyce::dout() << "\nli_c2 = " << li_c2 << std::endl;
    Xyce::dout() << "\nli_c3 = " << li_c3 << std::endl;
    Xyce::dout() << "\nli_c4 = " << li_c4 << std::endl;
    Xyce::dout() << "\nli_noi = " << li_noi << std::endl;

    Xyce::dout() << "\nEnd of ADMSbjt504tva::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
  addInternalNode(symbol_table, li_e1, getName(), "e1");
  addInternalNode(symbol_table, li_b1, getName(), "b1");
  addInternalNode(symbol_table, li_b2, getName(), "b2");
  if (!collapseNode_c1)
  {
    addInternalNode(symbol_table, li_c1, getName(), "c1");
  }
  addInternalNode(symbol_table, li_c2, getName(), "c2");
  addInternalNode(symbol_table, li_c3, getName(), "c3");
  if (!collapseNode_c4)
  {
    addInternalNode(symbol_table, li_c4, getName(), "c4");
  }
  addInternalNode(symbol_table, li_noi, getName(), "noi");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_ic, getName(), "BRANCH_DC");
    addBranchDataNode( symbol_table, li_branch_ib, getName(), "BRANCH_DB");
    addBranchDataNode( symbol_table, li_branch_ie, getName(), "BRANCH_DE");
    addBranchDataNode( symbol_table, li_branch_is, getName(), "BRANCH_D4");
    addBranchDataNode( symbol_table, li_branch_idt, getName(), "BRANCH_D5");
  }
}
 
//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());

  int numSto = stoLIDVecRef.size();
  if (numSto > 0)
  {
    int i=0;
    stoLIDVec = stoLIDVecRef;

    li_store_admsProbeID_V_b2_c1 = stoLIDVec[i++];
    li_store_admsProbeID_V_b2_c2 = stoLIDVec[i++];
    li_store_admsProbeID_V_b1_e1 = stoLIDVec[i++];
    li_store_admsProbeID_V_b1_b2 = stoLIDVec[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {    
    int i = 0;
    li_branch_ic = branchLIDVecRef[i++];
    li_branch_ib = branchLIDVecRef[i++];
    li_branch_ie = branchLIDVecRef[i++];
    li_branch_is = branchLIDVecRef[i++];
    li_branch_idt = branchLIDVecRef[i++];
  }
}
  
//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes : In initial version, we won't support mapping away nodes
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
  return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_b)];
  A_c_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c)];
  A_c_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_dt)];
  A_c_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c3)];
  A_c_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c4)];
  A_c_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c1)];
  A_c_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c2)];
  A_c_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_b2)];
  A_c_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_b1)];
  A_c_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_s)];
  A_b_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c1)];
  A_b_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c2)];
  A_b_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b2)];
  A_b_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_e1)];
  A_b_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c3)];
  A_b_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c4)];
  A_b_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b1)];
  A_b_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b)];
  A_b_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c)];
  A_b_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_dt)];
  A_b_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_e)];
  A_b_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_dt)];
  A_e_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_e)];
  A_e_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_e1)];
  A_e_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_b)];
  A_e_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_s)];
  A_s_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c1)];
  A_s_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c4)];
  A_s_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c2)];
  A_s_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_b2)];
  A_s_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_b1)];
  A_s_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_dt)];
  A_s_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_e1)];
  A_s_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c3)];
  A_s_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_b)];
  A_s_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c)];
  A_s_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_dt)];
  A_dt_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_s)];
  A_dt_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_c1)];
  A_dt_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_b1)];
  A_dt_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_e1)];
  A_dt_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_e)];
  A_dt_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_c3)];
  A_dt_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_c4)];
  A_dt_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_b2)];
  A_dt_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_b)];
  A_dt_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_c)];
  A_dt_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_c2)];
  A_dt_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c1)];
  A_e1_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c2)];
  A_e1_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_b2)];
  A_e1_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_e1)];
  A_e1_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_dt)];
  A_e1_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_b1)];
  A_e1_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_e)];
  A_e1_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c3)];
  A_e1_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c4)];
  A_e1_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_b)];
  A_e1_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c)];
  A_e1_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_noi)];
  A_e1_Equ_noi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_b1)];
  A_b1_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_e1)];
  A_b1_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_dt)];
  A_b1_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_s)];
  A_b1_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c1)];
  A_b1_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c4)];
  A_b1_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c2)];
  A_b1_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_b2)];
  A_b1_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c3)];
  A_b1_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_b)];
  A_b1_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c)];
  A_b1_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_b2)];
  A_b2_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_e1)];
  A_b2_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_dt)];
  A_b2_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c1)];
  A_b2_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c2)];
  A_b2_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c3)];
  A_b2_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c4)];
  A_b2_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_b)];
  A_b2_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_b1)];
  A_b2_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c)];
  A_b2_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_noi)];
  A_b2_Equ_noi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c1)];
  A_c1_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c2)];
  A_c1_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_b2)];
  A_c1_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_dt)];
  A_c1_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_s)];
  A_c1_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_e1)];
  A_c1_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_b1)];
  A_c1_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c4)];
  A_c1_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c3)];
  A_c1_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_b)];
  A_c1_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c)];
  A_c1_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c1)];
  A_c2_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c2)];
  A_c2_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_b2)];
  A_c2_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_dt)];
  A_c2_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_e1)];
  A_c2_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c3)];
  A_c2_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c4)];
  A_c2_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_b1)];
  A_c2_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_b)];
  A_c2_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c)];
  A_c2_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_noi)];
  A_c2_Equ_noi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_s)];
  A_c3_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c1)];
  A_c3_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c2)];
  A_c3_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_b2)];
  A_c3_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_e1)];
  A_c3_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c3)];
  A_c3_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c4)];
  A_c3_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_b1)];
  A_c3_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_b)];
  A_c3_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c)];
  A_c3_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_dt)];
  A_c3_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_dt)];
  A_c4_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c4)];
  A_c4_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c1)];
  A_c4_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_b2)];
  A_c4_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_e1)];
  A_c4_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c2)];
  A_c4_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_b1)];
  A_c4_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c3)];
  A_c4_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_s)];
  A_c4_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_b)];
  A_c4_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c)];
  A_c4_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_c1)];
  A_noi_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_c2)];
  A_noi_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_b2)];
  A_noi_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_e1)];
  A_noi_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_dt)];
  A_noi_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_noi)];
  A_noi_Equ_noi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix * dFdxMatPtr = extData.dFdxMatrixPtr;
  Linear::Matrix * dQdxMatPtr = extData.dQdxMatrixPtr;
  f_c_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_b);
  q_c_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_b);
  f_c_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_c);
  q_c_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_c);
  f_c_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_dt);
  q_c_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_dt);
  f_c_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_c3);
  q_c_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_c3);
  f_c_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_c4);
  q_c_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_c4);
  f_c_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_c1);
  q_c_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_c1);
  f_c_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_c2);
  q_c_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_c2);
  f_c_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_b2);
  q_c_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_b2);
  f_c_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_b1);
  q_c_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_b1);
  f_b_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_s);
  q_b_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_s);
  f_b_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_c1);
  q_b_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_c1);
  f_b_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_c2);
  q_b_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_c2);
  f_b_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_b2);
  q_b_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_b2);
  f_b_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_e1);
  q_b_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_e1);
  f_b_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_c3);
  q_b_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_c3);
  f_b_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_c4);
  q_b_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_c4);
  f_b_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_b1);
  q_b_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_b1);
  f_b_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_b);
  q_b_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_b);
  f_b_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_c);
  q_b_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_c);
  f_b_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_dt);
  q_b_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_dt);
  f_b_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_e);
  q_b_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_e);
  f_e_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_dt);
  q_e_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_dt);
  f_e_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_e);
  q_e_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_e);
  f_e_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_e1);
  q_e_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_e1);
  f_e_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_b);
  q_e_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_b);
  f_s_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_s);
  q_s_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_s);
  f_s_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_c1);
  q_s_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_c1);
  f_s_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_c4);
  q_s_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_c4);
  f_s_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_c2);
  q_s_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_c2);
  f_s_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_b2);
  q_s_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_b2);
  f_s_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_b1);
  q_s_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_b1);
  f_s_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_dt);
  q_s_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_dt);
  f_s_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_e1);
  q_s_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_e1);
  f_s_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_c3);
  q_s_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_c3);
  f_s_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_b);
  q_s_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_b);
  f_s_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_c);
  q_s_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_c);
  f_dt_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_dt);
  q_dt_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_dt);
  f_dt_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_s);
  q_dt_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_s);
  f_dt_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_c1);
  q_dt_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_c1);
  f_dt_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_b1);
  q_dt_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_b1);
  f_dt_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_e1);
  q_dt_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_e1);
  f_dt_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_e);
  q_dt_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_e);
  f_dt_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_c3);
  q_dt_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_c3);
  f_dt_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_c4);
  q_dt_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_c4);
  f_dt_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_b2);
  q_dt_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_b2);
  f_dt_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_b);
  q_dt_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_b);
  f_dt_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_c);
  q_dt_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_c);
  f_dt_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_c2);
  q_dt_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_c2);
  f_e1_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_c1);
  q_e1_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_c1);
  f_e1_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_c2);
  q_e1_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_c2);
  f_e1_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_b2);
  q_e1_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_b2);
  f_e1_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_e1);
  q_e1_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_e1);
  f_e1_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_dt);
  q_e1_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_dt);
  f_e1_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_b1);
  q_e1_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_b1);
  f_e1_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_e);
  q_e1_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_e);
  f_e1_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_c3);
  q_e1_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_c3);
  f_e1_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_c4);
  q_e1_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_c4);
  f_e1_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_b);
  q_e1_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_b);
  f_e1_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_c);
  q_e1_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_c);
  f_e1_Equ_noi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_noi);
  q_e1_Equ_noi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_noi);
  f_b1_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_b1);
  q_b1_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_b1);
  f_b1_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_e1);
  q_b1_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_e1);
  f_b1_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_dt);
  q_b1_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_dt);
  f_b1_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_s);
  q_b1_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_s);
  f_b1_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_c1);
  q_b1_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_c1);
  f_b1_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_c4);
  q_b1_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_c4);
  f_b1_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_c2);
  q_b1_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_c2);
  f_b1_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_b2);
  q_b1_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_b2);
  f_b1_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_c3);
  q_b1_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_c3);
  f_b1_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_b);
  q_b1_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_b);
  f_b1_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_c);
  q_b1_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_c);
  f_b2_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_b2);
  q_b2_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_b2);
  f_b2_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_e1);
  q_b2_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_e1);
  f_b2_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_dt);
  q_b2_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_dt);
  f_b2_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_c1);
  q_b2_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_c1);
  f_b2_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_c2);
  q_b2_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_c2);
  f_b2_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_c3);
  q_b2_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_c3);
  f_b2_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_c4);
  q_b2_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_c4);
  f_b2_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_b);
  q_b2_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_b);
  f_b2_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_b1);
  q_b2_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_b1);
  f_b2_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_c);
  q_b2_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_c);
  f_b2_Equ_noi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_noi);
  q_b2_Equ_noi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_noi);
  f_c1_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_c1);
  q_c1_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_c1);
  f_c1_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_c2);
  q_c1_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_c2);
  f_c1_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_b2);
  q_c1_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_b2);
  f_c1_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_dt);
  q_c1_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_dt);
  f_c1_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_s);
  q_c1_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_s);
  f_c1_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_e1);
  q_c1_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_e1);
  f_c1_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_b1);
  q_c1_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_b1);
  f_c1_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_c4);
  q_c1_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_c4);
  f_c1_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_c3);
  q_c1_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_c3);
  f_c1_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_b);
  q_c1_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_b);
  f_c1_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_c);
  q_c1_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_c);
  f_c2_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_c1);
  q_c2_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_c1);
  f_c2_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_c2);
  q_c2_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_c2);
  f_c2_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_b2);
  q_c2_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_b2);
  f_c2_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_dt);
  q_c2_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_dt);
  f_c2_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_e1);
  q_c2_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_e1);
  f_c2_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_c3);
  q_c2_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_c3);
  f_c2_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_c4);
  q_c2_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_c4);
  f_c2_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_b1);
  q_c2_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_b1);
  f_c2_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_b);
  q_c2_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_b);
  f_c2_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_c);
  q_c2_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_c);
  f_c2_Equ_noi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_noi);
  q_c2_Equ_noi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_noi);
  f_c3_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_s);
  q_c3_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_s);
  f_c3_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_c1);
  q_c3_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_c1);
  f_c3_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_c2);
  q_c3_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_c2);
  f_c3_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_b2);
  q_c3_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_b2);
  f_c3_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_e1);
  q_c3_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_e1);
  f_c3_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_c3);
  q_c3_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_c3);
  f_c3_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_c4);
  q_c3_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_c4);
  f_c3_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_b1);
  q_c3_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_b1);
  f_c3_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_b);
  q_c3_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_b);
  f_c3_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_c);
  q_c3_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_c);
  f_c3_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_dt);
  q_c3_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_dt);
  f_c4_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_dt);
  q_c4_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_dt);
  f_c4_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_c4);
  q_c4_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_c4);
  f_c4_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_c1);
  q_c4_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_c1);
  f_c4_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_b2);
  q_c4_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_b2);
  f_c4_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_e1);
  q_c4_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_e1);
  f_c4_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_c2);
  q_c4_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_c2);
  f_c4_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_b1);
  q_c4_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_b1);
  f_c4_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_c3);
  q_c4_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_c3);
  f_c4_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_s);
  q_c4_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_s);
  f_c4_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_b);
  q_c4_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_b);
  f_c4_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_c);
  q_c4_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_c);
  f_noi_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_noi,li_c1);
  q_noi_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_noi,li_c1);
  f_noi_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_noi,li_c2);
  q_noi_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_noi,li_c2);
  f_noi_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_noi,li_b2);
  q_noi_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_noi,li_b2);
  f_noi_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_noi,li_e1);
  q_noi_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_noi,li_e1);
  f_noi_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_noi,li_dt);
  q_noi_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_noi,li_dt);
  f_noi_Equ_noi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_noi,li_noi);
  q_noi_Equ_noi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_noi,li_noi);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
  (*extData.daeFVectorPtr)[li_c] += staticContributions[admsNodeID_c].val();
  (*extData.daeFVectorPtr)[li_b] += staticContributions[admsNodeID_b].val();
  (*extData.daeFVectorPtr)[li_e] += staticContributions[admsNodeID_e].val();
  (*extData.daeFVectorPtr)[li_s] += staticContributions[admsNodeID_s].val();
  (*extData.daeFVectorPtr)[li_dt] += staticContributions[admsNodeID_dt].val();
  (*extData.daeFVectorPtr)[li_e1] += staticContributions[admsNodeID_e1].val();
  (*extData.daeFVectorPtr)[li_b1] += staticContributions[admsNodeID_b1].val();
  (*extData.daeFVectorPtr)[li_b2] += staticContributions[admsNodeID_b2].val();
  (*extData.daeFVectorPtr)[li_c1] += staticContributions[admsNodeID_c1].val();
  (*extData.daeFVectorPtr)[li_c2] += staticContributions[admsNodeID_c2].val();
  (*extData.daeFVectorPtr)[li_c3] += staticContributions[admsNodeID_c3].val();
  (*extData.daeFVectorPtr)[li_c4] += staticContributions[admsNodeID_c4].val();
  (*extData.daeFVectorPtr)[li_noi] += staticContributions[admsNodeID_noi].val();

  if (getDeviceOptions().voltageLimiterFlag && !origFlag)
  {
    double *dFdxdVp = extData.dFdxdVpVectorRawPtr;
    dFdxdVp[li_c] += Jdxp_static[admsNodeID_c];
    dFdxdVp[li_b] += Jdxp_static[admsNodeID_b];
    dFdxdVp[li_e] += Jdxp_static[admsNodeID_e];
    dFdxdVp[li_s] += Jdxp_static[admsNodeID_s];
    dFdxdVp[li_dt] += Jdxp_static[admsNodeID_dt];
    dFdxdVp[li_e1] += Jdxp_static[admsNodeID_e1];
    dFdxdVp[li_b1] += Jdxp_static[admsNodeID_b1];
    dFdxdVp[li_b2] += Jdxp_static[admsNodeID_b2];
    dFdxdVp[li_c1] += Jdxp_static[admsNodeID_c1];
    dFdxdVp[li_c2] += Jdxp_static[admsNodeID_c2];
    dFdxdVp[li_c3] += Jdxp_static[admsNodeID_c3];
    dFdxdVp[li_c4] += Jdxp_static[admsNodeID_c4];
    dFdxdVp[li_noi] += Jdxp_static[admsNodeID_noi];


  }

  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;

    leadF[li_branch_ic] = leadCurrentF[admsNodeID_c];
    leadF[li_branch_ib] = leadCurrentF[admsNodeID_b];
    leadF[li_branch_ie] = leadCurrentF[admsNodeID_e];
    leadF[li_branch_is] = leadCurrentF[admsNodeID_s];
    leadF[li_branch_idt] = leadCurrentF[admsNodeID_dt];

    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.
    
    double * solVec = extData.nextSolVectorRawPtr;
    double * junctionV = extData.nextJunctionVCompRawPtr;
    junctionV[li_branch_ic] = solVec[li_c] - solVec[li_e];
    junctionV[li_branch_ib] = solVec[li_b] - solVec[li_e];
          
  }  
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
  (*extData.daeQVectorPtr)[li_c] += dynamicContributions[admsNodeID_c].val();
  (*extData.daeQVectorPtr)[li_b] += dynamicContributions[admsNodeID_b].val();
  (*extData.daeQVectorPtr)[li_e] += dynamicContributions[admsNodeID_e].val();
  (*extData.daeQVectorPtr)[li_s] += dynamicContributions[admsNodeID_s].val();
  (*extData.daeQVectorPtr)[li_dt] += dynamicContributions[admsNodeID_dt].val();
  (*extData.daeQVectorPtr)[li_e1] += dynamicContributions[admsNodeID_e1].val();
  (*extData.daeQVectorPtr)[li_b1] += dynamicContributions[admsNodeID_b1].val();
  (*extData.daeQVectorPtr)[li_b2] += dynamicContributions[admsNodeID_b2].val();
  (*extData.daeQVectorPtr)[li_c1] += dynamicContributions[admsNodeID_c1].val();
  (*extData.daeQVectorPtr)[li_c2] += dynamicContributions[admsNodeID_c2].val();
  (*extData.daeQVectorPtr)[li_c3] += dynamicContributions[admsNodeID_c3].val();
  (*extData.daeQVectorPtr)[li_c4] += dynamicContributions[admsNodeID_c4].val();
  (*extData.daeQVectorPtr)[li_noi] += dynamicContributions[admsNodeID_noi].val();

  if (getDeviceOptions().voltageLimiterFlag && !origFlag)
  {
    double *dQdxdVp = extData.dQdxdVpVectorRawPtr;
    dQdxdVp[li_c] += Jdxp_dynamic[admsNodeID_c];
    dQdxdVp[li_b] += Jdxp_dynamic[admsNodeID_b];
    dQdxdVp[li_e] += Jdxp_dynamic[admsNodeID_e];
    dQdxdVp[li_s] += Jdxp_dynamic[admsNodeID_s];
    dQdxdVp[li_dt] += Jdxp_dynamic[admsNodeID_dt];
    dQdxdVp[li_e1] += Jdxp_dynamic[admsNodeID_e1];
    dQdxdVp[li_b1] += Jdxp_dynamic[admsNodeID_b1];
    dQdxdVp[li_b2] += Jdxp_dynamic[admsNodeID_b2];
    dQdxdVp[li_c1] += Jdxp_dynamic[admsNodeID_c1];
    dQdxdVp[li_c2] += Jdxp_dynamic[admsNodeID_c2];
    dQdxdVp[li_c3] += Jdxp_dynamic[admsNodeID_c3];
    dQdxdVp[li_c4] += Jdxp_dynamic[admsNodeID_c4];
    dQdxdVp[li_noi] += Jdxp_dynamic[admsNodeID_noi];

  }

  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;

    leadQ[li_branch_ic] = leadCurrentQ[admsNodeID_c];
    leadQ[li_branch_ib] = leadCurrentQ[admsNodeID_b];
    leadQ[li_branch_ie] = leadCurrentQ[admsNodeID_e];
    leadQ[li_branch_is] = leadCurrentQ[admsNodeID_s];
    leadQ[li_branch_idt] = leadCurrentQ[admsNodeID_dt];
  }  
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.

  double * stoVec = extData.nextStoVectorRawPtr;
  // Also need to save limited voltage drops
  // This formulation assumes that we have *always* written the
  // limited voltages back into the probeVars[] array.

  stoVec[li_store_admsProbeID_V_b2_c1] = probeVars[admsProbeID_V_b2_c1].val();
  stoVec[li_store_admsProbeID_V_b2_c2] = probeVars[admsProbeID_V_b2_c2].val();
  stoVec[li_store_admsProbeID_V_b1_e1] = probeVars[admsProbeID_V_b1_e1].val();
  stoVec[li_store_admsProbeID_V_b1_b2] = probeVars[admsProbeID_V_b1_b2].val();

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one bjt504tva instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSbjt504tva::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  AdmsFadType common;
  AdmsFadType powerREC;
  AdmsFadType powerRBC;
  AdmsFadType powerRCCxx;
  AdmsFadType powerRCCex;
  AdmsFadType powerRCCin;
  AdmsFadType powerRBV;
  AdmsFadType In_N;
  AdmsFadType powerCCS;
  AdmsFadType Gem_N;
  AdmsFadType powerIIS;
  AdmsFadType Taub_N;
  AdmsFadType taun;
  AdmsFadType powerFBCS;
  AdmsFadType powerFBC1fB1;
  double exponentFBC1fB2;
  AdmsFadType powerFBC1fB2;
  AdmsFadType powerEBSCS;
  AdmsFadType powerEBSC1f;
  AdmsFadType powerRBCS;
  AdmsFadType powerRBC1f;
  AdmsFadType powerExCS;
  AdmsFadType powerExC1f;
  AdmsFadType powerExCSMOD;
  AdmsFadType powerExC1fMOD;
  AdmsFadType powerSubsCS_B1S;
  AdmsFadType powerSubsCS_BS;
  AdmsFadType Vb2c1;
  AdmsFadType Vb2c2;
  AdmsFadType Vb2e1;
  AdmsFadType Vb1e1;
  AdmsFadType Vb1b2;
  AdmsFadType Vsc1;
  AdmsFadType Vc1c2;
  AdmsFadType Vee1;
  AdmsFadType Vbb1;
  AdmsFadType Vbe;
  AdmsFadType Vbc;
  AdmsFadType Vc4c1;
  AdmsFadType Vc3c4;
  AdmsFadType Vb1c4;
  AdmsFadType Vcc3;
  AdmsFadType Vbc3;
  AdmsFadType Vsc4;
  AdmsFadType Vsc3;
  double expl;
  AdmsFadType eVb2c2;
  AdmsFadType eVb2e1;
  AdmsFadType eVb1e1;
  AdmsFadType eVb1c4;
  AdmsFadType eVb1b2;
  AdmsFadType eVbc3;
  AdmsFadType eVsc1;
  AdmsFadType eVsc3;
  AdmsFadType eVsc4;
  AdmsFadType eVbc3VDC;
  AdmsFadType eVb1c4VDC;
  AdmsFadType eVb2c2VDC;
  AdmsFadType eVb2c1VDC;
  AdmsFadType K0;
  AdmsFadType Kw;
  AdmsFadType pW;
  AdmsFadType Ec;
  AdmsFadType Ic1c2;
  AdmsFadType pav;
  AdmsFadType tmpV;
  AdmsFadType Vqs_th;
  AdmsFadType eps_VDC;
  AdmsFadType eps2;
  AdmsFadType x2;
  AdmsFadType Vqs;
  AdmsFadType Iqs;
  AdmsFadType Ic1c2_Iqs;
  AdmsFadType alpha1;
  AdmsFadType alpha;
  AdmsFadType vyi;
  AdmsFadType yi;
  AdmsFadType xi_w;
  AdmsFadType gp0;
  AdmsFadType gp0_help;
  AdmsFadType gp02;
  AdmsFadType sqr_arg;
  AdmsFadType p0star;
  AdmsFadType eVb2c2star;
  AdmsFadType B1;
  AdmsFadType B2;
  AdmsFadType Vxi0;
  AdmsFadType Vch;
  AdmsFadType Icap;
  AdmsFadType Icap_IHC;
  AdmsFadType Vfe;
  AdmsFadType a_VDE;
  AdmsFadType Vje;
  AdmsFadType E0BE;
  AdmsFadType Vte;
  AdmsFadType Vjunc;
  AdmsFadType bjc;
  AdmsFadType Vfc;
  AdmsFadType Vjc;
  AdmsFadType fI;
  AdmsFadType Vcv;
  AdmsFadType Vtc;
  AdmsFadType If0;
  AdmsFadType f1;
  AdmsFadType n0;
  AdmsFadType f2;
  AdmsFadType nB;
  AdmsFadType termE;
  AdmsFadType termC;
  AdmsFadType q0I;
  AdmsFadType q1I;
  AdmsFadType qBI;
  AdmsFadType Ir;
  AdmsFadType If;
  AdmsFadType In;
  AdmsFadType Ibf0;
  AdmsFadType Ib1;
  AdmsFadType Ib1_s;
  AdmsFadType tmpExp;
  AdmsFadType Ib2;
  AdmsFadType Ib3;
  AdmsFadType eZEB;
  AdmsFadType x;
  AdmsFadType dE0BE;
  AdmsFadType edZEB;
  AdmsFadType DZEB;
  AdmsFadType Izteb;
  AdmsFadType g1;
  AdmsFadType g2;
  AdmsFadType nBex;
  AdmsFadType pWex;
  AdmsFadType Iex;
  AdmsFadType Isub;
  AdmsFadType Isf;
  AdmsFadType XIex;
  AdmsFadType XIsub;
  AdmsFadType Xg1;
  AdmsFadType XnBex;
  AdmsFadType XIMex;
  AdmsFadType XIMsub;
  AdmsFadType Vex_bias;
  AdmsFadType Vex;
  AdmsFadType vdif;
  AdmsFadType VBex;
  AdmsFadType Fex;
  AdmsFadType q0Q;
  AdmsFadType q1Q;
  AdmsFadType qBQ;
  AdmsFadType Rb2;
  AdmsFadType Ib1b2;
  AdmsFadType Iavl;
  AdmsFadType Gem;
  double dEdx0;
  AdmsFadType xd;
  AdmsFadType xi_w1;
  AdmsFadType Weff;
  AdmsFadType Wd;
  AdmsFadType Eav;
  AdmsFadType E0;
  AdmsFadType SHw;
  double Efi;
  AdmsFadType Ew;
  AdmsFadType Em;
  AdmsFadType EmEav_Em;
  AdmsFadType lambda;
  AdmsFadType Gmax;
  AdmsFadType Vb2c2star;
  AdmsFadType power;
  AdmsFadType Qte;
  AdmsFadType Vje_s;
  AdmsFadType Qte_s;
  AdmsFadType Qtc;
  AdmsFadType Qb0;
  AdmsFadType Qbe_qs;
  AdmsFadType Qbc_qs;
  AdmsFadType a_VDC;
  AdmsFadType Vjcex;
  AdmsFadType Vtexv;
  AdmsFadType Qtex;
  AdmsFadType XVjcex;
  AdmsFadType XVtexv;
  AdmsFadType XQtex;
  AdmsFadType a_VDS;
  AdmsFadType Vfs;
  AdmsFadType Vjs;
  AdmsFadType Qts;
  AdmsFadType Qe0;
  AdmsFadType Qe_qs;
  AdmsFadType Qepi0;
  AdmsFadType Qepi;
  AdmsFadType Qex;
  AdmsFadType XQex;
  AdmsFadType Xg2;
  AdmsFadType XpWex;
  AdmsFadType Qb1b2;
  AdmsFadType dVteVje;
  AdmsFadType Vb2e1Vfe;
  AdmsFadType dVjeVb2e1;
  AdmsFadType dVteVb2e1;
  AdmsFadType dQteVb2e1;
  AdmsFadType dn0Vb2e1;
  AdmsFadType dQbeVb2e1;
  AdmsFadType dQeVb2e1;
  AdmsFadType Qe;
  AdmsFadType Qbe_qs_eff;
  AdmsFadType Qbc;
  AdmsFadType Qbe;
  double RTH_Tamb_M;
  AdmsFadType GCCin_TM;
  AdmsFadType GCCex_TM;
  AdmsFadType GCCxx_TM;
  AdmsFadType RCV_TM;
  AdmsFadType RCCin_TM;
  AdmsFadType RCCex_TM;
  AdmsFadType RCCxx_TM;
  AdmsFadType RBV_TM;
  AdmsFadType RBC_TM;
  AdmsFadType RE_TM;
  AdmsFadType CJS_TM;
  AdmsFadType CJC_TM;
  AdmsFadType CJE_TM;
  AdmsFadType IKS_TM;
  AdmsFadType ICSS_TM;
  AdmsFadType ISS_TM;
  double IHC_M;
  AdmsFadType IZEB_TM;
  AdmsFadType IBR_TM;
  AdmsFadType IBF_TM;
  AdmsFadType IK_TM;
  AdmsFadType IS_TM;
  double RTH_Tamb;
  AdmsFadType DEG_T;
  AdmsFadType BnT;
  AdmsFadType Tk300;
  AdmsFadType TAUR_T;
  AdmsFadType TEPI_T;
  AdmsFadType TAUB_T;
  AdmsFadType TAUE_T;
  AdmsFadType IKS_T;
  AdmsFadType ICSS_T;
  AdmsFadType ISS_T;
  AdmsFadType VER_T;
  AdmsFadType VEF_T;
  AdmsFadType IZEB_T;
  AdmsFadType nZEB_T;
  AdmsFadType y;
  AdmsFadType tempx;
  AdmsFadType IBR_T;
  AdmsFadType IBF_T;
  AdmsFadType IK_T;
  AdmsFadType IS_T;
  AdmsFadType BRI_T;
  AdmsFadType BF_T;
  AdmsFadType RCV_T;
  AdmsFadType RCCin_T;
  AdmsFadType RCCex_T;
  AdmsFadType RCCxx_T;
  AdmsFadType RBC_T;
  AdmsFadType RBV_T;
  AdmsFadType RE_T;
  AdmsFadType XP_T;
  AdmsFadType CJC_T;
  AdmsFadType CJCscaleINV;
  AdmsFadType CJCscale;
  AdmsFadType CJS_T;
  AdmsFadType CJE_T;
  AdmsFadType CJE_T_div_CJE;
  AdmsFadType inv_VDE_T;
  AdmsFadType VDS_T;
  AdmsFadType UdsT;
  AdmsFadType VDC_T;
  AdmsFadType UdcT;
  AdmsFadType VDE_T;
  AdmsFadType UdeT;
  AdmsFadType VGZEB_T;
  AdmsFadType lntN;
  AdmsFadType VdtINV;
  double VtrINV;
  AdmsFadType VtINV;
  double Vtr;
  AdmsFadType Vt;
  AdmsFadType tN;
  AdmsFadType Tk;
  AdmsFadType Vdt;
  AdmsFadType Tki;
  // temporary variables for limiting
  double Vb1b2_orig,Vb1b2_limited,Vb1b2_old;
  double Vb1e1_orig,Vb1e1_limited,Vb1e1_old;
  double Vb2c2_orig,Vb2c2_limited,Vb2c2_old;
  double Vb2c1_orig,Vb2c1_limited,Vb2c1_old;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (16))
  {
    probeVars.resize(16);
    staticContributions.resize(13+0);
    dynamicContributions.resize(13+0);
    probeDiffs.resize(16,0.0);
    Jdxp_static.resize(13+0);
    Jdxp_dynamic.resize(13+0);
  }

  noiseContribsPower.resize(26);
  noiseContribsExponent.resize(26);
  
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 13+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
    Jdxp_static[i]=0;
    Jdxp_dynamic[i]=0;
  }

  for (int i=0; i < 16 ; ++i)
  {
    probeDiffs[i] = 0.0;
  }
  // extract solution variables and set as Fad independent variables.
  probeVars[admsProbeID_V_noi_GND] = (*solVectorPtr)[li_noi];
  probeVars[admsProbeID_V_noi_GND].diff(admsProbeID_V_noi_GND,16);
  probeVars[admsProbeID_V_c3_c1] = (*solVectorPtr)[li_c3] - (*solVectorPtr)[li_c1];
  probeVars[admsProbeID_V_c3_c1].diff(admsProbeID_V_c3_c1,16);
  probeVars[admsProbeID_V_c3_c4] = (*solVectorPtr)[li_c3] - (*solVectorPtr)[li_c4];
  probeVars[admsProbeID_V_c3_c4].diff(admsProbeID_V_c3_c4,16);
  probeVars[admsProbeID_V_c4_c1] = (*solVectorPtr)[li_c4] - (*solVectorPtr)[li_c1];
  probeVars[admsProbeID_V_c4_c1].diff(admsProbeID_V_c4_c1,16);
  probeVars[admsProbeID_V_b_c] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_c];
  probeVars[admsProbeID_V_b_c].diff(admsProbeID_V_b_c,16);
  probeVars[admsProbeID_V_b_e] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_e];
  probeVars[admsProbeID_V_b_e].diff(admsProbeID_V_b_e,16);
  probeVars[admsProbeID_V_b_b1] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_b1];
  probeVars[admsProbeID_V_b_b1].diff(admsProbeID_V_b_b1,16);
  probeVars[admsProbeID_V_e_e1] = (*solVectorPtr)[li_e] - (*solVectorPtr)[li_e1];
  probeVars[admsProbeID_V_e_e1].diff(admsProbeID_V_e_e1,16);
  probeVars[admsProbeID_V_c1_c2] = (*solVectorPtr)[li_c1] - (*solVectorPtr)[li_c2];
  probeVars[admsProbeID_V_c1_c2].diff(admsProbeID_V_c1_c2,16);
  probeVars[admsProbeID_V_s_c1] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_c1];
  probeVars[admsProbeID_V_s_c1].diff(admsProbeID_V_s_c1,16);
  probeVars[admsProbeID_V_b1_b2] = (*solVectorPtr)[li_b1] - (*solVectorPtr)[li_b2];
  probeVars[admsProbeID_V_b1_b2].diff(admsProbeID_V_b1_b2,16);
  probeVars[admsProbeID_V_b1_e1] = (*solVectorPtr)[li_b1] - (*solVectorPtr)[li_e1];
  probeVars[admsProbeID_V_b1_e1].diff(admsProbeID_V_b1_e1,16);
  probeVars[admsProbeID_V_b2_e1] = (*solVectorPtr)[li_b2] - (*solVectorPtr)[li_e1];
  probeVars[admsProbeID_V_b2_e1].diff(admsProbeID_V_b2_e1,16);
  probeVars[admsProbeID_V_b2_c2] = (*solVectorPtr)[li_b2] - (*solVectorPtr)[li_c2];
  probeVars[admsProbeID_V_b2_c2].diff(admsProbeID_V_b2_c2,16);
  probeVars[admsProbeID_V_b2_c1] = (*solVectorPtr)[li_b2] - (*solVectorPtr)[li_c1];
  probeVars[admsProbeID_V_b2_c1].diff(admsProbeID_V_b2_c1,16);
  probeVars[admsProbeID_V_dt_GND] = (*solVectorPtr)[li_dt];
  probeVars[admsProbeID_V_dt_GND].diff(admsProbeID_V_dt_GND,16);


  // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
  probeVars[admsProbeID_V_b1_b2] *= (model_.TYPE);
  probeVars[admsProbeID_V_b1_e1] *= (model_.TYPE);
  probeVars[admsProbeID_V_b2_c2] *= (model_.TYPE);
  probeVars[admsProbeID_V_b2_c1] *= (model_.TYPE);

  // Copy probes into limiting vars

  Vb1b2_orig = Vb1b2_limited = probeVars[admsProbeID_V_b1_b2].val();
  probeDiffs[admsProbeID_V_b1_b2] = 0.0;
  Vb1e1_orig = Vb1e1_limited = probeVars[admsProbeID_V_b1_e1].val();
  probeDiffs[admsProbeID_V_b1_e1] = 0.0;
  Vb2c2_orig = Vb2c2_limited = probeVars[admsProbeID_V_b2_c2].val();
  probeDiffs[admsProbeID_V_b2_c2] = 0.0;
  Vb2c1_orig = Vb2c1_limited = probeVars[admsProbeID_V_b2_c1].val();
  probeDiffs[admsProbeID_V_b2_c1] = 0.0;

  origFlag = true;

  if (getSolverState().newtonIter == 0)
  {

    if (!(getSolverState().dcopFlag)||(getSolverState().locaEnabledFlag && getSolverState().dcopFlag))
    {
      Vb1b2_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_b1_b2];
      Vb1e1_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_b1_e1];
      Vb2c2_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_b2_c2];
      Vb2c1_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_b2_c1];
    }
    else
    {
      Vb1b2_old = Vb1b2_limited;
      Vb1e1_old = Vb1e1_limited;
      Vb2c2_old = Vb2c2_limited;
      Vb2c1_old = Vb2c1_limited;
    }
  }
  else
  {
    Vb1b2_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_b1_b2];
    Vb1e1_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_b1_e1];
    Vb2c2_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_b2_c2];
    Vb2c1_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_b2_c1];
  }
  // -- code converted from analog/code block
  Tki = (probeVars[admsProbeID_V_dt_GND]);
  if ((Tki<0.0))
  {
    Tki = (-log((1.0-Tki)));
  }
  if ((Tki<200.0))
  {
    Vdt = Tki;
  }
  else
  {
    Vdt = (200.0+log((1.0+(Tki-200.0))));
  }
  Vdt = Vdt;
  Tk = (Tamb+Vdt);
  tN = (Tk/Trk);
  Vt = (8.61708691805812512584e-5*Tk);
  Vtr = (8.61708691805812512584e-5*Trk);
  VtINV = (1.0/Vt);
  VtrINV = (1.0/Vtr);
  VdtINV = (VtINV-VtrINV);
  lntN = log(tN);
  dxa = (((VGZEBOK-((((model_.AVGEB)*Tk)*Tk)/(Tk+(model_.TVGEB))))-0.05)/0.1);
  if (((VGZEBOK-((((model_.AVGEB)*Tk)*Tk)/(Tk+(model_.TVGEB))))<0.05))
  {
    VGZEB_T = (0.05+(0.1*log((1.0+exp(dxa)))));
  }
  else
  {
    VGZEB_T = ((VGZEBOK-((((model_.AVGEB)*Tk)*Tk)/(Tk+(model_.TVGEB))))+(0.1*log((1.0+exp((-dxa))))));
  }
  VGZEB_T = VGZEB_T;
  UdeT = (((((-3.0)*Vt)*log(tN))+((model_.VDE)*tN))+((1.0-tN)*(model_.VGB)));
  dxa = ((0.05-UdeT)/Vt);
  if ((0.05<UdeT))
  {
    VDE_T = (UdeT+(Vt*log((1.0+exp(dxa)))));
  }
  else
  {
    VDE_T = (0.05+(Vt*log((1.0+exp((-dxa))))));
  }
  VDE_T = VDE_T;
  UdcT = (((((-3.0)*Vt)*log(tN))+((model_.VDC)*tN))+((1.0-tN)*(model_.VGC)));
  dxa = ((0.05-UdcT)/Vt);
  if ((0.05<UdcT))
  {
    VDC_T = (UdcT+(Vt*log((1.0+exp(dxa)))));
  }
  else
  {
    VDC_T = (0.05+(Vt*log((1.0+exp((-dxa))))));
  }
  VDC_T = VDC_T;
  UdsT = (((((-3.0)*Vt)*log(tN))+((model_.VDS)*tN))+((1.0-tN)*(model_.VGS)));
  dxa = ((0.05-UdsT)/Vt);
  if ((0.05<UdsT))
  {
    VDS_T = (UdsT+(Vt*log((1.0+exp(dxa)))));
  }
  else
  {
    VDS_T = (0.05+(Vt*log((1.0+exp((-dxa))))));
  }
  VDS_T = VDS_T;
  inv_VDE_T = (1.0/VDE_T);
  CJE_T_div_CJE = pow(((model_.VDE)*inv_VDE_T),(model_.PE));
  CJE_T = ((model_.CJE)*CJE_T_div_CJE);
  CJS_T = ((model_.CJS)*pow(((model_.VDS)/VDS_T),(model_.PS)));
  CJCscale = (((1.0-(model_.XP))*pow(((model_.VDC)/VDC_T),(model_.PC)))+(model_.XP));
  CJCscaleINV = (1.0/CJCscale);
  CJC_T = ((model_.CJC)*CJCscale);
  XP_T = ((model_.XP)*CJCscaleINV);
  RE_T = ((model_.RE)*exp((lntN*(model_.AE))));
  RBV_T = ((model_.RBV)*exp((lntN*((model_.AB)-(model_.AQBO)))));
  RBC_T = ((model_.RBC)*exp((lntN*(model_.AEX))));
  RCCxx_T = ((model_.RCC)*exp((lntN*(model_.AC))));
  RCCex_T = ((model_.RCBLX)*exp((lntN*(model_.ACBL))));
  RCCin_T = ((model_.RCBLI)*exp((lntN*(model_.ACBL))));
  RCV_T = ((model_.RCV)*exp((lntN*(model_.AEPI))));
  BF_T = (((model_.BF)*exp((lntN*(((model_.AE)-(model_.AB))-(model_.AQBO)))))*exp(((-(model_.DVGBF))*VdtINV)));
  BRI_T = ((model_.BRI)*exp(((-(model_.DVGBR))*VdtINV)));
  IS_T = (((model_.IS)*exp((lntN*(((4.0-(model_.AB))-(model_.AQBO))+(model_.DAIS)))))*exp(((-(model_.VGB))*VdtINV)));
  IK_T = ((model_.IK)*exp((lntN*(1.0-(model_.AB)))));
  IBF_T = (((model_.IBF)*exp((lntN*(6.0-(2.0*(model_.MLF))))))*exp((((-(model_.VGJ))*VdtINV)/(model_.MLF))));
  IBR_T = ((((model_.IBR)*tN)*tN)*exp((((-(model_.VGC))*VdtINV)/2.0)));
  tempx = pow((VGZEB_T*inv_VGZEB_Tr),(-0.5));
  y = (1.0/CJE_T_div_CJE);
  nZEB_T = (((((((((model_.NZEB)*VGZEB_T)*VGZEB_T)*tempx)*y)*(model_.VDE))*inv_VDE_T)*inv_VGZEB_Tr)*inv_VGZEB_Tr);
  IZEB_T = ((((((((model_.IZEB)*tempx)*VDE_T)*VDE_T)*inv_VDE)*inv_VDE)*CJE_T_div_CJE)*exp(((model_.NZEB)-nZEB_T)));
  tempx = exp((lntN*(model_.AQBO)));
  VEF_T = (((model_.VEF)*tempx)*CJCscaleINV);
  VER_T = (((model_.VER)*tempx)*y);
  ISS_T = (((model_.ISS)*exp((lntN*(4.0-(model_.AS)))))*exp(((-(model_.VGS))*VdtINV)));
  ICSS_T = (((model_.ICSS)*exp((lntN*(3.5-(0.5*(model_.ASUB))))))*exp(((-(model_.VGS))*VdtINV)));
  if ((ISS_T>0.0))
  {
    IKS_T = ((((model_.IKS)*exp((lntN*(1.0-(model_.AS)))))*(IS_T/(model_.IS)))*((model_.ISS)/ISS_T));
  }
  else
  {
    IKS_T = ((model_.IKS)*exp((lntN*(1.0-(model_.AS)))));
  }
  TAUE_T = (((model_.TAUE)*exp((lntN*((model_.AB)-2.0))))*exp(((-(model_.DVGTE))*VdtINV)));
  TAUB_T = ((model_.TAUB)*exp((lntN*(((model_.AQBO)+(model_.AB))-1.0))));
  TEPI_T = ((model_.TEPI)*exp((lntN*((model_.AEPI)-1.0))));
  TAUR_T = (((model_.TAUR)*(TAUB_T+TEPI_T))/((model_.TAUB)+(model_.TEPI)));
  Tk300 = (Tk-300.0);
  if ((Tk<525.0))
  {
    BnT = (Bn*((1.0+(7.2e-4*Tk300))-((1.6e-6*Tk300)*Tk300)));
  }
  else
  {
    BnT = (Bn*1.081);
  }
  DEG_T = ((model_.DEG)*exp((lntN*(model_.AQBO))));
  RTH_Tamb = ((model_.RTH)*pow((Tamb/Trk),(model_.ATH)));
  IS_TM = (IS_T*MULT);
  IK_TM = (IK_T*MULT);
  IBF_TM = (IBF_T*MULT);
  IBR_TM = (IBR_T*MULT);
  IZEB_TM = (IZEB_T*MULT);
  IHC_M = ((model_.IHC)*MULT);
  ISS_TM = (ISS_T*MULT);
  ICSS_TM = (ICSS_T*MULT);
  IKS_TM = (IKS_T*MULT);
  CJE_TM = (CJE_T*MULT);
  CJC_TM = (CJC_T*MULT);
  CJS_TM = (CJS_T*MULT);
  RE_TM = (RE_T*invMULT);
  RBC_TM = (RBC_T*invMULT);
  RBV_TM = (RBV_T*invMULT);
  RCCxx_TM = (RCCxx_T*invMULT);
  RCCex_TM = (RCCex_T*invMULT);
  RCCin_TM = (RCCin_T*invMULT);
  RCV_TM = (RCV_T*invMULT);
  if (((model_.RCC)>0.0))
  {
    GCCxx_TM = (1.0/RCCxx_TM);
  }
  else
  {
    GCCxx_TM = 0;
  }
  if (((model_.RCBLX)>0.0))
  {
    GCCex_TM = (1.0/RCCex_TM);
  }
  else
  {
    GCCex_TM = 0;
  }
  if (((model_.RCBLI)>0.0))
  {
    GCCin_TM = (1.0/RCCin_TM);
  }
  else
  {
    GCCin_TM = 0;
  }
  RTH_Tamb_M = (RTH_Tamb*invMULT);
  {


    //Vb2c1 = ($limit(V(b2,c1),"trunc_ev","typed",TYPE,(-VER),0.7));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vb2c1_limited = AnalogFunctions::trunc_ev(Vb2c1_limited,Vb2c1_old,(-(model_.VER)),0.7);
      if (Vb2c1_limited != Vb2c1_orig)
      {
        icheck=1;
      }
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_b2_c1] = Vb2c1_limited - Vb2c1_orig;
        probeVars[admsProbeID_V_b2_c1] += probeDiffs[admsProbeID_V_b2_c1];
      }
    }
    Vb2c1 = probeVars[admsProbeID_V_b2_c1];



    //Vb2c2 = ($limit(V(b2,c2),"trunc_ev","typed",TYPE,(-VER),0.7));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vb2c2_limited = AnalogFunctions::trunc_ev(Vb2c2_limited,Vb2c2_old,(-(model_.VER)),0.7);
      if (Vb2c2_limited != Vb2c2_orig)
      {
        icheck=1;
      }
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_b2_c2] = Vb2c2_limited - Vb2c2_orig;
        probeVars[admsProbeID_V_b2_c2] += probeDiffs[admsProbeID_V_b2_c2];
      }
    }
    Vb2c2 = probeVars[admsProbeID_V_b2_c2];

    Vb2e1 = ((model_.TYPE)*(probeVars[admsProbeID_V_b2_e1]));


    //Vb1e1 = ($limit(V(b1,e1),"trunc_ev","typed",TYPE,(-VER),0.7));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vb1e1_limited = AnalogFunctions::trunc_ev(Vb1e1_limited,Vb1e1_old,(-(model_.VER)),0.7);
      if (Vb1e1_limited != Vb1e1_orig)
      {
        icheck=1;
      }
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_b1_e1] = Vb1e1_limited - Vb1e1_orig;
        probeVars[admsProbeID_V_b1_e1] += probeDiffs[admsProbeID_V_b1_e1];
      }
    }
    Vb1e1 = probeVars[admsProbeID_V_b1_e1];



    //Vb1b2 = ($limit(V(b1,b2),"trunc_ev","typed",TYPE,(-VER),0.7));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vb1b2_limited = AnalogFunctions::trunc_ev(Vb1b2_limited,Vb1b2_old,(-(model_.VER)),0.7);
      if (Vb1b2_limited != Vb1b2_orig)
      {
        icheck=1;
      }
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_b1_b2] = Vb1b2_limited - Vb1b2_orig;
        probeVars[admsProbeID_V_b1_b2] += probeDiffs[admsProbeID_V_b1_b2];
      }
    }
    Vb1b2 = probeVars[admsProbeID_V_b1_b2];

    Vsc1 = ((model_.TYPE)*(probeVars[admsProbeID_V_s_c1]));
    Vc1c2 = ((model_.TYPE)*(probeVars[admsProbeID_V_c1_c2]));
    Vee1 = ((model_.TYPE)*(probeVars[admsProbeID_V_e_e1]));
    Vbb1 = ((model_.TYPE)*(probeVars[admsProbeID_V_b_b1]));
    Vbe = ((model_.TYPE)*(probeVars[admsProbeID_V_b_e]));
    Vbc = ((model_.TYPE)*(probeVars[admsProbeID_V_b_c]));
    if (((model_.RCBLX)>0.0))
    {
      if (((model_.RCBLI)>0.0))
      {
        Vc4c1 = ((model_.TYPE)*(probeVars[admsProbeID_V_c4_c1]));
        Vc3c4 = ((model_.TYPE)*(probeVars[admsProbeID_V_c3_c4]));
      }
      else
      {
        Vc4c1 = 0;
        Vc3c4 = ((model_.TYPE)*(probeVars[admsProbeID_V_c3_c1]));
      }
    }
    else
    {
      if (((model_.RCBLI)>0.0))
      {
        Vc4c1 = ((model_.TYPE)*(probeVars[admsProbeID_V_c4_c1]));
        Vc3c4 = 0;
      }
      else
      {
        Vc4c1 = 0;
        Vc3c4 = 0;
      }
    }
    Vb1c4 = (((Vb1b2+Vb2c2)-Vc1c2)-Vc4c1);
    Vcc3 = ((((-Vbc)+Vbb1)+Vb1c4)-Vc3c4);
    Vbc3 = (Vbc+Vcc3);
    Vsc4 = (Vsc1-Vc4c1);
    Vsc3 = (Vsc4-Vc3c4);
    if (((Vb2c2*VtINV)<400.0))
    {
      eVb2c2 = exp((Vb2c2*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb2c2 = (expl*(1.0+((Vb2c2*VtINV)-400.0)));
    }
    if (((Vb2e1*VtINV)<400.0))
    {
      eVb2e1 = exp((Vb2e1*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb2e1 = (expl*(1.0+((Vb2e1*VtINV)-400.0)));
    }
    if (((Vb1e1*VtINV)<400.0))
    {
      eVb1e1 = exp((Vb1e1*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb1e1 = (expl*(1.0+((Vb1e1*VtINV)-400.0)));
    }
    if (((Vb1c4*VtINV)<400.0))
    {
      eVb1c4 = exp((Vb1c4*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb1c4 = (expl*(1.0+((Vb1c4*VtINV)-400.0)));
    }
    if (((Vb1b2*VtINV)<400.0))
    {
      eVb1b2 = exp((Vb1b2*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb1b2 = (expl*(1.0+((Vb1b2*VtINV)-400.0)));
    }
    if (((Vbc3*VtINV)<400.0))
    {
      eVbc3 = exp((Vbc3*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVbc3 = (expl*(1.0+((Vbc3*VtINV)-400.0)));
    }
    if (((Vsc1*VtINV)<400.0))
    {
      eVsc1 = exp((Vsc1*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVsc1 = (expl*(1.0+((Vsc1*VtINV)-400.0)));
    }
    if (((Vsc3*VtINV)<400.0))
    {
      eVsc3 = exp((Vsc3*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVsc3 = (expl*(1.0+((Vsc3*VtINV)-400.0)));
    }
    if (((Vsc4*VtINV)<400.0))
    {
      eVsc4 = exp((Vsc4*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVsc4 = (expl*(1.0+((Vsc4*VtINV)-400.0)));
    }
    if ((((Vbc3-VDC_T)*VtINV)<400.0))
    {
      eVbc3VDC = exp(((Vbc3-VDC_T)*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVbc3VDC = (expl*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0)));
    }
    if ((((Vb1c4-VDC_T)*VtINV)<400.0))
    {
      eVb1c4VDC = exp(((Vb1c4-VDC_T)*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb1c4VDC = (expl*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0)));
    }
    if ((((Vb2c2-VDC_T)*VtINV)<400.0))
    {
      eVb2c2VDC = exp(((Vb2c2-VDC_T)*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb2c2VDC = (expl*(1.0+(((Vb2c2-VDC_T)*VtINV)-400.0)));
    }
    if ((((Vb2c1-VDC_T)*VtINV)<400.0))
    {
      eVb2c1VDC = exp(((Vb2c1-VDC_T)*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb2c1VDC = (expl*(1.0+(((Vb2c1-VDC_T)*VtINV)-400.0)));
    }
    K0 = sqrt((1.0+(4.0*eVb2c2VDC)));
    Kw = sqrt((1.0+(4.0*eVb2c1VDC)));
    pW = ((2.0*eVb2c1VDC)/(1.0+Kw));
    Ec = (Vt*((K0-Kw)-log(((K0+1.0)/(Kw+1.0)))));
    Ic1c2 = ((Ec+Vc1c2)/RCV_TM);
    if ((Ic1c2>0.0))
    {
      if ((Vb2c1<100.0))
      {
        tmpV = Vb2c1;
      }
      else
      {
        tmpV = (100.0+log((1.0+(Vb2c1-100.0))));
      }
      tmpV = tmpV;
      Vqs_th = ((VDC_T+((2.0*Vt)*log(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))))-tmpV);
      eps_VDC = (0.2*VDC_T);
      eps2 = (eps_VDC*eps_VDC);
      x2 = (Vqs_th*Vqs_th);
      if ((Vqs_th<0.0))
      {
        Vqs = ((0.5*eps2)/(sqrt((x2+eps2))-Vqs_th));
      }
      else
      {
        Vqs = (0.5*(sqrt((x2+eps2))+Vqs_th));
      }
      Vqs = Vqs;
      Iqs = ((Vqs*(Vqs+(IHC_M*SCRCV_M)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
      Ic1c2_Iqs = (Ic1c2/Iqs);
      dxa = ((Ic1c2_Iqs-1.0)/(model_.AXI));
      if ((Ic1c2_Iqs<1.0))
      {
        alpha1 = (1.0+((model_.AXI)*log((1.0+exp(dxa)))));
      }
      else
      {
        alpha1 = (Ic1c2_Iqs+((model_.AXI)*log((1.0+exp((-dxa))))));
      }
      alpha1 = alpha1;
      alpha = (alpha1/(1.0+((model_.AXI)*log((1.0+exp(((-1.0)/(model_.AXI))))))));
      vyi = (Vqs/(IHC_M*SCRCV_M));
      yi = ((1.0+sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi)))))/((2.0*alpha)*(1.0+vyi)));
      xi_w = (((1.0-yi)+(pW*yi))/(1.0+(pW*yi)));
      gp0 = ((((0.5*Ic1c2)*RCV_TM)*xi_w)*VtINV);
      gp0_help = ((2.0*gp0)+(pW*((pW+gp0)+1.0)));
      gp02 = (0.5*(gp0-1.0));
      sqr_arg = ((gp02*gp02)+gp0_help);
      if ((gp0>=1.0))
      {
        p0star = (gp02+sqrt(sqr_arg));
      }
      else
      {
        p0star = (gp0_help/(sqrt(sqr_arg)-gp02));
      }
      eVb2c2star = ((p0star*(p0star+1.0))*exp((VDC_T*VtINV)));
      B1 = ((0.5*SCRCV_M)*(Ic1c2-IHC_M));
      B2 = (((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2);
      Vxi0 = (B1+sqrt(((B1*B1)+B2)));
      Vch = (VDC_T*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs))));
      Icap = ((IHC_M*Ic1c2)/(IHC_M+Ic1c2));
      Icap_IHC = (IHC_M/(IHC_M+Ic1c2));
    }
    else
    {
      Iqs = 0.0;
      p0star = ((2.0*eVb2c2VDC)/(1.0+K0));
      eVb2c2star = eVb2c2;
      if (((fabs(Vc1c2)<(1.0e-5*Vt))||(fabs(Ec)<((1.0e-40*Vt)*(K0+Kw)))))
      {
        pav = (0.5*(p0star+pW));
        xi_w = (pav/(pav+1.0));
      }
      else
      {
        xi_w = (Ec/((Ec+Vb2c2)-Vb2c1));
      }
      Vxi0 = Vc1c2;
      Vch = (0.1*VDC_T);
      Icap = Ic1c2;
      Icap_IHC = (1.0-(Icap/IHC_M));
    }
    Vfe = (VDE_T*(1.0-pow(3.0,((-1.0)/(model_.PE)))));
    a_VDE = (0.1*VDE_T);
    dxa = ((Vb2e1-Vfe)/a_VDE);
    if ((Vb2e1<Vfe))
    {
      Vje = (Vb2e1-(a_VDE*log((1.0+exp(dxa)))));
    }
    else
    {
      Vje = (Vfe-(a_VDE*log((1.0+exp((-dxa))))));
    }
    Vje = Vje;
    E0BE = pow((1.0-(Vje*inv_VDE_T)),(1.0-(model_.PE)));
    Vte = (((VDE_T/(1.0-(model_.PE)))*(1.0-E0BE))+(3.0*(Vb2e1-Vje)));
    Vjunc = (Vb2c1+Vxi0);
    bjc = ((2.0-XP_T)/(1.0-XP_T));
    Vfc = (VDC_T*(1.0-pow(bjc,((-1.0)/(model_.PC)))));
    dxa = ((Vjunc-Vfc)/Vch);
    if ((Vjunc<Vfc))
    {
      Vjc = (Vjunc-(Vch*log((1.0+exp(dxa)))));
    }
    else
    {
      Vjc = (Vfc-(Vch*log((1.0+exp((-dxa))))));
    }
    Vjc = Vjc;
    fI = pow(Icap_IHC,(model_.MC));
    Vcv = (((VDC_T/(1.0-(model_.PC)))*(1.0-(fI*pow((1.0-(Vjc/VDC_T)),(1.0-(model_.PC))))))+((fI*bjc)*(Vjunc-Vjc)));
    Vtc = (((1.0-XP_T)*Vcv)+(XP_T*Vb2c1));
    If0 = ((4.0*IS_TM)/IK_TM);
    f1 = (If0*eVb2e1);
    n0 = (f1/(1.0+sqrt((1.0+f1))));
    f2 = (If0*eVb2c2star);
    nB = (f2/(1.0+sqrt((1.0+f2))));
    if (((model_.DEG)==0.0))
    {
      q0I = ((1.0+(Vte/VER_T))+(Vtc/VEF_T));
    }
    else
    {
      termE = ((((Vte/VER_T)+1.0)*DEG_T)*VtINV);
      termC = ((((-Vtc)/VEF_T)*DEG_T)*VtINV);
      q0I = ((exp(termE)-exp(termC))/(exp((DEG_T*VtINV))-1.0));
    }
    eps2 = (0.1*0.1);
    x2 = (q0I*q0I);
    if ((q0I<0.0))
    {
      q1I = ((0.5*eps2)/(sqrt((x2+eps2))-q0I));
    }
    else
    {
      q1I = (0.5*(sqrt((x2+eps2))+q0I));
    }
    q1I = q1I;
    qBI = (q1I*(1.0+(0.5*(n0+nB))));
    Ir = (IS_TM*eVb2c2star);
    If = (IS_TM*eVb2e1);
    In = ((If-Ir)/qBI);
    Ibf0 = (IS_TM/BF_T);
    if (((model_.XREC)==0.0))
    {
      Ib1 = (((1.0-(model_.XIBI))*Ibf0)*(eVb2e1-1.0));
    }
    else
    {
      Ib1 = (((1.0-(model_.XIBI))*Ibf0)*(((1.0-(model_.XREC))*(eVb2e1-1.0))+(((model_.XREC)*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T)))));
    }
    Ib1_s = (((model_.XIBI)*Ibf0)*(eVb1e1-1.0));
    if ((((Vb2e1*VtINV)/(model_.MLF))<400.0))
    {
      tmpExp = exp(((Vb2e1*VtINV)/(model_.MLF)));
    }
    else
    {
      expl = exp(400.0);
      tmpExp = (expl*(1.0+(((Vb2e1*VtINV)/(model_.MLF))-400.0)));
    }
    Ib2 = ((IBF_TM*(tmpExp-1.0))+((model_.GMIN)*Vb2e1));
    if ((((0.5*Vb1c4)*VtINV)<400.0))
    {
      tmpExp = exp(((0.5*Vb1c4)*VtINV));
    }
    else
    {
      expl = exp(400.0);
      tmpExp = (expl*(1.0+(((0.5*Vb1c4)*VtINV)-400.0)));
    }
    Ib3 = (((IBR_TM*(eVb1c4-1.0))/(tmpExp+exp(((0.5*(model_.VLR))*VtINV))))+((model_.GMIN)*Vb1c4));
    if (((((model_.IZEB)>0.0)&&((model_.NZEB)>0.0))&&(Vb2e1<0)))
    {
      if (((nZEB_T*(1-(pow2_2mPE/(2.0*E0BE))))<400.0))
      {
        eZEB = exp((nZEB_T*(1-(pow2_2mPE/(2.0*E0BE)))));
      }
      else
      {
        expl = exp(400.0);
        eZEB = (expl*(1.0+((nZEB_T*(1-(pow2_2mPE/(2.0*E0BE))))-400.0)));
      }
      x = (Vb2e1*inv_VDE_T);
      dE0BE = ((pow((-x),((-2.0)-(model_.PE)))*(((model_.PE)*((1-((model_.PE)*(model_.PE)))-((3*x)*((model_.PE)-1))))-(((6*x)*x)*(((model_.PE)-1)+x))))*0.16666666666666666667);
      if (((((Vb2e1*pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE))<400.0))
      {
        edZEB = exp((((Vb2e1*pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE)));
      }
      else
      {
        expl = exp(400.0);
        edZEB = (expl*(1.0+((((Vb2e1*pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE))-400.0)));
      }
      DZEB = ((-Vb2e1)-(((VGZEB_T*dE0BE)*(1-edZEB))/(pow2_2mPE*nZEB_T)));
      Izteb = ((((((2.0*IZEB_TM)*DZEB)*E0BE)*eZEB)*inv_VDE_T)*pow2_PEm2);
    }
    else
    {
      DZEB = 0;
      Izteb = 0;
    }
    g1 = (If0*eVb1c4);
    g2 = (4.0*eVb1c4VDC);
    nBex = ((g1-If0)/(1.0+sqrt((1.0+g1))));
    pWex = (g2/(1.0+sqrt((1.0+g2))));
    Iex = ((IK_TM*nBex)/(2.0*BRI_T));
    if (((model_.EXSUB)==1.0))
    {
      Isub = (((2.0*ISS_TM)*(eVb1c4-eVsc4))/(1.0+sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))));
    }
    else
    {
      Isub = (((2.0*ISS_TM)*(eVb1c4-1.0))/(1.0+sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))));
    }
    if (((model_.ICSS)<0.0))
    {
      Isf = (ISS_TM*(eVsc1-1.0));
    }
    else
    {
      Isf = (ICSS_TM*(eVsc1-1.0));
    }
    XIex = 0.0;
    XIsub = 0.0;
    if ((((model_.EXMOD)==1)||((model_.EXMOD)==2)))
    {
      Iex = (Iex*Xext1);
      Isub = (Isub*Xext1);
      Xg1 = (If0*eVbc3);
      XnBex = ((Xg1-If0)/(1.0+sqrt((1.0+Xg1))));
      XIMex = (((((model_.XEXT)*0.5)*IK_TM)*XnBex)/BRI_T);
      if (((model_.EXSUB)==1.0))
      {
        XIMsub = (((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-eVsc3))/(1.0+sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))));
      }
      else
      {
        XIMsub = (((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-1.0))/(1.0+sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))));
      }
      if (((model_.EXMOD)==1))
      {
        Vex_bias = (((model_.XEXT)*((IS_TM/BRI_T)+ISS_TM))*RCCxx_TM);
        Vex = (Vt*(2.0-log((Vex_bias*VtINV))));
        vdif = (Vbc3-Vex);
        eps2 = (0.11*0.11);
        x2 = (vdif*vdif);
        if ((vdif<0.0))
        {
          VBex = ((0.5*eps2)/(sqrt((x2+eps2))-vdif));
        }
        else
        {
          VBex = (0.5*(sqrt((x2+eps2))+vdif));
        }
        VBex = VBex;
        Fex = (VBex/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
      }
      else
      {
        Vex = 0.0;
        vdif = 0.0;
        VBex = 0.0;
        Fex = 1.0;
      }
      XIex = (Fex*XIMex);
      XIsub = (Fex*XIMsub);
    }
    else
    {
      Fex = 0;
      XnBex = 0;
    }
    q0Q = ((1.0+(Vte/VER_T))+(Vtc/VEF_T));
    eps2 = (0.1*0.1);
    x2 = (q0Q*q0Q);
    if ((q0Q<0.0))
    {
      q1Q = ((0.5*eps2)/(sqrt((x2+eps2))-q0Q));
    }
    else
    {
      q1Q = (0.5*(sqrt((x2+eps2))+q0Q));
    }
    q1Q = q1Q;
    qBQ = (q1Q*(1.0+(0.5*(n0+nB))));
    Rb2 = ((3.0*RBV_TM)/qBQ);
    Ib1b2 = ((((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)/Rb2);
    Iavl = 0.0;
    Gem = 0.0;
    if (((Ic1c2>0.0)&&(Vb2c1<VDC_T)))
    {
      dEdx0 = ((2.0*(model_.VAVL))/((model_.WAVL)*(model_.WAVL)));
      sqr_arg = ((VDC_T-Vb2c1)/Icap_IHC);
      xd = sqrt(((2.0*sqr_arg)/dEdx0));
      if (((model_.EXAVL)==0.0))
      {
        Weff = (model_.WAVL);
      }
      else
      {
        xi_w1 = (1.0-(0.5*xi_w));
        Weff = (((model_.WAVL)*xi_w1)*xi_w1);
      }
      Wd = ((xd*Weff)/sqrt(((xd*xd)+(Weff*Weff))));
      Eav = ((VDC_T-Vb2c1)/Wd);
      E0 = (Eav+(((0.5*Wd)*dEdx0)*Icap_IHC));
      if (((model_.EXAVL)==0))
      {
        Em = E0;
      }
      else
      {
        SHw = (1.0+((2.0*(model_.SFH))*(1.0+(2.0*xi_w))));
        Efi = ((1.0+(model_.SFH))/(1.0+(2.0*(model_.SFH))));
        Ew = (Eav-(((0.5*Wd)*dEdx0)*(Efi-(Ic1c2/(IHC_M*SHw)))));
        sqr_arg = (((Ew-E0)*(Ew-E0))+((((0.1*Eav)*Eav)*Icap)/IHC_M));
        Em = (0.5*((Ew+E0)+sqrt(sqr_arg)));
      }
      EmEav_Em = ((Em-Eav)/Em);
      if ((fabs(EmEav_Em)>1.0e-7))
      {
        lambda = ((0.5*Wd)/EmEav_Em);
        Gem = ((((An/BnT)*Em)*lambda)*(exp(((-BnT)/Em))-exp((((-BnT)/Em)*(1.0+(Weff/lambda))))));
      }
      else
      {
        Gem = ((An*Weff)*exp(((-BnT)/Em)));
      }
      Gmax = (((Vt/(Ic1c2*(RBC_TM+Rb2)))+(qBI/BF_T))+(RE_TM/(RBC_TM+Rb2)));
      Iavl = ((Ic1c2*Gem)/((Gem+(Gem/Gmax))+1.0));
    }
    if ((eVb2c2star>0.0))
    {
      Vb2c2star = (Vt*log(eVb2c2star));
    }
    else
    {
      Vb2c2star = Vb2c2;
    }
    power = ((((((((((((((((In*(Vb2e1-Vb2c2star))+(Ic1c2*(Vb2c2star-Vb2c1)))-(Iavl*Vb2c2star))+((Vee1*Vee1)/RE_TM))+((Vcc3*Vcc3)*GCCxx_TM))+((Vc3c4*Vc3c4)*GCCex_TM))+((Vc4c1*Vc4c1)*GCCin_TM))+((Vbb1*Vbb1)/RBC_TM))+(Ib1b2*Vb1b2))+(((Ib1+Ib2)-Izteb)*Vb2e1))+(Ib1_s*Vb1e1))+((Iex+Ib3)*Vb1c4))+(XIex*Vbc3))+(Isub*(Vb1c4-Vsc4)))+(XIsub*(Vbc3-Vsc3)))+(Isf*Vsc1));
    Qte = (((1.0-(model_.XCJE))*CJE_TM)*Vte);
    dxa = ((Vb1e1-Vfe)/a_VDE);
    if ((Vb1e1<Vfe))
    {
      Vje_s = (Vb1e1-(a_VDE*log((1.0+exp(dxa)))));
    }
    else
    {
      Vje_s = (Vfe-(a_VDE*log((1.0+exp((-dxa))))));
    }
    Vje_s = Vje_s;
    Qte_s = (((model_.XCJE)*CJE_TM)*(((VDE_T/(1.0-(model_.PE)))*(1.0-pow((1.0-(Vje_s*inv_VDE_T)),(1.0-(model_.PE)))))+(3.0*(Vb1e1-Vje_s))));
    Qtc = (((model_.XCJC)*CJC_TM)*Vtc);
    Qb0 = (TAUB_T*IK_TM);
    Qbe_qs = (((0.5*Qb0)*n0)*q1Q);
    Qbc_qs = (((0.5*Qb0)*nB)*q1Q);
    a_VDC = (0.1*VDC_T);
    dxa = ((Vb1c4-Vfc)/a_VDC);
    if ((Vb1c4<Vfc))
    {
      Vjcex = (Vb1c4-(a_VDC*log((1.0+exp(dxa)))));
    }
    else
    {
      Vjcex = (Vfc-(a_VDC*log((1.0+exp((-dxa))))));
    }
    Vjcex = Vjcex;
    Vtexv = (((VDC_T/(1.0-(model_.PC)))*(1.0-pow((1.0-(Vjcex/VDC_T)),(1.0-(model_.PC)))))+(bjc*(Vb1c4-Vjcex)));
    Qtex = (((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-(model_.XCJC)))*(1.0-(model_.XEXT)));
    dxa = ((Vbc3-Vfc)/a_VDC);
    if ((Vbc3<Vfc))
    {
      XVjcex = (Vbc3-(a_VDC*log((1.0+exp(dxa)))));
    }
    else
    {
      XVjcex = (Vfc-(a_VDC*log((1.0+exp((-dxa))))));
    }
    XVjcex = XVjcex;
    XVtexv = (((VDC_T/(1.0-(model_.PC)))*(1.0-pow((1.0-(XVjcex/VDC_T)),(1.0-(model_.PC)))))+(bjc*(Vbc3-XVjcex)));
    XQtex = (((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-(model_.XCJC)))*(model_.XEXT));
    a_VDS = (0.1*VDS_T);
    Vfs = (VDS_T*(1.0-pow(2.0,((-1.0)/(model_.PS)))));
    dxa = ((Vsc1-Vfs)/a_VDS);
    if ((Vsc1<Vfs))
    {
      Vjs = (Vsc1-(a_VDS*log((1.0+exp(dxa)))));
    }
    else
    {
      Vjs = (Vfs-(a_VDS*log((1.0+exp((-dxa))))));
    }
    Vjs = Vjs;
    Qts = (CJS_TM*(((VDS_T/(1.0-(model_.PS)))*(1.0-pow((1.0-(Vjs/VDS_T)),(1.0-(model_.PS)))))+(2.0*(Vsc1-Vjs))));
    Qe0 = ((TAUE_T*IK_TM)*pow((IS_TM/IK_TM),(1.0/(model_.MTAU))));
    if (((Vb2e1/((model_.MTAU)*Vt))<400.0))
    {
      tmpExp = exp((Vb2e1/((model_.MTAU)*Vt)));
    }
    else
    {
      expl = exp(400.0);
      tmpExp = (expl*(1.0+((Vb2e1/((model_.MTAU)*Vt))-400.0)));
    }
    Qe_qs = (Qe0*tmpExp);
    Qepi0 = (((4.0*TEPI_T)*Vt)/RCV_TM);
    Qepi = (((0.5*Qepi0)*xi_w)*((p0star+pW)+2.0));
    Qex = (((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))/(TAUB_T+TEPI_T));
    XQex = 0.0;
    if (((model_.EXMOD)==1))
    {
      Qex = (Qex*(1.0-(model_.XEXT)));
      Xg2 = (4.0*eVbc3VDC);
      XpWex = (Xg2/(1.0+sqrt((1.0+Xg2))));
      XQex = (((((0.5*Fex)*(model_.XEXT))*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))/(TAUB_T+TEPI_T));
    }
    Qb1b2 = 0.0;
    if (((model_.EXPHI)==1))
    {
      dVteVje = (pow((1.0-(Vje*inv_VDE_T)),(-(model_.PE)))-3.0);
      Vb2e1Vfe = ((Vb2e1-Vfe)/a_VDE);
      if ((Vb2e1Vfe<0.0))
      {
        dVjeVb2e1 = (1.0/(1.0+exp(Vb2e1Vfe)));
      }
      else
      {
        dVjeVb2e1 = (exp((-Vb2e1Vfe))/(1.0+exp((-Vb2e1Vfe))));
      }
      dVteVb2e1 = ((dVteVje*dVjeVb2e1)+3.0);
      dQteVb2e1 = (((1.0-(model_.XCJE))*CJE_TM)*dVteVb2e1);
      dn0Vb2e1 = (((If0*eVb2e1)*VtINV)*(0.5/sqrt((1.0+f1))));
      dQbeVb2e1 = (((0.5*Qb0)*q1Q)*dn0Vb2e1);
      dQeVb2e1 = (Qe_qs/((model_.MTAU)*Vt));
      Qb1b2 = ((0.2*Vb1b2)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1));
      Qe = ((1-(model_.KE))*Qe_qs);
      Qbe_qs_eff = (Qbe_qs+((model_.KE)*Qe_qs));
      Qbc = (((model_.XQB)*Qbe_qs_eff)+Qbc_qs);
      Qbe = ((1-(model_.XQB))*Qbe_qs_eff);
    }
    else
    {
      Qbe = Qbe_qs;
      Qbc = Qbc_qs;
      Qe = Qe_qs;
    }
    // I(c1,c2) <+ ((TYPE*Ic1c2))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*Ic1c2);
      staticContributions[admsNodeID_c1] += contribTemp;
      staticContributions[admsNodeID_c2] -= contribTemp;

      Jdxp_static[admsNodeID_c1] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
      Jdxp_static[admsNodeID_c2] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
    }
    // I(c2,e1) <+ ((TYPE*In))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*In);
      staticContributions[admsNodeID_c2] += contribTemp;
      staticContributions[admsNodeID_e1] -= contribTemp;

      Jdxp_static[admsNodeID_c2] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
      Jdxp_static[admsNodeID_e1] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
    }
    // I(b1,e1) <+ ((TYPE*Ib1_s))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*Ib1_s);
      staticContributions[admsNodeID_b1] += contribTemp;
      staticContributions[admsNodeID_e1] -= contribTemp;

      Jdxp_static[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1);
      Jdxp_static[admsNodeID_e1] -= contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1);
    }
    // I(b2,e1) <+ ((TYPE*((Ib1+Ib2)-Izteb)))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*((Ib1+Ib2)-Izteb));
      staticContributions[admsNodeID_b2] += contribTemp;
      staticContributions[admsNodeID_e1] -= contribTemp;

      Jdxp_static[admsNodeID_b2] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
      Jdxp_static[admsNodeID_e1] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
    }
    // I(b1,s) <+ ((TYPE*Isub))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*Isub);
      staticContributions[admsNodeID_b1] += contribTemp;
      staticContributions[admsNodeID_s] -= contribTemp;

      Jdxp_static[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_static[admsNodeID_s] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(b,s) <+ ((TYPE*XIsub))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*XIsub);
      staticContributions[admsNodeID_b] += contribTemp;
      staticContributions[admsNodeID_s] -= contribTemp;

      Jdxp_static[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_static[admsNodeID_s] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(s,c1) <+ ((TYPE*Isf))
    staticContributions[admsNodeID_s] += ((model_.TYPE)*Isf);
    staticContributions[admsNodeID_c1] -= ((model_.TYPE)*Isf);
    // I(b1,b2) <+ ((TYPE*Ib1b2))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*Ib1b2);
      staticContributions[admsNodeID_b1] += contribTemp;
      staticContributions[admsNodeID_b2] -= contribTemp;

      Jdxp_static[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_static[admsNodeID_b2] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(b2,c2) <+ ((TYPE*((-1.0)*Iavl)))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*((-1.0)*Iavl));
      staticContributions[admsNodeID_b2] += contribTemp;
      staticContributions[admsNodeID_c2] -= contribTemp;

      Jdxp_static[admsNodeID_b2] += contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
      Jdxp_static[admsNodeID_c2] -= contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
    }
    // I(e,e1) <+ (((TYPE*Vee1)/RE_TM))
    staticContributions[admsNodeID_e] += (((model_.TYPE)*Vee1)/RE_TM);
    staticContributions[admsNodeID_e1] -= (((model_.TYPE)*Vee1)/RE_TM);
    // I(b,b1) <+ (((TYPE*Vbb1)/RBC_TM))
    staticContributions[admsNodeID_b] += (((model_.TYPE)*Vbb1)/RBC_TM);
    staticContributions[admsNodeID_b1] -= (((model_.TYPE)*Vbb1)/RBC_TM);
    // I(dt,GND) <+ ((V(dt,GND)/RTH_Tamb_M))
    staticContributions[admsNodeID_dt] += ((probeVars[admsProbeID_V_dt_GND])/RTH_Tamb_M);
    // I(dt,GND) <+ (ddt((CTH_M*V(dt,GND))))
    dynamicContributions[admsNodeID_dt] += ((CTH_M*(probeVars[admsProbeID_V_dt_GND])));
    // I(dt,GND) <+ (((-1.0)*power))
    {
      AdmsFadType contribTemp;
      contribTemp= ((-1.0)*power);
      staticContributions[admsNodeID_dt] += contribTemp;

      Jdxp_static[admsNodeID_dt] += contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
    }
    // I(b2,e1) <+ (ddt((TYPE*((Qte+Qbe)+Qe))))
    {
      AdmsFadType contribTemp;
      contribTemp= (((model_.TYPE)*((Qte+Qbe)+Qe)));
      dynamicContributions[admsNodeID_b2] += contribTemp;
      dynamicContributions[admsNodeID_e1] -= contribTemp;

      Jdxp_dynamic[admsNodeID_b2] += contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
      Jdxp_dynamic[admsNodeID_e1] -= contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
    }
    // I(b1,e1) <+ (ddt((TYPE*Qte_s)))
    {
      AdmsFadType contribTemp;
      contribTemp= (((model_.TYPE)*Qte_s));
      dynamicContributions[admsNodeID_b1] += contribTemp;
      dynamicContributions[admsNodeID_e1] -= contribTemp;

      Jdxp_dynamic[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1);
      Jdxp_dynamic[admsNodeID_e1] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1);
    }
    // I(b2,c2) <+ (ddt((TYPE*((Qtc+Qbc)+Qepi))))
    {
      AdmsFadType contribTemp;
      contribTemp= (((model_.TYPE)*((Qtc+Qbc)+Qepi)));
      dynamicContributions[admsNodeID_b2] += contribTemp;
      dynamicContributions[admsNodeID_c2] -= contribTemp;

      Jdxp_dynamic[admsNodeID_b2] += contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
      Jdxp_dynamic[admsNodeID_c2] -= contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
    }
    // I(s,c1) <+ (ddt((TYPE*Qts)))
    {
      AdmsFadType contribTemp;
      contribTemp= (((model_.TYPE)*Qts));
      dynamicContributions[admsNodeID_s] += contribTemp;
      dynamicContributions[admsNodeID_c1] -= contribTemp;

      Jdxp_dynamic[admsNodeID_s] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_dynamic[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(b1,b2) <+ (ddt((TYPE*Qb1b2)))
    {
      AdmsFadType contribTemp;
      contribTemp= (((model_.TYPE)*Qb1b2));
      dynamicContributions[admsNodeID_b1] += contribTemp;
      dynamicContributions[admsNodeID_b2] -= contribTemp;

      Jdxp_dynamic[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_dynamic[admsNodeID_b2] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(b,e) <+ (ddt(((TYPE*CBEO_M)*Vbe)))
    dynamicContributions[admsNodeID_b] += ((((model_.TYPE)*CBEO_M)*Vbe));
    dynamicContributions[admsNodeID_e] -= ((((model_.TYPE)*CBEO_M)*Vbe));
    // I(b,c) <+ (ddt(((TYPE*CBCO_M)*Vbc)))
    dynamicContributions[admsNodeID_b] += ((((model_.TYPE)*CBCO_M)*Vbc));
    dynamicContributions[admsNodeID_c] -= ((((model_.TYPE)*CBCO_M)*Vbc));
  }
  if (((model_.RCBLX)>0.0))
  {
    // I(b,c3) <+ ((TYPE*XIex))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*XIex);
      staticContributions[admsNodeID_b] += contribTemp;
      staticContributions[admsNodeID_c3] -= contribTemp;

      Jdxp_static[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_static[admsNodeID_c3] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(c,c3) <+ (((TYPE*Vcc3)*GCCxx_TM))
    {
      AdmsFadType contribTemp;
      contribTemp= (((model_.TYPE)*Vcc3)*GCCxx_TM);
      staticContributions[admsNodeID_c] += contribTemp;
      staticContributions[admsNodeID_c3] -= contribTemp;

      Jdxp_static[admsNodeID_c] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_static[admsNodeID_c3] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(b,c3) <+ (ddt((TYPE*(XQtex+XQex))))
    {
      AdmsFadType contribTemp;
      contribTemp= (((model_.TYPE)*(XQtex+XQex)));
      dynamicContributions[admsNodeID_b] += contribTemp;
      dynamicContributions[admsNodeID_c3] -= contribTemp;

      Jdxp_dynamic[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_dynamic[admsNodeID_c3] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    if (((model_.RCBLI)>0.0))
    {
      // I(c4,c1) <+ (((TYPE*Vc4c1)*GCCin_TM))
      staticContributions[admsNodeID_c4] += (((model_.TYPE)*Vc4c1)*GCCin_TM);
      staticContributions[admsNodeID_c1] -= (((model_.TYPE)*Vc4c1)*GCCin_TM);
      // I(b1,c4) <+ ((TYPE*(Ib3+Iex)))
      {
        AdmsFadType contribTemp;
        contribTemp= ((model_.TYPE)*(Ib3+Iex));
        staticContributions[admsNodeID_b1] += contribTemp;
        staticContributions[admsNodeID_c4] -= contribTemp;

        Jdxp_static[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c4] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(c3,c4) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += (((model_.TYPE)*Vc3c4)*GCCex_TM);
      staticContributions[admsNodeID_c4] -= (((model_.TYPE)*Vc3c4)*GCCex_TM);
      // I(b1,c4) <+ (ddt((TYPE*(Qtex+Qex))))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*(Qtex+Qex)));
        dynamicContributions[admsNodeID_b1] += contribTemp;
        dynamicContributions[admsNodeID_c4] -= contribTemp;

        Jdxp_dynamic[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_dynamic[admsNodeID_c4] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
    }
    else
    {
      // V(c4,c1) <+ (0.0)
      // do nothing at all
      // I(b1,c1) <+ ((TYPE*(Ib3+Iex)))
      {
        AdmsFadType contribTemp;
        contribTemp= ((model_.TYPE)*(Ib3+Iex));
        staticContributions[admsNodeID_b1] += contribTemp;
        staticContributions[admsNodeID_c1] -= contribTemp;

        Jdxp_static[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(b1,c1) <+ (ddt((TYPE*(Qtex+Qex))))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*(Qtex+Qex)));
        dynamicContributions[admsNodeID_b1] += contribTemp;
        dynamicContributions[admsNodeID_c1] -= contribTemp;

        Jdxp_dynamic[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_dynamic[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(c3,c1) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += (((model_.TYPE)*Vc3c4)*GCCex_TM);
      staticContributions[admsNodeID_c1] -= (((model_.TYPE)*Vc3c4)*GCCex_TM);
    }
  }
  else
  {
    // V(c3,c4) <+ (0)
    // do nothing at all
    if (((model_.RCBLI)>0.0))
    {
      // I(b,c4) <+ ((TYPE*XIex))
      {
        AdmsFadType contribTemp;
        contribTemp= ((model_.TYPE)*XIex);
        staticContributions[admsNodeID_b] += contribTemp;
        staticContributions[admsNodeID_c4] -= contribTemp;

        Jdxp_static[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c4] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(c,c4) <+ (((TYPE*Vcc3)*GCCxx_TM))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*Vcc3)*GCCxx_TM);
        staticContributions[admsNodeID_c] += contribTemp;
        staticContributions[admsNodeID_c4] -= contribTemp;

        Jdxp_static[admsNodeID_c] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c4] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(c4,c1) <+ (((TYPE*Vc4c1)*GCCin_TM))
      staticContributions[admsNodeID_c4] += (((model_.TYPE)*Vc4c1)*GCCin_TM);
      staticContributions[admsNodeID_c1] -= (((model_.TYPE)*Vc4c1)*GCCin_TM);
      // I(b1,c4) <+ ((TYPE*(Ib3+Iex)))
      {
        AdmsFadType contribTemp;
        contribTemp= ((model_.TYPE)*(Ib3+Iex));
        staticContributions[admsNodeID_b1] += contribTemp;
        staticContributions[admsNodeID_c4] -= contribTemp;

        Jdxp_static[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c4] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(b1,c4) <+ (ddt((TYPE*(Qtex+Qex))))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*(Qtex+Qex)));
        dynamicContributions[admsNodeID_b1] += contribTemp;
        dynamicContributions[admsNodeID_c4] -= contribTemp;

        Jdxp_dynamic[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_dynamic[admsNodeID_c4] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(b,c4) <+ (ddt((TYPE*(XQtex+XQex))))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*(XQtex+XQex)));
        dynamicContributions[admsNodeID_b] += contribTemp;
        dynamicContributions[admsNodeID_c4] -= contribTemp;

        Jdxp_dynamic[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_dynamic[admsNodeID_c4] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
    }
    else
    {
      // I(b,c1) <+ ((TYPE*XIex))
      {
        AdmsFadType contribTemp;
        contribTemp= ((model_.TYPE)*XIex);
        staticContributions[admsNodeID_b] += contribTemp;
        staticContributions[admsNodeID_c1] -= contribTemp;

        Jdxp_static[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(c,c1) <+ (((TYPE*Vcc3)*GCCxx_TM))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*Vcc3)*GCCxx_TM);
        staticContributions[admsNodeID_c] += contribTemp;
        staticContributions[admsNodeID_c1] -= contribTemp;

        Jdxp_static[admsNodeID_c] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // V(c4,c1) <+ (0.0)
      // do nothing at all
      // I(b1,c1) <+ ((TYPE*(Ib3+Iex)))
      {
        AdmsFadType contribTemp;
        contribTemp= ((model_.TYPE)*(Ib3+Iex));
        staticContributions[admsNodeID_b1] += contribTemp;
        staticContributions[admsNodeID_c1] -= contribTemp;

        Jdxp_static[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(b1,c1) <+ (ddt((TYPE*(Qtex+Qex))))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*(Qtex+Qex)));
        dynamicContributions[admsNodeID_b1] += contribTemp;
        dynamicContributions[admsNodeID_c1] -= contribTemp;

        Jdxp_dynamic[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_dynamic[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(b,c1) <+ (ddt((TYPE*(XQtex+XQex))))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*(XQtex+XQex)));
        dynamicContributions[admsNodeID_b] += contribTemp;
        dynamicContributions[admsNodeID_c1] -= contribTemp;

        Jdxp_dynamic[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_dynamic[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(c3,c1) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += (((model_.TYPE)*Vc3c4)*GCCex_TM);
      staticContributions[admsNodeID_c1] -= (((model_.TYPE)*Vc3c4)*GCCex_TM);
    }
  }
  {
    common = ((4.0*1.3806226e-23)*Tk);
    powerREC = (common/RE_TM);
    powerRBC = (common/RBC_TM);
    powerRCCxx = (common*GCCxx_TM);
    powerRCCex = (common*GCCex_TM);
    powerRCCin = (common*GCCin_TM);
    powerRBV = (((common/Rb2)*((4.0*eVb1b2)+5.0))*0.33333333333333333333);
    In_N = ((If+Ir)/qBI);
    powerCCS = ((2.0*1.6021918e-19)*fabs(In_N));
    if (((model_.KAVL)>0))
    {
      Gem_N = fabs((Iavl/In_N));
    }
    else
    {
      Gem_N = 0.0;
    }
    powerIIS = (((2.0*1.6021918e-19)*Iavl)*(Gem_N+1));
    if ((In_N>0.0))
    {
      Taub_N = ((Qbe+Qbc)/In_N);
    }
    else
    {
      Taub_N = ((TAUB_T*q1Q)*qBI);
    }
    if (((model_.KC)==1))
    {
      taun = ((model_.XQB)*Taub_N);
    }
    else
    {
      if (((model_.KC)==2))
      {
        taun = ((model_.FTAUN)*Taub_N);
      }
      else
      {
        taun = 0;
      }
    }
    powerFBCS = ((2.0*1.6021918e-19)*((fabs(Ib1)+fabs(Ib2))+fabs(Izteb)));
    powerFBC1fB1 = (((1.0-(model_.XIBI))*pow((fabs(Ib1)/(1-(model_.XIBI))),(model_.AF)))*KF_M);
    exponentFBC1fB2 = ((2.0*((model_.MLF)-1.0))+((model_.AF)*(2.0-(model_.MLF))));
    powerFBC1fB2 = (KFN_M*pow(fabs(Ib2),exponentFBC1fB2));
    powerEBSCS = ((2.0*1.6021918e-19)*fabs(Ib1_s));
    if (((model_.XIBI)==0))
    {
      powerEBSC1f = 0.0;
    }
    else
    {
      powerEBSC1f = ((KF_M*(model_.XIBI))*pow(fabs((Ib1_s/(model_.XIBI))),(model_.AF)));
    }
    powerRBCS = ((2.0*1.6021918e-19)*fabs(Ib3));
    powerRBC1f = (KF_M*pow(fabs(Ib3),(model_.AF)));
    powerExCS = ((2.0*1.6021918e-19)*fabs(Iex));
    powerExC1f = ((KF_M*(1-((model_.EXMOD)*(model_.XEXT))))*pow((fabs(Iex)/(1-((model_.EXMOD)*(model_.XEXT)))),(model_.AF)));
    powerExCSMOD = (((2.0*1.6021918e-19)*fabs(XIex))*(model_.EXMOD));
    if (((model_.XEXT)==0.0))
    {
      powerExC1fMOD = 0.0;
    }
    else
    {
      powerExC1fMOD = (((KF_M*(model_.EXMOD))*(model_.XEXT))*pow((fabs(XIex)/(model_.XEXT)),(model_.AF)));
    }
    powerSubsCS_B1S = ((2.0*1.6021918e-19)*fabs(Isub));
    powerSubsCS_BS = ((2.0*1.6021918e-19)*fabs(XIsub));
    // I(noi,GND) <+ (white_noise(powerCCS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[0]= powerCCS.val();
    }
    // I(noi,GND) <+ (V(noi,GND))
    staticContributions[admsNodeID_noi] += (probeVars[admsProbeID_V_noi_GND]);
    // I(b2,e1) <+ ((taun*ddt(V(noi,GND))))
    {
      AdmsFadType contribTemp;
      contribTemp= (taun*((probeVars[admsProbeID_V_noi_GND])));
      dynamicContributions[admsNodeID_b2] += contribTemp;
      dynamicContributions[admsNodeID_e1] -= contribTemp;

      Jdxp_dynamic[admsNodeID_b2] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_dynamic[admsNodeID_e1] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(c2,b2) <+ ((Gem_N*V(noi,GND)))
    {
      AdmsFadType contribTemp;
      contribTemp= (Gem_N*(probeVars[admsProbeID_V_noi_GND]));
      staticContributions[admsNodeID_c2] += contribTemp;
      staticContributions[admsNodeID_b2] -= contribTemp;

      Jdxp_static[admsNodeID_c2] += contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
      Jdxp_static[admsNodeID_b2] -= contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
    }
    // I(c2,e1) <+ (V(noi,GND))
    staticContributions[admsNodeID_c2] += (probeVars[admsProbeID_V_noi_GND]);
    staticContributions[admsNodeID_e1] -= (probeVars[admsProbeID_V_noi_GND]);
    // I(c2,b2) <+ (white_noise(powerIIS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[1]= powerIIS.val();
    }
    // I(b2,e1) <+ (white_noise(powerFBCS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[2]= powerFBCS.val();
    }
    // I(e,e1) <+ (white_noise(powerREC))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[3]= powerREC.val();
    }
    // I(b,b1) <+ (white_noise(powerRBC))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[4]= powerRBC.val();
    }
    // I(b1,b2) <+ (white_noise(powerRBV))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[5]= powerRBV.val();
    }
    // I(b2,e1) <+ (flicker_noise(powerFBC1fB1,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[6]= powerFBC1fB1.val();
      noiseContribsExponent[6]= 1;
    }
    // I(b2,e1) <+ (flicker_noise(powerFBC1fB2,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[7]= powerFBC1fB2.val();
      noiseContribsExponent[7]= 1;
    }
    // I(e1,b1) <+ (white_noise(powerEBSCS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[8]= powerEBSCS.val();
    }
    // I(e1,b1) <+ (flicker_noise(powerEBSC1f,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[9]= powerEBSC1f.val();
      noiseContribsExponent[9]= 1;
    }
    // I(b1,c4) <+ (white_noise(powerRBCS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[10]= powerRBCS.val();
    }
    // I(b1,c4) <+ (flicker_noise(powerRBC1f,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[11]= powerRBC1f.val();
      noiseContribsExponent[11]= 1;
    }
    // I(b1,c4) <+ (white_noise(powerExCS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[12]= powerExCS.val();
    }
    // I(b1,c4) <+ (flicker_noise(powerExC1f,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[13]= powerExC1f.val();
      noiseContribsExponent[13]= 1;
    }
    // I(b,c3) <+ (white_noise(powerExCSMOD))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[14]= powerExCSMOD.val();
    }
    // I(b,c3) <+ (flicker_noise(powerExC1fMOD,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[15]= powerExC1fMOD.val();
      noiseContribsExponent[15]= 1;
    }
    // I(b1,s) <+ (white_noise(powerSubsCS_B1S))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[16]= powerSubsCS_B1S.val();
    }
    // I(b,s) <+ (white_noise(powerSubsCS_BS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[17]= powerSubsCS_BS.val();
    }
    if (((model_.RCBLX)>0.0))
    {
      if (((model_.RCBLI)>0.0))
      {
        // I(c,c3) <+ (white_noise(powerRCCxx))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[18]= powerRCCxx.val();
        }
        // I(c3,c4) <+ (white_noise(powerRCCex))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[19]= powerRCCex.val();
        }
        // I(c4,c1) <+ (white_noise(powerRCCin))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[20]= powerRCCin.val();
        }
      }
      else
      {
        // I(c,c3) <+ (white_noise(powerRCCxx))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[21]= powerRCCxx.val();
        }
        // I(c3,c1) <+ (white_noise(powerRCCex))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[22]= powerRCCex.val();
        }
      }
    }
    else
    {
      if (((model_.RCBLI)>0.0))
      {
        // I(c,c4) <+ (white_noise(powerRCCxx))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[23]= powerRCCxx.val();
        }
        // I(c4,c1) <+ (white_noise(powerRCCin))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[24]= powerRCCin.val();
        }
      }
      else
      {
        // I(c,c1) <+ (white_noise(powerRCCxx))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[25]= powerRCCxx.val();
        }
      }
    }
  }


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_noi_GND] =  "
                 <<probeVars[admsProbeID_V_noi_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c3_c1] =  "
                 <<probeVars[admsProbeID_V_c3_c1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c3_c4] =  "
                 <<probeVars[admsProbeID_V_c3_c4].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c4_c1] =  "
                 <<probeVars[admsProbeID_V_c4_c1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_c] =  "
                 <<probeVars[admsProbeID_V_b_c].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_e] =  "
                 <<probeVars[admsProbeID_V_b_e].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_b1] =  "
                 <<probeVars[admsProbeID_V_b_b1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_e_e1] =  "
                 <<probeVars[admsProbeID_V_e_e1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c1_c2] =  "
                 <<probeVars[admsProbeID_V_c1_c2].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_c1] =  "
                 <<probeVars[admsProbeID_V_s_c1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b1_b2] =  "
                 <<probeVars[admsProbeID_V_b1_b2].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b1_e1] =  "
                 <<probeVars[admsProbeID_V_b1_e1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b2_e1] =  "
                 <<probeVars[admsProbeID_V_b2_e1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b2_c2] =  "
                 <<probeVars[admsProbeID_V_b2_c2].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b2_c1] =  "
                 <<probeVars[admsProbeID_V_b2_c1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_dt_GND] =  "
                 <<probeVars[admsProbeID_V_dt_GND].val() << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c] =  "
                 <<staticContributions[admsNodeID_c].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_noi_GND) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c] =  "
                 <<dynamicContributions[admsNodeID_c].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_noi_GND) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c] =  "
                 <<Jdxp_static[admsNodeID_c] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c] =  "
                 <<Jdxp_dynamic[admsNodeID_c] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b] =  "
                 <<staticContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_noi_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b] =  "
                 <<dynamicContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_noi_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_b] =  "
                 <<Jdxp_static[admsNodeID_b] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_b] =  "
                 <<Jdxp_dynamic[admsNodeID_b] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_e] =  "
                 <<staticContributions[admsNodeID_e].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_noi_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_e] =  "
                 <<dynamicContributions[admsNodeID_e].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_noi_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_e] =  "
                 <<Jdxp_static[admsNodeID_e] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_e] =  "
                 <<Jdxp_dynamic[admsNodeID_e] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_s] =  "
                 <<staticContributions[admsNodeID_s].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_noi_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_s] =  "
                 <<dynamicContributions[admsNodeID_s].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_noi_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_s] =  "
                 <<Jdxp_static[admsNodeID_s] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_s] =  "
                 <<Jdxp_dynamic[admsNodeID_s] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_dt] =  "
                 <<staticContributions[admsNodeID_dt].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_noi_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_dt] =  "
                 <<dynamicContributions[admsNodeID_dt].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_noi_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_dt] =  "
                 <<Jdxp_static[admsNodeID_dt] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_dt] =  "
                 <<Jdxp_dynamic[admsNodeID_dt] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_e1] =  "
                 <<staticContributions[admsNodeID_e1].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_noi_GND) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_e1] =  "
                 <<dynamicContributions[admsNodeID_e1].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_noi_GND) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_e1] =  "
                 <<Jdxp_static[admsNodeID_e1] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_e1] =  "
                 <<Jdxp_dynamic[admsNodeID_e1] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b1] =  "
                 <<staticContributions[admsNodeID_b1].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_noi_GND) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b1] =  "
                 <<dynamicContributions[admsNodeID_b1].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_noi_GND) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_b1] =  "
                 <<Jdxp_static[admsNodeID_b1] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_b1] =  "
                 <<Jdxp_dynamic[admsNodeID_b1] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b2] =  "
                 <<staticContributions[admsNodeID_b2].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_noi_GND) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b2] =  "
                 <<dynamicContributions[admsNodeID_b2].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_noi_GND) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_b2] =  "
                 <<Jdxp_static[admsNodeID_b2] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_b2] =  "
                 <<Jdxp_dynamic[admsNodeID_b2] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c1] =  "
                 <<staticContributions[admsNodeID_c1].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_noi_GND) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c1] =  "
                 <<dynamicContributions[admsNodeID_c1].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_noi_GND) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c1] =  "
                 <<Jdxp_static[admsNodeID_c1] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c1] =  "
                 <<Jdxp_dynamic[admsNodeID_c1] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c2] =  "
                 <<staticContributions[admsNodeID_c2].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_noi_GND) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c2] =  "
                 <<dynamicContributions[admsNodeID_c2].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_noi_GND) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c2] =  "
                 <<Jdxp_static[admsNodeID_c2] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c2] =  "
                 <<Jdxp_dynamic[admsNodeID_c2] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c3] =  "
                 <<staticContributions[admsNodeID_c3].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_noi_GND) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c3] =  "
                 <<dynamicContributions[admsNodeID_c3].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_noi_GND) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c3] =  "
                 <<Jdxp_static[admsNodeID_c3] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c3] =  "
                 <<Jdxp_dynamic[admsNodeID_c3] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c4] =  "
                 <<staticContributions[admsNodeID_c4].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_noi_GND) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c4] =  "
                 <<dynamicContributions[admsNodeID_c4].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_noi_GND) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c4] =  "
                 <<Jdxp_static[admsNodeID_c4] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c4] =  "
                 <<Jdxp_dynamic[admsNodeID_c4] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_noi] =  "
                 <<staticContributions[admsNodeID_noi].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_noi_GND) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_noi] =  "
                 <<dynamicContributions[admsNodeID_noi].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_noi_GND) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_noi_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_noi] =  "
                 <<Jdxp_static[admsNodeID_noi] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_noi] =  "
                 <<Jdxp_dynamic[admsNodeID_noi] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 5 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 13; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 5 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode].val();
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode].val();
      }
    }
  }  
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
  return 26;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
  int numSources=getNumNoiseSources();
  noiseData.numSources = numSources;
  noiseData.resize(numSources);

  noiseData.deviceName = getName().getEncodedName();
  std::string theNoiseName;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_noi_GND");
  noiseData.noiseNames[0]=theNoiseName;
  noiseData.li_Pos[0]=li_noi;
  noiseData.li_Neg[0]=-1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c2_b2");
  noiseData.noiseNames[1]=theNoiseName;
  noiseData.li_Pos[1]=li_c2;
  noiseData.li_Neg[1]=li_b2;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b2_e1");
  noiseData.noiseNames[2]=theNoiseName;
  noiseData.li_Pos[2]=li_b2;
  noiseData.li_Neg[2]=li_e1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_e_e1");
  noiseData.noiseNames[3]=theNoiseName;
  noiseData.li_Pos[3]=li_e;
  noiseData.li_Neg[3]=li_e1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b_b1");
  noiseData.noiseNames[4]=theNoiseName;
  noiseData.li_Pos[4]=li_b;
  noiseData.li_Neg[4]=li_b1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b1_b2");
  noiseData.noiseNames[5]=theNoiseName;
  noiseData.li_Pos[5]=li_b1;
  noiseData.li_Neg[5]=li_b2;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_b2_e1");
  noiseData.noiseNames[6]=theNoiseName;
  noiseData.li_Pos[6]=li_b2;
  noiseData.li_Neg[6]=li_e1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_b2_e1");
  noiseData.noiseNames[7]=theNoiseName;
  noiseData.li_Pos[7]=li_b2;
  noiseData.li_Neg[7]=li_e1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_e1_b1");
  noiseData.noiseNames[8]=theNoiseName;
  noiseData.li_Pos[8]=li_e1;
  noiseData.li_Neg[8]=li_b1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_e1_b1");
  noiseData.noiseNames[9]=theNoiseName;
  noiseData.li_Pos[9]=li_e1;
  noiseData.li_Neg[9]=li_b1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b1_c4");
  noiseData.noiseNames[10]=theNoiseName;
  noiseData.li_Pos[10]=li_b1;
  noiseData.li_Neg[10]=li_c4;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_b1_c4");
  noiseData.noiseNames[11]=theNoiseName;
  noiseData.li_Pos[11]=li_b1;
  noiseData.li_Neg[11]=li_c4;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b1_c4");
  noiseData.noiseNames[12]=theNoiseName;
  noiseData.li_Pos[12]=li_b1;
  noiseData.li_Neg[12]=li_c4;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_b1_c4");
  noiseData.noiseNames[13]=theNoiseName;
  noiseData.li_Pos[13]=li_b1;
  noiseData.li_Neg[13]=li_c4;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b_c3");
  noiseData.noiseNames[14]=theNoiseName;
  noiseData.li_Pos[14]=li_b;
  noiseData.li_Neg[14]=li_c3;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_b_c3");
  noiseData.noiseNames[15]=theNoiseName;
  noiseData.li_Pos[15]=li_b;
  noiseData.li_Neg[15]=li_c3;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b1_s");
  noiseData.noiseNames[16]=theNoiseName;
  noiseData.li_Pos[16]=li_b1;
  noiseData.li_Neg[16]=li_s;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b_s");
  noiseData.noiseNames[17]=theNoiseName;
  noiseData.li_Pos[17]=li_b;
  noiseData.li_Neg[17]=li_s;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c_c3");
  noiseData.noiseNames[18]=theNoiseName;
  noiseData.li_Pos[18]=li_c;
  noiseData.li_Neg[18]=li_c3;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c3_c4");
  noiseData.noiseNames[19]=theNoiseName;
  noiseData.li_Pos[19]=li_c3;
  noiseData.li_Neg[19]=li_c4;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c4_c1");
  noiseData.noiseNames[20]=theNoiseName;
  noiseData.li_Pos[20]=li_c4;
  noiseData.li_Neg[20]=li_c1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c_c3");
  noiseData.noiseNames[21]=theNoiseName;
  noiseData.li_Pos[21]=li_c;
  noiseData.li_Neg[21]=li_c3;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c3_c1");
  noiseData.noiseNames[22]=theNoiseName;
  noiseData.li_Pos[22]=li_c3;
  noiseData.li_Neg[22]=li_c1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c_c4");
  noiseData.noiseNames[23]=theNoiseName;
  noiseData.li_Pos[23]=li_c;
  noiseData.li_Neg[23]=li_c4;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c4_c1");
  noiseData.noiseNames[24]=theNoiseName;
  noiseData.li_Pos[24]=li_c4;
  noiseData.li_Neg[24]=li_c1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c_c1");
  noiseData.noiseNames[25]=theNoiseName;
  noiseData.li_Pos[25]=li_c;
  noiseData.li_Neg[25]=li_c1;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];
  noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
  noiseData.noiseDens[1] = noiseContribsPower[1];
  noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
  noiseData.noiseDens[2] = noiseContribsPower[2];
  noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
  noiseData.noiseDens[3] = noiseContribsPower[3];
  noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
  noiseData.noiseDens[4] = noiseContribsPower[4];
  noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
  noiseData.noiseDens[5] = noiseContribsPower[5];
  noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));
  noiseData.noiseDens[6] = noiseContribsPower[6];

  noiseData.noiseDens[6] /= pow(noiseData.freq,noiseContribsExponent[6]);noiseData.lnNoiseDens[6] = std::log(std::max(noiseData.noiseDens[6],N_MINLOG));
  noiseData.noiseDens[7] = noiseContribsPower[7];

  noiseData.noiseDens[7] /= pow(noiseData.freq,noiseContribsExponent[7]);noiseData.lnNoiseDens[7] = std::log(std::max(noiseData.noiseDens[7],N_MINLOG));
  noiseData.noiseDens[8] = noiseContribsPower[8];
  noiseData.lnNoiseDens[8] = std::log(std::max(noiseData.noiseDens[8],N_MINLOG));
  noiseData.noiseDens[9] = noiseContribsPower[9];

  noiseData.noiseDens[9] /= pow(noiseData.freq,noiseContribsExponent[9]);noiseData.lnNoiseDens[9] = std::log(std::max(noiseData.noiseDens[9],N_MINLOG));
  noiseData.noiseDens[10] = noiseContribsPower[10];
  noiseData.lnNoiseDens[10] = std::log(std::max(noiseData.noiseDens[10],N_MINLOG));
  noiseData.noiseDens[11] = noiseContribsPower[11];

  noiseData.noiseDens[11] /= pow(noiseData.freq,noiseContribsExponent[11]);noiseData.lnNoiseDens[11] = std::log(std::max(noiseData.noiseDens[11],N_MINLOG));
  noiseData.noiseDens[12] = noiseContribsPower[12];
  noiseData.lnNoiseDens[12] = std::log(std::max(noiseData.noiseDens[12],N_MINLOG));
  noiseData.noiseDens[13] = noiseContribsPower[13];

  noiseData.noiseDens[13] /= pow(noiseData.freq,noiseContribsExponent[13]);noiseData.lnNoiseDens[13] = std::log(std::max(noiseData.noiseDens[13],N_MINLOG));
  noiseData.noiseDens[14] = noiseContribsPower[14];
  noiseData.lnNoiseDens[14] = std::log(std::max(noiseData.noiseDens[14],N_MINLOG));
  noiseData.noiseDens[15] = noiseContribsPower[15];

  noiseData.noiseDens[15] /= pow(noiseData.freq,noiseContribsExponent[15]);noiseData.lnNoiseDens[15] = std::log(std::max(noiseData.noiseDens[15],N_MINLOG));
  noiseData.noiseDens[16] = noiseContribsPower[16];
  noiseData.lnNoiseDens[16] = std::log(std::max(noiseData.noiseDens[16],N_MINLOG));
  noiseData.noiseDens[17] = noiseContribsPower[17];
  noiseData.lnNoiseDens[17] = std::log(std::max(noiseData.noiseDens[17],N_MINLOG));
  noiseData.noiseDens[18] = noiseContribsPower[18];
  noiseData.lnNoiseDens[18] = std::log(std::max(noiseData.noiseDens[18],N_MINLOG));
  noiseData.noiseDens[19] = noiseContribsPower[19];
  noiseData.lnNoiseDens[19] = std::log(std::max(noiseData.noiseDens[19],N_MINLOG));
  noiseData.noiseDens[20] = noiseContribsPower[20];
  noiseData.lnNoiseDens[20] = std::log(std::max(noiseData.noiseDens[20],N_MINLOG));
  noiseData.noiseDens[21] = noiseContribsPower[21];
  noiseData.lnNoiseDens[21] = std::log(std::max(noiseData.noiseDens[21],N_MINLOG));
  noiseData.noiseDens[22] = noiseContribsPower[22];
  noiseData.lnNoiseDens[22] = std::log(std::max(noiseData.noiseDens[22],N_MINLOG));
  noiseData.noiseDens[23] = noiseContribsPower[23];
  noiseData.lnNoiseDens[23] = std::log(std::max(noiseData.noiseDens[23],N_MINLOG));
  noiseData.noiseDens[24] = noiseContribsPower[24];
  noiseData.lnNoiseDens[24] = std::log(std::max(noiseData.noiseDens[24],N_MINLOG));
  noiseData.noiseDens[25] = noiseContribsPower[25];
  noiseData.lnNoiseDens[25] = std::log(std::max(noiseData.noiseDens[25],N_MINLOG));

}  

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_c1_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2);
  (*f_c1_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2);
  (*f_c2_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2);
  (*f_c2_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2);
  (*f_c1_Equ_b2_Node_Ptr) +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1);
  (*f_c2_Equ_b2_Node_Ptr) +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1);
  (*f_c1_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_c1].dx(admsProbeID_V_dt_GND);
  (*f_c2_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_dt_GND);
  (*f_e1_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2);
  (*f_e1_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2);
  (*f_e1_Equ_b2_Node_Ptr) +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1);
  (*f_c2_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1);
  (*f_e1_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1) -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1);
  (*f_e1_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_dt_GND);
  (*f_b1_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1);
  (*f_b1_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1);
  (*f_e1_Equ_b1_Node_Ptr) +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1);
  (*f_b1_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_dt_GND);
  (*f_b2_Equ_b2_Node_Ptr) +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1);
  (*f_b2_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1);
  (*f_b2_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_dt_GND);
  (*f_b2_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2);
  (*f_b2_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2);
  (*f_b1_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1);
  (*f_b1_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1);
  (*f_s_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c1);
  (*f_s_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c1);
  (*f_b1_Equ_c4_Node_Ptr) +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1);
  (*f_s_Equ_c4_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1);
  (*f_b1_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2);
  (*f_s_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2);
  (*f_b1_Equ_b2_Node_Ptr) +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2);
  (*f_s_Equ_b2_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2);
  (*f_s_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2);
  (*f_s_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_dt_GND);
  (*f_b_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  (*f_b_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  (*f_b_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2);
  (*f_b_Equ_b2_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1);
  (*f_b_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1);
  (*f_s_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1);
  (*f_b_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  (*f_b_Equ_c4_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  (*f_s_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4);
  (*f_b_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2);
  (*f_b_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_b1);
  (*f_s_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b_b1);
  (*f_b_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c);
  (*f_s_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c);
  (*f_b_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND);
  (*f_c1_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1);
  (*f_b1_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4);
  (*f_b2_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  (*f_b2_Equ_c4_Node_Ptr) +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  (*f_b1_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1);
  (*f_b2_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1);
  (*f_b2_Equ_b1_Node_Ptr) +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1);
  (*f_b1_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_c);
  (*f_b2_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_c);
  (*f_c2_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  (*f_c2_Equ_c4_Node_Ptr) +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  (*f_c2_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2);
  (*f_c2_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1);
  (*f_c2_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_c);
  (*f_e_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_dt_GND);
  (*f_e_Equ_e_Node_Ptr) +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_e_e1);
  (*f_e_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_e_e1);
  (*f_e1_Equ_e_Node_Ptr) +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1);
  (*f_dt_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND);
  (*f_dt_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_c1);
  (*f_dt_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_c1);
  (*f_dt_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b1_e1);
  (*f_dt_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_e1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_e1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b1_e1);
  (*f_dt_Equ_e_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_e1);
  (*f_dt_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c4);
  (*f_dt_Equ_c4_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c4);
  (*f_dt_Equ_b2_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b1_b2);
  (*f_dt_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_b1);
  (*f_dt_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_c);
  (*f_dt_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_c1_c2);
  (*f_c1_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1);
  (*f_c1_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2);
  (*f_c1_Equ_c4_Node_Ptr) +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1);
  (*f_c1_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4);
  (*f_c1_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1);
  (*f_c1_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_c);
  (*f_c_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c].dx(admsProbeID_V_b_b1);
  (*f_c_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  (*f_c3_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  (*f_c3_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  (*f_c3_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2);
  (*f_c3_Equ_b2_Node_Ptr) +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1);
  (*f_c3_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1);
  (*f_c3_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  (*f_c3_Equ_c4_Node_Ptr) +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  (*f_c3_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2);
  (*f_c3_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1);
  (*f_c3_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_c);
  (*f_c3_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_dt_GND);
  (*f_c_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_dt_GND);
  (*f_c_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4);
  (*f_c_Equ_c4_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4);
  (*f_c_Equ_c1_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1);
  (*f_c_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2);
  (*f_c_Equ_b2_Node_Ptr) +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2);
  (*f_c_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2);
  (*f_c4_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_dt_GND);
  (*f_c4_Equ_c4_Node_Ptr) +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1);
  (*f_c4_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1);
  (*f_c4_Equ_b2_Node_Ptr) +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1);
  (*f_c4_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1);
  (*f_c4_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2);
  (*f_c4_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2);
  (*f_c4_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4);
  (*f_c4_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1);
  (*f_c4_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1);
  (*f_c4_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_c);
  (*f_noi_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2);
  (*f_noi_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2);
  (*f_noi_Equ_b2_Node_Ptr) +=  +staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1);
  (*f_noi_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1);
  (*f_noi_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_noi].dx(admsProbeID_V_dt_GND);
  (*f_noi_Equ_noi_Node_Ptr) +=  +staticContributions[admsNodeID_noi].dx(admsProbeID_V_noi_GND);
  (*f_b2_Equ_noi_Node_Ptr) +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_noi_GND);
  (*f_e1_Equ_noi_Node_Ptr) +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_noi_GND);
  (*f_c2_Equ_noi_Node_Ptr) +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_noi_GND);

#else
  //use the offsets instead of pointers
  dFdx[li_c1][A_c1_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2);
  dFdx[li_c1][A_c1_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2);
  dFdx[li_c2][A_c2_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2);
  dFdx[li_c2][A_c2_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2);
  dFdx[li_c1][A_c1_Equ_b2_NodeOffset] +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1);
  dFdx[li_c2][A_c2_Equ_b2_NodeOffset] +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1);
  dFdx[li_c1][A_c1_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_c1].dx(admsProbeID_V_dt_GND);
  dFdx[li_c2][A_c2_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_dt_GND);
  dFdx[li_e1][A_e1_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2);
  dFdx[li_e1][A_e1_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2);
  dFdx[li_e1][A_e1_Equ_b2_NodeOffset] +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1);
  dFdx[li_c2][A_c2_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1);
  dFdx[li_e1][A_e1_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1) -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1);
  dFdx[li_e1][A_e1_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_dt_GND);
  dFdx[li_b1][A_b1_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1);
  dFdx[li_b1][A_b1_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1);
  dFdx[li_e1][A_e1_Equ_b1_NodeOffset] +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1);
  dFdx[li_b1][A_b1_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_dt_GND);
  dFdx[li_b2][A_b2_Equ_b2_NodeOffset] +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1);
  dFdx[li_b2][A_b2_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1);
  dFdx[li_b2][A_b2_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_dt_GND);
  dFdx[li_b2][A_b2_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2);
  dFdx[li_b2][A_b2_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2);
  dFdx[li_b1][A_b1_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1);
  dFdx[li_b1][A_b1_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1);
  dFdx[li_s][A_s_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c1);
  dFdx[li_s][A_s_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c1);
  dFdx[li_b1][A_b1_Equ_c4_NodeOffset] +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1);
  dFdx[li_s][A_s_Equ_c4_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1);
  dFdx[li_b1][A_b1_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2);
  dFdx[li_s][A_s_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2);
  dFdx[li_b1][A_b1_Equ_b2_NodeOffset] +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2);
  dFdx[li_s][A_s_Equ_b2_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2);
  dFdx[li_s][A_s_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2);
  dFdx[li_s][A_s_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_dt_GND);
  dFdx[li_b][A_b_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  dFdx[li_b][A_b_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  dFdx[li_b][A_b_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2);
  dFdx[li_b][A_b_Equ_b2_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1);
  dFdx[li_b][A_b_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1);
  dFdx[li_s][A_s_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1);
  dFdx[li_b][A_b_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  dFdx[li_b][A_b_Equ_c4_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  dFdx[li_s][A_s_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4);
  dFdx[li_b][A_b_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2);
  dFdx[li_b][A_b_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_b1);
  dFdx[li_s][A_s_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b_b1);
  dFdx[li_b][A_b_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c);
  dFdx[li_s][A_s_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c);
  dFdx[li_b][A_b_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND);
  dFdx[li_c1][A_c1_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1);
  dFdx[li_b1][A_b1_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4);
  dFdx[li_b2][A_b2_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  dFdx[li_b2][A_b2_Equ_c4_NodeOffset] +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  dFdx[li_b1][A_b1_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1);
  dFdx[li_b2][A_b2_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1);
  dFdx[li_b2][A_b2_Equ_b1_NodeOffset] +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1);
  dFdx[li_b1][A_b1_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_c);
  dFdx[li_b2][A_b2_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_c);
  dFdx[li_c2][A_c2_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  dFdx[li_c2][A_c2_Equ_c4_NodeOffset] +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  dFdx[li_c2][A_c2_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2);
  dFdx[li_c2][A_c2_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1);
  dFdx[li_c2][A_c2_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_c);
  dFdx[li_e][A_e_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_dt_GND);
  dFdx[li_e][A_e_Equ_e_NodeOffset] +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_e_e1);
  dFdx[li_e][A_e_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_e_e1);
  dFdx[li_e1][A_e1_Equ_e_NodeOffset] +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1);
  dFdx[li_dt][A_dt_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND);
  dFdx[li_dt][A_dt_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_c1);
  dFdx[li_dt][A_dt_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_c1);
  dFdx[li_dt][A_dt_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b1_e1);
  dFdx[li_dt][A_dt_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_e1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_e1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b1_e1);
  dFdx[li_dt][A_dt_Equ_e_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_e1);
  dFdx[li_dt][A_dt_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c4);
  dFdx[li_dt][A_dt_Equ_c4_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c4);
  dFdx[li_dt][A_dt_Equ_b2_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b1_b2);
  dFdx[li_dt][A_dt_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_b1);
  dFdx[li_dt][A_dt_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_c);
  dFdx[li_dt][A_dt_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_c1_c2);
  dFdx[li_c1][A_c1_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1);
  dFdx[li_c1][A_c1_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2);
  dFdx[li_c1][A_c1_Equ_c4_NodeOffset] +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1);
  dFdx[li_c1][A_c1_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4);
  dFdx[li_c1][A_c1_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1);
  dFdx[li_c1][A_c1_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_c);
  dFdx[li_c][A_c_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c].dx(admsProbeID_V_b_b1);
  dFdx[li_c][A_c_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  dFdx[li_c3][A_c3_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  dFdx[li_c3][A_c3_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  dFdx[li_c3][A_c3_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2);
  dFdx[li_c3][A_c3_Equ_b2_NodeOffset] +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1);
  dFdx[li_c3][A_c3_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1);
  dFdx[li_c3][A_c3_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  dFdx[li_c3][A_c3_Equ_c4_NodeOffset] +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  dFdx[li_c3][A_c3_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2);
  dFdx[li_c3][A_c3_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1);
  dFdx[li_c3][A_c3_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_c);
  dFdx[li_c3][A_c3_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_dt_GND);
  dFdx[li_c][A_c_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_dt_GND);
  dFdx[li_c][A_c_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4);
  dFdx[li_c][A_c_Equ_c4_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4);
  dFdx[li_c][A_c_Equ_c1_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1);
  dFdx[li_c][A_c_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2);
  dFdx[li_c][A_c_Equ_b2_NodeOffset] +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2);
  dFdx[li_c][A_c_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2);
  dFdx[li_c4][A_c4_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_dt_GND);
  dFdx[li_c4][A_c4_Equ_c4_NodeOffset] +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1);
  dFdx[li_c4][A_c4_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1);
  dFdx[li_c4][A_c4_Equ_b2_NodeOffset] +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1);
  dFdx[li_c4][A_c4_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1);
  dFdx[li_c4][A_c4_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2);
  dFdx[li_c4][A_c4_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2);
  dFdx[li_c4][A_c4_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4);
  dFdx[li_c4][A_c4_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1);
  dFdx[li_c4][A_c4_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1);
  dFdx[li_c4][A_c4_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_c);
  dFdx[li_noi][A_noi_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2);
  dFdx[li_noi][A_noi_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2);
  dFdx[li_noi][A_noi_Equ_b2_NodeOffset] +=  +staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1);
  dFdx[li_noi][A_noi_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1);
  dFdx[li_noi][A_noi_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_noi].dx(admsProbeID_V_dt_GND);
  dFdx[li_noi][A_noi_Equ_noi_NodeOffset] +=  +staticContributions[admsNodeID_noi].dx(admsProbeID_V_noi_GND);
  dFdx[li_b2][A_b2_Equ_noi_NodeOffset] +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_noi_GND);
  dFdx[li_e1][A_e1_Equ_noi_NodeOffset] +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_noi_GND);
  dFdx[li_c2][A_c2_Equ_noi_NodeOffset] +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_noi_GND);

#endif
  
  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_c1_Equ_c1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2);
  (*q_c1_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2);
  (*q_c2_Equ_c1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1);
  (*q_c2_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2);
  (*q_c1_Equ_b2_Node_Ptr) +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1);
  (*q_c2_Equ_b2_Node_Ptr) +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2);
  (*q_c1_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_dt_GND);
  (*q_c2_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_dt_GND);
  (*q_e1_Equ_c1_Node_Ptr) +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1);
  (*q_e1_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2);
  (*q_e1_Equ_b2_Node_Ptr) +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2);
  (*q_c2_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1);
  (*q_e1_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1);
  (*q_e1_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_dt_GND);
  (*q_b1_Equ_b1_Node_Ptr) +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1);
  (*q_b1_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1);
  (*q_e1_Equ_b1_Node_Ptr) +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2);
  (*q_b1_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_dt_GND);
  (*q_b2_Equ_b2_Node_Ptr) +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2);
  (*q_b2_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1);
  (*q_b2_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_dt_GND);
  (*q_b2_Equ_c1_Node_Ptr) +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1);
  (*q_b2_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2);
  (*q_b1_Equ_c1_Node_Ptr) +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2);
  (*q_s_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c1);
  (*q_s_Equ_c1_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2);
  (*q_b1_Equ_c4_Node_Ptr) +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4);
  (*q_s_Equ_c4_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1);
  (*q_b1_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2);
  (*q_s_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2);
  (*q_b1_Equ_b2_Node_Ptr) +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1);
  (*q_s_Equ_b2_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1);
  (*q_s_Equ_b1_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_e1);
  (*q_s_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_dt_GND);
  (*q_b_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  (*q_b_Equ_c1_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  (*q_b_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2);
  (*q_b_Equ_b2_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1);
  (*q_b_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1);
  (*q_s_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1);
  (*q_b_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  (*q_b_Equ_c4_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  (*q_s_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4);
  (*q_b_Equ_b1_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_e1);
  (*q_b_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  (*q_s_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_b1);
  (*q_b_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c);
  (*q_s_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_c);
  (*q_b_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND);
  (*q_c1_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1);
  (*q_b1_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4);
  (*q_b2_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  (*q_b2_Equ_c4_Node_Ptr) +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  (*q_b1_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1);
  (*q_b2_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1);
  (*q_b2_Equ_b1_Node_Ptr) +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2);
  (*q_b1_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_c);
  (*q_b2_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_c);
  (*q_c2_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  (*q_c2_Equ_c4_Node_Ptr) +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  (*q_c2_Equ_b1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2);
  (*q_c2_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1);
  (*q_c2_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_c);
  (*q_e_Equ_e_Node_Ptr) +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  (*q_dt_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND);
  (*q_e1_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4);
  (*q_e1_Equ_c4_Node_Ptr) +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4);
  (*q_e1_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1);
  (*q_e1_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_c);
  (*q_c1_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1);
  (*q_c1_Equ_b1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_e1);
  (*q_c1_Equ_c4_Node_Ptr) +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1);
  (*q_c1_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4);
  (*q_c1_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1);
  (*q_c1_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_c);
  (*q_b_Equ_e_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  (*q_e_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  (*q_c_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  (*q_c_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  (*q_c3_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  (*q_c3_Equ_c1_Node_Ptr) +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  (*q_c3_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2);
  (*q_c3_Equ_b2_Node_Ptr) +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1);
  (*q_c3_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1);
  (*q_c3_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  (*q_c3_Equ_c4_Node_Ptr) +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  (*q_c3_Equ_b1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_e1);
  (*q_c3_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1);
  (*q_c3_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_c);
  (*q_c3_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_dt_GND);
  (*q_c4_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_dt_GND);
  (*q_c4_Equ_c4_Node_Ptr) +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1);
  (*q_c4_Equ_c1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1);
  (*q_c4_Equ_b2_Node_Ptr) +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1);
  (*q_c4_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1);
  (*q_c4_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2);
  (*q_c4_Equ_b1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_e1);
  (*q_c4_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4);
  (*q_c4_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1);
  (*q_c4_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1);
  (*q_c4_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_c);
  (*q_b2_Equ_noi_Node_Ptr) +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_noi_GND);
  (*q_e1_Equ_noi_Node_Ptr) +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_noi_GND);

#else
  //use the offsets instead of pointers
  dQdx[li_c1][A_c1_Equ_c1_NodeOffset] +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2);
  dQdx[li_c1][A_c1_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2);
  dQdx[li_c2][A_c2_Equ_c1_NodeOffset] +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1);
  dQdx[li_c2][A_c2_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2);
  dQdx[li_c1][A_c1_Equ_b2_NodeOffset] +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1);
  dQdx[li_c2][A_c2_Equ_b2_NodeOffset] +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2);
  dQdx[li_c1][A_c1_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_dt_GND);
  dQdx[li_c2][A_c2_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_dt_GND);
  dQdx[li_e1][A_e1_Equ_c1_NodeOffset] +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1);
  dQdx[li_e1][A_e1_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2);
  dQdx[li_e1][A_e1_Equ_b2_NodeOffset] +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2);
  dQdx[li_c2][A_c2_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1);
  dQdx[li_e1][A_e1_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1);
  dQdx[li_e1][A_e1_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_dt_GND);
  dQdx[li_b1][A_b1_Equ_b1_NodeOffset] +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1);
  dQdx[li_b1][A_b1_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1);
  dQdx[li_e1][A_e1_Equ_b1_NodeOffset] +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2);
  dQdx[li_b1][A_b1_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_dt_GND);
  dQdx[li_b2][A_b2_Equ_b2_NodeOffset] +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2);
  dQdx[li_b2][A_b2_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1);
  dQdx[li_b2][A_b2_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_dt_GND);
  dQdx[li_b2][A_b2_Equ_c1_NodeOffset] +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1);
  dQdx[li_b2][A_b2_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2);
  dQdx[li_b1][A_b1_Equ_c1_NodeOffset] +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2);
  dQdx[li_s][A_s_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c1);
  dQdx[li_s][A_s_Equ_c1_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2);
  dQdx[li_b1][A_b1_Equ_c4_NodeOffset] +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4);
  dQdx[li_s][A_s_Equ_c4_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1);
  dQdx[li_b1][A_b1_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2);
  dQdx[li_s][A_s_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2);
  dQdx[li_b1][A_b1_Equ_b2_NodeOffset] +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1);
  dQdx[li_s][A_s_Equ_b2_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1);
  dQdx[li_s][A_s_Equ_b1_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_e1);
  dQdx[li_s][A_s_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_dt_GND);
  dQdx[li_b][A_b_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  dQdx[li_b][A_b_Equ_c1_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  dQdx[li_b][A_b_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2);
  dQdx[li_b][A_b_Equ_b2_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1);
  dQdx[li_b][A_b_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1);
  dQdx[li_s][A_s_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1);
  dQdx[li_b][A_b_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  dQdx[li_b][A_b_Equ_c4_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  dQdx[li_s][A_s_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4);
  dQdx[li_b][A_b_Equ_b1_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_e1);
  dQdx[li_b][A_b_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  dQdx[li_s][A_s_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_b1);
  dQdx[li_b][A_b_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c);
  dQdx[li_s][A_s_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_c);
  dQdx[li_b][A_b_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND);
  dQdx[li_c1][A_c1_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1);
  dQdx[li_b1][A_b1_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4);
  dQdx[li_b2][A_b2_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  dQdx[li_b2][A_b2_Equ_c4_NodeOffset] +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  dQdx[li_b1][A_b1_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1);
  dQdx[li_b2][A_b2_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1);
  dQdx[li_b2][A_b2_Equ_b1_NodeOffset] +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2);
  dQdx[li_b1][A_b1_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_c);
  dQdx[li_b2][A_b2_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_c);
  dQdx[li_c2][A_c2_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  dQdx[li_c2][A_c2_Equ_c4_NodeOffset] +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  dQdx[li_c2][A_c2_Equ_b1_NodeOffset] +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2);
  dQdx[li_c2][A_c2_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1);
  dQdx[li_c2][A_c2_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_c);
  dQdx[li_e][A_e_Equ_e_NodeOffset] +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  dQdx[li_dt][A_dt_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND);
  dQdx[li_e1][A_e1_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4);
  dQdx[li_e1][A_e1_Equ_c4_NodeOffset] +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4);
  dQdx[li_e1][A_e1_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1);
  dQdx[li_e1][A_e1_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_c);
  dQdx[li_c1][A_c1_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1);
  dQdx[li_c1][A_c1_Equ_b1_NodeOffset] +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_e1);
  dQdx[li_c1][A_c1_Equ_c4_NodeOffset] +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1);
  dQdx[li_c1][A_c1_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4);
  dQdx[li_c1][A_c1_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1);
  dQdx[li_c1][A_c1_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_c);
  dQdx[li_b][A_b_Equ_e_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  dQdx[li_e][A_e_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  dQdx[li_c][A_c_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  dQdx[li_c][A_c_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  dQdx[li_c3][A_c3_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  dQdx[li_c3][A_c3_Equ_c1_NodeOffset] +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  dQdx[li_c3][A_c3_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2);
  dQdx[li_c3][A_c3_Equ_b2_NodeOffset] +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1);
  dQdx[li_c3][A_c3_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1);
  dQdx[li_c3][A_c3_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  dQdx[li_c3][A_c3_Equ_c4_NodeOffset] +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  dQdx[li_c3][A_c3_Equ_b1_NodeOffset] +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_e1);
  dQdx[li_c3][A_c3_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1);
  dQdx[li_c3][A_c3_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_c);
  dQdx[li_c3][A_c3_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_dt_GND);
  dQdx[li_c4][A_c4_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_dt_GND);
  dQdx[li_c4][A_c4_Equ_c4_NodeOffset] +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1);
  dQdx[li_c4][A_c4_Equ_c1_NodeOffset] +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1);
  dQdx[li_c4][A_c4_Equ_b2_NodeOffset] +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1);
  dQdx[li_c4][A_c4_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1);
  dQdx[li_c4][A_c4_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2);
  dQdx[li_c4][A_c4_Equ_b1_NodeOffset] +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_e1);
  dQdx[li_c4][A_c4_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4);
  dQdx[li_c4][A_c4_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1);
  dQdx[li_c4][A_c4_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1);
  dQdx[li_c4][A_c4_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_c);
  dQdx[li_b2][A_b2_Equ_noi_NodeOffset] +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_noi_GND);
  dQdx[li_e1][A_e1_Equ_noi_NodeOffset] +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_noi_GND);

  
#endif
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

  // set internal model type based on model card type
  if (getType() == "pnp" || getType() == "PNP")
    TYPE = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter LEVEL : [ 504, 505 [
  if ( (!((LEVEL >=504 && LEVEL <505 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter LEVEL value " << LEVEL << " out of range [ 504, 505 [";
  }

  //    Parameter TREF : [ (-273.0),  (+inf) [
  if ( (!((TREF >=(-273.0)))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter TREF value " << TREF << " out of range [ (-273.0),  (+inf) [";
  }

  //    Parameter EXMOD : [ 0, 2 ]
  if ( (!((EXMOD >=0 && EXMOD <=2 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter EXMOD value " << EXMOD << " out of range [ 0, 2 ]";
  }

  //    Parameter EXPHI : [ 0, 1 ]
  if ( (!((EXPHI >=0 && EXPHI <=1 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter EXPHI value " << EXPHI << " out of range [ 0, 1 ]";
  }

  //    Parameter EXAVL : [ 0, 1 ]
  if ( (!((EXAVL >=0 && EXAVL <=1 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter EXAVL value " << EXAVL << " out of range [ 0, 1 ]";
  }

  //    Parameter EXSUB : [ 0, 1 ]
  if ( (!((EXSUB >=0 && EXSUB <=1 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter EXSUB value " << EXSUB << " out of range [ 0, 1 ]";
  }

  //    Parameter IS : ] 0.0,  (+inf) [
  if ( (!((IS >0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter IS value " << IS << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter IK : [ 1.0*1.0e-12,  (+inf) [
  if ( (!((IK >=1.0*1.0e-12))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter IK value " << IK << " out of range [ 1.0*1.0e-12,  (+inf) [";
  }

  //    Parameter VER : [ 0.01,  (+inf) [
  if ( (!((VER >=0.01))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter VER value " << VER << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter VEF : [ 0.01,  (+inf) [
  if ( (!((VEF >=0.01))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter VEF value " << VEF << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter BF : [ 0.1*1.0e-3,  (+inf) [
  if ( (!((BF >=0.1*1.0e-3))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter BF value " << BF << " out of range [ 0.1*1.0e-3,  (+inf) [";
  }

  //    Parameter IBF : [ 0.0,  (+inf) [
  if ( (!((IBF >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter IBF value " << IBF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter MLF : [ 0.1,  (+inf) [
  if ( (!((MLF >=0.1))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter MLF value " << MLF << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter XIBI : [ 0.0, 1.0 ]
  if ( (!((XIBI >=0.0 && XIBI <=1.0 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter XIBI value " << XIBI << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter IZEB : [ 0.0,  (+inf) [
  if ( (!((IZEB >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter IZEB value " << IZEB << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter NZEB : [ 0.0,  (+inf) [
  if ( (!((NZEB >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter NZEB value " << NZEB << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter BRI : [ 1.0e-4,  (+inf) [
  if ( (!((BRI >=1.0e-4))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter BRI value " << BRI << " out of range [ 1.0e-4,  (+inf) [";
  }

  //    Parameter IBR : [ 0.0,  (+inf) [
  if ( (!((IBR >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter IBR value " << IBR << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter XEXT : [ 0.0, 1.0 ]
  if ( (!((XEXT >=0.0 && XEXT <=1.0 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter XEXT value " << XEXT << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter WAVL : [ 1.0*1.0e-9,  (+inf) [
  if ( (!((WAVL >=1.0*1.0e-9))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter WAVL value " << WAVL << " out of range [ 1.0*1.0e-9,  (+inf) [";
  }

  //    Parameter VAVL : [ 0.01,  (+inf) [
  if ( (!((VAVL >=0.01))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter VAVL value " << VAVL << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter SFH : [ 0.0,  (+inf) [
  if ( (!((SFH >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter SFH value " << SFH << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RE : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RE >=1.0*1.0e-3))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter RE value " << RE << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter RBC : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RBC >=1.0*1.0e-3))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter RBC value " << RBC << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter RBV : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RBV >=1.0*1.0e-3))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter RBV value " << RBV << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter RCC : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RCC >=1.0*1.0e-3))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter RCC value " << RCC << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter RCV : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RCV >=1.0*1.0e-3))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter RCV value " << RCV << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter SCRCV : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((SCRCV >=1.0*1.0e-3))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter SCRCV value " << SCRCV << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter IHC : [ 1.0*1.0e-12,  (+inf) [
  if ( (!((IHC >=1.0*1.0e-12))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter IHC value " << IHC << " out of range [ 1.0*1.0e-12,  (+inf) [";
  }

  //    Parameter AXI : [ 0.02,  (+inf) [
  if ( (!((AXI >=0.02))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter AXI value " << AXI << " out of range [ 0.02,  (+inf) [";
  }

  //    Parameter CJE : [ 0.0,  (+inf) [
  if ( (!((CJE >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter CJE value " << CJE << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VDE : [ 0.05,  (+inf) [
  if ( (!((VDE >=0.05))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter VDE value " << VDE << " out of range [ 0.05,  (+inf) [";
  }

  //    Parameter PE : [ 0.01, 0.99 [
  if ( (!((PE >=0.01 && PE <0.99 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter PE value " << PE << " out of range [ 0.01, 0.99 [";
  }

  //    Parameter XCJE : [ 0.0, 1.0 ]
  if ( (!((XCJE >=0.0 && XCJE <=1.0 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter XCJE value " << XCJE << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter CBEO : [ 0.0,  (+inf) [
  if ( (!((CBEO >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter CBEO value " << CBEO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CJC : [ 0.0,  (+inf) [
  if ( (!((CJC >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter CJC value " << CJC << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VDC : [ 0.05,  (+inf) [
  if ( (!((VDC >=0.05))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter VDC value " << VDC << " out of range [ 0.05,  (+inf) [";
  }

  //    Parameter PC : [ 0.01, 0.99 [
  if ( (!((PC >=0.01 && PC <0.99 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter PC value " << PC << " out of range [ 0.01, 0.99 [";
  }

  //    Parameter XP : [ 0.0, 0.99 [
  if ( (!((XP >=0.0 && XP <0.99 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter XP value " << XP << " out of range [ 0.0, 0.99 [";
  }

  //    Parameter MC : [ 0.0, 1.0 [
  if ( (!((MC >=0.0 && MC <1.0 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter MC value " << MC << " out of range [ 0.0, 1.0 [";
  }

  //    Parameter XCJC : [ 0.0, 1.0 ]
  if ( (!((XCJC >=0.0 && XCJC <=1.0 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter XCJC value " << XCJC << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter RCBLX : [ 0.0,  (+inf) [
  if ( (!((RCBLX >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter RCBLX value " << RCBLX << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RCBLI : [ 0.0,  (+inf) [
  if ( (!((RCBLI >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter RCBLI value " << RCBLI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CBCO : [ 0.0,  (+inf) [
  if ( (!((CBCO >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter CBCO value " << CBCO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter MTAU : [ 0.1,  (+inf) [
  if ( (!((MTAU >=0.1))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter MTAU value " << MTAU << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter TAUE : [ 0.0,  (+inf) [
  if ( (!((TAUE >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter TAUE value " << TAUE << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter TAUB : ] 0.0,  (+inf) [
  if ( (!((TAUB >0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter TAUB value " << TAUB << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter TEPI : [ 0.0,  (+inf) [
  if ( (!((TEPI >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter TEPI value " << TEPI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter TAUR : [ 0.0,  (+inf) [
  if ( (!((TAUR >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter TAUR value " << TAUR << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter XREC : [ 0.0,  (+inf) [
  if ( (!((XREC >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter XREC value " << XREC << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter XQB : [ 0.0, 1.0 ]
  if ( (!((XQB >=0.0 && XQB <=1.0 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter XQB value " << XQB << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter ACBL : [ 0.0,  (+inf) [
  if ( (!((ACBL >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter ACBL value " << ACBL << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VGB : [ 0.1,  (+inf) [
  if ( (!((VGB >=0.1))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter VGB value " << VGB << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VGC : [ 0.1,  (+inf) [
  if ( (!((VGC >=0.1))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter VGC value " << VGC << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VGJ : [ 0.1,  (+inf) [
  if ( (!((VGJ >=0.1))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter VGJ value " << VGJ << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VGZEB : [ 0.1,  (+inf) [
  if ( (!((VGZEB >=0.1))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter VGZEB value " << VGZEB << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter AVGEB :  ] (-inf)  (+inf) [

  //    Parameter TVGEB : [ 0.0,  (+inf) [
  if ( (!((TVGEB >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter TVGEB value " << TVGEB << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter AF : [ 0.01,  (+inf) [
  if ( (!((AF >=0.01))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter AF value " << AF << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter KF : [ 0.0,  (+inf) [
  if ( (!((KF >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter KF value " << KF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter KFN : [ 0.0,  (+inf) [
  if ( (!((KFN >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter KFN value " << KFN << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter KAVL : [ 0, 1 ]
  if ( (!((KAVL >=0 && KAVL <=1 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter KAVL value " << KAVL << " out of range [ 0, 1 ]";
  }

  //    Parameter KC : [ 0, 2 ]
  if ( (!((KC >=0 && KC <=2 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter KC value " << KC << " out of range [ 0, 2 ]";
  }

  //    Parameter KE : [ 0.0, 1.0 ]
  if ( (!((KE >=0.0 && KE <=1.0 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter KE value " << KE << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter FTAUN : [ 0.0, 1.0 ]
  if ( (!((FTAUN >=0.0 && FTAUN <=1.0 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter FTAUN value " << FTAUN << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter ISS : [ 0.0,  (+inf) [
  if ( (!((ISS >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter ISS value " << ISS << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ICSS :  ] (-inf)  (+inf) [

  //    Parameter IKS : [ 1.0*1.0e-12,  (+inf) [
  if ( (!((IKS >=1.0*1.0e-12))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter IKS value " << IKS << " out of range [ 1.0*1.0e-12,  (+inf) [";
  }

  //    Parameter CJS : [ 0.0,  (+inf) [
  if ( (!((CJS >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter CJS value " << CJS << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VDS : ] 0.05,  (+inf) [
  if ( (!((VDS >0.05))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter VDS value " << VDS << " out of range ] 0.05,  (+inf) [";
  }

  //    Parameter PS : ] 0.01, 0.99 [
  if ( (!((PS >0.01 && PS <0.99 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter PS value " << PS << " out of range ] 0.01, 0.99 [";
  }

  //    Parameter VGS : [ 0.1,  (+inf) [
  if ( (!((VGS >=0.1))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter VGS value " << VGS << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter RTH : ] 0.0,  (+inf) [
  if ( (!((RTH >0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter RTH value " << RTH << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter CTH : [ 0.0,  (+inf) [
  if ( (!((CTH >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter CTH value " << CTH << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter MULT : ] 0.0,  (+inf) [
  if ( (!((MULT >0.0))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter MULT value " << MULT << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter TYPE : [ (-1), 1 ]] 0, 0 [
  if ( (!((TYPE >=(-1) && TYPE <=1 )) || (TYPE >0 && TYPE <0 )) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter TYPE value " << TYPE << " out of range [ (-1), 1 ] or  ] 0, 0 [";
  }

  //    Parameter GMIN : ] 0.0, 1e-10 ]
  if ( (!((GMIN >0.0 && GMIN <=1e-10 ))) )
  {
    UserError0(*this) << "ADMSbjt504tva: Parameter GMIN value " << GMIN << " out of range ] 0.0, 1e-10 ]";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
   const Configuration & configuration,
   const ModelBlock &    model_block,
   const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    LEVEL(504),
    TREF(25.0),
    DTA(0.0),
    EXMOD(1),
    EXPHI(1),
    EXAVL(0),
    EXSUB(0),
    IS(22.0*1.0e-18),
    IK(0.1),
    VER(2.5),
    VEF(44.0),
    BF(215.0),
    IBF(2.7*1.0e-15),
    MLF(2.0),
    XIBI(0.0),
    IZEB(0.0),
    NZEB(22.0),
    BRI(7.0),
    IBR(1.0*1.0e-15),
    VLR(0.2),
    XEXT(0.63),
    WAVL(1.1*1.0e-6),
    VAVL(3.0),
    SFH(0.3),
    RE(5.0),
    RBC(23.0),
    RBV(18.0),
    RCC(12.0),
    RCV(150.0),
    SCRCV(1250.0),
    IHC(4.0*1.0e-3),
    AXI(0.3),
    CJE(73.0*1.0e-15),
    VDE(0.95),
    PE(0.4),
    XCJE(0.4),
    CBEO(0.0),
    CJC(78.0*1.0e-15),
    VDC(0.68),
    PC(0.5),
    XP(0.35),
    MC(0.5),
    XCJC(32.0*1.0e-3),
    RCBLX(0.0),
    RCBLI(0.0),
    CBCO(0.0),
    MTAU(1.0),
    TAUE(2.0*1.0e-12),
    TAUB(4.2*1.0e-12),
    TEPI(41.0*1.0e-12),
    TAUR(520.0*1.0e-12),
    DEG(0.0),
    XREC(0.0),
    XQB(0.33333333333333333333),
    AQBO(0.3),
    AE(0.0),
    AB(1.0),
    AEPI(2.5),
    AEX(0.62),
    AC(2.0),
    ACBL(2.0),
    DVGBF(50.0*1.0e-3),
    DVGBR(45.0*1.0e-3),
    VGB(1.17),
    VGC(1.18),
    VGJ(1.15),
    VGZEB(1.15),
    AVGEB(4.73e-4),
    TVGEB(636.0),
    DVGTE(0.05),
    DAIS(0.0),
    AF(2.0),
    KF(20.0*1.0e-12),
    KFN(20.0*1.0e-12),
    KAVL(0),
    KC(0),
    KE(0.0),
    FTAUN(0.0),
    ISS(48.0*1.0e-18),
    ICSS((-1.0)),
    IKS(250.0*1.0e-6),
    CJS(315.0*1.0e-15),
    VDS(0.62),
    PS(0.34),
    VGS(1.20),
    AS(1.58),
    ASUB(2.0),
    RTH(300.0),
    CTH(3.0*1.0e-9),
    ATH(0.0),
    MULT(1.0),
    TYPE(1),
    GMIN(1.0e-13)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << "MULT  =  " << (*iter)->MULT << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       : 
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
/// 
/// @param[in] op Operator to apply to all instances.
/// 
/// 
void Model::forEachInstance(DeviceInstanceOp &op) const /* override */ 
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void registerDevice()
{
  Config<Traits>::addConfiguration()
    .registerDevice("q", 505)
    .registerModelType("npn", 505)
    .registerModelType("pnp", 505);
}



#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_MULT,
   bool instancePar_given_MULT,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_An,
   AdmsSensFadType & instanceVar_Bn,
   AdmsSensFadType & instanceVar_Trk,
   AdmsSensFadType & instanceVar_Tamb,
   AdmsSensFadType & instanceVar_pow2_2mPE,
   AdmsSensFadType & instanceVar_pow2_PEm2,
   AdmsSensFadType & instanceVar_inv_VDE,
   AdmsSensFadType & instanceVar_inv_VGZEB_Tr,
   AdmsSensFadType & instanceVar_VGZEBOK,
   AdmsSensFadType & instanceVar_invMULT,
   AdmsSensFadType & instanceVar_SCRCV_M,
   AdmsSensFadType & instanceVar_KF_M,
   AdmsSensFadType & instanceVar_KFN_M,
   AdmsSensFadType & instanceVar_CTH_M,
   AdmsSensFadType & instanceVar_Xext1,
   AdmsSensFadType & instanceVar_CBEO_M,
   AdmsSensFadType & instanceVar_CBCO_M,
   AdmsSensFadType & instanceVar_dxa,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TREF,
   bool modelPar_given_TREF,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_IK,
   bool modelPar_given_IK,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_BF,
   bool modelPar_given_BF,
   AdmsSensFadType & modelPar_IBF,
   bool modelPar_given_IBF,
   AdmsSensFadType & modelPar_MLF,
   bool modelPar_given_MLF,
   AdmsSensFadType & modelPar_XIBI,
   bool modelPar_given_XIBI,
   AdmsSensFadType & modelPar_IZEB,
   bool modelPar_given_IZEB,
   AdmsSensFadType & modelPar_NZEB,
   bool modelPar_given_NZEB,
   AdmsSensFadType & modelPar_BRI,
   bool modelPar_given_BRI,
   AdmsSensFadType & modelPar_IBR,
   bool modelPar_given_IBR,
   AdmsSensFadType & modelPar_VLR,
   bool modelPar_given_VLR,
   AdmsSensFadType & modelPar_XEXT,
   bool modelPar_given_XEXT,
   AdmsSensFadType & modelPar_WAVL,
   bool modelPar_given_WAVL,
   AdmsSensFadType & modelPar_VAVL,
   bool modelPar_given_VAVL,
   AdmsSensFadType & modelPar_SFH,
   bool modelPar_given_SFH,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RBC,
   bool modelPar_given_RBC,
   AdmsSensFadType & modelPar_RBV,
   bool modelPar_given_RBV,
   AdmsSensFadType & modelPar_RCC,
   bool modelPar_given_RCC,
   AdmsSensFadType & modelPar_RCV,
   bool modelPar_given_RCV,
   AdmsSensFadType & modelPar_SCRCV,
   bool modelPar_given_SCRCV,
   AdmsSensFadType & modelPar_IHC,
   bool modelPar_given_IHC,
   AdmsSensFadType & modelPar_AXI,
   bool modelPar_given_AXI,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_VDE,
   bool modelPar_given_VDE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_XCJE,
   bool modelPar_given_XCJE,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_VDC,
   bool modelPar_given_VDC,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_XP,
   bool modelPar_given_XP,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_XCJC,
   bool modelPar_given_XCJC,
   AdmsSensFadType & modelPar_RCBLX,
   bool modelPar_given_RCBLX,
   AdmsSensFadType & modelPar_RCBLI,
   bool modelPar_given_RCBLI,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_MTAU,
   bool modelPar_given_MTAU,
   AdmsSensFadType & modelPar_TAUE,
   bool modelPar_given_TAUE,
   AdmsSensFadType & modelPar_TAUB,
   bool modelPar_given_TAUB,
   AdmsSensFadType & modelPar_TEPI,
   bool modelPar_given_TEPI,
   AdmsSensFadType & modelPar_TAUR,
   bool modelPar_given_TAUR,
   AdmsSensFadType & modelPar_DEG,
   bool modelPar_given_DEG,
   AdmsSensFadType & modelPar_XREC,
   bool modelPar_given_XREC,
   AdmsSensFadType & modelPar_XQB,
   bool modelPar_given_XQB,
   AdmsSensFadType & modelPar_AQBO,
   bool modelPar_given_AQBO,
   AdmsSensFadType & modelPar_AE,
   bool modelPar_given_AE,
   AdmsSensFadType & modelPar_AB,
   bool modelPar_given_AB,
   AdmsSensFadType & modelPar_AEPI,
   bool modelPar_given_AEPI,
   AdmsSensFadType & modelPar_AEX,
   bool modelPar_given_AEX,
   AdmsSensFadType & modelPar_AC,
   bool modelPar_given_AC,
   AdmsSensFadType & modelPar_ACBL,
   bool modelPar_given_ACBL,
   AdmsSensFadType & modelPar_DVGBF,
   bool modelPar_given_DVGBF,
   AdmsSensFadType & modelPar_DVGBR,
   bool modelPar_given_DVGBR,
   AdmsSensFadType & modelPar_VGB,
   bool modelPar_given_VGB,
   AdmsSensFadType & modelPar_VGC,
   bool modelPar_given_VGC,
   AdmsSensFadType & modelPar_VGJ,
   bool modelPar_given_VGJ,
   AdmsSensFadType & modelPar_VGZEB,
   bool modelPar_given_VGZEB,
   AdmsSensFadType & modelPar_AVGEB,
   bool modelPar_given_AVGEB,
   AdmsSensFadType & modelPar_TVGEB,
   bool modelPar_given_TVGEB,
   AdmsSensFadType & modelPar_DVGTE,
   bool modelPar_given_DVGTE,
   AdmsSensFadType & modelPar_DAIS,
   bool modelPar_given_DAIS,
   AdmsSensFadType & modelPar_AF,
   bool modelPar_given_AF,
   AdmsSensFadType & modelPar_KF,
   bool modelPar_given_KF,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_KE,
   bool modelPar_given_KE,
   AdmsSensFadType & modelPar_FTAUN,
   bool modelPar_given_FTAUN,
   AdmsSensFadType & modelPar_ISS,
   bool modelPar_given_ISS,
   AdmsSensFadType & modelPar_ICSS,
   bool modelPar_given_ICSS,
   AdmsSensFadType & modelPar_IKS,
   bool modelPar_given_IKS,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_VDS,
   bool modelPar_given_VDS,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_VGS,
   bool modelPar_given_VGS,
   AdmsSensFadType & modelPar_AS,
   bool modelPar_given_AS,
   AdmsSensFadType & modelPar_ASUB,
   bool modelPar_given_ASUB,
   AdmsSensFadType & modelPar_RTH,
   bool modelPar_given_RTH,
   AdmsSensFadType & modelPar_CTH,
   bool modelPar_given_CTH,
   AdmsSensFadType & modelPar_ATH,
   bool modelPar_given_ATH,
   AdmsSensFadType & modelPar_MULT,
   bool modelPar_given_MULT,
   AdmsSensFadType & modelPar_GMIN,
   bool modelPar_given_GMIN,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_EXMOD,
   bool modelPar_given_EXMOD,
   int modelPar_EXPHI,
   bool modelPar_given_EXPHI,
   int modelPar_EXAVL,
   bool modelPar_given_EXAVL,
   int modelPar_EXSUB,
   bool modelPar_given_EXSUB,
   int modelPar_KAVL,
   bool modelPar_given_KAVL,
   int modelPar_KC,
   bool modelPar_given_KC,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   double admsTemperature, double adms_vt_nom, double gmin, const Instance & theInstance)
{
  AdmsSensFadType VGZEB_Tr;
  //Begin block initial_instance
  {
    if ((modelPar_TYPE==1))
    {
      instanceVar_An = 7.03e7;
      instanceVar_Bn = 1.23e8;
    }
    else
    {
      instanceVar_An = 1.58e8;
      instanceVar_Bn = 2.04e8;
    }
    instanceVar_Xext1 = (1.0-modelPar_XEXT);
    instanceVar_CTH_M = (modelPar_CTH*instancePar_MULT);
    instanceVar_CBEO_M = (modelPar_CBEO*instancePar_MULT);
    instanceVar_CBCO_M = (modelPar_CBCO*instancePar_MULT);
    instanceVar_invMULT = (1.0/instancePar_MULT);
    instanceVar_SCRCV_M = (modelPar_SCRCV*instanceVar_invMULT);
    instanceVar_KF_M = (modelPar_KF*pow(instancePar_MULT,(1.0-modelPar_AF)));
    instanceVar_KFN_M = (modelPar_KFN*pow(instancePar_MULT,(1.0-((2.0*(modelPar_MLF-1.0))+(modelPar_AF*(2.0-modelPar_MLF))))));
    instanceVar_pow2_2mPE = pow(2.0,(2.0-modelPar_PE));
    instanceVar_pow2_PEm2 = (1.0/instanceVar_pow2_2mPE);
    instanceVar_Trk = (modelPar_TREF+273.15);
    instanceVar_Tamb = (admsTemperature+modelPar_DTA);
    instanceVar_dxa = (((modelPar_VGZEB+(((modelPar_AVGEB*instanceVar_Trk)*instanceVar_Trk)/(instanceVar_Trk+modelPar_TVGEB)))-0.05)/0.1);
    if (((modelPar_VGZEB+(((modelPar_AVGEB*instanceVar_Trk)*instanceVar_Trk)/(instanceVar_Trk+modelPar_TVGEB)))<0.05))
    {
      instanceVar_VGZEBOK = (0.05+(0.1*log((1.0+exp(instanceVar_dxa)))));
    }
    else
    {
      instanceVar_VGZEBOK = ((modelPar_VGZEB+(((modelPar_AVGEB*instanceVar_Trk)*instanceVar_Trk)/(instanceVar_Trk+modelPar_TVGEB)))+(0.1*log((1.0+exp((-instanceVar_dxa))))));
    }
    instanceVar_VGZEBOK = instanceVar_VGZEBOK;
    VGZEB_Tr = modelPar_VGZEB;
    instanceVar_inv_VGZEB_Tr = (1.0/VGZEB_Tr);
    instanceVar_inv_VDE = (1.0/modelPar_VDE);
  }
  // End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TREF,
   bool modelPar_given_TREF,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_IK,
   bool modelPar_given_IK,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_BF,
   bool modelPar_given_BF,
   AdmsSensFadType & modelPar_IBF,
   bool modelPar_given_IBF,
   AdmsSensFadType & modelPar_MLF,
   bool modelPar_given_MLF,
   AdmsSensFadType & modelPar_XIBI,
   bool modelPar_given_XIBI,
   AdmsSensFadType & modelPar_IZEB,
   bool modelPar_given_IZEB,
   AdmsSensFadType & modelPar_NZEB,
   bool modelPar_given_NZEB,
   AdmsSensFadType & modelPar_BRI,
   bool modelPar_given_BRI,
   AdmsSensFadType & modelPar_IBR,
   bool modelPar_given_IBR,
   AdmsSensFadType & modelPar_VLR,
   bool modelPar_given_VLR,
   AdmsSensFadType & modelPar_XEXT,
   bool modelPar_given_XEXT,
   AdmsSensFadType & modelPar_WAVL,
   bool modelPar_given_WAVL,
   AdmsSensFadType & modelPar_VAVL,
   bool modelPar_given_VAVL,
   AdmsSensFadType & modelPar_SFH,
   bool modelPar_given_SFH,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RBC,
   bool modelPar_given_RBC,
   AdmsSensFadType & modelPar_RBV,
   bool modelPar_given_RBV,
   AdmsSensFadType & modelPar_RCC,
   bool modelPar_given_RCC,
   AdmsSensFadType & modelPar_RCV,
   bool modelPar_given_RCV,
   AdmsSensFadType & modelPar_SCRCV,
   bool modelPar_given_SCRCV,
   AdmsSensFadType & modelPar_IHC,
   bool modelPar_given_IHC,
   AdmsSensFadType & modelPar_AXI,
   bool modelPar_given_AXI,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_VDE,
   bool modelPar_given_VDE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_XCJE,
   bool modelPar_given_XCJE,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_VDC,
   bool modelPar_given_VDC,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_XP,
   bool modelPar_given_XP,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_XCJC,
   bool modelPar_given_XCJC,
   AdmsSensFadType & modelPar_RCBLX,
   bool modelPar_given_RCBLX,
   AdmsSensFadType & modelPar_RCBLI,
   bool modelPar_given_RCBLI,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_MTAU,
   bool modelPar_given_MTAU,
   AdmsSensFadType & modelPar_TAUE,
   bool modelPar_given_TAUE,
   AdmsSensFadType & modelPar_TAUB,
   bool modelPar_given_TAUB,
   AdmsSensFadType & modelPar_TEPI,
   bool modelPar_given_TEPI,
   AdmsSensFadType & modelPar_TAUR,
   bool modelPar_given_TAUR,
   AdmsSensFadType & modelPar_DEG,
   bool modelPar_given_DEG,
   AdmsSensFadType & modelPar_XREC,
   bool modelPar_given_XREC,
   AdmsSensFadType & modelPar_XQB,
   bool modelPar_given_XQB,
   AdmsSensFadType & modelPar_AQBO,
   bool modelPar_given_AQBO,
   AdmsSensFadType & modelPar_AE,
   bool modelPar_given_AE,
   AdmsSensFadType & modelPar_AB,
   bool modelPar_given_AB,
   AdmsSensFadType & modelPar_AEPI,
   bool modelPar_given_AEPI,
   AdmsSensFadType & modelPar_AEX,
   bool modelPar_given_AEX,
   AdmsSensFadType & modelPar_AC,
   bool modelPar_given_AC,
   AdmsSensFadType & modelPar_ACBL,
   bool modelPar_given_ACBL,
   AdmsSensFadType & modelPar_DVGBF,
   bool modelPar_given_DVGBF,
   AdmsSensFadType & modelPar_DVGBR,
   bool modelPar_given_DVGBR,
   AdmsSensFadType & modelPar_VGB,
   bool modelPar_given_VGB,
   AdmsSensFadType & modelPar_VGC,
   bool modelPar_given_VGC,
   AdmsSensFadType & modelPar_VGJ,
   bool modelPar_given_VGJ,
   AdmsSensFadType & modelPar_VGZEB,
   bool modelPar_given_VGZEB,
   AdmsSensFadType & modelPar_AVGEB,
   bool modelPar_given_AVGEB,
   AdmsSensFadType & modelPar_TVGEB,
   bool modelPar_given_TVGEB,
   AdmsSensFadType & modelPar_DVGTE,
   bool modelPar_given_DVGTE,
   AdmsSensFadType & modelPar_DAIS,
   bool modelPar_given_DAIS,
   AdmsSensFadType & modelPar_AF,
   bool modelPar_given_AF,
   AdmsSensFadType & modelPar_KF,
   bool modelPar_given_KF,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_KE,
   bool modelPar_given_KE,
   AdmsSensFadType & modelPar_FTAUN,
   bool modelPar_given_FTAUN,
   AdmsSensFadType & modelPar_ISS,
   bool modelPar_given_ISS,
   AdmsSensFadType & modelPar_ICSS,
   bool modelPar_given_ICSS,
   AdmsSensFadType & modelPar_IKS,
   bool modelPar_given_IKS,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_VDS,
   bool modelPar_given_VDS,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_VGS,
   bool modelPar_given_VGS,
   AdmsSensFadType & modelPar_AS,
   bool modelPar_given_AS,
   AdmsSensFadType & modelPar_ASUB,
   bool modelPar_given_ASUB,
   AdmsSensFadType & modelPar_RTH,
   bool modelPar_given_RTH,
   AdmsSensFadType & modelPar_CTH,
   bool modelPar_given_CTH,
   AdmsSensFadType & modelPar_ATH,
   bool modelPar_given_ATH,
   AdmsSensFadType & modelPar_MULT,
   bool modelPar_given_MULT,
   AdmsSensFadType & modelPar_GMIN,
   bool modelPar_given_GMIN,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_EXMOD,
   bool modelPar_given_EXMOD,
   int modelPar_EXPHI,
   bool modelPar_given_EXPHI,
   int modelPar_EXAVL,
   bool modelPar_given_EXAVL,
   int modelPar_EXSUB,
   bool modelPar_given_EXSUB,
   int modelPar_KAVL,
   bool modelPar_given_KAVL,
   int modelPar_KC,
   bool modelPar_given_KC,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   double admsTemperature, double gmin, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_noi_GND,
   const int admsProbeID_V_c3_c1,
   const int admsProbeID_V_c3_c4,
   const int admsProbeID_V_c4_c1,
   const int admsProbeID_V_b_c,
   const int admsProbeID_V_b_e,
   const int admsProbeID_V_b_b1,
   const int admsProbeID_V_e_e1,
   const int admsProbeID_V_c1_c2,
   const int admsProbeID_V_s_c1,
   const int admsProbeID_V_b1_b2,
   const int admsProbeID_V_b1_e1,
   const int admsProbeID_V_b2_e1,
   const int admsProbeID_V_b2_c2,
   const int admsProbeID_V_b2_c1,
   const int admsProbeID_V_dt_GND,
   // node constants
   const int admsNodeID_c,
   const int admsNodeID_b,
   const int admsNodeID_e,
   const int admsNodeID_s,
   const int admsNodeID_dt,
   const int admsNodeID_e1,
   const int admsNodeID_b1,
   const int admsNodeID_b2,
   const int admsNodeID_c1,
   const int admsNodeID_c2,
   const int admsNodeID_c3,
   const int admsNodeID_c4,
   const int admsNodeID_noi,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_MULT,
   bool instancePar_given_MULT,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_An,
   AdmsSensFadType & instanceVar_Bn,
   AdmsSensFadType & instanceVar_Trk,
   AdmsSensFadType & instanceVar_Tamb,
   AdmsSensFadType & instanceVar_pow2_2mPE,
   AdmsSensFadType & instanceVar_pow2_PEm2,
   AdmsSensFadType & instanceVar_inv_VDE,
   AdmsSensFadType & instanceVar_inv_VGZEB_Tr,
   AdmsSensFadType & instanceVar_VGZEBOK,
   AdmsSensFadType & instanceVar_invMULT,
   AdmsSensFadType & instanceVar_SCRCV_M,
   AdmsSensFadType & instanceVar_KF_M,
   AdmsSensFadType & instanceVar_KFN_M,
   AdmsSensFadType & instanceVar_CTH_M,
   AdmsSensFadType & instanceVar_Xext1,
   AdmsSensFadType & instanceVar_CBEO_M,
   AdmsSensFadType & instanceVar_CBCO_M,
   AdmsSensFadType & instanceVar_dxa,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TREF,
   bool modelPar_given_TREF,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_IK,
   bool modelPar_given_IK,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_BF,
   bool modelPar_given_BF,
   AdmsSensFadType & modelPar_IBF,
   bool modelPar_given_IBF,
   AdmsSensFadType & modelPar_MLF,
   bool modelPar_given_MLF,
   AdmsSensFadType & modelPar_XIBI,
   bool modelPar_given_XIBI,
   AdmsSensFadType & modelPar_IZEB,
   bool modelPar_given_IZEB,
   AdmsSensFadType & modelPar_NZEB,
   bool modelPar_given_NZEB,
   AdmsSensFadType & modelPar_BRI,
   bool modelPar_given_BRI,
   AdmsSensFadType & modelPar_IBR,
   bool modelPar_given_IBR,
   AdmsSensFadType & modelPar_VLR,
   bool modelPar_given_VLR,
   AdmsSensFadType & modelPar_XEXT,
   bool modelPar_given_XEXT,
   AdmsSensFadType & modelPar_WAVL,
   bool modelPar_given_WAVL,
   AdmsSensFadType & modelPar_VAVL,
   bool modelPar_given_VAVL,
   AdmsSensFadType & modelPar_SFH,
   bool modelPar_given_SFH,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RBC,
   bool modelPar_given_RBC,
   AdmsSensFadType & modelPar_RBV,
   bool modelPar_given_RBV,
   AdmsSensFadType & modelPar_RCC,
   bool modelPar_given_RCC,
   AdmsSensFadType & modelPar_RCV,
   bool modelPar_given_RCV,
   AdmsSensFadType & modelPar_SCRCV,
   bool modelPar_given_SCRCV,
   AdmsSensFadType & modelPar_IHC,
   bool modelPar_given_IHC,
   AdmsSensFadType & modelPar_AXI,
   bool modelPar_given_AXI,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_VDE,
   bool modelPar_given_VDE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_XCJE,
   bool modelPar_given_XCJE,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_VDC,
   bool modelPar_given_VDC,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_XP,
   bool modelPar_given_XP,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_XCJC,
   bool modelPar_given_XCJC,
   AdmsSensFadType & modelPar_RCBLX,
   bool modelPar_given_RCBLX,
   AdmsSensFadType & modelPar_RCBLI,
   bool modelPar_given_RCBLI,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_MTAU,
   bool modelPar_given_MTAU,
   AdmsSensFadType & modelPar_TAUE,
   bool modelPar_given_TAUE,
   AdmsSensFadType & modelPar_TAUB,
   bool modelPar_given_TAUB,
   AdmsSensFadType & modelPar_TEPI,
   bool modelPar_given_TEPI,
   AdmsSensFadType & modelPar_TAUR,
   bool modelPar_given_TAUR,
   AdmsSensFadType & modelPar_DEG,
   bool modelPar_given_DEG,
   AdmsSensFadType & modelPar_XREC,
   bool modelPar_given_XREC,
   AdmsSensFadType & modelPar_XQB,
   bool modelPar_given_XQB,
   AdmsSensFadType & modelPar_AQBO,
   bool modelPar_given_AQBO,
   AdmsSensFadType & modelPar_AE,
   bool modelPar_given_AE,
   AdmsSensFadType & modelPar_AB,
   bool modelPar_given_AB,
   AdmsSensFadType & modelPar_AEPI,
   bool modelPar_given_AEPI,
   AdmsSensFadType & modelPar_AEX,
   bool modelPar_given_AEX,
   AdmsSensFadType & modelPar_AC,
   bool modelPar_given_AC,
   AdmsSensFadType & modelPar_ACBL,
   bool modelPar_given_ACBL,
   AdmsSensFadType & modelPar_DVGBF,
   bool modelPar_given_DVGBF,
   AdmsSensFadType & modelPar_DVGBR,
   bool modelPar_given_DVGBR,
   AdmsSensFadType & modelPar_VGB,
   bool modelPar_given_VGB,
   AdmsSensFadType & modelPar_VGC,
   bool modelPar_given_VGC,
   AdmsSensFadType & modelPar_VGJ,
   bool modelPar_given_VGJ,
   AdmsSensFadType & modelPar_VGZEB,
   bool modelPar_given_VGZEB,
   AdmsSensFadType & modelPar_AVGEB,
   bool modelPar_given_AVGEB,
   AdmsSensFadType & modelPar_TVGEB,
   bool modelPar_given_TVGEB,
   AdmsSensFadType & modelPar_DVGTE,
   bool modelPar_given_DVGTE,
   AdmsSensFadType & modelPar_DAIS,
   bool modelPar_given_DAIS,
   AdmsSensFadType & modelPar_AF,
   bool modelPar_given_AF,
   AdmsSensFadType & modelPar_KF,
   bool modelPar_given_KF,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_KE,
   bool modelPar_given_KE,
   AdmsSensFadType & modelPar_FTAUN,
   bool modelPar_given_FTAUN,
   AdmsSensFadType & modelPar_ISS,
   bool modelPar_given_ISS,
   AdmsSensFadType & modelPar_ICSS,
   bool modelPar_given_ICSS,
   AdmsSensFadType & modelPar_IKS,
   bool modelPar_given_IKS,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_VDS,
   bool modelPar_given_VDS,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_VGS,
   bool modelPar_given_VGS,
   AdmsSensFadType & modelPar_AS,
   bool modelPar_given_AS,
   AdmsSensFadType & modelPar_ASUB,
   bool modelPar_given_ASUB,
   AdmsSensFadType & modelPar_RTH,
   bool modelPar_given_RTH,
   AdmsSensFadType & modelPar_CTH,
   bool modelPar_given_CTH,
   AdmsSensFadType & modelPar_ATH,
   bool modelPar_given_ATH,
   AdmsSensFadType & modelPar_MULT,
   bool modelPar_given_MULT,
   AdmsSensFadType & modelPar_GMIN,
   bool modelPar_given_GMIN,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_EXMOD,
   bool modelPar_given_EXMOD,
   int modelPar_EXPHI,
   bool modelPar_given_EXPHI,
   int modelPar_EXAVL,
   bool modelPar_given_EXAVL,
   int modelPar_EXSUB,
   bool modelPar_given_EXSUB,
   int modelPar_KAVL,
   bool modelPar_given_KAVL,
   int modelPar_KC,
   bool modelPar_given_KC,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   // basic variables
   double admsTemperature, double adms_vt_nom, double gmin, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance)
{

  // Local variables
  AdmsSensFadType common;
  AdmsSensFadType powerREC;
  AdmsSensFadType powerRBC;
  AdmsSensFadType powerRCCxx;
  AdmsSensFadType powerRCCex;
  AdmsSensFadType powerRCCin;
  AdmsSensFadType powerRBV;
  AdmsSensFadType In_N;
  AdmsSensFadType powerCCS;
  AdmsSensFadType Gem_N;
  AdmsSensFadType powerIIS;
  AdmsSensFadType Taub_N;
  AdmsSensFadType taun;
  AdmsSensFadType powerFBCS;
  AdmsSensFadType powerFBC1fB1;
  AdmsSensFadType exponentFBC1fB2;
  AdmsSensFadType powerFBC1fB2;
  AdmsSensFadType powerEBSCS;
  AdmsSensFadType powerEBSC1f;
  AdmsSensFadType powerRBCS;
  AdmsSensFadType powerRBC1f;
  AdmsSensFadType powerExCS;
  AdmsSensFadType powerExC1f;
  AdmsSensFadType powerExCSMOD;
  AdmsSensFadType powerExC1fMOD;
  AdmsSensFadType powerSubsCS_B1S;
  AdmsSensFadType powerSubsCS_BS;
  AdmsSensFadType Vb2c1;
  AdmsSensFadType Vb2c2;
  AdmsSensFadType Vb2e1;
  AdmsSensFadType Vb1e1;
  AdmsSensFadType Vb1b2;
  AdmsSensFadType Vsc1;
  AdmsSensFadType Vc1c2;
  AdmsSensFadType Vee1;
  AdmsSensFadType Vbb1;
  AdmsSensFadType Vbe;
  AdmsSensFadType Vbc;
  AdmsSensFadType Vc4c1;
  AdmsSensFadType Vc3c4;
  AdmsSensFadType Vb1c4;
  AdmsSensFadType Vcc3;
  AdmsSensFadType Vbc3;
  AdmsSensFadType Vsc4;
  AdmsSensFadType Vsc3;
  double expl;
  AdmsSensFadType eVb2c2;
  AdmsSensFadType eVb2e1;
  AdmsSensFadType eVb1e1;
  AdmsSensFadType eVb1c4;
  AdmsSensFadType eVb1b2;
  AdmsSensFadType eVbc3;
  AdmsSensFadType eVsc1;
  AdmsSensFadType eVsc3;
  AdmsSensFadType eVsc4;
  AdmsSensFadType eVbc3VDC;
  AdmsSensFadType eVb1c4VDC;
  AdmsSensFadType eVb2c2VDC;
  AdmsSensFadType eVb2c1VDC;
  AdmsSensFadType K0;
  AdmsSensFadType Kw;
  AdmsSensFadType pW;
  AdmsSensFadType Ec;
  AdmsSensFadType Ic1c2;
  AdmsSensFadType pav;
  AdmsSensFadType tmpV;
  AdmsSensFadType Vqs_th;
  AdmsSensFadType eps_VDC;
  AdmsSensFadType eps2;
  AdmsSensFadType x2;
  AdmsSensFadType Vqs;
  AdmsSensFadType Iqs;
  AdmsSensFadType Ic1c2_Iqs;
  AdmsSensFadType alpha1;
  AdmsSensFadType alpha;
  AdmsSensFadType vyi;
  AdmsSensFadType yi;
  AdmsSensFadType xi_w;
  AdmsSensFadType gp0;
  AdmsSensFadType gp0_help;
  AdmsSensFadType gp02;
  AdmsSensFadType sqr_arg;
  AdmsSensFadType p0star;
  AdmsSensFadType eVb2c2star;
  AdmsSensFadType B1;
  AdmsSensFadType B2;
  AdmsSensFadType Vxi0;
  AdmsSensFadType Vch;
  AdmsSensFadType Icap;
  AdmsSensFadType Icap_IHC;
  AdmsSensFadType Vfe;
  AdmsSensFadType a_VDE;
  AdmsSensFadType Vje;
  AdmsSensFadType E0BE;
  AdmsSensFadType Vte;
  AdmsSensFadType Vjunc;
  AdmsSensFadType bjc;
  AdmsSensFadType Vfc;
  AdmsSensFadType Vjc;
  AdmsSensFadType fI;
  AdmsSensFadType Vcv;
  AdmsSensFadType Vtc;
  AdmsSensFadType If0;
  AdmsSensFadType f1;
  AdmsSensFadType n0;
  AdmsSensFadType f2;
  AdmsSensFadType nB;
  AdmsSensFadType termE;
  AdmsSensFadType termC;
  AdmsSensFadType q0I;
  AdmsSensFadType q1I;
  AdmsSensFadType qBI;
  AdmsSensFadType Ir;
  AdmsSensFadType If;
  AdmsSensFadType In;
  AdmsSensFadType Ibf0;
  AdmsSensFadType Ib1;
  AdmsSensFadType Ib1_s;
  AdmsSensFadType tmpExp;
  AdmsSensFadType Ib2;
  AdmsSensFadType Ib3;
  AdmsSensFadType eZEB;
  AdmsSensFadType x;
  AdmsSensFadType dE0BE;
  AdmsSensFadType edZEB;
  AdmsSensFadType DZEB;
  AdmsSensFadType Izteb;
  AdmsSensFadType g1;
  AdmsSensFadType g2;
  AdmsSensFadType nBex;
  AdmsSensFadType pWex;
  AdmsSensFadType Iex;
  AdmsSensFadType Isub;
  AdmsSensFadType Isf;
  AdmsSensFadType XIex;
  AdmsSensFadType XIsub;
  AdmsSensFadType Xg1;
  AdmsSensFadType XnBex;
  AdmsSensFadType XIMex;
  AdmsSensFadType XIMsub;
  AdmsSensFadType Vex_bias;
  AdmsSensFadType Vex;
  AdmsSensFadType vdif;
  AdmsSensFadType VBex;
  AdmsSensFadType Fex;
  AdmsSensFadType q0Q;
  AdmsSensFadType q1Q;
  AdmsSensFadType qBQ;
  AdmsSensFadType Rb2;
  AdmsSensFadType Ib1b2;
  AdmsSensFadType Iavl;
  AdmsSensFadType Gem;
  AdmsSensFadType dEdx0;
  AdmsSensFadType xd;
  AdmsSensFadType xi_w1;
  AdmsSensFadType Weff;
  AdmsSensFadType Wd;
  AdmsSensFadType Eav;
  AdmsSensFadType E0;
  AdmsSensFadType SHw;
  AdmsSensFadType Efi;
  AdmsSensFadType Ew;
  AdmsSensFadType Em;
  AdmsSensFadType EmEav_Em;
  AdmsSensFadType lambda;
  AdmsSensFadType Gmax;
  AdmsSensFadType Vb2c2star;
  AdmsSensFadType power;
  AdmsSensFadType Qte;
  AdmsSensFadType Vje_s;
  AdmsSensFadType Qte_s;
  AdmsSensFadType Qtc;
  AdmsSensFadType Qb0;
  AdmsSensFadType Qbe_qs;
  AdmsSensFadType Qbc_qs;
  AdmsSensFadType a_VDC;
  AdmsSensFadType Vjcex;
  AdmsSensFadType Vtexv;
  AdmsSensFadType Qtex;
  AdmsSensFadType XVjcex;
  AdmsSensFadType XVtexv;
  AdmsSensFadType XQtex;
  AdmsSensFadType a_VDS;
  AdmsSensFadType Vfs;
  AdmsSensFadType Vjs;
  AdmsSensFadType Qts;
  AdmsSensFadType Qe0;
  AdmsSensFadType Qe_qs;
  AdmsSensFadType Qepi0;
  AdmsSensFadType Qepi;
  AdmsSensFadType Qex;
  AdmsSensFadType XQex;
  AdmsSensFadType Xg2;
  AdmsSensFadType XpWex;
  AdmsSensFadType Qb1b2;
  AdmsSensFadType dVteVje;
  AdmsSensFadType Vb2e1Vfe;
  AdmsSensFadType dVjeVb2e1;
  AdmsSensFadType dVteVb2e1;
  AdmsSensFadType dQteVb2e1;
  AdmsSensFadType dn0Vb2e1;
  AdmsSensFadType dQbeVb2e1;
  AdmsSensFadType dQeVb2e1;
  AdmsSensFadType Qe;
  AdmsSensFadType Qbe_qs_eff;
  AdmsSensFadType Qbc;
  AdmsSensFadType Qbe;
  AdmsSensFadType RTH_Tamb_M;
  AdmsSensFadType GCCin_TM;
  AdmsSensFadType GCCex_TM;
  AdmsSensFadType GCCxx_TM;
  AdmsSensFadType RCV_TM;
  AdmsSensFadType RCCin_TM;
  AdmsSensFadType RCCex_TM;
  AdmsSensFadType RCCxx_TM;
  AdmsSensFadType RBV_TM;
  AdmsSensFadType RBC_TM;
  AdmsSensFadType RE_TM;
  AdmsSensFadType CJS_TM;
  AdmsSensFadType CJC_TM;
  AdmsSensFadType CJE_TM;
  AdmsSensFadType IKS_TM;
  AdmsSensFadType ICSS_TM;
  AdmsSensFadType ISS_TM;
  AdmsSensFadType IHC_M;
  AdmsSensFadType IZEB_TM;
  AdmsSensFadType IBR_TM;
  AdmsSensFadType IBF_TM;
  AdmsSensFadType IK_TM;
  AdmsSensFadType IS_TM;
  AdmsSensFadType RTH_Tamb;
  AdmsSensFadType DEG_T;
  AdmsSensFadType BnT;
  AdmsSensFadType Tk300;
  AdmsSensFadType TAUR_T;
  AdmsSensFadType TEPI_T;
  AdmsSensFadType TAUB_T;
  AdmsSensFadType TAUE_T;
  AdmsSensFadType IKS_T;
  AdmsSensFadType ICSS_T;
  AdmsSensFadType ISS_T;
  AdmsSensFadType VER_T;
  AdmsSensFadType VEF_T;
  AdmsSensFadType IZEB_T;
  AdmsSensFadType nZEB_T;
  AdmsSensFadType y;
  AdmsSensFadType tempx;
  AdmsSensFadType IBR_T;
  AdmsSensFadType IBF_T;
  AdmsSensFadType IK_T;
  AdmsSensFadType IS_T;
  AdmsSensFadType BRI_T;
  AdmsSensFadType BF_T;
  AdmsSensFadType RCV_T;
  AdmsSensFadType RCCin_T;
  AdmsSensFadType RCCex_T;
  AdmsSensFadType RCCxx_T;
  AdmsSensFadType RBC_T;
  AdmsSensFadType RBV_T;
  AdmsSensFadType RE_T;
  AdmsSensFadType XP_T;
  AdmsSensFadType CJC_T;
  AdmsSensFadType CJCscaleINV;
  AdmsSensFadType CJCscale;
  AdmsSensFadType CJS_T;
  AdmsSensFadType CJE_T;
  AdmsSensFadType CJE_T_div_CJE;
  AdmsSensFadType inv_VDE_T;
  AdmsSensFadType VDS_T;
  AdmsSensFadType UdsT;
  AdmsSensFadType VDC_T;
  AdmsSensFadType UdcT;
  AdmsSensFadType VDE_T;
  AdmsSensFadType UdeT;
  AdmsSensFadType VGZEB_T;
  AdmsSensFadType lntN;
  AdmsSensFadType VdtINV;
  AdmsSensFadType VtrINV;
  AdmsSensFadType VtINV;
  AdmsSensFadType Vtr;
  AdmsSensFadType Vt;
  AdmsSensFadType tN;
  AdmsSensFadType Tk;
  double Vdt;
  double Tki;


  // -- code converted from analog/code block
  Tki = (probeVars[admsProbeID_V_dt_GND]);
  if ((Tki<0.0))
  {
    Tki = (-log((1.0-Tki)));
  }
  if ((Tki<200.0))
  {
    Vdt = Tki;
  }
  else
  {
    Vdt = (200.0+log((1.0+(Tki-200.0))));
  }
  Vdt = Vdt;
  Tk = (instanceVar_Tamb+Vdt);
  tN = (Tk/instanceVar_Trk);
  Vt = (8.61708691805812512584e-5*Tk);
  Vtr = (8.61708691805812512584e-5*instanceVar_Trk);
  VtINV = (1.0/Vt);
  VtrINV = (1.0/Vtr);
  VdtINV = (VtINV-VtrINV);
  lntN = log(tN);
  instanceVar_dxa = (((instanceVar_VGZEBOK-(((modelPar_AVGEB*Tk)*Tk)/(Tk+modelPar_TVGEB)))-0.05)/0.1);
  if (((instanceVar_VGZEBOK-(((modelPar_AVGEB*Tk)*Tk)/(Tk+modelPar_TVGEB)))<0.05))
  {
    VGZEB_T = (0.05+(0.1*log((1.0+exp(instanceVar_dxa)))));
  }
  else
  {
    VGZEB_T = ((instanceVar_VGZEBOK-(((modelPar_AVGEB*Tk)*Tk)/(Tk+modelPar_TVGEB)))+(0.1*log((1.0+exp((-instanceVar_dxa))))));
  }
  VGZEB_T = VGZEB_T;
  UdeT = (((((-3.0)*Vt)*log(tN))+(modelPar_VDE*tN))+((1.0-tN)*modelPar_VGB));
  instanceVar_dxa = ((0.05-UdeT)/Vt);
  if ((0.05<UdeT))
  {
    VDE_T = (UdeT+(Vt*log((1.0+exp(instanceVar_dxa)))));
  }
  else
  {
    VDE_T = (0.05+(Vt*log((1.0+exp((-instanceVar_dxa))))));
  }
  VDE_T = VDE_T;
  UdcT = (((((-3.0)*Vt)*log(tN))+(modelPar_VDC*tN))+((1.0-tN)*modelPar_VGC));
  instanceVar_dxa = ((0.05-UdcT)/Vt);
  if ((0.05<UdcT))
  {
    VDC_T = (UdcT+(Vt*log((1.0+exp(instanceVar_dxa)))));
  }
  else
  {
    VDC_T = (0.05+(Vt*log((1.0+exp((-instanceVar_dxa))))));
  }
  VDC_T = VDC_T;
  UdsT = (((((-3.0)*Vt)*log(tN))+(modelPar_VDS*tN))+((1.0-tN)*modelPar_VGS));
  instanceVar_dxa = ((0.05-UdsT)/Vt);
  if ((0.05<UdsT))
  {
    VDS_T = (UdsT+(Vt*log((1.0+exp(instanceVar_dxa)))));
  }
  else
  {
    VDS_T = (0.05+(Vt*log((1.0+exp((-instanceVar_dxa))))));
  }
  VDS_T = VDS_T;
  inv_VDE_T = (1.0/VDE_T);
  CJE_T_div_CJE = pow((modelPar_VDE*inv_VDE_T),modelPar_PE);
  CJE_T = (modelPar_CJE*CJE_T_div_CJE);
  CJS_T = (modelPar_CJS*pow((modelPar_VDS/VDS_T),modelPar_PS));
  CJCscale = (((1.0-modelPar_XP)*pow((modelPar_VDC/VDC_T),modelPar_PC))+modelPar_XP);
  CJCscaleINV = (1.0/CJCscale);
  CJC_T = (modelPar_CJC*CJCscale);
  XP_T = (modelPar_XP*CJCscaleINV);
  RE_T = (modelPar_RE*exp((lntN*modelPar_AE)));
  RBV_T = (modelPar_RBV*exp((lntN*(modelPar_AB-modelPar_AQBO))));
  RBC_T = (modelPar_RBC*exp((lntN*modelPar_AEX)));
  RCCxx_T = (modelPar_RCC*exp((lntN*modelPar_AC)));
  RCCex_T = (modelPar_RCBLX*exp((lntN*modelPar_ACBL)));
  RCCin_T = (modelPar_RCBLI*exp((lntN*modelPar_ACBL)));
  RCV_T = (modelPar_RCV*exp((lntN*modelPar_AEPI)));
  BF_T = ((modelPar_BF*exp((lntN*((modelPar_AE-modelPar_AB)-modelPar_AQBO))))*exp(((-modelPar_DVGBF)*VdtINV)));
  BRI_T = (modelPar_BRI*exp(((-modelPar_DVGBR)*VdtINV)));
  IS_T = ((modelPar_IS*exp((lntN*(((4.0-modelPar_AB)-modelPar_AQBO)+modelPar_DAIS))))*exp(((-modelPar_VGB)*VdtINV)));
  IK_T = (modelPar_IK*exp((lntN*(1.0-modelPar_AB))));
  IBF_T = ((modelPar_IBF*exp((lntN*(6.0-(2.0*modelPar_MLF)))))*exp((((-modelPar_VGJ)*VdtINV)/modelPar_MLF)));
  IBR_T = (((modelPar_IBR*tN)*tN)*exp((((-modelPar_VGC)*VdtINV)/2.0)));
  tempx = pow((VGZEB_T*instanceVar_inv_VGZEB_Tr),(-0.5));
  y = (1.0/CJE_T_div_CJE);
  nZEB_T = ((((((((modelPar_NZEB*VGZEB_T)*VGZEB_T)*tempx)*y)*modelPar_VDE)*inv_VDE_T)*instanceVar_inv_VGZEB_Tr)*instanceVar_inv_VGZEB_Tr);
  IZEB_T = (((((((modelPar_IZEB*tempx)*VDE_T)*VDE_T)*instanceVar_inv_VDE)*instanceVar_inv_VDE)*CJE_T_div_CJE)*exp((modelPar_NZEB-nZEB_T)));
  tempx = exp((lntN*modelPar_AQBO));
  VEF_T = ((modelPar_VEF*tempx)*CJCscaleINV);
  VER_T = ((modelPar_VER*tempx)*y);
  ISS_T = ((modelPar_ISS*exp((lntN*(4.0-modelPar_AS))))*exp(((-modelPar_VGS)*VdtINV)));
  ICSS_T = ((modelPar_ICSS*exp((lntN*(3.5-(0.5*modelPar_ASUB)))))*exp(((-modelPar_VGS)*VdtINV)));
  if ((ISS_T>0.0))
  {
    IKS_T = (((modelPar_IKS*exp((lntN*(1.0-modelPar_AS))))*(IS_T/modelPar_IS))*(modelPar_ISS/ISS_T));
  }
  else
  {
    IKS_T = (modelPar_IKS*exp((lntN*(1.0-modelPar_AS))));
  }
  TAUE_T = ((modelPar_TAUE*exp((lntN*(modelPar_AB-2.0))))*exp(((-modelPar_DVGTE)*VdtINV)));
  TAUB_T = (modelPar_TAUB*exp((lntN*((modelPar_AQBO+modelPar_AB)-1.0))));
  TEPI_T = (modelPar_TEPI*exp((lntN*(modelPar_AEPI-1.0))));
  TAUR_T = ((modelPar_TAUR*(TAUB_T+TEPI_T))/(modelPar_TAUB+modelPar_TEPI));
  Tk300 = (Tk-300.0);
  if ((Tk<525.0))
  {
    BnT = (instanceVar_Bn*((1.0+(7.2e-4*Tk300))-((1.6e-6*Tk300)*Tk300)));
  }
  else
  {
    BnT = (instanceVar_Bn*1.081);
  }
  DEG_T = (modelPar_DEG*exp((lntN*modelPar_AQBO)));
  RTH_Tamb = (modelPar_RTH*pow((instanceVar_Tamb/instanceVar_Trk),modelPar_ATH));
  IS_TM = (IS_T*instancePar_MULT);
  IK_TM = (IK_T*instancePar_MULT);
  IBF_TM = (IBF_T*instancePar_MULT);
  IBR_TM = (IBR_T*instancePar_MULT);
  IZEB_TM = (IZEB_T*instancePar_MULT);
  IHC_M = (modelPar_IHC*instancePar_MULT);
  ISS_TM = (ISS_T*instancePar_MULT);
  ICSS_TM = (ICSS_T*instancePar_MULT);
  IKS_TM = (IKS_T*instancePar_MULT);
  CJE_TM = (CJE_T*instancePar_MULT);
  CJC_TM = (CJC_T*instancePar_MULT);
  CJS_TM = (CJS_T*instancePar_MULT);
  RE_TM = (RE_T*instanceVar_invMULT);
  RBC_TM = (RBC_T*instanceVar_invMULT);
  RBV_TM = (RBV_T*instanceVar_invMULT);
  RCCxx_TM = (RCCxx_T*instanceVar_invMULT);
  RCCex_TM = (RCCex_T*instanceVar_invMULT);
  RCCin_TM = (RCCin_T*instanceVar_invMULT);
  RCV_TM = (RCV_T*instanceVar_invMULT);
  if ((modelPar_RCC>0.0))
  {
    GCCxx_TM = (1.0/RCCxx_TM);
  }
  else
  {
    GCCxx_TM = 0;
  }
  if ((modelPar_RCBLX>0.0))
  {
    GCCex_TM = (1.0/RCCex_TM);
  }
  else
  {
    GCCex_TM = 0;
  }
  if ((modelPar_RCBLI>0.0))
  {
    GCCin_TM = (1.0/RCCin_TM);
  }
  else
  {
    GCCin_TM = 0;
  }
  RTH_Tamb_M = (RTH_Tamb*instanceVar_invMULT);
  {
    Vb2c1 = probeVars[admsProbeID_V_b2_c1];

    Vb2c2 = probeVars[admsProbeID_V_b2_c2];

    Vb2e1 = (modelPar_TYPE*(probeVars[admsProbeID_V_b2_e1]));
    Vb1e1 = probeVars[admsProbeID_V_b1_e1];

    Vb1b2 = probeVars[admsProbeID_V_b1_b2];

    Vsc1 = (modelPar_TYPE*(probeVars[admsProbeID_V_s_c1]));
    Vc1c2 = (modelPar_TYPE*(probeVars[admsProbeID_V_c1_c2]));
    Vee1 = (modelPar_TYPE*(probeVars[admsProbeID_V_e_e1]));
    Vbb1 = (modelPar_TYPE*(probeVars[admsProbeID_V_b_b1]));
    Vbe = (modelPar_TYPE*(probeVars[admsProbeID_V_b_e]));
    Vbc = (modelPar_TYPE*(probeVars[admsProbeID_V_b_c]));
    if ((modelPar_RCBLX>0.0))
    {
      if ((modelPar_RCBLI>0.0))
      {
        Vc4c1 = (modelPar_TYPE*(probeVars[admsProbeID_V_c4_c1]));
        Vc3c4 = (modelPar_TYPE*(probeVars[admsProbeID_V_c3_c4]));
      }
      else
      {
        Vc4c1 = 0;
        Vc3c4 = (modelPar_TYPE*(probeVars[admsProbeID_V_c3_c1]));
      }
    }
    else
    {
      if ((modelPar_RCBLI>0.0))
      {
        Vc4c1 = (modelPar_TYPE*(probeVars[admsProbeID_V_c4_c1]));
        Vc3c4 = 0;
      }
      else
      {
        Vc4c1 = 0;
        Vc3c4 = 0;
      }
    }
    Vb1c4 = (((Vb1b2+Vb2c2)-Vc1c2)-Vc4c1);
    Vcc3 = ((((-Vbc)+Vbb1)+Vb1c4)-Vc3c4);
    Vbc3 = (Vbc+Vcc3);
    Vsc4 = (Vsc1-Vc4c1);
    Vsc3 = (Vsc4-Vc3c4);
    if (((Vb2c2*VtINV)<400.0))
    {
      eVb2c2 = exp((Vb2c2*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb2c2 = (expl*(1.0+((Vb2c2*VtINV)-400.0)));
    }
    if (((Vb2e1*VtINV)<400.0))
    {
      eVb2e1 = exp((Vb2e1*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb2e1 = (expl*(1.0+((Vb2e1*VtINV)-400.0)));
    }
    if (((Vb1e1*VtINV)<400.0))
    {
      eVb1e1 = exp((Vb1e1*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb1e1 = (expl*(1.0+((Vb1e1*VtINV)-400.0)));
    }
    if (((Vb1c4*VtINV)<400.0))
    {
      eVb1c4 = exp((Vb1c4*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb1c4 = (expl*(1.0+((Vb1c4*VtINV)-400.0)));
    }
    if (((Vb1b2*VtINV)<400.0))
    {
      eVb1b2 = exp((Vb1b2*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb1b2 = (expl*(1.0+((Vb1b2*VtINV)-400.0)));
    }
    if (((Vbc3*VtINV)<400.0))
    {
      eVbc3 = exp((Vbc3*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVbc3 = (expl*(1.0+((Vbc3*VtINV)-400.0)));
    }
    if (((Vsc1*VtINV)<400.0))
    {
      eVsc1 = exp((Vsc1*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVsc1 = (expl*(1.0+((Vsc1*VtINV)-400.0)));
    }
    if (((Vsc3*VtINV)<400.0))
    {
      eVsc3 = exp((Vsc3*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVsc3 = (expl*(1.0+((Vsc3*VtINV)-400.0)));
    }
    if (((Vsc4*VtINV)<400.0))
    {
      eVsc4 = exp((Vsc4*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVsc4 = (expl*(1.0+((Vsc4*VtINV)-400.0)));
    }
    if ((((Vbc3-VDC_T)*VtINV)<400.0))
    {
      eVbc3VDC = exp(((Vbc3-VDC_T)*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVbc3VDC = (expl*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0)));
    }
    if ((((Vb1c4-VDC_T)*VtINV)<400.0))
    {
      eVb1c4VDC = exp(((Vb1c4-VDC_T)*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb1c4VDC = (expl*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0)));
    }
    if ((((Vb2c2-VDC_T)*VtINV)<400.0))
    {
      eVb2c2VDC = exp(((Vb2c2-VDC_T)*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb2c2VDC = (expl*(1.0+(((Vb2c2-VDC_T)*VtINV)-400.0)));
    }
    if ((((Vb2c1-VDC_T)*VtINV)<400.0))
    {
      eVb2c1VDC = exp(((Vb2c1-VDC_T)*VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb2c1VDC = (expl*(1.0+(((Vb2c1-VDC_T)*VtINV)-400.0)));
    }
    K0 = sqrt((1.0+(4.0*eVb2c2VDC)));
    Kw = sqrt((1.0+(4.0*eVb2c1VDC)));
    pW = ((2.0*eVb2c1VDC)/(1.0+Kw));
    Ec = (Vt*((K0-Kw)-log(((K0+1.0)/(Kw+1.0)))));
    Ic1c2 = ((Ec+Vc1c2)/RCV_TM);
    if ((Ic1c2>0.0))
    {
      if ((Vb2c1<100.0))
      {
        tmpV = Vb2c1;
      }
      else
      {
        tmpV = (100.0+log((1.0+(Vb2c1-100.0))));
      }
      tmpV = tmpV;
      Vqs_th = ((VDC_T+((2.0*Vt)*log(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))))-tmpV);
      eps_VDC = (0.2*VDC_T);
      eps2 = (eps_VDC*eps_VDC);
      x2 = (Vqs_th*Vqs_th);
      if ((Vqs_th<0.0))
      {
        Vqs = ((0.5*eps2)/(sqrt((x2+eps2))-Vqs_th));
      }
      else
      {
        Vqs = (0.5*(sqrt((x2+eps2))+Vqs_th));
      }
      Vqs = Vqs;
      Iqs = ((Vqs*(Vqs+(IHC_M*instanceVar_SCRCV_M)))/(instanceVar_SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
      Ic1c2_Iqs = (Ic1c2/Iqs);
      instanceVar_dxa = ((Ic1c2_Iqs-1.0)/modelPar_AXI);
      if ((Ic1c2_Iqs<1.0))
      {
        alpha1 = (1.0+(modelPar_AXI*log((1.0+exp(instanceVar_dxa)))));
      }
      else
      {
        alpha1 = (Ic1c2_Iqs+(modelPar_AXI*log((1.0+exp((-instanceVar_dxa))))));
      }
      alpha1 = alpha1;
      alpha = (alpha1/(1.0+(modelPar_AXI*log((1.0+exp(((-1.0)/modelPar_AXI)))))));
      vyi = (Vqs/(IHC_M*instanceVar_SCRCV_M));
      yi = ((1.0+sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi)))))/((2.0*alpha)*(1.0+vyi)));
      xi_w = (((1.0-yi)+(pW*yi))/(1.0+(pW*yi)));
      gp0 = ((((0.5*Ic1c2)*RCV_TM)*xi_w)*VtINV);
      gp0_help = ((2.0*gp0)+(pW*((pW+gp0)+1.0)));
      gp02 = (0.5*(gp0-1.0));
      sqr_arg = ((gp02*gp02)+gp0_help);
      if ((gp0>=1.0))
      {
        p0star = (gp02+sqrt(sqr_arg));
      }
      else
      {
        p0star = (gp0_help/(sqrt(sqr_arg)-gp02));
      }
      eVb2c2star = ((p0star*(p0star+1.0))*exp((VDC_T*VtINV)));
      B1 = ((0.5*instanceVar_SCRCV_M)*(Ic1c2-IHC_M));
      B2 = (((instanceVar_SCRCV_M*RCV_TM)*IHC_M)*Ic1c2);
      Vxi0 = (B1+sqrt(((B1*B1)+B2)));
      Vch = (VDC_T*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs))));
      Icap = ((IHC_M*Ic1c2)/(IHC_M+Ic1c2));
      Icap_IHC = (IHC_M/(IHC_M+Ic1c2));
    }
    else
    {
      Iqs = 0.0;
      p0star = ((2.0*eVb2c2VDC)/(1.0+K0));
      eVb2c2star = eVb2c2;
      if (((fabs(Vc1c2)<(1.0e-5*Vt))||(fabs(Ec)<((1.0e-40*Vt)*(K0+Kw)))))
      {
        pav = (0.5*(p0star+pW));
        xi_w = (pav/(pav+1.0));
      }
      else
      {
        xi_w = (Ec/((Ec+Vb2c2)-Vb2c1));
      }
      Vxi0 = Vc1c2;
      Vch = (0.1*VDC_T);
      Icap = Ic1c2;
      Icap_IHC = (1.0-(Icap/IHC_M));
    }
    Vfe = (VDE_T*(1.0-pow(3.0,((-1.0)/modelPar_PE))));
    a_VDE = (0.1*VDE_T);
    instanceVar_dxa = ((Vb2e1-Vfe)/a_VDE);
    if ((Vb2e1<Vfe))
    {
      Vje = (Vb2e1-(a_VDE*log((1.0+exp(instanceVar_dxa)))));
    }
    else
    {
      Vje = (Vfe-(a_VDE*log((1.0+exp((-instanceVar_dxa))))));
    }
    Vje = Vje;
    E0BE = pow((1.0-(Vje*inv_VDE_T)),(1.0-modelPar_PE));
    Vte = (((VDE_T/(1.0-modelPar_PE))*(1.0-E0BE))+(3.0*(Vb2e1-Vje)));
    Vjunc = (Vb2c1+Vxi0);
    bjc = ((2.0-XP_T)/(1.0-XP_T));
    Vfc = (VDC_T*(1.0-pow(bjc,((-1.0)/modelPar_PC))));
    instanceVar_dxa = ((Vjunc-Vfc)/Vch);
    if ((Vjunc<Vfc))
    {
      Vjc = (Vjunc-(Vch*log((1.0+exp(instanceVar_dxa)))));
    }
    else
    {
      Vjc = (Vfc-(Vch*log((1.0+exp((-instanceVar_dxa))))));
    }
    Vjc = Vjc;
    fI = pow(Icap_IHC,modelPar_MC);
    Vcv = (((VDC_T/(1.0-modelPar_PC))*(1.0-(fI*pow((1.0-(Vjc/VDC_T)),(1.0-modelPar_PC)))))+((fI*bjc)*(Vjunc-Vjc)));
    Vtc = (((1.0-XP_T)*Vcv)+(XP_T*Vb2c1));
    If0 = ((4.0*IS_TM)/IK_TM);
    f1 = (If0*eVb2e1);
    n0 = (f1/(1.0+sqrt((1.0+f1))));
    f2 = (If0*eVb2c2star);
    nB = (f2/(1.0+sqrt((1.0+f2))));
    if ((modelPar_DEG==0.0))
    {
      q0I = ((1.0+(Vte/VER_T))+(Vtc/VEF_T));
    }
    else
    {
      termE = ((((Vte/VER_T)+1.0)*DEG_T)*VtINV);
      termC = ((((-Vtc)/VEF_T)*DEG_T)*VtINV);
      q0I = ((exp(termE)-exp(termC))/(exp((DEG_T*VtINV))-1.0));
    }
    eps2 = (0.1*0.1);
    x2 = (q0I*q0I);
    if ((q0I<0.0))
    {
      q1I = ((0.5*eps2)/(sqrt((x2+eps2))-q0I));
    }
    else
    {
      q1I = (0.5*(sqrt((x2+eps2))+q0I));
    }
    q1I = q1I;
    qBI = (q1I*(1.0+(0.5*(n0+nB))));
    Ir = (IS_TM*eVb2c2star);
    If = (IS_TM*eVb2e1);
    In = ((If-Ir)/qBI);
    Ibf0 = (IS_TM/BF_T);
    if ((modelPar_XREC==0.0))
    {
      Ib1 = (((1.0-modelPar_XIBI)*Ibf0)*(eVb2e1-1.0));
    }
    else
    {
      Ib1 = (((1.0-modelPar_XIBI)*Ibf0)*(((1.0-modelPar_XREC)*(eVb2e1-1.0))+((modelPar_XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T)))));
    }
    Ib1_s = ((modelPar_XIBI*Ibf0)*(eVb1e1-1.0));
    if ((((Vb2e1*VtINV)/modelPar_MLF)<400.0))
    {
      tmpExp = exp(((Vb2e1*VtINV)/modelPar_MLF));
    }
    else
    {
      expl = exp(400.0);
      tmpExp = (expl*(1.0+(((Vb2e1*VtINV)/modelPar_MLF)-400.0)));
    }
    Ib2 = ((IBF_TM*(tmpExp-1.0))+(modelPar_GMIN*Vb2e1));
    if ((((0.5*Vb1c4)*VtINV)<400.0))
    {
      tmpExp = exp(((0.5*Vb1c4)*VtINV));
    }
    else
    {
      expl = exp(400.0);
      tmpExp = (expl*(1.0+(((0.5*Vb1c4)*VtINV)-400.0)));
    }
    Ib3 = (((IBR_TM*(eVb1c4-1.0))/(tmpExp+exp(((0.5*modelPar_VLR)*VtINV))))+(modelPar_GMIN*Vb1c4));
    if ((((modelPar_IZEB>0.0)&&(modelPar_NZEB>0.0))&&(Vb2e1<0)))
    {
      if (((nZEB_T*(1-(instanceVar_pow2_2mPE/(2.0*E0BE))))<400.0))
      {
        eZEB = exp((nZEB_T*(1-(instanceVar_pow2_2mPE/(2.0*E0BE)))));
      }
      else
      {
        expl = exp(400.0);
        eZEB = (expl*(1.0+((nZEB_T*(1-(instanceVar_pow2_2mPE/(2.0*E0BE))))-400.0)));
      }
      x = (Vb2e1*inv_VDE_T);
      dE0BE = ((pow((-x),((-2.0)-modelPar_PE))*((modelPar_PE*((1-(modelPar_PE*modelPar_PE))-((3*x)*(modelPar_PE-1))))-(((6*x)*x)*((modelPar_PE-1)+x))))*0.16666666666666666667);
      if (((((Vb2e1*instanceVar_pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE))<400.0))
      {
        edZEB = exp((((Vb2e1*instanceVar_pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE)));
      }
      else
      {
        expl = exp(400.0);
        edZEB = (expl*(1.0+((((Vb2e1*instanceVar_pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE))-400.0)));
      }
      DZEB = ((-Vb2e1)-(((VGZEB_T*dE0BE)*(1-edZEB))/(instanceVar_pow2_2mPE*nZEB_T)));
      Izteb = ((((((2.0*IZEB_TM)*DZEB)*E0BE)*eZEB)*inv_VDE_T)*instanceVar_pow2_PEm2);
    }
    else
    {
      DZEB = 0;
      Izteb = 0;
    }
    g1 = (If0*eVb1c4);
    g2 = (4.0*eVb1c4VDC);
    nBex = ((g1-If0)/(1.0+sqrt((1.0+g1))));
    pWex = (g2/(1.0+sqrt((1.0+g2))));
    Iex = ((IK_TM*nBex)/(2.0*BRI_T));
    if ((modelPar_EXSUB==1.0))
    {
      Isub = (((2.0*ISS_TM)*(eVb1c4-eVsc4))/(1.0+sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))));
    }
    else
    {
      Isub = (((2.0*ISS_TM)*(eVb1c4-1.0))/(1.0+sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))));
    }
    if ((modelPar_ICSS<0.0))
    {
      Isf = (ISS_TM*(eVsc1-1.0));
    }
    else
    {
      Isf = (ICSS_TM*(eVsc1-1.0));
    }
    XIex = 0.0;
    XIsub = 0.0;
    if (((modelPar_EXMOD==1)||(modelPar_EXMOD==2)))
    {
      Iex = (Iex*instanceVar_Xext1);
      Isub = (Isub*instanceVar_Xext1);
      Xg1 = (If0*eVbc3);
      XnBex = ((Xg1-If0)/(1.0+sqrt((1.0+Xg1))));
      XIMex = ((((modelPar_XEXT*0.5)*IK_TM)*XnBex)/BRI_T);
      if ((modelPar_EXSUB==1.0))
      {
        XIMsub = ((((modelPar_XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))/(1.0+sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))));
      }
      else
      {
        XIMsub = ((((modelPar_XEXT*2.0)*ISS_TM)*(eVbc3-1.0))/(1.0+sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))));
      }
      if ((modelPar_EXMOD==1))
      {
        Vex_bias = ((modelPar_XEXT*((IS_TM/BRI_T)+ISS_TM))*RCCxx_TM);
        Vex = (Vt*(2.0-log((Vex_bias*VtINV))));
        vdif = (Vbc3-Vex);
        eps2 = (0.11*0.11);
        x2 = (vdif*vdif);
        if ((vdif<0.0))
        {
          VBex = ((0.5*eps2)/(sqrt((x2+eps2))-vdif));
        }
        else
        {
          VBex = (0.5*(sqrt((x2+eps2))+vdif));
        }
        VBex = VBex;
        Fex = (VBex/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
      }
      else
      {
        Vex = 0.0;
        vdif = 0.0;
        VBex = 0.0;
        Fex = 1.0;
      }
      XIex = (Fex*XIMex);
      XIsub = (Fex*XIMsub);
    }
    else
    {
      Fex = 0;
      XnBex = 0;
    }
    q0Q = ((1.0+(Vte/VER_T))+(Vtc/VEF_T));
    eps2 = (0.1*0.1);
    x2 = (q0Q*q0Q);
    if ((q0Q<0.0))
    {
      q1Q = ((0.5*eps2)/(sqrt((x2+eps2))-q0Q));
    }
    else
    {
      q1Q = (0.5*(sqrt((x2+eps2))+q0Q));
    }
    q1Q = q1Q;
    qBQ = (q1Q*(1.0+(0.5*(n0+nB))));
    Rb2 = ((3.0*RBV_TM)/qBQ);
    Ib1b2 = ((((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)/Rb2);
    Iavl = 0.0;
    Gem = 0.0;
    if (((Ic1c2>0.0)&&(Vb2c1<VDC_T)))
    {
      dEdx0 = ((2.0*modelPar_VAVL)/(modelPar_WAVL*modelPar_WAVL));
      sqr_arg = ((VDC_T-Vb2c1)/Icap_IHC);
      xd = sqrt(((2.0*sqr_arg)/dEdx0));
      if ((modelPar_EXAVL==0.0))
      {
        Weff = modelPar_WAVL;
      }
      else
      {
        xi_w1 = (1.0-(0.5*xi_w));
        Weff = ((modelPar_WAVL*xi_w1)*xi_w1);
      }
      Wd = ((xd*Weff)/sqrt(((xd*xd)+(Weff*Weff))));
      Eav = ((VDC_T-Vb2c1)/Wd);
      E0 = (Eav+(((0.5*Wd)*dEdx0)*Icap_IHC));
      if ((modelPar_EXAVL==0))
      {
        Em = E0;
      }
      else
      {
        SHw = (1.0+((2.0*modelPar_SFH)*(1.0+(2.0*xi_w))));
        Efi = ((1.0+modelPar_SFH)/(1.0+(2.0*modelPar_SFH)));
        Ew = (Eav-(((0.5*Wd)*dEdx0)*(Efi-(Ic1c2/(IHC_M*SHw)))));
        sqr_arg = (((Ew-E0)*(Ew-E0))+((((0.1*Eav)*Eav)*Icap)/IHC_M));
        Em = (0.5*((Ew+E0)+sqrt(sqr_arg)));
      }
      EmEav_Em = ((Em-Eav)/Em);
      if ((fabs(EmEav_Em)>1.0e-7))
      {
        lambda = ((0.5*Wd)/EmEav_Em);
        Gem = ((((instanceVar_An/BnT)*Em)*lambda)*(exp(((-BnT)/Em))-exp((((-BnT)/Em)*(1.0+(Weff/lambda))))));
      }
      else
      {
        Gem = ((instanceVar_An*Weff)*exp(((-BnT)/Em)));
      }
      Gmax = (((Vt/(Ic1c2*(RBC_TM+Rb2)))+(qBI/BF_T))+(RE_TM/(RBC_TM+Rb2)));
      Iavl = ((Ic1c2*Gem)/((Gem+(Gem/Gmax))+1.0));
    }
    if ((eVb2c2star>0.0))
    {
      Vb2c2star = (Vt*log(eVb2c2star));
    }
    else
    {
      Vb2c2star = Vb2c2;
    }
    power = ((((((((((((((((In*(Vb2e1-Vb2c2star))+(Ic1c2*(Vb2c2star-Vb2c1)))-(Iavl*Vb2c2star))+((Vee1*Vee1)/RE_TM))+((Vcc3*Vcc3)*GCCxx_TM))+((Vc3c4*Vc3c4)*GCCex_TM))+((Vc4c1*Vc4c1)*GCCin_TM))+((Vbb1*Vbb1)/RBC_TM))+(Ib1b2*Vb1b2))+(((Ib1+Ib2)-Izteb)*Vb2e1))+(Ib1_s*Vb1e1))+((Iex+Ib3)*Vb1c4))+(XIex*Vbc3))+(Isub*(Vb1c4-Vsc4)))+(XIsub*(Vbc3-Vsc3)))+(Isf*Vsc1));
    Qte = (((1.0-modelPar_XCJE)*CJE_TM)*Vte);
    instanceVar_dxa = ((Vb1e1-Vfe)/a_VDE);
    if ((Vb1e1<Vfe))
    {
      Vje_s = (Vb1e1-(a_VDE*log((1.0+exp(instanceVar_dxa)))));
    }
    else
    {
      Vje_s = (Vfe-(a_VDE*log((1.0+exp((-instanceVar_dxa))))));
    }
    Vje_s = Vje_s;
    Qte_s = ((modelPar_XCJE*CJE_TM)*(((VDE_T/(1.0-modelPar_PE))*(1.0-pow((1.0-(Vje_s*inv_VDE_T)),(1.0-modelPar_PE))))+(3.0*(Vb1e1-Vje_s))));
    Qtc = ((modelPar_XCJC*CJC_TM)*Vtc);
    Qb0 = (TAUB_T*IK_TM);
    Qbe_qs = (((0.5*Qb0)*n0)*q1Q);
    Qbc_qs = (((0.5*Qb0)*nB)*q1Q);
    a_VDC = (0.1*VDC_T);
    instanceVar_dxa = ((Vb1c4-Vfc)/a_VDC);
    if ((Vb1c4<Vfc))
    {
      Vjcex = (Vb1c4-(a_VDC*log((1.0+exp(instanceVar_dxa)))));
    }
    else
    {
      Vjcex = (Vfc-(a_VDC*log((1.0+exp((-instanceVar_dxa))))));
    }
    Vjcex = Vjcex;
    Vtexv = (((VDC_T/(1.0-modelPar_PC))*(1.0-pow((1.0-(Vjcex/VDC_T)),(1.0-modelPar_PC))))+(bjc*(Vb1c4-Vjcex)));
    Qtex = (((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-modelPar_XCJC))*(1.0-modelPar_XEXT));
    instanceVar_dxa = ((Vbc3-Vfc)/a_VDC);
    if ((Vbc3<Vfc))
    {
      XVjcex = (Vbc3-(a_VDC*log((1.0+exp(instanceVar_dxa)))));
    }
    else
    {
      XVjcex = (Vfc-(a_VDC*log((1.0+exp((-instanceVar_dxa))))));
    }
    XVjcex = XVjcex;
    XVtexv = (((VDC_T/(1.0-modelPar_PC))*(1.0-pow((1.0-(XVjcex/VDC_T)),(1.0-modelPar_PC))))+(bjc*(Vbc3-XVjcex)));
    XQtex = (((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-modelPar_XCJC))*modelPar_XEXT);
    a_VDS = (0.1*VDS_T);
    Vfs = (VDS_T*(1.0-pow(2.0,((-1.0)/modelPar_PS))));
    instanceVar_dxa = ((Vsc1-Vfs)/a_VDS);
    if ((Vsc1<Vfs))
    {
      Vjs = (Vsc1-(a_VDS*log((1.0+exp(instanceVar_dxa)))));
    }
    else
    {
      Vjs = (Vfs-(a_VDS*log((1.0+exp((-instanceVar_dxa))))));
    }
    Vjs = Vjs;
    Qts = (CJS_TM*(((VDS_T/(1.0-modelPar_PS))*(1.0-pow((1.0-(Vjs/VDS_T)),(1.0-modelPar_PS))))+(2.0*(Vsc1-Vjs))));
    Qe0 = ((TAUE_T*IK_TM)*pow((IS_TM/IK_TM),(1.0/modelPar_MTAU)));
    if (((Vb2e1/(modelPar_MTAU*Vt))<400.0))
    {
      tmpExp = exp((Vb2e1/(modelPar_MTAU*Vt)));
    }
    else
    {
      expl = exp(400.0);
      tmpExp = (expl*(1.0+((Vb2e1/(modelPar_MTAU*Vt))-400.0)));
    }
    Qe_qs = (Qe0*tmpExp);
    Qepi0 = (((4.0*TEPI_T)*Vt)/RCV_TM);
    Qepi = (((0.5*Qepi0)*xi_w)*((p0star+pW)+2.0));
    Qex = (((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))/(TAUB_T+TEPI_T));
    XQex = 0.0;
    if ((modelPar_EXMOD==1))
    {
      Qex = (Qex*(1.0-modelPar_XEXT));
      Xg2 = (4.0*eVbc3VDC);
      XpWex = (Xg2/(1.0+sqrt((1.0+Xg2))));
      XQex = (((((0.5*Fex)*modelPar_XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))/(TAUB_T+TEPI_T));
    }
    Qb1b2 = 0.0;
    if ((modelPar_EXPHI==1))
    {
      dVteVje = (pow((1.0-(Vje*inv_VDE_T)),(-modelPar_PE))-3.0);
      Vb2e1Vfe = ((Vb2e1-Vfe)/a_VDE);
      if ((Vb2e1Vfe<0.0))
      {
        dVjeVb2e1 = (1.0/(1.0+exp(Vb2e1Vfe)));
      }
      else
      {
        dVjeVb2e1 = (exp((-Vb2e1Vfe))/(1.0+exp((-Vb2e1Vfe))));
      }
      dVteVb2e1 = ((dVteVje*dVjeVb2e1)+3.0);
      dQteVb2e1 = (((1.0-modelPar_XCJE)*CJE_TM)*dVteVb2e1);
      dn0Vb2e1 = (((If0*eVb2e1)*VtINV)*(0.5/sqrt((1.0+f1))));
      dQbeVb2e1 = (((0.5*Qb0)*q1Q)*dn0Vb2e1);
      dQeVb2e1 = (Qe_qs/(modelPar_MTAU*Vt));
      Qb1b2 = ((0.2*Vb1b2)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1));
      Qe = ((1-modelPar_KE)*Qe_qs);
      Qbe_qs_eff = (Qbe_qs+(modelPar_KE*Qe_qs));
      Qbc = ((modelPar_XQB*Qbe_qs_eff)+Qbc_qs);
      Qbe = ((1-modelPar_XQB)*Qbe_qs_eff);
    }
    else
    {
      Qbe = Qbe_qs;
      Qbc = Qbc_qs;
      Qe = Qe_qs;
    }
    // I(c1,c2) <+ ((TYPE*Ic1c2))
    staticContributions[admsNodeID_c1] += (modelPar_TYPE*Ic1c2);
    staticContributions[admsNodeID_c2] -= (modelPar_TYPE*Ic1c2);
    // I(c2,e1) <+ ((TYPE*In))
    staticContributions[admsNodeID_c2] += (modelPar_TYPE*In);
    staticContributions[admsNodeID_e1] -= (modelPar_TYPE*In);
    // I(b1,e1) <+ ((TYPE*Ib1_s))
    staticContributions[admsNodeID_b1] += (modelPar_TYPE*Ib1_s);
    staticContributions[admsNodeID_e1] -= (modelPar_TYPE*Ib1_s);
    // I(b2,e1) <+ ((TYPE*((Ib1+Ib2)-Izteb)))
    staticContributions[admsNodeID_b2] += (modelPar_TYPE*((Ib1+Ib2)-Izteb));
    staticContributions[admsNodeID_e1] -= (modelPar_TYPE*((Ib1+Ib2)-Izteb));
    // I(b1,s) <+ ((TYPE*Isub))
    staticContributions[admsNodeID_b1] += (modelPar_TYPE*Isub);
    staticContributions[admsNodeID_s] -= (modelPar_TYPE*Isub);
    // I(b,s) <+ ((TYPE*XIsub))
    staticContributions[admsNodeID_b] += (modelPar_TYPE*XIsub);
    staticContributions[admsNodeID_s] -= (modelPar_TYPE*XIsub);
    // I(s,c1) <+ ((TYPE*Isf))
    staticContributions[admsNodeID_s] += (modelPar_TYPE*Isf);
    staticContributions[admsNodeID_c1] -= (modelPar_TYPE*Isf);
    // I(b1,b2) <+ ((TYPE*Ib1b2))
    staticContributions[admsNodeID_b1] += (modelPar_TYPE*Ib1b2);
    staticContributions[admsNodeID_b2] -= (modelPar_TYPE*Ib1b2);
    // I(b2,c2) <+ ((TYPE*((-1.0)*Iavl)))
    staticContributions[admsNodeID_b2] += (modelPar_TYPE*((-1.0)*Iavl));
    staticContributions[admsNodeID_c2] -= (modelPar_TYPE*((-1.0)*Iavl));
    // I(e,e1) <+ (((TYPE*Vee1)/RE_TM))
    staticContributions[admsNodeID_e] += ((modelPar_TYPE*Vee1)/RE_TM);
    staticContributions[admsNodeID_e1] -= ((modelPar_TYPE*Vee1)/RE_TM);
    // I(b,b1) <+ (((TYPE*Vbb1)/RBC_TM))
    staticContributions[admsNodeID_b] += ((modelPar_TYPE*Vbb1)/RBC_TM);
    staticContributions[admsNodeID_b1] -= ((modelPar_TYPE*Vbb1)/RBC_TM);
    // I(dt,GND) <+ ((V(dt,GND)/RTH_Tamb_M))
    staticContributions[admsNodeID_dt] += ((probeVars[admsProbeID_V_dt_GND])/RTH_Tamb_M);
    // I(dt,GND) <+ (ddt((CTH_M*V(dt,GND))))
    dynamicContributions[admsNodeID_dt] += ((instanceVar_CTH_M*(probeVars[admsProbeID_V_dt_GND])));
    // I(dt,GND) <+ (((-1.0)*power))
    staticContributions[admsNodeID_dt] += ((-1.0)*power);
    // I(b2,e1) <+ (ddt((TYPE*((Qte+Qbe)+Qe))))
    dynamicContributions[admsNodeID_b2] += ((modelPar_TYPE*((Qte+Qbe)+Qe)));
    dynamicContributions[admsNodeID_e1] -= ((modelPar_TYPE*((Qte+Qbe)+Qe)));
    // I(b1,e1) <+ (ddt((TYPE*Qte_s)))
    dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*Qte_s));
    dynamicContributions[admsNodeID_e1] -= ((modelPar_TYPE*Qte_s));
    // I(b2,c2) <+ (ddt((TYPE*((Qtc+Qbc)+Qepi))))
    dynamicContributions[admsNodeID_b2] += ((modelPar_TYPE*((Qtc+Qbc)+Qepi)));
    dynamicContributions[admsNodeID_c2] -= ((modelPar_TYPE*((Qtc+Qbc)+Qepi)));
    // I(s,c1) <+ (ddt((TYPE*Qts)))
    dynamicContributions[admsNodeID_s] += ((modelPar_TYPE*Qts));
    dynamicContributions[admsNodeID_c1] -= ((modelPar_TYPE*Qts));
    // I(b1,b2) <+ (ddt((TYPE*Qb1b2)))
    dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*Qb1b2));
    dynamicContributions[admsNodeID_b2] -= ((modelPar_TYPE*Qb1b2));
    // I(b,e) <+ (ddt(((TYPE*CBEO_M)*Vbe)))
    dynamicContributions[admsNodeID_b] += (((modelPar_TYPE*instanceVar_CBEO_M)*Vbe));
    dynamicContributions[admsNodeID_e] -= (((modelPar_TYPE*instanceVar_CBEO_M)*Vbe));
    // I(b,c) <+ (ddt(((TYPE*CBCO_M)*Vbc)))
    dynamicContributions[admsNodeID_b] += (((modelPar_TYPE*instanceVar_CBCO_M)*Vbc));
    dynamicContributions[admsNodeID_c] -= (((modelPar_TYPE*instanceVar_CBCO_M)*Vbc));
  }
  if ((modelPar_RCBLX>0.0))
  {
    // I(b,c3) <+ ((TYPE*XIex))
    staticContributions[admsNodeID_b] += (modelPar_TYPE*XIex);
    staticContributions[admsNodeID_c3] -= (modelPar_TYPE*XIex);
    // I(c,c3) <+ (((TYPE*Vcc3)*GCCxx_TM))
    staticContributions[admsNodeID_c] += ((modelPar_TYPE*Vcc3)*GCCxx_TM);
    staticContributions[admsNodeID_c3] -= ((modelPar_TYPE*Vcc3)*GCCxx_TM);
    // I(b,c3) <+ (ddt((TYPE*(XQtex+XQex))))
    dynamicContributions[admsNodeID_b] += ((modelPar_TYPE*(XQtex+XQex)));
    dynamicContributions[admsNodeID_c3] -= ((modelPar_TYPE*(XQtex+XQex)));
    if ((modelPar_RCBLI>0.0))
    {
      // I(c4,c1) <+ (((TYPE*Vc4c1)*GCCin_TM))
      staticContributions[admsNodeID_c4] += ((modelPar_TYPE*Vc4c1)*GCCin_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vc4c1)*GCCin_TM);
      // I(b1,c4) <+ ((TYPE*(Ib3+Iex)))
      staticContributions[admsNodeID_b1] += (modelPar_TYPE*(Ib3+Iex));
      staticContributions[admsNodeID_c4] -= (modelPar_TYPE*(Ib3+Iex));
      // I(c3,c4) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += ((modelPar_TYPE*Vc3c4)*GCCex_TM);
      staticContributions[admsNodeID_c4] -= ((modelPar_TYPE*Vc3c4)*GCCex_TM);
      // I(b1,c4) <+ (ddt((TYPE*(Qtex+Qex))))
      dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*(Qtex+Qex)));
      dynamicContributions[admsNodeID_c4] -= ((modelPar_TYPE*(Qtex+Qex)));
    }
    else
    {
      // V(c4,c1) <+ (0.0)
      // do nothing at all
      // I(b1,c1) <+ ((TYPE*(Ib3+Iex)))
      staticContributions[admsNodeID_b1] += (modelPar_TYPE*(Ib3+Iex));
      staticContributions[admsNodeID_c1] -= (modelPar_TYPE*(Ib3+Iex));
      // I(b1,c1) <+ (ddt((TYPE*(Qtex+Qex))))
      dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*(Qtex+Qex)));
      dynamicContributions[admsNodeID_c1] -= ((modelPar_TYPE*(Qtex+Qex)));
      // I(c3,c1) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += ((modelPar_TYPE*Vc3c4)*GCCex_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vc3c4)*GCCex_TM);
    }
  }
  else
  {
    // V(c3,c4) <+ (0)
    // do nothing at all
    if ((modelPar_RCBLI>0.0))
    {
      // I(b,c4) <+ ((TYPE*XIex))
      staticContributions[admsNodeID_b] += (modelPar_TYPE*XIex);
      staticContributions[admsNodeID_c4] -= (modelPar_TYPE*XIex);
      // I(c,c4) <+ (((TYPE*Vcc3)*GCCxx_TM))
      staticContributions[admsNodeID_c] += ((modelPar_TYPE*Vcc3)*GCCxx_TM);
      staticContributions[admsNodeID_c4] -= ((modelPar_TYPE*Vcc3)*GCCxx_TM);
      // I(c4,c1) <+ (((TYPE*Vc4c1)*GCCin_TM))
      staticContributions[admsNodeID_c4] += ((modelPar_TYPE*Vc4c1)*GCCin_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vc4c1)*GCCin_TM);
      // I(b1,c4) <+ ((TYPE*(Ib3+Iex)))
      staticContributions[admsNodeID_b1] += (modelPar_TYPE*(Ib3+Iex));
      staticContributions[admsNodeID_c4] -= (modelPar_TYPE*(Ib3+Iex));
      // I(b1,c4) <+ (ddt((TYPE*(Qtex+Qex))))
      dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*(Qtex+Qex)));
      dynamicContributions[admsNodeID_c4] -= ((modelPar_TYPE*(Qtex+Qex)));
      // I(b,c4) <+ (ddt((TYPE*(XQtex+XQex))))
      dynamicContributions[admsNodeID_b] += ((modelPar_TYPE*(XQtex+XQex)));
      dynamicContributions[admsNodeID_c4] -= ((modelPar_TYPE*(XQtex+XQex)));
    }
    else
    {
      // I(b,c1) <+ ((TYPE*XIex))
      staticContributions[admsNodeID_b] += (modelPar_TYPE*XIex);
      staticContributions[admsNodeID_c1] -= (modelPar_TYPE*XIex);
      // I(c,c1) <+ (((TYPE*Vcc3)*GCCxx_TM))
      staticContributions[admsNodeID_c] += ((modelPar_TYPE*Vcc3)*GCCxx_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vcc3)*GCCxx_TM);
      // V(c4,c1) <+ (0.0)
      // do nothing at all
      // I(b1,c1) <+ ((TYPE*(Ib3+Iex)))
      staticContributions[admsNodeID_b1] += (modelPar_TYPE*(Ib3+Iex));
      staticContributions[admsNodeID_c1] -= (modelPar_TYPE*(Ib3+Iex));
      // I(b1,c1) <+ (ddt((TYPE*(Qtex+Qex))))
      dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*(Qtex+Qex)));
      dynamicContributions[admsNodeID_c1] -= ((modelPar_TYPE*(Qtex+Qex)));
      // I(b,c1) <+ (ddt((TYPE*(XQtex+XQex))))
      dynamicContributions[admsNodeID_b] += ((modelPar_TYPE*(XQtex+XQex)));
      dynamicContributions[admsNodeID_c1] -= ((modelPar_TYPE*(XQtex+XQex)));
      // I(c3,c1) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += ((modelPar_TYPE*Vc3c4)*GCCex_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vc3c4)*GCCex_TM);
    }
  }
  {
    common = ((4.0*1.3806226e-23)*Tk);
    powerREC = (common/RE_TM);
    powerRBC = (common/RBC_TM);
    powerRCCxx = (common*GCCxx_TM);
    powerRCCex = (common*GCCex_TM);
    powerRCCin = (common*GCCin_TM);
    powerRBV = (((common/Rb2)*((4.0*eVb1b2)+5.0))*0.33333333333333333333);
    In_N = ((If+Ir)/qBI);
    powerCCS = ((2.0*1.6021918e-19)*fabs(In_N));
    if ((modelPar_KAVL>0))
    {
      Gem_N = fabs((Iavl/In_N));
    }
    else
    {
      Gem_N = 0.0;
    }
    powerIIS = (((2.0*1.6021918e-19)*Iavl)*(Gem_N+1));
    if ((In_N>0.0))
    {
      Taub_N = ((Qbe+Qbc)/In_N);
    }
    else
    {
      Taub_N = ((TAUB_T*q1Q)*qBI);
    }
    if ((modelPar_KC==1))
    {
      taun = (modelPar_XQB*Taub_N);
    }
    else
    {
      if ((modelPar_KC==2))
      {
        taun = (modelPar_FTAUN*Taub_N);
      }
      else
      {
        taun = 0;
      }
    }
    powerFBCS = ((2.0*1.6021918e-19)*((fabs(Ib1)+fabs(Ib2))+fabs(Izteb)));
    powerFBC1fB1 = (((1.0-modelPar_XIBI)*pow((fabs(Ib1)/(1-modelPar_XIBI)),modelPar_AF))*instanceVar_KF_M);
    exponentFBC1fB2 = ((2.0*(modelPar_MLF-1.0))+(modelPar_AF*(2.0-modelPar_MLF)));
    powerFBC1fB2 = (instanceVar_KFN_M*pow(fabs(Ib2),exponentFBC1fB2));
    powerEBSCS = ((2.0*1.6021918e-19)*fabs(Ib1_s));
    if ((modelPar_XIBI==0))
    {
      powerEBSC1f = 0.0;
    }
    else
    {
      powerEBSC1f = ((instanceVar_KF_M*modelPar_XIBI)*pow(fabs((Ib1_s/modelPar_XIBI)),modelPar_AF));
    }
    powerRBCS = ((2.0*1.6021918e-19)*fabs(Ib3));
    powerRBC1f = (instanceVar_KF_M*pow(fabs(Ib3),modelPar_AF));
    powerExCS = ((2.0*1.6021918e-19)*fabs(Iex));
    powerExC1f = ((instanceVar_KF_M*(1-(modelPar_EXMOD*modelPar_XEXT)))*pow((fabs(Iex)/(1-(modelPar_EXMOD*modelPar_XEXT))),modelPar_AF));
    powerExCSMOD = (((2.0*1.6021918e-19)*fabs(XIex))*modelPar_EXMOD);
    if ((modelPar_XEXT==0.0))
    {
      powerExC1fMOD = 0.0;
    }
    else
    {
      powerExC1fMOD = (((instanceVar_KF_M*modelPar_EXMOD)*modelPar_XEXT)*pow((fabs(XIex)/modelPar_XEXT),modelPar_AF));
    }
    powerSubsCS_B1S = ((2.0*1.6021918e-19)*fabs(Isub));
    powerSubsCS_BS = ((2.0*1.6021918e-19)*fabs(XIsub));
    // I(noi,GND) <+ (white_noise(powerCCS))
    // I(noi,GND) <+ (V(noi,GND))
    staticContributions[admsNodeID_noi] += (probeVars[admsProbeID_V_noi_GND]);
    // I(b2,e1) <+ ((taun*ddt(V(noi,GND))))
    dynamicContributions[admsNodeID_b2] += (taun*((probeVars[admsProbeID_V_noi_GND])));
    dynamicContributions[admsNodeID_e1] -= (taun*((probeVars[admsProbeID_V_noi_GND])));
    // I(c2,b2) <+ ((Gem_N*V(noi,GND)))
    staticContributions[admsNodeID_c2] += (Gem_N*(probeVars[admsProbeID_V_noi_GND]));
    staticContributions[admsNodeID_b2] -= (Gem_N*(probeVars[admsProbeID_V_noi_GND]));
    // I(c2,e1) <+ (V(noi,GND))
    staticContributions[admsNodeID_c2] += (probeVars[admsProbeID_V_noi_GND]);
    staticContributions[admsNodeID_e1] -= (probeVars[admsProbeID_V_noi_GND]);
    // I(c2,b2) <+ (white_noise(powerIIS))
    // I(b2,e1) <+ (white_noise(powerFBCS))
    // I(e,e1) <+ (white_noise(powerREC))
    // I(b,b1) <+ (white_noise(powerRBC))
    // I(b1,b2) <+ (white_noise(powerRBV))
    // I(b2,e1) <+ (flicker_noise(powerFBC1fB1,1))
    // I(b2,e1) <+ (flicker_noise(powerFBC1fB2,1))
    // I(e1,b1) <+ (white_noise(powerEBSCS))
    // I(e1,b1) <+ (flicker_noise(powerEBSC1f,1))
    // I(b1,c4) <+ (white_noise(powerRBCS))
    // I(b1,c4) <+ (flicker_noise(powerRBC1f,1))
    // I(b1,c4) <+ (white_noise(powerExCS))
    // I(b1,c4) <+ (flicker_noise(powerExC1f,1))
    // I(b,c3) <+ (white_noise(powerExCSMOD))
    // I(b,c3) <+ (flicker_noise(powerExC1fMOD,1))
    // I(b1,s) <+ (white_noise(powerSubsCS_B1S))
    // I(b,s) <+ (white_noise(powerSubsCS_BS))
    if ((modelPar_RCBLX>0.0))
    {
      if ((modelPar_RCBLI>0.0))
      {
        // I(c,c3) <+ (white_noise(powerRCCxx))
        // I(c3,c4) <+ (white_noise(powerRCCex))
        // I(c4,c1) <+ (white_noise(powerRCCin))
      }
      else
      {
        // I(c,c3) <+ (white_noise(powerRCCxx))
        // I(c3,c1) <+ (white_noise(powerRCCex))
      }
    }
    else
    {
      if ((modelPar_RCBLI>0.0))
      {
        // I(c,c4) <+ (white_noise(powerRCCxx))
        // I(c4,c1) <+ (white_noise(powerRCCin))
      }
      else
      {
        // I(c,c1) <+ (white_noise(powerRCCxx))
      }
    }
  }
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void InstanceSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Instance & in = *(dynamic_cast<const Instance *> (e1));
  const Model & mod =in.model_;

  dfdp.resize(13+0);
  dqdp.resize(13+0);
  Findices.resize(13+0);
  Qindices.resize(13+0);

  std::vector <double> probeVars(16);
  std::vector <AdmsSensFadType> staticContributions(13+0);
  std::vector <AdmsSensFadType> dynamicContributions(13+0);


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 13+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // Copy out all the model parameters (doubles) into FAD types
  //reals
  AdmsSensFadType modelPar_TREF=mod.TREF;
  bool modelPar_given_TREF=mod.given("TREF");
  AdmsSensFadType modelPar_DTA=mod.DTA;
  bool modelPar_given_DTA=mod.given("DTA");
  AdmsSensFadType modelPar_IS=mod.IS;
  bool modelPar_given_IS=mod.given("IS");
  AdmsSensFadType modelPar_IK=mod.IK;
  bool modelPar_given_IK=mod.given("IK");
  AdmsSensFadType modelPar_VER=mod.VER;
  bool modelPar_given_VER=mod.given("VER");
  AdmsSensFadType modelPar_VEF=mod.VEF;
  bool modelPar_given_VEF=mod.given("VEF");
  AdmsSensFadType modelPar_BF=mod.BF;
  bool modelPar_given_BF=mod.given("BF");
  AdmsSensFadType modelPar_IBF=mod.IBF;
  bool modelPar_given_IBF=mod.given("IBF");
  AdmsSensFadType modelPar_MLF=mod.MLF;
  bool modelPar_given_MLF=mod.given("MLF");
  AdmsSensFadType modelPar_XIBI=mod.XIBI;
  bool modelPar_given_XIBI=mod.given("XIBI");
  AdmsSensFadType modelPar_IZEB=mod.IZEB;
  bool modelPar_given_IZEB=mod.given("IZEB");
  AdmsSensFadType modelPar_NZEB=mod.NZEB;
  bool modelPar_given_NZEB=mod.given("NZEB");
  AdmsSensFadType modelPar_BRI=mod.BRI;
  bool modelPar_given_BRI=mod.given("BRI");
  AdmsSensFadType modelPar_IBR=mod.IBR;
  bool modelPar_given_IBR=mod.given("IBR");
  AdmsSensFadType modelPar_VLR=mod.VLR;
  bool modelPar_given_VLR=mod.given("VLR");
  AdmsSensFadType modelPar_XEXT=mod.XEXT;
  bool modelPar_given_XEXT=mod.given("XEXT");
  AdmsSensFadType modelPar_WAVL=mod.WAVL;
  bool modelPar_given_WAVL=mod.given("WAVL");
  AdmsSensFadType modelPar_VAVL=mod.VAVL;
  bool modelPar_given_VAVL=mod.given("VAVL");
  AdmsSensFadType modelPar_SFH=mod.SFH;
  bool modelPar_given_SFH=mod.given("SFH");
  AdmsSensFadType modelPar_RE=mod.RE;
  bool modelPar_given_RE=mod.given("RE");
  AdmsSensFadType modelPar_RBC=mod.RBC;
  bool modelPar_given_RBC=mod.given("RBC");
  AdmsSensFadType modelPar_RBV=mod.RBV;
  bool modelPar_given_RBV=mod.given("RBV");
  AdmsSensFadType modelPar_RCC=mod.RCC;
  bool modelPar_given_RCC=mod.given("RCC");
  AdmsSensFadType modelPar_RCV=mod.RCV;
  bool modelPar_given_RCV=mod.given("RCV");
  AdmsSensFadType modelPar_SCRCV=mod.SCRCV;
  bool modelPar_given_SCRCV=mod.given("SCRCV");
  AdmsSensFadType modelPar_IHC=mod.IHC;
  bool modelPar_given_IHC=mod.given("IHC");
  AdmsSensFadType modelPar_AXI=mod.AXI;
  bool modelPar_given_AXI=mod.given("AXI");
  AdmsSensFadType modelPar_CJE=mod.CJE;
  bool modelPar_given_CJE=mod.given("CJE");
  AdmsSensFadType modelPar_VDE=mod.VDE;
  bool modelPar_given_VDE=mod.given("VDE");
  AdmsSensFadType modelPar_PE=mod.PE;
  bool modelPar_given_PE=mod.given("PE");
  AdmsSensFadType modelPar_XCJE=mod.XCJE;
  bool modelPar_given_XCJE=mod.given("XCJE");
  AdmsSensFadType modelPar_CBEO=mod.CBEO;
  bool modelPar_given_CBEO=mod.given("CBEO");
  AdmsSensFadType modelPar_CJC=mod.CJC;
  bool modelPar_given_CJC=mod.given("CJC");
  AdmsSensFadType modelPar_VDC=mod.VDC;
  bool modelPar_given_VDC=mod.given("VDC");
  AdmsSensFadType modelPar_PC=mod.PC;
  bool modelPar_given_PC=mod.given("PC");
  AdmsSensFadType modelPar_XP=mod.XP;
  bool modelPar_given_XP=mod.given("XP");
  AdmsSensFadType modelPar_MC=mod.MC;
  bool modelPar_given_MC=mod.given("MC");
  AdmsSensFadType modelPar_XCJC=mod.XCJC;
  bool modelPar_given_XCJC=mod.given("XCJC");
  AdmsSensFadType modelPar_RCBLX=mod.RCBLX;
  bool modelPar_given_RCBLX=mod.given("RCBLX");
  AdmsSensFadType modelPar_RCBLI=mod.RCBLI;
  bool modelPar_given_RCBLI=mod.given("RCBLI");
  AdmsSensFadType modelPar_CBCO=mod.CBCO;
  bool modelPar_given_CBCO=mod.given("CBCO");
  AdmsSensFadType modelPar_MTAU=mod.MTAU;
  bool modelPar_given_MTAU=mod.given("MTAU");
  AdmsSensFadType modelPar_TAUE=mod.TAUE;
  bool modelPar_given_TAUE=mod.given("TAUE");
  AdmsSensFadType modelPar_TAUB=mod.TAUB;
  bool modelPar_given_TAUB=mod.given("TAUB");
  AdmsSensFadType modelPar_TEPI=mod.TEPI;
  bool modelPar_given_TEPI=mod.given("TEPI");
  AdmsSensFadType modelPar_TAUR=mod.TAUR;
  bool modelPar_given_TAUR=mod.given("TAUR");
  AdmsSensFadType modelPar_DEG=mod.DEG;
  bool modelPar_given_DEG=mod.given("DEG");
  AdmsSensFadType modelPar_XREC=mod.XREC;
  bool modelPar_given_XREC=mod.given("XREC");
  AdmsSensFadType modelPar_XQB=mod.XQB;
  bool modelPar_given_XQB=mod.given("XQB");
  AdmsSensFadType modelPar_AQBO=mod.AQBO;
  bool modelPar_given_AQBO=mod.given("AQBO");
  AdmsSensFadType modelPar_AE=mod.AE;
  bool modelPar_given_AE=mod.given("AE");
  AdmsSensFadType modelPar_AB=mod.AB;
  bool modelPar_given_AB=mod.given("AB");
  AdmsSensFadType modelPar_AEPI=mod.AEPI;
  bool modelPar_given_AEPI=mod.given("AEPI");
  AdmsSensFadType modelPar_AEX=mod.AEX;
  bool modelPar_given_AEX=mod.given("AEX");
  AdmsSensFadType modelPar_AC=mod.AC;
  bool modelPar_given_AC=mod.given("AC");
  AdmsSensFadType modelPar_ACBL=mod.ACBL;
  bool modelPar_given_ACBL=mod.given("ACBL");
  AdmsSensFadType modelPar_DVGBF=mod.DVGBF;
  bool modelPar_given_DVGBF=mod.given("DVGBF");
  AdmsSensFadType modelPar_DVGBR=mod.DVGBR;
  bool modelPar_given_DVGBR=mod.given("DVGBR");
  AdmsSensFadType modelPar_VGB=mod.VGB;
  bool modelPar_given_VGB=mod.given("VGB");
  AdmsSensFadType modelPar_VGC=mod.VGC;
  bool modelPar_given_VGC=mod.given("VGC");
  AdmsSensFadType modelPar_VGJ=mod.VGJ;
  bool modelPar_given_VGJ=mod.given("VGJ");
  AdmsSensFadType modelPar_VGZEB=mod.VGZEB;
  bool modelPar_given_VGZEB=mod.given("VGZEB");
  AdmsSensFadType modelPar_AVGEB=mod.AVGEB;
  bool modelPar_given_AVGEB=mod.given("AVGEB");
  AdmsSensFadType modelPar_TVGEB=mod.TVGEB;
  bool modelPar_given_TVGEB=mod.given("TVGEB");
  AdmsSensFadType modelPar_DVGTE=mod.DVGTE;
  bool modelPar_given_DVGTE=mod.given("DVGTE");
  AdmsSensFadType modelPar_DAIS=mod.DAIS;
  bool modelPar_given_DAIS=mod.given("DAIS");
  AdmsSensFadType modelPar_AF=mod.AF;
  bool modelPar_given_AF=mod.given("AF");
  AdmsSensFadType modelPar_KF=mod.KF;
  bool modelPar_given_KF=mod.given("KF");
  AdmsSensFadType modelPar_KFN=mod.KFN;
  bool modelPar_given_KFN=mod.given("KFN");
  AdmsSensFadType modelPar_KE=mod.KE;
  bool modelPar_given_KE=mod.given("KE");
  AdmsSensFadType modelPar_FTAUN=mod.FTAUN;
  bool modelPar_given_FTAUN=mod.given("FTAUN");
  AdmsSensFadType modelPar_ISS=mod.ISS;
  bool modelPar_given_ISS=mod.given("ISS");
  AdmsSensFadType modelPar_ICSS=mod.ICSS;
  bool modelPar_given_ICSS=mod.given("ICSS");
  AdmsSensFadType modelPar_IKS=mod.IKS;
  bool modelPar_given_IKS=mod.given("IKS");
  AdmsSensFadType modelPar_CJS=mod.CJS;
  bool modelPar_given_CJS=mod.given("CJS");
  AdmsSensFadType modelPar_VDS=mod.VDS;
  bool modelPar_given_VDS=mod.given("VDS");
  AdmsSensFadType modelPar_PS=mod.PS;
  bool modelPar_given_PS=mod.given("PS");
  AdmsSensFadType modelPar_VGS=mod.VGS;
  bool modelPar_given_VGS=mod.given("VGS");
  AdmsSensFadType modelPar_AS=mod.AS;
  bool modelPar_given_AS=mod.given("AS");
  AdmsSensFadType modelPar_ASUB=mod.ASUB;
  bool modelPar_given_ASUB=mod.given("ASUB");
  AdmsSensFadType modelPar_RTH=mod.RTH;
  bool modelPar_given_RTH=mod.given("RTH");
  AdmsSensFadType modelPar_CTH=mod.CTH;
  bool modelPar_given_CTH=mod.given("CTH");
  AdmsSensFadType modelPar_ATH=mod.ATH;
  bool modelPar_given_ATH=mod.given("ATH");
  AdmsSensFadType modelPar_MULT=mod.MULT;
  bool modelPar_given_MULT=mod.given("MULT");
  AdmsSensFadType modelPar_GMIN=mod.GMIN;
  bool modelPar_given_GMIN=mod.given("GMIN");


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_LEVEL=mod.LEVEL;
  bool modelPar_given_LEVEL=mod.given("LEVEL");
  int modelPar_EXMOD=mod.EXMOD;
  bool modelPar_given_EXMOD=mod.given("EXMOD");
  int modelPar_EXPHI=mod.EXPHI;
  bool modelPar_given_EXPHI=mod.given("EXPHI");
  int modelPar_EXAVL=mod.EXAVL;
  bool modelPar_given_EXAVL=mod.given("EXAVL");
  int modelPar_EXSUB=mod.EXSUB;
  bool modelPar_given_EXSUB=mod.given("EXSUB");
  int modelPar_KAVL=mod.KAVL;
  bool modelPar_given_KAVL=mod.given("KAVL");
  int modelPar_KC=mod.KC;
  bool modelPar_given_KC=mod.given("KC");
  int modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");



  // Copy out all the instance parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> inParamMap;

  // reals
  AdmsSensFadType instancePar_MULT=in.MULT;
  bool instancePar_given_MULT=in.given("MULT");
  inParamMap["MULT"] = &instancePar_MULT;


  // Copy all the real hidden instance params into fad types



  // Copy all the non-real instance params into vars of their appropriate type:


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check the name first, otherwise segfault on invalid name!
  inParamMap[name]->diff(0,1);

  //make local copies of all instance vars
  //reals
  AdmsSensFadType instanceVar_An=in.An;
  AdmsSensFadType instanceVar_Bn=in.Bn;
  AdmsSensFadType instanceVar_Trk=in.Trk;
  AdmsSensFadType instanceVar_Tamb=in.Tamb;
  AdmsSensFadType instanceVar_pow2_2mPE=in.pow2_2mPE;
  AdmsSensFadType instanceVar_pow2_PEm2=in.pow2_PEm2;
  AdmsSensFadType instanceVar_inv_VDE=in.inv_VDE;
  AdmsSensFadType instanceVar_inv_VGZEB_Tr=in.inv_VGZEB_Tr;
  AdmsSensFadType instanceVar_VGZEBOK=in.VGZEBOK;
  AdmsSensFadType instanceVar_invMULT=in.invMULT;
  AdmsSensFadType instanceVar_SCRCV_M=in.SCRCV_M;
  AdmsSensFadType instanceVar_KF_M=in.KF_M;
  AdmsSensFadType instanceVar_KFN_M=in.KFN_M;
  AdmsSensFadType instanceVar_CTH_M=in.CTH_M;
  AdmsSensFadType instanceVar_Xext1=in.Xext1;
  AdmsSensFadType instanceVar_CBEO_M=in.CBEO_M;
  AdmsSensFadType instanceVar_CBCO_M=in.CBCO_M;
  AdmsSensFadType instanceVar_dxa=in.dxa;


  //non-reals


  //make local copies of all model vars
  //reals


  // non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables and set as Fad independent variables.
  probeVars[in.admsProbeID_V_noi_GND] = (*solVectorPtr)[in.li_noi];
  probeVars[in.admsProbeID_V_c3_c1] = (*solVectorPtr)[in.li_c3]- (*solVectorPtr)[in.li_c1];
  probeVars[in.admsProbeID_V_c3_c4] = (*solVectorPtr)[in.li_c3]- (*solVectorPtr)[in.li_c4];
  probeVars[in.admsProbeID_V_c4_c1] = (*solVectorPtr)[in.li_c4]- (*solVectorPtr)[in.li_c1];
  probeVars[in.admsProbeID_V_b_c] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_c];
  probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_e];
  probeVars[in.admsProbeID_V_b_b1] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_b1];
  probeVars[in.admsProbeID_V_e_e1] = (*solVectorPtr)[in.li_e]- (*solVectorPtr)[in.li_e1];
  probeVars[in.admsProbeID_V_c1_c2] = (*solVectorPtr)[in.li_c1]- (*solVectorPtr)[in.li_c2];
  probeVars[in.admsProbeID_V_s_c1] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_c1];
  probeVars[in.admsProbeID_V_b1_b2] = (*solVectorPtr)[in.li_b1]- (*solVectorPtr)[in.li_b2];
  probeVars[in.admsProbeID_V_b1_e1] = (*solVectorPtr)[in.li_b1]- (*solVectorPtr)[in.li_e1];
  probeVars[in.admsProbeID_V_b2_e1] = (*solVectorPtr)[in.li_b2]- (*solVectorPtr)[in.li_e1];
  probeVars[in.admsProbeID_V_b2_c2] = (*solVectorPtr)[in.li_b2]- (*solVectorPtr)[in.li_c2];
  probeVars[in.admsProbeID_V_b2_c1] = (*solVectorPtr)[in.li_b2]- (*solVectorPtr)[in.li_c1];
  probeVars[in.admsProbeID_V_dt_GND] = (*solVectorPtr)[in.li_dt];


  // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
    
  probeVars[in.admsProbeID_V_b1_b2] *= modelPar_TYPE;
  probeVars[in.admsProbeID_V_b1_e1] *= modelPar_TYPE;
  probeVars[in.admsProbeID_V_b2_c2] *= modelPar_TYPE;
  probeVars[in.admsProbeID_V_b2_c1] *= modelPar_TYPE;

  evaluateInitialInstance(
     // instance parameters
     // reals
     instancePar_MULT,
     instancePar_given_MULT,
     // instance variables
     // reals
     instanceVar_An,
     instanceVar_Bn,
     instanceVar_Trk,
     instanceVar_Tamb,
     instanceVar_pow2_2mPE,
     instanceVar_pow2_PEm2,
     instanceVar_inv_VDE,
     instanceVar_inv_VGZEB_Tr,
     instanceVar_VGZEBOK,
     instanceVar_invMULT,
     instanceVar_SCRCV_M,
     instanceVar_KF_M,
     instanceVar_KFN_M,
     instanceVar_CTH_M,
     instanceVar_Xext1,
     instanceVar_CBEO_M,
     instanceVar_CBCO_M,
     instanceVar_dxa,
     // model parameters
     // reals
     modelPar_TREF,
     modelPar_given_TREF,
     modelPar_DTA,
     modelPar_given_DTA,
     modelPar_IS,
     modelPar_given_IS,
     modelPar_IK,
     modelPar_given_IK,
     modelPar_VER,
     modelPar_given_VER,
     modelPar_VEF,
     modelPar_given_VEF,
     modelPar_BF,
     modelPar_given_BF,
     modelPar_IBF,
     modelPar_given_IBF,
     modelPar_MLF,
     modelPar_given_MLF,
     modelPar_XIBI,
     modelPar_given_XIBI,
     modelPar_IZEB,
     modelPar_given_IZEB,
     modelPar_NZEB,
     modelPar_given_NZEB,
     modelPar_BRI,
     modelPar_given_BRI,
     modelPar_IBR,
     modelPar_given_IBR,
     modelPar_VLR,
     modelPar_given_VLR,
     modelPar_XEXT,
     modelPar_given_XEXT,
     modelPar_WAVL,
     modelPar_given_WAVL,
     modelPar_VAVL,
     modelPar_given_VAVL,
     modelPar_SFH,
     modelPar_given_SFH,
     modelPar_RE,
     modelPar_given_RE,
     modelPar_RBC,
     modelPar_given_RBC,
     modelPar_RBV,
     modelPar_given_RBV,
     modelPar_RCC,
     modelPar_given_RCC,
     modelPar_RCV,
     modelPar_given_RCV,
     modelPar_SCRCV,
     modelPar_given_SCRCV,
     modelPar_IHC,
     modelPar_given_IHC,
     modelPar_AXI,
     modelPar_given_AXI,
     modelPar_CJE,
     modelPar_given_CJE,
     modelPar_VDE,
     modelPar_given_VDE,
     modelPar_PE,
     modelPar_given_PE,
     modelPar_XCJE,
     modelPar_given_XCJE,
     modelPar_CBEO,
     modelPar_given_CBEO,
     modelPar_CJC,
     modelPar_given_CJC,
     modelPar_VDC,
     modelPar_given_VDC,
     modelPar_PC,
     modelPar_given_PC,
     modelPar_XP,
     modelPar_given_XP,
     modelPar_MC,
     modelPar_given_MC,
     modelPar_XCJC,
     modelPar_given_XCJC,
     modelPar_RCBLX,
     modelPar_given_RCBLX,
     modelPar_RCBLI,
     modelPar_given_RCBLI,
     modelPar_CBCO,
     modelPar_given_CBCO,
     modelPar_MTAU,
     modelPar_given_MTAU,
     modelPar_TAUE,
     modelPar_given_TAUE,
     modelPar_TAUB,
     modelPar_given_TAUB,
     modelPar_TEPI,
     modelPar_given_TEPI,
     modelPar_TAUR,
     modelPar_given_TAUR,
     modelPar_DEG,
     modelPar_given_DEG,
     modelPar_XREC,
     modelPar_given_XREC,
     modelPar_XQB,
     modelPar_given_XQB,
     modelPar_AQBO,
     modelPar_given_AQBO,
     modelPar_AE,
     modelPar_given_AE,
     modelPar_AB,
     modelPar_given_AB,
     modelPar_AEPI,
     modelPar_given_AEPI,
     modelPar_AEX,
     modelPar_given_AEX,
     modelPar_AC,
     modelPar_given_AC,
     modelPar_ACBL,
     modelPar_given_ACBL,
     modelPar_DVGBF,
     modelPar_given_DVGBF,
     modelPar_DVGBR,
     modelPar_given_DVGBR,
     modelPar_VGB,
     modelPar_given_VGB,
     modelPar_VGC,
     modelPar_given_VGC,
     modelPar_VGJ,
     modelPar_given_VGJ,
     modelPar_VGZEB,
     modelPar_given_VGZEB,
     modelPar_AVGEB,
     modelPar_given_AVGEB,
     modelPar_TVGEB,
     modelPar_given_TVGEB,
     modelPar_DVGTE,
     modelPar_given_DVGTE,
     modelPar_DAIS,
     modelPar_given_DAIS,
     modelPar_AF,
     modelPar_given_AF,
     modelPar_KF,
     modelPar_given_KF,
     modelPar_KFN,
     modelPar_given_KFN,
     modelPar_KE,
     modelPar_given_KE,
     modelPar_FTAUN,
     modelPar_given_FTAUN,
     modelPar_ISS,
     modelPar_given_ISS,
     modelPar_ICSS,
     modelPar_given_ICSS,
     modelPar_IKS,
     modelPar_given_IKS,
     modelPar_CJS,
     modelPar_given_CJS,
     modelPar_VDS,
     modelPar_given_VDS,
     modelPar_PS,
     modelPar_given_PS,
     modelPar_VGS,
     modelPar_given_VGS,
     modelPar_AS,
     modelPar_given_AS,
     modelPar_ASUB,
     modelPar_given_ASUB,
     modelPar_RTH,
     modelPar_given_RTH,
     modelPar_CTH,
     modelPar_given_CTH,
     modelPar_ATH,
     modelPar_given_ATH,
     modelPar_MULT,
     modelPar_given_MULT,
     modelPar_GMIN,
     modelPar_given_GMIN,
     // non-reals (including hidden)
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_EXMOD,
     modelPar_given_EXMOD,
     modelPar_EXPHI,
     modelPar_given_EXPHI,
     modelPar_EXAVL,
     modelPar_given_EXAVL,
     modelPar_EXSUB,
     modelPar_given_EXSUB,
     modelPar_KAVL,
     modelPar_given_KAVL,
     modelPar_KC,
     modelPar_given_KC,
     modelPar_TYPE,
     modelPar_given_TYPE,
     in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


  // Now call  the function that does the heavy lifting.
  evaluateModelEquations(
     probeVars,
     // probe constants
     in.admsProbeID_V_noi_GND,
     in.admsProbeID_V_c3_c1,
     in.admsProbeID_V_c3_c4,
     in.admsProbeID_V_c4_c1,
     in.admsProbeID_V_b_c,
     in.admsProbeID_V_b_e,
     in.admsProbeID_V_b_b1,
     in.admsProbeID_V_e_e1,
     in.admsProbeID_V_c1_c2,
     in.admsProbeID_V_s_c1,
     in.admsProbeID_V_b1_b2,
     in.admsProbeID_V_b1_e1,
     in.admsProbeID_V_b2_e1,
     in.admsProbeID_V_b2_c2,
     in.admsProbeID_V_b2_c1,
     in.admsProbeID_V_dt_GND,

     // node constants
     in.admsNodeID_c,
     in.admsNodeID_b,
     in.admsNodeID_e,
     in.admsNodeID_s,
     in.admsNodeID_dt,
     in.admsNodeID_e1,
     in.admsNodeID_b1,
     in.admsNodeID_b2,
     in.admsNodeID_c1,
     in.admsNodeID_c2,
     in.admsNodeID_c3,
     in.admsNodeID_c4,
     in.admsNodeID_noi,
     // instance parameters
     // reals
     instancePar_MULT,
     instancePar_given_MULT,
     // instance variables
     // reals
     instanceVar_An,
     instanceVar_Bn,
     instanceVar_Trk,
     instanceVar_Tamb,
     instanceVar_pow2_2mPE,
     instanceVar_pow2_PEm2,
     instanceVar_inv_VDE,
     instanceVar_inv_VGZEB_Tr,
     instanceVar_VGZEBOK,
     instanceVar_invMULT,
     instanceVar_SCRCV_M,
     instanceVar_KF_M,
     instanceVar_KFN_M,
     instanceVar_CTH_M,
     instanceVar_Xext1,
     instanceVar_CBEO_M,
     instanceVar_CBCO_M,
     instanceVar_dxa,
     // model parameters
     // reals
     modelPar_TREF,
     modelPar_given_TREF,
     modelPar_DTA,
     modelPar_given_DTA,
     modelPar_IS,
     modelPar_given_IS,
     modelPar_IK,
     modelPar_given_IK,
     modelPar_VER,
     modelPar_given_VER,
     modelPar_VEF,
     modelPar_given_VEF,
     modelPar_BF,
     modelPar_given_BF,
     modelPar_IBF,
     modelPar_given_IBF,
     modelPar_MLF,
     modelPar_given_MLF,
     modelPar_XIBI,
     modelPar_given_XIBI,
     modelPar_IZEB,
     modelPar_given_IZEB,
     modelPar_NZEB,
     modelPar_given_NZEB,
     modelPar_BRI,
     modelPar_given_BRI,
     modelPar_IBR,
     modelPar_given_IBR,
     modelPar_VLR,
     modelPar_given_VLR,
     modelPar_XEXT,
     modelPar_given_XEXT,
     modelPar_WAVL,
     modelPar_given_WAVL,
     modelPar_VAVL,
     modelPar_given_VAVL,
     modelPar_SFH,
     modelPar_given_SFH,
     modelPar_RE,
     modelPar_given_RE,
     modelPar_RBC,
     modelPar_given_RBC,
     modelPar_RBV,
     modelPar_given_RBV,
     modelPar_RCC,
     modelPar_given_RCC,
     modelPar_RCV,
     modelPar_given_RCV,
     modelPar_SCRCV,
     modelPar_given_SCRCV,
     modelPar_IHC,
     modelPar_given_IHC,
     modelPar_AXI,
     modelPar_given_AXI,
     modelPar_CJE,
     modelPar_given_CJE,
     modelPar_VDE,
     modelPar_given_VDE,
     modelPar_PE,
     modelPar_given_PE,
     modelPar_XCJE,
     modelPar_given_XCJE,
     modelPar_CBEO,
     modelPar_given_CBEO,
     modelPar_CJC,
     modelPar_given_CJC,
     modelPar_VDC,
     modelPar_given_VDC,
     modelPar_PC,
     modelPar_given_PC,
     modelPar_XP,
     modelPar_given_XP,
     modelPar_MC,
     modelPar_given_MC,
     modelPar_XCJC,
     modelPar_given_XCJC,
     modelPar_RCBLX,
     modelPar_given_RCBLX,
     modelPar_RCBLI,
     modelPar_given_RCBLI,
     modelPar_CBCO,
     modelPar_given_CBCO,
     modelPar_MTAU,
     modelPar_given_MTAU,
     modelPar_TAUE,
     modelPar_given_TAUE,
     modelPar_TAUB,
     modelPar_given_TAUB,
     modelPar_TEPI,
     modelPar_given_TEPI,
     modelPar_TAUR,
     modelPar_given_TAUR,
     modelPar_DEG,
     modelPar_given_DEG,
     modelPar_XREC,
     modelPar_given_XREC,
     modelPar_XQB,
     modelPar_given_XQB,
     modelPar_AQBO,
     modelPar_given_AQBO,
     modelPar_AE,
     modelPar_given_AE,
     modelPar_AB,
     modelPar_given_AB,
     modelPar_AEPI,
     modelPar_given_AEPI,
     modelPar_AEX,
     modelPar_given_AEX,
     modelPar_AC,
     modelPar_given_AC,
     modelPar_ACBL,
     modelPar_given_ACBL,
     modelPar_DVGBF,
     modelPar_given_DVGBF,
     modelPar_DVGBR,
     modelPar_given_DVGBR,
     modelPar_VGB,
     modelPar_given_VGB,
     modelPar_VGC,
     modelPar_given_VGC,
     modelPar_VGJ,
     modelPar_given_VGJ,
     modelPar_VGZEB,
     modelPar_given_VGZEB,
     modelPar_AVGEB,
     modelPar_given_AVGEB,
     modelPar_TVGEB,
     modelPar_given_TVGEB,
     modelPar_DVGTE,
     modelPar_given_DVGTE,
     modelPar_DAIS,
     modelPar_given_DAIS,
     modelPar_AF,
     modelPar_given_AF,
     modelPar_KF,
     modelPar_given_KF,
     modelPar_KFN,
     modelPar_given_KFN,
     modelPar_KE,
     modelPar_given_KE,
     modelPar_FTAUN,
     modelPar_given_FTAUN,
     modelPar_ISS,
     modelPar_given_ISS,
     modelPar_ICSS,
     modelPar_given_ICSS,
     modelPar_IKS,
     modelPar_given_IKS,
     modelPar_CJS,
     modelPar_given_CJS,
     modelPar_VDS,
     modelPar_given_VDS,
     modelPar_PS,
     modelPar_given_PS,
     modelPar_VGS,
     modelPar_given_VGS,
     modelPar_AS,
     modelPar_given_AS,
     modelPar_ASUB,
     modelPar_given_ASUB,
     modelPar_RTH,
     modelPar_given_RTH,
     modelPar_CTH,
     modelPar_given_CTH,
     modelPar_ATH,
     modelPar_given_ATH,
     modelPar_MULT,
     modelPar_given_MULT,
     modelPar_GMIN,
     modelPar_given_GMIN,
     // non-reals (including hidden)
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_EXMOD,
     modelPar_given_EXMOD,
     modelPar_EXPHI,
     modelPar_given_EXPHI,
     modelPar_EXAVL,
     modelPar_given_EXAVL,
     modelPar_EXSUB,
     modelPar_given_EXSUB,
     modelPar_KAVL,
     modelPar_given_KAVL,
     modelPar_KC,
     modelPar_given_KC,
     modelPar_TYPE,
     modelPar_given_TYPE,
     in.admsTemperature,
     in.adms_vt_nom,
     in.getDeviceOptions().gmin,
     staticContributions,
     dynamicContributions,
     in);


  // We now have the F and Q vector stuff, populate the dependencies:

  dfdp[in.admsNodeID_c] += staticContributions[in.admsNodeID_c].dx(0);
  dqdp[in.admsNodeID_c] += dynamicContributions[in.admsNodeID_c].dx(0);
  Findices[in.admsNodeID_c] = in.li_c;
  Qindices[in.admsNodeID_c] = in.li_c;
  dfdp[in.admsNodeID_b] += staticContributions[in.admsNodeID_b].dx(0);
  dqdp[in.admsNodeID_b] += dynamicContributions[in.admsNodeID_b].dx(0);
  Findices[in.admsNodeID_b] = in.li_b;
  Qindices[in.admsNodeID_b] = in.li_b;
  dfdp[in.admsNodeID_e] += staticContributions[in.admsNodeID_e].dx(0);
  dqdp[in.admsNodeID_e] += dynamicContributions[in.admsNodeID_e].dx(0);
  Findices[in.admsNodeID_e] = in.li_e;
  Qindices[in.admsNodeID_e] = in.li_e;
  dfdp[in.admsNodeID_s] += staticContributions[in.admsNodeID_s].dx(0);
  dqdp[in.admsNodeID_s] += dynamicContributions[in.admsNodeID_s].dx(0);
  Findices[in.admsNodeID_s] = in.li_s;
  Qindices[in.admsNodeID_s] = in.li_s;
  dfdp[in.admsNodeID_dt] += staticContributions[in.admsNodeID_dt].dx(0);
  dqdp[in.admsNodeID_dt] += dynamicContributions[in.admsNodeID_dt].dx(0);
  Findices[in.admsNodeID_dt] = in.li_dt;
  Qindices[in.admsNodeID_dt] = in.li_dt;
  dfdp[in.admsNodeID_e1] += staticContributions[in.admsNodeID_e1].dx(0);
  dqdp[in.admsNodeID_e1] += dynamicContributions[in.admsNodeID_e1].dx(0);
  Findices[in.admsNodeID_e1] = in.li_e1;
  Qindices[in.admsNodeID_e1] = in.li_e1;
  dfdp[in.admsNodeID_b1] += staticContributions[in.admsNodeID_b1].dx(0);
  dqdp[in.admsNodeID_b1] += dynamicContributions[in.admsNodeID_b1].dx(0);
  Findices[in.admsNodeID_b1] = in.li_b1;
  Qindices[in.admsNodeID_b1] = in.li_b1;
  dfdp[in.admsNodeID_b2] += staticContributions[in.admsNodeID_b2].dx(0);
  dqdp[in.admsNodeID_b2] += dynamicContributions[in.admsNodeID_b2].dx(0);
  Findices[in.admsNodeID_b2] = in.li_b2;
  Qindices[in.admsNodeID_b2] = in.li_b2;
  dfdp[in.admsNodeID_c1] += staticContributions[in.admsNodeID_c1].dx(0);
  dqdp[in.admsNodeID_c1] += dynamicContributions[in.admsNodeID_c1].dx(0);
  Findices[in.admsNodeID_c1] = in.li_c1;
  Qindices[in.admsNodeID_c1] = in.li_c1;
  dfdp[in.admsNodeID_c2] += staticContributions[in.admsNodeID_c2].dx(0);
  dqdp[in.admsNodeID_c2] += dynamicContributions[in.admsNodeID_c2].dx(0);
  Findices[in.admsNodeID_c2] = in.li_c2;
  Qindices[in.admsNodeID_c2] = in.li_c2;
  dfdp[in.admsNodeID_c3] += staticContributions[in.admsNodeID_c3].dx(0);
  dqdp[in.admsNodeID_c3] += dynamicContributions[in.admsNodeID_c3].dx(0);
  Findices[in.admsNodeID_c3] = in.li_c3;
  Qindices[in.admsNodeID_c3] = in.li_c3;
  dfdp[in.admsNodeID_c4] += staticContributions[in.admsNodeID_c4].dx(0);
  dqdp[in.admsNodeID_c4] += dynamicContributions[in.admsNodeID_c4].dx(0);
  Findices[in.admsNodeID_c4] = in.li_c4;
  Qindices[in.admsNodeID_c4] = in.li_c4;
  dfdp[in.admsNodeID_noi] += staticContributions[in.admsNodeID_noi].dx(0);
  dqdp[in.admsNodeID_noi] += dynamicContributions[in.admsNodeID_noi].dx(0);
  Findices[in.admsNodeID_noi] = in.li_noi;
  Qindices[in.admsNodeID_noi] = in.li_noi;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void ModelSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Model & mod = *(dynamic_cast<const Model *> (e1));
  int sizeInstance = mod.instanceContainer.size();

  dfdp.resize((13+0)*sizeInstance);
  dqdp.resize((13+0)*sizeInstance);
  Findices.resize((13+0)*sizeInstance);
  Qindices.resize((13+0)*sizeInstance);

  std::vector <double> probeVars(16);
  std::vector <AdmsSensFadType> staticContributions(13+0);
  std::vector <AdmsSensFadType> dynamicContributions(13+0);


  // Copy out all the model parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> modParamMap;

  // reals
  AdmsSensFadType modelPar_TREF=mod.TREF;
  bool modelPar_given_TREF=mod.given("TREF");
  modParamMap["TREF"] = &modelPar_TREF;
  AdmsSensFadType modelPar_DTA=mod.DTA;
  bool modelPar_given_DTA=mod.given("DTA");
  modParamMap["DTA"] = &modelPar_DTA;
  AdmsSensFadType modelPar_IS=mod.IS;
  bool modelPar_given_IS=mod.given("IS");
  modParamMap["IS"] = &modelPar_IS;
  AdmsSensFadType modelPar_IK=mod.IK;
  bool modelPar_given_IK=mod.given("IK");
  modParamMap["IK"] = &modelPar_IK;
  AdmsSensFadType modelPar_VER=mod.VER;
  bool modelPar_given_VER=mod.given("VER");
  modParamMap["VER"] = &modelPar_VER;
  AdmsSensFadType modelPar_VEF=mod.VEF;
  bool modelPar_given_VEF=mod.given("VEF");
  modParamMap["VEF"] = &modelPar_VEF;
  AdmsSensFadType modelPar_BF=mod.BF;
  bool modelPar_given_BF=mod.given("BF");
  modParamMap["BF"] = &modelPar_BF;
  AdmsSensFadType modelPar_IBF=mod.IBF;
  bool modelPar_given_IBF=mod.given("IBF");
  modParamMap["IBF"] = &modelPar_IBF;
  AdmsSensFadType modelPar_MLF=mod.MLF;
  bool modelPar_given_MLF=mod.given("MLF");
  modParamMap["MLF"] = &modelPar_MLF;
  AdmsSensFadType modelPar_XIBI=mod.XIBI;
  bool modelPar_given_XIBI=mod.given("XIBI");
  modParamMap["XIBI"] = &modelPar_XIBI;
  AdmsSensFadType modelPar_IZEB=mod.IZEB;
  bool modelPar_given_IZEB=mod.given("IZEB");
  modParamMap["IZEB"] = &modelPar_IZEB;
  AdmsSensFadType modelPar_NZEB=mod.NZEB;
  bool modelPar_given_NZEB=mod.given("NZEB");
  modParamMap["NZEB"] = &modelPar_NZEB;
  AdmsSensFadType modelPar_BRI=mod.BRI;
  bool modelPar_given_BRI=mod.given("BRI");
  modParamMap["BRI"] = &modelPar_BRI;
  AdmsSensFadType modelPar_IBR=mod.IBR;
  bool modelPar_given_IBR=mod.given("IBR");
  modParamMap["IBR"] = &modelPar_IBR;
  AdmsSensFadType modelPar_VLR=mod.VLR;
  bool modelPar_given_VLR=mod.given("VLR");
  modParamMap["VLR"] = &modelPar_VLR;
  AdmsSensFadType modelPar_XEXT=mod.XEXT;
  bool modelPar_given_XEXT=mod.given("XEXT");
  modParamMap["XEXT"] = &modelPar_XEXT;
  AdmsSensFadType modelPar_WAVL=mod.WAVL;
  bool modelPar_given_WAVL=mod.given("WAVL");
  modParamMap["WAVL"] = &modelPar_WAVL;
  AdmsSensFadType modelPar_VAVL=mod.VAVL;
  bool modelPar_given_VAVL=mod.given("VAVL");
  modParamMap["VAVL"] = &modelPar_VAVL;
  AdmsSensFadType modelPar_SFH=mod.SFH;
  bool modelPar_given_SFH=mod.given("SFH");
  modParamMap["SFH"] = &modelPar_SFH;
  AdmsSensFadType modelPar_RE=mod.RE;
  bool modelPar_given_RE=mod.given("RE");
  modParamMap["RE"] = &modelPar_RE;
  AdmsSensFadType modelPar_RBC=mod.RBC;
  bool modelPar_given_RBC=mod.given("RBC");
  modParamMap["RBC"] = &modelPar_RBC;
  AdmsSensFadType modelPar_RBV=mod.RBV;
  bool modelPar_given_RBV=mod.given("RBV");
  modParamMap["RBV"] = &modelPar_RBV;
  AdmsSensFadType modelPar_RCC=mod.RCC;
  bool modelPar_given_RCC=mod.given("RCC");
  modParamMap["RCC"] = &modelPar_RCC;
  AdmsSensFadType modelPar_RCV=mod.RCV;
  bool modelPar_given_RCV=mod.given("RCV");
  modParamMap["RCV"] = &modelPar_RCV;
  AdmsSensFadType modelPar_SCRCV=mod.SCRCV;
  bool modelPar_given_SCRCV=mod.given("SCRCV");
  modParamMap["SCRCV"] = &modelPar_SCRCV;
  AdmsSensFadType modelPar_IHC=mod.IHC;
  bool modelPar_given_IHC=mod.given("IHC");
  modParamMap["IHC"] = &modelPar_IHC;
  AdmsSensFadType modelPar_AXI=mod.AXI;
  bool modelPar_given_AXI=mod.given("AXI");
  modParamMap["AXI"] = &modelPar_AXI;
  AdmsSensFadType modelPar_CJE=mod.CJE;
  bool modelPar_given_CJE=mod.given("CJE");
  modParamMap["CJE"] = &modelPar_CJE;
  AdmsSensFadType modelPar_VDE=mod.VDE;
  bool modelPar_given_VDE=mod.given("VDE");
  modParamMap["VDE"] = &modelPar_VDE;
  AdmsSensFadType modelPar_PE=mod.PE;
  bool modelPar_given_PE=mod.given("PE");
  modParamMap["PE"] = &modelPar_PE;
  AdmsSensFadType modelPar_XCJE=mod.XCJE;
  bool modelPar_given_XCJE=mod.given("XCJE");
  modParamMap["XCJE"] = &modelPar_XCJE;
  AdmsSensFadType modelPar_CBEO=mod.CBEO;
  bool modelPar_given_CBEO=mod.given("CBEO");
  modParamMap["CBEO"] = &modelPar_CBEO;
  AdmsSensFadType modelPar_CJC=mod.CJC;
  bool modelPar_given_CJC=mod.given("CJC");
  modParamMap["CJC"] = &modelPar_CJC;
  AdmsSensFadType modelPar_VDC=mod.VDC;
  bool modelPar_given_VDC=mod.given("VDC");
  modParamMap["VDC"] = &modelPar_VDC;
  AdmsSensFadType modelPar_PC=mod.PC;
  bool modelPar_given_PC=mod.given("PC");
  modParamMap["PC"] = &modelPar_PC;
  AdmsSensFadType modelPar_XP=mod.XP;
  bool modelPar_given_XP=mod.given("XP");
  modParamMap["XP"] = &modelPar_XP;
  AdmsSensFadType modelPar_MC=mod.MC;
  bool modelPar_given_MC=mod.given("MC");
  modParamMap["MC"] = &modelPar_MC;
  AdmsSensFadType modelPar_XCJC=mod.XCJC;
  bool modelPar_given_XCJC=mod.given("XCJC");
  modParamMap["XCJC"] = &modelPar_XCJC;
  AdmsSensFadType modelPar_RCBLX=mod.RCBLX;
  bool modelPar_given_RCBLX=mod.given("RCBLX");
  modParamMap["RCBLX"] = &modelPar_RCBLX;
  AdmsSensFadType modelPar_RCBLI=mod.RCBLI;
  bool modelPar_given_RCBLI=mod.given("RCBLI");
  modParamMap["RCBLI"] = &modelPar_RCBLI;
  AdmsSensFadType modelPar_CBCO=mod.CBCO;
  bool modelPar_given_CBCO=mod.given("CBCO");
  modParamMap["CBCO"] = &modelPar_CBCO;
  AdmsSensFadType modelPar_MTAU=mod.MTAU;
  bool modelPar_given_MTAU=mod.given("MTAU");
  modParamMap["MTAU"] = &modelPar_MTAU;
  AdmsSensFadType modelPar_TAUE=mod.TAUE;
  bool modelPar_given_TAUE=mod.given("TAUE");
  modParamMap["TAUE"] = &modelPar_TAUE;
  AdmsSensFadType modelPar_TAUB=mod.TAUB;
  bool modelPar_given_TAUB=mod.given("TAUB");
  modParamMap["TAUB"] = &modelPar_TAUB;
  AdmsSensFadType modelPar_TEPI=mod.TEPI;
  bool modelPar_given_TEPI=mod.given("TEPI");
  modParamMap["TEPI"] = &modelPar_TEPI;
  AdmsSensFadType modelPar_TAUR=mod.TAUR;
  bool modelPar_given_TAUR=mod.given("TAUR");
  modParamMap["TAUR"] = &modelPar_TAUR;
  AdmsSensFadType modelPar_DEG=mod.DEG;
  bool modelPar_given_DEG=mod.given("DEG");
  modParamMap["DEG"] = &modelPar_DEG;
  AdmsSensFadType modelPar_XREC=mod.XREC;
  bool modelPar_given_XREC=mod.given("XREC");
  modParamMap["XREC"] = &modelPar_XREC;
  AdmsSensFadType modelPar_XQB=mod.XQB;
  bool modelPar_given_XQB=mod.given("XQB");
  modParamMap["XQB"] = &modelPar_XQB;
  AdmsSensFadType modelPar_AQBO=mod.AQBO;
  bool modelPar_given_AQBO=mod.given("AQBO");
  modParamMap["AQBO"] = &modelPar_AQBO;
  AdmsSensFadType modelPar_AE=mod.AE;
  bool modelPar_given_AE=mod.given("AE");
  modParamMap["AE"] = &modelPar_AE;
  AdmsSensFadType modelPar_AB=mod.AB;
  bool modelPar_given_AB=mod.given("AB");
  modParamMap["AB"] = &modelPar_AB;
  AdmsSensFadType modelPar_AEPI=mod.AEPI;
  bool modelPar_given_AEPI=mod.given("AEPI");
  modParamMap["AEPI"] = &modelPar_AEPI;
  AdmsSensFadType modelPar_AEX=mod.AEX;
  bool modelPar_given_AEX=mod.given("AEX");
  modParamMap["AEX"] = &modelPar_AEX;
  AdmsSensFadType modelPar_AC=mod.AC;
  bool modelPar_given_AC=mod.given("AC");
  modParamMap["AC"] = &modelPar_AC;
  AdmsSensFadType modelPar_ACBL=mod.ACBL;
  bool modelPar_given_ACBL=mod.given("ACBL");
  modParamMap["ACBL"] = &modelPar_ACBL;
  AdmsSensFadType modelPar_DVGBF=mod.DVGBF;
  bool modelPar_given_DVGBF=mod.given("DVGBF");
  modParamMap["DVGBF"] = &modelPar_DVGBF;
  AdmsSensFadType modelPar_DVGBR=mod.DVGBR;
  bool modelPar_given_DVGBR=mod.given("DVGBR");
  modParamMap["DVGBR"] = &modelPar_DVGBR;
  AdmsSensFadType modelPar_VGB=mod.VGB;
  bool modelPar_given_VGB=mod.given("VGB");
  modParamMap["VGB"] = &modelPar_VGB;
  AdmsSensFadType modelPar_VGC=mod.VGC;
  bool modelPar_given_VGC=mod.given("VGC");
  modParamMap["VGC"] = &modelPar_VGC;
  AdmsSensFadType modelPar_VGJ=mod.VGJ;
  bool modelPar_given_VGJ=mod.given("VGJ");
  modParamMap["VGJ"] = &modelPar_VGJ;
  AdmsSensFadType modelPar_VGZEB=mod.VGZEB;
  bool modelPar_given_VGZEB=mod.given("VGZEB");
  modParamMap["VGZEB"] = &modelPar_VGZEB;
  AdmsSensFadType modelPar_AVGEB=mod.AVGEB;
  bool modelPar_given_AVGEB=mod.given("AVGEB");
  modParamMap["AVGEB"] = &modelPar_AVGEB;
  AdmsSensFadType modelPar_TVGEB=mod.TVGEB;
  bool modelPar_given_TVGEB=mod.given("TVGEB");
  modParamMap["TVGEB"] = &modelPar_TVGEB;
  AdmsSensFadType modelPar_DVGTE=mod.DVGTE;
  bool modelPar_given_DVGTE=mod.given("DVGTE");
  modParamMap["DVGTE"] = &modelPar_DVGTE;
  AdmsSensFadType modelPar_DAIS=mod.DAIS;
  bool modelPar_given_DAIS=mod.given("DAIS");
  modParamMap["DAIS"] = &modelPar_DAIS;
  AdmsSensFadType modelPar_AF=mod.AF;
  bool modelPar_given_AF=mod.given("AF");
  modParamMap["AF"] = &modelPar_AF;
  AdmsSensFadType modelPar_KF=mod.KF;
  bool modelPar_given_KF=mod.given("KF");
  modParamMap["KF"] = &modelPar_KF;
  AdmsSensFadType modelPar_KFN=mod.KFN;
  bool modelPar_given_KFN=mod.given("KFN");
  modParamMap["KFN"] = &modelPar_KFN;
  AdmsSensFadType modelPar_KE=mod.KE;
  bool modelPar_given_KE=mod.given("KE");
  modParamMap["KE"] = &modelPar_KE;
  AdmsSensFadType modelPar_FTAUN=mod.FTAUN;
  bool modelPar_given_FTAUN=mod.given("FTAUN");
  modParamMap["FTAUN"] = &modelPar_FTAUN;
  AdmsSensFadType modelPar_ISS=mod.ISS;
  bool modelPar_given_ISS=mod.given("ISS");
  modParamMap["ISS"] = &modelPar_ISS;
  AdmsSensFadType modelPar_ICSS=mod.ICSS;
  bool modelPar_given_ICSS=mod.given("ICSS");
  modParamMap["ICSS"] = &modelPar_ICSS;
  AdmsSensFadType modelPar_IKS=mod.IKS;
  bool modelPar_given_IKS=mod.given("IKS");
  modParamMap["IKS"] = &modelPar_IKS;
  AdmsSensFadType modelPar_CJS=mod.CJS;
  bool modelPar_given_CJS=mod.given("CJS");
  modParamMap["CJS"] = &modelPar_CJS;
  AdmsSensFadType modelPar_VDS=mod.VDS;
  bool modelPar_given_VDS=mod.given("VDS");
  modParamMap["VDS"] = &modelPar_VDS;
  AdmsSensFadType modelPar_PS=mod.PS;
  bool modelPar_given_PS=mod.given("PS");
  modParamMap["PS"] = &modelPar_PS;
  AdmsSensFadType modelPar_VGS=mod.VGS;
  bool modelPar_given_VGS=mod.given("VGS");
  modParamMap["VGS"] = &modelPar_VGS;
  AdmsSensFadType modelPar_AS=mod.AS;
  bool modelPar_given_AS=mod.given("AS");
  modParamMap["AS"] = &modelPar_AS;
  AdmsSensFadType modelPar_ASUB=mod.ASUB;
  bool modelPar_given_ASUB=mod.given("ASUB");
  modParamMap["ASUB"] = &modelPar_ASUB;
  AdmsSensFadType modelPar_RTH=mod.RTH;
  bool modelPar_given_RTH=mod.given("RTH");
  modParamMap["RTH"] = &modelPar_RTH;
  AdmsSensFadType modelPar_CTH=mod.CTH;
  bool modelPar_given_CTH=mod.given("CTH");
  modParamMap["CTH"] = &modelPar_CTH;
  AdmsSensFadType modelPar_ATH=mod.ATH;
  bool modelPar_given_ATH=mod.given("ATH");
  modParamMap["ATH"] = &modelPar_ATH;
  AdmsSensFadType modelPar_MULT=mod.MULT;
  bool modelPar_given_MULT=mod.given("MULT");
  modParamMap["MULT"] = &modelPar_MULT;
  AdmsSensFadType modelPar_GMIN=mod.GMIN;
  bool modelPar_given_GMIN=mod.given("GMIN");
  modParamMap["GMIN"] = &modelPar_GMIN;


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_LEVEL=mod.LEVEL;
  bool modelPar_given_LEVEL=mod.given("LEVEL");
  int modelPar_EXMOD=mod.EXMOD;
  bool modelPar_given_EXMOD=mod.given("EXMOD");
  int modelPar_EXPHI=mod.EXPHI;
  bool modelPar_given_EXPHI=mod.given("EXPHI");
  int modelPar_EXAVL=mod.EXAVL;
  bool modelPar_given_EXAVL=mod.given("EXAVL");
  int modelPar_EXSUB=mod.EXSUB;
  bool modelPar_given_EXSUB=mod.given("EXSUB");
  int modelPar_KAVL=mod.KAVL;
  bool modelPar_given_KAVL=mod.given("KAVL");
  int modelPar_KC=mod.KC;
  bool modelPar_given_KC=mod.given("KC");
  int modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check name for presence first!  Segfault on invalid.
  modParamMap[name]->diff(0,1);

  //make local copies of all model vars
  //reals


  // non-reals



  // Now loop over all instances and do the deed
  int inst=0;
  for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
  {

    Instance & in=*(*in_it);
    // initialize contributions to zero (automatically sets derivatives to zero)
    for (int i=0; i < 13+0 ; ++i)
    {
      staticContributions[i]=0;
      dynamicContributions[i]=0;
    }



    // Copy out all the instance parameters (doubles) into FAD types
    // reals
    AdmsSensFadType instancePar_MULT=in.MULT;
    bool instancePar_given_MULT=in.given("MULT");


    // real hidden instance


    // Copy all the non-real instance params into vars of their appropriate type:




    // If there are any instance parameters that were not given, and have
    // corresponding model params, copy the model param into the instance.
    // This was already done by the instance constructor, but we do it again
    // because now we're propagating derivatives, and the user could be trying
    // to get sensitivity to the model parameter.
    if (!(in.given("MULT")))
    {
      instancePar_MULT = modelPar_MULT;
    }


    //make local copies of all instance vars
    //reals
    AdmsSensFadType instanceVar_An=in.An;
    AdmsSensFadType instanceVar_Bn=in.Bn;
    AdmsSensFadType instanceVar_Trk=in.Trk;
    AdmsSensFadType instanceVar_Tamb=in.Tamb;
    AdmsSensFadType instanceVar_pow2_2mPE=in.pow2_2mPE;
    AdmsSensFadType instanceVar_pow2_PEm2=in.pow2_PEm2;
    AdmsSensFadType instanceVar_inv_VDE=in.inv_VDE;
    AdmsSensFadType instanceVar_inv_VGZEB_Tr=in.inv_VGZEB_Tr;
    AdmsSensFadType instanceVar_VGZEBOK=in.VGZEBOK;
    AdmsSensFadType instanceVar_invMULT=in.invMULT;
    AdmsSensFadType instanceVar_SCRCV_M=in.SCRCV_M;
    AdmsSensFadType instanceVar_KF_M=in.KF_M;
    AdmsSensFadType instanceVar_KFN_M=in.KFN_M;
    AdmsSensFadType instanceVar_CTH_M=in.CTH_M;
    AdmsSensFadType instanceVar_Xext1=in.Xext1;
    AdmsSensFadType instanceVar_CBEO_M=in.CBEO_M;
    AdmsSensFadType instanceVar_CBCO_M=in.CBCO_M;
    AdmsSensFadType instanceVar_dxa=in.dxa;

  
    //non-reals
  
  
  
    Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

    // extract solution variables and set as Fad independent variables.
    probeVars[in.admsProbeID_V_noi_GND] = (*solVectorPtr)[in.li_noi];
    probeVars[in.admsProbeID_V_c3_c1] = (*solVectorPtr)[in.li_c3] - (*solVectorPtr)[in.li_c1];
    probeVars[in.admsProbeID_V_c3_c4] = (*solVectorPtr)[in.li_c3] - (*solVectorPtr)[in.li_c4];
    probeVars[in.admsProbeID_V_c4_c1] = (*solVectorPtr)[in.li_c4] - (*solVectorPtr)[in.li_c1];
    probeVars[in.admsProbeID_V_b_c] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_c];
    probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_e];
    probeVars[in.admsProbeID_V_b_b1] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_b1];
    probeVars[in.admsProbeID_V_e_e1] = (*solVectorPtr)[in.li_e] - (*solVectorPtr)[in.li_e1];
    probeVars[in.admsProbeID_V_c1_c2] = (*solVectorPtr)[in.li_c1] - (*solVectorPtr)[in.li_c2];
    probeVars[in.admsProbeID_V_s_c1] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_c1];
    probeVars[in.admsProbeID_V_b1_b2] = (*solVectorPtr)[in.li_b1] - (*solVectorPtr)[in.li_b2];
    probeVars[in.admsProbeID_V_b1_e1] = (*solVectorPtr)[in.li_b1] - (*solVectorPtr)[in.li_e1];
    probeVars[in.admsProbeID_V_b2_e1] = (*solVectorPtr)[in.li_b2] - (*solVectorPtr)[in.li_e1];
    probeVars[in.admsProbeID_V_b2_c2] = (*solVectorPtr)[in.li_b2] - (*solVectorPtr)[in.li_c2];
    probeVars[in.admsProbeID_V_b2_c1] = (*solVectorPtr)[in.li_b2] - (*solVectorPtr)[in.li_c1];
    probeVars[in.admsProbeID_V_dt_GND] = (*solVectorPtr)[in.li_dt];

    
    // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
    probeVars[in.admsProbeID_V_b1_b2] *= modelPar_TYPE;
    probeVars[in.admsProbeID_V_b1_e1] *= modelPar_TYPE;
    probeVars[in.admsProbeID_V_b2_c2] *= modelPar_TYPE;
    probeVars[in.admsProbeID_V_b2_c1] *= modelPar_TYPE;


    evaluateInitialInstance(
       // instance parameters
       // reals
       instancePar_MULT,
       instancePar_given_MULT,
       // instance variables
       // reals
       instanceVar_An,
       instanceVar_Bn,
       instanceVar_Trk,
       instanceVar_Tamb,
       instanceVar_pow2_2mPE,
       instanceVar_pow2_PEm2,
       instanceVar_inv_VDE,
       instanceVar_inv_VGZEB_Tr,
       instanceVar_VGZEBOK,
       instanceVar_invMULT,
       instanceVar_SCRCV_M,
       instanceVar_KF_M,
       instanceVar_KFN_M,
       instanceVar_CTH_M,
       instanceVar_Xext1,
       instanceVar_CBEO_M,
       instanceVar_CBCO_M,
       instanceVar_dxa,
       // model parameters
       // reals
       modelPar_TREF,
       modelPar_given_TREF,
       modelPar_DTA,
       modelPar_given_DTA,
       modelPar_IS,
       modelPar_given_IS,
       modelPar_IK,
       modelPar_given_IK,
       modelPar_VER,
       modelPar_given_VER,
       modelPar_VEF,
       modelPar_given_VEF,
       modelPar_BF,
       modelPar_given_BF,
       modelPar_IBF,
       modelPar_given_IBF,
       modelPar_MLF,
       modelPar_given_MLF,
       modelPar_XIBI,
       modelPar_given_XIBI,
       modelPar_IZEB,
       modelPar_given_IZEB,
       modelPar_NZEB,
       modelPar_given_NZEB,
       modelPar_BRI,
       modelPar_given_BRI,
       modelPar_IBR,
       modelPar_given_IBR,
       modelPar_VLR,
       modelPar_given_VLR,
       modelPar_XEXT,
       modelPar_given_XEXT,
       modelPar_WAVL,
       modelPar_given_WAVL,
       modelPar_VAVL,
       modelPar_given_VAVL,
       modelPar_SFH,
       modelPar_given_SFH,
       modelPar_RE,
       modelPar_given_RE,
       modelPar_RBC,
       modelPar_given_RBC,
       modelPar_RBV,
       modelPar_given_RBV,
       modelPar_RCC,
       modelPar_given_RCC,
       modelPar_RCV,
       modelPar_given_RCV,
       modelPar_SCRCV,
       modelPar_given_SCRCV,
       modelPar_IHC,
       modelPar_given_IHC,
       modelPar_AXI,
       modelPar_given_AXI,
       modelPar_CJE,
       modelPar_given_CJE,
       modelPar_VDE,
       modelPar_given_VDE,
       modelPar_PE,
       modelPar_given_PE,
       modelPar_XCJE,
       modelPar_given_XCJE,
       modelPar_CBEO,
       modelPar_given_CBEO,
       modelPar_CJC,
       modelPar_given_CJC,
       modelPar_VDC,
       modelPar_given_VDC,
       modelPar_PC,
       modelPar_given_PC,
       modelPar_XP,
       modelPar_given_XP,
       modelPar_MC,
       modelPar_given_MC,
       modelPar_XCJC,
       modelPar_given_XCJC,
       modelPar_RCBLX,
       modelPar_given_RCBLX,
       modelPar_RCBLI,
       modelPar_given_RCBLI,
       modelPar_CBCO,
       modelPar_given_CBCO,
       modelPar_MTAU,
       modelPar_given_MTAU,
       modelPar_TAUE,
       modelPar_given_TAUE,
       modelPar_TAUB,
       modelPar_given_TAUB,
       modelPar_TEPI,
       modelPar_given_TEPI,
       modelPar_TAUR,
       modelPar_given_TAUR,
       modelPar_DEG,
       modelPar_given_DEG,
       modelPar_XREC,
       modelPar_given_XREC,
       modelPar_XQB,
       modelPar_given_XQB,
       modelPar_AQBO,
       modelPar_given_AQBO,
       modelPar_AE,
       modelPar_given_AE,
       modelPar_AB,
       modelPar_given_AB,
       modelPar_AEPI,
       modelPar_given_AEPI,
       modelPar_AEX,
       modelPar_given_AEX,
       modelPar_AC,
       modelPar_given_AC,
       modelPar_ACBL,
       modelPar_given_ACBL,
       modelPar_DVGBF,
       modelPar_given_DVGBF,
       modelPar_DVGBR,
       modelPar_given_DVGBR,
       modelPar_VGB,
       modelPar_given_VGB,
       modelPar_VGC,
       modelPar_given_VGC,
       modelPar_VGJ,
       modelPar_given_VGJ,
       modelPar_VGZEB,
       modelPar_given_VGZEB,
       modelPar_AVGEB,
       modelPar_given_AVGEB,
       modelPar_TVGEB,
       modelPar_given_TVGEB,
       modelPar_DVGTE,
       modelPar_given_DVGTE,
       modelPar_DAIS,
       modelPar_given_DAIS,
       modelPar_AF,
       modelPar_given_AF,
       modelPar_KF,
       modelPar_given_KF,
       modelPar_KFN,
       modelPar_given_KFN,
       modelPar_KE,
       modelPar_given_KE,
       modelPar_FTAUN,
       modelPar_given_FTAUN,
       modelPar_ISS,
       modelPar_given_ISS,
       modelPar_ICSS,
       modelPar_given_ICSS,
       modelPar_IKS,
       modelPar_given_IKS,
       modelPar_CJS,
       modelPar_given_CJS,
       modelPar_VDS,
       modelPar_given_VDS,
       modelPar_PS,
       modelPar_given_PS,
       modelPar_VGS,
       modelPar_given_VGS,
       modelPar_AS,
       modelPar_given_AS,
       modelPar_ASUB,
       modelPar_given_ASUB,
       modelPar_RTH,
       modelPar_given_RTH,
       modelPar_CTH,
       modelPar_given_CTH,
       modelPar_ATH,
       modelPar_given_ATH,
       modelPar_MULT,
       modelPar_given_MULT,
       modelPar_GMIN,
       modelPar_given_GMIN,
       // non-reals (including hidden)
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_EXMOD,
       modelPar_given_EXMOD,
       modelPar_EXPHI,
       modelPar_given_EXPHI,
       modelPar_EXAVL,
       modelPar_given_EXAVL,
       modelPar_EXSUB,
       modelPar_given_EXSUB,
       modelPar_KAVL,
       modelPar_given_KAVL,
       modelPar_KC,
       modelPar_given_KC,
       modelPar_TYPE,
       modelPar_given_TYPE,
       in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


    // Now call  the function that does the heavy lifting.

    evaluateModelEquations(
       probeVars,
       // probe constants
       in.admsProbeID_V_noi_GND,
       in.admsProbeID_V_c3_c1,
       in.admsProbeID_V_c3_c4,
       in.admsProbeID_V_c4_c1,
       in.admsProbeID_V_b_c,
       in.admsProbeID_V_b_e,
       in.admsProbeID_V_b_b1,
       in.admsProbeID_V_e_e1,
       in.admsProbeID_V_c1_c2,
       in.admsProbeID_V_s_c1,
       in.admsProbeID_V_b1_b2,
       in.admsProbeID_V_b1_e1,
       in.admsProbeID_V_b2_e1,
       in.admsProbeID_V_b2_c2,
       in.admsProbeID_V_b2_c1,
       in.admsProbeID_V_dt_GND,

       // node constants
       in.admsNodeID_c,
       in.admsNodeID_b,
       in.admsNodeID_e,
       in.admsNodeID_s,
       in.admsNodeID_dt,
       in.admsNodeID_e1,
       in.admsNodeID_b1,
       in.admsNodeID_b2,
       in.admsNodeID_c1,
       in.admsNodeID_c2,
       in.admsNodeID_c3,
       in.admsNodeID_c4,
       in.admsNodeID_noi,
       // instance parameters
       // reals
       instancePar_MULT,
       instancePar_given_MULT,
       // instance variables
       // reals
       instanceVar_An,
       instanceVar_Bn,
       instanceVar_Trk,
       instanceVar_Tamb,
       instanceVar_pow2_2mPE,
       instanceVar_pow2_PEm2,
       instanceVar_inv_VDE,
       instanceVar_inv_VGZEB_Tr,
       instanceVar_VGZEBOK,
       instanceVar_invMULT,
       instanceVar_SCRCV_M,
       instanceVar_KF_M,
       instanceVar_KFN_M,
       instanceVar_CTH_M,
       instanceVar_Xext1,
       instanceVar_CBEO_M,
       instanceVar_CBCO_M,
       instanceVar_dxa,
       // model parameters
       // reals
       modelPar_TREF,
       modelPar_given_TREF,
       modelPar_DTA,
       modelPar_given_DTA,
       modelPar_IS,
       modelPar_given_IS,
       modelPar_IK,
       modelPar_given_IK,
       modelPar_VER,
       modelPar_given_VER,
       modelPar_VEF,
       modelPar_given_VEF,
       modelPar_BF,
       modelPar_given_BF,
       modelPar_IBF,
       modelPar_given_IBF,
       modelPar_MLF,
       modelPar_given_MLF,
       modelPar_XIBI,
       modelPar_given_XIBI,
       modelPar_IZEB,
       modelPar_given_IZEB,
       modelPar_NZEB,
       modelPar_given_NZEB,
       modelPar_BRI,
       modelPar_given_BRI,
       modelPar_IBR,
       modelPar_given_IBR,
       modelPar_VLR,
       modelPar_given_VLR,
       modelPar_XEXT,
       modelPar_given_XEXT,
       modelPar_WAVL,
       modelPar_given_WAVL,
       modelPar_VAVL,
       modelPar_given_VAVL,
       modelPar_SFH,
       modelPar_given_SFH,
       modelPar_RE,
       modelPar_given_RE,
       modelPar_RBC,
       modelPar_given_RBC,
       modelPar_RBV,
       modelPar_given_RBV,
       modelPar_RCC,
       modelPar_given_RCC,
       modelPar_RCV,
       modelPar_given_RCV,
       modelPar_SCRCV,
       modelPar_given_SCRCV,
       modelPar_IHC,
       modelPar_given_IHC,
       modelPar_AXI,
       modelPar_given_AXI,
       modelPar_CJE,
       modelPar_given_CJE,
       modelPar_VDE,
       modelPar_given_VDE,
       modelPar_PE,
       modelPar_given_PE,
       modelPar_XCJE,
       modelPar_given_XCJE,
       modelPar_CBEO,
       modelPar_given_CBEO,
       modelPar_CJC,
       modelPar_given_CJC,
       modelPar_VDC,
       modelPar_given_VDC,
       modelPar_PC,
       modelPar_given_PC,
       modelPar_XP,
       modelPar_given_XP,
       modelPar_MC,
       modelPar_given_MC,
       modelPar_XCJC,
       modelPar_given_XCJC,
       modelPar_RCBLX,
       modelPar_given_RCBLX,
       modelPar_RCBLI,
       modelPar_given_RCBLI,
       modelPar_CBCO,
       modelPar_given_CBCO,
       modelPar_MTAU,
       modelPar_given_MTAU,
       modelPar_TAUE,
       modelPar_given_TAUE,
       modelPar_TAUB,
       modelPar_given_TAUB,
       modelPar_TEPI,
       modelPar_given_TEPI,
       modelPar_TAUR,
       modelPar_given_TAUR,
       modelPar_DEG,
       modelPar_given_DEG,
       modelPar_XREC,
       modelPar_given_XREC,
       modelPar_XQB,
       modelPar_given_XQB,
       modelPar_AQBO,
       modelPar_given_AQBO,
       modelPar_AE,
       modelPar_given_AE,
       modelPar_AB,
       modelPar_given_AB,
       modelPar_AEPI,
       modelPar_given_AEPI,
       modelPar_AEX,
       modelPar_given_AEX,
       modelPar_AC,
       modelPar_given_AC,
       modelPar_ACBL,
       modelPar_given_ACBL,
       modelPar_DVGBF,
       modelPar_given_DVGBF,
       modelPar_DVGBR,
       modelPar_given_DVGBR,
       modelPar_VGB,
       modelPar_given_VGB,
       modelPar_VGC,
       modelPar_given_VGC,
       modelPar_VGJ,
       modelPar_given_VGJ,
       modelPar_VGZEB,
       modelPar_given_VGZEB,
       modelPar_AVGEB,
       modelPar_given_AVGEB,
       modelPar_TVGEB,
       modelPar_given_TVGEB,
       modelPar_DVGTE,
       modelPar_given_DVGTE,
       modelPar_DAIS,
       modelPar_given_DAIS,
       modelPar_AF,
       modelPar_given_AF,
       modelPar_KF,
       modelPar_given_KF,
       modelPar_KFN,
       modelPar_given_KFN,
       modelPar_KE,
       modelPar_given_KE,
       modelPar_FTAUN,
       modelPar_given_FTAUN,
       modelPar_ISS,
       modelPar_given_ISS,
       modelPar_ICSS,
       modelPar_given_ICSS,
       modelPar_IKS,
       modelPar_given_IKS,
       modelPar_CJS,
       modelPar_given_CJS,
       modelPar_VDS,
       modelPar_given_VDS,
       modelPar_PS,
       modelPar_given_PS,
       modelPar_VGS,
       modelPar_given_VGS,
       modelPar_AS,
       modelPar_given_AS,
       modelPar_ASUB,
       modelPar_given_ASUB,
       modelPar_RTH,
       modelPar_given_RTH,
       modelPar_CTH,
       modelPar_given_CTH,
       modelPar_ATH,
       modelPar_given_ATH,
       modelPar_MULT,
       modelPar_given_MULT,
       modelPar_GMIN,
       modelPar_given_GMIN,
       // non-reals (including hidden)
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_EXMOD,
       modelPar_given_EXMOD,
       modelPar_EXPHI,
       modelPar_given_EXPHI,
       modelPar_EXAVL,
       modelPar_given_EXAVL,
       modelPar_EXSUB,
       modelPar_given_EXSUB,
       modelPar_KAVL,
       modelPar_given_KAVL,
       modelPar_KC,
       modelPar_given_KC,
       modelPar_TYPE,
       modelPar_given_TYPE,
       in.admsTemperature,
       in.adms_vt_nom,
       in.getDeviceOptions().gmin,
       staticContributions,
       dynamicContributions,
       in);

  
    // We now have the F and Q vector stuff, populate the dependencies:
  
    dfdp[in.admsNodeID_c+inst*(13+0)] += staticContributions[in.admsNodeID_c].dx(0);
    dqdp[in.admsNodeID_c+inst*(13+0)] += dynamicContributions[in.admsNodeID_c].dx(0);
    Findices[in.admsNodeID_c+inst*(13+0)] = in.li_c;
    Qindices[in.admsNodeID_c+inst*(13+0)] = in.li_c;
    dfdp[in.admsNodeID_b+inst*(13+0)] += staticContributions[in.admsNodeID_b].dx(0);
    dqdp[in.admsNodeID_b+inst*(13+0)] += dynamicContributions[in.admsNodeID_b].dx(0);
    Findices[in.admsNodeID_b+inst*(13+0)] = in.li_b;
    Qindices[in.admsNodeID_b+inst*(13+0)] = in.li_b;
    dfdp[in.admsNodeID_e+inst*(13+0)] += staticContributions[in.admsNodeID_e].dx(0);
    dqdp[in.admsNodeID_e+inst*(13+0)] += dynamicContributions[in.admsNodeID_e].dx(0);
    Findices[in.admsNodeID_e+inst*(13+0)] = in.li_e;
    Qindices[in.admsNodeID_e+inst*(13+0)] = in.li_e;
    dfdp[in.admsNodeID_s+inst*(13+0)] += staticContributions[in.admsNodeID_s].dx(0);
    dqdp[in.admsNodeID_s+inst*(13+0)] += dynamicContributions[in.admsNodeID_s].dx(0);
    Findices[in.admsNodeID_s+inst*(13+0)] = in.li_s;
    Qindices[in.admsNodeID_s+inst*(13+0)] = in.li_s;
    dfdp[in.admsNodeID_dt+inst*(13+0)] += staticContributions[in.admsNodeID_dt].dx(0);
    dqdp[in.admsNodeID_dt+inst*(13+0)] += dynamicContributions[in.admsNodeID_dt].dx(0);
    Findices[in.admsNodeID_dt+inst*(13+0)] = in.li_dt;
    Qindices[in.admsNodeID_dt+inst*(13+0)] = in.li_dt;
    dfdp[in.admsNodeID_e1+inst*(13+0)] += staticContributions[in.admsNodeID_e1].dx(0);
    dqdp[in.admsNodeID_e1+inst*(13+0)] += dynamicContributions[in.admsNodeID_e1].dx(0);
    Findices[in.admsNodeID_e1+inst*(13+0)] = in.li_e1;
    Qindices[in.admsNodeID_e1+inst*(13+0)] = in.li_e1;
    dfdp[in.admsNodeID_b1+inst*(13+0)] += staticContributions[in.admsNodeID_b1].dx(0);
    dqdp[in.admsNodeID_b1+inst*(13+0)] += dynamicContributions[in.admsNodeID_b1].dx(0);
    Findices[in.admsNodeID_b1+inst*(13+0)] = in.li_b1;
    Qindices[in.admsNodeID_b1+inst*(13+0)] = in.li_b1;
    dfdp[in.admsNodeID_b2+inst*(13+0)] += staticContributions[in.admsNodeID_b2].dx(0);
    dqdp[in.admsNodeID_b2+inst*(13+0)] += dynamicContributions[in.admsNodeID_b2].dx(0);
    Findices[in.admsNodeID_b2+inst*(13+0)] = in.li_b2;
    Qindices[in.admsNodeID_b2+inst*(13+0)] = in.li_b2;
    dfdp[in.admsNodeID_c1+inst*(13+0)] += staticContributions[in.admsNodeID_c1].dx(0);
    dqdp[in.admsNodeID_c1+inst*(13+0)] += dynamicContributions[in.admsNodeID_c1].dx(0);
    Findices[in.admsNodeID_c1+inst*(13+0)] = in.li_c1;
    Qindices[in.admsNodeID_c1+inst*(13+0)] = in.li_c1;
    dfdp[in.admsNodeID_c2+inst*(13+0)] += staticContributions[in.admsNodeID_c2].dx(0);
    dqdp[in.admsNodeID_c2+inst*(13+0)] += dynamicContributions[in.admsNodeID_c2].dx(0);
    Findices[in.admsNodeID_c2+inst*(13+0)] = in.li_c2;
    Qindices[in.admsNodeID_c2+inst*(13+0)] = in.li_c2;
    dfdp[in.admsNodeID_c3+inst*(13+0)] += staticContributions[in.admsNodeID_c3].dx(0);
    dqdp[in.admsNodeID_c3+inst*(13+0)] += dynamicContributions[in.admsNodeID_c3].dx(0);
    Findices[in.admsNodeID_c3+inst*(13+0)] = in.li_c3;
    Qindices[in.admsNodeID_c3+inst*(13+0)] = in.li_c3;
    dfdp[in.admsNodeID_c4+inst*(13+0)] += staticContributions[in.admsNodeID_c4].dx(0);
    dqdp[in.admsNodeID_c4+inst*(13+0)] += dynamicContributions[in.admsNodeID_c4].dx(0);
    Findices[in.admsNodeID_c4+inst*(13+0)] = in.li_c4;
    Qindices[in.admsNodeID_c4+inst*(13+0)] = in.li_c4;
    dfdp[in.admsNodeID_noi+inst*(13+0)] += staticContributions[in.admsNodeID_noi].dx(0);
    dqdp[in.admsNodeID_noi+inst*(13+0)] += dynamicContributions[in.admsNodeID_noi].dx(0);
    Findices[in.admsNodeID_noi+inst*(13+0)] = in.li_noi;
    Qindices[in.admsNodeID_noi+inst*(13+0)] = in.li_noi;
  }

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSbjt504tva
} // namespace Device
} // namespace Xyce
