
//-----------------------------------------------------------------------------
// Copyright Notice
//
//   Copyright 2002 Sandia Corporation. Under the terms
//   of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
//   Government retains certain rights in this software.
//
//    Xyce(TM) Parallel Electrical Simulator
//    Copyright (C) 2002-2017 Sandia Corporation
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------------------------

//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file bsimcmg.va with ADMS
//                  interface for Xyce 6.6.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.6
//
// Creation Date  : Tue, 07 Mar 2017 09:13:44
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSbsimcmg_110.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

#include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#if defined(HAVE_UNORDERED_MAP)
#include <unordered_map>
using std::unordered_map;
#elif defined(HAVE_TR1_UNORDERED_MAP)
#include <tr1/unordered_map>
using std::tr1::unordered_map;
#else
#error neither unordered_map or tr1/unordered_map found
#endif

namespace Xyce {
namespace Device {
namespace ADMSbsimcmg_110 {


//This is necessary because the IntPair usage can trip undefined references
const int Instance::admsNodeID_d;
const int Instance::admsNodeID_g;
const int Instance::admsNodeID_s;
const int Instance::admsNodeID_e;
const int Instance::admsNodeID_t;
const int Instance::admsNodeID_si;
const int Instance::admsNodeID_di;
const int Instance::admsNodeID_ge;
const int Instance::admsNodeID_N;
const int Instance::admsNodeID_GND;
// Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSbsimcmg_110::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSbsimcmg_110::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("L", static_cast<double>(3.0e-8), &ADMSbsimcmg_110::Instance::L)
    .setUnit(U_METER)
    .setDescription("Designed gate length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("D", static_cast<double>(4.0e-8), &ADMSbsimcmg_110::Instance::D)
    .setUnit(U_METER)
    .setDescription("Diameter of the cylinder (GEOMOD=3)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TFIN", static_cast<double>(1.5e-8), &ADMSbsimcmg_110::Instance::TFIN)
    .setUnit(U_METER)
    .setDescription("Body (fin) thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FPITCH", static_cast<double>(8.0e-8), &ADMSbsimcmg_110::Instance::FPITCH)
    .setUnit(U_METER)
    .setDescription("Fin pitch")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NF", static_cast<int>(1), &ADMSbsimcmg_110::Instance::NF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers");
  p.addPar("NFIN", static_cast<double>(1.0), &ADMSbsimcmg_110::Instance::NFIN)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fins per finger (real number enables optimization)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NGCON", static_cast<int>(1), &ADMSbsimcmg_110::Instance::NGCON)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of gate contact (1 or 2 sided)");
  p.addPar("ASEO", static_cast<double>(0.0), &ADMSbsimcmg_110::Instance::ASEO)
    .setUnit(U_METER2)
    .setDescription("Source-to-substrate overlap area through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ADEO", static_cast<double>(0.0), &ADMSbsimcmg_110::Instance::ADEO)
    .setUnit(U_METER2)
    .setDescription("Drain-to-substrate overlap area through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSEO", static_cast<double>(0.0), &ADMSbsimcmg_110::Instance::PSEO)
    .setUnit(U_METER)
    .setDescription("Perimeter of source-to-substrate overlap region through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDEO", static_cast<double>(0.0), &ADMSbsimcmg_110::Instance::PDEO)
    .setUnit(U_METER)
    .setDescription("Perimeter of drain-to-substrate overlap region through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ASEJ", static_cast<double>(0.0), &ADMSbsimcmg_110::Instance::ASEJ)
    .setUnit(U_METER2)
    .setDescription("Source junction area (BULKMOD=1 or 2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ADEJ", static_cast<double>(0.0), &ADMSbsimcmg_110::Instance::ADEJ)
    .setUnit(U_METER2)
    .setDescription("Drain junction area (BULKMOD=1 or 2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSEJ", static_cast<double>(0.0), &ADMSbsimcmg_110::Instance::PSEJ)
    .setUnit(U_METER)
    .setDescription("Source-to-substrate PN junction perimeter (BULKMOD=1 or 2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDEJ", static_cast<double>(0.0), &ADMSbsimcmg_110::Instance::PDEJ)
    .setUnit(U_METER)
    .setDescription("Drain-to-substrate PN junction perimeter (BULKMOD=1 or 2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("COVS", static_cast<double>(0.0), &ADMSbsimcmg_110::Instance::COVS)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant gate-to-source overlap capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("COVD", 0.0, &ADMSbsimcmg_110::Instance::COVD)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant gate-to-drain overlap capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGSP", static_cast<double>(0.0), &ADMSbsimcmg_110::Instance::CGSP)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant gate-to-source fringe capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGDP", static_cast<double>(0.0), &ADMSbsimcmg_110::Instance::CGDP)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant gate-to-drain fringe capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSP", static_cast<double>(0.0), &ADMSbsimcmg_110::Instance::CDSP)
    .setUnit(U_FARAD)
    .setDescription("Constant drain-to-source fringe capacitance (all CGEOMOD)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NRS", static_cast<double>(0.0), &ADMSbsimcmg_110::Instance::NRS)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of source diffusion squares")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NRD", static_cast<double>(0.0), &ADMSbsimcmg_110::Instance::NRD)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of source diffusion squares")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LRSD", 0.0, &ADMSbsimcmg_110::Instance::LRSD)
    .setUnit(U_METER)
    .setDescription("Length of the source/drain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFINNOM", static_cast<double>(1.0), &ADMSbsimcmg_110::Instance::NFINNOM)
    .setUnit(U_UNKNOWN)
    .setDescription("Nominal number of fins per finger")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("M", static_cast<double>(1.0), &ADMSbsimcmg_110::Instance::m)
    .setUnit(U_UNKNOWN)
    .setDescription("multiplicity factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;


}

void Traits::loadModelParameters(ParametricData<ADMSbsimcmg_110::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSbsimcmg_110::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("L", static_cast<double>(3.0e-8), &ADMSbsimcmg_110::Model::L)
    .setUnit(U_METER)
    .setDescription("Designed gate length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("D", static_cast<double>(4.0e-8), &ADMSbsimcmg_110::Model::D)
    .setUnit(U_METER)
    .setDescription("Diameter of the cylinder (GEOMOD=3)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TFIN", static_cast<double>(1.5e-8), &ADMSbsimcmg_110::Model::TFIN)
    .setUnit(U_METER)
    .setDescription("Body (fin) thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FPITCH", static_cast<double>(8.0e-8), &ADMSbsimcmg_110::Model::FPITCH)
    .setUnit(U_METER)
    .setDescription("Fin pitch")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NF", static_cast<int>(1), &ADMSbsimcmg_110::Model::NF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers");
  p.addPar("NFIN", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::NFIN)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fins per finger (real number enables optimization)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NGCON", static_cast<int>(1), &ADMSbsimcmg_110::Model::NGCON)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of gate contact (1 or 2 sided)");
  p.addPar("ASEO", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ASEO)
    .setUnit(U_METER2)
    .setDescription("Source-to-substrate overlap area through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ADEO", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ADEO)
    .setUnit(U_METER2)
    .setDescription("Drain-to-substrate overlap area through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSEO", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PSEO)
    .setUnit(U_METER)
    .setDescription("Perimeter of source-to-substrate overlap region through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDEO", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PDEO)
    .setUnit(U_METER)
    .setDescription("Perimeter of drain-to-substrate overlap region through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ASEJ", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ASEJ)
    .setUnit(U_METER2)
    .setDescription("Source junction area (BULKMOD=1 or 2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ADEJ", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ADEJ)
    .setUnit(U_METER2)
    .setDescription("Drain junction area (BULKMOD=1 or 2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSEJ", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PSEJ)
    .setUnit(U_METER)
    .setDescription("Source-to-substrate PN junction perimeter (BULKMOD=1 or 2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDEJ", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PDEJ)
    .setUnit(U_METER)
    .setDescription("Drain-to-substrate PN junction perimeter (BULKMOD=1 or 2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("COVS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::COVS)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant gate-to-source overlap capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("COVD", 0.0, &ADMSbsimcmg_110::Model::COVD)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant gate-to-drain overlap capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGSP", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CGSP)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant gate-to-source fringe capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGDP", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CGDP)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant gate-to-drain fringe capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSP", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CDSP)
    .setUnit(U_FARAD)
    .setDescription("Constant drain-to-source fringe capacitance (all CGEOMOD)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NRS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NRS)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of source diffusion squares")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NRD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NRD)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of source diffusion squares")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LRSD", 0.0, &ADMSbsimcmg_110::Model::LRSD)
    .setUnit(U_METER)
    .setDescription("Length of the source/drain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::XL)
    .setUnit(U_METER)
    .setDescription("L offset for channel length due to mask/etch effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DTEMP", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DTEMP)
    .setUnit(U_DEGC)
    .setDescription("Variability in device temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELVTRAND", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DELVTRAND)
    .setUnit(U_VOLT)
    .setDescription("Variability in Vth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("U0MULT", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::U0MULT)
    .setUnit(U_UNKNOWN)
    .setDescription("Variability in carrier mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDS0MULT", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::IDS0MULT)
    .setUnit(U_UNKNOWN)
    .setDescription("Variability in drain current for miscellaneous reasons")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DEVTYPE", static_cast<int>(1), &ADMSbsimcmg_110::Model::DEVTYPE)
    .setUnit(U_UNKNOWN)
    .setDescription("0: PMOS; 1: NMOS");
  p.addPar("TYPE", 0, &ADMSbsimcmg_110::Model::TYPE)
    .setUnit(U_UNKNOWN)
    .setDescription("0: PMOS; 1: NMOS");
  p.addPar("BULKMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::BULKMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: SOI multi-gate; 1: Bulk multi-gate; 2: for decoupled bulk multi-gate");
  p.addPar("GEOMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::GEOMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Double gate; 1: Triple gate; 2: Quadruple gate; 3: Cylindrical gate; 4: Unified fin Shape");
  p.addPar("CGEO1SW", static_cast<int>(0), &ADMSbsimcmg_110::Model::CGEO1SW)
    .setUnit(U_UNKNOWN)
    .setDescription("For CGEOMOD=1 only, this switch enables the parameters COVS, COVD, CGSP, and CGDP to be in F per fin, per gate-finger, per unit channel width");
  p.addPar("RDSMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::RDSMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Internal S/D resistance model; 1: External S/D resistance model; 2: Both bias dependent and independent part of S/D resistance internal");
  p.addPar("ASYMMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::ASYMMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Turn off asymmetry model - forward mode parameters used; 1: Turn on asymmetry model");
  p.addPar("IGCMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::IGCMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Turn off Igc, Igs and Igd; 1: Turn on Igc, Igs and Igd");
  p.addPar("IGBMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::IGBMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Turn off Igb; 1: Turn on Igb");
  p.addPar("GIDLMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::GIDLMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Turn off GIDL/GISL current; 1: Turn on GIDL/GISL current");
  p.addPar("IIMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::IIMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Turn off impact ionization current; 1: BSIM4-based model; 2: BSIMSOI-based model");
  p.addPar("TNOIMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::TNOIMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Charge-based, 1: Correlated thermal noise model");
  p.addPar("NQSMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::NQSMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Turn off NQS model; 1: NQS gate resistance (with gi node); 2: NQS charge deficit model from BSIM4 (with q node)");
  p.addPar("SHMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::SHMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Turn off self-heating; 1: Turn on self-heating");
  p.addPar("TEMPMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::TEMPMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("1: Change temperature dependence of specific parameters");
  p.addPar("RGATEMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::RGATEMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Turn off gate electrode resistance (without ge node); 1: Turn on gate electrode resistance (with ge node)");
  p.addPar("RGEOMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::RGEOMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry-dependent source/drain resistance; 0: RSH-based; 1: Holistic");
  p.addPar("CGEOMOD", static_cast<int>(0), &ADMSbsimcmg_110::Model::CGEOMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry-dependent parasitic capacitance model selector");
  p.addPar("SH_WARN", static_cast<int>(0), &ADMSbsimcmg_110::Model::SH_WARN)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Disable self-heating warnings; 1: Enable self-heating warnings");
  p.addPar("IGCLAMP", static_cast<int>(1), &ADMSbsimcmg_110::Model::IGCLAMP)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Disable gate current clamps; 1: Enable gate current clamps");
  p.addPar("LINT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LINT)
    .setUnit(U_METER)
    .setDescription("Length reduction parameter (dopant diffusion effect)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length reduction parameter (dopant diffusion effect)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LLN", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::LLN)
    .setUnit(U_UNKNOWN)
    .setDescription("Length reduction parameter (dopant diffusion effect)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DLC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DLC)
    .setUnit(U_METER)
    .setDescription("Delta L for C-V model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DLCACC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DLCACC)
    .setUnit(U_METER)
    .setDescription("Delta L for C-V model in accumulation region (BULKMOD=1 or 2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DLBIN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DLBIN)
    .setUnit(U_METER)
    .setDescription("Delta L for binning")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LLC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LLC)
    .setUnit(U_UNKNOWN)
    .setDescription("Length reduction parameter (dopant diffusion effect)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EOT", static_cast<double>(1.0e-9), &ADMSbsimcmg_110::Model::EOT)
    .setUnit(U_METER)
    .setDescription("Equivalent oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOXP", static_cast<double>(1.2e-9), &ADMSbsimcmg_110::Model::TOXP)
    .setUnit(U_METER)
    .setDescription("Physical oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EOTBOX", static_cast<double>(1.4e-7), &ADMSbsimcmg_110::Model::EOTBOX)
    .setUnit(U_METER)
    .setDescription("Equivalent oxide thickness of the buried oxide (SOI FinFET)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("HFIN", static_cast<double>(3.0e-8), &ADMSbsimcmg_110::Model::HFIN)
    .setUnit(U_METER)
    .setDescription("Fin height")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FECH", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::FECH)
    .setUnit(U_UNKNOWN)
    .setDescription("End-channel factor for different orientation/shape")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTAW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DELTAW)
    .setUnit(U_METER)
    .setDescription("Change of effective width due to shape of fin/cylinder")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FECHCV", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::FECHCV)
    .setUnit(U_UNKNOWN)
    .setDescription("CV end-channel factor for different orientation/shape")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTAWCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DELTAWCV)
    .setUnit(U_METER)
    .setDescription("CV change of effective width due to shape of fin/cylinder")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBODY", static_cast<double>(1.0e22), &ADMSbsimcmg_110::Model::NBODY)
    .setUnit(U_UNKNOWN)
    .setDescription("Channel (body) doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBODYN1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NBODYN1)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of channel (body) doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBODYN2", static_cast<double>(1.0e5), &ADMSbsimcmg_110::Model::NBODYN2)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of channel (body) doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSD", static_cast<double>(2.0e26), &ADMSbsimcmg_110::Model::NSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Source/drain active doping concentration")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIG", static_cast<double>(4.61), &ADMSbsimcmg_110::Model::PHIG)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate workfunction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PHIGL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of gate workfunction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGLT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PHIGLT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coupled NFIN and length dependence of gate workfunction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGN1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PHIGN1)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of gate workfunction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGN2", static_cast<double>(1.0e5), &ADMSbsimcmg_110::Model::PHIGN2)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of gate workfunction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EPSROX", static_cast<double>(3.9), &ADMSbsimcmg_110::Model::EPSROX)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative dielectric constant of the gate dielectric")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EPSRSUB", static_cast<double>(11.9), &ADMSbsimcmg_110::Model::EPSRSUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative dielectric constant of the channel material")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EASUB", static_cast<double>(4.05), &ADMSbsimcmg_110::Model::EASUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Electron affinity of substrate")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NI0SUB", static_cast<double>(1.1e16), &ADMSbsimcmg_110::Model::NI0SUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Intrinsic carrier constant at 300.15K")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BG0SUB", static_cast<double>(1.12), &ADMSbsimcmg_110::Model::BG0SUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Bandgap of substrate at 300.15K")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NC0SUB", static_cast<double>(2.86e25), &ADMSbsimcmg_110::Model::NC0SUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Conduction band density of states")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NGATE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NGATE)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for poly gate doping. For metal gate please set NGATE = 0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IMIN", static_cast<double>(1.0e-15), &ADMSbsimcmg_110::Model::Imin)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Vgs clamping for inversion region calculation in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CIT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CIT)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for interface trap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CITR", 0.0, &ADMSbsimcmg_110::Model::CITR)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for interface trap in reverse mode for asymmetric model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSC", static_cast<double>(7.0e-3), &ADMSbsimcmg_110::Model::CDSC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coupling capacitance between S/D and channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCN1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CDSCN1)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of CDSC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCN2", static_cast<double>(1.0e5), &ADMSbsimcmg_110::Model::CDSCN2)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of CDSC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCD", static_cast<double>(7.0e-3), &ADMSbsimcmg_110::Model::CDSCD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain-bias sensitivity of CDSC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCDN1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CDSCDN1)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of CDSCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCDN2", static_cast<double>(1.0e5), &ADMSbsimcmg_110::Model::CDSCDN2)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of CDSCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCDR", 0.0, &ADMSbsimcmg_110::Model::CDSCDR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode drain-bias sensitivity of CDSC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCDRN1", 0.0, &ADMSbsimcmg_110::Model::CDSCDRN1)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of CDSCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCDRN2", 0.0, &ADMSbsimcmg_110::Model::CDSCDRN2)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of CDSCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVT0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DVT0)
    .setUnit(U_UNKNOWN)
    .setDescription("SCE coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVT1", static_cast<double>(0.6), &ADMSbsimcmg_110::Model::DVT1)
    .setUnit(U_UNKNOWN)
    .setDescription("SCE exponent coefficient. After binning it should be within (0:inf)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVT1SS", 0.0, &ADMSbsimcmg_110::Model::DVT1SS)
    .setUnit(U_UNKNOWN)
    .setDescription("Subthreshold swing exponent coefficient. After binning it should be within (0:inf)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIN", static_cast<double>(0.05), &ADMSbsimcmg_110::Model::PHIN)
    .setUnit(U_VOLT)
    .setDescription("Nonuniform vertical doping effect on surface potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETA0", static_cast<double>(0.6), &ADMSbsimcmg_110::Model::ETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETA0N1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ETA0N1)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of ETA0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETA0N2", static_cast<double>(1.0e5), &ADMSbsimcmg_110::Model::ETA0N2)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of ETA0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETA0LT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ETA0LT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coupled NFIN and length dependence of ETA0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TETA0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::TETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of DIBL coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETA0R", 0.0, &ADMSbsimcmg_110::Model::ETA0R)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode DIBL coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TETA0R", 0.0, &ADMSbsimcmg_110::Model::TETA0R)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of reverse-mode DIBL coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DSUB", static_cast<double>(1.06), &ADMSbsimcmg_110::Model::DSUB)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL exponent coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVTP0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DVTP0)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for drain-induced Vth shift (DITS)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVTP1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DVTP1)
    .setUnit(U_UNKNOWN)
    .setDescription("DITS exponent coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ADVTP0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ADVTP0)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for DITS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BDVTP0", static_cast<double>(1.0e-7), &ADMSbsimcmg_110::Model::BDVTP0)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for DITS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ADVTP1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ADVTP1)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for DVTP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BDVTP1", static_cast<double>(1.0e-7), &ADMSbsimcmg_110::Model::BDVTP1)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for DVTP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVTP2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DVTP2)
    .setUnit(U_UNKNOWN)
    .setDescription("DITS model parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K1RSCE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::K1RSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("K1 for reverse short channel effect calculation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPE0", static_cast<double>(5.0e-9), &ADMSbsimcmg_110::Model::LPE0)
    .setUnit(U_METER)
    .setDescription("Equivalent length of pocket region at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVTSHIFT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DVTSHIFT)
    .setUnit(U_VOLT)
    .setDescription("Vth shift handle")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVTSHIFTR", 0.0, &ADMSbsimcmg_110::Model::DVTSHIFTR)
    .setUnit(U_UNKNOWN)
    .setDescription("Vth shift handle for asymmetric mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THETASCE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::THETASCE)
    .setUnit(U_UNKNOWN)
    .setDescription("Vth roll-off length dependence. If defined by user, it will overwrite Theta_SCE in the code")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THETADIBL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::THETADIBL)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL length dependence. If defined by user, will overwrite Theta_DIBL in the code")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THETASW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::THETASW)
    .setUnit(U_UNKNOWN)
    .setDescription("Subthreshold swing length dependence. If defined by user, it will overwrite Theta_SW in the code")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NVTM", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NVTM)
    .setUnit(U_VOLT)
    .setDescription("Subthreshold swing factor multiplied by Vtm. If defined by user, it will overwrite nVtm in the code")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::K0)
    .setUnit(U_VOLT)
    .setDescription("Lateral NUD voltage parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K01", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::K01)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of lateral NUD voltage parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K0SI", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::K0SI)
    .setUnit(U_UNKNOWN)
    .setDescription("Correction factor for strong inversion used in Mnud. After binning it should be within (0:inf)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K0SI1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::K0SI1)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of K0SI")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2SI", 0.0, &ADMSbsimcmg_110::Model::K2SI)
    .setUnit(U_UNKNOWN)
    .setDescription("Correction factor for strong inversion used in Mob")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2SI1", 0.0, &ADMSbsimcmg_110::Model::K2SI1)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of K2SI")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K0SISAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::K0SISAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Correction factor for strong inversion used in Mnud")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K0SISAT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::K0SISAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of K0SISAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2SISAT", 0.0, &ADMSbsimcmg_110::Model::K2SISAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Correction factor for strong inversion used in Mob")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2SISAT1", 0.0, &ADMSbsimcmg_110::Model::K2SISAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of K2SISAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIBE", static_cast<double>(0.7), &ADMSbsimcmg_110::Model::PHIBE)
    .setUnit(U_VOLT)
    .setDescription("Body effect voltage parameter. After binning it should be within [0.2:1.2]")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K1", static_cast<double>(1.0e-6), &ADMSbsimcmg_110::Model::K1)
    .setUnit(U_UNKNOWN)
    .setDescription("Body effect coefficient for subthreshold region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K11", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::K11)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of K1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2SAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::K2SAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Correction factor for K2 in saturation (high Vds)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2SAT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::K2SAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of K2SAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::K2)
    .setUnit(U_UNKNOWN)
    .setDescription("Body effect coefficient for BULKMOD==2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K21", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::K21)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of K2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QMFACTOR", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::QMFACTOR)
    .setUnit(U_UNKNOWN)
    .setDescription("Prefactor + switch for QM Vth correction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QMTCENCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::QMTCENCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Prefactor + switch for QM Width and Toxeff correction for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QMTCENCVA", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::QMTCENCVA)
    .setUnit(U_UNKNOWN)
    .setDescription("Prefactor + switch for QM Width and Toxeff correction for CV (accumulation region)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AQMTCEN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::AQMTCEN)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for geometric dependence of Tcen on R/TFIN/HFIN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BQMTCEN", static_cast<double>(1.2e-8), &ADMSbsimcmg_110::Model::BQMTCEN)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for geometric dependence of Tcen on R/TFIN/HFIN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETAQM", static_cast<double>(0.54), &ADMSbsimcmg_110::Model::ETAQM)
    .setUnit(U_UNKNOWN)
    .setDescription("Bulk charge coefficient for Tcen")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QM0", static_cast<double>(1.0e-3), &ADMSbsimcmg_110::Model::QM0)
    .setUnit(U_VOLT)
    .setDescription("Knee-point for Tcen in inversion (Charge normalized to Cox)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PQM", static_cast<double>(0.66), &ADMSbsimcmg_110::Model::PQM)
    .setUnit(U_UNKNOWN)
    .setDescription("Slope of normalized Tcen in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QM0ACC", static_cast<double>(1.0e-3), &ADMSbsimcmg_110::Model::QM0ACC)
    .setUnit(U_VOLT)
    .setDescription("Knee-point for Tcen in accumulation (Charge normalized to Cox)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PQMACC", static_cast<double>(0.66), &ADMSbsimcmg_110::Model::PQMACC)
    .setUnit(U_UNKNOWN)
    .setDescription("Slope of normalized Tcen in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSAT", static_cast<double>(8.5e4), &ADMSbsimcmg_110::Model::VSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation velocity for the saturation region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATR", 0.0, &ADMSbsimcmg_110::Model::VSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation velocity for the saturation region in the reverse mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATN1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::VSATN1)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATN2", static_cast<double>(1.0e5), &ADMSbsimcmg_110::Model::VSATN2)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATRN1", 0.0, &ADMSbsimcmg_110::Model::VSATRN1)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of VSATR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATRN2", 0.0, &ADMSbsimcmg_110::Model::VSATRN2)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of VSATR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AVSAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::AVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BVSAT", static_cast<double>(1.0e-7), &ADMSbsimcmg_110::Model::BVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSAT1", 0.0, &ADMSbsimcmg_110::Model::VSAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("Velocity saturation parameter for Ion degradation - forward mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSAT1N1", 0.0, &ADMSbsimcmg_110::Model::VSAT1N1)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of VSAT1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSAT1N2", 0.0, &ADMSbsimcmg_110::Model::VSAT1N2)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of VSAT1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSAT1R", 0.0, &ADMSbsimcmg_110::Model::VSAT1R)
    .setUnit(U_UNKNOWN)
    .setDescription("Velocity saturation parameter for Ion degradation - reverse mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSAT1RN1", 0.0, &ADMSbsimcmg_110::Model::VSAT1RN1)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of VSAT1R")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSAT1RN2", 0.0, &ADMSbsimcmg_110::Model::VSAT1RN2)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of VSAT1R")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AVSAT1", 0.0, &ADMSbsimcmg_110::Model::AVSAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for VSAT1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BVSAT1", 0.0, &ADMSbsimcmg_110::Model::BVSAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for VSAT1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTAVSAT", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::DELTAVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("velocity saturation parameter in the linear region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSAT", static_cast<double>(2.0), &ADMSbsimcmg_110::Model::PSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Velocity saturation exponent, after binnig should be from [2.0:inf)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("APSAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::APSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for PSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BPSAT", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::BPSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for PSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KSATIV", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::KSATIV)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for long channel Vdsat")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KSATIVR", 0.0, &ADMSbsimcmg_110::Model::KSATIVR)
    .setUnit(U_UNKNOWN)
    .setDescription("KSATIV in asymmetric mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATCV", 0.0, &ADMSbsimcmg_110::Model::VSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Velocity saturation parameter for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AVSATCV", 0.0, &ADMSbsimcmg_110::Model::AVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for VSATCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BVSATCV", 0.0, &ADMSbsimcmg_110::Model::BVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for VSATCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTAVSATCV", 0.0, &ADMSbsimcmg_110::Model::DELTAVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Velocity saturation parameter in the linear region for the capacitance model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSATCV", 0.0, &ADMSbsimcmg_110::Model::PSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Velocity saturation exponent for C-V")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("APSATCV", 0.0, &ADMSbsimcmg_110::Model::APSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for PSATCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BPSATCV", 0.0, &ADMSbsimcmg_110::Model::BPSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for PSATCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEXP", static_cast<double>(4.0), &ADMSbsimcmg_110::Model::MEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Smoothing function factor for Vdsat")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AMEXP", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::AMEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for MEXP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BMEXP", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::BMEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for MEXP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEXPR", 0.0, &ADMSbsimcmg_110::Model::MEXPR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode smoothing function factor for Vdsat")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AMEXPR", 0.0, &ADMSbsimcmg_110::Model::AMEXPR)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for MEXPR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BMEXPR", 0.0, &ADMSbsimcmg_110::Model::BMEXPR)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for MEXPR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTWG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PTWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Gmsat degradation parameter - forward mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTWGR", 0.0, &ADMSbsimcmg_110::Model::PTWGR)
    .setUnit(U_UNKNOWN)
    .setDescription("Gmsat degradation parameter - reverse mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("APTWG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::APTWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for PTWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BPTWG", static_cast<double>(1.0e-7), &ADMSbsimcmg_110::Model::BPTWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for PTWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AT", static_cast<double>((-1.56e-3)), &ADMSbsimcmg_110::Model::AT)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation velocity temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ATR", 0.0, &ADMSbsimcmg_110::Model::ATR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode saturation velocity temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ATCV", 0.0, &ADMSbsimcmg_110::Model::ATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation velocity temperature coefficient for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TMEXP", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::TMEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for Vdseff smoothing")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TMEXPR", 0.0, &ADMSbsimcmg_110::Model::TMEXPR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode temperature coefficient for Vdseff smoothing")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTWGT", static_cast<double>(4.0e-3), &ADMSbsimcmg_110::Model::PTWGT)
    .setUnit(U_UNKNOWN)
    .setDescription("PTWG temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("U0", static_cast<double>(3.0e-2), &ADMSbsimcmg_110::Model::U0)
    .setUnit(U_UNKNOWN)
    .setDescription("Low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("U0R", 0.0, &ADMSbsimcmg_110::Model::U0R)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("U0N1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::U0N1)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of U0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("U0N1R", 0.0, &ADMSbsimcmg_110::Model::U0N1R)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode NFIN dependence of U0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("U0N2", static_cast<double>(1.0e5), &ADMSbsimcmg_110::Model::U0N2)
    .setUnit(U_UNKNOWN)
    .setDescription("NFIN dependence of U0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("U0N2R", 0.0, &ADMSbsimcmg_110::Model::U0N2R)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode NFIN dependence of U0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("U0LT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::U0LT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coupled NFIN and length dependence of U0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETAMOB", static_cast<double>(2.0), &ADMSbsimcmg_110::Model::ETAMOB)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective field parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UP", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::UP)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility L coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPA", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::LPA)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility L power coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UPR", 0.0, &ADMSbsimcmg_110::Model::UPR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode mobility L coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPAR", 0.0, &ADMSbsimcmg_110::Model::LPAR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode mobility L power coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UA", static_cast<double>(0.3), &ADMSbsimcmg_110::Model::UA)
    .setUnit(U_UNKNOWN)
    .setDescription("Phonon/surface roughness scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UAR", 0.0, &ADMSbsimcmg_110::Model::UAR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode phonon/surface roughness scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AUA", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::AUA)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AUAR", 0.0, &ADMSbsimcmg_110::Model::AUAR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode pre-exponential coefficient for UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BUA", static_cast<double>(1.0e-7), &ADMSbsimcmg_110::Model::BUA)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BUAR", 0.0, &ADMSbsimcmg_110::Model::BUAR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode exponential coefficient for UAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::UC)
    .setUnit(U_UNKNOWN)
    .setDescription("Body effect for mobility degradation parameter - BULKMOD=1 or 2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UCR", 0.0, &ADMSbsimcmg_110::Model::UCR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode body effect for mobility degradation parameter - BULKMOD=1 or 2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EU", static_cast<double>(2.5), &ADMSbsimcmg_110::Model::EU)
    .setUnit(U_UNKNOWN)
    .setDescription("Phonon/surface roughness scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EUR", 0.0, &ADMSbsimcmg_110::Model::EUR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode phonon/surface roughness scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AEU", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::AEU)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AEUR", 0.0, &ADMSbsimcmg_110::Model::AEUR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode pre-exponential coefficient for EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BEU", static_cast<double>(1.0e-7), &ADMSbsimcmg_110::Model::BEU)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BEUR", 0.0, &ADMSbsimcmg_110::Model::BEUR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode exponential coefficient for EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::UD)
    .setUnit(U_UNKNOWN)
    .setDescription("Columbic scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UDR", 0.0, &ADMSbsimcmg_110::Model::UDR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode columbic scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AUD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::AUD)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for UD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AUDR", 0.0, &ADMSbsimcmg_110::Model::AUDR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode pre-exponential coefficient for UD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BUD", static_cast<double>(5.0e-8), &ADMSbsimcmg_110::Model::BUD)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for UD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BUDR", 0.0, &ADMSbsimcmg_110::Model::BUDR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode exponential coefficient for UD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UCS", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::UCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Columbic scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UTE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::UTE)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UTER", 0.0, &ADMSbsimcmg_110::Model::UTER)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode for mobility temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UTL", static_cast<double>((-1.5e-3)), &ADMSbsimcmg_110::Model::UTL)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UTLR", 0.0, &ADMSbsimcmg_110::Model::UTLR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode for mobility temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EMOBT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::EMOBT)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of ETAMOB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UA1", static_cast<double>(1.032e-3), &ADMSbsimcmg_110::Model::UA1)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility temperature coefficient for UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UA1R", 0.0, &ADMSbsimcmg_110::Model::UA1R)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode mobility temperature coefficient for UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UC1", static_cast<double>(5.6e-11), &ADMSbsimcmg_110::Model::UC1)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility temperature coefficient for UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UC1R", 0.0, &ADMSbsimcmg_110::Model::UC1R)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode mobility temperature coefficient for UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UD1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::UD1)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility temperature coefficient for UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UD1R", 0.0, &ADMSbsimcmg_110::Model::UD1R)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode mobility temperature coefficient for UD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UCSTE", static_cast<double>((-4.775e-3)), &ADMSbsimcmg_110::Model::UCSTE)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CHARGEWF", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CHARGEWF)
    .setUnit(U_UNKNOWN)
    .setDescription("Average channel charge weighting factor, +1: source-side, 0: middle, -1: drain-side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDSWMIN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::RDSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("RDSMOD = 0 S/D extension resistance per unit width at high Vgs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDSW", static_cast<double>(1.0e2), &ADMSbsimcmg_110::Model::RDSW)
    .setUnit(U_UNKNOWN)
    .setDescription("RDSMOD = 0 zero bias S/D extension resistance per unit width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ARDSW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ARDSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for RDSW")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BRDSW", static_cast<double>(1.0e-7), &ADMSbsimcmg_110::Model::BRDSW)
    .setUnit(U_UNKNOWN)
    .setDescription("exponential coefficient for RDSW")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSWMIN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::RSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("RDSMOD = 1 source extension resistance per unit width at high Vgs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSW", static_cast<double>(5.0e1), &ADMSbsimcmg_110::Model::RSW)
    .setUnit(U_UNKNOWN)
    .setDescription("RDSMOD = 1 zero bias source extension resistance per unit width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ARSW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ARSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for RSW")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BRSW", static_cast<double>(1.0e-7), &ADMSbsimcmg_110::Model::BRSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for RSW")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDWMIN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::RDWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("RDSMOD = 1 drain extension resistance per unit width at high Vgs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDW", static_cast<double>(5.0e1), &ADMSbsimcmg_110::Model::RDW)
    .setUnit(U_UNKNOWN)
    .setDescription("RDSMOD = 1 zero bias drain extension resistance per unit width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ARDW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ARDW)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for RDW")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BRDW", static_cast<double>(1.0e-7), &ADMSbsimcmg_110::Model::BRDW)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for RDW")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSDR", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::RSDR)
    .setUnit(U_UNKNOWN)
    .setDescription("Source-side drift resistance parameter - forward mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSDRR", 0.0, &ADMSbsimcmg_110::Model::RSDRR)
    .setUnit(U_UNKNOWN)
    .setDescription("Source-side drift resistance parameter - reverse mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDDR", 0.0, &ADMSbsimcmg_110::Model::RDDR)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain-side drift resistance parameter - forward mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDDRR", 0.0, &ADMSbsimcmg_110::Model::RDDRR)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain-side drift resistance parameter - reverse mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRSDR", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::PRSDR)
    .setUnit(U_UNKNOWN)
    .setDescription("Source-side quasi-saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRDDR", 0.0, &ADMSbsimcmg_110::Model::PRDDR)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain-side quasi-saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRWGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PRWGS)
    .setUnit(U_VOLTM1)
    .setDescription("Gate bias dependence of source extension resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRWGD", 0.0, &ADMSbsimcmg_110::Model::PRWGD)
    .setUnit(U_VOLTM1)
    .setDescription("Gate bias dependence of drain extension resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WR", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::WR)
    .setUnit(U_UNKNOWN)
    .setDescription("W dependence parameter of S/D extension resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRT", static_cast<double>(1.0e-3), &ADMSbsimcmg_110::Model::PRT)
    .setUnit(U_UNKNOWN)
    .setDescription("Series resistance temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TRSDR", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::TRSDR)
    .setUnit(U_UNKNOWN)
    .setDescription("Source-side drift resistance temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TRDDR", 0.0, &ADMSbsimcmg_110::Model::TRDDR)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain-side drift resistance temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDIBL1", static_cast<double>(1.3), &ADMSbsimcmg_110::Model::PDIBL1)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL output conductance parameter - forward mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDIBL1R", 0.0, &ADMSbsimcmg_110::Model::PDIBL1R)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL output conductance parameter - reverse mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDIBL2", static_cast<double>(2.0e-4), &ADMSbsimcmg_110::Model::PDIBL2)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL output conductance parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDIBL2R", 0.0, &ADMSbsimcmg_110::Model::PDIBL2R)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL output conductance parameter - reverse mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DROUT", static_cast<double>(1.06), &ADMSbsimcmg_110::Model::DROUT)
    .setUnit(U_UNKNOWN)
    .setDescription("L dependence of DIBL effect on Rout")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PVAG", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::PVAG)
    .setUnit(U_UNKNOWN)
    .setDescription("Vgs dependence on early voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCLM", static_cast<double>(1.3e-2), &ADMSbsimcmg_110::Model::PCLM)
    .setUnit(U_UNKNOWN)
    .setDescription("Channel length modulation (CLM) parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCLMR", 0.0, &ADMSbsimcmg_110::Model::PCLMR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse model PCLM parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("APCLM", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::APCLM)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for PCLM")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("APCLMR", 0.0, &ADMSbsimcmg_110::Model::APCLMR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode pre-exponential coefficient for PCLM")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BPCLM", static_cast<double>(1.0e-7), &ADMSbsimcmg_110::Model::BPCLM)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for PCLM")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BPCLMR", 0.0, &ADMSbsimcmg_110::Model::BPCLMR)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse-mode exponential coefficient for PCLM")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCLMG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCLMG)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate bias dependence parameter for CLM")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCLMCV", 0.0, &ADMSbsimcmg_110::Model::PCLMCV)
    .setUnit(U_UNKNOWN)
    .setDescription("CLM parameter for short-channel CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::A1)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-saturation effect parameter for strong inversion Region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A11", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::A11)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::A2)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-saturation effect parameter for moderate Inversion Region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A21", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::A21)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of A2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RGEXT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::RGEXT)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective gate electrode external resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RGFIN", static_cast<double>(1.0e-3), &ADMSbsimcmg_110::Model::RGFIN)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective gate electrode per finger per fin resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSHS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::RSHS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source-side sheet resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSHD", 0.0, &ADMSbsimcmg_110::Model::RSHD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain-side sheet resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("HEPI", static_cast<double>(1.0e-8), &ADMSbsimcmg_110::Model::HEPI)
    .setUnit(U_METER)
    .setDescription("Height of the raised source/drain on top of the fin")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TSILI", static_cast<double>(1.0e-8), &ADMSbsimcmg_110::Model::TSILI)
    .setUnit(U_METER)
    .setDescription("Thickness of the silicide on top of the raised source/drain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RHOC", static_cast<double>(1.0e-12), &ADMSbsimcmg_110::Model::RHOC)
    .setUnit(U_UNKNOWN)
    .setDescription("Contact resistivity at the silicon/silicide interface")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RHORSD", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::RHORSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Average resistivity of silicon in the raised source/drain region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CRATIO", static_cast<double>(0.5), &ADMSbsimcmg_110::Model::CRATIO)
    .setUnit(U_UNKNOWN)
    .setDescription("Ratio of the corner area filled with silicon to the total corner area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTAPRSD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DELTAPRSD)
    .setUnit(U_METER)
    .setDescription("Change in silicon/silicide interface length due to non-rectangular epi")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SDTERM", static_cast<int>(0), &ADMSbsimcmg_110::Model::SDTERM)
    .setUnit(U_UNKNOWN)
    .setDescription("Indicator of whether the source/drain are terminated with silicide");
  p.addPar("LSP", 0.0, &ADMSbsimcmg_110::Model::LSP)
    .setUnit(U_METER)
    .setDescription("Thickness of the gate sidewall spacer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EPSRSP", static_cast<double>(3.9), &ADMSbsimcmg_110::Model::EPSRSP)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative dielectric constant of the spacer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TGATE", static_cast<double>(3.0e-8), &ADMSbsimcmg_110::Model::TGATE)
    .setUnit(U_METER)
    .setDescription("Gate height on top of the hard mask")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TMASK", static_cast<double>(3.0e-8), &ADMSbsimcmg_110::Model::TMASK)
    .setUnit(U_METER)
    .setDescription("Height of hard mask on top of the fin")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ASILIEND", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ASILIEND)
    .setUnit(U_METER2)
    .setDescription("Extra silicide cross sectional area at the two ends of the FinFET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ARSDEND", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ARSDEND)
    .setUnit(U_METER2)
    .setDescription("Extra raised source/drain cross sectional areaat the two ends of the FinFET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRSDEND", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PRSDEND)
    .setUnit(U_METER)
    .setDescription("Extra silicon/silicide interface perimeter at the two ends of the FinFET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSDE", static_cast<double>(2.0e25), &ADMSbsimcmg_110::Model::NSDE)
    .setUnit(U_UNKNOWN)
    .setDescription("Source/drain active doping concentration at Leff edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RGEOA", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::RGEOA)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for RGEOMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RGEOB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::RGEOB)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for RGEOMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RGEOC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::RGEOC)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for RGEOMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RGEOD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::RGEOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for RGEOMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RGEOE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::RGEOE)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for RGEOMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGEOA", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::CGEOA)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for CGEOMOD=2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGEOB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CGEOB)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for CGEOMOD=2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGEOC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CGEOC)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for CGEOMOD=2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGEOD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CGEOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for CGEOMOD=2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGEOE", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::CGEOE)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for CGEOMOD=2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGBINV", static_cast<double>(1.11e-2), &ADMSbsimcmg_110::Model::AIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGBINV1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::AIGBINV1)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BIGBINV", static_cast<double>(9.49e-4), &ADMSbsimcmg_110::Model::BIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CIGBINV", static_cast<double>(6.0e-3), &ADMSbsimcmg_110::Model::CIGBINV)
    .setUnit(U_VOLTM1)
    .setDescription("Parameter for Igb in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EIGBINV", static_cast<double>(1.1), &ADMSbsimcmg_110::Model::EIGBINV)
    .setUnit(U_VOLT)
    .setDescription("Parameter for Igb in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NIGBINV", static_cast<double>(3.0), &ADMSbsimcmg_110::Model::NIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGBACC", static_cast<double>(1.36e-2), &ADMSbsimcmg_110::Model::AIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGBACC1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::AIGBACC1)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BIGBACC", static_cast<double>(1.71e-3), &ADMSbsimcmg_110::Model::BIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CIGBACC", static_cast<double>(7.5e-2), &ADMSbsimcmg_110::Model::CIGBACC)
    .setUnit(U_VOLTM1)
    .setDescription("Parameter for Igb in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NIGBACC", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::NIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGC", static_cast<double>(1.36e-2), &ADMSbsimcmg_110::Model::AIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igc in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGC1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::AIGC1)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igc in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BIGC", static_cast<double>(1.71e-3), &ADMSbsimcmg_110::Model::BIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igc in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CIGC", static_cast<double>(7.5e-2), &ADMSbsimcmg_110::Model::CIGC)
    .setUnit(U_VOLTM1)
    .setDescription("Parameter for Igc in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PIGCD", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::PIGCD)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igc partition")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DLCIGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DLCIGS)
    .setUnit(U_METER)
    .setDescription("Delta L for Igs model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGS", static_cast<double>(1.36e-2), &ADMSbsimcmg_110::Model::AIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGS1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::AIGS1)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BIGS", static_cast<double>(1.71e-3), &ADMSbsimcmg_110::Model::BIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CIGS", static_cast<double>(7.5e-2), &ADMSbsimcmg_110::Model::CIGS)
    .setUnit(U_VOLTM1)
    .setDescription("Parameter for Igs in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DLCIGD", 0.0, &ADMSbsimcmg_110::Model::DLCIGD)
    .setUnit(U_METER)
    .setDescription("Delta L for Igd model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGD", 0.0, &ADMSbsimcmg_110::Model::AIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igd in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGD1", 0.0, &ADMSbsimcmg_110::Model::AIGD1)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igd in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BIGD", 0.0, &ADMSbsimcmg_110::Model::BIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igd in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CIGD", 0.0, &ADMSbsimcmg_110::Model::CIGD)
    .setUnit(U_VOLTM1)
    .setDescription("Parameter for Igd in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBSD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::VFBSD)
    .setUnit(U_VOLT)
    .setDescription("Flatband voltage for S/D region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBSDCV", 0.0, &ADMSbsimcmg_110::Model::VFBSDCV)
    .setUnit(U_VOLT)
    .setDescription("Flatband voltage for S/D region for C-V calculations")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOXREF", static_cast<double>(1.2e-9), &ADMSbsimcmg_110::Model::TOXREF)
    .setUnit(U_METER)
    .setDescription("Target tox value")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOXG", 0.0, &ADMSbsimcmg_110::Model::TOXG)
    .setUnit(U_METER)
    .setDescription("Oxide thickness for gate current model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NTOX", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::NTOX)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for Tox ratio")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POXEDGE", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::POXEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Factor for the gate edge Tox")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AGISL", static_cast<double>(6.055e-12), &ADMSbsimcmg_110::Model::AGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BGISL", static_cast<double>(3.0e8), &ADMSbsimcmg_110::Model::BGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGISL", static_cast<double>(0.5), &ADMSbsimcmg_110::Model::CGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for body-effect of GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EGISL", static_cast<double>(0.2), &ADMSbsimcmg_110::Model::EGISL)
    .setUnit(U_VOLT)
    .setDescription("Band bending parameter for GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PGISL", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::PGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for body-bias effect on GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AGIDL", 0.0, &ADMSbsimcmg_110::Model::AGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-exponential coefficient for GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BGIDL", 0.0, &ADMSbsimcmg_110::Model::BGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponential coefficient for GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGIDL", 0.0, &ADMSbsimcmg_110::Model::CGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for body-effect of GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EGIDL", 0.0, &ADMSbsimcmg_110::Model::EGIDL)
    .setUnit(U_VOLT)
    .setDescription("Band bending parameter for GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PGIDL", 0.0, &ADMSbsimcmg_110::Model::PGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for body-bias effect on GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHA0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ALPHA0)
    .setUnit(U_MVM1)
    .setDescription("First parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHA01", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ALPHA01)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of ALPHA0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHA1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ALPHA1)
    .setUnit(U_VOLTM1)
    .setDescription("L scaling parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHA11", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ALPHA11)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence ALPHA1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETA0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::BETA0)
    .setUnit(U_VOLTM1)
    .setDescription("Vds dependence parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHAII0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ALPHAII0)
    .setUnit(U_MVM1)
    .setDescription("First parameter of Iii for IIMOD=2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHAII01", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ALPHAII01)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of ALPHAII0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHAII1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ALPHAII1)
    .setUnit(U_VOLTM1)
    .setDescription("L scaling parameter of Iii for IIMOD=2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHAII11", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::ALPHAII11)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of ALPHAII1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETAII0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::BETAII0)
    .setUnit(U_VOLTM1)
    .setDescription("Vds dependence parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETAII1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::BETAII1)
    .setUnit(U_UNKNOWN)
    .setDescription("Vds dependence parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETAII2", static_cast<double>(0.1), &ADMSbsimcmg_110::Model::BETAII2)
    .setUnit(U_VOLT)
    .setDescription("Vds dependence parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ESATII", static_cast<double>(1.0e7), &ADMSbsimcmg_110::Model::ESATII)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation channel E-field for Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LII", static_cast<double>(0.5e-9), &ADMSbsimcmg_110::Model::LII)
    .setUnit(U_UNKNOWN)
    .setDescription("Channel length dependence parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SII0", static_cast<double>(0.5), &ADMSbsimcmg_110::Model::SII0)
    .setUnit(U_VOLTM1)
    .setDescription("Vgs dependence parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SII1", static_cast<double>(0.1), &ADMSbsimcmg_110::Model::SII1)
    .setUnit(U_UNKNOWN)
    .setDescription("1st Vgs dependence parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SII2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::SII2)
    .setUnit(U_VOLT)
    .setDescription("2nd Vgs dependence parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SIID", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::SIID)
    .setUnit(U_VOLT)
    .setDescription("3rd Vds dependence parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IIMOD2CLAMP1", static_cast<double>(0.1), &ADMSbsimcmg_110::Model::IIMOD2CLAMP1)
    .setUnit(U_VOLT)
    .setDescription("Clamp1 of SII1*Vg term in IIMOD=2 model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IIMOD2CLAMP2", static_cast<double>(0.1), &ADMSbsimcmg_110::Model::IIMOD2CLAMP2)
    .setUnit(U_VOLT)
    .setDescription("Clamp2 of SII0*Vg term in IIMOD=2 model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IIMOD2CLAMP3", static_cast<double>(0.1), &ADMSbsimcmg_110::Model::IIMOD2CLAMP3)
    .setUnit(U_VOLT)
    .setDescription("Clamp3 of Ratio term in IIMOD=2 model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EOTACC", 0.0, &ADMSbsimcmg_110::Model::EOTACC)
    .setUnit(U_METER)
    .setDescription("Equivalent oxide thickness for accumulation region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELVFBACC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::DELVFBACC)
    .setUnit(U_VOLT)
    .setDescription("Change in flatband voltage: Vfb_accumulation - Vfb_inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFS", static_cast<double>(2.5e-11), &ADMSbsimcmg_110::Model::CFS)
    .setUnit(U_UNKNOWN)
    .setDescription("Outer fringe capacitance at source side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFD", 0.0, &ADMSbsimcmg_110::Model::CFD)
    .setUnit(U_UNKNOWN)
    .setDescription("Outer fringe capacitance at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGSO", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CGSO)
    .setUnit(U_UNKNOWN)
    .setDescription("Non LDD region source-gate overlap capacitance per unit channel width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGDO", 0.0, &ADMSbsimcmg_110::Model::CGDO)
    .setUnit(U_UNKNOWN)
    .setDescription("Non LDD region drain-gate overlap capacitance per unit channel width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGSL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CGSL)
    .setUnit(U_UNKNOWN)
    .setDescription("Overlap capacitance between gate and lightly-doped source region (for CGEOMOD = 0, 2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGDL", 0.0, &ADMSbsimcmg_110::Model::CGDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Overlap capacitance between gate and lightly-doped drain region (for CGEOMOD = 0, 2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CKAPPAS", static_cast<double>(0.6), &ADMSbsimcmg_110::Model::CKAPPAS)
    .setUnit(U_VOLT)
    .setDescription("Coefficient of bias-dependent overlap capacitance for the source side (for CGEOMOD = 0, 2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CKAPPAD", 0.0, &ADMSbsimcmg_110::Model::CKAPPAD)
    .setUnit(U_VOLT)
    .setDescription("Coefficient of bias-dependent overlap capacitance for the drain side (for CGEOMOD = 0, 2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGBO", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CGBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate-to-substrate overlap capacitance per unit channel length per finger per NGCON")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGBN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CGBN)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate-to-substrate overlap capacitance per unit channel length per fin per finger")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGBL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CGBL)
    .setUnit(U_UNKNOWN)
    .setDescription("Bias dependent component of gate-to-substrate overlap capacitance per unit channel length per fin per finger")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CKAPPAB", static_cast<double>(0.6), &ADMSbsimcmg_110::Model::CKAPPAB)
    .setUnit(U_UNKNOWN)
    .setDescription("Bias dependent gate-to-substrate parasitic capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSDESW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CSDESW)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for source/drain-to-substrate sidewall capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJS", static_cast<double>(5.0e-4), &ADMSbsimcmg_110::Model::CJS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit area source-side junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJD", 0.0, &ADMSbsimcmg_110::Model::CJD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit area drain-side junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJSWS", static_cast<double>(5.0e-10), &ADMSbsimcmg_110::Model::CJSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length source-side sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJSWD", 0.0, &ADMSbsimcmg_110::Model::CJSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length drain-side sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJSWGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::CJSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length source-side gate sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJSWGD", 0.0, &ADMSbsimcmg_110::Model::CJSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length drain-side gate sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBS", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::PBS)
    .setUnit(U_VOLT)
    .setDescription("Source-side bulk junction built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBD", 0.0, &ADMSbsimcmg_110::Model::PBD)
    .setUnit(U_VOLT)
    .setDescription("Drain-side bulk junction built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBSWS", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::PBSWS)
    .setUnit(U_VOLT)
    .setDescription("Built-in potential for Source-side sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBSWD", 0.0, &ADMSbsimcmg_110::Model::PBSWD)
    .setUnit(U_VOLT)
    .setDescription("Built-in potential for Drain-side sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBSWGS", 0.0, &ADMSbsimcmg_110::Model::PBSWGS)
    .setUnit(U_VOLT)
    .setDescription("Built-in potential for Source-side gate sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBSWGD", 0.0, &ADMSbsimcmg_110::Model::PBSWGD)
    .setUnit(U_VOLT)
    .setDescription("Built-in potential for Drain-side gate sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJS", static_cast<double>(0.5), &ADMSbsimcmg_110::Model::MJS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source bottom junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJD", 0.0, &ADMSbsimcmg_110::Model::MJD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain bottom junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJSWS", static_cast<double>(0.33), &ADMSbsimcmg_110::Model::MJSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJSWD", 0.0, &ADMSbsimcmg_110::Model::MJSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJSWGS", 0.0, &ADMSbsimcmg_110::Model::MJSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source-side gate sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJSWGD", 0.0, &ADMSbsimcmg_110::Model::MJSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain-side gate sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SJS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::SJS)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant for source-side two-step second junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SJD", 0.0, &ADMSbsimcmg_110::Model::SJD)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant for drain-side two-step second junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SJSWS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::SJSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant for source-side sidewall two-step second junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SJSWD", 0.0, &ADMSbsimcmg_110::Model::SJSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant for drain-side sidewall two-step second junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SJSWGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::SJSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant for source-side gate sidewall two-step second junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SJSWGD", 0.0, &ADMSbsimcmg_110::Model::SJSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant for source-side gate sidewall two-step second junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJS2", static_cast<double>(1.25e-1), &ADMSbsimcmg_110::Model::MJS2)
    .setUnit(U_UNKNOWN)
    .setDescription("Source bottom two-step second junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJD2", 0.0, &ADMSbsimcmg_110::Model::MJD2)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain bottom two-step second junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJSWS2", static_cast<double>(8.3e-2), &ADMSbsimcmg_110::Model::MJSWS2)
    .setUnit(U_UNKNOWN)
    .setDescription("Source sidewall two-step second junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJSWD2", 0.0, &ADMSbsimcmg_110::Model::MJSWD2)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain sidewall two-step second junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJSWGS2", 0.0, &ADMSbsimcmg_110::Model::MJSWGS2)
    .setUnit(U_UNKNOWN)
    .setDescription("Source-side gate sidewall two-step second junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJSWGD2", 0.0, &ADMSbsimcmg_110::Model::MJSWGD2)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain-side gate sidewall two-step second junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSS", static_cast<double>(1.0e-4), &ADMSbsimcmg_110::Model::JSS)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom source junction reverse saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSD", 0.0, &ADMSbsimcmg_110::Model::JSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom drain junction reverse saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSWS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::JSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length reverse saturation current for sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSWD", 0.0, &ADMSbsimcmg_110::Model::JSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length reverse saturation current for sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSWGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::JSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length reverse saturation current for gate-edge sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSWGD", 0.0, &ADMSbsimcmg_110::Model::JSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length reverse saturation current for gate-edge sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJS", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::NJS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source junction emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJD", 0.0, &ADMSbsimcmg_110::Model::NJD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain junction emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IJTHSFWD", static_cast<double>(0.1), &ADMSbsimcmg_110::Model::IJTHSFWD)
    .setUnit(U_AMP)
    .setDescription("Forward source diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IJTHDFWD", 0.0, &ADMSbsimcmg_110::Model::IJTHDFWD)
    .setUnit(U_AMP)
    .setDescription("Forward drain diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IJTHSREV", static_cast<double>(0.1), &ADMSbsimcmg_110::Model::IJTHSREV)
    .setUnit(U_AMP)
    .setDescription("Reverse source diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IJTHDREV", 0.0, &ADMSbsimcmg_110::Model::IJTHDREV)
    .setUnit(U_AMP)
    .setDescription("Reverse drain diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BVS", static_cast<double>(1.0e1), &ADMSbsimcmg_110::Model::BVS)
    .setUnit(U_VOLT)
    .setDescription("Source diode breakdown voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BVD", 0.0, &ADMSbsimcmg_110::Model::BVD)
    .setUnit(U_VOLT)
    .setDescription("Drain diode breakdown voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJBVS", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::XJBVS)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for source diode breakdown current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJBVD", 0.0, &ADMSbsimcmg_110::Model::XJBVD)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for drain diode breakdown current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JTSS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::JTSS)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom source junction trap-assisted saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JTSD", 0.0, &ADMSbsimcmg_110::Model::JTSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom drain junction trap-assisted saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JTSSWS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::JTSSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted saturation current for sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JTSSWD", 0.0, &ADMSbsimcmg_110::Model::JTSSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted saturation current for sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JTSSWGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::JTSSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted saturation current for gate-edge sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JTSSWGD", 0.0, &ADMSbsimcmg_110::Model::JTSSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted saturation current for gate-edge sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JTWEFF", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::JTWEFF)
    .setUnit(U_METER)
    .setDescription("Trap-assisted tunneling current width dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJTS", static_cast<double>(2.0e1), &ADMSbsimcmg_110::Model::NJTS)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJTSD", 0.0, &ADMSbsimcmg_110::Model::NJTSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJTSSW", static_cast<double>(2.0e1), &ADMSbsimcmg_110::Model::NJTSSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSSWS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJTSSWD", 0.0, &ADMSbsimcmg_110::Model::NJTSSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJTSSWG", static_cast<double>(2.0e1), &ADMSbsimcmg_110::Model::NJTSSWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSSWGS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJTSSWGD", 0.0, &ADMSbsimcmg_110::Model::NJTSSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTSS", static_cast<double>(1.0e1), &ADMSbsimcmg_110::Model::VTSS)
    .setUnit(U_VOLT)
    .setDescription("Bottom source junction trap-assisted current voltage dependent parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTSD", 0.0, &ADMSbsimcmg_110::Model::VTSD)
    .setUnit(U_VOLT)
    .setDescription("Bottom drain junction trap-assisted current voltage dependent parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTSSWS", static_cast<double>(1.0e1), &ADMSbsimcmg_110::Model::VTSSWS)
    .setUnit(U_VOLT)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTSSWD", 0.0, &ADMSbsimcmg_110::Model::VTSSWD)
    .setUnit(U_VOLT)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTSSWGS", static_cast<double>(1.0e1), &ADMSbsimcmg_110::Model::VTSSWGS)
    .setUnit(U_VOLT)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for gate-edge sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTSSWGD", 0.0, &ADMSbsimcmg_110::Model::VTSSWGD)
    .setUnit(U_VOLT)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for gate-edge sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LINTIGEN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LINTIGEN)
    .setUnit(U_METER)
    .setDescription("Lint for thermal generation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NTGEN", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::NTGEN)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal generation current parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGEN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::AIGEN)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal generation current parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BIGEN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::BIGEN)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal generation current parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRCRG1", static_cast<double>(1.2e1), &ADMSbsimcmg_110::Model::XRCRG1)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for non-quasistatic gate resistance (NQSMOD = 1) and NQSMOD = 2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRCRG2", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::XRCRG2)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for non-quasistatic gate resistance (NQSMOD = 1) and NQSMOD = 2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSEG", static_cast<int>(4), &ADMSbsimcmg_110::Model::NSEG)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of segments for NQSMOD=3 (3, 5 and 10 supported)");
  p.addPar("EF", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::EF)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise frequency exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EM", static_cast<double>(4.1e7), &ADMSbsimcmg_110::Model::EM)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NOIA", static_cast<double>(6.25e39), &ADMSbsimcmg_110::Model::NOIA)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NOIB", static_cast<double>(3.125e24), &ADMSbsimcmg_110::Model::NOIB)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NOIC", static_cast<double>(8.75e7), &ADMSbsimcmg_110::Model::NOIC)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LINTNOI", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LINTNOI)
    .setUnit(U_METER2)
    .setDescription("L offset for flicker noise calculation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NTNOI", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::NTNOI)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNOIA", static_cast<double>(1.5), &ADMSbsimcmg_110::Model::TNOIA)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNOIB", static_cast<double>(3.5), &ADMSbsimcmg_110::Model::TNOIB)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RNOIA", static_cast<double>(5.77e-1), &ADMSbsimcmg_110::Model::RNOIA)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RNOIB", static_cast<double>(3.7e-1), &ADMSbsimcmg_110::Model::RNOIB)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNOIC", static_cast<double>(3.5), &ADMSbsimcmg_110::Model::TNOIC)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise parameter for TNOIMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RNOIC", static_cast<double>(3.95e-1), &ADMSbsimcmg_110::Model::RNOIC)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise coefficient for TNOIMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCALEN", static_cast<double>(1.0e5), &ADMSbsimcmg_110::Model::SCALEN)
    .setUnit(U_UNKNOWN)
    .setDescription("Noise scaling parameter for TNOIMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNOM", static_cast<double>(27.0), &ADMSbsimcmg_110::Model::TNOM)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature at which the model is extracted")
    .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TBGASUB", static_cast<double>(7.02e-4), &ADMSbsimcmg_110::Model::TBGASUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Bandgap temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TBGBSUB", static_cast<double>(1.108e3), &ADMSbsimcmg_110::Model::TBGBSUB)
    .setUnit(U_DEGK)
    .setDescription("Bandgap temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::KT1)
    .setUnit(U_VOLT)
    .setDescription("Vth temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KT1L", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::KT1L)
    .setUnit(U_UNKNOWN)
    .setDescription("Vth temperature L coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TSS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::TSS)
    .setUnit(U_UNKNOWN)
    .setDescription("Swing temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IIT", static_cast<double>((-0.5)), &ADMSbsimcmg_110::Model::IIT)
    .setUnit(U_UNKNOWN)
    .setDescription("Impact ionization temperature dependence for IIMOD = 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TII", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::TII)
    .setUnit(U_UNKNOWN)
    .setDescription("Impact ionization temperature dependence for IIMOD = 2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TGIDL", static_cast<double>((-3.0e-3)), &ADMSbsimcmg_110::Model::TGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("GIDL/GISL temperature dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IGT", static_cast<double>(2.5), &ADMSbsimcmg_110::Model::IGT)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current temperature dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TCJ", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::TCJ)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for CJS/CJD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TCJSW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::TCJSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for CJSWS/CJSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TCJSWG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::TCJSWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for CJSWGS/CJSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TPB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::TPB)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for PBS/PBD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TPBSW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::TPBSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for PBSWS/PBSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TPBSWG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::TPBSWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for PBSWGS/PBSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTIS", static_cast<double>(3.0), &ADMSbsimcmg_110::Model::XTIS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source junction current temperature exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTID", 0.0, &ADMSbsimcmg_110::Model::XTID)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain junction current temperature exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTSS", static_cast<double>(2.0e-2), &ADMSbsimcmg_110::Model::XTSS)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSS on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTSD", 0.0, &ADMSbsimcmg_110::Model::XTSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSD on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTSSWS", static_cast<double>(2.0e-2), &ADMSbsimcmg_110::Model::XTSSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSSWS on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTSSWD", 0.0, &ADMSbsimcmg_110::Model::XTSSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSSWD on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTSSWGS", static_cast<double>(2.0e-2), &ADMSbsimcmg_110::Model::XTSSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSSWGS on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTSSWGD", 0.0, &ADMSbsimcmg_110::Model::XTSSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSSWGD on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNJTS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::TNJTS)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNJTSD", 0.0, &ADMSbsimcmg_110::Model::TNJTSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNJTSSW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::TNJTSSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSSW")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNJTSSWD", 0.0, &ADMSbsimcmg_110::Model::TNJTSSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNJTSSWG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::TNJTSSWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSSWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNJTSSWGD", 0.0, &ADMSbsimcmg_110::Model::TNJTSSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RTH0", static_cast<double>(1.0e-2), &ADMSbsimcmg_110::Model::RTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTH0", static_cast<double>(1.0e-5), &ADMSbsimcmg_110::Model::CTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WTH0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::WTH0)
    .setUnit(U_METER)
    .setDescription("Width dependence coefficient for Rth and Cth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ASHEXP", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::ASHEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent to tune RTH dependence of NFINTOTAL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BSHEXP", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::BSHEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent to tune RTH dependence of NF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ACH_UFCM", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::ACH_UFCM)
    .setUnit(U_METER2)
    .setDescription("Area of the channel for the unified Model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CINS_UFCM", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::CINS_UFCM)
    .setUnit(U_UNKNOWN)
    .setDescription("Insulator capacitance for the unified Model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("W_UFCM", static_cast<double>(1.0), &ADMSbsimcmg_110::Model::W_UFCM)
    .setUnit(U_METER)
    .setDescription("Effective channel width for the unified Model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TFIN_TOP", static_cast<double>(1.5e-8), &ADMSbsimcmg_110::Model::TFIN_TOP)
    .setUnit(U_METER)
    .setDescription("Top body (fin) thickness for trapezoidal triple gate")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TFIN_BASE", static_cast<double>(1.5e-8), &ADMSbsimcmg_110::Model::TFIN_BASE)
    .setUnit(U_METER)
    .setDescription("Base body (fin) thickness for trapezoidal triple gate")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QMFACTORCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::QMFACTORCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Charge dependence taking QM effects into account")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHA_UFCM", static_cast<double>(0.5556), &ADMSbsimcmg_110::Model::ALPHA_UFCM)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobile charge scaling term taking QM effects into account")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LNBODY", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LNBODY)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NNBODY", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NNBODY)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNBODY", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PNBODY)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPHIG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPHIG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPHIG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPHIG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPHIG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPHIG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LNGATE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LNGATE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NNGATE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NNGATE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNGATE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PNGATE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCIT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LCIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCIT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NCIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCIT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCIT)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCITR", 0.0, &ADMSbsimcmg_110::Model::LCITR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCITR", 0.0, &ADMSbsimcmg_110::Model::NCITR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCITR", 0.0, &ADMSbsimcmg_110::Model::PCITR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCDSC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LCDSC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCDSC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NCDSC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCDSC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCDSC)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCDSCD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LCDSCD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCDSCD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NCDSCD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCDSCD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCDSCD)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCDSCDR", 0.0, &ADMSbsimcmg_110::Model::LCDSCDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCDSCDR", 0.0, &ADMSbsimcmg_110::Model::NCDSCDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCDSCDR", 0.0, &ADMSbsimcmg_110::Model::PCDSCDR)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDVT0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LDVT0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDVT0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NDVT0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDVT0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PDVT0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDVT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LDVT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDVT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NDVT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDVT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PDVT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDVT1SS", 0.0, &ADMSbsimcmg_110::Model::LDVT1SS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDVT1SS", 0.0, &ADMSbsimcmg_110::Model::NDVT1SS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDVT1SS", 0.0, &ADMSbsimcmg_110::Model::PDVT1SS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPHIN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPHIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPHIN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPHIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPHIN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPHIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LETA0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NETA0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PETA0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LETA0R", 0.0, &ADMSbsimcmg_110::Model::LETA0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NETA0R", 0.0, &ADMSbsimcmg_110::Model::NETA0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PETA0R", 0.0, &ADMSbsimcmg_110::Model::PETA0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDSUB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LDSUB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDSUB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NDSUB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDSUB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PDSUB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK1RSCE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LK1RSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK1RSCE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NK1RSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK1RSCE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PK1RSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LLPE0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LLPE0)
    .setUnit(U_METER2)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NLPE0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NLPE0)
    .setUnit(U_METER2)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLPE0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PLPE0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDVTSHIFT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LDVTSHIFT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDVTSHIFT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NDVTSHIFT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDVTSHIFT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PDVTSHIFT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDVTSHIFTR", 0.0, &ADMSbsimcmg_110::Model::LDVTSHIFTR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDVTSHIFTR", 0.0, &ADMSbsimcmg_110::Model::NDVTSHIFTR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDVTSHIFTR", 0.0, &ADMSbsimcmg_110::Model::PDVTSHIFTR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPHIBE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPHIBE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPHIBE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPHIBE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPHIBE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPHIBE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LK0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NK0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PK0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK01", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LK01)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK01", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NK01)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK01", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PK01)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK0SI", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LK0SI)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK0SI", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NK0SI)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK0SI", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PK0SI)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK0SI1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LK0SI1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK0SI1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NK0SI1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK0SI1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PK0SI1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LK1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NK1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PK1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK11", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LK11)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK11", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NK11)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK11", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PK11)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK2SI", 0.0, &ADMSbsimcmg_110::Model::LK2SI)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK2SI", 0.0, &ADMSbsimcmg_110::Model::NK2SI)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK2SI", 0.0, &ADMSbsimcmg_110::Model::PK2SI)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK2SI1", 0.0, &ADMSbsimcmg_110::Model::LK2SI1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK2SI1", 0.0, &ADMSbsimcmg_110::Model::NK2SI1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK2SI1", 0.0, &ADMSbsimcmg_110::Model::PK2SI1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK0SISAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LK0SISAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK0SISAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NK0SISAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK0SISAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PK0SISAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK0SISAT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LK0SISAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK0SISAT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NK0SISAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK0SISAT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PK0SISAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK2SISAT", 0.0, &ADMSbsimcmg_110::Model::LK2SISAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK2SISAT", 0.0, &ADMSbsimcmg_110::Model::NK2SISAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK2SISAT", 0.0, &ADMSbsimcmg_110::Model::PK2SISAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK2SISAT1", 0.0, &ADMSbsimcmg_110::Model::LK2SISAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK2SISAT1", 0.0, &ADMSbsimcmg_110::Model::NK2SISAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK2SISAT1", 0.0, &ADMSbsimcmg_110::Model::PK2SISAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK2SAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LK2SAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK2SAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NK2SAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK2SAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PK2SAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK2SAT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LK2SAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK2SAT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NK2SAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK2SAT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PK2SAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LK2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NK2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PK2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK21", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LK21)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NK21", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NK21)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK21", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PK21)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDVTB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LDVTB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDVTB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NDVTB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDVTB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PDVTB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LLPEB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LLPEB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NLPEB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NLPEB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLPEB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PLPEB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LQMFACTOR", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LQMFACTOR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NQMFACTOR", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NQMFACTOR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PQMFACTOR", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PQMFACTOR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LQMTCENCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LQMTCENCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NQMTCENCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NQMTCENCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PQMTCENCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PQMTCENCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LQMTCENCVA", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LQMTCENCVA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NQMTCENCVA", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NQMTCENCVA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PQMTCENCVA", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PQMTCENCVA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVSAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NVSAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PVSAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVSATR", 0.0, &ADMSbsimcmg_110::Model::LVSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NVSATR", 0.0, &ADMSbsimcmg_110::Model::NVSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PVSATR", 0.0, &ADMSbsimcmg_110::Model::PVSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVSAT1", 0.0, &ADMSbsimcmg_110::Model::LVSAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NVSAT1", 0.0, &ADMSbsimcmg_110::Model::NVSAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PVSAT1", 0.0, &ADMSbsimcmg_110::Model::PVSAT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVSAT1R", 0.0, &ADMSbsimcmg_110::Model::LVSAT1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NVSAT1R", 0.0, &ADMSbsimcmg_110::Model::NVSAT1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PVSAT1R", 0.0, &ADMSbsimcmg_110::Model::PVSAT1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPSAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPSAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPSAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDELTAVSAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LDELTAVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDELTAVSAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NDELTAVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDELTAVSAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PDELTAVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LKSATIV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LKSATIV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NKSATIV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NKSATIV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PKSATIV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PKSATIV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LKSATIVR", 0.0, &ADMSbsimcmg_110::Model::LKSATIVR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NKSATIVR", 0.0, &ADMSbsimcmg_110::Model::NKSATIVR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PKSATIVR", 0.0, &ADMSbsimcmg_110::Model::PKSATIVR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVSATCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NVSATCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PVSATCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPSATCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPSATCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPSATCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDELTAVSATCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LDELTAVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDELTAVSATCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NDELTAVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDELTAVSATCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PDELTAVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LMEXP", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LMEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NMEXP", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NMEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PMEXP", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PMEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LMEXPR", 0.0, &ADMSbsimcmg_110::Model::LMEXPR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NMEXPR", 0.0, &ADMSbsimcmg_110::Model::NMEXPR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PMEXPR", 0.0, &ADMSbsimcmg_110::Model::PMEXPR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPTWG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPTWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPTWG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPTWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPTWG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPTWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPTWGR", 0.0, &ADMSbsimcmg_110::Model::LPTWGR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPTWGR", 0.0, &ADMSbsimcmg_110::Model::NPTWGR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPTWGR", 0.0, &ADMSbsimcmg_110::Model::PPTWGR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LU0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LU0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NU0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NU0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PU0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PU0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LU0R", 0.0, &ADMSbsimcmg_110::Model::LU0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NU0R", 0.0, &ADMSbsimcmg_110::Model::NU0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PU0R", 0.0, &ADMSbsimcmg_110::Model::PU0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LETAMOB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LETAMOB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NETAMOB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NETAMOB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PETAMOB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PETAMOB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUP", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LUP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUP", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NUP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUP", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PUP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUPR", 0.0, &ADMSbsimcmg_110::Model::LUPR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUPR", 0.0, &ADMSbsimcmg_110::Model::NUPR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUPR", 0.0, &ADMSbsimcmg_110::Model::PUPR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUA", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LUA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUA", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NUA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUA", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PUA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUAR", 0.0, &ADMSbsimcmg_110::Model::LUAR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUAR", 0.0, &ADMSbsimcmg_110::Model::NUAR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUAR", 0.0, &ADMSbsimcmg_110::Model::PUAR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LUC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NUC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PUC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUCR", 0.0, &ADMSbsimcmg_110::Model::LUCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUCR", 0.0, &ADMSbsimcmg_110::Model::NUCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUCR", 0.0, &ADMSbsimcmg_110::Model::PUCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LEU", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LEU)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NEU", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NEU)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PEU", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PEU)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LEUR", 0.0, &ADMSbsimcmg_110::Model::LEUR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NEUR", 0.0, &ADMSbsimcmg_110::Model::NEUR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PEUR", 0.0, &ADMSbsimcmg_110::Model::PEUR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LUD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NUD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PUD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUDR", 0.0, &ADMSbsimcmg_110::Model::LUDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUDR", 0.0, &ADMSbsimcmg_110::Model::NUDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUDR", 0.0, &ADMSbsimcmg_110::Model::PUDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUCS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LUCS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUCS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NUCS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUCS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PUCS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPCLM", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPCLM)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPCLM", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPCLM)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPCLM", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPCLM)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPCLMR", 0.0, &ADMSbsimcmg_110::Model::LPCLMR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPCLMR", 0.0, &ADMSbsimcmg_110::Model::NPCLMR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPCLMR", 0.0, &ADMSbsimcmg_110::Model::PPCLMR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPCLMG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPCLMG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPCLMG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPCLMG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPCLMG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPCLMG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPCLMCV", 0.0, &ADMSbsimcmg_110::Model::LPCLMCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPCLMCV", 0.0, &ADMSbsimcmg_110::Model::NPCLMCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPCLMCV", 0.0, &ADMSbsimcmg_110::Model::PPCLMCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LA1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NA1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PA1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LA11", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LA11)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NA11", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NA11)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PA11", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PA11)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LA2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LA2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NA2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NA2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PA2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PA2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LA21", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LA21)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NA21", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NA21)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PA21", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PA21)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LRDSW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LRDSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NRDSW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NRDSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRDSW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PRDSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LRSW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LRSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NRSW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NRSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRSW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PRSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LRDW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LRDW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NRDW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NRDW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRDW", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PRDW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPRWGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPRWGS)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPRWGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPRWGS)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPRWGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPRWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPRWGD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPRWGD)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPRWGD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPRWGD)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPRWGD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPRWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LWR", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LWR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NWR", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NWR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWR", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PWR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPDIBL1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPDIBL1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPDIBL1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPDIBL1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPDIBL1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPDIBL1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPDIBL1R", 0.0, &ADMSbsimcmg_110::Model::LPDIBL1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPDIBL1R", 0.0, &ADMSbsimcmg_110::Model::NPDIBL1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPDIBL1R", 0.0, &ADMSbsimcmg_110::Model::PPDIBL1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPDIBL2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPDIBL2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPDIBL2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPDIBL2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPDIBL2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPDIBL2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPDIBL2R", 0.0, &ADMSbsimcmg_110::Model::LPDIBL2R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPDIBL2R", 0.0, &ADMSbsimcmg_110::Model::NPDIBL2R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPDIBL2R", 0.0, &ADMSbsimcmg_110::Model::PPDIBL2R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDROUT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LDROUT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDROUT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NDROUT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDROUT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PDROUT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPVAG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPVAG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPVAG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPVAG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPVAG", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPVAG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LAIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NAIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NAIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PAIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGBINV1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LAIGBINV1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NAIGBINV1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NAIGBINV1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGBINV1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PAIGBINV1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LBIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NBIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PBIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LCIGBINV)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NCIGBINV)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LEIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LEIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NEIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NEIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PEIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PEIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LNIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LNIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NNIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NNIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNIGBINV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PNIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGBACC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LAIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NAIGBACC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NAIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGBACC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PAIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGBACC1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LAIGBACC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NAIGBACC1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NAIGBACC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGBACC1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PAIGBACC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBIGBACC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LBIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBIGBACC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NBIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBIGBACC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PBIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCIGBACC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LCIGBACC)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCIGBACC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NCIGBACC)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCIGBACC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LNIGBACC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LNIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NNIGBACC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NNIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNIGBACC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PNIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LAIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NAIGC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NAIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PAIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGC1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LAIGC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NAIGC1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NAIGC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGC1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PAIGC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBIGC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LBIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBIGC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NBIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBIGC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PBIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCIGC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LCIGC)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCIGC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NCIGC)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCIGC", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPIGCD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPIGCD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPIGCD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPIGCD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPIGCD", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPIGCD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LAIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NAIGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NAIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PAIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGS1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LAIGS1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NAIGS1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NAIGS1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGS1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PAIGS1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBIGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LBIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBIGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NBIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBIGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PBIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCIGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LCIGS)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCIGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NCIGS)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCIGS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGD", 0.0, &ADMSbsimcmg_110::Model::LAIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NAIGD", 0.0, &ADMSbsimcmg_110::Model::NAIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGD", 0.0, &ADMSbsimcmg_110::Model::PAIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGD1", 0.0, &ADMSbsimcmg_110::Model::LAIGD1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NAIGD1", 0.0, &ADMSbsimcmg_110::Model::NAIGD1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGD1", 0.0, &ADMSbsimcmg_110::Model::PAIGD1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBIGD", 0.0, &ADMSbsimcmg_110::Model::LBIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBIGD", 0.0, &ADMSbsimcmg_110::Model::NBIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBIGD", 0.0, &ADMSbsimcmg_110::Model::PBIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCIGD", 0.0, &ADMSbsimcmg_110::Model::LCIGD)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCIGD", 0.0, &ADMSbsimcmg_110::Model::NCIGD)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCIGD", 0.0, &ADMSbsimcmg_110::Model::PCIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LNTOX", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LNTOX)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NNTOX", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NNTOX)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNTOX", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PNTOX)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPOXEDGE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPOXEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPOXEDGE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPOXEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPOXEDGE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPOXEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LAGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NAGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NAGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PAGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LBGISL)
    .setUnit(U_VOLT)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NBGISL)
    .setUnit(U_VOLT)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PBGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LCGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NCGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LEGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LEGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NEGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NEGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PEGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PEGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPGISL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAGIDL", 0.0, &ADMSbsimcmg_110::Model::LAGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NAGIDL", 0.0, &ADMSbsimcmg_110::Model::NAGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAGIDL", 0.0, &ADMSbsimcmg_110::Model::PAGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBGIDL", 0.0, &ADMSbsimcmg_110::Model::LBGIDL)
    .setUnit(U_VOLT)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBGIDL", 0.0, &ADMSbsimcmg_110::Model::NBGIDL)
    .setUnit(U_VOLT)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBGIDL", 0.0, &ADMSbsimcmg_110::Model::PBGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCGIDL", 0.0, &ADMSbsimcmg_110::Model::LCGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCGIDL", 0.0, &ADMSbsimcmg_110::Model::NCGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCGIDL", 0.0, &ADMSbsimcmg_110::Model::PCGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LEGIDL", 0.0, &ADMSbsimcmg_110::Model::LEGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NEGIDL", 0.0, &ADMSbsimcmg_110::Model::NEGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PEGIDL", 0.0, &ADMSbsimcmg_110::Model::PEGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPGIDL", 0.0, &ADMSbsimcmg_110::Model::LPGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPGIDL", 0.0, &ADMSbsimcmg_110::Model::NPGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPGIDL", 0.0, &ADMSbsimcmg_110::Model::PPGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LALPHA0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LALPHA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NALPHA0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NALPHA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PALPHA0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PALPHA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LALPHA1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LALPHA1)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NALPHA1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NALPHA1)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PALPHA1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PALPHA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LALPHAII0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LALPHAII0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NALPHAII0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NALPHAII0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PALPHAII0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PALPHAII0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LALPHAII1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LALPHAII1)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NALPHAII1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NALPHAII1)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PALPHAII1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PALPHAII1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBETA0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LBETA0)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBETA0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NBETA0)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBETA0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PBETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBETAII0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LBETAII0)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBETAII0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NBETAII0)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBETAII0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PBETAII0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBETAII1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LBETAII1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBETAII1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NBETAII1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBETAII1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PBETAII1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBETAII2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LBETAII2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBETAII2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NBETAII2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBETAII2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PBETAII2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LESATII", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LESATII)
    .setUnit(U_VOLT)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NESATII", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NESATII)
    .setUnit(U_VOLT)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PESATII", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PESATII)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LLII", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LLII)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NLII", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NLII)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLII", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PLII)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LSII0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LSII0)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSII0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NSII0)
    .setUnit(U_MVM1)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSII0", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PSII0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LSII1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LSII1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSII1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NSII1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSII1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PSII1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LSII2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LSII2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSII2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NSII2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSII2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PSII2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LSIID", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LSIID)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSIID", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NSIID)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSIID", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PSIID)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCFS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LCFS)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCFS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NCFS)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCFS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCFS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCFD", 0.0, &ADMSbsimcmg_110::Model::LCFD)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCFD", 0.0, &ADMSbsimcmg_110::Model::NCFD)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCFD", 0.0, &ADMSbsimcmg_110::Model::PCFD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCOVS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LCOVS)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCOVS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NCOVS)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCOVS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCOVS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCOVD", 0.0, &ADMSbsimcmg_110::Model::LCOVD)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCOVD", 0.0, &ADMSbsimcmg_110::Model::NCOVD)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCOVD", 0.0, &ADMSbsimcmg_110::Model::PCOVD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCGSL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LCGSL)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCGSL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NCGSL)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCGSL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCGSL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCGDL", 0.0, &ADMSbsimcmg_110::Model::LCGDL)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCGDL", 0.0, &ADMSbsimcmg_110::Model::NCGDL)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCGDL", 0.0, &ADMSbsimcmg_110::Model::PCGDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCKAPPAS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LCKAPPAS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCKAPPAS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NCKAPPAS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCKAPPAS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCKAPPAS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCKAPPAD", 0.0, &ADMSbsimcmg_110::Model::LCKAPPAD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCKAPPAD", 0.0, &ADMSbsimcmg_110::Model::NCKAPPAD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCKAPPAD", 0.0, &ADMSbsimcmg_110::Model::PCKAPPAD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCGBL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LCGBL)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCGBL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NCGBL)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCGBL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCGBL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCKAPPAB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LCKAPPAB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCKAPPAB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NCKAPPAB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCKAPPAB", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PCKAPPAB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LNTGEN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LNTGEN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NNTGEN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NNTGEN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNTGEN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PNTGEN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGEN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LAIGEN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NAIGEN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NAIGEN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGEN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PAIGEN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBIGEN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LBIGEN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBIGEN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NBIGEN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBIGEN", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PBIGEN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LXRCRG1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LXRCRG1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NXRCRG1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NXRCRG1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PXRCRG1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PXRCRG1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LXRCRG2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LXRCRG2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NXRCRG2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NXRCRG2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PXRCRG2", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PXRCRG2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUTE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LUTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUTE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NUTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUTE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PUTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUTER", 0.0, &ADMSbsimcmg_110::Model::LUTER)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUTER", 0.0, &ADMSbsimcmg_110::Model::NUTER)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUTER", 0.0, &ADMSbsimcmg_110::Model::PUTER)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUTL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LUTL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUTL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NUTL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUTL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PUTL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUTLR", 0.0, &ADMSbsimcmg_110::Model::LUTLR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUTLR", 0.0, &ADMSbsimcmg_110::Model::NUTLR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUTLR", 0.0, &ADMSbsimcmg_110::Model::PUTLR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LEMOBT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LEMOBT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NEMOBT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NEMOBT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PEMOBT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PEMOBT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUA1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LUA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUA1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NUA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUA1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PUA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUA1R", 0.0, &ADMSbsimcmg_110::Model::LUA1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUA1R", 0.0, &ADMSbsimcmg_110::Model::NUA1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUA1R", 0.0, &ADMSbsimcmg_110::Model::PUA1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUC1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LUC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUC1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NUC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUC1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PUC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUC1R", 0.0, &ADMSbsimcmg_110::Model::LUC1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUC1R", 0.0, &ADMSbsimcmg_110::Model::NUC1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUC1R", 0.0, &ADMSbsimcmg_110::Model::PUC1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUD1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LUD1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUD1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NUD1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUD1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PUD1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUD1R", 0.0, &ADMSbsimcmg_110::Model::LUD1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUD1R", 0.0, &ADMSbsimcmg_110::Model::NUD1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUD1R", 0.0, &ADMSbsimcmg_110::Model::PUD1R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUCSTE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LUCSTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NUCSTE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NUCSTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUCSTE", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PUCSTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPTWGT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPTWGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPTWGT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPTWGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPTWGT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPTWGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LATR", 0.0, &ADMSbsimcmg_110::Model::LATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NATR", 0.0, &ADMSbsimcmg_110::Model::NATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PATR", 0.0, &ADMSbsimcmg_110::Model::PATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LATCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NATCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PATCV", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LSTTHETASAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LSTTHETASAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSTTHETASAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NSTTHETASAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSTTHETASAT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PSTTHETASAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPRT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LPRT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPRT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NPRT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPRT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PPRT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LKT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LKT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NKT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NKT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PKT1", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PKT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LTSS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LTSS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NTSS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NTSS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTSS", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PTSS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LIIT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LIIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NIIT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NIIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PIIT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PIIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LTII", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LTII)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NTII", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NTII)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTII", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PTII)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LTGIDL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LTGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NTGIDL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NTGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTGIDL", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PTGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LIGT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::LIGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NIGT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::NIGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PIGT", static_cast<double>(0.0), &ADMSbsimcmg_110::Model::PIGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:
  if (!(given("L")))
  {
    L = model_.L;
  }
  if (!(given("D")))
  {
    D = model_.D;
  }
  if (!(given("TFIN")))
  {
    TFIN = model_.TFIN;
  }
  if (!(given("FPITCH")))
  {
    FPITCH = model_.FPITCH;
  }
  if (!(given("NF")))
  {
    NF = model_.NF;
  }
  if (!(given("NFIN")))
  {
    NFIN = model_.NFIN;
  }
  if (!(given("NGCON")))
  {
    NGCON = model_.NGCON;
  }
  if (!(given("ASEO")))
  {
    ASEO = model_.ASEO;
  }
  if (!(given("ADEO")))
  {
    ADEO = model_.ADEO;
  }
  if (!(given("PSEO")))
  {
    PSEO = model_.PSEO;
  }
  if (!(given("PDEO")))
  {
    PDEO = model_.PDEO;
  }
  if (!(given("ASEJ")))
  {
    ASEJ = model_.ASEJ;
  }
  if (!(given("ADEJ")))
  {
    ADEJ = model_.ADEJ;
  }
  if (!(given("PSEJ")))
  {
    PSEJ = model_.PSEJ;
  }
  if (!(given("PDEJ")))
  {
    PDEJ = model_.PDEJ;
  }
  if (!(given("COVS")))
  {
    COVS = model_.COVS;
  }
  if (!(given("COVD")))
  {
    COVD = model_.COVD;
  }
  if (!(given("CGSP")))
  {
    CGSP = model_.CGSP;
  }
  if (!(given("CGDP")))
  {
    CGDP = model_.CGDP;
  }
  if (!(given("CDSP")))
  {
    CDSP = model_.CDSP;
  }
  if (!(given("NRS")))
  {
    NRS = model_.NRS;
  }
  if (!(given("NRD")))
  {
    NRD = model_.NRD;
  }
  if (!(given("LRSD")))
  {
    LRSD = model_.LRSD;
  }



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:
  if (!given("COVD"))
  {
    COVD = COVS;
  }
  if (!given("LRSD"))
  {
    LRSD = L;
  }


  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter L : [ 1.0e-9,  (+inf) [
  if ( (!((L >=1.0e-9))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter L value " << L << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter D : [ 1.0e-9,  (+inf) [
  if ( (!((D >=1.0e-9))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter D value " << D << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter TFIN : [ 1.0e-9,  (+inf) [
  if ( (!((TFIN >=1.0e-9))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter TFIN value " << TFIN << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter FPITCH : [ TFIN,  (+inf) [
  if ( (!((FPITCH >=TFIN))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter FPITCH value " << FPITCH << " out of range [ TFIN,  (+inf) [";
  }

  //    Parameter NF : [ 1,  (+inf) [
  if ( (!((NF >=1))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NF value " << NF << " out of range [ 1,  (+inf) [";
  }

  //    Parameter NFIN : ] 0,  (+inf) [
  if ( (!((NFIN >0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NFIN value " << NFIN << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NGCON : [ 1, 2 ]
  if ( (!((NGCON >=1 && NGCON <=2 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NGCON value " << NGCON << " out of range [ 1, 2 ]";
  }

  //    Parameter ASEO : [ 0,  (+inf) [
  if ( (!((ASEO >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ASEO value " << ASEO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ADEO : [ 0,  (+inf) [
  if ( (!((ADEO >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ADEO value " << ADEO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PSEO : [ 0,  (+inf) [
  if ( (!((PSEO >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter PSEO value " << PSEO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PDEO : [ 0,  (+inf) [
  if ( (!((PDEO >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter PDEO value " << PDEO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ASEJ : [ 0,  (+inf) [
  if ( (!((ASEJ >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ASEJ value " << ASEJ << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ADEJ : [ 0,  (+inf) [
  if ( (!((ADEJ >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ADEJ value " << ADEJ << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PSEJ : [ 0,  (+inf) [
  if ( (!((PSEJ >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter PSEJ value " << PSEJ << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PDEJ : [ 0,  (+inf) [
  if ( (!((PDEJ >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter PDEJ value " << PDEJ << " out of range [ 0,  (+inf) [";
  }

  //    Parameter COVS : [ 0,  (+inf) [
  if ( (!((COVS >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter COVS value " << COVS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter COVD : [ 0,  (+inf) [
  if ( (!((COVD >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter COVD value " << COVD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CGSP : [ 0,  (+inf) [
  if ( (!((CGSP >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CGSP value " << CGSP << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CGDP : [ 0,  (+inf) [
  if ( (!((CGDP >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CGDP value " << CGDP << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CDSP : [ 0,  (+inf) [
  if ( (!((CDSP >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CDSP value " << CDSP << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NRS : [ 0,  (+inf) [
  if ( (!((NRS >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NRS value " << NRS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NRD : [ 0,  (+inf) [
  if ( (!((NRD >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NRD value " << NRD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter LRSD : ] 0,  (+inf) [
  if ( (!((LRSD >0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter LRSD value " << LRSD << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NFINNOM : ] 0,  (+inf) [
  if ( (!((NFINNOM >0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NFINNOM value " << NFINNOM << " out of range ] 0,  (+inf) [";
  }

  //    Parameter m : ] 0.0,  (+inf) [
  if ( (!((m >0.0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter m value " << m << " out of range ] 0.0,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  double Toxratioedge;
  double Ccorner;
  double Acorner;
  double Cgg_side;
  double Cgg_top;
  double Hr;
  double Lr;
  double Hgdelta;
  double Lmax;
  double y;
  double x;
  double Cnon;
  double CcgSat;
  double TT1;
  double Ccg1;
  double r1cf;
  double Rcf;
  double Ccg2;
  double Ccg;
  double C1;
  double C2;
  double C3;
  double Cfglog;
  double dcf;
  double TT0;
  double TT2;
  double Cfgsat;
  double Cfg;
  double Hrsd;
  double Wg;
  double Trsd;
  double Hg;
  double Rdsgeo;
  double Rrsd;
  double Rrsdside;
  double RrsdTML;
  double eta;
  double alpha;
  double lt;
  double prsd_total;
  double arsd_total;
  double Rsp;
  double afin;
  double thetarsp;
  double rhorsd;
  double mu_rsd;
  double mu_max;
  double Prsd;
  double Arsd;
  double Rgeltd;
  double NTOX_i;
  double WR_i;
  double UP_i;
  double LPE0_i;
  double DSUB_i;
  double DVT1SS_i;
  double DVT1_i;
  double NGATE_i;
  double NBODY_i;
  double Inv_LNFIN;
  double Inv_NFIN;
  double Inv_L;
  double Leff1;
  double deltaLCV;
  double deltaL1;
  double deltaL;
  double Lg;
  double cbox;
  double epssp;
  double UPR_i;
  double MTcen;
  //Begin block initial_instance
  {
    qid = 0.0;
    qis = 0.0;
    qba = 0.0;
    T11 = 0.0;
    T12 = 0.0;
    ids = 0.0;
    sigvds = 0.0;
    Iii = 0.0;
    qd = 0.0;
    qg = 0.0;
    qs = 0.0;
    qb = 0.0;
    Weff0 = 0.0;
    WeffCV0 = 0.0;
    CJS_t = 0.0;
    CJSWS_t = 0.0;
    CJSWGS_t = 0.0;
    CJD_t = 0.0;
    CJSWD_t = 0.0;
    CJSWGD_t = 0.0;
    PBS_t = 0.0;
    PBSWS_t = 0.0;
    PBSWGS_t = 0.0;
    PBD_t = 0.0;
    PBSWD_t = 0.0;
    PBSWGD_t = 0.0;
    JSS_t = 0.0;
    JSWS_t = 0.0;
    JSWGS_t = 0.0;
    JSD_t = 0.0;
    JSWD_t = 0.0;
    JSWGD_t = 0.0;
    JTSS_t = 0.0;
    JTSSWS_t = 0.0;
    JTSSWGS_t = 0.0;
    JTSD_t = 0.0;
    JTSSWD_t = 0.0;
    JTSSWGD_t = 0.0;
    NJTS_t = 0.0;
    NJTSSW_t = 0.0;
    NJTSSWG_t = 0.0;
    NJTSD_t = 0.0;
    NJTSSWD_t = 0.0;
    NJTSSWGD_t = 0.0;
    Ies = 0.0;
    Ied = 0.0;
    Czbs = 0.0;
    Czbssw = 0.0;
    Czbsswg = 0.0;
    Czbd = 0.0;
    Czbdsw = 0.0;
    Czbdswg = 0.0;
    Qes = 0.0;
    Qed = 0.0;
    Qeg = 0.0;
    Isbs = 0.0;
    Isbd = 0.0;
    Nvtms = 0.0;
    Nvtmd = 0.0;
    SslpRev = 0.0;
    IVjsmRev = 0.0;
    VjsmRev = 0.0;
    SslpFwd = 0.0;
    IVjsmFwd = 0.0;
    VjsmFwd = 0.0;
    DslpRev = 0.0;
    IVjdmRev = 0.0;
    VjdmRev = 0.0;
    DslpFwd = 0.0;
    IVjdmFwd = 0.0;
    VjdmFwd = 0.0;
    XExpBVS = 0.0;
    XExpBVD = 0.0;
    idsgen = 0.0;
    q0 = 0.0;
    Tcen = 0.0;
    MTcen = 0.0;
    Rdrain = 0.0;
    Rsource = 0.0;
    Cfr_geo = 0.0;
    igbinv = 0.0;
    igbs = 0.0;
    igbd = 0.0;
    igbacc = 0.0;
    igcs = 0.0;
    igcd = 0.0;
    igidl = 0.0;
    igisl = 0.0;
    igs = 0.0;
    igd = 0.0;
    cox_acc = 0.0;
    CGSO_i = 0.0;
    CGDO_i = 0.0;
    qb_acc = 0.0;
    qg_acc = 0.0;
    qgs_fr = 0.0;
    qgd_fr = 0.0;
    qds_fr = 0.0;
    qgs_parasitic = 0.0;
    qgd_parasitic = 0.0;
    FNPowerAt1Hz = 0.0;
    Gtnoi = 0.0;
    gspr = 0.0;
    gdpr = 0.0;
    Dr = 1.0;
    CDSCDR_i = 0.0;
    ETA0R_i = 0.0;
    VSAT1R_i = 0.0;
    VSAT1R_t = 0.0;
    MEXPR_i = 0.0;
    MEXPR_t = 0.0;
    PTWGR_i = 0.0;
    PTWGR_t = 0.0;
    PDIBL1R_i = 0.0;
    PDIBL2R_i = 0.0;
    PHIBE_i = 0.0;
    K1_i = 0.0;
    K11_i = 0.0;
    K2SAT_i = 0.0;
    K2SAT1_i = 0.0;
    KSATIVR_i = 0.0;
    K2_i = 0.0;
    K21_i = 0.0;
    UC_i = 0.0;
    UC1_i = 0.0;
    UC_t = 0.0;
    U0R_i = 0.0;
    UPR_i = 0.0;
    EUR_i = 0.0;
    ATR_i = 0.0;
    CITR_i = 0.0;
    ETA0R_i = 0.0;
    DVTP0_i = 0.0;
    DVTP1_i = 0.0;
    PDIBL2R_i = 0.0;
    PCLMR_i = 0.0;
    LeffCV_acc = 0.0;
    RDDRR_t = 0.0;
    RSDRR_t = 0.0;
    Rdsi = 0.0;
    T3 = 0.0;
    Tcen0 = 0.0;
    veseff = 0.0;
    U0R_t = 0.0;
    UAR_t = 0.0;
    UCR_t = 0.0;
    UDR_t = 0.0;
    VSAT_a = 0.0;
    DVTSHIFTR_i = 0.0;
    UA1R_i = 0.0;
    UAR_i = 0.0;
    UC1R_i = 0.0;
    UCR_i = 0.0;
    UD1R_i = 0.0;
    UDR_i = 0.0;
    UTER_i = 0.0;
    UTLR_i = 0.0;
    VSATR_i = 0.0;
    VSATR_t = 0.0;
    u0r = 0.0;
    sid = 0.0;
    ctnoi = 0.0;
    sf = 0.0;
    C0 = 0.0;
    gamma = 0.0;
    delta = 0.0;
    ggeltd = 0.0;
    qm = 1.0;
    Cins = 1.0;
    Ach = 1.0;
    Weff_UFCM = 1.0;
    qdep = (-1.0);
    rc = 1.0;
    vth_fixed_factor_Sub = 1.0;
    vth_fixed_factor_SI = 1.0;
    qi_acc_for_QM = 0.0;
    fieldnormalizationfactor = 0.0;
    auxQMfact = 0.0;
    QMFACTORCVfinal = 0.0;
    psipclamp = 1.0;
    sqrtpsip = 1.0;
    nq = 1.0;
    F0 = 0.0;
    e0 = 0.0;
    e1 = 0.0;
    e2 = 0.0;
    Qdep_ov_Cins = 0.0;
    if (((model_.TYPE)==1))
    {
      devsign = 1;
    }
    else
    {
      devsign = (-1);
    }
    epssub = ((model_.EPSRSUB)*8.8542e-12);
    epssp = ((model_.EPSRSP)*8.8542e-12);
    cbox = (((model_.EPSROX)*8.8542e-12)/(model_.EOTBOX));
    epsratio = ((model_.EPSRSUB)/(model_.EPSROX));
    mx = (0.916*9.11e-31);
    mxprime = (0.190*9.11e-31);
    md = (0.190*9.11e-31);
    mdprime = (0.417*9.11e-31);
    gprime = 4.0;
    gfactor = 2.0;
    Lg = (L+(model_.XL));
    deltaL = ((model_.LINT)+((model_.LL)*pow(Lg,(-(model_.LLN)))));
    deltaL1 = ((model_.LINT)+((model_.LL)*pow((Lg+(model_.DLBIN)),(-(model_.LLN)))));
    deltaLCV = ((model_.DLC)+((model_.LLC)*pow(Lg,(-(model_.LLN)))));
    Leff = (Lg-(2.0*deltaL));
    Leff1 = ((Lg+(model_.DLBIN))-(2.0*deltaL1));
    LeffCV = (Lg-(2.0*deltaLCV));
    if (((model_.BULKMOD)!=0))
    {
      LeffCV_acc = (LeffCV-(model_.DLCACC));
    }
    NFINtotal = (NFIN*NF);
    if ((Leff<=0.0))
    {
      std::cerr  << "Fatal: Leff = %e is not positive." << Leff <<  std::endl; 
      UserError0(*this) << "$finish called." << std::endl; 
    }
    else
    {
      if ((Leff<=1.0e-9))
      {
        std::cerr  << "Warning: Leff = %e <= 1.0e-9." << Leff <<  std::endl; 
      }
    }
    if ((Leff1<=0.0))
    {
      std::cerr  << "Fatal: Leff1 = %e is not positive." << Leff1 <<  std::endl; 
      UserError0(*this) << "$finish called." << std::endl; 
    }
    else
    {
      if ((Leff1<=1.0e-9))
      {
        std::cerr  << "Warning: Leff1 = %e <= 1.0e-9." << Leff1 <<  std::endl; 
      }
    }
    Inv_L = (1.0e-6/Leff1);
    Inv_NFIN = (1.0/NFIN);
    Inv_LNFIN = (1.0e-6/(Leff1*NFIN));
    NBODY_i = ((((model_.NBODY)+(Inv_L*(model_.LNBODY)))+(Inv_NFIN*(model_.NNBODY)))+(Inv_LNFIN*(model_.PNBODY)));
    if (((model_.NBODYN1)!=0.0))
    {
      NBODY_i = (NBODY_i*(1.0+(((model_.NBODYN1)/NFIN)*AnalogFunctions::lln((1.0+(NFIN/(model_.NBODYN2)))))));
    }
    if ( (model_.GEOMOD) == (0))
    {
      if (((!(model_.given("TFIN_TOP")))||(!(model_.given("TFIN_BASE")))))
      {
        Weff_UFCM = (2.0*(model_.HFIN));
        Cins = (((Weff_UFCM*(model_.EPSROX))*8.8542e-12)/(model_.EOT));
        Ach = ((model_.HFIN)*TFIN);
        rc = ((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
        Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
      }
      else
      {
        Weff_UFCM = (2.0*sqrt((((model_.HFIN)*(model_.HFIN))+((((model_.TFIN_TOP)-(model_.TFIN_BASE))*((model_.TFIN_TOP)-(model_.TFIN_BASE)))/4.0))));
        Cins = (((Weff_UFCM*(model_.EPSROX))*8.8542e-12)/(model_.EOT));
        Ach = (((model_.HFIN)*((model_.TFIN_TOP)+(model_.TFIN_BASE)))/2.0);
        rc = ((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
        Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
      }
    }
    else
      if ( (model_.GEOMOD) == (1))
      {
        if (((!(model_.given("TFIN_TOP")))||(!(model_.given("TFIN_BASE")))))
        {
          Weff_UFCM = ((2.0*(model_.HFIN))+TFIN);
          Cins = (((Weff_UFCM*(model_.EPSROX))*8.8542e-12)/(model_.EOT));
          Ach = ((model_.HFIN)*TFIN);
          rc = ((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
          Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
        }
        else
        {
          Weff_UFCM = ((2.0*sqrt((((model_.HFIN)*(model_.HFIN))+((((model_.TFIN_TOP)-(model_.TFIN_BASE))*((model_.TFIN_TOP)-(model_.TFIN_BASE)))/4.0))))+(model_.TFIN_TOP));
          Cins = (((Weff_UFCM*(model_.EPSROX))*8.8542e-12)/(model_.EOT));
          Ach = (((model_.HFIN)*((model_.TFIN_TOP)+(model_.TFIN_BASE)))/2.0);
          rc = ((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
          Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
        }
      }
      else
        if ( (model_.GEOMOD) == (2))
        {
          if (((!(model_.given("TFIN_TOP")))||(!(model_.given("TFIN_BASE")))))
          {
            Weff_UFCM = ((2.0*(model_.HFIN))+(2.0*TFIN));
            Cins = (((Weff_UFCM*(model_.EPSROX))*8.8542e-12)/(model_.EOT));
            Ach = ((model_.HFIN)*TFIN);
            rc = ((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
            Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
          }
          else
          {
            Weff_UFCM = (((2.0*sqrt((((model_.HFIN)*(model_.HFIN))+((((model_.TFIN_TOP)-(model_.TFIN_BASE))*((model_.TFIN_TOP)-(model_.TFIN_BASE)))/4.0))))+(model_.TFIN_TOP))+(model_.TFIN_BASE));
            Cins = (((Weff_UFCM*(model_.EPSROX))*8.8542e-12)/(model_.EOT));
            Ach = (((model_.HFIN)*((model_.TFIN_TOP)+(model_.TFIN_BASE)))/2.0);
            rc = ((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
            Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
          }
        }
        else
          if ( (model_.GEOMOD) == (3))
          {
            Weff_UFCM = (3.14159265358979323846*D);
            Cins = ((((2.0*3.14159265358979323846)*(model_.EPSROX))*8.8542e-12)/log((1.0+((2.0*(model_.EOT))/D))));
            Ach = (((3.14159265358979323846*D)*D)/4.0);
            rc = ((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
            Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
          }
          else
            if ( (model_.GEOMOD) == (4))
            {
              Weff_UFCM = (model_.W_UFCM);
              Cins = (model_.CINS_UFCM);
              Ach = (model_.ACH_UFCM);
              rc = ((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
              Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
            }
            else
            {
              // no default
            }
    cox = (Cins/Weff_UFCM);
    if (((model_.BULKMOD)!=0))
    {
      cox_acc = ((cox*(model_.EOT))/(model_.EOTACC));
    }
    Weff0 = (Weff_UFCM-(model_.DELTAW));
    WeffCV0 = (Weff_UFCM-(model_.DELTAWCV));
    scl = sqrt((((epssub*Ach)/Cins)*(1.0+((Ach*Cins)/(((2.0*epssub)*Weff_UFCM)*Weff_UFCM)))));
    PHIG_i = ((((model_.PHIG)+(Inv_L*(model_.LPHIG)))+(Inv_NFIN*(model_.NPHIG)))+(Inv_LNFIN*(model_.PPHIG)));
    NGATE_i = ((((model_.NGATE)+(Inv_L*(model_.LNGATE)))+(Inv_NFIN*(model_.NNGATE)))+(Inv_LNFIN*(model_.PNGATE)));
    CIT_i = ((((model_.CIT)+(Inv_L*(model_.LCIT)))+(Inv_NFIN*(model_.NCIT)))+(Inv_LNFIN*(model_.PCIT)));
    CDSC_i = ((((model_.CDSC)+(Inv_L*(model_.LCDSC)))+(Inv_NFIN*(model_.NCDSC)))+(Inv_LNFIN*(model_.PCDSC)));
    CDSCD_i = ((((model_.CDSCD)+(Inv_L*(model_.LCDSCD)))+(Inv_NFIN*(model_.NCDSCD)))+(Inv_LNFIN*(model_.PCDSCD)));
    DVT0_i = ((((model_.DVT0)+(Inv_L*(model_.LDVT0)))+(Inv_NFIN*(model_.NDVT0)))+(Inv_LNFIN*(model_.PDVT0)));
    DVT1_i = ((((model_.DVT1)+(Inv_L*(model_.LDVT1)))+(Inv_NFIN*(model_.NDVT1)))+(Inv_LNFIN*(model_.PDVT1)));
    DVT1SS_i = ((((model_.DVT1SS)+(Inv_L*(model_.LDVT1SS)))+(Inv_NFIN*(model_.NDVT1SS)))+(Inv_LNFIN*(model_.PDVT1SS)));
    PHIN_i = ((((model_.PHIN)+(Inv_L*(model_.LPHIN)))+(Inv_NFIN*(model_.NPHIN)))+(Inv_LNFIN*(model_.PPHIN)));
    ETA0_i = ((((model_.ETA0)+(Inv_L*(model_.LETA0)))+(Inv_NFIN*(model_.NETA0)))+(Inv_LNFIN*(model_.PETA0)));
    DSUB_i = ((((model_.DSUB)+(Inv_L*(model_.LDSUB)))+(Inv_NFIN*(model_.NDSUB)))+(Inv_LNFIN*(model_.PDSUB)));
    K1RSCE_i = ((((model_.K1RSCE)+(Inv_L*(model_.LK1RSCE)))+(Inv_NFIN*(model_.NK1RSCE)))+(Inv_LNFIN*(model_.PK1RSCE)));
    LPE0_i = ((((model_.LPE0)+(Inv_L*(model_.LLPE0)))+(Inv_NFIN*(model_.NLPE0)))+(Inv_LNFIN*(model_.PLPE0)));
    DVTSHIFT_i = ((((model_.DVTSHIFT)+(Inv_L*(model_.LDVTSHIFT)))+(Inv_NFIN*(model_.NDVTSHIFT)))+(Inv_LNFIN*(model_.PDVTSHIFT)));
    K0_i = ((((model_.K0)+(Inv_L*(model_.LK0)))+(Inv_NFIN*(model_.NK0)))+(Inv_LNFIN*(model_.PK0)));
    K01_i = ((((model_.K01)+(Inv_L*(model_.LK01)))+(Inv_NFIN*(model_.NK01)))+(Inv_LNFIN*(model_.PK01)));
    K0SI_i = ((((model_.K0SI)+(Inv_L*(model_.LK0SI)))+(Inv_NFIN*(model_.NK0SI)))+(Inv_LNFIN*(model_.PK0SI)));
    K0SI1_i = ((((model_.K0SI1)+(Inv_L*(model_.LK0SI1)))+(Inv_NFIN*(model_.NK0SI1)))+(Inv_LNFIN*(model_.PK0SI1)));
    K2SI_i = ((((model_.K2SI)+(Inv_L*(model_.LK2SI)))+(Inv_NFIN*(model_.NK2SI)))+(Inv_LNFIN*(model_.PK2SI)));
    K2SI1_i = ((((model_.K2SI1)+(Inv_L*(model_.LK2SI1)))+(Inv_NFIN*(model_.NK2SI1)))+(Inv_LNFIN*(model_.PK2SI1)));
    K0SISAT_i = ((((model_.K0SISAT)+(Inv_L*(model_.LK0SISAT)))+(Inv_NFIN*(model_.NK0SISAT)))+(Inv_LNFIN*(model_.PK0SISAT)));
    K0SISAT1_i = ((((model_.K0SISAT1)+(Inv_L*(model_.LK0SISAT1)))+(Inv_NFIN*(model_.NK0SISAT1)))+(Inv_LNFIN*(model_.PK0SISAT1)));
    K2SISAT_i = ((((model_.K2SISAT)+(Inv_L*(model_.LK2SISAT)))+(Inv_NFIN*(model_.NK2SISAT)))+(Inv_LNFIN*(model_.PK2SISAT)));
    K2SISAT1_i = ((((model_.K2SISAT1)+(Inv_L*(model_.LK2SISAT1)))+(Inv_NFIN*(model_.NK2SISAT1)))+(Inv_LNFIN*(model_.PK2SISAT1)));
    if (((model_.BULKMOD)!=0))
    {
      if (((model_.BULKMOD)==2))
      {
        K2_i = ((((model_.K2)+(Inv_L*(model_.LK2)))+(Inv_NFIN*(model_.NK2)))+(Inv_LNFIN*(model_.PK2)));
        K21_i = ((((model_.K21)+(Inv_L*(model_.LK21)))+(Inv_NFIN*(model_.NK21)))+(Inv_LNFIN*(model_.PK21)));
        K2SAT_i = ((((model_.K2SAT)+(Inv_L*(model_.LK2SAT)))+(Inv_NFIN*(model_.NK2SAT)))+(Inv_LNFIN*(model_.PK2SAT)));
        K2SAT1_i = ((((model_.K2SAT1)+(Inv_L*(model_.LK2SAT1)))+(Inv_NFIN*(model_.NK2SAT1)))+(Inv_LNFIN*(model_.PK2SAT1)));
      }
      PHIBE_i = ((((model_.PHIBE)+(Inv_L*(model_.LPHIBE)))+(Inv_NFIN*(model_.NPHIBE)))+(Inv_LNFIN*(model_.PPHIBE)));
      K1_i = ((((model_.K1)+(Inv_L*(model_.LK1)))+(Inv_NFIN*(model_.NK1)))+(Inv_LNFIN*(model_.PK1)));
      K11_i = ((((model_.K11)+(Inv_L*(model_.LK11)))+(Inv_NFIN*(model_.NK11)))+(Inv_LNFIN*(model_.PK11)));
    }
    QMFACTOR_i = ((((model_.QMFACTOR)+(Inv_L*(model_.LQMFACTOR)))+(Inv_NFIN*(model_.NQMFACTOR)))+(Inv_LNFIN*(model_.PQMFACTOR)));
    QMTCENCV_i = ((((model_.QMTCENCV)+(Inv_L*(model_.LQMTCENCV)))+(Inv_NFIN*(model_.NQMTCENCV)))+(Inv_LNFIN*(model_.PQMTCENCV)));
    QMTCENCVA_i = ((((model_.QMTCENCVA)+(Inv_L*(model_.LQMTCENCVA)))+(Inv_NFIN*(model_.NQMTCENCVA)))+(Inv_LNFIN*(model_.PQMTCENCVA)));
    VSAT_i = ((((model_.VSAT)+(Inv_L*(model_.LVSAT)))+(Inv_NFIN*(model_.NVSAT)))+(Inv_LNFIN*(model_.PVSAT)));
    VSAT1_i = ((((model_.VSAT1)+(Inv_L*(model_.LVSAT1)))+(Inv_NFIN*(model_.NVSAT1)))+(Inv_LNFIN*(model_.PVSAT1)));
    VSATCV_i = ((((model_.VSATCV)+(Inv_L*(model_.LVSATCV)))+(Inv_NFIN*(model_.NVSATCV)))+(Inv_LNFIN*(model_.PVSATCV)));
    DELTAVSAT_i = ((((model_.DELTAVSAT)+(Inv_L*(model_.LDELTAVSAT)))+(Inv_NFIN*(model_.NDELTAVSAT)))+(Inv_LNFIN*(model_.PDELTAVSAT)));
    PSAT_i = ((((model_.PSAT)+(Inv_L*(model_.LPSAT)))+(Inv_NFIN*(model_.NPSAT)))+(Inv_LNFIN*(model_.PPSAT)));
    DELTAVSATCV_i = ((((model_.DELTAVSATCV)+(Inv_L*(model_.LDELTAVSATCV)))+(Inv_NFIN*(model_.NDELTAVSATCV)))+(Inv_LNFIN*(model_.PDELTAVSATCV)));
    PSATCV_i = ((((model_.PSATCV)+(Inv_L*(model_.LPSATCV)))+(Inv_NFIN*(model_.NPSATCV)))+(Inv_LNFIN*(model_.PPSATCV)));
    KSATIV_i = ((((model_.KSATIV)+(Inv_L*(model_.LKSATIV)))+(Inv_NFIN*(model_.NKSATIV)))+(Inv_LNFIN*(model_.PKSATIV)));
    MEXP_i = ((((model_.MEXP)+(Inv_L*(model_.LMEXP)))+(Inv_NFIN*(model_.NMEXP)))+(Inv_LNFIN*(model_.PMEXP)));
    PTWG_i = ((((model_.PTWG)+(Inv_L*(model_.LPTWG)))+(Inv_NFIN*(model_.NPTWG)))+(Inv_LNFIN*(model_.PPTWG)));
    U0_i = ((((model_.U0)+(Inv_L*(model_.LU0)))+(Inv_NFIN*(model_.NU0)))+(Inv_LNFIN*(model_.PU0)));
    ETAMOB_i = ((((model_.ETAMOB)+(Inv_L*(model_.LETAMOB)))+(Inv_NFIN*(model_.NETAMOB)))+(Inv_LNFIN*(model_.PETAMOB)));
    UP_i = ((((model_.UP)+(Inv_L*(model_.LUP)))+(Inv_NFIN*(model_.NUP)))+(Inv_LNFIN*(model_.PUP)));
    UA_i = ((((model_.UA)+(Inv_L*(model_.LUA)))+(Inv_NFIN*(model_.NUA)))+(Inv_LNFIN*(model_.PUA)));
    if (((model_.BULKMOD)!=0))
    {
      UC_i = ((((model_.UC)+(Inv_L*(model_.LUC)))+(Inv_NFIN*(model_.NUC)))+(Inv_LNFIN*(model_.PUC)));
    }
    EU_i = ((((model_.EU)+(Inv_L*(model_.LEU)))+(Inv_NFIN*(model_.NEU)))+(Inv_LNFIN*(model_.PEU)));
    UD_i = ((((model_.UD)+(Inv_L*(model_.LUD)))+(Inv_NFIN*(model_.NUD)))+(Inv_LNFIN*(model_.PUD)));
    UCS_i = ((((model_.UCS)+(Inv_L*(model_.LUCS)))+(Inv_NFIN*(model_.NUCS)))+(Inv_LNFIN*(model_.PUCS)));
    PCLM_i = ((((model_.PCLM)+(Inv_L*(model_.LPCLM)))+(Inv_NFIN*(model_.NPCLM)))+(Inv_LNFIN*(model_.PPCLM)));
    PCLMG_i = ((((model_.PCLMG)+(Inv_L*(model_.LPCLMG)))+(Inv_NFIN*(model_.NPCLMG)))+(Inv_LNFIN*(model_.PPCLMG)));
    PCLMCV_i = ((((model_.PCLMCV)+(Inv_L*(model_.LPCLMCV)))+(Inv_NFIN*(model_.NPCLMCV)))+(Inv_LNFIN*(model_.PPCLMCV)));
    A1_i = ((((model_.A1)+(Inv_L*(model_.LA1)))+(Inv_NFIN*(model_.NA1)))+(Inv_LNFIN*(model_.PA1)));
    A11_i = ((((model_.A11)+(Inv_L*(model_.LA11)))+(Inv_NFIN*(model_.NA11)))+(Inv_LNFIN*(model_.PA11)));
    A2_i = ((((model_.A2)+(Inv_L*(model_.LA2)))+(Inv_NFIN*(model_.NA2)))+(Inv_LNFIN*(model_.PA2)));
    A21_i = ((((model_.A21)+(Inv_L*(model_.LA21)))+(Inv_NFIN*(model_.NA21)))+(Inv_LNFIN*(model_.PA21)));
    RDSW_i = ((((model_.RDSW)+(Inv_L*(model_.LRDSW)))+(Inv_NFIN*(model_.NRDSW)))+(Inv_LNFIN*(model_.PRDSW)));
    RSW_i = ((((model_.RSW)+(Inv_L*(model_.LRSW)))+(Inv_NFIN*(model_.NRSW)))+(Inv_LNFIN*(model_.PRSW)));
    RDW_i = ((((model_.RDW)+(Inv_L*(model_.LRDW)))+(Inv_NFIN*(model_.NRDW)))+(Inv_LNFIN*(model_.PRDW)));
    PRWGD_i = ((((model_.PRWGD)+(Inv_L*(model_.LPRWGD)))+(Inv_NFIN*(model_.NPRWGD)))+(Inv_LNFIN*(model_.PPRWGD)));
    PRWGS_i = ((((model_.PRWGS)+(Inv_L*(model_.LPRWGS)))+(Inv_NFIN*(model_.NPRWGS)))+(Inv_LNFIN*(model_.PPRWGS)));
    WR_i = ((((model_.WR)+(Inv_L*(model_.LWR)))+(Inv_NFIN*(model_.NWR)))+(Inv_LNFIN*(model_.PWR)));
    PDIBL1_i = ((((model_.PDIBL1)+(Inv_L*(model_.LPDIBL1)))+(Inv_NFIN*(model_.NPDIBL1)))+(Inv_LNFIN*(model_.PPDIBL1)));
    PDIBL2_i = ((((model_.PDIBL2)+(Inv_L*(model_.LPDIBL2)))+(Inv_NFIN*(model_.NPDIBL2)))+(Inv_LNFIN*(model_.PPDIBL2)));
    DROUT_i = ((((model_.DROUT)+(Inv_L*(model_.LDROUT)))+(Inv_NFIN*(model_.NDROUT)))+(Inv_LNFIN*(model_.PDROUT)));
    PVAG_i = ((((model_.PVAG)+(Inv_L*(model_.LPVAG)))+(Inv_NFIN*(model_.NPVAG)))+(Inv_LNFIN*(model_.PPVAG)));
    AIGBINV_i = ((((model_.AIGBINV)+(Inv_L*(model_.LAIGBINV)))+(Inv_NFIN*(model_.NAIGBINV)))+(Inv_LNFIN*(model_.PAIGBINV)));
    AIGBINV1_i = ((((model_.AIGBINV1)+(Inv_L*(model_.LAIGBINV1)))+(Inv_NFIN*(model_.NAIGBINV1)))+(Inv_LNFIN*(model_.PAIGBINV1)));
    BIGBINV_i = ((((model_.BIGBINV)+(Inv_L*(model_.LBIGBINV)))+(Inv_NFIN*(model_.NBIGBINV)))+(Inv_LNFIN*(model_.PBIGBINV)));
    CIGBINV_i = ((((model_.CIGBINV)+(Inv_L*(model_.LCIGBINV)))+(Inv_NFIN*(model_.NCIGBINV)))+(Inv_LNFIN*(model_.PCIGBINV)));
    EIGBINV_i = ((((model_.EIGBINV)+(Inv_L*(model_.LEIGBINV)))+(Inv_NFIN*(model_.NEIGBINV)))+(Inv_LNFIN*(model_.PEIGBINV)));
    NIGBINV_i = ((((model_.NIGBINV)+(Inv_L*(model_.LNIGBINV)))+(Inv_NFIN*(model_.NNIGBINV)))+(Inv_LNFIN*(model_.PNIGBINV)));
    AIGBACC_i = ((((model_.AIGBACC)+(Inv_L*(model_.LAIGBACC)))+(Inv_NFIN*(model_.NAIGBACC)))+(Inv_LNFIN*(model_.PAIGBACC)));
    AIGBACC1_i = ((((model_.AIGBACC1)+(Inv_L*(model_.LAIGBACC1)))+(Inv_NFIN*(model_.NAIGBACC1)))+(Inv_LNFIN*(model_.PAIGBACC1)));
    BIGBACC_i = ((((model_.BIGBACC)+(Inv_L*(model_.LBIGBACC)))+(Inv_NFIN*(model_.NBIGBACC)))+(Inv_LNFIN*(model_.PBIGBACC)));
    CIGBACC_i = ((((model_.CIGBACC)+(Inv_L*(model_.LCIGBACC)))+(Inv_NFIN*(model_.NCIGBACC)))+(Inv_LNFIN*(model_.PCIGBACC)));
    NIGBACC_i = ((((model_.NIGBACC)+(Inv_L*(model_.LNIGBACC)))+(Inv_NFIN*(model_.NNIGBACC)))+(Inv_LNFIN*(model_.PNIGBACC)));
    AIGC_i = ((((model_.AIGC)+(Inv_L*(model_.LAIGC)))+(Inv_NFIN*(model_.NAIGC)))+(Inv_LNFIN*(model_.PAIGC)));
    AIGC1_i = ((((model_.AIGC1)+(Inv_L*(model_.LAIGC1)))+(Inv_NFIN*(model_.NAIGC1)))+(Inv_LNFIN*(model_.PAIGC1)));
    BIGC_i = ((((model_.BIGC)+(Inv_L*(model_.LBIGC)))+(Inv_NFIN*(model_.NBIGC)))+(Inv_LNFIN*(model_.PBIGC)));
    CIGC_i = ((((model_.CIGC)+(Inv_L*(model_.LCIGC)))+(Inv_NFIN*(model_.NCIGC)))+(Inv_LNFIN*(model_.PCIGC)));
    PIGCD_i = ((((model_.PIGCD)+(Inv_L*(model_.LPIGCD)))+(Inv_NFIN*(model_.NPIGCD)))+(Inv_LNFIN*(model_.PPIGCD)));
    AIGS_i = ((((model_.AIGS)+(Inv_L*(model_.LAIGS)))+(Inv_NFIN*(model_.NAIGS)))+(Inv_LNFIN*(model_.PAIGS)));
    AIGS1_i = ((((model_.AIGS1)+(Inv_L*(model_.LAIGS1)))+(Inv_NFIN*(model_.NAIGS1)))+(Inv_LNFIN*(model_.PAIGS1)));
    BIGS_i = ((((model_.BIGS)+(Inv_L*(model_.LBIGS)))+(Inv_NFIN*(model_.NBIGS)))+(Inv_LNFIN*(model_.PBIGS)));
    CIGS_i = ((((model_.CIGS)+(Inv_L*(model_.LCIGS)))+(Inv_NFIN*(model_.NCIGS)))+(Inv_LNFIN*(model_.PCIGS)));
    AIGD_i = ((((model_.AIGD)+(Inv_L*(model_.LAIGD)))+(Inv_NFIN*(model_.NAIGD)))+(Inv_LNFIN*(model_.PAIGD)));
    AIGD1_i = ((((model_.AIGD1)+(Inv_L*(model_.LAIGD1)))+(Inv_NFIN*(model_.NAIGD1)))+(Inv_LNFIN*(model_.PAIGD1)));
    BIGD_i = ((((model_.BIGD)+(Inv_L*(model_.LBIGD)))+(Inv_NFIN*(model_.NBIGD)))+(Inv_LNFIN*(model_.PBIGD)));
    CIGD_i = ((((model_.CIGD)+(Inv_L*(model_.LCIGD)))+(Inv_NFIN*(model_.NCIGD)))+(Inv_LNFIN*(model_.PCIGD)));
    NTOX_i = ((((model_.NTOX)+(Inv_L*(model_.LNTOX)))+(Inv_NFIN*(model_.NNTOX)))+(Inv_LNFIN*(model_.PNTOX)));
    POXEDGE_i = ((((model_.POXEDGE)+(Inv_L*(model_.LPOXEDGE)))+(Inv_NFIN*(model_.NPOXEDGE)))+(Inv_LNFIN*(model_.PPOXEDGE)));
    AGIDL_i = ((((model_.AGIDL)+(Inv_L*(model_.LAGIDL)))+(Inv_NFIN*(model_.NAGIDL)))+(Inv_LNFIN*(model_.PAGIDL)));
    BGIDL_i = ((((model_.BGIDL)+(Inv_L*(model_.LBGIDL)))+(Inv_NFIN*(model_.NBGIDL)))+(Inv_LNFIN*(model_.PBGIDL)));
    CGIDL_i = ((((model_.CGIDL)+(Inv_L*(model_.LCGIDL)))+(Inv_NFIN*(model_.NCGIDL)))+(Inv_LNFIN*(model_.PCGIDL)));
    EGIDL_i = ((((model_.EGIDL)+(Inv_L*(model_.LEGIDL)))+(Inv_NFIN*(model_.NEGIDL)))+(Inv_LNFIN*(model_.PEGIDL)));
    PGIDL_i = ((((model_.PGIDL)+(Inv_L*(model_.LPGIDL)))+(Inv_NFIN*(model_.NPGIDL)))+(Inv_LNFIN*(model_.PPGIDL)));
    AGISL_i = ((((model_.AGISL)+(Inv_L*(model_.LAGISL)))+(Inv_NFIN*(model_.NAGISL)))+(Inv_LNFIN*(model_.PAGISL)));
    BGISL_i = ((((model_.BGISL)+(Inv_L*(model_.LBGISL)))+(Inv_NFIN*(model_.NBGISL)))+(Inv_LNFIN*(model_.PBGISL)));
    CGISL_i = ((((model_.CGISL)+(Inv_L*(model_.LCGISL)))+(Inv_NFIN*(model_.NCGISL)))+(Inv_LNFIN*(model_.PCGISL)));
    EGISL_i = ((((model_.EGISL)+(Inv_L*(model_.LEGISL)))+(Inv_NFIN*(model_.NEGISL)))+(Inv_LNFIN*(model_.PEGISL)));
    PGISL_i = ((((model_.PGISL)+(Inv_L*(model_.LPGISL)))+(Inv_NFIN*(model_.NPGISL)))+(Inv_LNFIN*(model_.PPGISL)));
    ALPHA0_i = ((((model_.ALPHA0)+(Inv_L*(model_.LALPHA0)))+(Inv_NFIN*(model_.NALPHA0)))+(Inv_LNFIN*(model_.PALPHA0)));
    ALPHA1_i = ((((model_.ALPHA1)+(Inv_L*(model_.LALPHA1)))+(Inv_NFIN*(model_.NALPHA1)))+(Inv_LNFIN*(model_.PALPHA1)));
    ALPHAII0_i = ((((model_.ALPHAII0)+(Inv_L*(model_.LALPHAII0)))+(Inv_NFIN*(model_.NALPHAII0)))+(Inv_LNFIN*(model_.PALPHAII0)));
    ALPHAII1_i = ((((model_.ALPHAII1)+(Inv_L*(model_.LALPHAII1)))+(Inv_NFIN*(model_.NALPHAII1)))+(Inv_LNFIN*(model_.PALPHAII1)));
    BETA0_i = ((((model_.BETA0)+(Inv_L*(model_.LBETA0)))+(Inv_NFIN*(model_.NBETA0)))+(Inv_LNFIN*(model_.PBETA0)));
    BETAII0_i = ((((model_.BETAII0)+(Inv_L*(model_.LBETAII0)))+(Inv_NFIN*(model_.NBETAII0)))+(Inv_LNFIN*(model_.PBETAII0)));
    BETAII1_i = ((((model_.BETAII1)+(Inv_L*(model_.LBETAII1)))+(Inv_NFIN*(model_.NBETAII1)))+(Inv_LNFIN*(model_.PBETAII1)));
    BETAII2_i = ((((model_.BETAII2)+(Inv_L*(model_.LBETAII2)))+(Inv_NFIN*(model_.NBETAII2)))+(Inv_LNFIN*(model_.PBETAII2)));
    ESATII_i = ((((model_.ESATII)+(Inv_L*(model_.LESATII)))+(Inv_NFIN*(model_.NESATII)))+(Inv_LNFIN*(model_.PESATII)));
    LII_i = ((((model_.LII)+(Inv_L*(model_.LLII)))+(Inv_NFIN*(model_.NLII)))+(Inv_LNFIN*(model_.PLII)));
    SII0_i = ((((model_.SII0)+(Inv_L*(model_.LSII0)))+(Inv_NFIN*(model_.NSII0)))+(Inv_LNFIN*(model_.PSII0)));
    SII1_i = ((((model_.SII1)+(Inv_L*(model_.LSII1)))+(Inv_NFIN*(model_.NSII1)))+(Inv_LNFIN*(model_.PSII1)));
    SII2_i = ((((model_.SII2)+(Inv_L*(model_.LSII2)))+(Inv_NFIN*(model_.NSII2)))+(Inv_LNFIN*(model_.PSII2)));
    SIID_i = ((((model_.SIID)+(Inv_L*(model_.LSIID)))+(Inv_NFIN*(model_.NSIID)))+(Inv_LNFIN*(model_.PSIID)));
    TII_i = ((((model_.TII)+(Inv_L*(model_.LTII)))+(Inv_NFIN*(model_.NTII)))+(Inv_LNFIN*(model_.PTII)));
    CFS_i = ((((model_.CFS)+(Inv_L*(model_.LCFS)))+(Inv_NFIN*(model_.NCFS)))+(Inv_LNFIN*(model_.PCFS)));
    CFD_i = ((((model_.CFD)+(Inv_L*(model_.LCFD)))+(Inv_NFIN*(model_.NCFD)))+(Inv_LNFIN*(model_.PCFD)));
    COVS_i = (((COVS+(Inv_L*(model_.LCOVS)))+(Inv_NFIN*(model_.NCOVS)))+(Inv_LNFIN*(model_.PCOVS)));
    COVD_i = (((COVD+(Inv_L*(model_.LCOVD)))+(Inv_NFIN*(model_.NCOVD)))+(Inv_LNFIN*(model_.PCOVD)));
    CGSL_i = ((((model_.CGSL)+(Inv_L*(model_.LCGSL)))+(Inv_NFIN*(model_.NCGSL)))+(Inv_LNFIN*(model_.PCGSL)));
    CGDL_i = ((((model_.CGDL)+(Inv_L*(model_.LCGDL)))+(Inv_NFIN*(model_.NCGDL)))+(Inv_LNFIN*(model_.PCGDL)));
    CGBL_i = ((((model_.CGBL)+(Inv_L*(model_.LCGBL)))+(Inv_NFIN*(model_.NCGBL)))+(Inv_LNFIN*(model_.PCGBL)));
    CKAPPAS_i = ((((model_.CKAPPAS)+(Inv_L*(model_.LCKAPPAS)))+(Inv_NFIN*(model_.NCKAPPAS)))+(Inv_LNFIN*(model_.PCKAPPAS)));
    CKAPPAD_i = ((((model_.CKAPPAD)+(Inv_L*(model_.LCKAPPAD)))+(Inv_NFIN*(model_.NCKAPPAD)))+(Inv_LNFIN*(model_.PCKAPPAD)));
    CKAPPAB_i = ((((model_.CKAPPAB)+(Inv_L*(model_.LCKAPPAB)))+(Inv_NFIN*(model_.NCKAPPAB)))+(Inv_LNFIN*(model_.PCKAPPAB)));
    NTGEN_i = ((((model_.NTGEN)+(Inv_L*(model_.LNTGEN)))+(Inv_NFIN*(model_.NNTGEN)))+(Inv_LNFIN*(model_.PNTGEN)));
    AIGEN_i = ((((model_.AIGEN)+(Inv_L*(model_.LAIGEN)))+(Inv_NFIN*(model_.NAIGEN)))+(Inv_LNFIN*(model_.PAIGEN)));
    BIGEN_i = ((((model_.BIGEN)+(Inv_L*(model_.LBIGEN)))+(Inv_NFIN*(model_.NBIGEN)))+(Inv_LNFIN*(model_.PBIGEN)));
    if (((model_.ASYMMOD)!=0))
    {
      CDSCDR_i = ((((model_.CDSCDR)+(Inv_L*(model_.LCDSCDR)))+(Inv_NFIN*(model_.NCDSCDR)))+(Inv_LNFIN*(model_.PCDSCDR)));
      CITR_i = ((((model_.CITR)+(Inv_L*(model_.LCITR)))+(Inv_NFIN*(model_.NCITR)))+(Inv_LNFIN*(model_.PCITR)));
      ETA0R_i = ((((model_.ETA0R)+(Inv_L*(model_.LETA0R)))+(Inv_NFIN*(model_.NETA0R)))+(Inv_LNFIN*(model_.PETA0R)));
      VSAT1R_i = ((((model_.VSAT1R)+(Inv_L*(model_.LVSAT1R)))+(Inv_NFIN*(model_.NVSAT1R)))+(Inv_LNFIN*(model_.PVSAT1R)));
      MEXPR_i = ((((model_.MEXPR)+(Inv_L*(model_.LMEXPR)))+(Inv_NFIN*(model_.NMEXPR)))+(Inv_LNFIN*(model_.PMEXPR)));
      PTWGR_i = ((((model_.PTWGR)+(Inv_L*(model_.LPTWGR)))+(Inv_NFIN*(model_.NPTWGR)))+(Inv_LNFIN*(model_.PPTWGR)));
      PDIBL1R_i = ((((model_.PDIBL1R)+(Inv_L*(model_.LPDIBL1R)))+(Inv_NFIN*(model_.NPDIBL1R)))+(Inv_LNFIN*(model_.PPDIBL1R)));
      PDIBL2R_i = ((((model_.PDIBL2R)+(Inv_L*(model_.LPDIBL2R)))+(Inv_NFIN*(model_.NPDIBL2R)))+(Inv_LNFIN*(model_.PPDIBL2R)));
      PCLMR_i = ((((model_.PCLMR)+(Inv_L*(model_.LPCLMR)))+(Inv_NFIN*(model_.NPCLMR)))+(Inv_LNFIN*(model_.PPCLMR)));
      DVTSHIFTR_i = ((((model_.DVTSHIFTR)+(Inv_L*(model_.LDVTSHIFTR)))+(Inv_NFIN*(model_.NDVTSHIFTR)))+(Inv_LNFIN*(model_.PDVTSHIFTR)));
      VSATR_i = ((((model_.VSATR)+(Inv_L*(model_.LVSATR)))+(Inv_NFIN*(model_.NVSATR)))+(Inv_LNFIN*(model_.PVSATR)));
      KSATIVR_i = ((((model_.KSATIVR)+(Inv_L*(model_.LKSATIVR)))+(Inv_NFIN*(model_.NKSATIVR)))+(Inv_LNFIN*(model_.PKSATIVR)));
      U0R_i = ((((model_.U0R)+(Inv_L*(model_.LU0R)))+(Inv_NFIN*(model_.NU0R)))+(Inv_LNFIN*(model_.PU0R)));
      UAR_i = ((((model_.UAR)+(Inv_L*(model_.LUAR)))+(Inv_NFIN*(model_.NUAR)))+(Inv_LNFIN*(model_.PUAR)));
      UPR_i = ((((model_.UPR)+(Inv_L*(model_.LUPR)))+(Inv_NFIN*(model_.NUPR)))+(Inv_LNFIN*(model_.PUPR)));
      if (((model_.BULKMOD)!=0))
      {
        UCR_i = ((((model_.UCR)+(Inv_L*(model_.LUCR)))+(Inv_NFIN*(model_.NUCR)))+(Inv_LNFIN*(model_.PUCR)));
      }
      EUR_i = ((((model_.EUR)+(Inv_L*(model_.LEUR)))+(Inv_NFIN*(model_.NEUR)))+(Inv_LNFIN*(model_.PEUR)));
      UDR_i = ((((model_.UDR)+(Inv_L*(model_.LUDR)))+(Inv_NFIN*(model_.NUDR)))+(Inv_LNFIN*(model_.PUDR)));
    }
    if (((model_.NQSMOD)==1))
    {
      std::cerr  << " Although the model selector NQSMOD is set to 1, the NQS gate resistance model is not activated in the Verilog-A code. Please uncomment `define __NQSMOD1__ in bsimcmg.va to activate it." <<  std::endl; 
    }
    if (((model_.NQSMOD)==2))
    {
      std::cerr  << " Although the model selector NQSMOD is set to 2, the NQS gate resistance model is not activated in the Verilog-A code. Please uncomment `define __NQSMOD2__ in bsimcmg.va to activate it." <<  std::endl; 
    }
    UTE_i = ((((model_.UTE)+(Inv_L*(model_.LUTE)))+(Inv_NFIN*(model_.NUTE)))+(Inv_LNFIN*(model_.PUTE)));
    UTL_i = ((((model_.UTL)+(Inv_L*(model_.LUTL)))+(Inv_NFIN*(model_.NUTL)))+(Inv_LNFIN*(model_.PUTL)));
    EMOBT_i = ((((model_.EMOBT)+(Inv_L*(model_.LEMOBT)))+(Inv_NFIN*(model_.NEMOBT)))+(Inv_LNFIN*(model_.PEMOBT)));
    UA1_i = ((((model_.UA1)+(Inv_L*(model_.LUA1)))+(Inv_NFIN*(model_.NUA1)))+(Inv_LNFIN*(model_.PUA1)));
    if (((model_.BULKMOD)!=0))
    {
      UC1_i = ((((model_.UC1)+(Inv_L*(model_.LUC1)))+(Inv_NFIN*(model_.NUC1)))+(Inv_LNFIN*(model_.PUC1)));
    }
    UD1_i = ((((model_.UD1)+(Inv_L*(model_.LUD1)))+(Inv_NFIN*(model_.NUD1)))+(Inv_LNFIN*(model_.PUD1)));
    UCSTE_i = ((((model_.UCSTE)+(Inv_L*(model_.LUCSTE)))+(Inv_NFIN*(model_.NUCSTE)))+(Inv_LNFIN*(model_.PUCSTE)));
    PTWGT_i = ((((model_.PTWGT)+(Inv_L*(model_.LPTWGT)))+(Inv_NFIN*(model_.NPTWGT)))+(Inv_LNFIN*(model_.PPTWGT)));
    AT_i = ((((model_.AT)+(Inv_L*(model_.LAT)))+(Inv_NFIN*(model_.NAT)))+(Inv_LNFIN*(model_.PAT)));
    ATCV_i = ((((model_.ATCV)+(Inv_L*(model_.LATCV)))+(Inv_NFIN*(model_.NATCV)))+(Inv_LNFIN*(model_.PATCV)));
    PRT_i = ((((model_.PRT)+(Inv_L*(model_.LPRT)))+(Inv_NFIN*(model_.NPRT)))+(Inv_LNFIN*(model_.PPRT)));
    KT1_i = ((((model_.KT1)+(Inv_L*(model_.LKT1)))+(Inv_NFIN*(model_.NKT1)))+(Inv_LNFIN*(model_.PKT1)));
    TSS_i = ((((model_.TSS)+(Inv_L*(model_.LTSS)))+(Inv_NFIN*(model_.NTSS)))+(Inv_LNFIN*(model_.PTSS)));
    IIT_i = ((((model_.IIT)+(Inv_L*(model_.LIIT)))+(Inv_NFIN*(model_.NIIT)))+(Inv_LNFIN*(model_.PIIT)));
    TGIDL_i = ((((model_.TGIDL)+(Inv_L*(model_.LTGIDL)))+(Inv_NFIN*(model_.NTGIDL)))+(Inv_LNFIN*(model_.PTGIDL)));
    IGT_i = ((((model_.IGT)+(Inv_L*(model_.LIGT)))+(Inv_NFIN*(model_.NIGT)))+(Inv_LNFIN*(model_.PIGT)));
    if (((model_.ASYMMOD)!=0))
    {
      UTER_i = ((((model_.UTER)+(Inv_L*(model_.LUTER)))+(Inv_NFIN*(model_.NUTER)))+(Inv_LNFIN*(model_.PUTER)));
      UTLR_i = ((((model_.UTLR)+(Inv_L*(model_.LUTLR)))+(Inv_NFIN*(model_.NUTLR)))+(Inv_LNFIN*(model_.PUTLR)));
      UA1R_i = ((((model_.UA1R)+(Inv_L*(model_.LUA1R)))+(Inv_NFIN*(model_.NUA1R)))+(Inv_LNFIN*(model_.PUA1R)));
      UD1R_i = ((((model_.UD1R)+(Inv_L*(model_.LUD1R)))+(Inv_NFIN*(model_.NUD1R)))+(Inv_LNFIN*(model_.PUD1R)));
      ATR_i = ((((model_.ATR)+(Inv_L*(model_.LATR)))+(Inv_NFIN*(model_.NATR)))+(Inv_LNFIN*(model_.PATR)));
      if (((model_.BULKMOD)!=0))
      {
        UC1R_i = ((((model_.UC1R)+(Inv_L*(model_.LUC1R)))+(Inv_NFIN*(model_.NUC1R)))+(Inv_LNFIN*(model_.PUC1R)));
      }
    }
    if (((model_.PHIGN1)!=0.0))
    {
      PHIG_i = (PHIG_i*(1.0+(((model_.PHIGN1)/NFIN)*AnalogFunctions::lln((1.0+(NFIN/(model_.PHIGN2)))))));
    }
    if (((model_.ETA0N1)!=0.0))
    {
      ETA0_i = (ETA0_i*(1.0+(((model_.ETA0N1)/NFIN)*AnalogFunctions::lln((1.0+(NFIN/(model_.ETA0N2)))))));
    }
    if (((model_.CDSCN1)!=0.0))
    {
      CDSC_i = (CDSC_i*(1.0+(((model_.CDSCN1)/NFIN)*AnalogFunctions::lln((1.0+(NFIN/(model_.CDSCN2)))))));
    }
    if (((model_.CDSCDN1)!=0.0))
    {
      CDSCD_i = (CDSCD_i*(1.0+(((model_.CDSCDN1)/NFIN)*AnalogFunctions::lln((1.0+(NFIN/(model_.CDSCDN2)))))));
    }
    if (((model_.CDSCDRN1)!=0.0))
    {
      CDSCDR_i = (CDSCDR_i*(1.0+(((model_.CDSCDRN1)/NFIN)*AnalogFunctions::lln((1.0+(NFIN/(model_.CDSCDRN2)))))));
    }
    if (((model_.VSATN1)!=0.0))
    {
      VSAT_i = (VSAT_i*(1.0+(((model_.VSATN1)/NFIN)*AnalogFunctions::lln((1.0+(NFIN/(model_.VSATN2)))))));
    }
    if (((model_.VSAT1N1)!=0.0))
    {
      VSAT1_i = (VSAT1_i*(1.0+(((model_.VSAT1N1)/NFIN)*AnalogFunctions::lln((1.0+(NFIN/(model_.VSAT1N2)))))));
    }
    if (((model_.VSAT1RN1)!=0.0))
    {
      VSAT1R_i = (VSAT1R_i*(1.0+(((model_.VSAT1RN1)/NFIN)*AnalogFunctions::lln((1.0+(NFIN/(model_.VSAT1RN2)))))));
    }
    if (((model_.U0N1)!=0.0))
    {
      U0_i = (U0_i*(1.0+(((model_.U0N1)/NFIN)*AnalogFunctions::lln((1.0+(NFIN/(model_.U0N2)))))));
    }
    if (given("NFINNOM"))
    {
      PHIG_i = (PHIG_i*(1.0+(((NFIN-NFINNOM)*(model_.PHIGLT))*Leff)));
      ETA0_i = (ETA0_i*(1.0+(((NFIN-NFINNOM)*(model_.ETA0LT))*Leff)));
      U0_i = (U0_i*(1.0+(((NFIN-NFINNOM)*(model_.U0LT))*Leff)));
    }
    if (((model_.U0N1R)!=0.0))
    {
      U0R_i = (U0R_i*(1.0+(((model_.U0N1R)/NFIN)*AnalogFunctions::lln((1.0+(NFIN/(model_.U0N2R)))))));
    }
    PHIG_i = (PHIG_i+((model_.PHIGL)*Leff));
    if (((model_.LPA)>0.0))
    {
      U0_i = (U0_i*(1.0-(UP_i*pow(Leff,(-(model_.LPA))))));
    }
    else
    {
      U0_i = (U0_i*(1.0-UP_i));
    }
    UA_i = (UA_i+((model_.AUA)*AnalogFunctions::lexp(((-Leff)/(model_.BUA)))));
    UD_i = (UD_i+((model_.AUD)*AnalogFunctions::lexp(((-Leff)/(model_.BUD)))));
    EU_i = (EU_i+((model_.AEU)*AnalogFunctions::lexp(((-Leff)/(model_.BEU)))));
    if (((model_.ASYMMOD)!=0))
    {
      if (((model_.LPAR)>0.0))
      {
        U0R_i = (U0R_i*(1.0-(UPR_i*pow(Leff,(-(model_.LPAR))))));
      }
      else
      {
        U0R_i = (U0R_i*(1.0-UPR_i));
      }
      UAR_i = (UAR_i+((model_.AUAR)*AnalogFunctions::lexp(((-Leff)/(model_.BUAR)))));
      UDR_i = (UDR_i+((model_.AUDR)*AnalogFunctions::lexp(((-Leff)/(model_.BUDR)))));
      EUR_i = (EUR_i+((model_.AEUR)*AnalogFunctions::lexp(((-Leff)/(model_.BEUR)))));
    }
    if (((model_.RDSMOD)==1))
    {
      RSW_i = (RSW_i+((model_.ARSW)*AnalogFunctions::lexp(((-Leff)/(model_.BRSW)))));
      RDW_i = (RDW_i+((model_.ARDW)*AnalogFunctions::lexp(((-Leff)/(model_.BRDW)))));
    }
    else
    {
      RDSW_i = (RDSW_i+((model_.ARDSW)*AnalogFunctions::lexp(((-Leff)/(model_.BRDSW)))));
    }
    PCLM_i = (PCLM_i+((model_.APCLM)*AnalogFunctions::lexp(((-Leff)/(model_.BPCLM)))));
    if (((model_.ASYMMOD)!=0))
    {
      PCLMR_i = (PCLMR_i+((model_.APCLMR)*pow(Leff,(-(model_.BPCLMR)))));
    }
    MEXP_i = (MEXP_i+((model_.AMEXP)*pow(Leff,(-(model_.BMEXP)))));
    if (((model_.ASYMMOD)!=0))
    {
      MEXPR_i = (MEXPR_i+((model_.AMEXPR)*pow(Leff,(-(model_.BMEXPR)))));
    }
    PTWG_i = (PTWG_i+((model_.APTWG)*AnalogFunctions::lexp(((-Leff)/(model_.BPTWG)))));
    if (((model_.ASYMMOD)!=0))
    {
      PTWGR_i = (PTWGR_i+((model_.APTWG)*AnalogFunctions::lexp(((-Leff)/(model_.BPTWG)))));
    }
    VSAT_i = (VSAT_i+((model_.AVSAT)*AnalogFunctions::lexp(((-Leff)/(model_.BVSAT)))));
    VSAT1_i = (VSAT1_i+((model_.AVSAT1)*AnalogFunctions::lexp(((-Leff)/(model_.BVSAT1)))));
    if (((model_.ASYMMOD)!=0))
    {
      VSAT1R_i = (VSAT1R_i+((model_.AVSAT1)*AnalogFunctions::lexp(((-Leff)/(model_.BVSAT1)))));
    }
    PSAT_i = (PSAT_i+((model_.APSAT)*AnalogFunctions::lexp(((-Leff)/(model_.BPSAT)))));
    PSATCV_i = (PSATCV_i+((model_.APSATCV)*AnalogFunctions::lexp(((-Leff)/(model_.BPSATCV)))));
    VSATCV_i = (VSATCV_i+((model_.AVSATCV)*AnalogFunctions::lexp(((-LeffCV)/(model_.BVSATCV)))));
    DVTP0_i = ((model_.DVTP0)+((model_.ADVTP0)*AnalogFunctions::lexp(((-Leff)/(model_.BDVTP0)))));
    DVTP1_i = ((model_.DVTP1)+((model_.ADVTP1)*AnalogFunctions::lexp(((-Leff)/(model_.BDVTP1)))));
    if (((QMTCENCV_i>0.0)||(QMTCENCVA_i>0.0)))
    {
      MTcen = (1.0+((model_.AQMTCEN)*AnalogFunctions::lexp(((-((2.0*Ach)/Weff_UFCM))/(model_.BQMTCEN)))));
      Tcen0 = (((2.0*Ach)/Weff_UFCM)*MTcen);
    }
    if ((LeffCV<=1.0e-9))
    {
      std::cerr  << "Warning: LeffCV = %e <= 1.0e-9." << LeffCV <<  std::endl; 
    }
    if (((model_.BULKMOD)!=0))
    {
      if ((LeffCV_acc<=1.0e-9))
      {
        std::cerr  << "Warning: LeffCV_acc = %e <= 1.0e-9." << LeffCV_acc <<  std::endl; 
      }
    }
    if ((Weff0<=1.0e-9))
    {
      std::cerr  << "Warning: Weff0 = %e <= 1.0e-9." << Weff0 <<  std::endl; 
    }
    if ((WeffCV0<=1.0e-9))
    {
      std::cerr  << "Warning: WeffCV0 = %e <= 1.0e-9." << WeffCV0 <<  std::endl; 
    }
    if ((NBODY_i<=0.0))
    {
      std::cerr  << "Fatal: NBODY_i = %e is not positive." << NBODY_i <<  std::endl; 
      UserError0(*this) << "$finish called." << std::endl; 
    }
    else
    {
      if ((NBODY_i<=1.0e18))
      {
        std::cerr  << "Warning: NBODY_i = %e m^-3 may be too small." << NBODY_i <<  std::endl; 
      }
    }
    if ((NGATE_i<0.0))
    {
      std::cerr  << "Fatal: NGATE_i = %e is negative." << NGATE_i <<  std::endl; 
      UserError0(*this) << "$finish called." << std::endl; 
    }
    else
    {
      if (((NGATE_i!=0.0)&&(NGATE_i<=1.0e24)))
      {
        std::cerr  << "Warning: NGATE_i = %e may be too small." << NGATE_i <<  std::endl; 
      }
      else
      {
        if ((NGATE_i>1.0e31))
        {
          std::cerr  << "Fatal: NGATE_i = %e is too high." << NGATE_i <<  std::endl; 
          UserError0(*this) << "$finish called." << std::endl; 
        }
      }
    }
    if ((DVT0_i<0.0))
    {
      std::cerr  << "Warning: DVT0_i = %e is negative." << DVT0_i <<  std::endl; 
    }
    if ((PHIG_i<=0.0))
    {
      std::cerr  << "Fatal: PHIG_i = %e is not positive." << PHIG_i <<  std::endl; 
      UserError0(*this) << "$finish called." << std::endl; 
    }
    if ((VSAT_i<=0.0))
    {
      std::cerr  << "Fatal: VSAT_i = %e is not positive." << VSAT_i <<  std::endl; 
      UserError0(*this) << "$finish called." << std::endl; 
    }
    if ((VSAT1_i<=0.0))
    {
      std::cerr  << "Fatal: VSAT1_i = %e is not positive." << VSAT1_i <<  std::endl; 
      UserError0(*this) << "$finish called." << std::endl; 
    }
    if ((((model_.ASYMMOD)!=0)&&(VSAT1R_i<=0.0)))
    {
      std::cerr  << "Fatal: VSAT1R_i = %e is not positive." << VSAT1R_i <<  std::endl; 
      UserError0(*this) << "$finish called." << std::endl; 
    }
    if ((DVT1_i<=0.0))
    {
      std::cerr  << "Fatal: DVT1_i = %e is not positive." << DVT1_i <<  std::endl; 
      UserError0(*this) << "$finish called." << std::endl; 
    }
    if ((DVT1SS_i<=0.0))
    {
      std::cerr  << "Fatal: DVT1SS_i = %e is not positive." << DVT1SS_i <<  std::endl; 
      UserError0(*this) << "$finish called." << std::endl; 
    }
    if ((CDSC_i<0.0))
    {
      std::cerr  << "Warning: CDSC_i = %e is negative." << CDSC_i <<  std::endl; 
    }
    if ((CDSCD_i<0.0))
    {
      std::cerr  << "Warning: CDSCD_i = %e is negative." << CDSCD_i <<  std::endl; 
    }
    if ((((model_.ASYMMOD)!=0)&&(CDSCDR_i<0.0)))
    {
      std::cerr  << "Warning: CDSCDR_i = %e is negative." << CDSCDR_i <<  std::endl; 
    }
    if ((DSUB_i<=0.0))
    {
      std::cerr  << "Fatal: DSUB_i = %e is not positive." << DSUB_i <<  std::endl; 
      UserError0(*this) << "$finish called." << std::endl; 
    }
    if ((ETA0_i<0.0))
    {
      std::cerr  << "Warning: ETA0_i = %e is negative, setting it to 0" << ETA0_i <<  std::endl; 
      ETA0_i = 0.0;
    }
    if ((ETA0R_i<0.0))
    {
      std::cerr  << "Warning: ETA0R_i = %e is negative, setting it to 0" << ETA0R_i <<  std::endl; 
      ETA0R_i = 0.0;
    }
    if ((LPE0_i<(-Leff)))
    {
      std::cerr  << "Warning: LPE0_i = %e is less than -Leff. Clipping LPE0_i to 0" << LPE0_i <<  std::endl; 
      LPE0_i = 0.0;
    }
    if ((K0SI_i<=0.0))
    {
      std::cerr  << "Warning: K0SI_i = %e is not positive, setting it to 0." << K0SI_i <<  std::endl; 
      K0SI_i = 0.0;
    }
    if ((K2SI_i<=0.0))
    {
      std::cerr  << "Warning: K2SI_i = %e is not positive, setting it to 0." << K2SI_i <<  std::endl; 
      K2SI_i = 0.0;
    }
    if (((PHIBE_i<0.2)&&((model_.BULKMOD)!=0)))
    {
      std::cerr  << "Warning: PHIBE_i = %e is less than 0.2, setting it to 0.2." << PHIBE_i <<  std::endl; 
      PHIBE_i = 0.2;
    }
    if (((PHIBE_i>1.2)&&((model_.BULKMOD)!=0)))
    {
      std::cerr  << "Warning: PHIBE_i = %e is larger than 1.2, setting it to 1.2." << PHIBE_i <<  std::endl; 
      PHIBE_i = 1.2;
    }
    if ((PSAT_i<2.0))
    {
      std::cerr  << "Warning: PSAT_i = %e is less than 2.0, setting it to 2.0." << PSAT_i <<  std::endl; 
      PSAT_i = 2.0;
    }
    if ((PSATCV_i<2.0))
    {
      std::cerr  << "Warning: PSATCV_i = %e is less than 2.0, setting it to 2.0." << PSATCV_i <<  std::endl; 
      PSATCV_i = 2.0;
    }
    if ((U0_i<0.0))
    {
      std::cerr  << "Warning: U0_i = %e is negative, setting it to the default value." << U0_i <<  std::endl; 
      U0_i = 0.03;
    }
    if ((UA_i<0.0))
    {
      std::cerr  << "Warning: UA_i = %e is negative, setting it to 0." << UA_i <<  std::endl; 
      UA_i = 0.0;
    }
    if ((EU_i<0.0))
    {
      std::cerr  << "Warning: EU_i = %e is negative, setting it to 0." << EU_i <<  std::endl; 
      EU_i = 0.0;
    }
    if ((UD_i<0.0))
    {
      std::cerr  << "Warning: UD_i = %e is negative, setting it to 0." << UD_i <<  std::endl; 
      UD_i = 0.0;
    }
    if ((UCS_i<0.0))
    {
      std::cerr  << "Warning: UCS_i = %e is negative, setting it to 0." << UCS_i <<  std::endl; 
      UCS_i = 0.0;
    }
    if ((ETAMOB_i<0.0))
    {
      std::cerr  << "Warning: ETAMOB_i = %e is negative, setting it to 0" << ETAMOB_i <<  std::endl; 
      ETAMOB_i = 0.0;
    }
    RDSWMIN_i = (model_.RDSWMIN);
    if ((RDSWMIN_i<0.0))
    {
      std::cerr  << "Warning: RDSWMIN = %e is negative.  Set to zero" << RDSWMIN_i <<  std::endl; 
      RDSWMIN_i = 0.0;
    }
    if ((RDSW_i<0.0))
    {
      std::cerr  << "Warning: RDSW_i = %e is negative.  Set to zero" << RDSW_i <<  std::endl; 
      RDSW_i = 0.0;
    }
    RSWMIN_i = (model_.RSWMIN);
    if ((RSWMIN_i<0.0))
    {
      std::cerr  << "Warning: RSWMIN = %e is negative.  Set to zero" << RSWMIN_i <<  std::endl; 
      RSWMIN_i = 0.0;
    }
    if ((RSW_i<0.0))
    {
      std::cerr  << "Warning: RSW_i = %e is negative.  Set to zero" << RSW_i <<  std::endl; 
      RSW_i = 0.0;
    }
    RDWMIN_i = (model_.RDWMIN);
    if ((RDWMIN_i<0.0))
    {
      std::cerr  << "Warning: RDWMIN = %e is negative.  Set to zero" << RDWMIN_i <<  std::endl; 
      RDWMIN_i = 0.0;
    }
    if ((RDW_i<0))
    {
      std::cerr  << "Warning: RDW_i = %e is negative.  Set to zero" << RDW_i <<  std::endl; 
      RDW_i = 0.0;
    }
    if ((PRWGD_i<0.0))
    {
      std::cerr  << "Warning: PRWGD_i = %e is negative.  Set to zero" << PRWGD_i <<  std::endl; 
      PRWGD_i = 0.0;
    }
    if ((PRWGS_i<0.0))
    {
      std::cerr  << "Warning: PRWGS_i = %e is negative.  Set to zero" << PRWGS_i <<  std::endl; 
      PRWGS_i = 0.0;
    }
    if ((PCLM_i<0))
    {
      std::cerr  << "Warning: PCLM_i = %e is negative." << PCLM_i <<  std::endl; 
    }
    if ((PDIBL1_i<0.0))
    {
      std::cerr  << "Warning: PDIBL1_i = %e is negative." << PDIBL1_i <<  std::endl; 
    }
    if (((model_.ASYMMOD)!=0))
    {
      if ((PDIBL1R_i<0.0))
      {
        std::cerr  << "Warning: PDIBL1R_i = %e is negative." << PDIBL1R_i <<  std::endl; 
      }
      if ((PDIBL2R_i<0.0))
      {
        std::cerr  << "Warning: PDIBL2R_i = %e is negative." << PDIBL2R_i <<  std::endl; 
      }
      if ((U0R_i<0))
      {
        std::cerr  << "Warning: U0R_i = %e is negative, setting it to 0." << U0R_i <<  std::endl; 
        U0R_i = 0.0;
      }
      if ((UAR_i<0.0))
      {
        std::cerr  << "Warning: UAR_i = %e is negative, setting it to 0." << UAR_i <<  std::endl; 
        UAR_i = 0.0;
      }
      if ((EUR_i<0.0))
      {
        std::cerr  << "Warning: EUR_i = %e is negative, setting it to 0." << EUR_i <<  std::endl; 
        EUR_i = 0.0;
      }
      if ((UDR_i<0.0))
      {
        std::cerr  << "Warning: UDR_i = %e is negative, setting it to 0." << UDR_i <<  std::endl; 
        UDR_i = 0.0;
      }
    }
    if ((PDIBL2_i<0.0))
    {
      std::cerr  << "Warning: PDIBL2_i = %e is negative." << PDIBL2_i <<  std::endl; 
    }
    if ((DROUT_i<=0.0))
    {
      std::cerr  << "Fatal: DROUT_i = %e is non-positive." << DROUT_i <<  std::endl; 
      UserError0(*this) << "$finish called." << std::endl; 
    }
    if ((MEXP_i<2.0))
    {
      std::cerr  << "Warning: MEXP_i = %e < 2. Setting MEXP_i = 2." << MEXP_i <<  std::endl; 
      MEXP_i = 2.0;
    }
    if (((model_.ASYMMOD)!=0))
    {
      if ((MEXPR_i<2.0))
      {
        std::cerr  << "Warning: MEXPR_i = %e < 2.  Setting MEXPR_i = 2." << MEXPR_i <<  std::endl; 
        MEXPR_i = 2.0;
      }
    }
    if ((PTWG_i<0))
    {
      std::cerr  << "Warning: PTWG_i = %e is negative, setting it to 0." << PTWG_i <<  std::endl; 
      PTWG_i = 0.0;
    }
    if ((QMTCENCV_i>0.0))
    {
      if (((model_.QM0)<=0.0))
      {
        std::cerr  << "Fatal: QM0 = %e is non-positive." << (model_.QM0) <<  std::endl; 
        UserError0(*this) << "$finish called." << std::endl; 
      }
    }
    if ((((model_.BULKMOD)!=0)&&(QMTCENCVA_i>0.0)))
    {
      if (((model_.QM0ACC)<=0.0))
      {
        std::cerr  << "Fatal: QM0ACC = %e is non-positive." << (model_.QM0ACC) <<  std::endl; 
        UserError0(*this) << "$finish called." << std::endl; 
      }
    }
    if ((CGIDL_i<0.0))
    {
      std::cerr  << "Warning: CGIDL_i = %e < 0.  Setting CGIDL_i = 0." << CGIDL_i <<  std::endl; 
      CGIDL_i = 0.0;
    }
    if ((CGISL_i<0.0))
    {
      std::cerr  << "Warning: CGISL_i = %e < 0.  Setting CGISL_i = 0." << CGISL_i <<  std::endl; 
      CGISL_i = 0.0;
    }
    if (((model_.IGBMOD)!=0))
    {
      if ((NIGBINV_i<=0.0))
      {
        std::cerr  << "Fatal: NIGBINV_i = %e is non-positive." << NIGBINV_i <<  std::endl; 
        UserError0(*this) << "$finish called." << std::endl; 
      }
      if ((NIGBACC_i<=0.0))
      {
        std::cerr  << "Fatal: NIGBACC_i = %e is non-positive." << NIGBACC_i <<  std::endl; 
        UserError0(*this) << "$finish called." << std::endl; 
      }
    }
    if (((model_.IGCMOD)!=0))
    {
      if ((POXEDGE_i<=0.0))
      {
        std::cerr  << "Fatal: POXEDGE_i = %e is non-positive." << POXEDGE_i <<  std::endl; 
        UserError0(*this) << "$finish called." << std::endl; 
      }
      if ((PIGCD_i<=0.0))
      {
        std::cerr  << "Fatal: PIGCD_i = %e is non-positive." << PIGCD_i <<  std::endl; 
        UserError0(*this) << "$finish called." << std::endl; 
      }
    }
    if ((((model_.IGCMOD)!=0)||((model_.IGBMOD)!=0)))
    {
      if (((model_.TOXREF)<=0))
      {
        std::cerr  << "Fatal: TOXREF = %e is non-positive." << (model_.TOXREF) <<  std::endl; 
        UserError0(*this) << "$finish called." << std::endl; 
      }
    }
    if (((model_.LINTIGEN)>=(Leff/2.0)))
    {
      std::cerr  << "Warning: LINTIGEN = %e is too large - Leff for r/g current is negative.  Re-setting LINTIGEN = 0." << (model_.LINTIGEN) <<  std::endl; 
      LINTIGEN_i = 0.0;
    }
    else
    {
      LINTIGEN_i = (model_.LINTIGEN);
    }
    if ((NTGEN_i<=0.0))
    {
      std::cerr  << "Fatal: NTGEN_i = %e is non-positive." << NTGEN_i <<  std::endl; 
      UserError0(*this) << "$finish called." << std::endl; 
    }
    if (((model_.IIMOD)==2))
    {
      if ((BETAII0_i<0.0))
      {
        std::cerr  << "Warning:  BETAII0_i = %e is negative." << BETAII0_i <<  std::endl; 
      }
      if ((BETAII1_i<0.0))
      {
        std::cerr  << "Warning:  BETAII1_i = %e is negative." << BETAII1_i <<  std::endl; 
      }
      if ((BETAII2_i<0.0))
      {
        std::cerr  << "Warning:  BETAII2_i = %e is negative." << BETAII2_i <<  std::endl; 
      }
      if ((ESATII_i<0.0))
      {
        std::cerr  << "Warning:  ESATII_i = %e is negative." << ESATII_i <<  std::endl; 
      }
      if ((LII_i<0.0))
      {
        std::cerr  << "Warning:  LII_i = %e is negative." << LII_i <<  std::endl; 
      }
      if ((SII1_i<0.0))
      {
        std::cerr  << "Warning:  SII1_i = %e is negative." << (model_.SII1) <<  std::endl; 
      }
      if ((SII2_i<0.0))
      {
        std::cerr  << "Warning:  SII2_i = %e is negative." << SII2_i <<  std::endl; 
      }
      if ((SIID_i<0.0))
      {
        std::cerr  << "Warning:  SIID_i = %e is negative." << SIID_i <<  std::endl; 
      }
    }
    if (((model_.EF)<=0.0))
    {
      std::cerr  << "Fatal: EF = %e is non-positive." << (model_.EF) <<  std::endl; 
      UserError0(*this) << "$finish called." << std::endl; 
    }
    else
    {
      if (((model_.EF)>2.0))
      {
        std::cerr  << "Fatal: EF = %e > 2.0." << (model_.EF) <<  std::endl; 
        UserError0(*this) << "$finish called." << std::endl; 
      }
    }
    if (((model_.LINTNOI)>=(Leff/2.0)))
    {
      std::cerr  << "Warning: LINTNOI = %e is too large - Leff for noise is negative.  Re-setting LINTNOI = 0." << (model_.LINTNOI) <<  std::endl; 
      LINTNOI_i = 0.0;
    }
    else
    {
      LINTNOI_i = (model_.LINTNOI);
    }
    if (((model_.NTNOI)<0))
    {
      std::cerr  << "Warning: NTNOI = %e is negative. Set to zero." << (model_.NTNOI) <<  std::endl; 
      NTNOI_i = 0.0;
    }
    else
    {
      NTNOI_i = (model_.NTNOI);
    }
    if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0.0)))
    {
      T1 = (model_.WTH0);
      if (((model_.BSHEXP)!=0.0))
      {
        T1 = ((model_.WTH0)*pow(NF,(model_.BSHEXP)));
      }
      T2 = FPITCH;
      if (((model_.ASHEXP)!=0.0))
      {
        T2 = (FPITCH*pow(NFINtotal,(model_.ASHEXP)));
      }
      gth = ((T1.val()+T2.val())/(model_.RTH0));
      cth = ((model_.CTH0)*(T1.val()+T2.val()));
    }
    else
    {
      gth = 1.0;
      cth = 0.0;
    }
    if (((model_.RGATEMOD)!=0))
    {
      Rgeltd = ((((model_.RGEXT)/NGCON)+(((model_.RGFIN)*NFIN)/((NGCON==2)?12.0:3.0)))/NF);
      ggeltd = (1.0/std::max(static_cast<double>(1.0e-3),Rgeltd));
    }
    if (((model_.RGEOMOD)==0))
    {
      RSourceGeo = ((model_.RSHS)*NRS);
      RDrainGeo = ((model_.RSHD)*NRD);
    }
    else
    {
      if (((model_.HEPI)>0.0))
      {
        Arsd = ((FPITCH*(model_.HFIN))+((TFIN+((FPITCH-TFIN)*(model_.CRATIO)))*(model_.HEPI)));
      }
      else
      {
        Arsd = (FPITCH*std::max(static_cast<double>(1.0e-9),((model_.HFIN)+(model_.HEPI))));
      }
      Prsd = (FPITCH+(model_.DELTAPRSD));
      if ((model_.given("RHORSD")))
      {
        rhorsd = (model_.RHORSD);
      }
      else
      {
        mu_max = (((model_.TYPE)==1)?1417.0:470.5);
        if (((model_.TYPE)==1))
        {
          mu_rsd = (((52.2+((mu_max-52.2)/(1.0+pow(((model_.NSD)/9.68e22),0.680))))-(43.4/(1.0+pow((3.43e26/(model_.NSD)),2.0))))*1.0e-4);
        }
        else
        {
          mu_rsd = (((44.9+((mu_max-44.9)/(1.0+pow(((model_.NSD)/2.23e22),0.719))))-(29.0/(1.0+pow((6.10e26/(model_.NSD)),2.0))))*1.0e-4);
        }
        rhorsd = (1.0/((1.60219e-19*(model_.NSD))*mu_rsd));
      }
      thetarsp = ((55.0*3.14159265358979323846)/180.0);
      afin = std::min(Arsd,std::max(static_cast<double>(1.0e-18),(TFIN*((model_.HFIN)+std::min(static_cast<double>(0.0),(model_.HEPI))))));
      T1 = ((thetarsp>=(3.14159265358979323846/2))?0:((thetarsp<=((-3.14159265358979323846)/2))?0:(1.0/tan(thetarsp))));
      Rsp = (((rhorsd*T1.val())/(sqrt(static_cast<double>(3.14159265358979323846))*NFIN))*(((1.0/sqrt(afin))-(2.0/sqrt(Arsd)))+sqrt((afin/(Arsd*Arsd)))));
      arsd_total = ((Arsd*NFIN)+(model_.ARSDEND));
      prsd_total = ((Prsd*NFIN)+(model_.PRSDEND));
      lt = sqrt((((model_.RHOC)*arsd_total)/(rhorsd*prsd_total)));
      alpha = (LRSD/lt);
      T0 = AnalogFunctions::lexp<AdmsFadType>((alpha+alpha));
      if (((model_.SDTERM)==1.0))
      {
        eta = ((rhorsd*lt)/(model_.RHOC));
        T1 = (T0*(1.0+eta));
        T2 = ((T1+1.0)-eta);
        T3 = ((T1-1.0)+eta);
      }
      else
      {
        T2 = (T0+1.0);
        T3 = (T0-1.0);
      }
      RrsdTML = (((rhorsd*lt)*T2.val())/(arsd_total*T3.val()));
      if (((model_.HEPI)<(-1.0e-10)))
      {
        Rrsdside = ((model_.RHOC)/(((-(model_.HEPI))*TFIN)*NFIN));
        Rrsd = (((RrsdTML+Rsp)*Rrsdside)/((RrsdTML+Rsp)+Rrsdside));
      }
      else
      {
        Rrsd = (RrsdTML+Rsp);
      }
      Rdsgeo = ((Rrsd/NF)*std::max(static_cast<double>(0.0),(((((model_.RGEOA)+((model_.RGEOB)*TFIN))+((model_.RGEOC)*FPITCH))+((model_.RGEOD)*LRSD))+((model_.RGEOE)*(model_.HEPI)))));
      RSourceGeo = Rdsgeo;
      RDrainGeo = Rdsgeo;
    }
    if ((RSourceGeo<=1.0e-3))
    {
      RSourceGeo = 1.0e-3;
    }
    if ((RDrainGeo<=1.0e-3))
    {
      RDrainGeo = 1.0e-3;
    }
    if (((model_.RDSMOD)==1))
    {
      if ((RSWMIN_i<=0.0))
      {
        RSWMIN_i = 0.0;
      }
      if ((RDWMIN_i<=0.0))
      {
        RDWMIN_i = 0.0;
      }
      if ((RSW_i<=0.0))
      {
        RSW_i = 0.0;
      }
      if ((RDW_i<=0.0))
      {
        RDW_i = 0.0;
      }
    }
    else
    {
      if ((RDSWMIN_i<=0.0))
      {
        RDSWMIN_i = 0.0;
      }
      if ((RDSW_i<=0.0))
      {
        RDSW_i = 0.0;
      }
    }
    if (((model_.CGEOMOD)!=1))
    {
      if ((model_.given("CGSO")))
      {
        CGSO_i = (model_.CGSO);
      }
      else
      {
        if (((model_.given("DLC"))&&((model_.DLC)>0.0)))
        {
          CGSO_i = std::max(static_cast<double>(0.0),(((model_.DLC)*cox)-CGSL_i));
        }
        else
        {
          CGSO_i = ((0.3*TFIN)*cox);
        }
      }
      if ((model_.given("CGDO")))
      {
        CGDO_i = (model_.CGDO);
      }
      else
      {
        if (((model_.given("DLC"))&&((model_.DLC)>0.0)))
        {
          CGDO_i = std::max(static_cast<double>(0.0),(((model_.DLC)*cox)-CGDL_i));
        }
        else
        {
          CGDO_i = ((0.3*TFIN)*cox);
        }
      }
    }
    if (((model_.CGEOMOD)==2))
    {
      Hg = ((model_.TGATE)+(model_.TMASK));
      Trsd = (0.5*(FPITCH-TFIN));
      Wg = std::max(static_cast<double>(0.0),(Trsd-(model_.TOXP)));
      Hrsd = std::max(static_cast<double>(0.0),((model_.HEPI)+(model_.TSILI)));
      if (((model_.TMASK)>0.0))
      {
        T0 = (3.467e-11*AnalogFunctions::lln<AdmsFadType>(((1.0e-7*(model_.EPSRSP))/(3.9*(model_.LSP)))));
        T1 = (((0.942*Hrsd)*epssp)/(model_.LSP));
        Cgg_top = ((T0.val()+T1.val())*(TFIN+((FPITCH-TFIN)*(model_.CRATIO))));
      }
      else
      {
        //Begin block cfr_top_trigate
        {
          //Block-local variables for block cfr_top_trigate
          double Hr;
          double Lr;
          double Hgdelta;
          double Lmax;
          double y;
          double x;
          //End of Block-local variables
          //Block-local variables for block cfr_top_trigate
          double CcgSat;
          double Cnon;
          double TT1;
          double Ccg1;
          double r1cf;
          double Rcf;
          double Ccg2;
          //End of Block-local variables
          //Block-local variables for block cfr_top_trigate
          double Ccg;
          double C1;
          double C2;
          double C3;
          double Cfglog;
          double dcf;
          double TT0;
          //End of Block-local variables
          //Block-local variables for block cfr_top_trigate
          double TT2;
          double Cfgsat;
          double delta;
          double Cfg;
          //End of Block-local variables
          Hr = (2.3+((0.2*(Hg+(model_.TOXP)))/Hrsd));
          Lr = 1.05;
          Hgdelta = fabs(((Hg+(model_.TOXP))-Hrsd));
          Lmax = ((model_.LSP)*Lr);
          y = std::min(Hrsd,(Hg+(model_.TOXP)));
          x = ((model_.LSP)/(Hr+1.0));
          Cnon = 1.7e12;
          CcgSat = ((epssp*(y-x))/(model_.LSP));
          TT1 = (Cnon*CcgSat);
          if ((TT1>80.0))
          {
            Ccg1 = CcgSat;
          }
          else
          {
            Ccg1 = ((1.0/Cnon)*log((1.0+AnalogFunctions::lexp(TT1))));
          }
          r1cf = (0.5*std::min((Hrsd/(Hg+(model_.TOXP))),((Hg+(model_.TOXP))/Hrsd)));
          Rcf = (Hgdelta*r1cf);
          Ccg2 = (((epssp*2)/3.14159265358979323846)*log((((model_.LSP)+((0.5*3.14159265358979323846)*Rcf))/(model_.LSP))));
          Ccg = (TFIN*(Ccg1+Ccg2));
          x = (Lmax/Hg);
          C1 = (4.0/(sqrt((2.0*(x+1)))*3.14159265358979323846));
          C2 = ((((sqrt(((((model_.TOXP)*(model_.TOXP))+((2.0*Hg)*(model_.TOXP)))+((Hg*Hg)*(x+1))))*sqrt((x+1)))+(model_.TOXP))+(Hg*x))+Hg);
          C3 = (((model_.TOXP)*sqrt(((x+1)*(x+4))))+((model_.TOXP)*(x+2)));
          Cfglog = (epssp*((C1*log((C2/C3)))+12.27));
          dcf = (Hr*Lr);
          TT0 = sqrt(((dcf*dcf)+1.0));
          TT1 = (((sqrt((((dcf*dcf)+1)*((((dcf*(model_.TOXP))*(dcf*(model_.TOXP)))+(((2*dcf)*Lmax)*(model_.TOXP)))+((((dcf*dcf)+1)*Lmax)*Lmax))))+(dcf*(model_.TOXP)))+((dcf*dcf)*Lmax))+Lmax);
          TT2 = ((TT0+1.0)*(dcf*(model_.TOXP)));
          Cfgsat = (((((((2.0*epssp)*sqrt(static_cast<double>(2)))/3.14159265358979323846)*0.85)*dcf)/TT0)*log((TT1/TT2)));
          delta = 1.2e-12;
          TT1 = ((Cfgsat-Cfglog)-delta);
          Cfg = (TFIN*(Cfgsat-(0.5*(TT1+sqrt(((TT1*TT1)+((4*delta)*Cfgsat)))))));
          Cgg_top = (Ccg+Cfg);
        }
        // End block cfr_top_trigate
      }
      if (((model_.TMASK)>0))
      {
        //Begin block cfr_side_dblgate
        {
          //Block-local variables for block cfr_side_dblgate
          double Hr;
          double Lr;
          double Hgdelta;
          double Lmax;
          double y;
          double x;
          //End of Block-local variables
          //Block-local variables for block cfr_side_dblgate
          double CcgSat;
          double Cnon;
          double TT1;
          double Ccg1;
          double r1cf;
          double Rcf;
          double Ccg2;
          //End of Block-local variables
          //Block-local variables for block cfr_side_dblgate
          double Ccg;
          double C1;
          double C2;
          double C3;
          double Cfglog;
          double dcf;
          double TT0;
          //End of Block-local variables
          //Block-local variables for block cfr_side_dblgate
          double TT2;
          double Cfgsat;
          double delta;
          double Cfg;
          //End of Block-local variables
          Hr = (2.3+((0.2*(Wg+(model_.TOXP)))/Trsd));
          Lr = 1.05;
          Hgdelta = fabs(((Wg+(model_.TOXP))-Trsd));
          Lmax = ((model_.LSP)*Lr);
          y = std::min(Trsd,(Wg+(model_.TOXP)));
          x = ((model_.LSP)/(Hr+1.0));
          Cnon = 1.7e12;
          CcgSat = ((epssp*(y-x))/(model_.LSP));
          TT1 = (Cnon*CcgSat);
          if ((TT1>80.0))
          {
            Ccg1 = CcgSat;
          }
          else
          {
            Ccg1 = ((1.0/Cnon)*log((1.0+AnalogFunctions::lexp(TT1))));
          }
          r1cf = (0.5*std::min((Trsd/(Wg+(model_.TOXP))),((Wg+(model_.TOXP))/Trsd)));
          Rcf = (Hgdelta*r1cf);
          Ccg2 = (((epssp*2)/3.14159265358979323846)*log((((model_.LSP)+((0.5*3.14159265358979323846)*Rcf))/(model_.LSP))));
          Ccg = ((model_.HFIN)*(Ccg1+Ccg2));
          x = (Lmax/Wg);
          C1 = (4.0/(sqrt((2.0*(x+1)))*3.14159265358979323846));
          C2 = ((((sqrt(((((model_.TOXP)*(model_.TOXP))+((2.0*Wg)*(model_.TOXP)))+((Wg*Wg)*(x+1))))*sqrt((x+1)))+(model_.TOXP))+(Wg*x))+Wg);
          C3 = (((model_.TOXP)*sqrt(((x+1)*(x+4))))+((model_.TOXP)*(x+2)));
          Cfglog = (epssp*((C1*log((C2/C3)))+12.27));
          dcf = (Hr*Lr);
          TT0 = sqrt(((dcf*dcf)+1.0));
          TT1 = (((sqrt((((dcf*dcf)+1)*((((dcf*(model_.TOXP))*(dcf*(model_.TOXP)))+(((2*dcf)*Lmax)*(model_.TOXP)))+((((dcf*dcf)+1)*Lmax)*Lmax))))+(dcf*(model_.TOXP)))+((dcf*dcf)*Lmax))+Lmax);
          TT2 = ((TT0+1.0)*(dcf*(model_.TOXP)));
          Cfgsat = (((((((2.0*epssp)*sqrt(static_cast<double>(2)))/3.14159265358979323846)*0.70)*dcf)/TT0)*log((TT1/TT2)));
          delta = 1.2e-12;
          TT1 = ((Cfgsat-Cfglog)-delta);
          Cfg = ((model_.HFIN)*(Cfgsat-(0.5*(TT1+sqrt(((TT1*TT1)+((4*delta)*Cfgsat)))))));
          Cgg_side = (Ccg+Cfg);
        }
        // End block cfr_side_dblgate
      }
      else
      {
        //Begin block cfr_side_trigate
        {
          //Block-local variables for block cfr_side_trigate
          double Hr;
          double Lr;
          double Hgdelta;
          double Lmax;
          double y;
          double x;
          //End of Block-local variables
          //Block-local variables for block cfr_side_trigate
          double CcgSat;
          double Cnon;
          double TT1;
          double Ccg1;
          double r1cf;
          double Rcf;
          double Ccg2;
          //End of Block-local variables
          //Block-local variables for block cfr_side_trigate
          double Ccg;
          double C1;
          double C2;
          double C3;
          double Cfglog;
          double dcf;
          double TT0;
          //End of Block-local variables
          //Block-local variables for block cfr_side_trigate
          double TT2;
          double Cfgsat;
          double delta;
          double Cfg;
          //End of Block-local variables
          Hr = (2.3+((0.2*(Wg+(model_.TOXP)))/Trsd));
          Lr = 1.05;
          Hgdelta = fabs(((Wg+(model_.TOXP))-Trsd));
          Lmax = ((model_.LSP)*Lr);
          y = std::min(Trsd,(Wg+(model_.TOXP)));
          x = ((model_.LSP)/(Hr+1.0));
          Cnon = 1.7e12;
          CcgSat = ((epssp*(y-x))/(model_.LSP));
          TT1 = (Cnon*CcgSat);
          if ((TT1>80.0))
          {
            Ccg1 = CcgSat;
          }
          else
          {
            Ccg1 = ((1.0/Cnon)*log((1.0+AnalogFunctions::lexp(TT1))));
          }
          r1cf = (0.5*std::min((Trsd/(Wg+(model_.TOXP))),((Wg+(model_.TOXP))/Trsd)));
          Rcf = (Hgdelta*r1cf);
          Ccg2 = (((epssp*2)/3.14159265358979323846)*log((((model_.LSP)+((0.5*3.14159265358979323846)*Rcf))/(model_.LSP))));
          Ccg = ((model_.HFIN)*(Ccg1+Ccg2));
          x = (Lmax/Wg);
          C1 = (4.0/(sqrt((2.0*(x+1)))*3.14159265358979323846));
          C2 = ((((sqrt(((((model_.TOXP)*(model_.TOXP))+((2.0*Wg)*(model_.TOXP)))+((Wg*Wg)*(x+1))))*sqrt((x+1)))+(model_.TOXP))+(Wg*x))+Wg);
          C3 = (((model_.TOXP)*sqrt(((x+1)*(x+4))))+((model_.TOXP)*(x+2)));
          Cfglog = (epssp*((C1*log((C2/C3)))+12.27));
          dcf = (Hr*Lr);
          TT0 = sqrt(((dcf*dcf)+1.0));
          TT1 = (((sqrt((((dcf*dcf)+1)*((((dcf*(model_.TOXP))*(dcf*(model_.TOXP)))+(((2*dcf)*Lmax)*(model_.TOXP)))+((((dcf*dcf)+1)*Lmax)*Lmax))))+(dcf*(model_.TOXP)))+((dcf*dcf)*Lmax))+Lmax);
          TT2 = ((TT0+1.0)*(dcf*(model_.TOXP)));
          Cfgsat = (((((((2.0*epssp)*sqrt(static_cast<double>(2)))/3.14159265358979323846)*0.85)*dcf)/TT0)*log((TT1/TT2)));
          delta = 1.2e-12;
          TT1 = ((Cfgsat-Cfglog)-delta);
          Cfg = ((model_.HFIN)*(Cfgsat-(0.5*(TT1+sqrt(((TT1*TT1)+((4*delta)*Cfgsat)))))));
          Cgg_side = (Ccg+Cfg);
        }
        // End block cfr_side_trigate
      }
      if (((model_.TMASK)>0.0))
      {
        Acorner = 0.0;
      }
      else
      {
        if (((model_.HEPI)>0.0))
        {
          Acorner = ((FPITCH-TFIN)*(((model_.HEPI)*(model_.CRATIO))+(model_.TSILI)));
        }
        else
        {
          Acorner = ((FPITCH-TFIN)*Hrsd);
        }
      }
      Ccorner = (((((NFIN*Acorner)+(model_.ARSDEND))+(model_.ASILIEND))*epssp)/(model_.LSP));
      Cfr_geo = (((Ccorner+(Cgg_top*NFIN))+((((model_.CGEOE)*Cgg_side)*NFIN)*2.0))*NF);
      Cfr_geo = (Cfr_geo*std::max(static_cast<double>(0.0),((((model_.CGEOA)+((model_.CGEOB)*TFIN))+((model_.CGEOC)*FPITCH))+((model_.CGEOD)*LRSD))));
    }
    T0 = ((model_.CSDESW)*AnalogFunctions::lln<AdmsFadType>((1.0+((model_.HFIN)/(model_.EOTBOX)))));
    csbox = ((cbox*ASEO)+(T0.val()*std::max(static_cast<double>(0.0),(PSEO-(FPITCH*NFINtotal)))));
    cdbox = ((cbox*ADEO)+(T0.val()*std::max(static_cast<double>(0.0),(PDEO-(FPITCH*NFINtotal)))));
    cgbox = (((((model_.CGBO)*NF)*NGCON)+((model_.CGBN)*NFINtotal))*Lg);
    EeffFactor = (1.0e-8/(epsratio*(model_.EOT)));
    WeffWRFactor = (1.0/(pow((Weff0*1.0e6),WR_i)*NFINtotal));
    litl = sqrt((((epsratio*(model_.EOT))*0.5)*TFIN));
    if ((!(model_.given("THETASCE"))))
    {
      tmp = (((DVT1_i*Leff)/scl)+1.0e-6);
      if ((tmp<40.0))
      {
        Theta_SCE = (0.5/(cosh(tmp)-1.0));
      }
      else
      {
        Theta_SCE = exp((-tmp));
      }
    }
    else
    {
      Theta_SCE = (model_.THETASCE);
    }
    if ((!(model_.given("THETASW"))))
    {
      tmp = (((DVT1SS_i*Leff)/scl)+1.0e-6);
      if ((tmp<40.0))
      {
        Theta_SW = (0.5/(cosh(tmp)-1.0));
      }
      else
      {
        Theta_SW = exp((-tmp));
      }
    }
    else
    {
      Theta_SW = (model_.THETASW);
    }
    if ((!(model_.given("THETADIBL"))))
    {
      tmp = (((DSUB_i*Leff)/scl)+1.0e-6);
      if ((tmp<40.0))
      {
        Theta_DIBL = (0.5/(cosh(tmp)-1.0));
      }
      else
      {
        Theta_DIBL = exp((-tmp));
      }
    }
    else
    {
      Theta_DIBL = (model_.THETADIBL);
    }
    Theta_RSCE = (sqrt((1.0+(LPE0_i/Leff)))-1.0);
    tmp = (((DSUB_i*Leff)/scl)+1.0e-6);
    if ((tmp<40.0))
    {
      T0 = (1.0/std::max((1.0+((model_.DVTP2)*(cosh(tmp)-2.0))),static_cast<double>(1.0e-6)));
    }
    else
    {
      T0 = (exp((-tmp))/std::max((exp((-tmp))+(model_.DVTP2)),static_cast<double>(1.0e-6)));
    }
    Theta_DITS = T0.val();
    nbody = NBODY_i;
    qbs = (((1.60219e-19*nbody)*Ach)/Cins);
    if (((model_.TYPE)==1))
    {
      Aechvb = 4.97232e-7;
      Bechvb = 7.45669e11;
    }
    else
    {
      Aechvb = 3.42537e-7;
      Bechvb = 1.16645e12;
    }
    T0 = ((model_.TOXG)*(model_.TOXG));
    T1 = ((model_.TOXG)*POXEDGE_i);
    T2 = (T1*T1);
    Toxratio = (AnalogFunctions::lexp((NTOX_i*AnalogFunctions::lln(((model_.TOXREF)/(model_.TOXG)))))/T0.val());
    Toxratioedge = (AnalogFunctions::lexp((NTOX_i*AnalogFunctions::lln(((model_.TOXREF)/T1.val()))))/T2.val());
    igsd_mult0 = ((Weff0*Aechvb)*Toxratioedge);
    if (((model_.TNOM)<(-273.15)))
    {
      std::cerr  << "Warning: (TNOM=%e) < -`P_CELSIUS0. Set to 27 C." << (model_.TNOM) <<  std::endl; 
      Tnom = 300.15;
    }
    else
    {
      Tnom = ((model_.TNOM)+273.15);
    }
  }
  // End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
   const Configuration & configuration,
   const InstanceBlock & instance_block,
   Model &               model,
   const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    L(3.0e-8),
    D(4.0e-8),
    TFIN(1.5e-8),
    FPITCH(8.0e-8),
    NF(1),
    NFIN(1.0),
    NGCON(1),
    ASEO(0.0),
    ADEO(0.0),
    PSEO(0.0),
    PDEO(0.0),
    ASEJ(0.0),
    ADEJ(0.0),
    PSEJ(0.0),
    PDEJ(0.0),
    COVS(0.0),
    COVD(0.0),
    CGSP(0.0),
    CGDP(0.0),
    CDSP(0.0),
    NRS(0.0),
    NRD(0.0),
    LRSD(0.0),
    NFINNOM(1.0),
    m(1.0),
    devsign(0),
    NFINtotal(0.0),
    ids(0.0),
    sigvds(0.0),
    qd(0.0),
    qg(0.0),
    qs(0.0),
    qb(0.0),
    epssub(0.0),
    epsratio(0.0),
    Leff(0.0),
    LeffCV(0.0),
    LeffCV_acc(0.0),
    Weff0(0.0),
    WeffCV0(0.0),
    cox(0.0),
    nbody(0.0),
    T0(0.0),
    T1(0.0),
    T2(0.0),
    T3(0.0),
    Tnom(0.0),
    PTWGR_t(0.0),
    CJS_t(0.0),
    CJSWS_t(0.0),
    CJSWGD_t(0.0),
    CJD_t(0.0),
    CJSWD_t(0.0),
    CJSWGS_t(0.0),
    PBS_t(0.0),
    PBSWS_t(0.0),
    PBSWGS_t(0.0),
    PBD_t(0.0),
    PBSWD_t(0.0),
    PBSWGD_t(0.0),
    JSS_t(0.0),
    JSWS_t(0.0),
    JSWGS_t(0.0),
    JSD_t(0.0),
    JSWD_t(0.0),
    JSWGD_t(0.0),
    JTSS_t(0.0),
    JTSD_t(0.0),
    JTSSWS_t(0.0),
    JTSSWD_t(0.0),
    JTSSWGS_t(0.0),
    JTSSWGD_t(0.0),
    NJTS_t(0.0),
    NJTSD_t(0.0),
    NJTSSW_t(0.0),
    NJTSSWD_t(0.0),
    NJTSSWG_t(0.0),
    NJTSSWGD_t(0.0),
    q0(0.0),
    T11(0.0),
    T12(0.0),
    e0(0.0),
    e1(0.0),
    e2(0.0),
    scl(0.0),
    tmp(0.0),
    Theta_SCE(0.0),
    Theta_SW(0.0),
    Theta_DIBL(0.0),
    Theta_RSCE(0.0),
    Theta_DITS(0.0),
    veseff(0.0),
    Tcen0(0.0),
    Tcen(0.0),
    mx(0.0),
    mxprime(0.0),
    md(0.0),
    mdprime(0.0),
    gprime(0.0),
    gfactor(0.0),
    qis(0.0),
    qid(0.0),
    qbs(0.0),
    qba(0.0),
    u0r(0.0),
    UAR_t(0.0),
    UC_t(0.0),
    UCR_t(0.0),
    UDR_t(0.0),
    U0R_t(0.0),
    EeffFactor(0.0),
    Dr(0.0),
    WeffWRFactor(0.0),
    RSourceGeo(0.0),
    RDrainGeo(0.0),
    RDSWMIN_i(0.0),
    RDWMIN_i(0.0),
    RSWMIN_i(0.0),
    Rdrain(0.0),
    Rsource(0.0),
    Rdsi(0.0),
    RSDRR_t(0.0),
    RDDRR_t(0.0),
    VSAT1R_t(0.0),
    MEXPR_t(0.0),
    VSAT_a(0.0),
    Cfr_geo(0.0),
    ggeltd(0.0),
    igbinv(0.0),
    igsd_mult0(0.0),
    igbs(0.0),
    igbd(0.0),
    igbacc(0.0),
    igcs(0.0),
    igcd(0.0),
    igisl(0.0),
    igidl(0.0),
    igs(0.0),
    igd(0.0),
    Aechvb(0.0),
    Bechvb(0.0),
    Toxratio(0.0),
    Iii(0.0),
    cox_acc(0.0),
    qg_acc(0.0),
    qb_acc(0.0),
    qgs_fr(0.0),
    qgd_fr(0.0),
    qds_fr(0.0),
    qgs_parasitic(0.0),
    qgd_parasitic(0.0),
    Qes(0.0),
    Qed(0.0),
    Qeg(0.0),
    csbox(0.0),
    cdbox(0.0),
    cgbox(0.0),
    Ies(0.0),
    Ied(0.0),
    Czbs(0.0),
    Czbssw(0.0),
    Czbsswg(0.0),
    Czbd(0.0),
    Czbdsw(0.0),
    Czbdswg(0.0),
    Isbs(0.0),
    Isbd(0.0),
    Nvtms(0.0),
    Nvtmd(0.0),
    SslpRev(0.0),
    IVjsmRev(0.0),
    VjsmRev(0.0),
    SslpFwd(0.0),
    IVjsmFwd(0.0),
    VjsmFwd(0.0),
    XExpBVS(0.0),
    DslpRev(0.0),
    IVjdmRev(0.0),
    VjdmRev(0.0),
    DslpFwd(0.0),
    IVjdmFwd(0.0),
    VjdmFwd(0.0),
    XExpBVD(0.0),
    idsgen(0.0),
    LINTIGEN_i(0.0),
    LINTNOI_i(0.0),
    litl(0.0),
    FNPowerAt1Hz(0.0),
    NTNOI_i(0.0),
    Gtnoi(0.0),
    sid(0.0),
    gspr(0.0),
    gdpr(0.0),
    gamma(0.0),
    delta(0.0),
    ctnoi(0.0),
    C0(0.0),
    sf(0.0),
    gth(0.0),
    cth(0.0),
    PHIG_i(0.0),
    CFD_i(0.0),
    CFS_i(0.0),
    COVS_i(0.0),
    COVD_i(0.0),
    CGSO_i(0.0),
    CGDO_i(0.0),
    CGSL_i(0.0),
    CGDL_i(0.0),
    CGBL_i(0.0),
    CKAPPAS_i(0.0),
    CKAPPAD_i(0.0),
    CKAPPAB_i(0.0),
    QMFACTOR_i(0.0),
    QMTCENCV_i(0.0),
    QMTCENCVA_i(0.0),
    KSATIV_i(0.0),
    KSATIVR_i(0.0),
    CDSC_i(0.0),
    CDSCD_i(0.0),
    CDSCDR_i(0.0),
    CIT_i(0.0),
    DVT0_i(0.0),
    CITR_i(0.0),
    PHIN_i(0.0),
    ETA0_i(0.0),
    ETA0R_i(0.0),
    VSAT_i(0.0),
    VSATR_i(0.0),
    VSATR_t(0.0),
    DVTP0_i(0.0),
    DVTP1_i(0.0),
    K0_i(0.0),
    K01_i(0.0),
    K0SI_i(0.0),
    K0SI1_i(0.0),
    K2SI_i(0.0),
    K2SI1_i(0.0),
    PHIBE_i(0.0),
    K1_i(0.0),
    K11_i(0.0),
    K2SAT_i(0.0),
    K2SAT1_i(0.0),
    DELTAVSAT_i(0.0),
    PSAT_i(0.0),
    DELTAVSATCV_i(0.0),
    PSATCV_i(0.0),
    VSAT1_i(0.0),
    VSAT1R_i(0.0),
    PTWG_i(0.0),
    PTWGR_i(0.0),
    VSATCV_i(0.0),
    U0_i(0.0),
    U0R_i(0.0),
    ETAMOB_i(0.0),
    RDSW_i(0.0),
    PRWGS_i(0.0),
    PRWGD_i(0.0),
    PDIBL1_i(0.0),
    PDIBL1R_i(0.0),
    PDIBL2_i(0.0),
    PDIBL2R_i(0.0),
    DROUT_i(0.0),
    PVAG_i(0.0),
    AIGBINV_i(0.0),
    AIGBINV1_i(0.0),
    BIGBINV_i(0.0),
    CIGBINV_i(0.0),
    EIGBINV_i(0.0),
    NIGBINV_i(0.0),
    AIGBACC_i(0.0),
    AIGBACC1_i(0.0),
    BIGBACC_i(0.0),
    CIGBACC_i(0.0),
    NIGBACC_i(0.0),
    AIGC_i(0.0),
    AIGC1_i(0.0),
    BIGC_i(0.0),
    CIGC_i(0.0),
    PIGCD_i(0.0),
    AIGS_i(0.0),
    AIGS1_i(0.0),
    BIGS_i(0.0),
    CIGS_i(0.0),
    POXEDGE_i(0.0),
    AIGD_i(0.0),
    AIGD1_i(0.0),
    BIGD_i(0.0),
    CIGD_i(0.0),
    AGIDL_i(0.0),
    BGIDL_i(0.0),
    CGIDL_i(0.0),
    EGIDL_i(0.0),
    PGIDL_i(0.0),
    AGISL_i(0.0),
    BGISL_i(0.0),
    CGISL_i(0.0),
    EGISL_i(0.0),
    PGISL_i(0.0),
    ALPHA0_i(0.0),
    ALPHA1_i(0.0),
    ALPHAII0_i(0.0),
    ALPHAII1_i(0.0),
    BETA0_i(0.0),
    BETAII0_i(0.0),
    BETAII1_i(0.0),
    BETAII2_i(0.0),
    ESATII_i(0.0),
    LII_i(0.0),
    SII0_i(0.0),
    SII1_i(0.0),
    SII2_i(0.0),
    SIID_i(0.0),
    TII_i(0.0),
    MEXP_i(0.0),
    MEXPR_i(0.0),
    PCLM_i(0.0),
    PCLMG_i(0.0),
    PCLMCV_i(0.0),
    PCLMR_i(0.0),
    A1_i(0.0),
    A2_i(0.0),
    A11_i(0.0),
    A21_i(0.0),
    K1RSCE_i(0.0),
    DVTSHIFT_i(0.0),
    DVTSHIFTR_i(0.0),
    UA_i(0.0),
    UC_i(0.0),
    EU_i(0.0),
    UD_i(0.0),
    UCS_i(0.0),
    UAR_i(0.0),
    EUR_i(0.0),
    UCR_i(0.0),
    UDR_i(0.0),
    UA1_i(0.0),
    UA1R_i(0.0),
    UC1_i(0.0),
    UD1_i(0.0),
    UCSTE_i(0.0),
    UTE_i(0.0),
    UTL_i(0.0),
    EMOBT_i(0.0),
    UC1R_i(0.0),
    UD1R_i(0.0),
    UTER_i(0.0),
    UTLR_i(0.0),
    PTWGT_i(0.0),
    AT_i(0.0),
    ATCV_i(0.0),
    ATR_i(0.0),
    RDW_i(0.0),
    RSW_i(0.0),
    PRT_i(0.0),
    KT1_i(0.0),
    TSS_i(0.0),
    IIT_i(0.0),
    IGT_i(0.0),
    TGIDL_i(0.0),
    NTGEN_i(0.0),
    AIGEN_i(0.0),
    BIGEN_i(0.0),
    K0SISAT_i(0.0),
    K0SISAT1_i(0.0),
    K2SISAT_i(0.0),
    K2SISAT1_i(0.0),
    K2_i(0.0),
    K21_i(0.0),
    Cins(0.0),
    Ach(0.0),
    Weff_UFCM(0.0),
    qdep(0.0),
    rc(0.0),
    vth_fixed_factor_Sub(0.0),
    vth_fixed_factor_SI(0.0),
    qm(0.0),
    Qdep_ov_Cins(0.0),
    qi_acc_for_QM(0.0),
    fieldnormalizationfactor(0.0),
    auxQMfact(0.0),
    QMFACTORCVfinal(0.0),
    psipclamp(0.0),
    sqrtpsip(0.0),
    nq(0.0),
    F0(0.0),
    li_d(-1),
    li_g(-1),
    li_s(-1),
    li_e(-1),
    li_t(-1),
    li_si(-1),
    li_di(-1),
    li_ge(-1),
    li_N(-1),
    li_branch_id(-1),
    li_branch_ig(-1),
    li_branch_is(-1),
    li_branch_ie(-1),
    f_di_Equ_ge_Node_Ptr(0),
    f_di_Equ_di_Node_Ptr(0),
    f_si_Equ_ge_Node_Ptr(0),
    f_si_Equ_di_Node_Ptr(0),
    f_di_Equ_si_Node_Ptr(0),
    f_si_Equ_si_Node_Ptr(0),
    f_di_Equ_e_Node_Ptr(0),
    f_si_Equ_e_Node_Ptr(0),
    f_di_Equ_t_Node_Ptr(0),
    f_si_Equ_t_Node_Ptr(0),
    f_ge_Equ_ge_Node_Ptr(0),
    f_ge_Equ_e_Node_Ptr(0),
    f_ge_Equ_t_Node_Ptr(0),
    f_ge_Equ_si_Node_Ptr(0),
    f_ge_Equ_di_Node_Ptr(0),
    f_ge_Equ_s_Node_Ptr(0),
    f_si_Equ_s_Node_Ptr(0),
    f_ge_Equ_d_Node_Ptr(0),
    f_si_Equ_d_Node_Ptr(0),
    f_di_Equ_s_Node_Ptr(0),
    f_di_Equ_d_Node_Ptr(0),
    f_e_Equ_ge_Node_Ptr(0),
    f_e_Equ_si_Node_Ptr(0),
    f_e_Equ_e_Node_Ptr(0),
    f_e_Equ_di_Node_Ptr(0),
    f_e_Equ_t_Node_Ptr(0),
    f_e_Equ_s_Node_Ptr(0),
    f_e_Equ_d_Node_Ptr(0),
    f_d_Equ_d_Node_Ptr(0),
    f_d_Equ_s_Node_Ptr(0),
    f_s_Equ_d_Node_Ptr(0),
    f_s_Equ_s_Node_Ptr(0),
    f_s_Equ_t_Node_Ptr(0),
    f_s_Equ_di_Node_Ptr(0),
    f_s_Equ_si_Node_Ptr(0),
    f_s_Equ_ge_Node_Ptr(0),
    f_s_Equ_e_Node_Ptr(0),
    f_d_Equ_t_Node_Ptr(0),
    f_d_Equ_di_Node_Ptr(0),
    f_d_Equ_si_Node_Ptr(0),
    f_d_Equ_ge_Node_Ptr(0),
    f_d_Equ_e_Node_Ptr(0),
    f_g_Equ_g_Node_Ptr(0),
    f_g_Equ_ge_Node_Ptr(0),
    f_ge_Equ_g_Node_Ptr(0),
    f_g_Equ_t_Node_Ptr(0),
    f_di_Equ_N_Node_Ptr(0),
    f_si_Equ_N_Node_Ptr(0),
    f_N_Equ_ge_Node_Ptr(0),
    f_N_Equ_e_Node_Ptr(0),
    f_N_Equ_si_Node_Ptr(0),
    f_N_Equ_s_Node_Ptr(0),
    f_N_Equ_di_Node_Ptr(0),
    f_N_Equ_d_Node_Ptr(0),
    f_N_Equ_t_Node_Ptr(0),
    f_N_Equ_N_Node_Ptr(0),
    f_ge_Equ_N_Node_Ptr(0),
    f_t_Equ_s_Node_Ptr(0),
    f_t_Equ_si_Node_Ptr(0),
    f_t_Equ_di_Node_Ptr(0),
    f_t_Equ_d_Node_Ptr(0),
    f_t_Equ_ge_Node_Ptr(0),
    f_t_Equ_e_Node_Ptr(0),
    f_t_Equ_t_Node_Ptr(0),
    q_di_Equ_ge_Node_Ptr(0),
    q_di_Equ_di_Node_Ptr(0),
    q_si_Equ_ge_Node_Ptr(0),
    q_si_Equ_di_Node_Ptr(0),
    q_di_Equ_si_Node_Ptr(0),
    q_si_Equ_si_Node_Ptr(0),
    q_di_Equ_e_Node_Ptr(0),
    q_si_Equ_e_Node_Ptr(0),
    q_di_Equ_t_Node_Ptr(0),
    q_si_Equ_t_Node_Ptr(0),
    q_ge_Equ_ge_Node_Ptr(0),
    q_ge_Equ_e_Node_Ptr(0),
    q_ge_Equ_t_Node_Ptr(0),
    q_ge_Equ_si_Node_Ptr(0),
    q_ge_Equ_di_Node_Ptr(0),
    q_ge_Equ_s_Node_Ptr(0),
    q_si_Equ_s_Node_Ptr(0),
    q_ge_Equ_d_Node_Ptr(0),
    q_si_Equ_d_Node_Ptr(0),
    q_di_Equ_s_Node_Ptr(0),
    q_di_Equ_d_Node_Ptr(0),
    q_e_Equ_ge_Node_Ptr(0),
    q_e_Equ_si_Node_Ptr(0),
    q_e_Equ_e_Node_Ptr(0),
    q_e_Equ_di_Node_Ptr(0),
    q_e_Equ_t_Node_Ptr(0),
    q_e_Equ_s_Node_Ptr(0),
    q_e_Equ_d_Node_Ptr(0),
    q_d_Equ_d_Node_Ptr(0),
    q_d_Equ_s_Node_Ptr(0),
    q_s_Equ_d_Node_Ptr(0),
    q_s_Equ_s_Node_Ptr(0),
    q_s_Equ_t_Node_Ptr(0),
    q_s_Equ_di_Node_Ptr(0),
    q_s_Equ_si_Node_Ptr(0),
    q_s_Equ_ge_Node_Ptr(0),
    q_s_Equ_e_Node_Ptr(0),
    q_d_Equ_t_Node_Ptr(0),
    q_d_Equ_di_Node_Ptr(0),
    q_d_Equ_si_Node_Ptr(0),
    q_d_Equ_ge_Node_Ptr(0),
    q_d_Equ_e_Node_Ptr(0),
    q_g_Equ_g_Node_Ptr(0),
    q_g_Equ_ge_Node_Ptr(0),
    q_ge_Equ_g_Node_Ptr(0),
    q_g_Equ_t_Node_Ptr(0),
    q_di_Equ_N_Node_Ptr(0),
    q_si_Equ_N_Node_Ptr(0),
    q_N_Equ_ge_Node_Ptr(0),
    q_N_Equ_e_Node_Ptr(0),
    q_N_Equ_si_Node_Ptr(0),
    q_N_Equ_s_Node_Ptr(0),
    q_N_Equ_di_Node_Ptr(0),
    q_N_Equ_d_Node_Ptr(0),
    q_N_Equ_t_Node_Ptr(0),
    q_N_Equ_N_Node_Ptr(0),
    q_ge_Equ_N_Node_Ptr(0),
    q_t_Equ_s_Node_Ptr(0),
    q_t_Equ_si_Node_Ptr(0),
    q_t_Equ_di_Node_Ptr(0),
    q_t_Equ_d_Node_Ptr(0),
    q_t_Equ_ge_Node_Ptr(0),
    q_t_Equ_e_Node_Ptr(0),
    q_t_Equ_t_Node_Ptr(0),
    A_di_Equ_ge_NodeOffset(-1),
    A_di_Equ_di_NodeOffset(-1),
    A_si_Equ_ge_NodeOffset(-1),
    A_si_Equ_di_NodeOffset(-1),
    A_di_Equ_si_NodeOffset(-1),
    A_si_Equ_si_NodeOffset(-1),
    A_di_Equ_e_NodeOffset(-1),
    A_si_Equ_e_NodeOffset(-1),
    A_di_Equ_t_NodeOffset(-1),
    A_si_Equ_t_NodeOffset(-1),
    A_ge_Equ_ge_NodeOffset(-1),
    A_ge_Equ_e_NodeOffset(-1),
    A_ge_Equ_t_NodeOffset(-1),
    A_ge_Equ_si_NodeOffset(-1),
    A_ge_Equ_di_NodeOffset(-1),
    A_ge_Equ_s_NodeOffset(-1),
    A_si_Equ_s_NodeOffset(-1),
    A_ge_Equ_d_NodeOffset(-1),
    A_si_Equ_d_NodeOffset(-1),
    A_di_Equ_s_NodeOffset(-1),
    A_di_Equ_d_NodeOffset(-1),
    A_e_Equ_ge_NodeOffset(-1),
    A_e_Equ_si_NodeOffset(-1),
    A_e_Equ_e_NodeOffset(-1),
    A_e_Equ_di_NodeOffset(-1),
    A_e_Equ_t_NodeOffset(-1),
    A_e_Equ_s_NodeOffset(-1),
    A_e_Equ_d_NodeOffset(-1),
    A_d_Equ_d_NodeOffset(-1),
    A_d_Equ_s_NodeOffset(-1),
    A_s_Equ_d_NodeOffset(-1),
    A_s_Equ_s_NodeOffset(-1),
    A_s_Equ_t_NodeOffset(-1),
    A_s_Equ_di_NodeOffset(-1),
    A_s_Equ_si_NodeOffset(-1),
    A_s_Equ_ge_NodeOffset(-1),
    A_s_Equ_e_NodeOffset(-1),
    A_d_Equ_t_NodeOffset(-1),
    A_d_Equ_di_NodeOffset(-1),
    A_d_Equ_si_NodeOffset(-1),
    A_d_Equ_ge_NodeOffset(-1),
    A_d_Equ_e_NodeOffset(-1),
    A_g_Equ_g_NodeOffset(-1),
    A_g_Equ_ge_NodeOffset(-1),
    A_ge_Equ_g_NodeOffset(-1),
    A_g_Equ_t_NodeOffset(-1),
    A_di_Equ_N_NodeOffset(-1),
    A_si_Equ_N_NodeOffset(-1),
    A_N_Equ_ge_NodeOffset(-1),
    A_N_Equ_e_NodeOffset(-1),
    A_N_Equ_si_NodeOffset(-1),
    A_N_Equ_s_NodeOffset(-1),
    A_N_Equ_di_NodeOffset(-1),
    A_N_Equ_d_NodeOffset(-1),
    A_N_Equ_t_NodeOffset(-1),
    A_N_Equ_N_NodeOffset(-1),
    A_ge_Equ_N_NodeOffset(-1),
    A_t_Equ_s_NodeOffset(-1),
    A_t_Equ_si_NodeOffset(-1),
    A_t_Equ_di_NodeOffset(-1),
    A_t_Equ_d_NodeOffset(-1),
    A_t_Equ_ge_NodeOffset(-1),
    A_t_Equ_e_NodeOffset(-1),
    A_t_Equ_t_NodeOffset(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
  numIntVars = 5 + 0;
  numExtVars = 4;


  // Right now, we only have store for limited probes...
  setNumStoreVars(0);

  // Manually inserted code:  detect extra nodes given on instance line,
  // set external node mode for those normally-internal nodes.
  devConMap.resize(numExtVars);
  for (int j=0; j< numExtVars; j++)
    devConMap[j] = 1;

  if (instance_block.numExtVars > numExtVars)
  {
    devConMap.resize(instance_block.numExtVars);
    if (instance_block.numExtVars >= numExtVars+1)
    {
      --numIntVars;
      devConMap[numExtVars] = 2;
    }
  }
  // END manually inserted code
  
  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 4;

  leadCurrentF.resize(4);
  leadCurrentQ.resize(4);
  
  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
  PairVector jacobianElements;
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_ge));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_g));
  jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_ge));
  jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_ge));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_ge));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_ge));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_ge));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_N));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_ge));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_N));
  jacobianElements.push_back(IntPair(admsNodeID_ge,admsNodeID_ge));
  jacobianElements.push_back(IntPair(admsNodeID_ge,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_ge,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_ge,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_ge,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_ge,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_ge,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_ge,admsNodeID_g));
  jacobianElements.push_back(IntPair(admsNodeID_ge,admsNodeID_N));
  jacobianElements.push_back(IntPair(admsNodeID_N,admsNodeID_ge));
  jacobianElements.push_back(IntPair(admsNodeID_N,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_N,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_N,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_N,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_N,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_N,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_N,admsNodeID_N));

  

  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_si)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_si,admsNodeID_s));
  }
  if (collapseNode_di)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_di,admsNodeID_d));
  }
  if (collapseNode_ge)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_ge,admsNodeID_g));
  }
  if (collapseNode_N)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_N,admsNodeID_GND));
  }

  // Now generate the jacstamp from what we already have.
  // This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
  // node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
  // (for devices that have no collapsibles, this will be static, so check that it hasn't already
  // been filled in)
  if (jacStamp.empty())
  {
    int originalSize = 9+0;
    computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
  }

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
  collapseNode_si = false;
  collapseNode_di = false;
  collapseNode_ge = false;
  collapseNode_N = false;
  if (((model_.RDSMOD)==2))
  {

    collapseNode_di = true;

    collapseNode_si = true;

  }

  if (!(((model_.RGATEMOD)!=0)))
  {
    collapseNode_ge = true;

  }

  if (((model_.TNOIMOD)==0))
  {

    collapseNode_N = true;

  }


  if (collapseNode_si)
  {
    numIntVars--;
  }
  if (collapseNode_di)
  {
    numIntVars--;
  }
  if (collapseNode_ge)
  {
    numIntVars--;
  }
  if (collapseNode_N)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local ID's.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;
  
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSbsimcmg_110::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
  }
    
  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_d = localLIDVec[nodeMap[admsNodeID_d]];
  li_g = localLIDVec[nodeMap[admsNodeID_g]];
  li_s = localLIDVec[nodeMap[admsNodeID_s]];
  li_e = localLIDVec[nodeMap[admsNodeID_e]];
  li_t = localLIDVec[nodeMap[admsNodeID_t]];
  li_si = localLIDVec[nodeMap[admsNodeID_si]];
  li_di = localLIDVec[nodeMap[admsNodeID_di]];
  li_ge = localLIDVec[nodeMap[admsNodeID_ge]];
  if (collapseNode_N)
  {
    li_N = -1;
  }
  else
  {
    li_N = localLIDVec[nodeMap[admsNodeID_N]];
  }


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
    Xyce::dout() << "\nli_d = " << li_d << std::endl;
    Xyce::dout() << "\nli_g = " << li_g << std::endl;
    Xyce::dout() << "\nli_s = " << li_s << std::endl;
    Xyce::dout() << "\nli_e = " << li_e << std::endl;
    Xyce::dout() << "\nli_t = " << li_t << std::endl;
    Xyce::dout() << "\nli_si = " << li_si << std::endl;
    Xyce::dout() << "\nli_di = " << li_di << std::endl;
    Xyce::dout() << "\nli_ge = " << li_ge << std::endl;
    Xyce::dout() << "\nli_N = " << li_N << std::endl;

    Xyce::dout() << "\nEnd of ADMSbsimcmg_110::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
  addInternalNode(symbol_table, li_t, getName(), "t");
  if (!collapseNode_si)
  {
    addInternalNode(symbol_table, li_si, getName(), "si");
  }
  if (!collapseNode_di)
  {
    addInternalNode(symbol_table, li_di, getName(), "di");
  }
  if (!collapseNode_ge)
  {
    addInternalNode(symbol_table, li_ge, getName(), "ge");
  }
  if (!collapseNode_N)
  {
    addInternalNode(symbol_table, li_N, getName(), "N");
  }

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_id, getName(), "BRANCH_DD");
    addBranchDataNode( symbol_table, li_branch_ig, getName(), "BRANCH_DG");
    addBranchDataNode( symbol_table, li_branch_is, getName(), "BRANCH_DS");
    addBranchDataNode( symbol_table, li_branch_ie, getName(), "BRANCH_D4");
  }
}
 
//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {    
    int i = 0;
    li_branch_id = branchLIDVecRef[i++];
    li_branch_ig = branchLIDVecRef[i++];
    li_branch_is = branchLIDVecRef[i++];
    li_branch_ie = branchLIDVecRef[i++];
  }
}
  
//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes : In initial version, we won't support mapping away nodes
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
  return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_d)];
  A_d_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_s)];
  A_d_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_t)];
  A_d_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_di)];
  A_d_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_si)];
  A_d_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_ge)];
  A_d_Equ_ge_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_e)];
  A_d_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_g)];
  A_g_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_ge)];
  A_g_Equ_ge_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_t)];
  A_g_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_d)];
  A_s_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_s)];
  A_s_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_t)];
  A_s_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_di)];
  A_s_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_si)];
  A_s_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_ge)];
  A_s_Equ_ge_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_e)];
  A_s_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_ge)];
  A_e_Equ_ge_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_si)];
  A_e_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_e)];
  A_e_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_di)];
  A_e_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_t)];
  A_e_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_s)];
  A_e_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_d)];
  A_e_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_s)];
  A_t_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_si)];
  A_t_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_di)];
  A_t_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_d)];
  A_t_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_ge)];
  A_t_Equ_ge_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_e)];
  A_t_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_t)];
  A_t_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_ge)];
  A_si_Equ_ge_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_di)];
  A_si_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_si)];
  A_si_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_e)];
  A_si_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_t)];
  A_si_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_s)];
  A_si_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_d)];
  A_si_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_N)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_N)];
    A_si_Equ_N_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_ge)];
  A_di_Equ_ge_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_di)];
  A_di_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_si)];
  A_di_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_e)];
  A_di_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_t)];
  A_di_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_s)];
  A_di_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_d)];
  A_di_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_N)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_N)];
    A_di_Equ_N_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ge,admsNodeID_ge)];
  A_ge_Equ_ge_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ge,admsNodeID_e)];
  A_ge_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ge,admsNodeID_t)];
  A_ge_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ge,admsNodeID_si)];
  A_ge_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ge,admsNodeID_di)];
  A_ge_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ge,admsNodeID_s)];
  A_ge_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ge,admsNodeID_d)];
  A_ge_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ge,admsNodeID_g)];
  A_ge_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_N)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ge,admsNodeID_N)];
    A_ge_Equ_N_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_N)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N,admsNodeID_ge)];
    A_N_Equ_ge_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_N)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N,admsNodeID_e)];
    A_N_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_N)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N,admsNodeID_si)];
    A_N_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_N)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N,admsNodeID_s)];
    A_N_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_N)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N,admsNodeID_di)];
    A_N_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_N)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N,admsNodeID_d)];
    A_N_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_N)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N,admsNodeID_t)];
    A_N_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_N)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N,admsNodeID_N)];
    A_N_Equ_N_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix * dFdxMatPtr = extData.dFdxMatrixPtr;
  Linear::Matrix * dQdxMatPtr = extData.dQdxMatrixPtr;
  f_d_Equ_d_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_d,li_d);
  q_d_Equ_d_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_d,li_d);
  f_d_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_d,li_s);
  q_d_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_d,li_s);
  f_d_Equ_t_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_d,li_t);
  q_d_Equ_t_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_d,li_t);
  f_d_Equ_di_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_d,li_di);
  q_d_Equ_di_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_d,li_di);
  f_d_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_d,li_si);
  q_d_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_d,li_si);
  f_d_Equ_ge_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_d,li_ge);
  q_d_Equ_ge_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_d,li_ge);
  f_d_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_d,li_e);
  q_d_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_d,li_e);
  f_g_Equ_g_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_g,li_g);
  q_g_Equ_g_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_g,li_g);
  f_g_Equ_ge_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_g,li_ge);
  q_g_Equ_ge_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_g,li_ge);
  f_g_Equ_t_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_g,li_t);
  q_g_Equ_t_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_g,li_t);
  f_s_Equ_d_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_d);
  q_s_Equ_d_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_d);
  f_s_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_s);
  q_s_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_s);
  f_s_Equ_t_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_t);
  q_s_Equ_t_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_t);
  f_s_Equ_di_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_di);
  q_s_Equ_di_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_di);
  f_s_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_si);
  q_s_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_si);
  f_s_Equ_ge_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_ge);
  q_s_Equ_ge_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_ge);
  f_s_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_e);
  q_s_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_e);
  f_e_Equ_ge_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_ge);
  q_e_Equ_ge_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_ge);
  f_e_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_si);
  q_e_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_si);
  f_e_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_e);
  q_e_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_e);
  f_e_Equ_di_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_di);
  q_e_Equ_di_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_di);
  f_e_Equ_t_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_t);
  q_e_Equ_t_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_t);
  f_e_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_s);
  q_e_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_s);
  f_e_Equ_d_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_d);
  q_e_Equ_d_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_d);
  f_t_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_t,li_s);
  q_t_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_t,li_s);
  f_t_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_t,li_si);
  q_t_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_t,li_si);
  f_t_Equ_di_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_t,li_di);
  q_t_Equ_di_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_t,li_di);
  f_t_Equ_d_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_t,li_d);
  q_t_Equ_d_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_t,li_d);
  f_t_Equ_ge_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_t,li_ge);
  q_t_Equ_ge_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_t,li_ge);
  f_t_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_t,li_e);
  q_t_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_t,li_e);
  f_t_Equ_t_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_t,li_t);
  q_t_Equ_t_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_t,li_t);
  f_si_Equ_ge_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_ge);
  q_si_Equ_ge_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_ge);
  f_si_Equ_di_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_di);
  q_si_Equ_di_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_di);
  f_si_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_si);
  q_si_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_si);
  f_si_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_e);
  q_si_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_e);
  f_si_Equ_t_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_t);
  q_si_Equ_t_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_t);
  f_si_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_s);
  q_si_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_s);
  f_si_Equ_d_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_d);
  q_si_Equ_d_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_d);
  if (!collapseNode_N)
  {
    f_si_Equ_N_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_N);
    q_si_Equ_N_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_N);
  }
  f_di_Equ_ge_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_di,li_ge);
  q_di_Equ_ge_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_di,li_ge);
  f_di_Equ_di_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_di,li_di);
  q_di_Equ_di_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_di,li_di);
  f_di_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_di,li_si);
  q_di_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_di,li_si);
  f_di_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_di,li_e);
  q_di_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_di,li_e);
  f_di_Equ_t_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_di,li_t);
  q_di_Equ_t_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_di,li_t);
  f_di_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_di,li_s);
  q_di_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_di,li_s);
  f_di_Equ_d_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_di,li_d);
  q_di_Equ_d_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_di,li_d);
  if (!collapseNode_N)
  {
    f_di_Equ_N_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_di,li_N);
    q_di_Equ_N_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_di,li_N);
  }
  f_ge_Equ_ge_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ge,li_ge);
  q_ge_Equ_ge_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ge,li_ge);
  f_ge_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ge,li_e);
  q_ge_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ge,li_e);
  f_ge_Equ_t_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ge,li_t);
  q_ge_Equ_t_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ge,li_t);
  f_ge_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ge,li_si);
  q_ge_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ge,li_si);
  f_ge_Equ_di_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ge,li_di);
  q_ge_Equ_di_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ge,li_di);
  f_ge_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ge,li_s);
  q_ge_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ge,li_s);
  f_ge_Equ_d_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ge,li_d);
  q_ge_Equ_d_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ge,li_d);
  f_ge_Equ_g_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ge,li_g);
  q_ge_Equ_g_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ge,li_g);
  if (!collapseNode_N)
  {
    f_ge_Equ_N_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ge,li_N);
    q_ge_Equ_N_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ge,li_N);
  }
  if (!collapseNode_N)
  {
    f_N_Equ_ge_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_N,li_ge);
    q_N_Equ_ge_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_N,li_ge);
  }
  if (!collapseNode_N)
  {
    f_N_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_N,li_e);
    q_N_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_N,li_e);
  }
  if (!collapseNode_N)
  {
    f_N_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_N,li_si);
    q_N_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_N,li_si);
  }
  if (!collapseNode_N)
  {
    f_N_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_N,li_s);
    q_N_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_N,li_s);
  }
  if (!collapseNode_N)
  {
    f_N_Equ_di_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_N,li_di);
    q_N_Equ_di_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_N,li_di);
  }
  if (!collapseNode_N)
  {
    f_N_Equ_d_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_N,li_d);
    q_N_Equ_d_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_N,li_d);
  }
  if (!collapseNode_N)
  {
    f_N_Equ_t_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_N,li_t);
    q_N_Equ_t_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_N,li_t);
  }
  if (!collapseNode_N)
  {
    f_N_Equ_N_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_N,li_N);
    q_N_Equ_N_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_N,li_N);
  }


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
  (*extData.daeFVectorPtr)[li_d] += staticContributions[admsNodeID_d].val();
  (*extData.daeFVectorPtr)[li_g] += staticContributions[admsNodeID_g].val();
  (*extData.daeFVectorPtr)[li_s] += staticContributions[admsNodeID_s].val();
  (*extData.daeFVectorPtr)[li_e] += staticContributions[admsNodeID_e].val();
  (*extData.daeFVectorPtr)[li_t] += staticContributions[admsNodeID_t].val();
  (*extData.daeFVectorPtr)[li_si] += staticContributions[admsNodeID_si].val();
  (*extData.daeFVectorPtr)[li_di] += staticContributions[admsNodeID_di].val();
  (*extData.daeFVectorPtr)[li_ge] += staticContributions[admsNodeID_ge].val();
  if (!collapseNode_N)
    (*extData.daeFVectorPtr)[li_N] += staticContributions[admsNodeID_N].val();


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;

    leadF[li_branch_id] = leadCurrentF[admsNodeID_d];
    leadF[li_branch_ig] = leadCurrentF[admsNodeID_g];
    leadF[li_branch_is] = leadCurrentF[admsNodeID_s];
    leadF[li_branch_ie] = leadCurrentF[admsNodeID_e];

    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.
    
    double * solVec = extData.nextSolVectorRawPtr;
    double * junctionV = extData.nextJunctionVCompRawPtr;
    junctionV[li_branch_id] = solVec[li_d] - solVec[li_s];
    junctionV[li_branch_ig] = solVec[li_g] - solVec[li_s];
          
  }  
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
  (*extData.daeQVectorPtr)[li_d] += dynamicContributions[admsNodeID_d].val();
  (*extData.daeQVectorPtr)[li_g] += dynamicContributions[admsNodeID_g].val();
  (*extData.daeQVectorPtr)[li_s] += dynamicContributions[admsNodeID_s].val();
  (*extData.daeQVectorPtr)[li_e] += dynamicContributions[admsNodeID_e].val();
  (*extData.daeQVectorPtr)[li_t] += dynamicContributions[admsNodeID_t].val();
  (*extData.daeQVectorPtr)[li_si] += dynamicContributions[admsNodeID_si].val();
  (*extData.daeQVectorPtr)[li_di] += dynamicContributions[admsNodeID_di].val();
  (*extData.daeQVectorPtr)[li_ge] += dynamicContributions[admsNodeID_ge].val();
  if (!collapseNode_N)
    (*extData.daeQVectorPtr)[li_N] += dynamicContributions[admsNodeID_N].val();


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;

    leadQ[li_branch_id] = leadCurrentQ[admsNodeID_d];
    leadQ[li_branch_ig] = leadCurrentQ[admsNodeID_g];
    leadQ[li_branch_is] = leadCurrentQ[admsNodeID_s];
    leadQ[li_branch_ie] = leadCurrentQ[admsNodeID_e];
  }  
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.


  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one bsimcmg_110 instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSbsimcmg_110::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double Abulk;
  AdmsFadType etaa;
  AdmsFadType epsilon;
  AdmsFadType npart_c;
  AdmsFadType npart_beta;
  AdmsFadType npart_theta;
  AdmsFadType gche;
  AdmsFadType noiGd0;
  AdmsFadType GammaGd0;
  AdmsFadType Swi;
  AdmsFadType Ssi;
  AdmsFadType Nstar;
  AdmsFadType Nl;
  AdmsFadType N0;
  AdmsFadType DelClm;
  double Leffnoisq;
  double Leffnoi;
  AdmsFadType Esatnoi;
  AdmsFadType vge_overlap;
  AdmsFadType Qedj3;
  AdmsFadType Qedj2;
  AdmsFadType Qedj1;
  AdmsFadType Qesj3;
  AdmsFadType Qesj2;
  AdmsFadType vec;
  AdmsFadType pb2;
  AdmsFadType Qec;
  AdmsFadType arg;
  AdmsFadType sarg;
  AdmsFadType Qesj1;
  AdmsFadType T4a;
  AdmsFadType T1_exp;
  AdmsFadType Vdseffx;
  AdmsFadType igc0;
  AdmsFadType Voxacc;
  AdmsFadType Vaux_Igbacc;
  AdmsFadType vfbzb;
  AdmsFadType Vaux_Igbinv;
  AdmsFadType ALPHAII;
  AdmsFadType VgsStep;
  AdmsFadType Vdsatii;
  AdmsFadType Vdiff;
  AdmsFadType Ratio;
  AdmsFadType cgsp;
  AdmsFadType cgdp;
  AdmsFadType vgd_overlap;
  AdmsFadType vgs_overlap;
  AdmsFadType qgd_ov;
  AdmsFadType qgs_ov;
  AdmsFadType qinv;
  AdmsFadType inv_MclmCV;
  AdmsFadType vgs_eff;
  AdmsFadType vgd_eff;
  AdmsFadType ids0;
  AdmsFadType ids0_ov_dqi;
  AdmsFadType MclmCV;
  AdmsFadType DvsatCV;
  AdmsFadType EsatCVL;
  AdmsFadType EsatCV;
  AdmsFadType Mob;
  AdmsFadType Mnud;
  AdmsFadType Nsat;
  AdmsFadType Dvsat;
  AdmsFadType Esat1L;
  AdmsFadType Esat1;
  AdmsFadType Mclm;
  AdmsFadType Moc;
  AdmsFadType VaDIBL;
  AdmsFadType Vgst2Vtm;
  AdmsFadType diffVds;
  AdmsFadType PVAGfactor;
  AdmsFadType DIBLfactor;
  AdmsFadType Dmob_cv;
  AdmsFadType Eeffm_cv;
  AdmsFadType ueff;
  AdmsFadType Dmob;
  AdmsFadType Eeffm;
  AdmsFadType beta;
  AdmsFadType coxeff;
  AdmsFadType qia2;
  AdmsFadType dqi;
  AdmsFadType qia;
  AdmsFadType T10;
  AdmsFadType T9;
  AdmsFadType Vdseff;
  AdmsFadType Vdsat;
  AdmsFadType Tc;
  AdmsFadType Ta;
  AdmsFadType WVCox;
  AdmsFadType T6;
  AdmsFadType EsatL;
  AdmsFadType Esat;
  AdmsFadType Rdss;
  AdmsFadType Dmobs;
  double qb0;
  AdmsFadType Eeffs;
  AdmsFadType T5;
  AdmsFadType T4;
  AdmsFadType T8;
  AdmsFadType T7;
  AdmsFadType vch;
  AdmsFadType vgsfbeff;
  AdmsFadType beta0;
  AdmsFadType dvth_all;
  AdmsFadType dvth_rsce;
  AdmsFadType dvth_dibl;
  AdmsFadType dvth_vtroll;
  AdmsFadType nVtm;
  AdmsFadType cdsc;
  AdmsFadType phist;
  AdmsFadType inv_MEXP;
  AdmsFadType EU_a;
  AdmsFadType UC_a;
  AdmsFadType UD_a;
  AdmsFadType UA_a;
  AdmsFadType u0_a;
  AdmsFadType CIT_a;
  AdmsFadType DVTSHIFT_a;
  AdmsFadType KSATIV_a;
  AdmsFadType PCLM_a;
  AdmsFadType RDDR_a;
  AdmsFadType RSDR_a;
  AdmsFadType VSAT1_a;
  AdmsFadType PTWG_a;
  AdmsFadType MEXP_a;
  AdmsFadType PDIBL2_a;
  AdmsFadType PDIBL1_a;
  AdmsFadType ETA0_a;
  AdmsFadType CDSCD_a;
  AdmsFadType wr;
  AdmsFadType wf;
  double vesmax;
  AdmsFadType vesx;
  AdmsFadType vdsx;
  AdmsFadType Qedj;
  AdmsFadType Qesj;
  AdmsFadType etaiv;
  AdmsFadType vgsfb;
  AdmsFadType ves;
  AdmsFadType vds;
  AdmsFadType vgs;
  AdmsFadType vge;
  AdmsFadType ved_jct;
  AdmsFadType ves_jct;
  AdmsFadType vgd_noswap;
  AdmsFadType vds_noswap;
  AdmsFadType vgs_noswap;
  AdmsFadType TRatio;
  AdmsFadType delTemp;
  AdmsFadType Vtm;
  double Vtm0;
  AdmsFadType Eg;
  double Eg0;
  AdmsFadType ni;
  AdmsFadType Nc;
  AdmsFadType ThetaSS;
  AdmsFadType kT;
  double E0;
  double E0prime;
  double E1;
  double E1prime;
  AdmsFadType gam0;
  AdmsFadType gam1;
  AdmsFadType dvch_qm;
  AdmsFadType ETA0_t;
  AdmsFadType ETA0R_t;
  AdmsFadType U0_t;
  AdmsFadType u0;
  AdmsFadType ETAMOB_t;
  AdmsFadType UA_t;
  AdmsFadType UD_t;
  AdmsFadType UCS_t;
  AdmsFadType rdstemp;
  AdmsFadType RSDR_t;
  AdmsFadType RDDR_t;
  AdmsFadType VSAT_t;
  AdmsFadType VSAT1_t;
  AdmsFadType VSATCV_t;
  AdmsFadType MEXP_t;
  AdmsFadType PTWG_t;
  AdmsFadType dvth_temp;
  AdmsFadType BETA0_t;
  AdmsFadType SII0_t;
  AdmsFadType K0_t;
  AdmsFadType K0SI_t;
  AdmsFadType K2SI_t;
  AdmsFadType K1_t;
  AdmsFadType K2SAT_t;
  AdmsFadType A1_t;
  AdmsFadType A2_t;
  AdmsFadType K2_t;
  AdmsFadType K0SISAT_t;
  AdmsFadType K2SISAT_t;
  AdmsFadType AIGBINV_t;
  AdmsFadType AIGBACC_t;
  AdmsFadType AIGC_t;
  AdmsFadType AIGS_t;
  AdmsFadType AIGD_t;
  AdmsFadType BGIDL_t;
  AdmsFadType BGISL_t;
  AdmsFadType ALPHA0_t;
  AdmsFadType ALPHA1_t;
  AdmsFadType ALPHAII0_t;
  AdmsFadType ALPHAII1_t;
  AdmsFadType igtemp;
  AdmsFadType igsd_mult;
  AdmsFadType vfbsd;
  AdmsFadType vfbsdcv;
  AdmsFadType phib;
  AdmsFadType vbi;
  AdmsFadType deltaPhi;
  AdmsFadType eta_mu;
  double eta_mu_cv;
  AdmsFadType Tb;
  AdmsFadType igentemp;
  AdmsFadType DevTemp;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (19))
  {
    probeVars.resize(19);
    staticContributions.resize(9+0);
    dynamicContributions.resize(9+0);
  }

  noiseContribsPower.resize(14);
  noiseContribsExponent.resize(14);
  
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 9+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // extract solution variables and set as Fad independent variables.
  probeVars[admsProbeID_V_N_GND] = ((collapseNode_N)?(0):((*solVectorPtr)[li_N]));
  probeVars[admsProbeID_V_N_GND].diff(admsProbeID_V_N_GND,19);
  probeVars[admsProbeID_V_g_ge] = (*solVectorPtr)[li_g] - (*solVectorPtr)[li_ge];
  probeVars[admsProbeID_V_g_ge].diff(admsProbeID_V_g_ge,19);
  probeVars[admsProbeID_V_s_si] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_si];
  probeVars[admsProbeID_V_s_si].diff(admsProbeID_V_s_si,19);
  probeVars[admsProbeID_V_d_di] = (*solVectorPtr)[li_d] - (*solVectorPtr)[li_di];
  probeVars[admsProbeID_V_d_di].diff(admsProbeID_V_d_di,19);
  probeVars[admsProbeID_V_e_ge] = (*solVectorPtr)[li_e] - (*solVectorPtr)[li_ge];
  probeVars[admsProbeID_V_e_ge].diff(admsProbeID_V_e_ge,19);
  probeVars[admsProbeID_V_ge_d] = (*solVectorPtr)[li_ge] - (*solVectorPtr)[li_d];
  probeVars[admsProbeID_V_ge_d].diff(admsProbeID_V_ge_d,19);
  probeVars[admsProbeID_V_ge_s] = (*solVectorPtr)[li_ge] - (*solVectorPtr)[li_s];
  probeVars[admsProbeID_V_ge_s].diff(admsProbeID_V_ge_s,19);
  probeVars[admsProbeID_V_di_d] = (*solVectorPtr)[li_di] - (*solVectorPtr)[li_d];
  probeVars[admsProbeID_V_di_d].diff(admsProbeID_V_di_d,19);
  probeVars[admsProbeID_V_si_s] = (*solVectorPtr)[li_si] - (*solVectorPtr)[li_s];
  probeVars[admsProbeID_V_si_s].diff(admsProbeID_V_si_s,19);
  probeVars[admsProbeID_V_e_s] = (*solVectorPtr)[li_e] - (*solVectorPtr)[li_s];
  probeVars[admsProbeID_V_e_s].diff(admsProbeID_V_e_s,19);
  probeVars[admsProbeID_V_d_s] = (*solVectorPtr)[li_d] - (*solVectorPtr)[li_s];
  probeVars[admsProbeID_V_d_s].diff(admsProbeID_V_d_s,19);
  probeVars[admsProbeID_V_g_s] = (*solVectorPtr)[li_g] - (*solVectorPtr)[li_s];
  probeVars[admsProbeID_V_g_s].diff(admsProbeID_V_g_s,19);
  probeVars[admsProbeID_V_ge_e] = (*solVectorPtr)[li_ge] - (*solVectorPtr)[li_e];
  probeVars[admsProbeID_V_ge_e].diff(admsProbeID_V_ge_e,19);
  probeVars[admsProbeID_V_e_di] = (*solVectorPtr)[li_e] - (*solVectorPtr)[li_di];
  probeVars[admsProbeID_V_e_di].diff(admsProbeID_V_e_di,19);
  probeVars[admsProbeID_V_e_si] = (*solVectorPtr)[li_e] - (*solVectorPtr)[li_si];
  probeVars[admsProbeID_V_e_si].diff(admsProbeID_V_e_si,19);
  probeVars[admsProbeID_V_ge_di] = (*solVectorPtr)[li_ge] - (*solVectorPtr)[li_di];
  probeVars[admsProbeID_V_ge_di].diff(admsProbeID_V_ge_di,19);
  probeVars[admsProbeID_V_di_si] = (*solVectorPtr)[li_di] - (*solVectorPtr)[li_si];
  probeVars[admsProbeID_V_di_si].diff(admsProbeID_V_di_si,19);
  probeVars[admsProbeID_V_ge_si] = (*solVectorPtr)[li_ge] - (*solVectorPtr)[li_si];
  probeVars[admsProbeID_V_ge_si].diff(admsProbeID_V_ge_si,19);
  probeVars[admsProbeID_Temp_t_GND] = (*solVectorPtr)[li_t];
  probeVars[admsProbeID_Temp_t_GND].diff(admsProbeID_Temp_t_GND,19);
  // -- code converted from analog/code block
  if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0.0)))
  {
    DevTemp = ((admsTemperature+(probeVars[admsProbeID_Temp_t_GND]))+(model_.DTEMP));
  }
  else
  {
    DevTemp = (admsTemperature+(model_.DTEMP));
  }
  //Begin block CMGTempDepCalc
  {
    TRatio = (DevTemp/Tnom);
    delTemp = (DevTemp-Tnom);
    Vtm = (8.617087e-5*DevTemp);
    Vtm0 = (8.617087e-5*Tnom);
    Eg = ((model_.BG0SUB)-((((model_.TBGASUB)*DevTemp)*DevTemp)/(DevTemp+(model_.TBGBSUB))));
    Eg0 = ((model_.BG0SUB)-((((model_.TBGASUB)*Tnom)*Tnom)/(Tnom+(model_.TBGBSUB))));
    T1 = ((DevTemp/300.15)*sqrt((DevTemp/300.15)));
    ni = (((model_.NI0SUB)*T1)*AnalogFunctions::lexp<AdmsFadType>((((model_.BG0SUB)/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm)))));
    Nc = ((model_.NC0SUB)*T1);
    ThetaSS = AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+(TSS_i*delTemp))-1.0e-6),1.0e-3);
    kT = (Vtm*1.60219e-19);
    T0 = ((1.05457e-34*3.14159265358979323846)/((2*Ach)/Weff_UFCM));
    E0 = ((T0.val()*T0.val())/(2.0*mx));
    E0prime = ((T0.val()*T0.val())/(2.0*mxprime));
    E1 = (4.0*E0);
    E1prime = (4.0*E0prime);
    T1 = ((gprime*mdprime)/(gfactor*md));
    gam0 = (1.0+(T1*AnalogFunctions::lexp<AdmsFadType>(((E0-E0prime)/kT))));
    gam1 = ((gam0+AnalogFunctions::lexp<AdmsFadType>(((E0-E1)/kT)))+(T1*AnalogFunctions::lexp<AdmsFadType>(((E0-E1prime)/kT))));
    T2 = ((-Vtm)*AnalogFunctions::lln<AdmsFadType>((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1)));
    dvch_qm = (QMFACTOR_i*((E0/1.60219e-19)+T2));
    ETA0_t = AnalogFunctions::Tempdep<AdmsFadType>(ETA0_i,(model_.TETA0),delTemp,(model_.TEMPMOD));
    ETA0R_t = AnalogFunctions::Tempdep<AdmsFadType>(ETA0R_i,(model_.TETA0R),delTemp,(model_.TEMPMOD));
    T1 = (U0_i*pow(TRatio,UTE_i));
    U0_t = (T1+AnalogFunctions::hypmax<AdmsFadType>((UTL_i*delTemp),((-0.9)*T1),1.0e-4));
    u0 = U0_t;
    if (((model_.ASYMMOD)==1))
    {
      T1 = (U0R_i*pow(TRatio,UTER_i));
      U0R_t = (T1+AnalogFunctions::hypmax<AdmsFadType>((UTLR_i*delTemp),((-0.9)*T1),1.0e-4));
      u0r = U0R_t;
    }
    ETAMOB_t = AnalogFunctions::Tempdep<AdmsFadType>(ETAMOB_i,EMOBT_i,delTemp,(model_.TEMPMOD));
    UA_t = (UA_i+AnalogFunctions::hypmax<AdmsFadType>((UA1_i*delTemp),(-UA_i),1.0e-6));
    if (((model_.ASYMMOD)!=0))
    {
      UAR_t = (UAR_i+AnalogFunctions::hypmax<AdmsFadType>((UA1R_i*delTemp),(-UAR_i),1.0e-6));
    }
    if (((model_.BULKMOD)!=0))
    {
      if (((model_.TEMPMOD)==0))
      {
        UC_t = AnalogFunctions::Tempdep<AdmsFadType>(UC_i,UC1_i,delTemp,0);
        if (((model_.ASYMMOD)!=0))
        {
          UCR_t = AnalogFunctions::Tempdep<AdmsFadType>(UCR_i,UC1R_i,delTemp,0);
        }
      }
      else
      {
        UC_t = (UC_i+(UC1_i*delTemp));
        if (((model_.ASYMMOD)!=0))
        {
          UCR_t = (UCR_i+(UC1R_i*delTemp));
        }
      }
    }
    UD_t = (UD_i*pow(TRatio,UD1_i));
    if (((model_.ASYMMOD)!=0))
    {
      UDR_t = (UDR_i*pow(TRatio,UD1R_i));
    }
    UCS_t = (UCS_i*pow(TRatio,UCSTE_i));
    rdstemp = AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+(PRT_i*delTemp))-1.0e-6),1.0e-3);
    RSDR_t = AnalogFunctions::Tempdep<AdmsFadType>((model_.RSDR),(model_.TRSDR),delTemp,(model_.TEMPMOD));
    if (((model_.ASYMMOD)!=0))
    {
      RSDRR_t = AnalogFunctions::Tempdep<AdmsFadType>((model_.RSDRR),(model_.TRSDR),delTemp,(model_.TEMPMOD));
    }
    RDDR_t = AnalogFunctions::Tempdep<AdmsFadType>((model_.RDDR),(model_.TRDDR),delTemp,(model_.TEMPMOD));
    if (((model_.ASYMMOD)!=0))
    {
      RDDRR_t = AnalogFunctions::Tempdep<AdmsFadType>((model_.RDDRR),(model_.TRDDR),delTemp,(model_.TEMPMOD));
    }
    VSAT_t = AnalogFunctions::Tempdep<AdmsFadType>(VSAT_i,(-AT_i),delTemp,(model_.TEMPMOD));
    if ((VSAT_t<1000))
    {
      std::cerr  << "Warning: VSAT(%f) = %e is less than 1K, setting it to 1K." << DevTemp << VSAT_t <<  std::endl; 
      VSAT_t = 1000;
    }
    if (((model_.ASYMMOD)!=0))
    {
      VSATR_t = AnalogFunctions::Tempdep<AdmsFadType>(VSATR_i,(-ATR_i),delTemp,(model_.TEMPMOD));
      if ((VSATR_t<1000))
      {
        std::cerr  << "Warning: VSATR(%f) = %e is less than 1K, setting it to 1K." << DevTemp << VSATR_t <<  std::endl; 
        VSATR_t = 1000;
      }
    }
    VSAT1_t = AnalogFunctions::Tempdep<AdmsFadType>(VSAT1_i,(-AT_i),delTemp,(model_.TEMPMOD));
    if ((VSAT1_t<1000))
    {
      std::cerr  << "Warning: VSAT1(%f) = %e is less than 1K, setting it to 1K." << DevTemp << VSAT1_t <<  std::endl; 
      VSAT1_t = 1000;
    }
    if (((model_.ASYMMOD)!=0))
    {
      VSAT1R_t = AnalogFunctions::Tempdep<AdmsFadType>(VSAT1R_i,(-AT_i),delTemp,(model_.TEMPMOD));
      if ((VSAT1R_t<1000))
      {
        std::cerr  << "Warning: VSAT1R(%f) = %e is less than 1K, setting it to 1K." << DevTemp << VSAT1R_t <<  std::endl; 
        VSAT1R_t = 1000;
      }
    }
    VSATCV_t = AnalogFunctions::Tempdep<AdmsFadType>(VSATCV_i,(-ATCV_i),delTemp,(model_.TEMPMOD));
    if ((VSATCV_t<1000))
    {
      std::cerr  << "Warning: VSATCV(%f) = %e is less than 1K, setting it to 1K." << DevTemp << VSATCV_t <<  std::endl; 
      VSATCV_t = 1000;
    }
    MEXP_t = (AnalogFunctions::hypsmooth<AdmsFadType>(((MEXP_i*(1.0+((model_.TMEXP)*delTemp)))-2.0),1.0e-3)+2.0);
    if (((model_.ASYMMOD)!=0))
    {
      MEXPR_t = (AnalogFunctions::hypsmooth<AdmsFadType>(((MEXPR_i*(1.0+((model_.TMEXPR)*delTemp)))-2.0),1.0e-3)+2.0);
    }
    PTWG_t = AnalogFunctions::Tempdep<AdmsFadType>(PTWG_i,(-PTWGT_i),delTemp,(model_.TEMPMOD));
    if (((model_.ASYMMOD)!=0))
    {
      PTWGR_t = AnalogFunctions::Tempdep<AdmsFadType>(PTWGR_i,(-PTWGT_i),delTemp,(model_.TEMPMOD));
    }
    dvth_temp = ((KT1_i+((model_.KT1L)/Leff))*(TRatio-1.0));
    BETA0_t = (BETA0_i*pow(TRatio,IIT_i));
    SII0_t = (SII0_i*(AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+(TII_i*(TRatio-1.0)))-0.01),1.0e-3)+0.01));
    K0_t = (K0_i+(K01_i*delTemp));
    K0SI_t = (K0SI_i+AnalogFunctions::hypmax<AdmsFadType>((K0SI1_i*delTemp),(-K0SI_i),1.0e-6));
    K2SI_t = (K2SI_i+AnalogFunctions::hypmax<AdmsFadType>((K2SI1_i*delTemp),(-K2SI_i),1.0e-6));
    K1_t = (K1_i+AnalogFunctions::hypmax<AdmsFadType>((K11_i*delTemp),(-K1_i),1.0e-6));
    K2SAT_t = (K2SAT_i+(K2SAT1_i*delTemp));
    A1_t = (A1_i+(A11_i*delTemp));
    A2_t = (A2_i+(A21_i*delTemp));
    K2_t = (K2_i+AnalogFunctions::hypmax<AdmsFadType>((K21_i*delTemp),(-K2_i),1.0e-6));
    K0SISAT_t = (K0SISAT_i+(K0SISAT1_i*delTemp));
    K2SISAT_t = (K2SISAT_i+(K2SISAT1_i*delTemp));
    AIGBINV_t = (AIGBINV_i+AnalogFunctions::hypmax<AdmsFadType>((AIGBINV1_i*delTemp),(-AIGBINV_i),1.0e-6));
    AIGBACC_t = (AIGBACC_i+AnalogFunctions::hypmax<AdmsFadType>((AIGBACC1_i*delTemp),(-AIGBACC_i),1.0e-6));
    AIGC_t = (AIGC_i+AnalogFunctions::hypmax<AdmsFadType>((AIGC1_i*delTemp),(-AIGC_i),1.0e-6));
    AIGS_t = (AIGS_i+AnalogFunctions::hypmax<AdmsFadType>((AIGS1_i*delTemp),(-AIGS_i),1.0e-6));
    AIGD_t = (AIGD_i+AnalogFunctions::hypmax<AdmsFadType>((AIGD1_i*delTemp),(-AIGD_i),1.0e-6));
    BGIDL_t = (BGIDL_i*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3));
    BGISL_t = (BGISL_i*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3));
    ALPHA0_t = (ALPHA0_i+AnalogFunctions::hypmax<AdmsFadType>(((model_.ALPHA01)*delTemp),(-ALPHA0_i),1.0e-6));
    ALPHA1_t = (ALPHA1_i+AnalogFunctions::hypmax<AdmsFadType>(((model_.ALPHA11)*delTemp),(-ALPHA1_i),1.0e-6));
    ALPHAII0_t = (ALPHAII0_i+AnalogFunctions::hypmax<AdmsFadType>(((model_.ALPHAII01)*delTemp),(-ALPHAII0_i),1.0e-25));
    ALPHAII1_t = (ALPHAII1_i+AnalogFunctions::hypmax<AdmsFadType>(((model_.ALPHAII11)*delTemp),(-ALPHAII1_i),1.0e-20));
    igtemp = AnalogFunctions::lexp<AdmsFadType>((IGT_i*AnalogFunctions::lln<AdmsFadType>(TRatio)));
    igsd_mult = (igsd_mult0*igtemp);
    if (((model_.BULKMOD)!=0))
    {
      CJS_t = AnalogFunctions::Tempdep<AdmsFadType>((model_.CJS),(model_.TCJ),delTemp,(model_.TEMPMOD));
      CJD_t = AnalogFunctions::Tempdep<AdmsFadType>((model_.CJD),(model_.TCJ),delTemp,(model_.TEMPMOD));
      CJSWS_t = AnalogFunctions::Tempdep<AdmsFadType>((model_.CJSWS),(model_.TCJSW),delTemp,(model_.TEMPMOD));
      CJSWD_t = AnalogFunctions::Tempdep<AdmsFadType>((model_.CJSWD),(model_.TCJSW),delTemp,(model_.TEMPMOD));
      CJSWGS_t = AnalogFunctions::Tempdep<AdmsFadType>((model_.CJSWGS),(model_.TCJSWG),delTemp,(model_.TEMPMOD));
      CJSWGD_t = AnalogFunctions::Tempdep<AdmsFadType>((model_.CJSWGD),(model_.TCJSWG),delTemp,(model_.TEMPMOD));
      PBS_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.PBS)-((model_.TPB)*delTemp))-0.01),1.0e-3)+0.01);
      PBD_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.PBD)-((model_.TPB)*delTemp))-0.01),1.0e-3)+0.01);
      PBSWS_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.PBSWS)-((model_.TPBSW)*delTemp))-0.01),1.0e-3)+0.01);
      PBSWD_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.PBSWD)-((model_.TPBSW)*delTemp))-0.01),1.0e-3)+0.01);
      PBSWGS_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.PBSWGS)-((model_.TPBSWG)*delTemp))-0.01),1.0e-3)+0.01);
      PBSWGD_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.PBSWGD)-((model_.TPBSWG)*delTemp))-0.01),1.0e-3)+0.01);
      T0 = ((Eg0/Vtm0)-(Eg/Vtm));
      T1 = AnalogFunctions::lln<AdmsFadType>(TRatio);
      T3 = AnalogFunctions::lexp<AdmsFadType>(((T0+((model_.XTIS)*T1))/(model_.NJS)));
      JSS_t = ((model_.JSS)*T3);
      JSWS_t = ((model_.JSWS)*T3);
      JSWGS_t = ((model_.JSWGS)*T3);
      T3 = AnalogFunctions::lexp<AdmsFadType>(((T0+((model_.XTID)*T1))/(model_.NJD)));
      JSD_t = ((model_.JSD)*T3);
      JSWD_t = ((model_.JSWD)*T3);
      JSWGD_t = ((model_.JSWGD)*T3);
      JTSS_t = ((model_.JTSS)*AnalogFunctions::lexp<AdmsFadType>((((Eg0*(model_.XTSS))*(TRatio-1.0))/Vtm)));
      JTSD_t = ((model_.JTSD)*AnalogFunctions::lexp<AdmsFadType>((((Eg0*(model_.XTSD))*(TRatio-1.0))/Vtm)));
      JTSSWS_t = ((model_.JTSSWS)*AnalogFunctions::lexp<AdmsFadType>((((Eg0*(model_.XTSSWS))*(TRatio-1.0))/Vtm)));
      JTSSWD_t = ((model_.JTSSWD)*AnalogFunctions::lexp<AdmsFadType>((((Eg0*(model_.XTSSWD))*(TRatio-1.0))/Vtm)));
      JTSSWGS_t = (((model_.JTSSWGS)*(sqrt(((model_.JTWEFF)/Weff0))+1.0))*AnalogFunctions::lexp<AdmsFadType>((((Eg0*(model_.XTSSWGS))*(TRatio-1.0))/Vtm)));
      JTSSWGD_t = (((model_.JTSSWGD)*(sqrt(((model_.JTWEFF)/Weff0))+1.0))*AnalogFunctions::lexp<AdmsFadType>((((Eg0*(model_.XTSSWGD))*(TRatio-1.0))/Vtm)));
      NJTS_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.NJTS)*(1.0+((model_.TNJTS)*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
      NJTSD_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.NJTSD)*(1.0+((model_.TNJTSD)*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
      NJTSSW_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.NJTSSW)*(1.0+((model_.TNJTSSW)*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
      NJTSSWD_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.NJTSSWD)*(1.0+((model_.TNJTSSWD)*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
      NJTSSWG_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.NJTSSWG)*(1.0+((model_.TNJTSSWG)*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
      NJTSSWGD_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.NJTSSWGD)*(1.0+((model_.TNJTSSWGD)*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
    }
    if ((!(model_.given("VFBSD"))))
    {
      if (((model_.NGATE)>0.0))
      {
        vfbsd = (devsign*(AnalogFunctions::hypsmooth<AdmsFadType>(((0.5*Eg)-(Vtm*AnalogFunctions::lln<AdmsFadType>(((model_.NGATE)/ni)))),1.0e-4)-((0.5*Eg)-(devsign*((0.5*Eg)-AnalogFunctions::hypsmooth<AdmsFadType>(((0.5*Eg)-(Vtm*AnalogFunctions::lln<AdmsFadType>(((model_.NSD)/ni)))),1.0e-4))))));
      }
      else
      {
        vfbsd = (devsign*(PHIG_i-(((model_.EASUB)+(0.5*Eg))-(devsign*((0.5*Eg)-AnalogFunctions::hypsmooth<AdmsFadType>(((0.5*Eg)-(Vtm*AnalogFunctions::lln<AdmsFadType>(((model_.NSD)/ni)))),1.0e-4))))));
      }
    }
    else
    {
      vfbsd = (model_.VFBSD);
    }
    if ((!(model_.given("VFBSDCV"))))
    {
      vfbsdcv = vfbsd;
    }
    else
    {
      vfbsdcv = (model_.VFBSDCV);
    }
    if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0.0)))
    {
      T0 = (Vtm*AnalogFunctions::lln<AdmsFadType>((nbody/ni)));
      phib = sqrt(((T0*T0)+1.0e-6));
    }
    else
    {
      phib = (Vtm*AnalogFunctions::lln<AdmsFadType>((nbody/ni)));
    }
    if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0.0)))
    {
      T0 = (Vtm*AnalogFunctions::lln<AdmsFadType>(((nbody*(model_.NSD))/(ni*ni))));
      vbi = sqrt(((T0*T0)+1.0e-6));
    }
    else
    {
      vbi = (Vtm*AnalogFunctions::lln<AdmsFadType>(((nbody*(model_.NSD))/(ni*ni))));
    }
    deltaPhi = (devsign*(PHIG_i-((model_.EASUB)+adms_ternary_op<AdmsFadType>(((model_.TYPE)==1),0,Eg))));
    eta_mu = (0.5*ETAMOB_t);
    eta_mu_cv = 0.5;
    if (((model_.TYPE)!=1))
    {
      eta_mu = ((1.0/3.0)*ETAMOB_t);
      eta_mu_cv = (1.0/3.0);
    }
    if (((model_.BULKMOD)!=0))
    {
      Isbs = (((ASEJ*JSS_t)+(PSEJ*JSWS_t))+((TFIN*NFINtotal)*JSWGS_t));
      if ((Isbs>0.0))
      {
        Nvtms = (Vtm*(model_.NJS));
        XExpBVS = (AnalogFunctions::lexp<AdmsFadType>(((-(model_.BVS))/Nvtms))*(model_.XJBVS));
        T2 = max(((model_.IJTHSFWD)/Isbs),static_cast<double>(10.0));
        Tb = ((1.0+T2)-XExpBVS);
        VjsmFwd = (Nvtms*AnalogFunctions::lln<AdmsFadType>((0.5*(Tb+sqrt(((Tb*Tb)+(4.0*XExpBVS)))))));
        T0 = AnalogFunctions::lexp<AdmsFadType>((VjsmFwd/Nvtms));
        IVjsmFwd = (Isbs*(((T0-(XExpBVS/T0))+XExpBVS)-1.0));
        SslpFwd = ((Isbs*(T0+(XExpBVS/T0)))/Nvtms);
        T2 = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.IJTHSREV)/Isbs)-10.0),1.0e-3)+10.0);
        VjsmRev = ((-(model_.BVS))-(Nvtms*AnalogFunctions::lln<AdmsFadType>(((T2-1.0)/(model_.XJBVS)))));
        T1 = ((model_.XJBVS)*AnalogFunctions::lexp<AdmsFadType>(((-((model_.BVS)+VjsmRev))/Nvtms)));
        IVjsmRev = (Isbs*(1.0+T1));
        SslpRev = (((-Isbs)*T1)/Nvtms);
      }
      Isbd = (((ADEJ*JSD_t)+(PDEJ*JSWD_t))+((TFIN*NFINtotal)*JSWGD_t));
      if ((Isbd>0.0))
      {
        Nvtmd = (Vtm*(model_.NJD));
        XExpBVD = (AnalogFunctions::lexp<AdmsFadType>(((-(model_.BVD))/Nvtmd))*(model_.XJBVD));
        T2 = max(((model_.IJTHDFWD)/Isbd),static_cast<double>(10.0));
        Tb = ((1.0+T2)-XExpBVD);
        VjdmFwd = (Nvtmd*AnalogFunctions::lln<AdmsFadType>((0.5*(Tb+sqrt(((Tb*Tb)+(4.0*XExpBVD)))))));
        T0 = AnalogFunctions::lexp<AdmsFadType>((VjdmFwd/Nvtmd));
        IVjdmFwd = (Isbd*(((T0-(XExpBVD/T0))+XExpBVD)-1.0));
        DslpFwd = ((Isbd*(T0+(XExpBVD/T0)))/Nvtmd);
        T2 = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.IJTHDREV)/Isbd)-10.0),1.0e-3)+10.0);
        VjdmRev = ((-(model_.BVD))-(Nvtmd*AnalogFunctions::lln<AdmsFadType>(((T2-1.0)/(model_.XJBVD)))));
        T1 = ((model_.XJBVD)*AnalogFunctions::lexp<AdmsFadType>(((-((model_.BVD)+VjdmRev))/Nvtmd)));
        IVjdmRev = (Isbd*(1.0+T1));
        DslpRev = (((-Isbd)*T1)/Nvtmd);
      }
      Czbs = (CJS_t*ASEJ);
      Czbssw = (CJSWS_t*PSEJ);
      Czbsswg = ((CJSWGS_t*Weff0)*NFINtotal);
      Czbd = (CJD_t*ADEJ);
      Czbdsw = (CJSWD_t*PDEJ);
      Czbdswg = ((CJSWGD_t*Weff0)*NFINtotal);
    }
    T0 = ((Eg/Vtm)*(TRatio-1.0));
    T1 = (T0/NTGEN_i);
    igentemp = AnalogFunctions::lexp<AdmsFadType>(T1);
  }
  // End block CMGTempDepCalc
  vgs_noswap = (devsign*(probeVars[admsProbeID_V_ge_si]));
  vds_noswap = (devsign*(probeVars[admsProbeID_V_di_si]));
  vgd_noswap = (devsign*(probeVars[admsProbeID_V_ge_di]));
  ves_jct = (devsign*(probeVars[admsProbeID_V_e_si]));
  ved_jct = (devsign*(probeVars[admsProbeID_V_e_di]));
  vge = (devsign*(probeVars[admsProbeID_V_ge_e]));
  sigvds = 1.0;
  if ((vds_noswap<0.0))
  {
    sigvds = (-1.0);
    vgs = (vgs_noswap-vds_noswap);
    vds = ((-1.0)*vds_noswap);
    ves = ved_jct;
  }
  else
  {
    vgs = vgs_noswap;
    vds = vds_noswap;
    ves = ves_jct;
  }
  vgsfb = (vgs-deltaPhi);
  etaiv = 0.0;
  Qes = 0.0;
  Qesj = 0.0;
  Qeg = 0.0;
  Qed = 0.0;
  Qedj = 0.0;
  vdsx = (sqrt(((vds*vds)+0.01))-0.1);
  if (((model_.BULKMOD)!=0))
  {
    vesx = (ves-(0.5*(vds-vdsx)));
    vesmax = (0.95*PHIBE_i);
    T2 = ((vesmax-vesx)-1.0e-3);
    veseff = (vesmax-(0.5*(T2+sqrt(((T2*T2)+(0.004*vesmax))))));
  }
  T0 = tanh(((0.6*vds_noswap)/Vtm));
  wf = (0.5+(0.5*T0));
  wr = (1.0-wf);
  if (((model_.ASYMMOD)!=0))
  {
    CDSCD_a = ((CDSCDR_i*wr)+(CDSCD_i*wf));
    ETA0_a = ((ETA0R_t*wr)+(ETA0_t*wf));
    PDIBL1_a = ((PDIBL1R_i*wr)+(PDIBL1_i*wf));
    PDIBL2_a = ((PDIBL2R_i*wr)+(PDIBL2_i*wf));
    MEXP_a = ((MEXPR_t*wr)+(MEXP_t*wf));
    PTWG_a = ((PTWGR_t*wr)+(PTWG_t*wf));
    VSAT1_a = ((VSAT1R_t*wr)+(VSAT1_t*wf));
    RSDR_a = ((RSDRR_t*wr)+(RSDR_t*wf));
    RDDR_a = ((RDDRR_t*wr)+(RDDR_t*wf));
    PCLM_a = ((PCLMR_i*wr)+(PCLM_i*wf));
    VSAT_a = ((VSATR_t*wr)+(VSAT_t*wf));
    KSATIV_a = ((KSATIVR_i*wr)+(KSATIV_i*wf));
    DVTSHIFT_a = ((DVTSHIFTR_i*wr)+(DVTSHIFT_i*wf));
    CIT_a = ((CITR_i*wr)+(CIT_i*wf));
    u0_a = ((u0r*wr)+(u0*wf));
    UA_a = ((UAR_t*wr)+(UA_t*wf));
    UD_a = ((UDR_t*wr)+(UD_t*wf));
    UC_a = ((UCR_t*wr)+(UC_t*wf));
    EU_a = ((EUR_i*wr)+(EU_i*wf));
  }
  else
  {
    CDSCD_a = CDSCD_i;
    ETA0_a = ETA0_t;
    PDIBL1_a = PDIBL1_i;
    PDIBL2_a = PDIBL2_i;
    MEXP_a = MEXP_t;
    PTWG_a = PTWG_t;
    VSAT1_a = VSAT1_t;
    RSDR_a = RSDR_t;
    RDDR_a = RDDR_t;
    PCLM_a = PCLM_i;
    VSAT_a = VSAT_t;
    KSATIV_a = KSATIV_i;
    DVTSHIFT_a = DVTSHIFT_i;
    CIT_a = CIT_i;
    u0_a = u0;
    UA_a = UA_t;
    UD_a = UD_t;
    UC_a = UC_t;
    EU_a = EU_i;
  }
  inv_MEXP = (1.0/MEXP_a);
  phist = ((0.4+phib)+PHIN_i);
  T1 = ((2.0*(Cins/Weff_UFCM))/(rc+2.0));
  cdsc = (Theta_SW*(CDSC_i+(CDSCD_a*vdsx)));
  if ((!(model_.given("NVTM"))))
  {
    nVtm = ((Vtm*ThetaSS)*(1.0+((CIT_a+cdsc)/T1)));
  }
  else
  {
    nVtm = (model_.NVTM);
  }
  qdep = (Qdep_ov_Cins/nVtm);
  vth_fixed_factor_SI = log(((Cins*nVtm)/(((1.60219e-19*Nc)*2.0)*Ach)));
  vth_fixed_factor_Sub = (log((((qdep*rc)*(qdep*rc))/((exp((qdep*rc))-(qdep*rc))-1.0)))+vth_fixed_factor_SI);
  q0 = (((10.0*nVtm)/rc)+(2.0*qbs));
  fieldnormalizationfactor = ((Vtm*Cins)/(Weff_UFCM*epssub));
  auxQMfact = pow((((((((3.0/4.0)*3.0)*1.05457e-34)*2.0)*3.14159265358979323846)*1.60219e-19)/(4.0*sqrt((2.0*mx)))),(2.0/3.0));
  QMFACTORCVfinal = ((((model_.QMFACTORCV)*auxQMfact)*pow(fieldnormalizationfactor,(2.0/3.0)))*(1/(1.60219e-19*Vtm)));
  dvth_vtroll = (((-DVT0_i)*Theta_SCE)*(vbi-phist));
  dvth_dibl = ((((-ETA0_a)*Theta_DIBL)*vdsx)+((DVTP0_i*Theta_DITS)*pow(vdsx,DVTP1_i)));
  dvth_rsce = ((K1RSCE_i*Theta_RSCE)*sqrt(phist));
  dvth_all = ((((dvth_vtroll+dvth_dibl)+dvth_rsce)+dvth_temp)+DVTSHIFT_a);
  vgsfb = (vgsfb-dvth_all);
  beta0 = (((u0_a*cox)*Weff0)/Leff);
  T0 = (-(dvch_qm+(nVtm*AnalogFunctions::lln<AdmsFadType>((((2.0*cox)*(model_.Imin))/((((beta0*nVtm)*1.60219e-19)*Nc)*TFIN))))));
  T1 = ((vgsfb+T0)+(model_.DELVTRAND));
  vgsfbeff = (AnalogFunctions::hypsmooth<AdmsFadType>(T1,1.0e-4)-T0);
  vch = (+dvch_qm);
  if (((model_.BULKMOD)!=0))
  {
    T1 = AnalogFunctions::hypsmooth<AdmsFadType>((((2.0*phib)+vch)-ves),0.1);
    T3 = (((-K1_t)/(2.0*nVtm))*(sqrt(T1)-sqrt((2.0*phib))));
    T0 = ((((-qdep)-T3)+vth_fixed_factor_Sub)+(QMFACTORCVfinal*pow((-qdep),(2.0/3.0))));
    T1 = (((-qdep)-T3)+vth_fixed_factor_SI);
  }
  else
  {
    T0 = (((-qdep)+vth_fixed_factor_Sub)+(QMFACTORCVfinal*pow((-qdep),(2.0/3.0))));
    T1 = ((-qdep)+vth_fixed_factor_SI);
  }
  T2 = ((vgsfbeff-vch)/nVtm);
  F0 = ((-T2)+T1);
  T3 = (0.5*(T2-T0));
  qm = exp(T3);
  if ((qm>1.0e-7))
  {
    T7 = log((1.0+qm));
    qm = (2.0*(1.0-sqrt((1.0+(T7*T7)))));
    T8 = (((qm*(model_.ALPHA_UFCM))+qdep)*rc);
    T4 = (T8/((exp(T8)-T8)-1.0));
    T5 = (T8*T4);
    e0 = ((((F0-qm)+log((-qm)))+log(T5))+(QMFACTORCVfinal*pow((-(qm+qdep)),(2.0/3.0))));
    e1 = ((((-1.0)+(1.0/qm))+((((2.0/T8)-T4)-1.0)*rc))-(((2.0/3.0)*QMFACTORCVfinal)*pow((-(qm+qdep)),((-1.0)/3.0))));
    e2 = (((-1.0)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*pow((-(qm+qdep)),((-4.0)/3.0))));
    qm = (qm-((e0/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))));
    T8 = (((qm*(model_.ALPHA_UFCM))+qdep)*rc);
    T4 = (T8/((exp(T8)-T8)-1.0));
    T5 = (T8*T4);
    e0 = ((((F0-qm)+log((-qm)))+log(T5))+(QMFACTORCVfinal*pow((-(qm+qdep)),(2.0/3.0))));
    e1 = ((((-1.0)+(1.0/qm))+((((2.0/T8)-T4)-1.0)*rc))-(((2.0/3.0)*QMFACTORCVfinal)*pow((-(qm+qdep)),((-1.0)/3.0))));
    e2 = (((-1.0)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*pow((-(qm+qdep)),((-4.0)/3.0))));
    qm = (qm-((e0/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))));
  }
  else
  {
    qm = ((-qm)*qm);
  }
  qis = ((-qm)*nVtm);
  Eeffs = (EeffFactor*(qbs+(eta_mu*qis)));
  qb0 = (1.0e-2/cox);
  T2 = pow((0.5*(1.0+fabs((qis/qb0)))),UCS_t);
  if (((model_.BULKMOD)!=0))
  {
    T3 = (((UA_a+(UC_a*veseff))*pow(fabs(Eeffs),EU_a))+(UD_a/T2));
  }
  else
  {
    T3 = ((UA_a*pow(fabs(Eeffs),EU_a))+(UD_a/T2));
  }
  Dmobs = (1.0+T3);
  Dmobs = (Dmobs/(model_.U0MULT));
  if (((model_.RDSMOD)==1))
  {
    Rdss = 0.0;
  }
  else
  {
    if (((model_.RDSMOD)==0))
    {
      T4 = (1.0+(PRWGS_i*qis));
      T1 = (1.0/T4);
      T0 = (0.5*(T1+sqrt(((T1*T1)+0.01))));
      Rdss = ((((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*rdstemp);
    }
    else
    {
      T4 = (1.0+(PRWGS_i*qis));
      T1 = (1.0/T4);
      T0 = (0.5*(T1+sqrt(((T1*T1)+0.01))));
      Rdss = ((((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*rdstemp);
    }
  }
  Esat = (((2.0*VSAT_a)/u0_a)*Dmobs);
  EsatL = (Esat*Leff);
  T6 = (KSATIV_a*(qis+(2*Vtm)));
  if ((Rdss==0.0))
  {
    Vdsat = ((EsatL*T6)/(EsatL+T6));
  }
  else
  {
    WVCox = ((Weff0*VSAT_a)*cox);
    T0 = (WVCox*Rdss);
    Ta = (2.0*T0);
    Tb = ((T6+EsatL)+((3.0*T6)*T0));
    Tc = (T6*(EsatL+((2.0*T6)*T0)));
    Vdsat = ((Tb-sqrt(((Tb*Tb)-((2.0*Ta)*Tc))))/Ta);
  }
  Vdsat = (AnalogFunctions::hypsmooth<AdmsFadType>((Vdsat-1.0e-3),1.0e-5)+1.0e-3);
  T7 = pow((vds/Vdsat),MEXP_a);
  T8 = pow((1.0+T7),inv_MEXP);
  Vdseff = (vds/T8);
  if ((Vdseff>vds))
  {
    Vdseff = vds;
  }
  vch = (Vdseff+dvch_qm);
  if (((model_.BULKMOD)!=0))
  {
    T1 = AnalogFunctions::hypsmooth<AdmsFadType>((((2.0*phib)+vch)-ves),0.1);
    T3 = (((-K1_t)/(2.0*nVtm))*(sqrt(T1)-sqrt((2.0*phib))));
    T0 = ((((-qdep)-T3)+vth_fixed_factor_Sub)+(QMFACTORCVfinal*pow((-qdep),(2.0/3.0))));
    T1 = (((-qdep)-T3)+vth_fixed_factor_SI);
  }
  else
  {
    T0 = (((-qdep)+vth_fixed_factor_Sub)+(QMFACTORCVfinal*pow((-qdep),(2.0/3.0))));
    T1 = ((-qdep)+vth_fixed_factor_SI);
  }
  T2 = ((vgsfbeff-vch)/nVtm);
  F0 = ((-T2)+T1);
  T3 = ((T2-T0)*0.5);
  qm = exp(T3);
  if ((qm>1.0e-7))
  {
    T7 = log((1.0+qm));
    qm = (2.0*(1.0-sqrt((1.0+(T7*T7)))));
    T8 = (((qm*(model_.ALPHA_UFCM))+qdep)*rc);
    T4 = (T8/((exp(T8)-T8)-1.0));
    T5 = (T8*T4);
    e0 = ((((F0-qm)+log((-qm)))+log(T5))+(QMFACTORCVfinal*pow((-(qm+qdep)),(2.0/3.0))));
    e1 = ((((-1.0)+(1.0/qm))+((((2.0/T8)-T4)-1.0)*rc))-(((2.0/3.0)*QMFACTORCVfinal)*pow((-(qm+qdep)),((-1.0)/3.0))));
    e2 = (((-1.0)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*pow((-(qm+qdep)),((-4.0)/3.0))));
    qm = (qm-((e0/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))));
    T8 = (((qm*(model_.ALPHA_UFCM))+qdep)*rc);
    T4 = (T8/((exp(T8)-T8)-1.0));
    T5 = (T8*T4);
    e0 = ((((F0-qm)+log((-qm)))+log(T5))+(QMFACTORCVfinal*pow((-(qm+qdep)),(2.0/3.0))));
    e1 = ((((-1.0)+(1.0/qm))+((((2.0/T8)-T4)-1.0)*rc))-(((2.0/3.0)*QMFACTORCVfinal)*pow((-(qm+qdep)),((-1.0)/3.0))));
    e2 = (((-1.0)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*pow((-(qm+qdep)),((-4.0)/3.0))));
    qm = (qm-((e0/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))));
  }
  else
  {
    qm = ((-qm)*qm);
  }
  qid = ((-qm)*nVtm);
  if (((model_.BULKMOD)!=0))
  {
    T9 = ((K1_t/(2.0*nVtm))*sqrt(Vtm));
    T0 = (T9/2.0);
    T2 = ((vge-(((deltaPhi-Eg)-(Vtm*log(((model_.NBODY)/Nc))))+(model_.DELVFBACC)))/Vtm);
    if (((T2*Vtm)>(phib+(T9*sqrt((phib*Vtm))))))
    {
      T1 = (sqrt(((T2-1.0)+(T0*T0)))-T0);
      T10 = (1.0+(T1*T1));
    }
    else
    {
      T3 = ((T2*0.5)-(3.0*(1.0+(T9/sqrt(static_cast<double>(2.0))))));
      T10 = (T3+sqrt(((T3*T3)+(6.0*T2))));
      if ((T2<0.0))
      {
        T4 = ((T2-T10)/T9);
        T10 = (-log(((1.0-T10)+(T4*T4))));
      }
      else
      {
        T11 = exp((-T10));
        T4 = (sqrt((((T2-1.0)+T11)+(T0*T0)))-T0);
        T10 = ((1.0-T11)+(T4*T4));
      }
    }
    T6 = (exp((-T10))-1.0);
    T7 = sqrt((T6+T10));
    if ((T10>1.0e-15))
    {
      e0 = ((-(T2-T10))+(T9*T7));
      e1 = (1.0-(((T9*0.5)*T6)/T7));
      T8 = (T10-(e0/e1));
      T11 = (exp((-T8))-1.0);
      T12 = sqrt((T11+T8));
      qba = (((-T9)*T12)*Vtm);
    }
    else
    {
      if ((T10<(-1.0e-15)))
      {
        e0 = ((-(T2-T10))-(T9*T7));
        e1 = (1.0+(((T9*0.5)*T6)/T7));
        T8 = (T10-(e0/e1));
        T12 = (T9*sqrt(((exp((-T8))+T8)-1.0)));
      }
      else
      {
        T12 = 0.0;
        T8 = 0.0;
      }
      qba = (T12*Vtm);
    }
    qi_acc_for_QM = ((T9*exp(((-T8)/2.0)))*Vtm);
    psipclamp = (0.5*((T8+1.0)+sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))));
    sqrtpsip = sqrt(psipclamp);
    nq = (1.0+(T9/sqrtpsip));
  }
  qia = (0.5*(qis+qid));
  dqi = (qis-qid);
  T0 = (pow(Vdseff,2.0)/6.25e-4);
  if (((model_.CHARGEWF)!=0.0))
  {
    qia2 = ((0.5*(qis+qid))+((((model_.CHARGEWF)*(1.0-AnalogFunctions::lexp<AdmsFadType>((-T0))))*0.5)*dqi));
  }
  else
  {
    qia2 = (0.5*(qis+qid));
  }
  if ((qis<0.0))
  {
    std::cerr  << "Warning: negative source-side inversion carrier density.  Vgs=%f  Vds=%f  Vbs=%f qis=%e" << (probeVars[admsProbeID_V_g_s]) << (probeVars[admsProbeID_V_d_s]) << (probeVars[admsProbeID_V_e_s]) << qis <<  std::endl; 
  }
  if ((qid<0.0))
  {
    std::cerr  << "Warning: negative drain-side inversion carrier density.  Vgs=%f  Vds=%f  Vbs=%f qid=%e" << (probeVars[admsProbeID_V_g_s]) << (probeVars[admsProbeID_V_d_s]) << (probeVars[admsProbeID_V_e_s]) << qid <<  std::endl; 
  }
  if ((QMTCENCV_i>0.0))
  {
    T4 = (qia/(model_.QM0));
    T5 = (1.0+pow(T4,(model_.PQM)));
    Tcen = (Tcen0/T5);
    coxeff = (1.0/((1.0/((cox*(model_.EOT))/(model_.TOXP)))+((Tcen*QMTCENCV_i)/epssub)));
  }
  else
  {
    coxeff = cox;
  }
  if ((((model_.BULKMOD)!=0)&&(QMTCENCVA_i!=0.0)))
  {
    T6 = (1.0+pow((qi_acc_for_QM/(model_.QM0ACC)),(model_.PQMACC)));
    Tcen = (Tcen0/T6);
    cox_acc = (1.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  }
  beta = (((u0_a*cox)*Weff0)/Leff);
  Eeffm = (EeffFactor*(qba+(eta_mu*qia2)));
  T2 = pow((0.5*(1.0+fabs((qia2/qb0)))),UCS_t);
  if (((model_.BULKMOD)!=0))
  {
    T3 = (((UA_a+(UC_a*veseff))*pow(fabs(Eeffm),EU_a))+(UD_a/T2));
  }
  else
  {
    T3 = ((UA_a*pow(fabs(Eeffm),EU_a))+(UD_a/T2));
  }
  Dmob = (1.0+T3);
  Dmob = (Dmob/(model_.U0MULT));
  ueff = (u0_a/Dmob);
  Eeffm_cv = (EeffFactor*(qba+(eta_mu_cv*qia2)));
  T3 = ((UA_a*pow(fabs(Eeffm_cv),EU_a))+(UD_a/T2));
  Dmob_cv = (1.0+T3);
  Dmob_cv = (Dmob_cv/(model_.U0MULT));
  tmp = (((DROUT_i*Leff)/scl)+1.0e-6);
  if ((tmp<40.0))
  {
    DIBLfactor = (((0.5*PDIBL1_a)/(cosh(tmp)-1.0))+PDIBL2_a);
  }
  else
  {
    DIBLfactor = ((PDIBL1_a*exp((-tmp)))+PDIBL2_a);
  }
  if ((PVAG_i>0.0))
  {
    PVAGfactor = (1.0+((PVAG_i*qia)/EsatL));
  }
  else
  {
    PVAGfactor = (1.0/(1.0-((PVAG_i*qia)/EsatL)));
  }
  if ((Vdseff>vds))
  {
    Vdseff = vds;
  }
  diffVds = (vds-Vdseff);
  Vgst2Vtm = (qia+(2.0*Vtm));
  if ((DIBLfactor>0))
  {
    T1 = Vgst2Vtm;
    T3 = (T1/(Vdsat+T1));
    VaDIBL = (((T1/DIBLfactor)*T3)*PVAGfactor);
    Moc = (1.0+(diffVds/VaDIBL));
  }
  else
  {
    Moc = 1.0;
  }
  if ((PCLM_a>0.0))
  {
    if ((PCLMG_i<0.0))
    {
      T1 = (1.0/((1.0/PCLM_a)-(PCLMG_i*qia)));
    }
    else
    {
      T1 = (PCLM_a+(PCLMG_i*qia));
    }
    Mclm = (1.0+(T1*AnalogFunctions::lln<AdmsFadType>((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))));
  }
  else
  {
    Mclm = 1.0;
  }
  Moc = (Moc*Mclm);
  Esat1 = ((2.0*VSAT1_a)/ueff);
  Esat1L = (Esat1*Leff);
  T0 = AnalogFunctions::lexp<AdmsFadType>((PSAT_i*AnalogFunctions::lln<AdmsFadType>((dqi/Esat1L))));
  Ta = (1.0+AnalogFunctions::lexp<AdmsFadType>(((1.0/PSAT_i)*AnalogFunctions::lln<AdmsFadType>(DELTAVSAT_i))));
  Dvsat = ((1.0+AnalogFunctions::lexp<AdmsFadType>(((1.0/PSAT_i)*AnalogFunctions::lln<AdmsFadType>((DELTAVSAT_i+T0)))))/Ta);
  Dvsat = (Dvsat+((((0.5*PTWG_a)*qia)*dqi)*dqi));
  T0 = (A1_t+(A2_t/(qia+(2.0*nVtm))));
  T1 = ((T0*dqi)*dqi);
  T2 = ((T1+1.0)-0.001);
  T3 = ((-1.0)+(0.5*(T2+sqrt(((T2*T2)+0.004)))));
  Nsat = (0.5*(1.0+sqrt((1.0+T3))));
  Dvsat = (Dvsat*Nsat);
  if ((K0_t!=0))
  {
    T1 = (K0_t/((max(static_cast<double>(0),(K0SI_t+((K0SISAT_t*dqi)*dqi)))*qia)+(2.0*nVtm)));
    Mnud = AnalogFunctions::lexp<AdmsFadType>((-T1));
  }
  else
  {
    Mnud = 1.0;
  }
  if (((model_.BULKMOD)==2))
  {
    T0 = AnalogFunctions::hypsmooth<AdmsFadType>((K2_t+(K2SAT_t*vdsx)),1.0e-6);
    T1 = (T0/((max(static_cast<double>(0),(K2SI_t+((K2SISAT_t*dqi)*dqi)))*qia)+(2.0*nVtm)));
    T3 = (sqrt((PHIBE_i-veseff))-sqrt(PHIBE_i));
    Mob = AnalogFunctions::lexp<AdmsFadType>(((-T1)*T3));
  }
  else
  {
    Mob = 1.0;
  }
  EsatCV = (((2.0*VSATCV_t)*Dmob_cv)/u0_a);
  EsatCVL = (EsatCV*LeffCV);
  T0 = AnalogFunctions::lexp<AdmsFadType>((PSATCV_i*AnalogFunctions::lln<AdmsFadType>((dqi/EsatCVL))));
  Ta = (1.0+AnalogFunctions::lexp<AdmsFadType>(((1.0/PSATCV_i)*AnalogFunctions::lln<AdmsFadType>(DELTAVSATCV_i))));
  DvsatCV = ((1.0+AnalogFunctions::lexp<AdmsFadType>(((1.0/PSATCV_i)*AnalogFunctions::lln<AdmsFadType>((DELTAVSATCV_i+T0)))))/Ta);
  if ((PCLMCV_i!=0))
  {
    MclmCV = (1.0+(PCLMCV_i*AnalogFunctions::lln<AdmsFadType>((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))));
  }
  else
  {
    MclmCV = 1.0;
  }
  qb = ((((-1.60219e-19)*nbody)*Ach)*LeffCV);
  T1 = qia;
  etaiv = (q0/(q0+qia));
  T2 = ((2.0-etaiv)*nVtm);
  ids0_ov_dqi = (T1+T2);
  ids0 = (ids0_ov_dqi*dqi);
  if ( (model_.RDSMOD) == (1))
  {
    Rdsi = 0.0;
    Dr = 1.0;
    T2 = (vgs_noswap-vfbsd);
    T3 = sqrt(((T2*T2)+1.0e-1));
    vgs_eff = (0.5*(T2+T3));
    T4 = (1.0+(PRWGS_i*vgs_eff));
    T1 = (1.0/T4);
    T0 = (0.5*(T1+sqrt(((T1*T1)+0.01))));
    T5 = (RSW_i*(1.0+(RSDR_a*AnalogFunctions::lexp<AdmsFadType>(((0.5*(model_.PRSDR))*AnalogFunctions::lln<AdmsFadType>((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6)))))));
    Rsource = (rdstemp*(RSourceGeo+((RSWMIN_i+(T5*T0))*WeffWRFactor)));
    T2 = (vgd_noswap-vfbsd);
    T3 = sqrt(((T2*T2)+1.0e-1));
    vgd_eff = (0.5*(T2+T3));
    T4 = (1.0+(PRWGD_i*vgd_eff));
    T1 = (1.0/T4);
    T0 = (0.5*(T1+sqrt(((T1*T1)+0.01))));
    T5 = (RDW_i*(1.0+(RDDR_a*AnalogFunctions::lexp<AdmsFadType>(((0.5*(model_.PRDDR))*AnalogFunctions::lln<AdmsFadType>((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6)))))));
    Rdrain = (rdstemp*(RDrainGeo+((RDWMIN_i+(T5*T0))*WeffWRFactor)));
  }
  else
    if ( (model_.RDSMOD) == (0))
    {
      Rsource = RSourceGeo;
      Rdrain = RDrainGeo;
      T4 = (1.0+(PRWGS_i*qia));
      T1 = (1.0/T4);
      T0 = (0.5*(T1+sqrt(((T1*T1)+0.01))));
      Rdsi = ((rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*WeffWRFactor);
      Dr = (1.0+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi));
    }
    else
      if ( (model_.RDSMOD) == (2))
      {
        T4 = (1.0+(PRWGS_i*qia));
        T1 = (1.0/T4);
        T0 = (0.5*(T1+sqrt(((T1*T1)+0.01))));
        Rdsi = ((rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*WeffWRFactor);
        Dr = (1.0+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi));
        Rsource = 0.0;
        Rdrain = 0.0;
      }
      else
      {
        // no default
      }
  ids = ((((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)/((Dmob*Dvsat)*Dr));
  ids = (ids*(model_.IDS0MULT));
  T11 = (((2.0*qia)+nVtm)/DvsatCV);
  qg = (qia+((dqi*dqi)/(6.0*T11)));
  qd = ((-0.5)*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))));
  inv_MclmCV = (1.0/MclmCV);
  qg = ((inv_MclmCV*qg)+((MclmCV-1.0)*qid));
  qd = (((inv_MclmCV*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*qid));
  qs = ((-qg)-qd);
  T6 = (((NFINtotal*WeffCV0)*LeffCV)*coxeff);
  qg = (T6*qg);
  qd = (T6*qd);
  qs = (T6*qs);
  qinv = qg;
  if (((model_.BULKMOD)!=0))
  {
    T1 = (((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc);
    T7 = qi_acc_for_QM;
    T10 = (T7*T1);
    qg_acc = (-T10);
    qb_acc = T10;
    T1 = (((NFINtotal*WeffCV0)*LeffCV)*cox);
    T2 = (qba-qi_acc_for_QM);
    T10 = (T1*T2);
    qg_acc = (qg_acc-T10);
    qb_acc = (qb_acc+T10);
    T1 = (((NFINtotal*WeffCV0)*LeffCV)*cox);
    T2 = (((nq-1.0)*0.5)*(qia+((dqi*dqi)/(6.0*T11))));
    T10 = (T1*T2);
    qg_acc = (qg_acc-T10);
    qb_acc = (qb_acc+T10);
  }
  if ((sigvds<0))
  {
    T1 = qd;
    qd = qs;
    qs = T1;
  }
  qgs_ov = 0.0;
  qgd_ov = 0.0;
  if (((model_.CGEOMOD)!=1))
  {
    T1 = ((NFINtotal*WeffCV0)*devsign);
    T2 = (devsign*(probeVars[admsProbeID_V_ge_si]));
    T0 = ((T2-vfbsdcv)+0.02);
    vgs_overlap = (0.5*(T0-sqrt(((T0*T0)+(4.0*0.02)))));
    qgs_ov = (T1*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))-1.0))))+(CGSO_i*T2)));
    T2 = (devsign*(probeVars[admsProbeID_V_ge_di]));
    T0 = ((T2-vfbsdcv)+0.02);
    vgd_overlap = (0.5*(T0-sqrt(((T0*T0)+(4.0*0.02)))));
    qgd_ov = (T1*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))-1.0))))+(CGDO_i*T2)));
  }
  if (((model_.CGEOMOD)==0))
  {
    T1 = (NFINtotal*WeffCV0);
    qgs_fr = ((T1*CFS_i)*(probeVars[admsProbeID_V_ge_si]));
    qgd_fr = ((T1*CFD_i)*(probeVars[admsProbeID_V_ge_di]));
    qgs_parasitic = (qgs_ov+qgs_fr);
    qgd_parasitic = (qgd_ov+qgd_fr);
  }
  else
  {
    if (((model_.CGEOMOD)==1))
    {
      if (((model_.CGEO1SW)==1))
      {
        T0 = (NFINtotal*WeffCV0);
        COVS_i = (T0*COVS_i);
        COVD_i = (T0*COVD_i);
        cgsp = (T0*CGSP);
        cgdp = (T0*CGDP);
      }
      else
      {
        cgsp = CGSP;
        cgdp = CGDP;
      }
      qgs_ov = (COVS_i*(probeVars[admsProbeID_V_ge_si]));
      qgd_ov = (COVD_i*(probeVars[admsProbeID_V_ge_di]));
      qgs_parasitic = qgs_ov;
      qgd_parasitic = qgd_ov;
      qgs_fr = (cgsp*(probeVars[admsProbeID_V_ge_s]));
      qgd_fr = (cgdp*(probeVars[admsProbeID_V_ge_d]));
    }
    else
    {
      qgs_fr = (Cfr_geo*(probeVars[admsProbeID_V_ge_si]));
      qgd_fr = (Cfr_geo*(probeVars[admsProbeID_V_ge_di]));
      qgs_parasitic = (qgs_ov+qgs_fr);
      qgd_parasitic = (qgd_ov+qgd_fr);
    }
  }
  qds_fr = (CDSP*(probeVars[admsProbeID_V_d_s]));
  Iii = 0.0;
  if (((model_.IIMOD)==1))
  {
    T0 = ((ALPHA0_t+(ALPHA1_t*Leff))/Leff);
    if (((T0<=0.0)||(BETA0_t<=0.0)))
    {
      Iii = 0.0;
    }
    else
    {
      T1 = ((-BETA0_t)/(diffVds+1.0e-30));
      Iii = (((T0*diffVds)*ids)*AnalogFunctions::lexp<AdmsFadType>(T1));
    }
  }
  else
  {
    if (((model_.IIMOD)==2))
    {
      ALPHAII = ((ALPHAII0_t+(ALPHAII1_t*Leff))/Leff);
      if ((ALPHAII<=0.0))
      {
        Iii = 0.0;
      }
      else
      {
        T0 = (ESATII_i*Leff);
        T1 = ((SII0_t*T0)/(1.0+T0));
        T0 = (1.0/(1.0+AnalogFunctions::hypsmooth<AdmsFadType>((SII1_i*vgsfbeff),(model_.IIMOD2CLAMP1))));
        T3 = (T0+SII2_i);
        T2 = AnalogFunctions::hypsmooth<AdmsFadType>((vgsfbeff*T3),(model_.IIMOD2CLAMP2));
        T3 = (1.0/(1.0+(SIID_i*vds)));
        VgsStep = ((T1*T2)*T3);
        Vdsatii = (VgsStep*(1.0-(LII_i/Leff)));
        Vdiff = (vds-Vdsatii);
        T0 = ((BETAII2_i+(BETAII1_i*Vdiff))+((BETAII0_i*Vdiff)*Vdiff));
        T1 = sqrt(((T0*T0)+1.0e-10));
        Ratio = (-AnalogFunctions::hypmax<AdmsFadType>(((-ALPHAII)*AnalogFunctions::lexp<AdmsFadType>((Vdiff/T1))),(-10.0),(model_.IIMOD2CLAMP3)));
        Iii = (Ratio*ids);
      }
    }
  }
  igbinv = 0.0;
  igbacc = 0.0;
  igcs = 0.0;
  igcd = 0.0;
  igs = 0.0;
  igd = 0.0;
  if (((model_.IGBMOD)!=0))
  {
    T1 = (((qia-EIGBINV_i)/NIGBINV_i)/Vtm);
    Vaux_Igbinv = ((NIGBINV_i*Vtm)*AnalogFunctions::lln<AdmsFadType>((1.0+AnalogFunctions::lexp<AdmsFadType>(T1))));
    T2 = (AIGBINV_t-(BIGBINV_i*qia));
    T3 = (1.0+(CIGBINV_i*qia));
    T4 = ((((-9.82222e11)*(model_.TOXG))*T2)*T3);
    T5 = AnalogFunctions::lexp<AdmsFadType>(T4);
    T6 = 3.75956e-7;
    igbinv = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*T5);
    igbinv = (igbinv*igtemp);
    vfbzb = ((deltaPhi-(Eg/2.0))-phib);
    T0 = (vfbzb-vge);
    T1 = ((T0/NIGBACC_i)/Vtm);
    Vaux_Igbacc = ((NIGBACC_i*Vtm)*AnalogFunctions::lln<AdmsFadType>((1.0+AnalogFunctions::lexp<AdmsFadType>(T1))));
    if (((model_.BULKMOD)!=0))
    {
      Voxacc = qi_acc_for_QM;
    }
    else
    {
      if ((vfbzb<=0))
      {
        Voxacc = (0.5*((T0-0.02)+sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))));
      }
      else
      {
        Voxacc = (0.5*((T0-0.02)+sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))));
      }
    }
    T2 = (AIGBACC_t-(BIGBACC_i*Voxacc));
    T3 = (1.0+(CIGBACC_i*Voxacc));
    T4 = ((((-7.45669e11)*(model_.TOXG))*T2)*T3);
    T5 = AnalogFunctions::lexp<AdmsFadType>(T4);
    T6 = 4.97232e-7;
    igbacc = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*T5);
    igbacc = (igbacc*igtemp);
  }
  if (((model_.IGCMOD)!=0))
  {
    T1 = (AIGC_t-(BIGC_i*qia));
    T2 = (1.0+(CIGC_i*qia));
    T3 = ((((-Bechvb)*(model_.TOXG))*T1)*T2);
    T4 = (qia*AnalogFunctions::lexp<AdmsFadType>(T3));
    T5 = ((vge+(0.5*vdsx))+(0.5*(ves_jct+ved_jct)));
    igc0 = ((((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*igtemp);
    Vdseffx = (sqrt(((Vdseff*Vdseff)+0.01))-0.1);
    T1 = (PIGCD_i*Vdseffx);
    T1_exp = AnalogFunctions::lexp<AdmsFadType>((-T1));
    T3 = (((T1+T1_exp)-1.0)+1.0e-4);
    T4 = ((1.0-((T1+1.0)*T1_exp))+1.0e-4);
    T5 = ((T1*T1)+2.0e-4);
    igcd = ((igc0*T4)/T5);
    igcs = ((igc0*T3)/T5);
    T0 = (vgs_noswap-vfbsd);
    vgs_eff = sqrt(((T0*T0)+1.0e-4));
    if (((model_.IGCLAMP)==1))
    {
      T1 = AnalogFunctions::hypsmooth<AdmsFadType>((AIGS_t-(BIGS_i*vgs_eff)),1.0e-6);
      if ((CIGS_i<0.01))
      {
        CIGS_i = 0.01;
      }
    }
    else
    {
      T1 = (AIGS_t-(BIGS_i*vgs_eff));
    }
    T2 = (1.0+(CIGS_i*vgs_eff));
    T3 = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*T2);
    T4 = AnalogFunctions::lexp<AdmsFadType>(T3);
    if ((sigvds>0.0))
    {
      igs = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*T4);
    }
    else
    {
      igd = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*T4);
    }
    T0 = (vgd_noswap-vfbsd);
    vgd_eff = sqrt(((T0*T0)+1.0e-4));
    if (((model_.IGCLAMP)==1))
    {
      T1 = AnalogFunctions::hypsmooth<AdmsFadType>((AIGD_t-(BIGD_i*vgd_eff)),1.0e-6);
      if ((CIGD_i<0.01))
      {
        CIGD_i = 0.01;
      }
    }
    else
    {
      T1 = (AIGD_t-(BIGD_i*vgd_eff));
    }
    T2 = (1.0+(CIGD_i*vgd_eff));
    T3 = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*T2);
    T4 = AnalogFunctions::lexp<AdmsFadType>(T3);
    if ((sigvds>0.0))
    {
      igd = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*T4);
    }
    else
    {
      igs = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*T4);
    }
  }
  igisl = 0.0;
  igidl = 0.0;
  if (((model_.GIDLMOD)!=0))
  {
    T0 = (epsratio*(model_.EOT));
    if (((AGIDL_i<=0.0)||(BGIDL_t<=0.0)))
    {
      T6 = 0.0;
    }
    else
    {
      T1 = ((((-vgd_noswap)-EGIDL_i)+vfbsd)/T0);
      T1 = AnalogFunctions::hypsmooth<AdmsFadType>(T1,1.0e-2);
      T2 = (BGIDL_t/(T1+1.0e-3));
      T3 = AnalogFunctions::lexp<AdmsFadType>((PGIDL_i*AnalogFunctions::lln<AdmsFadType>(T1)));
      if (((model_.BULKMOD)!=0))
      {
        T4 = (((-ved_jct)*ved_jct)*ved_jct);
        T4a = ((CGIDL_i+fabs(T4))+1.0e-5);
        T5 = (AnalogFunctions::hypsmooth<AdmsFadType>((T4/T4a),1.0e-6)-1.0e-6);
        T6 = ((((AGIDL_i*Weff0)*T3)*AnalogFunctions::lexp<AdmsFadType>((-T2)))*T5);
      }
      else
      {
        T6 = ((((AGIDL_i*Weff0)*T3)*AnalogFunctions::lexp<AdmsFadType>((-T2)))*vds_noswap);
      }
    }
    if ((sigvds>0.0))
    {
      igidl = T6;
    }
    else
    {
      igisl = T6;
    }
    if (((AGISL_i<=0.0)||(BGISL_t<=0.0)))
    {
      T6 = 0.0;
    }
    else
    {
      T1 = ((((-vgs_noswap)-EGISL_i)+vfbsd)/T0);
      T1 = AnalogFunctions::hypsmooth<AdmsFadType>(T1,1.0e-2);
      T2 = (BGISL_t/(T1+1.0e-3));
      T3 = AnalogFunctions::lexp<AdmsFadType>((PGISL_i*AnalogFunctions::lln<AdmsFadType>(T1)));
      if (((model_.BULKMOD)!=0))
      {
        T4 = (((-ves_jct)*ves_jct)*ves_jct);
        T4a = ((CGISL_i+fabs(T4))+1.0e-5);
        T5 = (AnalogFunctions::hypsmooth<AdmsFadType>((T4/T4a),1.0e-6)-1.0e-6);
        T6 = ((((AGISL_i*Weff0)*T3)*AnalogFunctions::lexp<AdmsFadType>((-T2)))*T5);
      }
      else
      {
        T6 = ((((AGISL_i*Weff0)*T3)*AnalogFunctions::lexp<AdmsFadType>((-T2)))*(-vds_noswap));
      }
    }
    if ((sigvds>0.0))
    {
      igisl = T6;
    }
    else
    {
      igidl = T6;
    }
  }
  if (((model_.BULKMOD)!=0))
  {
    if ((Isbs>0.0))
    {
      if ((ves_jct<VjsmRev))
      {
        T0 = (ves_jct/Nvtms);
        T1 = (AnalogFunctions::lexp<AdmsFadType>(T0)-1.0);
        T2 = (IVjsmRev+(SslpRev*(ves_jct-VjsmRev)));
        Ies = (T1*T2);
      }
      else
      {
        if ((ves_jct<=VjsmFwd))
        {
          T0 = (ves_jct/Nvtms);
          T1 = (((model_.BVS)+ves_jct)/Nvtms);
          T2 = AnalogFunctions::lexp<AdmsFadType>((-T1));
          Ies = (Isbs*(((AnalogFunctions::lexp<AdmsFadType>(T0)+XExpBVS)-1.0)-((model_.XJBVS)*T2)));
        }
        else
        {
          Ies = (IVjsmFwd+(SslpFwd*(ves_jct-VjsmFwd)));
        }
      }
    }
    else
    {
      Ies = 0.0;
    }
    if ((JTSS_t>0.0))
    {
      if ((((model_.VTSS)-ves_jct)<((model_.VTSS)*1.0e-3)))
      {
        T0 = (((-ves_jct)/Vtm0)/NJTS_t);
        T1 = (AnalogFunctions::lexp<AdmsFadType>((T0*1.0e3))-1.0);
        Ies = (Ies-((ASEJ*JTSS_t)*T1));
      }
      else
      {
        T0 = (((-ves_jct)/Vtm0)/NJTS_t);
        T1 = (AnalogFunctions::lexp<AdmsFadType>(((T0*(model_.VTSS))/((model_.VTSS)-ves_jct)))-1.0);
        Ies = (Ies-((ASEJ*JTSS_t)*T1));
      }
    }
    if ((JTSSWS_t>0.0))
    {
      if ((((model_.VTSSWS)-ves_jct)<((model_.VTSSWS)*1.0e-3)))
      {
        T0 = (((-ves_jct)/Vtm0)/NJTSSW_t);
        T1 = (AnalogFunctions::lexp<AdmsFadType>((T0*1.0e3))-1.0);
        Ies = (Ies-((PSEJ*JTSSWS_t)*T1));
      }
      else
      {
        T0 = (((-ves_jct)/Vtm0)/NJTSSW_t);
        T1 = (AnalogFunctions::lexp<AdmsFadType>(((T0*(model_.VTSSWS))/((model_.VTSSWS)-ves_jct)))-1.0);
        Ies = (Ies-((PSEJ*JTSSWS_t)*T1));
      }
    }
    if ((JTSSWGS_t>0.0))
    {
      if ((((model_.VTSSWGS)-ves_jct)<((model_.VTSSWGS)*1.0e-3)))
      {
        T0 = (((-ves_jct)/Vtm0)/NJTSSWG_t);
        T1 = (AnalogFunctions::lexp<AdmsFadType>((T0*1.0e3))-1.0);
        Ies = (Ies-(((Weff0*NFINtotal)*JTSSWGS_t)*T1));
      }
      else
      {
        T0 = (((-ves_jct)/Vtm0)/NJTSSWG_t);
        T1 = (AnalogFunctions::lexp<AdmsFadType>(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-ves_jct)))-1.0);
        Ies = (Ies-(((Weff0*NFINtotal)*JTSSWGS_t)*T1));
      }
    }
    if ((Isbd>0.0))
    {
      if ((ved_jct<VjdmRev))
      {
        T0 = (ved_jct/Nvtmd);
        T1 = (AnalogFunctions::lexp<AdmsFadType>(T0)-1.0);
        T2 = (IVjdmRev+(DslpRev*(ved_jct-VjdmRev)));
        Ied = (T1*T2);
      }
      else
      {
        if ((ved_jct<=VjdmFwd))
        {
          T0 = (ved_jct/Nvtmd);
          T1 = (((model_.BVD)+ved_jct)/Nvtmd);
          T2 = AnalogFunctions::lexp<AdmsFadType>((-T1));
          Ied = (Isbd*(((AnalogFunctions::lexp<AdmsFadType>(T0)+XExpBVD)-1.0)-((model_.XJBVD)*T2)));
        }
        else
        {
          Ied = (IVjdmFwd+(DslpFwd*(ved_jct-VjdmFwd)));
        }
      }
    }
    else
    {
      Ied = 0.0;
    }
    if ((JTSD_t>0.0))
    {
      if ((((model_.VTSD)-ved_jct)<((model_.VTSD)*1.0e-3)))
      {
        T0 = (((-ved_jct)/Vtm0)/NJTSD_t);
        T1 = (AnalogFunctions::lexp<AdmsFadType>((T0*1.0e3))-1.0);
        Ied = (Ied-((ADEJ*JTSD_t)*T1));
      }
      else
      {
        T0 = (((-ved_jct)/Vtm0)/NJTSD_t);
        T1 = (AnalogFunctions::lexp<AdmsFadType>(((T0*(model_.VTSD))/((model_.VTSD)-ved_jct)))-1.0);
        Ied = (Ied-((ADEJ*JTSD_t)*T1));
      }
    }
    if ((JTSSWD_t>0.0))
    {
      if ((((model_.VTSSWD)-ved_jct)<((model_.VTSSWD)*1.0e-3)))
      {
        T0 = (((-ved_jct)/Vtm0)/NJTSSWD_t);
        T1 = (AnalogFunctions::lexp<AdmsFadType>((T0*1.0e3))-1.0);
        Ied = (Ied-((PDEJ*JTSSWD_t)*T1));
      }
      else
      {
        T0 = (((-ved_jct)/Vtm0)/NJTSSWD_t);
        T1 = (AnalogFunctions::lexp<AdmsFadType>(((T0*(model_.VTSSWD))/((model_.VTSSWD)-ved_jct)))-1.0);
        Ied = (Ied-((PDEJ*JTSSWD_t)*T1));
      }
    }
    if ((JTSSWGD_t>0.0))
    {
      if ((((model_.VTSSWGD)-ved_jct)<((model_.VTSSWGD)*1.0e-3)))
      {
        T0 = (((-ved_jct)/Vtm0)/NJTSSWGD_t);
        T1 = (AnalogFunctions::lexp<AdmsFadType>((T0*1.0e3))-1.0);
        Ied = (Ied-(((Weff0*NFINtotal)*JTSSWGD_t)*T1));
      }
      else
      {
        T0 = (((-ved_jct)/Vtm0)/NJTSSWGD_t);
        T1 = (AnalogFunctions::lexp<AdmsFadType>(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-ved_jct)))-1.0);
        Ied = (Ied-(((Weff0*NFINtotal)*JTSSWGD_t)*T1));
      }
    }
    {
      if ((Czbs>0.0))
      {
        T1 = (ves_jct/PBS_t);
        if ((T1<0.9))
        {
          if (((model_.SJS)>0.0))
          {
            vec = (PBS_t*(1.0-AnalogFunctions::lexp<AdmsFadType>(((1.0/(model_.MJS))*AnalogFunctions::lln<AdmsFadType>((1.0/(model_.SJS)))))));
            pb2 = ((((PBS_t*(model_.SJS))*(model_.MJS2))/(model_.MJS))/AnalogFunctions::lexp<AdmsFadType>(((-(1.0+(model_.MJS)))*AnalogFunctions::lln<AdmsFadType>((1.0-(vec/PBS_t))))));
            if ((ves_jct>vec))
            {
              arg = (1.0-T1);
              if (((model_.MJS)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJS))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qesj1 = (((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-(model_.MJS)));
            }
            else
            {
              arg = (1.0-(vec/PBS_t));
              if (((model_.MJS)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJS))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qec = (((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-(model_.MJS)));
              arg = (1.0-((ves_jct-vec)/pb2));
              if (((model_.MJS2)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJS2))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qesj1 = (Qec+(((((model_.SJS)*pb2)*Czbs)*(1.0-(arg*sarg)))/(1.0-(model_.MJS2))));
            }
          }
          else
          {
            arg = (1.0-T1);
            if (((model_.MJS)==0.5))
            {
              sarg = (1.0/sqrt(arg));
            }
            else
            {
              sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJS))*AnalogFunctions::lln<AdmsFadType>(arg)));
            }
            Qesj1 = (((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-(model_.MJS)));
          }
        }
        else
        {
          T2 = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJS))*AnalogFunctions::lln<AdmsFadType>(0.1)));
          T3 = (1.0/(1.0-(model_.MJS)));
          T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));
          T5 = (T3*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));
          Qesj1 = ((PBS_t*Czbs)*(T4+T5));
        }
      }
      else
      {
        Qesj1 = 0.0;
      }
    }
    {
      if ((Czbssw>0.0))
      {
        T1 = (ves_jct/PBSWS_t);
        if ((T1<0.9))
        {
          if (((model_.SJSWS)>0.0))
          {
            vec = (PBSWS_t*(1.0-AnalogFunctions::lexp<AdmsFadType>(((1.0/(model_.MJSWS))*AnalogFunctions::lln<AdmsFadType>((1.0/(model_.SJSWS)))))));
            pb2 = ((((PBSWS_t*(model_.SJSWS))*(model_.MJSWS2))/(model_.MJSWS))/AnalogFunctions::lexp<AdmsFadType>(((-(1.0+(model_.MJSWS)))*AnalogFunctions::lln<AdmsFadType>((1.0-(vec/PBSWS_t))))));
            if ((ves_jct>vec))
            {
              arg = (1.0-T1);
              if (((model_.MJSWS)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWS))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qesj2 = (((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWS)));
            }
            else
            {
              arg = (1.0-(vec/PBSWS_t));
              if (((model_.MJSWS)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWS))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qec = (((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWS)));
              arg = (1.0-((ves_jct-vec)/pb2));
              if (((model_.MJSWS2)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWS2))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qesj2 = (Qec+(((((model_.SJSWS)*pb2)*Czbssw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWS2))));
            }
          }
          else
          {
            arg = (1.0-T1);
            if (((model_.MJSWS)==0.5))
            {
              sarg = (1.0/sqrt(arg));
            }
            else
            {
              sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWS))*AnalogFunctions::lln<AdmsFadType>(arg)));
            }
            Qesj2 = (((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWS)));
          }
        }
        else
        {
          T2 = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWS))*AnalogFunctions::lln<AdmsFadType>(0.1)));
          T3 = (1.0/(1.0-(model_.MJSWS)));
          T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));
          T5 = (T3*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));
          Qesj2 = ((PBSWS_t*Czbssw)*(T4+T5));
        }
      }
      else
      {
        Qesj2 = 0.0;
      }
    }
    {
      if ((Czbsswg>0.0))
      {
        T1 = (ves_jct/PBSWGS_t);
        if ((T1<0.9))
        {
          if (((model_.SJSWGS)>0.0))
          {
            vec = (PBSWGS_t*(1.0-AnalogFunctions::lexp<AdmsFadType>(((1.0/(model_.MJSWGS))*AnalogFunctions::lln<AdmsFadType>((1.0/(model_.SJSWGS)))))));
            pb2 = ((((PBSWGS_t*(model_.SJSWGS))*(model_.MJSWGS2))/(model_.MJSWGS))/AnalogFunctions::lexp<AdmsFadType>(((-(1.0+(model_.MJSWGS)))*AnalogFunctions::lln<AdmsFadType>((1.0-(vec/PBSWGS_t))))));
            if ((ves_jct>vec))
            {
              arg = (1.0-T1);
              if (((model_.MJSWGS)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWGS))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qesj3 = (((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGS)));
            }
            else
            {
              arg = (1.0-(vec/PBSWGS_t));
              if (((model_.MJSWGS)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWGS))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qec = (((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGS)));
              arg = (1.0-((ves_jct-vec)/pb2));
              if (((model_.MJSWGS2)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWGS2))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qesj3 = (Qec+(((((model_.SJSWGS)*pb2)*Czbsswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGS2))));
            }
          }
          else
          {
            arg = (1.0-T1);
            if (((model_.MJSWGS)==0.5))
            {
              sarg = (1.0/sqrt(arg));
            }
            else
            {
              sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWGS))*AnalogFunctions::lln<AdmsFadType>(arg)));
            }
            Qesj3 = (((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGS)));
          }
        }
        else
        {
          T2 = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWGS))*AnalogFunctions::lln<AdmsFadType>(0.1)));
          T3 = (1.0/(1.0-(model_.MJSWGS)));
          T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));
          T5 = (T3*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));
          Qesj3 = ((PBSWGS_t*Czbsswg)*(T4+T5));
        }
      }
      else
      {
        Qesj3 = 0.0;
      }
    }
    Qesj = ((Qesj1+Qesj2)+Qesj3);
    {
      if ((Czbd>0.0))
      {
        T1 = (ved_jct/PBD_t);
        if ((T1<0.9))
        {
          if (((model_.SJD)>0.0))
          {
            vec = (PBD_t*(1.0-AnalogFunctions::lexp<AdmsFadType>(((1.0/(model_.MJD))*AnalogFunctions::lln<AdmsFadType>((1.0/(model_.SJD)))))));
            pb2 = ((((PBD_t*(model_.SJD))*(model_.MJD2))/(model_.MJD))/AnalogFunctions::lexp<AdmsFadType>(((-(1.0+(model_.MJD)))*AnalogFunctions::lln<AdmsFadType>((1.0-(vec/PBD_t))))));
            if ((ved_jct>vec))
            {
              arg = (1.0-T1);
              if (((model_.MJD)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJD))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qedj1 = (((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-(model_.MJD)));
            }
            else
            {
              arg = (1.0-(vec/PBD_t));
              if (((model_.MJD)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJD))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qec = (((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-(model_.MJD)));
              arg = (1.0-((ved_jct-vec)/pb2));
              if (((model_.MJD2)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJD2))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qedj1 = (Qec+(((((model_.SJD)*pb2)*Czbd)*(1.0-(arg*sarg)))/(1.0-(model_.MJD2))));
            }
          }
          else
          {
            arg = (1.0-T1);
            if (((model_.MJD)==0.5))
            {
              sarg = (1.0/sqrt(arg));
            }
            else
            {
              sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJD))*AnalogFunctions::lln<AdmsFadType>(arg)));
            }
            Qedj1 = (((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-(model_.MJD)));
          }
        }
        else
        {
          T2 = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJD))*AnalogFunctions::lln<AdmsFadType>(0.1)));
          T3 = (1.0/(1.0-(model_.MJD)));
          T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));
          T5 = (T3*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));
          Qedj1 = ((PBD_t*Czbd)*(T4+T5));
        }
      }
      else
      {
        Qedj1 = 0.0;
      }
    }
    {
      if ((Czbdsw>0.0))
      {
        T1 = (ved_jct/PBSWD_t);
        if ((T1<0.9))
        {
          if (((model_.SJSWD)>0.0))
          {
            vec = (PBSWD_t*(1.0-AnalogFunctions::lexp<AdmsFadType>(((1.0/(model_.MJSWD))*AnalogFunctions::lln<AdmsFadType>((1.0/(model_.SJSWD)))))));
            pb2 = ((((PBSWD_t*(model_.SJSWD))*(model_.MJSWD2))/(model_.MJSWD))/AnalogFunctions::lexp<AdmsFadType>(((-(1.0+(model_.MJSWD)))*AnalogFunctions::lln<AdmsFadType>((1.0-(vec/PBSWD_t))))));
            if ((ved_jct>vec))
            {
              arg = (1.0-T1);
              if (((model_.MJSWD)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWD))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qedj2 = (((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWD)));
            }
            else
            {
              arg = (1.0-(vec/PBSWD_t));
              if (((model_.MJSWD)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWD))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qec = (((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWD)));
              arg = (1.0-((ved_jct-vec)/pb2));
              if (((model_.MJSWD2)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWD2))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qedj2 = (Qec+(((((model_.SJSWD)*pb2)*Czbdsw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWD2))));
            }
          }
          else
          {
            arg = (1.0-T1);
            if (((model_.MJSWD)==0.5))
            {
              sarg = (1.0/sqrt(arg));
            }
            else
            {
              sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWD))*AnalogFunctions::lln<AdmsFadType>(arg)));
            }
            Qedj2 = (((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWD)));
          }
        }
        else
        {
          T2 = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWD))*AnalogFunctions::lln<AdmsFadType>(0.1)));
          T3 = (1.0/(1.0-(model_.MJSWD)));
          T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));
          T5 = (T3*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));
          Qedj2 = ((PBSWD_t*Czbdsw)*(T4+T5));
        }
      }
      else
      {
        Qedj2 = 0.0;
      }
    }
    {
      if ((Czbdswg>0.0))
      {
        T1 = (ved_jct/PBSWGD_t);
        if ((T1<0.9))
        {
          if (((model_.SJSWGD)>0.0))
          {
            vec = (PBSWGD_t*(1.0-AnalogFunctions::lexp<AdmsFadType>(((1.0/(model_.MJSWGD))*AnalogFunctions::lln<AdmsFadType>((1.0/(model_.SJSWGD)))))));
            pb2 = ((((PBSWGD_t*(model_.SJSWGD))*(model_.MJSWGD2))/(model_.MJSWGD))/AnalogFunctions::lexp<AdmsFadType>(((-(1.0+(model_.MJSWGD)))*AnalogFunctions::lln<AdmsFadType>((1.0-(vec/PBSWGD_t))))));
            if ((ved_jct>vec))
            {
              arg = (1.0-T1);
              if (((model_.MJSWGD)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWGD))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qedj3 = (((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGD)));
            }
            else
            {
              arg = (1.0-(vec/PBSWGD_t));
              if (((model_.MJSWGD)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWGD))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qec = (((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGD)));
              arg = (1.0-((ved_jct-vec)/pb2));
              if (((model_.MJSWGD2)==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWGD2))*AnalogFunctions::lln<AdmsFadType>(arg)));
              }
              Qedj3 = (Qec+(((((model_.SJSWGD)*pb2)*Czbdswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGD2))));
            }
          }
          else
          {
            arg = (1.0-T1);
            if (((model_.MJSWGD)==0.5))
            {
              sarg = (1.0/sqrt(arg));
            }
            else
            {
              sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWGD))*AnalogFunctions::lln<AdmsFadType>(arg)));
            }
            Qedj3 = (((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGD)));
          }
        }
        else
        {
          T2 = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWGD))*AnalogFunctions::lln<AdmsFadType>(0.1)));
          T3 = (1.0/(1.0-(model_.MJSWGD)));
          T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));
          T5 = (T3*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));
          Qedj3 = ((PBSWGD_t*Czbdswg)*(T4+T5));
        }
      }
      else
      {
        Qedj3 = 0.0;
      }
    }
    Qedj = ((Qedj1+Qedj2)+Qedj3);
  }
  Qes = (Qesj+(csbox*ves_jct));
  Qed = (Qedj+(cdbox*ved_jct));
  Qeg = ((cgbox*devsign)*(probeVars[admsProbeID_V_e_ge]));
  if (((model_.BULKMOD)!=0))
  {
    T2 = (devsign*(probeVars[admsProbeID_V_ge_e]));
    T3 = ((((T2-deltaPhi)+(Eg/2.0))+phib)-(model_.DELVFBACC));
    T0 = (T3+0.02);
    vge_overlap = (0.5*(T0+sqrt(((T0*T0)+(4.0*0.02)))));
    Qeg = (Qeg-((NFINtotal*LeffCV)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))-1.0))))));
  }
  T0 = vds;
  T1 = (T0*(AIGEN_i+((BIGEN_i*T0)*T0)));
  idsgen = (((((model_.HFIN)*TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*T1);
  T0 = (((ueff*coxeff)*Weff0)/Leff);
  igidl = (NFINtotal*igidl);
  igisl = (NFINtotal*igisl);
  igcd = (NFINtotal*igcd);
  igcs = (NFINtotal*igcs);
  igs = (NFINtotal*igs);
  igd = (NFINtotal*igd);
  igbinv = (NFINtotal*igbinv);
  igbacc = (NFINtotal*igbacc);
  idsgen = (NFINtotal*idsgen);
  igbs = 0.0;
  igbd = 0.0;
  if (((model_.BULKMOD)==0))
  {
    igbs = ((igbinv+igbacc)*wf);
    igbd = ((igbinv+igbacc)*wr);
  }
  Esatnoi = ((2.0*VSAT_a)/ueff);
  if (((((model_.NOIA)>0.0)||((model_.NOIB)>0.0))||((model_.NOIC)>0.0)))
  {
    Leffnoi = (Leff-(2.0*LINTNOI_i));
    Leffnoisq = (Leffnoi*Leffnoi);
    if (((model_.EM)<=0.0))
    {
      DelClm = 0.0;
    }
    else
    {
      T0 = (((diffVds/litl)+(model_.EM))/Esatnoi);
      DelClm = (litl*AnalogFunctions::lln<AdmsFadType>(T0));
      if ((DelClm<0.0))
      {
        DelClm = 0.0;
      }
    }
    T1 = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*fabs(ids))*ueff);
    T2 = ((1.0e10*coxeff)*Leffnoisq);
    N0 = ((coxeff*qis)/1.60219e-19);
    Nl = ((coxeff*qid)/1.60219e-19);
    Nstar = ((Vtm/1.60219e-19)*(coxeff+CIT_a));
    T3 = ((model_.NOIA)*AnalogFunctions::lln<AdmsFadType>(((N0+Nstar)/(Nl+Nstar))));
    T4 = ((model_.NOIB)*(N0-Nl));
    T5 = ((0.5*(model_.NOIC))*((N0*N0)-(Nl*Nl)));
    T6 = (((1.60219e-19*Vtm)*ids)*ids);
    T7 = (((1.0e10*Leffnoisq)*Weff0)*NFINtotal);
    T8 = (((model_.NOIA)+((model_.NOIB)*Nl))+(((model_.NOIC)*Nl)*Nl));
    T9 = ((Nl+Nstar)*(Nl+Nstar));
    Ssi = (((T1/T2)*((T3+T4)+T5))+((((T6/T7)*DelClm)*T8)/T9));
    T10 = (((model_.NOIA)*1.60219e-19)*Vtm);
    T11 = (((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar);
    Swi = (((T10/T11)*ids)*ids);
    T1 = (Swi+Ssi);
    if ((T1>0.0))
    {
      FNPowerAt1Hz = ((Ssi*Swi)/T1);
    }
    else
    {
      FNPowerAt1Hz = 0.0;
    }
  }
  else
  {
    FNPowerAt1Hz = 0.0;
  }
  if ( (model_.TNOIMOD) == (0))
  {
    T0 = (ueff*qinv);
    T1 = ((T0*Rdsi)+(Leff*Leff));
    Gtnoi = ((T0/T1)*NTNOI_i);
    sid = (((4.0*Vtm)*1.60219e-19)*Gtnoi);
  }
  else
    if ( (model_.TNOIMOD) == (1))
    {
      Abulk = 1.0;
      Vgst2Vtm = (KSATIV_a*(qis+(2.0*Vtm)));
      etaa = (1.0-((Vdseff*Abulk)/Vgst2Vtm));
      T0 = (1.0-etaa);
      T1 = (1.0+etaa);
      T2 = (T1+(((2.0*Abulk)*Vtm)/(qia+1.0e-10)));
      T3 = (T2*T2);
      T4 = (T0*T0);
      T5 = (T3*T3);
      T6 = (1.0/(1.0+(Vdseff/EsatL)));
      gamma = (T6*((0.5*T1)+((T0*T0)/(6.0*T2))));
      delta = ((((T1/T3)-((((5.0*T1)+T2)*T4)/(15.0*T5)))+((T4*T4)/((9.0*T5)*T2)))/(((6.0*T6)*T6)*T6));
      T7 = (T0/T2);
      epsilon = ((T7+(((T7*T7)*T7)/3.0))/(6.0*T6));
      T8 = (qia/EsatL);
      T8 = (T8*T8);
      npart_c = ((model_.RNOIC)*(1.0+((T8*(model_.TNOIC))*Leff)));
      T9 = (gamma*delta);
      if ((T9>0.0))
      {
        ctnoi = ((epsilon/sqrt((gamma*delta)))*(2.5316*npart_c));
      }
      else
      {
        ctnoi = 1.0;
      }
      if ((ctnoi>1))
      {
        ctnoi = 1.0;
      }
      if ((ctnoi<0))
      {
        ctnoi = 0.0;
      }
      npart_beta = ((model_.RNOIA)*(1.0+((T8*(model_.TNOIA))*Leff)));
      npart_theta = ((model_.RNOIB)*(1.0+((T8*(model_.TNOIB))*Leff)));
      gamma = (gamma*((3.0*npart_beta)*npart_beta));
      delta = (delta*((3.75*npart_theta)*npart_theta));
      T9 = ((qia*0.5)*T1);
      gche = ((beta*T9)*T6);
      noiGd0 = (((NFINtotal*beta)*qia)/(1.0+(gche*Rdsi)));
      GammaGd0 = (gamma*noiGd0);
      sid = (((4.0*Vtm)*1.60219e-19)*GammaGd0);
      C0 = (((NFINtotal*coxeff)*WeffCV0)*LeffCV);
      if (((gamma>0.0)&&(delta>0.0)))
      {
        sf = ((noiGd0+1.0e-15)/sqrt((delta/gamma)));
      }
      else
      {
        sf = 0.0;
      }
    }
    else
    {
      // no default
    }
  if (((model_.RDSMOD)!=2))
  {
    gspr = (1.0/Rsource);
    gdpr = (1.0/Rdrain);
  }
  if ((sigvds>0.0))
  {
    // I(di,si) <+ (((m*devsign)*ids))
    staticContributions[admsNodeID_di] += ((m*devsign)*ids);
    staticContributions[admsNodeID_si] -= ((m*devsign)*ids);
  }
  else
  {
    // I(si,di) <+ (((m*devsign)*ids))
    staticContributions[admsNodeID_si] += ((m*devsign)*ids);
    staticContributions[admsNodeID_di] -= ((m*devsign)*ids);
  }
  // I(di,si) <+ (((m*devsign)*ddt(qd)))
  dynamicContributions[admsNodeID_di] += ((m*devsign)*(qd));
  dynamicContributions[admsNodeID_si] -= ((m*devsign)*(qd));
  // I(ge,si) <+ (((m*devsign)*ddt(qg)))
  dynamicContributions[admsNodeID_ge] += ((m*devsign)*(qg));
  dynamicContributions[admsNodeID_si] -= ((m*devsign)*(qg));
  if ((sigvds>0.0))
  {
    // I(di,si) <+ (((m*devsign)*idsgen))
    staticContributions[admsNodeID_di] += ((m*devsign)*idsgen);
    staticContributions[admsNodeID_si] -= ((m*devsign)*idsgen);
    // I(ge,si) <+ (((m*devsign)*(igcs+igs)))
    staticContributions[admsNodeID_ge] += ((m*devsign)*(igcs+igs));
    staticContributions[admsNodeID_si] -= ((m*devsign)*(igcs+igs));
    // I(ge,di) <+ (((m*devsign)*(igcd+igd)))
    staticContributions[admsNodeID_ge] += ((m*devsign)*(igcd+igd));
    staticContributions[admsNodeID_di] -= ((m*devsign)*(igcd+igd));
    if (((model_.BULKMOD)!=0))
    {
      // I(di,e) <+ (((m*devsign)*(igidl+Iii)))
      staticContributions[admsNodeID_di] += ((m*devsign)*(igidl+Iii));
      staticContributions[admsNodeID_e] -= ((m*devsign)*(igidl+Iii));
      // I(si,e) <+ (((m*devsign)*igisl))
      staticContributions[admsNodeID_si] += ((m*devsign)*igisl);
      staticContributions[admsNodeID_e] -= ((m*devsign)*igisl);
      // I(ge,e) <+ (((m*devsign)*(igbinv+igbacc)))
      staticContributions[admsNodeID_ge] += ((m*devsign)*(igbinv+igbacc));
      staticContributions[admsNodeID_e] -= ((m*devsign)*(igbinv+igbacc));
    }
    else
    {
      // I(di,si) <+ (((m*devsign)*(igidl+Iii)))
      staticContributions[admsNodeID_di] += ((m*devsign)*(igidl+Iii));
      staticContributions[admsNodeID_si] -= ((m*devsign)*(igidl+Iii));
      // I(si,di) <+ (((m*devsign)*igisl))
      staticContributions[admsNodeID_si] += ((m*devsign)*igisl);
      staticContributions[admsNodeID_di] -= ((m*devsign)*igisl);
    }
  }
  else
  {
    // I(si,di) <+ (((m*devsign)*idsgen))
    staticContributions[admsNodeID_si] += ((m*devsign)*idsgen);
    staticContributions[admsNodeID_di] -= ((m*devsign)*idsgen);
    // I(ge,di) <+ (((m*devsign)*(igcs+igs)))
    staticContributions[admsNodeID_ge] += ((m*devsign)*(igcs+igs));
    staticContributions[admsNodeID_di] -= ((m*devsign)*(igcs+igs));
    // I(ge,si) <+ (((m*devsign)*(igcd+igd)))
    staticContributions[admsNodeID_ge] += ((m*devsign)*(igcd+igd));
    staticContributions[admsNodeID_si] -= ((m*devsign)*(igcd+igd));
    if (((model_.BULKMOD)!=0))
    {
      // I(si,e) <+ (((m*devsign)*(igidl+Iii)))
      staticContributions[admsNodeID_si] += ((m*devsign)*(igidl+Iii));
      staticContributions[admsNodeID_e] -= ((m*devsign)*(igidl+Iii));
      // I(di,e) <+ (((m*devsign)*igisl))
      staticContributions[admsNodeID_di] += ((m*devsign)*igisl);
      staticContributions[admsNodeID_e] -= ((m*devsign)*igisl);
      // I(ge,e) <+ (((m*devsign)*(igbinv+igbacc)))
      staticContributions[admsNodeID_ge] += ((m*devsign)*(igbinv+igbacc));
      staticContributions[admsNodeID_e] -= ((m*devsign)*(igbinv+igbacc));
    }
    else
    {
      // I(si,di) <+ (((m*devsign)*(igidl+Iii)))
      staticContributions[admsNodeID_si] += ((m*devsign)*(igidl+Iii));
      staticContributions[admsNodeID_di] -= ((m*devsign)*(igidl+Iii));
      // I(di,si) <+ (((m*devsign)*igisl))
      staticContributions[admsNodeID_di] += ((m*devsign)*igisl);
      staticContributions[admsNodeID_si] -= ((m*devsign)*igisl);
    }
  }
  if (((model_.BULKMOD)==0))
  {
    // I(ge,si) <+ (((m*devsign)*igbs))
    staticContributions[admsNodeID_ge] += ((m*devsign)*igbs);
    staticContributions[admsNodeID_si] -= ((m*devsign)*igbs);
    // I(ge,di) <+ (((m*devsign)*igbd))
    staticContributions[admsNodeID_ge] += ((m*devsign)*igbd);
    staticContributions[admsNodeID_di] -= ((m*devsign)*igbd);
  }
  if (((model_.BULKMOD)!=0))
  {
    // I(e,si) <+ (((m*devsign)*Ies))
    staticContributions[admsNodeID_e] += ((m*devsign)*Ies);
    staticContributions[admsNodeID_si] -= ((m*devsign)*Ies);
    // I(e,di) <+ (((m*devsign)*Ied))
    staticContributions[admsNodeID_e] += ((m*devsign)*Ied);
    staticContributions[admsNodeID_di] -= ((m*devsign)*Ied);
  }
  // I(e,si) <+ (((m*devsign)*ddt(Qes)))
  dynamicContributions[admsNodeID_e] += ((m*devsign)*(Qes));
  dynamicContributions[admsNodeID_si] -= ((m*devsign)*(Qes));
  // I(e,di) <+ (((m*devsign)*ddt(Qed)))
  dynamicContributions[admsNodeID_e] += ((m*devsign)*(Qed));
  dynamicContributions[admsNodeID_di] -= ((m*devsign)*(Qed));
  // I(e,ge) <+ (((m*devsign)*ddt(Qeg)))
  dynamicContributions[admsNodeID_e] += ((m*devsign)*(Qeg));
  dynamicContributions[admsNodeID_ge] -= ((m*devsign)*(Qeg));
  // I(ge,si) <+ ((m*ddt(qgs_parasitic)))
  dynamicContributions[admsNodeID_ge] += (m*(qgs_parasitic));
  dynamicContributions[admsNodeID_si] -= (m*(qgs_parasitic));
  // I(ge,di) <+ ((m*ddt(qgd_parasitic)))
  dynamicContributions[admsNodeID_ge] += (m*(qgd_parasitic));
  dynamicContributions[admsNodeID_di] -= (m*(qgd_parasitic));
  // I(d,s) <+ ((m*ddt(qds_fr)))
  dynamicContributions[admsNodeID_d] += (m*(qds_fr));
  dynamicContributions[admsNodeID_s] -= (m*(qds_fr));
  if (((model_.CGEOMOD)==1))
  {
    // I(ge,s) <+ ((m*ddt(qgs_fr)))
    dynamicContributions[admsNodeID_ge] += (m*(qgs_fr));
    dynamicContributions[admsNodeID_s] -= (m*(qgs_fr));
    // I(ge,d) <+ ((m*ddt(qgd_fr)))
    dynamicContributions[admsNodeID_ge] += (m*(qgd_fr));
    dynamicContributions[admsNodeID_d] -= (m*(qgd_fr));
  }
  if (((model_.BULKMOD)!=0))
  {
    // I(ge,si) <+ (((m*devsign)*ddt(qg_acc)))
    dynamicContributions[admsNodeID_ge] += ((m*devsign)*(qg_acc));
    dynamicContributions[admsNodeID_si] -= ((m*devsign)*(qg_acc));
    // I(e,si) <+ (((m*devsign)*ddt(qb_acc)))
    dynamicContributions[admsNodeID_e] += ((m*devsign)*(qb_acc));
    dynamicContributions[admsNodeID_si] -= ((m*devsign)*(qb_acc));
  }
  if (((model_.RDSMOD)==2))
  {
    // V(d,di) <+ (0.0)
    // do nothing at all
    // V(s,si) <+ (0.0)
    // do nothing at all
  }
  else
  {
    // I(d,di) <+ (((m*V(d,di))/Rdrain))
    staticContributions[admsNodeID_d] += ((m*(probeVars[admsProbeID_V_d_di]))/Rdrain);
    staticContributions[admsNodeID_di] -= ((m*(probeVars[admsProbeID_V_d_di]))/Rdrain);
    // I(s,si) <+ (((m*V(s,si))/Rsource))
    staticContributions[admsNodeID_s] += ((m*(probeVars[admsProbeID_V_s_si]))/Rsource);
    staticContributions[admsNodeID_si] -= ((m*(probeVars[admsProbeID_V_s_si]))/Rsource);
  }
  if (((model_.RGATEMOD)!=0))
  {
    // I(g,ge) <+ (((m*V(g,ge))*ggeltd))
    staticContributions[admsNodeID_g] += ((m*(probeVars[admsProbeID_V_g_ge]))*ggeltd);
    staticContributions[admsNodeID_ge] -= ((m*(probeVars[admsProbeID_V_g_ge]))*ggeltd);
  }
  else
  {
    // V(g,ge) <+ (0.0)
    // do nothing at all
  }
  // I(di,si) <+ (flicker_noise((m*FNPowerAt1Hz),EF,"flicker"))
  if (getSolverState().noiseFlag)
  {
    noiseContribsPower[0]= (m*FNPowerAt1Hz.val());
    noiseContribsExponent[0]= (model_.EF);
  }
  if (((model_.RDSMOD)!=2))
  {
    // I(d,di) <+ (white_noise(((((m*4.0)*Vtm)*1.60219e-19)*gdpr),"thermal"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[1]= ((((m*4.0)*Vtm.val())*1.60219e-19)*gdpr.val());
    }
    // I(s,si) <+ (white_noise(((((m*4.0)*Vtm)*1.60219e-19)*gspr),"thermal"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[2]= ((((m*4.0)*Vtm.val())*1.60219e-19)*gspr.val());
    }
  }
  if (((model_.RGATEMOD)!=0))
  {
    // I(g,ge) <+ (white_noise(((((m*4.0)*Vtm)*1.60219e-19)*ggeltd),"thermal"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[3]= ((((m*4.0)*Vtm.val())*1.60219e-19)*ggeltd);
    }
  }
  if (((model_.TNOIMOD)==0))
  {
    // I(di,si) <+ (white_noise((m*sid),"thermal"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[4]= (m*sid.val());
    }
    // V(N,GND) <+ (0.0)
    // do nothing at all
  }
  else
  {
    // I(di,si) <+ (white_noise(((m*sid)*abs((1.0-(ctnoi*ctnoi)))),"thermal"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[5]= ((m*sid.val())*fabs((1.0-(ctnoi.val()*ctnoi.val()))));
    }
    // I(di,si) <+ (((((m*ctnoi)*V(N,GND))*sf)*SCALEN))
    staticContributions[admsNodeID_di] += ((((m*ctnoi)*(probeVars[admsProbeID_V_N_GND]))*sf)*(model_.SCALEN));
    staticContributions[admsNodeID_si] -= ((((m*ctnoi)*(probeVars[admsProbeID_V_N_GND]))*sf)*(model_.SCALEN));
    if (((gamma>0)&&(delta>0)))
    {
      // I(N,GND) <+ ((((m*V(N,GND))*sf)*SCALEN))
      staticContributions[admsNodeID_N] += (((m*(probeVars[admsProbeID_V_N_GND]))*sf)*(model_.SCALEN));
      // I(N,GND) <+ (white_noise(((m*sid)/(((sf*sf)*SCALEN)*SCALEN))))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[6]= ((m*sid.val())/(((sf.val()*sf.val())*(model_.SCALEN))*(model_.SCALEN)));
      }
    }
    else
    {
      // I(N,GND) <+ ((m*V(N,GND)))
      staticContributions[admsNodeID_N] += (m*(probeVars[admsProbeID_V_N_GND]));
    }
    // I(ge,si) <+ (ddt(((((m*0.5)*C0)*SCALEN)*V(N,GND))))
    dynamicContributions[admsNodeID_ge] += (((((m*0.5)*C0)*(model_.SCALEN))*(probeVars[admsProbeID_V_N_GND])));
    dynamicContributions[admsNodeID_si] -= (((((m*0.5)*C0)*(model_.SCALEN))*(probeVars[admsProbeID_V_N_GND])));
    // I(ge,di) <+ (ddt(((((m*0.5)*C0)*SCALEN)*V(N,GND))))
    dynamicContributions[admsNodeID_ge] += (((((m*0.5)*C0)*(model_.SCALEN))*(probeVars[admsProbeID_V_N_GND])));
    dynamicContributions[admsNodeID_di] -= (((((m*0.5)*C0)*(model_.SCALEN))*(probeVars[admsProbeID_V_N_GND])));
  }
  if (((model_.IGCMOD)!=0))
  {
    if ((sigvds>0))
    {
      // I(ge,si) <+ (white_noise((((m*2.0)*1.60219e-19)*abs((igcs+igs))),"shot"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[7]= (((m*2.0)*1.60219e-19)*fabs((igcs.val()+igs.val())));
      }
      // I(ge,di) <+ (white_noise((((m*2.0)*1.60219e-19)*abs((igcd+igd))),"shot"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[8]= (((m*2.0)*1.60219e-19)*fabs((igcd.val()+igd.val())));
      }
    }
    else
    {
      // I(ge,di) <+ (white_noise((((m*2.0)*1.60219e-19)*abs((igcs+igs))),"shot"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[9]= (((m*2.0)*1.60219e-19)*fabs((igcs.val()+igs.val())));
      }
      // I(ge,si) <+ (white_noise((((m*2.0)*1.60219e-19)*abs((igcd+igd))),"shot"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[10]= (((m*2.0)*1.60219e-19)*fabs((igcd.val()+igd.val())));
      }
    }
  }
  if (((model_.IGBMOD)!=0))
  {
    if (((model_.BULKMOD)!=0))
    {
      // I(ge,e) <+ (white_noise((((m*2.0)*1.60219e-19)*abs((igbinv+igbacc))),"shot"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[11]= (((m*2.0)*1.60219e-19)*fabs((igbinv.val()+igbacc.val())));
      }
    }
    else
    {
      // I(ge,si) <+ (white_noise((((m*2.0)*1.60219e-19)*abs(igbs)),"shot"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[12]= (((m*2.0)*1.60219e-19)*fabs(igbs.val()));
      }
      // I(ge,di) <+ (white_noise((((m*2.0)*1.60219e-19)*abs(igbd)),"shot"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[13]= (((m*2.0)*1.60219e-19)*fabs(igbd.val()));
      }
    }
  }
  if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0)))
  {
    if (((model_.RDSMOD)!=2))
    {
      // Pwr(t,GND) <+ ((m*(-(((((devsign*sigvds)*V(di,si))*ids)+((V(d,di)*V(d,di))/Rdrain))+((V(s,si)*V(s,si))/Rsource)))))
      staticContributions[admsNodeID_t] += (m*(-(((((devsign*sigvds)*(probeVars[admsProbeID_V_di_si]))*ids)+(((probeVars[admsProbeID_V_d_di])*(probeVars[admsProbeID_V_d_di]))/Rdrain))+(((probeVars[admsProbeID_V_s_si])*(probeVars[admsProbeID_V_s_si]))/Rsource))));
    }
    else
    {
      // Pwr(t,GND) <+ ((m*(-(((devsign*sigvds)*V(di,si))*ids))))
      staticContributions[admsNodeID_t] += (m*(-(((devsign*sigvds)*(probeVars[admsProbeID_V_di_si]))*ids)));
    }
  }
  // Pwr(t,GND) <+ (((m*Temp(t,GND))*gth))
  staticContributions[admsNodeID_t] += ((m*(probeVars[admsProbeID_Temp_t_GND]))*gth);
  // Pwr(t,GND) <+ (ddt(((m*Temp(t,GND))*cth)))
  dynamicContributions[admsNodeID_t] += (((m*(probeVars[admsProbeID_Temp_t_GND]))*cth));


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_N_GND] =  "
                 <<probeVars[admsProbeID_V_N_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_g_ge] =  "
                 <<probeVars[admsProbeID_V_g_ge].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_si] =  "
                 <<probeVars[admsProbeID_V_s_si].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_di] =  "
                 <<probeVars[admsProbeID_V_d_di].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_e_ge] =  "
                 <<probeVars[admsProbeID_V_e_ge].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ge_d] =  "
                 <<probeVars[admsProbeID_V_ge_d].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ge_s] =  "
                 <<probeVars[admsProbeID_V_ge_s].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_di_d] =  "
                 <<probeVars[admsProbeID_V_di_d].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_si_s] =  "
                 <<probeVars[admsProbeID_V_si_s].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_e_s] =  "
                 <<probeVars[admsProbeID_V_e_s].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_s] =  "
                 <<probeVars[admsProbeID_V_d_s].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_g_s] =  "
                 <<probeVars[admsProbeID_V_g_s].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ge_e] =  "
                 <<probeVars[admsProbeID_V_ge_e].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_e_di] =  "
                 <<probeVars[admsProbeID_V_e_di].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_e_si] =  "
                 <<probeVars[admsProbeID_V_e_si].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ge_di] =  "
                 <<probeVars[admsProbeID_V_ge_di].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_di_si] =  "
                 <<probeVars[admsProbeID_V_di_si].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ge_si] =  "
                 <<probeVars[admsProbeID_V_ge_si].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_Temp_t_GND] =  "
                 <<probeVars[admsProbeID_Temp_t_GND].val() << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_d] =  "
                 <<staticContributions[admsNodeID_d].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_N_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_g_ge) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_e_ge) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_d) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_s) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_di_d) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_si_s) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_e_s) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_g_s) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_e) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_e_di) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_e_si) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_di) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_si) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_d] =  "
                 <<dynamicContributions[admsNodeID_d].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_N_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_ge) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_ge) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_d) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_s) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_d) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_si_s) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_s) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_s) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_e) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_di) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_si) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_di) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_si) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_g] =  "
                 <<staticContributions[admsNodeID_g].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_N_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_g_ge) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_e_ge) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_ge_d) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_ge_s) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_di_d) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_si_s) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_e_s) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_g_s) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_ge_e) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_e_di) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_e_si) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_ge_di) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_ge_si) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_g] =  "
                 <<dynamicContributions[admsNodeID_g].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_N_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_ge) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_e_ge) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_ge_d) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_ge_s) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_d) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_si_s) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_e_s) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_s) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_ge_e) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_e_di) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_e_si) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_ge_di) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_ge_si) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_s] =  "
                 <<staticContributions[admsNodeID_s].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_N_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_g_ge) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_e_ge) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_d) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_s) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_di_d) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_s) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_e_s) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_g_s) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_e) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_e_di) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_e_si) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_di) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_si) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_s] =  "
                 <<dynamicContributions[admsNodeID_s].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_N_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_ge) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_ge) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_d) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_s) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_d) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_s) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_s) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_s) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_e) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_di) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_si) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_di) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_si) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_e] =  "
                 <<staticContributions[admsNodeID_e].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_N_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_g_ge) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_e_ge) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_d) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_s) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_di_d) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_si_s) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_e_s) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_g_s) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_e) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_e_di) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_e_si) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_di) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_si) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_e] =  "
                 <<dynamicContributions[admsNodeID_e].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_N_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_g_ge) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_ge) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_d) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_s) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_d) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_si_s) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_s) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_g_s) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_e) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_di) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_si) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_di) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_si) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_t] =  "
                 <<staticContributions[admsNodeID_t].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_N_GND) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_g_ge) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_e_ge) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_d) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_s) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_di_d) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_si_s) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_e_s) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_g_s) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_e) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_e_di) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_e_si) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_di) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_si) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_t] =  "
                 <<dynamicContributions[admsNodeID_t].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_N_GND) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_g_ge) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_e_ge) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ge_d) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ge_s) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_di_d) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_si_s) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_e_s) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_g_s) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ge_e) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_e_di) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_e_si) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ge_di) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ge_si) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_si] =  "
                 <<staticContributions[admsNodeID_si].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_N_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_g_ge) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_e_ge) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_d) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_s) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_di_d) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_s) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_e_s) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_g_s) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_e) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_e_di) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_e_si) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_di) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_si) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_si] =  "
                 <<dynamicContributions[admsNodeID_si].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_N_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_ge) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_ge) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_d) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_s) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_d) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_s) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_s) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_s) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_e) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_di) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_si) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_di) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_si) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_di] =  "
                 <<staticContributions[admsNodeID_di].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_N_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_g_ge) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_e_ge) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_d) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_s) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_di_d) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_si_s) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_e_s) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_g_s) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_e) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_e_di) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_e_si) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_di) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_si) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_di] =  "
                 <<dynamicContributions[admsNodeID_di].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_N_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_ge) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_ge) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_d) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_s) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_d) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_s) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_s) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_s) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_e) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_di) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_si) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_di) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_si) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ge] =  "
                 <<staticContributions[admsNodeID_ge].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_N_GND) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_g_ge) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_ge) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_d) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_s) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_di_d) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_si_s) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_s) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_g_s) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_e) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_di) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_si) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_di) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_si) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ge].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_ge].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ge] =  "
                 <<dynamicContributions[admsNodeID_ge].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_N_GND) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_g_ge) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_ge) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_d) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_s) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_di_d) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_si_s) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_s) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_g_s) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_e) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_di) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_si) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_di) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_si) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ge].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_ge].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_N] =  "
                 <<staticContributions[admsNodeID_N].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_N_GND) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_g_ge) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_e_ge) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_d) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_s) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_di_d) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_si_s) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_e_s) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_g_s) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_e) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_e_di) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_e_si) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_di) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_si) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_N].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_N] =  "
                 <<dynamicContributions[admsNodeID_N].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_N_GND) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_N_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_g_ge) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_g_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_e_ge) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_e_ge) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_ge_d) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_ge_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_ge_s) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_ge_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_di_d) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_di_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_si_s) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_si_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_e_s) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_e_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_g_s) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_g_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_ge_e) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_ge_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_e_di) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_e_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_e_si) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_e_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_ge_di) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_ge_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_V_ge_si) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_V_ge_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_N].dx(admsProbeID_Temp_t_GND) << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 4 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 9; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 4 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode].val();
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode].val();
      }
    }
  }  
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
  return 14;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
  int numSources=getNumNoiseSources();
  noiseData.numSources = numSources;
  noiseData.resize(numSources);

  noiseData.deviceName = getName().getEncodedName();
  std::string theNoiseName;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_di_si")+std::string("_")+std::string("flicker");
  noiseData.noiseNames[0]=theNoiseName;
  noiseData.li_Pos[0]=li_di;
  noiseData.li_Neg[0]=li_si;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_d_di")+std::string("_")+std::string("thermal");
  noiseData.noiseNames[1]=theNoiseName;
  noiseData.li_Pos[1]=li_d;
  noiseData.li_Neg[1]=li_di;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_s_si")+std::string("_")+std::string("thermal");
  noiseData.noiseNames[2]=theNoiseName;
  noiseData.li_Pos[2]=li_s;
  noiseData.li_Neg[2]=li_si;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_g_ge")+std::string("_")+std::string("thermal");
  noiseData.noiseNames[3]=theNoiseName;
  noiseData.li_Pos[3]=li_g;
  noiseData.li_Neg[3]=li_ge;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_di_si")+std::string("_")+std::string("thermal");
  noiseData.noiseNames[4]=theNoiseName;
  noiseData.li_Pos[4]=li_di;
  noiseData.li_Neg[4]=li_si;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_di_si")+std::string("_")+std::string("thermal");
  noiseData.noiseNames[5]=theNoiseName;
  noiseData.li_Pos[5]=li_di;
  noiseData.li_Neg[5]=li_si;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_N_GND");
  noiseData.noiseNames[6]=theNoiseName;
  noiseData.li_Pos[6]=li_N;
  noiseData.li_Neg[6]=-1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_ge_si")+std::string("_")+std::string("shot");
  noiseData.noiseNames[7]=theNoiseName;
  noiseData.li_Pos[7]=li_ge;
  noiseData.li_Neg[7]=li_si;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_ge_di")+std::string("_")+std::string("shot");
  noiseData.noiseNames[8]=theNoiseName;
  noiseData.li_Pos[8]=li_ge;
  noiseData.li_Neg[8]=li_di;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_ge_di")+std::string("_")+std::string("shot");
  noiseData.noiseNames[9]=theNoiseName;
  noiseData.li_Pos[9]=li_ge;
  noiseData.li_Neg[9]=li_di;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_ge_si")+std::string("_")+std::string("shot");
  noiseData.noiseNames[10]=theNoiseName;
  noiseData.li_Pos[10]=li_ge;
  noiseData.li_Neg[10]=li_si;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_ge_e")+std::string("_")+std::string("shot");
  noiseData.noiseNames[11]=theNoiseName;
  noiseData.li_Pos[11]=li_ge;
  noiseData.li_Neg[11]=li_e;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_ge_si")+std::string("_")+std::string("shot");
  noiseData.noiseNames[12]=theNoiseName;
  noiseData.li_Pos[12]=li_ge;
  noiseData.li_Neg[12]=li_si;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_ge_di")+std::string("_")+std::string("shot");
  noiseData.noiseNames[13]=theNoiseName;
  noiseData.li_Pos[13]=li_ge;
  noiseData.li_Neg[13]=li_di;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];

  noiseData.noiseDens[0] /= pow(noiseData.freq,noiseContribsExponent[0]);noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
  noiseData.noiseDens[1] = noiseContribsPower[1];
  noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
  noiseData.noiseDens[2] = noiseContribsPower[2];
  noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
  noiseData.noiseDens[3] = noiseContribsPower[3];
  noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
  noiseData.noiseDens[4] = noiseContribsPower[4];
  noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
  noiseData.noiseDens[5] = noiseContribsPower[5];
  noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));
  noiseData.noiseDens[6] = noiseContribsPower[6];
  noiseData.lnNoiseDens[6] = std::log(std::max(noiseData.noiseDens[6],N_MINLOG));
  noiseData.noiseDens[7] = noiseContribsPower[7];
  noiseData.lnNoiseDens[7] = std::log(std::max(noiseData.noiseDens[7],N_MINLOG));
  noiseData.noiseDens[8] = noiseContribsPower[8];
  noiseData.lnNoiseDens[8] = std::log(std::max(noiseData.noiseDens[8],N_MINLOG));
  noiseData.noiseDens[9] = noiseContribsPower[9];
  noiseData.lnNoiseDens[9] = std::log(std::max(noiseData.noiseDens[9],N_MINLOG));
  noiseData.noiseDens[10] = noiseContribsPower[10];
  noiseData.lnNoiseDens[10] = std::log(std::max(noiseData.noiseDens[10],N_MINLOG));
  noiseData.noiseDens[11] = noiseContribsPower[11];
  noiseData.lnNoiseDens[11] = std::log(std::max(noiseData.noiseDens[11],N_MINLOG));
  noiseData.noiseDens[12] = noiseContribsPower[12];
  noiseData.lnNoiseDens[12] = std::log(std::max(noiseData.noiseDens[12],N_MINLOG));
  noiseData.noiseDens[13] = noiseContribsPower[13];
  noiseData.lnNoiseDens[13] = std::log(std::max(noiseData.noiseDens[13],N_MINLOG));

}  

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_di_Equ_ge_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_di);
  (*f_di_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_d_di) +staticContributions[admsNodeID_di].dx(admsProbeID_V_di_d) +staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_di].dx(admsProbeID_V_e_di) -staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_di);
  (*f_si_Equ_ge_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_di);
  (*f_si_Equ_di_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_di_d) +staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_si].dx(admsProbeID_V_e_di) -staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_di);
  (*f_di_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_si_s) -staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_di].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_si);
  (*f_si_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_si_s) -staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_si].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_si);
  (*f_di_Equ_e_Node_Ptr) +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_di].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_di].dx(admsProbeID_V_e_di);
  (*f_si_Equ_e_Node_Ptr) +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_si].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_e_di);
  (*f_di_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND);
  (*f_si_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND);
  (*f_ge_Equ_ge_Node_Ptr) +=  -staticContributions[admsNodeID_ge].dx(admsProbeID_V_g_ge) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_di) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_si);
  (*f_ge_Equ_e_Node_Ptr) +=  -staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_di);
  (*f_ge_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_ge].dx(admsProbeID_Temp_t_GND);
  (*f_ge_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_ge].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_si_s);
  (*f_ge_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_di) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_di) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_di_d);
  (*f_ge_Equ_s_Node_Ptr) +=  -staticContributions[admsNodeID_ge].dx(admsProbeID_V_si_s);
  (*f_si_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) -staticContributions[admsNodeID_si].dx(admsProbeID_V_si_s);
  (*f_ge_Equ_d_Node_Ptr) +=  -staticContributions[admsNodeID_ge].dx(admsProbeID_V_di_d);
  (*f_si_Equ_d_Node_Ptr) +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_di_d);
  (*f_di_Equ_s_Node_Ptr) +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_si_s);
  (*f_di_Equ_d_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_d_di) -staticContributions[admsNodeID_di].dx(admsProbeID_V_di_d);
  (*f_e_Equ_ge_Node_Ptr) +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_di) +staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_si);
  (*f_e_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_si_s) -staticContributions[admsNodeID_e].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_e].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_si);
  (*f_e_Equ_e_Node_Ptr) +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_e].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_e].dx(admsProbeID_V_e_di);
  (*f_e_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_di) +staticContributions[admsNodeID_e].dx(admsProbeID_V_di_d) +staticContributions[admsNodeID_e].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_e].dx(admsProbeID_V_e_di);
  (*f_e_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_e].dx(admsProbeID_Temp_t_GND);
  (*f_e_Equ_s_Node_Ptr) +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_si_s);
  (*f_e_Equ_d_Node_Ptr) +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_di_d);
  (*f_d_Equ_d_Node_Ptr) +=  +staticContributions[admsNodeID_d].dx(admsProbeID_V_d_di) -staticContributions[admsNodeID_d].dx(admsProbeID_V_di_d);
  (*f_d_Equ_s_Node_Ptr) +=  -staticContributions[admsNodeID_d].dx(admsProbeID_V_si_s);
  (*f_s_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si) -staticContributions[admsNodeID_s].dx(admsProbeID_V_si_s);
  (*f_s_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND);
  (*f_s_Equ_di_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_s].dx(admsProbeID_V_e_di);
  (*f_s_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si) +staticContributions[admsNodeID_s].dx(admsProbeID_V_si_s) -staticContributions[admsNodeID_s].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_s].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_si);
  (*f_s_Equ_ge_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_si);
  (*f_s_Equ_e_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_s].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_s].dx(admsProbeID_V_e_di);
  (*f_d_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND);
  (*f_d_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_d].dx(admsProbeID_V_d_di) +staticContributions[admsNodeID_d].dx(admsProbeID_V_di_d) +staticContributions[admsNodeID_d].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_d].dx(admsProbeID_V_e_di) -staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_di);
  (*f_d_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_d].dx(admsProbeID_V_si_s) -staticContributions[admsNodeID_d].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_d].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_si);
  (*f_d_Equ_ge_Node_Ptr) +=  +staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_di);
  (*f_d_Equ_e_Node_Ptr) +=  -staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_d].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_d].dx(admsProbeID_V_e_di);
  (*f_g_Equ_g_Node_Ptr) +=  +staticContributions[admsNodeID_g].dx(admsProbeID_V_g_ge);
  (*f_g_Equ_ge_Node_Ptr) +=  -staticContributions[admsNodeID_g].dx(admsProbeID_V_g_ge);
  (*f_ge_Equ_g_Node_Ptr) +=  +staticContributions[admsNodeID_ge].dx(admsProbeID_V_g_ge);
  (*f_g_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_g].dx(admsProbeID_Temp_t_GND);
  if (!collapseNode_N)
  {
    (*f_di_Equ_N_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_N_GND);
  }
  if (!collapseNode_N)
  {
    (*f_si_Equ_N_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_N_GND);
  }
  if (!collapseNode_N)
  {
    (*f_N_Equ_ge_Node_Ptr) +=  +staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_di) +staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_e);
  }
  if (!collapseNode_N)
  {
    (*f_N_Equ_e_Node_Ptr) +=  +staticContributions[admsNodeID_N].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_N].dx(admsProbeID_V_e_di) -staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_e);
  }
  if (!collapseNode_N)
  {
    (*f_N_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_N].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_N].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_N].dx(admsProbeID_V_si_s);
  }
  if (!collapseNode_N)
  {
    (*f_N_Equ_s_Node_Ptr) +=  -staticContributions[admsNodeID_N].dx(admsProbeID_V_si_s);
  }
  if (!collapseNode_N)
  {
    (*f_N_Equ_di_Node_Ptr) +=  +staticContributions[admsNodeID_N].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_N].dx(admsProbeID_V_e_di) -staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_di) +staticContributions[admsNodeID_N].dx(admsProbeID_V_di_d);
  }
  if (!collapseNode_N)
  {
    (*f_N_Equ_d_Node_Ptr) +=  -staticContributions[admsNodeID_N].dx(admsProbeID_V_di_d);
  }
  if (!collapseNode_N)
  {
    (*f_N_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_N].dx(admsProbeID_Temp_t_GND);
  }
  if (!collapseNode_N)
  {
    (*f_N_Equ_N_Node_Ptr) +=  +staticContributions[admsNodeID_N].dx(admsProbeID_V_N_GND);
  }
  (*f_t_Equ_s_Node_Ptr) +=  -staticContributions[admsNodeID_t].dx(admsProbeID_V_si_s) +staticContributions[admsNodeID_t].dx(admsProbeID_V_s_si);
  (*f_t_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_t].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_t].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_t].dx(admsProbeID_V_si_s) -staticContributions[admsNodeID_t].dx(admsProbeID_V_s_si);
  (*f_t_Equ_di_Node_Ptr) +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_t].dx(admsProbeID_V_e_di) -staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_di) -staticContributions[admsNodeID_t].dx(admsProbeID_V_d_di) +staticContributions[admsNodeID_t].dx(admsProbeID_V_di_d);
  (*f_t_Equ_d_Node_Ptr) +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_d_di) -staticContributions[admsNodeID_t].dx(admsProbeID_V_di_d);
  (*f_t_Equ_ge_Node_Ptr) +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_di);
  (*f_t_Equ_e_Node_Ptr) +=  -staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_t].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_t].dx(admsProbeID_V_e_di);
  (*f_t_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND);

#else
  //use the offsets instead of pointers
  dFdx[li_di][A_di_Equ_ge_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_di);
  dFdx[li_di][A_di_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_d_di) +staticContributions[admsNodeID_di].dx(admsProbeID_V_di_d) +staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_di].dx(admsProbeID_V_e_di) -staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_di);
  dFdx[li_si][A_si_Equ_ge_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_di);
  dFdx[li_si][A_si_Equ_di_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_di_d) +staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_si].dx(admsProbeID_V_e_di) -staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_di);
  dFdx[li_di][A_di_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_si_s) -staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_di].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_si);
  dFdx[li_si][A_si_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_si_s) -staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_si].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_si);
  dFdx[li_di][A_di_Equ_e_NodeOffset] +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_di].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_di].dx(admsProbeID_V_e_di);
  dFdx[li_si][A_si_Equ_e_NodeOffset] +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_si].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_e_di);
  dFdx[li_di][A_di_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND);
  dFdx[li_si][A_si_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND);
  dFdx[li_ge][A_ge_Equ_ge_NodeOffset] +=  -staticContributions[admsNodeID_ge].dx(admsProbeID_V_g_ge) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_di) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_si);
  dFdx[li_ge][A_ge_Equ_e_NodeOffset] +=  -staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_di);
  dFdx[li_ge][A_ge_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_ge].dx(admsProbeID_Temp_t_GND);
  dFdx[li_ge][A_ge_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_ge].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_si_s);
  dFdx[li_ge][A_ge_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_ge].dx(admsProbeID_V_ge_di) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_ge].dx(admsProbeID_V_e_di) +staticContributions[admsNodeID_ge].dx(admsProbeID_V_di_d);
  dFdx[li_ge][A_ge_Equ_s_NodeOffset] +=  -staticContributions[admsNodeID_ge].dx(admsProbeID_V_si_s);
  dFdx[li_si][A_si_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) -staticContributions[admsNodeID_si].dx(admsProbeID_V_si_s);
  dFdx[li_ge][A_ge_Equ_d_NodeOffset] +=  -staticContributions[admsNodeID_ge].dx(admsProbeID_V_di_d);
  dFdx[li_si][A_si_Equ_d_NodeOffset] +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_di_d);
  dFdx[li_di][A_di_Equ_s_NodeOffset] +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_si_s);
  dFdx[li_di][A_di_Equ_d_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_d_di) -staticContributions[admsNodeID_di].dx(admsProbeID_V_di_d);
  dFdx[li_e][A_e_Equ_ge_NodeOffset] +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_di) +staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_si);
  dFdx[li_e][A_e_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_si_s) -staticContributions[admsNodeID_e].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_e].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_si);
  dFdx[li_e][A_e_Equ_e_NodeOffset] +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_e].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_e].dx(admsProbeID_V_e_di);
  dFdx[li_e][A_e_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_ge_di) +staticContributions[admsNodeID_e].dx(admsProbeID_V_di_d) +staticContributions[admsNodeID_e].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_e].dx(admsProbeID_V_e_di);
  dFdx[li_e][A_e_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_e].dx(admsProbeID_Temp_t_GND);
  dFdx[li_e][A_e_Equ_s_NodeOffset] +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_si_s);
  dFdx[li_e][A_e_Equ_d_NodeOffset] +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_di_d);
  dFdx[li_d][A_d_Equ_d_NodeOffset] +=  +staticContributions[admsNodeID_d].dx(admsProbeID_V_d_di) -staticContributions[admsNodeID_d].dx(admsProbeID_V_di_d);
  dFdx[li_d][A_d_Equ_s_NodeOffset] +=  -staticContributions[admsNodeID_d].dx(admsProbeID_V_si_s);
  dFdx[li_s][A_s_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si) -staticContributions[admsNodeID_s].dx(admsProbeID_V_si_s);
  dFdx[li_s][A_s_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND);
  dFdx[li_s][A_s_Equ_di_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_s].dx(admsProbeID_V_e_di);
  dFdx[li_s][A_s_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si) +staticContributions[admsNodeID_s].dx(admsProbeID_V_si_s) -staticContributions[admsNodeID_s].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_s].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_si);
  dFdx[li_s][A_s_Equ_ge_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_si);
  dFdx[li_s][A_s_Equ_e_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_s].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_s].dx(admsProbeID_V_e_di);
  dFdx[li_d][A_d_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND);
  dFdx[li_d][A_d_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_d].dx(admsProbeID_V_d_di) +staticContributions[admsNodeID_d].dx(admsProbeID_V_di_d) +staticContributions[admsNodeID_d].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_d].dx(admsProbeID_V_e_di) -staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_di);
  dFdx[li_d][A_d_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_d].dx(admsProbeID_V_si_s) -staticContributions[admsNodeID_d].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_d].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_si);
  dFdx[li_d][A_d_Equ_ge_NodeOffset] +=  +staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_di);
  dFdx[li_d][A_d_Equ_e_NodeOffset] +=  -staticContributions[admsNodeID_d].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_d].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_d].dx(admsProbeID_V_e_di);
  dFdx[li_g][A_g_Equ_g_NodeOffset] +=  +staticContributions[admsNodeID_g].dx(admsProbeID_V_g_ge);
  dFdx[li_g][A_g_Equ_ge_NodeOffset] +=  -staticContributions[admsNodeID_g].dx(admsProbeID_V_g_ge);
  dFdx[li_ge][A_ge_Equ_g_NodeOffset] +=  +staticContributions[admsNodeID_ge].dx(admsProbeID_V_g_ge);
  dFdx[li_g][A_g_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_g].dx(admsProbeID_Temp_t_GND);
  if (!collapseNode_N)
  {
    dFdx[li_di][A_di_Equ_N_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_N_GND);
  }
  if (!collapseNode_N)
  {
    dFdx[li_si][A_si_Equ_N_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_N_GND);
  }
  if (!collapseNode_N)
  {
    dFdx[li_N][A_N_Equ_ge_NodeOffset] +=  +staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_di) +staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_e);
  }
  if (!collapseNode_N)
  {
    dFdx[li_N][A_N_Equ_e_NodeOffset] +=  +staticContributions[admsNodeID_N].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_N].dx(admsProbeID_V_e_di) -staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_e);
  }
  if (!collapseNode_N)
  {
    dFdx[li_N][A_N_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_N].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_N].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_N].dx(admsProbeID_V_si_s);
  }
  if (!collapseNode_N)
  {
    dFdx[li_N][A_N_Equ_s_NodeOffset] +=  -staticContributions[admsNodeID_N].dx(admsProbeID_V_si_s);
  }
  if (!collapseNode_N)
  {
    dFdx[li_N][A_N_Equ_di_NodeOffset] +=  +staticContributions[admsNodeID_N].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_N].dx(admsProbeID_V_e_di) -staticContributions[admsNodeID_N].dx(admsProbeID_V_ge_di) +staticContributions[admsNodeID_N].dx(admsProbeID_V_di_d);
  }
  if (!collapseNode_N)
  {
    dFdx[li_N][A_N_Equ_d_NodeOffset] +=  -staticContributions[admsNodeID_N].dx(admsProbeID_V_di_d);
  }
  if (!collapseNode_N)
  {
    dFdx[li_N][A_N_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_N].dx(admsProbeID_Temp_t_GND);
  }
  if (!collapseNode_N)
  {
    dFdx[li_N][A_N_Equ_N_NodeOffset] +=  +staticContributions[admsNodeID_N].dx(admsProbeID_V_N_GND);
  }
  dFdx[li_t][A_t_Equ_s_NodeOffset] +=  -staticContributions[admsNodeID_t].dx(admsProbeID_V_si_s) +staticContributions[admsNodeID_t].dx(admsProbeID_V_s_si);
  dFdx[li_t][A_t_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_t].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_t].dx(admsProbeID_V_e_si) -staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_t].dx(admsProbeID_V_si_s) -staticContributions[admsNodeID_t].dx(admsProbeID_V_s_si);
  dFdx[li_t][A_t_Equ_di_NodeOffset] +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_t].dx(admsProbeID_V_e_di) -staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_di) -staticContributions[admsNodeID_t].dx(admsProbeID_V_d_di) +staticContributions[admsNodeID_t].dx(admsProbeID_V_di_d);
  dFdx[li_t][A_t_Equ_d_NodeOffset] +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_d_di) -staticContributions[admsNodeID_t].dx(admsProbeID_V_di_d);
  dFdx[li_t][A_t_Equ_ge_NodeOffset] +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_si) +staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_di);
  dFdx[li_t][A_t_Equ_e_NodeOffset] +=  -staticContributions[admsNodeID_t].dx(admsProbeID_V_ge_e) +staticContributions[admsNodeID_t].dx(admsProbeID_V_e_si) +staticContributions[admsNodeID_t].dx(admsProbeID_V_e_di);
  dFdx[li_t][A_t_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND);

#endif
  
  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_di_Equ_ge_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_d) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_si) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_e);
  (*q_di_Equ_di_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_d) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_di);
  (*q_si_Equ_ge_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_s) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_si) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_e);
  (*q_si_Equ_di_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_d) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_di);
  (*q_di_Equ_si_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_s) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_si) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_si);
  (*q_si_Equ_si_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_s) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_si) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_si);
  (*q_di_Equ_e_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_si) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_di) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_e);
  (*q_si_Equ_e_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_si) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_di) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_e);
  (*q_di_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND);
  (*q_si_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND);
  (*q_ge_Equ_ge_Node_Ptr) +=  +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_d) +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_s) +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_di) -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_ge) +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_si) +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_e);
  (*q_ge_Equ_e_Node_Ptr) +=  +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_ge) +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_si) +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_di) -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_e);
  (*q_ge_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_ge].dx(admsProbeID_Temp_t_GND);
  (*q_ge_Equ_si_Node_Ptr) +=  -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_si) -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_si);
  (*q_ge_Equ_di_Node_Ptr) +=  -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_di);
  (*q_ge_Equ_s_Node_Ptr) +=  -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_s);
  (*q_si_Equ_s_Node_Ptr) +=  -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_s) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_s);
  (*q_ge_Equ_d_Node_Ptr) +=  -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_d);
  (*q_si_Equ_d_Node_Ptr) +=  -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_d);
  (*q_di_Equ_s_Node_Ptr) +=  -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_s);
  (*q_di_Equ_d_Node_Ptr) +=  -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_d) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_d);
  (*q_e_Equ_ge_Node_Ptr) +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_ge) +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_e) +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_si);
  (*q_e_Equ_si_Node_Ptr) +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_si_s) -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_si) -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_si) -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_si);
  (*q_e_Equ_e_Node_Ptr) +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_ge) -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_e) +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_si) +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_di);
  (*q_e_Equ_di_Node_Ptr) +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_d) -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_di) -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_di) +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_si);
  (*q_e_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_Temp_t_GND);
  (*q_e_Equ_s_Node_Ptr) +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_si_s);
  (*q_e_Equ_d_Node_Ptr) +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_d);
  (*q_d_Equ_d_Node_Ptr) +=  -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_d) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_s);
  (*q_d_Equ_s_Node_Ptr) +=  -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_s);
  (*q_s_Equ_d_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_s);
  (*q_s_Equ_s_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_s) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_s);
  (*q_s_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND);
  (*q_s_Equ_di_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_di) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_di) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_si);
  (*q_s_Equ_si_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_si) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_si) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_si);
  (*q_s_Equ_ge_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_s) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_e) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_si);
  (*q_s_Equ_e_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_e) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_si) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_di);
  (*q_d_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND);
  (*q_d_Equ_di_Node_Ptr) +=  -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_di) -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_di) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_si);
  (*q_d_Equ_si_Node_Ptr) +=  -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_si) -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_si) -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_si);
  (*q_d_Equ_ge_Node_Ptr) +=  +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_d) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_e) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_si);
  (*q_d_Equ_e_Node_Ptr) +=  -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_e) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_si) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_di);
  if (!collapseNode_N)
  {
    (*q_di_Equ_N_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_N_GND);
  }
  if (!collapseNode_N)
  {
    (*q_si_Equ_N_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_N_GND);
  }
  if (!collapseNode_N)
  {
    (*q_ge_Equ_N_Node_Ptr) +=  +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_N_GND);
  }
  (*q_t_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND);

#else
  //use the offsets instead of pointers
  dQdx[li_di][A_di_Equ_ge_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_d) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_si) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_e);
  dQdx[li_di][A_di_Equ_di_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_d) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_di);
  dQdx[li_si][A_si_Equ_ge_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_s) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_si) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_e);
  dQdx[li_si][A_si_Equ_di_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_d) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_di);
  dQdx[li_di][A_di_Equ_si_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_s) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_si) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_si);
  dQdx[li_si][A_si_Equ_si_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_s) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_si) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_si);
  dQdx[li_di][A_di_Equ_e_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_si) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_di) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_e);
  dQdx[li_si][A_si_Equ_e_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_si) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_di) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_e);
  dQdx[li_di][A_di_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND);
  dQdx[li_si][A_si_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND);
  dQdx[li_ge][A_ge_Equ_ge_NodeOffset] +=  +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_d) +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_s) +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_di) -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_ge) +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_si) +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_e);
  dQdx[li_ge][A_ge_Equ_e_NodeOffset] +=  +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_ge) +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_si) +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_di) -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_e);
  dQdx[li_ge][A_ge_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_ge].dx(admsProbeID_Temp_t_GND);
  dQdx[li_ge][A_ge_Equ_si_NodeOffset] +=  -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_si) -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_si);
  dQdx[li_ge][A_ge_Equ_di_NodeOffset] +=  -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_e_di);
  dQdx[li_ge][A_ge_Equ_s_NodeOffset] +=  -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_s);
  dQdx[li_si][A_si_Equ_s_NodeOffset] +=  -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ge_s) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_s);
  dQdx[li_ge][A_ge_Equ_d_NodeOffset] +=  -dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_ge_d);
  dQdx[li_si][A_si_Equ_d_NodeOffset] +=  -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_d);
  dQdx[li_di][A_di_Equ_s_NodeOffset] +=  -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_s);
  dQdx[li_di][A_di_Equ_d_NodeOffset] +=  -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_ge_d) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_d);
  dQdx[li_e][A_e_Equ_ge_NodeOffset] +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_ge) +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_e) +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_si);
  dQdx[li_e][A_e_Equ_si_NodeOffset] +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_si_s) -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_si) -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_si) -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_si);
  dQdx[li_e][A_e_Equ_e_NodeOffset] +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_ge) -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_e) +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_si) +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_di);
  dQdx[li_e][A_e_Equ_di_NodeOffset] +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_d) -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ge_di) -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_di) +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_si);
  dQdx[li_e][A_e_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_Temp_t_GND);
  dQdx[li_e][A_e_Equ_s_NodeOffset] +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_si_s);
  dQdx[li_e][A_e_Equ_d_NodeOffset] +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_d);
  dQdx[li_d][A_d_Equ_d_NodeOffset] +=  -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_d) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_s);
  dQdx[li_d][A_d_Equ_s_NodeOffset] +=  -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_s);
  dQdx[li_s][A_s_Equ_d_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_s);
  dQdx[li_s][A_s_Equ_s_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_s) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_s);
  dQdx[li_s][A_s_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND);
  dQdx[li_s][A_s_Equ_di_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_di) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_di) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_si);
  dQdx[li_s][A_s_Equ_si_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_si) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_si) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_si);
  dQdx[li_s][A_s_Equ_ge_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_s) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_e) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_si);
  dQdx[li_s][A_s_Equ_e_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ge_e) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_si) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_di);
  dQdx[li_d][A_d_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND);
  dQdx[li_d][A_d_Equ_di_NodeOffset] +=  -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_di) -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_di) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_si);
  dQdx[li_d][A_d_Equ_si_NodeOffset] +=  -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_si) -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_si) -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_si);
  dQdx[li_d][A_d_Equ_ge_NodeOffset] +=  +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_d) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_di) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_e) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_si);
  dQdx[li_d][A_d_Equ_e_NodeOffset] +=  -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_ge_e) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_si) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_di);
  if (!collapseNode_N)
  {
    dQdx[li_di][A_di_Equ_N_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_N_GND);
  }
  if (!collapseNode_N)
  {
    dQdx[li_si][A_si_Equ_N_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_N_GND);
  }
  if (!collapseNode_N)
  {
    dQdx[li_ge][A_ge_Equ_N_NodeOffset] +=  +dynamicContributions[admsNodeID_ge].dx(admsProbeID_V_N_GND);
  }
  dQdx[li_t][A_t_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND);

  
#endif
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:
  if (!given("COVD"))
  {
    COVD = COVS;
  }
  if (!given("LRSD"))
  {
    LRSD = L;
  }
  if (!given("TYPE"))
  {
    TYPE = DEVTYPE;
  }

  // set internal model type based on model card type
  if (getType() == "pmos" || getType() == "PMOS")
    TYPE = 0;
  if (!given("CITR"))
  {
    CITR = CIT;
  }
  if (!given("CDSCDR"))
  {
    CDSCDR = CDSCD;
  }
  if (!given("CDSCDRN1"))
  {
    CDSCDRN1 = CDSCDN1;
  }
  if (!given("CDSCDRN2"))
  {
    CDSCDRN2 = CDSCDN2;
  }
  if (!given("DVT1SS"))
  {
    DVT1SS = DVT1;
  }
  if (!given("ETA0R"))
  {
    ETA0R = ETA0;
  }
  if (!given("TETA0R"))
  {
    TETA0R = TETA0;
  }
  if (!given("DVTSHIFTR"))
  {
    DVTSHIFTR = DVTSHIFT;
  }
  if (!given("K2SI"))
  {
    K2SI = K0SI;
  }
  if (!given("K2SI1"))
  {
    K2SI1 = K0SI1;
  }
  if (!given("K2SISAT"))
  {
    K2SISAT = K0SISAT;
  }
  if (!given("K2SISAT1"))
  {
    K2SISAT1 = K0SISAT1;
  }
  if (!given("VSATR"))
  {
    VSATR = VSAT;
  }
  if (!given("VSATRN1"))
  {
    VSATRN1 = VSATN1;
  }
  if (!given("VSATRN2"))
  {
    VSATRN2 = VSATN2;
  }
  if (!given("VSAT1"))
  {
    VSAT1 = VSAT;
  }
  if (!given("VSAT1N1"))
  {
    VSAT1N1 = VSATN1;
  }
  if (!given("VSAT1N2"))
  {
    VSAT1N2 = VSATN2;
  }
  if (!given("VSAT1R"))
  {
    VSAT1R = VSAT1;
  }
  if (!given("VSAT1RN1"))
  {
    VSAT1RN1 = VSAT1N1;
  }
  if (!given("VSAT1RN2"))
  {
    VSAT1RN2 = VSAT1N2;
  }
  if (!given("AVSAT1"))
  {
    AVSAT1 = AVSAT;
  }
  if (!given("BVSAT1"))
  {
    BVSAT1 = BVSAT;
  }
  if (!given("KSATIVR"))
  {
    KSATIVR = KSATIV;
  }
  if (!given("VSATCV"))
  {
    VSATCV = VSAT;
  }
  if (!given("AVSATCV"))
  {
    AVSATCV = AVSAT;
  }
  if (!given("BVSATCV"))
  {
    BVSATCV = BVSAT;
  }
  if (!given("DELTAVSATCV"))
  {
    DELTAVSATCV = DELTAVSAT;
  }
  if (!given("PSATCV"))
  {
    PSATCV = PSAT;
  }
  if (!given("APSATCV"))
  {
    APSATCV = APSAT;
  }
  if (!given("BPSATCV"))
  {
    BPSATCV = BPSAT;
  }
  if (!given("MEXPR"))
  {
    MEXPR = MEXP;
  }
  if (!given("AMEXPR"))
  {
    AMEXPR = AMEXP;
  }
  if (!given("BMEXPR"))
  {
    BMEXPR = BMEXP;
  }
  if (!given("PTWGR"))
  {
    PTWGR = PTWG;
  }
  if (!given("ATR"))
  {
    ATR = AT;
  }
  if (!given("ATCV"))
  {
    ATCV = AT;
  }
  if (!given("TMEXPR"))
  {
    TMEXPR = TMEXP;
  }
  if (!given("U0R"))
  {
    U0R = U0;
  }
  if (!given("U0N1R"))
  {
    U0N1R = U0N1;
  }
  if (!given("U0N2R"))
  {
    U0N2R = U0N2;
  }
  if (!given("UPR"))
  {
    UPR = UP;
  }
  if (!given("LPAR"))
  {
    LPAR = LPA;
  }
  if (!given("UAR"))
  {
    UAR = UA;
  }
  if (!given("AUAR"))
  {
    AUAR = AUA;
  }
  if (!given("BUAR"))
  {
    BUAR = BUA;
  }
  if (!given("UCR"))
  {
    UCR = UC;
  }
  if (!given("EUR"))
  {
    EUR = EU;
  }
  if (!given("AEUR"))
  {
    AEUR = AEU;
  }
  if (!given("BEUR"))
  {
    BEUR = BEU;
  }
  if (!given("UDR"))
  {
    UDR = UD;
  }
  if (!given("AUDR"))
  {
    AUDR = AUD;
  }
  if (!given("BUDR"))
  {
    BUDR = BUD;
  }
  if (!given("UTER"))
  {
    UTER = UTE;
  }
  if (!given("UTLR"))
  {
    UTLR = UTL;
  }
  if (!given("UA1R"))
  {
    UA1R = UA1;
  }
  if (!given("UC1R"))
  {
    UC1R = UC1;
  }
  if (!given("UD1R"))
  {
    UD1R = UD1;
  }
  if (!given("RSDRR"))
  {
    RSDRR = RSDR;
  }
  if (!given("RDDR"))
  {
    RDDR = RSDR;
  }
  if (!given("RDDRR"))
  {
    RDDRR = RDDR;
  }
  if (!given("PRDDR"))
  {
    PRDDR = PRSDR;
  }
  if (!given("PRWGD"))
  {
    PRWGD = PRWGS;
  }
  if (!given("TRDDR"))
  {
    TRDDR = TRSDR;
  }
  if (!given("PDIBL1R"))
  {
    PDIBL1R = PDIBL1;
  }
  if (!given("PDIBL2R"))
  {
    PDIBL2R = PDIBL2;
  }
  if (!given("PCLMR"))
  {
    PCLMR = PCLM;
  }
  if (!given("APCLMR"))
  {
    APCLMR = APCLM;
  }
  if (!given("BPCLMR"))
  {
    BPCLMR = BPCLM;
  }
  if (!given("PCLMCV"))
  {
    PCLMCV = PCLM;
  }
  if (!given("RSHD"))
  {
    RSHD = RSHS;
  }
  if (!given("LSP"))
  {
    LSP = (0.2*(L+XL));
  }
  if (!given("DLCIGD"))
  {
    DLCIGD = DLCIGS;
  }
  if (!given("AIGD"))
  {
    AIGD = AIGS;
  }
  if (!given("AIGD1"))
  {
    AIGD1 = AIGS1;
  }
  if (!given("BIGD"))
  {
    BIGD = BIGS;
  }
  if (!given("CIGD"))
  {
    CIGD = CIGS;
  }
  if (!given("VFBSDCV"))
  {
    VFBSDCV = VFBSD;
  }
  if (!given("TOXG"))
  {
    TOXG = TOXP;
  }
  if (!given("AGIDL"))
  {
    AGIDL = AGISL;
  }
  if (!given("BGIDL"))
  {
    BGIDL = BGISL;
  }
  if (!given("CGIDL"))
  {
    CGIDL = CGISL;
  }
  if (!given("EGIDL"))
  {
    EGIDL = EGISL;
  }
  if (!given("PGIDL"))
  {
    PGIDL = PGISL;
  }
  if (!given("EOTACC"))
  {
    EOTACC = EOT;
  }
  if (!given("CFD"))
  {
    CFD = CFS;
  }
  if (!given("CGDO"))
  {
    CGDO = CGSO;
  }
  if (!given("CGDL"))
  {
    CGDL = CGSL;
  }
  if (!given("CKAPPAD"))
  {
    CKAPPAD = CKAPPAS;
  }
  if (!given("CJD"))
  {
    CJD = CJS;
  }
  if (!given("CJSWD"))
  {
    CJSWD = CJSWS;
  }
  if (!given("CJSWGD"))
  {
    CJSWGD = CJSWGS;
  }
  if (!given("PBD"))
  {
    PBD = PBS;
  }
  if (!given("PBSWD"))
  {
    PBSWD = PBSWS;
  }
  if (!given("PBSWGS"))
  {
    PBSWGS = PBSWS;
  }
  if (!given("PBSWGD"))
  {
    PBSWGD = PBSWGS;
  }
  if (!given("MJD"))
  {
    MJD = MJS;
  }
  if (!given("MJSWD"))
  {
    MJSWD = MJSWS;
  }
  if (!given("MJSWGS"))
  {
    MJSWGS = MJSWS;
  }
  if (!given("MJSWGD"))
  {
    MJSWGD = MJSWGS;
  }
  if (!given("SJD"))
  {
    SJD = SJS;
  }
  if (!given("SJSWD"))
  {
    SJSWD = SJSWS;
  }
  if (!given("SJSWGD"))
  {
    SJSWGD = SJSWGS;
  }
  if (!given("MJD2"))
  {
    MJD2 = MJS2;
  }
  if (!given("MJSWD2"))
  {
    MJSWD2 = MJSWS2;
  }
  if (!given("MJSWGS2"))
  {
    MJSWGS2 = MJSWS2;
  }
  if (!given("MJSWGD2"))
  {
    MJSWGD2 = MJSWGS2;
  }
  if (!given("JSD"))
  {
    JSD = JSS;
  }
  if (!given("JSWD"))
  {
    JSWD = JSWS;
  }
  if (!given("JSWGD"))
  {
    JSWGD = JSWGS;
  }
  if (!given("NJD"))
  {
    NJD = NJS;
  }
  if (!given("IJTHDFWD"))
  {
    IJTHDFWD = IJTHSFWD;
  }
  if (!given("IJTHDREV"))
  {
    IJTHDREV = IJTHSREV;
  }
  if (!given("BVD"))
  {
    BVD = BVS;
  }
  if (!given("XJBVD"))
  {
    XJBVD = XJBVS;
  }
  if (!given("JTSD"))
  {
    JTSD = JTSS;
  }
  if (!given("JTSSWD"))
  {
    JTSSWD = JTSSWS;
  }
  if (!given("JTSSWGD"))
  {
    JTSSWGD = JTSSWGS;
  }
  if (!given("NJTSD"))
  {
    NJTSD = NJTS;
  }
  if (!given("NJTSSWD"))
  {
    NJTSSWD = NJTSSW;
  }
  if (!given("NJTSSWGD"))
  {
    NJTSSWGD = NJTSSWG;
  }
  if (!given("VTSD"))
  {
    VTSD = VTSS;
  }
  if (!given("VTSSWD"))
  {
    VTSSWD = VTSSWS;
  }
  if (!given("VTSSWGD"))
  {
    VTSSWGD = VTSSWGS;
  }
  if (!given("XTID"))
  {
    XTID = XTIS;
  }
  if (!given("XTSD"))
  {
    XTSD = XTSS;
  }
  if (!given("XTSSWD"))
  {
    XTSSWD = XTSSWS;
  }
  if (!given("XTSSWGD"))
  {
    XTSSWGD = XTSSWGS;
  }
  if (!given("TNJTSD"))
  {
    TNJTSD = TNJTS;
  }
  if (!given("TNJTSSWD"))
  {
    TNJTSSWD = TNJTSSW;
  }
  if (!given("TNJTSSWGD"))
  {
    TNJTSSWGD = TNJTSSWG;
  }
  if (!given("LCITR"))
  {
    LCITR = LCIT;
  }
  if (!given("NCITR"))
  {
    NCITR = NCIT;
  }
  if (!given("PCITR"))
  {
    PCITR = PCIT;
  }
  if (!given("LCDSCDR"))
  {
    LCDSCDR = LCDSCD;
  }
  if (!given("NCDSCDR"))
  {
    NCDSCDR = NCDSCD;
  }
  if (!given("PCDSCDR"))
  {
    PCDSCDR = PCDSCD;
  }
  if (!given("LDVT1SS"))
  {
    LDVT1SS = LDVT1;
  }
  if (!given("NDVT1SS"))
  {
    NDVT1SS = NDVT1;
  }
  if (!given("PDVT1SS"))
  {
    PDVT1SS = PDVT1;
  }
  if (!given("LETA0R"))
  {
    LETA0R = LETA0;
  }
  if (!given("NETA0R"))
  {
    NETA0R = NETA0;
  }
  if (!given("PETA0R"))
  {
    PETA0R = PETA0;
  }
  if (!given("LDVTSHIFTR"))
  {
    LDVTSHIFTR = LDVTSHIFT;
  }
  if (!given("NDVTSHIFTR"))
  {
    NDVTSHIFTR = NDVTSHIFT;
  }
  if (!given("PDVTSHIFTR"))
  {
    PDVTSHIFTR = PDVTSHIFT;
  }
  if (!given("LK2SI"))
  {
    LK2SI = LK0SI;
  }
  if (!given("NK2SI"))
  {
    NK2SI = NK0SI;
  }
  if (!given("PK2SI"))
  {
    PK2SI = PK0SI;
  }
  if (!given("LK2SI1"))
  {
    LK2SI1 = LK0SI1;
  }
  if (!given("NK2SI1"))
  {
    NK2SI1 = NK0SI1;
  }
  if (!given("PK2SI1"))
  {
    PK2SI1 = PK0SI1;
  }
  if (!given("LK2SISAT"))
  {
    LK2SISAT = LK0SISAT;
  }
  if (!given("NK2SISAT"))
  {
    NK2SISAT = NK0SISAT;
  }
  if (!given("PK2SISAT"))
  {
    PK2SISAT = PK0SISAT;
  }
  if (!given("LK2SISAT1"))
  {
    LK2SISAT1 = LK0SISAT1;
  }
  if (!given("NK2SISAT1"))
  {
    NK2SISAT1 = NK0SISAT1;
  }
  if (!given("PK2SISAT1"))
  {
    PK2SISAT1 = PK0SISAT1;
  }
  if (!given("LVSATR"))
  {
    LVSATR = LVSAT;
  }
  if (!given("NVSATR"))
  {
    NVSATR = NVSAT;
  }
  if (!given("PVSATR"))
  {
    PVSATR = PVSAT;
  }
  if (!given("LVSAT1"))
  {
    LVSAT1 = LVSAT;
  }
  if (!given("NVSAT1"))
  {
    NVSAT1 = NVSAT;
  }
  if (!given("PVSAT1"))
  {
    PVSAT1 = PVSAT;
  }
  if (!given("LVSAT1R"))
  {
    LVSAT1R = LVSAT1;
  }
  if (!given("NVSAT1R"))
  {
    NVSAT1R = NVSAT1;
  }
  if (!given("PVSAT1R"))
  {
    PVSAT1R = PVSAT1;
  }
  if (!given("LKSATIVR"))
  {
    LKSATIVR = LKSATIV;
  }
  if (!given("NKSATIVR"))
  {
    NKSATIVR = NKSATIV;
  }
  if (!given("PKSATIVR"))
  {
    PKSATIVR = PKSATIV;
  }
  if (!given("LMEXPR"))
  {
    LMEXPR = LMEXP;
  }
  if (!given("NMEXPR"))
  {
    NMEXPR = NMEXP;
  }
  if (!given("PMEXPR"))
  {
    PMEXPR = PMEXP;
  }
  if (!given("LPTWGR"))
  {
    LPTWGR = LPTWG;
  }
  if (!given("NPTWGR"))
  {
    NPTWGR = NPTWG;
  }
  if (!given("PPTWGR"))
  {
    PPTWGR = PPTWG;
  }
  if (!given("LU0R"))
  {
    LU0R = LU0;
  }
  if (!given("NU0R"))
  {
    NU0R = NU0;
  }
  if (!given("PU0R"))
  {
    PU0R = PU0;
  }
  if (!given("LUPR"))
  {
    LUPR = LUP;
  }
  if (!given("NUPR"))
  {
    NUPR = NUP;
  }
  if (!given("PUPR"))
  {
    PUPR = PUP;
  }
  if (!given("LUAR"))
  {
    LUAR = LUA;
  }
  if (!given("NUAR"))
  {
    NUAR = NUA;
  }
  if (!given("PUAR"))
  {
    PUAR = PUA;
  }
  if (!given("LUCR"))
  {
    LUCR = LUC;
  }
  if (!given("NUCR"))
  {
    NUCR = NUC;
  }
  if (!given("PUCR"))
  {
    PUCR = PUC;
  }
  if (!given("LEUR"))
  {
    LEUR = LEU;
  }
  if (!given("NEUR"))
  {
    NEUR = NEU;
  }
  if (!given("PEUR"))
  {
    PEUR = PEU;
  }
  if (!given("LUDR"))
  {
    LUDR = LUD;
  }
  if (!given("NUDR"))
  {
    NUDR = NUD;
  }
  if (!given("PUDR"))
  {
    PUDR = PUD;
  }
  if (!given("LPCLMR"))
  {
    LPCLMR = LPCLM;
  }
  if (!given("NPCLMR"))
  {
    NPCLMR = NPCLM;
  }
  if (!given("PPCLMR"))
  {
    PPCLMR = PPCLM;
  }
  if (!given("LPCLMCV"))
  {
    LPCLMCV = LPCLM;
  }
  if (!given("NPCLMCV"))
  {
    NPCLMCV = NPCLM;
  }
  if (!given("PPCLMCV"))
  {
    PPCLMCV = PPCLM;
  }
  if (!given("LPDIBL1R"))
  {
    LPDIBL1R = LPDIBL1;
  }
  if (!given("NPDIBL1R"))
  {
    NPDIBL1R = NPDIBL1;
  }
  if (!given("PPDIBL1R"))
  {
    PPDIBL1R = PPDIBL1;
  }
  if (!given("LPDIBL2R"))
  {
    LPDIBL2R = LPDIBL2;
  }
  if (!given("NPDIBL2R"))
  {
    NPDIBL2R = NPDIBL2;
  }
  if (!given("PPDIBL2R"))
  {
    PPDIBL2R = PPDIBL2;
  }
  if (!given("LAIGD"))
  {
    LAIGD = LAIGS;
  }
  if (!given("NAIGD"))
  {
    NAIGD = NAIGS;
  }
  if (!given("PAIGD"))
  {
    PAIGD = PAIGS;
  }
  if (!given("LAIGD1"))
  {
    LAIGD1 = LAIGS1;
  }
  if (!given("NAIGD1"))
  {
    NAIGD1 = NAIGS1;
  }
  if (!given("PAIGD1"))
  {
    PAIGD1 = PAIGS1;
  }
  if (!given("LBIGD"))
  {
    LBIGD = LBIGS;
  }
  if (!given("NBIGD"))
  {
    NBIGD = NBIGS;
  }
  if (!given("PBIGD"))
  {
    PBIGD = PBIGS;
  }
  if (!given("LCIGD"))
  {
    LCIGD = LCIGS;
  }
  if (!given("NCIGD"))
  {
    NCIGD = NCIGS;
  }
  if (!given("PCIGD"))
  {
    PCIGD = PCIGS;
  }
  if (!given("LAGIDL"))
  {
    LAGIDL = LAGISL;
  }
  if (!given("NAGIDL"))
  {
    NAGIDL = NAGISL;
  }
  if (!given("PAGIDL"))
  {
    PAGIDL = PAGISL;
  }
  if (!given("LBGIDL"))
  {
    LBGIDL = LBGISL;
  }
  if (!given("NBGIDL"))
  {
    NBGIDL = NBGISL;
  }
  if (!given("PBGIDL"))
  {
    PBGIDL = PBGISL;
  }
  if (!given("LCGIDL"))
  {
    LCGIDL = LCGISL;
  }
  if (!given("NCGIDL"))
  {
    NCGIDL = NCGISL;
  }
  if (!given("PCGIDL"))
  {
    PCGIDL = PCGISL;
  }
  if (!given("LEGIDL"))
  {
    LEGIDL = LEGISL;
  }
  if (!given("NEGIDL"))
  {
    NEGIDL = NEGISL;
  }
  if (!given("PEGIDL"))
  {
    PEGIDL = PEGISL;
  }
  if (!given("LPGIDL"))
  {
    LPGIDL = LPGISL;
  }
  if (!given("NPGIDL"))
  {
    NPGIDL = NPGISL;
  }
  if (!given("PPGIDL"))
  {
    PPGIDL = PPGISL;
  }
  if (!given("LCFD"))
  {
    LCFD = LCFS;
  }
  if (!given("NCFD"))
  {
    NCFD = NCFS;
  }
  if (!given("PCFD"))
  {
    PCFD = PCFS;
  }
  if (!given("LCOVD"))
  {
    LCOVD = LCOVS;
  }
  if (!given("NCOVD"))
  {
    NCOVD = NCOVS;
  }
  if (!given("PCOVD"))
  {
    PCOVD = PCOVS;
  }
  if (!given("LCGDL"))
  {
    LCGDL = LCGSL;
  }
  if (!given("NCGDL"))
  {
    NCGDL = NCGSL;
  }
  if (!given("PCGDL"))
  {
    PCGDL = PCGSL;
  }
  if (!given("LCKAPPAD"))
  {
    LCKAPPAD = LCKAPPAS;
  }
  if (!given("NCKAPPAD"))
  {
    NCKAPPAD = NCKAPPAS;
  }
  if (!given("PCKAPPAD"))
  {
    PCKAPPAD = PCKAPPAS;
  }
  if (!given("LUTER"))
  {
    LUTER = LUTE;
  }
  if (!given("NUTER"))
  {
    NUTER = NUTE;
  }
  if (!given("PUTER"))
  {
    PUTER = PUTE;
  }
  if (!given("LUTLR"))
  {
    LUTLR = LUTL;
  }
  if (!given("NUTLR"))
  {
    NUTLR = NUTL;
  }
  if (!given("PUTLR"))
  {
    PUTLR = PUTL;
  }
  if (!given("LUA1R"))
  {
    LUA1R = LUA1;
  }
  if (!given("NUA1R"))
  {
    NUA1R = NUA1;
  }
  if (!given("PUA1R"))
  {
    PUA1R = PUA1;
  }
  if (!given("LUC1R"))
  {
    LUC1R = LUC1;
  }
  if (!given("NUC1R"))
  {
    NUC1R = NUC1;
  }
  if (!given("PUC1R"))
  {
    PUC1R = PUC1;
  }
  if (!given("LUD1R"))
  {
    LUD1R = LUD1;
  }
  if (!given("NUD1R"))
  {
    NUD1R = NUD1;
  }
  if (!given("PUD1R"))
  {
    PUD1R = PUD1;
  }
  if (!given("LATR"))
  {
    LATR = LAT;
  }
  if (!given("NATR"))
  {
    NATR = NAT;
  }
  if (!given("PATR"))
  {
    PATR = PAT;
  }



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter L : [ 1.0e-9,  (+inf) [
  if ( (!((L >=1.0e-9))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter L value " << L << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter D : [ 1.0e-9,  (+inf) [
  if ( (!((D >=1.0e-9))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter D value " << D << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter TFIN : [ 1.0e-9,  (+inf) [
  if ( (!((TFIN >=1.0e-9))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter TFIN value " << TFIN << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter FPITCH : [ TFIN,  (+inf) [
  if ( (!((FPITCH >=TFIN))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter FPITCH value " << FPITCH << " out of range [ TFIN,  (+inf) [";
  }

  //    Parameter NF : [ 1,  (+inf) [
  if ( (!((NF >=1))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NF value " << NF << " out of range [ 1,  (+inf) [";
  }

  //    Parameter NFIN : ] 0,  (+inf) [
  if ( (!((NFIN >0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NFIN value " << NFIN << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NGCON : [ 1, 2 ]
  if ( (!((NGCON >=1 && NGCON <=2 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NGCON value " << NGCON << " out of range [ 1, 2 ]";
  }

  //    Parameter ASEO : [ 0,  (+inf) [
  if ( (!((ASEO >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ASEO value " << ASEO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ADEO : [ 0,  (+inf) [
  if ( (!((ADEO >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ADEO value " << ADEO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PSEO : [ 0,  (+inf) [
  if ( (!((PSEO >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter PSEO value " << PSEO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PDEO : [ 0,  (+inf) [
  if ( (!((PDEO >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter PDEO value " << PDEO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ASEJ : [ 0,  (+inf) [
  if ( (!((ASEJ >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ASEJ value " << ASEJ << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ADEJ : [ 0,  (+inf) [
  if ( (!((ADEJ >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ADEJ value " << ADEJ << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PSEJ : [ 0,  (+inf) [
  if ( (!((PSEJ >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter PSEJ value " << PSEJ << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PDEJ : [ 0,  (+inf) [
  if ( (!((PDEJ >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter PDEJ value " << PDEJ << " out of range [ 0,  (+inf) [";
  }

  //    Parameter COVS : [ 0,  (+inf) [
  if ( (!((COVS >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter COVS value " << COVS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter COVD : [ 0,  (+inf) [
  if ( (!((COVD >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter COVD value " << COVD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CGSP : [ 0,  (+inf) [
  if ( (!((CGSP >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CGSP value " << CGSP << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CGDP : [ 0,  (+inf) [
  if ( (!((CGDP >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CGDP value " << CGDP << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CDSP : [ 0,  (+inf) [
  if ( (!((CDSP >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CDSP value " << CDSP << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NRS : [ 0,  (+inf) [
  if ( (!((NRS >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NRS value " << NRS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NRD : [ 0,  (+inf) [
  if ( (!((NRD >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NRD value " << NRD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter LRSD : ] 0,  (+inf) [
  if ( (!((LRSD >0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter LRSD value " << LRSD << " out of range ] 0,  (+inf) [";
  }

  //    Parameter U0MULT : [ 0,  (+inf) [
  if ( (!((U0MULT >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter U0MULT value " << U0MULT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter IDS0MULT : [ 0,  (+inf) [
  if ( (!((IDS0MULT >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter IDS0MULT value " << IDS0MULT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter DEVTYPE : [ 0, 1 ]
  if ( (!((DEVTYPE >=0 && DEVTYPE <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter DEVTYPE value " << DEVTYPE << " out of range [ 0, 1 ]";
  }

  //    Parameter TYPE : [ 0, 1 ]
  if ( (!((TYPE >=0 && TYPE <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter TYPE value " << TYPE << " out of range [ 0, 1 ]";
  }

  //    Parameter BULKMOD : [ 0, 2 ]
  if ( (!((BULKMOD >=0 && BULKMOD <=2 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BULKMOD value " << BULKMOD << " out of range [ 0, 2 ]";
  }

  //    Parameter GEOMOD : [ 0, 4 ]
  if ( (!((GEOMOD >=0 && GEOMOD <=4 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter GEOMOD value " << GEOMOD << " out of range [ 0, 4 ]";
  }

  //    Parameter CGEO1SW : [ 0, 1 ]
  if ( (!((CGEO1SW >=0 && CGEO1SW <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CGEO1SW value " << CGEO1SW << " out of range [ 0, 1 ]";
  }

  //    Parameter RDSMOD : [ 0, 2 ]
  if ( (!((RDSMOD >=0 && RDSMOD <=2 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter RDSMOD value " << RDSMOD << " out of range [ 0, 2 ]";
  }

  //    Parameter ASYMMOD : [ 0, 1 ]
  if ( (!((ASYMMOD >=0 && ASYMMOD <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ASYMMOD value " << ASYMMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter IGCMOD : [ 0, 1 ]
  if ( (!((IGCMOD >=0 && IGCMOD <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter IGCMOD value " << IGCMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter IGBMOD : [ 0, 1 ]
  if ( (!((IGBMOD >=0 && IGBMOD <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter IGBMOD value " << IGBMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter GIDLMOD : [ 0, 1 ]
  if ( (!((GIDLMOD >=0 && GIDLMOD <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter GIDLMOD value " << GIDLMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter IIMOD : [ 0, 2 ]
  if ( (!((IIMOD >=0 && IIMOD <=2 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter IIMOD value " << IIMOD << " out of range [ 0, 2 ]";
  }

  //    Parameter TNOIMOD : [ 0, 1 ]
  if ( (!((TNOIMOD >=0 && TNOIMOD <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter TNOIMOD value " << TNOIMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter NQSMOD : [ 0, 2 ]
  if ( (!((NQSMOD >=0 && NQSMOD <=2 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NQSMOD value " << NQSMOD << " out of range [ 0, 2 ]";
  }

  //    Parameter SHMOD : [ 0, 1 ]
  if ( (!((SHMOD >=0 && SHMOD <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter SHMOD value " << SHMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter TEMPMOD : [ 0, 1 ]
  if ( (!((TEMPMOD >=0 && TEMPMOD <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter TEMPMOD value " << TEMPMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter RGATEMOD : [ 0, 1 ]
  if ( (!((RGATEMOD >=0 && RGATEMOD <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter RGATEMOD value " << RGATEMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter RGEOMOD : [ 0, 1 ]
  if ( (!((RGEOMOD >=0 && RGEOMOD <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter RGEOMOD value " << RGEOMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter CGEOMOD : [ 0, 2 ]
  if ( (!((CGEOMOD >=0 && CGEOMOD <=2 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CGEOMOD value " << CGEOMOD << " out of range [ 0, 2 ]";
  }

  //    Parameter SH_WARN : [ 0, 1 ]
  if ( (!((SH_WARN >=0 && SH_WARN <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter SH_WARN value " << SH_WARN << " out of range [ 0, 1 ]";
  }

  //    Parameter IGCLAMP : [ 0, 1 ]
  if ( (!((IGCLAMP >=0 && IGCLAMP <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter IGCLAMP value " << IGCLAMP << " out of range [ 0, 1 ]";
  }

  //    Parameter EOT : [ 1.0e-10,  (+inf) [
  if ( (!((EOT >=1.0e-10))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter EOT value " << EOT << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter TOXP : [ 1.0e-10,  (+inf) [
  if ( (!((TOXP >=1.0e-10))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter TOXP value " << TOXP << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter EOTBOX : [ 1.0e-9,  (+inf) [
  if ( (!((EOTBOX >=1.0e-9))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter EOTBOX value " << EOTBOX << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter HFIN : [ 1.0e-9,  (+inf) [
  if ( (!((HFIN >=1.0e-9))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter HFIN value " << HFIN << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter FECH : [ 0,  (+inf) [
  if ( (!((FECH >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter FECH value " << FECH << " out of range [ 0,  (+inf) [";
  }

  //    Parameter FECHCV : [ 0,  (+inf) [
  if ( (!((FECHCV >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter FECHCV value " << FECHCV << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NBODYN2 : ] 0.0, 0.0 [
  if ( ((NBODYN2 >0.0 && NBODYN2 <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NBODYN2 value " << NBODYN2 << "  ] 0.0, 0.0 [";
  }

  //    Parameter NSD : [ 2.0e25, 1.0e27 ]
  if ( (!((NSD >=2.0e25 && NSD <=1.0e27 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NSD value " << NSD << " out of range [ 2.0e25, 1.0e27 ]";
  }

  //    Parameter PHIG : [ 0,  (+inf) [
  if ( (!((PHIG >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter PHIG value " << PHIG << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PHIGN2 : ] 0.0, 0.0 [
  if ( ((PHIGN2 >0.0 && PHIGN2 <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter PHIGN2 value " << PHIGN2 << "  ] 0.0, 0.0 [";
  }

  //    Parameter EPSROX : [ 1.0,  (+inf) [
  if ( (!((EPSROX >=1.0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter EPSROX value " << EPSROX << " out of range [ 1.0,  (+inf) [";
  }

  //    Parameter EPSRSUB : [ 1.0,  (+inf) [
  if ( (!((EPSRSUB >=1.0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter EPSRSUB value " << EPSRSUB << " out of range [ 1.0,  (+inf) [";
  }

  //    Parameter EASUB : [ 0,  (+inf) [
  if ( (!((EASUB >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter EASUB value " << EASUB << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CDSCDN2 : ] 0.0, 0.0 [
  if ( ((CDSCDN2 >0.0 && CDSCDN2 <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CDSCDN2 value " << CDSCDN2 << "  ] 0.0, 0.0 [";
  }

  //    Parameter CDSCDRN2 : ] 0.0, 0.0 [
  if ( ((CDSCDRN2 >0.0 && CDSCDRN2 <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CDSCDRN2 value " << CDSCDRN2 << "  ] 0.0, 0.0 [";
  }

  //    Parameter ETA0N2 : [ 1.0e-5,  (+inf) [
  if ( (!((ETA0N2 >=1.0e-5))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ETA0N2 value " << ETA0N2 << " out of range [ 1.0e-5,  (+inf) [";
  }

  //    Parameter BDVTP0 : ] 0.0, 0.0 [
  if ( ((BDVTP0 >0.0 && BDVTP0 <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BDVTP0 value " << BDVTP0 << "  ] 0.0, 0.0 [";
  }

  //    Parameter BDVTP1 : ] 0.0, 0.0 [
  if ( ((BDVTP1 >0.0 && BDVTP1 <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BDVTP1 value " << BDVTP1 << "  ] 0.0, 0.0 [";
  }

  //    Parameter K1 : [ 1.0e-6,  (+inf) [
  if ( (!((K1 >=1.0e-6))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter K1 value " << K1 << " out of range [ 1.0e-6,  (+inf) [";
  }

  //    Parameter BQMTCEN : ] 0.0, 0.0 [
  if ( ((BQMTCEN >0.0 && BQMTCEN <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BQMTCEN value " << BQMTCEN << "  ] 0.0, 0.0 [";
  }

  //    Parameter VSATN2 : ] 0.0, 0.0 [
  if ( ((VSATN2 >0.0 && VSATN2 <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter VSATN2 value " << VSATN2 << "  ] 0.0, 0.0 [";
  }

  //    Parameter VSATRN2 : ] 0.0, 0.0 [
  if ( ((VSATRN2 >0.0 && VSATRN2 <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter VSATRN2 value " << VSATRN2 << "  ] 0.0, 0.0 [";
  }

  //    Parameter BVSAT : ] 0.0, 0.0 [
  if ( ((BVSAT >0.0 && BVSAT <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BVSAT value " << BVSAT << "  ] 0.0, 0.0 [";
  }

  //    Parameter VSAT1N2 : ] 0.0, 0.0 [
  if ( ((VSAT1N2 >0.0 && VSAT1N2 <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter VSAT1N2 value " << VSAT1N2 << "  ] 0.0, 0.0 [";
  }

  //    Parameter VSAT1RN2 : ] 0.0, 0.0 [
  if ( ((VSAT1RN2 >0.0 && VSAT1RN2 <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter VSAT1RN2 value " << VSAT1RN2 << "  ] 0.0, 0.0 [";
  }

  //    Parameter BVSAT1 : ] 0.0, 0.0 [
  if ( ((BVSAT1 >0.0 && BVSAT1 <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BVSAT1 value " << BVSAT1 << "  ] 0.0, 0.0 [";
  }

  //    Parameter BPSAT : ] 0.0, 0.0 [
  if ( ((BPSAT >0.0 && BPSAT <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BPSAT value " << BPSAT << "  ] 0.0, 0.0 [";
  }

  //    Parameter BVSATCV : ] 0.0, 0.0 [
  if ( ((BVSATCV >0.0 && BVSATCV <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BVSATCV value " << BVSATCV << "  ] 0.0, 0.0 [";
  }

  //    Parameter BPSATCV : ] 0.0, 0.0 [
  if ( ((BPSATCV >0.0 && BPSATCV <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BPSATCV value " << BPSATCV << "  ] 0.0, 0.0 [";
  }

  //    Parameter BPTWG : ] 0.0, 0.0 [
  if ( ((BPTWG >0.0 && BPTWG <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BPTWG value " << BPTWG << "  ] 0.0, 0.0 [";
  }

  //    Parameter U0N2 : ] 0.0, 0.0 [
  if ( ((U0N2 >0.0 && U0N2 <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter U0N2 value " << U0N2 << "  ] 0.0, 0.0 [";
  }

  //    Parameter U0N2R : ] 0.0, 0.0 [
  if ( ((U0N2R >0.0 && U0N2R <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter U0N2R value " << U0N2R << "  ] 0.0, 0.0 [";
  }

  //    Parameter BUA : ] 0.0, 0.0 [
  if ( ((BUA >0.0 && BUA <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BUA value " << BUA << "  ] 0.0, 0.0 [";
  }

  //    Parameter BUAR : ] 0.0, 0.0 [
  if ( ((BUAR >0.0 && BUAR <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BUAR value " << BUAR << "  ] 0.0, 0.0 [";
  }

  //    Parameter BEU : ] 0.0, 0.0 [
  if ( ((BEU >0.0 && BEU <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BEU value " << BEU << "  ] 0.0, 0.0 [";
  }

  //    Parameter BEUR : ] 0.0, 0.0 [
  if ( ((BEUR >0.0 && BEUR <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BEUR value " << BEUR << "  ] 0.0, 0.0 [";
  }

  //    Parameter BUD : ] 0.0, 0.0 [
  if ( ((BUD >0.0 && BUD <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BUD value " << BUD << "  ] 0.0, 0.0 [";
  }

  //    Parameter BUDR : ] 0.0, 0.0 [
  if ( ((BUDR >0.0 && BUDR <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BUDR value " << BUDR << "  ] 0.0, 0.0 [";
  }

  //    Parameter CHARGEWF : [ (-1.0), 1.0 ]
  if ( (!((CHARGEWF >=(-1.0) && CHARGEWF <=1.0 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CHARGEWF value " << CHARGEWF << " out of range [ (-1.0), 1.0 ]";
  }

  //    Parameter BRDSW : ] 0.0, 0.0 [
  if ( ((BRDSW >0.0 && BRDSW <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BRDSW value " << BRDSW << "  ] 0.0, 0.0 [";
  }

  //    Parameter BRSW : ] 0.0, 0.0 [
  if ( ((BRSW >0.0 && BRSW <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BRSW value " << BRSW << "  ] 0.0, 0.0 [";
  }

  //    Parameter BRDW : ] 0.0, 0.0 [
  if ( ((BRDW >0.0 && BRDW <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BRDW value " << BRDW << "  ] 0.0, 0.0 [";
  }

  //    Parameter RSDR : [ 0,  (+inf) [
  if ( (!((RSDR >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter RSDR value " << RSDR << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RSDRR : [ 0,  (+inf) [
  if ( (!((RSDRR >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter RSDRR value " << RSDRR << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RDDR : [ 0,  (+inf) [
  if ( (!((RDDR >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter RDDR value " << RDDR << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RDDRR : [ 0,  (+inf) [
  if ( (!((RDDRR >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter RDDRR value " << RDDRR << " out of range [ 0,  (+inf) [";
  }

  //    Parameter BPCLM : ] 0.0, 0.0 [
  if ( ((BPCLM >0.0 && BPCLM <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BPCLM value " << BPCLM << "  ] 0.0, 0.0 [";
  }

  //    Parameter BPCLMR : ] 0.0, 0.0 [
  if ( ((BPCLMR >0.0 && BPCLMR <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BPCLMR value " << BPCLMR << "  ] 0.0, 0.0 [";
  }

  //    Parameter RGEXT : [ 0,  (+inf) [
  if ( (!((RGEXT >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter RGEXT value " << RGEXT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RGFIN : [ 1.0e-3,  (+inf) [
  if ( (!((RGFIN >=1.0e-3))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter RGFIN value " << RGFIN << " out of range [ 1.0e-3,  (+inf) [";
  }

  //    Parameter RHOC : [ 1.0e-18, 1.0e-9 ]
  if ( (!((RHOC >=1.0e-18 && RHOC <=1.0e-9 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter RHOC value " << RHOC << " out of range [ 1.0e-18, 1.0e-9 ]";
  }

  //    Parameter RHORSD : ] 0,  (+inf) [
  if ( (!((RHORSD >0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter RHORSD value " << RHORSD << " out of range ] 0,  (+inf) [";
  }

  //    Parameter CRATIO : [ 0.0, 1.0 ]
  if ( (!((CRATIO >=0.0 && CRATIO <=1.0 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CRATIO value " << CRATIO << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter DELTAPRSD : ] (-FPITCH),  (+inf) [
  if ( (!((DELTAPRSD >(-FPITCH)))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter DELTAPRSD value " << DELTAPRSD << " out of range ] (-FPITCH),  (+inf) [";
  }

  //    Parameter SDTERM : [ 0, 1 ]
  if ( (!((SDTERM >=0 && SDTERM <=1 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter SDTERM value " << SDTERM << " out of range [ 0, 1 ]";
  }

  //    Parameter EPSRSP : [ 1.0,  (+inf) [
  if ( (!((EPSRSP >=1.0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter EPSRSP value " << EPSRSP << " out of range [ 1.0,  (+inf) [";
  }

  //    Parameter TGATE : ] 0,  (+inf) [
  if ( (!((TGATE >0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter TGATE value " << TGATE << " out of range ] 0,  (+inf) [";
  }

  //    Parameter TMASK : [ 0,  (+inf) [
  if ( (!((TMASK >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter TMASK value " << TMASK << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ASILIEND : [ 0,  (+inf) [
  if ( (!((ASILIEND >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ASILIEND value " << ASILIEND << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ARSDEND : [ 0,  (+inf) [
  if ( (!((ARSDEND >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ARSDEND value " << ARSDEND << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PRSDEND : [ 0,  (+inf) [
  if ( (!((PRSDEND >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter PRSDEND value " << PRSDEND << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NSDE : [ 1.0e25, 1.0e26 ]
  if ( (!((NSDE >=1.0e25 && NSDE <=1.0e26 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NSDE value " << NSDE << " out of range [ 1.0e25, 1.0e26 ]";
  }

  //    Parameter CGEOE : [ 0,  (+inf) [
  if ( (!((CGEOE >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CGEOE value " << CGEOE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter TOXREF : ] 0,  (+inf) [
  if ( (!((TOXREF >0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter TOXREF value " << TOXREF << " out of range ] 0,  (+inf) [";
  }

  //    Parameter IIMOD2CLAMP1 : ] 0.0,  (+inf) [
  if ( (!((IIMOD2CLAMP1 >0.0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter IIMOD2CLAMP1 value " << IIMOD2CLAMP1 << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter IIMOD2CLAMP2 : ] 0.0,  (+inf) [
  if ( (!((IIMOD2CLAMP2 >0.0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter IIMOD2CLAMP2 value " << IIMOD2CLAMP2 << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter IIMOD2CLAMP3 : ] 0.0,  (+inf) [
  if ( (!((IIMOD2CLAMP3 >0.0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter IIMOD2CLAMP3 value " << IIMOD2CLAMP3 << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter EOTACC : [ 1.0e-10,  (+inf) [
  if ( (!((EOTACC >=1.0e-10))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter EOTACC value " << EOTACC << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter CFS : [ 0,  (+inf) [
  if ( (!((CFS >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CFS value " << CFS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CFD : [ 0,  (+inf) [
  if ( (!((CFD >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CFD value " << CFD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CGSO : [ 0,  (+inf) [
  if ( (!((CGSO >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CGSO value " << CGSO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CGDO : [ 0,  (+inf) [
  if ( (!((CGDO >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CGDO value " << CGDO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CGSL : [ 0,  (+inf) [
  if ( (!((CGSL >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CGSL value " << CGSL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CGDL : [ 0,  (+inf) [
  if ( (!((CGDL >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CGDL value " << CGDL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CKAPPAS : [ 2.0e-2,  (+inf) [
  if ( (!((CKAPPAS >=2.0e-2))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CKAPPAS value " << CKAPPAS << " out of range [ 2.0e-2,  (+inf) [";
  }

  //    Parameter CKAPPAD : [ 2.0e-2,  (+inf) [
  if ( (!((CKAPPAD >=2.0e-2))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CKAPPAD value " << CKAPPAD << " out of range [ 2.0e-2,  (+inf) [";
  }

  //    Parameter CGBO : [ 0,  (+inf) [
  if ( (!((CGBO >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CGBO value " << CGBO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CGBN : [ 0,  (+inf) [
  if ( (!((CGBN >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CGBN value " << CGBN << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CGBL : [ 0,  (+inf) [
  if ( (!((CGBL >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CGBL value " << CGBL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CKAPPAB : [ 2.0e-2,  (+inf) [
  if ( (!((CKAPPAB >=2.0e-2))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CKAPPAB value " << CKAPPAB << " out of range [ 2.0e-2,  (+inf) [";
  }

  //    Parameter CSDESW : [ 0,  (+inf) [
  if ( (!((CSDESW >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CSDESW value " << CSDESW << " out of range [ 0,  (+inf) [";
  }

  //    Parameter SJS : [ 0,  (+inf) [
  if ( (!((SJS >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter SJS value " << SJS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter SJD : [ 0,  (+inf) [
  if ( (!((SJD >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter SJD value " << SJD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter SJSWS : [ 0,  (+inf) [
  if ( (!((SJSWS >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter SJSWS value " << SJSWS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter SJSWD : [ 0,  (+inf) [
  if ( (!((SJSWD >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter SJSWD value " << SJSWD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter SJSWGS : [ 0,  (+inf) [
  if ( (!((SJSWGS >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter SJSWGS value " << SJSWGS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter SJSWGD : [ 0,  (+inf) [
  if ( (!((SJSWGD >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter SJSWGD value " << SJSWGD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NJS : ] 0.0, 0.0 [
  if ( ((NJS >0.0 && NJS <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NJS value " << NJS << "  ] 0.0, 0.0 [";
  }

  //    Parameter NJD : ] 0.0, 0.0 [
  if ( ((NJD >0.0 && NJD <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NJD value " << NJD << "  ] 0.0, 0.0 [";
  }

  //    Parameter NSEG : [ 4, 10 ]
  if ( (!((NSEG >=4 && NSEG <=10 ))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NSEG value " << NSEG << " out of range [ 4, 10 ]";
  }

  //    Parameter NTNOI : [ 0,  (+inf) [
  if ( (!((NTNOI >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter NTNOI value " << NTNOI << " out of range [ 0,  (+inf) [";
  }

  //    Parameter SCALEN : ] 0.0, 0.0 [
  if ( ((SCALEN >0.0 && SCALEN <0.0 )) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter SCALEN value " << SCALEN << "  ] 0.0, 0.0 [";
  }

  //    Parameter TNOM : [ (-273.15),  (+inf) [
  if ( (!((TNOM >=(-273.15)))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter TNOM value " << TNOM << " out of range [ (-273.15),  (+inf) [";
  }

  //    Parameter RTH0 : [ 0,  (+inf) [
  if ( (!((RTH0 >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter RTH0 value " << RTH0 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CTH0 : [ 0,  (+inf) [
  if ( (!((CTH0 >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CTH0 value " << CTH0 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter WTH0 : [ 0,  (+inf) [
  if ( (!((WTH0 >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter WTH0 value " << WTH0 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ASHEXP : [ 0,  (+inf) [
  if ( (!((ASHEXP >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ASHEXP value " << ASHEXP << " out of range [ 0,  (+inf) [";
  }

  //    Parameter BSHEXP : [ 0,  (+inf) [
  if ( (!((BSHEXP >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter BSHEXP value " << BSHEXP << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ACH_UFCM : ] 0,  (+inf) [
  if ( (!((ACH_UFCM >0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ACH_UFCM value " << ACH_UFCM << " out of range ] 0,  (+inf) [";
  }

  //    Parameter CINS_UFCM : ] 0,  (+inf) [
  if ( (!((CINS_UFCM >0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter CINS_UFCM value " << CINS_UFCM << " out of range ] 0,  (+inf) [";
  }

  //    Parameter W_UFCM : ] 0,  (+inf) [
  if ( (!((W_UFCM >0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter W_UFCM value " << W_UFCM << " out of range ] 0,  (+inf) [";
  }

  //    Parameter TFIN_TOP : [ 0,  (+inf) [
  if ( (!((TFIN_TOP >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter TFIN_TOP value " << TFIN_TOP << " out of range [ 0,  (+inf) [";
  }

  //    Parameter TFIN_BASE : [ 1.0e-9,  (+inf) [
  if ( (!((TFIN_BASE >=1.0e-9))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter TFIN_BASE value " << TFIN_BASE << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter QMFACTORCV : [ 0,  (+inf) [
  if ( (!((QMFACTORCV >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter QMFACTORCV value " << QMFACTORCV << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ALPHA_UFCM : [ 0,  (+inf) [
  if ( (!((ALPHA_UFCM >=0))) )
  {
    UserError0(*this) << "ADMSbsimcmg_110: Parameter ALPHA_UFCM value " << ALPHA_UFCM << " out of range [ 0,  (+inf) [";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
   const Configuration & configuration,
   const ModelBlock &    model_block,
   const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    L(3.0e-8),
    D(4.0e-8),
    TFIN(1.5e-8),
    FPITCH(8.0e-8),
    NF(1),
    NFIN(1.0),
    NGCON(1),
    ASEO(0.0),
    ADEO(0.0),
    PSEO(0.0),
    PDEO(0.0),
    ASEJ(0.0),
    ADEJ(0.0),
    PSEJ(0.0),
    PDEJ(0.0),
    COVS(0.0),
    COVD(0.0),
    CGSP(0.0),
    CGDP(0.0),
    CDSP(0.0),
    NRS(0.0),
    NRD(0.0),
    LRSD(0.0),
    XL(0.0),
    DTEMP(0.0),
    DELVTRAND(0.0),
    U0MULT(1.0),
    IDS0MULT(1.0),
    DEVTYPE(1),
    TYPE(0),
    BULKMOD(0),
    GEOMOD(0),
    CGEO1SW(0),
    RDSMOD(0),
    ASYMMOD(0),
    IGCMOD(0),
    IGBMOD(0),
    GIDLMOD(0),
    IIMOD(0),
    TNOIMOD(0),
    NQSMOD(0),
    SHMOD(0),
    TEMPMOD(0),
    RGATEMOD(0),
    RGEOMOD(0),
    CGEOMOD(0),
    SH_WARN(0),
    IGCLAMP(1),
    LINT(0.0),
    LL(0.0),
    LLN(1.0),
    DLC(0.0),
    DLCACC(0.0),
    DLBIN(0.0),
    LLC(0.0),
    EOT(1.0e-9),
    TOXP(1.2e-9),
    EOTBOX(1.4e-7),
    HFIN(3.0e-8),
    FECH(1.0),
    DELTAW(0.0),
    FECHCV(1.0),
    DELTAWCV(0.0),
    NBODY(1.0e22),
    NBODYN1(0.0),
    NBODYN2(1.0e5),
    NSD(2.0e26),
    PHIG(4.61),
    PHIGL(0.0),
    PHIGLT(0.0),
    PHIGN1(0.0),
    PHIGN2(1.0e5),
    EPSROX(3.9),
    EPSRSUB(11.9),
    EASUB(4.05),
    NI0SUB(1.1e16),
    BG0SUB(1.12),
    NC0SUB(2.86e25),
    NGATE(0.0),
    Imin(1.0e-15),
    CIT(0.0),
    CITR(0.0),
    CDSC(7.0e-3),
    CDSCN1(0.0),
    CDSCN2(1.0e5),
    CDSCD(7.0e-3),
    CDSCDN1(0.0),
    CDSCDN2(1.0e5),
    CDSCDR(0.0),
    CDSCDRN1(0.0),
    CDSCDRN2(0.0),
    DVT0(0.0),
    DVT1(0.6),
    DVT1SS(0.0),
    PHIN(0.05),
    ETA0(0.6),
    ETA0N1(0.0),
    ETA0N2(1.0e5),
    ETA0LT(0.0),
    TETA0(0.0),
    ETA0R(0.0),
    TETA0R(0.0),
    DSUB(1.06),
    DVTP0(0.0),
    DVTP1(0.0),
    ADVTP0(0.0),
    BDVTP0(1.0e-7),
    ADVTP1(0.0),
    BDVTP1(1.0e-7),
    DVTP2(0.0),
    K1RSCE(0.0),
    LPE0(5.0e-9),
    DVTSHIFT(0.0),
    DVTSHIFTR(0.0),
    THETASCE(0.0),
    THETADIBL(0.0),
    THETASW(0.0),
    NVTM(0.0),
    K0(0.0),
    K01(0.0),
    K0SI(1.0),
    K0SI1(0.0),
    K2SI(0.0),
    K2SI1(0.0),
    K0SISAT(0.0),
    K0SISAT1(0.0),
    K2SISAT(0.0),
    K2SISAT1(0.0),
    PHIBE(0.7),
    K1(1.0e-6),
    K11(0.0),
    K2SAT(0.0),
    K2SAT1(0.0),
    K2(0.0),
    K21(0.0),
    QMFACTOR(0.0),
    QMTCENCV(0.0),
    QMTCENCVA(0.0),
    AQMTCEN(0.0),
    BQMTCEN(1.2e-8),
    ETAQM(0.54),
    QM0(1.0e-3),
    PQM(0.66),
    QM0ACC(1.0e-3),
    PQMACC(0.66),
    VSAT(8.5e4),
    VSATR(0.0),
    VSATN1(0.0),
    VSATN2(1.0e5),
    VSATRN1(0.0),
    VSATRN2(0.0),
    AVSAT(0.0),
    BVSAT(1.0e-7),
    VSAT1(0.0),
    VSAT1N1(0.0),
    VSAT1N2(0.0),
    VSAT1R(0.0),
    VSAT1RN1(0.0),
    VSAT1RN2(0.0),
    AVSAT1(0.0),
    BVSAT1(0.0),
    DELTAVSAT(1.0),
    PSAT(2.0),
    APSAT(0.0),
    BPSAT(1.0),
    KSATIV(1.0),
    KSATIVR(0.0),
    VSATCV(0.0),
    AVSATCV(0.0),
    BVSATCV(0.0),
    DELTAVSATCV(0.0),
    PSATCV(0.0),
    APSATCV(0.0),
    BPSATCV(0.0),
    MEXP(4.0),
    AMEXP(0.0),
    BMEXP(1.0),
    MEXPR(0.0),
    AMEXPR(0.0),
    BMEXPR(0.0),
    PTWG(0.0),
    PTWGR(0.0),
    APTWG(0.0),
    BPTWG(1.0e-7),
    AT((-1.56e-3)),
    ATR(0.0),
    ATCV(0.0),
    TMEXP(0.0),
    TMEXPR(0.0),
    PTWGT(4.0e-3),
    U0(3.0e-2),
    U0R(0.0),
    U0N1(0.0),
    U0N1R(0.0),
    U0N2(1.0e5),
    U0N2R(0.0),
    U0LT(0.0),
    ETAMOB(2.0),
    UP(0.0),
    LPA(1.0),
    UPR(0.0),
    LPAR(0.0),
    UA(0.3),
    UAR(0.0),
    AUA(0.0),
    AUAR(0.0),
    BUA(1.0e-7),
    BUAR(0.0),
    UC(0.0),
    UCR(0.0),
    EU(2.5),
    EUR(0.0),
    AEU(0.0),
    AEUR(0.0),
    BEU(1.0e-7),
    BEUR(0.0),
    UD(0.0),
    UDR(0.0),
    AUD(0.0),
    AUDR(0.0),
    BUD(5.0e-8),
    BUDR(0.0),
    UCS(1.0),
    UTE(0.0),
    UTER(0.0),
    UTL((-1.5e-3)),
    UTLR(0.0),
    EMOBT(0.0),
    UA1(1.032e-3),
    UA1R(0.0),
    UC1(5.6e-11),
    UC1R(0.0),
    UD1(0.0),
    UD1R(0.0),
    UCSTE((-4.775e-3)),
    CHARGEWF(0.0),
    RDSWMIN(0.0),
    RDSW(1.0e2),
    ARDSW(0.0),
    BRDSW(1.0e-7),
    RSWMIN(0.0),
    RSW(5.0e1),
    ARSW(0.0),
    BRSW(1.0e-7),
    RDWMIN(0.0),
    RDW(5.0e1),
    ARDW(0.0),
    BRDW(1.0e-7),
    RSDR(0.0),
    RSDRR(0.0),
    RDDR(0.0),
    RDDRR(0.0),
    PRSDR(1.0),
    PRDDR(0.0),
    PRWGS(0.0),
    PRWGD(0.0),
    WR(1.0),
    PRT(1.0e-3),
    TRSDR(0.0),
    TRDDR(0.0),
    PDIBL1(1.3),
    PDIBL1R(0.0),
    PDIBL2(2.0e-4),
    PDIBL2R(0.0),
    DROUT(1.06),
    PVAG(1.0),
    PCLM(1.3e-2),
    PCLMR(0.0),
    APCLM(0.0),
    APCLMR(0.0),
    BPCLM(1.0e-7),
    BPCLMR(0.0),
    PCLMG(0.0),
    PCLMCV(0.0),
    A1(0.0),
    A11(0.0),
    A2(0.0),
    A21(0.0),
    RGEXT(0.0),
    RGFIN(1.0e-3),
    RSHS(0.0),
    RSHD(0.0),
    HEPI(1.0e-8),
    TSILI(1.0e-8),
    RHOC(1.0e-12),
    RHORSD(1.0),
    CRATIO(0.5),
    DELTAPRSD(0.0),
    SDTERM(0),
    LSP(0.0),
    EPSRSP(3.9),
    TGATE(3.0e-8),
    TMASK(3.0e-8),
    ASILIEND(0.0),
    ARSDEND(0.0),
    PRSDEND(0.0),
    NSDE(2.0e25),
    RGEOA(1.0),
    RGEOB(0.0),
    RGEOC(0.0),
    RGEOD(0.0),
    RGEOE(0.0),
    CGEOA(1.0),
    CGEOB(0.0),
    CGEOC(0.0),
    CGEOD(0.0),
    CGEOE(1.0),
    AIGBINV(1.11e-2),
    AIGBINV1(0.0),
    BIGBINV(9.49e-4),
    CIGBINV(6.0e-3),
    EIGBINV(1.1),
    NIGBINV(3.0),
    AIGBACC(1.36e-2),
    AIGBACC1(0.0),
    BIGBACC(1.71e-3),
    CIGBACC(7.5e-2),
    NIGBACC(1.0),
    AIGC(1.36e-2),
    AIGC1(0.0),
    BIGC(1.71e-3),
    CIGC(7.5e-2),
    PIGCD(1.0),
    DLCIGS(0.0),
    AIGS(1.36e-2),
    AIGS1(0.0),
    BIGS(1.71e-3),
    CIGS(7.5e-2),
    DLCIGD(0.0),
    AIGD(0.0),
    AIGD1(0.0),
    BIGD(0.0),
    CIGD(0.0),
    VFBSD(0.0),
    VFBSDCV(0.0),
    TOXREF(1.2e-9),
    TOXG(0.0),
    NTOX(1.0),
    POXEDGE(1.0),
    AGISL(6.055e-12),
    BGISL(3.0e8),
    CGISL(0.5),
    EGISL(0.2),
    PGISL(1.0),
    AGIDL(0.0),
    BGIDL(0.0),
    CGIDL(0.0),
    EGIDL(0.0),
    PGIDL(0.0),
    ALPHA0(0.0),
    ALPHA01(0.0),
    ALPHA1(0.0),
    ALPHA11(0.0),
    BETA0(0.0),
    ALPHAII0(0.0),
    ALPHAII01(0.0),
    ALPHAII1(0.0),
    ALPHAII11(0.0),
    BETAII0(0.0),
    BETAII1(0.0),
    BETAII2(0.1),
    ESATII(1.0e7),
    LII(0.5e-9),
    SII0(0.5),
    SII1(0.1),
    SII2(0.0),
    SIID(0.0),
    IIMOD2CLAMP1(0.1),
    IIMOD2CLAMP2(0.1),
    IIMOD2CLAMP3(0.1),
    EOTACC(0.0),
    DELVFBACC(0.0),
    CFS(2.5e-11),
    CFD(0.0),
    CGSO(0.0),
    CGDO(0.0),
    CGSL(0.0),
    CGDL(0.0),
    CKAPPAS(0.6),
    CKAPPAD(0.0),
    CGBO(0.0),
    CGBN(0.0),
    CGBL(0.0),
    CKAPPAB(0.6),
    CSDESW(0.0),
    CJS(5.0e-4),
    CJD(0.0),
    CJSWS(5.0e-10),
    CJSWD(0.0),
    CJSWGS(0.0),
    CJSWGD(0.0),
    PBS(1.0),
    PBD(0.0),
    PBSWS(1.0),
    PBSWD(0.0),
    PBSWGS(0.0),
    PBSWGD(0.0),
    MJS(0.5),
    MJD(0.0),
    MJSWS(0.33),
    MJSWD(0.0),
    MJSWGS(0.0),
    MJSWGD(0.0),
    SJS(0.0),
    SJD(0.0),
    SJSWS(0.0),
    SJSWD(0.0),
    SJSWGS(0.0),
    SJSWGD(0.0),
    MJS2(1.25e-1),
    MJD2(0.0),
    MJSWS2(8.3e-2),
    MJSWD2(0.0),
    MJSWGS2(0.0),
    MJSWGD2(0.0),
    JSS(1.0e-4),
    JSD(0.0),
    JSWS(0.0),
    JSWD(0.0),
    JSWGS(0.0),
    JSWGD(0.0),
    NJS(1.0),
    NJD(0.0),
    IJTHSFWD(0.1),
    IJTHDFWD(0.0),
    IJTHSREV(0.1),
    IJTHDREV(0.0),
    BVS(1.0e1),
    BVD(0.0),
    XJBVS(1.0),
    XJBVD(0.0),
    JTSS(0.0),
    JTSD(0.0),
    JTSSWS(0.0),
    JTSSWD(0.0),
    JTSSWGS(0.0),
    JTSSWGD(0.0),
    JTWEFF(0.0),
    NJTS(2.0e1),
    NJTSD(0.0),
    NJTSSW(2.0e1),
    NJTSSWD(0.0),
    NJTSSWG(2.0e1),
    NJTSSWGD(0.0),
    VTSS(1.0e1),
    VTSD(0.0),
    VTSSWS(1.0e1),
    VTSSWD(0.0),
    VTSSWGS(1.0e1),
    VTSSWGD(0.0),
    LINTIGEN(0.0),
    NTGEN(1.0),
    AIGEN(0.0),
    BIGEN(0.0),
    XRCRG1(1.2e1),
    XRCRG2(1.0),
    NSEG(4),
    EF(1.0),
    EM(4.1e7),
    NOIA(6.25e39),
    NOIB(3.125e24),
    NOIC(8.75e7),
    LINTNOI(0.0),
    NTNOI(1.0),
    TNOIA(1.5),
    TNOIB(3.5),
    RNOIA(5.77e-1),
    RNOIB(3.7e-1),
    TNOIC(3.5),
    RNOIC(3.95e-1),
    SCALEN(1.0e5),
    TNOM(27.0),
    TBGASUB(7.02e-4),
    TBGBSUB(1.108e3),
    KT1(0.0),
    KT1L(0.0),
    TSS(0.0),
    IIT((-0.5)),
    TII(0.0),
    TGIDL((-3.0e-3)),
    IGT(2.5),
    TCJ(0.0),
    TCJSW(0.0),
    TCJSWG(0.0),
    TPB(0.0),
    TPBSW(0.0),
    TPBSWG(0.0),
    XTIS(3.0),
    XTID(0.0),
    XTSS(2.0e-2),
    XTSD(0.0),
    XTSSWS(2.0e-2),
    XTSSWD(0.0),
    XTSSWGS(2.0e-2),
    XTSSWGD(0.0),
    TNJTS(0.0),
    TNJTSD(0.0),
    TNJTSSW(0.0),
    TNJTSSWD(0.0),
    TNJTSSWG(0.0),
    TNJTSSWGD(0.0),
    RTH0(1.0e-2),
    CTH0(1.0e-5),
    WTH0(0.0),
    ASHEXP(1.0),
    BSHEXP(1.0),
    ACH_UFCM(1.0),
    CINS_UFCM(1.0),
    W_UFCM(1.0),
    TFIN_TOP(1.5e-8),
    TFIN_BASE(1.5e-8),
    QMFACTORCV(0.0),
    ALPHA_UFCM(0.5556),
    LNBODY(0.0),
    NNBODY(0.0),
    PNBODY(0.0),
    LPHIG(0.0),
    NPHIG(0.0),
    PPHIG(0.0),
    LNGATE(0.0),
    NNGATE(0.0),
    PNGATE(0.0),
    LCIT(0.0),
    NCIT(0.0),
    PCIT(0.0),
    LCITR(0.0),
    NCITR(0.0),
    PCITR(0.0),
    LCDSC(0.0),
    NCDSC(0.0),
    PCDSC(0.0),
    LCDSCD(0.0),
    NCDSCD(0.0),
    PCDSCD(0.0),
    LCDSCDR(0.0),
    NCDSCDR(0.0),
    PCDSCDR(0.0),
    LDVT0(0.0),
    NDVT0(0.0),
    PDVT0(0.0),
    LDVT1(0.0),
    NDVT1(0.0),
    PDVT1(0.0),
    LDVT1SS(0.0),
    NDVT1SS(0.0),
    PDVT1SS(0.0),
    LPHIN(0.0),
    NPHIN(0.0),
    PPHIN(0.0),
    LETA0(0.0),
    NETA0(0.0),
    PETA0(0.0),
    LETA0R(0.0),
    NETA0R(0.0),
    PETA0R(0.0),
    LDSUB(0.0),
    NDSUB(0.0),
    PDSUB(0.0),
    LK1RSCE(0.0),
    NK1RSCE(0.0),
    PK1RSCE(0.0),
    LLPE0(0.0),
    NLPE0(0.0),
    PLPE0(0.0),
    LDVTSHIFT(0.0),
    NDVTSHIFT(0.0),
    PDVTSHIFT(0.0),
    LDVTSHIFTR(0.0),
    NDVTSHIFTR(0.0),
    PDVTSHIFTR(0.0),
    LPHIBE(0.0),
    NPHIBE(0.0),
    PPHIBE(0.0),
    LK0(0.0),
    NK0(0.0),
    PK0(0.0),
    LK01(0.0),
    NK01(0.0),
    PK01(0.0),
    LK0SI(0.0),
    NK0SI(0.0),
    PK0SI(0.0),
    LK0SI1(0.0),
    NK0SI1(0.0),
    PK0SI1(0.0),
    LK1(0.0),
    NK1(0.0),
    PK1(0.0),
    LK11(0.0),
    NK11(0.0),
    PK11(0.0),
    LK2SI(0.0),
    NK2SI(0.0),
    PK2SI(0.0),
    LK2SI1(0.0),
    NK2SI1(0.0),
    PK2SI1(0.0),
    LK0SISAT(0.0),
    NK0SISAT(0.0),
    PK0SISAT(0.0),
    LK0SISAT1(0.0),
    NK0SISAT1(0.0),
    PK0SISAT1(0.0),
    LK2SISAT(0.0),
    NK2SISAT(0.0),
    PK2SISAT(0.0),
    LK2SISAT1(0.0),
    NK2SISAT1(0.0),
    PK2SISAT1(0.0),
    LK2SAT(0.0),
    NK2SAT(0.0),
    PK2SAT(0.0),
    LK2SAT1(0.0),
    NK2SAT1(0.0),
    PK2SAT1(0.0),
    LK2(0.0),
    NK2(0.0),
    PK2(0.0),
    LK21(0.0),
    NK21(0.0),
    PK21(0.0),
    LDVTB(0.0),
    NDVTB(0.0),
    PDVTB(0.0),
    LLPEB(0.0),
    NLPEB(0.0),
    PLPEB(0.0),
    LQMFACTOR(0.0),
    NQMFACTOR(0.0),
    PQMFACTOR(0.0),
    LQMTCENCV(0.0),
    NQMTCENCV(0.0),
    PQMTCENCV(0.0),
    LQMTCENCVA(0.0),
    NQMTCENCVA(0.0),
    PQMTCENCVA(0.0),
    LVSAT(0.0),
    NVSAT(0.0),
    PVSAT(0.0),
    LVSATR(0.0),
    NVSATR(0.0),
    PVSATR(0.0),
    LVSAT1(0.0),
    NVSAT1(0.0),
    PVSAT1(0.0),
    LVSAT1R(0.0),
    NVSAT1R(0.0),
    PVSAT1R(0.0),
    LPSAT(0.0),
    NPSAT(0.0),
    PPSAT(0.0),
    LDELTAVSAT(0.0),
    NDELTAVSAT(0.0),
    PDELTAVSAT(0.0),
    LKSATIV(0.0),
    NKSATIV(0.0),
    PKSATIV(0.0),
    LKSATIVR(0.0),
    NKSATIVR(0.0),
    PKSATIVR(0.0),
    LVSATCV(0.0),
    NVSATCV(0.0),
    PVSATCV(0.0),
    LPSATCV(0.0),
    NPSATCV(0.0),
    PPSATCV(0.0),
    LDELTAVSATCV(0.0),
    NDELTAVSATCV(0.0),
    PDELTAVSATCV(0.0),
    LMEXP(0.0),
    NMEXP(0.0),
    PMEXP(0.0),
    LMEXPR(0.0),
    NMEXPR(0.0),
    PMEXPR(0.0),
    LPTWG(0.0),
    NPTWG(0.0),
    PPTWG(0.0),
    LPTWGR(0.0),
    NPTWGR(0.0),
    PPTWGR(0.0),
    LU0(0.0),
    NU0(0.0),
    PU0(0.0),
    LU0R(0.0),
    NU0R(0.0),
    PU0R(0.0),
    LETAMOB(0.0),
    NETAMOB(0.0),
    PETAMOB(0.0),
    LUP(0.0),
    NUP(0.0),
    PUP(0.0),
    LUPR(0.0),
    NUPR(0.0),
    PUPR(0.0),
    LUA(0.0),
    NUA(0.0),
    PUA(0.0),
    LUAR(0.0),
    NUAR(0.0),
    PUAR(0.0),
    LUC(0.0),
    NUC(0.0),
    PUC(0.0),
    LUCR(0.0),
    NUCR(0.0),
    PUCR(0.0),
    LEU(0.0),
    NEU(0.0),
    PEU(0.0),
    LEUR(0.0),
    NEUR(0.0),
    PEUR(0.0),
    LUD(0.0),
    NUD(0.0),
    PUD(0.0),
    LUDR(0.0),
    NUDR(0.0),
    PUDR(0.0),
    LUCS(0.0),
    NUCS(0.0),
    PUCS(0.0),
    LPCLM(0.0),
    NPCLM(0.0),
    PPCLM(0.0),
    LPCLMR(0.0),
    NPCLMR(0.0),
    PPCLMR(0.0),
    LPCLMG(0.0),
    NPCLMG(0.0),
    PPCLMG(0.0),
    LPCLMCV(0.0),
    NPCLMCV(0.0),
    PPCLMCV(0.0),
    LA1(0.0),
    NA1(0.0),
    PA1(0.0),
    LA11(0.0),
    NA11(0.0),
    PA11(0.0),
    LA2(0.0),
    NA2(0.0),
    PA2(0.0),
    LA21(0.0),
    NA21(0.0),
    PA21(0.0),
    LRDSW(0.0),
    NRDSW(0.0),
    PRDSW(0.0),
    LRSW(0.0),
    NRSW(0.0),
    PRSW(0.0),
    LRDW(0.0),
    NRDW(0.0),
    PRDW(0.0),
    LPRWGS(0.0),
    NPRWGS(0.0),
    PPRWGS(0.0),
    LPRWGD(0.0),
    NPRWGD(0.0),
    PPRWGD(0.0),
    LWR(0.0),
    NWR(0.0),
    PWR(0.0),
    LPDIBL1(0.0),
    NPDIBL1(0.0),
    PPDIBL1(0.0),
    LPDIBL1R(0.0),
    NPDIBL1R(0.0),
    PPDIBL1R(0.0),
    LPDIBL2(0.0),
    NPDIBL2(0.0),
    PPDIBL2(0.0),
    LPDIBL2R(0.0),
    NPDIBL2R(0.0),
    PPDIBL2R(0.0),
    LDROUT(0.0),
    NDROUT(0.0),
    PDROUT(0.0),
    LPVAG(0.0),
    NPVAG(0.0),
    PPVAG(0.0),
    LAIGBINV(0.0),
    NAIGBINV(0.0),
    PAIGBINV(0.0),
    LAIGBINV1(0.0),
    NAIGBINV1(0.0),
    PAIGBINV1(0.0),
    LBIGBINV(0.0),
    NBIGBINV(0.0),
    PBIGBINV(0.0),
    LCIGBINV(0.0),
    NCIGBINV(0.0),
    PCIGBINV(0.0),
    LEIGBINV(0.0),
    NEIGBINV(0.0),
    PEIGBINV(0.0),
    LNIGBINV(0.0),
    NNIGBINV(0.0),
    PNIGBINV(0.0),
    LAIGBACC(0.0),
    NAIGBACC(0.0),
    PAIGBACC(0.0),
    LAIGBACC1(0.0),
    NAIGBACC1(0.0),
    PAIGBACC1(0.0),
    LBIGBACC(0.0),
    NBIGBACC(0.0),
    PBIGBACC(0.0),
    LCIGBACC(0.0),
    NCIGBACC(0.0),
    PCIGBACC(0.0),
    LNIGBACC(0.0),
    NNIGBACC(0.0),
    PNIGBACC(0.0),
    LAIGC(0.0),
    NAIGC(0.0),
    PAIGC(0.0),
    LAIGC1(0.0),
    NAIGC1(0.0),
    PAIGC1(0.0),
    LBIGC(0.0),
    NBIGC(0.0),
    PBIGC(0.0),
    LCIGC(0.0),
    NCIGC(0.0),
    PCIGC(0.0),
    LPIGCD(0.0),
    NPIGCD(0.0),
    PPIGCD(0.0),
    LAIGS(0.0),
    NAIGS(0.0),
    PAIGS(0.0),
    LAIGS1(0.0),
    NAIGS1(0.0),
    PAIGS1(0.0),
    LBIGS(0.0),
    NBIGS(0.0),
    PBIGS(0.0),
    LCIGS(0.0),
    NCIGS(0.0),
    PCIGS(0.0),
    LAIGD(0.0),
    NAIGD(0.0),
    PAIGD(0.0),
    LAIGD1(0.0),
    NAIGD1(0.0),
    PAIGD1(0.0),
    LBIGD(0.0),
    NBIGD(0.0),
    PBIGD(0.0),
    LCIGD(0.0),
    NCIGD(0.0),
    PCIGD(0.0),
    LNTOX(0.0),
    NNTOX(0.0),
    PNTOX(0.0),
    LPOXEDGE(0.0),
    NPOXEDGE(0.0),
    PPOXEDGE(0.0),
    LAGISL(0.0),
    NAGISL(0.0),
    PAGISL(0.0),
    LBGISL(0.0),
    NBGISL(0.0),
    PBGISL(0.0),
    LCGISL(0.0),
    NCGISL(0.0),
    PCGISL(0.0),
    LEGISL(0.0),
    NEGISL(0.0),
    PEGISL(0.0),
    LPGISL(0.0),
    NPGISL(0.0),
    PPGISL(0.0),
    LAGIDL(0.0),
    NAGIDL(0.0),
    PAGIDL(0.0),
    LBGIDL(0.0),
    NBGIDL(0.0),
    PBGIDL(0.0),
    LCGIDL(0.0),
    NCGIDL(0.0),
    PCGIDL(0.0),
    LEGIDL(0.0),
    NEGIDL(0.0),
    PEGIDL(0.0),
    LPGIDL(0.0),
    NPGIDL(0.0),
    PPGIDL(0.0),
    LALPHA0(0.0),
    NALPHA0(0.0),
    PALPHA0(0.0),
    LALPHA1(0.0),
    NALPHA1(0.0),
    PALPHA1(0.0),
    LALPHAII0(0.0),
    NALPHAII0(0.0),
    PALPHAII0(0.0),
    LALPHAII1(0.0),
    NALPHAII1(0.0),
    PALPHAII1(0.0),
    LBETA0(0.0),
    NBETA0(0.0),
    PBETA0(0.0),
    LBETAII0(0.0),
    NBETAII0(0.0),
    PBETAII0(0.0),
    LBETAII1(0.0),
    NBETAII1(0.0),
    PBETAII1(0.0),
    LBETAII2(0.0),
    NBETAII2(0.0),
    PBETAII2(0.0),
    LESATII(0.0),
    NESATII(0.0),
    PESATII(0.0),
    LLII(0.0),
    NLII(0.0),
    PLII(0.0),
    LSII0(0.0),
    NSII0(0.0),
    PSII0(0.0),
    LSII1(0.0),
    NSII1(0.0),
    PSII1(0.0),
    LSII2(0.0),
    NSII2(0.0),
    PSII2(0.0),
    LSIID(0.0),
    NSIID(0.0),
    PSIID(0.0),
    LCFS(0.0),
    NCFS(0.0),
    PCFS(0.0),
    LCFD(0.0),
    NCFD(0.0),
    PCFD(0.0),
    LCOVS(0.0),
    NCOVS(0.0),
    PCOVS(0.0),
    LCOVD(0.0),
    NCOVD(0.0),
    PCOVD(0.0),
    LCGSL(0.0),
    NCGSL(0.0),
    PCGSL(0.0),
    LCGDL(0.0),
    NCGDL(0.0),
    PCGDL(0.0),
    LCKAPPAS(0.0),
    NCKAPPAS(0.0),
    PCKAPPAS(0.0),
    LCKAPPAD(0.0),
    NCKAPPAD(0.0),
    PCKAPPAD(0.0),
    LCGBL(0.0),
    NCGBL(0.0),
    PCGBL(0.0),
    LCKAPPAB(0.0),
    NCKAPPAB(0.0),
    PCKAPPAB(0.0),
    LNTGEN(0.0),
    NNTGEN(0.0),
    PNTGEN(0.0),
    LAIGEN(0.0),
    NAIGEN(0.0),
    PAIGEN(0.0),
    LBIGEN(0.0),
    NBIGEN(0.0),
    PBIGEN(0.0),
    LXRCRG1(0.0),
    NXRCRG1(0.0),
    PXRCRG1(0.0),
    LXRCRG2(0.0),
    NXRCRG2(0.0),
    PXRCRG2(0.0),
    LUTE(0.0),
    NUTE(0.0),
    PUTE(0.0),
    LUTER(0.0),
    NUTER(0.0),
    PUTER(0.0),
    LUTL(0.0),
    NUTL(0.0),
    PUTL(0.0),
    LUTLR(0.0),
    NUTLR(0.0),
    PUTLR(0.0),
    LEMOBT(0.0),
    NEMOBT(0.0),
    PEMOBT(0.0),
    LUA1(0.0),
    NUA1(0.0),
    PUA1(0.0),
    LUA1R(0.0),
    NUA1R(0.0),
    PUA1R(0.0),
    LUC1(0.0),
    NUC1(0.0),
    PUC1(0.0),
    LUC1R(0.0),
    NUC1R(0.0),
    PUC1R(0.0),
    LUD1(0.0),
    NUD1(0.0),
    PUD1(0.0),
    LUD1R(0.0),
    NUD1R(0.0),
    PUD1R(0.0),
    LUCSTE(0.0),
    NUCSTE(0.0),
    PUCSTE(0.0),
    LPTWGT(0.0),
    NPTWGT(0.0),
    PPTWGT(0.0),
    LAT(0.0),
    NAT(0.0),
    PAT(0.0),
    LATR(0.0),
    NATR(0.0),
    PATR(0.0),
    LATCV(0.0),
    NATCV(0.0),
    PATCV(0.0),
    LSTTHETASAT(0.0),
    NSTTHETASAT(0.0),
    PSTTHETASAT(0.0),
    LPRT(0.0),
    NPRT(0.0),
    PPRT(0.0),
    LKT1(0.0),
    NKT1(0.0),
    PKT1(0.0),
    LTSS(0.0),
    NTSS(0.0),
    PTSS(0.0),
    LIIT(0.0),
    NIIT(0.0),
    PIIT(0.0),
    LTII(0.0),
    NTII(0.0),
    PTII(0.0),
    LTGIDL(0.0),
    NTGIDL(0.0),
    PTGIDL(0.0),
    LIGT(0.0),
    NIGT(0.0),
    PIGT(0.0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << "L  =  " << (*iter)->L << std::endl;
    os << "D  =  " << (*iter)->D << std::endl;
    os << "TFIN  =  " << (*iter)->TFIN << std::endl;
    os << "FPITCH  =  " << (*iter)->FPITCH << std::endl;
    os << "NF  =  " << (*iter)->NF << std::endl;
    os << "NFIN  =  " << (*iter)->NFIN << std::endl;
    os << "NGCON  =  " << (*iter)->NGCON << std::endl;
    os << "ASEO  =  " << (*iter)->ASEO << std::endl;
    os << "ADEO  =  " << (*iter)->ADEO << std::endl;
    os << "PSEO  =  " << (*iter)->PSEO << std::endl;
    os << "PDEO  =  " << (*iter)->PDEO << std::endl;
    os << "ASEJ  =  " << (*iter)->ASEJ << std::endl;
    os << "ADEJ  =  " << (*iter)->ADEJ << std::endl;
    os << "PSEJ  =  " << (*iter)->PSEJ << std::endl;
    os << "PDEJ  =  " << (*iter)->PDEJ << std::endl;
    os << "COVS  =  " << (*iter)->COVS << std::endl;
    os << "COVD  =  " << (*iter)->COVD << std::endl;
    os << "CGSP  =  " << (*iter)->CGSP << std::endl;
    os << "CGDP  =  " << (*iter)->CGDP << std::endl;
    os << "CDSP  =  " << (*iter)->CDSP << std::endl;
    os << "NRS  =  " << (*iter)->NRS << std::endl;
    os << "NRD  =  " << (*iter)->NRD << std::endl;
    os << "LRSD  =  " << (*iter)->LRSD << std::endl;
    os << "NFINNOM  =  " << (*iter)->NFINNOM << std::endl;
    os << "M  =  " << (*iter)->m << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       : 
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
/// 
/// @param[in] op Operator to apply to all instances.
/// 
/// 
void Model::forEachInstance(DeviceInstanceOp &op) const /* override */ 
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void registerDevice()
{
  Config<Traits>::addConfiguration()
    .registerDevice("m", 110)
    .registerModelType("nmos", 110)
    .registerModelType("pmos", 110);
}



#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_L,
   bool instancePar_given_L,
   AdmsSensFadType & instancePar_D,
   bool instancePar_given_D,
   AdmsSensFadType & instancePar_TFIN,
   bool instancePar_given_TFIN,
   AdmsSensFadType & instancePar_FPITCH,
   bool instancePar_given_FPITCH,
   AdmsSensFadType & instancePar_NFIN,
   bool instancePar_given_NFIN,
   AdmsSensFadType & instancePar_ASEO,
   bool instancePar_given_ASEO,
   AdmsSensFadType & instancePar_ADEO,
   bool instancePar_given_ADEO,
   AdmsSensFadType & instancePar_PSEO,
   bool instancePar_given_PSEO,
   AdmsSensFadType & instancePar_PDEO,
   bool instancePar_given_PDEO,
   AdmsSensFadType & instancePar_ASEJ,
   bool instancePar_given_ASEJ,
   AdmsSensFadType & instancePar_ADEJ,
   bool instancePar_given_ADEJ,
   AdmsSensFadType & instancePar_PSEJ,
   bool instancePar_given_PSEJ,
   AdmsSensFadType & instancePar_PDEJ,
   bool instancePar_given_PDEJ,
   AdmsSensFadType & instancePar_COVS,
   bool instancePar_given_COVS,
   AdmsSensFadType & instancePar_COVD,
   bool instancePar_given_COVD,
   AdmsSensFadType & instancePar_CGSP,
   bool instancePar_given_CGSP,
   AdmsSensFadType & instancePar_CGDP,
   bool instancePar_given_CGDP,
   AdmsSensFadType & instancePar_CDSP,
   bool instancePar_given_CDSP,
   AdmsSensFadType & instancePar_NRS,
   bool instancePar_given_NRS,
   AdmsSensFadType & instancePar_NRD,
   bool instancePar_given_NRD,
   AdmsSensFadType & instancePar_LRSD,
   bool instancePar_given_LRSD,
   AdmsSensFadType & instancePar_NFINNOM,
   bool instancePar_given_NFINNOM,
   AdmsSensFadType & instancePar_m,
   bool instancePar_given_m,
   // non-reals(including hidden)
   int instancePar_NF,
   bool instancePar_given_NF,
   int instancePar_NGCON,
   bool instancePar_given_NGCON,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_NFINtotal,
   AdmsSensFadType & instanceVar_ids,
   AdmsSensFadType & instanceVar_sigvds,
   AdmsSensFadType & instanceVar_qd,
   AdmsSensFadType & instanceVar_qg,
   AdmsSensFadType & instanceVar_qs,
   AdmsSensFadType & instanceVar_qb,
   AdmsSensFadType & instanceVar_epssub,
   AdmsSensFadType & instanceVar_epsratio,
   AdmsSensFadType & instanceVar_Leff,
   AdmsSensFadType & instanceVar_LeffCV,
   AdmsSensFadType & instanceVar_LeffCV_acc,
   AdmsSensFadType & instanceVar_Weff0,
   AdmsSensFadType & instanceVar_WeffCV0,
   AdmsSensFadType & instanceVar_cox,
   AdmsSensFadType & instanceVar_nbody,
   AdmsSensFadType & instanceVar_T0,
   AdmsSensFadType & instanceVar_T1,
   AdmsSensFadType & instanceVar_T2,
   AdmsSensFadType & instanceVar_T3,
   AdmsSensFadType & instanceVar_Tnom,
   AdmsSensFadType & instanceVar_PTWGR_t,
   AdmsSensFadType & instanceVar_CJS_t,
   AdmsSensFadType & instanceVar_CJSWS_t,
   AdmsSensFadType & instanceVar_CJSWGD_t,
   AdmsSensFadType & instanceVar_CJD_t,
   AdmsSensFadType & instanceVar_CJSWD_t,
   AdmsSensFadType & instanceVar_CJSWGS_t,
   AdmsSensFadType & instanceVar_PBS_t,
   AdmsSensFadType & instanceVar_PBSWS_t,
   AdmsSensFadType & instanceVar_PBSWGS_t,
   AdmsSensFadType & instanceVar_PBD_t,
   AdmsSensFadType & instanceVar_PBSWD_t,
   AdmsSensFadType & instanceVar_PBSWGD_t,
   AdmsSensFadType & instanceVar_JSS_t,
   AdmsSensFadType & instanceVar_JSWS_t,
   AdmsSensFadType & instanceVar_JSWGS_t,
   AdmsSensFadType & instanceVar_JSD_t,
   AdmsSensFadType & instanceVar_JSWD_t,
   AdmsSensFadType & instanceVar_JSWGD_t,
   AdmsSensFadType & instanceVar_JTSS_t,
   AdmsSensFadType & instanceVar_JTSD_t,
   AdmsSensFadType & instanceVar_JTSSWS_t,
   AdmsSensFadType & instanceVar_JTSSWD_t,
   AdmsSensFadType & instanceVar_JTSSWGS_t,
   AdmsSensFadType & instanceVar_JTSSWGD_t,
   AdmsSensFadType & instanceVar_NJTS_t,
   AdmsSensFadType & instanceVar_NJTSD_t,
   AdmsSensFadType & instanceVar_NJTSSW_t,
   AdmsSensFadType & instanceVar_NJTSSWD_t,
   AdmsSensFadType & instanceVar_NJTSSWG_t,
   AdmsSensFadType & instanceVar_NJTSSWGD_t,
   AdmsSensFadType & instanceVar_q0,
   AdmsSensFadType & instanceVar_T11,
   AdmsSensFadType & instanceVar_T12,
   AdmsSensFadType & instanceVar_e0,
   AdmsSensFadType & instanceVar_e1,
   AdmsSensFadType & instanceVar_e2,
   AdmsSensFadType & instanceVar_scl,
   AdmsSensFadType & instanceVar_tmp,
   AdmsSensFadType & instanceVar_Theta_SCE,
   AdmsSensFadType & instanceVar_Theta_SW,
   AdmsSensFadType & instanceVar_Theta_DIBL,
   AdmsSensFadType & instanceVar_Theta_RSCE,
   AdmsSensFadType & instanceVar_Theta_DITS,
   AdmsSensFadType & instanceVar_veseff,
   AdmsSensFadType & instanceVar_Tcen0,
   AdmsSensFadType & instanceVar_Tcen,
   AdmsSensFadType & instanceVar_mx,
   AdmsSensFadType & instanceVar_mxprime,
   AdmsSensFadType & instanceVar_md,
   AdmsSensFadType & instanceVar_mdprime,
   AdmsSensFadType & instanceVar_gprime,
   AdmsSensFadType & instanceVar_gfactor,
   AdmsSensFadType & instanceVar_qis,
   AdmsSensFadType & instanceVar_qid,
   AdmsSensFadType & instanceVar_qbs,
   AdmsSensFadType & instanceVar_qba,
   AdmsSensFadType & instanceVar_u0r,
   AdmsSensFadType & instanceVar_UAR_t,
   AdmsSensFadType & instanceVar_UC_t,
   AdmsSensFadType & instanceVar_UCR_t,
   AdmsSensFadType & instanceVar_UDR_t,
   AdmsSensFadType & instanceVar_U0R_t,
   AdmsSensFadType & instanceVar_EeffFactor,
   AdmsSensFadType & instanceVar_Dr,
   AdmsSensFadType & instanceVar_WeffWRFactor,
   AdmsSensFadType & instanceVar_RSourceGeo,
   AdmsSensFadType & instanceVar_RDrainGeo,
   AdmsSensFadType & instanceVar_RDSWMIN_i,
   AdmsSensFadType & instanceVar_RDWMIN_i,
   AdmsSensFadType & instanceVar_RSWMIN_i,
   AdmsSensFadType & instanceVar_Rdrain,
   AdmsSensFadType & instanceVar_Rsource,
   AdmsSensFadType & instanceVar_Rdsi,
   AdmsSensFadType & instanceVar_RSDRR_t,
   AdmsSensFadType & instanceVar_RDDRR_t,
   AdmsSensFadType & instanceVar_VSAT1R_t,
   AdmsSensFadType & instanceVar_MEXPR_t,
   AdmsSensFadType & instanceVar_VSAT_a,
   AdmsSensFadType & instanceVar_Cfr_geo,
   AdmsSensFadType & instanceVar_ggeltd,
   AdmsSensFadType & instanceVar_igbinv,
   AdmsSensFadType & instanceVar_igsd_mult0,
   AdmsSensFadType & instanceVar_igbs,
   AdmsSensFadType & instanceVar_igbd,
   AdmsSensFadType & instanceVar_igbacc,
   AdmsSensFadType & instanceVar_igcs,
   AdmsSensFadType & instanceVar_igcd,
   AdmsSensFadType & instanceVar_igisl,
   AdmsSensFadType & instanceVar_igidl,
   AdmsSensFadType & instanceVar_igs,
   AdmsSensFadType & instanceVar_igd,
   AdmsSensFadType & instanceVar_Aechvb,
   AdmsSensFadType & instanceVar_Bechvb,
   AdmsSensFadType & instanceVar_Toxratio,
   AdmsSensFadType & instanceVar_Iii,
   AdmsSensFadType & instanceVar_cox_acc,
   AdmsSensFadType & instanceVar_qg_acc,
   AdmsSensFadType & instanceVar_qb_acc,
   AdmsSensFadType & instanceVar_qgs_fr,
   AdmsSensFadType & instanceVar_qgd_fr,
   AdmsSensFadType & instanceVar_qds_fr,
   AdmsSensFadType & instanceVar_qgs_parasitic,
   AdmsSensFadType & instanceVar_qgd_parasitic,
   AdmsSensFadType & instanceVar_Qes,
   AdmsSensFadType & instanceVar_Qed,
   AdmsSensFadType & instanceVar_Qeg,
   AdmsSensFadType & instanceVar_csbox,
   AdmsSensFadType & instanceVar_cdbox,
   AdmsSensFadType & instanceVar_cgbox,
   AdmsSensFadType & instanceVar_Ies,
   AdmsSensFadType & instanceVar_Ied,
   AdmsSensFadType & instanceVar_Czbs,
   AdmsSensFadType & instanceVar_Czbssw,
   AdmsSensFadType & instanceVar_Czbsswg,
   AdmsSensFadType & instanceVar_Czbd,
   AdmsSensFadType & instanceVar_Czbdsw,
   AdmsSensFadType & instanceVar_Czbdswg,
   AdmsSensFadType & instanceVar_Isbs,
   AdmsSensFadType & instanceVar_Isbd,
   AdmsSensFadType & instanceVar_Nvtms,
   AdmsSensFadType & instanceVar_Nvtmd,
   AdmsSensFadType & instanceVar_SslpRev,
   AdmsSensFadType & instanceVar_IVjsmRev,
   AdmsSensFadType & instanceVar_VjsmRev,
   AdmsSensFadType & instanceVar_SslpFwd,
   AdmsSensFadType & instanceVar_IVjsmFwd,
   AdmsSensFadType & instanceVar_VjsmFwd,
   AdmsSensFadType & instanceVar_XExpBVS,
   AdmsSensFadType & instanceVar_DslpRev,
   AdmsSensFadType & instanceVar_IVjdmRev,
   AdmsSensFadType & instanceVar_VjdmRev,
   AdmsSensFadType & instanceVar_DslpFwd,
   AdmsSensFadType & instanceVar_IVjdmFwd,
   AdmsSensFadType & instanceVar_VjdmFwd,
   AdmsSensFadType & instanceVar_XExpBVD,
   AdmsSensFadType & instanceVar_idsgen,
   AdmsSensFadType & instanceVar_LINTIGEN_i,
   AdmsSensFadType & instanceVar_LINTNOI_i,
   AdmsSensFadType & instanceVar_litl,
   AdmsSensFadType & instanceVar_FNPowerAt1Hz,
   AdmsSensFadType & instanceVar_NTNOI_i,
   AdmsSensFadType & instanceVar_Gtnoi,
   AdmsSensFadType & instanceVar_sid,
   AdmsSensFadType & instanceVar_gspr,
   AdmsSensFadType & instanceVar_gdpr,
   AdmsSensFadType & instanceVar_gamma,
   AdmsSensFadType & instanceVar_delta,
   AdmsSensFadType & instanceVar_ctnoi,
   AdmsSensFadType & instanceVar_C0,
   AdmsSensFadType & instanceVar_sf,
   AdmsSensFadType & instanceVar_gth,
   AdmsSensFadType & instanceVar_cth,
   AdmsSensFadType & instanceVar_PHIG_i,
   AdmsSensFadType & instanceVar_CFD_i,
   AdmsSensFadType & instanceVar_CFS_i,
   AdmsSensFadType & instanceVar_COVS_i,
   AdmsSensFadType & instanceVar_COVD_i,
   AdmsSensFadType & instanceVar_CGSO_i,
   AdmsSensFadType & instanceVar_CGDO_i,
   AdmsSensFadType & instanceVar_CGSL_i,
   AdmsSensFadType & instanceVar_CGDL_i,
   AdmsSensFadType & instanceVar_CGBL_i,
   AdmsSensFadType & instanceVar_CKAPPAS_i,
   AdmsSensFadType & instanceVar_CKAPPAD_i,
   AdmsSensFadType & instanceVar_CKAPPAB_i,
   AdmsSensFadType & instanceVar_QMFACTOR_i,
   AdmsSensFadType & instanceVar_QMTCENCV_i,
   AdmsSensFadType & instanceVar_QMTCENCVA_i,
   AdmsSensFadType & instanceVar_KSATIV_i,
   AdmsSensFadType & instanceVar_KSATIVR_i,
   AdmsSensFadType & instanceVar_CDSC_i,
   AdmsSensFadType & instanceVar_CDSCD_i,
   AdmsSensFadType & instanceVar_CDSCDR_i,
   AdmsSensFadType & instanceVar_CIT_i,
   AdmsSensFadType & instanceVar_DVT0_i,
   AdmsSensFadType & instanceVar_CITR_i,
   AdmsSensFadType & instanceVar_PHIN_i,
   AdmsSensFadType & instanceVar_ETA0_i,
   AdmsSensFadType & instanceVar_ETA0R_i,
   AdmsSensFadType & instanceVar_VSAT_i,
   AdmsSensFadType & instanceVar_VSATR_i,
   AdmsSensFadType & instanceVar_VSATR_t,
   AdmsSensFadType & instanceVar_DVTP0_i,
   AdmsSensFadType & instanceVar_DVTP1_i,
   AdmsSensFadType & instanceVar_K0_i,
   AdmsSensFadType & instanceVar_K01_i,
   AdmsSensFadType & instanceVar_K0SI_i,
   AdmsSensFadType & instanceVar_K0SI1_i,
   AdmsSensFadType & instanceVar_K2SI_i,
   AdmsSensFadType & instanceVar_K2SI1_i,
   AdmsSensFadType & instanceVar_PHIBE_i,
   AdmsSensFadType & instanceVar_K1_i,
   AdmsSensFadType & instanceVar_K11_i,
   AdmsSensFadType & instanceVar_K2SAT_i,
   AdmsSensFadType & instanceVar_K2SAT1_i,
   AdmsSensFadType & instanceVar_DELTAVSAT_i,
   AdmsSensFadType & instanceVar_PSAT_i,
   AdmsSensFadType & instanceVar_DELTAVSATCV_i,
   AdmsSensFadType & instanceVar_PSATCV_i,
   AdmsSensFadType & instanceVar_VSAT1_i,
   AdmsSensFadType & instanceVar_VSAT1R_i,
   AdmsSensFadType & instanceVar_PTWG_i,
   AdmsSensFadType & instanceVar_PTWGR_i,
   AdmsSensFadType & instanceVar_VSATCV_i,
   AdmsSensFadType & instanceVar_U0_i,
   AdmsSensFadType & instanceVar_U0R_i,
   AdmsSensFadType & instanceVar_ETAMOB_i,
   AdmsSensFadType & instanceVar_RDSW_i,
   AdmsSensFadType & instanceVar_PRWGS_i,
   AdmsSensFadType & instanceVar_PRWGD_i,
   AdmsSensFadType & instanceVar_PDIBL1_i,
   AdmsSensFadType & instanceVar_PDIBL1R_i,
   AdmsSensFadType & instanceVar_PDIBL2_i,
   AdmsSensFadType & instanceVar_PDIBL2R_i,
   AdmsSensFadType & instanceVar_DROUT_i,
   AdmsSensFadType & instanceVar_PVAG_i,
   AdmsSensFadType & instanceVar_AIGBINV_i,
   AdmsSensFadType & instanceVar_AIGBINV1_i,
   AdmsSensFadType & instanceVar_BIGBINV_i,
   AdmsSensFadType & instanceVar_CIGBINV_i,
   AdmsSensFadType & instanceVar_EIGBINV_i,
   AdmsSensFadType & instanceVar_NIGBINV_i,
   AdmsSensFadType & instanceVar_AIGBACC_i,
   AdmsSensFadType & instanceVar_AIGBACC1_i,
   AdmsSensFadType & instanceVar_BIGBACC_i,
   AdmsSensFadType & instanceVar_CIGBACC_i,
   AdmsSensFadType & instanceVar_NIGBACC_i,
   AdmsSensFadType & instanceVar_AIGC_i,
   AdmsSensFadType & instanceVar_AIGC1_i,
   AdmsSensFadType & instanceVar_BIGC_i,
   AdmsSensFadType & instanceVar_CIGC_i,
   AdmsSensFadType & instanceVar_PIGCD_i,
   AdmsSensFadType & instanceVar_AIGS_i,
   AdmsSensFadType & instanceVar_AIGS1_i,
   AdmsSensFadType & instanceVar_BIGS_i,
   AdmsSensFadType & instanceVar_CIGS_i,
   AdmsSensFadType & instanceVar_POXEDGE_i,
   AdmsSensFadType & instanceVar_AIGD_i,
   AdmsSensFadType & instanceVar_AIGD1_i,
   AdmsSensFadType & instanceVar_BIGD_i,
   AdmsSensFadType & instanceVar_CIGD_i,
   AdmsSensFadType & instanceVar_AGIDL_i,
   AdmsSensFadType & instanceVar_BGIDL_i,
   AdmsSensFadType & instanceVar_CGIDL_i,
   AdmsSensFadType & instanceVar_EGIDL_i,
   AdmsSensFadType & instanceVar_PGIDL_i,
   AdmsSensFadType & instanceVar_AGISL_i,
   AdmsSensFadType & instanceVar_BGISL_i,
   AdmsSensFadType & instanceVar_CGISL_i,
   AdmsSensFadType & instanceVar_EGISL_i,
   AdmsSensFadType & instanceVar_PGISL_i,
   AdmsSensFadType & instanceVar_ALPHA0_i,
   AdmsSensFadType & instanceVar_ALPHA1_i,
   AdmsSensFadType & instanceVar_ALPHAII0_i,
   AdmsSensFadType & instanceVar_ALPHAII1_i,
   AdmsSensFadType & instanceVar_BETA0_i,
   AdmsSensFadType & instanceVar_BETAII0_i,
   AdmsSensFadType & instanceVar_BETAII1_i,
   AdmsSensFadType & instanceVar_BETAII2_i,
   AdmsSensFadType & instanceVar_ESATII_i,
   AdmsSensFadType & instanceVar_LII_i,
   AdmsSensFadType & instanceVar_SII0_i,
   AdmsSensFadType & instanceVar_SII1_i,
   AdmsSensFadType & instanceVar_SII2_i,
   AdmsSensFadType & instanceVar_SIID_i,
   AdmsSensFadType & instanceVar_TII_i,
   AdmsSensFadType & instanceVar_MEXP_i,
   AdmsSensFadType & instanceVar_MEXPR_i,
   AdmsSensFadType & instanceVar_PCLM_i,
   AdmsSensFadType & instanceVar_PCLMG_i,
   AdmsSensFadType & instanceVar_PCLMCV_i,
   AdmsSensFadType & instanceVar_PCLMR_i,
   AdmsSensFadType & instanceVar_A1_i,
   AdmsSensFadType & instanceVar_A2_i,
   AdmsSensFadType & instanceVar_A11_i,
   AdmsSensFadType & instanceVar_A21_i,
   AdmsSensFadType & instanceVar_K1RSCE_i,
   AdmsSensFadType & instanceVar_DVTSHIFT_i,
   AdmsSensFadType & instanceVar_DVTSHIFTR_i,
   AdmsSensFadType & instanceVar_UA_i,
   AdmsSensFadType & instanceVar_UC_i,
   AdmsSensFadType & instanceVar_EU_i,
   AdmsSensFadType & instanceVar_UD_i,
   AdmsSensFadType & instanceVar_UCS_i,
   AdmsSensFadType & instanceVar_UAR_i,
   AdmsSensFadType & instanceVar_EUR_i,
   AdmsSensFadType & instanceVar_UCR_i,
   AdmsSensFadType & instanceVar_UDR_i,
   AdmsSensFadType & instanceVar_UA1_i,
   AdmsSensFadType & instanceVar_UA1R_i,
   AdmsSensFadType & instanceVar_UC1_i,
   AdmsSensFadType & instanceVar_UD1_i,
   AdmsSensFadType & instanceVar_UCSTE_i,
   AdmsSensFadType & instanceVar_UTE_i,
   AdmsSensFadType & instanceVar_UTL_i,
   AdmsSensFadType & instanceVar_EMOBT_i,
   AdmsSensFadType & instanceVar_UC1R_i,
   AdmsSensFadType & instanceVar_UD1R_i,
   AdmsSensFadType & instanceVar_UTER_i,
   AdmsSensFadType & instanceVar_UTLR_i,
   AdmsSensFadType & instanceVar_PTWGT_i,
   AdmsSensFadType & instanceVar_AT_i,
   AdmsSensFadType & instanceVar_ATCV_i,
   AdmsSensFadType & instanceVar_ATR_i,
   AdmsSensFadType & instanceVar_RDW_i,
   AdmsSensFadType & instanceVar_RSW_i,
   AdmsSensFadType & instanceVar_PRT_i,
   AdmsSensFadType & instanceVar_KT1_i,
   AdmsSensFadType & instanceVar_TSS_i,
   AdmsSensFadType & instanceVar_IIT_i,
   AdmsSensFadType & instanceVar_IGT_i,
   AdmsSensFadType & instanceVar_TGIDL_i,
   AdmsSensFadType & instanceVar_NTGEN_i,
   AdmsSensFadType & instanceVar_AIGEN_i,
   AdmsSensFadType & instanceVar_BIGEN_i,
   AdmsSensFadType & instanceVar_K0SISAT_i,
   AdmsSensFadType & instanceVar_K0SISAT1_i,
   AdmsSensFadType & instanceVar_K2SISAT_i,
   AdmsSensFadType & instanceVar_K2SISAT1_i,
   AdmsSensFadType & instanceVar_K2_i,
   AdmsSensFadType & instanceVar_K21_i,
   AdmsSensFadType & instanceVar_Cins,
   AdmsSensFadType & instanceVar_Ach,
   AdmsSensFadType & instanceVar_Weff_UFCM,
   AdmsSensFadType & instanceVar_qdep,
   AdmsSensFadType & instanceVar_rc,
   AdmsSensFadType & instanceVar_vth_fixed_factor_Sub,
   AdmsSensFadType & instanceVar_vth_fixed_factor_SI,
   AdmsSensFadType & instanceVar_qm,
   AdmsSensFadType & instanceVar_Qdep_ov_Cins,
   AdmsSensFadType & instanceVar_qi_acc_for_QM,
   AdmsSensFadType & instanceVar_fieldnormalizationfactor,
   AdmsSensFadType & instanceVar_auxQMfact,
   AdmsSensFadType & instanceVar_QMFACTORCVfinal,
   AdmsSensFadType & instanceVar_psipclamp,
   AdmsSensFadType & instanceVar_sqrtpsip,
   AdmsSensFadType & instanceVar_nq,
   AdmsSensFadType & instanceVar_F0,
   // non-reals
   int instanceVar_devsign,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_D,
   bool modelPar_given_D,
   AdmsSensFadType & modelPar_TFIN,
   bool modelPar_given_TFIN,
   AdmsSensFadType & modelPar_FPITCH,
   bool modelPar_given_FPITCH,
   AdmsSensFadType & modelPar_NFIN,
   bool modelPar_given_NFIN,
   AdmsSensFadType & modelPar_ASEO,
   bool modelPar_given_ASEO,
   AdmsSensFadType & modelPar_ADEO,
   bool modelPar_given_ADEO,
   AdmsSensFadType & modelPar_PSEO,
   bool modelPar_given_PSEO,
   AdmsSensFadType & modelPar_PDEO,
   bool modelPar_given_PDEO,
   AdmsSensFadType & modelPar_ASEJ,
   bool modelPar_given_ASEJ,
   AdmsSensFadType & modelPar_ADEJ,
   bool modelPar_given_ADEJ,
   AdmsSensFadType & modelPar_PSEJ,
   bool modelPar_given_PSEJ,
   AdmsSensFadType & modelPar_PDEJ,
   bool modelPar_given_PDEJ,
   AdmsSensFadType & modelPar_COVS,
   bool modelPar_given_COVS,
   AdmsSensFadType & modelPar_COVD,
   bool modelPar_given_COVD,
   AdmsSensFadType & modelPar_CGSP,
   bool modelPar_given_CGSP,
   AdmsSensFadType & modelPar_CGDP,
   bool modelPar_given_CGDP,
   AdmsSensFadType & modelPar_CDSP,
   bool modelPar_given_CDSP,
   AdmsSensFadType & modelPar_NRS,
   bool modelPar_given_NRS,
   AdmsSensFadType & modelPar_NRD,
   bool modelPar_given_NRD,
   AdmsSensFadType & modelPar_LRSD,
   bool modelPar_given_LRSD,
   AdmsSensFadType & modelPar_XL,
   bool modelPar_given_XL,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_DELVTRAND,
   bool modelPar_given_DELVTRAND,
   AdmsSensFadType & modelPar_U0MULT,
   bool modelPar_given_U0MULT,
   AdmsSensFadType & modelPar_IDS0MULT,
   bool modelPar_given_IDS0MULT,
   AdmsSensFadType & modelPar_LINT,
   bool modelPar_given_LINT,
   AdmsSensFadType & modelPar_LL,
   bool modelPar_given_LL,
   AdmsSensFadType & modelPar_LLN,
   bool modelPar_given_LLN,
   AdmsSensFadType & modelPar_DLC,
   bool modelPar_given_DLC,
   AdmsSensFadType & modelPar_DLCACC,
   bool modelPar_given_DLCACC,
   AdmsSensFadType & modelPar_DLBIN,
   bool modelPar_given_DLBIN,
   AdmsSensFadType & modelPar_LLC,
   bool modelPar_given_LLC,
   AdmsSensFadType & modelPar_EOT,
   bool modelPar_given_EOT,
   AdmsSensFadType & modelPar_TOXP,
   bool modelPar_given_TOXP,
   AdmsSensFadType & modelPar_EOTBOX,
   bool modelPar_given_EOTBOX,
   AdmsSensFadType & modelPar_HFIN,
   bool modelPar_given_HFIN,
   AdmsSensFadType & modelPar_FECH,
   bool modelPar_given_FECH,
   AdmsSensFadType & modelPar_DELTAW,
   bool modelPar_given_DELTAW,
   AdmsSensFadType & modelPar_FECHCV,
   bool modelPar_given_FECHCV,
   AdmsSensFadType & modelPar_DELTAWCV,
   bool modelPar_given_DELTAWCV,
   AdmsSensFadType & modelPar_NBODY,
   bool modelPar_given_NBODY,
   AdmsSensFadType & modelPar_NBODYN1,
   bool modelPar_given_NBODYN1,
   AdmsSensFadType & modelPar_NBODYN2,
   bool modelPar_given_NBODYN2,
   AdmsSensFadType & modelPar_NSD,
   bool modelPar_given_NSD,
   AdmsSensFadType & modelPar_PHIG,
   bool modelPar_given_PHIG,
   AdmsSensFadType & modelPar_PHIGL,
   bool modelPar_given_PHIGL,
   AdmsSensFadType & modelPar_PHIGLT,
   bool modelPar_given_PHIGLT,
   AdmsSensFadType & modelPar_PHIGN1,
   bool modelPar_given_PHIGN1,
   AdmsSensFadType & modelPar_PHIGN2,
   bool modelPar_given_PHIGN2,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_EPSRSUB,
   bool modelPar_given_EPSRSUB,
   AdmsSensFadType & modelPar_EASUB,
   bool modelPar_given_EASUB,
   AdmsSensFadType & modelPar_NI0SUB,
   bool modelPar_given_NI0SUB,
   AdmsSensFadType & modelPar_BG0SUB,
   bool modelPar_given_BG0SUB,
   AdmsSensFadType & modelPar_NC0SUB,
   bool modelPar_given_NC0SUB,
   AdmsSensFadType & modelPar_NGATE,
   bool modelPar_given_NGATE,
   AdmsSensFadType & modelPar_Imin,
   bool modelPar_given_Imin,
   AdmsSensFadType & modelPar_CIT,
   bool modelPar_given_CIT,
   AdmsSensFadType & modelPar_CITR,
   bool modelPar_given_CITR,
   AdmsSensFadType & modelPar_CDSC,
   bool modelPar_given_CDSC,
   AdmsSensFadType & modelPar_CDSCN1,
   bool modelPar_given_CDSCN1,
   AdmsSensFadType & modelPar_CDSCN2,
   bool modelPar_given_CDSCN2,
   AdmsSensFadType & modelPar_CDSCD,
   bool modelPar_given_CDSCD,
   AdmsSensFadType & modelPar_CDSCDN1,
   bool modelPar_given_CDSCDN1,
   AdmsSensFadType & modelPar_CDSCDN2,
   bool modelPar_given_CDSCDN2,
   AdmsSensFadType & modelPar_CDSCDR,
   bool modelPar_given_CDSCDR,
   AdmsSensFadType & modelPar_CDSCDRN1,
   bool modelPar_given_CDSCDRN1,
   AdmsSensFadType & modelPar_CDSCDRN2,
   bool modelPar_given_CDSCDRN2,
   AdmsSensFadType & modelPar_DVT0,
   bool modelPar_given_DVT0,
   AdmsSensFadType & modelPar_DVT1,
   bool modelPar_given_DVT1,
   AdmsSensFadType & modelPar_DVT1SS,
   bool modelPar_given_DVT1SS,
   AdmsSensFadType & modelPar_PHIN,
   bool modelPar_given_PHIN,
   AdmsSensFadType & modelPar_ETA0,
   bool modelPar_given_ETA0,
   AdmsSensFadType & modelPar_ETA0N1,
   bool modelPar_given_ETA0N1,
   AdmsSensFadType & modelPar_ETA0N2,
   bool modelPar_given_ETA0N2,
   AdmsSensFadType & modelPar_ETA0LT,
   bool modelPar_given_ETA0LT,
   AdmsSensFadType & modelPar_TETA0,
   bool modelPar_given_TETA0,
   AdmsSensFadType & modelPar_ETA0R,
   bool modelPar_given_ETA0R,
   AdmsSensFadType & modelPar_TETA0R,
   bool modelPar_given_TETA0R,
   AdmsSensFadType & modelPar_DSUB,
   bool modelPar_given_DSUB,
   AdmsSensFadType & modelPar_DVTP0,
   bool modelPar_given_DVTP0,
   AdmsSensFadType & modelPar_DVTP1,
   bool modelPar_given_DVTP1,
   AdmsSensFadType & modelPar_ADVTP0,
   bool modelPar_given_ADVTP0,
   AdmsSensFadType & modelPar_BDVTP0,
   bool modelPar_given_BDVTP0,
   AdmsSensFadType & modelPar_ADVTP1,
   bool modelPar_given_ADVTP1,
   AdmsSensFadType & modelPar_BDVTP1,
   bool modelPar_given_BDVTP1,
   AdmsSensFadType & modelPar_DVTP2,
   bool modelPar_given_DVTP2,
   AdmsSensFadType & modelPar_K1RSCE,
   bool modelPar_given_K1RSCE,
   AdmsSensFadType & modelPar_LPE0,
   bool modelPar_given_LPE0,
   AdmsSensFadType & modelPar_DVTSHIFT,
   bool modelPar_given_DVTSHIFT,
   AdmsSensFadType & modelPar_DVTSHIFTR,
   bool modelPar_given_DVTSHIFTR,
   AdmsSensFadType & modelPar_THETASCE,
   bool modelPar_given_THETASCE,
   AdmsSensFadType & modelPar_THETADIBL,
   bool modelPar_given_THETADIBL,
   AdmsSensFadType & modelPar_THETASW,
   bool modelPar_given_THETASW,
   AdmsSensFadType & modelPar_NVTM,
   bool modelPar_given_NVTM,
   AdmsSensFadType & modelPar_K0,
   bool modelPar_given_K0,
   AdmsSensFadType & modelPar_K01,
   bool modelPar_given_K01,
   AdmsSensFadType & modelPar_K0SI,
   bool modelPar_given_K0SI,
   AdmsSensFadType & modelPar_K0SI1,
   bool modelPar_given_K0SI1,
   AdmsSensFadType & modelPar_K2SI,
   bool modelPar_given_K2SI,
   AdmsSensFadType & modelPar_K2SI1,
   bool modelPar_given_K2SI1,
   AdmsSensFadType & modelPar_K0SISAT,
   bool modelPar_given_K0SISAT,
   AdmsSensFadType & modelPar_K0SISAT1,
   bool modelPar_given_K0SISAT1,
   AdmsSensFadType & modelPar_K2SISAT,
   bool modelPar_given_K2SISAT,
   AdmsSensFadType & modelPar_K2SISAT1,
   bool modelPar_given_K2SISAT1,
   AdmsSensFadType & modelPar_PHIBE,
   bool modelPar_given_PHIBE,
   AdmsSensFadType & modelPar_K1,
   bool modelPar_given_K1,
   AdmsSensFadType & modelPar_K11,
   bool modelPar_given_K11,
   AdmsSensFadType & modelPar_K2SAT,
   bool modelPar_given_K2SAT,
   AdmsSensFadType & modelPar_K2SAT1,
   bool modelPar_given_K2SAT1,
   AdmsSensFadType & modelPar_K2,
   bool modelPar_given_K2,
   AdmsSensFadType & modelPar_K21,
   bool modelPar_given_K21,
   AdmsSensFadType & modelPar_QMFACTOR,
   bool modelPar_given_QMFACTOR,
   AdmsSensFadType & modelPar_QMTCENCV,
   bool modelPar_given_QMTCENCV,
   AdmsSensFadType & modelPar_QMTCENCVA,
   bool modelPar_given_QMTCENCVA,
   AdmsSensFadType & modelPar_AQMTCEN,
   bool modelPar_given_AQMTCEN,
   AdmsSensFadType & modelPar_BQMTCEN,
   bool modelPar_given_BQMTCEN,
   AdmsSensFadType & modelPar_ETAQM,
   bool modelPar_given_ETAQM,
   AdmsSensFadType & modelPar_QM0,
   bool modelPar_given_QM0,
   AdmsSensFadType & modelPar_PQM,
   bool modelPar_given_PQM,
   AdmsSensFadType & modelPar_QM0ACC,
   bool modelPar_given_QM0ACC,
   AdmsSensFadType & modelPar_PQMACC,
   bool modelPar_given_PQMACC,
   AdmsSensFadType & modelPar_VSAT,
   bool modelPar_given_VSAT,
   AdmsSensFadType & modelPar_VSATR,
   bool modelPar_given_VSATR,
   AdmsSensFadType & modelPar_VSATN1,
   bool modelPar_given_VSATN1,
   AdmsSensFadType & modelPar_VSATN2,
   bool modelPar_given_VSATN2,
   AdmsSensFadType & modelPar_VSATRN1,
   bool modelPar_given_VSATRN1,
   AdmsSensFadType & modelPar_VSATRN2,
   bool modelPar_given_VSATRN2,
   AdmsSensFadType & modelPar_AVSAT,
   bool modelPar_given_AVSAT,
   AdmsSensFadType & modelPar_BVSAT,
   bool modelPar_given_BVSAT,
   AdmsSensFadType & modelPar_VSAT1,
   bool modelPar_given_VSAT1,
   AdmsSensFadType & modelPar_VSAT1N1,
   bool modelPar_given_VSAT1N1,
   AdmsSensFadType & modelPar_VSAT1N2,
   bool modelPar_given_VSAT1N2,
   AdmsSensFadType & modelPar_VSAT1R,
   bool modelPar_given_VSAT1R,
   AdmsSensFadType & modelPar_VSAT1RN1,
   bool modelPar_given_VSAT1RN1,
   AdmsSensFadType & modelPar_VSAT1RN2,
   bool modelPar_given_VSAT1RN2,
   AdmsSensFadType & modelPar_AVSAT1,
   bool modelPar_given_AVSAT1,
   AdmsSensFadType & modelPar_BVSAT1,
   bool modelPar_given_BVSAT1,
   AdmsSensFadType & modelPar_DELTAVSAT,
   bool modelPar_given_DELTAVSAT,
   AdmsSensFadType & modelPar_PSAT,
   bool modelPar_given_PSAT,
   AdmsSensFadType & modelPar_APSAT,
   bool modelPar_given_APSAT,
   AdmsSensFadType & modelPar_BPSAT,
   bool modelPar_given_BPSAT,
   AdmsSensFadType & modelPar_KSATIV,
   bool modelPar_given_KSATIV,
   AdmsSensFadType & modelPar_KSATIVR,
   bool modelPar_given_KSATIVR,
   AdmsSensFadType & modelPar_VSATCV,
   bool modelPar_given_VSATCV,
   AdmsSensFadType & modelPar_AVSATCV,
   bool modelPar_given_AVSATCV,
   AdmsSensFadType & modelPar_BVSATCV,
   bool modelPar_given_BVSATCV,
   AdmsSensFadType & modelPar_DELTAVSATCV,
   bool modelPar_given_DELTAVSATCV,
   AdmsSensFadType & modelPar_PSATCV,
   bool modelPar_given_PSATCV,
   AdmsSensFadType & modelPar_APSATCV,
   bool modelPar_given_APSATCV,
   AdmsSensFadType & modelPar_BPSATCV,
   bool modelPar_given_BPSATCV,
   AdmsSensFadType & modelPar_MEXP,
   bool modelPar_given_MEXP,
   AdmsSensFadType & modelPar_AMEXP,
   bool modelPar_given_AMEXP,
   AdmsSensFadType & modelPar_BMEXP,
   bool modelPar_given_BMEXP,
   AdmsSensFadType & modelPar_MEXPR,
   bool modelPar_given_MEXPR,
   AdmsSensFadType & modelPar_AMEXPR,
   bool modelPar_given_AMEXPR,
   AdmsSensFadType & modelPar_BMEXPR,
   bool modelPar_given_BMEXPR,
   AdmsSensFadType & modelPar_PTWG,
   bool modelPar_given_PTWG,
   AdmsSensFadType & modelPar_PTWGR,
   bool modelPar_given_PTWGR,
   AdmsSensFadType & modelPar_APTWG,
   bool modelPar_given_APTWG,
   AdmsSensFadType & modelPar_BPTWG,
   bool modelPar_given_BPTWG,
   AdmsSensFadType & modelPar_AT,
   bool modelPar_given_AT,
   AdmsSensFadType & modelPar_ATR,
   bool modelPar_given_ATR,
   AdmsSensFadType & modelPar_ATCV,
   bool modelPar_given_ATCV,
   AdmsSensFadType & modelPar_TMEXP,
   bool modelPar_given_TMEXP,
   AdmsSensFadType & modelPar_TMEXPR,
   bool modelPar_given_TMEXPR,
   AdmsSensFadType & modelPar_PTWGT,
   bool modelPar_given_PTWGT,
   AdmsSensFadType & modelPar_U0,
   bool modelPar_given_U0,
   AdmsSensFadType & modelPar_U0R,
   bool modelPar_given_U0R,
   AdmsSensFadType & modelPar_U0N1,
   bool modelPar_given_U0N1,
   AdmsSensFadType & modelPar_U0N1R,
   bool modelPar_given_U0N1R,
   AdmsSensFadType & modelPar_U0N2,
   bool modelPar_given_U0N2,
   AdmsSensFadType & modelPar_U0N2R,
   bool modelPar_given_U0N2R,
   AdmsSensFadType & modelPar_U0LT,
   bool modelPar_given_U0LT,
   AdmsSensFadType & modelPar_ETAMOB,
   bool modelPar_given_ETAMOB,
   AdmsSensFadType & modelPar_UP,
   bool modelPar_given_UP,
   AdmsSensFadType & modelPar_LPA,
   bool modelPar_given_LPA,
   AdmsSensFadType & modelPar_UPR,
   bool modelPar_given_UPR,
   AdmsSensFadType & modelPar_LPAR,
   bool modelPar_given_LPAR,
   AdmsSensFadType & modelPar_UA,
   bool modelPar_given_UA,
   AdmsSensFadType & modelPar_UAR,
   bool modelPar_given_UAR,
   AdmsSensFadType & modelPar_AUA,
   bool modelPar_given_AUA,
   AdmsSensFadType & modelPar_AUAR,
   bool modelPar_given_AUAR,
   AdmsSensFadType & modelPar_BUA,
   bool modelPar_given_BUA,
   AdmsSensFadType & modelPar_BUAR,
   bool modelPar_given_BUAR,
   AdmsSensFadType & modelPar_UC,
   bool modelPar_given_UC,
   AdmsSensFadType & modelPar_UCR,
   bool modelPar_given_UCR,
   AdmsSensFadType & modelPar_EU,
   bool modelPar_given_EU,
   AdmsSensFadType & modelPar_EUR,
   bool modelPar_given_EUR,
   AdmsSensFadType & modelPar_AEU,
   bool modelPar_given_AEU,
   AdmsSensFadType & modelPar_AEUR,
   bool modelPar_given_AEUR,
   AdmsSensFadType & modelPar_BEU,
   bool modelPar_given_BEU,
   AdmsSensFadType & modelPar_BEUR,
   bool modelPar_given_BEUR,
   AdmsSensFadType & modelPar_UD,
   bool modelPar_given_UD,
   AdmsSensFadType & modelPar_UDR,
   bool modelPar_given_UDR,
   AdmsSensFadType & modelPar_AUD,
   bool modelPar_given_AUD,
   AdmsSensFadType & modelPar_AUDR,
   bool modelPar_given_AUDR,
   AdmsSensFadType & modelPar_BUD,
   bool modelPar_given_BUD,
   AdmsSensFadType & modelPar_BUDR,
   bool modelPar_given_BUDR,
   AdmsSensFadType & modelPar_UCS,
   bool modelPar_given_UCS,
   AdmsSensFadType & modelPar_UTE,
   bool modelPar_given_UTE,
   AdmsSensFadType & modelPar_UTER,
   bool modelPar_given_UTER,
   AdmsSensFadType & modelPar_UTL,
   bool modelPar_given_UTL,
   AdmsSensFadType & modelPar_UTLR,
   bool modelPar_given_UTLR,
   AdmsSensFadType & modelPar_EMOBT,
   bool modelPar_given_EMOBT,
   AdmsSensFadType & modelPar_UA1,
   bool modelPar_given_UA1,
   AdmsSensFadType & modelPar_UA1R,
   bool modelPar_given_UA1R,
   AdmsSensFadType & modelPar_UC1,
   bool modelPar_given_UC1,
   AdmsSensFadType & modelPar_UC1R,
   bool modelPar_given_UC1R,
   AdmsSensFadType & modelPar_UD1,
   bool modelPar_given_UD1,
   AdmsSensFadType & modelPar_UD1R,
   bool modelPar_given_UD1R,
   AdmsSensFadType & modelPar_UCSTE,
   bool modelPar_given_UCSTE,
   AdmsSensFadType & modelPar_CHARGEWF,
   bool modelPar_given_CHARGEWF,
   AdmsSensFadType & modelPar_RDSWMIN,
   bool modelPar_given_RDSWMIN,
   AdmsSensFadType & modelPar_RDSW,
   bool modelPar_given_RDSW,
   AdmsSensFadType & modelPar_ARDSW,
   bool modelPar_given_ARDSW,
   AdmsSensFadType & modelPar_BRDSW,
   bool modelPar_given_BRDSW,
   AdmsSensFadType & modelPar_RSWMIN,
   bool modelPar_given_RSWMIN,
   AdmsSensFadType & modelPar_RSW,
   bool modelPar_given_RSW,
   AdmsSensFadType & modelPar_ARSW,
   bool modelPar_given_ARSW,
   AdmsSensFadType & modelPar_BRSW,
   bool modelPar_given_BRSW,
   AdmsSensFadType & modelPar_RDWMIN,
   bool modelPar_given_RDWMIN,
   AdmsSensFadType & modelPar_RDW,
   bool modelPar_given_RDW,
   AdmsSensFadType & modelPar_ARDW,
   bool modelPar_given_ARDW,
   AdmsSensFadType & modelPar_BRDW,
   bool modelPar_given_BRDW,
   AdmsSensFadType & modelPar_RSDR,
   bool modelPar_given_RSDR,
   AdmsSensFadType & modelPar_RSDRR,
   bool modelPar_given_RSDRR,
   AdmsSensFadType & modelPar_RDDR,
   bool modelPar_given_RDDR,
   AdmsSensFadType & modelPar_RDDRR,
   bool modelPar_given_RDDRR,
   AdmsSensFadType & modelPar_PRSDR,
   bool modelPar_given_PRSDR,
   AdmsSensFadType & modelPar_PRDDR,
   bool modelPar_given_PRDDR,
   AdmsSensFadType & modelPar_PRWGS,
   bool modelPar_given_PRWGS,
   AdmsSensFadType & modelPar_PRWGD,
   bool modelPar_given_PRWGD,
   AdmsSensFadType & modelPar_WR,
   bool modelPar_given_WR,
   AdmsSensFadType & modelPar_PRT,
   bool modelPar_given_PRT,
   AdmsSensFadType & modelPar_TRSDR,
   bool modelPar_given_TRSDR,
   AdmsSensFadType & modelPar_TRDDR,
   bool modelPar_given_TRDDR,
   AdmsSensFadType & modelPar_PDIBL1,
   bool modelPar_given_PDIBL1,
   AdmsSensFadType & modelPar_PDIBL1R,
   bool modelPar_given_PDIBL1R,
   AdmsSensFadType & modelPar_PDIBL2,
   bool modelPar_given_PDIBL2,
   AdmsSensFadType & modelPar_PDIBL2R,
   bool modelPar_given_PDIBL2R,
   AdmsSensFadType & modelPar_DROUT,
   bool modelPar_given_DROUT,
   AdmsSensFadType & modelPar_PVAG,
   bool modelPar_given_PVAG,
   AdmsSensFadType & modelPar_PCLM,
   bool modelPar_given_PCLM,
   AdmsSensFadType & modelPar_PCLMR,
   bool modelPar_given_PCLMR,
   AdmsSensFadType & modelPar_APCLM,
   bool modelPar_given_APCLM,
   AdmsSensFadType & modelPar_APCLMR,
   bool modelPar_given_APCLMR,
   AdmsSensFadType & modelPar_BPCLM,
   bool modelPar_given_BPCLM,
   AdmsSensFadType & modelPar_BPCLMR,
   bool modelPar_given_BPCLMR,
   AdmsSensFadType & modelPar_PCLMG,
   bool modelPar_given_PCLMG,
   AdmsSensFadType & modelPar_PCLMCV,
   bool modelPar_given_PCLMCV,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_A11,
   bool modelPar_given_A11,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_A21,
   bool modelPar_given_A21,
   AdmsSensFadType & modelPar_RGEXT,
   bool modelPar_given_RGEXT,
   AdmsSensFadType & modelPar_RGFIN,
   bool modelPar_given_RGFIN,
   AdmsSensFadType & modelPar_RSHS,
   bool modelPar_given_RSHS,
   AdmsSensFadType & modelPar_RSHD,
   bool modelPar_given_RSHD,
   AdmsSensFadType & modelPar_HEPI,
   bool modelPar_given_HEPI,
   AdmsSensFadType & modelPar_TSILI,
   bool modelPar_given_TSILI,
   AdmsSensFadType & modelPar_RHOC,
   bool modelPar_given_RHOC,
   AdmsSensFadType & modelPar_RHORSD,
   bool modelPar_given_RHORSD,
   AdmsSensFadType & modelPar_CRATIO,
   bool modelPar_given_CRATIO,
   AdmsSensFadType & modelPar_DELTAPRSD,
   bool modelPar_given_DELTAPRSD,
   AdmsSensFadType & modelPar_LSP,
   bool modelPar_given_LSP,
   AdmsSensFadType & modelPar_EPSRSP,
   bool modelPar_given_EPSRSP,
   AdmsSensFadType & modelPar_TGATE,
   bool modelPar_given_TGATE,
   AdmsSensFadType & modelPar_TMASK,
   bool modelPar_given_TMASK,
   AdmsSensFadType & modelPar_ASILIEND,
   bool modelPar_given_ASILIEND,
   AdmsSensFadType & modelPar_ARSDEND,
   bool modelPar_given_ARSDEND,
   AdmsSensFadType & modelPar_PRSDEND,
   bool modelPar_given_PRSDEND,
   AdmsSensFadType & modelPar_NSDE,
   bool modelPar_given_NSDE,
   AdmsSensFadType & modelPar_RGEOA,
   bool modelPar_given_RGEOA,
   AdmsSensFadType & modelPar_RGEOB,
   bool modelPar_given_RGEOB,
   AdmsSensFadType & modelPar_RGEOC,
   bool modelPar_given_RGEOC,
   AdmsSensFadType & modelPar_RGEOD,
   bool modelPar_given_RGEOD,
   AdmsSensFadType & modelPar_RGEOE,
   bool modelPar_given_RGEOE,
   AdmsSensFadType & modelPar_CGEOA,
   bool modelPar_given_CGEOA,
   AdmsSensFadType & modelPar_CGEOB,
   bool modelPar_given_CGEOB,
   AdmsSensFadType & modelPar_CGEOC,
   bool modelPar_given_CGEOC,
   AdmsSensFadType & modelPar_CGEOD,
   bool modelPar_given_CGEOD,
   AdmsSensFadType & modelPar_CGEOE,
   bool modelPar_given_CGEOE,
   AdmsSensFadType & modelPar_AIGBINV,
   bool modelPar_given_AIGBINV,
   AdmsSensFadType & modelPar_AIGBINV1,
   bool modelPar_given_AIGBINV1,
   AdmsSensFadType & modelPar_BIGBINV,
   bool modelPar_given_BIGBINV,
   AdmsSensFadType & modelPar_CIGBINV,
   bool modelPar_given_CIGBINV,
   AdmsSensFadType & modelPar_EIGBINV,
   bool modelPar_given_EIGBINV,
   AdmsSensFadType & modelPar_NIGBINV,
   bool modelPar_given_NIGBINV,
   AdmsSensFadType & modelPar_AIGBACC,
   bool modelPar_given_AIGBACC,
   AdmsSensFadType & modelPar_AIGBACC1,
   bool modelPar_given_AIGBACC1,
   AdmsSensFadType & modelPar_BIGBACC,
   bool modelPar_given_BIGBACC,
   AdmsSensFadType & modelPar_CIGBACC,
   bool modelPar_given_CIGBACC,
   AdmsSensFadType & modelPar_NIGBACC,
   bool modelPar_given_NIGBACC,
   AdmsSensFadType & modelPar_AIGC,
   bool modelPar_given_AIGC,
   AdmsSensFadType & modelPar_AIGC1,
   bool modelPar_given_AIGC1,
   AdmsSensFadType & modelPar_BIGC,
   bool modelPar_given_BIGC,
   AdmsSensFadType & modelPar_CIGC,
   bool modelPar_given_CIGC,
   AdmsSensFadType & modelPar_PIGCD,
   bool modelPar_given_PIGCD,
   AdmsSensFadType & modelPar_DLCIGS,
   bool modelPar_given_DLCIGS,
   AdmsSensFadType & modelPar_AIGS,
   bool modelPar_given_AIGS,
   AdmsSensFadType & modelPar_AIGS1,
   bool modelPar_given_AIGS1,
   AdmsSensFadType & modelPar_BIGS,
   bool modelPar_given_BIGS,
   AdmsSensFadType & modelPar_CIGS,
   bool modelPar_given_CIGS,
   AdmsSensFadType & modelPar_DLCIGD,
   bool modelPar_given_DLCIGD,
   AdmsSensFadType & modelPar_AIGD,
   bool modelPar_given_AIGD,
   AdmsSensFadType & modelPar_AIGD1,
   bool modelPar_given_AIGD1,
   AdmsSensFadType & modelPar_BIGD,
   bool modelPar_given_BIGD,
   AdmsSensFadType & modelPar_CIGD,
   bool modelPar_given_CIGD,
   AdmsSensFadType & modelPar_VFBSD,
   bool modelPar_given_VFBSD,
   AdmsSensFadType & modelPar_VFBSDCV,
   bool modelPar_given_VFBSDCV,
   AdmsSensFadType & modelPar_TOXREF,
   bool modelPar_given_TOXREF,
   AdmsSensFadType & modelPar_TOXG,
   bool modelPar_given_TOXG,
   AdmsSensFadType & modelPar_NTOX,
   bool modelPar_given_NTOX,
   AdmsSensFadType & modelPar_POXEDGE,
   bool modelPar_given_POXEDGE,
   AdmsSensFadType & modelPar_AGISL,
   bool modelPar_given_AGISL,
   AdmsSensFadType & modelPar_BGISL,
   bool modelPar_given_BGISL,
   AdmsSensFadType & modelPar_CGISL,
   bool modelPar_given_CGISL,
   AdmsSensFadType & modelPar_EGISL,
   bool modelPar_given_EGISL,
   AdmsSensFadType & modelPar_PGISL,
   bool modelPar_given_PGISL,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_EGIDL,
   bool modelPar_given_EGIDL,
   AdmsSensFadType & modelPar_PGIDL,
   bool modelPar_given_PGIDL,
   AdmsSensFadType & modelPar_ALPHA0,
   bool modelPar_given_ALPHA0,
   AdmsSensFadType & modelPar_ALPHA01,
   bool modelPar_given_ALPHA01,
   AdmsSensFadType & modelPar_ALPHA1,
   bool modelPar_given_ALPHA1,
   AdmsSensFadType & modelPar_ALPHA11,
   bool modelPar_given_ALPHA11,
   AdmsSensFadType & modelPar_BETA0,
   bool modelPar_given_BETA0,
   AdmsSensFadType & modelPar_ALPHAII0,
   bool modelPar_given_ALPHAII0,
   AdmsSensFadType & modelPar_ALPHAII01,
   bool modelPar_given_ALPHAII01,
   AdmsSensFadType & modelPar_ALPHAII1,
   bool modelPar_given_ALPHAII1,
   AdmsSensFadType & modelPar_ALPHAII11,
   bool modelPar_given_ALPHAII11,
   AdmsSensFadType & modelPar_BETAII0,
   bool modelPar_given_BETAII0,
   AdmsSensFadType & modelPar_BETAII1,
   bool modelPar_given_BETAII1,
   AdmsSensFadType & modelPar_BETAII2,
   bool modelPar_given_BETAII2,
   AdmsSensFadType & modelPar_ESATII,
   bool modelPar_given_ESATII,
   AdmsSensFadType & modelPar_LII,
   bool modelPar_given_LII,
   AdmsSensFadType & modelPar_SII0,
   bool modelPar_given_SII0,
   AdmsSensFadType & modelPar_SII1,
   bool modelPar_given_SII1,
   AdmsSensFadType & modelPar_SII2,
   bool modelPar_given_SII2,
   AdmsSensFadType & modelPar_SIID,
   bool modelPar_given_SIID,
   AdmsSensFadType & modelPar_IIMOD2CLAMP1,
   bool modelPar_given_IIMOD2CLAMP1,
   AdmsSensFadType & modelPar_IIMOD2CLAMP2,
   bool modelPar_given_IIMOD2CLAMP2,
   AdmsSensFadType & modelPar_IIMOD2CLAMP3,
   bool modelPar_given_IIMOD2CLAMP3,
   AdmsSensFadType & modelPar_EOTACC,
   bool modelPar_given_EOTACC,
   AdmsSensFadType & modelPar_DELVFBACC,
   bool modelPar_given_DELVFBACC,
   AdmsSensFadType & modelPar_CFS,
   bool modelPar_given_CFS,
   AdmsSensFadType & modelPar_CFD,
   bool modelPar_given_CFD,
   AdmsSensFadType & modelPar_CGSO,
   bool modelPar_given_CGSO,
   AdmsSensFadType & modelPar_CGDO,
   bool modelPar_given_CGDO,
   AdmsSensFadType & modelPar_CGSL,
   bool modelPar_given_CGSL,
   AdmsSensFadType & modelPar_CGDL,
   bool modelPar_given_CGDL,
   AdmsSensFadType & modelPar_CKAPPAS,
   bool modelPar_given_CKAPPAS,
   AdmsSensFadType & modelPar_CKAPPAD,
   bool modelPar_given_CKAPPAD,
   AdmsSensFadType & modelPar_CGBO,
   bool modelPar_given_CGBO,
   AdmsSensFadType & modelPar_CGBN,
   bool modelPar_given_CGBN,
   AdmsSensFadType & modelPar_CGBL,
   bool modelPar_given_CGBL,
   AdmsSensFadType & modelPar_CKAPPAB,
   bool modelPar_given_CKAPPAB,
   AdmsSensFadType & modelPar_CSDESW,
   bool modelPar_given_CSDESW,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_CJD,
   bool modelPar_given_CJD,
   AdmsSensFadType & modelPar_CJSWS,
   bool modelPar_given_CJSWS,
   AdmsSensFadType & modelPar_CJSWD,
   bool modelPar_given_CJSWD,
   AdmsSensFadType & modelPar_CJSWGS,
   bool modelPar_given_CJSWGS,
   AdmsSensFadType & modelPar_CJSWGD,
   bool modelPar_given_CJSWGD,
   AdmsSensFadType & modelPar_PBS,
   bool modelPar_given_PBS,
   AdmsSensFadType & modelPar_PBD,
   bool modelPar_given_PBD,
   AdmsSensFadType & modelPar_PBSWS,
   bool modelPar_given_PBSWS,
   AdmsSensFadType & modelPar_PBSWD,
   bool modelPar_given_PBSWD,
   AdmsSensFadType & modelPar_PBSWGS,
   bool modelPar_given_PBSWGS,
   AdmsSensFadType & modelPar_PBSWGD,
   bool modelPar_given_PBSWGD,
   AdmsSensFadType & modelPar_MJS,
   bool modelPar_given_MJS,
   AdmsSensFadType & modelPar_MJD,
   bool modelPar_given_MJD,
   AdmsSensFadType & modelPar_MJSWS,
   bool modelPar_given_MJSWS,
   AdmsSensFadType & modelPar_MJSWD,
   bool modelPar_given_MJSWD,
   AdmsSensFadType & modelPar_MJSWGS,
   bool modelPar_given_MJSWGS,
   AdmsSensFadType & modelPar_MJSWGD,
   bool modelPar_given_MJSWGD,
   AdmsSensFadType & modelPar_SJS,
   bool modelPar_given_SJS,
   AdmsSensFadType & modelPar_SJD,
   bool modelPar_given_SJD,
   AdmsSensFadType & modelPar_SJSWS,
   bool modelPar_given_SJSWS,
   AdmsSensFadType & modelPar_SJSWD,
   bool modelPar_given_SJSWD,
   AdmsSensFadType & modelPar_SJSWGS,
   bool modelPar_given_SJSWGS,
   AdmsSensFadType & modelPar_SJSWGD,
   bool modelPar_given_SJSWGD,
   AdmsSensFadType & modelPar_MJS2,
   bool modelPar_given_MJS2,
   AdmsSensFadType & modelPar_MJD2,
   bool modelPar_given_MJD2,
   AdmsSensFadType & modelPar_MJSWS2,
   bool modelPar_given_MJSWS2,
   AdmsSensFadType & modelPar_MJSWD2,
   bool modelPar_given_MJSWD2,
   AdmsSensFadType & modelPar_MJSWGS2,
   bool modelPar_given_MJSWGS2,
   AdmsSensFadType & modelPar_MJSWGD2,
   bool modelPar_given_MJSWGD2,
   AdmsSensFadType & modelPar_JSS,
   bool modelPar_given_JSS,
   AdmsSensFadType & modelPar_JSD,
   bool modelPar_given_JSD,
   AdmsSensFadType & modelPar_JSWS,
   bool modelPar_given_JSWS,
   AdmsSensFadType & modelPar_JSWD,
   bool modelPar_given_JSWD,
   AdmsSensFadType & modelPar_JSWGS,
   bool modelPar_given_JSWGS,
   AdmsSensFadType & modelPar_JSWGD,
   bool modelPar_given_JSWGD,
   AdmsSensFadType & modelPar_NJS,
   bool modelPar_given_NJS,
   AdmsSensFadType & modelPar_NJD,
   bool modelPar_given_NJD,
   AdmsSensFadType & modelPar_IJTHSFWD,
   bool modelPar_given_IJTHSFWD,
   AdmsSensFadType & modelPar_IJTHDFWD,
   bool modelPar_given_IJTHDFWD,
   AdmsSensFadType & modelPar_IJTHSREV,
   bool modelPar_given_IJTHSREV,
   AdmsSensFadType & modelPar_IJTHDREV,
   bool modelPar_given_IJTHDREV,
   AdmsSensFadType & modelPar_BVS,
   bool modelPar_given_BVS,
   AdmsSensFadType & modelPar_BVD,
   bool modelPar_given_BVD,
   AdmsSensFadType & modelPar_XJBVS,
   bool modelPar_given_XJBVS,
   AdmsSensFadType & modelPar_XJBVD,
   bool modelPar_given_XJBVD,
   AdmsSensFadType & modelPar_JTSS,
   bool modelPar_given_JTSS,
   AdmsSensFadType & modelPar_JTSD,
   bool modelPar_given_JTSD,
   AdmsSensFadType & modelPar_JTSSWS,
   bool modelPar_given_JTSSWS,
   AdmsSensFadType & modelPar_JTSSWD,
   bool modelPar_given_JTSSWD,
   AdmsSensFadType & modelPar_JTSSWGS,
   bool modelPar_given_JTSSWGS,
   AdmsSensFadType & modelPar_JTSSWGD,
   bool modelPar_given_JTSSWGD,
   AdmsSensFadType & modelPar_JTWEFF,
   bool modelPar_given_JTWEFF,
   AdmsSensFadType & modelPar_NJTS,
   bool modelPar_given_NJTS,
   AdmsSensFadType & modelPar_NJTSD,
   bool modelPar_given_NJTSD,
   AdmsSensFadType & modelPar_NJTSSW,
   bool modelPar_given_NJTSSW,
   AdmsSensFadType & modelPar_NJTSSWD,
   bool modelPar_given_NJTSSWD,
   AdmsSensFadType & modelPar_NJTSSWG,
   bool modelPar_given_NJTSSWG,
   AdmsSensFadType & modelPar_NJTSSWGD,
   bool modelPar_given_NJTSSWGD,
   AdmsSensFadType & modelPar_VTSS,
   bool modelPar_given_VTSS,
   AdmsSensFadType & modelPar_VTSD,
   bool modelPar_given_VTSD,
   AdmsSensFadType & modelPar_VTSSWS,
   bool modelPar_given_VTSSWS,
   AdmsSensFadType & modelPar_VTSSWD,
   bool modelPar_given_VTSSWD,
   AdmsSensFadType & modelPar_VTSSWGS,
   bool modelPar_given_VTSSWGS,
   AdmsSensFadType & modelPar_VTSSWGD,
   bool modelPar_given_VTSSWGD,
   AdmsSensFadType & modelPar_LINTIGEN,
   bool modelPar_given_LINTIGEN,
   AdmsSensFadType & modelPar_NTGEN,
   bool modelPar_given_NTGEN,
   AdmsSensFadType & modelPar_AIGEN,
   bool modelPar_given_AIGEN,
   AdmsSensFadType & modelPar_BIGEN,
   bool modelPar_given_BIGEN,
   AdmsSensFadType & modelPar_XRCRG1,
   bool modelPar_given_XRCRG1,
   AdmsSensFadType & modelPar_XRCRG2,
   bool modelPar_given_XRCRG2,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_EM,
   bool modelPar_given_EM,
   AdmsSensFadType & modelPar_NOIA,
   bool modelPar_given_NOIA,
   AdmsSensFadType & modelPar_NOIB,
   bool modelPar_given_NOIB,
   AdmsSensFadType & modelPar_NOIC,
   bool modelPar_given_NOIC,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_NTNOI,
   bool modelPar_given_NTNOI,
   AdmsSensFadType & modelPar_TNOIA,
   bool modelPar_given_TNOIA,
   AdmsSensFadType & modelPar_TNOIB,
   bool modelPar_given_TNOIB,
   AdmsSensFadType & modelPar_RNOIA,
   bool modelPar_given_RNOIA,
   AdmsSensFadType & modelPar_RNOIB,
   bool modelPar_given_RNOIB,
   AdmsSensFadType & modelPar_TNOIC,
   bool modelPar_given_TNOIC,
   AdmsSensFadType & modelPar_RNOIC,
   bool modelPar_given_RNOIC,
   AdmsSensFadType & modelPar_SCALEN,
   bool modelPar_given_SCALEN,
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_TBGASUB,
   bool modelPar_given_TBGASUB,
   AdmsSensFadType & modelPar_TBGBSUB,
   bool modelPar_given_TBGBSUB,
   AdmsSensFadType & modelPar_KT1,
   bool modelPar_given_KT1,
   AdmsSensFadType & modelPar_KT1L,
   bool modelPar_given_KT1L,
   AdmsSensFadType & modelPar_TSS,
   bool modelPar_given_TSS,
   AdmsSensFadType & modelPar_IIT,
   bool modelPar_given_IIT,
   AdmsSensFadType & modelPar_TII,
   bool modelPar_given_TII,
   AdmsSensFadType & modelPar_TGIDL,
   bool modelPar_given_TGIDL,
   AdmsSensFadType & modelPar_IGT,
   bool modelPar_given_IGT,
   AdmsSensFadType & modelPar_TCJ,
   bool modelPar_given_TCJ,
   AdmsSensFadType & modelPar_TCJSW,
   bool modelPar_given_TCJSW,
   AdmsSensFadType & modelPar_TCJSWG,
   bool modelPar_given_TCJSWG,
   AdmsSensFadType & modelPar_TPB,
   bool modelPar_given_TPB,
   AdmsSensFadType & modelPar_TPBSW,
   bool modelPar_given_TPBSW,
   AdmsSensFadType & modelPar_TPBSWG,
   bool modelPar_given_TPBSWG,
   AdmsSensFadType & modelPar_XTIS,
   bool modelPar_given_XTIS,
   AdmsSensFadType & modelPar_XTID,
   bool modelPar_given_XTID,
   AdmsSensFadType & modelPar_XTSS,
   bool modelPar_given_XTSS,
   AdmsSensFadType & modelPar_XTSD,
   bool modelPar_given_XTSD,
   AdmsSensFadType & modelPar_XTSSWS,
   bool modelPar_given_XTSSWS,
   AdmsSensFadType & modelPar_XTSSWD,
   bool modelPar_given_XTSSWD,
   AdmsSensFadType & modelPar_XTSSWGS,
   bool modelPar_given_XTSSWGS,
   AdmsSensFadType & modelPar_XTSSWGD,
   bool modelPar_given_XTSSWGD,
   AdmsSensFadType & modelPar_TNJTS,
   bool modelPar_given_TNJTS,
   AdmsSensFadType & modelPar_TNJTSD,
   bool modelPar_given_TNJTSD,
   AdmsSensFadType & modelPar_TNJTSSW,
   bool modelPar_given_TNJTSSW,
   AdmsSensFadType & modelPar_TNJTSSWD,
   bool modelPar_given_TNJTSSWD,
   AdmsSensFadType & modelPar_TNJTSSWG,
   bool modelPar_given_TNJTSSWG,
   AdmsSensFadType & modelPar_TNJTSSWGD,
   bool modelPar_given_TNJTSSWGD,
   AdmsSensFadType & modelPar_RTH0,
   bool modelPar_given_RTH0,
   AdmsSensFadType & modelPar_CTH0,
   bool modelPar_given_CTH0,
   AdmsSensFadType & modelPar_WTH0,
   bool modelPar_given_WTH0,
   AdmsSensFadType & modelPar_ASHEXP,
   bool modelPar_given_ASHEXP,
   AdmsSensFadType & modelPar_BSHEXP,
   bool modelPar_given_BSHEXP,
   AdmsSensFadType & modelPar_ACH_UFCM,
   bool modelPar_given_ACH_UFCM,
   AdmsSensFadType & modelPar_CINS_UFCM,
   bool modelPar_given_CINS_UFCM,
   AdmsSensFadType & modelPar_W_UFCM,
   bool modelPar_given_W_UFCM,
   AdmsSensFadType & modelPar_TFIN_TOP,
   bool modelPar_given_TFIN_TOP,
   AdmsSensFadType & modelPar_TFIN_BASE,
   bool modelPar_given_TFIN_BASE,
   AdmsSensFadType & modelPar_QMFACTORCV,
   bool modelPar_given_QMFACTORCV,
   AdmsSensFadType & modelPar_ALPHA_UFCM,
   bool modelPar_given_ALPHA_UFCM,
   AdmsSensFadType & modelPar_LNBODY,
   bool modelPar_given_LNBODY,
   AdmsSensFadType & modelPar_NNBODY,
   bool modelPar_given_NNBODY,
   AdmsSensFadType & modelPar_PNBODY,
   bool modelPar_given_PNBODY,
   AdmsSensFadType & modelPar_LPHIG,
   bool modelPar_given_LPHIG,
   AdmsSensFadType & modelPar_NPHIG,
   bool modelPar_given_NPHIG,
   AdmsSensFadType & modelPar_PPHIG,
   bool modelPar_given_PPHIG,
   AdmsSensFadType & modelPar_LNGATE,
   bool modelPar_given_LNGATE,
   AdmsSensFadType & modelPar_NNGATE,
   bool modelPar_given_NNGATE,
   AdmsSensFadType & modelPar_PNGATE,
   bool modelPar_given_PNGATE,
   AdmsSensFadType & modelPar_LCIT,
   bool modelPar_given_LCIT,
   AdmsSensFadType & modelPar_NCIT,
   bool modelPar_given_NCIT,
   AdmsSensFadType & modelPar_PCIT,
   bool modelPar_given_PCIT,
   AdmsSensFadType & modelPar_LCITR,
   bool modelPar_given_LCITR,
   AdmsSensFadType & modelPar_NCITR,
   bool modelPar_given_NCITR,
   AdmsSensFadType & modelPar_PCITR,
   bool modelPar_given_PCITR,
   AdmsSensFadType & modelPar_LCDSC,
   bool modelPar_given_LCDSC,
   AdmsSensFadType & modelPar_NCDSC,
   bool modelPar_given_NCDSC,
   AdmsSensFadType & modelPar_PCDSC,
   bool modelPar_given_PCDSC,
   AdmsSensFadType & modelPar_LCDSCD,
   bool modelPar_given_LCDSCD,
   AdmsSensFadType & modelPar_NCDSCD,
   bool modelPar_given_NCDSCD,
   AdmsSensFadType & modelPar_PCDSCD,
   bool modelPar_given_PCDSCD,
   AdmsSensFadType & modelPar_LCDSCDR,
   bool modelPar_given_LCDSCDR,
   AdmsSensFadType & modelPar_NCDSCDR,
   bool modelPar_given_NCDSCDR,
   AdmsSensFadType & modelPar_PCDSCDR,
   bool modelPar_given_PCDSCDR,
   AdmsSensFadType & modelPar_LDVT0,
   bool modelPar_given_LDVT0,
   AdmsSensFadType & modelPar_NDVT0,
   bool modelPar_given_NDVT0,
   AdmsSensFadType & modelPar_PDVT0,
   bool modelPar_given_PDVT0,
   AdmsSensFadType & modelPar_LDVT1,
   bool modelPar_given_LDVT1,
   AdmsSensFadType & modelPar_NDVT1,
   bool modelPar_given_NDVT1,
   AdmsSensFadType & modelPar_PDVT1,
   bool modelPar_given_PDVT1,
   AdmsSensFadType & modelPar_LDVT1SS,
   bool modelPar_given_LDVT1SS,
   AdmsSensFadType & modelPar_NDVT1SS,
   bool modelPar_given_NDVT1SS,
   AdmsSensFadType & modelPar_PDVT1SS,
   bool modelPar_given_PDVT1SS,
   AdmsSensFadType & modelPar_LPHIN,
   bool modelPar_given_LPHIN,
   AdmsSensFadType & modelPar_NPHIN,
   bool modelPar_given_NPHIN,
   AdmsSensFadType & modelPar_PPHIN,
   bool modelPar_given_PPHIN,
   AdmsSensFadType & modelPar_LETA0,
   bool modelPar_given_LETA0,
   AdmsSensFadType & modelPar_NETA0,
   bool modelPar_given_NETA0,
   AdmsSensFadType & modelPar_PETA0,
   bool modelPar_given_PETA0,
   AdmsSensFadType & modelPar_LETA0R,
   bool modelPar_given_LETA0R,
   AdmsSensFadType & modelPar_NETA0R,
   bool modelPar_given_NETA0R,
   AdmsSensFadType & modelPar_PETA0R,
   bool modelPar_given_PETA0R,
   AdmsSensFadType & modelPar_LDSUB,
   bool modelPar_given_LDSUB,
   AdmsSensFadType & modelPar_NDSUB,
   bool modelPar_given_NDSUB,
   AdmsSensFadType & modelPar_PDSUB,
   bool modelPar_given_PDSUB,
   AdmsSensFadType & modelPar_LK1RSCE,
   bool modelPar_given_LK1RSCE,
   AdmsSensFadType & modelPar_NK1RSCE,
   bool modelPar_given_NK1RSCE,
   AdmsSensFadType & modelPar_PK1RSCE,
   bool modelPar_given_PK1RSCE,
   AdmsSensFadType & modelPar_LLPE0,
   bool modelPar_given_LLPE0,
   AdmsSensFadType & modelPar_NLPE0,
   bool modelPar_given_NLPE0,
   AdmsSensFadType & modelPar_PLPE0,
   bool modelPar_given_PLPE0,
   AdmsSensFadType & modelPar_LDVTSHIFT,
   bool modelPar_given_LDVTSHIFT,
   AdmsSensFadType & modelPar_NDVTSHIFT,
   bool modelPar_given_NDVTSHIFT,
   AdmsSensFadType & modelPar_PDVTSHIFT,
   bool modelPar_given_PDVTSHIFT,
   AdmsSensFadType & modelPar_LDVTSHIFTR,
   bool modelPar_given_LDVTSHIFTR,
   AdmsSensFadType & modelPar_NDVTSHIFTR,
   bool modelPar_given_NDVTSHIFTR,
   AdmsSensFadType & modelPar_PDVTSHIFTR,
   bool modelPar_given_PDVTSHIFTR,
   AdmsSensFadType & modelPar_LPHIBE,
   bool modelPar_given_LPHIBE,
   AdmsSensFadType & modelPar_NPHIBE,
   bool modelPar_given_NPHIBE,
   AdmsSensFadType & modelPar_PPHIBE,
   bool modelPar_given_PPHIBE,
   AdmsSensFadType & modelPar_LK0,
   bool modelPar_given_LK0,
   AdmsSensFadType & modelPar_NK0,
   bool modelPar_given_NK0,
   AdmsSensFadType & modelPar_PK0,
   bool modelPar_given_PK0,
   AdmsSensFadType & modelPar_LK01,
   bool modelPar_given_LK01,
   AdmsSensFadType & modelPar_NK01,
   bool modelPar_given_NK01,
   AdmsSensFadType & modelPar_PK01,
   bool modelPar_given_PK01,
   AdmsSensFadType & modelPar_LK0SI,
   bool modelPar_given_LK0SI,
   AdmsSensFadType & modelPar_NK0SI,
   bool modelPar_given_NK0SI,
   AdmsSensFadType & modelPar_PK0SI,
   bool modelPar_given_PK0SI,
   AdmsSensFadType & modelPar_LK0SI1,
   bool modelPar_given_LK0SI1,
   AdmsSensFadType & modelPar_NK0SI1,
   bool modelPar_given_NK0SI1,
   AdmsSensFadType & modelPar_PK0SI1,
   bool modelPar_given_PK0SI1,
   AdmsSensFadType & modelPar_LK1,
   bool modelPar_given_LK1,
   AdmsSensFadType & modelPar_NK1,
   bool modelPar_given_NK1,
   AdmsSensFadType & modelPar_PK1,
   bool modelPar_given_PK1,
   AdmsSensFadType & modelPar_LK11,
   bool modelPar_given_LK11,
   AdmsSensFadType & modelPar_NK11,
   bool modelPar_given_NK11,
   AdmsSensFadType & modelPar_PK11,
   bool modelPar_given_PK11,
   AdmsSensFadType & modelPar_LK2SI,
   bool modelPar_given_LK2SI,
   AdmsSensFadType & modelPar_NK2SI,
   bool modelPar_given_NK2SI,
   AdmsSensFadType & modelPar_PK2SI,
   bool modelPar_given_PK2SI,
   AdmsSensFadType & modelPar_LK2SI1,
   bool modelPar_given_LK2SI1,
   AdmsSensFadType & modelPar_NK2SI1,
   bool modelPar_given_NK2SI1,
   AdmsSensFadType & modelPar_PK2SI1,
   bool modelPar_given_PK2SI1,
   AdmsSensFadType & modelPar_LK0SISAT,
   bool modelPar_given_LK0SISAT,
   AdmsSensFadType & modelPar_NK0SISAT,
   bool modelPar_given_NK0SISAT,
   AdmsSensFadType & modelPar_PK0SISAT,
   bool modelPar_given_PK0SISAT,
   AdmsSensFadType & modelPar_LK0SISAT1,
   bool modelPar_given_LK0SISAT1,
   AdmsSensFadType & modelPar_NK0SISAT1,
   bool modelPar_given_NK0SISAT1,
   AdmsSensFadType & modelPar_PK0SISAT1,
   bool modelPar_given_PK0SISAT1,
   AdmsSensFadType & modelPar_LK2SISAT,
   bool modelPar_given_LK2SISAT,
   AdmsSensFadType & modelPar_NK2SISAT,
   bool modelPar_given_NK2SISAT,
   AdmsSensFadType & modelPar_PK2SISAT,
   bool modelPar_given_PK2SISAT,
   AdmsSensFadType & modelPar_LK2SISAT1,
   bool modelPar_given_LK2SISAT1,
   AdmsSensFadType & modelPar_NK2SISAT1,
   bool modelPar_given_NK2SISAT1,
   AdmsSensFadType & modelPar_PK2SISAT1,
   bool modelPar_given_PK2SISAT1,
   AdmsSensFadType & modelPar_LK2SAT,
   bool modelPar_given_LK2SAT,
   AdmsSensFadType & modelPar_NK2SAT,
   bool modelPar_given_NK2SAT,
   AdmsSensFadType & modelPar_PK2SAT,
   bool modelPar_given_PK2SAT,
   AdmsSensFadType & modelPar_LK2SAT1,
   bool modelPar_given_LK2SAT1,
   AdmsSensFadType & modelPar_NK2SAT1,
   bool modelPar_given_NK2SAT1,
   AdmsSensFadType & modelPar_PK2SAT1,
   bool modelPar_given_PK2SAT1,
   AdmsSensFadType & modelPar_LK2,
   bool modelPar_given_LK2,
   AdmsSensFadType & modelPar_NK2,
   bool modelPar_given_NK2,
   AdmsSensFadType & modelPar_PK2,
   bool modelPar_given_PK2,
   AdmsSensFadType & modelPar_LK21,
   bool modelPar_given_LK21,
   AdmsSensFadType & modelPar_NK21,
   bool modelPar_given_NK21,
   AdmsSensFadType & modelPar_PK21,
   bool modelPar_given_PK21,
   AdmsSensFadType & modelPar_LDVTB,
   bool modelPar_given_LDVTB,
   AdmsSensFadType & modelPar_NDVTB,
   bool modelPar_given_NDVTB,
   AdmsSensFadType & modelPar_PDVTB,
   bool modelPar_given_PDVTB,
   AdmsSensFadType & modelPar_LLPEB,
   bool modelPar_given_LLPEB,
   AdmsSensFadType & modelPar_NLPEB,
   bool modelPar_given_NLPEB,
   AdmsSensFadType & modelPar_PLPEB,
   bool modelPar_given_PLPEB,
   AdmsSensFadType & modelPar_LQMFACTOR,
   bool modelPar_given_LQMFACTOR,
   AdmsSensFadType & modelPar_NQMFACTOR,
   bool modelPar_given_NQMFACTOR,
   AdmsSensFadType & modelPar_PQMFACTOR,
   bool modelPar_given_PQMFACTOR,
   AdmsSensFadType & modelPar_LQMTCENCV,
   bool modelPar_given_LQMTCENCV,
   AdmsSensFadType & modelPar_NQMTCENCV,
   bool modelPar_given_NQMTCENCV,
   AdmsSensFadType & modelPar_PQMTCENCV,
   bool modelPar_given_PQMTCENCV,
   AdmsSensFadType & modelPar_LQMTCENCVA,
   bool modelPar_given_LQMTCENCVA,
   AdmsSensFadType & modelPar_NQMTCENCVA,
   bool modelPar_given_NQMTCENCVA,
   AdmsSensFadType & modelPar_PQMTCENCVA,
   bool modelPar_given_PQMTCENCVA,
   AdmsSensFadType & modelPar_LVSAT,
   bool modelPar_given_LVSAT,
   AdmsSensFadType & modelPar_NVSAT,
   bool modelPar_given_NVSAT,
   AdmsSensFadType & modelPar_PVSAT,
   bool modelPar_given_PVSAT,
   AdmsSensFadType & modelPar_LVSATR,
   bool modelPar_given_LVSATR,
   AdmsSensFadType & modelPar_NVSATR,
   bool modelPar_given_NVSATR,
   AdmsSensFadType & modelPar_PVSATR,
   bool modelPar_given_PVSATR,
   AdmsSensFadType & modelPar_LVSAT1,
   bool modelPar_given_LVSAT1,
   AdmsSensFadType & modelPar_NVSAT1,
   bool modelPar_given_NVSAT1,
   AdmsSensFadType & modelPar_PVSAT1,
   bool modelPar_given_PVSAT1,
   AdmsSensFadType & modelPar_LVSAT1R,
   bool modelPar_given_LVSAT1R,
   AdmsSensFadType & modelPar_NVSAT1R,
   bool modelPar_given_NVSAT1R,
   AdmsSensFadType & modelPar_PVSAT1R,
   bool modelPar_given_PVSAT1R,
   AdmsSensFadType & modelPar_LPSAT,
   bool modelPar_given_LPSAT,
   AdmsSensFadType & modelPar_NPSAT,
   bool modelPar_given_NPSAT,
   AdmsSensFadType & modelPar_PPSAT,
   bool modelPar_given_PPSAT,
   AdmsSensFadType & modelPar_LDELTAVSAT,
   bool modelPar_given_LDELTAVSAT,
   AdmsSensFadType & modelPar_NDELTAVSAT,
   bool modelPar_given_NDELTAVSAT,
   AdmsSensFadType & modelPar_PDELTAVSAT,
   bool modelPar_given_PDELTAVSAT,
   AdmsSensFadType & modelPar_LKSATIV,
   bool modelPar_given_LKSATIV,
   AdmsSensFadType & modelPar_NKSATIV,
   bool modelPar_given_NKSATIV,
   AdmsSensFadType & modelPar_PKSATIV,
   bool modelPar_given_PKSATIV,
   AdmsSensFadType & modelPar_LKSATIVR,
   bool modelPar_given_LKSATIVR,
   AdmsSensFadType & modelPar_NKSATIVR,
   bool modelPar_given_NKSATIVR,
   AdmsSensFadType & modelPar_PKSATIVR,
   bool modelPar_given_PKSATIVR,
   AdmsSensFadType & modelPar_LVSATCV,
   bool modelPar_given_LVSATCV,
   AdmsSensFadType & modelPar_NVSATCV,
   bool modelPar_given_NVSATCV,
   AdmsSensFadType & modelPar_PVSATCV,
   bool modelPar_given_PVSATCV,
   AdmsSensFadType & modelPar_LPSATCV,
   bool modelPar_given_LPSATCV,
   AdmsSensFadType & modelPar_NPSATCV,
   bool modelPar_given_NPSATCV,
   AdmsSensFadType & modelPar_PPSATCV,
   bool modelPar_given_PPSATCV,
   AdmsSensFadType & modelPar_LDELTAVSATCV,
   bool modelPar_given_LDELTAVSATCV,
   AdmsSensFadType & modelPar_NDELTAVSATCV,
   bool modelPar_given_NDELTAVSATCV,
   AdmsSensFadType & modelPar_PDELTAVSATCV,
   bool modelPar_given_PDELTAVSATCV,
   AdmsSensFadType & modelPar_LMEXP,
   bool modelPar_given_LMEXP,
   AdmsSensFadType & modelPar_NMEXP,
   bool modelPar_given_NMEXP,
   AdmsSensFadType & modelPar_PMEXP,
   bool modelPar_given_PMEXP,
   AdmsSensFadType & modelPar_LMEXPR,
   bool modelPar_given_LMEXPR,
   AdmsSensFadType & modelPar_NMEXPR,
   bool modelPar_given_NMEXPR,
   AdmsSensFadType & modelPar_PMEXPR,
   bool modelPar_given_PMEXPR,
   AdmsSensFadType & modelPar_LPTWG,
   bool modelPar_given_LPTWG,
   AdmsSensFadType & modelPar_NPTWG,
   bool modelPar_given_NPTWG,
   AdmsSensFadType & modelPar_PPTWG,
   bool modelPar_given_PPTWG,
   AdmsSensFadType & modelPar_LPTWGR,
   bool modelPar_given_LPTWGR,
   AdmsSensFadType & modelPar_NPTWGR,
   bool modelPar_given_NPTWGR,
   AdmsSensFadType & modelPar_PPTWGR,
   bool modelPar_given_PPTWGR,
   AdmsSensFadType & modelPar_LU0,
   bool modelPar_given_LU0,
   AdmsSensFadType & modelPar_NU0,
   bool modelPar_given_NU0,
   AdmsSensFadType & modelPar_PU0,
   bool modelPar_given_PU0,
   AdmsSensFadType & modelPar_LU0R,
   bool modelPar_given_LU0R,
   AdmsSensFadType & modelPar_NU0R,
   bool modelPar_given_NU0R,
   AdmsSensFadType & modelPar_PU0R,
   bool modelPar_given_PU0R,
   AdmsSensFadType & modelPar_LETAMOB,
   bool modelPar_given_LETAMOB,
   AdmsSensFadType & modelPar_NETAMOB,
   bool modelPar_given_NETAMOB,
   AdmsSensFadType & modelPar_PETAMOB,
   bool modelPar_given_PETAMOB,
   AdmsSensFadType & modelPar_LUP,
   bool modelPar_given_LUP,
   AdmsSensFadType & modelPar_NUP,
   bool modelPar_given_NUP,
   AdmsSensFadType & modelPar_PUP,
   bool modelPar_given_PUP,
   AdmsSensFadType & modelPar_LUPR,
   bool modelPar_given_LUPR,
   AdmsSensFadType & modelPar_NUPR,
   bool modelPar_given_NUPR,
   AdmsSensFadType & modelPar_PUPR,
   bool modelPar_given_PUPR,
   AdmsSensFadType & modelPar_LUA,
   bool modelPar_given_LUA,
   AdmsSensFadType & modelPar_NUA,
   bool modelPar_given_NUA,
   AdmsSensFadType & modelPar_PUA,
   bool modelPar_given_PUA,
   AdmsSensFadType & modelPar_LUAR,
   bool modelPar_given_LUAR,
   AdmsSensFadType & modelPar_NUAR,
   bool modelPar_given_NUAR,
   AdmsSensFadType & modelPar_PUAR,
   bool modelPar_given_PUAR,
   AdmsSensFadType & modelPar_LUC,
   bool modelPar_given_LUC,
   AdmsSensFadType & modelPar_NUC,
   bool modelPar_given_NUC,
   AdmsSensFadType & modelPar_PUC,
   bool modelPar_given_PUC,
   AdmsSensFadType & modelPar_LUCR,
   bool modelPar_given_LUCR,
   AdmsSensFadType & modelPar_NUCR,
   bool modelPar_given_NUCR,
   AdmsSensFadType & modelPar_PUCR,
   bool modelPar_given_PUCR,
   AdmsSensFadType & modelPar_LEU,
   bool modelPar_given_LEU,
   AdmsSensFadType & modelPar_NEU,
   bool modelPar_given_NEU,
   AdmsSensFadType & modelPar_PEU,
   bool modelPar_given_PEU,
   AdmsSensFadType & modelPar_LEUR,
   bool modelPar_given_LEUR,
   AdmsSensFadType & modelPar_NEUR,
   bool modelPar_given_NEUR,
   AdmsSensFadType & modelPar_PEUR,
   bool modelPar_given_PEUR,
   AdmsSensFadType & modelPar_LUD,
   bool modelPar_given_LUD,
   AdmsSensFadType & modelPar_NUD,
   bool modelPar_given_NUD,
   AdmsSensFadType & modelPar_PUD,
   bool modelPar_given_PUD,
   AdmsSensFadType & modelPar_LUDR,
   bool modelPar_given_LUDR,
   AdmsSensFadType & modelPar_NUDR,
   bool modelPar_given_NUDR,
   AdmsSensFadType & modelPar_PUDR,
   bool modelPar_given_PUDR,
   AdmsSensFadType & modelPar_LUCS,
   bool modelPar_given_LUCS,
   AdmsSensFadType & modelPar_NUCS,
   bool modelPar_given_NUCS,
   AdmsSensFadType & modelPar_PUCS,
   bool modelPar_given_PUCS,
   AdmsSensFadType & modelPar_LPCLM,
   bool modelPar_given_LPCLM,
   AdmsSensFadType & modelPar_NPCLM,
   bool modelPar_given_NPCLM,
   AdmsSensFadType & modelPar_PPCLM,
   bool modelPar_given_PPCLM,
   AdmsSensFadType & modelPar_LPCLMR,
   bool modelPar_given_LPCLMR,
   AdmsSensFadType & modelPar_NPCLMR,
   bool modelPar_given_NPCLMR,
   AdmsSensFadType & modelPar_PPCLMR,
   bool modelPar_given_PPCLMR,
   AdmsSensFadType & modelPar_LPCLMG,
   bool modelPar_given_LPCLMG,
   AdmsSensFadType & modelPar_NPCLMG,
   bool modelPar_given_NPCLMG,
   AdmsSensFadType & modelPar_PPCLMG,
   bool modelPar_given_PPCLMG,
   AdmsSensFadType & modelPar_LPCLMCV,
   bool modelPar_given_LPCLMCV,
   AdmsSensFadType & modelPar_NPCLMCV,
   bool modelPar_given_NPCLMCV,
   AdmsSensFadType & modelPar_PPCLMCV,
   bool modelPar_given_PPCLMCV,
   AdmsSensFadType & modelPar_LA1,
   bool modelPar_given_LA1,
   AdmsSensFadType & modelPar_NA1,
   bool modelPar_given_NA1,
   AdmsSensFadType & modelPar_PA1,
   bool modelPar_given_PA1,
   AdmsSensFadType & modelPar_LA11,
   bool modelPar_given_LA11,
   AdmsSensFadType & modelPar_NA11,
   bool modelPar_given_NA11,
   AdmsSensFadType & modelPar_PA11,
   bool modelPar_given_PA11,
   AdmsSensFadType & modelPar_LA2,
   bool modelPar_given_LA2,
   AdmsSensFadType & modelPar_NA2,
   bool modelPar_given_NA2,
   AdmsSensFadType & modelPar_PA2,
   bool modelPar_given_PA2,
   AdmsSensFadType & modelPar_LA21,
   bool modelPar_given_LA21,
   AdmsSensFadType & modelPar_NA21,
   bool modelPar_given_NA21,
   AdmsSensFadType & modelPar_PA21,
   bool modelPar_given_PA21,
   AdmsSensFadType & modelPar_LRDSW,
   bool modelPar_given_LRDSW,
   AdmsSensFadType & modelPar_NRDSW,
   bool modelPar_given_NRDSW,
   AdmsSensFadType & modelPar_PRDSW,
   bool modelPar_given_PRDSW,
   AdmsSensFadType & modelPar_LRSW,
   bool modelPar_given_LRSW,
   AdmsSensFadType & modelPar_NRSW,
   bool modelPar_given_NRSW,
   AdmsSensFadType & modelPar_PRSW,
   bool modelPar_given_PRSW,
   AdmsSensFadType & modelPar_LRDW,
   bool modelPar_given_LRDW,
   AdmsSensFadType & modelPar_NRDW,
   bool modelPar_given_NRDW,
   AdmsSensFadType & modelPar_PRDW,
   bool modelPar_given_PRDW,
   AdmsSensFadType & modelPar_LPRWGS,
   bool modelPar_given_LPRWGS,
   AdmsSensFadType & modelPar_NPRWGS,
   bool modelPar_given_NPRWGS,
   AdmsSensFadType & modelPar_PPRWGS,
   bool modelPar_given_PPRWGS,
   AdmsSensFadType & modelPar_LPRWGD,
   bool modelPar_given_LPRWGD,
   AdmsSensFadType & modelPar_NPRWGD,
   bool modelPar_given_NPRWGD,
   AdmsSensFadType & modelPar_PPRWGD,
   bool modelPar_given_PPRWGD,
   AdmsSensFadType & modelPar_LWR,
   bool modelPar_given_LWR,
   AdmsSensFadType & modelPar_NWR,
   bool modelPar_given_NWR,
   AdmsSensFadType & modelPar_PWR,
   bool modelPar_given_PWR,
   AdmsSensFadType & modelPar_LPDIBL1,
   bool modelPar_given_LPDIBL1,
   AdmsSensFadType & modelPar_NPDIBL1,
   bool modelPar_given_NPDIBL1,
   AdmsSensFadType & modelPar_PPDIBL1,
   bool modelPar_given_PPDIBL1,
   AdmsSensFadType & modelPar_LPDIBL1R,
   bool modelPar_given_LPDIBL1R,
   AdmsSensFadType & modelPar_NPDIBL1R,
   bool modelPar_given_NPDIBL1R,
   AdmsSensFadType & modelPar_PPDIBL1R,
   bool modelPar_given_PPDIBL1R,
   AdmsSensFadType & modelPar_LPDIBL2,
   bool modelPar_given_LPDIBL2,
   AdmsSensFadType & modelPar_NPDIBL2,
   bool modelPar_given_NPDIBL2,
   AdmsSensFadType & modelPar_PPDIBL2,
   bool modelPar_given_PPDIBL2,
   AdmsSensFadType & modelPar_LPDIBL2R,
   bool modelPar_given_LPDIBL2R,
   AdmsSensFadType & modelPar_NPDIBL2R,
   bool modelPar_given_NPDIBL2R,
   AdmsSensFadType & modelPar_PPDIBL2R,
   bool modelPar_given_PPDIBL2R,
   AdmsSensFadType & modelPar_LDROUT,
   bool modelPar_given_LDROUT,
   AdmsSensFadType & modelPar_NDROUT,
   bool modelPar_given_NDROUT,
   AdmsSensFadType & modelPar_PDROUT,
   bool modelPar_given_PDROUT,
   AdmsSensFadType & modelPar_LPVAG,
   bool modelPar_given_LPVAG,
   AdmsSensFadType & modelPar_NPVAG,
   bool modelPar_given_NPVAG,
   AdmsSensFadType & modelPar_PPVAG,
   bool modelPar_given_PPVAG,
   AdmsSensFadType & modelPar_LAIGBINV,
   bool modelPar_given_LAIGBINV,
   AdmsSensFadType & modelPar_NAIGBINV,
   bool modelPar_given_NAIGBINV,
   AdmsSensFadType & modelPar_PAIGBINV,
   bool modelPar_given_PAIGBINV,
   AdmsSensFadType & modelPar_LAIGBINV1,
   bool modelPar_given_LAIGBINV1,
   AdmsSensFadType & modelPar_NAIGBINV1,
   bool modelPar_given_NAIGBINV1,
   AdmsSensFadType & modelPar_PAIGBINV1,
   bool modelPar_given_PAIGBINV1,
   AdmsSensFadType & modelPar_LBIGBINV,
   bool modelPar_given_LBIGBINV,
   AdmsSensFadType & modelPar_NBIGBINV,
   bool modelPar_given_NBIGBINV,
   AdmsSensFadType & modelPar_PBIGBINV,
   bool modelPar_given_PBIGBINV,
   AdmsSensFadType & modelPar_LCIGBINV,
   bool modelPar_given_LCIGBINV,
   AdmsSensFadType & modelPar_NCIGBINV,
   bool modelPar_given_NCIGBINV,
   AdmsSensFadType & modelPar_PCIGBINV,
   bool modelPar_given_PCIGBINV,
   AdmsSensFadType & modelPar_LEIGBINV,
   bool modelPar_given_LEIGBINV,
   AdmsSensFadType & modelPar_NEIGBINV,
   bool modelPar_given_NEIGBINV,
   AdmsSensFadType & modelPar_PEIGBINV,
   bool modelPar_given_PEIGBINV,
   AdmsSensFadType & modelPar_LNIGBINV,
   bool modelPar_given_LNIGBINV,
   AdmsSensFadType & modelPar_NNIGBINV,
   bool modelPar_given_NNIGBINV,
   AdmsSensFadType & modelPar_PNIGBINV,
   bool modelPar_given_PNIGBINV,
   AdmsSensFadType & modelPar_LAIGBACC,
   bool modelPar_given_LAIGBACC,
   AdmsSensFadType & modelPar_NAIGBACC,
   bool modelPar_given_NAIGBACC,
   AdmsSensFadType & modelPar_PAIGBACC,
   bool modelPar_given_PAIGBACC,
   AdmsSensFadType & modelPar_LAIGBACC1,
   bool modelPar_given_LAIGBACC1,
   AdmsSensFadType & modelPar_NAIGBACC1,
   bool modelPar_given_NAIGBACC1,
   AdmsSensFadType & modelPar_PAIGBACC1,
   bool modelPar_given_PAIGBACC1,
   AdmsSensFadType & modelPar_LBIGBACC,
   bool modelPar_given_LBIGBACC,
   AdmsSensFadType & modelPar_NBIGBACC,
   bool modelPar_given_NBIGBACC,
   AdmsSensFadType & modelPar_PBIGBACC,
   bool modelPar_given_PBIGBACC,
   AdmsSensFadType & modelPar_LCIGBACC,
   bool modelPar_given_LCIGBACC,
   AdmsSensFadType & modelPar_NCIGBACC,
   bool modelPar_given_NCIGBACC,
   AdmsSensFadType & modelPar_PCIGBACC,
   bool modelPar_given_PCIGBACC,
   AdmsSensFadType & modelPar_LNIGBACC,
   bool modelPar_given_LNIGBACC,
   AdmsSensFadType & modelPar_NNIGBACC,
   bool modelPar_given_NNIGBACC,
   AdmsSensFadType & modelPar_PNIGBACC,
   bool modelPar_given_PNIGBACC,
   AdmsSensFadType & modelPar_LAIGC,
   bool modelPar_given_LAIGC,
   AdmsSensFadType & modelPar_NAIGC,
   bool modelPar_given_NAIGC,
   AdmsSensFadType & modelPar_PAIGC,
   bool modelPar_given_PAIGC,
   AdmsSensFadType & modelPar_LAIGC1,
   bool modelPar_given_LAIGC1,
   AdmsSensFadType & modelPar_NAIGC1,
   bool modelPar_given_NAIGC1,
   AdmsSensFadType & modelPar_PAIGC1,
   bool modelPar_given_PAIGC1,
   AdmsSensFadType & modelPar_LBIGC,
   bool modelPar_given_LBIGC,
   AdmsSensFadType & modelPar_NBIGC,
   bool modelPar_given_NBIGC,
   AdmsSensFadType & modelPar_PBIGC,
   bool modelPar_given_PBIGC,
   AdmsSensFadType & modelPar_LCIGC,
   bool modelPar_given_LCIGC,
   AdmsSensFadType & modelPar_NCIGC,
   bool modelPar_given_NCIGC,
   AdmsSensFadType & modelPar_PCIGC,
   bool modelPar_given_PCIGC,
   AdmsSensFadType & modelPar_LPIGCD,
   bool modelPar_given_LPIGCD,
   AdmsSensFadType & modelPar_NPIGCD,
   bool modelPar_given_NPIGCD,
   AdmsSensFadType & modelPar_PPIGCD,
   bool modelPar_given_PPIGCD,
   AdmsSensFadType & modelPar_LAIGS,
   bool modelPar_given_LAIGS,
   AdmsSensFadType & modelPar_NAIGS,
   bool modelPar_given_NAIGS,
   AdmsSensFadType & modelPar_PAIGS,
   bool modelPar_given_PAIGS,
   AdmsSensFadType & modelPar_LAIGS1,
   bool modelPar_given_LAIGS1,
   AdmsSensFadType & modelPar_NAIGS1,
   bool modelPar_given_NAIGS1,
   AdmsSensFadType & modelPar_PAIGS1,
   bool modelPar_given_PAIGS1,
   AdmsSensFadType & modelPar_LBIGS,
   bool modelPar_given_LBIGS,
   AdmsSensFadType & modelPar_NBIGS,
   bool modelPar_given_NBIGS,
   AdmsSensFadType & modelPar_PBIGS,
   bool modelPar_given_PBIGS,
   AdmsSensFadType & modelPar_LCIGS,
   bool modelPar_given_LCIGS,
   AdmsSensFadType & modelPar_NCIGS,
   bool modelPar_given_NCIGS,
   AdmsSensFadType & modelPar_PCIGS,
   bool modelPar_given_PCIGS,
   AdmsSensFadType & modelPar_LAIGD,
   bool modelPar_given_LAIGD,
   AdmsSensFadType & modelPar_NAIGD,
   bool modelPar_given_NAIGD,
   AdmsSensFadType & modelPar_PAIGD,
   bool modelPar_given_PAIGD,
   AdmsSensFadType & modelPar_LAIGD1,
   bool modelPar_given_LAIGD1,
   AdmsSensFadType & modelPar_NAIGD1,
   bool modelPar_given_NAIGD1,
   AdmsSensFadType & modelPar_PAIGD1,
   bool modelPar_given_PAIGD1,
   AdmsSensFadType & modelPar_LBIGD,
   bool modelPar_given_LBIGD,
   AdmsSensFadType & modelPar_NBIGD,
   bool modelPar_given_NBIGD,
   AdmsSensFadType & modelPar_PBIGD,
   bool modelPar_given_PBIGD,
   AdmsSensFadType & modelPar_LCIGD,
   bool modelPar_given_LCIGD,
   AdmsSensFadType & modelPar_NCIGD,
   bool modelPar_given_NCIGD,
   AdmsSensFadType & modelPar_PCIGD,
   bool modelPar_given_PCIGD,
   AdmsSensFadType & modelPar_LNTOX,
   bool modelPar_given_LNTOX,
   AdmsSensFadType & modelPar_NNTOX,
   bool modelPar_given_NNTOX,
   AdmsSensFadType & modelPar_PNTOX,
   bool modelPar_given_PNTOX,
   AdmsSensFadType & modelPar_LPOXEDGE,
   bool modelPar_given_LPOXEDGE,
   AdmsSensFadType & modelPar_NPOXEDGE,
   bool modelPar_given_NPOXEDGE,
   AdmsSensFadType & modelPar_PPOXEDGE,
   bool modelPar_given_PPOXEDGE,
   AdmsSensFadType & modelPar_LAGISL,
   bool modelPar_given_LAGISL,
   AdmsSensFadType & modelPar_NAGISL,
   bool modelPar_given_NAGISL,
   AdmsSensFadType & modelPar_PAGISL,
   bool modelPar_given_PAGISL,
   AdmsSensFadType & modelPar_LBGISL,
   bool modelPar_given_LBGISL,
   AdmsSensFadType & modelPar_NBGISL,
   bool modelPar_given_NBGISL,
   AdmsSensFadType & modelPar_PBGISL,
   bool modelPar_given_PBGISL,
   AdmsSensFadType & modelPar_LCGISL,
   bool modelPar_given_LCGISL,
   AdmsSensFadType & modelPar_NCGISL,
   bool modelPar_given_NCGISL,
   AdmsSensFadType & modelPar_PCGISL,
   bool modelPar_given_PCGISL,
   AdmsSensFadType & modelPar_LEGISL,
   bool modelPar_given_LEGISL,
   AdmsSensFadType & modelPar_NEGISL,
   bool modelPar_given_NEGISL,
   AdmsSensFadType & modelPar_PEGISL,
   bool modelPar_given_PEGISL,
   AdmsSensFadType & modelPar_LPGISL,
   bool modelPar_given_LPGISL,
   AdmsSensFadType & modelPar_NPGISL,
   bool modelPar_given_NPGISL,
   AdmsSensFadType & modelPar_PPGISL,
   bool modelPar_given_PPGISL,
   AdmsSensFadType & modelPar_LAGIDL,
   bool modelPar_given_LAGIDL,
   AdmsSensFadType & modelPar_NAGIDL,
   bool modelPar_given_NAGIDL,
   AdmsSensFadType & modelPar_PAGIDL,
   bool modelPar_given_PAGIDL,
   AdmsSensFadType & modelPar_LBGIDL,
   bool modelPar_given_LBGIDL,
   AdmsSensFadType & modelPar_NBGIDL,
   bool modelPar_given_NBGIDL,
   AdmsSensFadType & modelPar_PBGIDL,
   bool modelPar_given_PBGIDL,
   AdmsSensFadType & modelPar_LCGIDL,
   bool modelPar_given_LCGIDL,
   AdmsSensFadType & modelPar_NCGIDL,
   bool modelPar_given_NCGIDL,
   AdmsSensFadType & modelPar_PCGIDL,
   bool modelPar_given_PCGIDL,
   AdmsSensFadType & modelPar_LEGIDL,
   bool modelPar_given_LEGIDL,
   AdmsSensFadType & modelPar_NEGIDL,
   bool modelPar_given_NEGIDL,
   AdmsSensFadType & modelPar_PEGIDL,
   bool modelPar_given_PEGIDL,
   AdmsSensFadType & modelPar_LPGIDL,
   bool modelPar_given_LPGIDL,
   AdmsSensFadType & modelPar_NPGIDL,
   bool modelPar_given_NPGIDL,
   AdmsSensFadType & modelPar_PPGIDL,
   bool modelPar_given_PPGIDL,
   AdmsSensFadType & modelPar_LALPHA0,
   bool modelPar_given_LALPHA0,
   AdmsSensFadType & modelPar_NALPHA0,
   bool modelPar_given_NALPHA0,
   AdmsSensFadType & modelPar_PALPHA0,
   bool modelPar_given_PALPHA0,
   AdmsSensFadType & modelPar_LALPHA1,
   bool modelPar_given_LALPHA1,
   AdmsSensFadType & modelPar_NALPHA1,
   bool modelPar_given_NALPHA1,
   AdmsSensFadType & modelPar_PALPHA1,
   bool modelPar_given_PALPHA1,
   AdmsSensFadType & modelPar_LALPHAII0,
   bool modelPar_given_LALPHAII0,
   AdmsSensFadType & modelPar_NALPHAII0,
   bool modelPar_given_NALPHAII0,
   AdmsSensFadType & modelPar_PALPHAII0,
   bool modelPar_given_PALPHAII0,
   AdmsSensFadType & modelPar_LALPHAII1,
   bool modelPar_given_LALPHAII1,
   AdmsSensFadType & modelPar_NALPHAII1,
   bool modelPar_given_NALPHAII1,
   AdmsSensFadType & modelPar_PALPHAII1,
   bool modelPar_given_PALPHAII1,
   AdmsSensFadType & modelPar_LBETA0,
   bool modelPar_given_LBETA0,
   AdmsSensFadType & modelPar_NBETA0,
   bool modelPar_given_NBETA0,
   AdmsSensFadType & modelPar_PBETA0,
   bool modelPar_given_PBETA0,
   AdmsSensFadType & modelPar_LBETAII0,
   bool modelPar_given_LBETAII0,
   AdmsSensFadType & modelPar_NBETAII0,
   bool modelPar_given_NBETAII0,
   AdmsSensFadType & modelPar_PBETAII0,
   bool modelPar_given_PBETAII0,
   AdmsSensFadType & modelPar_LBETAII1,
   bool modelPar_given_LBETAII1,
   AdmsSensFadType & modelPar_NBETAII1,
   bool modelPar_given_NBETAII1,
   AdmsSensFadType & modelPar_PBETAII1,
   bool modelPar_given_PBETAII1,
   AdmsSensFadType & modelPar_LBETAII2,
   bool modelPar_given_LBETAII2,
   AdmsSensFadType & modelPar_NBETAII2,
   bool modelPar_given_NBETAII2,
   AdmsSensFadType & modelPar_PBETAII2,
   bool modelPar_given_PBETAII2,
   AdmsSensFadType & modelPar_LESATII,
   bool modelPar_given_LESATII,
   AdmsSensFadType & modelPar_NESATII,
   bool modelPar_given_NESATII,
   AdmsSensFadType & modelPar_PESATII,
   bool modelPar_given_PESATII,
   AdmsSensFadType & modelPar_LLII,
   bool modelPar_given_LLII,
   AdmsSensFadType & modelPar_NLII,
   bool modelPar_given_NLII,
   AdmsSensFadType & modelPar_PLII,
   bool modelPar_given_PLII,
   AdmsSensFadType & modelPar_LSII0,
   bool modelPar_given_LSII0,
   AdmsSensFadType & modelPar_NSII0,
   bool modelPar_given_NSII0,
   AdmsSensFadType & modelPar_PSII0,
   bool modelPar_given_PSII0,
   AdmsSensFadType & modelPar_LSII1,
   bool modelPar_given_LSII1,
   AdmsSensFadType & modelPar_NSII1,
   bool modelPar_given_NSII1,
   AdmsSensFadType & modelPar_PSII1,
   bool modelPar_given_PSII1,
   AdmsSensFadType & modelPar_LSII2,
   bool modelPar_given_LSII2,
   AdmsSensFadType & modelPar_NSII2,
   bool modelPar_given_NSII2,
   AdmsSensFadType & modelPar_PSII2,
   bool modelPar_given_PSII2,
   AdmsSensFadType & modelPar_LSIID,
   bool modelPar_given_LSIID,
   AdmsSensFadType & modelPar_NSIID,
   bool modelPar_given_NSIID,
   AdmsSensFadType & modelPar_PSIID,
   bool modelPar_given_PSIID,
   AdmsSensFadType & modelPar_LCFS,
   bool modelPar_given_LCFS,
   AdmsSensFadType & modelPar_NCFS,
   bool modelPar_given_NCFS,
   AdmsSensFadType & modelPar_PCFS,
   bool modelPar_given_PCFS,
   AdmsSensFadType & modelPar_LCFD,
   bool modelPar_given_LCFD,
   AdmsSensFadType & modelPar_NCFD,
   bool modelPar_given_NCFD,
   AdmsSensFadType & modelPar_PCFD,
   bool modelPar_given_PCFD,
   AdmsSensFadType & modelPar_LCOVS,
   bool modelPar_given_LCOVS,
   AdmsSensFadType & modelPar_NCOVS,
   bool modelPar_given_NCOVS,
   AdmsSensFadType & modelPar_PCOVS,
   bool modelPar_given_PCOVS,
   AdmsSensFadType & modelPar_LCOVD,
   bool modelPar_given_LCOVD,
   AdmsSensFadType & modelPar_NCOVD,
   bool modelPar_given_NCOVD,
   AdmsSensFadType & modelPar_PCOVD,
   bool modelPar_given_PCOVD,
   AdmsSensFadType & modelPar_LCGSL,
   bool modelPar_given_LCGSL,
   AdmsSensFadType & modelPar_NCGSL,
   bool modelPar_given_NCGSL,
   AdmsSensFadType & modelPar_PCGSL,
   bool modelPar_given_PCGSL,
   AdmsSensFadType & modelPar_LCGDL,
   bool modelPar_given_LCGDL,
   AdmsSensFadType & modelPar_NCGDL,
   bool modelPar_given_NCGDL,
   AdmsSensFadType & modelPar_PCGDL,
   bool modelPar_given_PCGDL,
   AdmsSensFadType & modelPar_LCKAPPAS,
   bool modelPar_given_LCKAPPAS,
   AdmsSensFadType & modelPar_NCKAPPAS,
   bool modelPar_given_NCKAPPAS,
   AdmsSensFadType & modelPar_PCKAPPAS,
   bool modelPar_given_PCKAPPAS,
   AdmsSensFadType & modelPar_LCKAPPAD,
   bool modelPar_given_LCKAPPAD,
   AdmsSensFadType & modelPar_NCKAPPAD,
   bool modelPar_given_NCKAPPAD,
   AdmsSensFadType & modelPar_PCKAPPAD,
   bool modelPar_given_PCKAPPAD,
   AdmsSensFadType & modelPar_LCGBL,
   bool modelPar_given_LCGBL,
   AdmsSensFadType & modelPar_NCGBL,
   bool modelPar_given_NCGBL,
   AdmsSensFadType & modelPar_PCGBL,
   bool modelPar_given_PCGBL,
   AdmsSensFadType & modelPar_LCKAPPAB,
   bool modelPar_given_LCKAPPAB,
   AdmsSensFadType & modelPar_NCKAPPAB,
   bool modelPar_given_NCKAPPAB,
   AdmsSensFadType & modelPar_PCKAPPAB,
   bool modelPar_given_PCKAPPAB,
   AdmsSensFadType & modelPar_LNTGEN,
   bool modelPar_given_LNTGEN,
   AdmsSensFadType & modelPar_NNTGEN,
   bool modelPar_given_NNTGEN,
   AdmsSensFadType & modelPar_PNTGEN,
   bool modelPar_given_PNTGEN,
   AdmsSensFadType & modelPar_LAIGEN,
   bool modelPar_given_LAIGEN,
   AdmsSensFadType & modelPar_NAIGEN,
   bool modelPar_given_NAIGEN,
   AdmsSensFadType & modelPar_PAIGEN,
   bool modelPar_given_PAIGEN,
   AdmsSensFadType & modelPar_LBIGEN,
   bool modelPar_given_LBIGEN,
   AdmsSensFadType & modelPar_NBIGEN,
   bool modelPar_given_NBIGEN,
   AdmsSensFadType & modelPar_PBIGEN,
   bool modelPar_given_PBIGEN,
   AdmsSensFadType & modelPar_LXRCRG1,
   bool modelPar_given_LXRCRG1,
   AdmsSensFadType & modelPar_NXRCRG1,
   bool modelPar_given_NXRCRG1,
   AdmsSensFadType & modelPar_PXRCRG1,
   bool modelPar_given_PXRCRG1,
   AdmsSensFadType & modelPar_LXRCRG2,
   bool modelPar_given_LXRCRG2,
   AdmsSensFadType & modelPar_NXRCRG2,
   bool modelPar_given_NXRCRG2,
   AdmsSensFadType & modelPar_PXRCRG2,
   bool modelPar_given_PXRCRG2,
   AdmsSensFadType & modelPar_LUTE,
   bool modelPar_given_LUTE,
   AdmsSensFadType & modelPar_NUTE,
   bool modelPar_given_NUTE,
   AdmsSensFadType & modelPar_PUTE,
   bool modelPar_given_PUTE,
   AdmsSensFadType & modelPar_LUTER,
   bool modelPar_given_LUTER,
   AdmsSensFadType & modelPar_NUTER,
   bool modelPar_given_NUTER,
   AdmsSensFadType & modelPar_PUTER,
   bool modelPar_given_PUTER,
   AdmsSensFadType & modelPar_LUTL,
   bool modelPar_given_LUTL,
   AdmsSensFadType & modelPar_NUTL,
   bool modelPar_given_NUTL,
   AdmsSensFadType & modelPar_PUTL,
   bool modelPar_given_PUTL,
   AdmsSensFadType & modelPar_LUTLR,
   bool modelPar_given_LUTLR,
   AdmsSensFadType & modelPar_NUTLR,
   bool modelPar_given_NUTLR,
   AdmsSensFadType & modelPar_PUTLR,
   bool modelPar_given_PUTLR,
   AdmsSensFadType & modelPar_LEMOBT,
   bool modelPar_given_LEMOBT,
   AdmsSensFadType & modelPar_NEMOBT,
   bool modelPar_given_NEMOBT,
   AdmsSensFadType & modelPar_PEMOBT,
   bool modelPar_given_PEMOBT,
   AdmsSensFadType & modelPar_LUA1,
   bool modelPar_given_LUA1,
   AdmsSensFadType & modelPar_NUA1,
   bool modelPar_given_NUA1,
   AdmsSensFadType & modelPar_PUA1,
   bool modelPar_given_PUA1,
   AdmsSensFadType & modelPar_LUA1R,
   bool modelPar_given_LUA1R,
   AdmsSensFadType & modelPar_NUA1R,
   bool modelPar_given_NUA1R,
   AdmsSensFadType & modelPar_PUA1R,
   bool modelPar_given_PUA1R,
   AdmsSensFadType & modelPar_LUC1,
   bool modelPar_given_LUC1,
   AdmsSensFadType & modelPar_NUC1,
   bool modelPar_given_NUC1,
   AdmsSensFadType & modelPar_PUC1,
   bool modelPar_given_PUC1,
   AdmsSensFadType & modelPar_LUC1R,
   bool modelPar_given_LUC1R,
   AdmsSensFadType & modelPar_NUC1R,
   bool modelPar_given_NUC1R,
   AdmsSensFadType & modelPar_PUC1R,
   bool modelPar_given_PUC1R,
   AdmsSensFadType & modelPar_LUD1,
   bool modelPar_given_LUD1,
   AdmsSensFadType & modelPar_NUD1,
   bool modelPar_given_NUD1,
   AdmsSensFadType & modelPar_PUD1,
   bool modelPar_given_PUD1,
   AdmsSensFadType & modelPar_LUD1R,
   bool modelPar_given_LUD1R,
   AdmsSensFadType & modelPar_NUD1R,
   bool modelPar_given_NUD1R,
   AdmsSensFadType & modelPar_PUD1R,
   bool modelPar_given_PUD1R,
   AdmsSensFadType & modelPar_LUCSTE,
   bool modelPar_given_LUCSTE,
   AdmsSensFadType & modelPar_NUCSTE,
   bool modelPar_given_NUCSTE,
   AdmsSensFadType & modelPar_PUCSTE,
   bool modelPar_given_PUCSTE,
   AdmsSensFadType & modelPar_LPTWGT,
   bool modelPar_given_LPTWGT,
   AdmsSensFadType & modelPar_NPTWGT,
   bool modelPar_given_NPTWGT,
   AdmsSensFadType & modelPar_PPTWGT,
   bool modelPar_given_PPTWGT,
   AdmsSensFadType & modelPar_LAT,
   bool modelPar_given_LAT,
   AdmsSensFadType & modelPar_NAT,
   bool modelPar_given_NAT,
   AdmsSensFadType & modelPar_PAT,
   bool modelPar_given_PAT,
   AdmsSensFadType & modelPar_LATR,
   bool modelPar_given_LATR,
   AdmsSensFadType & modelPar_NATR,
   bool modelPar_given_NATR,
   AdmsSensFadType & modelPar_PATR,
   bool modelPar_given_PATR,
   AdmsSensFadType & modelPar_LATCV,
   bool modelPar_given_LATCV,
   AdmsSensFadType & modelPar_NATCV,
   bool modelPar_given_NATCV,
   AdmsSensFadType & modelPar_PATCV,
   bool modelPar_given_PATCV,
   AdmsSensFadType & modelPar_LSTTHETASAT,
   bool modelPar_given_LSTTHETASAT,
   AdmsSensFadType & modelPar_NSTTHETASAT,
   bool modelPar_given_NSTTHETASAT,
   AdmsSensFadType & modelPar_PSTTHETASAT,
   bool modelPar_given_PSTTHETASAT,
   AdmsSensFadType & modelPar_LPRT,
   bool modelPar_given_LPRT,
   AdmsSensFadType & modelPar_NPRT,
   bool modelPar_given_NPRT,
   AdmsSensFadType & modelPar_PPRT,
   bool modelPar_given_PPRT,
   AdmsSensFadType & modelPar_LKT1,
   bool modelPar_given_LKT1,
   AdmsSensFadType & modelPar_NKT1,
   bool modelPar_given_NKT1,
   AdmsSensFadType & modelPar_PKT1,
   bool modelPar_given_PKT1,
   AdmsSensFadType & modelPar_LTSS,
   bool modelPar_given_LTSS,
   AdmsSensFadType & modelPar_NTSS,
   bool modelPar_given_NTSS,
   AdmsSensFadType & modelPar_PTSS,
   bool modelPar_given_PTSS,
   AdmsSensFadType & modelPar_LIIT,
   bool modelPar_given_LIIT,
   AdmsSensFadType & modelPar_NIIT,
   bool modelPar_given_NIIT,
   AdmsSensFadType & modelPar_PIIT,
   bool modelPar_given_PIIT,
   AdmsSensFadType & modelPar_LTII,
   bool modelPar_given_LTII,
   AdmsSensFadType & modelPar_NTII,
   bool modelPar_given_NTII,
   AdmsSensFadType & modelPar_PTII,
   bool modelPar_given_PTII,
   AdmsSensFadType & modelPar_LTGIDL,
   bool modelPar_given_LTGIDL,
   AdmsSensFadType & modelPar_NTGIDL,
   bool modelPar_given_NTGIDL,
   AdmsSensFadType & modelPar_PTGIDL,
   bool modelPar_given_PTGIDL,
   AdmsSensFadType & modelPar_LIGT,
   bool modelPar_given_LIGT,
   AdmsSensFadType & modelPar_NIGT,
   bool modelPar_given_NIGT,
   AdmsSensFadType & modelPar_PIGT,
   bool modelPar_given_PIGT,
   // non-reals (including hidden)
   int modelPar_NF,
   bool modelPar_given_NF,
   int modelPar_NGCON,
   bool modelPar_given_NGCON,
   int modelPar_DEVTYPE,
   bool modelPar_given_DEVTYPE,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   int modelPar_BULKMOD,
   bool modelPar_given_BULKMOD,
   int modelPar_GEOMOD,
   bool modelPar_given_GEOMOD,
   int modelPar_CGEO1SW,
   bool modelPar_given_CGEO1SW,
   int modelPar_RDSMOD,
   bool modelPar_given_RDSMOD,
   int modelPar_ASYMMOD,
   bool modelPar_given_ASYMMOD,
   int modelPar_IGCMOD,
   bool modelPar_given_IGCMOD,
   int modelPar_IGBMOD,
   bool modelPar_given_IGBMOD,
   int modelPar_GIDLMOD,
   bool modelPar_given_GIDLMOD,
   int modelPar_IIMOD,
   bool modelPar_given_IIMOD,
   int modelPar_TNOIMOD,
   bool modelPar_given_TNOIMOD,
   int modelPar_NQSMOD,
   bool modelPar_given_NQSMOD,
   int modelPar_SHMOD,
   bool modelPar_given_SHMOD,
   int modelPar_TEMPMOD,
   bool modelPar_given_TEMPMOD,
   int modelPar_RGATEMOD,
   bool modelPar_given_RGATEMOD,
   int modelPar_RGEOMOD,
   bool modelPar_given_RGEOMOD,
   int modelPar_CGEOMOD,
   bool modelPar_given_CGEOMOD,
   int modelPar_SH_WARN,
   bool modelPar_given_SH_WARN,
   int modelPar_IGCLAMP,
   bool modelPar_given_IGCLAMP,
   int modelPar_SDTERM,
   bool modelPar_given_SDTERM,
   int modelPar_NSEG,
   bool modelPar_given_NSEG,
   double admsTemperature, double adms_vt_nom, double gmin, const Instance & theInstance)
{
  AdmsSensFadType Toxratioedge;
  AdmsSensFadType Ccorner;
  AdmsSensFadType Acorner;
  AdmsSensFadType Cgg_side;
  AdmsSensFadType Cgg_top;
  AdmsSensFadType Hr;
  double Lr;
  AdmsSensFadType Hgdelta;
  AdmsSensFadType Lmax;
  AdmsSensFadType y;
  AdmsSensFadType x;
  double Cnon;
  AdmsSensFadType CcgSat;
  AdmsSensFadType TT1;
  AdmsSensFadType Ccg1;
  AdmsSensFadType r1cf;
  AdmsSensFadType Rcf;
  AdmsSensFadType Ccg2;
  AdmsSensFadType Ccg;
  AdmsSensFadType C1;
  AdmsSensFadType C2;
  AdmsSensFadType C3;
  AdmsSensFadType Cfglog;
  AdmsSensFadType dcf;
  AdmsSensFadType TT0;
  AdmsSensFadType TT2;
  AdmsSensFadType Cfgsat;
  AdmsSensFadType Cfg;
  AdmsSensFadType Hrsd;
  AdmsSensFadType Wg;
  AdmsSensFadType Trsd;
  AdmsSensFadType Hg;
  AdmsSensFadType Rdsgeo;
  AdmsSensFadType Rrsd;
  AdmsSensFadType Rrsdside;
  AdmsSensFadType RrsdTML;
  AdmsSensFadType eta;
  AdmsSensFadType alpha;
  AdmsSensFadType lt;
  AdmsSensFadType prsd_total;
  AdmsSensFadType arsd_total;
  AdmsSensFadType Rsp;
  AdmsSensFadType afin;
  double thetarsp;
  AdmsSensFadType rhorsd;
  AdmsSensFadType mu_rsd;
  AdmsSensFadType mu_max;
  AdmsSensFadType Prsd;
  AdmsSensFadType Arsd;
  AdmsSensFadType Rgeltd;
  AdmsSensFadType NTOX_i;
  AdmsSensFadType WR_i;
  AdmsSensFadType UP_i;
  AdmsSensFadType LPE0_i;
  AdmsSensFadType DSUB_i;
  AdmsSensFadType DVT1SS_i;
  AdmsSensFadType DVT1_i;
  AdmsSensFadType NGATE_i;
  AdmsSensFadType NBODY_i;
  AdmsSensFadType Inv_LNFIN;
  AdmsSensFadType Inv_NFIN;
  AdmsSensFadType Inv_L;
  AdmsSensFadType Leff1;
  AdmsSensFadType deltaLCV;
  AdmsSensFadType deltaL1;
  AdmsSensFadType deltaL;
  AdmsSensFadType Lg;
  AdmsSensFadType cbox;
  AdmsSensFadType epssp;
  AdmsSensFadType UPR_i;
  AdmsSensFadType MTcen;
  //Begin block initial_instance
  {
    instanceVar_qid = 0.0;
    instanceVar_qis = 0.0;
    instanceVar_qba = 0.0;
    instanceVar_T11 = 0.0;
    instanceVar_T12 = 0.0;
    instanceVar_ids = 0.0;
    instanceVar_sigvds = 0.0;
    instanceVar_Iii = 0.0;
    instanceVar_qd = 0.0;
    instanceVar_qg = 0.0;
    instanceVar_qs = 0.0;
    instanceVar_qb = 0.0;
    instanceVar_Weff0 = 0.0;
    instanceVar_WeffCV0 = 0.0;
    instanceVar_CJS_t = 0.0;
    instanceVar_CJSWS_t = 0.0;
    instanceVar_CJSWGS_t = 0.0;
    instanceVar_CJD_t = 0.0;
    instanceVar_CJSWD_t = 0.0;
    instanceVar_CJSWGD_t = 0.0;
    instanceVar_PBS_t = 0.0;
    instanceVar_PBSWS_t = 0.0;
    instanceVar_PBSWGS_t = 0.0;
    instanceVar_PBD_t = 0.0;
    instanceVar_PBSWD_t = 0.0;
    instanceVar_PBSWGD_t = 0.0;
    instanceVar_JSS_t = 0.0;
    instanceVar_JSWS_t = 0.0;
    instanceVar_JSWGS_t = 0.0;
    instanceVar_JSD_t = 0.0;
    instanceVar_JSWD_t = 0.0;
    instanceVar_JSWGD_t = 0.0;
    instanceVar_JTSS_t = 0.0;
    instanceVar_JTSSWS_t = 0.0;
    instanceVar_JTSSWGS_t = 0.0;
    instanceVar_JTSD_t = 0.0;
    instanceVar_JTSSWD_t = 0.0;
    instanceVar_JTSSWGD_t = 0.0;
    instanceVar_NJTS_t = 0.0;
    instanceVar_NJTSSW_t = 0.0;
    instanceVar_NJTSSWG_t = 0.0;
    instanceVar_NJTSD_t = 0.0;
    instanceVar_NJTSSWD_t = 0.0;
    instanceVar_NJTSSWGD_t = 0.0;
    instanceVar_Ies = 0.0;
    instanceVar_Ied = 0.0;
    instanceVar_Czbs = 0.0;
    instanceVar_Czbssw = 0.0;
    instanceVar_Czbsswg = 0.0;
    instanceVar_Czbd = 0.0;
    instanceVar_Czbdsw = 0.0;
    instanceVar_Czbdswg = 0.0;
    instanceVar_Qes = 0.0;
    instanceVar_Qed = 0.0;
    instanceVar_Qeg = 0.0;
    instanceVar_Isbs = 0.0;
    instanceVar_Isbd = 0.0;
    instanceVar_Nvtms = 0.0;
    instanceVar_Nvtmd = 0.0;
    instanceVar_SslpRev = 0.0;
    instanceVar_IVjsmRev = 0.0;
    instanceVar_VjsmRev = 0.0;
    instanceVar_SslpFwd = 0.0;
    instanceVar_IVjsmFwd = 0.0;
    instanceVar_VjsmFwd = 0.0;
    instanceVar_DslpRev = 0.0;
    instanceVar_IVjdmRev = 0.0;
    instanceVar_VjdmRev = 0.0;
    instanceVar_DslpFwd = 0.0;
    instanceVar_IVjdmFwd = 0.0;
    instanceVar_VjdmFwd = 0.0;
    instanceVar_XExpBVS = 0.0;
    instanceVar_XExpBVD = 0.0;
    instanceVar_idsgen = 0.0;
    instanceVar_q0 = 0.0;
    instanceVar_Tcen = 0.0;
    MTcen = 0.0;
    instanceVar_Rdrain = 0.0;
    instanceVar_Rsource = 0.0;
    instanceVar_Cfr_geo = 0.0;
    instanceVar_igbinv = 0.0;
    instanceVar_igbs = 0.0;
    instanceVar_igbd = 0.0;
    instanceVar_igbacc = 0.0;
    instanceVar_igcs = 0.0;
    instanceVar_igcd = 0.0;
    instanceVar_igidl = 0.0;
    instanceVar_igisl = 0.0;
    instanceVar_igs = 0.0;
    instanceVar_igd = 0.0;
    instanceVar_cox_acc = 0.0;
    instanceVar_CGSO_i = 0.0;
    instanceVar_CGDO_i = 0.0;
    instanceVar_qb_acc = 0.0;
    instanceVar_qg_acc = 0.0;
    instanceVar_qgs_fr = 0.0;
    instanceVar_qgd_fr = 0.0;
    instanceVar_qds_fr = 0.0;
    instanceVar_qgs_parasitic = 0.0;
    instanceVar_qgd_parasitic = 0.0;
    instanceVar_FNPowerAt1Hz = 0.0;
    instanceVar_Gtnoi = 0.0;
    instanceVar_gspr = 0.0;
    instanceVar_gdpr = 0.0;
    instanceVar_Dr = 1.0;
    instanceVar_CDSCDR_i = 0.0;
    instanceVar_ETA0R_i = 0.0;
    instanceVar_VSAT1R_i = 0.0;
    instanceVar_VSAT1R_t = 0.0;
    instanceVar_MEXPR_i = 0.0;
    instanceVar_MEXPR_t = 0.0;
    instanceVar_PTWGR_i = 0.0;
    instanceVar_PTWGR_t = 0.0;
    instanceVar_PDIBL1R_i = 0.0;
    instanceVar_PDIBL2R_i = 0.0;
    instanceVar_PHIBE_i = 0.0;
    instanceVar_K1_i = 0.0;
    instanceVar_K11_i = 0.0;
    instanceVar_K2SAT_i = 0.0;
    instanceVar_K2SAT1_i = 0.0;
    instanceVar_KSATIVR_i = 0.0;
    instanceVar_K2_i = 0.0;
    instanceVar_K21_i = 0.0;
    instanceVar_UC_i = 0.0;
    instanceVar_UC1_i = 0.0;
    instanceVar_UC_t = 0.0;
    instanceVar_U0R_i = 0.0;
    UPR_i = 0.0;
    instanceVar_EUR_i = 0.0;
    instanceVar_ATR_i = 0.0;
    instanceVar_CITR_i = 0.0;
    instanceVar_ETA0R_i = 0.0;
    instanceVar_DVTP0_i = 0.0;
    instanceVar_DVTP1_i = 0.0;
    instanceVar_PDIBL2R_i = 0.0;
    instanceVar_PCLMR_i = 0.0;
    instanceVar_LeffCV_acc = 0.0;
    instanceVar_RDDRR_t = 0.0;
    instanceVar_RSDRR_t = 0.0;
    instanceVar_Rdsi = 0.0;
    instanceVar_T3 = 0.0;
    instanceVar_Tcen0 = 0.0;
    instanceVar_veseff = 0.0;
    instanceVar_U0R_t = 0.0;
    instanceVar_UAR_t = 0.0;
    instanceVar_UCR_t = 0.0;
    instanceVar_UDR_t = 0.0;
    instanceVar_VSAT_a = 0.0;
    instanceVar_DVTSHIFTR_i = 0.0;
    instanceVar_UA1R_i = 0.0;
    instanceVar_UAR_i = 0.0;
    instanceVar_UC1R_i = 0.0;
    instanceVar_UCR_i = 0.0;
    instanceVar_UD1R_i = 0.0;
    instanceVar_UDR_i = 0.0;
    instanceVar_UTER_i = 0.0;
    instanceVar_UTLR_i = 0.0;
    instanceVar_VSATR_i = 0.0;
    instanceVar_VSATR_t = 0.0;
    instanceVar_u0r = 0.0;
    instanceVar_sid = 0.0;
    instanceVar_ctnoi = 0.0;
    instanceVar_sf = 0.0;
    instanceVar_C0 = 0.0;
    instanceVar_gamma = 0.0;
    instanceVar_delta = 0.0;
    instanceVar_ggeltd = 0.0;
    instanceVar_qm = 1.0;
    instanceVar_Cins = 1.0;
    instanceVar_Ach = 1.0;
    instanceVar_Weff_UFCM = 1.0;
    instanceVar_qdep = (-1.0);
    instanceVar_rc = 1.0;
    instanceVar_vth_fixed_factor_Sub = 1.0;
    instanceVar_vth_fixed_factor_SI = 1.0;
    instanceVar_qi_acc_for_QM = 0.0;
    instanceVar_fieldnormalizationfactor = 0.0;
    instanceVar_auxQMfact = 0.0;
    instanceVar_QMFACTORCVfinal = 0.0;
    instanceVar_psipclamp = 1.0;
    instanceVar_sqrtpsip = 1.0;
    instanceVar_nq = 1.0;
    instanceVar_F0 = 0.0;
    instanceVar_e0 = 0.0;
    instanceVar_e1 = 0.0;
    instanceVar_e2 = 0.0;
    instanceVar_Qdep_ov_Cins = 0.0;
    if ((modelPar_TYPE==1))
    {
      instanceVar_devsign = 1;
    }
    else
    {
      instanceVar_devsign = (-1);
    }
    instanceVar_epssub = (modelPar_EPSRSUB*8.8542e-12);
    epssp = (modelPar_EPSRSP*8.8542e-12);
    cbox = ((modelPar_EPSROX*8.8542e-12)/modelPar_EOTBOX);
    instanceVar_epsratio = (modelPar_EPSRSUB/modelPar_EPSROX);
    instanceVar_mx = (0.916*9.11e-31);
    instanceVar_mxprime = (0.190*9.11e-31);
    instanceVar_md = (0.190*9.11e-31);
    instanceVar_mdprime = (0.417*9.11e-31);
    instanceVar_gprime = 4.0;
    instanceVar_gfactor = 2.0;
    Lg = (instancePar_L+modelPar_XL);
    deltaL = (modelPar_LINT+(modelPar_LL*pow(Lg,(-modelPar_LLN))));
    deltaL1 = (modelPar_LINT+(modelPar_LL*pow((Lg+modelPar_DLBIN),(-modelPar_LLN))));
    deltaLCV = (modelPar_DLC+(modelPar_LLC*pow(Lg,(-modelPar_LLN))));
    instanceVar_Leff = (Lg-(2.0*deltaL));
    Leff1 = ((Lg+modelPar_DLBIN)-(2.0*deltaL1));
    instanceVar_LeffCV = (Lg-(2.0*deltaLCV));
    if ((modelPar_BULKMOD!=0))
    {
      instanceVar_LeffCV_acc = (instanceVar_LeffCV-modelPar_DLCACC);
    }
    instanceVar_NFINtotal = (instancePar_NFIN*instancePar_NF);
    if ((instanceVar_Leff<=0.0))
    {
      std::cerr  << "Fatal: Leff = %e is not positive." << instanceVar_Leff <<  std::endl; 
      UserError0(theInstance) << "$finish called." << std::endl; 
    }
    else
    {
      if ((instanceVar_Leff<=1.0e-9))
      {
        std::cerr  << "Warning: Leff = %e <= 1.0e-9." << instanceVar_Leff <<  std::endl; 
      }
    }
    if ((Leff1<=0.0))
    {
      std::cerr  << "Fatal: Leff1 = %e is not positive." << Leff1 <<  std::endl; 
      UserError0(theInstance) << "$finish called." << std::endl; 
    }
    else
    {
      if ((Leff1<=1.0e-9))
      {
        std::cerr  << "Warning: Leff1 = %e <= 1.0e-9." << Leff1 <<  std::endl; 
      }
    }
    Inv_L = (1.0e-6/Leff1);
    Inv_NFIN = (1.0/instancePar_NFIN);
    Inv_LNFIN = (1.0e-6/(Leff1*instancePar_NFIN));
    NBODY_i = (((modelPar_NBODY+(Inv_L*modelPar_LNBODY))+(Inv_NFIN*modelPar_NNBODY))+(Inv_LNFIN*modelPar_PNBODY));
    if ((modelPar_NBODYN1!=0.0))
    {
      NBODY_i = (NBODY_i*(1.0+((modelPar_NBODYN1/instancePar_NFIN)*AnalogFunctions::lln<AdmsSensFadType>((1.0+(instancePar_NFIN/modelPar_NBODYN2))))));
    }
    if ( modelPar_GEOMOD == (0))
    {
      if (((!modelPar_given_TFIN_TOP)||(!modelPar_given_TFIN_BASE)))
      {
        instanceVar_Weff_UFCM = (2.0*modelPar_HFIN);
        instanceVar_Cins = (((instanceVar_Weff_UFCM*modelPar_EPSROX)*8.8542e-12)/modelPar_EOT);
        instanceVar_Ach = (modelPar_HFIN*instancePar_TFIN);
        instanceVar_rc = ((2.0*instanceVar_Cins)/(((instanceVar_Weff_UFCM*instanceVar_Weff_UFCM)*instanceVar_epssub)/instanceVar_Ach));
        instanceVar_Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*instanceVar_Ach)/instanceVar_Cins);
      }
      else
      {
        instanceVar_Weff_UFCM = (2.0*sqrt(((modelPar_HFIN*modelPar_HFIN)+(((modelPar_TFIN_TOP-modelPar_TFIN_BASE)*(modelPar_TFIN_TOP-modelPar_TFIN_BASE))/4.0))));
        instanceVar_Cins = (((instanceVar_Weff_UFCM*modelPar_EPSROX)*8.8542e-12)/modelPar_EOT);
        instanceVar_Ach = ((modelPar_HFIN*(modelPar_TFIN_TOP+modelPar_TFIN_BASE))/2.0);
        instanceVar_rc = ((2.0*instanceVar_Cins)/(((instanceVar_Weff_UFCM*instanceVar_Weff_UFCM)*instanceVar_epssub)/instanceVar_Ach));
        instanceVar_Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*instanceVar_Ach)/instanceVar_Cins);
      }
    }
    else
      if ( modelPar_GEOMOD == (1))
      {
        if (((!modelPar_given_TFIN_TOP)||(!modelPar_given_TFIN_BASE)))
        {
          instanceVar_Weff_UFCM = ((2.0*modelPar_HFIN)+instancePar_TFIN);
          instanceVar_Cins = (((instanceVar_Weff_UFCM*modelPar_EPSROX)*8.8542e-12)/modelPar_EOT);
          instanceVar_Ach = (modelPar_HFIN*instancePar_TFIN);
          instanceVar_rc = ((2.0*instanceVar_Cins)/(((instanceVar_Weff_UFCM*instanceVar_Weff_UFCM)*instanceVar_epssub)/instanceVar_Ach));
          instanceVar_Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*instanceVar_Ach)/instanceVar_Cins);
        }
        else
        {
          instanceVar_Weff_UFCM = ((2.0*sqrt(((modelPar_HFIN*modelPar_HFIN)+(((modelPar_TFIN_TOP-modelPar_TFIN_BASE)*(modelPar_TFIN_TOP-modelPar_TFIN_BASE))/4.0))))+modelPar_TFIN_TOP);
          instanceVar_Cins = (((instanceVar_Weff_UFCM*modelPar_EPSROX)*8.8542e-12)/modelPar_EOT);
          instanceVar_Ach = ((modelPar_HFIN*(modelPar_TFIN_TOP+modelPar_TFIN_BASE))/2.0);
          instanceVar_rc = ((2.0*instanceVar_Cins)/(((instanceVar_Weff_UFCM*instanceVar_Weff_UFCM)*instanceVar_epssub)/instanceVar_Ach));
          instanceVar_Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*instanceVar_Ach)/instanceVar_Cins);
        }
      }
      else
        if ( modelPar_GEOMOD == (2))
        {
          if (((!modelPar_given_TFIN_TOP)||(!modelPar_given_TFIN_BASE)))
          {
            instanceVar_Weff_UFCM = ((2.0*modelPar_HFIN)+(2.0*instancePar_TFIN));
            instanceVar_Cins = (((instanceVar_Weff_UFCM*modelPar_EPSROX)*8.8542e-12)/modelPar_EOT);
            instanceVar_Ach = (modelPar_HFIN*instancePar_TFIN);
            instanceVar_rc = ((2.0*instanceVar_Cins)/(((instanceVar_Weff_UFCM*instanceVar_Weff_UFCM)*instanceVar_epssub)/instanceVar_Ach));
            instanceVar_Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*instanceVar_Ach)/instanceVar_Cins);
          }
          else
          {
            instanceVar_Weff_UFCM = (((2.0*sqrt(((modelPar_HFIN*modelPar_HFIN)+(((modelPar_TFIN_TOP-modelPar_TFIN_BASE)*(modelPar_TFIN_TOP-modelPar_TFIN_BASE))/4.0))))+modelPar_TFIN_TOP)+modelPar_TFIN_BASE);
            instanceVar_Cins = (((instanceVar_Weff_UFCM*modelPar_EPSROX)*8.8542e-12)/modelPar_EOT);
            instanceVar_Ach = ((modelPar_HFIN*(modelPar_TFIN_TOP+modelPar_TFIN_BASE))/2.0);
            instanceVar_rc = ((2.0*instanceVar_Cins)/(((instanceVar_Weff_UFCM*instanceVar_Weff_UFCM)*instanceVar_epssub)/instanceVar_Ach));
            instanceVar_Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*instanceVar_Ach)/instanceVar_Cins);
          }
        }
        else
          if ( modelPar_GEOMOD == (3))
          {
            instanceVar_Weff_UFCM = (3.14159265358979323846*instancePar_D);
            instanceVar_Cins = ((((2.0*3.14159265358979323846)*modelPar_EPSROX)*8.8542e-12)/log((1.0+((2.0*modelPar_EOT)/instancePar_D))));
            instanceVar_Ach = (((3.14159265358979323846*instancePar_D)*instancePar_D)/4.0);
            instanceVar_rc = ((2.0*instanceVar_Cins)/(((instanceVar_Weff_UFCM*instanceVar_Weff_UFCM)*instanceVar_epssub)/instanceVar_Ach));
            instanceVar_Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*instanceVar_Ach)/instanceVar_Cins);
          }
          else
            if ( modelPar_GEOMOD == (4))
            {
              instanceVar_Weff_UFCM = modelPar_W_UFCM;
              instanceVar_Cins = modelPar_CINS_UFCM;
              instanceVar_Ach = modelPar_ACH_UFCM;
              instanceVar_rc = ((2.0*instanceVar_Cins)/(((instanceVar_Weff_UFCM*instanceVar_Weff_UFCM)*instanceVar_epssub)/instanceVar_Ach));
              instanceVar_Qdep_ov_Cins = ((((-1.60219e-19)*NBODY_i)*instanceVar_Ach)/instanceVar_Cins);
            }
            else
            {
              // no default
            }
    instanceVar_cox = (instanceVar_Cins/instanceVar_Weff_UFCM);
    if ((modelPar_BULKMOD!=0))
    {
      instanceVar_cox_acc = ((instanceVar_cox*modelPar_EOT)/modelPar_EOTACC);
    }
    instanceVar_Weff0 = (instanceVar_Weff_UFCM-modelPar_DELTAW);
    instanceVar_WeffCV0 = (instanceVar_Weff_UFCM-modelPar_DELTAWCV);
    instanceVar_scl = sqrt((((instanceVar_epssub*instanceVar_Ach)/instanceVar_Cins)*(1.0+((instanceVar_Ach*instanceVar_Cins)/(((2.0*instanceVar_epssub)*instanceVar_Weff_UFCM)*instanceVar_Weff_UFCM)))));
    instanceVar_PHIG_i = (((modelPar_PHIG+(Inv_L*modelPar_LPHIG))+(Inv_NFIN*modelPar_NPHIG))+(Inv_LNFIN*modelPar_PPHIG));
    NGATE_i = (((modelPar_NGATE+(Inv_L*modelPar_LNGATE))+(Inv_NFIN*modelPar_NNGATE))+(Inv_LNFIN*modelPar_PNGATE));
    instanceVar_CIT_i = (((modelPar_CIT+(Inv_L*modelPar_LCIT))+(Inv_NFIN*modelPar_NCIT))+(Inv_LNFIN*modelPar_PCIT));
    instanceVar_CDSC_i = (((modelPar_CDSC+(Inv_L*modelPar_LCDSC))+(Inv_NFIN*modelPar_NCDSC))+(Inv_LNFIN*modelPar_PCDSC));
    instanceVar_CDSCD_i = (((modelPar_CDSCD+(Inv_L*modelPar_LCDSCD))+(Inv_NFIN*modelPar_NCDSCD))+(Inv_LNFIN*modelPar_PCDSCD));
    instanceVar_DVT0_i = (((modelPar_DVT0+(Inv_L*modelPar_LDVT0))+(Inv_NFIN*modelPar_NDVT0))+(Inv_LNFIN*modelPar_PDVT0));
    DVT1_i = (((modelPar_DVT1+(Inv_L*modelPar_LDVT1))+(Inv_NFIN*modelPar_NDVT1))+(Inv_LNFIN*modelPar_PDVT1));
    DVT1SS_i = (((modelPar_DVT1SS+(Inv_L*modelPar_LDVT1SS))+(Inv_NFIN*modelPar_NDVT1SS))+(Inv_LNFIN*modelPar_PDVT1SS));
    instanceVar_PHIN_i = (((modelPar_PHIN+(Inv_L*modelPar_LPHIN))+(Inv_NFIN*modelPar_NPHIN))+(Inv_LNFIN*modelPar_PPHIN));
    instanceVar_ETA0_i = (((modelPar_ETA0+(Inv_L*modelPar_LETA0))+(Inv_NFIN*modelPar_NETA0))+(Inv_LNFIN*modelPar_PETA0));
    DSUB_i = (((modelPar_DSUB+(Inv_L*modelPar_LDSUB))+(Inv_NFIN*modelPar_NDSUB))+(Inv_LNFIN*modelPar_PDSUB));
    instanceVar_K1RSCE_i = (((modelPar_K1RSCE+(Inv_L*modelPar_LK1RSCE))+(Inv_NFIN*modelPar_NK1RSCE))+(Inv_LNFIN*modelPar_PK1RSCE));
    LPE0_i = (((modelPar_LPE0+(Inv_L*modelPar_LLPE0))+(Inv_NFIN*modelPar_NLPE0))+(Inv_LNFIN*modelPar_PLPE0));
    instanceVar_DVTSHIFT_i = (((modelPar_DVTSHIFT+(Inv_L*modelPar_LDVTSHIFT))+(Inv_NFIN*modelPar_NDVTSHIFT))+(Inv_LNFIN*modelPar_PDVTSHIFT));
    instanceVar_K0_i = (((modelPar_K0+(Inv_L*modelPar_LK0))+(Inv_NFIN*modelPar_NK0))+(Inv_LNFIN*modelPar_PK0));
    instanceVar_K01_i = (((modelPar_K01+(Inv_L*modelPar_LK01))+(Inv_NFIN*modelPar_NK01))+(Inv_LNFIN*modelPar_PK01));
    instanceVar_K0SI_i = (((modelPar_K0SI+(Inv_L*modelPar_LK0SI))+(Inv_NFIN*modelPar_NK0SI))+(Inv_LNFIN*modelPar_PK0SI));
    instanceVar_K0SI1_i = (((modelPar_K0SI1+(Inv_L*modelPar_LK0SI1))+(Inv_NFIN*modelPar_NK0SI1))+(Inv_LNFIN*modelPar_PK0SI1));
    instanceVar_K2SI_i = (((modelPar_K2SI+(Inv_L*modelPar_LK2SI))+(Inv_NFIN*modelPar_NK2SI))+(Inv_LNFIN*modelPar_PK2SI));
    instanceVar_K2SI1_i = (((modelPar_K2SI1+(Inv_L*modelPar_LK2SI1))+(Inv_NFIN*modelPar_NK2SI1))+(Inv_LNFIN*modelPar_PK2SI1));
    instanceVar_K0SISAT_i = (((modelPar_K0SISAT+(Inv_L*modelPar_LK0SISAT))+(Inv_NFIN*modelPar_NK0SISAT))+(Inv_LNFIN*modelPar_PK0SISAT));
    instanceVar_K0SISAT1_i = (((modelPar_K0SISAT1+(Inv_L*modelPar_LK0SISAT1))+(Inv_NFIN*modelPar_NK0SISAT1))+(Inv_LNFIN*modelPar_PK0SISAT1));
    instanceVar_K2SISAT_i = (((modelPar_K2SISAT+(Inv_L*modelPar_LK2SISAT))+(Inv_NFIN*modelPar_NK2SISAT))+(Inv_LNFIN*modelPar_PK2SISAT));
    instanceVar_K2SISAT1_i = (((modelPar_K2SISAT1+(Inv_L*modelPar_LK2SISAT1))+(Inv_NFIN*modelPar_NK2SISAT1))+(Inv_LNFIN*modelPar_PK2SISAT1));
    if ((modelPar_BULKMOD!=0))
    {
      if ((modelPar_BULKMOD==2))
      {
        instanceVar_K2_i = (((modelPar_K2+(Inv_L*modelPar_LK2))+(Inv_NFIN*modelPar_NK2))+(Inv_LNFIN*modelPar_PK2));
        instanceVar_K21_i = (((modelPar_K21+(Inv_L*modelPar_LK21))+(Inv_NFIN*modelPar_NK21))+(Inv_LNFIN*modelPar_PK21));
        instanceVar_K2SAT_i = (((modelPar_K2SAT+(Inv_L*modelPar_LK2SAT))+(Inv_NFIN*modelPar_NK2SAT))+(Inv_LNFIN*modelPar_PK2SAT));
        instanceVar_K2SAT1_i = (((modelPar_K2SAT1+(Inv_L*modelPar_LK2SAT1))+(Inv_NFIN*modelPar_NK2SAT1))+(Inv_LNFIN*modelPar_PK2SAT1));
      }
      instanceVar_PHIBE_i = (((modelPar_PHIBE+(Inv_L*modelPar_LPHIBE))+(Inv_NFIN*modelPar_NPHIBE))+(Inv_LNFIN*modelPar_PPHIBE));
      instanceVar_K1_i = (((modelPar_K1+(Inv_L*modelPar_LK1))+(Inv_NFIN*modelPar_NK1))+(Inv_LNFIN*modelPar_PK1));
      instanceVar_K11_i = (((modelPar_K11+(Inv_L*modelPar_LK11))+(Inv_NFIN*modelPar_NK11))+(Inv_LNFIN*modelPar_PK11));
    }
    instanceVar_QMFACTOR_i = (((modelPar_QMFACTOR+(Inv_L*modelPar_LQMFACTOR))+(Inv_NFIN*modelPar_NQMFACTOR))+(Inv_LNFIN*modelPar_PQMFACTOR));
    instanceVar_QMTCENCV_i = (((modelPar_QMTCENCV+(Inv_L*modelPar_LQMTCENCV))+(Inv_NFIN*modelPar_NQMTCENCV))+(Inv_LNFIN*modelPar_PQMTCENCV));
    instanceVar_QMTCENCVA_i = (((modelPar_QMTCENCVA+(Inv_L*modelPar_LQMTCENCVA))+(Inv_NFIN*modelPar_NQMTCENCVA))+(Inv_LNFIN*modelPar_PQMTCENCVA));
    instanceVar_VSAT_i = (((modelPar_VSAT+(Inv_L*modelPar_LVSAT))+(Inv_NFIN*modelPar_NVSAT))+(Inv_LNFIN*modelPar_PVSAT));
    instanceVar_VSAT1_i = (((modelPar_VSAT1+(Inv_L*modelPar_LVSAT1))+(Inv_NFIN*modelPar_NVSAT1))+(Inv_LNFIN*modelPar_PVSAT1));
    instanceVar_VSATCV_i = (((modelPar_VSATCV+(Inv_L*modelPar_LVSATCV))+(Inv_NFIN*modelPar_NVSATCV))+(Inv_LNFIN*modelPar_PVSATCV));
    instanceVar_DELTAVSAT_i = (((modelPar_DELTAVSAT+(Inv_L*modelPar_LDELTAVSAT))+(Inv_NFIN*modelPar_NDELTAVSAT))+(Inv_LNFIN*modelPar_PDELTAVSAT));
    instanceVar_PSAT_i = (((modelPar_PSAT+(Inv_L*modelPar_LPSAT))+(Inv_NFIN*modelPar_NPSAT))+(Inv_LNFIN*modelPar_PPSAT));
    instanceVar_DELTAVSATCV_i = (((modelPar_DELTAVSATCV+(Inv_L*modelPar_LDELTAVSATCV))+(Inv_NFIN*modelPar_NDELTAVSATCV))+(Inv_LNFIN*modelPar_PDELTAVSATCV));
    instanceVar_PSATCV_i = (((modelPar_PSATCV+(Inv_L*modelPar_LPSATCV))+(Inv_NFIN*modelPar_NPSATCV))+(Inv_LNFIN*modelPar_PPSATCV));
    instanceVar_KSATIV_i = (((modelPar_KSATIV+(Inv_L*modelPar_LKSATIV))+(Inv_NFIN*modelPar_NKSATIV))+(Inv_LNFIN*modelPar_PKSATIV));
    instanceVar_MEXP_i = (((modelPar_MEXP+(Inv_L*modelPar_LMEXP))+(Inv_NFIN*modelPar_NMEXP))+(Inv_LNFIN*modelPar_PMEXP));
    instanceVar_PTWG_i = (((modelPar_PTWG+(Inv_L*modelPar_LPTWG))+(Inv_NFIN*modelPar_NPTWG))+(Inv_LNFIN*modelPar_PPTWG));
    instanceVar_U0_i = (((modelPar_U0+(Inv_L*modelPar_LU0))+(Inv_NFIN*modelPar_NU0))+(Inv_LNFIN*modelPar_PU0));
    instanceVar_ETAMOB_i = (((modelPar_ETAMOB+(Inv_L*modelPar_LETAMOB))+(Inv_NFIN*modelPar_NETAMOB))+(Inv_LNFIN*modelPar_PETAMOB));
    UP_i = (((modelPar_UP+(Inv_L*modelPar_LUP))+(Inv_NFIN*modelPar_NUP))+(Inv_LNFIN*modelPar_PUP));
    instanceVar_UA_i = (((modelPar_UA+(Inv_L*modelPar_LUA))+(Inv_NFIN*modelPar_NUA))+(Inv_LNFIN*modelPar_PUA));
    if ((modelPar_BULKMOD!=0))
    {
      instanceVar_UC_i = (((modelPar_UC+(Inv_L*modelPar_LUC))+(Inv_NFIN*modelPar_NUC))+(Inv_LNFIN*modelPar_PUC));
    }
    instanceVar_EU_i = (((modelPar_EU+(Inv_L*modelPar_LEU))+(Inv_NFIN*modelPar_NEU))+(Inv_LNFIN*modelPar_PEU));
    instanceVar_UD_i = (((modelPar_UD+(Inv_L*modelPar_LUD))+(Inv_NFIN*modelPar_NUD))+(Inv_LNFIN*modelPar_PUD));
    instanceVar_UCS_i = (((modelPar_UCS+(Inv_L*modelPar_LUCS))+(Inv_NFIN*modelPar_NUCS))+(Inv_LNFIN*modelPar_PUCS));
    instanceVar_PCLM_i = (((modelPar_PCLM+(Inv_L*modelPar_LPCLM))+(Inv_NFIN*modelPar_NPCLM))+(Inv_LNFIN*modelPar_PPCLM));
    instanceVar_PCLMG_i = (((modelPar_PCLMG+(Inv_L*modelPar_LPCLMG))+(Inv_NFIN*modelPar_NPCLMG))+(Inv_LNFIN*modelPar_PPCLMG));
    instanceVar_PCLMCV_i = (((modelPar_PCLMCV+(Inv_L*modelPar_LPCLMCV))+(Inv_NFIN*modelPar_NPCLMCV))+(Inv_LNFIN*modelPar_PPCLMCV));
    instanceVar_A1_i = (((modelPar_A1+(Inv_L*modelPar_LA1))+(Inv_NFIN*modelPar_NA1))+(Inv_LNFIN*modelPar_PA1));
    instanceVar_A11_i = (((modelPar_A11+(Inv_L*modelPar_LA11))+(Inv_NFIN*modelPar_NA11))+(Inv_LNFIN*modelPar_PA11));
    instanceVar_A2_i = (((modelPar_A2+(Inv_L*modelPar_LA2))+(Inv_NFIN*modelPar_NA2))+(Inv_LNFIN*modelPar_PA2));
    instanceVar_A21_i = (((modelPar_A21+(Inv_L*modelPar_LA21))+(Inv_NFIN*modelPar_NA21))+(Inv_LNFIN*modelPar_PA21));
    instanceVar_RDSW_i = (((modelPar_RDSW+(Inv_L*modelPar_LRDSW))+(Inv_NFIN*modelPar_NRDSW))+(Inv_LNFIN*modelPar_PRDSW));
    instanceVar_RSW_i = (((modelPar_RSW+(Inv_L*modelPar_LRSW))+(Inv_NFIN*modelPar_NRSW))+(Inv_LNFIN*modelPar_PRSW));
    instanceVar_RDW_i = (((modelPar_RDW+(Inv_L*modelPar_LRDW))+(Inv_NFIN*modelPar_NRDW))+(Inv_LNFIN*modelPar_PRDW));
    instanceVar_PRWGD_i = (((modelPar_PRWGD+(Inv_L*modelPar_LPRWGD))+(Inv_NFIN*modelPar_NPRWGD))+(Inv_LNFIN*modelPar_PPRWGD));
    instanceVar_PRWGS_i = (((modelPar_PRWGS+(Inv_L*modelPar_LPRWGS))+(Inv_NFIN*modelPar_NPRWGS))+(Inv_LNFIN*modelPar_PPRWGS));
    WR_i = (((modelPar_WR+(Inv_L*modelPar_LWR))+(Inv_NFIN*modelPar_NWR))+(Inv_LNFIN*modelPar_PWR));
    instanceVar_PDIBL1_i = (((modelPar_PDIBL1+(Inv_L*modelPar_LPDIBL1))+(Inv_NFIN*modelPar_NPDIBL1))+(Inv_LNFIN*modelPar_PPDIBL1));
    instanceVar_PDIBL2_i = (((modelPar_PDIBL2+(Inv_L*modelPar_LPDIBL2))+(Inv_NFIN*modelPar_NPDIBL2))+(Inv_LNFIN*modelPar_PPDIBL2));
    instanceVar_DROUT_i = (((modelPar_DROUT+(Inv_L*modelPar_LDROUT))+(Inv_NFIN*modelPar_NDROUT))+(Inv_LNFIN*modelPar_PDROUT));
    instanceVar_PVAG_i = (((modelPar_PVAG+(Inv_L*modelPar_LPVAG))+(Inv_NFIN*modelPar_NPVAG))+(Inv_LNFIN*modelPar_PPVAG));
    instanceVar_AIGBINV_i = (((modelPar_AIGBINV+(Inv_L*modelPar_LAIGBINV))+(Inv_NFIN*modelPar_NAIGBINV))+(Inv_LNFIN*modelPar_PAIGBINV));
    instanceVar_AIGBINV1_i = (((modelPar_AIGBINV1+(Inv_L*modelPar_LAIGBINV1))+(Inv_NFIN*modelPar_NAIGBINV1))+(Inv_LNFIN*modelPar_PAIGBINV1));
    instanceVar_BIGBINV_i = (((modelPar_BIGBINV+(Inv_L*modelPar_LBIGBINV))+(Inv_NFIN*modelPar_NBIGBINV))+(Inv_LNFIN*modelPar_PBIGBINV));
    instanceVar_CIGBINV_i = (((modelPar_CIGBINV+(Inv_L*modelPar_LCIGBINV))+(Inv_NFIN*modelPar_NCIGBINV))+(Inv_LNFIN*modelPar_PCIGBINV));
    instanceVar_EIGBINV_i = (((modelPar_EIGBINV+(Inv_L*modelPar_LEIGBINV))+(Inv_NFIN*modelPar_NEIGBINV))+(Inv_LNFIN*modelPar_PEIGBINV));
    instanceVar_NIGBINV_i = (((modelPar_NIGBINV+(Inv_L*modelPar_LNIGBINV))+(Inv_NFIN*modelPar_NNIGBINV))+(Inv_LNFIN*modelPar_PNIGBINV));
    instanceVar_AIGBACC_i = (((modelPar_AIGBACC+(Inv_L*modelPar_LAIGBACC))+(Inv_NFIN*modelPar_NAIGBACC))+(Inv_LNFIN*modelPar_PAIGBACC));
    instanceVar_AIGBACC1_i = (((modelPar_AIGBACC1+(Inv_L*modelPar_LAIGBACC1))+(Inv_NFIN*modelPar_NAIGBACC1))+(Inv_LNFIN*modelPar_PAIGBACC1));
    instanceVar_BIGBACC_i = (((modelPar_BIGBACC+(Inv_L*modelPar_LBIGBACC))+(Inv_NFIN*modelPar_NBIGBACC))+(Inv_LNFIN*modelPar_PBIGBACC));
    instanceVar_CIGBACC_i = (((modelPar_CIGBACC+(Inv_L*modelPar_LCIGBACC))+(Inv_NFIN*modelPar_NCIGBACC))+(Inv_LNFIN*modelPar_PCIGBACC));
    instanceVar_NIGBACC_i = (((modelPar_NIGBACC+(Inv_L*modelPar_LNIGBACC))+(Inv_NFIN*modelPar_NNIGBACC))+(Inv_LNFIN*modelPar_PNIGBACC));
    instanceVar_AIGC_i = (((modelPar_AIGC+(Inv_L*modelPar_LAIGC))+(Inv_NFIN*modelPar_NAIGC))+(Inv_LNFIN*modelPar_PAIGC));
    instanceVar_AIGC1_i = (((modelPar_AIGC1+(Inv_L*modelPar_LAIGC1))+(Inv_NFIN*modelPar_NAIGC1))+(Inv_LNFIN*modelPar_PAIGC1));
    instanceVar_BIGC_i = (((modelPar_BIGC+(Inv_L*modelPar_LBIGC))+(Inv_NFIN*modelPar_NBIGC))+(Inv_LNFIN*modelPar_PBIGC));
    instanceVar_CIGC_i = (((modelPar_CIGC+(Inv_L*modelPar_LCIGC))+(Inv_NFIN*modelPar_NCIGC))+(Inv_LNFIN*modelPar_PCIGC));
    instanceVar_PIGCD_i = (((modelPar_PIGCD+(Inv_L*modelPar_LPIGCD))+(Inv_NFIN*modelPar_NPIGCD))+(Inv_LNFIN*modelPar_PPIGCD));
    instanceVar_AIGS_i = (((modelPar_AIGS+(Inv_L*modelPar_LAIGS))+(Inv_NFIN*modelPar_NAIGS))+(Inv_LNFIN*modelPar_PAIGS));
    instanceVar_AIGS1_i = (((modelPar_AIGS1+(Inv_L*modelPar_LAIGS1))+(Inv_NFIN*modelPar_NAIGS1))+(Inv_LNFIN*modelPar_PAIGS1));
    instanceVar_BIGS_i = (((modelPar_BIGS+(Inv_L*modelPar_LBIGS))+(Inv_NFIN*modelPar_NBIGS))+(Inv_LNFIN*modelPar_PBIGS));
    instanceVar_CIGS_i = (((modelPar_CIGS+(Inv_L*modelPar_LCIGS))+(Inv_NFIN*modelPar_NCIGS))+(Inv_LNFIN*modelPar_PCIGS));
    instanceVar_AIGD_i = (((modelPar_AIGD+(Inv_L*modelPar_LAIGD))+(Inv_NFIN*modelPar_NAIGD))+(Inv_LNFIN*modelPar_PAIGD));
    instanceVar_AIGD1_i = (((modelPar_AIGD1+(Inv_L*modelPar_LAIGD1))+(Inv_NFIN*modelPar_NAIGD1))+(Inv_LNFIN*modelPar_PAIGD1));
    instanceVar_BIGD_i = (((modelPar_BIGD+(Inv_L*modelPar_LBIGD))+(Inv_NFIN*modelPar_NBIGD))+(Inv_LNFIN*modelPar_PBIGD));
    instanceVar_CIGD_i = (((modelPar_CIGD+(Inv_L*modelPar_LCIGD))+(Inv_NFIN*modelPar_NCIGD))+(Inv_LNFIN*modelPar_PCIGD));
    NTOX_i = (((modelPar_NTOX+(Inv_L*modelPar_LNTOX))+(Inv_NFIN*modelPar_NNTOX))+(Inv_LNFIN*modelPar_PNTOX));
    instanceVar_POXEDGE_i = (((modelPar_POXEDGE+(Inv_L*modelPar_LPOXEDGE))+(Inv_NFIN*modelPar_NPOXEDGE))+(Inv_LNFIN*modelPar_PPOXEDGE));
    instanceVar_AGIDL_i = (((modelPar_AGIDL+(Inv_L*modelPar_LAGIDL))+(Inv_NFIN*modelPar_NAGIDL))+(Inv_LNFIN*modelPar_PAGIDL));
    instanceVar_BGIDL_i = (((modelPar_BGIDL+(Inv_L*modelPar_LBGIDL))+(Inv_NFIN*modelPar_NBGIDL))+(Inv_LNFIN*modelPar_PBGIDL));
    instanceVar_CGIDL_i = (((modelPar_CGIDL+(Inv_L*modelPar_LCGIDL))+(Inv_NFIN*modelPar_NCGIDL))+(Inv_LNFIN*modelPar_PCGIDL));
    instanceVar_EGIDL_i = (((modelPar_EGIDL+(Inv_L*modelPar_LEGIDL))+(Inv_NFIN*modelPar_NEGIDL))+(Inv_LNFIN*modelPar_PEGIDL));
    instanceVar_PGIDL_i = (((modelPar_PGIDL+(Inv_L*modelPar_LPGIDL))+(Inv_NFIN*modelPar_NPGIDL))+(Inv_LNFIN*modelPar_PPGIDL));
    instanceVar_AGISL_i = (((modelPar_AGISL+(Inv_L*modelPar_LAGISL))+(Inv_NFIN*modelPar_NAGISL))+(Inv_LNFIN*modelPar_PAGISL));
    instanceVar_BGISL_i = (((modelPar_BGISL+(Inv_L*modelPar_LBGISL))+(Inv_NFIN*modelPar_NBGISL))+(Inv_LNFIN*modelPar_PBGISL));
    instanceVar_CGISL_i = (((modelPar_CGISL+(Inv_L*modelPar_LCGISL))+(Inv_NFIN*modelPar_NCGISL))+(Inv_LNFIN*modelPar_PCGISL));
    instanceVar_EGISL_i = (((modelPar_EGISL+(Inv_L*modelPar_LEGISL))+(Inv_NFIN*modelPar_NEGISL))+(Inv_LNFIN*modelPar_PEGISL));
    instanceVar_PGISL_i = (((modelPar_PGISL+(Inv_L*modelPar_LPGISL))+(Inv_NFIN*modelPar_NPGISL))+(Inv_LNFIN*modelPar_PPGISL));
    instanceVar_ALPHA0_i = (((modelPar_ALPHA0+(Inv_L*modelPar_LALPHA0))+(Inv_NFIN*modelPar_NALPHA0))+(Inv_LNFIN*modelPar_PALPHA0));
    instanceVar_ALPHA1_i = (((modelPar_ALPHA1+(Inv_L*modelPar_LALPHA1))+(Inv_NFIN*modelPar_NALPHA1))+(Inv_LNFIN*modelPar_PALPHA1));
    instanceVar_ALPHAII0_i = (((modelPar_ALPHAII0+(Inv_L*modelPar_LALPHAII0))+(Inv_NFIN*modelPar_NALPHAII0))+(Inv_LNFIN*modelPar_PALPHAII0));
    instanceVar_ALPHAII1_i = (((modelPar_ALPHAII1+(Inv_L*modelPar_LALPHAII1))+(Inv_NFIN*modelPar_NALPHAII1))+(Inv_LNFIN*modelPar_PALPHAII1));
    instanceVar_BETA0_i = (((modelPar_BETA0+(Inv_L*modelPar_LBETA0))+(Inv_NFIN*modelPar_NBETA0))+(Inv_LNFIN*modelPar_PBETA0));
    instanceVar_BETAII0_i = (((modelPar_BETAII0+(Inv_L*modelPar_LBETAII0))+(Inv_NFIN*modelPar_NBETAII0))+(Inv_LNFIN*modelPar_PBETAII0));
    instanceVar_BETAII1_i = (((modelPar_BETAII1+(Inv_L*modelPar_LBETAII1))+(Inv_NFIN*modelPar_NBETAII1))+(Inv_LNFIN*modelPar_PBETAII1));
    instanceVar_BETAII2_i = (((modelPar_BETAII2+(Inv_L*modelPar_LBETAII2))+(Inv_NFIN*modelPar_NBETAII2))+(Inv_LNFIN*modelPar_PBETAII2));
    instanceVar_ESATII_i = (((modelPar_ESATII+(Inv_L*modelPar_LESATII))+(Inv_NFIN*modelPar_NESATII))+(Inv_LNFIN*modelPar_PESATII));
    instanceVar_LII_i = (((modelPar_LII+(Inv_L*modelPar_LLII))+(Inv_NFIN*modelPar_NLII))+(Inv_LNFIN*modelPar_PLII));
    instanceVar_SII0_i = (((modelPar_SII0+(Inv_L*modelPar_LSII0))+(Inv_NFIN*modelPar_NSII0))+(Inv_LNFIN*modelPar_PSII0));
    instanceVar_SII1_i = (((modelPar_SII1+(Inv_L*modelPar_LSII1))+(Inv_NFIN*modelPar_NSII1))+(Inv_LNFIN*modelPar_PSII1));
    instanceVar_SII2_i = (((modelPar_SII2+(Inv_L*modelPar_LSII2))+(Inv_NFIN*modelPar_NSII2))+(Inv_LNFIN*modelPar_PSII2));
    instanceVar_SIID_i = (((modelPar_SIID+(Inv_L*modelPar_LSIID))+(Inv_NFIN*modelPar_NSIID))+(Inv_LNFIN*modelPar_PSIID));
    instanceVar_TII_i = (((modelPar_TII+(Inv_L*modelPar_LTII))+(Inv_NFIN*modelPar_NTII))+(Inv_LNFIN*modelPar_PTII));
    instanceVar_CFS_i = (((modelPar_CFS+(Inv_L*modelPar_LCFS))+(Inv_NFIN*modelPar_NCFS))+(Inv_LNFIN*modelPar_PCFS));
    instanceVar_CFD_i = (((modelPar_CFD+(Inv_L*modelPar_LCFD))+(Inv_NFIN*modelPar_NCFD))+(Inv_LNFIN*modelPar_PCFD));
    instanceVar_COVS_i = (((instancePar_COVS+(Inv_L*modelPar_LCOVS))+(Inv_NFIN*modelPar_NCOVS))+(Inv_LNFIN*modelPar_PCOVS));
    instanceVar_COVD_i = (((instancePar_COVD+(Inv_L*modelPar_LCOVD))+(Inv_NFIN*modelPar_NCOVD))+(Inv_LNFIN*modelPar_PCOVD));
    instanceVar_CGSL_i = (((modelPar_CGSL+(Inv_L*modelPar_LCGSL))+(Inv_NFIN*modelPar_NCGSL))+(Inv_LNFIN*modelPar_PCGSL));
    instanceVar_CGDL_i = (((modelPar_CGDL+(Inv_L*modelPar_LCGDL))+(Inv_NFIN*modelPar_NCGDL))+(Inv_LNFIN*modelPar_PCGDL));
    instanceVar_CGBL_i = (((modelPar_CGBL+(Inv_L*modelPar_LCGBL))+(Inv_NFIN*modelPar_NCGBL))+(Inv_LNFIN*modelPar_PCGBL));
    instanceVar_CKAPPAS_i = (((modelPar_CKAPPAS+(Inv_L*modelPar_LCKAPPAS))+(Inv_NFIN*modelPar_NCKAPPAS))+(Inv_LNFIN*modelPar_PCKAPPAS));
    instanceVar_CKAPPAD_i = (((modelPar_CKAPPAD+(Inv_L*modelPar_LCKAPPAD))+(Inv_NFIN*modelPar_NCKAPPAD))+(Inv_LNFIN*modelPar_PCKAPPAD));
    instanceVar_CKAPPAB_i = (((modelPar_CKAPPAB+(Inv_L*modelPar_LCKAPPAB))+(Inv_NFIN*modelPar_NCKAPPAB))+(Inv_LNFIN*modelPar_PCKAPPAB));
    instanceVar_NTGEN_i = (((modelPar_NTGEN+(Inv_L*modelPar_LNTGEN))+(Inv_NFIN*modelPar_NNTGEN))+(Inv_LNFIN*modelPar_PNTGEN));
    instanceVar_AIGEN_i = (((modelPar_AIGEN+(Inv_L*modelPar_LAIGEN))+(Inv_NFIN*modelPar_NAIGEN))+(Inv_LNFIN*modelPar_PAIGEN));
    instanceVar_BIGEN_i = (((modelPar_BIGEN+(Inv_L*modelPar_LBIGEN))+(Inv_NFIN*modelPar_NBIGEN))+(Inv_LNFIN*modelPar_PBIGEN));
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_CDSCDR_i = (((modelPar_CDSCDR+(Inv_L*modelPar_LCDSCDR))+(Inv_NFIN*modelPar_NCDSCDR))+(Inv_LNFIN*modelPar_PCDSCDR));
      instanceVar_CITR_i = (((modelPar_CITR+(Inv_L*modelPar_LCITR))+(Inv_NFIN*modelPar_NCITR))+(Inv_LNFIN*modelPar_PCITR));
      instanceVar_ETA0R_i = (((modelPar_ETA0R+(Inv_L*modelPar_LETA0R))+(Inv_NFIN*modelPar_NETA0R))+(Inv_LNFIN*modelPar_PETA0R));
      instanceVar_VSAT1R_i = (((modelPar_VSAT1R+(Inv_L*modelPar_LVSAT1R))+(Inv_NFIN*modelPar_NVSAT1R))+(Inv_LNFIN*modelPar_PVSAT1R));
      instanceVar_MEXPR_i = (((modelPar_MEXPR+(Inv_L*modelPar_LMEXPR))+(Inv_NFIN*modelPar_NMEXPR))+(Inv_LNFIN*modelPar_PMEXPR));
      instanceVar_PTWGR_i = (((modelPar_PTWGR+(Inv_L*modelPar_LPTWGR))+(Inv_NFIN*modelPar_NPTWGR))+(Inv_LNFIN*modelPar_PPTWGR));
      instanceVar_PDIBL1R_i = (((modelPar_PDIBL1R+(Inv_L*modelPar_LPDIBL1R))+(Inv_NFIN*modelPar_NPDIBL1R))+(Inv_LNFIN*modelPar_PPDIBL1R));
      instanceVar_PDIBL2R_i = (((modelPar_PDIBL2R+(Inv_L*modelPar_LPDIBL2R))+(Inv_NFIN*modelPar_NPDIBL2R))+(Inv_LNFIN*modelPar_PPDIBL2R));
      instanceVar_PCLMR_i = (((modelPar_PCLMR+(Inv_L*modelPar_LPCLMR))+(Inv_NFIN*modelPar_NPCLMR))+(Inv_LNFIN*modelPar_PPCLMR));
      instanceVar_DVTSHIFTR_i = (((modelPar_DVTSHIFTR+(Inv_L*modelPar_LDVTSHIFTR))+(Inv_NFIN*modelPar_NDVTSHIFTR))+(Inv_LNFIN*modelPar_PDVTSHIFTR));
      instanceVar_VSATR_i = (((modelPar_VSATR+(Inv_L*modelPar_LVSATR))+(Inv_NFIN*modelPar_NVSATR))+(Inv_LNFIN*modelPar_PVSATR));
      instanceVar_KSATIVR_i = (((modelPar_KSATIVR+(Inv_L*modelPar_LKSATIVR))+(Inv_NFIN*modelPar_NKSATIVR))+(Inv_LNFIN*modelPar_PKSATIVR));
      instanceVar_U0R_i = (((modelPar_U0R+(Inv_L*modelPar_LU0R))+(Inv_NFIN*modelPar_NU0R))+(Inv_LNFIN*modelPar_PU0R));
      instanceVar_UAR_i = (((modelPar_UAR+(Inv_L*modelPar_LUAR))+(Inv_NFIN*modelPar_NUAR))+(Inv_LNFIN*modelPar_PUAR));
      UPR_i = (((modelPar_UPR+(Inv_L*modelPar_LUPR))+(Inv_NFIN*modelPar_NUPR))+(Inv_LNFIN*modelPar_PUPR));
      if ((modelPar_BULKMOD!=0))
      {
        instanceVar_UCR_i = (((modelPar_UCR+(Inv_L*modelPar_LUCR))+(Inv_NFIN*modelPar_NUCR))+(Inv_LNFIN*modelPar_PUCR));
      }
      instanceVar_EUR_i = (((modelPar_EUR+(Inv_L*modelPar_LEUR))+(Inv_NFIN*modelPar_NEUR))+(Inv_LNFIN*modelPar_PEUR));
      instanceVar_UDR_i = (((modelPar_UDR+(Inv_L*modelPar_LUDR))+(Inv_NFIN*modelPar_NUDR))+(Inv_LNFIN*modelPar_PUDR));
    }
    if ((modelPar_NQSMOD==1))
    {
      std::cerr  << " Although the model selector NQSMOD is set to 1, the NQS gate resistance model is not activated in the Verilog-A code. Please uncomment `define __NQSMOD1__ in bsimcmg.va to activate it." <<  std::endl; 
    }
    if ((modelPar_NQSMOD==2))
    {
      std::cerr  << " Although the model selector NQSMOD is set to 2, the NQS gate resistance model is not activated in the Verilog-A code. Please uncomment `define __NQSMOD2__ in bsimcmg.va to activate it." <<  std::endl; 
    }
    instanceVar_UTE_i = (((modelPar_UTE+(Inv_L*modelPar_LUTE))+(Inv_NFIN*modelPar_NUTE))+(Inv_LNFIN*modelPar_PUTE));
    instanceVar_UTL_i = (((modelPar_UTL+(Inv_L*modelPar_LUTL))+(Inv_NFIN*modelPar_NUTL))+(Inv_LNFIN*modelPar_PUTL));
    instanceVar_EMOBT_i = (((modelPar_EMOBT+(Inv_L*modelPar_LEMOBT))+(Inv_NFIN*modelPar_NEMOBT))+(Inv_LNFIN*modelPar_PEMOBT));
    instanceVar_UA1_i = (((modelPar_UA1+(Inv_L*modelPar_LUA1))+(Inv_NFIN*modelPar_NUA1))+(Inv_LNFIN*modelPar_PUA1));
    if ((modelPar_BULKMOD!=0))
    {
      instanceVar_UC1_i = (((modelPar_UC1+(Inv_L*modelPar_LUC1))+(Inv_NFIN*modelPar_NUC1))+(Inv_LNFIN*modelPar_PUC1));
    }
    instanceVar_UD1_i = (((modelPar_UD1+(Inv_L*modelPar_LUD1))+(Inv_NFIN*modelPar_NUD1))+(Inv_LNFIN*modelPar_PUD1));
    instanceVar_UCSTE_i = (((modelPar_UCSTE+(Inv_L*modelPar_LUCSTE))+(Inv_NFIN*modelPar_NUCSTE))+(Inv_LNFIN*modelPar_PUCSTE));
    instanceVar_PTWGT_i = (((modelPar_PTWGT+(Inv_L*modelPar_LPTWGT))+(Inv_NFIN*modelPar_NPTWGT))+(Inv_LNFIN*modelPar_PPTWGT));
    instanceVar_AT_i = (((modelPar_AT+(Inv_L*modelPar_LAT))+(Inv_NFIN*modelPar_NAT))+(Inv_LNFIN*modelPar_PAT));
    instanceVar_ATCV_i = (((modelPar_ATCV+(Inv_L*modelPar_LATCV))+(Inv_NFIN*modelPar_NATCV))+(Inv_LNFIN*modelPar_PATCV));
    instanceVar_PRT_i = (((modelPar_PRT+(Inv_L*modelPar_LPRT))+(Inv_NFIN*modelPar_NPRT))+(Inv_LNFIN*modelPar_PPRT));
    instanceVar_KT1_i = (((modelPar_KT1+(Inv_L*modelPar_LKT1))+(Inv_NFIN*modelPar_NKT1))+(Inv_LNFIN*modelPar_PKT1));
    instanceVar_TSS_i = (((modelPar_TSS+(Inv_L*modelPar_LTSS))+(Inv_NFIN*modelPar_NTSS))+(Inv_LNFIN*modelPar_PTSS));
    instanceVar_IIT_i = (((modelPar_IIT+(Inv_L*modelPar_LIIT))+(Inv_NFIN*modelPar_NIIT))+(Inv_LNFIN*modelPar_PIIT));
    instanceVar_TGIDL_i = (((modelPar_TGIDL+(Inv_L*modelPar_LTGIDL))+(Inv_NFIN*modelPar_NTGIDL))+(Inv_LNFIN*modelPar_PTGIDL));
    instanceVar_IGT_i = (((modelPar_IGT+(Inv_L*modelPar_LIGT))+(Inv_NFIN*modelPar_NIGT))+(Inv_LNFIN*modelPar_PIGT));
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_UTER_i = (((modelPar_UTER+(Inv_L*modelPar_LUTER))+(Inv_NFIN*modelPar_NUTER))+(Inv_LNFIN*modelPar_PUTER));
      instanceVar_UTLR_i = (((modelPar_UTLR+(Inv_L*modelPar_LUTLR))+(Inv_NFIN*modelPar_NUTLR))+(Inv_LNFIN*modelPar_PUTLR));
      instanceVar_UA1R_i = (((modelPar_UA1R+(Inv_L*modelPar_LUA1R))+(Inv_NFIN*modelPar_NUA1R))+(Inv_LNFIN*modelPar_PUA1R));
      instanceVar_UD1R_i = (((modelPar_UD1R+(Inv_L*modelPar_LUD1R))+(Inv_NFIN*modelPar_NUD1R))+(Inv_LNFIN*modelPar_PUD1R));
      instanceVar_ATR_i = (((modelPar_ATR+(Inv_L*modelPar_LATR))+(Inv_NFIN*modelPar_NATR))+(Inv_LNFIN*modelPar_PATR));
      if ((modelPar_BULKMOD!=0))
      {
        instanceVar_UC1R_i = (((modelPar_UC1R+(Inv_L*modelPar_LUC1R))+(Inv_NFIN*modelPar_NUC1R))+(Inv_LNFIN*modelPar_PUC1R));
      }
    }
    if ((modelPar_PHIGN1!=0.0))
    {
      instanceVar_PHIG_i = (instanceVar_PHIG_i*(1.0+((modelPar_PHIGN1/instancePar_NFIN)*AnalogFunctions::lln<AdmsSensFadType>((1.0+(instancePar_NFIN/modelPar_PHIGN2))))));
    }
    if ((modelPar_ETA0N1!=0.0))
    {
      instanceVar_ETA0_i = (instanceVar_ETA0_i*(1.0+((modelPar_ETA0N1/instancePar_NFIN)*AnalogFunctions::lln<AdmsSensFadType>((1.0+(instancePar_NFIN/modelPar_ETA0N2))))));
    }
    if ((modelPar_CDSCN1!=0.0))
    {
      instanceVar_CDSC_i = (instanceVar_CDSC_i*(1.0+((modelPar_CDSCN1/instancePar_NFIN)*AnalogFunctions::lln<AdmsSensFadType>((1.0+(instancePar_NFIN/modelPar_CDSCN2))))));
    }
    if ((modelPar_CDSCDN1!=0.0))
    {
      instanceVar_CDSCD_i = (instanceVar_CDSCD_i*(1.0+((modelPar_CDSCDN1/instancePar_NFIN)*AnalogFunctions::lln<AdmsSensFadType>((1.0+(instancePar_NFIN/modelPar_CDSCDN2))))));
    }
    if ((modelPar_CDSCDRN1!=0.0))
    {
      instanceVar_CDSCDR_i = (instanceVar_CDSCDR_i*(1.0+((modelPar_CDSCDRN1/instancePar_NFIN)*AnalogFunctions::lln<AdmsSensFadType>((1.0+(instancePar_NFIN/modelPar_CDSCDRN2))))));
    }
    if ((modelPar_VSATN1!=0.0))
    {
      instanceVar_VSAT_i = (instanceVar_VSAT_i*(1.0+((modelPar_VSATN1/instancePar_NFIN)*AnalogFunctions::lln<AdmsSensFadType>((1.0+(instancePar_NFIN/modelPar_VSATN2))))));
    }
    if ((modelPar_VSAT1N1!=0.0))
    {
      instanceVar_VSAT1_i = (instanceVar_VSAT1_i*(1.0+((modelPar_VSAT1N1/instancePar_NFIN)*AnalogFunctions::lln<AdmsSensFadType>((1.0+(instancePar_NFIN/modelPar_VSAT1N2))))));
    }
    if ((modelPar_VSAT1RN1!=0.0))
    {
      instanceVar_VSAT1R_i = (instanceVar_VSAT1R_i*(1.0+((modelPar_VSAT1RN1/instancePar_NFIN)*AnalogFunctions::lln<AdmsSensFadType>((1.0+(instancePar_NFIN/modelPar_VSAT1RN2))))));
    }
    if ((modelPar_U0N1!=0.0))
    {
      instanceVar_U0_i = (instanceVar_U0_i*(1.0+((modelPar_U0N1/instancePar_NFIN)*AnalogFunctions::lln<AdmsSensFadType>((1.0+(instancePar_NFIN/modelPar_U0N2))))));
    }
    if (instancePar_given_NFINNOM)
    {
      instanceVar_PHIG_i = (instanceVar_PHIG_i*(1.0+(((instancePar_NFIN-instancePar_NFINNOM)*modelPar_PHIGLT)*instanceVar_Leff)));
      instanceVar_ETA0_i = (instanceVar_ETA0_i*(1.0+(((instancePar_NFIN-instancePar_NFINNOM)*modelPar_ETA0LT)*instanceVar_Leff)));
      instanceVar_U0_i = (instanceVar_U0_i*(1.0+(((instancePar_NFIN-instancePar_NFINNOM)*modelPar_U0LT)*instanceVar_Leff)));
    }
    if ((modelPar_U0N1R!=0.0))
    {
      instanceVar_U0R_i = (instanceVar_U0R_i*(1.0+((modelPar_U0N1R/instancePar_NFIN)*AnalogFunctions::lln<AdmsSensFadType>((1.0+(instancePar_NFIN/modelPar_U0N2R))))));
    }
    instanceVar_PHIG_i = (instanceVar_PHIG_i+(modelPar_PHIGL*instanceVar_Leff));
    if ((modelPar_LPA>0.0))
    {
      instanceVar_U0_i = (instanceVar_U0_i*(1.0-(UP_i*pow(instanceVar_Leff,(-modelPar_LPA)))));
    }
    else
    {
      instanceVar_U0_i = (instanceVar_U0_i*(1.0-UP_i));
    }
    instanceVar_UA_i = (instanceVar_UA_i+(modelPar_AUA*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BUA))));
    instanceVar_UD_i = (instanceVar_UD_i+(modelPar_AUD*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BUD))));
    instanceVar_EU_i = (instanceVar_EU_i+(modelPar_AEU*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BEU))));
    if ((modelPar_ASYMMOD!=0))
    {
      if ((modelPar_LPAR>0.0))
      {
        instanceVar_U0R_i = (instanceVar_U0R_i*(1.0-(UPR_i*pow(instanceVar_Leff,(-modelPar_LPAR)))));
      }
      else
      {
        instanceVar_U0R_i = (instanceVar_U0R_i*(1.0-UPR_i));
      }
      instanceVar_UAR_i = (instanceVar_UAR_i+(modelPar_AUAR*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BUAR))));
      instanceVar_UDR_i = (instanceVar_UDR_i+(modelPar_AUDR*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BUDR))));
      instanceVar_EUR_i = (instanceVar_EUR_i+(modelPar_AEUR*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BEUR))));
    }
    if ((modelPar_RDSMOD==1))
    {
      instanceVar_RSW_i = (instanceVar_RSW_i+(modelPar_ARSW*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BRSW))));
      instanceVar_RDW_i = (instanceVar_RDW_i+(modelPar_ARDW*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BRDW))));
    }
    else
    {
      instanceVar_RDSW_i = (instanceVar_RDSW_i+(modelPar_ARDSW*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BRDSW))));
    }
    instanceVar_PCLM_i = (instanceVar_PCLM_i+(modelPar_APCLM*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BPCLM))));
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_PCLMR_i = (instanceVar_PCLMR_i+(modelPar_APCLMR*pow(instanceVar_Leff,(-modelPar_BPCLMR))));
    }
    instanceVar_MEXP_i = (instanceVar_MEXP_i+(modelPar_AMEXP*pow(instanceVar_Leff,(-modelPar_BMEXP))));
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_MEXPR_i = (instanceVar_MEXPR_i+(modelPar_AMEXPR*pow(instanceVar_Leff,(-modelPar_BMEXPR))));
    }
    instanceVar_PTWG_i = (instanceVar_PTWG_i+(modelPar_APTWG*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BPTWG))));
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_PTWGR_i = (instanceVar_PTWGR_i+(modelPar_APTWG*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BPTWG))));
    }
    instanceVar_VSAT_i = (instanceVar_VSAT_i+(modelPar_AVSAT*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BVSAT))));
    instanceVar_VSAT1_i = (instanceVar_VSAT1_i+(modelPar_AVSAT1*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BVSAT1))));
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_VSAT1R_i = (instanceVar_VSAT1R_i+(modelPar_AVSAT1*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BVSAT1))));
    }
    instanceVar_PSAT_i = (instanceVar_PSAT_i+(modelPar_APSAT*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BPSAT))));
    instanceVar_PSATCV_i = (instanceVar_PSATCV_i+(modelPar_APSATCV*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BPSATCV))));
    instanceVar_VSATCV_i = (instanceVar_VSATCV_i+(modelPar_AVSATCV*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_LeffCV)/modelPar_BVSATCV))));
    instanceVar_DVTP0_i = (modelPar_DVTP0+(modelPar_ADVTP0*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BDVTP0))));
    instanceVar_DVTP1_i = (modelPar_DVTP1+(modelPar_ADVTP1*AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_Leff)/modelPar_BDVTP1))));
    if (((instanceVar_QMTCENCV_i>0.0)||(instanceVar_QMTCENCVA_i>0.0)))
    {
      MTcen = (1.0+(modelPar_AQMTCEN*AnalogFunctions::lexp<AdmsSensFadType>(((-((2.0*instanceVar_Ach)/instanceVar_Weff_UFCM))/modelPar_BQMTCEN))));
      instanceVar_Tcen0 = (((2.0*instanceVar_Ach)/instanceVar_Weff_UFCM)*MTcen);
    }
    if ((instanceVar_LeffCV<=1.0e-9))
    {
      std::cerr  << "Warning: LeffCV = %e <= 1.0e-9." << instanceVar_LeffCV <<  std::endl; 
    }
    if ((modelPar_BULKMOD!=0))
    {
      if ((instanceVar_LeffCV_acc<=1.0e-9))
      {
        std::cerr  << "Warning: LeffCV_acc = %e <= 1.0e-9." << instanceVar_LeffCV_acc <<  std::endl; 
      }
    }
    if ((instanceVar_Weff0<=1.0e-9))
    {
      std::cerr  << "Warning: Weff0 = %e <= 1.0e-9." << instanceVar_Weff0 <<  std::endl; 
    }
    if ((instanceVar_WeffCV0<=1.0e-9))
    {
      std::cerr  << "Warning: WeffCV0 = %e <= 1.0e-9." << instanceVar_WeffCV0 <<  std::endl; 
    }
    if ((NBODY_i<=0.0))
    {
      std::cerr  << "Fatal: NBODY_i = %e is not positive." << NBODY_i <<  std::endl; 
      UserError0(theInstance) << "$finish called." << std::endl; 
    }
    else
    {
      if ((NBODY_i<=1.0e18))
      {
        std::cerr  << "Warning: NBODY_i = %e m^-3 may be too small." << NBODY_i <<  std::endl; 
      }
    }
    if ((NGATE_i<0.0))
    {
      std::cerr  << "Fatal: NGATE_i = %e is negative." << NGATE_i <<  std::endl; 
      UserError0(theInstance) << "$finish called." << std::endl; 
    }
    else
    {
      if (((NGATE_i!=0.0)&&(NGATE_i<=1.0e24)))
      {
        std::cerr  << "Warning: NGATE_i = %e may be too small." << NGATE_i <<  std::endl; 
      }
      else
      {
        if ((NGATE_i>1.0e31))
        {
          std::cerr  << "Fatal: NGATE_i = %e is too high." << NGATE_i <<  std::endl; 
          UserError0(theInstance) << "$finish called." << std::endl; 
        }
      }
    }
    if ((instanceVar_DVT0_i<0.0))
    {
      std::cerr  << "Warning: DVT0_i = %e is negative." << instanceVar_DVT0_i <<  std::endl; 
    }
    if ((instanceVar_PHIG_i<=0.0))
    {
      std::cerr  << "Fatal: PHIG_i = %e is not positive." << instanceVar_PHIG_i <<  std::endl; 
      UserError0(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_VSAT_i<=0.0))
    {
      std::cerr  << "Fatal: VSAT_i = %e is not positive." << instanceVar_VSAT_i <<  std::endl; 
      UserError0(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_VSAT1_i<=0.0))
    {
      std::cerr  << "Fatal: VSAT1_i = %e is not positive." << instanceVar_VSAT1_i <<  std::endl; 
      UserError0(theInstance) << "$finish called." << std::endl; 
    }
    if (((modelPar_ASYMMOD!=0)&&(instanceVar_VSAT1R_i<=0.0)))
    {
      std::cerr  << "Fatal: VSAT1R_i = %e is not positive." << instanceVar_VSAT1R_i <<  std::endl; 
      UserError0(theInstance) << "$finish called." << std::endl; 
    }
    if ((DVT1_i<=0.0))
    {
      std::cerr  << "Fatal: DVT1_i = %e is not positive." << DVT1_i <<  std::endl; 
      UserError0(theInstance) << "$finish called." << std::endl; 
    }
    if ((DVT1SS_i<=0.0))
    {
      std::cerr  << "Fatal: DVT1SS_i = %e is not positive." << DVT1SS_i <<  std::endl; 
      UserError0(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_CDSC_i<0.0))
    {
      std::cerr  << "Warning: CDSC_i = %e is negative." << instanceVar_CDSC_i <<  std::endl; 
    }
    if ((instanceVar_CDSCD_i<0.0))
    {
      std::cerr  << "Warning: CDSCD_i = %e is negative." << instanceVar_CDSCD_i <<  std::endl; 
    }
    if (((modelPar_ASYMMOD!=0)&&(instanceVar_CDSCDR_i<0.0)))
    {
      std::cerr  << "Warning: CDSCDR_i = %e is negative." << instanceVar_CDSCDR_i <<  std::endl; 
    }
    if ((DSUB_i<=0.0))
    {
      std::cerr  << "Fatal: DSUB_i = %e is not positive." << DSUB_i <<  std::endl; 
      UserError0(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_ETA0_i<0.0))
    {
      std::cerr  << "Warning: ETA0_i = %e is negative, setting it to 0" << instanceVar_ETA0_i <<  std::endl; 
      instanceVar_ETA0_i = 0.0;
    }
    if ((instanceVar_ETA0R_i<0.0))
    {
      std::cerr  << "Warning: ETA0R_i = %e is negative, setting it to 0" << instanceVar_ETA0R_i <<  std::endl; 
      instanceVar_ETA0R_i = 0.0;
    }
    if ((LPE0_i<(-instanceVar_Leff)))
    {
      std::cerr  << "Warning: LPE0_i = %e is less than -Leff. Clipping LPE0_i to 0" << LPE0_i <<  std::endl; 
      LPE0_i = 0.0;
    }
    if ((instanceVar_K0SI_i<=0.0))
    {
      std::cerr  << "Warning: K0SI_i = %e is not positive, setting it to 0." << instanceVar_K0SI_i <<  std::endl; 
      instanceVar_K0SI_i = 0.0;
    }
    if ((instanceVar_K2SI_i<=0.0))
    {
      std::cerr  << "Warning: K2SI_i = %e is not positive, setting it to 0." << instanceVar_K2SI_i <<  std::endl; 
      instanceVar_K2SI_i = 0.0;
    }
    if (((instanceVar_PHIBE_i<0.2)&&(modelPar_BULKMOD!=0)))
    {
      std::cerr  << "Warning: PHIBE_i = %e is less than 0.2, setting it to 0.2." << instanceVar_PHIBE_i <<  std::endl; 
      instanceVar_PHIBE_i = 0.2;
    }
    if (((instanceVar_PHIBE_i>1.2)&&(modelPar_BULKMOD!=0)))
    {
      std::cerr  << "Warning: PHIBE_i = %e is larger than 1.2, setting it to 1.2." << instanceVar_PHIBE_i <<  std::endl; 
      instanceVar_PHIBE_i = 1.2;
    }
    if ((instanceVar_PSAT_i<2.0))
    {
      std::cerr  << "Warning: PSAT_i = %e is less than 2.0, setting it to 2.0." << instanceVar_PSAT_i <<  std::endl; 
      instanceVar_PSAT_i = 2.0;
    }
    if ((instanceVar_PSATCV_i<2.0))
    {
      std::cerr  << "Warning: PSATCV_i = %e is less than 2.0, setting it to 2.0." << instanceVar_PSATCV_i <<  std::endl; 
      instanceVar_PSATCV_i = 2.0;
    }
    if ((instanceVar_U0_i<0.0))
    {
      std::cerr  << "Warning: U0_i = %e is negative, setting it to the default value." << instanceVar_U0_i <<  std::endl; 
      instanceVar_U0_i = 0.03;
    }
    if ((instanceVar_UA_i<0.0))
    {
      std::cerr  << "Warning: UA_i = %e is negative, setting it to 0." << instanceVar_UA_i <<  std::endl; 
      instanceVar_UA_i = 0.0;
    }
    if ((instanceVar_EU_i<0.0))
    {
      std::cerr  << "Warning: EU_i = %e is negative, setting it to 0." << instanceVar_EU_i <<  std::endl; 
      instanceVar_EU_i = 0.0;
    }
    if ((instanceVar_UD_i<0.0))
    {
      std::cerr  << "Warning: UD_i = %e is negative, setting it to 0." << instanceVar_UD_i <<  std::endl; 
      instanceVar_UD_i = 0.0;
    }
    if ((instanceVar_UCS_i<0.0))
    {
      std::cerr  << "Warning: UCS_i = %e is negative, setting it to 0." << instanceVar_UCS_i <<  std::endl; 
      instanceVar_UCS_i = 0.0;
    }
    if ((instanceVar_ETAMOB_i<0.0))
    {
      std::cerr  << "Warning: ETAMOB_i = %e is negative, setting it to 0" << instanceVar_ETAMOB_i <<  std::endl; 
      instanceVar_ETAMOB_i = 0.0;
    }
    instanceVar_RDSWMIN_i = modelPar_RDSWMIN;
    if ((instanceVar_RDSWMIN_i<0.0))
    {
      std::cerr  << "Warning: RDSWMIN = %e is negative.  Set to zero" << instanceVar_RDSWMIN_i <<  std::endl; 
      instanceVar_RDSWMIN_i = 0.0;
    }
    if ((instanceVar_RDSW_i<0.0))
    {
      std::cerr  << "Warning: RDSW_i = %e is negative.  Set to zero" << instanceVar_RDSW_i <<  std::endl; 
      instanceVar_RDSW_i = 0.0;
    }
    instanceVar_RSWMIN_i = modelPar_RSWMIN;
    if ((instanceVar_RSWMIN_i<0.0))
    {
      std::cerr  << "Warning: RSWMIN = %e is negative.  Set to zero" << instanceVar_RSWMIN_i <<  std::endl; 
      instanceVar_RSWMIN_i = 0.0;
    }
    if ((instanceVar_RSW_i<0.0))
    {
      std::cerr  << "Warning: RSW_i = %e is negative.  Set to zero" << instanceVar_RSW_i <<  std::endl; 
      instanceVar_RSW_i = 0.0;
    }
    instanceVar_RDWMIN_i = modelPar_RDWMIN;
    if ((instanceVar_RDWMIN_i<0.0))
    {
      std::cerr  << "Warning: RDWMIN = %e is negative.  Set to zero" << instanceVar_RDWMIN_i <<  std::endl; 
      instanceVar_RDWMIN_i = 0.0;
    }
    if ((instanceVar_RDW_i<0))
    {
      std::cerr  << "Warning: RDW_i = %e is negative.  Set to zero" << instanceVar_RDW_i <<  std::endl; 
      instanceVar_RDW_i = 0.0;
    }
    if ((instanceVar_PRWGD_i<0.0))
    {
      std::cerr  << "Warning: PRWGD_i = %e is negative.  Set to zero" << instanceVar_PRWGD_i <<  std::endl; 
      instanceVar_PRWGD_i = 0.0;
    }
    if ((instanceVar_PRWGS_i<0.0))
    {
      std::cerr  << "Warning: PRWGS_i = %e is negative.  Set to zero" << instanceVar_PRWGS_i <<  std::endl; 
      instanceVar_PRWGS_i = 0.0;
    }
    if ((instanceVar_PCLM_i<0))
    {
      std::cerr  << "Warning: PCLM_i = %e is negative." << instanceVar_PCLM_i <<  std::endl; 
    }
    if ((instanceVar_PDIBL1_i<0.0))
    {
      std::cerr  << "Warning: PDIBL1_i = %e is negative." << instanceVar_PDIBL1_i <<  std::endl; 
    }
    if ((modelPar_ASYMMOD!=0))
    {
      if ((instanceVar_PDIBL1R_i<0.0))
      {
        std::cerr  << "Warning: PDIBL1R_i = %e is negative." << instanceVar_PDIBL1R_i <<  std::endl; 
      }
      if ((instanceVar_PDIBL2R_i<0.0))
      {
        std::cerr  << "Warning: PDIBL2R_i = %e is negative." << instanceVar_PDIBL2R_i <<  std::endl; 
      }
      if ((instanceVar_U0R_i<0))
      {
        std::cerr  << "Warning: U0R_i = %e is negative, setting it to 0." << instanceVar_U0R_i <<  std::endl; 
        instanceVar_U0R_i = 0.0;
      }
      if ((instanceVar_UAR_i<0.0))
      {
        std::cerr  << "Warning: UAR_i = %e is negative, setting it to 0." << instanceVar_UAR_i <<  std::endl; 
        instanceVar_UAR_i = 0.0;
      }
      if ((instanceVar_EUR_i<0.0))
      {
        std::cerr  << "Warning: EUR_i = %e is negative, setting it to 0." << instanceVar_EUR_i <<  std::endl; 
        instanceVar_EUR_i = 0.0;
      }
      if ((instanceVar_UDR_i<0.0))
      {
        std::cerr  << "Warning: UDR_i = %e is negative, setting it to 0." << instanceVar_UDR_i <<  std::endl; 
        instanceVar_UDR_i = 0.0;
      }
    }
    if ((instanceVar_PDIBL2_i<0.0))
    {
      std::cerr  << "Warning: PDIBL2_i = %e is negative." << instanceVar_PDIBL2_i <<  std::endl; 
    }
    if ((instanceVar_DROUT_i<=0.0))
    {
      std::cerr  << "Fatal: DROUT_i = %e is non-positive." << instanceVar_DROUT_i <<  std::endl; 
      UserError0(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_MEXP_i<2.0))
    {
      std::cerr  << "Warning: MEXP_i = %e < 2. Setting MEXP_i = 2." << instanceVar_MEXP_i <<  std::endl; 
      instanceVar_MEXP_i = 2.0;
    }
    if ((modelPar_ASYMMOD!=0))
    {
      if ((instanceVar_MEXPR_i<2.0))
      {
        std::cerr  << "Warning: MEXPR_i = %e < 2.  Setting MEXPR_i = 2." << instanceVar_MEXPR_i <<  std::endl; 
        instanceVar_MEXPR_i = 2.0;
      }
    }
    if ((instanceVar_PTWG_i<0))
    {
      std::cerr  << "Warning: PTWG_i = %e is negative, setting it to 0." << instanceVar_PTWG_i <<  std::endl; 
      instanceVar_PTWG_i = 0.0;
    }
    if ((instanceVar_QMTCENCV_i>0.0))
    {
      if ((modelPar_QM0<=0.0))
      {
        std::cerr  << "Fatal: QM0 = %e is non-positive." << modelPar_QM0 <<  std::endl; 
        UserError0(theInstance) << "$finish called." << std::endl; 
      }
    }
    if (((modelPar_BULKMOD!=0)&&(instanceVar_QMTCENCVA_i>0.0)))
    {
      if ((modelPar_QM0ACC<=0.0))
      {
        std::cerr  << "Fatal: QM0ACC = %e is non-positive." << modelPar_QM0ACC <<  std::endl; 
        UserError0(theInstance) << "$finish called." << std::endl; 
      }
    }
    if ((instanceVar_CGIDL_i<0.0))
    {
      std::cerr  << "Warning: CGIDL_i = %e < 0.  Setting CGIDL_i = 0." << instanceVar_CGIDL_i <<  std::endl; 
      instanceVar_CGIDL_i = 0.0;
    }
    if ((instanceVar_CGISL_i<0.0))
    {
      std::cerr  << "Warning: CGISL_i = %e < 0.  Setting CGISL_i = 0." << instanceVar_CGISL_i <<  std::endl; 
      instanceVar_CGISL_i = 0.0;
    }
    if ((modelPar_IGBMOD!=0))
    {
      if ((instanceVar_NIGBINV_i<=0.0))
      {
        std::cerr  << "Fatal: NIGBINV_i = %e is non-positive." << instanceVar_NIGBINV_i <<  std::endl; 
        UserError0(theInstance) << "$finish called." << std::endl; 
      }
      if ((instanceVar_NIGBACC_i<=0.0))
      {
        std::cerr  << "Fatal: NIGBACC_i = %e is non-positive." << instanceVar_NIGBACC_i <<  std::endl; 
        UserError0(theInstance) << "$finish called." << std::endl; 
      }
    }
    if ((modelPar_IGCMOD!=0))
    {
      if ((instanceVar_POXEDGE_i<=0.0))
      {
        std::cerr  << "Fatal: POXEDGE_i = %e is non-positive." << instanceVar_POXEDGE_i <<  std::endl; 
        UserError0(theInstance) << "$finish called." << std::endl; 
      }
      if ((instanceVar_PIGCD_i<=0.0))
      {
        std::cerr  << "Fatal: PIGCD_i = %e is non-positive." << instanceVar_PIGCD_i <<  std::endl; 
        UserError0(theInstance) << "$finish called." << std::endl; 
      }
    }
    if (((modelPar_IGCMOD!=0)||(modelPar_IGBMOD!=0)))
    {
      if ((modelPar_TOXREF<=0))
      {
        std::cerr  << "Fatal: TOXREF = %e is non-positive." << modelPar_TOXREF <<  std::endl; 
        UserError0(theInstance) << "$finish called." << std::endl; 
      }
    }
    if ((modelPar_LINTIGEN>=(instanceVar_Leff/2.0)))
    {
      std::cerr  << "Warning: LINTIGEN = %e is too large - Leff for r/g current is negative.  Re-setting LINTIGEN = 0." << modelPar_LINTIGEN <<  std::endl; 
      instanceVar_LINTIGEN_i = 0.0;
    }
    else
    {
      instanceVar_LINTIGEN_i = modelPar_LINTIGEN;
    }
    if ((instanceVar_NTGEN_i<=0.0))
    {
      std::cerr  << "Fatal: NTGEN_i = %e is non-positive." << instanceVar_NTGEN_i <<  std::endl; 
      UserError0(theInstance) << "$finish called." << std::endl; 
    }
    if ((modelPar_IIMOD==2))
    {
      if ((instanceVar_BETAII0_i<0.0))
      {
        std::cerr  << "Warning:  BETAII0_i = %e is negative." << instanceVar_BETAII0_i <<  std::endl; 
      }
      if ((instanceVar_BETAII1_i<0.0))
      {
        std::cerr  << "Warning:  BETAII1_i = %e is negative." << instanceVar_BETAII1_i <<  std::endl; 
      }
      if ((instanceVar_BETAII2_i<0.0))
      {
        std::cerr  << "Warning:  BETAII2_i = %e is negative." << instanceVar_BETAII2_i <<  std::endl; 
      }
      if ((instanceVar_ESATII_i<0.0))
      {
        std::cerr  << "Warning:  ESATII_i = %e is negative." << instanceVar_ESATII_i <<  std::endl; 
      }
      if ((instanceVar_LII_i<0.0))
      {
        std::cerr  << "Warning:  LII_i = %e is negative." << instanceVar_LII_i <<  std::endl; 
      }
      if ((instanceVar_SII1_i<0.0))
      {
        std::cerr  << "Warning:  SII1_i = %e is negative." << modelPar_SII1 <<  std::endl; 
      }
      if ((instanceVar_SII2_i<0.0))
      {
        std::cerr  << "Warning:  SII2_i = %e is negative." << instanceVar_SII2_i <<  std::endl; 
      }
      if ((instanceVar_SIID_i<0.0))
      {
        std::cerr  << "Warning:  SIID_i = %e is negative." << instanceVar_SIID_i <<  std::endl; 
      }
    }
    if ((modelPar_EF<=0.0))
    {
      std::cerr  << "Fatal: EF = %e is non-positive." << modelPar_EF <<  std::endl; 
      UserError0(theInstance) << "$finish called." << std::endl; 
    }
    else
    {
      if ((modelPar_EF>2.0))
      {
        std::cerr  << "Fatal: EF = %e > 2.0." << modelPar_EF <<  std::endl; 
        UserError0(theInstance) << "$finish called." << std::endl; 
      }
    }
    if ((modelPar_LINTNOI>=(instanceVar_Leff/2.0)))
    {
      std::cerr  << "Warning: LINTNOI = %e is too large - Leff for noise is negative.  Re-setting LINTNOI = 0." << modelPar_LINTNOI <<  std::endl; 
      instanceVar_LINTNOI_i = 0.0;
    }
    else
    {
      instanceVar_LINTNOI_i = modelPar_LINTNOI;
    }
    if ((modelPar_NTNOI<0))
    {
      std::cerr  << "Warning: NTNOI = %e is negative. Set to zero." << modelPar_NTNOI <<  std::endl; 
      instanceVar_NTNOI_i = 0.0;
    }
    else
    {
      instanceVar_NTNOI_i = modelPar_NTNOI;
    }
    if (((modelPar_SHMOD!=0)&&(modelPar_RTH0>0.0)))
    {
      instanceVar_T1 = modelPar_WTH0;
      if ((modelPar_BSHEXP!=0.0))
      {
        instanceVar_T1 = (modelPar_WTH0*pow(instancePar_NF,modelPar_BSHEXP));
      }
      instanceVar_T2 = instancePar_FPITCH;
      if ((modelPar_ASHEXP!=0.0))
      {
        instanceVar_T2 = (instancePar_FPITCH*pow(instanceVar_NFINtotal,modelPar_ASHEXP));
      }
      instanceVar_gth = ((instanceVar_T1+instanceVar_T2)/modelPar_RTH0);
      instanceVar_cth = (modelPar_CTH0*(instanceVar_T1+instanceVar_T2));
    }
    else
    {
      instanceVar_gth = 1.0;
      instanceVar_cth = 0.0;
    }
    if ((modelPar_RGATEMOD!=0))
    {
      Rgeltd = (((modelPar_RGEXT/instancePar_NGCON)+((modelPar_RGFIN*instancePar_NFIN)/((instancePar_NGCON==2)?12.0:3.0)))/instancePar_NF);
      instanceVar_ggeltd = (1.0/std::max(static_cast<double>(1.0e-3),Rgeltd));
    }
    if ((modelPar_RGEOMOD==0))
    {
      instanceVar_RSourceGeo = (modelPar_RSHS*instancePar_NRS);
      instanceVar_RDrainGeo = (modelPar_RSHD*instancePar_NRD);
    }
    else
    {
      if ((modelPar_HEPI>0.0))
      {
        Arsd = ((instancePar_FPITCH*modelPar_HFIN)+((instancePar_TFIN+((instancePar_FPITCH-instancePar_TFIN)*modelPar_CRATIO))*modelPar_HEPI));
      }
      else
      {
        Arsd = (instancePar_FPITCH*std::max(static_cast<double>(1.0e-9),(modelPar_HFIN+modelPar_HEPI)));
      }
      Prsd = (instancePar_FPITCH+modelPar_DELTAPRSD);
      if (modelPar_given_RHORSD)
      {
        rhorsd = modelPar_RHORSD;
      }
      else
      {
        mu_max = ((modelPar_TYPE==1)?1417.0:470.5);
        if ((modelPar_TYPE==1))
        {
          mu_rsd = (((52.2+((mu_max-52.2)/(1.0+pow((modelPar_NSD/9.68e22),0.680))))-(43.4/(1.0+pow((3.43e26/modelPar_NSD),2.0))))*1.0e-4);
        }
        else
        {
          mu_rsd = (((44.9+((mu_max-44.9)/(1.0+pow((modelPar_NSD/2.23e22),0.719))))-(29.0/(1.0+pow((6.10e26/modelPar_NSD),2.0))))*1.0e-4);
        }
        rhorsd = (1.0/((1.60219e-19*modelPar_NSD)*mu_rsd));
      }
      thetarsp = ((55.0*3.14159265358979323846)/180.0);
      afin = std::min(Arsd,std::max(static_cast<double>(1.0e-18),(instancePar_TFIN*(modelPar_HFIN+std::min(static_cast<double>(0.0),modelPar_HEPI)))));
      instanceVar_T1 = ((thetarsp>=(3.14159265358979323846/2))?0:((thetarsp<=((-3.14159265358979323846)/2))?0:(1.0/tan(thetarsp))));
      Rsp = (((rhorsd*instanceVar_T1)/(sqrt(static_cast<double>(3.14159265358979323846))*instancePar_NFIN))*(((1.0/sqrt(afin))-(2.0/sqrt(Arsd)))+sqrt((afin/(Arsd*Arsd)))));
      arsd_total = ((Arsd*instancePar_NFIN)+modelPar_ARSDEND);
      prsd_total = ((Prsd*instancePar_NFIN)+modelPar_PRSDEND);
      lt = sqrt(((modelPar_RHOC*arsd_total)/(rhorsd*prsd_total)));
      alpha = (instancePar_LRSD/lt);
      instanceVar_T0 = AnalogFunctions::lexp<AdmsSensFadType>((alpha+alpha));
      if ((modelPar_SDTERM==1.0))
      {
        eta = ((rhorsd*lt)/modelPar_RHOC);
        instanceVar_T1 = (instanceVar_T0*(1.0+eta));
        instanceVar_T2 = ((instanceVar_T1+1.0)-eta);
        instanceVar_T3 = ((instanceVar_T1-1.0)+eta);
      }
      else
      {
        instanceVar_T2 = (instanceVar_T0+1.0);
        instanceVar_T3 = (instanceVar_T0-1.0);
      }
      RrsdTML = (((rhorsd*lt)*instanceVar_T2)/(arsd_total*instanceVar_T3));
      if ((modelPar_HEPI<(-1.0e-10)))
      {
        Rrsdside = (modelPar_RHOC/(((-modelPar_HEPI)*instancePar_TFIN)*instancePar_NFIN));
        Rrsd = (((RrsdTML+Rsp)*Rrsdside)/((RrsdTML+Rsp)+Rrsdside));
      }
      else
      {
        Rrsd = (RrsdTML+Rsp);
      }
      Rdsgeo = ((Rrsd/instancePar_NF)*std::max(static_cast<double>(0.0),((((modelPar_RGEOA+(modelPar_RGEOB*instancePar_TFIN))+(modelPar_RGEOC*instancePar_FPITCH))+(modelPar_RGEOD*instancePar_LRSD))+(modelPar_RGEOE*modelPar_HEPI))));
      instanceVar_RSourceGeo = Rdsgeo;
      instanceVar_RDrainGeo = Rdsgeo;
    }
    if ((instanceVar_RSourceGeo<=1.0e-3))
    {
      instanceVar_RSourceGeo = 1.0e-3;
    }
    if ((instanceVar_RDrainGeo<=1.0e-3))
    {
      instanceVar_RDrainGeo = 1.0e-3;
    }
    if ((modelPar_RDSMOD==1))
    {
      if ((instanceVar_RSWMIN_i<=0.0))
      {
        instanceVar_RSWMIN_i = 0.0;
      }
      if ((instanceVar_RDWMIN_i<=0.0))
      {
        instanceVar_RDWMIN_i = 0.0;
      }
      if ((instanceVar_RSW_i<=0.0))
      {
        instanceVar_RSW_i = 0.0;
      }
      if ((instanceVar_RDW_i<=0.0))
      {
        instanceVar_RDW_i = 0.0;
      }
    }
    else
    {
      if ((instanceVar_RDSWMIN_i<=0.0))
      {
        instanceVar_RDSWMIN_i = 0.0;
      }
      if ((instanceVar_RDSW_i<=0.0))
      {
        instanceVar_RDSW_i = 0.0;
      }
    }
    if ((modelPar_CGEOMOD!=1))
    {
      if (modelPar_given_CGSO)
      {
        instanceVar_CGSO_i = modelPar_CGSO;
      }
      else
      {
        if ((modelPar_given_DLC&&(modelPar_DLC>0.0)))
        {
          instanceVar_CGSO_i = std::max(static_cast<double>(0.0),((modelPar_DLC*instanceVar_cox)-instanceVar_CGSL_i));
        }
        else
        {
          instanceVar_CGSO_i = ((0.3*instancePar_TFIN)*instanceVar_cox);
        }
      }
      if (modelPar_given_CGDO)
      {
        instanceVar_CGDO_i = modelPar_CGDO;
      }
      else
      {
        if ((modelPar_given_DLC&&(modelPar_DLC>0.0)))
        {
          instanceVar_CGDO_i = std::max(static_cast<double>(0.0),((modelPar_DLC*instanceVar_cox)-instanceVar_CGDL_i));
        }
        else
        {
          instanceVar_CGDO_i = ((0.3*instancePar_TFIN)*instanceVar_cox);
        }
      }
    }
    if ((modelPar_CGEOMOD==2))
    {
      Hg = (modelPar_TGATE+modelPar_TMASK);
      Trsd = (0.5*(instancePar_FPITCH-instancePar_TFIN));
      Wg = std::max(static_cast<double>(0.0),(Trsd-modelPar_TOXP));
      Hrsd = std::max(static_cast<double>(0.0),(modelPar_HEPI+modelPar_TSILI));
      if ((modelPar_TMASK>0.0))
      {
        instanceVar_T0 = (3.467e-11*AnalogFunctions::lln<AdmsSensFadType>(((1.0e-7*modelPar_EPSRSP)/(3.9*modelPar_LSP))));
        instanceVar_T1 = (((0.942*Hrsd)*epssp)/modelPar_LSP);
        Cgg_top = ((instanceVar_T0+instanceVar_T1)*(instancePar_TFIN+((instancePar_FPITCH-instancePar_TFIN)*modelPar_CRATIO)));
      }
      else
      {
        //Begin block cfr_top_trigate
        {
          //Block-local variables for block cfr_top_trigate
          AdmsSensFadType Hr;
          double Lr;
          AdmsSensFadType Hgdelta;
          AdmsSensFadType Lmax;
          AdmsSensFadType y;
          AdmsSensFadType x;
          //End of Block-local variables
          //Block-local variables for block cfr_top_trigate
          AdmsSensFadType CcgSat;
          double Cnon;
          AdmsSensFadType TT1;
          AdmsSensFadType Ccg1;
          AdmsSensFadType r1cf;
          AdmsSensFadType Rcf;
          AdmsSensFadType Ccg2;
          //End of Block-local variables
          //Block-local variables for block cfr_top_trigate
          AdmsSensFadType Ccg;
          AdmsSensFadType C1;
          AdmsSensFadType C2;
          AdmsSensFadType C3;
          AdmsSensFadType Cfglog;
          AdmsSensFadType dcf;
          AdmsSensFadType TT0;
          //End of Block-local variables
          //Block-local variables for block cfr_top_trigate
          AdmsSensFadType TT2;
          AdmsSensFadType Cfgsat;
          double delta;
          AdmsSensFadType Cfg;
          //End of Block-local variables
          Hr = (2.3+((0.2*(Hg+modelPar_TOXP))/Hrsd));
          Lr = 1.05;
          Hgdelta = fabs(((Hg+modelPar_TOXP)-Hrsd));
          Lmax = (modelPar_LSP*Lr);
          y = std::min(Hrsd,(Hg+modelPar_TOXP));
          x = (modelPar_LSP/(Hr+1.0));
          Cnon = 1.7e12;
          CcgSat = ((epssp*(y-x))/modelPar_LSP);
          TT1 = (Cnon*CcgSat);
          if ((TT1>80.0))
          {
            Ccg1 = CcgSat;
          }
          else
          {
            Ccg1 = ((1.0/Cnon)*log((1.0+AnalogFunctions::lexp<AdmsSensFadType>(TT1))));
          }
          r1cf = (0.5*std::min((Hrsd/(Hg+modelPar_TOXP)),((Hg+modelPar_TOXP)/Hrsd)));
          Rcf = (Hgdelta*r1cf);
          Ccg2 = (((epssp*2)/3.14159265358979323846)*log(((modelPar_LSP+((0.5*3.14159265358979323846)*Rcf))/modelPar_LSP)));
          Ccg = (instancePar_TFIN*(Ccg1+Ccg2));
          x = (Lmax/Hg);
          C1 = (4.0/(sqrt((2.0*(x+1)))*3.14159265358979323846));
          C2 = ((((sqrt((((modelPar_TOXP*modelPar_TOXP)+((2.0*Hg)*modelPar_TOXP))+((Hg*Hg)*(x+1))))*sqrt((x+1)))+modelPar_TOXP)+(Hg*x))+Hg);
          C3 = ((modelPar_TOXP*sqrt(((x+1)*(x+4))))+(modelPar_TOXP*(x+2)));
          Cfglog = (epssp*((C1*log((C2/C3)))+12.27));
          dcf = (Hr*Lr);
          TT0 = sqrt(((dcf*dcf)+1.0));
          TT1 = (((sqrt((((dcf*dcf)+1)*((((dcf*modelPar_TOXP)*(dcf*modelPar_TOXP))+(((2*dcf)*Lmax)*modelPar_TOXP))+((((dcf*dcf)+1)*Lmax)*Lmax))))+(dcf*modelPar_TOXP))+((dcf*dcf)*Lmax))+Lmax);
          TT2 = ((TT0+1.0)*(dcf*modelPar_TOXP));
          Cfgsat = (((((((2.0*epssp)*sqrt(static_cast<double>(2)))/3.14159265358979323846)*0.85)*dcf)/TT0)*log((TT1/TT2)));
          delta = 1.2e-12;
          TT1 = ((Cfgsat-Cfglog)-delta);
          Cfg = (instancePar_TFIN*(Cfgsat-(0.5*(TT1+sqrt(((TT1*TT1)+((4*delta)*Cfgsat)))))));
          Cgg_top = (Ccg+Cfg);
        }
        // End block cfr_top_trigate
      }
      if ((modelPar_TMASK>0))
      {
        //Begin block cfr_side_dblgate
        {
          //Block-local variables for block cfr_side_dblgate
          AdmsSensFadType Hr;
          double Lr;
          AdmsSensFadType Hgdelta;
          AdmsSensFadType Lmax;
          AdmsSensFadType y;
          AdmsSensFadType x;
          //End of Block-local variables
          //Block-local variables for block cfr_side_dblgate
          AdmsSensFadType CcgSat;
          double Cnon;
          AdmsSensFadType TT1;
          AdmsSensFadType Ccg1;
          AdmsSensFadType r1cf;
          AdmsSensFadType Rcf;
          AdmsSensFadType Ccg2;
          //End of Block-local variables
          //Block-local variables for block cfr_side_dblgate
          AdmsSensFadType Ccg;
          AdmsSensFadType C1;
          AdmsSensFadType C2;
          AdmsSensFadType C3;
          AdmsSensFadType Cfglog;
          AdmsSensFadType dcf;
          AdmsSensFadType TT0;
          //End of Block-local variables
          //Block-local variables for block cfr_side_dblgate
          AdmsSensFadType TT2;
          AdmsSensFadType Cfgsat;
          double delta;
          AdmsSensFadType Cfg;
          //End of Block-local variables
          Hr = (2.3+((0.2*(Wg+modelPar_TOXP))/Trsd));
          Lr = 1.05;
          Hgdelta = fabs(((Wg+modelPar_TOXP)-Trsd));
          Lmax = (modelPar_LSP*Lr);
          y = std::min(Trsd,(Wg+modelPar_TOXP));
          x = (modelPar_LSP/(Hr+1.0));
          Cnon = 1.7e12;
          CcgSat = ((epssp*(y-x))/modelPar_LSP);
          TT1 = (Cnon*CcgSat);
          if ((TT1>80.0))
          {
            Ccg1 = CcgSat;
          }
          else
          {
            Ccg1 = ((1.0/Cnon)*log((1.0+AnalogFunctions::lexp<AdmsSensFadType>(TT1))));
          }
          r1cf = (0.5*std::min((Trsd/(Wg+modelPar_TOXP)),((Wg+modelPar_TOXP)/Trsd)));
          Rcf = (Hgdelta*r1cf);
          Ccg2 = (((epssp*2)/3.14159265358979323846)*log(((modelPar_LSP+((0.5*3.14159265358979323846)*Rcf))/modelPar_LSP)));
          Ccg = (modelPar_HFIN*(Ccg1+Ccg2));
          x = (Lmax/Wg);
          C1 = (4.0/(sqrt((2.0*(x+1)))*3.14159265358979323846));
          C2 = ((((sqrt((((modelPar_TOXP*modelPar_TOXP)+((2.0*Wg)*modelPar_TOXP))+((Wg*Wg)*(x+1))))*sqrt((x+1)))+modelPar_TOXP)+(Wg*x))+Wg);
          C3 = ((modelPar_TOXP*sqrt(((x+1)*(x+4))))+(modelPar_TOXP*(x+2)));
          Cfglog = (epssp*((C1*log((C2/C3)))+12.27));
          dcf = (Hr*Lr);
          TT0 = sqrt(((dcf*dcf)+1.0));
          TT1 = (((sqrt((((dcf*dcf)+1)*((((dcf*modelPar_TOXP)*(dcf*modelPar_TOXP))+(((2*dcf)*Lmax)*modelPar_TOXP))+((((dcf*dcf)+1)*Lmax)*Lmax))))+(dcf*modelPar_TOXP))+((dcf*dcf)*Lmax))+Lmax);
          TT2 = ((TT0+1.0)*(dcf*modelPar_TOXP));
          Cfgsat = (((((((2.0*epssp)*sqrt(static_cast<double>(2)))/3.14159265358979323846)*0.70)*dcf)/TT0)*log((TT1/TT2)));
          delta = 1.2e-12;
          TT1 = ((Cfgsat-Cfglog)-delta);
          Cfg = (modelPar_HFIN*(Cfgsat-(0.5*(TT1+sqrt(((TT1*TT1)+((4*delta)*Cfgsat)))))));
          Cgg_side = (Ccg+Cfg);
        }
        // End block cfr_side_dblgate
      }
      else
      {
        //Begin block cfr_side_trigate
        {
          //Block-local variables for block cfr_side_trigate
          AdmsSensFadType Hr;
          double Lr;
          AdmsSensFadType Hgdelta;
          AdmsSensFadType Lmax;
          AdmsSensFadType y;
          AdmsSensFadType x;
          //End of Block-local variables
          //Block-local variables for block cfr_side_trigate
          AdmsSensFadType CcgSat;
          double Cnon;
          AdmsSensFadType TT1;
          AdmsSensFadType Ccg1;
          AdmsSensFadType r1cf;
          AdmsSensFadType Rcf;
          AdmsSensFadType Ccg2;
          //End of Block-local variables
          //Block-local variables for block cfr_side_trigate
          AdmsSensFadType Ccg;
          AdmsSensFadType C1;
          AdmsSensFadType C2;
          AdmsSensFadType C3;
          AdmsSensFadType Cfglog;
          AdmsSensFadType dcf;
          AdmsSensFadType TT0;
          //End of Block-local variables
          //Block-local variables for block cfr_side_trigate
          AdmsSensFadType TT2;
          AdmsSensFadType Cfgsat;
          double delta;
          AdmsSensFadType Cfg;
          //End of Block-local variables
          Hr = (2.3+((0.2*(Wg+modelPar_TOXP))/Trsd));
          Lr = 1.05;
          Hgdelta = fabs(((Wg+modelPar_TOXP)-Trsd));
          Lmax = (modelPar_LSP*Lr);
          y = std::min(Trsd,(Wg+modelPar_TOXP));
          x = (modelPar_LSP/(Hr+1.0));
          Cnon = 1.7e12;
          CcgSat = ((epssp*(y-x))/modelPar_LSP);
          TT1 = (Cnon*CcgSat);
          if ((TT1>80.0))
          {
            Ccg1 = CcgSat;
          }
          else
          {
            Ccg1 = ((1.0/Cnon)*log((1.0+AnalogFunctions::lexp<AdmsSensFadType>(TT1))));
          }
          r1cf = (0.5*std::min((Trsd/(Wg+modelPar_TOXP)),((Wg+modelPar_TOXP)/Trsd)));
          Rcf = (Hgdelta*r1cf);
          Ccg2 = (((epssp*2)/3.14159265358979323846)*log(((modelPar_LSP+((0.5*3.14159265358979323846)*Rcf))/modelPar_LSP)));
          Ccg = (modelPar_HFIN*(Ccg1+Ccg2));
          x = (Lmax/Wg);
          C1 = (4.0/(sqrt((2.0*(x+1)))*3.14159265358979323846));
          C2 = ((((sqrt((((modelPar_TOXP*modelPar_TOXP)+((2.0*Wg)*modelPar_TOXP))+((Wg*Wg)*(x+1))))*sqrt((x+1)))+modelPar_TOXP)+(Wg*x))+Wg);
          C3 = ((modelPar_TOXP*sqrt(((x+1)*(x+4))))+(modelPar_TOXP*(x+2)));
          Cfglog = (epssp*((C1*log((C2/C3)))+12.27));
          dcf = (Hr*Lr);
          TT0 = sqrt(((dcf*dcf)+1.0));
          TT1 = (((sqrt((((dcf*dcf)+1)*((((dcf*modelPar_TOXP)*(dcf*modelPar_TOXP))+(((2*dcf)*Lmax)*modelPar_TOXP))+((((dcf*dcf)+1)*Lmax)*Lmax))))+(dcf*modelPar_TOXP))+((dcf*dcf)*Lmax))+Lmax);
          TT2 = ((TT0+1.0)*(dcf*modelPar_TOXP));
          Cfgsat = (((((((2.0*epssp)*sqrt(static_cast<double>(2)))/3.14159265358979323846)*0.85)*dcf)/TT0)*log((TT1/TT2)));
          delta = 1.2e-12;
          TT1 = ((Cfgsat-Cfglog)-delta);
          Cfg = (modelPar_HFIN*(Cfgsat-(0.5*(TT1+sqrt(((TT1*TT1)+((4*delta)*Cfgsat)))))));
          Cgg_side = (Ccg+Cfg);
        }
        // End block cfr_side_trigate
      }
      if ((modelPar_TMASK>0.0))
      {
        Acorner = 0.0;
      }
      else
      {
        if ((modelPar_HEPI>0.0))
        {
          Acorner = ((instancePar_FPITCH-instancePar_TFIN)*((modelPar_HEPI*modelPar_CRATIO)+modelPar_TSILI));
        }
        else
        {
          Acorner = ((instancePar_FPITCH-instancePar_TFIN)*Hrsd);
        }
      }
      Ccorner = (((((instancePar_NFIN*Acorner)+modelPar_ARSDEND)+modelPar_ASILIEND)*epssp)/modelPar_LSP);
      instanceVar_Cfr_geo = (((Ccorner+(Cgg_top*instancePar_NFIN))+(((modelPar_CGEOE*Cgg_side)*instancePar_NFIN)*2.0))*instancePar_NF);
      instanceVar_Cfr_geo = (instanceVar_Cfr_geo*std::max(static_cast<double>(0.0),(((modelPar_CGEOA+(modelPar_CGEOB*instancePar_TFIN))+(modelPar_CGEOC*instancePar_FPITCH))+(modelPar_CGEOD*instancePar_LRSD))));
    }
    instanceVar_T0 = (modelPar_CSDESW*AnalogFunctions::lln<AdmsSensFadType>((1.0+(modelPar_HFIN/modelPar_EOTBOX))));
    instanceVar_csbox = ((cbox*instancePar_ASEO)+(instanceVar_T0*std::max(static_cast<double>(0.0),(instancePar_PSEO-(instancePar_FPITCH*instanceVar_NFINtotal)))));
    instanceVar_cdbox = ((cbox*instancePar_ADEO)+(instanceVar_T0*std::max(static_cast<double>(0.0),(instancePar_PDEO-(instancePar_FPITCH*instanceVar_NFINtotal)))));
    instanceVar_cgbox = ((((modelPar_CGBO*instancePar_NF)*instancePar_NGCON)+(modelPar_CGBN*instanceVar_NFINtotal))*Lg);
    instanceVar_EeffFactor = (1.0e-8/(instanceVar_epsratio*modelPar_EOT));
    instanceVar_WeffWRFactor = (1.0/(pow((instanceVar_Weff0*1.0e6),WR_i)*instanceVar_NFINtotal));
    instanceVar_litl = sqrt((((instanceVar_epsratio*modelPar_EOT)*0.5)*instancePar_TFIN));
    if ((!modelPar_given_THETASCE))
    {
      instanceVar_tmp = (((DVT1_i*instanceVar_Leff)/instanceVar_scl)+1.0e-6);
      if ((instanceVar_tmp<40.0))
      {
        instanceVar_Theta_SCE = (0.5/(cosh(instanceVar_tmp)-1.0));
      }
      else
      {
        instanceVar_Theta_SCE = exp((-instanceVar_tmp));
      }
    }
    else
    {
      instanceVar_Theta_SCE = modelPar_THETASCE;
    }
    if ((!modelPar_given_THETASW))
    {
      instanceVar_tmp = (((DVT1SS_i*instanceVar_Leff)/instanceVar_scl)+1.0e-6);
      if ((instanceVar_tmp<40.0))
      {
        instanceVar_Theta_SW = (0.5/(cosh(instanceVar_tmp)-1.0));
      }
      else
      {
        instanceVar_Theta_SW = exp((-instanceVar_tmp));
      }
    }
    else
    {
      instanceVar_Theta_SW = modelPar_THETASW;
    }
    if ((!modelPar_given_THETADIBL))
    {
      instanceVar_tmp = (((DSUB_i*instanceVar_Leff)/instanceVar_scl)+1.0e-6);
      if ((instanceVar_tmp<40.0))
      {
        instanceVar_Theta_DIBL = (0.5/(cosh(instanceVar_tmp)-1.0));
      }
      else
      {
        instanceVar_Theta_DIBL = exp((-instanceVar_tmp));
      }
    }
    else
    {
      instanceVar_Theta_DIBL = modelPar_THETADIBL;
    }
    instanceVar_Theta_RSCE = (sqrt((1.0+(LPE0_i/instanceVar_Leff)))-1.0);
    instanceVar_tmp = (((DSUB_i*instanceVar_Leff)/instanceVar_scl)+1.0e-6);
    if ((instanceVar_tmp<40.0))
    {
      instanceVar_T0 = (1.0/std::max((1.0+(modelPar_DVTP2*(cosh(instanceVar_tmp)-2.0))),static_cast<double>(1.0e-6)));
    }
    else
    {
      instanceVar_T0 = (exp((-instanceVar_tmp))/std::max((exp((-instanceVar_tmp))+modelPar_DVTP2),static_cast<double>(1.0e-6)));
    }
    instanceVar_Theta_DITS = instanceVar_T0;
    instanceVar_nbody = NBODY_i;
    instanceVar_qbs = (((1.60219e-19*instanceVar_nbody)*instanceVar_Ach)/instanceVar_Cins);
    if ((modelPar_TYPE==1))
    {
      instanceVar_Aechvb = 4.97232e-7;
      instanceVar_Bechvb = 7.45669e11;
    }
    else
    {
      instanceVar_Aechvb = 3.42537e-7;
      instanceVar_Bechvb = 1.16645e12;
    }
    instanceVar_T0 = (modelPar_TOXG*modelPar_TOXG);
    instanceVar_T1 = (modelPar_TOXG*instanceVar_POXEDGE_i);
    instanceVar_T2 = (instanceVar_T1*instanceVar_T1);
    instanceVar_Toxratio = (AnalogFunctions::lexp<AdmsSensFadType>((NTOX_i*AnalogFunctions::lln<AdmsSensFadType>((modelPar_TOXREF/modelPar_TOXG))))/instanceVar_T0);
    Toxratioedge = (AnalogFunctions::lexp<AdmsSensFadType>((NTOX_i*AnalogFunctions::lln<AdmsSensFadType>((modelPar_TOXREF/instanceVar_T1))))/instanceVar_T2);
    instanceVar_igsd_mult0 = ((instanceVar_Weff0*instanceVar_Aechvb)*Toxratioedge);
    if ((modelPar_TNOM<(-273.15)))
    {
      std::cerr  << "Warning: (TNOM=%e) < -`P_CELSIUS0. Set to 27 C." << modelPar_TNOM <<  std::endl; 
      instanceVar_Tnom = 300.15;
    }
    else
    {
      instanceVar_Tnom = (modelPar_TNOM+273.15);
    }
  }
  // End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_D,
   bool modelPar_given_D,
   AdmsSensFadType & modelPar_TFIN,
   bool modelPar_given_TFIN,
   AdmsSensFadType & modelPar_FPITCH,
   bool modelPar_given_FPITCH,
   AdmsSensFadType & modelPar_NFIN,
   bool modelPar_given_NFIN,
   AdmsSensFadType & modelPar_ASEO,
   bool modelPar_given_ASEO,
   AdmsSensFadType & modelPar_ADEO,
   bool modelPar_given_ADEO,
   AdmsSensFadType & modelPar_PSEO,
   bool modelPar_given_PSEO,
   AdmsSensFadType & modelPar_PDEO,
   bool modelPar_given_PDEO,
   AdmsSensFadType & modelPar_ASEJ,
   bool modelPar_given_ASEJ,
   AdmsSensFadType & modelPar_ADEJ,
   bool modelPar_given_ADEJ,
   AdmsSensFadType & modelPar_PSEJ,
   bool modelPar_given_PSEJ,
   AdmsSensFadType & modelPar_PDEJ,
   bool modelPar_given_PDEJ,
   AdmsSensFadType & modelPar_COVS,
   bool modelPar_given_COVS,
   AdmsSensFadType & modelPar_COVD,
   bool modelPar_given_COVD,
   AdmsSensFadType & modelPar_CGSP,
   bool modelPar_given_CGSP,
   AdmsSensFadType & modelPar_CGDP,
   bool modelPar_given_CGDP,
   AdmsSensFadType & modelPar_CDSP,
   bool modelPar_given_CDSP,
   AdmsSensFadType & modelPar_NRS,
   bool modelPar_given_NRS,
   AdmsSensFadType & modelPar_NRD,
   bool modelPar_given_NRD,
   AdmsSensFadType & modelPar_LRSD,
   bool modelPar_given_LRSD,
   AdmsSensFadType & modelPar_XL,
   bool modelPar_given_XL,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_DELVTRAND,
   bool modelPar_given_DELVTRAND,
   AdmsSensFadType & modelPar_U0MULT,
   bool modelPar_given_U0MULT,
   AdmsSensFadType & modelPar_IDS0MULT,
   bool modelPar_given_IDS0MULT,
   AdmsSensFadType & modelPar_LINT,
   bool modelPar_given_LINT,
   AdmsSensFadType & modelPar_LL,
   bool modelPar_given_LL,
   AdmsSensFadType & modelPar_LLN,
   bool modelPar_given_LLN,
   AdmsSensFadType & modelPar_DLC,
   bool modelPar_given_DLC,
   AdmsSensFadType & modelPar_DLCACC,
   bool modelPar_given_DLCACC,
   AdmsSensFadType & modelPar_DLBIN,
   bool modelPar_given_DLBIN,
   AdmsSensFadType & modelPar_LLC,
   bool modelPar_given_LLC,
   AdmsSensFadType & modelPar_EOT,
   bool modelPar_given_EOT,
   AdmsSensFadType & modelPar_TOXP,
   bool modelPar_given_TOXP,
   AdmsSensFadType & modelPar_EOTBOX,
   bool modelPar_given_EOTBOX,
   AdmsSensFadType & modelPar_HFIN,
   bool modelPar_given_HFIN,
   AdmsSensFadType & modelPar_FECH,
   bool modelPar_given_FECH,
   AdmsSensFadType & modelPar_DELTAW,
   bool modelPar_given_DELTAW,
   AdmsSensFadType & modelPar_FECHCV,
   bool modelPar_given_FECHCV,
   AdmsSensFadType & modelPar_DELTAWCV,
   bool modelPar_given_DELTAWCV,
   AdmsSensFadType & modelPar_NBODY,
   bool modelPar_given_NBODY,
   AdmsSensFadType & modelPar_NBODYN1,
   bool modelPar_given_NBODYN1,
   AdmsSensFadType & modelPar_NBODYN2,
   bool modelPar_given_NBODYN2,
   AdmsSensFadType & modelPar_NSD,
   bool modelPar_given_NSD,
   AdmsSensFadType & modelPar_PHIG,
   bool modelPar_given_PHIG,
   AdmsSensFadType & modelPar_PHIGL,
   bool modelPar_given_PHIGL,
   AdmsSensFadType & modelPar_PHIGLT,
   bool modelPar_given_PHIGLT,
   AdmsSensFadType & modelPar_PHIGN1,
   bool modelPar_given_PHIGN1,
   AdmsSensFadType & modelPar_PHIGN2,
   bool modelPar_given_PHIGN2,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_EPSRSUB,
   bool modelPar_given_EPSRSUB,
   AdmsSensFadType & modelPar_EASUB,
   bool modelPar_given_EASUB,
   AdmsSensFadType & modelPar_NI0SUB,
   bool modelPar_given_NI0SUB,
   AdmsSensFadType & modelPar_BG0SUB,
   bool modelPar_given_BG0SUB,
   AdmsSensFadType & modelPar_NC0SUB,
   bool modelPar_given_NC0SUB,
   AdmsSensFadType & modelPar_NGATE,
   bool modelPar_given_NGATE,
   AdmsSensFadType & modelPar_Imin,
   bool modelPar_given_Imin,
   AdmsSensFadType & modelPar_CIT,
   bool modelPar_given_CIT,
   AdmsSensFadType & modelPar_CITR,
   bool modelPar_given_CITR,
   AdmsSensFadType & modelPar_CDSC,
   bool modelPar_given_CDSC,
   AdmsSensFadType & modelPar_CDSCN1,
   bool modelPar_given_CDSCN1,
   AdmsSensFadType & modelPar_CDSCN2,
   bool modelPar_given_CDSCN2,
   AdmsSensFadType & modelPar_CDSCD,
   bool modelPar_given_CDSCD,
   AdmsSensFadType & modelPar_CDSCDN1,
   bool modelPar_given_CDSCDN1,
   AdmsSensFadType & modelPar_CDSCDN2,
   bool modelPar_given_CDSCDN2,
   AdmsSensFadType & modelPar_CDSCDR,
   bool modelPar_given_CDSCDR,
   AdmsSensFadType & modelPar_CDSCDRN1,
   bool modelPar_given_CDSCDRN1,
   AdmsSensFadType & modelPar_CDSCDRN2,
   bool modelPar_given_CDSCDRN2,
   AdmsSensFadType & modelPar_DVT0,
   bool modelPar_given_DVT0,
   AdmsSensFadType & modelPar_DVT1,
   bool modelPar_given_DVT1,
   AdmsSensFadType & modelPar_DVT1SS,
   bool modelPar_given_DVT1SS,
   AdmsSensFadType & modelPar_PHIN,
   bool modelPar_given_PHIN,
   AdmsSensFadType & modelPar_ETA0,
   bool modelPar_given_ETA0,
   AdmsSensFadType & modelPar_ETA0N1,
   bool modelPar_given_ETA0N1,
   AdmsSensFadType & modelPar_ETA0N2,
   bool modelPar_given_ETA0N2,
   AdmsSensFadType & modelPar_ETA0LT,
   bool modelPar_given_ETA0LT,
   AdmsSensFadType & modelPar_TETA0,
   bool modelPar_given_TETA0,
   AdmsSensFadType & modelPar_ETA0R,
   bool modelPar_given_ETA0R,
   AdmsSensFadType & modelPar_TETA0R,
   bool modelPar_given_TETA0R,
   AdmsSensFadType & modelPar_DSUB,
   bool modelPar_given_DSUB,
   AdmsSensFadType & modelPar_DVTP0,
   bool modelPar_given_DVTP0,
   AdmsSensFadType & modelPar_DVTP1,
   bool modelPar_given_DVTP1,
   AdmsSensFadType & modelPar_ADVTP0,
   bool modelPar_given_ADVTP0,
   AdmsSensFadType & modelPar_BDVTP0,
   bool modelPar_given_BDVTP0,
   AdmsSensFadType & modelPar_ADVTP1,
   bool modelPar_given_ADVTP1,
   AdmsSensFadType & modelPar_BDVTP1,
   bool modelPar_given_BDVTP1,
   AdmsSensFadType & modelPar_DVTP2,
   bool modelPar_given_DVTP2,
   AdmsSensFadType & modelPar_K1RSCE,
   bool modelPar_given_K1RSCE,
   AdmsSensFadType & modelPar_LPE0,
   bool modelPar_given_LPE0,
   AdmsSensFadType & modelPar_DVTSHIFT,
   bool modelPar_given_DVTSHIFT,
   AdmsSensFadType & modelPar_DVTSHIFTR,
   bool modelPar_given_DVTSHIFTR,
   AdmsSensFadType & modelPar_THETASCE,
   bool modelPar_given_THETASCE,
   AdmsSensFadType & modelPar_THETADIBL,
   bool modelPar_given_THETADIBL,
   AdmsSensFadType & modelPar_THETASW,
   bool modelPar_given_THETASW,
   AdmsSensFadType & modelPar_NVTM,
   bool modelPar_given_NVTM,
   AdmsSensFadType & modelPar_K0,
   bool modelPar_given_K0,
   AdmsSensFadType & modelPar_K01,
   bool modelPar_given_K01,
   AdmsSensFadType & modelPar_K0SI,
   bool modelPar_given_K0SI,
   AdmsSensFadType & modelPar_K0SI1,
   bool modelPar_given_K0SI1,
   AdmsSensFadType & modelPar_K2SI,
   bool modelPar_given_K2SI,
   AdmsSensFadType & modelPar_K2SI1,
   bool modelPar_given_K2SI1,
   AdmsSensFadType & modelPar_K0SISAT,
   bool modelPar_given_K0SISAT,
   AdmsSensFadType & modelPar_K0SISAT1,
   bool modelPar_given_K0SISAT1,
   AdmsSensFadType & modelPar_K2SISAT,
   bool modelPar_given_K2SISAT,
   AdmsSensFadType & modelPar_K2SISAT1,
   bool modelPar_given_K2SISAT1,
   AdmsSensFadType & modelPar_PHIBE,
   bool modelPar_given_PHIBE,
   AdmsSensFadType & modelPar_K1,
   bool modelPar_given_K1,
   AdmsSensFadType & modelPar_K11,
   bool modelPar_given_K11,
   AdmsSensFadType & modelPar_K2SAT,
   bool modelPar_given_K2SAT,
   AdmsSensFadType & modelPar_K2SAT1,
   bool modelPar_given_K2SAT1,
   AdmsSensFadType & modelPar_K2,
   bool modelPar_given_K2,
   AdmsSensFadType & modelPar_K21,
   bool modelPar_given_K21,
   AdmsSensFadType & modelPar_QMFACTOR,
   bool modelPar_given_QMFACTOR,
   AdmsSensFadType & modelPar_QMTCENCV,
   bool modelPar_given_QMTCENCV,
   AdmsSensFadType & modelPar_QMTCENCVA,
   bool modelPar_given_QMTCENCVA,
   AdmsSensFadType & modelPar_AQMTCEN,
   bool modelPar_given_AQMTCEN,
   AdmsSensFadType & modelPar_BQMTCEN,
   bool modelPar_given_BQMTCEN,
   AdmsSensFadType & modelPar_ETAQM,
   bool modelPar_given_ETAQM,
   AdmsSensFadType & modelPar_QM0,
   bool modelPar_given_QM0,
   AdmsSensFadType & modelPar_PQM,
   bool modelPar_given_PQM,
   AdmsSensFadType & modelPar_QM0ACC,
   bool modelPar_given_QM0ACC,
   AdmsSensFadType & modelPar_PQMACC,
   bool modelPar_given_PQMACC,
   AdmsSensFadType & modelPar_VSAT,
   bool modelPar_given_VSAT,
   AdmsSensFadType & modelPar_VSATR,
   bool modelPar_given_VSATR,
   AdmsSensFadType & modelPar_VSATN1,
   bool modelPar_given_VSATN1,
   AdmsSensFadType & modelPar_VSATN2,
   bool modelPar_given_VSATN2,
   AdmsSensFadType & modelPar_VSATRN1,
   bool modelPar_given_VSATRN1,
   AdmsSensFadType & modelPar_VSATRN2,
   bool modelPar_given_VSATRN2,
   AdmsSensFadType & modelPar_AVSAT,
   bool modelPar_given_AVSAT,
   AdmsSensFadType & modelPar_BVSAT,
   bool modelPar_given_BVSAT,
   AdmsSensFadType & modelPar_VSAT1,
   bool modelPar_given_VSAT1,
   AdmsSensFadType & modelPar_VSAT1N1,
   bool modelPar_given_VSAT1N1,
   AdmsSensFadType & modelPar_VSAT1N2,
   bool modelPar_given_VSAT1N2,
   AdmsSensFadType & modelPar_VSAT1R,
   bool modelPar_given_VSAT1R,
   AdmsSensFadType & modelPar_VSAT1RN1,
   bool modelPar_given_VSAT1RN1,
   AdmsSensFadType & modelPar_VSAT1RN2,
   bool modelPar_given_VSAT1RN2,
   AdmsSensFadType & modelPar_AVSAT1,
   bool modelPar_given_AVSAT1,
   AdmsSensFadType & modelPar_BVSAT1,
   bool modelPar_given_BVSAT1,
   AdmsSensFadType & modelPar_DELTAVSAT,
   bool modelPar_given_DELTAVSAT,
   AdmsSensFadType & modelPar_PSAT,
   bool modelPar_given_PSAT,
   AdmsSensFadType & modelPar_APSAT,
   bool modelPar_given_APSAT,
   AdmsSensFadType & modelPar_BPSAT,
   bool modelPar_given_BPSAT,
   AdmsSensFadType & modelPar_KSATIV,
   bool modelPar_given_KSATIV,
   AdmsSensFadType & modelPar_KSATIVR,
   bool modelPar_given_KSATIVR,
   AdmsSensFadType & modelPar_VSATCV,
   bool modelPar_given_VSATCV,
   AdmsSensFadType & modelPar_AVSATCV,
   bool modelPar_given_AVSATCV,
   AdmsSensFadType & modelPar_BVSATCV,
   bool modelPar_given_BVSATCV,
   AdmsSensFadType & modelPar_DELTAVSATCV,
   bool modelPar_given_DELTAVSATCV,
   AdmsSensFadType & modelPar_PSATCV,
   bool modelPar_given_PSATCV,
   AdmsSensFadType & modelPar_APSATCV,
   bool modelPar_given_APSATCV,
   AdmsSensFadType & modelPar_BPSATCV,
   bool modelPar_given_BPSATCV,
   AdmsSensFadType & modelPar_MEXP,
   bool modelPar_given_MEXP,
   AdmsSensFadType & modelPar_AMEXP,
   bool modelPar_given_AMEXP,
   AdmsSensFadType & modelPar_BMEXP,
   bool modelPar_given_BMEXP,
   AdmsSensFadType & modelPar_MEXPR,
   bool modelPar_given_MEXPR,
   AdmsSensFadType & modelPar_AMEXPR,
   bool modelPar_given_AMEXPR,
   AdmsSensFadType & modelPar_BMEXPR,
   bool modelPar_given_BMEXPR,
   AdmsSensFadType & modelPar_PTWG,
   bool modelPar_given_PTWG,
   AdmsSensFadType & modelPar_PTWGR,
   bool modelPar_given_PTWGR,
   AdmsSensFadType & modelPar_APTWG,
   bool modelPar_given_APTWG,
   AdmsSensFadType & modelPar_BPTWG,
   bool modelPar_given_BPTWG,
   AdmsSensFadType & modelPar_AT,
   bool modelPar_given_AT,
   AdmsSensFadType & modelPar_ATR,
   bool modelPar_given_ATR,
   AdmsSensFadType & modelPar_ATCV,
   bool modelPar_given_ATCV,
   AdmsSensFadType & modelPar_TMEXP,
   bool modelPar_given_TMEXP,
   AdmsSensFadType & modelPar_TMEXPR,
   bool modelPar_given_TMEXPR,
   AdmsSensFadType & modelPar_PTWGT,
   bool modelPar_given_PTWGT,
   AdmsSensFadType & modelPar_U0,
   bool modelPar_given_U0,
   AdmsSensFadType & modelPar_U0R,
   bool modelPar_given_U0R,
   AdmsSensFadType & modelPar_U0N1,
   bool modelPar_given_U0N1,
   AdmsSensFadType & modelPar_U0N1R,
   bool modelPar_given_U0N1R,
   AdmsSensFadType & modelPar_U0N2,
   bool modelPar_given_U0N2,
   AdmsSensFadType & modelPar_U0N2R,
   bool modelPar_given_U0N2R,
   AdmsSensFadType & modelPar_U0LT,
   bool modelPar_given_U0LT,
   AdmsSensFadType & modelPar_ETAMOB,
   bool modelPar_given_ETAMOB,
   AdmsSensFadType & modelPar_UP,
   bool modelPar_given_UP,
   AdmsSensFadType & modelPar_LPA,
   bool modelPar_given_LPA,
   AdmsSensFadType & modelPar_UPR,
   bool modelPar_given_UPR,
   AdmsSensFadType & modelPar_LPAR,
   bool modelPar_given_LPAR,
   AdmsSensFadType & modelPar_UA,
   bool modelPar_given_UA,
   AdmsSensFadType & modelPar_UAR,
   bool modelPar_given_UAR,
   AdmsSensFadType & modelPar_AUA,
   bool modelPar_given_AUA,
   AdmsSensFadType & modelPar_AUAR,
   bool modelPar_given_AUAR,
   AdmsSensFadType & modelPar_BUA,
   bool modelPar_given_BUA,
   AdmsSensFadType & modelPar_BUAR,
   bool modelPar_given_BUAR,
   AdmsSensFadType & modelPar_UC,
   bool modelPar_given_UC,
   AdmsSensFadType & modelPar_UCR,
   bool modelPar_given_UCR,
   AdmsSensFadType & modelPar_EU,
   bool modelPar_given_EU,
   AdmsSensFadType & modelPar_EUR,
   bool modelPar_given_EUR,
   AdmsSensFadType & modelPar_AEU,
   bool modelPar_given_AEU,
   AdmsSensFadType & modelPar_AEUR,
   bool modelPar_given_AEUR,
   AdmsSensFadType & modelPar_BEU,
   bool modelPar_given_BEU,
   AdmsSensFadType & modelPar_BEUR,
   bool modelPar_given_BEUR,
   AdmsSensFadType & modelPar_UD,
   bool modelPar_given_UD,
   AdmsSensFadType & modelPar_UDR,
   bool modelPar_given_UDR,
   AdmsSensFadType & modelPar_AUD,
   bool modelPar_given_AUD,
   AdmsSensFadType & modelPar_AUDR,
   bool modelPar_given_AUDR,
   AdmsSensFadType & modelPar_BUD,
   bool modelPar_given_BUD,
   AdmsSensFadType & modelPar_BUDR,
   bool modelPar_given_BUDR,
   AdmsSensFadType & modelPar_UCS,
   bool modelPar_given_UCS,
   AdmsSensFadType & modelPar_UTE,
   bool modelPar_given_UTE,
   AdmsSensFadType & modelPar_UTER,
   bool modelPar_given_UTER,
   AdmsSensFadType & modelPar_UTL,
   bool modelPar_given_UTL,
   AdmsSensFadType & modelPar_UTLR,
   bool modelPar_given_UTLR,
   AdmsSensFadType & modelPar_EMOBT,
   bool modelPar_given_EMOBT,
   AdmsSensFadType & modelPar_UA1,
   bool modelPar_given_UA1,
   AdmsSensFadType & modelPar_UA1R,
   bool modelPar_given_UA1R,
   AdmsSensFadType & modelPar_UC1,
   bool modelPar_given_UC1,
   AdmsSensFadType & modelPar_UC1R,
   bool modelPar_given_UC1R,
   AdmsSensFadType & modelPar_UD1,
   bool modelPar_given_UD1,
   AdmsSensFadType & modelPar_UD1R,
   bool modelPar_given_UD1R,
   AdmsSensFadType & modelPar_UCSTE,
   bool modelPar_given_UCSTE,
   AdmsSensFadType & modelPar_CHARGEWF,
   bool modelPar_given_CHARGEWF,
   AdmsSensFadType & modelPar_RDSWMIN,
   bool modelPar_given_RDSWMIN,
   AdmsSensFadType & modelPar_RDSW,
   bool modelPar_given_RDSW,
   AdmsSensFadType & modelPar_ARDSW,
   bool modelPar_given_ARDSW,
   AdmsSensFadType & modelPar_BRDSW,
   bool modelPar_given_BRDSW,
   AdmsSensFadType & modelPar_RSWMIN,
   bool modelPar_given_RSWMIN,
   AdmsSensFadType & modelPar_RSW,
   bool modelPar_given_RSW,
   AdmsSensFadType & modelPar_ARSW,
   bool modelPar_given_ARSW,
   AdmsSensFadType & modelPar_BRSW,
   bool modelPar_given_BRSW,
   AdmsSensFadType & modelPar_RDWMIN,
   bool modelPar_given_RDWMIN,
   AdmsSensFadType & modelPar_RDW,
   bool modelPar_given_RDW,
   AdmsSensFadType & modelPar_ARDW,
   bool modelPar_given_ARDW,
   AdmsSensFadType & modelPar_BRDW,
   bool modelPar_given_BRDW,
   AdmsSensFadType & modelPar_RSDR,
   bool modelPar_given_RSDR,
   AdmsSensFadType & modelPar_RSDRR,
   bool modelPar_given_RSDRR,
   AdmsSensFadType & modelPar_RDDR,
   bool modelPar_given_RDDR,
   AdmsSensFadType & modelPar_RDDRR,
   bool modelPar_given_RDDRR,
   AdmsSensFadType & modelPar_PRSDR,
   bool modelPar_given_PRSDR,
   AdmsSensFadType & modelPar_PRDDR,
   bool modelPar_given_PRDDR,
   AdmsSensFadType & modelPar_PRWGS,
   bool modelPar_given_PRWGS,
   AdmsSensFadType & modelPar_PRWGD,
   bool modelPar_given_PRWGD,
   AdmsSensFadType & modelPar_WR,
   bool modelPar_given_WR,
   AdmsSensFadType & modelPar_PRT,
   bool modelPar_given_PRT,
   AdmsSensFadType & modelPar_TRSDR,
   bool modelPar_given_TRSDR,
   AdmsSensFadType & modelPar_TRDDR,
   bool modelPar_given_TRDDR,
   AdmsSensFadType & modelPar_PDIBL1,
   bool modelPar_given_PDIBL1,
   AdmsSensFadType & modelPar_PDIBL1R,
   bool modelPar_given_PDIBL1R,
   AdmsSensFadType & modelPar_PDIBL2,
   bool modelPar_given_PDIBL2,
   AdmsSensFadType & modelPar_PDIBL2R,
   bool modelPar_given_PDIBL2R,
   AdmsSensFadType & modelPar_DROUT,
   bool modelPar_given_DROUT,
   AdmsSensFadType & modelPar_PVAG,
   bool modelPar_given_PVAG,
   AdmsSensFadType & modelPar_PCLM,
   bool modelPar_given_PCLM,
   AdmsSensFadType & modelPar_PCLMR,
   bool modelPar_given_PCLMR,
   AdmsSensFadType & modelPar_APCLM,
   bool modelPar_given_APCLM,
   AdmsSensFadType & modelPar_APCLMR,
   bool modelPar_given_APCLMR,
   AdmsSensFadType & modelPar_BPCLM,
   bool modelPar_given_BPCLM,
   AdmsSensFadType & modelPar_BPCLMR,
   bool modelPar_given_BPCLMR,
   AdmsSensFadType & modelPar_PCLMG,
   bool modelPar_given_PCLMG,
   AdmsSensFadType & modelPar_PCLMCV,
   bool modelPar_given_PCLMCV,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_A11,
   bool modelPar_given_A11,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_A21,
   bool modelPar_given_A21,
   AdmsSensFadType & modelPar_RGEXT,
   bool modelPar_given_RGEXT,
   AdmsSensFadType & modelPar_RGFIN,
   bool modelPar_given_RGFIN,
   AdmsSensFadType & modelPar_RSHS,
   bool modelPar_given_RSHS,
   AdmsSensFadType & modelPar_RSHD,
   bool modelPar_given_RSHD,
   AdmsSensFadType & modelPar_HEPI,
   bool modelPar_given_HEPI,
   AdmsSensFadType & modelPar_TSILI,
   bool modelPar_given_TSILI,
   AdmsSensFadType & modelPar_RHOC,
   bool modelPar_given_RHOC,
   AdmsSensFadType & modelPar_RHORSD,
   bool modelPar_given_RHORSD,
   AdmsSensFadType & modelPar_CRATIO,
   bool modelPar_given_CRATIO,
   AdmsSensFadType & modelPar_DELTAPRSD,
   bool modelPar_given_DELTAPRSD,
   AdmsSensFadType & modelPar_LSP,
   bool modelPar_given_LSP,
   AdmsSensFadType & modelPar_EPSRSP,
   bool modelPar_given_EPSRSP,
   AdmsSensFadType & modelPar_TGATE,
   bool modelPar_given_TGATE,
   AdmsSensFadType & modelPar_TMASK,
   bool modelPar_given_TMASK,
   AdmsSensFadType & modelPar_ASILIEND,
   bool modelPar_given_ASILIEND,
   AdmsSensFadType & modelPar_ARSDEND,
   bool modelPar_given_ARSDEND,
   AdmsSensFadType & modelPar_PRSDEND,
   bool modelPar_given_PRSDEND,
   AdmsSensFadType & modelPar_NSDE,
   bool modelPar_given_NSDE,
   AdmsSensFadType & modelPar_RGEOA,
   bool modelPar_given_RGEOA,
   AdmsSensFadType & modelPar_RGEOB,
   bool modelPar_given_RGEOB,
   AdmsSensFadType & modelPar_RGEOC,
   bool modelPar_given_RGEOC,
   AdmsSensFadType & modelPar_RGEOD,
   bool modelPar_given_RGEOD,
   AdmsSensFadType & modelPar_RGEOE,
   bool modelPar_given_RGEOE,
   AdmsSensFadType & modelPar_CGEOA,
   bool modelPar_given_CGEOA,
   AdmsSensFadType & modelPar_CGEOB,
   bool modelPar_given_CGEOB,
   AdmsSensFadType & modelPar_CGEOC,
   bool modelPar_given_CGEOC,
   AdmsSensFadType & modelPar_CGEOD,
   bool modelPar_given_CGEOD,
   AdmsSensFadType & modelPar_CGEOE,
   bool modelPar_given_CGEOE,
   AdmsSensFadType & modelPar_AIGBINV,
   bool modelPar_given_AIGBINV,
   AdmsSensFadType & modelPar_AIGBINV1,
   bool modelPar_given_AIGBINV1,
   AdmsSensFadType & modelPar_BIGBINV,
   bool modelPar_given_BIGBINV,
   AdmsSensFadType & modelPar_CIGBINV,
   bool modelPar_given_CIGBINV,
   AdmsSensFadType & modelPar_EIGBINV,
   bool modelPar_given_EIGBINV,
   AdmsSensFadType & modelPar_NIGBINV,
   bool modelPar_given_NIGBINV,
   AdmsSensFadType & modelPar_AIGBACC,
   bool modelPar_given_AIGBACC,
   AdmsSensFadType & modelPar_AIGBACC1,
   bool modelPar_given_AIGBACC1,
   AdmsSensFadType & modelPar_BIGBACC,
   bool modelPar_given_BIGBACC,
   AdmsSensFadType & modelPar_CIGBACC,
   bool modelPar_given_CIGBACC,
   AdmsSensFadType & modelPar_NIGBACC,
   bool modelPar_given_NIGBACC,
   AdmsSensFadType & modelPar_AIGC,
   bool modelPar_given_AIGC,
   AdmsSensFadType & modelPar_AIGC1,
   bool modelPar_given_AIGC1,
   AdmsSensFadType & modelPar_BIGC,
   bool modelPar_given_BIGC,
   AdmsSensFadType & modelPar_CIGC,
   bool modelPar_given_CIGC,
   AdmsSensFadType & modelPar_PIGCD,
   bool modelPar_given_PIGCD,
   AdmsSensFadType & modelPar_DLCIGS,
   bool modelPar_given_DLCIGS,
   AdmsSensFadType & modelPar_AIGS,
   bool modelPar_given_AIGS,
   AdmsSensFadType & modelPar_AIGS1,
   bool modelPar_given_AIGS1,
   AdmsSensFadType & modelPar_BIGS,
   bool modelPar_given_BIGS,
   AdmsSensFadType & modelPar_CIGS,
   bool modelPar_given_CIGS,
   AdmsSensFadType & modelPar_DLCIGD,
   bool modelPar_given_DLCIGD,
   AdmsSensFadType & modelPar_AIGD,
   bool modelPar_given_AIGD,
   AdmsSensFadType & modelPar_AIGD1,
   bool modelPar_given_AIGD1,
   AdmsSensFadType & modelPar_BIGD,
   bool modelPar_given_BIGD,
   AdmsSensFadType & modelPar_CIGD,
   bool modelPar_given_CIGD,
   AdmsSensFadType & modelPar_VFBSD,
   bool modelPar_given_VFBSD,
   AdmsSensFadType & modelPar_VFBSDCV,
   bool modelPar_given_VFBSDCV,
   AdmsSensFadType & modelPar_TOXREF,
   bool modelPar_given_TOXREF,
   AdmsSensFadType & modelPar_TOXG,
   bool modelPar_given_TOXG,
   AdmsSensFadType & modelPar_NTOX,
   bool modelPar_given_NTOX,
   AdmsSensFadType & modelPar_POXEDGE,
   bool modelPar_given_POXEDGE,
   AdmsSensFadType & modelPar_AGISL,
   bool modelPar_given_AGISL,
   AdmsSensFadType & modelPar_BGISL,
   bool modelPar_given_BGISL,
   AdmsSensFadType & modelPar_CGISL,
   bool modelPar_given_CGISL,
   AdmsSensFadType & modelPar_EGISL,
   bool modelPar_given_EGISL,
   AdmsSensFadType & modelPar_PGISL,
   bool modelPar_given_PGISL,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_EGIDL,
   bool modelPar_given_EGIDL,
   AdmsSensFadType & modelPar_PGIDL,
   bool modelPar_given_PGIDL,
   AdmsSensFadType & modelPar_ALPHA0,
   bool modelPar_given_ALPHA0,
   AdmsSensFadType & modelPar_ALPHA01,
   bool modelPar_given_ALPHA01,
   AdmsSensFadType & modelPar_ALPHA1,
   bool modelPar_given_ALPHA1,
   AdmsSensFadType & modelPar_ALPHA11,
   bool modelPar_given_ALPHA11,
   AdmsSensFadType & modelPar_BETA0,
   bool modelPar_given_BETA0,
   AdmsSensFadType & modelPar_ALPHAII0,
   bool modelPar_given_ALPHAII0,
   AdmsSensFadType & modelPar_ALPHAII01,
   bool modelPar_given_ALPHAII01,
   AdmsSensFadType & modelPar_ALPHAII1,
   bool modelPar_given_ALPHAII1,
   AdmsSensFadType & modelPar_ALPHAII11,
   bool modelPar_given_ALPHAII11,
   AdmsSensFadType & modelPar_BETAII0,
   bool modelPar_given_BETAII0,
   AdmsSensFadType & modelPar_BETAII1,
   bool modelPar_given_BETAII1,
   AdmsSensFadType & modelPar_BETAII2,
   bool modelPar_given_BETAII2,
   AdmsSensFadType & modelPar_ESATII,
   bool modelPar_given_ESATII,
   AdmsSensFadType & modelPar_LII,
   bool modelPar_given_LII,
   AdmsSensFadType & modelPar_SII0,
   bool modelPar_given_SII0,
   AdmsSensFadType & modelPar_SII1,
   bool modelPar_given_SII1,
   AdmsSensFadType & modelPar_SII2,
   bool modelPar_given_SII2,
   AdmsSensFadType & modelPar_SIID,
   bool modelPar_given_SIID,
   AdmsSensFadType & modelPar_IIMOD2CLAMP1,
   bool modelPar_given_IIMOD2CLAMP1,
   AdmsSensFadType & modelPar_IIMOD2CLAMP2,
   bool modelPar_given_IIMOD2CLAMP2,
   AdmsSensFadType & modelPar_IIMOD2CLAMP3,
   bool modelPar_given_IIMOD2CLAMP3,
   AdmsSensFadType & modelPar_EOTACC,
   bool modelPar_given_EOTACC,
   AdmsSensFadType & modelPar_DELVFBACC,
   bool modelPar_given_DELVFBACC,
   AdmsSensFadType & modelPar_CFS,
   bool modelPar_given_CFS,
   AdmsSensFadType & modelPar_CFD,
   bool modelPar_given_CFD,
   AdmsSensFadType & modelPar_CGSO,
   bool modelPar_given_CGSO,
   AdmsSensFadType & modelPar_CGDO,
   bool modelPar_given_CGDO,
   AdmsSensFadType & modelPar_CGSL,
   bool modelPar_given_CGSL,
   AdmsSensFadType & modelPar_CGDL,
   bool modelPar_given_CGDL,
   AdmsSensFadType & modelPar_CKAPPAS,
   bool modelPar_given_CKAPPAS,
   AdmsSensFadType & modelPar_CKAPPAD,
   bool modelPar_given_CKAPPAD,
   AdmsSensFadType & modelPar_CGBO,
   bool modelPar_given_CGBO,
   AdmsSensFadType & modelPar_CGBN,
   bool modelPar_given_CGBN,
   AdmsSensFadType & modelPar_CGBL,
   bool modelPar_given_CGBL,
   AdmsSensFadType & modelPar_CKAPPAB,
   bool modelPar_given_CKAPPAB,
   AdmsSensFadType & modelPar_CSDESW,
   bool modelPar_given_CSDESW,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_CJD,
   bool modelPar_given_CJD,
   AdmsSensFadType & modelPar_CJSWS,
   bool modelPar_given_CJSWS,
   AdmsSensFadType & modelPar_CJSWD,
   bool modelPar_given_CJSWD,
   AdmsSensFadType & modelPar_CJSWGS,
   bool modelPar_given_CJSWGS,
   AdmsSensFadType & modelPar_CJSWGD,
   bool modelPar_given_CJSWGD,
   AdmsSensFadType & modelPar_PBS,
   bool modelPar_given_PBS,
   AdmsSensFadType & modelPar_PBD,
   bool modelPar_given_PBD,
   AdmsSensFadType & modelPar_PBSWS,
   bool modelPar_given_PBSWS,
   AdmsSensFadType & modelPar_PBSWD,
   bool modelPar_given_PBSWD,
   AdmsSensFadType & modelPar_PBSWGS,
   bool modelPar_given_PBSWGS,
   AdmsSensFadType & modelPar_PBSWGD,
   bool modelPar_given_PBSWGD,
   AdmsSensFadType & modelPar_MJS,
   bool modelPar_given_MJS,
   AdmsSensFadType & modelPar_MJD,
   bool modelPar_given_MJD,
   AdmsSensFadType & modelPar_MJSWS,
   bool modelPar_given_MJSWS,
   AdmsSensFadType & modelPar_MJSWD,
   bool modelPar_given_MJSWD,
   AdmsSensFadType & modelPar_MJSWGS,
   bool modelPar_given_MJSWGS,
   AdmsSensFadType & modelPar_MJSWGD,
   bool modelPar_given_MJSWGD,
   AdmsSensFadType & modelPar_SJS,
   bool modelPar_given_SJS,
   AdmsSensFadType & modelPar_SJD,
   bool modelPar_given_SJD,
   AdmsSensFadType & modelPar_SJSWS,
   bool modelPar_given_SJSWS,
   AdmsSensFadType & modelPar_SJSWD,
   bool modelPar_given_SJSWD,
   AdmsSensFadType & modelPar_SJSWGS,
   bool modelPar_given_SJSWGS,
   AdmsSensFadType & modelPar_SJSWGD,
   bool modelPar_given_SJSWGD,
   AdmsSensFadType & modelPar_MJS2,
   bool modelPar_given_MJS2,
   AdmsSensFadType & modelPar_MJD2,
   bool modelPar_given_MJD2,
   AdmsSensFadType & modelPar_MJSWS2,
   bool modelPar_given_MJSWS2,
   AdmsSensFadType & modelPar_MJSWD2,
   bool modelPar_given_MJSWD2,
   AdmsSensFadType & modelPar_MJSWGS2,
   bool modelPar_given_MJSWGS2,
   AdmsSensFadType & modelPar_MJSWGD2,
   bool modelPar_given_MJSWGD2,
   AdmsSensFadType & modelPar_JSS,
   bool modelPar_given_JSS,
   AdmsSensFadType & modelPar_JSD,
   bool modelPar_given_JSD,
   AdmsSensFadType & modelPar_JSWS,
   bool modelPar_given_JSWS,
   AdmsSensFadType & modelPar_JSWD,
   bool modelPar_given_JSWD,
   AdmsSensFadType & modelPar_JSWGS,
   bool modelPar_given_JSWGS,
   AdmsSensFadType & modelPar_JSWGD,
   bool modelPar_given_JSWGD,
   AdmsSensFadType & modelPar_NJS,
   bool modelPar_given_NJS,
   AdmsSensFadType & modelPar_NJD,
   bool modelPar_given_NJD,
   AdmsSensFadType & modelPar_IJTHSFWD,
   bool modelPar_given_IJTHSFWD,
   AdmsSensFadType & modelPar_IJTHDFWD,
   bool modelPar_given_IJTHDFWD,
   AdmsSensFadType & modelPar_IJTHSREV,
   bool modelPar_given_IJTHSREV,
   AdmsSensFadType & modelPar_IJTHDREV,
   bool modelPar_given_IJTHDREV,
   AdmsSensFadType & modelPar_BVS,
   bool modelPar_given_BVS,
   AdmsSensFadType & modelPar_BVD,
   bool modelPar_given_BVD,
   AdmsSensFadType & modelPar_XJBVS,
   bool modelPar_given_XJBVS,
   AdmsSensFadType & modelPar_XJBVD,
   bool modelPar_given_XJBVD,
   AdmsSensFadType & modelPar_JTSS,
   bool modelPar_given_JTSS,
   AdmsSensFadType & modelPar_JTSD,
   bool modelPar_given_JTSD,
   AdmsSensFadType & modelPar_JTSSWS,
   bool modelPar_given_JTSSWS,
   AdmsSensFadType & modelPar_JTSSWD,
   bool modelPar_given_JTSSWD,
   AdmsSensFadType & modelPar_JTSSWGS,
   bool modelPar_given_JTSSWGS,
   AdmsSensFadType & modelPar_JTSSWGD,
   bool modelPar_given_JTSSWGD,
   AdmsSensFadType & modelPar_JTWEFF,
   bool modelPar_given_JTWEFF,
   AdmsSensFadType & modelPar_NJTS,
   bool modelPar_given_NJTS,
   AdmsSensFadType & modelPar_NJTSD,
   bool modelPar_given_NJTSD,
   AdmsSensFadType & modelPar_NJTSSW,
   bool modelPar_given_NJTSSW,
   AdmsSensFadType & modelPar_NJTSSWD,
   bool modelPar_given_NJTSSWD,
   AdmsSensFadType & modelPar_NJTSSWG,
   bool modelPar_given_NJTSSWG,
   AdmsSensFadType & modelPar_NJTSSWGD,
   bool modelPar_given_NJTSSWGD,
   AdmsSensFadType & modelPar_VTSS,
   bool modelPar_given_VTSS,
   AdmsSensFadType & modelPar_VTSD,
   bool modelPar_given_VTSD,
   AdmsSensFadType & modelPar_VTSSWS,
   bool modelPar_given_VTSSWS,
   AdmsSensFadType & modelPar_VTSSWD,
   bool modelPar_given_VTSSWD,
   AdmsSensFadType & modelPar_VTSSWGS,
   bool modelPar_given_VTSSWGS,
   AdmsSensFadType & modelPar_VTSSWGD,
   bool modelPar_given_VTSSWGD,
   AdmsSensFadType & modelPar_LINTIGEN,
   bool modelPar_given_LINTIGEN,
   AdmsSensFadType & modelPar_NTGEN,
   bool modelPar_given_NTGEN,
   AdmsSensFadType & modelPar_AIGEN,
   bool modelPar_given_AIGEN,
   AdmsSensFadType & modelPar_BIGEN,
   bool modelPar_given_BIGEN,
   AdmsSensFadType & modelPar_XRCRG1,
   bool modelPar_given_XRCRG1,
   AdmsSensFadType & modelPar_XRCRG2,
   bool modelPar_given_XRCRG2,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_EM,
   bool modelPar_given_EM,
   AdmsSensFadType & modelPar_NOIA,
   bool modelPar_given_NOIA,
   AdmsSensFadType & modelPar_NOIB,
   bool modelPar_given_NOIB,
   AdmsSensFadType & modelPar_NOIC,
   bool modelPar_given_NOIC,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_NTNOI,
   bool modelPar_given_NTNOI,
   AdmsSensFadType & modelPar_TNOIA,
   bool modelPar_given_TNOIA,
   AdmsSensFadType & modelPar_TNOIB,
   bool modelPar_given_TNOIB,
   AdmsSensFadType & modelPar_RNOIA,
   bool modelPar_given_RNOIA,
   AdmsSensFadType & modelPar_RNOIB,
   bool modelPar_given_RNOIB,
   AdmsSensFadType & modelPar_TNOIC,
   bool modelPar_given_TNOIC,
   AdmsSensFadType & modelPar_RNOIC,
   bool modelPar_given_RNOIC,
   AdmsSensFadType & modelPar_SCALEN,
   bool modelPar_given_SCALEN,
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_TBGASUB,
   bool modelPar_given_TBGASUB,
   AdmsSensFadType & modelPar_TBGBSUB,
   bool modelPar_given_TBGBSUB,
   AdmsSensFadType & modelPar_KT1,
   bool modelPar_given_KT1,
   AdmsSensFadType & modelPar_KT1L,
   bool modelPar_given_KT1L,
   AdmsSensFadType & modelPar_TSS,
   bool modelPar_given_TSS,
   AdmsSensFadType & modelPar_IIT,
   bool modelPar_given_IIT,
   AdmsSensFadType & modelPar_TII,
   bool modelPar_given_TII,
   AdmsSensFadType & modelPar_TGIDL,
   bool modelPar_given_TGIDL,
   AdmsSensFadType & modelPar_IGT,
   bool modelPar_given_IGT,
   AdmsSensFadType & modelPar_TCJ,
   bool modelPar_given_TCJ,
   AdmsSensFadType & modelPar_TCJSW,
   bool modelPar_given_TCJSW,
   AdmsSensFadType & modelPar_TCJSWG,
   bool modelPar_given_TCJSWG,
   AdmsSensFadType & modelPar_TPB,
   bool modelPar_given_TPB,
   AdmsSensFadType & modelPar_TPBSW,
   bool modelPar_given_TPBSW,
   AdmsSensFadType & modelPar_TPBSWG,
   bool modelPar_given_TPBSWG,
   AdmsSensFadType & modelPar_XTIS,
   bool modelPar_given_XTIS,
   AdmsSensFadType & modelPar_XTID,
   bool modelPar_given_XTID,
   AdmsSensFadType & modelPar_XTSS,
   bool modelPar_given_XTSS,
   AdmsSensFadType & modelPar_XTSD,
   bool modelPar_given_XTSD,
   AdmsSensFadType & modelPar_XTSSWS,
   bool modelPar_given_XTSSWS,
   AdmsSensFadType & modelPar_XTSSWD,
   bool modelPar_given_XTSSWD,
   AdmsSensFadType & modelPar_XTSSWGS,
   bool modelPar_given_XTSSWGS,
   AdmsSensFadType & modelPar_XTSSWGD,
   bool modelPar_given_XTSSWGD,
   AdmsSensFadType & modelPar_TNJTS,
   bool modelPar_given_TNJTS,
   AdmsSensFadType & modelPar_TNJTSD,
   bool modelPar_given_TNJTSD,
   AdmsSensFadType & modelPar_TNJTSSW,
   bool modelPar_given_TNJTSSW,
   AdmsSensFadType & modelPar_TNJTSSWD,
   bool modelPar_given_TNJTSSWD,
   AdmsSensFadType & modelPar_TNJTSSWG,
   bool modelPar_given_TNJTSSWG,
   AdmsSensFadType & modelPar_TNJTSSWGD,
   bool modelPar_given_TNJTSSWGD,
   AdmsSensFadType & modelPar_RTH0,
   bool modelPar_given_RTH0,
   AdmsSensFadType & modelPar_CTH0,
   bool modelPar_given_CTH0,
   AdmsSensFadType & modelPar_WTH0,
   bool modelPar_given_WTH0,
   AdmsSensFadType & modelPar_ASHEXP,
   bool modelPar_given_ASHEXP,
   AdmsSensFadType & modelPar_BSHEXP,
   bool modelPar_given_BSHEXP,
   AdmsSensFadType & modelPar_ACH_UFCM,
   bool modelPar_given_ACH_UFCM,
   AdmsSensFadType & modelPar_CINS_UFCM,
   bool modelPar_given_CINS_UFCM,
   AdmsSensFadType & modelPar_W_UFCM,
   bool modelPar_given_W_UFCM,
   AdmsSensFadType & modelPar_TFIN_TOP,
   bool modelPar_given_TFIN_TOP,
   AdmsSensFadType & modelPar_TFIN_BASE,
   bool modelPar_given_TFIN_BASE,
   AdmsSensFadType & modelPar_QMFACTORCV,
   bool modelPar_given_QMFACTORCV,
   AdmsSensFadType & modelPar_ALPHA_UFCM,
   bool modelPar_given_ALPHA_UFCM,
   AdmsSensFadType & modelPar_LNBODY,
   bool modelPar_given_LNBODY,
   AdmsSensFadType & modelPar_NNBODY,
   bool modelPar_given_NNBODY,
   AdmsSensFadType & modelPar_PNBODY,
   bool modelPar_given_PNBODY,
   AdmsSensFadType & modelPar_LPHIG,
   bool modelPar_given_LPHIG,
   AdmsSensFadType & modelPar_NPHIG,
   bool modelPar_given_NPHIG,
   AdmsSensFadType & modelPar_PPHIG,
   bool modelPar_given_PPHIG,
   AdmsSensFadType & modelPar_LNGATE,
   bool modelPar_given_LNGATE,
   AdmsSensFadType & modelPar_NNGATE,
   bool modelPar_given_NNGATE,
   AdmsSensFadType & modelPar_PNGATE,
   bool modelPar_given_PNGATE,
   AdmsSensFadType & modelPar_LCIT,
   bool modelPar_given_LCIT,
   AdmsSensFadType & modelPar_NCIT,
   bool modelPar_given_NCIT,
   AdmsSensFadType & modelPar_PCIT,
   bool modelPar_given_PCIT,
   AdmsSensFadType & modelPar_LCITR,
   bool modelPar_given_LCITR,
   AdmsSensFadType & modelPar_NCITR,
   bool modelPar_given_NCITR,
   AdmsSensFadType & modelPar_PCITR,
   bool modelPar_given_PCITR,
   AdmsSensFadType & modelPar_LCDSC,
   bool modelPar_given_LCDSC,
   AdmsSensFadType & modelPar_NCDSC,
   bool modelPar_given_NCDSC,
   AdmsSensFadType & modelPar_PCDSC,
   bool modelPar_given_PCDSC,
   AdmsSensFadType & modelPar_LCDSCD,
   bool modelPar_given_LCDSCD,
   AdmsSensFadType & modelPar_NCDSCD,
   bool modelPar_given_NCDSCD,
   AdmsSensFadType & modelPar_PCDSCD,
   bool modelPar_given_PCDSCD,
   AdmsSensFadType & modelPar_LCDSCDR,
   bool modelPar_given_LCDSCDR,
   AdmsSensFadType & modelPar_NCDSCDR,
   bool modelPar_given_NCDSCDR,
   AdmsSensFadType & modelPar_PCDSCDR,
   bool modelPar_given_PCDSCDR,
   AdmsSensFadType & modelPar_LDVT0,
   bool modelPar_given_LDVT0,
   AdmsSensFadType & modelPar_NDVT0,
   bool modelPar_given_NDVT0,
   AdmsSensFadType & modelPar_PDVT0,
   bool modelPar_given_PDVT0,
   AdmsSensFadType & modelPar_LDVT1,
   bool modelPar_given_LDVT1,
   AdmsSensFadType & modelPar_NDVT1,
   bool modelPar_given_NDVT1,
   AdmsSensFadType & modelPar_PDVT1,
   bool modelPar_given_PDVT1,
   AdmsSensFadType & modelPar_LDVT1SS,
   bool modelPar_given_LDVT1SS,
   AdmsSensFadType & modelPar_NDVT1SS,
   bool modelPar_given_NDVT1SS,
   AdmsSensFadType & modelPar_PDVT1SS,
   bool modelPar_given_PDVT1SS,
   AdmsSensFadType & modelPar_LPHIN,
   bool modelPar_given_LPHIN,
   AdmsSensFadType & modelPar_NPHIN,
   bool modelPar_given_NPHIN,
   AdmsSensFadType & modelPar_PPHIN,
   bool modelPar_given_PPHIN,
   AdmsSensFadType & modelPar_LETA0,
   bool modelPar_given_LETA0,
   AdmsSensFadType & modelPar_NETA0,
   bool modelPar_given_NETA0,
   AdmsSensFadType & modelPar_PETA0,
   bool modelPar_given_PETA0,
   AdmsSensFadType & modelPar_LETA0R,
   bool modelPar_given_LETA0R,
   AdmsSensFadType & modelPar_NETA0R,
   bool modelPar_given_NETA0R,
   AdmsSensFadType & modelPar_PETA0R,
   bool modelPar_given_PETA0R,
   AdmsSensFadType & modelPar_LDSUB,
   bool modelPar_given_LDSUB,
   AdmsSensFadType & modelPar_NDSUB,
   bool modelPar_given_NDSUB,
   AdmsSensFadType & modelPar_PDSUB,
   bool modelPar_given_PDSUB,
   AdmsSensFadType & modelPar_LK1RSCE,
   bool modelPar_given_LK1RSCE,
   AdmsSensFadType & modelPar_NK1RSCE,
   bool modelPar_given_NK1RSCE,
   AdmsSensFadType & modelPar_PK1RSCE,
   bool modelPar_given_PK1RSCE,
   AdmsSensFadType & modelPar_LLPE0,
   bool modelPar_given_LLPE0,
   AdmsSensFadType & modelPar_NLPE0,
   bool modelPar_given_NLPE0,
   AdmsSensFadType & modelPar_PLPE0,
   bool modelPar_given_PLPE0,
   AdmsSensFadType & modelPar_LDVTSHIFT,
   bool modelPar_given_LDVTSHIFT,
   AdmsSensFadType & modelPar_NDVTSHIFT,
   bool modelPar_given_NDVTSHIFT,
   AdmsSensFadType & modelPar_PDVTSHIFT,
   bool modelPar_given_PDVTSHIFT,
   AdmsSensFadType & modelPar_LDVTSHIFTR,
   bool modelPar_given_LDVTSHIFTR,
   AdmsSensFadType & modelPar_NDVTSHIFTR,
   bool modelPar_given_NDVTSHIFTR,
   AdmsSensFadType & modelPar_PDVTSHIFTR,
   bool modelPar_given_PDVTSHIFTR,
   AdmsSensFadType & modelPar_LPHIBE,
   bool modelPar_given_LPHIBE,
   AdmsSensFadType & modelPar_NPHIBE,
   bool modelPar_given_NPHIBE,
   AdmsSensFadType & modelPar_PPHIBE,
   bool modelPar_given_PPHIBE,
   AdmsSensFadType & modelPar_LK0,
   bool modelPar_given_LK0,
   AdmsSensFadType & modelPar_NK0,
   bool modelPar_given_NK0,
   AdmsSensFadType & modelPar_PK0,
   bool modelPar_given_PK0,
   AdmsSensFadType & modelPar_LK01,
   bool modelPar_given_LK01,
   AdmsSensFadType & modelPar_NK01,
   bool modelPar_given_NK01,
   AdmsSensFadType & modelPar_PK01,
   bool modelPar_given_PK01,
   AdmsSensFadType & modelPar_LK0SI,
   bool modelPar_given_LK0SI,
   AdmsSensFadType & modelPar_NK0SI,
   bool modelPar_given_NK0SI,
   AdmsSensFadType & modelPar_PK0SI,
   bool modelPar_given_PK0SI,
   AdmsSensFadType & modelPar_LK0SI1,
   bool modelPar_given_LK0SI1,
   AdmsSensFadType & modelPar_NK0SI1,
   bool modelPar_given_NK0SI1,
   AdmsSensFadType & modelPar_PK0SI1,
   bool modelPar_given_PK0SI1,
   AdmsSensFadType & modelPar_LK1,
   bool modelPar_given_LK1,
   AdmsSensFadType & modelPar_NK1,
   bool modelPar_given_NK1,
   AdmsSensFadType & modelPar_PK1,
   bool modelPar_given_PK1,
   AdmsSensFadType & modelPar_LK11,
   bool modelPar_given_LK11,
   AdmsSensFadType & modelPar_NK11,
   bool modelPar_given_NK11,
   AdmsSensFadType & modelPar_PK11,
   bool modelPar_given_PK11,
   AdmsSensFadType & modelPar_LK2SI,
   bool modelPar_given_LK2SI,
   AdmsSensFadType & modelPar_NK2SI,
   bool modelPar_given_NK2SI,
   AdmsSensFadType & modelPar_PK2SI,
   bool modelPar_given_PK2SI,
   AdmsSensFadType & modelPar_LK2SI1,
   bool modelPar_given_LK2SI1,
   AdmsSensFadType & modelPar_NK2SI1,
   bool modelPar_given_NK2SI1,
   AdmsSensFadType & modelPar_PK2SI1,
   bool modelPar_given_PK2SI1,
   AdmsSensFadType & modelPar_LK0SISAT,
   bool modelPar_given_LK0SISAT,
   AdmsSensFadType & modelPar_NK0SISAT,
   bool modelPar_given_NK0SISAT,
   AdmsSensFadType & modelPar_PK0SISAT,
   bool modelPar_given_PK0SISAT,
   AdmsSensFadType & modelPar_LK0SISAT1,
   bool modelPar_given_LK0SISAT1,
   AdmsSensFadType & modelPar_NK0SISAT1,
   bool modelPar_given_NK0SISAT1,
   AdmsSensFadType & modelPar_PK0SISAT1,
   bool modelPar_given_PK0SISAT1,
   AdmsSensFadType & modelPar_LK2SISAT,
   bool modelPar_given_LK2SISAT,
   AdmsSensFadType & modelPar_NK2SISAT,
   bool modelPar_given_NK2SISAT,
   AdmsSensFadType & modelPar_PK2SISAT,
   bool modelPar_given_PK2SISAT,
   AdmsSensFadType & modelPar_LK2SISAT1,
   bool modelPar_given_LK2SISAT1,
   AdmsSensFadType & modelPar_NK2SISAT1,
   bool modelPar_given_NK2SISAT1,
   AdmsSensFadType & modelPar_PK2SISAT1,
   bool modelPar_given_PK2SISAT1,
   AdmsSensFadType & modelPar_LK2SAT,
   bool modelPar_given_LK2SAT,
   AdmsSensFadType & modelPar_NK2SAT,
   bool modelPar_given_NK2SAT,
   AdmsSensFadType & modelPar_PK2SAT,
   bool modelPar_given_PK2SAT,
   AdmsSensFadType & modelPar_LK2SAT1,
   bool modelPar_given_LK2SAT1,
   AdmsSensFadType & modelPar_NK2SAT1,
   bool modelPar_given_NK2SAT1,
   AdmsSensFadType & modelPar_PK2SAT1,
   bool modelPar_given_PK2SAT1,
   AdmsSensFadType & modelPar_LK2,
   bool modelPar_given_LK2,
   AdmsSensFadType & modelPar_NK2,
   bool modelPar_given_NK2,
   AdmsSensFadType & modelPar_PK2,
   bool modelPar_given_PK2,
   AdmsSensFadType & modelPar_LK21,
   bool modelPar_given_LK21,
   AdmsSensFadType & modelPar_NK21,
   bool modelPar_given_NK21,
   AdmsSensFadType & modelPar_PK21,
   bool modelPar_given_PK21,
   AdmsSensFadType & modelPar_LDVTB,
   bool modelPar_given_LDVTB,
   AdmsSensFadType & modelPar_NDVTB,
   bool modelPar_given_NDVTB,
   AdmsSensFadType & modelPar_PDVTB,
   bool modelPar_given_PDVTB,
   AdmsSensFadType & modelPar_LLPEB,
   bool modelPar_given_LLPEB,
   AdmsSensFadType & modelPar_NLPEB,
   bool modelPar_given_NLPEB,
   AdmsSensFadType & modelPar_PLPEB,
   bool modelPar_given_PLPEB,
   AdmsSensFadType & modelPar_LQMFACTOR,
   bool modelPar_given_LQMFACTOR,
   AdmsSensFadType & modelPar_NQMFACTOR,
   bool modelPar_given_NQMFACTOR,
   AdmsSensFadType & modelPar_PQMFACTOR,
   bool modelPar_given_PQMFACTOR,
   AdmsSensFadType & modelPar_LQMTCENCV,
   bool modelPar_given_LQMTCENCV,
   AdmsSensFadType & modelPar_NQMTCENCV,
   bool modelPar_given_NQMTCENCV,
   AdmsSensFadType & modelPar_PQMTCENCV,
   bool modelPar_given_PQMTCENCV,
   AdmsSensFadType & modelPar_LQMTCENCVA,
   bool modelPar_given_LQMTCENCVA,
   AdmsSensFadType & modelPar_NQMTCENCVA,
   bool modelPar_given_NQMTCENCVA,
   AdmsSensFadType & modelPar_PQMTCENCVA,
   bool modelPar_given_PQMTCENCVA,
   AdmsSensFadType & modelPar_LVSAT,
   bool modelPar_given_LVSAT,
   AdmsSensFadType & modelPar_NVSAT,
   bool modelPar_given_NVSAT,
   AdmsSensFadType & modelPar_PVSAT,
   bool modelPar_given_PVSAT,
   AdmsSensFadType & modelPar_LVSATR,
   bool modelPar_given_LVSATR,
   AdmsSensFadType & modelPar_NVSATR,
   bool modelPar_given_NVSATR,
   AdmsSensFadType & modelPar_PVSATR,
   bool modelPar_given_PVSATR,
   AdmsSensFadType & modelPar_LVSAT1,
   bool modelPar_given_LVSAT1,
   AdmsSensFadType & modelPar_NVSAT1,
   bool modelPar_given_NVSAT1,
   AdmsSensFadType & modelPar_PVSAT1,
   bool modelPar_given_PVSAT1,
   AdmsSensFadType & modelPar_LVSAT1R,
   bool modelPar_given_LVSAT1R,
   AdmsSensFadType & modelPar_NVSAT1R,
   bool modelPar_given_NVSAT1R,
   AdmsSensFadType & modelPar_PVSAT1R,
   bool modelPar_given_PVSAT1R,
   AdmsSensFadType & modelPar_LPSAT,
   bool modelPar_given_LPSAT,
   AdmsSensFadType & modelPar_NPSAT,
   bool modelPar_given_NPSAT,
   AdmsSensFadType & modelPar_PPSAT,
   bool modelPar_given_PPSAT,
   AdmsSensFadType & modelPar_LDELTAVSAT,
   bool modelPar_given_LDELTAVSAT,
   AdmsSensFadType & modelPar_NDELTAVSAT,
   bool modelPar_given_NDELTAVSAT,
   AdmsSensFadType & modelPar_PDELTAVSAT,
   bool modelPar_given_PDELTAVSAT,
   AdmsSensFadType & modelPar_LKSATIV,
   bool modelPar_given_LKSATIV,
   AdmsSensFadType & modelPar_NKSATIV,
   bool modelPar_given_NKSATIV,
   AdmsSensFadType & modelPar_PKSATIV,
   bool modelPar_given_PKSATIV,
   AdmsSensFadType & modelPar_LKSATIVR,
   bool modelPar_given_LKSATIVR,
   AdmsSensFadType & modelPar_NKSATIVR,
   bool modelPar_given_NKSATIVR,
   AdmsSensFadType & modelPar_PKSATIVR,
   bool modelPar_given_PKSATIVR,
   AdmsSensFadType & modelPar_LVSATCV,
   bool modelPar_given_LVSATCV,
   AdmsSensFadType & modelPar_NVSATCV,
   bool modelPar_given_NVSATCV,
   AdmsSensFadType & modelPar_PVSATCV,
   bool modelPar_given_PVSATCV,
   AdmsSensFadType & modelPar_LPSATCV,
   bool modelPar_given_LPSATCV,
   AdmsSensFadType & modelPar_NPSATCV,
   bool modelPar_given_NPSATCV,
   AdmsSensFadType & modelPar_PPSATCV,
   bool modelPar_given_PPSATCV,
   AdmsSensFadType & modelPar_LDELTAVSATCV,
   bool modelPar_given_LDELTAVSATCV,
   AdmsSensFadType & modelPar_NDELTAVSATCV,
   bool modelPar_given_NDELTAVSATCV,
   AdmsSensFadType & modelPar_PDELTAVSATCV,
   bool modelPar_given_PDELTAVSATCV,
   AdmsSensFadType & modelPar_LMEXP,
   bool modelPar_given_LMEXP,
   AdmsSensFadType & modelPar_NMEXP,
   bool modelPar_given_NMEXP,
   AdmsSensFadType & modelPar_PMEXP,
   bool modelPar_given_PMEXP,
   AdmsSensFadType & modelPar_LMEXPR,
   bool modelPar_given_LMEXPR,
   AdmsSensFadType & modelPar_NMEXPR,
   bool modelPar_given_NMEXPR,
   AdmsSensFadType & modelPar_PMEXPR,
   bool modelPar_given_PMEXPR,
   AdmsSensFadType & modelPar_LPTWG,
   bool modelPar_given_LPTWG,
   AdmsSensFadType & modelPar_NPTWG,
   bool modelPar_given_NPTWG,
   AdmsSensFadType & modelPar_PPTWG,
   bool modelPar_given_PPTWG,
   AdmsSensFadType & modelPar_LPTWGR,
   bool modelPar_given_LPTWGR,
   AdmsSensFadType & modelPar_NPTWGR,
   bool modelPar_given_NPTWGR,
   AdmsSensFadType & modelPar_PPTWGR,
   bool modelPar_given_PPTWGR,
   AdmsSensFadType & modelPar_LU0,
   bool modelPar_given_LU0,
   AdmsSensFadType & modelPar_NU0,
   bool modelPar_given_NU0,
   AdmsSensFadType & modelPar_PU0,
   bool modelPar_given_PU0,
   AdmsSensFadType & modelPar_LU0R,
   bool modelPar_given_LU0R,
   AdmsSensFadType & modelPar_NU0R,
   bool modelPar_given_NU0R,
   AdmsSensFadType & modelPar_PU0R,
   bool modelPar_given_PU0R,
   AdmsSensFadType & modelPar_LETAMOB,
   bool modelPar_given_LETAMOB,
   AdmsSensFadType & modelPar_NETAMOB,
   bool modelPar_given_NETAMOB,
   AdmsSensFadType & modelPar_PETAMOB,
   bool modelPar_given_PETAMOB,
   AdmsSensFadType & modelPar_LUP,
   bool modelPar_given_LUP,
   AdmsSensFadType & modelPar_NUP,
   bool modelPar_given_NUP,
   AdmsSensFadType & modelPar_PUP,
   bool modelPar_given_PUP,
   AdmsSensFadType & modelPar_LUPR,
   bool modelPar_given_LUPR,
   AdmsSensFadType & modelPar_NUPR,
   bool modelPar_given_NUPR,
   AdmsSensFadType & modelPar_PUPR,
   bool modelPar_given_PUPR,
   AdmsSensFadType & modelPar_LUA,
   bool modelPar_given_LUA,
   AdmsSensFadType & modelPar_NUA,
   bool modelPar_given_NUA,
   AdmsSensFadType & modelPar_PUA,
   bool modelPar_given_PUA,
   AdmsSensFadType & modelPar_LUAR,
   bool modelPar_given_LUAR,
   AdmsSensFadType & modelPar_NUAR,
   bool modelPar_given_NUAR,
   AdmsSensFadType & modelPar_PUAR,
   bool modelPar_given_PUAR,
   AdmsSensFadType & modelPar_LUC,
   bool modelPar_given_LUC,
   AdmsSensFadType & modelPar_NUC,
   bool modelPar_given_NUC,
   AdmsSensFadType & modelPar_PUC,
   bool modelPar_given_PUC,
   AdmsSensFadType & modelPar_LUCR,
   bool modelPar_given_LUCR,
   AdmsSensFadType & modelPar_NUCR,
   bool modelPar_given_NUCR,
   AdmsSensFadType & modelPar_PUCR,
   bool modelPar_given_PUCR,
   AdmsSensFadType & modelPar_LEU,
   bool modelPar_given_LEU,
   AdmsSensFadType & modelPar_NEU,
   bool modelPar_given_NEU,
   AdmsSensFadType & modelPar_PEU,
   bool modelPar_given_PEU,
   AdmsSensFadType & modelPar_LEUR,
   bool modelPar_given_LEUR,
   AdmsSensFadType & modelPar_NEUR,
   bool modelPar_given_NEUR,
   AdmsSensFadType & modelPar_PEUR,
   bool modelPar_given_PEUR,
   AdmsSensFadType & modelPar_LUD,
   bool modelPar_given_LUD,
   AdmsSensFadType & modelPar_NUD,
   bool modelPar_given_NUD,
   AdmsSensFadType & modelPar_PUD,
   bool modelPar_given_PUD,
   AdmsSensFadType & modelPar_LUDR,
   bool modelPar_given_LUDR,
   AdmsSensFadType & modelPar_NUDR,
   bool modelPar_given_NUDR,
   AdmsSensFadType & modelPar_PUDR,
   bool modelPar_given_PUDR,
   AdmsSensFadType & modelPar_LUCS,
   bool modelPar_given_LUCS,
   AdmsSensFadType & modelPar_NUCS,
   bool modelPar_given_NUCS,
   AdmsSensFadType & modelPar_PUCS,
   bool modelPar_given_PUCS,
   AdmsSensFadType & modelPar_LPCLM,
   bool modelPar_given_LPCLM,
   AdmsSensFadType & modelPar_NPCLM,
   bool modelPar_given_NPCLM,
   AdmsSensFadType & modelPar_PPCLM,
   bool modelPar_given_PPCLM,
   AdmsSensFadType & modelPar_LPCLMR,
   bool modelPar_given_LPCLMR,
   AdmsSensFadType & modelPar_NPCLMR,
   bool modelPar_given_NPCLMR,
   AdmsSensFadType & modelPar_PPCLMR,
   bool modelPar_given_PPCLMR,
   AdmsSensFadType & modelPar_LPCLMG,
   bool modelPar_given_LPCLMG,
   AdmsSensFadType & modelPar_NPCLMG,
   bool modelPar_given_NPCLMG,
   AdmsSensFadType & modelPar_PPCLMG,
   bool modelPar_given_PPCLMG,
   AdmsSensFadType & modelPar_LPCLMCV,
   bool modelPar_given_LPCLMCV,
   AdmsSensFadType & modelPar_NPCLMCV,
   bool modelPar_given_NPCLMCV,
   AdmsSensFadType & modelPar_PPCLMCV,
   bool modelPar_given_PPCLMCV,
   AdmsSensFadType & modelPar_LA1,
   bool modelPar_given_LA1,
   AdmsSensFadType & modelPar_NA1,
   bool modelPar_given_NA1,
   AdmsSensFadType & modelPar_PA1,
   bool modelPar_given_PA1,
   AdmsSensFadType & modelPar_LA11,
   bool modelPar_given_LA11,
   AdmsSensFadType & modelPar_NA11,
   bool modelPar_given_NA11,
   AdmsSensFadType & modelPar_PA11,
   bool modelPar_given_PA11,
   AdmsSensFadType & modelPar_LA2,
   bool modelPar_given_LA2,
   AdmsSensFadType & modelPar_NA2,
   bool modelPar_given_NA2,
   AdmsSensFadType & modelPar_PA2,
   bool modelPar_given_PA2,
   AdmsSensFadType & modelPar_LA21,
   bool modelPar_given_LA21,
   AdmsSensFadType & modelPar_NA21,
   bool modelPar_given_NA21,
   AdmsSensFadType & modelPar_PA21,
   bool modelPar_given_PA21,
   AdmsSensFadType & modelPar_LRDSW,
   bool modelPar_given_LRDSW,
   AdmsSensFadType & modelPar_NRDSW,
   bool modelPar_given_NRDSW,
   AdmsSensFadType & modelPar_PRDSW,
   bool modelPar_given_PRDSW,
   AdmsSensFadType & modelPar_LRSW,
   bool modelPar_given_LRSW,
   AdmsSensFadType & modelPar_NRSW,
   bool modelPar_given_NRSW,
   AdmsSensFadType & modelPar_PRSW,
   bool modelPar_given_PRSW,
   AdmsSensFadType & modelPar_LRDW,
   bool modelPar_given_LRDW,
   AdmsSensFadType & modelPar_NRDW,
   bool modelPar_given_NRDW,
   AdmsSensFadType & modelPar_PRDW,
   bool modelPar_given_PRDW,
   AdmsSensFadType & modelPar_LPRWGS,
   bool modelPar_given_LPRWGS,
   AdmsSensFadType & modelPar_NPRWGS,
   bool modelPar_given_NPRWGS,
   AdmsSensFadType & modelPar_PPRWGS,
   bool modelPar_given_PPRWGS,
   AdmsSensFadType & modelPar_LPRWGD,
   bool modelPar_given_LPRWGD,
   AdmsSensFadType & modelPar_NPRWGD,
   bool modelPar_given_NPRWGD,
   AdmsSensFadType & modelPar_PPRWGD,
   bool modelPar_given_PPRWGD,
   AdmsSensFadType & modelPar_LWR,
   bool modelPar_given_LWR,
   AdmsSensFadType & modelPar_NWR,
   bool modelPar_given_NWR,
   AdmsSensFadType & modelPar_PWR,
   bool modelPar_given_PWR,
   AdmsSensFadType & modelPar_LPDIBL1,
   bool modelPar_given_LPDIBL1,
   AdmsSensFadType & modelPar_NPDIBL1,
   bool modelPar_given_NPDIBL1,
   AdmsSensFadType & modelPar_PPDIBL1,
   bool modelPar_given_PPDIBL1,
   AdmsSensFadType & modelPar_LPDIBL1R,
   bool modelPar_given_LPDIBL1R,
   AdmsSensFadType & modelPar_NPDIBL1R,
   bool modelPar_given_NPDIBL1R,
   AdmsSensFadType & modelPar_PPDIBL1R,
   bool modelPar_given_PPDIBL1R,
   AdmsSensFadType & modelPar_LPDIBL2,
   bool modelPar_given_LPDIBL2,
   AdmsSensFadType & modelPar_NPDIBL2,
   bool modelPar_given_NPDIBL2,
   AdmsSensFadType & modelPar_PPDIBL2,
   bool modelPar_given_PPDIBL2,
   AdmsSensFadType & modelPar_LPDIBL2R,
   bool modelPar_given_LPDIBL2R,
   AdmsSensFadType & modelPar_NPDIBL2R,
   bool modelPar_given_NPDIBL2R,
   AdmsSensFadType & modelPar_PPDIBL2R,
   bool modelPar_given_PPDIBL2R,
   AdmsSensFadType & modelPar_LDROUT,
   bool modelPar_given_LDROUT,
   AdmsSensFadType & modelPar_NDROUT,
   bool modelPar_given_NDROUT,
   AdmsSensFadType & modelPar_PDROUT,
   bool modelPar_given_PDROUT,
   AdmsSensFadType & modelPar_LPVAG,
   bool modelPar_given_LPVAG,
   AdmsSensFadType & modelPar_NPVAG,
   bool modelPar_given_NPVAG,
   AdmsSensFadType & modelPar_PPVAG,
   bool modelPar_given_PPVAG,
   AdmsSensFadType & modelPar_LAIGBINV,
   bool modelPar_given_LAIGBINV,
   AdmsSensFadType & modelPar_NAIGBINV,
   bool modelPar_given_NAIGBINV,
   AdmsSensFadType & modelPar_PAIGBINV,
   bool modelPar_given_PAIGBINV,
   AdmsSensFadType & modelPar_LAIGBINV1,
   bool modelPar_given_LAIGBINV1,
   AdmsSensFadType & modelPar_NAIGBINV1,
   bool modelPar_given_NAIGBINV1,
   AdmsSensFadType & modelPar_PAIGBINV1,
   bool modelPar_given_PAIGBINV1,
   AdmsSensFadType & modelPar_LBIGBINV,
   bool modelPar_given_LBIGBINV,
   AdmsSensFadType & modelPar_NBIGBINV,
   bool modelPar_given_NBIGBINV,
   AdmsSensFadType & modelPar_PBIGBINV,
   bool modelPar_given_PBIGBINV,
   AdmsSensFadType & modelPar_LCIGBINV,
   bool modelPar_given_LCIGBINV,
   AdmsSensFadType & modelPar_NCIGBINV,
   bool modelPar_given_NCIGBINV,
   AdmsSensFadType & modelPar_PCIGBINV,
   bool modelPar_given_PCIGBINV,
   AdmsSensFadType & modelPar_LEIGBINV,
   bool modelPar_given_LEIGBINV,
   AdmsSensFadType & modelPar_NEIGBINV,
   bool modelPar_given_NEIGBINV,
   AdmsSensFadType & modelPar_PEIGBINV,
   bool modelPar_given_PEIGBINV,
   AdmsSensFadType & modelPar_LNIGBINV,
   bool modelPar_given_LNIGBINV,
   AdmsSensFadType & modelPar_NNIGBINV,
   bool modelPar_given_NNIGBINV,
   AdmsSensFadType & modelPar_PNIGBINV,
   bool modelPar_given_PNIGBINV,
   AdmsSensFadType & modelPar_LAIGBACC,
   bool modelPar_given_LAIGBACC,
   AdmsSensFadType & modelPar_NAIGBACC,
   bool modelPar_given_NAIGBACC,
   AdmsSensFadType & modelPar_PAIGBACC,
   bool modelPar_given_PAIGBACC,
   AdmsSensFadType & modelPar_LAIGBACC1,
   bool modelPar_given_LAIGBACC1,
   AdmsSensFadType & modelPar_NAIGBACC1,
   bool modelPar_given_NAIGBACC1,
   AdmsSensFadType & modelPar_PAIGBACC1,
   bool modelPar_given_PAIGBACC1,
   AdmsSensFadType & modelPar_LBIGBACC,
   bool modelPar_given_LBIGBACC,
   AdmsSensFadType & modelPar_NBIGBACC,
   bool modelPar_given_NBIGBACC,
   AdmsSensFadType & modelPar_PBIGBACC,
   bool modelPar_given_PBIGBACC,
   AdmsSensFadType & modelPar_LCIGBACC,
   bool modelPar_given_LCIGBACC,
   AdmsSensFadType & modelPar_NCIGBACC,
   bool modelPar_given_NCIGBACC,
   AdmsSensFadType & modelPar_PCIGBACC,
   bool modelPar_given_PCIGBACC,
   AdmsSensFadType & modelPar_LNIGBACC,
   bool modelPar_given_LNIGBACC,
   AdmsSensFadType & modelPar_NNIGBACC,
   bool modelPar_given_NNIGBACC,
   AdmsSensFadType & modelPar_PNIGBACC,
   bool modelPar_given_PNIGBACC,
   AdmsSensFadType & modelPar_LAIGC,
   bool modelPar_given_LAIGC,
   AdmsSensFadType & modelPar_NAIGC,
   bool modelPar_given_NAIGC,
   AdmsSensFadType & modelPar_PAIGC,
   bool modelPar_given_PAIGC,
   AdmsSensFadType & modelPar_LAIGC1,
   bool modelPar_given_LAIGC1,
   AdmsSensFadType & modelPar_NAIGC1,
   bool modelPar_given_NAIGC1,
   AdmsSensFadType & modelPar_PAIGC1,
   bool modelPar_given_PAIGC1,
   AdmsSensFadType & modelPar_LBIGC,
   bool modelPar_given_LBIGC,
   AdmsSensFadType & modelPar_NBIGC,
   bool modelPar_given_NBIGC,
   AdmsSensFadType & modelPar_PBIGC,
   bool modelPar_given_PBIGC,
   AdmsSensFadType & modelPar_LCIGC,
   bool modelPar_given_LCIGC,
   AdmsSensFadType & modelPar_NCIGC,
   bool modelPar_given_NCIGC,
   AdmsSensFadType & modelPar_PCIGC,
   bool modelPar_given_PCIGC,
   AdmsSensFadType & modelPar_LPIGCD,
   bool modelPar_given_LPIGCD,
   AdmsSensFadType & modelPar_NPIGCD,
   bool modelPar_given_NPIGCD,
   AdmsSensFadType & modelPar_PPIGCD,
   bool modelPar_given_PPIGCD,
   AdmsSensFadType & modelPar_LAIGS,
   bool modelPar_given_LAIGS,
   AdmsSensFadType & modelPar_NAIGS,
   bool modelPar_given_NAIGS,
   AdmsSensFadType & modelPar_PAIGS,
   bool modelPar_given_PAIGS,
   AdmsSensFadType & modelPar_LAIGS1,
   bool modelPar_given_LAIGS1,
   AdmsSensFadType & modelPar_NAIGS1,
   bool modelPar_given_NAIGS1,
   AdmsSensFadType & modelPar_PAIGS1,
   bool modelPar_given_PAIGS1,
   AdmsSensFadType & modelPar_LBIGS,
   bool modelPar_given_LBIGS,
   AdmsSensFadType & modelPar_NBIGS,
   bool modelPar_given_NBIGS,
   AdmsSensFadType & modelPar_PBIGS,
   bool modelPar_given_PBIGS,
   AdmsSensFadType & modelPar_LCIGS,
   bool modelPar_given_LCIGS,
   AdmsSensFadType & modelPar_NCIGS,
   bool modelPar_given_NCIGS,
   AdmsSensFadType & modelPar_PCIGS,
   bool modelPar_given_PCIGS,
   AdmsSensFadType & modelPar_LAIGD,
   bool modelPar_given_LAIGD,
   AdmsSensFadType & modelPar_NAIGD,
   bool modelPar_given_NAIGD,
   AdmsSensFadType & modelPar_PAIGD,
   bool modelPar_given_PAIGD,
   AdmsSensFadType & modelPar_LAIGD1,
   bool modelPar_given_LAIGD1,
   AdmsSensFadType & modelPar_NAIGD1,
   bool modelPar_given_NAIGD1,
   AdmsSensFadType & modelPar_PAIGD1,
   bool modelPar_given_PAIGD1,
   AdmsSensFadType & modelPar_LBIGD,
   bool modelPar_given_LBIGD,
   AdmsSensFadType & modelPar_NBIGD,
   bool modelPar_given_NBIGD,
   AdmsSensFadType & modelPar_PBIGD,
   bool modelPar_given_PBIGD,
   AdmsSensFadType & modelPar_LCIGD,
   bool modelPar_given_LCIGD,
   AdmsSensFadType & modelPar_NCIGD,
   bool modelPar_given_NCIGD,
   AdmsSensFadType & modelPar_PCIGD,
   bool modelPar_given_PCIGD,
   AdmsSensFadType & modelPar_LNTOX,
   bool modelPar_given_LNTOX,
   AdmsSensFadType & modelPar_NNTOX,
   bool modelPar_given_NNTOX,
   AdmsSensFadType & modelPar_PNTOX,
   bool modelPar_given_PNTOX,
   AdmsSensFadType & modelPar_LPOXEDGE,
   bool modelPar_given_LPOXEDGE,
   AdmsSensFadType & modelPar_NPOXEDGE,
   bool modelPar_given_NPOXEDGE,
   AdmsSensFadType & modelPar_PPOXEDGE,
   bool modelPar_given_PPOXEDGE,
   AdmsSensFadType & modelPar_LAGISL,
   bool modelPar_given_LAGISL,
   AdmsSensFadType & modelPar_NAGISL,
   bool modelPar_given_NAGISL,
   AdmsSensFadType & modelPar_PAGISL,
   bool modelPar_given_PAGISL,
   AdmsSensFadType & modelPar_LBGISL,
   bool modelPar_given_LBGISL,
   AdmsSensFadType & modelPar_NBGISL,
   bool modelPar_given_NBGISL,
   AdmsSensFadType & modelPar_PBGISL,
   bool modelPar_given_PBGISL,
   AdmsSensFadType & modelPar_LCGISL,
   bool modelPar_given_LCGISL,
   AdmsSensFadType & modelPar_NCGISL,
   bool modelPar_given_NCGISL,
   AdmsSensFadType & modelPar_PCGISL,
   bool modelPar_given_PCGISL,
   AdmsSensFadType & modelPar_LEGISL,
   bool modelPar_given_LEGISL,
   AdmsSensFadType & modelPar_NEGISL,
   bool modelPar_given_NEGISL,
   AdmsSensFadType & modelPar_PEGISL,
   bool modelPar_given_PEGISL,
   AdmsSensFadType & modelPar_LPGISL,
   bool modelPar_given_LPGISL,
   AdmsSensFadType & modelPar_NPGISL,
   bool modelPar_given_NPGISL,
   AdmsSensFadType & modelPar_PPGISL,
   bool modelPar_given_PPGISL,
   AdmsSensFadType & modelPar_LAGIDL,
   bool modelPar_given_LAGIDL,
   AdmsSensFadType & modelPar_NAGIDL,
   bool modelPar_given_NAGIDL,
   AdmsSensFadType & modelPar_PAGIDL,
   bool modelPar_given_PAGIDL,
   AdmsSensFadType & modelPar_LBGIDL,
   bool modelPar_given_LBGIDL,
   AdmsSensFadType & modelPar_NBGIDL,
   bool modelPar_given_NBGIDL,
   AdmsSensFadType & modelPar_PBGIDL,
   bool modelPar_given_PBGIDL,
   AdmsSensFadType & modelPar_LCGIDL,
   bool modelPar_given_LCGIDL,
   AdmsSensFadType & modelPar_NCGIDL,
   bool modelPar_given_NCGIDL,
   AdmsSensFadType & modelPar_PCGIDL,
   bool modelPar_given_PCGIDL,
   AdmsSensFadType & modelPar_LEGIDL,
   bool modelPar_given_LEGIDL,
   AdmsSensFadType & modelPar_NEGIDL,
   bool modelPar_given_NEGIDL,
   AdmsSensFadType & modelPar_PEGIDL,
   bool modelPar_given_PEGIDL,
   AdmsSensFadType & modelPar_LPGIDL,
   bool modelPar_given_LPGIDL,
   AdmsSensFadType & modelPar_NPGIDL,
   bool modelPar_given_NPGIDL,
   AdmsSensFadType & modelPar_PPGIDL,
   bool modelPar_given_PPGIDL,
   AdmsSensFadType & modelPar_LALPHA0,
   bool modelPar_given_LALPHA0,
   AdmsSensFadType & modelPar_NALPHA0,
   bool modelPar_given_NALPHA0,
   AdmsSensFadType & modelPar_PALPHA0,
   bool modelPar_given_PALPHA0,
   AdmsSensFadType & modelPar_LALPHA1,
   bool modelPar_given_LALPHA1,
   AdmsSensFadType & modelPar_NALPHA1,
   bool modelPar_given_NALPHA1,
   AdmsSensFadType & modelPar_PALPHA1,
   bool modelPar_given_PALPHA1,
   AdmsSensFadType & modelPar_LALPHAII0,
   bool modelPar_given_LALPHAII0,
   AdmsSensFadType & modelPar_NALPHAII0,
   bool modelPar_given_NALPHAII0,
   AdmsSensFadType & modelPar_PALPHAII0,
   bool modelPar_given_PALPHAII0,
   AdmsSensFadType & modelPar_LALPHAII1,
   bool modelPar_given_LALPHAII1,
   AdmsSensFadType & modelPar_NALPHAII1,
   bool modelPar_given_NALPHAII1,
   AdmsSensFadType & modelPar_PALPHAII1,
   bool modelPar_given_PALPHAII1,
   AdmsSensFadType & modelPar_LBETA0,
   bool modelPar_given_LBETA0,
   AdmsSensFadType & modelPar_NBETA0,
   bool modelPar_given_NBETA0,
   AdmsSensFadType & modelPar_PBETA0,
   bool modelPar_given_PBETA0,
   AdmsSensFadType & modelPar_LBETAII0,
   bool modelPar_given_LBETAII0,
   AdmsSensFadType & modelPar_NBETAII0,
   bool modelPar_given_NBETAII0,
   AdmsSensFadType & modelPar_PBETAII0,
   bool modelPar_given_PBETAII0,
   AdmsSensFadType & modelPar_LBETAII1,
   bool modelPar_given_LBETAII1,
   AdmsSensFadType & modelPar_NBETAII1,
   bool modelPar_given_NBETAII1,
   AdmsSensFadType & modelPar_PBETAII1,
   bool modelPar_given_PBETAII1,
   AdmsSensFadType & modelPar_LBETAII2,
   bool modelPar_given_LBETAII2,
   AdmsSensFadType & modelPar_NBETAII2,
   bool modelPar_given_NBETAII2,
   AdmsSensFadType & modelPar_PBETAII2,
   bool modelPar_given_PBETAII2,
   AdmsSensFadType & modelPar_LESATII,
   bool modelPar_given_LESATII,
   AdmsSensFadType & modelPar_NESATII,
   bool modelPar_given_NESATII,
   AdmsSensFadType & modelPar_PESATII,
   bool modelPar_given_PESATII,
   AdmsSensFadType & modelPar_LLII,
   bool modelPar_given_LLII,
   AdmsSensFadType & modelPar_NLII,
   bool modelPar_given_NLII,
   AdmsSensFadType & modelPar_PLII,
   bool modelPar_given_PLII,
   AdmsSensFadType & modelPar_LSII0,
   bool modelPar_given_LSII0,
   AdmsSensFadType & modelPar_NSII0,
   bool modelPar_given_NSII0,
   AdmsSensFadType & modelPar_PSII0,
   bool modelPar_given_PSII0,
   AdmsSensFadType & modelPar_LSII1,
   bool modelPar_given_LSII1,
   AdmsSensFadType & modelPar_NSII1,
   bool modelPar_given_NSII1,
   AdmsSensFadType & modelPar_PSII1,
   bool modelPar_given_PSII1,
   AdmsSensFadType & modelPar_LSII2,
   bool modelPar_given_LSII2,
   AdmsSensFadType & modelPar_NSII2,
   bool modelPar_given_NSII2,
   AdmsSensFadType & modelPar_PSII2,
   bool modelPar_given_PSII2,
   AdmsSensFadType & modelPar_LSIID,
   bool modelPar_given_LSIID,
   AdmsSensFadType & modelPar_NSIID,
   bool modelPar_given_NSIID,
   AdmsSensFadType & modelPar_PSIID,
   bool modelPar_given_PSIID,
   AdmsSensFadType & modelPar_LCFS,
   bool modelPar_given_LCFS,
   AdmsSensFadType & modelPar_NCFS,
   bool modelPar_given_NCFS,
   AdmsSensFadType & modelPar_PCFS,
   bool modelPar_given_PCFS,
   AdmsSensFadType & modelPar_LCFD,
   bool modelPar_given_LCFD,
   AdmsSensFadType & modelPar_NCFD,
   bool modelPar_given_NCFD,
   AdmsSensFadType & modelPar_PCFD,
   bool modelPar_given_PCFD,
   AdmsSensFadType & modelPar_LCOVS,
   bool modelPar_given_LCOVS,
   AdmsSensFadType & modelPar_NCOVS,
   bool modelPar_given_NCOVS,
   AdmsSensFadType & modelPar_PCOVS,
   bool modelPar_given_PCOVS,
   AdmsSensFadType & modelPar_LCOVD,
   bool modelPar_given_LCOVD,
   AdmsSensFadType & modelPar_NCOVD,
   bool modelPar_given_NCOVD,
   AdmsSensFadType & modelPar_PCOVD,
   bool modelPar_given_PCOVD,
   AdmsSensFadType & modelPar_LCGSL,
   bool modelPar_given_LCGSL,
   AdmsSensFadType & modelPar_NCGSL,
   bool modelPar_given_NCGSL,
   AdmsSensFadType & modelPar_PCGSL,
   bool modelPar_given_PCGSL,
   AdmsSensFadType & modelPar_LCGDL,
   bool modelPar_given_LCGDL,
   AdmsSensFadType & modelPar_NCGDL,
   bool modelPar_given_NCGDL,
   AdmsSensFadType & modelPar_PCGDL,
   bool modelPar_given_PCGDL,
   AdmsSensFadType & modelPar_LCKAPPAS,
   bool modelPar_given_LCKAPPAS,
   AdmsSensFadType & modelPar_NCKAPPAS,
   bool modelPar_given_NCKAPPAS,
   AdmsSensFadType & modelPar_PCKAPPAS,
   bool modelPar_given_PCKAPPAS,
   AdmsSensFadType & modelPar_LCKAPPAD,
   bool modelPar_given_LCKAPPAD,
   AdmsSensFadType & modelPar_NCKAPPAD,
   bool modelPar_given_NCKAPPAD,
   AdmsSensFadType & modelPar_PCKAPPAD,
   bool modelPar_given_PCKAPPAD,
   AdmsSensFadType & modelPar_LCGBL,
   bool modelPar_given_LCGBL,
   AdmsSensFadType & modelPar_NCGBL,
   bool modelPar_given_NCGBL,
   AdmsSensFadType & modelPar_PCGBL,
   bool modelPar_given_PCGBL,
   AdmsSensFadType & modelPar_LCKAPPAB,
   bool modelPar_given_LCKAPPAB,
   AdmsSensFadType & modelPar_NCKAPPAB,
   bool modelPar_given_NCKAPPAB,
   AdmsSensFadType & modelPar_PCKAPPAB,
   bool modelPar_given_PCKAPPAB,
   AdmsSensFadType & modelPar_LNTGEN,
   bool modelPar_given_LNTGEN,
   AdmsSensFadType & modelPar_NNTGEN,
   bool modelPar_given_NNTGEN,
   AdmsSensFadType & modelPar_PNTGEN,
   bool modelPar_given_PNTGEN,
   AdmsSensFadType & modelPar_LAIGEN,
   bool modelPar_given_LAIGEN,
   AdmsSensFadType & modelPar_NAIGEN,
   bool modelPar_given_NAIGEN,
   AdmsSensFadType & modelPar_PAIGEN,
   bool modelPar_given_PAIGEN,
   AdmsSensFadType & modelPar_LBIGEN,
   bool modelPar_given_LBIGEN,
   AdmsSensFadType & modelPar_NBIGEN,
   bool modelPar_given_NBIGEN,
   AdmsSensFadType & modelPar_PBIGEN,
   bool modelPar_given_PBIGEN,
   AdmsSensFadType & modelPar_LXRCRG1,
   bool modelPar_given_LXRCRG1,
   AdmsSensFadType & modelPar_NXRCRG1,
   bool modelPar_given_NXRCRG1,
   AdmsSensFadType & modelPar_PXRCRG1,
   bool modelPar_given_PXRCRG1,
   AdmsSensFadType & modelPar_LXRCRG2,
   bool modelPar_given_LXRCRG2,
   AdmsSensFadType & modelPar_NXRCRG2,
   bool modelPar_given_NXRCRG2,
   AdmsSensFadType & modelPar_PXRCRG2,
   bool modelPar_given_PXRCRG2,
   AdmsSensFadType & modelPar_LUTE,
   bool modelPar_given_LUTE,
   AdmsSensFadType & modelPar_NUTE,
   bool modelPar_given_NUTE,
   AdmsSensFadType & modelPar_PUTE,
   bool modelPar_given_PUTE,
   AdmsSensFadType & modelPar_LUTER,
   bool modelPar_given_LUTER,
   AdmsSensFadType & modelPar_NUTER,
   bool modelPar_given_NUTER,
   AdmsSensFadType & modelPar_PUTER,
   bool modelPar_given_PUTER,
   AdmsSensFadType & modelPar_LUTL,
   bool modelPar_given_LUTL,
   AdmsSensFadType & modelPar_NUTL,
   bool modelPar_given_NUTL,
   AdmsSensFadType & modelPar_PUTL,
   bool modelPar_given_PUTL,
   AdmsSensFadType & modelPar_LUTLR,
   bool modelPar_given_LUTLR,
   AdmsSensFadType & modelPar_NUTLR,
   bool modelPar_given_NUTLR,
   AdmsSensFadType & modelPar_PUTLR,
   bool modelPar_given_PUTLR,
   AdmsSensFadType & modelPar_LEMOBT,
   bool modelPar_given_LEMOBT,
   AdmsSensFadType & modelPar_NEMOBT,
   bool modelPar_given_NEMOBT,
   AdmsSensFadType & modelPar_PEMOBT,
   bool modelPar_given_PEMOBT,
   AdmsSensFadType & modelPar_LUA1,
   bool modelPar_given_LUA1,
   AdmsSensFadType & modelPar_NUA1,
   bool modelPar_given_NUA1,
   AdmsSensFadType & modelPar_PUA1,
   bool modelPar_given_PUA1,
   AdmsSensFadType & modelPar_LUA1R,
   bool modelPar_given_LUA1R,
   AdmsSensFadType & modelPar_NUA1R,
   bool modelPar_given_NUA1R,
   AdmsSensFadType & modelPar_PUA1R,
   bool modelPar_given_PUA1R,
   AdmsSensFadType & modelPar_LUC1,
   bool modelPar_given_LUC1,
   AdmsSensFadType & modelPar_NUC1,
   bool modelPar_given_NUC1,
   AdmsSensFadType & modelPar_PUC1,
   bool modelPar_given_PUC1,
   AdmsSensFadType & modelPar_LUC1R,
   bool modelPar_given_LUC1R,
   AdmsSensFadType & modelPar_NUC1R,
   bool modelPar_given_NUC1R,
   AdmsSensFadType & modelPar_PUC1R,
   bool modelPar_given_PUC1R,
   AdmsSensFadType & modelPar_LUD1,
   bool modelPar_given_LUD1,
   AdmsSensFadType & modelPar_NUD1,
   bool modelPar_given_NUD1,
   AdmsSensFadType & modelPar_PUD1,
   bool modelPar_given_PUD1,
   AdmsSensFadType & modelPar_LUD1R,
   bool modelPar_given_LUD1R,
   AdmsSensFadType & modelPar_NUD1R,
   bool modelPar_given_NUD1R,
   AdmsSensFadType & modelPar_PUD1R,
   bool modelPar_given_PUD1R,
   AdmsSensFadType & modelPar_LUCSTE,
   bool modelPar_given_LUCSTE,
   AdmsSensFadType & modelPar_NUCSTE,
   bool modelPar_given_NUCSTE,
   AdmsSensFadType & modelPar_PUCSTE,
   bool modelPar_given_PUCSTE,
   AdmsSensFadType & modelPar_LPTWGT,
   bool modelPar_given_LPTWGT,
   AdmsSensFadType & modelPar_NPTWGT,
   bool modelPar_given_NPTWGT,
   AdmsSensFadType & modelPar_PPTWGT,
   bool modelPar_given_PPTWGT,
   AdmsSensFadType & modelPar_LAT,
   bool modelPar_given_LAT,
   AdmsSensFadType & modelPar_NAT,
   bool modelPar_given_NAT,
   AdmsSensFadType & modelPar_PAT,
   bool modelPar_given_PAT,
   AdmsSensFadType & modelPar_LATR,
   bool modelPar_given_LATR,
   AdmsSensFadType & modelPar_NATR,
   bool modelPar_given_NATR,
   AdmsSensFadType & modelPar_PATR,
   bool modelPar_given_PATR,
   AdmsSensFadType & modelPar_LATCV,
   bool modelPar_given_LATCV,
   AdmsSensFadType & modelPar_NATCV,
   bool modelPar_given_NATCV,
   AdmsSensFadType & modelPar_PATCV,
   bool modelPar_given_PATCV,
   AdmsSensFadType & modelPar_LSTTHETASAT,
   bool modelPar_given_LSTTHETASAT,
   AdmsSensFadType & modelPar_NSTTHETASAT,
   bool modelPar_given_NSTTHETASAT,
   AdmsSensFadType & modelPar_PSTTHETASAT,
   bool modelPar_given_PSTTHETASAT,
   AdmsSensFadType & modelPar_LPRT,
   bool modelPar_given_LPRT,
   AdmsSensFadType & modelPar_NPRT,
   bool modelPar_given_NPRT,
   AdmsSensFadType & modelPar_PPRT,
   bool modelPar_given_PPRT,
   AdmsSensFadType & modelPar_LKT1,
   bool modelPar_given_LKT1,
   AdmsSensFadType & modelPar_NKT1,
   bool modelPar_given_NKT1,
   AdmsSensFadType & modelPar_PKT1,
   bool modelPar_given_PKT1,
   AdmsSensFadType & modelPar_LTSS,
   bool modelPar_given_LTSS,
   AdmsSensFadType & modelPar_NTSS,
   bool modelPar_given_NTSS,
   AdmsSensFadType & modelPar_PTSS,
   bool modelPar_given_PTSS,
   AdmsSensFadType & modelPar_LIIT,
   bool modelPar_given_LIIT,
   AdmsSensFadType & modelPar_NIIT,
   bool modelPar_given_NIIT,
   AdmsSensFadType & modelPar_PIIT,
   bool modelPar_given_PIIT,
   AdmsSensFadType & modelPar_LTII,
   bool modelPar_given_LTII,
   AdmsSensFadType & modelPar_NTII,
   bool modelPar_given_NTII,
   AdmsSensFadType & modelPar_PTII,
   bool modelPar_given_PTII,
   AdmsSensFadType & modelPar_LTGIDL,
   bool modelPar_given_LTGIDL,
   AdmsSensFadType & modelPar_NTGIDL,
   bool modelPar_given_NTGIDL,
   AdmsSensFadType & modelPar_PTGIDL,
   bool modelPar_given_PTGIDL,
   AdmsSensFadType & modelPar_LIGT,
   bool modelPar_given_LIGT,
   AdmsSensFadType & modelPar_NIGT,
   bool modelPar_given_NIGT,
   AdmsSensFadType & modelPar_PIGT,
   bool modelPar_given_PIGT,
   // non-reals (including hidden)
   int modelPar_NF,
   bool modelPar_given_NF,
   int modelPar_NGCON,
   bool modelPar_given_NGCON,
   int modelPar_DEVTYPE,
   bool modelPar_given_DEVTYPE,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   int modelPar_BULKMOD,
   bool modelPar_given_BULKMOD,
   int modelPar_GEOMOD,
   bool modelPar_given_GEOMOD,
   int modelPar_CGEO1SW,
   bool modelPar_given_CGEO1SW,
   int modelPar_RDSMOD,
   bool modelPar_given_RDSMOD,
   int modelPar_ASYMMOD,
   bool modelPar_given_ASYMMOD,
   int modelPar_IGCMOD,
   bool modelPar_given_IGCMOD,
   int modelPar_IGBMOD,
   bool modelPar_given_IGBMOD,
   int modelPar_GIDLMOD,
   bool modelPar_given_GIDLMOD,
   int modelPar_IIMOD,
   bool modelPar_given_IIMOD,
   int modelPar_TNOIMOD,
   bool modelPar_given_TNOIMOD,
   int modelPar_NQSMOD,
   bool modelPar_given_NQSMOD,
   int modelPar_SHMOD,
   bool modelPar_given_SHMOD,
   int modelPar_TEMPMOD,
   bool modelPar_given_TEMPMOD,
   int modelPar_RGATEMOD,
   bool modelPar_given_RGATEMOD,
   int modelPar_RGEOMOD,
   bool modelPar_given_RGEOMOD,
   int modelPar_CGEOMOD,
   bool modelPar_given_CGEOMOD,
   int modelPar_SH_WARN,
   bool modelPar_given_SH_WARN,
   int modelPar_IGCLAMP,
   bool modelPar_given_IGCLAMP,
   int modelPar_SDTERM,
   bool modelPar_given_SDTERM,
   int modelPar_NSEG,
   bool modelPar_given_NSEG,
   double admsTemperature, double gmin, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_N_GND,
   const int admsProbeID_V_g_ge,
   const int admsProbeID_V_s_si,
   const int admsProbeID_V_d_di,
   const int admsProbeID_V_e_ge,
   const int admsProbeID_V_ge_d,
   const int admsProbeID_V_ge_s,
   const int admsProbeID_V_di_d,
   const int admsProbeID_V_si_s,
   const int admsProbeID_V_e_s,
   const int admsProbeID_V_d_s,
   const int admsProbeID_V_g_s,
   const int admsProbeID_V_ge_e,
   const int admsProbeID_V_e_di,
   const int admsProbeID_V_e_si,
   const int admsProbeID_V_ge_di,
   const int admsProbeID_V_di_si,
   const int admsProbeID_V_ge_si,
   const int admsProbeID_Temp_t_GND,
   // node constants
   const int admsNodeID_d,
   const int admsNodeID_g,
   const int admsNodeID_s,
   const int admsNodeID_e,
   const int admsNodeID_t,
   const int admsNodeID_si,
   const int admsNodeID_di,
   const int admsNodeID_ge,
   const int admsNodeID_N,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_L,
   bool instancePar_given_L,
   AdmsSensFadType & instancePar_D,
   bool instancePar_given_D,
   AdmsSensFadType & instancePar_TFIN,
   bool instancePar_given_TFIN,
   AdmsSensFadType & instancePar_FPITCH,
   bool instancePar_given_FPITCH,
   AdmsSensFadType & instancePar_NFIN,
   bool instancePar_given_NFIN,
   AdmsSensFadType & instancePar_ASEO,
   bool instancePar_given_ASEO,
   AdmsSensFadType & instancePar_ADEO,
   bool instancePar_given_ADEO,
   AdmsSensFadType & instancePar_PSEO,
   bool instancePar_given_PSEO,
   AdmsSensFadType & instancePar_PDEO,
   bool instancePar_given_PDEO,
   AdmsSensFadType & instancePar_ASEJ,
   bool instancePar_given_ASEJ,
   AdmsSensFadType & instancePar_ADEJ,
   bool instancePar_given_ADEJ,
   AdmsSensFadType & instancePar_PSEJ,
   bool instancePar_given_PSEJ,
   AdmsSensFadType & instancePar_PDEJ,
   bool instancePar_given_PDEJ,
   AdmsSensFadType & instancePar_COVS,
   bool instancePar_given_COVS,
   AdmsSensFadType & instancePar_COVD,
   bool instancePar_given_COVD,
   AdmsSensFadType & instancePar_CGSP,
   bool instancePar_given_CGSP,
   AdmsSensFadType & instancePar_CGDP,
   bool instancePar_given_CGDP,
   AdmsSensFadType & instancePar_CDSP,
   bool instancePar_given_CDSP,
   AdmsSensFadType & instancePar_NRS,
   bool instancePar_given_NRS,
   AdmsSensFadType & instancePar_NRD,
   bool instancePar_given_NRD,
   AdmsSensFadType & instancePar_LRSD,
   bool instancePar_given_LRSD,
   AdmsSensFadType & instancePar_NFINNOM,
   bool instancePar_given_NFINNOM,
   AdmsSensFadType & instancePar_m,
   bool instancePar_given_m,
   // non-reals(including hidden)
   int instancePar_NF,
   bool instancePar_given_NF,
   int instancePar_NGCON,
   bool instancePar_given_NGCON,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_NFINtotal,
   AdmsSensFadType & instanceVar_ids,
   AdmsSensFadType & instanceVar_sigvds,
   AdmsSensFadType & instanceVar_qd,
   AdmsSensFadType & instanceVar_qg,
   AdmsSensFadType & instanceVar_qs,
   AdmsSensFadType & instanceVar_qb,
   AdmsSensFadType & instanceVar_epssub,
   AdmsSensFadType & instanceVar_epsratio,
   AdmsSensFadType & instanceVar_Leff,
   AdmsSensFadType & instanceVar_LeffCV,
   AdmsSensFadType & instanceVar_LeffCV_acc,
   AdmsSensFadType & instanceVar_Weff0,
   AdmsSensFadType & instanceVar_WeffCV0,
   AdmsSensFadType & instanceVar_cox,
   AdmsSensFadType & instanceVar_nbody,
   AdmsSensFadType & instanceVar_T0,
   AdmsSensFadType & instanceVar_T1,
   AdmsSensFadType & instanceVar_T2,
   AdmsSensFadType & instanceVar_T3,
   AdmsSensFadType & instanceVar_Tnom,
   AdmsSensFadType & instanceVar_PTWGR_t,
   AdmsSensFadType & instanceVar_CJS_t,
   AdmsSensFadType & instanceVar_CJSWS_t,
   AdmsSensFadType & instanceVar_CJSWGD_t,
   AdmsSensFadType & instanceVar_CJD_t,
   AdmsSensFadType & instanceVar_CJSWD_t,
   AdmsSensFadType & instanceVar_CJSWGS_t,
   AdmsSensFadType & instanceVar_PBS_t,
   AdmsSensFadType & instanceVar_PBSWS_t,
   AdmsSensFadType & instanceVar_PBSWGS_t,
   AdmsSensFadType & instanceVar_PBD_t,
   AdmsSensFadType & instanceVar_PBSWD_t,
   AdmsSensFadType & instanceVar_PBSWGD_t,
   AdmsSensFadType & instanceVar_JSS_t,
   AdmsSensFadType & instanceVar_JSWS_t,
   AdmsSensFadType & instanceVar_JSWGS_t,
   AdmsSensFadType & instanceVar_JSD_t,
   AdmsSensFadType & instanceVar_JSWD_t,
   AdmsSensFadType & instanceVar_JSWGD_t,
   AdmsSensFadType & instanceVar_JTSS_t,
   AdmsSensFadType & instanceVar_JTSD_t,
   AdmsSensFadType & instanceVar_JTSSWS_t,
   AdmsSensFadType & instanceVar_JTSSWD_t,
   AdmsSensFadType & instanceVar_JTSSWGS_t,
   AdmsSensFadType & instanceVar_JTSSWGD_t,
   AdmsSensFadType & instanceVar_NJTS_t,
   AdmsSensFadType & instanceVar_NJTSD_t,
   AdmsSensFadType & instanceVar_NJTSSW_t,
   AdmsSensFadType & instanceVar_NJTSSWD_t,
   AdmsSensFadType & instanceVar_NJTSSWG_t,
   AdmsSensFadType & instanceVar_NJTSSWGD_t,
   AdmsSensFadType & instanceVar_q0,
   AdmsSensFadType & instanceVar_T11,
   AdmsSensFadType & instanceVar_T12,
   AdmsSensFadType & instanceVar_e0,
   AdmsSensFadType & instanceVar_e1,
   AdmsSensFadType & instanceVar_e2,
   AdmsSensFadType & instanceVar_scl,
   AdmsSensFadType & instanceVar_tmp,
   AdmsSensFadType & instanceVar_Theta_SCE,
   AdmsSensFadType & instanceVar_Theta_SW,
   AdmsSensFadType & instanceVar_Theta_DIBL,
   AdmsSensFadType & instanceVar_Theta_RSCE,
   AdmsSensFadType & instanceVar_Theta_DITS,
   AdmsSensFadType & instanceVar_veseff,
   AdmsSensFadType & instanceVar_Tcen0,
   AdmsSensFadType & instanceVar_Tcen,
   AdmsSensFadType & instanceVar_mx,
   AdmsSensFadType & instanceVar_mxprime,
   AdmsSensFadType & instanceVar_md,
   AdmsSensFadType & instanceVar_mdprime,
   AdmsSensFadType & instanceVar_gprime,
   AdmsSensFadType & instanceVar_gfactor,
   AdmsSensFadType & instanceVar_qis,
   AdmsSensFadType & instanceVar_qid,
   AdmsSensFadType & instanceVar_qbs,
   AdmsSensFadType & instanceVar_qba,
   AdmsSensFadType & instanceVar_u0r,
   AdmsSensFadType & instanceVar_UAR_t,
   AdmsSensFadType & instanceVar_UC_t,
   AdmsSensFadType & instanceVar_UCR_t,
   AdmsSensFadType & instanceVar_UDR_t,
   AdmsSensFadType & instanceVar_U0R_t,
   AdmsSensFadType & instanceVar_EeffFactor,
   AdmsSensFadType & instanceVar_Dr,
   AdmsSensFadType & instanceVar_WeffWRFactor,
   AdmsSensFadType & instanceVar_RSourceGeo,
   AdmsSensFadType & instanceVar_RDrainGeo,
   AdmsSensFadType & instanceVar_RDSWMIN_i,
   AdmsSensFadType & instanceVar_RDWMIN_i,
   AdmsSensFadType & instanceVar_RSWMIN_i,
   AdmsSensFadType & instanceVar_Rdrain,
   AdmsSensFadType & instanceVar_Rsource,
   AdmsSensFadType & instanceVar_Rdsi,
   AdmsSensFadType & instanceVar_RSDRR_t,
   AdmsSensFadType & instanceVar_RDDRR_t,
   AdmsSensFadType & instanceVar_VSAT1R_t,
   AdmsSensFadType & instanceVar_MEXPR_t,
   AdmsSensFadType & instanceVar_VSAT_a,
   AdmsSensFadType & instanceVar_Cfr_geo,
   AdmsSensFadType & instanceVar_ggeltd,
   AdmsSensFadType & instanceVar_igbinv,
   AdmsSensFadType & instanceVar_igsd_mult0,
   AdmsSensFadType & instanceVar_igbs,
   AdmsSensFadType & instanceVar_igbd,
   AdmsSensFadType & instanceVar_igbacc,
   AdmsSensFadType & instanceVar_igcs,
   AdmsSensFadType & instanceVar_igcd,
   AdmsSensFadType & instanceVar_igisl,
   AdmsSensFadType & instanceVar_igidl,
   AdmsSensFadType & instanceVar_igs,
   AdmsSensFadType & instanceVar_igd,
   AdmsSensFadType & instanceVar_Aechvb,
   AdmsSensFadType & instanceVar_Bechvb,
   AdmsSensFadType & instanceVar_Toxratio,
   AdmsSensFadType & instanceVar_Iii,
   AdmsSensFadType & instanceVar_cox_acc,
   AdmsSensFadType & instanceVar_qg_acc,
   AdmsSensFadType & instanceVar_qb_acc,
   AdmsSensFadType & instanceVar_qgs_fr,
   AdmsSensFadType & instanceVar_qgd_fr,
   AdmsSensFadType & instanceVar_qds_fr,
   AdmsSensFadType & instanceVar_qgs_parasitic,
   AdmsSensFadType & instanceVar_qgd_parasitic,
   AdmsSensFadType & instanceVar_Qes,
   AdmsSensFadType & instanceVar_Qed,
   AdmsSensFadType & instanceVar_Qeg,
   AdmsSensFadType & instanceVar_csbox,
   AdmsSensFadType & instanceVar_cdbox,
   AdmsSensFadType & instanceVar_cgbox,
   AdmsSensFadType & instanceVar_Ies,
   AdmsSensFadType & instanceVar_Ied,
   AdmsSensFadType & instanceVar_Czbs,
   AdmsSensFadType & instanceVar_Czbssw,
   AdmsSensFadType & instanceVar_Czbsswg,
   AdmsSensFadType & instanceVar_Czbd,
   AdmsSensFadType & instanceVar_Czbdsw,
   AdmsSensFadType & instanceVar_Czbdswg,
   AdmsSensFadType & instanceVar_Isbs,
   AdmsSensFadType & instanceVar_Isbd,
   AdmsSensFadType & instanceVar_Nvtms,
   AdmsSensFadType & instanceVar_Nvtmd,
   AdmsSensFadType & instanceVar_SslpRev,
   AdmsSensFadType & instanceVar_IVjsmRev,
   AdmsSensFadType & instanceVar_VjsmRev,
   AdmsSensFadType & instanceVar_SslpFwd,
   AdmsSensFadType & instanceVar_IVjsmFwd,
   AdmsSensFadType & instanceVar_VjsmFwd,
   AdmsSensFadType & instanceVar_XExpBVS,
   AdmsSensFadType & instanceVar_DslpRev,
   AdmsSensFadType & instanceVar_IVjdmRev,
   AdmsSensFadType & instanceVar_VjdmRev,
   AdmsSensFadType & instanceVar_DslpFwd,
   AdmsSensFadType & instanceVar_IVjdmFwd,
   AdmsSensFadType & instanceVar_VjdmFwd,
   AdmsSensFadType & instanceVar_XExpBVD,
   AdmsSensFadType & instanceVar_idsgen,
   AdmsSensFadType & instanceVar_LINTIGEN_i,
   AdmsSensFadType & instanceVar_LINTNOI_i,
   AdmsSensFadType & instanceVar_litl,
   AdmsSensFadType & instanceVar_FNPowerAt1Hz,
   AdmsSensFadType & instanceVar_NTNOI_i,
   AdmsSensFadType & instanceVar_Gtnoi,
   AdmsSensFadType & instanceVar_sid,
   AdmsSensFadType & instanceVar_gspr,
   AdmsSensFadType & instanceVar_gdpr,
   AdmsSensFadType & instanceVar_gamma,
   AdmsSensFadType & instanceVar_delta,
   AdmsSensFadType & instanceVar_ctnoi,
   AdmsSensFadType & instanceVar_C0,
   AdmsSensFadType & instanceVar_sf,
   AdmsSensFadType & instanceVar_gth,
   AdmsSensFadType & instanceVar_cth,
   AdmsSensFadType & instanceVar_PHIG_i,
   AdmsSensFadType & instanceVar_CFD_i,
   AdmsSensFadType & instanceVar_CFS_i,
   AdmsSensFadType & instanceVar_COVS_i,
   AdmsSensFadType & instanceVar_COVD_i,
   AdmsSensFadType & instanceVar_CGSO_i,
   AdmsSensFadType & instanceVar_CGDO_i,
   AdmsSensFadType & instanceVar_CGSL_i,
   AdmsSensFadType & instanceVar_CGDL_i,
   AdmsSensFadType & instanceVar_CGBL_i,
   AdmsSensFadType & instanceVar_CKAPPAS_i,
   AdmsSensFadType & instanceVar_CKAPPAD_i,
   AdmsSensFadType & instanceVar_CKAPPAB_i,
   AdmsSensFadType & instanceVar_QMFACTOR_i,
   AdmsSensFadType & instanceVar_QMTCENCV_i,
   AdmsSensFadType & instanceVar_QMTCENCVA_i,
   AdmsSensFadType & instanceVar_KSATIV_i,
   AdmsSensFadType & instanceVar_KSATIVR_i,
   AdmsSensFadType & instanceVar_CDSC_i,
   AdmsSensFadType & instanceVar_CDSCD_i,
   AdmsSensFadType & instanceVar_CDSCDR_i,
   AdmsSensFadType & instanceVar_CIT_i,
   AdmsSensFadType & instanceVar_DVT0_i,
   AdmsSensFadType & instanceVar_CITR_i,
   AdmsSensFadType & instanceVar_PHIN_i,
   AdmsSensFadType & instanceVar_ETA0_i,
   AdmsSensFadType & instanceVar_ETA0R_i,
   AdmsSensFadType & instanceVar_VSAT_i,
   AdmsSensFadType & instanceVar_VSATR_i,
   AdmsSensFadType & instanceVar_VSATR_t,
   AdmsSensFadType & instanceVar_DVTP0_i,
   AdmsSensFadType & instanceVar_DVTP1_i,
   AdmsSensFadType & instanceVar_K0_i,
   AdmsSensFadType & instanceVar_K01_i,
   AdmsSensFadType & instanceVar_K0SI_i,
   AdmsSensFadType & instanceVar_K0SI1_i,
   AdmsSensFadType & instanceVar_K2SI_i,
   AdmsSensFadType & instanceVar_K2SI1_i,
   AdmsSensFadType & instanceVar_PHIBE_i,
   AdmsSensFadType & instanceVar_K1_i,
   AdmsSensFadType & instanceVar_K11_i,
   AdmsSensFadType & instanceVar_K2SAT_i,
   AdmsSensFadType & instanceVar_K2SAT1_i,
   AdmsSensFadType & instanceVar_DELTAVSAT_i,
   AdmsSensFadType & instanceVar_PSAT_i,
   AdmsSensFadType & instanceVar_DELTAVSATCV_i,
   AdmsSensFadType & instanceVar_PSATCV_i,
   AdmsSensFadType & instanceVar_VSAT1_i,
   AdmsSensFadType & instanceVar_VSAT1R_i,
   AdmsSensFadType & instanceVar_PTWG_i,
   AdmsSensFadType & instanceVar_PTWGR_i,
   AdmsSensFadType & instanceVar_VSATCV_i,
   AdmsSensFadType & instanceVar_U0_i,
   AdmsSensFadType & instanceVar_U0R_i,
   AdmsSensFadType & instanceVar_ETAMOB_i,
   AdmsSensFadType & instanceVar_RDSW_i,
   AdmsSensFadType & instanceVar_PRWGS_i,
   AdmsSensFadType & instanceVar_PRWGD_i,
   AdmsSensFadType & instanceVar_PDIBL1_i,
   AdmsSensFadType & instanceVar_PDIBL1R_i,
   AdmsSensFadType & instanceVar_PDIBL2_i,
   AdmsSensFadType & instanceVar_PDIBL2R_i,
   AdmsSensFadType & instanceVar_DROUT_i,
   AdmsSensFadType & instanceVar_PVAG_i,
   AdmsSensFadType & instanceVar_AIGBINV_i,
   AdmsSensFadType & instanceVar_AIGBINV1_i,
   AdmsSensFadType & instanceVar_BIGBINV_i,
   AdmsSensFadType & instanceVar_CIGBINV_i,
   AdmsSensFadType & instanceVar_EIGBINV_i,
   AdmsSensFadType & instanceVar_NIGBINV_i,
   AdmsSensFadType & instanceVar_AIGBACC_i,
   AdmsSensFadType & instanceVar_AIGBACC1_i,
   AdmsSensFadType & instanceVar_BIGBACC_i,
   AdmsSensFadType & instanceVar_CIGBACC_i,
   AdmsSensFadType & instanceVar_NIGBACC_i,
   AdmsSensFadType & instanceVar_AIGC_i,
   AdmsSensFadType & instanceVar_AIGC1_i,
   AdmsSensFadType & instanceVar_BIGC_i,
   AdmsSensFadType & instanceVar_CIGC_i,
   AdmsSensFadType & instanceVar_PIGCD_i,
   AdmsSensFadType & instanceVar_AIGS_i,
   AdmsSensFadType & instanceVar_AIGS1_i,
   AdmsSensFadType & instanceVar_BIGS_i,
   AdmsSensFadType & instanceVar_CIGS_i,
   AdmsSensFadType & instanceVar_POXEDGE_i,
   AdmsSensFadType & instanceVar_AIGD_i,
   AdmsSensFadType & instanceVar_AIGD1_i,
   AdmsSensFadType & instanceVar_BIGD_i,
   AdmsSensFadType & instanceVar_CIGD_i,
   AdmsSensFadType & instanceVar_AGIDL_i,
   AdmsSensFadType & instanceVar_BGIDL_i,
   AdmsSensFadType & instanceVar_CGIDL_i,
   AdmsSensFadType & instanceVar_EGIDL_i,
   AdmsSensFadType & instanceVar_PGIDL_i,
   AdmsSensFadType & instanceVar_AGISL_i,
   AdmsSensFadType & instanceVar_BGISL_i,
   AdmsSensFadType & instanceVar_CGISL_i,
   AdmsSensFadType & instanceVar_EGISL_i,
   AdmsSensFadType & instanceVar_PGISL_i,
   AdmsSensFadType & instanceVar_ALPHA0_i,
   AdmsSensFadType & instanceVar_ALPHA1_i,
   AdmsSensFadType & instanceVar_ALPHAII0_i,
   AdmsSensFadType & instanceVar_ALPHAII1_i,
   AdmsSensFadType & instanceVar_BETA0_i,
   AdmsSensFadType & instanceVar_BETAII0_i,
   AdmsSensFadType & instanceVar_BETAII1_i,
   AdmsSensFadType & instanceVar_BETAII2_i,
   AdmsSensFadType & instanceVar_ESATII_i,
   AdmsSensFadType & instanceVar_LII_i,
   AdmsSensFadType & instanceVar_SII0_i,
   AdmsSensFadType & instanceVar_SII1_i,
   AdmsSensFadType & instanceVar_SII2_i,
   AdmsSensFadType & instanceVar_SIID_i,
   AdmsSensFadType & instanceVar_TII_i,
   AdmsSensFadType & instanceVar_MEXP_i,
   AdmsSensFadType & instanceVar_MEXPR_i,
   AdmsSensFadType & instanceVar_PCLM_i,
   AdmsSensFadType & instanceVar_PCLMG_i,
   AdmsSensFadType & instanceVar_PCLMCV_i,
   AdmsSensFadType & instanceVar_PCLMR_i,
   AdmsSensFadType & instanceVar_A1_i,
   AdmsSensFadType & instanceVar_A2_i,
   AdmsSensFadType & instanceVar_A11_i,
   AdmsSensFadType & instanceVar_A21_i,
   AdmsSensFadType & instanceVar_K1RSCE_i,
   AdmsSensFadType & instanceVar_DVTSHIFT_i,
   AdmsSensFadType & instanceVar_DVTSHIFTR_i,
   AdmsSensFadType & instanceVar_UA_i,
   AdmsSensFadType & instanceVar_UC_i,
   AdmsSensFadType & instanceVar_EU_i,
   AdmsSensFadType & instanceVar_UD_i,
   AdmsSensFadType & instanceVar_UCS_i,
   AdmsSensFadType & instanceVar_UAR_i,
   AdmsSensFadType & instanceVar_EUR_i,
   AdmsSensFadType & instanceVar_UCR_i,
   AdmsSensFadType & instanceVar_UDR_i,
   AdmsSensFadType & instanceVar_UA1_i,
   AdmsSensFadType & instanceVar_UA1R_i,
   AdmsSensFadType & instanceVar_UC1_i,
   AdmsSensFadType & instanceVar_UD1_i,
   AdmsSensFadType & instanceVar_UCSTE_i,
   AdmsSensFadType & instanceVar_UTE_i,
   AdmsSensFadType & instanceVar_UTL_i,
   AdmsSensFadType & instanceVar_EMOBT_i,
   AdmsSensFadType & instanceVar_UC1R_i,
   AdmsSensFadType & instanceVar_UD1R_i,
   AdmsSensFadType & instanceVar_UTER_i,
   AdmsSensFadType & instanceVar_UTLR_i,
   AdmsSensFadType & instanceVar_PTWGT_i,
   AdmsSensFadType & instanceVar_AT_i,
   AdmsSensFadType & instanceVar_ATCV_i,
   AdmsSensFadType & instanceVar_ATR_i,
   AdmsSensFadType & instanceVar_RDW_i,
   AdmsSensFadType & instanceVar_RSW_i,
   AdmsSensFadType & instanceVar_PRT_i,
   AdmsSensFadType & instanceVar_KT1_i,
   AdmsSensFadType & instanceVar_TSS_i,
   AdmsSensFadType & instanceVar_IIT_i,
   AdmsSensFadType & instanceVar_IGT_i,
   AdmsSensFadType & instanceVar_TGIDL_i,
   AdmsSensFadType & instanceVar_NTGEN_i,
   AdmsSensFadType & instanceVar_AIGEN_i,
   AdmsSensFadType & instanceVar_BIGEN_i,
   AdmsSensFadType & instanceVar_K0SISAT_i,
   AdmsSensFadType & instanceVar_K0SISAT1_i,
   AdmsSensFadType & instanceVar_K2SISAT_i,
   AdmsSensFadType & instanceVar_K2SISAT1_i,
   AdmsSensFadType & instanceVar_K2_i,
   AdmsSensFadType & instanceVar_K21_i,
   AdmsSensFadType & instanceVar_Cins,
   AdmsSensFadType & instanceVar_Ach,
   AdmsSensFadType & instanceVar_Weff_UFCM,
   AdmsSensFadType & instanceVar_qdep,
   AdmsSensFadType & instanceVar_rc,
   AdmsSensFadType & instanceVar_vth_fixed_factor_Sub,
   AdmsSensFadType & instanceVar_vth_fixed_factor_SI,
   AdmsSensFadType & instanceVar_qm,
   AdmsSensFadType & instanceVar_Qdep_ov_Cins,
   AdmsSensFadType & instanceVar_qi_acc_for_QM,
   AdmsSensFadType & instanceVar_fieldnormalizationfactor,
   AdmsSensFadType & instanceVar_auxQMfact,
   AdmsSensFadType & instanceVar_QMFACTORCVfinal,
   AdmsSensFadType & instanceVar_psipclamp,
   AdmsSensFadType & instanceVar_sqrtpsip,
   AdmsSensFadType & instanceVar_nq,
   AdmsSensFadType & instanceVar_F0,
   // non-reals
   int instanceVar_devsign,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_D,
   bool modelPar_given_D,
   AdmsSensFadType & modelPar_TFIN,
   bool modelPar_given_TFIN,
   AdmsSensFadType & modelPar_FPITCH,
   bool modelPar_given_FPITCH,
   AdmsSensFadType & modelPar_NFIN,
   bool modelPar_given_NFIN,
   AdmsSensFadType & modelPar_ASEO,
   bool modelPar_given_ASEO,
   AdmsSensFadType & modelPar_ADEO,
   bool modelPar_given_ADEO,
   AdmsSensFadType & modelPar_PSEO,
   bool modelPar_given_PSEO,
   AdmsSensFadType & modelPar_PDEO,
   bool modelPar_given_PDEO,
   AdmsSensFadType & modelPar_ASEJ,
   bool modelPar_given_ASEJ,
   AdmsSensFadType & modelPar_ADEJ,
   bool modelPar_given_ADEJ,
   AdmsSensFadType & modelPar_PSEJ,
   bool modelPar_given_PSEJ,
   AdmsSensFadType & modelPar_PDEJ,
   bool modelPar_given_PDEJ,
   AdmsSensFadType & modelPar_COVS,
   bool modelPar_given_COVS,
   AdmsSensFadType & modelPar_COVD,
   bool modelPar_given_COVD,
   AdmsSensFadType & modelPar_CGSP,
   bool modelPar_given_CGSP,
   AdmsSensFadType & modelPar_CGDP,
   bool modelPar_given_CGDP,
   AdmsSensFadType & modelPar_CDSP,
   bool modelPar_given_CDSP,
   AdmsSensFadType & modelPar_NRS,
   bool modelPar_given_NRS,
   AdmsSensFadType & modelPar_NRD,
   bool modelPar_given_NRD,
   AdmsSensFadType & modelPar_LRSD,
   bool modelPar_given_LRSD,
   AdmsSensFadType & modelPar_XL,
   bool modelPar_given_XL,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_DELVTRAND,
   bool modelPar_given_DELVTRAND,
   AdmsSensFadType & modelPar_U0MULT,
   bool modelPar_given_U0MULT,
   AdmsSensFadType & modelPar_IDS0MULT,
   bool modelPar_given_IDS0MULT,
   AdmsSensFadType & modelPar_LINT,
   bool modelPar_given_LINT,
   AdmsSensFadType & modelPar_LL,
   bool modelPar_given_LL,
   AdmsSensFadType & modelPar_LLN,
   bool modelPar_given_LLN,
   AdmsSensFadType & modelPar_DLC,
   bool modelPar_given_DLC,
   AdmsSensFadType & modelPar_DLCACC,
   bool modelPar_given_DLCACC,
   AdmsSensFadType & modelPar_DLBIN,
   bool modelPar_given_DLBIN,
   AdmsSensFadType & modelPar_LLC,
   bool modelPar_given_LLC,
   AdmsSensFadType & modelPar_EOT,
   bool modelPar_given_EOT,
   AdmsSensFadType & modelPar_TOXP,
   bool modelPar_given_TOXP,
   AdmsSensFadType & modelPar_EOTBOX,
   bool modelPar_given_EOTBOX,
   AdmsSensFadType & modelPar_HFIN,
   bool modelPar_given_HFIN,
   AdmsSensFadType & modelPar_FECH,
   bool modelPar_given_FECH,
   AdmsSensFadType & modelPar_DELTAW,
   bool modelPar_given_DELTAW,
   AdmsSensFadType & modelPar_FECHCV,
   bool modelPar_given_FECHCV,
   AdmsSensFadType & modelPar_DELTAWCV,
   bool modelPar_given_DELTAWCV,
   AdmsSensFadType & modelPar_NBODY,
   bool modelPar_given_NBODY,
   AdmsSensFadType & modelPar_NBODYN1,
   bool modelPar_given_NBODYN1,
   AdmsSensFadType & modelPar_NBODYN2,
   bool modelPar_given_NBODYN2,
   AdmsSensFadType & modelPar_NSD,
   bool modelPar_given_NSD,
   AdmsSensFadType & modelPar_PHIG,
   bool modelPar_given_PHIG,
   AdmsSensFadType & modelPar_PHIGL,
   bool modelPar_given_PHIGL,
   AdmsSensFadType & modelPar_PHIGLT,
   bool modelPar_given_PHIGLT,
   AdmsSensFadType & modelPar_PHIGN1,
   bool modelPar_given_PHIGN1,
   AdmsSensFadType & modelPar_PHIGN2,
   bool modelPar_given_PHIGN2,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_EPSRSUB,
   bool modelPar_given_EPSRSUB,
   AdmsSensFadType & modelPar_EASUB,
   bool modelPar_given_EASUB,
   AdmsSensFadType & modelPar_NI0SUB,
   bool modelPar_given_NI0SUB,
   AdmsSensFadType & modelPar_BG0SUB,
   bool modelPar_given_BG0SUB,
   AdmsSensFadType & modelPar_NC0SUB,
   bool modelPar_given_NC0SUB,
   AdmsSensFadType & modelPar_NGATE,
   bool modelPar_given_NGATE,
   AdmsSensFadType & modelPar_Imin,
   bool modelPar_given_Imin,
   AdmsSensFadType & modelPar_CIT,
   bool modelPar_given_CIT,
   AdmsSensFadType & modelPar_CITR,
   bool modelPar_given_CITR,
   AdmsSensFadType & modelPar_CDSC,
   bool modelPar_given_CDSC,
   AdmsSensFadType & modelPar_CDSCN1,
   bool modelPar_given_CDSCN1,
   AdmsSensFadType & modelPar_CDSCN2,
   bool modelPar_given_CDSCN2,
   AdmsSensFadType & modelPar_CDSCD,
   bool modelPar_given_CDSCD,
   AdmsSensFadType & modelPar_CDSCDN1,
   bool modelPar_given_CDSCDN1,
   AdmsSensFadType & modelPar_CDSCDN2,
   bool modelPar_given_CDSCDN2,
   AdmsSensFadType & modelPar_CDSCDR,
   bool modelPar_given_CDSCDR,
   AdmsSensFadType & modelPar_CDSCDRN1,
   bool modelPar_given_CDSCDRN1,
   AdmsSensFadType & modelPar_CDSCDRN2,
   bool modelPar_given_CDSCDRN2,
   AdmsSensFadType & modelPar_DVT0,
   bool modelPar_given_DVT0,
   AdmsSensFadType & modelPar_DVT1,
   bool modelPar_given_DVT1,
   AdmsSensFadType & modelPar_DVT1SS,
   bool modelPar_given_DVT1SS,
   AdmsSensFadType & modelPar_PHIN,
   bool modelPar_given_PHIN,
   AdmsSensFadType & modelPar_ETA0,
   bool modelPar_given_ETA0,
   AdmsSensFadType & modelPar_ETA0N1,
   bool modelPar_given_ETA0N1,
   AdmsSensFadType & modelPar_ETA0N2,
   bool modelPar_given_ETA0N2,
   AdmsSensFadType & modelPar_ETA0LT,
   bool modelPar_given_ETA0LT,
   AdmsSensFadType & modelPar_TETA0,
   bool modelPar_given_TETA0,
   AdmsSensFadType & modelPar_ETA0R,
   bool modelPar_given_ETA0R,
   AdmsSensFadType & modelPar_TETA0R,
   bool modelPar_given_TETA0R,
   AdmsSensFadType & modelPar_DSUB,
   bool modelPar_given_DSUB,
   AdmsSensFadType & modelPar_DVTP0,
   bool modelPar_given_DVTP0,
   AdmsSensFadType & modelPar_DVTP1,
   bool modelPar_given_DVTP1,
   AdmsSensFadType & modelPar_ADVTP0,
   bool modelPar_given_ADVTP0,
   AdmsSensFadType & modelPar_BDVTP0,
   bool modelPar_given_BDVTP0,
   AdmsSensFadType & modelPar_ADVTP1,
   bool modelPar_given_ADVTP1,
   AdmsSensFadType & modelPar_BDVTP1,
   bool modelPar_given_BDVTP1,
   AdmsSensFadType & modelPar_DVTP2,
   bool modelPar_given_DVTP2,
   AdmsSensFadType & modelPar_K1RSCE,
   bool modelPar_given_K1RSCE,
   AdmsSensFadType & modelPar_LPE0,
   bool modelPar_given_LPE0,
   AdmsSensFadType & modelPar_DVTSHIFT,
   bool modelPar_given_DVTSHIFT,
   AdmsSensFadType & modelPar_DVTSHIFTR,
   bool modelPar_given_DVTSHIFTR,
   AdmsSensFadType & modelPar_THETASCE,
   bool modelPar_given_THETASCE,
   AdmsSensFadType & modelPar_THETADIBL,
   bool modelPar_given_THETADIBL,
   AdmsSensFadType & modelPar_THETASW,
   bool modelPar_given_THETASW,
   AdmsSensFadType & modelPar_NVTM,
   bool modelPar_given_NVTM,
   AdmsSensFadType & modelPar_K0,
   bool modelPar_given_K0,
   AdmsSensFadType & modelPar_K01,
   bool modelPar_given_K01,
   AdmsSensFadType & modelPar_K0SI,
   bool modelPar_given_K0SI,
   AdmsSensFadType & modelPar_K0SI1,
   bool modelPar_given_K0SI1,
   AdmsSensFadType & modelPar_K2SI,
   bool modelPar_given_K2SI,
   AdmsSensFadType & modelPar_K2SI1,
   bool modelPar_given_K2SI1,
   AdmsSensFadType & modelPar_K0SISAT,
   bool modelPar_given_K0SISAT,
   AdmsSensFadType & modelPar_K0SISAT1,
   bool modelPar_given_K0SISAT1,
   AdmsSensFadType & modelPar_K2SISAT,
   bool modelPar_given_K2SISAT,
   AdmsSensFadType & modelPar_K2SISAT1,
   bool modelPar_given_K2SISAT1,
   AdmsSensFadType & modelPar_PHIBE,
   bool modelPar_given_PHIBE,
   AdmsSensFadType & modelPar_K1,
   bool modelPar_given_K1,
   AdmsSensFadType & modelPar_K11,
   bool modelPar_given_K11,
   AdmsSensFadType & modelPar_K2SAT,
   bool modelPar_given_K2SAT,
   AdmsSensFadType & modelPar_K2SAT1,
   bool modelPar_given_K2SAT1,
   AdmsSensFadType & modelPar_K2,
   bool modelPar_given_K2,
   AdmsSensFadType & modelPar_K21,
   bool modelPar_given_K21,
   AdmsSensFadType & modelPar_QMFACTOR,
   bool modelPar_given_QMFACTOR,
   AdmsSensFadType & modelPar_QMTCENCV,
   bool modelPar_given_QMTCENCV,
   AdmsSensFadType & modelPar_QMTCENCVA,
   bool modelPar_given_QMTCENCVA,
   AdmsSensFadType & modelPar_AQMTCEN,
   bool modelPar_given_AQMTCEN,
   AdmsSensFadType & modelPar_BQMTCEN,
   bool modelPar_given_BQMTCEN,
   AdmsSensFadType & modelPar_ETAQM,
   bool modelPar_given_ETAQM,
   AdmsSensFadType & modelPar_QM0,
   bool modelPar_given_QM0,
   AdmsSensFadType & modelPar_PQM,
   bool modelPar_given_PQM,
   AdmsSensFadType & modelPar_QM0ACC,
   bool modelPar_given_QM0ACC,
   AdmsSensFadType & modelPar_PQMACC,
   bool modelPar_given_PQMACC,
   AdmsSensFadType & modelPar_VSAT,
   bool modelPar_given_VSAT,
   AdmsSensFadType & modelPar_VSATR,
   bool modelPar_given_VSATR,
   AdmsSensFadType & modelPar_VSATN1,
   bool modelPar_given_VSATN1,
   AdmsSensFadType & modelPar_VSATN2,
   bool modelPar_given_VSATN2,
   AdmsSensFadType & modelPar_VSATRN1,
   bool modelPar_given_VSATRN1,
   AdmsSensFadType & modelPar_VSATRN2,
   bool modelPar_given_VSATRN2,
   AdmsSensFadType & modelPar_AVSAT,
   bool modelPar_given_AVSAT,
   AdmsSensFadType & modelPar_BVSAT,
   bool modelPar_given_BVSAT,
   AdmsSensFadType & modelPar_VSAT1,
   bool modelPar_given_VSAT1,
   AdmsSensFadType & modelPar_VSAT1N1,
   bool modelPar_given_VSAT1N1,
   AdmsSensFadType & modelPar_VSAT1N2,
   bool modelPar_given_VSAT1N2,
   AdmsSensFadType & modelPar_VSAT1R,
   bool modelPar_given_VSAT1R,
   AdmsSensFadType & modelPar_VSAT1RN1,
   bool modelPar_given_VSAT1RN1,
   AdmsSensFadType & modelPar_VSAT1RN2,
   bool modelPar_given_VSAT1RN2,
   AdmsSensFadType & modelPar_AVSAT1,
   bool modelPar_given_AVSAT1,
   AdmsSensFadType & modelPar_BVSAT1,
   bool modelPar_given_BVSAT1,
   AdmsSensFadType & modelPar_DELTAVSAT,
   bool modelPar_given_DELTAVSAT,
   AdmsSensFadType & modelPar_PSAT,
   bool modelPar_given_PSAT,
   AdmsSensFadType & modelPar_APSAT,
   bool modelPar_given_APSAT,
   AdmsSensFadType & modelPar_BPSAT,
   bool modelPar_given_BPSAT,
   AdmsSensFadType & modelPar_KSATIV,
   bool modelPar_given_KSATIV,
   AdmsSensFadType & modelPar_KSATIVR,
   bool modelPar_given_KSATIVR,
   AdmsSensFadType & modelPar_VSATCV,
   bool modelPar_given_VSATCV,
   AdmsSensFadType & modelPar_AVSATCV,
   bool modelPar_given_AVSATCV,
   AdmsSensFadType & modelPar_BVSATCV,
   bool modelPar_given_BVSATCV,
   AdmsSensFadType & modelPar_DELTAVSATCV,
   bool modelPar_given_DELTAVSATCV,
   AdmsSensFadType & modelPar_PSATCV,
   bool modelPar_given_PSATCV,
   AdmsSensFadType & modelPar_APSATCV,
   bool modelPar_given_APSATCV,
   AdmsSensFadType & modelPar_BPSATCV,
   bool modelPar_given_BPSATCV,
   AdmsSensFadType & modelPar_MEXP,
   bool modelPar_given_MEXP,
   AdmsSensFadType & modelPar_AMEXP,
   bool modelPar_given_AMEXP,
   AdmsSensFadType & modelPar_BMEXP,
   bool modelPar_given_BMEXP,
   AdmsSensFadType & modelPar_MEXPR,
   bool modelPar_given_MEXPR,
   AdmsSensFadType & modelPar_AMEXPR,
   bool modelPar_given_AMEXPR,
   AdmsSensFadType & modelPar_BMEXPR,
   bool modelPar_given_BMEXPR,
   AdmsSensFadType & modelPar_PTWG,
   bool modelPar_given_PTWG,
   AdmsSensFadType & modelPar_PTWGR,
   bool modelPar_given_PTWGR,
   AdmsSensFadType & modelPar_APTWG,
   bool modelPar_given_APTWG,
   AdmsSensFadType & modelPar_BPTWG,
   bool modelPar_given_BPTWG,
   AdmsSensFadType & modelPar_AT,
   bool modelPar_given_AT,
   AdmsSensFadType & modelPar_ATR,
   bool modelPar_given_ATR,
   AdmsSensFadType & modelPar_ATCV,
   bool modelPar_given_ATCV,
   AdmsSensFadType & modelPar_TMEXP,
   bool modelPar_given_TMEXP,
   AdmsSensFadType & modelPar_TMEXPR,
   bool modelPar_given_TMEXPR,
   AdmsSensFadType & modelPar_PTWGT,
   bool modelPar_given_PTWGT,
   AdmsSensFadType & modelPar_U0,
   bool modelPar_given_U0,
   AdmsSensFadType & modelPar_U0R,
   bool modelPar_given_U0R,
   AdmsSensFadType & modelPar_U0N1,
   bool modelPar_given_U0N1,
   AdmsSensFadType & modelPar_U0N1R,
   bool modelPar_given_U0N1R,
   AdmsSensFadType & modelPar_U0N2,
   bool modelPar_given_U0N2,
   AdmsSensFadType & modelPar_U0N2R,
   bool modelPar_given_U0N2R,
   AdmsSensFadType & modelPar_U0LT,
   bool modelPar_given_U0LT,
   AdmsSensFadType & modelPar_ETAMOB,
   bool modelPar_given_ETAMOB,
   AdmsSensFadType & modelPar_UP,
   bool modelPar_given_UP,
   AdmsSensFadType & modelPar_LPA,
   bool modelPar_given_LPA,
   AdmsSensFadType & modelPar_UPR,
   bool modelPar_given_UPR,
   AdmsSensFadType & modelPar_LPAR,
   bool modelPar_given_LPAR,
   AdmsSensFadType & modelPar_UA,
   bool modelPar_given_UA,
   AdmsSensFadType & modelPar_UAR,
   bool modelPar_given_UAR,
   AdmsSensFadType & modelPar_AUA,
   bool modelPar_given_AUA,
   AdmsSensFadType & modelPar_AUAR,
   bool modelPar_given_AUAR,
   AdmsSensFadType & modelPar_BUA,
   bool modelPar_given_BUA,
   AdmsSensFadType & modelPar_BUAR,
   bool modelPar_given_BUAR,
   AdmsSensFadType & modelPar_UC,
   bool modelPar_given_UC,
   AdmsSensFadType & modelPar_UCR,
   bool modelPar_given_UCR,
   AdmsSensFadType & modelPar_EU,
   bool modelPar_given_EU,
   AdmsSensFadType & modelPar_EUR,
   bool modelPar_given_EUR,
   AdmsSensFadType & modelPar_AEU,
   bool modelPar_given_AEU,
   AdmsSensFadType & modelPar_AEUR,
   bool modelPar_given_AEUR,
   AdmsSensFadType & modelPar_BEU,
   bool modelPar_given_BEU,
   AdmsSensFadType & modelPar_BEUR,
   bool modelPar_given_BEUR,
   AdmsSensFadType & modelPar_UD,
   bool modelPar_given_UD,
   AdmsSensFadType & modelPar_UDR,
   bool modelPar_given_UDR,
   AdmsSensFadType & modelPar_AUD,
   bool modelPar_given_AUD,
   AdmsSensFadType & modelPar_AUDR,
   bool modelPar_given_AUDR,
   AdmsSensFadType & modelPar_BUD,
   bool modelPar_given_BUD,
   AdmsSensFadType & modelPar_BUDR,
   bool modelPar_given_BUDR,
   AdmsSensFadType & modelPar_UCS,
   bool modelPar_given_UCS,
   AdmsSensFadType & modelPar_UTE,
   bool modelPar_given_UTE,
   AdmsSensFadType & modelPar_UTER,
   bool modelPar_given_UTER,
   AdmsSensFadType & modelPar_UTL,
   bool modelPar_given_UTL,
   AdmsSensFadType & modelPar_UTLR,
   bool modelPar_given_UTLR,
   AdmsSensFadType & modelPar_EMOBT,
   bool modelPar_given_EMOBT,
   AdmsSensFadType & modelPar_UA1,
   bool modelPar_given_UA1,
   AdmsSensFadType & modelPar_UA1R,
   bool modelPar_given_UA1R,
   AdmsSensFadType & modelPar_UC1,
   bool modelPar_given_UC1,
   AdmsSensFadType & modelPar_UC1R,
   bool modelPar_given_UC1R,
   AdmsSensFadType & modelPar_UD1,
   bool modelPar_given_UD1,
   AdmsSensFadType & modelPar_UD1R,
   bool modelPar_given_UD1R,
   AdmsSensFadType & modelPar_UCSTE,
   bool modelPar_given_UCSTE,
   AdmsSensFadType & modelPar_CHARGEWF,
   bool modelPar_given_CHARGEWF,
   AdmsSensFadType & modelPar_RDSWMIN,
   bool modelPar_given_RDSWMIN,
   AdmsSensFadType & modelPar_RDSW,
   bool modelPar_given_RDSW,
   AdmsSensFadType & modelPar_ARDSW,
   bool modelPar_given_ARDSW,
   AdmsSensFadType & modelPar_BRDSW,
   bool modelPar_given_BRDSW,
   AdmsSensFadType & modelPar_RSWMIN,
   bool modelPar_given_RSWMIN,
   AdmsSensFadType & modelPar_RSW,
   bool modelPar_given_RSW,
   AdmsSensFadType & modelPar_ARSW,
   bool modelPar_given_ARSW,
   AdmsSensFadType & modelPar_BRSW,
   bool modelPar_given_BRSW,
   AdmsSensFadType & modelPar_RDWMIN,
   bool modelPar_given_RDWMIN,
   AdmsSensFadType & modelPar_RDW,
   bool modelPar_given_RDW,
   AdmsSensFadType & modelPar_ARDW,
   bool modelPar_given_ARDW,
   AdmsSensFadType & modelPar_BRDW,
   bool modelPar_given_BRDW,
   AdmsSensFadType & modelPar_RSDR,
   bool modelPar_given_RSDR,
   AdmsSensFadType & modelPar_RSDRR,
   bool modelPar_given_RSDRR,
   AdmsSensFadType & modelPar_RDDR,
   bool modelPar_given_RDDR,
   AdmsSensFadType & modelPar_RDDRR,
   bool modelPar_given_RDDRR,
   AdmsSensFadType & modelPar_PRSDR,
   bool modelPar_given_PRSDR,
   AdmsSensFadType & modelPar_PRDDR,
   bool modelPar_given_PRDDR,
   AdmsSensFadType & modelPar_PRWGS,
   bool modelPar_given_PRWGS,
   AdmsSensFadType & modelPar_PRWGD,
   bool modelPar_given_PRWGD,
   AdmsSensFadType & modelPar_WR,
   bool modelPar_given_WR,
   AdmsSensFadType & modelPar_PRT,
   bool modelPar_given_PRT,
   AdmsSensFadType & modelPar_TRSDR,
   bool modelPar_given_TRSDR,
   AdmsSensFadType & modelPar_TRDDR,
   bool modelPar_given_TRDDR,
   AdmsSensFadType & modelPar_PDIBL1,
   bool modelPar_given_PDIBL1,
   AdmsSensFadType & modelPar_PDIBL1R,
   bool modelPar_given_PDIBL1R,
   AdmsSensFadType & modelPar_PDIBL2,
   bool modelPar_given_PDIBL2,
   AdmsSensFadType & modelPar_PDIBL2R,
   bool modelPar_given_PDIBL2R,
   AdmsSensFadType & modelPar_DROUT,
   bool modelPar_given_DROUT,
   AdmsSensFadType & modelPar_PVAG,
   bool modelPar_given_PVAG,
   AdmsSensFadType & modelPar_PCLM,
   bool modelPar_given_PCLM,
   AdmsSensFadType & modelPar_PCLMR,
   bool modelPar_given_PCLMR,
   AdmsSensFadType & modelPar_APCLM,
   bool modelPar_given_APCLM,
   AdmsSensFadType & modelPar_APCLMR,
   bool modelPar_given_APCLMR,
   AdmsSensFadType & modelPar_BPCLM,
   bool modelPar_given_BPCLM,
   AdmsSensFadType & modelPar_BPCLMR,
   bool modelPar_given_BPCLMR,
   AdmsSensFadType & modelPar_PCLMG,
   bool modelPar_given_PCLMG,
   AdmsSensFadType & modelPar_PCLMCV,
   bool modelPar_given_PCLMCV,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_A11,
   bool modelPar_given_A11,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_A21,
   bool modelPar_given_A21,
   AdmsSensFadType & modelPar_RGEXT,
   bool modelPar_given_RGEXT,
   AdmsSensFadType & modelPar_RGFIN,
   bool modelPar_given_RGFIN,
   AdmsSensFadType & modelPar_RSHS,
   bool modelPar_given_RSHS,
   AdmsSensFadType & modelPar_RSHD,
   bool modelPar_given_RSHD,
   AdmsSensFadType & modelPar_HEPI,
   bool modelPar_given_HEPI,
   AdmsSensFadType & modelPar_TSILI,
   bool modelPar_given_TSILI,
   AdmsSensFadType & modelPar_RHOC,
   bool modelPar_given_RHOC,
   AdmsSensFadType & modelPar_RHORSD,
   bool modelPar_given_RHORSD,
   AdmsSensFadType & modelPar_CRATIO,
   bool modelPar_given_CRATIO,
   AdmsSensFadType & modelPar_DELTAPRSD,
   bool modelPar_given_DELTAPRSD,
   AdmsSensFadType & modelPar_LSP,
   bool modelPar_given_LSP,
   AdmsSensFadType & modelPar_EPSRSP,
   bool modelPar_given_EPSRSP,
   AdmsSensFadType & modelPar_TGATE,
   bool modelPar_given_TGATE,
   AdmsSensFadType & modelPar_TMASK,
   bool modelPar_given_TMASK,
   AdmsSensFadType & modelPar_ASILIEND,
   bool modelPar_given_ASILIEND,
   AdmsSensFadType & modelPar_ARSDEND,
   bool modelPar_given_ARSDEND,
   AdmsSensFadType & modelPar_PRSDEND,
   bool modelPar_given_PRSDEND,
   AdmsSensFadType & modelPar_NSDE,
   bool modelPar_given_NSDE,
   AdmsSensFadType & modelPar_RGEOA,
   bool modelPar_given_RGEOA,
   AdmsSensFadType & modelPar_RGEOB,
   bool modelPar_given_RGEOB,
   AdmsSensFadType & modelPar_RGEOC,
   bool modelPar_given_RGEOC,
   AdmsSensFadType & modelPar_RGEOD,
   bool modelPar_given_RGEOD,
   AdmsSensFadType & modelPar_RGEOE,
   bool modelPar_given_RGEOE,
   AdmsSensFadType & modelPar_CGEOA,
   bool modelPar_given_CGEOA,
   AdmsSensFadType & modelPar_CGEOB,
   bool modelPar_given_CGEOB,
   AdmsSensFadType & modelPar_CGEOC,
   bool modelPar_given_CGEOC,
   AdmsSensFadType & modelPar_CGEOD,
   bool modelPar_given_CGEOD,
   AdmsSensFadType & modelPar_CGEOE,
   bool modelPar_given_CGEOE,
   AdmsSensFadType & modelPar_AIGBINV,
   bool modelPar_given_AIGBINV,
   AdmsSensFadType & modelPar_AIGBINV1,
   bool modelPar_given_AIGBINV1,
   AdmsSensFadType & modelPar_BIGBINV,
   bool modelPar_given_BIGBINV,
   AdmsSensFadType & modelPar_CIGBINV,
   bool modelPar_given_CIGBINV,
   AdmsSensFadType & modelPar_EIGBINV,
   bool modelPar_given_EIGBINV,
   AdmsSensFadType & modelPar_NIGBINV,
   bool modelPar_given_NIGBINV,
   AdmsSensFadType & modelPar_AIGBACC,
   bool modelPar_given_AIGBACC,
   AdmsSensFadType & modelPar_AIGBACC1,
   bool modelPar_given_AIGBACC1,
   AdmsSensFadType & modelPar_BIGBACC,
   bool modelPar_given_BIGBACC,
   AdmsSensFadType & modelPar_CIGBACC,
   bool modelPar_given_CIGBACC,
   AdmsSensFadType & modelPar_NIGBACC,
   bool modelPar_given_NIGBACC,
   AdmsSensFadType & modelPar_AIGC,
   bool modelPar_given_AIGC,
   AdmsSensFadType & modelPar_AIGC1,
   bool modelPar_given_AIGC1,
   AdmsSensFadType & modelPar_BIGC,
   bool modelPar_given_BIGC,
   AdmsSensFadType & modelPar_CIGC,
   bool modelPar_given_CIGC,
   AdmsSensFadType & modelPar_PIGCD,
   bool modelPar_given_PIGCD,
   AdmsSensFadType & modelPar_DLCIGS,
   bool modelPar_given_DLCIGS,
   AdmsSensFadType & modelPar_AIGS,
   bool modelPar_given_AIGS,
   AdmsSensFadType & modelPar_AIGS1,
   bool modelPar_given_AIGS1,
   AdmsSensFadType & modelPar_BIGS,
   bool modelPar_given_BIGS,
   AdmsSensFadType & modelPar_CIGS,
   bool modelPar_given_CIGS,
   AdmsSensFadType & modelPar_DLCIGD,
   bool modelPar_given_DLCIGD,
   AdmsSensFadType & modelPar_AIGD,
   bool modelPar_given_AIGD,
   AdmsSensFadType & modelPar_AIGD1,
   bool modelPar_given_AIGD1,
   AdmsSensFadType & modelPar_BIGD,
   bool modelPar_given_BIGD,
   AdmsSensFadType & modelPar_CIGD,
   bool modelPar_given_CIGD,
   AdmsSensFadType & modelPar_VFBSD,
   bool modelPar_given_VFBSD,
   AdmsSensFadType & modelPar_VFBSDCV,
   bool modelPar_given_VFBSDCV,
   AdmsSensFadType & modelPar_TOXREF,
   bool modelPar_given_TOXREF,
   AdmsSensFadType & modelPar_TOXG,
   bool modelPar_given_TOXG,
   AdmsSensFadType & modelPar_NTOX,
   bool modelPar_given_NTOX,
   AdmsSensFadType & modelPar_POXEDGE,
   bool modelPar_given_POXEDGE,
   AdmsSensFadType & modelPar_AGISL,
   bool modelPar_given_AGISL,
   AdmsSensFadType & modelPar_BGISL,
   bool modelPar_given_BGISL,
   AdmsSensFadType & modelPar_CGISL,
   bool modelPar_given_CGISL,
   AdmsSensFadType & modelPar_EGISL,
   bool modelPar_given_EGISL,
   AdmsSensFadType & modelPar_PGISL,
   bool modelPar_given_PGISL,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_EGIDL,
   bool modelPar_given_EGIDL,
   AdmsSensFadType & modelPar_PGIDL,
   bool modelPar_given_PGIDL,
   AdmsSensFadType & modelPar_ALPHA0,
   bool modelPar_given_ALPHA0,
   AdmsSensFadType & modelPar_ALPHA01,
   bool modelPar_given_ALPHA01,
   AdmsSensFadType & modelPar_ALPHA1,
   bool modelPar_given_ALPHA1,
   AdmsSensFadType & modelPar_ALPHA11,
   bool modelPar_given_ALPHA11,
   AdmsSensFadType & modelPar_BETA0,
   bool modelPar_given_BETA0,
   AdmsSensFadType & modelPar_ALPHAII0,
   bool modelPar_given_ALPHAII0,
   AdmsSensFadType & modelPar_ALPHAII01,
   bool modelPar_given_ALPHAII01,
   AdmsSensFadType & modelPar_ALPHAII1,
   bool modelPar_given_ALPHAII1,
   AdmsSensFadType & modelPar_ALPHAII11,
   bool modelPar_given_ALPHAII11,
   AdmsSensFadType & modelPar_BETAII0,
   bool modelPar_given_BETAII0,
   AdmsSensFadType & modelPar_BETAII1,
   bool modelPar_given_BETAII1,
   AdmsSensFadType & modelPar_BETAII2,
   bool modelPar_given_BETAII2,
   AdmsSensFadType & modelPar_ESATII,
   bool modelPar_given_ESATII,
   AdmsSensFadType & modelPar_LII,
   bool modelPar_given_LII,
   AdmsSensFadType & modelPar_SII0,
   bool modelPar_given_SII0,
   AdmsSensFadType & modelPar_SII1,
   bool modelPar_given_SII1,
   AdmsSensFadType & modelPar_SII2,
   bool modelPar_given_SII2,
   AdmsSensFadType & modelPar_SIID,
   bool modelPar_given_SIID,
   AdmsSensFadType & modelPar_IIMOD2CLAMP1,
   bool modelPar_given_IIMOD2CLAMP1,
   AdmsSensFadType & modelPar_IIMOD2CLAMP2,
   bool modelPar_given_IIMOD2CLAMP2,
   AdmsSensFadType & modelPar_IIMOD2CLAMP3,
   bool modelPar_given_IIMOD2CLAMP3,
   AdmsSensFadType & modelPar_EOTACC,
   bool modelPar_given_EOTACC,
   AdmsSensFadType & modelPar_DELVFBACC,
   bool modelPar_given_DELVFBACC,
   AdmsSensFadType & modelPar_CFS,
   bool modelPar_given_CFS,
   AdmsSensFadType & modelPar_CFD,
   bool modelPar_given_CFD,
   AdmsSensFadType & modelPar_CGSO,
   bool modelPar_given_CGSO,
   AdmsSensFadType & modelPar_CGDO,
   bool modelPar_given_CGDO,
   AdmsSensFadType & modelPar_CGSL,
   bool modelPar_given_CGSL,
   AdmsSensFadType & modelPar_CGDL,
   bool modelPar_given_CGDL,
   AdmsSensFadType & modelPar_CKAPPAS,
   bool modelPar_given_CKAPPAS,
   AdmsSensFadType & modelPar_CKAPPAD,
   bool modelPar_given_CKAPPAD,
   AdmsSensFadType & modelPar_CGBO,
   bool modelPar_given_CGBO,
   AdmsSensFadType & modelPar_CGBN,
   bool modelPar_given_CGBN,
   AdmsSensFadType & modelPar_CGBL,
   bool modelPar_given_CGBL,
   AdmsSensFadType & modelPar_CKAPPAB,
   bool modelPar_given_CKAPPAB,
   AdmsSensFadType & modelPar_CSDESW,
   bool modelPar_given_CSDESW,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_CJD,
   bool modelPar_given_CJD,
   AdmsSensFadType & modelPar_CJSWS,
   bool modelPar_given_CJSWS,
   AdmsSensFadType & modelPar_CJSWD,
   bool modelPar_given_CJSWD,
   AdmsSensFadType & modelPar_CJSWGS,
   bool modelPar_given_CJSWGS,
   AdmsSensFadType & modelPar_CJSWGD,
   bool modelPar_given_CJSWGD,
   AdmsSensFadType & modelPar_PBS,
   bool modelPar_given_PBS,
   AdmsSensFadType & modelPar_PBD,
   bool modelPar_given_PBD,
   AdmsSensFadType & modelPar_PBSWS,
   bool modelPar_given_PBSWS,
   AdmsSensFadType & modelPar_PBSWD,
   bool modelPar_given_PBSWD,
   AdmsSensFadType & modelPar_PBSWGS,
   bool modelPar_given_PBSWGS,
   AdmsSensFadType & modelPar_PBSWGD,
   bool modelPar_given_PBSWGD,
   AdmsSensFadType & modelPar_MJS,
   bool modelPar_given_MJS,
   AdmsSensFadType & modelPar_MJD,
   bool modelPar_given_MJD,
   AdmsSensFadType & modelPar_MJSWS,
   bool modelPar_given_MJSWS,
   AdmsSensFadType & modelPar_MJSWD,
   bool modelPar_given_MJSWD,
   AdmsSensFadType & modelPar_MJSWGS,
   bool modelPar_given_MJSWGS,
   AdmsSensFadType & modelPar_MJSWGD,
   bool modelPar_given_MJSWGD,
   AdmsSensFadType & modelPar_SJS,
   bool modelPar_given_SJS,
   AdmsSensFadType & modelPar_SJD,
   bool modelPar_given_SJD,
   AdmsSensFadType & modelPar_SJSWS,
   bool modelPar_given_SJSWS,
   AdmsSensFadType & modelPar_SJSWD,
   bool modelPar_given_SJSWD,
   AdmsSensFadType & modelPar_SJSWGS,
   bool modelPar_given_SJSWGS,
   AdmsSensFadType & modelPar_SJSWGD,
   bool modelPar_given_SJSWGD,
   AdmsSensFadType & modelPar_MJS2,
   bool modelPar_given_MJS2,
   AdmsSensFadType & modelPar_MJD2,
   bool modelPar_given_MJD2,
   AdmsSensFadType & modelPar_MJSWS2,
   bool modelPar_given_MJSWS2,
   AdmsSensFadType & modelPar_MJSWD2,
   bool modelPar_given_MJSWD2,
   AdmsSensFadType & modelPar_MJSWGS2,
   bool modelPar_given_MJSWGS2,
   AdmsSensFadType & modelPar_MJSWGD2,
   bool modelPar_given_MJSWGD2,
   AdmsSensFadType & modelPar_JSS,
   bool modelPar_given_JSS,
   AdmsSensFadType & modelPar_JSD,
   bool modelPar_given_JSD,
   AdmsSensFadType & modelPar_JSWS,
   bool modelPar_given_JSWS,
   AdmsSensFadType & modelPar_JSWD,
   bool modelPar_given_JSWD,
   AdmsSensFadType & modelPar_JSWGS,
   bool modelPar_given_JSWGS,
   AdmsSensFadType & modelPar_JSWGD,
   bool modelPar_given_JSWGD,
   AdmsSensFadType & modelPar_NJS,
   bool modelPar_given_NJS,
   AdmsSensFadType & modelPar_NJD,
   bool modelPar_given_NJD,
   AdmsSensFadType & modelPar_IJTHSFWD,
   bool modelPar_given_IJTHSFWD,
   AdmsSensFadType & modelPar_IJTHDFWD,
   bool modelPar_given_IJTHDFWD,
   AdmsSensFadType & modelPar_IJTHSREV,
   bool modelPar_given_IJTHSREV,
   AdmsSensFadType & modelPar_IJTHDREV,
   bool modelPar_given_IJTHDREV,
   AdmsSensFadType & modelPar_BVS,
   bool modelPar_given_BVS,
   AdmsSensFadType & modelPar_BVD,
   bool modelPar_given_BVD,
   AdmsSensFadType & modelPar_XJBVS,
   bool modelPar_given_XJBVS,
   AdmsSensFadType & modelPar_XJBVD,
   bool modelPar_given_XJBVD,
   AdmsSensFadType & modelPar_JTSS,
   bool modelPar_given_JTSS,
   AdmsSensFadType & modelPar_JTSD,
   bool modelPar_given_JTSD,
   AdmsSensFadType & modelPar_JTSSWS,
   bool modelPar_given_JTSSWS,
   AdmsSensFadType & modelPar_JTSSWD,
   bool modelPar_given_JTSSWD,
   AdmsSensFadType & modelPar_JTSSWGS,
   bool modelPar_given_JTSSWGS,
   AdmsSensFadType & modelPar_JTSSWGD,
   bool modelPar_given_JTSSWGD,
   AdmsSensFadType & modelPar_JTWEFF,
   bool modelPar_given_JTWEFF,
   AdmsSensFadType & modelPar_NJTS,
   bool modelPar_given_NJTS,
   AdmsSensFadType & modelPar_NJTSD,
   bool modelPar_given_NJTSD,
   AdmsSensFadType & modelPar_NJTSSW,
   bool modelPar_given_NJTSSW,
   AdmsSensFadType & modelPar_NJTSSWD,
   bool modelPar_given_NJTSSWD,
   AdmsSensFadType & modelPar_NJTSSWG,
   bool modelPar_given_NJTSSWG,
   AdmsSensFadType & modelPar_NJTSSWGD,
   bool modelPar_given_NJTSSWGD,
   AdmsSensFadType & modelPar_VTSS,
   bool modelPar_given_VTSS,
   AdmsSensFadType & modelPar_VTSD,
   bool modelPar_given_VTSD,
   AdmsSensFadType & modelPar_VTSSWS,
   bool modelPar_given_VTSSWS,
   AdmsSensFadType & modelPar_VTSSWD,
   bool modelPar_given_VTSSWD,
   AdmsSensFadType & modelPar_VTSSWGS,
   bool modelPar_given_VTSSWGS,
   AdmsSensFadType & modelPar_VTSSWGD,
   bool modelPar_given_VTSSWGD,
   AdmsSensFadType & modelPar_LINTIGEN,
   bool modelPar_given_LINTIGEN,
   AdmsSensFadType & modelPar_NTGEN,
   bool modelPar_given_NTGEN,
   AdmsSensFadType & modelPar_AIGEN,
   bool modelPar_given_AIGEN,
   AdmsSensFadType & modelPar_BIGEN,
   bool modelPar_given_BIGEN,
   AdmsSensFadType & modelPar_XRCRG1,
   bool modelPar_given_XRCRG1,
   AdmsSensFadType & modelPar_XRCRG2,
   bool modelPar_given_XRCRG2,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_EM,
   bool modelPar_given_EM,
   AdmsSensFadType & modelPar_NOIA,
   bool modelPar_given_NOIA,
   AdmsSensFadType & modelPar_NOIB,
   bool modelPar_given_NOIB,
   AdmsSensFadType & modelPar_NOIC,
   bool modelPar_given_NOIC,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_NTNOI,
   bool modelPar_given_NTNOI,
   AdmsSensFadType & modelPar_TNOIA,
   bool modelPar_given_TNOIA,
   AdmsSensFadType & modelPar_TNOIB,
   bool modelPar_given_TNOIB,
   AdmsSensFadType & modelPar_RNOIA,
   bool modelPar_given_RNOIA,
   AdmsSensFadType & modelPar_RNOIB,
   bool modelPar_given_RNOIB,
   AdmsSensFadType & modelPar_TNOIC,
   bool modelPar_given_TNOIC,
   AdmsSensFadType & modelPar_RNOIC,
   bool modelPar_given_RNOIC,
   AdmsSensFadType & modelPar_SCALEN,
   bool modelPar_given_SCALEN,
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_TBGASUB,
   bool modelPar_given_TBGASUB,
   AdmsSensFadType & modelPar_TBGBSUB,
   bool modelPar_given_TBGBSUB,
   AdmsSensFadType & modelPar_KT1,
   bool modelPar_given_KT1,
   AdmsSensFadType & modelPar_KT1L,
   bool modelPar_given_KT1L,
   AdmsSensFadType & modelPar_TSS,
   bool modelPar_given_TSS,
   AdmsSensFadType & modelPar_IIT,
   bool modelPar_given_IIT,
   AdmsSensFadType & modelPar_TII,
   bool modelPar_given_TII,
   AdmsSensFadType & modelPar_TGIDL,
   bool modelPar_given_TGIDL,
   AdmsSensFadType & modelPar_IGT,
   bool modelPar_given_IGT,
   AdmsSensFadType & modelPar_TCJ,
   bool modelPar_given_TCJ,
   AdmsSensFadType & modelPar_TCJSW,
   bool modelPar_given_TCJSW,
   AdmsSensFadType & modelPar_TCJSWG,
   bool modelPar_given_TCJSWG,
   AdmsSensFadType & modelPar_TPB,
   bool modelPar_given_TPB,
   AdmsSensFadType & modelPar_TPBSW,
   bool modelPar_given_TPBSW,
   AdmsSensFadType & modelPar_TPBSWG,
   bool modelPar_given_TPBSWG,
   AdmsSensFadType & modelPar_XTIS,
   bool modelPar_given_XTIS,
   AdmsSensFadType & modelPar_XTID,
   bool modelPar_given_XTID,
   AdmsSensFadType & modelPar_XTSS,
   bool modelPar_given_XTSS,
   AdmsSensFadType & modelPar_XTSD,
   bool modelPar_given_XTSD,
   AdmsSensFadType & modelPar_XTSSWS,
   bool modelPar_given_XTSSWS,
   AdmsSensFadType & modelPar_XTSSWD,
   bool modelPar_given_XTSSWD,
   AdmsSensFadType & modelPar_XTSSWGS,
   bool modelPar_given_XTSSWGS,
   AdmsSensFadType & modelPar_XTSSWGD,
   bool modelPar_given_XTSSWGD,
   AdmsSensFadType & modelPar_TNJTS,
   bool modelPar_given_TNJTS,
   AdmsSensFadType & modelPar_TNJTSD,
   bool modelPar_given_TNJTSD,
   AdmsSensFadType & modelPar_TNJTSSW,
   bool modelPar_given_TNJTSSW,
   AdmsSensFadType & modelPar_TNJTSSWD,
   bool modelPar_given_TNJTSSWD,
   AdmsSensFadType & modelPar_TNJTSSWG,
   bool modelPar_given_TNJTSSWG,
   AdmsSensFadType & modelPar_TNJTSSWGD,
   bool modelPar_given_TNJTSSWGD,
   AdmsSensFadType & modelPar_RTH0,
   bool modelPar_given_RTH0,
   AdmsSensFadType & modelPar_CTH0,
   bool modelPar_given_CTH0,
   AdmsSensFadType & modelPar_WTH0,
   bool modelPar_given_WTH0,
   AdmsSensFadType & modelPar_ASHEXP,
   bool modelPar_given_ASHEXP,
   AdmsSensFadType & modelPar_BSHEXP,
   bool modelPar_given_BSHEXP,
   AdmsSensFadType & modelPar_ACH_UFCM,
   bool modelPar_given_ACH_UFCM,
   AdmsSensFadType & modelPar_CINS_UFCM,
   bool modelPar_given_CINS_UFCM,
   AdmsSensFadType & modelPar_W_UFCM,
   bool modelPar_given_W_UFCM,
   AdmsSensFadType & modelPar_TFIN_TOP,
   bool modelPar_given_TFIN_TOP,
   AdmsSensFadType & modelPar_TFIN_BASE,
   bool modelPar_given_TFIN_BASE,
   AdmsSensFadType & modelPar_QMFACTORCV,
   bool modelPar_given_QMFACTORCV,
   AdmsSensFadType & modelPar_ALPHA_UFCM,
   bool modelPar_given_ALPHA_UFCM,
   AdmsSensFadType & modelPar_LNBODY,
   bool modelPar_given_LNBODY,
   AdmsSensFadType & modelPar_NNBODY,
   bool modelPar_given_NNBODY,
   AdmsSensFadType & modelPar_PNBODY,
   bool modelPar_given_PNBODY,
   AdmsSensFadType & modelPar_LPHIG,
   bool modelPar_given_LPHIG,
   AdmsSensFadType & modelPar_NPHIG,
   bool modelPar_given_NPHIG,
   AdmsSensFadType & modelPar_PPHIG,
   bool modelPar_given_PPHIG,
   AdmsSensFadType & modelPar_LNGATE,
   bool modelPar_given_LNGATE,
   AdmsSensFadType & modelPar_NNGATE,
   bool modelPar_given_NNGATE,
   AdmsSensFadType & modelPar_PNGATE,
   bool modelPar_given_PNGATE,
   AdmsSensFadType & modelPar_LCIT,
   bool modelPar_given_LCIT,
   AdmsSensFadType & modelPar_NCIT,
   bool modelPar_given_NCIT,
   AdmsSensFadType & modelPar_PCIT,
   bool modelPar_given_PCIT,
   AdmsSensFadType & modelPar_LCITR,
   bool modelPar_given_LCITR,
   AdmsSensFadType & modelPar_NCITR,
   bool modelPar_given_NCITR,
   AdmsSensFadType & modelPar_PCITR,
   bool modelPar_given_PCITR,
   AdmsSensFadType & modelPar_LCDSC,
   bool modelPar_given_LCDSC,
   AdmsSensFadType & modelPar_NCDSC,
   bool modelPar_given_NCDSC,
   AdmsSensFadType & modelPar_PCDSC,
   bool modelPar_given_PCDSC,
   AdmsSensFadType & modelPar_LCDSCD,
   bool modelPar_given_LCDSCD,
   AdmsSensFadType & modelPar_NCDSCD,
   bool modelPar_given_NCDSCD,
   AdmsSensFadType & modelPar_PCDSCD,
   bool modelPar_given_PCDSCD,
   AdmsSensFadType & modelPar_LCDSCDR,
   bool modelPar_given_LCDSCDR,
   AdmsSensFadType & modelPar_NCDSCDR,
   bool modelPar_given_NCDSCDR,
   AdmsSensFadType & modelPar_PCDSCDR,
   bool modelPar_given_PCDSCDR,
   AdmsSensFadType & modelPar_LDVT0,
   bool modelPar_given_LDVT0,
   AdmsSensFadType & modelPar_NDVT0,
   bool modelPar_given_NDVT0,
   AdmsSensFadType & modelPar_PDVT0,
   bool modelPar_given_PDVT0,
   AdmsSensFadType & modelPar_LDVT1,
   bool modelPar_given_LDVT1,
   AdmsSensFadType & modelPar_NDVT1,
   bool modelPar_given_NDVT1,
   AdmsSensFadType & modelPar_PDVT1,
   bool modelPar_given_PDVT1,
   AdmsSensFadType & modelPar_LDVT1SS,
   bool modelPar_given_LDVT1SS,
   AdmsSensFadType & modelPar_NDVT1SS,
   bool modelPar_given_NDVT1SS,
   AdmsSensFadType & modelPar_PDVT1SS,
   bool modelPar_given_PDVT1SS,
   AdmsSensFadType & modelPar_LPHIN,
   bool modelPar_given_LPHIN,
   AdmsSensFadType & modelPar_NPHIN,
   bool modelPar_given_NPHIN,
   AdmsSensFadType & modelPar_PPHIN,
   bool modelPar_given_PPHIN,
   AdmsSensFadType & modelPar_LETA0,
   bool modelPar_given_LETA0,
   AdmsSensFadType & modelPar_NETA0,
   bool modelPar_given_NETA0,
   AdmsSensFadType & modelPar_PETA0,
   bool modelPar_given_PETA0,
   AdmsSensFadType & modelPar_LETA0R,
   bool modelPar_given_LETA0R,
   AdmsSensFadType & modelPar_NETA0R,
   bool modelPar_given_NETA0R,
   AdmsSensFadType & modelPar_PETA0R,
   bool modelPar_given_PETA0R,
   AdmsSensFadType & modelPar_LDSUB,
   bool modelPar_given_LDSUB,
   AdmsSensFadType & modelPar_NDSUB,
   bool modelPar_given_NDSUB,
   AdmsSensFadType & modelPar_PDSUB,
   bool modelPar_given_PDSUB,
   AdmsSensFadType & modelPar_LK1RSCE,
   bool modelPar_given_LK1RSCE,
   AdmsSensFadType & modelPar_NK1RSCE,
   bool modelPar_given_NK1RSCE,
   AdmsSensFadType & modelPar_PK1RSCE,
   bool modelPar_given_PK1RSCE,
   AdmsSensFadType & modelPar_LLPE0,
   bool modelPar_given_LLPE0,
   AdmsSensFadType & modelPar_NLPE0,
   bool modelPar_given_NLPE0,
   AdmsSensFadType & modelPar_PLPE0,
   bool modelPar_given_PLPE0,
   AdmsSensFadType & modelPar_LDVTSHIFT,
   bool modelPar_given_LDVTSHIFT,
   AdmsSensFadType & modelPar_NDVTSHIFT,
   bool modelPar_given_NDVTSHIFT,
   AdmsSensFadType & modelPar_PDVTSHIFT,
   bool modelPar_given_PDVTSHIFT,
   AdmsSensFadType & modelPar_LDVTSHIFTR,
   bool modelPar_given_LDVTSHIFTR,
   AdmsSensFadType & modelPar_NDVTSHIFTR,
   bool modelPar_given_NDVTSHIFTR,
   AdmsSensFadType & modelPar_PDVTSHIFTR,
   bool modelPar_given_PDVTSHIFTR,
   AdmsSensFadType & modelPar_LPHIBE,
   bool modelPar_given_LPHIBE,
   AdmsSensFadType & modelPar_NPHIBE,
   bool modelPar_given_NPHIBE,
   AdmsSensFadType & modelPar_PPHIBE,
   bool modelPar_given_PPHIBE,
   AdmsSensFadType & modelPar_LK0,
   bool modelPar_given_LK0,
   AdmsSensFadType & modelPar_NK0,
   bool modelPar_given_NK0,
   AdmsSensFadType & modelPar_PK0,
   bool modelPar_given_PK0,
   AdmsSensFadType & modelPar_LK01,
   bool modelPar_given_LK01,
   AdmsSensFadType & modelPar_NK01,
   bool modelPar_given_NK01,
   AdmsSensFadType & modelPar_PK01,
   bool modelPar_given_PK01,
   AdmsSensFadType & modelPar_LK0SI,
   bool modelPar_given_LK0SI,
   AdmsSensFadType & modelPar_NK0SI,
   bool modelPar_given_NK0SI,
   AdmsSensFadType & modelPar_PK0SI,
   bool modelPar_given_PK0SI,
   AdmsSensFadType & modelPar_LK0SI1,
   bool modelPar_given_LK0SI1,
   AdmsSensFadType & modelPar_NK0SI1,
   bool modelPar_given_NK0SI1,
   AdmsSensFadType & modelPar_PK0SI1,
   bool modelPar_given_PK0SI1,
   AdmsSensFadType & modelPar_LK1,
   bool modelPar_given_LK1,
   AdmsSensFadType & modelPar_NK1,
   bool modelPar_given_NK1,
   AdmsSensFadType & modelPar_PK1,
   bool modelPar_given_PK1,
   AdmsSensFadType & modelPar_LK11,
   bool modelPar_given_LK11,
   AdmsSensFadType & modelPar_NK11,
   bool modelPar_given_NK11,
   AdmsSensFadType & modelPar_PK11,
   bool modelPar_given_PK11,
   AdmsSensFadType & modelPar_LK2SI,
   bool modelPar_given_LK2SI,
   AdmsSensFadType & modelPar_NK2SI,
   bool modelPar_given_NK2SI,
   AdmsSensFadType & modelPar_PK2SI,
   bool modelPar_given_PK2SI,
   AdmsSensFadType & modelPar_LK2SI1,
   bool modelPar_given_LK2SI1,
   AdmsSensFadType & modelPar_NK2SI1,
   bool modelPar_given_NK2SI1,
   AdmsSensFadType & modelPar_PK2SI1,
   bool modelPar_given_PK2SI1,
   AdmsSensFadType & modelPar_LK0SISAT,
   bool modelPar_given_LK0SISAT,
   AdmsSensFadType & modelPar_NK0SISAT,
   bool modelPar_given_NK0SISAT,
   AdmsSensFadType & modelPar_PK0SISAT,
   bool modelPar_given_PK0SISAT,
   AdmsSensFadType & modelPar_LK0SISAT1,
   bool modelPar_given_LK0SISAT1,
   AdmsSensFadType & modelPar_NK0SISAT1,
   bool modelPar_given_NK0SISAT1,
   AdmsSensFadType & modelPar_PK0SISAT1,
   bool modelPar_given_PK0SISAT1,
   AdmsSensFadType & modelPar_LK2SISAT,
   bool modelPar_given_LK2SISAT,
   AdmsSensFadType & modelPar_NK2SISAT,
   bool modelPar_given_NK2SISAT,
   AdmsSensFadType & modelPar_PK2SISAT,
   bool modelPar_given_PK2SISAT,
   AdmsSensFadType & modelPar_LK2SISAT1,
   bool modelPar_given_LK2SISAT1,
   AdmsSensFadType & modelPar_NK2SISAT1,
   bool modelPar_given_NK2SISAT1,
   AdmsSensFadType & modelPar_PK2SISAT1,
   bool modelPar_given_PK2SISAT1,
   AdmsSensFadType & modelPar_LK2SAT,
   bool modelPar_given_LK2SAT,
   AdmsSensFadType & modelPar_NK2SAT,
   bool modelPar_given_NK2SAT,
   AdmsSensFadType & modelPar_PK2SAT,
   bool modelPar_given_PK2SAT,
   AdmsSensFadType & modelPar_LK2SAT1,
   bool modelPar_given_LK2SAT1,
   AdmsSensFadType & modelPar_NK2SAT1,
   bool modelPar_given_NK2SAT1,
   AdmsSensFadType & modelPar_PK2SAT1,
   bool modelPar_given_PK2SAT1,
   AdmsSensFadType & modelPar_LK2,
   bool modelPar_given_LK2,
   AdmsSensFadType & modelPar_NK2,
   bool modelPar_given_NK2,
   AdmsSensFadType & modelPar_PK2,
   bool modelPar_given_PK2,
   AdmsSensFadType & modelPar_LK21,
   bool modelPar_given_LK21,
   AdmsSensFadType & modelPar_NK21,
   bool modelPar_given_NK21,
   AdmsSensFadType & modelPar_PK21,
   bool modelPar_given_PK21,
   AdmsSensFadType & modelPar_LDVTB,
   bool modelPar_given_LDVTB,
   AdmsSensFadType & modelPar_NDVTB,
   bool modelPar_given_NDVTB,
   AdmsSensFadType & modelPar_PDVTB,
   bool modelPar_given_PDVTB,
   AdmsSensFadType & modelPar_LLPEB,
   bool modelPar_given_LLPEB,
   AdmsSensFadType & modelPar_NLPEB,
   bool modelPar_given_NLPEB,
   AdmsSensFadType & modelPar_PLPEB,
   bool modelPar_given_PLPEB,
   AdmsSensFadType & modelPar_LQMFACTOR,
   bool modelPar_given_LQMFACTOR,
   AdmsSensFadType & modelPar_NQMFACTOR,
   bool modelPar_given_NQMFACTOR,
   AdmsSensFadType & modelPar_PQMFACTOR,
   bool modelPar_given_PQMFACTOR,
   AdmsSensFadType & modelPar_LQMTCENCV,
   bool modelPar_given_LQMTCENCV,
   AdmsSensFadType & modelPar_NQMTCENCV,
   bool modelPar_given_NQMTCENCV,
   AdmsSensFadType & modelPar_PQMTCENCV,
   bool modelPar_given_PQMTCENCV,
   AdmsSensFadType & modelPar_LQMTCENCVA,
   bool modelPar_given_LQMTCENCVA,
   AdmsSensFadType & modelPar_NQMTCENCVA,
   bool modelPar_given_NQMTCENCVA,
   AdmsSensFadType & modelPar_PQMTCENCVA,
   bool modelPar_given_PQMTCENCVA,
   AdmsSensFadType & modelPar_LVSAT,
   bool modelPar_given_LVSAT,
   AdmsSensFadType & modelPar_NVSAT,
   bool modelPar_given_NVSAT,
   AdmsSensFadType & modelPar_PVSAT,
   bool modelPar_given_PVSAT,
   AdmsSensFadType & modelPar_LVSATR,
   bool modelPar_given_LVSATR,
   AdmsSensFadType & modelPar_NVSATR,
   bool modelPar_given_NVSATR,
   AdmsSensFadType & modelPar_PVSATR,
   bool modelPar_given_PVSATR,
   AdmsSensFadType & modelPar_LVSAT1,
   bool modelPar_given_LVSAT1,
   AdmsSensFadType & modelPar_NVSAT1,
   bool modelPar_given_NVSAT1,
   AdmsSensFadType & modelPar_PVSAT1,
   bool modelPar_given_PVSAT1,
   AdmsSensFadType & modelPar_LVSAT1R,
   bool modelPar_given_LVSAT1R,
   AdmsSensFadType & modelPar_NVSAT1R,
   bool modelPar_given_NVSAT1R,
   AdmsSensFadType & modelPar_PVSAT1R,
   bool modelPar_given_PVSAT1R,
   AdmsSensFadType & modelPar_LPSAT,
   bool modelPar_given_LPSAT,
   AdmsSensFadType & modelPar_NPSAT,
   bool modelPar_given_NPSAT,
   AdmsSensFadType & modelPar_PPSAT,
   bool modelPar_given_PPSAT,
   AdmsSensFadType & modelPar_LDELTAVSAT,
   bool modelPar_given_LDELTAVSAT,
   AdmsSensFadType & modelPar_NDELTAVSAT,
   bool modelPar_given_NDELTAVSAT,
   AdmsSensFadType & modelPar_PDELTAVSAT,
   bool modelPar_given_PDELTAVSAT,
   AdmsSensFadType & modelPar_LKSATIV,
   bool modelPar_given_LKSATIV,
   AdmsSensFadType & modelPar_NKSATIV,
   bool modelPar_given_NKSATIV,
   AdmsSensFadType & modelPar_PKSATIV,
   bool modelPar_given_PKSATIV,
   AdmsSensFadType & modelPar_LKSATIVR,
   bool modelPar_given_LKSATIVR,
   AdmsSensFadType & modelPar_NKSATIVR,
   bool modelPar_given_NKSATIVR,
   AdmsSensFadType & modelPar_PKSATIVR,
   bool modelPar_given_PKSATIVR,
   AdmsSensFadType & modelPar_LVSATCV,
   bool modelPar_given_LVSATCV,
   AdmsSensFadType & modelPar_NVSATCV,
   bool modelPar_given_NVSATCV,
   AdmsSensFadType & modelPar_PVSATCV,
   bool modelPar_given_PVSATCV,
   AdmsSensFadType & modelPar_LPSATCV,
   bool modelPar_given_LPSATCV,
   AdmsSensFadType & modelPar_NPSATCV,
   bool modelPar_given_NPSATCV,
   AdmsSensFadType & modelPar_PPSATCV,
   bool modelPar_given_PPSATCV,
   AdmsSensFadType & modelPar_LDELTAVSATCV,
   bool modelPar_given_LDELTAVSATCV,
   AdmsSensFadType & modelPar_NDELTAVSATCV,
   bool modelPar_given_NDELTAVSATCV,
   AdmsSensFadType & modelPar_PDELTAVSATCV,
   bool modelPar_given_PDELTAVSATCV,
   AdmsSensFadType & modelPar_LMEXP,
   bool modelPar_given_LMEXP,
   AdmsSensFadType & modelPar_NMEXP,
   bool modelPar_given_NMEXP,
   AdmsSensFadType & modelPar_PMEXP,
   bool modelPar_given_PMEXP,
   AdmsSensFadType & modelPar_LMEXPR,
   bool modelPar_given_LMEXPR,
   AdmsSensFadType & modelPar_NMEXPR,
   bool modelPar_given_NMEXPR,
   AdmsSensFadType & modelPar_PMEXPR,
   bool modelPar_given_PMEXPR,
   AdmsSensFadType & modelPar_LPTWG,
   bool modelPar_given_LPTWG,
   AdmsSensFadType & modelPar_NPTWG,
   bool modelPar_given_NPTWG,
   AdmsSensFadType & modelPar_PPTWG,
   bool modelPar_given_PPTWG,
   AdmsSensFadType & modelPar_LPTWGR,
   bool modelPar_given_LPTWGR,
   AdmsSensFadType & modelPar_NPTWGR,
   bool modelPar_given_NPTWGR,
   AdmsSensFadType & modelPar_PPTWGR,
   bool modelPar_given_PPTWGR,
   AdmsSensFadType & modelPar_LU0,
   bool modelPar_given_LU0,
   AdmsSensFadType & modelPar_NU0,
   bool modelPar_given_NU0,
   AdmsSensFadType & modelPar_PU0,
   bool modelPar_given_PU0,
   AdmsSensFadType & modelPar_LU0R,
   bool modelPar_given_LU0R,
   AdmsSensFadType & modelPar_NU0R,
   bool modelPar_given_NU0R,
   AdmsSensFadType & modelPar_PU0R,
   bool modelPar_given_PU0R,
   AdmsSensFadType & modelPar_LETAMOB,
   bool modelPar_given_LETAMOB,
   AdmsSensFadType & modelPar_NETAMOB,
   bool modelPar_given_NETAMOB,
   AdmsSensFadType & modelPar_PETAMOB,
   bool modelPar_given_PETAMOB,
   AdmsSensFadType & modelPar_LUP,
   bool modelPar_given_LUP,
   AdmsSensFadType & modelPar_NUP,
   bool modelPar_given_NUP,
   AdmsSensFadType & modelPar_PUP,
   bool modelPar_given_PUP,
   AdmsSensFadType & modelPar_LUPR,
   bool modelPar_given_LUPR,
   AdmsSensFadType & modelPar_NUPR,
   bool modelPar_given_NUPR,
   AdmsSensFadType & modelPar_PUPR,
   bool modelPar_given_PUPR,
   AdmsSensFadType & modelPar_LUA,
   bool modelPar_given_LUA,
   AdmsSensFadType & modelPar_NUA,
   bool modelPar_given_NUA,
   AdmsSensFadType & modelPar_PUA,
   bool modelPar_given_PUA,
   AdmsSensFadType & modelPar_LUAR,
   bool modelPar_given_LUAR,
   AdmsSensFadType & modelPar_NUAR,
   bool modelPar_given_NUAR,
   AdmsSensFadType & modelPar_PUAR,
   bool modelPar_given_PUAR,
   AdmsSensFadType & modelPar_LUC,
   bool modelPar_given_LUC,
   AdmsSensFadType & modelPar_NUC,
   bool modelPar_given_NUC,
   AdmsSensFadType & modelPar_PUC,
   bool modelPar_given_PUC,
   AdmsSensFadType & modelPar_LUCR,
   bool modelPar_given_LUCR,
   AdmsSensFadType & modelPar_NUCR,
   bool modelPar_given_NUCR,
   AdmsSensFadType & modelPar_PUCR,
   bool modelPar_given_PUCR,
   AdmsSensFadType & modelPar_LEU,
   bool modelPar_given_LEU,
   AdmsSensFadType & modelPar_NEU,
   bool modelPar_given_NEU,
   AdmsSensFadType & modelPar_PEU,
   bool modelPar_given_PEU,
   AdmsSensFadType & modelPar_LEUR,
   bool modelPar_given_LEUR,
   AdmsSensFadType & modelPar_NEUR,
   bool modelPar_given_NEUR,
   AdmsSensFadType & modelPar_PEUR,
   bool modelPar_given_PEUR,
   AdmsSensFadType & modelPar_LUD,
   bool modelPar_given_LUD,
   AdmsSensFadType & modelPar_NUD,
   bool modelPar_given_NUD,
   AdmsSensFadType & modelPar_PUD,
   bool modelPar_given_PUD,
   AdmsSensFadType & modelPar_LUDR,
   bool modelPar_given_LUDR,
   AdmsSensFadType & modelPar_NUDR,
   bool modelPar_given_NUDR,
   AdmsSensFadType & modelPar_PUDR,
   bool modelPar_given_PUDR,
   AdmsSensFadType & modelPar_LUCS,
   bool modelPar_given_LUCS,
   AdmsSensFadType & modelPar_NUCS,
   bool modelPar_given_NUCS,
   AdmsSensFadType & modelPar_PUCS,
   bool modelPar_given_PUCS,
   AdmsSensFadType & modelPar_LPCLM,
   bool modelPar_given_LPCLM,
   AdmsSensFadType & modelPar_NPCLM,
   bool modelPar_given_NPCLM,
   AdmsSensFadType & modelPar_PPCLM,
   bool modelPar_given_PPCLM,
   AdmsSensFadType & modelPar_LPCLMR,
   bool modelPar_given_LPCLMR,
   AdmsSensFadType & modelPar_NPCLMR,
   bool modelPar_given_NPCLMR,
   AdmsSensFadType & modelPar_PPCLMR,
   bool modelPar_given_PPCLMR,
   AdmsSensFadType & modelPar_LPCLMG,
   bool modelPar_given_LPCLMG,
   AdmsSensFadType & modelPar_NPCLMG,
   bool modelPar_given_NPCLMG,
   AdmsSensFadType & modelPar_PPCLMG,
   bool modelPar_given_PPCLMG,
   AdmsSensFadType & modelPar_LPCLMCV,
   bool modelPar_given_LPCLMCV,
   AdmsSensFadType & modelPar_NPCLMCV,
   bool modelPar_given_NPCLMCV,
   AdmsSensFadType & modelPar_PPCLMCV,
   bool modelPar_given_PPCLMCV,
   AdmsSensFadType & modelPar_LA1,
   bool modelPar_given_LA1,
   AdmsSensFadType & modelPar_NA1,
   bool modelPar_given_NA1,
   AdmsSensFadType & modelPar_PA1,
   bool modelPar_given_PA1,
   AdmsSensFadType & modelPar_LA11,
   bool modelPar_given_LA11,
   AdmsSensFadType & modelPar_NA11,
   bool modelPar_given_NA11,
   AdmsSensFadType & modelPar_PA11,
   bool modelPar_given_PA11,
   AdmsSensFadType & modelPar_LA2,
   bool modelPar_given_LA2,
   AdmsSensFadType & modelPar_NA2,
   bool modelPar_given_NA2,
   AdmsSensFadType & modelPar_PA2,
   bool modelPar_given_PA2,
   AdmsSensFadType & modelPar_LA21,
   bool modelPar_given_LA21,
   AdmsSensFadType & modelPar_NA21,
   bool modelPar_given_NA21,
   AdmsSensFadType & modelPar_PA21,
   bool modelPar_given_PA21,
   AdmsSensFadType & modelPar_LRDSW,
   bool modelPar_given_LRDSW,
   AdmsSensFadType & modelPar_NRDSW,
   bool modelPar_given_NRDSW,
   AdmsSensFadType & modelPar_PRDSW,
   bool modelPar_given_PRDSW,
   AdmsSensFadType & modelPar_LRSW,
   bool modelPar_given_LRSW,
   AdmsSensFadType & modelPar_NRSW,
   bool modelPar_given_NRSW,
   AdmsSensFadType & modelPar_PRSW,
   bool modelPar_given_PRSW,
   AdmsSensFadType & modelPar_LRDW,
   bool modelPar_given_LRDW,
   AdmsSensFadType & modelPar_NRDW,
   bool modelPar_given_NRDW,
   AdmsSensFadType & modelPar_PRDW,
   bool modelPar_given_PRDW,
   AdmsSensFadType & modelPar_LPRWGS,
   bool modelPar_given_LPRWGS,
   AdmsSensFadType & modelPar_NPRWGS,
   bool modelPar_given_NPRWGS,
   AdmsSensFadType & modelPar_PPRWGS,
   bool modelPar_given_PPRWGS,
   AdmsSensFadType & modelPar_LPRWGD,
   bool modelPar_given_LPRWGD,
   AdmsSensFadType & modelPar_NPRWGD,
   bool modelPar_given_NPRWGD,
   AdmsSensFadType & modelPar_PPRWGD,
   bool modelPar_given_PPRWGD,
   AdmsSensFadType & modelPar_LWR,
   bool modelPar_given_LWR,
   AdmsSensFadType & modelPar_NWR,
   bool modelPar_given_NWR,
   AdmsSensFadType & modelPar_PWR,
   bool modelPar_given_PWR,
   AdmsSensFadType & modelPar_LPDIBL1,
   bool modelPar_given_LPDIBL1,
   AdmsSensFadType & modelPar_NPDIBL1,
   bool modelPar_given_NPDIBL1,
   AdmsSensFadType & modelPar_PPDIBL1,
   bool modelPar_given_PPDIBL1,
   AdmsSensFadType & modelPar_LPDIBL1R,
   bool modelPar_given_LPDIBL1R,
   AdmsSensFadType & modelPar_NPDIBL1R,
   bool modelPar_given_NPDIBL1R,
   AdmsSensFadType & modelPar_PPDIBL1R,
   bool modelPar_given_PPDIBL1R,
   AdmsSensFadType & modelPar_LPDIBL2,
   bool modelPar_given_LPDIBL2,
   AdmsSensFadType & modelPar_NPDIBL2,
   bool modelPar_given_NPDIBL2,
   AdmsSensFadType & modelPar_PPDIBL2,
   bool modelPar_given_PPDIBL2,
   AdmsSensFadType & modelPar_LPDIBL2R,
   bool modelPar_given_LPDIBL2R,
   AdmsSensFadType & modelPar_NPDIBL2R,
   bool modelPar_given_NPDIBL2R,
   AdmsSensFadType & modelPar_PPDIBL2R,
   bool modelPar_given_PPDIBL2R,
   AdmsSensFadType & modelPar_LDROUT,
   bool modelPar_given_LDROUT,
   AdmsSensFadType & modelPar_NDROUT,
   bool modelPar_given_NDROUT,
   AdmsSensFadType & modelPar_PDROUT,
   bool modelPar_given_PDROUT,
   AdmsSensFadType & modelPar_LPVAG,
   bool modelPar_given_LPVAG,
   AdmsSensFadType & modelPar_NPVAG,
   bool modelPar_given_NPVAG,
   AdmsSensFadType & modelPar_PPVAG,
   bool modelPar_given_PPVAG,
   AdmsSensFadType & modelPar_LAIGBINV,
   bool modelPar_given_LAIGBINV,
   AdmsSensFadType & modelPar_NAIGBINV,
   bool modelPar_given_NAIGBINV,
   AdmsSensFadType & modelPar_PAIGBINV,
   bool modelPar_given_PAIGBINV,
   AdmsSensFadType & modelPar_LAIGBINV1,
   bool modelPar_given_LAIGBINV1,
   AdmsSensFadType & modelPar_NAIGBINV1,
   bool modelPar_given_NAIGBINV1,
   AdmsSensFadType & modelPar_PAIGBINV1,
   bool modelPar_given_PAIGBINV1,
   AdmsSensFadType & modelPar_LBIGBINV,
   bool modelPar_given_LBIGBINV,
   AdmsSensFadType & modelPar_NBIGBINV,
   bool modelPar_given_NBIGBINV,
   AdmsSensFadType & modelPar_PBIGBINV,
   bool modelPar_given_PBIGBINV,
   AdmsSensFadType & modelPar_LCIGBINV,
   bool modelPar_given_LCIGBINV,
   AdmsSensFadType & modelPar_NCIGBINV,
   bool modelPar_given_NCIGBINV,
   AdmsSensFadType & modelPar_PCIGBINV,
   bool modelPar_given_PCIGBINV,
   AdmsSensFadType & modelPar_LEIGBINV,
   bool modelPar_given_LEIGBINV,
   AdmsSensFadType & modelPar_NEIGBINV,
   bool modelPar_given_NEIGBINV,
   AdmsSensFadType & modelPar_PEIGBINV,
   bool modelPar_given_PEIGBINV,
   AdmsSensFadType & modelPar_LNIGBINV,
   bool modelPar_given_LNIGBINV,
   AdmsSensFadType & modelPar_NNIGBINV,
   bool modelPar_given_NNIGBINV,
   AdmsSensFadType & modelPar_PNIGBINV,
   bool modelPar_given_PNIGBINV,
   AdmsSensFadType & modelPar_LAIGBACC,
   bool modelPar_given_LAIGBACC,
   AdmsSensFadType & modelPar_NAIGBACC,
   bool modelPar_given_NAIGBACC,
   AdmsSensFadType & modelPar_PAIGBACC,
   bool modelPar_given_PAIGBACC,
   AdmsSensFadType & modelPar_LAIGBACC1,
   bool modelPar_given_LAIGBACC1,
   AdmsSensFadType & modelPar_NAIGBACC1,
   bool modelPar_given_NAIGBACC1,
   AdmsSensFadType & modelPar_PAIGBACC1,
   bool modelPar_given_PAIGBACC1,
   AdmsSensFadType & modelPar_LBIGBACC,
   bool modelPar_given_LBIGBACC,
   AdmsSensFadType & modelPar_NBIGBACC,
   bool modelPar_given_NBIGBACC,
   AdmsSensFadType & modelPar_PBIGBACC,
   bool modelPar_given_PBIGBACC,
   AdmsSensFadType & modelPar_LCIGBACC,
   bool modelPar_given_LCIGBACC,
   AdmsSensFadType & modelPar_NCIGBACC,
   bool modelPar_given_NCIGBACC,
   AdmsSensFadType & modelPar_PCIGBACC,
   bool modelPar_given_PCIGBACC,
   AdmsSensFadType & modelPar_LNIGBACC,
   bool modelPar_given_LNIGBACC,
   AdmsSensFadType & modelPar_NNIGBACC,
   bool modelPar_given_NNIGBACC,
   AdmsSensFadType & modelPar_PNIGBACC,
   bool modelPar_given_PNIGBACC,
   AdmsSensFadType & modelPar_LAIGC,
   bool modelPar_given_LAIGC,
   AdmsSensFadType & modelPar_NAIGC,
   bool modelPar_given_NAIGC,
   AdmsSensFadType & modelPar_PAIGC,
   bool modelPar_given_PAIGC,
   AdmsSensFadType & modelPar_LAIGC1,
   bool modelPar_given_LAIGC1,
   AdmsSensFadType & modelPar_NAIGC1,
   bool modelPar_given_NAIGC1,
   AdmsSensFadType & modelPar_PAIGC1,
   bool modelPar_given_PAIGC1,
   AdmsSensFadType & modelPar_LBIGC,
   bool modelPar_given_LBIGC,
   AdmsSensFadType & modelPar_NBIGC,
   bool modelPar_given_NBIGC,
   AdmsSensFadType & modelPar_PBIGC,
   bool modelPar_given_PBIGC,
   AdmsSensFadType & modelPar_LCIGC,
   bool modelPar_given_LCIGC,
   AdmsSensFadType & modelPar_NCIGC,
   bool modelPar_given_NCIGC,
   AdmsSensFadType & modelPar_PCIGC,
   bool modelPar_given_PCIGC,
   AdmsSensFadType & modelPar_LPIGCD,
   bool modelPar_given_LPIGCD,
   AdmsSensFadType & modelPar_NPIGCD,
   bool modelPar_given_NPIGCD,
   AdmsSensFadType & modelPar_PPIGCD,
   bool modelPar_given_PPIGCD,
   AdmsSensFadType & modelPar_LAIGS,
   bool modelPar_given_LAIGS,
   AdmsSensFadType & modelPar_NAIGS,
   bool modelPar_given_NAIGS,
   AdmsSensFadType & modelPar_PAIGS,
   bool modelPar_given_PAIGS,
   AdmsSensFadType & modelPar_LAIGS1,
   bool modelPar_given_LAIGS1,
   AdmsSensFadType & modelPar_NAIGS1,
   bool modelPar_given_NAIGS1,
   AdmsSensFadType & modelPar_PAIGS1,
   bool modelPar_given_PAIGS1,
   AdmsSensFadType & modelPar_LBIGS,
   bool modelPar_given_LBIGS,
   AdmsSensFadType & modelPar_NBIGS,
   bool modelPar_given_NBIGS,
   AdmsSensFadType & modelPar_PBIGS,
   bool modelPar_given_PBIGS,
   AdmsSensFadType & modelPar_LCIGS,
   bool modelPar_given_LCIGS,
   AdmsSensFadType & modelPar_NCIGS,
   bool modelPar_given_NCIGS,
   AdmsSensFadType & modelPar_PCIGS,
   bool modelPar_given_PCIGS,
   AdmsSensFadType & modelPar_LAIGD,
   bool modelPar_given_LAIGD,
   AdmsSensFadType & modelPar_NAIGD,
   bool modelPar_given_NAIGD,
   AdmsSensFadType & modelPar_PAIGD,
   bool modelPar_given_PAIGD,
   AdmsSensFadType & modelPar_LAIGD1,
   bool modelPar_given_LAIGD1,
   AdmsSensFadType & modelPar_NAIGD1,
   bool modelPar_given_NAIGD1,
   AdmsSensFadType & modelPar_PAIGD1,
   bool modelPar_given_PAIGD1,
   AdmsSensFadType & modelPar_LBIGD,
   bool modelPar_given_LBIGD,
   AdmsSensFadType & modelPar_NBIGD,
   bool modelPar_given_NBIGD,
   AdmsSensFadType & modelPar_PBIGD,
   bool modelPar_given_PBIGD,
   AdmsSensFadType & modelPar_LCIGD,
   bool modelPar_given_LCIGD,
   AdmsSensFadType & modelPar_NCIGD,
   bool modelPar_given_NCIGD,
   AdmsSensFadType & modelPar_PCIGD,
   bool modelPar_given_PCIGD,
   AdmsSensFadType & modelPar_LNTOX,
   bool modelPar_given_LNTOX,
   AdmsSensFadType & modelPar_NNTOX,
   bool modelPar_given_NNTOX,
   AdmsSensFadType & modelPar_PNTOX,
   bool modelPar_given_PNTOX,
   AdmsSensFadType & modelPar_LPOXEDGE,
   bool modelPar_given_LPOXEDGE,
   AdmsSensFadType & modelPar_NPOXEDGE,
   bool modelPar_given_NPOXEDGE,
   AdmsSensFadType & modelPar_PPOXEDGE,
   bool modelPar_given_PPOXEDGE,
   AdmsSensFadType & modelPar_LAGISL,
   bool modelPar_given_LAGISL,
   AdmsSensFadType & modelPar_NAGISL,
   bool modelPar_given_NAGISL,
   AdmsSensFadType & modelPar_PAGISL,
   bool modelPar_given_PAGISL,
   AdmsSensFadType & modelPar_LBGISL,
   bool modelPar_given_LBGISL,
   AdmsSensFadType & modelPar_NBGISL,
   bool modelPar_given_NBGISL,
   AdmsSensFadType & modelPar_PBGISL,
   bool modelPar_given_PBGISL,
   AdmsSensFadType & modelPar_LCGISL,
   bool modelPar_given_LCGISL,
   AdmsSensFadType & modelPar_NCGISL,
   bool modelPar_given_NCGISL,
   AdmsSensFadType & modelPar_PCGISL,
   bool modelPar_given_PCGISL,
   AdmsSensFadType & modelPar_LEGISL,
   bool modelPar_given_LEGISL,
   AdmsSensFadType & modelPar_NEGISL,
   bool modelPar_given_NEGISL,
   AdmsSensFadType & modelPar_PEGISL,
   bool modelPar_given_PEGISL,
   AdmsSensFadType & modelPar_LPGISL,
   bool modelPar_given_LPGISL,
   AdmsSensFadType & modelPar_NPGISL,
   bool modelPar_given_NPGISL,
   AdmsSensFadType & modelPar_PPGISL,
   bool modelPar_given_PPGISL,
   AdmsSensFadType & modelPar_LAGIDL,
   bool modelPar_given_LAGIDL,
   AdmsSensFadType & modelPar_NAGIDL,
   bool modelPar_given_NAGIDL,
   AdmsSensFadType & modelPar_PAGIDL,
   bool modelPar_given_PAGIDL,
   AdmsSensFadType & modelPar_LBGIDL,
   bool modelPar_given_LBGIDL,
   AdmsSensFadType & modelPar_NBGIDL,
   bool modelPar_given_NBGIDL,
   AdmsSensFadType & modelPar_PBGIDL,
   bool modelPar_given_PBGIDL,
   AdmsSensFadType & modelPar_LCGIDL,
   bool modelPar_given_LCGIDL,
   AdmsSensFadType & modelPar_NCGIDL,
   bool modelPar_given_NCGIDL,
   AdmsSensFadType & modelPar_PCGIDL,
   bool modelPar_given_PCGIDL,
   AdmsSensFadType & modelPar_LEGIDL,
   bool modelPar_given_LEGIDL,
   AdmsSensFadType & modelPar_NEGIDL,
   bool modelPar_given_NEGIDL,
   AdmsSensFadType & modelPar_PEGIDL,
   bool modelPar_given_PEGIDL,
   AdmsSensFadType & modelPar_LPGIDL,
   bool modelPar_given_LPGIDL,
   AdmsSensFadType & modelPar_NPGIDL,
   bool modelPar_given_NPGIDL,
   AdmsSensFadType & modelPar_PPGIDL,
   bool modelPar_given_PPGIDL,
   AdmsSensFadType & modelPar_LALPHA0,
   bool modelPar_given_LALPHA0,
   AdmsSensFadType & modelPar_NALPHA0,
   bool modelPar_given_NALPHA0,
   AdmsSensFadType & modelPar_PALPHA0,
   bool modelPar_given_PALPHA0,
   AdmsSensFadType & modelPar_LALPHA1,
   bool modelPar_given_LALPHA1,
   AdmsSensFadType & modelPar_NALPHA1,
   bool modelPar_given_NALPHA1,
   AdmsSensFadType & modelPar_PALPHA1,
   bool modelPar_given_PALPHA1,
   AdmsSensFadType & modelPar_LALPHAII0,
   bool modelPar_given_LALPHAII0,
   AdmsSensFadType & modelPar_NALPHAII0,
   bool modelPar_given_NALPHAII0,
   AdmsSensFadType & modelPar_PALPHAII0,
   bool modelPar_given_PALPHAII0,
   AdmsSensFadType & modelPar_LALPHAII1,
   bool modelPar_given_LALPHAII1,
   AdmsSensFadType & modelPar_NALPHAII1,
   bool modelPar_given_NALPHAII1,
   AdmsSensFadType & modelPar_PALPHAII1,
   bool modelPar_given_PALPHAII1,
   AdmsSensFadType & modelPar_LBETA0,
   bool modelPar_given_LBETA0,
   AdmsSensFadType & modelPar_NBETA0,
   bool modelPar_given_NBETA0,
   AdmsSensFadType & modelPar_PBETA0,
   bool modelPar_given_PBETA0,
   AdmsSensFadType & modelPar_LBETAII0,
   bool modelPar_given_LBETAII0,
   AdmsSensFadType & modelPar_NBETAII0,
   bool modelPar_given_NBETAII0,
   AdmsSensFadType & modelPar_PBETAII0,
   bool modelPar_given_PBETAII0,
   AdmsSensFadType & modelPar_LBETAII1,
   bool modelPar_given_LBETAII1,
   AdmsSensFadType & modelPar_NBETAII1,
   bool modelPar_given_NBETAII1,
   AdmsSensFadType & modelPar_PBETAII1,
   bool modelPar_given_PBETAII1,
   AdmsSensFadType & modelPar_LBETAII2,
   bool modelPar_given_LBETAII2,
   AdmsSensFadType & modelPar_NBETAII2,
   bool modelPar_given_NBETAII2,
   AdmsSensFadType & modelPar_PBETAII2,
   bool modelPar_given_PBETAII2,
   AdmsSensFadType & modelPar_LESATII,
   bool modelPar_given_LESATII,
   AdmsSensFadType & modelPar_NESATII,
   bool modelPar_given_NESATII,
   AdmsSensFadType & modelPar_PESATII,
   bool modelPar_given_PESATII,
   AdmsSensFadType & modelPar_LLII,
   bool modelPar_given_LLII,
   AdmsSensFadType & modelPar_NLII,
   bool modelPar_given_NLII,
   AdmsSensFadType & modelPar_PLII,
   bool modelPar_given_PLII,
   AdmsSensFadType & modelPar_LSII0,
   bool modelPar_given_LSII0,
   AdmsSensFadType & modelPar_NSII0,
   bool modelPar_given_NSII0,
   AdmsSensFadType & modelPar_PSII0,
   bool modelPar_given_PSII0,
   AdmsSensFadType & modelPar_LSII1,
   bool modelPar_given_LSII1,
   AdmsSensFadType & modelPar_NSII1,
   bool modelPar_given_NSII1,
   AdmsSensFadType & modelPar_PSII1,
   bool modelPar_given_PSII1,
   AdmsSensFadType & modelPar_LSII2,
   bool modelPar_given_LSII2,
   AdmsSensFadType & modelPar_NSII2,
   bool modelPar_given_NSII2,
   AdmsSensFadType & modelPar_PSII2,
   bool modelPar_given_PSII2,
   AdmsSensFadType & modelPar_LSIID,
   bool modelPar_given_LSIID,
   AdmsSensFadType & modelPar_NSIID,
   bool modelPar_given_NSIID,
   AdmsSensFadType & modelPar_PSIID,
   bool modelPar_given_PSIID,
   AdmsSensFadType & modelPar_LCFS,
   bool modelPar_given_LCFS,
   AdmsSensFadType & modelPar_NCFS,
   bool modelPar_given_NCFS,
   AdmsSensFadType & modelPar_PCFS,
   bool modelPar_given_PCFS,
   AdmsSensFadType & modelPar_LCFD,
   bool modelPar_given_LCFD,
   AdmsSensFadType & modelPar_NCFD,
   bool modelPar_given_NCFD,
   AdmsSensFadType & modelPar_PCFD,
   bool modelPar_given_PCFD,
   AdmsSensFadType & modelPar_LCOVS,
   bool modelPar_given_LCOVS,
   AdmsSensFadType & modelPar_NCOVS,
   bool modelPar_given_NCOVS,
   AdmsSensFadType & modelPar_PCOVS,
   bool modelPar_given_PCOVS,
   AdmsSensFadType & modelPar_LCOVD,
   bool modelPar_given_LCOVD,
   AdmsSensFadType & modelPar_NCOVD,
   bool modelPar_given_NCOVD,
   AdmsSensFadType & modelPar_PCOVD,
   bool modelPar_given_PCOVD,
   AdmsSensFadType & modelPar_LCGSL,
   bool modelPar_given_LCGSL,
   AdmsSensFadType & modelPar_NCGSL,
   bool modelPar_given_NCGSL,
   AdmsSensFadType & modelPar_PCGSL,
   bool modelPar_given_PCGSL,
   AdmsSensFadType & modelPar_LCGDL,
   bool modelPar_given_LCGDL,
   AdmsSensFadType & modelPar_NCGDL,
   bool modelPar_given_NCGDL,
   AdmsSensFadType & modelPar_PCGDL,
   bool modelPar_given_PCGDL,
   AdmsSensFadType & modelPar_LCKAPPAS,
   bool modelPar_given_LCKAPPAS,
   AdmsSensFadType & modelPar_NCKAPPAS,
   bool modelPar_given_NCKAPPAS,
   AdmsSensFadType & modelPar_PCKAPPAS,
   bool modelPar_given_PCKAPPAS,
   AdmsSensFadType & modelPar_LCKAPPAD,
   bool modelPar_given_LCKAPPAD,
   AdmsSensFadType & modelPar_NCKAPPAD,
   bool modelPar_given_NCKAPPAD,
   AdmsSensFadType & modelPar_PCKAPPAD,
   bool modelPar_given_PCKAPPAD,
   AdmsSensFadType & modelPar_LCGBL,
   bool modelPar_given_LCGBL,
   AdmsSensFadType & modelPar_NCGBL,
   bool modelPar_given_NCGBL,
   AdmsSensFadType & modelPar_PCGBL,
   bool modelPar_given_PCGBL,
   AdmsSensFadType & modelPar_LCKAPPAB,
   bool modelPar_given_LCKAPPAB,
   AdmsSensFadType & modelPar_NCKAPPAB,
   bool modelPar_given_NCKAPPAB,
   AdmsSensFadType & modelPar_PCKAPPAB,
   bool modelPar_given_PCKAPPAB,
   AdmsSensFadType & modelPar_LNTGEN,
   bool modelPar_given_LNTGEN,
   AdmsSensFadType & modelPar_NNTGEN,
   bool modelPar_given_NNTGEN,
   AdmsSensFadType & modelPar_PNTGEN,
   bool modelPar_given_PNTGEN,
   AdmsSensFadType & modelPar_LAIGEN,
   bool modelPar_given_LAIGEN,
   AdmsSensFadType & modelPar_NAIGEN,
   bool modelPar_given_NAIGEN,
   AdmsSensFadType & modelPar_PAIGEN,
   bool modelPar_given_PAIGEN,
   AdmsSensFadType & modelPar_LBIGEN,
   bool modelPar_given_LBIGEN,
   AdmsSensFadType & modelPar_NBIGEN,
   bool modelPar_given_NBIGEN,
   AdmsSensFadType & modelPar_PBIGEN,
   bool modelPar_given_PBIGEN,
   AdmsSensFadType & modelPar_LXRCRG1,
   bool modelPar_given_LXRCRG1,
   AdmsSensFadType & modelPar_NXRCRG1,
   bool modelPar_given_NXRCRG1,
   AdmsSensFadType & modelPar_PXRCRG1,
   bool modelPar_given_PXRCRG1,
   AdmsSensFadType & modelPar_LXRCRG2,
   bool modelPar_given_LXRCRG2,
   AdmsSensFadType & modelPar_NXRCRG2,
   bool modelPar_given_NXRCRG2,
   AdmsSensFadType & modelPar_PXRCRG2,
   bool modelPar_given_PXRCRG2,
   AdmsSensFadType & modelPar_LUTE,
   bool modelPar_given_LUTE,
   AdmsSensFadType & modelPar_NUTE,
   bool modelPar_given_NUTE,
   AdmsSensFadType & modelPar_PUTE,
   bool modelPar_given_PUTE,
   AdmsSensFadType & modelPar_LUTER,
   bool modelPar_given_LUTER,
   AdmsSensFadType & modelPar_NUTER,
   bool modelPar_given_NUTER,
   AdmsSensFadType & modelPar_PUTER,
   bool modelPar_given_PUTER,
   AdmsSensFadType & modelPar_LUTL,
   bool modelPar_given_LUTL,
   AdmsSensFadType & modelPar_NUTL,
   bool modelPar_given_NUTL,
   AdmsSensFadType & modelPar_PUTL,
   bool modelPar_given_PUTL,
   AdmsSensFadType & modelPar_LUTLR,
   bool modelPar_given_LUTLR,
   AdmsSensFadType & modelPar_NUTLR,
   bool modelPar_given_NUTLR,
   AdmsSensFadType & modelPar_PUTLR,
   bool modelPar_given_PUTLR,
   AdmsSensFadType & modelPar_LEMOBT,
   bool modelPar_given_LEMOBT,
   AdmsSensFadType & modelPar_NEMOBT,
   bool modelPar_given_NEMOBT,
   AdmsSensFadType & modelPar_PEMOBT,
   bool modelPar_given_PEMOBT,
   AdmsSensFadType & modelPar_LUA1,
   bool modelPar_given_LUA1,
   AdmsSensFadType & modelPar_NUA1,
   bool modelPar_given_NUA1,
   AdmsSensFadType & modelPar_PUA1,
   bool modelPar_given_PUA1,
   AdmsSensFadType & modelPar_LUA1R,
   bool modelPar_given_LUA1R,
   AdmsSensFadType & modelPar_NUA1R,
   bool modelPar_given_NUA1R,
   AdmsSensFadType & modelPar_PUA1R,
   bool modelPar_given_PUA1R,
   AdmsSensFadType & modelPar_LUC1,
   bool modelPar_given_LUC1,
   AdmsSensFadType & modelPar_NUC1,
   bool modelPar_given_NUC1,
   AdmsSensFadType & modelPar_PUC1,
   bool modelPar_given_PUC1,
   AdmsSensFadType & modelPar_LUC1R,
   bool modelPar_given_LUC1R,
   AdmsSensFadType & modelPar_NUC1R,
   bool modelPar_given_NUC1R,
   AdmsSensFadType & modelPar_PUC1R,
   bool modelPar_given_PUC1R,
   AdmsSensFadType & modelPar_LUD1,
   bool modelPar_given_LUD1,
   AdmsSensFadType & modelPar_NUD1,
   bool modelPar_given_NUD1,
   AdmsSensFadType & modelPar_PUD1,
   bool modelPar_given_PUD1,
   AdmsSensFadType & modelPar_LUD1R,
   bool modelPar_given_LUD1R,
   AdmsSensFadType & modelPar_NUD1R,
   bool modelPar_given_NUD1R,
   AdmsSensFadType & modelPar_PUD1R,
   bool modelPar_given_PUD1R,
   AdmsSensFadType & modelPar_LUCSTE,
   bool modelPar_given_LUCSTE,
   AdmsSensFadType & modelPar_NUCSTE,
   bool modelPar_given_NUCSTE,
   AdmsSensFadType & modelPar_PUCSTE,
   bool modelPar_given_PUCSTE,
   AdmsSensFadType & modelPar_LPTWGT,
   bool modelPar_given_LPTWGT,
   AdmsSensFadType & modelPar_NPTWGT,
   bool modelPar_given_NPTWGT,
   AdmsSensFadType & modelPar_PPTWGT,
   bool modelPar_given_PPTWGT,
   AdmsSensFadType & modelPar_LAT,
   bool modelPar_given_LAT,
   AdmsSensFadType & modelPar_NAT,
   bool modelPar_given_NAT,
   AdmsSensFadType & modelPar_PAT,
   bool modelPar_given_PAT,
   AdmsSensFadType & modelPar_LATR,
   bool modelPar_given_LATR,
   AdmsSensFadType & modelPar_NATR,
   bool modelPar_given_NATR,
   AdmsSensFadType & modelPar_PATR,
   bool modelPar_given_PATR,
   AdmsSensFadType & modelPar_LATCV,
   bool modelPar_given_LATCV,
   AdmsSensFadType & modelPar_NATCV,
   bool modelPar_given_NATCV,
   AdmsSensFadType & modelPar_PATCV,
   bool modelPar_given_PATCV,
   AdmsSensFadType & modelPar_LSTTHETASAT,
   bool modelPar_given_LSTTHETASAT,
   AdmsSensFadType & modelPar_NSTTHETASAT,
   bool modelPar_given_NSTTHETASAT,
   AdmsSensFadType & modelPar_PSTTHETASAT,
   bool modelPar_given_PSTTHETASAT,
   AdmsSensFadType & modelPar_LPRT,
   bool modelPar_given_LPRT,
   AdmsSensFadType & modelPar_NPRT,
   bool modelPar_given_NPRT,
   AdmsSensFadType & modelPar_PPRT,
   bool modelPar_given_PPRT,
   AdmsSensFadType & modelPar_LKT1,
   bool modelPar_given_LKT1,
   AdmsSensFadType & modelPar_NKT1,
   bool modelPar_given_NKT1,
   AdmsSensFadType & modelPar_PKT1,
   bool modelPar_given_PKT1,
   AdmsSensFadType & modelPar_LTSS,
   bool modelPar_given_LTSS,
   AdmsSensFadType & modelPar_NTSS,
   bool modelPar_given_NTSS,
   AdmsSensFadType & modelPar_PTSS,
   bool modelPar_given_PTSS,
   AdmsSensFadType & modelPar_LIIT,
   bool modelPar_given_LIIT,
   AdmsSensFadType & modelPar_NIIT,
   bool modelPar_given_NIIT,
   AdmsSensFadType & modelPar_PIIT,
   bool modelPar_given_PIIT,
   AdmsSensFadType & modelPar_LTII,
   bool modelPar_given_LTII,
   AdmsSensFadType & modelPar_NTII,
   bool modelPar_given_NTII,
   AdmsSensFadType & modelPar_PTII,
   bool modelPar_given_PTII,
   AdmsSensFadType & modelPar_LTGIDL,
   bool modelPar_given_LTGIDL,
   AdmsSensFadType & modelPar_NTGIDL,
   bool modelPar_given_NTGIDL,
   AdmsSensFadType & modelPar_PTGIDL,
   bool modelPar_given_PTGIDL,
   AdmsSensFadType & modelPar_LIGT,
   bool modelPar_given_LIGT,
   AdmsSensFadType & modelPar_NIGT,
   bool modelPar_given_NIGT,
   AdmsSensFadType & modelPar_PIGT,
   bool modelPar_given_PIGT,
   // non-reals (including hidden)
   int modelPar_NF,
   bool modelPar_given_NF,
   int modelPar_NGCON,
   bool modelPar_given_NGCON,
   int modelPar_DEVTYPE,
   bool modelPar_given_DEVTYPE,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   int modelPar_BULKMOD,
   bool modelPar_given_BULKMOD,
   int modelPar_GEOMOD,
   bool modelPar_given_GEOMOD,
   int modelPar_CGEO1SW,
   bool modelPar_given_CGEO1SW,
   int modelPar_RDSMOD,
   bool modelPar_given_RDSMOD,
   int modelPar_ASYMMOD,
   bool modelPar_given_ASYMMOD,
   int modelPar_IGCMOD,
   bool modelPar_given_IGCMOD,
   int modelPar_IGBMOD,
   bool modelPar_given_IGBMOD,
   int modelPar_GIDLMOD,
   bool modelPar_given_GIDLMOD,
   int modelPar_IIMOD,
   bool modelPar_given_IIMOD,
   int modelPar_TNOIMOD,
   bool modelPar_given_TNOIMOD,
   int modelPar_NQSMOD,
   bool modelPar_given_NQSMOD,
   int modelPar_SHMOD,
   bool modelPar_given_SHMOD,
   int modelPar_TEMPMOD,
   bool modelPar_given_TEMPMOD,
   int modelPar_RGATEMOD,
   bool modelPar_given_RGATEMOD,
   int modelPar_RGEOMOD,
   bool modelPar_given_RGEOMOD,
   int modelPar_CGEOMOD,
   bool modelPar_given_CGEOMOD,
   int modelPar_SH_WARN,
   bool modelPar_given_SH_WARN,
   int modelPar_IGCLAMP,
   bool modelPar_given_IGCLAMP,
   int modelPar_SDTERM,
   bool modelPar_given_SDTERM,
   int modelPar_NSEG,
   bool modelPar_given_NSEG,
   // basic variables
   double admsTemperature, double adms_vt_nom, double gmin, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance)
{

  // Local variables
  double Abulk;
  AdmsSensFadType etaa;
  AdmsSensFadType epsilon;
  AdmsSensFadType npart_c;
  AdmsSensFadType npart_beta;
  AdmsSensFadType npart_theta;
  AdmsSensFadType gche;
  AdmsSensFadType noiGd0;
  AdmsSensFadType GammaGd0;
  AdmsSensFadType Swi;
  AdmsSensFadType Ssi;
  AdmsSensFadType Nstar;
  AdmsSensFadType Nl;
  AdmsSensFadType N0;
  AdmsSensFadType DelClm;
  AdmsSensFadType Leffnoisq;
  AdmsSensFadType Leffnoi;
  AdmsSensFadType Esatnoi;
  AdmsSensFadType vge_overlap;
  AdmsSensFadType Qedj3;
  AdmsSensFadType Qedj2;
  AdmsSensFadType Qedj1;
  AdmsSensFadType Qesj3;
  AdmsSensFadType Qesj2;
  AdmsSensFadType vec;
  AdmsSensFadType pb2;
  AdmsSensFadType Qec;
  AdmsSensFadType arg;
  AdmsSensFadType sarg;
  AdmsSensFadType Qesj1;
  AdmsSensFadType T4a;
  AdmsSensFadType T1_exp;
  AdmsSensFadType Vdseffx;
  AdmsSensFadType igc0;
  AdmsSensFadType Voxacc;
  AdmsSensFadType Vaux_Igbacc;
  AdmsSensFadType vfbzb;
  AdmsSensFadType Vaux_Igbinv;
  AdmsSensFadType ALPHAII;
  AdmsSensFadType VgsStep;
  AdmsSensFadType Vdsatii;
  AdmsSensFadType Vdiff;
  AdmsSensFadType Ratio;
  AdmsSensFadType cgsp;
  AdmsSensFadType cgdp;
  AdmsSensFadType vgd_overlap;
  AdmsSensFadType vgs_overlap;
  AdmsSensFadType qgd_ov;
  AdmsSensFadType qgs_ov;
  AdmsSensFadType qinv;
  AdmsSensFadType inv_MclmCV;
  AdmsSensFadType vgs_eff;
  AdmsSensFadType vgd_eff;
  AdmsSensFadType ids0;
  AdmsSensFadType ids0_ov_dqi;
  AdmsSensFadType MclmCV;
  AdmsSensFadType DvsatCV;
  AdmsSensFadType EsatCVL;
  AdmsSensFadType EsatCV;
  AdmsSensFadType Mob;
  AdmsSensFadType Mnud;
  AdmsSensFadType Nsat;
  AdmsSensFadType Dvsat;
  AdmsSensFadType Esat1L;
  AdmsSensFadType Esat1;
  AdmsSensFadType Mclm;
  AdmsSensFadType Moc;
  AdmsSensFadType VaDIBL;
  AdmsSensFadType Vgst2Vtm;
  AdmsSensFadType diffVds;
  AdmsSensFadType PVAGfactor;
  AdmsSensFadType DIBLfactor;
  AdmsSensFadType Dmob_cv;
  AdmsSensFadType Eeffm_cv;
  AdmsSensFadType ueff;
  AdmsSensFadType Dmob;
  AdmsSensFadType Eeffm;
  AdmsSensFadType beta;
  AdmsSensFadType coxeff;
  AdmsSensFadType qia2;
  AdmsSensFadType dqi;
  AdmsSensFadType qia;
  AdmsSensFadType T10;
  AdmsSensFadType T9;
  AdmsSensFadType Vdseff;
  AdmsSensFadType Vdsat;
  AdmsSensFadType Tc;
  AdmsSensFadType Ta;
  AdmsSensFadType WVCox;
  AdmsSensFadType T6;
  AdmsSensFadType EsatL;
  AdmsSensFadType Esat;
  AdmsSensFadType Rdss;
  AdmsSensFadType Dmobs;
  AdmsSensFadType qb0;
  AdmsSensFadType Eeffs;
  AdmsSensFadType T5;
  AdmsSensFadType T4;
  AdmsSensFadType T8;
  AdmsSensFadType T7;
  AdmsSensFadType vch;
  AdmsSensFadType vgsfbeff;
  AdmsSensFadType beta0;
  AdmsSensFadType dvth_all;
  AdmsSensFadType dvth_rsce;
  AdmsSensFadType dvth_dibl;
  AdmsSensFadType dvth_vtroll;
  AdmsSensFadType nVtm;
  AdmsSensFadType cdsc;
  AdmsSensFadType phist;
  AdmsSensFadType inv_MEXP;
  AdmsSensFadType EU_a;
  AdmsSensFadType UC_a;
  AdmsSensFadType UD_a;
  AdmsSensFadType UA_a;
  AdmsSensFadType u0_a;
  AdmsSensFadType CIT_a;
  AdmsSensFadType DVTSHIFT_a;
  AdmsSensFadType KSATIV_a;
  AdmsSensFadType PCLM_a;
  AdmsSensFadType RDDR_a;
  AdmsSensFadType RSDR_a;
  AdmsSensFadType VSAT1_a;
  AdmsSensFadType PTWG_a;
  AdmsSensFadType MEXP_a;
  AdmsSensFadType PDIBL2_a;
  AdmsSensFadType PDIBL1_a;
  AdmsSensFadType ETA0_a;
  AdmsSensFadType CDSCD_a;
  AdmsSensFadType wr;
  AdmsSensFadType wf;
  AdmsSensFadType vesmax;
  double vesx;
  double vdsx;
  AdmsSensFadType Qedj;
  AdmsSensFadType Qesj;
  AdmsSensFadType etaiv;
  AdmsSensFadType vgsfb;
  double ves;
  double vds;
  double vgs;
  double vge;
  double ved_jct;
  double ves_jct;
  double vgd_noswap;
  double vds_noswap;
  double vgs_noswap;
  AdmsSensFadType TRatio;
  AdmsSensFadType delTemp;
  AdmsSensFadType Vtm;
  AdmsSensFadType Vtm0;
  AdmsSensFadType Eg;
  AdmsSensFadType Eg0;
  AdmsSensFadType ni;
  AdmsSensFadType Nc;
  AdmsSensFadType ThetaSS;
  AdmsSensFadType kT;
  AdmsSensFadType E0;
  AdmsSensFadType E0prime;
  AdmsSensFadType E1;
  AdmsSensFadType E1prime;
  AdmsSensFadType gam0;
  AdmsSensFadType gam1;
  AdmsSensFadType dvch_qm;
  AdmsSensFadType ETA0_t;
  AdmsSensFadType ETA0R_t;
  AdmsSensFadType U0_t;
  AdmsSensFadType u0;
  AdmsSensFadType ETAMOB_t;
  AdmsSensFadType UA_t;
  AdmsSensFadType UD_t;
  AdmsSensFadType UCS_t;
  AdmsSensFadType rdstemp;
  AdmsSensFadType RSDR_t;
  AdmsSensFadType RDDR_t;
  AdmsSensFadType VSAT_t;
  AdmsSensFadType VSAT1_t;
  AdmsSensFadType VSATCV_t;
  AdmsSensFadType MEXP_t;
  AdmsSensFadType PTWG_t;
  AdmsSensFadType dvth_temp;
  AdmsSensFadType BETA0_t;
  AdmsSensFadType SII0_t;
  AdmsSensFadType K0_t;
  AdmsSensFadType K0SI_t;
  AdmsSensFadType K2SI_t;
  AdmsSensFadType K1_t;
  AdmsSensFadType K2SAT_t;
  AdmsSensFadType A1_t;
  AdmsSensFadType A2_t;
  AdmsSensFadType K2_t;
  AdmsSensFadType K0SISAT_t;
  AdmsSensFadType K2SISAT_t;
  AdmsSensFadType AIGBINV_t;
  AdmsSensFadType AIGBACC_t;
  AdmsSensFadType AIGC_t;
  AdmsSensFadType AIGS_t;
  AdmsSensFadType AIGD_t;
  AdmsSensFadType BGIDL_t;
  AdmsSensFadType BGISL_t;
  AdmsSensFadType ALPHA0_t;
  AdmsSensFadType ALPHA1_t;
  AdmsSensFadType ALPHAII0_t;
  AdmsSensFadType ALPHAII1_t;
  AdmsSensFadType igtemp;
  AdmsSensFadType igsd_mult;
  AdmsSensFadType vfbsd;
  AdmsSensFadType vfbsdcv;
  AdmsSensFadType phib;
  AdmsSensFadType vbi;
  AdmsSensFadType deltaPhi;
  AdmsSensFadType eta_mu;
  double eta_mu_cv;
  AdmsSensFadType Tb;
  AdmsSensFadType igentemp;
  AdmsSensFadType DevTemp;


  // -- code converted from analog/code block
  if (((modelPar_SHMOD!=0)&&(modelPar_RTH0>0.0)))
  {
    DevTemp = ((admsTemperature+(probeVars[admsProbeID_Temp_t_GND]))+modelPar_DTEMP);
  }
  else
  {
    DevTemp = (admsTemperature+modelPar_DTEMP);
  }
  //Begin block CMGTempDepCalc
  {
    TRatio = (DevTemp/instanceVar_Tnom);
    delTemp = (DevTemp-instanceVar_Tnom);
    Vtm = (8.617087e-5*DevTemp);
    Vtm0 = (8.617087e-5*instanceVar_Tnom);
    Eg = (modelPar_BG0SUB-(((modelPar_TBGASUB*DevTemp)*DevTemp)/(DevTemp+modelPar_TBGBSUB)));
    Eg0 = (modelPar_BG0SUB-(((modelPar_TBGASUB*instanceVar_Tnom)*instanceVar_Tnom)/(instanceVar_Tnom+modelPar_TBGBSUB)));
    instanceVar_T1 = ((DevTemp/300.15)*sqrt((DevTemp/300.15)));
    ni = ((modelPar_NI0SUB*instanceVar_T1)*AnalogFunctions::lexp<AdmsSensFadType>(((modelPar_BG0SUB/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm)))));
    Nc = (modelPar_NC0SUB*instanceVar_T1);
    ThetaSS = AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(instanceVar_TSS_i*delTemp))-1.0e-6),1.0e-3);
    kT = (Vtm*1.60219e-19);
    instanceVar_T0 = ((1.05457e-34*3.14159265358979323846)/((2*instanceVar_Ach)/instanceVar_Weff_UFCM));
    E0 = ((instanceVar_T0*instanceVar_T0)/(2.0*instanceVar_mx));
    E0prime = ((instanceVar_T0*instanceVar_T0)/(2.0*instanceVar_mxprime));
    E1 = (4.0*E0);
    E1prime = (4.0*E0prime);
    instanceVar_T1 = ((instanceVar_gprime*instanceVar_mdprime)/(instanceVar_gfactor*instanceVar_md));
    gam0 = (1.0+(instanceVar_T1*AnalogFunctions::lexp<AdmsSensFadType>(((E0-E0prime)/kT))));
    gam1 = ((gam0+AnalogFunctions::lexp<AdmsSensFadType>(((E0-E1)/kT)))+(instanceVar_T1*AnalogFunctions::lexp<AdmsSensFadType>(((E0-E1prime)/kT))));
    instanceVar_T2 = ((-Vtm)*AnalogFunctions::lln<AdmsSensFadType>((((((instanceVar_gfactor*instanceVar_md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*instanceVar_Ach)/instanceVar_Weff_UFCM))*gam1)));
    dvch_qm = (instanceVar_QMFACTOR_i*((E0/1.60219e-19)+instanceVar_T2));
    ETA0_t = AnalogFunctions::Tempdep<AdmsSensFadType>(instanceVar_ETA0_i,modelPar_TETA0,delTemp,modelPar_TEMPMOD);
    ETA0R_t = AnalogFunctions::Tempdep<AdmsSensFadType>(instanceVar_ETA0R_i,modelPar_TETA0R,delTemp,modelPar_TEMPMOD);
    instanceVar_T1 = (instanceVar_U0_i*pow(TRatio,instanceVar_UTE_i));
    U0_t = (instanceVar_T1+AnalogFunctions::hypmax<AdmsSensFadType>((instanceVar_UTL_i*delTemp),((-0.9)*instanceVar_T1),1.0e-4));
    u0 = U0_t;
    if ((modelPar_ASYMMOD==1))
    {
      instanceVar_T1 = (instanceVar_U0R_i*pow(TRatio,instanceVar_UTER_i));
      instanceVar_U0R_t = (instanceVar_T1+AnalogFunctions::hypmax<AdmsSensFadType>((instanceVar_UTLR_i*delTemp),((-0.9)*instanceVar_T1),1.0e-4));
      instanceVar_u0r = instanceVar_U0R_t;
    }
    ETAMOB_t = AnalogFunctions::Tempdep<AdmsSensFadType>(instanceVar_ETAMOB_i,instanceVar_EMOBT_i,delTemp,modelPar_TEMPMOD);
    UA_t = (instanceVar_UA_i+AnalogFunctions::hypmax<AdmsSensFadType>((instanceVar_UA1_i*delTemp),(-instanceVar_UA_i),1.0e-6));
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_UAR_t = (instanceVar_UAR_i+AnalogFunctions::hypmax<AdmsSensFadType>((instanceVar_UA1R_i*delTemp),(-instanceVar_UAR_i),1.0e-6));
    }
    if ((modelPar_BULKMOD!=0))
    {
      if ((modelPar_TEMPMOD==0))
      {
        instanceVar_UC_t = AnalogFunctions::Tempdep<AdmsSensFadType>(instanceVar_UC_i,instanceVar_UC1_i,delTemp,0);
        if ((modelPar_ASYMMOD!=0))
        {
          instanceVar_UCR_t = AnalogFunctions::Tempdep<AdmsSensFadType>(instanceVar_UCR_i,instanceVar_UC1R_i,delTemp,0);
        }
      }
      else
      {
        instanceVar_UC_t = (instanceVar_UC_i+(instanceVar_UC1_i*delTemp));
        if ((modelPar_ASYMMOD!=0))
        {
          instanceVar_UCR_t = (instanceVar_UCR_i+(instanceVar_UC1R_i*delTemp));
        }
      }
    }
    UD_t = (instanceVar_UD_i*pow(TRatio,instanceVar_UD1_i));
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_UDR_t = (instanceVar_UDR_i*pow(TRatio,instanceVar_UD1R_i));
    }
    UCS_t = (instanceVar_UCS_i*pow(TRatio,instanceVar_UCSTE_i));
    rdstemp = AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(instanceVar_PRT_i*delTemp))-1.0e-6),1.0e-3);
    RSDR_t = AnalogFunctions::Tempdep<AdmsSensFadType>(modelPar_RSDR,modelPar_TRSDR,delTemp,modelPar_TEMPMOD);
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_RSDRR_t = AnalogFunctions::Tempdep<AdmsSensFadType>(modelPar_RSDRR,modelPar_TRSDR,delTemp,modelPar_TEMPMOD);
    }
    RDDR_t = AnalogFunctions::Tempdep<AdmsSensFadType>(modelPar_RDDR,modelPar_TRDDR,delTemp,modelPar_TEMPMOD);
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_RDDRR_t = AnalogFunctions::Tempdep<AdmsSensFadType>(modelPar_RDDRR,modelPar_TRDDR,delTemp,modelPar_TEMPMOD);
    }
    VSAT_t = AnalogFunctions::Tempdep<AdmsSensFadType>(instanceVar_VSAT_i,(-instanceVar_AT_i),delTemp,modelPar_TEMPMOD);
    if ((VSAT_t<1000))
    {
      std::cerr  << "Warning: VSAT(%f) = %e is less than 1K, setting it to 1K." << DevTemp << VSAT_t <<  std::endl; 
      VSAT_t = 1000;
    }
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_VSATR_t = AnalogFunctions::Tempdep<AdmsSensFadType>(instanceVar_VSATR_i,(-instanceVar_ATR_i),delTemp,modelPar_TEMPMOD);
      if ((instanceVar_VSATR_t<1000))
      {
        std::cerr  << "Warning: VSATR(%f) = %e is less than 1K, setting it to 1K." << DevTemp << instanceVar_VSATR_t <<  std::endl; 
        instanceVar_VSATR_t = 1000;
      }
    }
    VSAT1_t = AnalogFunctions::Tempdep<AdmsSensFadType>(instanceVar_VSAT1_i,(-instanceVar_AT_i),delTemp,modelPar_TEMPMOD);
    if ((VSAT1_t<1000))
    {
      std::cerr  << "Warning: VSAT1(%f) = %e is less than 1K, setting it to 1K." << DevTemp << VSAT1_t <<  std::endl; 
      VSAT1_t = 1000;
    }
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_VSAT1R_t = AnalogFunctions::Tempdep<AdmsSensFadType>(instanceVar_VSAT1R_i,(-instanceVar_AT_i),delTemp,modelPar_TEMPMOD);
      if ((instanceVar_VSAT1R_t<1000))
      {
        std::cerr  << "Warning: VSAT1R(%f) = %e is less than 1K, setting it to 1K." << DevTemp << instanceVar_VSAT1R_t <<  std::endl; 
        instanceVar_VSAT1R_t = 1000;
      }
    }
    VSATCV_t = AnalogFunctions::Tempdep<AdmsSensFadType>(instanceVar_VSATCV_i,(-instanceVar_ATCV_i),delTemp,modelPar_TEMPMOD);
    if ((VSATCV_t<1000))
    {
      std::cerr  << "Warning: VSATCV(%f) = %e is less than 1K, setting it to 1K." << DevTemp << VSATCV_t <<  std::endl; 
      VSATCV_t = 1000;
    }
    MEXP_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((instanceVar_MEXP_i*(1.0+(modelPar_TMEXP*delTemp)))-2.0),1.0e-3)+2.0);
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_MEXPR_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((instanceVar_MEXPR_i*(1.0+(modelPar_TMEXPR*delTemp)))-2.0),1.0e-3)+2.0);
    }
    PTWG_t = AnalogFunctions::Tempdep<AdmsSensFadType>(instanceVar_PTWG_i,(-instanceVar_PTWGT_i),delTemp,modelPar_TEMPMOD);
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_PTWGR_t = AnalogFunctions::Tempdep<AdmsSensFadType>(instanceVar_PTWGR_i,(-instanceVar_PTWGT_i),delTemp,modelPar_TEMPMOD);
    }
    dvth_temp = ((instanceVar_KT1_i+(modelPar_KT1L/instanceVar_Leff))*(TRatio-1.0));
    BETA0_t = (instanceVar_BETA0_i*pow(TRatio,instanceVar_IIT_i));
    SII0_t = (instanceVar_SII0_i*(AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(instanceVar_TII_i*(TRatio-1.0)))-0.01),1.0e-3)+0.01));
    K0_t = (instanceVar_K0_i+(instanceVar_K01_i*delTemp));
    K0SI_t = (instanceVar_K0SI_i+AnalogFunctions::hypmax<AdmsSensFadType>((instanceVar_K0SI1_i*delTemp),(-instanceVar_K0SI_i),1.0e-6));
    K2SI_t = (instanceVar_K2SI_i+AnalogFunctions::hypmax<AdmsSensFadType>((instanceVar_K2SI1_i*delTemp),(-instanceVar_K2SI_i),1.0e-6));
    K1_t = (instanceVar_K1_i+AnalogFunctions::hypmax<AdmsSensFadType>((instanceVar_K11_i*delTemp),(-instanceVar_K1_i),1.0e-6));
    K2SAT_t = (instanceVar_K2SAT_i+(instanceVar_K2SAT1_i*delTemp));
    A1_t = (instanceVar_A1_i+(instanceVar_A11_i*delTemp));
    A2_t = (instanceVar_A2_i+(instanceVar_A21_i*delTemp));
    K2_t = (instanceVar_K2_i+AnalogFunctions::hypmax<AdmsSensFadType>((instanceVar_K21_i*delTemp),(-instanceVar_K2_i),1.0e-6));
    K0SISAT_t = (instanceVar_K0SISAT_i+(instanceVar_K0SISAT1_i*delTemp));
    K2SISAT_t = (instanceVar_K2SISAT_i+(instanceVar_K2SISAT1_i*delTemp));
    AIGBINV_t = (instanceVar_AIGBINV_i+AnalogFunctions::hypmax<AdmsSensFadType>((instanceVar_AIGBINV1_i*delTemp),(-instanceVar_AIGBINV_i),1.0e-6));
    AIGBACC_t = (instanceVar_AIGBACC_i+AnalogFunctions::hypmax<AdmsSensFadType>((instanceVar_AIGBACC1_i*delTemp),(-instanceVar_AIGBACC_i),1.0e-6));
    AIGC_t = (instanceVar_AIGC_i+AnalogFunctions::hypmax<AdmsSensFadType>((instanceVar_AIGC1_i*delTemp),(-instanceVar_AIGC_i),1.0e-6));
    AIGS_t = (instanceVar_AIGS_i+AnalogFunctions::hypmax<AdmsSensFadType>((instanceVar_AIGS1_i*delTemp),(-instanceVar_AIGS_i),1.0e-6));
    AIGD_t = (instanceVar_AIGD_i+AnalogFunctions::hypmax<AdmsSensFadType>((instanceVar_AIGD1_i*delTemp),(-instanceVar_AIGD_i),1.0e-6));
    BGIDL_t = (instanceVar_BGIDL_i*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(instanceVar_TGIDL_i*delTemp))-1.0e-6),1.0e-3));
    BGISL_t = (instanceVar_BGISL_i*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(instanceVar_TGIDL_i*delTemp))-1.0e-6),1.0e-3));
    ALPHA0_t = (instanceVar_ALPHA0_i+AnalogFunctions::hypmax<AdmsSensFadType>((modelPar_ALPHA01*delTemp),(-instanceVar_ALPHA0_i),1.0e-6));
    ALPHA1_t = (instanceVar_ALPHA1_i+AnalogFunctions::hypmax<AdmsSensFadType>((modelPar_ALPHA11*delTemp),(-instanceVar_ALPHA1_i),1.0e-6));
    ALPHAII0_t = (instanceVar_ALPHAII0_i+AnalogFunctions::hypmax<AdmsSensFadType>((modelPar_ALPHAII01*delTemp),(-instanceVar_ALPHAII0_i),1.0e-25));
    ALPHAII1_t = (instanceVar_ALPHAII1_i+AnalogFunctions::hypmax<AdmsSensFadType>((modelPar_ALPHAII11*delTemp),(-instanceVar_ALPHAII1_i),1.0e-20));
    igtemp = AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_IGT_i*AnalogFunctions::lln<AdmsSensFadType>(TRatio)));
    igsd_mult = (instanceVar_igsd_mult0*igtemp);
    if ((modelPar_BULKMOD!=0))
    {
      instanceVar_CJS_t = AnalogFunctions::Tempdep<AdmsSensFadType>(modelPar_CJS,modelPar_TCJ,delTemp,modelPar_TEMPMOD);
      instanceVar_CJD_t = AnalogFunctions::Tempdep<AdmsSensFadType>(modelPar_CJD,modelPar_TCJ,delTemp,modelPar_TEMPMOD);
      instanceVar_CJSWS_t = AnalogFunctions::Tempdep<AdmsSensFadType>(modelPar_CJSWS,modelPar_TCJSW,delTemp,modelPar_TEMPMOD);
      instanceVar_CJSWD_t = AnalogFunctions::Tempdep<AdmsSensFadType>(modelPar_CJSWD,modelPar_TCJSW,delTemp,modelPar_TEMPMOD);
      instanceVar_CJSWGS_t = AnalogFunctions::Tempdep<AdmsSensFadType>(modelPar_CJSWGS,modelPar_TCJSWG,delTemp,modelPar_TEMPMOD);
      instanceVar_CJSWGD_t = AnalogFunctions::Tempdep<AdmsSensFadType>(modelPar_CJSWGD,modelPar_TCJSWG,delTemp,modelPar_TEMPMOD);
      instanceVar_PBS_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_PBS-(modelPar_TPB*delTemp))-0.01),1.0e-3)+0.01);
      instanceVar_PBD_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_PBD-(modelPar_TPB*delTemp))-0.01),1.0e-3)+0.01);
      instanceVar_PBSWS_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_PBSWS-(modelPar_TPBSW*delTemp))-0.01),1.0e-3)+0.01);
      instanceVar_PBSWD_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_PBSWD-(modelPar_TPBSW*delTemp))-0.01),1.0e-3)+0.01);
      instanceVar_PBSWGS_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_PBSWGS-(modelPar_TPBSWG*delTemp))-0.01),1.0e-3)+0.01);
      instanceVar_PBSWGD_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_PBSWGD-(modelPar_TPBSWG*delTemp))-0.01),1.0e-3)+0.01);
      instanceVar_T0 = ((Eg0/Vtm0)-(Eg/Vtm));
      instanceVar_T1 = AnalogFunctions::lln<AdmsSensFadType>(TRatio);
      instanceVar_T3 = AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0+(modelPar_XTIS*instanceVar_T1))/modelPar_NJS));
      instanceVar_JSS_t = (modelPar_JSS*instanceVar_T3);
      instanceVar_JSWS_t = (modelPar_JSWS*instanceVar_T3);
      instanceVar_JSWGS_t = (modelPar_JSWGS*instanceVar_T3);
      instanceVar_T3 = AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0+(modelPar_XTID*instanceVar_T1))/modelPar_NJD));
      instanceVar_JSD_t = (modelPar_JSD*instanceVar_T3);
      instanceVar_JSWD_t = (modelPar_JSWD*instanceVar_T3);
      instanceVar_JSWGD_t = (modelPar_JSWGD*instanceVar_T3);
      instanceVar_JTSS_t = (modelPar_JTSS*AnalogFunctions::lexp<AdmsSensFadType>((((Eg0*modelPar_XTSS)*(TRatio-1.0))/Vtm)));
      instanceVar_JTSD_t = (modelPar_JTSD*AnalogFunctions::lexp<AdmsSensFadType>((((Eg0*modelPar_XTSD)*(TRatio-1.0))/Vtm)));
      instanceVar_JTSSWS_t = (modelPar_JTSSWS*AnalogFunctions::lexp<AdmsSensFadType>((((Eg0*modelPar_XTSSWS)*(TRatio-1.0))/Vtm)));
      instanceVar_JTSSWD_t = (modelPar_JTSSWD*AnalogFunctions::lexp<AdmsSensFadType>((((Eg0*modelPar_XTSSWD)*(TRatio-1.0))/Vtm)));
      instanceVar_JTSSWGS_t = ((modelPar_JTSSWGS*(sqrt((modelPar_JTWEFF/instanceVar_Weff0))+1.0))*AnalogFunctions::lexp<AdmsSensFadType>((((Eg0*modelPar_XTSSWGS)*(TRatio-1.0))/Vtm)));
      instanceVar_JTSSWGD_t = ((modelPar_JTSSWGD*(sqrt((modelPar_JTWEFF/instanceVar_Weff0))+1.0))*AnalogFunctions::lexp<AdmsSensFadType>((((Eg0*modelPar_XTSSWGD)*(TRatio-1.0))/Vtm)));
      instanceVar_NJTS_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_NJTS*(1.0+(modelPar_TNJTS*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
      instanceVar_NJTSD_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_NJTSD*(1.0+(modelPar_TNJTSD*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
      instanceVar_NJTSSW_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_NJTSSW*(1.0+(modelPar_TNJTSSW*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
      instanceVar_NJTSSWD_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_NJTSSWD*(1.0+(modelPar_TNJTSSWD*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
      instanceVar_NJTSSWG_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_NJTSSWG*(1.0+(modelPar_TNJTSSWG*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
      instanceVar_NJTSSWGD_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_NJTSSWGD*(1.0+(modelPar_TNJTSSWGD*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
    }
    if ((!modelPar_given_VFBSD))
    {
      if ((modelPar_NGATE>0.0))
      {
        vfbsd = (instanceVar_devsign*(AnalogFunctions::hypsmooth<AdmsSensFadType>(((0.5*Eg)-(Vtm*AnalogFunctions::lln<AdmsSensFadType>((modelPar_NGATE/ni)))),1.0e-4)-((0.5*Eg)-(instanceVar_devsign*((0.5*Eg)-AnalogFunctions::hypsmooth<AdmsSensFadType>(((0.5*Eg)-(Vtm*AnalogFunctions::lln<AdmsSensFadType>((modelPar_NSD/ni)))),1.0e-4))))));
      }
      else
      {
        vfbsd = (instanceVar_devsign*(instanceVar_PHIG_i-((modelPar_EASUB+(0.5*Eg))-(instanceVar_devsign*((0.5*Eg)-AnalogFunctions::hypsmooth<AdmsSensFadType>(((0.5*Eg)-(Vtm*AnalogFunctions::lln<AdmsSensFadType>((modelPar_NSD/ni)))),1.0e-4))))));
      }
    }
    else
    {
      vfbsd = modelPar_VFBSD;
    }
    if ((!modelPar_given_VFBSDCV))
    {
      vfbsdcv = vfbsd;
    }
    else
    {
      vfbsdcv = modelPar_VFBSDCV;
    }
    if (((modelPar_SHMOD!=0)&&(modelPar_RTH0>0.0)))
    {
      instanceVar_T0 = (Vtm*AnalogFunctions::lln<AdmsSensFadType>((instanceVar_nbody/ni)));
      phib = sqrt(((instanceVar_T0*instanceVar_T0)+1.0e-6));
    }
    else
    {
      phib = (Vtm*AnalogFunctions::lln<AdmsSensFadType>((instanceVar_nbody/ni)));
    }
    if (((modelPar_SHMOD!=0)&&(modelPar_RTH0>0.0)))
    {
      instanceVar_T0 = (Vtm*AnalogFunctions::lln<AdmsSensFadType>(((instanceVar_nbody*modelPar_NSD)/(ni*ni))));
      vbi = sqrt(((instanceVar_T0*instanceVar_T0)+1.0e-6));
    }
    else
    {
      vbi = (Vtm*AnalogFunctions::lln<AdmsSensFadType>(((instanceVar_nbody*modelPar_NSD)/(ni*ni))));
    }
    deltaPhi = (instanceVar_devsign*(instanceVar_PHIG_i-(modelPar_EASUB+adms_ternary_op<AdmsSensFadType>((modelPar_TYPE==1),0,Eg))));
    eta_mu = (0.5*ETAMOB_t);
    eta_mu_cv = 0.5;
    if ((modelPar_TYPE!=1))
    {
      eta_mu = ((1.0/3.0)*ETAMOB_t);
      eta_mu_cv = (1.0/3.0);
    }
    if ((modelPar_BULKMOD!=0))
    {
      instanceVar_Isbs = (((instancePar_ASEJ*instanceVar_JSS_t)+(instancePar_PSEJ*instanceVar_JSWS_t))+((instancePar_TFIN*instanceVar_NFINtotal)*instanceVar_JSWGS_t));
      if ((instanceVar_Isbs>0.0))
      {
        instanceVar_Nvtms = (Vtm*modelPar_NJS);
        instanceVar_XExpBVS = (AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_BVS)/instanceVar_Nvtms))*modelPar_XJBVS);
        instanceVar_T2 = max((modelPar_IJTHSFWD/instanceVar_Isbs),static_cast<double>(10.0));
        Tb = ((1.0+instanceVar_T2)-instanceVar_XExpBVS);
        instanceVar_VjsmFwd = (instanceVar_Nvtms*AnalogFunctions::lln<AdmsSensFadType>((0.5*(Tb+sqrt(((Tb*Tb)+(4.0*instanceVar_XExpBVS)))))));
        instanceVar_T0 = AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_VjsmFwd/instanceVar_Nvtms));
        instanceVar_IVjsmFwd = (instanceVar_Isbs*(((instanceVar_T0-(instanceVar_XExpBVS/instanceVar_T0))+instanceVar_XExpBVS)-1.0));
        instanceVar_SslpFwd = ((instanceVar_Isbs*(instanceVar_T0+(instanceVar_XExpBVS/instanceVar_T0)))/instanceVar_Nvtms);
        instanceVar_T2 = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_IJTHSREV/instanceVar_Isbs)-10.0),1.0e-3)+10.0);
        instanceVar_VjsmRev = ((-modelPar_BVS)-(instanceVar_Nvtms*AnalogFunctions::lln<AdmsSensFadType>(((instanceVar_T2-1.0)/modelPar_XJBVS))));
        instanceVar_T1 = (modelPar_XJBVS*AnalogFunctions::lexp<AdmsSensFadType>(((-(modelPar_BVS+instanceVar_VjsmRev))/instanceVar_Nvtms)));
        instanceVar_IVjsmRev = (instanceVar_Isbs*(1.0+instanceVar_T1));
        instanceVar_SslpRev = (((-instanceVar_Isbs)*instanceVar_T1)/instanceVar_Nvtms);
      }
      instanceVar_Isbd = (((instancePar_ADEJ*instanceVar_JSD_t)+(instancePar_PDEJ*instanceVar_JSWD_t))+((instancePar_TFIN*instanceVar_NFINtotal)*instanceVar_JSWGD_t));
      if ((instanceVar_Isbd>0.0))
      {
        instanceVar_Nvtmd = (Vtm*modelPar_NJD);
        instanceVar_XExpBVD = (AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_BVD)/instanceVar_Nvtmd))*modelPar_XJBVD);
        instanceVar_T2 = max((modelPar_IJTHDFWD/instanceVar_Isbd),static_cast<double>(10.0));
        Tb = ((1.0+instanceVar_T2)-instanceVar_XExpBVD);
        instanceVar_VjdmFwd = (instanceVar_Nvtmd*AnalogFunctions::lln<AdmsSensFadType>((0.5*(Tb+sqrt(((Tb*Tb)+(4.0*instanceVar_XExpBVD)))))));
        instanceVar_T0 = AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_VjdmFwd/instanceVar_Nvtmd));
        instanceVar_IVjdmFwd = (instanceVar_Isbd*(((instanceVar_T0-(instanceVar_XExpBVD/instanceVar_T0))+instanceVar_XExpBVD)-1.0));
        instanceVar_DslpFwd = ((instanceVar_Isbd*(instanceVar_T0+(instanceVar_XExpBVD/instanceVar_T0)))/instanceVar_Nvtmd);
        instanceVar_T2 = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_IJTHDREV/instanceVar_Isbd)-10.0),1.0e-3)+10.0);
        instanceVar_VjdmRev = ((-modelPar_BVD)-(instanceVar_Nvtmd*AnalogFunctions::lln<AdmsSensFadType>(((instanceVar_T2-1.0)/modelPar_XJBVD))));
        instanceVar_T1 = (modelPar_XJBVD*AnalogFunctions::lexp<AdmsSensFadType>(((-(modelPar_BVD+instanceVar_VjdmRev))/instanceVar_Nvtmd)));
        instanceVar_IVjdmRev = (instanceVar_Isbd*(1.0+instanceVar_T1));
        instanceVar_DslpRev = (((-instanceVar_Isbd)*instanceVar_T1)/instanceVar_Nvtmd);
      }
      instanceVar_Czbs = (instanceVar_CJS_t*instancePar_ASEJ);
      instanceVar_Czbssw = (instanceVar_CJSWS_t*instancePar_PSEJ);
      instanceVar_Czbsswg = ((instanceVar_CJSWGS_t*instanceVar_Weff0)*instanceVar_NFINtotal);
      instanceVar_Czbd = (instanceVar_CJD_t*instancePar_ADEJ);
      instanceVar_Czbdsw = (instanceVar_CJSWD_t*instancePar_PDEJ);
      instanceVar_Czbdswg = ((instanceVar_CJSWGD_t*instanceVar_Weff0)*instanceVar_NFINtotal);
    }
    instanceVar_T0 = ((Eg/Vtm)*(TRatio-1.0));
    instanceVar_T1 = (instanceVar_T0/instanceVar_NTGEN_i);
    igentemp = AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T1);
  }
  // End block CMGTempDepCalc
  vgs_noswap = (instanceVar_devsign*(probeVars[admsProbeID_V_ge_si]));
  vds_noswap = (instanceVar_devsign*(probeVars[admsProbeID_V_di_si]));
  vgd_noswap = (instanceVar_devsign*(probeVars[admsProbeID_V_ge_di]));
  ves_jct = (instanceVar_devsign*(probeVars[admsProbeID_V_e_si]));
  ved_jct = (instanceVar_devsign*(probeVars[admsProbeID_V_e_di]));
  vge = (instanceVar_devsign*(probeVars[admsProbeID_V_ge_e]));
  instanceVar_sigvds = 1.0;
  if ((vds_noswap<0.0))
  {
    instanceVar_sigvds = (-1.0);
    vgs = (vgs_noswap-vds_noswap);
    vds = ((-1.0)*vds_noswap);
    ves = ved_jct;
  }
  else
  {
    vgs = vgs_noswap;
    vds = vds_noswap;
    ves = ves_jct;
  }
  vgsfb = (vgs-deltaPhi);
  etaiv = 0.0;
  instanceVar_Qes = 0.0;
  Qesj = 0.0;
  instanceVar_Qeg = 0.0;
  instanceVar_Qed = 0.0;
  Qedj = 0.0;
  vdsx = (sqrt(((vds*vds)+0.01))-0.1);
  if ((modelPar_BULKMOD!=0))
  {
    vesx = (ves-(0.5*(vds-vdsx)));
    vesmax = (0.95*instanceVar_PHIBE_i);
    instanceVar_T2 = ((vesmax-vesx)-1.0e-3);
    instanceVar_veseff = (vesmax-(0.5*(instanceVar_T2+sqrt(((instanceVar_T2*instanceVar_T2)+(0.004*vesmax))))));
  }
  instanceVar_T0 = tanh(((0.6*vds_noswap)/Vtm));
  wf = (0.5+(0.5*instanceVar_T0));
  wr = (1.0-wf);
  if ((modelPar_ASYMMOD!=0))
  {
    CDSCD_a = ((instanceVar_CDSCDR_i*wr)+(instanceVar_CDSCD_i*wf));
    ETA0_a = ((ETA0R_t*wr)+(ETA0_t*wf));
    PDIBL1_a = ((instanceVar_PDIBL1R_i*wr)+(instanceVar_PDIBL1_i*wf));
    PDIBL2_a = ((instanceVar_PDIBL2R_i*wr)+(instanceVar_PDIBL2_i*wf));
    MEXP_a = ((instanceVar_MEXPR_t*wr)+(MEXP_t*wf));
    PTWG_a = ((instanceVar_PTWGR_t*wr)+(PTWG_t*wf));
    VSAT1_a = ((instanceVar_VSAT1R_t*wr)+(VSAT1_t*wf));
    RSDR_a = ((instanceVar_RSDRR_t*wr)+(RSDR_t*wf));
    RDDR_a = ((instanceVar_RDDRR_t*wr)+(RDDR_t*wf));
    PCLM_a = ((instanceVar_PCLMR_i*wr)+(instanceVar_PCLM_i*wf));
    instanceVar_VSAT_a = ((instanceVar_VSATR_t*wr)+(VSAT_t*wf));
    KSATIV_a = ((instanceVar_KSATIVR_i*wr)+(instanceVar_KSATIV_i*wf));
    DVTSHIFT_a = ((instanceVar_DVTSHIFTR_i*wr)+(instanceVar_DVTSHIFT_i*wf));
    CIT_a = ((instanceVar_CITR_i*wr)+(instanceVar_CIT_i*wf));
    u0_a = ((instanceVar_u0r*wr)+(u0*wf));
    UA_a = ((instanceVar_UAR_t*wr)+(UA_t*wf));
    UD_a = ((instanceVar_UDR_t*wr)+(UD_t*wf));
    UC_a = ((instanceVar_UCR_t*wr)+(instanceVar_UC_t*wf));
    EU_a = ((instanceVar_EUR_i*wr)+(instanceVar_EU_i*wf));
  }
  else
  {
    CDSCD_a = instanceVar_CDSCD_i;
    ETA0_a = ETA0_t;
    PDIBL1_a = instanceVar_PDIBL1_i;
    PDIBL2_a = instanceVar_PDIBL2_i;
    MEXP_a = MEXP_t;
    PTWG_a = PTWG_t;
    VSAT1_a = VSAT1_t;
    RSDR_a = RSDR_t;
    RDDR_a = RDDR_t;
    PCLM_a = instanceVar_PCLM_i;
    instanceVar_VSAT_a = VSAT_t;
    KSATIV_a = instanceVar_KSATIV_i;
    DVTSHIFT_a = instanceVar_DVTSHIFT_i;
    CIT_a = instanceVar_CIT_i;
    u0_a = u0;
    UA_a = UA_t;
    UD_a = UD_t;
    UC_a = instanceVar_UC_t;
    EU_a = instanceVar_EU_i;
  }
  inv_MEXP = (1.0/MEXP_a);
  phist = ((0.4+phib)+instanceVar_PHIN_i);
  instanceVar_T1 = ((2.0*(instanceVar_Cins/instanceVar_Weff_UFCM))/(instanceVar_rc+2.0));
  cdsc = (instanceVar_Theta_SW*(instanceVar_CDSC_i+(CDSCD_a*vdsx)));
  if ((!modelPar_given_NVTM))
  {
    nVtm = ((Vtm*ThetaSS)*(1.0+((CIT_a+cdsc)/instanceVar_T1)));
  }
  else
  {
    nVtm = modelPar_NVTM;
  }
  instanceVar_qdep = (instanceVar_Qdep_ov_Cins/nVtm);
  instanceVar_vth_fixed_factor_SI = log(((instanceVar_Cins*nVtm)/(((1.60219e-19*Nc)*2.0)*instanceVar_Ach)));
  instanceVar_vth_fixed_factor_Sub = (log((((instanceVar_qdep*instanceVar_rc)*(instanceVar_qdep*instanceVar_rc))/((exp((instanceVar_qdep*instanceVar_rc))-(instanceVar_qdep*instanceVar_rc))-1.0)))+instanceVar_vth_fixed_factor_SI);
  instanceVar_q0 = (((10.0*nVtm)/instanceVar_rc)+(2.0*instanceVar_qbs));
  instanceVar_fieldnormalizationfactor = ((Vtm*instanceVar_Cins)/(instanceVar_Weff_UFCM*instanceVar_epssub));
  instanceVar_auxQMfact = pow((((((((3.0/4.0)*3.0)*1.05457e-34)*2.0)*3.14159265358979323846)*1.60219e-19)/(4.0*sqrt((2.0*instanceVar_mx)))),(2.0/3.0));
  instanceVar_QMFACTORCVfinal = (((modelPar_QMFACTORCV*instanceVar_auxQMfact)*pow(instanceVar_fieldnormalizationfactor,(2.0/3.0)))*(1/(1.60219e-19*Vtm)));
  dvth_vtroll = (((-instanceVar_DVT0_i)*instanceVar_Theta_SCE)*(vbi-phist));
  dvth_dibl = ((((-ETA0_a)*instanceVar_Theta_DIBL)*vdsx)+((instanceVar_DVTP0_i*instanceVar_Theta_DITS)*pow(vdsx,instanceVar_DVTP1_i)));
  dvth_rsce = ((instanceVar_K1RSCE_i*instanceVar_Theta_RSCE)*sqrt(phist));
  dvth_all = ((((dvth_vtroll+dvth_dibl)+dvth_rsce)+dvth_temp)+DVTSHIFT_a);
  vgsfb = (vgsfb-dvth_all);
  beta0 = (((u0_a*instanceVar_cox)*instanceVar_Weff0)/instanceVar_Leff);
  instanceVar_T0 = (-(dvch_qm+(nVtm*AnalogFunctions::lln<AdmsSensFadType>((((2.0*instanceVar_cox)*modelPar_Imin)/((((beta0*nVtm)*1.60219e-19)*Nc)*instancePar_TFIN))))));
  instanceVar_T1 = ((vgsfb+instanceVar_T0)+modelPar_DELVTRAND);
  vgsfbeff = (AnalogFunctions::hypsmooth<AdmsSensFadType>(instanceVar_T1,1.0e-4)-instanceVar_T0);
  vch = (+dvch_qm);
  if ((modelPar_BULKMOD!=0))
  {
    instanceVar_T1 = AnalogFunctions::hypsmooth<AdmsSensFadType>((((2.0*phib)+vch)-ves),0.1);
    instanceVar_T3 = (((-K1_t)/(2.0*nVtm))*(sqrt(instanceVar_T1)-sqrt((2.0*phib))));
    instanceVar_T0 = ((((-instanceVar_qdep)-instanceVar_T3)+instanceVar_vth_fixed_factor_Sub)+(instanceVar_QMFACTORCVfinal*pow((-instanceVar_qdep),(2.0/3.0))));
    instanceVar_T1 = (((-instanceVar_qdep)-instanceVar_T3)+instanceVar_vth_fixed_factor_SI);
  }
  else
  {
    instanceVar_T0 = (((-instanceVar_qdep)+instanceVar_vth_fixed_factor_Sub)+(instanceVar_QMFACTORCVfinal*pow((-instanceVar_qdep),(2.0/3.0))));
    instanceVar_T1 = ((-instanceVar_qdep)+instanceVar_vth_fixed_factor_SI);
  }
  instanceVar_T2 = ((vgsfbeff-vch)/nVtm);
  instanceVar_F0 = ((-instanceVar_T2)+instanceVar_T1);
  instanceVar_T3 = (0.5*(instanceVar_T2-instanceVar_T0));
  instanceVar_qm = exp(instanceVar_T3);
  if ((instanceVar_qm>1.0e-7))
  {
    T7 = log((1.0+instanceVar_qm));
    instanceVar_qm = (2.0*(1.0-sqrt((1.0+(T7*T7)))));
    T8 = (((instanceVar_qm*modelPar_ALPHA_UFCM)+instanceVar_qdep)*instanceVar_rc);
    T4 = (T8/((exp(T8)-T8)-1.0));
    T5 = (T8*T4);
    instanceVar_e0 = ((((instanceVar_F0-instanceVar_qm)+log((-instanceVar_qm)))+log(T5))+(instanceVar_QMFACTORCVfinal*pow((-(instanceVar_qm+instanceVar_qdep)),(2.0/3.0))));
    instanceVar_e1 = ((((-1.0)+(1.0/instanceVar_qm))+((((2.0/T8)-T4)-1.0)*instanceVar_rc))-(((2.0/3.0)*instanceVar_QMFACTORCVfinal)*pow((-(instanceVar_qm+instanceVar_qdep)),((-1.0)/3.0))));
    instanceVar_e2 = (((-1.0)/(instanceVar_qm*instanceVar_qm))-(((2.0/9.0)*instanceVar_QMFACTORCVfinal)*pow((-(instanceVar_qm+instanceVar_qdep)),((-4.0)/3.0))));
    instanceVar_qm = (instanceVar_qm-((instanceVar_e0/instanceVar_e1)*(1.0+((instanceVar_e0*instanceVar_e2)/((2.0*instanceVar_e1)*instanceVar_e1)))));
    T8 = (((instanceVar_qm*modelPar_ALPHA_UFCM)+instanceVar_qdep)*instanceVar_rc);
    T4 = (T8/((exp(T8)-T8)-1.0));
    T5 = (T8*T4);
    instanceVar_e0 = ((((instanceVar_F0-instanceVar_qm)+log((-instanceVar_qm)))+log(T5))+(instanceVar_QMFACTORCVfinal*pow((-(instanceVar_qm+instanceVar_qdep)),(2.0/3.0))));
    instanceVar_e1 = ((((-1.0)+(1.0/instanceVar_qm))+((((2.0/T8)-T4)-1.0)*instanceVar_rc))-(((2.0/3.0)*instanceVar_QMFACTORCVfinal)*pow((-(instanceVar_qm+instanceVar_qdep)),((-1.0)/3.0))));
    instanceVar_e2 = (((-1.0)/(instanceVar_qm*instanceVar_qm))-(((2.0/9.0)*instanceVar_QMFACTORCVfinal)*pow((-(instanceVar_qm+instanceVar_qdep)),((-4.0)/3.0))));
    instanceVar_qm = (instanceVar_qm-((instanceVar_e0/instanceVar_e1)*(1.0+((instanceVar_e0*instanceVar_e2)/((2.0*instanceVar_e1)*instanceVar_e1)))));
  }
  else
  {
    instanceVar_qm = ((-instanceVar_qm)*instanceVar_qm);
  }
  instanceVar_qis = ((-instanceVar_qm)*nVtm);
  Eeffs = (instanceVar_EeffFactor*(instanceVar_qbs+(eta_mu*instanceVar_qis)));
  qb0 = (1.0e-2/instanceVar_cox);
  instanceVar_T2 = pow((0.5*(1.0+fabs((instanceVar_qis/qb0)))),UCS_t);
  if ((modelPar_BULKMOD!=0))
  {
    instanceVar_T3 = (((UA_a+(UC_a*instanceVar_veseff))*pow(fabs(Eeffs),EU_a))+(UD_a/instanceVar_T2));
  }
  else
  {
    instanceVar_T3 = ((UA_a*pow(fabs(Eeffs),EU_a))+(UD_a/instanceVar_T2));
  }
  Dmobs = (1.0+instanceVar_T3);
  Dmobs = (Dmobs/modelPar_U0MULT);
  if ((modelPar_RDSMOD==1))
  {
    Rdss = 0.0;
  }
  else
  {
    if ((modelPar_RDSMOD==0))
    {
      T4 = (1.0+(instanceVar_PRWGS_i*instanceVar_qis));
      instanceVar_T1 = (1.0/T4);
      instanceVar_T0 = (0.5*(instanceVar_T1+sqrt(((instanceVar_T1*instanceVar_T1)+0.01))));
      Rdss = ((((instanceVar_RDSWMIN_i+(instanceVar_RDSW_i*instanceVar_T0))*instanceVar_WeffWRFactor)*instanceVar_NFINtotal)*rdstemp);
    }
    else
    {
      T4 = (1.0+(instanceVar_PRWGS_i*instanceVar_qis));
      instanceVar_T1 = (1.0/T4);
      instanceVar_T0 = (0.5*(instanceVar_T1+sqrt(((instanceVar_T1*instanceVar_T1)+0.01))));
      Rdss = ((((((instanceVar_RSourceGeo+instanceVar_RDrainGeo)+instanceVar_RDSWMIN_i)+(instanceVar_RDSW_i*instanceVar_T0))*instanceVar_WeffWRFactor)*instanceVar_NFINtotal)*rdstemp);
    }
  }
  Esat = (((2.0*instanceVar_VSAT_a)/u0_a)*Dmobs);
  EsatL = (Esat*instanceVar_Leff);
  T6 = (KSATIV_a*(instanceVar_qis+(2*Vtm)));
  if ((Rdss==0.0))
  {
    Vdsat = ((EsatL*T6)/(EsatL+T6));
  }
  else
  {
    WVCox = ((instanceVar_Weff0*instanceVar_VSAT_a)*instanceVar_cox);
    instanceVar_T0 = (WVCox*Rdss);
    Ta = (2.0*instanceVar_T0);
    Tb = ((T6+EsatL)+((3.0*T6)*instanceVar_T0));
    Tc = (T6*(EsatL+((2.0*T6)*instanceVar_T0)));
    Vdsat = ((Tb-sqrt(((Tb*Tb)-((2.0*Ta)*Tc))))/Ta);
  }
  Vdsat = (AnalogFunctions::hypsmooth<AdmsSensFadType>((Vdsat-1.0e-3),1.0e-5)+1.0e-3);
  T7 = pow((vds/Vdsat),MEXP_a);
  T8 = pow((1.0+T7),inv_MEXP);
  Vdseff = (vds/T8);
  if ((Vdseff>vds))
  {
    Vdseff = vds;
  }
  vch = (Vdseff+dvch_qm);
  if ((modelPar_BULKMOD!=0))
  {
    instanceVar_T1 = AnalogFunctions::hypsmooth<AdmsSensFadType>((((2.0*phib)+vch)-ves),0.1);
    instanceVar_T3 = (((-K1_t)/(2.0*nVtm))*(sqrt(instanceVar_T1)-sqrt((2.0*phib))));
    instanceVar_T0 = ((((-instanceVar_qdep)-instanceVar_T3)+instanceVar_vth_fixed_factor_Sub)+(instanceVar_QMFACTORCVfinal*pow((-instanceVar_qdep),(2.0/3.0))));
    instanceVar_T1 = (((-instanceVar_qdep)-instanceVar_T3)+instanceVar_vth_fixed_factor_SI);
  }
  else
  {
    instanceVar_T0 = (((-instanceVar_qdep)+instanceVar_vth_fixed_factor_Sub)+(instanceVar_QMFACTORCVfinal*pow((-instanceVar_qdep),(2.0/3.0))));
    instanceVar_T1 = ((-instanceVar_qdep)+instanceVar_vth_fixed_factor_SI);
  }
  instanceVar_T2 = ((vgsfbeff-vch)/nVtm);
  instanceVar_F0 = ((-instanceVar_T2)+instanceVar_T1);
  instanceVar_T3 = ((instanceVar_T2-instanceVar_T0)*0.5);
  instanceVar_qm = exp(instanceVar_T3);
  if ((instanceVar_qm>1.0e-7))
  {
    T7 = log((1.0+instanceVar_qm));
    instanceVar_qm = (2.0*(1.0-sqrt((1.0+(T7*T7)))));
    T8 = (((instanceVar_qm*modelPar_ALPHA_UFCM)+instanceVar_qdep)*instanceVar_rc);
    T4 = (T8/((exp(T8)-T8)-1.0));
    T5 = (T8*T4);
    instanceVar_e0 = ((((instanceVar_F0-instanceVar_qm)+log((-instanceVar_qm)))+log(T5))+(instanceVar_QMFACTORCVfinal*pow((-(instanceVar_qm+instanceVar_qdep)),(2.0/3.0))));
    instanceVar_e1 = ((((-1.0)+(1.0/instanceVar_qm))+((((2.0/T8)-T4)-1.0)*instanceVar_rc))-(((2.0/3.0)*instanceVar_QMFACTORCVfinal)*pow((-(instanceVar_qm+instanceVar_qdep)),((-1.0)/3.0))));
    instanceVar_e2 = (((-1.0)/(instanceVar_qm*instanceVar_qm))-(((2.0/9.0)*instanceVar_QMFACTORCVfinal)*pow((-(instanceVar_qm+instanceVar_qdep)),((-4.0)/3.0))));
    instanceVar_qm = (instanceVar_qm-((instanceVar_e0/instanceVar_e1)*(1.0+((instanceVar_e0*instanceVar_e2)/((2.0*instanceVar_e1)*instanceVar_e1)))));
    T8 = (((instanceVar_qm*modelPar_ALPHA_UFCM)+instanceVar_qdep)*instanceVar_rc);
    T4 = (T8/((exp(T8)-T8)-1.0));
    T5 = (T8*T4);
    instanceVar_e0 = ((((instanceVar_F0-instanceVar_qm)+log((-instanceVar_qm)))+log(T5))+(instanceVar_QMFACTORCVfinal*pow((-(instanceVar_qm+instanceVar_qdep)),(2.0/3.0))));
    instanceVar_e1 = ((((-1.0)+(1.0/instanceVar_qm))+((((2.0/T8)-T4)-1.0)*instanceVar_rc))-(((2.0/3.0)*instanceVar_QMFACTORCVfinal)*pow((-(instanceVar_qm+instanceVar_qdep)),((-1.0)/3.0))));
    instanceVar_e2 = (((-1.0)/(instanceVar_qm*instanceVar_qm))-(((2.0/9.0)*instanceVar_QMFACTORCVfinal)*pow((-(instanceVar_qm+instanceVar_qdep)),((-4.0)/3.0))));
    instanceVar_qm = (instanceVar_qm-((instanceVar_e0/instanceVar_e1)*(1.0+((instanceVar_e0*instanceVar_e2)/((2.0*instanceVar_e1)*instanceVar_e1)))));
  }
  else
  {
    instanceVar_qm = ((-instanceVar_qm)*instanceVar_qm);
  }
  instanceVar_qid = ((-instanceVar_qm)*nVtm);
  if ((modelPar_BULKMOD!=0))
  {
    T9 = ((K1_t/(2.0*nVtm))*sqrt(Vtm));
    instanceVar_T0 = (T9/2.0);
    instanceVar_T2 = ((vge-(((deltaPhi-Eg)-(Vtm*log((modelPar_NBODY/Nc))))+modelPar_DELVFBACC))/Vtm);
    if (((instanceVar_T2*Vtm)>(phib+(T9*sqrt((phib*Vtm))))))
    {
      instanceVar_T1 = (sqrt(((instanceVar_T2-1.0)+(instanceVar_T0*instanceVar_T0)))-instanceVar_T0);
      T10 = (1.0+(instanceVar_T1*instanceVar_T1));
    }
    else
    {
      instanceVar_T3 = ((instanceVar_T2*0.5)-(3.0*(1.0+(T9/sqrt(static_cast<double>(2.0))))));
      T10 = (instanceVar_T3+sqrt(((instanceVar_T3*instanceVar_T3)+(6.0*instanceVar_T2))));
      if ((instanceVar_T2<0.0))
      {
        T4 = ((instanceVar_T2-T10)/T9);
        T10 = (-log(((1.0-T10)+(T4*T4))));
      }
      else
      {
        instanceVar_T11 = exp((-T10));
        T4 = (sqrt((((instanceVar_T2-1.0)+instanceVar_T11)+(instanceVar_T0*instanceVar_T0)))-instanceVar_T0);
        T10 = ((1.0-instanceVar_T11)+(T4*T4));
      }
    }
    T6 = (exp((-T10))-1.0);
    T7 = sqrt((T6+T10));
    if ((T10>1.0e-15))
    {
      instanceVar_e0 = ((-(instanceVar_T2-T10))+(T9*T7));
      instanceVar_e1 = (1.0-(((T9*0.5)*T6)/T7));
      T8 = (T10-(instanceVar_e0/instanceVar_e1));
      instanceVar_T11 = (exp((-T8))-1.0);
      instanceVar_T12 = sqrt((instanceVar_T11+T8));
      instanceVar_qba = (((-T9)*instanceVar_T12)*Vtm);
    }
    else
    {
      if ((T10<(-1.0e-15)))
      {
        instanceVar_e0 = ((-(instanceVar_T2-T10))-(T9*T7));
        instanceVar_e1 = (1.0+(((T9*0.5)*T6)/T7));
        T8 = (T10-(instanceVar_e0/instanceVar_e1));
        instanceVar_T12 = (T9*sqrt(((exp((-T8))+T8)-1.0)));
      }
      else
      {
        instanceVar_T12 = 0.0;
        T8 = 0.0;
      }
      instanceVar_qba = (instanceVar_T12*Vtm);
    }
    instanceVar_qi_acc_for_QM = ((T9*exp(((-T8)/2.0)))*Vtm);
    instanceVar_psipclamp = (0.5*((T8+1.0)+sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))));
    instanceVar_sqrtpsip = sqrt(instanceVar_psipclamp);
    instanceVar_nq = (1.0+(T9/instanceVar_sqrtpsip));
  }
  qia = (0.5*(instanceVar_qis+instanceVar_qid));
  dqi = (instanceVar_qis-instanceVar_qid);
  instanceVar_T0 = (pow(Vdseff,2.0)/6.25e-4);
  if ((modelPar_CHARGEWF!=0.0))
  {
    qia2 = ((0.5*(instanceVar_qis+instanceVar_qid))+(((modelPar_CHARGEWF*(1.0-AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T0))))*0.5)*dqi));
  }
  else
  {
    qia2 = (0.5*(instanceVar_qis+instanceVar_qid));
  }
  if ((instanceVar_qis<0.0))
  {
    std::cerr  << "Warning: negative source-side inversion carrier density.  Vgs=%f  Vds=%f  Vbs=%f qis=%e" << (probeVars[admsProbeID_V_g_s]) << (probeVars[admsProbeID_V_d_s]) << (probeVars[admsProbeID_V_e_s]) << instanceVar_qis <<  std::endl; 
  }
  if ((instanceVar_qid<0.0))
  {
    std::cerr  << "Warning: negative drain-side inversion carrier density.  Vgs=%f  Vds=%f  Vbs=%f qid=%e" << (probeVars[admsProbeID_V_g_s]) << (probeVars[admsProbeID_V_d_s]) << (probeVars[admsProbeID_V_e_s]) << instanceVar_qid <<  std::endl; 
  }
  if ((instanceVar_QMTCENCV_i>0.0))
  {
    T4 = (qia/modelPar_QM0);
    T5 = (1.0+pow(T4,modelPar_PQM));
    instanceVar_Tcen = (instanceVar_Tcen0/T5);
    coxeff = (1.0/((1.0/((instanceVar_cox*modelPar_EOT)/modelPar_TOXP))+((instanceVar_Tcen*instanceVar_QMTCENCV_i)/instanceVar_epssub)));
  }
  else
  {
    coxeff = instanceVar_cox;
  }
  if (((modelPar_BULKMOD!=0)&&(instanceVar_QMTCENCVA_i!=0.0)))
  {
    T6 = (1.0+pow((instanceVar_qi_acc_for_QM/modelPar_QM0ACC),modelPar_PQMACC));
    instanceVar_Tcen = (instanceVar_Tcen0/T6);
    instanceVar_cox_acc = (1.0/((1.0/instanceVar_cox_acc)+((instanceVar_Tcen*instanceVar_QMTCENCVA_i)/instanceVar_epssub)));
  }
  beta = (((u0_a*instanceVar_cox)*instanceVar_Weff0)/instanceVar_Leff);
  Eeffm = (instanceVar_EeffFactor*(instanceVar_qba+(eta_mu*qia2)));
  instanceVar_T2 = pow((0.5*(1.0+fabs((qia2/qb0)))),UCS_t);
  if ((modelPar_BULKMOD!=0))
  {
    instanceVar_T3 = (((UA_a+(UC_a*instanceVar_veseff))*pow(fabs(Eeffm),EU_a))+(UD_a/instanceVar_T2));
  }
  else
  {
    instanceVar_T3 = ((UA_a*pow(fabs(Eeffm),EU_a))+(UD_a/instanceVar_T2));
  }
  Dmob = (1.0+instanceVar_T3);
  Dmob = (Dmob/modelPar_U0MULT);
  ueff = (u0_a/Dmob);
  Eeffm_cv = (instanceVar_EeffFactor*(instanceVar_qba+(eta_mu_cv*qia2)));
  instanceVar_T3 = ((UA_a*pow(fabs(Eeffm_cv),EU_a))+(UD_a/instanceVar_T2));
  Dmob_cv = (1.0+instanceVar_T3);
  Dmob_cv = (Dmob_cv/modelPar_U0MULT);
  instanceVar_tmp = (((instanceVar_DROUT_i*instanceVar_Leff)/instanceVar_scl)+1.0e-6);
  if ((instanceVar_tmp<40.0))
  {
    DIBLfactor = (((0.5*PDIBL1_a)/(cosh(instanceVar_tmp)-1.0))+PDIBL2_a);
  }
  else
  {
    DIBLfactor = ((PDIBL1_a*exp((-instanceVar_tmp)))+PDIBL2_a);
  }
  if ((instanceVar_PVAG_i>0.0))
  {
    PVAGfactor = (1.0+((instanceVar_PVAG_i*qia)/EsatL));
  }
  else
  {
    PVAGfactor = (1.0/(1.0-((instanceVar_PVAG_i*qia)/EsatL)));
  }
  if ((Vdseff>vds))
  {
    Vdseff = vds;
  }
  diffVds = (vds-Vdseff);
  Vgst2Vtm = (qia+(2.0*Vtm));
  if ((DIBLfactor>0))
  {
    instanceVar_T1 = Vgst2Vtm;
    instanceVar_T3 = (instanceVar_T1/(Vdsat+instanceVar_T1));
    VaDIBL = (((instanceVar_T1/DIBLfactor)*instanceVar_T3)*PVAGfactor);
    Moc = (1.0+(diffVds/VaDIBL));
  }
  else
  {
    Moc = 1.0;
  }
  if ((PCLM_a>0.0))
  {
    if ((instanceVar_PCLMG_i<0.0))
    {
      instanceVar_T1 = (1.0/((1.0/PCLM_a)-(instanceVar_PCLMG_i*qia)));
    }
    else
    {
      instanceVar_T1 = (PCLM_a+(instanceVar_PCLMG_i*qia));
    }
    Mclm = (1.0+(instanceVar_T1*AnalogFunctions::lln<AdmsSensFadType>((1.0+(((vds-Vdseff)/instanceVar_T1)/(Vdsat+EsatL))))));
  }
  else
  {
    Mclm = 1.0;
  }
  Moc = (Moc*Mclm);
  Esat1 = ((2.0*VSAT1_a)/ueff);
  Esat1L = (Esat1*instanceVar_Leff);
  instanceVar_T0 = AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_PSAT_i*AnalogFunctions::lln<AdmsSensFadType>((dqi/Esat1L))));
  Ta = (1.0+AnalogFunctions::lexp<AdmsSensFadType>(((1.0/instanceVar_PSAT_i)*AnalogFunctions::lln<AdmsSensFadType>(instanceVar_DELTAVSAT_i))));
  Dvsat = ((1.0+AnalogFunctions::lexp<AdmsSensFadType>(((1.0/instanceVar_PSAT_i)*AnalogFunctions::lln<AdmsSensFadType>((instanceVar_DELTAVSAT_i+instanceVar_T0)))))/Ta);
  Dvsat = (Dvsat+((((0.5*PTWG_a)*qia)*dqi)*dqi));
  instanceVar_T0 = (A1_t+(A2_t/(qia+(2.0*nVtm))));
  instanceVar_T1 = ((instanceVar_T0*dqi)*dqi);
  instanceVar_T2 = ((instanceVar_T1+1.0)-0.001);
  instanceVar_T3 = ((-1.0)+(0.5*(instanceVar_T2+sqrt(((instanceVar_T2*instanceVar_T2)+0.004)))));
  Nsat = (0.5*(1.0+sqrt((1.0+instanceVar_T3))));
  Dvsat = (Dvsat*Nsat);
  if ((K0_t!=0))
  {
    instanceVar_T1 = (K0_t/((max(static_cast<double>(0),(K0SI_t+((K0SISAT_t*dqi)*dqi)))*qia)+(2.0*nVtm)));
    Mnud = AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T1));
  }
  else
  {
    Mnud = 1.0;
  }
  if ((modelPar_BULKMOD==2))
  {
    instanceVar_T0 = AnalogFunctions::hypsmooth<AdmsSensFadType>((K2_t+(K2SAT_t*vdsx)),1.0e-6);
    instanceVar_T1 = (instanceVar_T0/((max(static_cast<double>(0),(K2SI_t+((K2SISAT_t*dqi)*dqi)))*qia)+(2.0*nVtm)));
    instanceVar_T3 = (sqrt((instanceVar_PHIBE_i-instanceVar_veseff))-sqrt(instanceVar_PHIBE_i));
    Mob = AnalogFunctions::lexp<AdmsSensFadType>(((-instanceVar_T1)*instanceVar_T3));
  }
  else
  {
    Mob = 1.0;
  }
  EsatCV = (((2.0*VSATCV_t)*Dmob_cv)/u0_a);
  EsatCVL = (EsatCV*instanceVar_LeffCV);
  instanceVar_T0 = AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_PSATCV_i*AnalogFunctions::lln<AdmsSensFadType>((dqi/EsatCVL))));
  Ta = (1.0+AnalogFunctions::lexp<AdmsSensFadType>(((1.0/instanceVar_PSATCV_i)*AnalogFunctions::lln<AdmsSensFadType>(instanceVar_DELTAVSATCV_i))));
  DvsatCV = ((1.0+AnalogFunctions::lexp<AdmsSensFadType>(((1.0/instanceVar_PSATCV_i)*AnalogFunctions::lln<AdmsSensFadType>((instanceVar_DELTAVSATCV_i+instanceVar_T0)))))/Ta);
  if ((instanceVar_PCLMCV_i!=0))
  {
    MclmCV = (1.0+(instanceVar_PCLMCV_i*AnalogFunctions::lln<AdmsSensFadType>((1.0+(((vds-Vdseff)/instanceVar_PCLMCV_i)/(Vdsat+EsatCVL))))));
  }
  else
  {
    MclmCV = 1.0;
  }
  instanceVar_qb = ((((-1.60219e-19)*instanceVar_nbody)*instanceVar_Ach)*instanceVar_LeffCV);
  instanceVar_T1 = qia;
  etaiv = (instanceVar_q0/(instanceVar_q0+qia));
  instanceVar_T2 = ((2.0-etaiv)*nVtm);
  ids0_ov_dqi = (instanceVar_T1+instanceVar_T2);
  ids0 = (ids0_ov_dqi*dqi);
  if ( modelPar_RDSMOD == (1))
  {
    instanceVar_Rdsi = 0.0;
    instanceVar_Dr = 1.0;
    instanceVar_T2 = (vgs_noswap-vfbsd);
    instanceVar_T3 = sqrt(((instanceVar_T2*instanceVar_T2)+1.0e-1));
    vgs_eff = (0.5*(instanceVar_T2+instanceVar_T3));
    T4 = (1.0+(instanceVar_PRWGS_i*vgs_eff));
    instanceVar_T1 = (1.0/T4);
    instanceVar_T0 = (0.5*(instanceVar_T1+sqrt(((instanceVar_T1*instanceVar_T1)+0.01))));
    T5 = (instanceVar_RSW_i*(1.0+(RSDR_a*AnalogFunctions::lexp<AdmsSensFadType>(((0.5*modelPar_PRSDR)*AnalogFunctions::lln<AdmsSensFadType>((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6)))))));
    instanceVar_Rsource = (rdstemp*(instanceVar_RSourceGeo+((instanceVar_RSWMIN_i+(T5*instanceVar_T0))*instanceVar_WeffWRFactor)));
    instanceVar_T2 = (vgd_noswap-vfbsd);
    instanceVar_T3 = sqrt(((instanceVar_T2*instanceVar_T2)+1.0e-1));
    vgd_eff = (0.5*(instanceVar_T2+instanceVar_T3));
    T4 = (1.0+(instanceVar_PRWGD_i*vgd_eff));
    instanceVar_T1 = (1.0/T4);
    instanceVar_T0 = (0.5*(instanceVar_T1+sqrt(((instanceVar_T1*instanceVar_T1)+0.01))));
    T5 = (instanceVar_RDW_i*(1.0+(RDDR_a*AnalogFunctions::lexp<AdmsSensFadType>(((0.5*modelPar_PRDDR)*AnalogFunctions::lln<AdmsSensFadType>((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6)))))));
    instanceVar_Rdrain = (rdstemp*(instanceVar_RDrainGeo+((instanceVar_RDWMIN_i+(T5*instanceVar_T0))*instanceVar_WeffWRFactor)));
  }
  else
    if ( modelPar_RDSMOD == (0))
    {
      instanceVar_Rsource = instanceVar_RSourceGeo;
      instanceVar_Rdrain = instanceVar_RDrainGeo;
      T4 = (1.0+(instanceVar_PRWGS_i*qia));
      instanceVar_T1 = (1.0/T4);
      instanceVar_T0 = (0.5*(instanceVar_T1+sqrt(((instanceVar_T1*instanceVar_T1)+0.01))));
      instanceVar_Rdsi = ((rdstemp*(instanceVar_RDSWMIN_i+(instanceVar_RDSW_i*instanceVar_T0)))*instanceVar_WeffWRFactor);
      instanceVar_Dr = (1.0+((((instanceVar_NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*instanceVar_Rdsi));
    }
    else
      if ( modelPar_RDSMOD == (2))
      {
        T4 = (1.0+(instanceVar_PRWGS_i*qia));
        instanceVar_T1 = (1.0/T4);
        instanceVar_T0 = (0.5*(instanceVar_T1+sqrt(((instanceVar_T1*instanceVar_T1)+0.01))));
        instanceVar_Rdsi = ((rdstemp*(((instanceVar_RSourceGeo+instanceVar_RDrainGeo)+instanceVar_RDSWMIN_i)+(instanceVar_RDSW_i*instanceVar_T0)))*instanceVar_WeffWRFactor);
        instanceVar_Dr = (1.0+((((instanceVar_NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*instanceVar_Rdsi));
        instanceVar_Rsource = 0.0;
        instanceVar_Rdrain = 0.0;
      }
      else
      {
        // no default
      }
  instanceVar_ids = ((((((instanceVar_NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)/((Dmob*Dvsat)*instanceVar_Dr));
  instanceVar_ids = (instanceVar_ids*modelPar_IDS0MULT);
  instanceVar_T11 = (((2.0*qia)+nVtm)/DvsatCV);
  instanceVar_qg = (qia+((dqi*dqi)/(6.0*instanceVar_T11)));
  instanceVar_qd = ((-0.5)*(qia-((dqi/6.0)*(1.0-((dqi/instanceVar_T11)*(1+(dqi/(5.0*instanceVar_T11))))))));
  inv_MclmCV = (1.0/MclmCV);
  instanceVar_qg = ((inv_MclmCV*instanceVar_qg)+((MclmCV-1.0)*instanceVar_qid));
  instanceVar_qd = (((inv_MclmCV*inv_MclmCV)*instanceVar_qd)+((0.5*(MclmCV-inv_MclmCV))*instanceVar_qid));
  instanceVar_qs = ((-instanceVar_qg)-instanceVar_qd);
  T6 = (((instanceVar_NFINtotal*instanceVar_WeffCV0)*instanceVar_LeffCV)*coxeff);
  instanceVar_qg = (T6*instanceVar_qg);
  instanceVar_qd = (T6*instanceVar_qd);
  instanceVar_qs = (T6*instanceVar_qs);
  qinv = instanceVar_qg;
  if ((modelPar_BULKMOD!=0))
  {
    instanceVar_T1 = (((instanceVar_NFINtotal*instanceVar_WeffCV0)*instanceVar_LeffCV_acc)*instanceVar_cox_acc);
    T7 = instanceVar_qi_acc_for_QM;
    T10 = (T7*instanceVar_T1);
    instanceVar_qg_acc = (-T10);
    instanceVar_qb_acc = T10;
    instanceVar_T1 = (((instanceVar_NFINtotal*instanceVar_WeffCV0)*instanceVar_LeffCV)*instanceVar_cox);
    instanceVar_T2 = (instanceVar_qba-instanceVar_qi_acc_for_QM);
    T10 = (instanceVar_T1*instanceVar_T2);
    instanceVar_qg_acc = (instanceVar_qg_acc-T10);
    instanceVar_qb_acc = (instanceVar_qb_acc+T10);
    instanceVar_T1 = (((instanceVar_NFINtotal*instanceVar_WeffCV0)*instanceVar_LeffCV)*instanceVar_cox);
    instanceVar_T2 = (((instanceVar_nq-1.0)*0.5)*(qia+((dqi*dqi)/(6.0*instanceVar_T11))));
    T10 = (instanceVar_T1*instanceVar_T2);
    instanceVar_qg_acc = (instanceVar_qg_acc-T10);
    instanceVar_qb_acc = (instanceVar_qb_acc+T10);
  }
  if ((instanceVar_sigvds<0))
  {
    instanceVar_T1 = instanceVar_qd;
    instanceVar_qd = instanceVar_qs;
    instanceVar_qs = instanceVar_T1;
  }
  qgs_ov = 0.0;
  qgd_ov = 0.0;
  if ((modelPar_CGEOMOD!=1))
  {
    instanceVar_T1 = ((instanceVar_NFINtotal*instanceVar_WeffCV0)*instanceVar_devsign);
    instanceVar_T2 = (instanceVar_devsign*(probeVars[admsProbeID_V_ge_si]));
    instanceVar_T0 = ((instanceVar_T2-vfbsdcv)+0.02);
    vgs_overlap = (0.5*(instanceVar_T0-sqrt(((instanceVar_T0*instanceVar_T0)+(4.0*0.02)))));
    qgs_ov = (instanceVar_T1*((instanceVar_CGSL_i*(((instanceVar_T2-vfbsdcv)-vgs_overlap)-((0.5*instanceVar_CKAPPAS_i)*(sqrt((1.0-((4.0*vgs_overlap)/instanceVar_CKAPPAS_i)))-1.0))))+(instanceVar_CGSO_i*instanceVar_T2)));
    instanceVar_T2 = (instanceVar_devsign*(probeVars[admsProbeID_V_ge_di]));
    instanceVar_T0 = ((instanceVar_T2-vfbsdcv)+0.02);
    vgd_overlap = (0.5*(instanceVar_T0-sqrt(((instanceVar_T0*instanceVar_T0)+(4.0*0.02)))));
    qgd_ov = (instanceVar_T1*((instanceVar_CGDL_i*(((instanceVar_T2-vfbsdcv)-vgd_overlap)-((0.5*instanceVar_CKAPPAD_i)*(sqrt((1.0-((4.0*vgd_overlap)/instanceVar_CKAPPAD_i)))-1.0))))+(instanceVar_CGDO_i*instanceVar_T2)));
  }
  if ((modelPar_CGEOMOD==0))
  {
    instanceVar_T1 = (instanceVar_NFINtotal*instanceVar_WeffCV0);
    instanceVar_qgs_fr = ((instanceVar_T1*instanceVar_CFS_i)*(probeVars[admsProbeID_V_ge_si]));
    instanceVar_qgd_fr = ((instanceVar_T1*instanceVar_CFD_i)*(probeVars[admsProbeID_V_ge_di]));
    instanceVar_qgs_parasitic = (qgs_ov+instanceVar_qgs_fr);
    instanceVar_qgd_parasitic = (qgd_ov+instanceVar_qgd_fr);
  }
  else
  {
    if ((modelPar_CGEOMOD==1))
    {
      if ((modelPar_CGEO1SW==1))
      {
        instanceVar_T0 = (instanceVar_NFINtotal*instanceVar_WeffCV0);
        instanceVar_COVS_i = (instanceVar_T0*instanceVar_COVS_i);
        instanceVar_COVD_i = (instanceVar_T0*instanceVar_COVD_i);
        cgsp = (instanceVar_T0*instancePar_CGSP);
        cgdp = (instanceVar_T0*instancePar_CGDP);
      }
      else
      {
        cgsp = instancePar_CGSP;
        cgdp = instancePar_CGDP;
      }
      qgs_ov = (instanceVar_COVS_i*(probeVars[admsProbeID_V_ge_si]));
      qgd_ov = (instanceVar_COVD_i*(probeVars[admsProbeID_V_ge_di]));
      instanceVar_qgs_parasitic = qgs_ov;
      instanceVar_qgd_parasitic = qgd_ov;
      instanceVar_qgs_fr = (cgsp*(probeVars[admsProbeID_V_ge_s]));
      instanceVar_qgd_fr = (cgdp*(probeVars[admsProbeID_V_ge_d]));
    }
    else
    {
      instanceVar_qgs_fr = (instanceVar_Cfr_geo*(probeVars[admsProbeID_V_ge_si]));
      instanceVar_qgd_fr = (instanceVar_Cfr_geo*(probeVars[admsProbeID_V_ge_di]));
      instanceVar_qgs_parasitic = (qgs_ov+instanceVar_qgs_fr);
      instanceVar_qgd_parasitic = (qgd_ov+instanceVar_qgd_fr);
    }
  }
  instanceVar_qds_fr = (instancePar_CDSP*(probeVars[admsProbeID_V_d_s]));
  instanceVar_Iii = 0.0;
  if ((modelPar_IIMOD==1))
  {
    instanceVar_T0 = ((ALPHA0_t+(ALPHA1_t*instanceVar_Leff))/instanceVar_Leff);
    if (((instanceVar_T0<=0.0)||(BETA0_t<=0.0)))
    {
      instanceVar_Iii = 0.0;
    }
    else
    {
      instanceVar_T1 = ((-BETA0_t)/(diffVds+1.0e-30));
      instanceVar_Iii = (((instanceVar_T0*diffVds)*instanceVar_ids)*AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T1));
    }
  }
  else
  {
    if ((modelPar_IIMOD==2))
    {
      ALPHAII = ((ALPHAII0_t+(ALPHAII1_t*instanceVar_Leff))/instanceVar_Leff);
      if ((ALPHAII<=0.0))
      {
        instanceVar_Iii = 0.0;
      }
      else
      {
        instanceVar_T0 = (instanceVar_ESATII_i*instanceVar_Leff);
        instanceVar_T1 = ((SII0_t*instanceVar_T0)/(1.0+instanceVar_T0));
        instanceVar_T0 = (1.0/(1.0+AnalogFunctions::hypsmooth<AdmsSensFadType>((instanceVar_SII1_i*vgsfbeff),modelPar_IIMOD2CLAMP1)));
        instanceVar_T3 = (instanceVar_T0+instanceVar_SII2_i);
        instanceVar_T2 = AnalogFunctions::hypsmooth<AdmsSensFadType>((vgsfbeff*instanceVar_T3),modelPar_IIMOD2CLAMP2);
        instanceVar_T3 = (1.0/(1.0+(instanceVar_SIID_i*vds)));
        VgsStep = ((instanceVar_T1*instanceVar_T2)*instanceVar_T3);
        Vdsatii = (VgsStep*(1.0-(instanceVar_LII_i/instanceVar_Leff)));
        Vdiff = (vds-Vdsatii);
        instanceVar_T0 = ((instanceVar_BETAII2_i+(instanceVar_BETAII1_i*Vdiff))+((instanceVar_BETAII0_i*Vdiff)*Vdiff));
        instanceVar_T1 = sqrt(((instanceVar_T0*instanceVar_T0)+1.0e-10));
        Ratio = (-AnalogFunctions::hypmax<AdmsSensFadType>(((-ALPHAII)*AnalogFunctions::lexp<AdmsSensFadType>((Vdiff/instanceVar_T1))),(-10.0),modelPar_IIMOD2CLAMP3));
        instanceVar_Iii = (Ratio*instanceVar_ids);
      }
    }
  }
  instanceVar_igbinv = 0.0;
  instanceVar_igbacc = 0.0;
  instanceVar_igcs = 0.0;
  instanceVar_igcd = 0.0;
  instanceVar_igs = 0.0;
  instanceVar_igd = 0.0;
  if ((modelPar_IGBMOD!=0))
  {
    instanceVar_T1 = (((qia-instanceVar_EIGBINV_i)/instanceVar_NIGBINV_i)/Vtm);
    Vaux_Igbinv = ((instanceVar_NIGBINV_i*Vtm)*AnalogFunctions::lln<AdmsSensFadType>((1.0+AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T1))));
    instanceVar_T2 = (AIGBINV_t-(instanceVar_BIGBINV_i*qia));
    instanceVar_T3 = (1.0+(instanceVar_CIGBINV_i*qia));
    T4 = ((((-9.82222e11)*modelPar_TOXG)*instanceVar_T2)*instanceVar_T3);
    T5 = AnalogFunctions::lexp<AdmsSensFadType>(T4);
    T6 = 3.75956e-7;
    instanceVar_igbinv = ((((((instanceVar_Weff0*instanceVar_Leff)*T6)*instanceVar_Toxratio)*vge)*Vaux_Igbinv)*T5);
    instanceVar_igbinv = (instanceVar_igbinv*igtemp);
    vfbzb = ((deltaPhi-(Eg/2.0))-phib);
    instanceVar_T0 = (vfbzb-vge);
    instanceVar_T1 = ((instanceVar_T0/instanceVar_NIGBACC_i)/Vtm);
    Vaux_Igbacc = ((instanceVar_NIGBACC_i*Vtm)*AnalogFunctions::lln<AdmsSensFadType>((1.0+AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T1))));
    if ((modelPar_BULKMOD!=0))
    {
      Voxacc = instanceVar_qi_acc_for_QM;
    }
    else
    {
      if ((vfbzb<=0))
      {
        Voxacc = (0.5*((instanceVar_T0-0.02)+sqrt((((instanceVar_T0-0.02)*(instanceVar_T0-0.02))-(0.08*vfbzb)))));
      }
      else
      {
        Voxacc = (0.5*((instanceVar_T0-0.02)+sqrt((((instanceVar_T0-0.02)*(instanceVar_T0-0.02))+(0.08*vfbzb)))));
      }
    }
    instanceVar_T2 = (AIGBACC_t-(instanceVar_BIGBACC_i*Voxacc));
    instanceVar_T3 = (1.0+(instanceVar_CIGBACC_i*Voxacc));
    T4 = ((((-7.45669e11)*modelPar_TOXG)*instanceVar_T2)*instanceVar_T3);
    T5 = AnalogFunctions::lexp<AdmsSensFadType>(T4);
    T6 = 4.97232e-7;
    instanceVar_igbacc = ((((((instanceVar_Weff0*instanceVar_Leff)*T6)*instanceVar_Toxratio)*vge)*Vaux_Igbacc)*T5);
    instanceVar_igbacc = (instanceVar_igbacc*igtemp);
  }
  if ((modelPar_IGCMOD!=0))
  {
    instanceVar_T1 = (AIGC_t-(instanceVar_BIGC_i*qia));
    instanceVar_T2 = (1.0+(instanceVar_CIGC_i*qia));
    instanceVar_T3 = ((((-instanceVar_Bechvb)*modelPar_TOXG)*instanceVar_T1)*instanceVar_T2);
    T4 = (qia*AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T3));
    T5 = ((vge+(0.5*vdsx))+(0.5*(ves_jct+ved_jct)));
    igc0 = ((((((instanceVar_Weff0*instanceVar_Leff)*instanceVar_Aechvb)*instanceVar_Toxratio)*T4)*T5)*igtemp);
    Vdseffx = (sqrt(((Vdseff*Vdseff)+0.01))-0.1);
    instanceVar_T1 = (instanceVar_PIGCD_i*Vdseffx);
    T1_exp = AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T1));
    instanceVar_T3 = (((instanceVar_T1+T1_exp)-1.0)+1.0e-4);
    T4 = ((1.0-((instanceVar_T1+1.0)*T1_exp))+1.0e-4);
    T5 = ((instanceVar_T1*instanceVar_T1)+2.0e-4);
    instanceVar_igcd = ((igc0*T4)/T5);
    instanceVar_igcs = ((igc0*instanceVar_T3)/T5);
    instanceVar_T0 = (vgs_noswap-vfbsd);
    vgs_eff = sqrt(((instanceVar_T0*instanceVar_T0)+1.0e-4));
    if ((modelPar_IGCLAMP==1))
    {
      instanceVar_T1 = AnalogFunctions::hypsmooth<AdmsSensFadType>((AIGS_t-(instanceVar_BIGS_i*vgs_eff)),1.0e-6);
      if ((instanceVar_CIGS_i<0.01))
      {
        instanceVar_CIGS_i = 0.01;
      }
    }
    else
    {
      instanceVar_T1 = (AIGS_t-(instanceVar_BIGS_i*vgs_eff));
    }
    instanceVar_T2 = (1.0+(instanceVar_CIGS_i*vgs_eff));
    instanceVar_T3 = (((((-instanceVar_Bechvb)*modelPar_TOXG)*instanceVar_POXEDGE_i)*instanceVar_T1)*instanceVar_T2);
    T4 = AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T3);
    if ((instanceVar_sigvds>0.0))
    {
      instanceVar_igs = ((((igsd_mult*modelPar_DLCIGS)*vgs_noswap)*vgs_eff)*T4);
    }
    else
    {
      instanceVar_igd = ((((igsd_mult*modelPar_DLCIGS)*vgs_noswap)*vgs_eff)*T4);
    }
    instanceVar_T0 = (vgd_noswap-vfbsd);
    vgd_eff = sqrt(((instanceVar_T0*instanceVar_T0)+1.0e-4));
    if ((modelPar_IGCLAMP==1))
    {
      instanceVar_T1 = AnalogFunctions::hypsmooth<AdmsSensFadType>((AIGD_t-(instanceVar_BIGD_i*vgd_eff)),1.0e-6);
      if ((instanceVar_CIGD_i<0.01))
      {
        instanceVar_CIGD_i = 0.01;
      }
    }
    else
    {
      instanceVar_T1 = (AIGD_t-(instanceVar_BIGD_i*vgd_eff));
    }
    instanceVar_T2 = (1.0+(instanceVar_CIGD_i*vgd_eff));
    instanceVar_T3 = (((((-instanceVar_Bechvb)*modelPar_TOXG)*instanceVar_POXEDGE_i)*instanceVar_T1)*instanceVar_T2);
    T4 = AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T3);
    if ((instanceVar_sigvds>0.0))
    {
      instanceVar_igd = ((((igsd_mult*modelPar_DLCIGD)*vgd_noswap)*vgd_eff)*T4);
    }
    else
    {
      instanceVar_igs = ((((igsd_mult*modelPar_DLCIGD)*vgd_noswap)*vgd_eff)*T4);
    }
  }
  instanceVar_igisl = 0.0;
  instanceVar_igidl = 0.0;
  if ((modelPar_GIDLMOD!=0))
  {
    instanceVar_T0 = (instanceVar_epsratio*modelPar_EOT);
    if (((instanceVar_AGIDL_i<=0.0)||(BGIDL_t<=0.0)))
    {
      T6 = 0.0;
    }
    else
    {
      instanceVar_T1 = ((((-vgd_noswap)-instanceVar_EGIDL_i)+vfbsd)/instanceVar_T0);
      instanceVar_T1 = AnalogFunctions::hypsmooth<AdmsSensFadType>(instanceVar_T1,1.0e-2);
      instanceVar_T2 = (BGIDL_t/(instanceVar_T1+1.0e-3));
      instanceVar_T3 = AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_PGIDL_i*AnalogFunctions::lln<AdmsSensFadType>(instanceVar_T1)));
      if ((modelPar_BULKMOD!=0))
      {
        T4 = (((-ved_jct)*ved_jct)*ved_jct);
        T4a = ((instanceVar_CGIDL_i+fabs(T4))+1.0e-5);
        T5 = (AnalogFunctions::hypsmooth<AdmsSensFadType>((T4/T4a),1.0e-6)-1.0e-6);
        T6 = ((((instanceVar_AGIDL_i*instanceVar_Weff0)*instanceVar_T3)*AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T2)))*T5);
      }
      else
      {
        T6 = ((((instanceVar_AGIDL_i*instanceVar_Weff0)*instanceVar_T3)*AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T2)))*vds_noswap);
      }
    }
    if ((instanceVar_sigvds>0.0))
    {
      instanceVar_igidl = T6;
    }
    else
    {
      instanceVar_igisl = T6;
    }
    if (((instanceVar_AGISL_i<=0.0)||(BGISL_t<=0.0)))
    {
      T6 = 0.0;
    }
    else
    {
      instanceVar_T1 = ((((-vgs_noswap)-instanceVar_EGISL_i)+vfbsd)/instanceVar_T0);
      instanceVar_T1 = AnalogFunctions::hypsmooth<AdmsSensFadType>(instanceVar_T1,1.0e-2);
      instanceVar_T2 = (BGISL_t/(instanceVar_T1+1.0e-3));
      instanceVar_T3 = AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_PGISL_i*AnalogFunctions::lln<AdmsSensFadType>(instanceVar_T1)));
      if ((modelPar_BULKMOD!=0))
      {
        T4 = (((-ves_jct)*ves_jct)*ves_jct);
        T4a = ((instanceVar_CGISL_i+fabs(T4))+1.0e-5);
        T5 = (AnalogFunctions::hypsmooth<AdmsSensFadType>((T4/T4a),1.0e-6)-1.0e-6);
        T6 = ((((instanceVar_AGISL_i*instanceVar_Weff0)*instanceVar_T3)*AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T2)))*T5);
      }
      else
      {
        T6 = ((((instanceVar_AGISL_i*instanceVar_Weff0)*instanceVar_T3)*AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T2)))*(-vds_noswap));
      }
    }
    if ((instanceVar_sigvds>0.0))
    {
      instanceVar_igisl = T6;
    }
    else
    {
      instanceVar_igidl = T6;
    }
  }
  if ((modelPar_BULKMOD!=0))
  {
    if ((instanceVar_Isbs>0.0))
    {
      if ((ves_jct<instanceVar_VjsmRev))
      {
        instanceVar_T0 = (ves_jct/instanceVar_Nvtms);
        instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T0)-1.0);
        instanceVar_T2 = (instanceVar_IVjsmRev+(instanceVar_SslpRev*(ves_jct-instanceVar_VjsmRev)));
        instanceVar_Ies = (instanceVar_T1*instanceVar_T2);
      }
      else
      {
        if ((ves_jct<=instanceVar_VjsmFwd))
        {
          instanceVar_T0 = (ves_jct/instanceVar_Nvtms);
          instanceVar_T1 = ((modelPar_BVS+ves_jct)/instanceVar_Nvtms);
          instanceVar_T2 = AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T1));
          instanceVar_Ies = (instanceVar_Isbs*(((AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T0)+instanceVar_XExpBVS)-1.0)-(modelPar_XJBVS*instanceVar_T2)));
        }
        else
        {
          instanceVar_Ies = (instanceVar_IVjsmFwd+(instanceVar_SslpFwd*(ves_jct-instanceVar_VjsmFwd)));
        }
      }
    }
    else
    {
      instanceVar_Ies = 0.0;
    }
    if ((instanceVar_JTSS_t>0.0))
    {
      if (((modelPar_VTSS-ves_jct)<(modelPar_VTSS*1.0e-3)))
      {
        instanceVar_T0 = (((-ves_jct)/Vtm0)/instanceVar_NJTS_t);
        instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_T0*1.0e3))-1.0);
        instanceVar_Ies = (instanceVar_Ies-((instancePar_ASEJ*instanceVar_JTSS_t)*instanceVar_T1));
      }
      else
      {
        instanceVar_T0 = (((-ves_jct)/Vtm0)/instanceVar_NJTS_t);
        instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0*modelPar_VTSS)/(modelPar_VTSS-ves_jct)))-1.0);
        instanceVar_Ies = (instanceVar_Ies-((instancePar_ASEJ*instanceVar_JTSS_t)*instanceVar_T1));
      }
    }
    if ((instanceVar_JTSSWS_t>0.0))
    {
      if (((modelPar_VTSSWS-ves_jct)<(modelPar_VTSSWS*1.0e-3)))
      {
        instanceVar_T0 = (((-ves_jct)/Vtm0)/instanceVar_NJTSSW_t);
        instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_T0*1.0e3))-1.0);
        instanceVar_Ies = (instanceVar_Ies-((instancePar_PSEJ*instanceVar_JTSSWS_t)*instanceVar_T1));
      }
      else
      {
        instanceVar_T0 = (((-ves_jct)/Vtm0)/instanceVar_NJTSSW_t);
        instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0*modelPar_VTSSWS)/(modelPar_VTSSWS-ves_jct)))-1.0);
        instanceVar_Ies = (instanceVar_Ies-((instancePar_PSEJ*instanceVar_JTSSWS_t)*instanceVar_T1));
      }
    }
    if ((instanceVar_JTSSWGS_t>0.0))
    {
      if (((modelPar_VTSSWGS-ves_jct)<(modelPar_VTSSWGS*1.0e-3)))
      {
        instanceVar_T0 = (((-ves_jct)/Vtm0)/instanceVar_NJTSSWG_t);
        instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_T0*1.0e3))-1.0);
        instanceVar_Ies = (instanceVar_Ies-(((instanceVar_Weff0*instanceVar_NFINtotal)*instanceVar_JTSSWGS_t)*instanceVar_T1));
      }
      else
      {
        instanceVar_T0 = (((-ves_jct)/Vtm0)/instanceVar_NJTSSWG_t);
        instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0*modelPar_VTSSWGS)/(modelPar_VTSSWGS-ves_jct)))-1.0);
        instanceVar_Ies = (instanceVar_Ies-(((instanceVar_Weff0*instanceVar_NFINtotal)*instanceVar_JTSSWGS_t)*instanceVar_T1));
      }
    }
    if ((instanceVar_Isbd>0.0))
    {
      if ((ved_jct<instanceVar_VjdmRev))
      {
        instanceVar_T0 = (ved_jct/instanceVar_Nvtmd);
        instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T0)-1.0);
        instanceVar_T2 = (instanceVar_IVjdmRev+(instanceVar_DslpRev*(ved_jct-instanceVar_VjdmRev)));
        instanceVar_Ied = (instanceVar_T1*instanceVar_T2);
      }
      else
      {
        if ((ved_jct<=instanceVar_VjdmFwd))
        {
          instanceVar_T0 = (ved_jct/instanceVar_Nvtmd);
          instanceVar_T1 = ((modelPar_BVD+ved_jct)/instanceVar_Nvtmd);
          instanceVar_T2 = AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T1));
          instanceVar_Ied = (instanceVar_Isbd*(((AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T0)+instanceVar_XExpBVD)-1.0)-(modelPar_XJBVD*instanceVar_T2)));
        }
        else
        {
          instanceVar_Ied = (instanceVar_IVjdmFwd+(instanceVar_DslpFwd*(ved_jct-instanceVar_VjdmFwd)));
        }
      }
    }
    else
    {
      instanceVar_Ied = 0.0;
    }
    if ((instanceVar_JTSD_t>0.0))
    {
      if (((modelPar_VTSD-ved_jct)<(modelPar_VTSD*1.0e-3)))
      {
        instanceVar_T0 = (((-ved_jct)/Vtm0)/instanceVar_NJTSD_t);
        instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_T0*1.0e3))-1.0);
        instanceVar_Ied = (instanceVar_Ied-((instancePar_ADEJ*instanceVar_JTSD_t)*instanceVar_T1));
      }
      else
      {
        instanceVar_T0 = (((-ved_jct)/Vtm0)/instanceVar_NJTSD_t);
        instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0*modelPar_VTSD)/(modelPar_VTSD-ved_jct)))-1.0);
        instanceVar_Ied = (instanceVar_Ied-((instancePar_ADEJ*instanceVar_JTSD_t)*instanceVar_T1));
      }
    }
    if ((instanceVar_JTSSWD_t>0.0))
    {
      if (((modelPar_VTSSWD-ved_jct)<(modelPar_VTSSWD*1.0e-3)))
      {
        instanceVar_T0 = (((-ved_jct)/Vtm0)/instanceVar_NJTSSWD_t);
        instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_T0*1.0e3))-1.0);
        instanceVar_Ied = (instanceVar_Ied-((instancePar_PDEJ*instanceVar_JTSSWD_t)*instanceVar_T1));
      }
      else
      {
        instanceVar_T0 = (((-ved_jct)/Vtm0)/instanceVar_NJTSSWD_t);
        instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0*modelPar_VTSSWD)/(modelPar_VTSSWD-ved_jct)))-1.0);
        instanceVar_Ied = (instanceVar_Ied-((instancePar_PDEJ*instanceVar_JTSSWD_t)*instanceVar_T1));
      }
    }
    if ((instanceVar_JTSSWGD_t>0.0))
    {
      if (((modelPar_VTSSWGD-ved_jct)<(modelPar_VTSSWGD*1.0e-3)))
      {
        instanceVar_T0 = (((-ved_jct)/Vtm0)/instanceVar_NJTSSWGD_t);
        instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_T0*1.0e3))-1.0);
        instanceVar_Ied = (instanceVar_Ied-(((instanceVar_Weff0*instanceVar_NFINtotal)*instanceVar_JTSSWGD_t)*instanceVar_T1));
      }
      else
      {
        instanceVar_T0 = (((-ved_jct)/Vtm0)/instanceVar_NJTSSWGD_t);
        instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0*modelPar_VTSSWGD)/(modelPar_VTSSWGD-ved_jct)))-1.0);
        instanceVar_Ied = (instanceVar_Ied-(((instanceVar_Weff0*instanceVar_NFINtotal)*instanceVar_JTSSWGD_t)*instanceVar_T1));
      }
    }
    {
      if ((instanceVar_Czbs>0.0))
      {
        instanceVar_T1 = (ves_jct/instanceVar_PBS_t);
        if ((instanceVar_T1<0.9))
        {
          if ((modelPar_SJS>0.0))
          {
            vec = (instanceVar_PBS_t*(1.0-AnalogFunctions::lexp<AdmsSensFadType>(((1.0/modelPar_MJS)*AnalogFunctions::lln<AdmsSensFadType>((1.0/modelPar_SJS))))));
            pb2 = ((((instanceVar_PBS_t*modelPar_SJS)*modelPar_MJS2)/modelPar_MJS)/AnalogFunctions::lexp<AdmsSensFadType>(((-(1.0+modelPar_MJS))*AnalogFunctions::lln<AdmsSensFadType>((1.0-(vec/instanceVar_PBS_t))))));
            if ((ves_jct>vec))
            {
              arg = (1.0-instanceVar_T1);
              if ((modelPar_MJS==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJS)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qesj1 = (((instanceVar_PBS_t*instanceVar_Czbs)*(1.0-(arg*sarg)))/(1.0-modelPar_MJS));
            }
            else
            {
              arg = (1.0-(vec/instanceVar_PBS_t));
              if ((modelPar_MJS==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJS)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qec = (((instanceVar_PBS_t*instanceVar_Czbs)*(1.0-(arg*sarg)))/(1.0-modelPar_MJS));
              arg = (1.0-((ves_jct-vec)/pb2));
              if ((modelPar_MJS2==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJS2)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qesj1 = (Qec+((((modelPar_SJS*pb2)*instanceVar_Czbs)*(1.0-(arg*sarg)))/(1.0-modelPar_MJS2)));
            }
          }
          else
          {
            arg = (1.0-instanceVar_T1);
            if ((modelPar_MJS==0.5))
            {
              sarg = (1.0/sqrt(arg));
            }
            else
            {
              sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJS)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
            }
            Qesj1 = (((instanceVar_PBS_t*instanceVar_Czbs)*(1.0-(arg*sarg)))/(1.0-modelPar_MJS));
          }
        }
        else
        {
          instanceVar_T2 = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJS)*AnalogFunctions::lln<AdmsSensFadType>(0.1)));
          instanceVar_T3 = (1.0/(1.0-modelPar_MJS));
          T4 = ((instanceVar_T2*(instanceVar_T1-1.0))*(((5.0*modelPar_MJS)*(instanceVar_T1-1.0))+(1.0+modelPar_MJS)));
          T5 = (instanceVar_T3*(1.0-(((0.05*modelPar_MJS)*(1.0+modelPar_MJS))*instanceVar_T2)));
          Qesj1 = ((instanceVar_PBS_t*instanceVar_Czbs)*(T4+T5));
        }
      }
      else
      {
        Qesj1 = 0.0;
      }
    }
    {
      if ((instanceVar_Czbssw>0.0))
      {
        instanceVar_T1 = (ves_jct/instanceVar_PBSWS_t);
        if ((instanceVar_T1<0.9))
        {
          if ((modelPar_SJSWS>0.0))
          {
            vec = (instanceVar_PBSWS_t*(1.0-AnalogFunctions::lexp<AdmsSensFadType>(((1.0/modelPar_MJSWS)*AnalogFunctions::lln<AdmsSensFadType>((1.0/modelPar_SJSWS))))));
            pb2 = ((((instanceVar_PBSWS_t*modelPar_SJSWS)*modelPar_MJSWS2)/modelPar_MJSWS)/AnalogFunctions::lexp<AdmsSensFadType>(((-(1.0+modelPar_MJSWS))*AnalogFunctions::lln<AdmsSensFadType>((1.0-(vec/instanceVar_PBSWS_t))))));
            if ((ves_jct>vec))
            {
              arg = (1.0-instanceVar_T1);
              if ((modelPar_MJSWS==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWS)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qesj2 = (((instanceVar_PBSWS_t*instanceVar_Czbssw)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWS));
            }
            else
            {
              arg = (1.0-(vec/instanceVar_PBSWS_t));
              if ((modelPar_MJSWS==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWS)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qec = (((instanceVar_PBSWS_t*instanceVar_Czbssw)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWS));
              arg = (1.0-((ves_jct-vec)/pb2));
              if ((modelPar_MJSWS2==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWS2)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qesj2 = (Qec+((((modelPar_SJSWS*pb2)*instanceVar_Czbssw)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWS2)));
            }
          }
          else
          {
            arg = (1.0-instanceVar_T1);
            if ((modelPar_MJSWS==0.5))
            {
              sarg = (1.0/sqrt(arg));
            }
            else
            {
              sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWS)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
            }
            Qesj2 = (((instanceVar_PBSWS_t*instanceVar_Czbssw)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWS));
          }
        }
        else
        {
          instanceVar_T2 = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWS)*AnalogFunctions::lln<AdmsSensFadType>(0.1)));
          instanceVar_T3 = (1.0/(1.0-modelPar_MJSWS));
          T4 = ((instanceVar_T2*(instanceVar_T1-1.0))*(((5.0*modelPar_MJSWS)*(instanceVar_T1-1.0))+(1.0+modelPar_MJSWS)));
          T5 = (instanceVar_T3*(1.0-(((0.05*modelPar_MJSWS)*(1.0+modelPar_MJSWS))*instanceVar_T2)));
          Qesj2 = ((instanceVar_PBSWS_t*instanceVar_Czbssw)*(T4+T5));
        }
      }
      else
      {
        Qesj2 = 0.0;
      }
    }
    {
      if ((instanceVar_Czbsswg>0.0))
      {
        instanceVar_T1 = (ves_jct/instanceVar_PBSWGS_t);
        if ((instanceVar_T1<0.9))
        {
          if ((modelPar_SJSWGS>0.0))
          {
            vec = (instanceVar_PBSWGS_t*(1.0-AnalogFunctions::lexp<AdmsSensFadType>(((1.0/modelPar_MJSWGS)*AnalogFunctions::lln<AdmsSensFadType>((1.0/modelPar_SJSWGS))))));
            pb2 = ((((instanceVar_PBSWGS_t*modelPar_SJSWGS)*modelPar_MJSWGS2)/modelPar_MJSWGS)/AnalogFunctions::lexp<AdmsSensFadType>(((-(1.0+modelPar_MJSWGS))*AnalogFunctions::lln<AdmsSensFadType>((1.0-(vec/instanceVar_PBSWGS_t))))));
            if ((ves_jct>vec))
            {
              arg = (1.0-instanceVar_T1);
              if ((modelPar_MJSWGS==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWGS)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qesj3 = (((instanceVar_PBSWGS_t*instanceVar_Czbsswg)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWGS));
            }
            else
            {
              arg = (1.0-(vec/instanceVar_PBSWGS_t));
              if ((modelPar_MJSWGS==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWGS)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qec = (((instanceVar_PBSWGS_t*instanceVar_Czbsswg)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWGS));
              arg = (1.0-((ves_jct-vec)/pb2));
              if ((modelPar_MJSWGS2==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWGS2)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qesj3 = (Qec+((((modelPar_SJSWGS*pb2)*instanceVar_Czbsswg)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWGS2)));
            }
          }
          else
          {
            arg = (1.0-instanceVar_T1);
            if ((modelPar_MJSWGS==0.5))
            {
              sarg = (1.0/sqrt(arg));
            }
            else
            {
              sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWGS)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
            }
            Qesj3 = (((instanceVar_PBSWGS_t*instanceVar_Czbsswg)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWGS));
          }
        }
        else
        {
          instanceVar_T2 = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWGS)*AnalogFunctions::lln<AdmsSensFadType>(0.1)));
          instanceVar_T3 = (1.0/(1.0-modelPar_MJSWGS));
          T4 = ((instanceVar_T2*(instanceVar_T1-1.0))*(((5.0*modelPar_MJSWGS)*(instanceVar_T1-1.0))+(1.0+modelPar_MJSWGS)));
          T5 = (instanceVar_T3*(1.0-(((0.05*modelPar_MJSWGS)*(1.0+modelPar_MJSWGS))*instanceVar_T2)));
          Qesj3 = ((instanceVar_PBSWGS_t*instanceVar_Czbsswg)*(T4+T5));
        }
      }
      else
      {
        Qesj3 = 0.0;
      }
    }
    Qesj = ((Qesj1+Qesj2)+Qesj3);
    {
      if ((instanceVar_Czbd>0.0))
      {
        instanceVar_T1 = (ved_jct/instanceVar_PBD_t);
        if ((instanceVar_T1<0.9))
        {
          if ((modelPar_SJD>0.0))
          {
            vec = (instanceVar_PBD_t*(1.0-AnalogFunctions::lexp<AdmsSensFadType>(((1.0/modelPar_MJD)*AnalogFunctions::lln<AdmsSensFadType>((1.0/modelPar_SJD))))));
            pb2 = ((((instanceVar_PBD_t*modelPar_SJD)*modelPar_MJD2)/modelPar_MJD)/AnalogFunctions::lexp<AdmsSensFadType>(((-(1.0+modelPar_MJD))*AnalogFunctions::lln<AdmsSensFadType>((1.0-(vec/instanceVar_PBD_t))))));
            if ((ved_jct>vec))
            {
              arg = (1.0-instanceVar_T1);
              if ((modelPar_MJD==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJD)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qedj1 = (((instanceVar_PBD_t*instanceVar_Czbd)*(1.0-(arg*sarg)))/(1.0-modelPar_MJD));
            }
            else
            {
              arg = (1.0-(vec/instanceVar_PBD_t));
              if ((modelPar_MJD==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJD)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qec = (((instanceVar_PBD_t*instanceVar_Czbd)*(1.0-(arg*sarg)))/(1.0-modelPar_MJD));
              arg = (1.0-((ved_jct-vec)/pb2));
              if ((modelPar_MJD2==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJD2)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qedj1 = (Qec+((((modelPar_SJD*pb2)*instanceVar_Czbd)*(1.0-(arg*sarg)))/(1.0-modelPar_MJD2)));
            }
          }
          else
          {
            arg = (1.0-instanceVar_T1);
            if ((modelPar_MJD==0.5))
            {
              sarg = (1.0/sqrt(arg));
            }
            else
            {
              sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJD)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
            }
            Qedj1 = (((instanceVar_PBD_t*instanceVar_Czbd)*(1.0-(arg*sarg)))/(1.0-modelPar_MJD));
          }
        }
        else
        {
          instanceVar_T2 = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJD)*AnalogFunctions::lln<AdmsSensFadType>(0.1)));
          instanceVar_T3 = (1.0/(1.0-modelPar_MJD));
          T4 = ((instanceVar_T2*(instanceVar_T1-1.0))*(((5.0*modelPar_MJD)*(instanceVar_T1-1.0))+(1.0+modelPar_MJD)));
          T5 = (instanceVar_T3*(1.0-(((0.05*modelPar_MJD)*(1.0+modelPar_MJD))*instanceVar_T2)));
          Qedj1 = ((instanceVar_PBD_t*instanceVar_Czbd)*(T4+T5));
        }
      }
      else
      {
        Qedj1 = 0.0;
      }
    }
    {
      if ((instanceVar_Czbdsw>0.0))
      {
        instanceVar_T1 = (ved_jct/instanceVar_PBSWD_t);
        if ((instanceVar_T1<0.9))
        {
          if ((modelPar_SJSWD>0.0))
          {
            vec = (instanceVar_PBSWD_t*(1.0-AnalogFunctions::lexp<AdmsSensFadType>(((1.0/modelPar_MJSWD)*AnalogFunctions::lln<AdmsSensFadType>((1.0/modelPar_SJSWD))))));
            pb2 = ((((instanceVar_PBSWD_t*modelPar_SJSWD)*modelPar_MJSWD2)/modelPar_MJSWD)/AnalogFunctions::lexp<AdmsSensFadType>(((-(1.0+modelPar_MJSWD))*AnalogFunctions::lln<AdmsSensFadType>((1.0-(vec/instanceVar_PBSWD_t))))));
            if ((ved_jct>vec))
            {
              arg = (1.0-instanceVar_T1);
              if ((modelPar_MJSWD==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWD)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qedj2 = (((instanceVar_PBSWD_t*instanceVar_Czbdsw)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWD));
            }
            else
            {
              arg = (1.0-(vec/instanceVar_PBSWD_t));
              if ((modelPar_MJSWD==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWD)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qec = (((instanceVar_PBSWD_t*instanceVar_Czbdsw)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWD));
              arg = (1.0-((ved_jct-vec)/pb2));
              if ((modelPar_MJSWD2==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWD2)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qedj2 = (Qec+((((modelPar_SJSWD*pb2)*instanceVar_Czbdsw)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWD2)));
            }
          }
          else
          {
            arg = (1.0-instanceVar_T1);
            if ((modelPar_MJSWD==0.5))
            {
              sarg = (1.0/sqrt(arg));
            }
            else
            {
              sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWD)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
            }
            Qedj2 = (((instanceVar_PBSWD_t*instanceVar_Czbdsw)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWD));
          }
        }
        else
        {
          instanceVar_T2 = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWD)*AnalogFunctions::lln<AdmsSensFadType>(0.1)));
          instanceVar_T3 = (1.0/(1.0-modelPar_MJSWD));
          T4 = ((instanceVar_T2*(instanceVar_T1-1.0))*(((5.0*modelPar_MJSWD)*(instanceVar_T1-1.0))+(1.0+modelPar_MJSWD)));
          T5 = (instanceVar_T3*(1.0-(((0.05*modelPar_MJSWD)*(1.0+modelPar_MJSWD))*instanceVar_T2)));
          Qedj2 = ((instanceVar_PBSWD_t*instanceVar_Czbdsw)*(T4+T5));
        }
      }
      else
      {
        Qedj2 = 0.0;
      }
    }
    {
      if ((instanceVar_Czbdswg>0.0))
      {
        instanceVar_T1 = (ved_jct/instanceVar_PBSWGD_t);
        if ((instanceVar_T1<0.9))
        {
          if ((modelPar_SJSWGD>0.0))
          {
            vec = (instanceVar_PBSWGD_t*(1.0-AnalogFunctions::lexp<AdmsSensFadType>(((1.0/modelPar_MJSWGD)*AnalogFunctions::lln<AdmsSensFadType>((1.0/modelPar_SJSWGD))))));
            pb2 = ((((instanceVar_PBSWGD_t*modelPar_SJSWGD)*modelPar_MJSWGD2)/modelPar_MJSWGD)/AnalogFunctions::lexp<AdmsSensFadType>(((-(1.0+modelPar_MJSWGD))*AnalogFunctions::lln<AdmsSensFadType>((1.0-(vec/instanceVar_PBSWGD_t))))));
            if ((ved_jct>vec))
            {
              arg = (1.0-instanceVar_T1);
              if ((modelPar_MJSWGD==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWGD)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qedj3 = (((instanceVar_PBSWGD_t*instanceVar_Czbdswg)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWGD));
            }
            else
            {
              arg = (1.0-(vec/instanceVar_PBSWGD_t));
              if ((modelPar_MJSWGD==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWGD)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qec = (((instanceVar_PBSWGD_t*instanceVar_Czbdswg)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWGD));
              arg = (1.0-((ved_jct-vec)/pb2));
              if ((modelPar_MJSWGD2==0.5))
              {
                sarg = (1.0/sqrt(arg));
              }
              else
              {
                sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWGD2)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
              }
              Qedj3 = (Qec+((((modelPar_SJSWGD*pb2)*instanceVar_Czbdswg)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWGD2)));
            }
          }
          else
          {
            arg = (1.0-instanceVar_T1);
            if ((modelPar_MJSWGD==0.5))
            {
              sarg = (1.0/sqrt(arg));
            }
            else
            {
              sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWGD)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
            }
            Qedj3 = (((instanceVar_PBSWGD_t*instanceVar_Czbdswg)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWGD));
          }
        }
        else
        {
          instanceVar_T2 = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWGD)*AnalogFunctions::lln<AdmsSensFadType>(0.1)));
          instanceVar_T3 = (1.0/(1.0-modelPar_MJSWGD));
          T4 = ((instanceVar_T2*(instanceVar_T1-1.0))*(((5.0*modelPar_MJSWGD)*(instanceVar_T1-1.0))+(1.0+modelPar_MJSWGD)));
          T5 = (instanceVar_T3*(1.0-(((0.05*modelPar_MJSWGD)*(1.0+modelPar_MJSWGD))*instanceVar_T2)));
          Qedj3 = ((instanceVar_PBSWGD_t*instanceVar_Czbdswg)*(T4+T5));
        }
      }
      else
      {
        Qedj3 = 0.0;
      }
    }
    Qedj = ((Qedj1+Qedj2)+Qedj3);
  }
  instanceVar_Qes = (Qesj+(instanceVar_csbox*ves_jct));
  instanceVar_Qed = (Qedj+(instanceVar_cdbox*ved_jct));
  instanceVar_Qeg = ((instanceVar_cgbox*instanceVar_devsign)*(probeVars[admsProbeID_V_e_ge]));
  if ((modelPar_BULKMOD!=0))
  {
    instanceVar_T2 = (instanceVar_devsign*(probeVars[admsProbeID_V_ge_e]));
    instanceVar_T3 = ((((instanceVar_T2-deltaPhi)+(Eg/2.0))+phib)-modelPar_DELVFBACC);
    instanceVar_T0 = (instanceVar_T3+0.02);
    vge_overlap = (0.5*(instanceVar_T0+sqrt(((instanceVar_T0*instanceVar_T0)+(4.0*0.02)))));
    instanceVar_Qeg = (instanceVar_Qeg-((instanceVar_NFINtotal*instanceVar_LeffCV)*(instanceVar_CGBL_i*((instanceVar_T3-vge_overlap)+((0.5*instanceVar_CKAPPAB_i)*(sqrt((1.0+((4.0*vge_overlap)/instanceVar_CKAPPAB_i)))-1.0))))));
  }
  instanceVar_T0 = vds;
  instanceVar_T1 = (instanceVar_T0*(instanceVar_AIGEN_i+((instanceVar_BIGEN_i*instanceVar_T0)*instanceVar_T0)));
  instanceVar_idsgen = ((((modelPar_HFIN*instancePar_TFIN)*(instanceVar_Leff-(2.0*instanceVar_LINTIGEN_i)))*igentemp)*instanceVar_T1);
  instanceVar_T0 = (((ueff*coxeff)*instanceVar_Weff0)/instanceVar_Leff);
  instanceVar_igidl = (instanceVar_NFINtotal*instanceVar_igidl);
  instanceVar_igisl = (instanceVar_NFINtotal*instanceVar_igisl);
  instanceVar_igcd = (instanceVar_NFINtotal*instanceVar_igcd);
  instanceVar_igcs = (instanceVar_NFINtotal*instanceVar_igcs);
  instanceVar_igs = (instanceVar_NFINtotal*instanceVar_igs);
  instanceVar_igd = (instanceVar_NFINtotal*instanceVar_igd);
  instanceVar_igbinv = (instanceVar_NFINtotal*instanceVar_igbinv);
  instanceVar_igbacc = (instanceVar_NFINtotal*instanceVar_igbacc);
  instanceVar_idsgen = (instanceVar_NFINtotal*instanceVar_idsgen);
  instanceVar_igbs = 0.0;
  instanceVar_igbd = 0.0;
  if ((modelPar_BULKMOD==0))
  {
    instanceVar_igbs = ((instanceVar_igbinv+instanceVar_igbacc)*wf);
    instanceVar_igbd = ((instanceVar_igbinv+instanceVar_igbacc)*wr);
  }
  Esatnoi = ((2.0*instanceVar_VSAT_a)/ueff);
  if ((((modelPar_NOIA>0.0)||(modelPar_NOIB>0.0))||(modelPar_NOIC>0.0)))
  {
    Leffnoi = (instanceVar_Leff-(2.0*instanceVar_LINTNOI_i));
    Leffnoisq = (Leffnoi*Leffnoi);
    if ((modelPar_EM<=0.0))
    {
      DelClm = 0.0;
    }
    else
    {
      instanceVar_T0 = (((diffVds/instanceVar_litl)+modelPar_EM)/Esatnoi);
      DelClm = (instanceVar_litl*AnalogFunctions::lln<AdmsSensFadType>(instanceVar_T0));
      if ((DelClm<0.0))
      {
        DelClm = 0.0;
      }
    }
    instanceVar_T1 = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*fabs(instanceVar_ids))*ueff);
    instanceVar_T2 = ((1.0e10*coxeff)*Leffnoisq);
    N0 = ((coxeff*instanceVar_qis)/1.60219e-19);
    Nl = ((coxeff*instanceVar_qid)/1.60219e-19);
    Nstar = ((Vtm/1.60219e-19)*(coxeff+CIT_a));
    instanceVar_T3 = (modelPar_NOIA*AnalogFunctions::lln<AdmsSensFadType>(((N0+Nstar)/(Nl+Nstar))));
    T4 = (modelPar_NOIB*(N0-Nl));
    T5 = ((0.5*modelPar_NOIC)*((N0*N0)-(Nl*Nl)));
    T6 = (((1.60219e-19*Vtm)*instanceVar_ids)*instanceVar_ids);
    T7 = (((1.0e10*Leffnoisq)*instanceVar_Weff0)*instanceVar_NFINtotal);
    T8 = ((modelPar_NOIA+(modelPar_NOIB*Nl))+((modelPar_NOIC*Nl)*Nl));
    T9 = ((Nl+Nstar)*(Nl+Nstar));
    Ssi = (((instanceVar_T1/instanceVar_T2)*((instanceVar_T3+T4)+T5))+((((T6/T7)*DelClm)*T8)/T9));
    T10 = ((modelPar_NOIA*1.60219e-19)*Vtm);
    instanceVar_T11 = (((((instanceVar_Weff0*instanceVar_NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar);
    Swi = (((T10/instanceVar_T11)*instanceVar_ids)*instanceVar_ids);
    instanceVar_T1 = (Swi+Ssi);
    if ((instanceVar_T1>0.0))
    {
      instanceVar_FNPowerAt1Hz = ((Ssi*Swi)/instanceVar_T1);
    }
    else
    {
      instanceVar_FNPowerAt1Hz = 0.0;
    }
  }
  else
  {
    instanceVar_FNPowerAt1Hz = 0.0;
  }
  if ( modelPar_TNOIMOD == (0))
  {
    instanceVar_T0 = (ueff*qinv);
    instanceVar_T1 = ((instanceVar_T0*instanceVar_Rdsi)+(instanceVar_Leff*instanceVar_Leff));
    instanceVar_Gtnoi = ((instanceVar_T0/instanceVar_T1)*instanceVar_NTNOI_i);
    instanceVar_sid = (((4.0*Vtm)*1.60219e-19)*instanceVar_Gtnoi);
  }
  else
    if ( modelPar_TNOIMOD == (1))
    {
      Abulk = 1.0;
      Vgst2Vtm = (KSATIV_a*(instanceVar_qis+(2.0*Vtm)));
      etaa = (1.0-((Vdseff*Abulk)/Vgst2Vtm));
      instanceVar_T0 = (1.0-etaa);
      instanceVar_T1 = (1.0+etaa);
      instanceVar_T2 = (instanceVar_T1+(((2.0*Abulk)*Vtm)/(qia+1.0e-10)));
      instanceVar_T3 = (instanceVar_T2*instanceVar_T2);
      T4 = (instanceVar_T0*instanceVar_T0);
      T5 = (instanceVar_T3*instanceVar_T3);
      T6 = (1.0/(1.0+(Vdseff/EsatL)));
      instanceVar_gamma = (T6*((0.5*instanceVar_T1)+((instanceVar_T0*instanceVar_T0)/(6.0*instanceVar_T2))));
      instanceVar_delta = ((((instanceVar_T1/instanceVar_T3)-((((5.0*instanceVar_T1)+instanceVar_T2)*T4)/(15.0*T5)))+((T4*T4)/((9.0*T5)*instanceVar_T2)))/(((6.0*T6)*T6)*T6));
      T7 = (instanceVar_T0/instanceVar_T2);
      epsilon = ((T7+(((T7*T7)*T7)/3.0))/(6.0*T6));
      T8 = (qia/EsatL);
      T8 = (T8*T8);
      npart_c = (modelPar_RNOIC*(1.0+((T8*modelPar_TNOIC)*instanceVar_Leff)));
      T9 = (instanceVar_gamma*instanceVar_delta);
      if ((T9>0.0))
      {
        instanceVar_ctnoi = ((epsilon/sqrt((instanceVar_gamma*instanceVar_delta)))*(2.5316*npart_c));
      }
      else
      {
        instanceVar_ctnoi = 1.0;
      }
      if ((instanceVar_ctnoi>1))
      {
        instanceVar_ctnoi = 1.0;
      }
      if ((instanceVar_ctnoi<0))
      {
        instanceVar_ctnoi = 0.0;
      }
      npart_beta = (modelPar_RNOIA*(1.0+((T8*modelPar_TNOIA)*instanceVar_Leff)));
      npart_theta = (modelPar_RNOIB*(1.0+((T8*modelPar_TNOIB)*instanceVar_Leff)));
      instanceVar_gamma = (instanceVar_gamma*((3.0*npart_beta)*npart_beta));
      instanceVar_delta = (instanceVar_delta*((3.75*npart_theta)*npart_theta));
      T9 = ((qia*0.5)*instanceVar_T1);
      gche = ((beta*T9)*T6);
      noiGd0 = (((instanceVar_NFINtotal*beta)*qia)/(1.0+(gche*instanceVar_Rdsi)));
      GammaGd0 = (instanceVar_gamma*noiGd0);
      instanceVar_sid = (((4.0*Vtm)*1.60219e-19)*GammaGd0);
      instanceVar_C0 = (((instanceVar_NFINtotal*coxeff)*instanceVar_WeffCV0)*instanceVar_LeffCV);
      if (((instanceVar_gamma>0.0)&&(instanceVar_delta>0.0)))
      {
        instanceVar_sf = ((noiGd0+1.0e-15)/sqrt((instanceVar_delta/instanceVar_gamma)));
      }
      else
      {
        instanceVar_sf = 0.0;
      }
    }
    else
    {
      // no default
    }
  if ((modelPar_RDSMOD!=2))
  {
    instanceVar_gspr = (1.0/instanceVar_Rsource);
    instanceVar_gdpr = (1.0/instanceVar_Rdrain);
  }
  if ((instanceVar_sigvds>0.0))
  {
    // I(di,si) <+ (((m*devsign)*ids))
    staticContributions[admsNodeID_di] += ((instancePar_m*instanceVar_devsign)*instanceVar_ids);
    staticContributions[admsNodeID_si] -= ((instancePar_m*instanceVar_devsign)*instanceVar_ids);
  }
  else
  {
    // I(si,di) <+ (((m*devsign)*ids))
    staticContributions[admsNodeID_si] += ((instancePar_m*instanceVar_devsign)*instanceVar_ids);
    staticContributions[admsNodeID_di] -= ((instancePar_m*instanceVar_devsign)*instanceVar_ids);
  }
  // I(di,si) <+ (((m*devsign)*ddt(qd)))
  dynamicContributions[admsNodeID_di] += ((instancePar_m*instanceVar_devsign)*(instanceVar_qd));
  dynamicContributions[admsNodeID_si] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_qd));
  // I(ge,si) <+ (((m*devsign)*ddt(qg)))
  dynamicContributions[admsNodeID_ge] += ((instancePar_m*instanceVar_devsign)*(instanceVar_qg));
  dynamicContributions[admsNodeID_si] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_qg));
  if ((instanceVar_sigvds>0.0))
  {
    // I(di,si) <+ (((m*devsign)*idsgen))
    staticContributions[admsNodeID_di] += ((instancePar_m*instanceVar_devsign)*instanceVar_idsgen);
    staticContributions[admsNodeID_si] -= ((instancePar_m*instanceVar_devsign)*instanceVar_idsgen);
    // I(ge,si) <+ (((m*devsign)*(igcs+igs)))
    staticContributions[admsNodeID_ge] += ((instancePar_m*instanceVar_devsign)*(instanceVar_igcs+instanceVar_igs));
    staticContributions[admsNodeID_si] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_igcs+instanceVar_igs));
    // I(ge,di) <+ (((m*devsign)*(igcd+igd)))
    staticContributions[admsNodeID_ge] += ((instancePar_m*instanceVar_devsign)*(instanceVar_igcd+instanceVar_igd));
    staticContributions[admsNodeID_di] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_igcd+instanceVar_igd));
    if ((modelPar_BULKMOD!=0))
    {
      // I(di,e) <+ (((m*devsign)*(igidl+Iii)))
      staticContributions[admsNodeID_di] += ((instancePar_m*instanceVar_devsign)*(instanceVar_igidl+instanceVar_Iii));
      staticContributions[admsNodeID_e] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_igidl+instanceVar_Iii));
      // I(si,e) <+ (((m*devsign)*igisl))
      staticContributions[admsNodeID_si] += ((instancePar_m*instanceVar_devsign)*instanceVar_igisl);
      staticContributions[admsNodeID_e] -= ((instancePar_m*instanceVar_devsign)*instanceVar_igisl);
      // I(ge,e) <+ (((m*devsign)*(igbinv+igbacc)))
      staticContributions[admsNodeID_ge] += ((instancePar_m*instanceVar_devsign)*(instanceVar_igbinv+instanceVar_igbacc));
      staticContributions[admsNodeID_e] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_igbinv+instanceVar_igbacc));
    }
    else
    {
      // I(di,si) <+ (((m*devsign)*(igidl+Iii)))
      staticContributions[admsNodeID_di] += ((instancePar_m*instanceVar_devsign)*(instanceVar_igidl+instanceVar_Iii));
      staticContributions[admsNodeID_si] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_igidl+instanceVar_Iii));
      // I(si,di) <+ (((m*devsign)*igisl))
      staticContributions[admsNodeID_si] += ((instancePar_m*instanceVar_devsign)*instanceVar_igisl);
      staticContributions[admsNodeID_di] -= ((instancePar_m*instanceVar_devsign)*instanceVar_igisl);
    }
  }
  else
  {
    // I(si,di) <+ (((m*devsign)*idsgen))
    staticContributions[admsNodeID_si] += ((instancePar_m*instanceVar_devsign)*instanceVar_idsgen);
    staticContributions[admsNodeID_di] -= ((instancePar_m*instanceVar_devsign)*instanceVar_idsgen);
    // I(ge,di) <+ (((m*devsign)*(igcs+igs)))
    staticContributions[admsNodeID_ge] += ((instancePar_m*instanceVar_devsign)*(instanceVar_igcs+instanceVar_igs));
    staticContributions[admsNodeID_di] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_igcs+instanceVar_igs));
    // I(ge,si) <+ (((m*devsign)*(igcd+igd)))
    staticContributions[admsNodeID_ge] += ((instancePar_m*instanceVar_devsign)*(instanceVar_igcd+instanceVar_igd));
    staticContributions[admsNodeID_si] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_igcd+instanceVar_igd));
    if ((modelPar_BULKMOD!=0))
    {
      // I(si,e) <+ (((m*devsign)*(igidl+Iii)))
      staticContributions[admsNodeID_si] += ((instancePar_m*instanceVar_devsign)*(instanceVar_igidl+instanceVar_Iii));
      staticContributions[admsNodeID_e] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_igidl+instanceVar_Iii));
      // I(di,e) <+ (((m*devsign)*igisl))
      staticContributions[admsNodeID_di] += ((instancePar_m*instanceVar_devsign)*instanceVar_igisl);
      staticContributions[admsNodeID_e] -= ((instancePar_m*instanceVar_devsign)*instanceVar_igisl);
      // I(ge,e) <+ (((m*devsign)*(igbinv+igbacc)))
      staticContributions[admsNodeID_ge] += ((instancePar_m*instanceVar_devsign)*(instanceVar_igbinv+instanceVar_igbacc));
      staticContributions[admsNodeID_e] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_igbinv+instanceVar_igbacc));
    }
    else
    {
      // I(si,di) <+ (((m*devsign)*(igidl+Iii)))
      staticContributions[admsNodeID_si] += ((instancePar_m*instanceVar_devsign)*(instanceVar_igidl+instanceVar_Iii));
      staticContributions[admsNodeID_di] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_igidl+instanceVar_Iii));
      // I(di,si) <+ (((m*devsign)*igisl))
      staticContributions[admsNodeID_di] += ((instancePar_m*instanceVar_devsign)*instanceVar_igisl);
      staticContributions[admsNodeID_si] -= ((instancePar_m*instanceVar_devsign)*instanceVar_igisl);
    }
  }
  if ((modelPar_BULKMOD==0))
  {
    // I(ge,si) <+ (((m*devsign)*igbs))
    staticContributions[admsNodeID_ge] += ((instancePar_m*instanceVar_devsign)*instanceVar_igbs);
    staticContributions[admsNodeID_si] -= ((instancePar_m*instanceVar_devsign)*instanceVar_igbs);
    // I(ge,di) <+ (((m*devsign)*igbd))
    staticContributions[admsNodeID_ge] += ((instancePar_m*instanceVar_devsign)*instanceVar_igbd);
    staticContributions[admsNodeID_di] -= ((instancePar_m*instanceVar_devsign)*instanceVar_igbd);
  }
  if ((modelPar_BULKMOD!=0))
  {
    // I(e,si) <+ (((m*devsign)*Ies))
    staticContributions[admsNodeID_e] += ((instancePar_m*instanceVar_devsign)*instanceVar_Ies);
    staticContributions[admsNodeID_si] -= ((instancePar_m*instanceVar_devsign)*instanceVar_Ies);
    // I(e,di) <+ (((m*devsign)*Ied))
    staticContributions[admsNodeID_e] += ((instancePar_m*instanceVar_devsign)*instanceVar_Ied);
    staticContributions[admsNodeID_di] -= ((instancePar_m*instanceVar_devsign)*instanceVar_Ied);
  }
  // I(e,si) <+ (((m*devsign)*ddt(Qes)))
  dynamicContributions[admsNodeID_e] += ((instancePar_m*instanceVar_devsign)*(instanceVar_Qes));
  dynamicContributions[admsNodeID_si] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_Qes));
  // I(e,di) <+ (((m*devsign)*ddt(Qed)))
  dynamicContributions[admsNodeID_e] += ((instancePar_m*instanceVar_devsign)*(instanceVar_Qed));
  dynamicContributions[admsNodeID_di] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_Qed));
  // I(e,ge) <+ (((m*devsign)*ddt(Qeg)))
  dynamicContributions[admsNodeID_e] += ((instancePar_m*instanceVar_devsign)*(instanceVar_Qeg));
  dynamicContributions[admsNodeID_ge] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_Qeg));
  // I(ge,si) <+ ((m*ddt(qgs_parasitic)))
  dynamicContributions[admsNodeID_ge] += (instancePar_m*(instanceVar_qgs_parasitic));
  dynamicContributions[admsNodeID_si] -= (instancePar_m*(instanceVar_qgs_parasitic));
  // I(ge,di) <+ ((m*ddt(qgd_parasitic)))
  dynamicContributions[admsNodeID_ge] += (instancePar_m*(instanceVar_qgd_parasitic));
  dynamicContributions[admsNodeID_di] -= (instancePar_m*(instanceVar_qgd_parasitic));
  // I(d,s) <+ ((m*ddt(qds_fr)))
  dynamicContributions[admsNodeID_d] += (instancePar_m*(instanceVar_qds_fr));
  dynamicContributions[admsNodeID_s] -= (instancePar_m*(instanceVar_qds_fr));
  if ((modelPar_CGEOMOD==1))
  {
    // I(ge,s) <+ ((m*ddt(qgs_fr)))
    dynamicContributions[admsNodeID_ge] += (instancePar_m*(instanceVar_qgs_fr));
    dynamicContributions[admsNodeID_s] -= (instancePar_m*(instanceVar_qgs_fr));
    // I(ge,d) <+ ((m*ddt(qgd_fr)))
    dynamicContributions[admsNodeID_ge] += (instancePar_m*(instanceVar_qgd_fr));
    dynamicContributions[admsNodeID_d] -= (instancePar_m*(instanceVar_qgd_fr));
  }
  if ((modelPar_BULKMOD!=0))
  {
    // I(ge,si) <+ (((m*devsign)*ddt(qg_acc)))
    dynamicContributions[admsNodeID_ge] += ((instancePar_m*instanceVar_devsign)*(instanceVar_qg_acc));
    dynamicContributions[admsNodeID_si] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_qg_acc));
    // I(e,si) <+ (((m*devsign)*ddt(qb_acc)))
    dynamicContributions[admsNodeID_e] += ((instancePar_m*instanceVar_devsign)*(instanceVar_qb_acc));
    dynamicContributions[admsNodeID_si] -= ((instancePar_m*instanceVar_devsign)*(instanceVar_qb_acc));
  }
  if ((modelPar_RDSMOD==2))
  {
    // V(d,di) <+ (0.0)
    // do nothing at all
    // V(s,si) <+ (0.0)
    // do nothing at all
  }
  else
  {
    // I(d,di) <+ (((m*V(d,di))/Rdrain))
    staticContributions[admsNodeID_d] += ((instancePar_m*(probeVars[admsProbeID_V_d_di]))/instanceVar_Rdrain);
    staticContributions[admsNodeID_di] -= ((instancePar_m*(probeVars[admsProbeID_V_d_di]))/instanceVar_Rdrain);
    // I(s,si) <+ (((m*V(s,si))/Rsource))
    staticContributions[admsNodeID_s] += ((instancePar_m*(probeVars[admsProbeID_V_s_si]))/instanceVar_Rsource);
    staticContributions[admsNodeID_si] -= ((instancePar_m*(probeVars[admsProbeID_V_s_si]))/instanceVar_Rsource);
  }
  if ((modelPar_RGATEMOD!=0))
  {
    // I(g,ge) <+ (((m*V(g,ge))*ggeltd))
    staticContributions[admsNodeID_g] += ((instancePar_m*(probeVars[admsProbeID_V_g_ge]))*instanceVar_ggeltd);
    staticContributions[admsNodeID_ge] -= ((instancePar_m*(probeVars[admsProbeID_V_g_ge]))*instanceVar_ggeltd);
  }
  else
  {
    // V(g,ge) <+ (0.0)
    // do nothing at all
  }
  // I(di,si) <+ (flicker_noise((m*FNPowerAt1Hz),EF,"flicker"))
  if ((modelPar_RDSMOD!=2))
  {
    // I(d,di) <+ (white_noise(((((m*4.0)*Vtm)*1.60219e-19)*gdpr),"thermal"))
    // I(s,si) <+ (white_noise(((((m*4.0)*Vtm)*1.60219e-19)*gspr),"thermal"))
  }
  if ((modelPar_RGATEMOD!=0))
  {
    // I(g,ge) <+ (white_noise(((((m*4.0)*Vtm)*1.60219e-19)*ggeltd),"thermal"))
  }
  if ((modelPar_TNOIMOD==0))
  {
    // I(di,si) <+ (white_noise((m*sid),"thermal"))
    // V(N,GND) <+ (0.0)
    // do nothing at all
  }
  else
  {
    // I(di,si) <+ (white_noise(((m*sid)*abs((1.0-(ctnoi*ctnoi)))),"thermal"))
    // I(di,si) <+ (((((m*ctnoi)*V(N,GND))*sf)*SCALEN))
    staticContributions[admsNodeID_di] += ((((instancePar_m*instanceVar_ctnoi)*(probeVars[admsProbeID_V_N_GND]))*instanceVar_sf)*modelPar_SCALEN);
    staticContributions[admsNodeID_si] -= ((((instancePar_m*instanceVar_ctnoi)*(probeVars[admsProbeID_V_N_GND]))*instanceVar_sf)*modelPar_SCALEN);
    if (((instanceVar_gamma>0)&&(instanceVar_delta>0)))
    {
      // I(N,GND) <+ ((((m*V(N,GND))*sf)*SCALEN))
      staticContributions[admsNodeID_N] += (((instancePar_m*(probeVars[admsProbeID_V_N_GND]))*instanceVar_sf)*modelPar_SCALEN);
      // I(N,GND) <+ (white_noise(((m*sid)/(((sf*sf)*SCALEN)*SCALEN))))
    }
    else
    {
      // I(N,GND) <+ ((m*V(N,GND)))
      staticContributions[admsNodeID_N] += (instancePar_m*(probeVars[admsProbeID_V_N_GND]));
    }
    // I(ge,si) <+ (ddt(((((m*0.5)*C0)*SCALEN)*V(N,GND))))
    dynamicContributions[admsNodeID_ge] += (((((instancePar_m*0.5)*instanceVar_C0)*modelPar_SCALEN)*(probeVars[admsProbeID_V_N_GND])));
    dynamicContributions[admsNodeID_si] -= (((((instancePar_m*0.5)*instanceVar_C0)*modelPar_SCALEN)*(probeVars[admsProbeID_V_N_GND])));
    // I(ge,di) <+ (ddt(((((m*0.5)*C0)*SCALEN)*V(N,GND))))
    dynamicContributions[admsNodeID_ge] += (((((instancePar_m*0.5)*instanceVar_C0)*modelPar_SCALEN)*(probeVars[admsProbeID_V_N_GND])));
    dynamicContributions[admsNodeID_di] -= (((((instancePar_m*0.5)*instanceVar_C0)*modelPar_SCALEN)*(probeVars[admsProbeID_V_N_GND])));
  }
  if ((modelPar_IGCMOD!=0))
  {
    if ((instanceVar_sigvds>0))
    {
      // I(ge,si) <+ (white_noise((((m*2.0)*1.60219e-19)*abs((igcs+igs))),"shot"))
      // I(ge,di) <+ (white_noise((((m*2.0)*1.60219e-19)*abs((igcd+igd))),"shot"))
    }
    else
    {
      // I(ge,di) <+ (white_noise((((m*2.0)*1.60219e-19)*abs((igcs+igs))),"shot"))
      // I(ge,si) <+ (white_noise((((m*2.0)*1.60219e-19)*abs((igcd+igd))),"shot"))
    }
  }
  if ((modelPar_IGBMOD!=0))
  {
    if ((modelPar_BULKMOD!=0))
    {
      // I(ge,e) <+ (white_noise((((m*2.0)*1.60219e-19)*abs((igbinv+igbacc))),"shot"))
    }
    else
    {
      // I(ge,si) <+ (white_noise((((m*2.0)*1.60219e-19)*abs(igbs)),"shot"))
      // I(ge,di) <+ (white_noise((((m*2.0)*1.60219e-19)*abs(igbd)),"shot"))
    }
  }
  if (((modelPar_SHMOD!=0)&&(modelPar_RTH0>0)))
  {
    if ((modelPar_RDSMOD!=2))
    {
      // Pwr(t,GND) <+ ((m*(-(((((devsign*sigvds)*V(di,si))*ids)+((V(d,di)*V(d,di))/Rdrain))+((V(s,si)*V(s,si))/Rsource)))))
      staticContributions[admsNodeID_t] += (instancePar_m*(-(((((instanceVar_devsign*instanceVar_sigvds)*(probeVars[admsProbeID_V_di_si]))*instanceVar_ids)+(((probeVars[admsProbeID_V_d_di])*(probeVars[admsProbeID_V_d_di]))/instanceVar_Rdrain))+(((probeVars[admsProbeID_V_s_si])*(probeVars[admsProbeID_V_s_si]))/instanceVar_Rsource))));
    }
    else
    {
      // Pwr(t,GND) <+ ((m*(-(((devsign*sigvds)*V(di,si))*ids))))
      staticContributions[admsNodeID_t] += (instancePar_m*(-(((instanceVar_devsign*instanceVar_sigvds)*(probeVars[admsProbeID_V_di_si]))*instanceVar_ids)));
    }
  }
  // Pwr(t,GND) <+ (((m*Temp(t,GND))*gth))
  staticContributions[admsNodeID_t] += ((instancePar_m*(probeVars[admsProbeID_Temp_t_GND]))*instanceVar_gth);
  // Pwr(t,GND) <+ (ddt(((m*Temp(t,GND))*cth)))
  dynamicContributions[admsNodeID_t] += (((instancePar_m*(probeVars[admsProbeID_Temp_t_GND]))*instanceVar_cth));
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void InstanceSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Instance & in = *(dynamic_cast<const Instance *> (e1));
  const Model & mod =in.model_;

  dfdp.resize(9+0);
  dqdp.resize(9+0);
  Findices.resize(9+0);
  Qindices.resize(9+0);

  std::vector <double> probeVars(19);
  std::vector <AdmsSensFadType> staticContributions(9+0);
  std::vector <AdmsSensFadType> dynamicContributions(9+0);


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 9+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // Copy out all the model parameters (doubles) into FAD types
  //reals
  AdmsSensFadType modelPar_L=mod.L;
  bool modelPar_given_L=mod.given("L");
  AdmsSensFadType modelPar_D=mod.D;
  bool modelPar_given_D=mod.given("D");
  AdmsSensFadType modelPar_TFIN=mod.TFIN;
  bool modelPar_given_TFIN=mod.given("TFIN");
  AdmsSensFadType modelPar_FPITCH=mod.FPITCH;
  bool modelPar_given_FPITCH=mod.given("FPITCH");
  AdmsSensFadType modelPar_NFIN=mod.NFIN;
  bool modelPar_given_NFIN=mod.given("NFIN");
  AdmsSensFadType modelPar_ASEO=mod.ASEO;
  bool modelPar_given_ASEO=mod.given("ASEO");
  AdmsSensFadType modelPar_ADEO=mod.ADEO;
  bool modelPar_given_ADEO=mod.given("ADEO");
  AdmsSensFadType modelPar_PSEO=mod.PSEO;
  bool modelPar_given_PSEO=mod.given("PSEO");
  AdmsSensFadType modelPar_PDEO=mod.PDEO;
  bool modelPar_given_PDEO=mod.given("PDEO");
  AdmsSensFadType modelPar_ASEJ=mod.ASEJ;
  bool modelPar_given_ASEJ=mod.given("ASEJ");
  AdmsSensFadType modelPar_ADEJ=mod.ADEJ;
  bool modelPar_given_ADEJ=mod.given("ADEJ");
  AdmsSensFadType modelPar_PSEJ=mod.PSEJ;
  bool modelPar_given_PSEJ=mod.given("PSEJ");
  AdmsSensFadType modelPar_PDEJ=mod.PDEJ;
  bool modelPar_given_PDEJ=mod.given("PDEJ");
  AdmsSensFadType modelPar_COVS=mod.COVS;
  bool modelPar_given_COVS=mod.given("COVS");
  AdmsSensFadType modelPar_COVD=mod.COVD;
  bool modelPar_given_COVD=mod.given("COVD");
  AdmsSensFadType modelPar_CGSP=mod.CGSP;
  bool modelPar_given_CGSP=mod.given("CGSP");
  AdmsSensFadType modelPar_CGDP=mod.CGDP;
  bool modelPar_given_CGDP=mod.given("CGDP");
  AdmsSensFadType modelPar_CDSP=mod.CDSP;
  bool modelPar_given_CDSP=mod.given("CDSP");
  AdmsSensFadType modelPar_NRS=mod.NRS;
  bool modelPar_given_NRS=mod.given("NRS");
  AdmsSensFadType modelPar_NRD=mod.NRD;
  bool modelPar_given_NRD=mod.given("NRD");
  AdmsSensFadType modelPar_LRSD=mod.LRSD;
  bool modelPar_given_LRSD=mod.given("LRSD");
  AdmsSensFadType modelPar_XL=mod.XL;
  bool modelPar_given_XL=mod.given("XL");
  AdmsSensFadType modelPar_DTEMP=mod.DTEMP;
  bool modelPar_given_DTEMP=mod.given("DTEMP");
  AdmsSensFadType modelPar_DELVTRAND=mod.DELVTRAND;
  bool modelPar_given_DELVTRAND=mod.given("DELVTRAND");
  AdmsSensFadType modelPar_U0MULT=mod.U0MULT;
  bool modelPar_given_U0MULT=mod.given("U0MULT");
  AdmsSensFadType modelPar_IDS0MULT=mod.IDS0MULT;
  bool modelPar_given_IDS0MULT=mod.given("IDS0MULT");
  AdmsSensFadType modelPar_LINT=mod.LINT;
  bool modelPar_given_LINT=mod.given("LINT");
  AdmsSensFadType modelPar_LL=mod.LL;
  bool modelPar_given_LL=mod.given("LL");
  AdmsSensFadType modelPar_LLN=mod.LLN;
  bool modelPar_given_LLN=mod.given("LLN");
  AdmsSensFadType modelPar_DLC=mod.DLC;
  bool modelPar_given_DLC=mod.given("DLC");
  AdmsSensFadType modelPar_DLCACC=mod.DLCACC;
  bool modelPar_given_DLCACC=mod.given("DLCACC");
  AdmsSensFadType modelPar_DLBIN=mod.DLBIN;
  bool modelPar_given_DLBIN=mod.given("DLBIN");
  AdmsSensFadType modelPar_LLC=mod.LLC;
  bool modelPar_given_LLC=mod.given("LLC");
  AdmsSensFadType modelPar_EOT=mod.EOT;
  bool modelPar_given_EOT=mod.given("EOT");
  AdmsSensFadType modelPar_TOXP=mod.TOXP;
  bool modelPar_given_TOXP=mod.given("TOXP");
  AdmsSensFadType modelPar_EOTBOX=mod.EOTBOX;
  bool modelPar_given_EOTBOX=mod.given("EOTBOX");
  AdmsSensFadType modelPar_HFIN=mod.HFIN;
  bool modelPar_given_HFIN=mod.given("HFIN");
  AdmsSensFadType modelPar_FECH=mod.FECH;
  bool modelPar_given_FECH=mod.given("FECH");
  AdmsSensFadType modelPar_DELTAW=mod.DELTAW;
  bool modelPar_given_DELTAW=mod.given("DELTAW");
  AdmsSensFadType modelPar_FECHCV=mod.FECHCV;
  bool modelPar_given_FECHCV=mod.given("FECHCV");
  AdmsSensFadType modelPar_DELTAWCV=mod.DELTAWCV;
  bool modelPar_given_DELTAWCV=mod.given("DELTAWCV");
  AdmsSensFadType modelPar_NBODY=mod.NBODY;
  bool modelPar_given_NBODY=mod.given("NBODY");
  AdmsSensFadType modelPar_NBODYN1=mod.NBODYN1;
  bool modelPar_given_NBODYN1=mod.given("NBODYN1");
  AdmsSensFadType modelPar_NBODYN2=mod.NBODYN2;
  bool modelPar_given_NBODYN2=mod.given("NBODYN2");
  AdmsSensFadType modelPar_NSD=mod.NSD;
  bool modelPar_given_NSD=mod.given("NSD");
  AdmsSensFadType modelPar_PHIG=mod.PHIG;
  bool modelPar_given_PHIG=mod.given("PHIG");
  AdmsSensFadType modelPar_PHIGL=mod.PHIGL;
  bool modelPar_given_PHIGL=mod.given("PHIGL");
  AdmsSensFadType modelPar_PHIGLT=mod.PHIGLT;
  bool modelPar_given_PHIGLT=mod.given("PHIGLT");
  AdmsSensFadType modelPar_PHIGN1=mod.PHIGN1;
  bool modelPar_given_PHIGN1=mod.given("PHIGN1");
  AdmsSensFadType modelPar_PHIGN2=mod.PHIGN2;
  bool modelPar_given_PHIGN2=mod.given("PHIGN2");
  AdmsSensFadType modelPar_EPSROX=mod.EPSROX;
  bool modelPar_given_EPSROX=mod.given("EPSROX");
  AdmsSensFadType modelPar_EPSRSUB=mod.EPSRSUB;
  bool modelPar_given_EPSRSUB=mod.given("EPSRSUB");
  AdmsSensFadType modelPar_EASUB=mod.EASUB;
  bool modelPar_given_EASUB=mod.given("EASUB");
  AdmsSensFadType modelPar_NI0SUB=mod.NI0SUB;
  bool modelPar_given_NI0SUB=mod.given("NI0SUB");
  AdmsSensFadType modelPar_BG0SUB=mod.BG0SUB;
  bool modelPar_given_BG0SUB=mod.given("BG0SUB");
  AdmsSensFadType modelPar_NC0SUB=mod.NC0SUB;
  bool modelPar_given_NC0SUB=mod.given("NC0SUB");
  AdmsSensFadType modelPar_NGATE=mod.NGATE;
  bool modelPar_given_NGATE=mod.given("NGATE");
  AdmsSensFadType modelPar_Imin=mod.Imin;
  bool modelPar_given_Imin=mod.given("Imin");
  AdmsSensFadType modelPar_CIT=mod.CIT;
  bool modelPar_given_CIT=mod.given("CIT");
  AdmsSensFadType modelPar_CITR=mod.CITR;
  bool modelPar_given_CITR=mod.given("CITR");
  AdmsSensFadType modelPar_CDSC=mod.CDSC;
  bool modelPar_given_CDSC=mod.given("CDSC");
  AdmsSensFadType modelPar_CDSCN1=mod.CDSCN1;
  bool modelPar_given_CDSCN1=mod.given("CDSCN1");
  AdmsSensFadType modelPar_CDSCN2=mod.CDSCN2;
  bool modelPar_given_CDSCN2=mod.given("CDSCN2");
  AdmsSensFadType modelPar_CDSCD=mod.CDSCD;
  bool modelPar_given_CDSCD=mod.given("CDSCD");
  AdmsSensFadType modelPar_CDSCDN1=mod.CDSCDN1;
  bool modelPar_given_CDSCDN1=mod.given("CDSCDN1");
  AdmsSensFadType modelPar_CDSCDN2=mod.CDSCDN2;
  bool modelPar_given_CDSCDN2=mod.given("CDSCDN2");
  AdmsSensFadType modelPar_CDSCDR=mod.CDSCDR;
  bool modelPar_given_CDSCDR=mod.given("CDSCDR");
  AdmsSensFadType modelPar_CDSCDRN1=mod.CDSCDRN1;
  bool modelPar_given_CDSCDRN1=mod.given("CDSCDRN1");
  AdmsSensFadType modelPar_CDSCDRN2=mod.CDSCDRN2;
  bool modelPar_given_CDSCDRN2=mod.given("CDSCDRN2");
  AdmsSensFadType modelPar_DVT0=mod.DVT0;
  bool modelPar_given_DVT0=mod.given("DVT0");
  AdmsSensFadType modelPar_DVT1=mod.DVT1;
  bool modelPar_given_DVT1=mod.given("DVT1");
  AdmsSensFadType modelPar_DVT1SS=mod.DVT1SS;
  bool modelPar_given_DVT1SS=mod.given("DVT1SS");
  AdmsSensFadType modelPar_PHIN=mod.PHIN;
  bool modelPar_given_PHIN=mod.given("PHIN");
  AdmsSensFadType modelPar_ETA0=mod.ETA0;
  bool modelPar_given_ETA0=mod.given("ETA0");
  AdmsSensFadType modelPar_ETA0N1=mod.ETA0N1;
  bool modelPar_given_ETA0N1=mod.given("ETA0N1");
  AdmsSensFadType modelPar_ETA0N2=mod.ETA0N2;
  bool modelPar_given_ETA0N2=mod.given("ETA0N2");
  AdmsSensFadType modelPar_ETA0LT=mod.ETA0LT;
  bool modelPar_given_ETA0LT=mod.given("ETA0LT");
  AdmsSensFadType modelPar_TETA0=mod.TETA0;
  bool modelPar_given_TETA0=mod.given("TETA0");
  AdmsSensFadType modelPar_ETA0R=mod.ETA0R;
  bool modelPar_given_ETA0R=mod.given("ETA0R");
  AdmsSensFadType modelPar_TETA0R=mod.TETA0R;
  bool modelPar_given_TETA0R=mod.given("TETA0R");
  AdmsSensFadType modelPar_DSUB=mod.DSUB;
  bool modelPar_given_DSUB=mod.given("DSUB");
  AdmsSensFadType modelPar_DVTP0=mod.DVTP0;
  bool modelPar_given_DVTP0=mod.given("DVTP0");
  AdmsSensFadType modelPar_DVTP1=mod.DVTP1;
  bool modelPar_given_DVTP1=mod.given("DVTP1");
  AdmsSensFadType modelPar_ADVTP0=mod.ADVTP0;
  bool modelPar_given_ADVTP0=mod.given("ADVTP0");
  AdmsSensFadType modelPar_BDVTP0=mod.BDVTP0;
  bool modelPar_given_BDVTP0=mod.given("BDVTP0");
  AdmsSensFadType modelPar_ADVTP1=mod.ADVTP1;
  bool modelPar_given_ADVTP1=mod.given("ADVTP1");
  AdmsSensFadType modelPar_BDVTP1=mod.BDVTP1;
  bool modelPar_given_BDVTP1=mod.given("BDVTP1");
  AdmsSensFadType modelPar_DVTP2=mod.DVTP2;
  bool modelPar_given_DVTP2=mod.given("DVTP2");
  AdmsSensFadType modelPar_K1RSCE=mod.K1RSCE;
  bool modelPar_given_K1RSCE=mod.given("K1RSCE");
  AdmsSensFadType modelPar_LPE0=mod.LPE0;
  bool modelPar_given_LPE0=mod.given("LPE0");
  AdmsSensFadType modelPar_DVTSHIFT=mod.DVTSHIFT;
  bool modelPar_given_DVTSHIFT=mod.given("DVTSHIFT");
  AdmsSensFadType modelPar_DVTSHIFTR=mod.DVTSHIFTR;
  bool modelPar_given_DVTSHIFTR=mod.given("DVTSHIFTR");
  AdmsSensFadType modelPar_THETASCE=mod.THETASCE;
  bool modelPar_given_THETASCE=mod.given("THETASCE");
  AdmsSensFadType modelPar_THETADIBL=mod.THETADIBL;
  bool modelPar_given_THETADIBL=mod.given("THETADIBL");
  AdmsSensFadType modelPar_THETASW=mod.THETASW;
  bool modelPar_given_THETASW=mod.given("THETASW");
  AdmsSensFadType modelPar_NVTM=mod.NVTM;
  bool modelPar_given_NVTM=mod.given("NVTM");
  AdmsSensFadType modelPar_K0=mod.K0;
  bool modelPar_given_K0=mod.given("K0");
  AdmsSensFadType modelPar_K01=mod.K01;
  bool modelPar_given_K01=mod.given("K01");
  AdmsSensFadType modelPar_K0SI=mod.K0SI;
  bool modelPar_given_K0SI=mod.given("K0SI");
  AdmsSensFadType modelPar_K0SI1=mod.K0SI1;
  bool modelPar_given_K0SI1=mod.given("K0SI1");
  AdmsSensFadType modelPar_K2SI=mod.K2SI;
  bool modelPar_given_K2SI=mod.given("K2SI");
  AdmsSensFadType modelPar_K2SI1=mod.K2SI1;
  bool modelPar_given_K2SI1=mod.given("K2SI1");
  AdmsSensFadType modelPar_K0SISAT=mod.K0SISAT;
  bool modelPar_given_K0SISAT=mod.given("K0SISAT");
  AdmsSensFadType modelPar_K0SISAT1=mod.K0SISAT1;
  bool modelPar_given_K0SISAT1=mod.given("K0SISAT1");
  AdmsSensFadType modelPar_K2SISAT=mod.K2SISAT;
  bool modelPar_given_K2SISAT=mod.given("K2SISAT");
  AdmsSensFadType modelPar_K2SISAT1=mod.K2SISAT1;
  bool modelPar_given_K2SISAT1=mod.given("K2SISAT1");
  AdmsSensFadType modelPar_PHIBE=mod.PHIBE;
  bool modelPar_given_PHIBE=mod.given("PHIBE");
  AdmsSensFadType modelPar_K1=mod.K1;
  bool modelPar_given_K1=mod.given("K1");
  AdmsSensFadType modelPar_K11=mod.K11;
  bool modelPar_given_K11=mod.given("K11");
  AdmsSensFadType modelPar_K2SAT=mod.K2SAT;
  bool modelPar_given_K2SAT=mod.given("K2SAT");
  AdmsSensFadType modelPar_K2SAT1=mod.K2SAT1;
  bool modelPar_given_K2SAT1=mod.given("K2SAT1");
  AdmsSensFadType modelPar_K2=mod.K2;
  bool modelPar_given_K2=mod.given("K2");
  AdmsSensFadType modelPar_K21=mod.K21;
  bool modelPar_given_K21=mod.given("K21");
  AdmsSensFadType modelPar_QMFACTOR=mod.QMFACTOR;
  bool modelPar_given_QMFACTOR=mod.given("QMFACTOR");
  AdmsSensFadType modelPar_QMTCENCV=mod.QMTCENCV;
  bool modelPar_given_QMTCENCV=mod.given("QMTCENCV");
  AdmsSensFadType modelPar_QMTCENCVA=mod.QMTCENCVA;
  bool modelPar_given_QMTCENCVA=mod.given("QMTCENCVA");
  AdmsSensFadType modelPar_AQMTCEN=mod.AQMTCEN;
  bool modelPar_given_AQMTCEN=mod.given("AQMTCEN");
  AdmsSensFadType modelPar_BQMTCEN=mod.BQMTCEN;
  bool modelPar_given_BQMTCEN=mod.given("BQMTCEN");
  AdmsSensFadType modelPar_ETAQM=mod.ETAQM;
  bool modelPar_given_ETAQM=mod.given("ETAQM");
  AdmsSensFadType modelPar_QM0=mod.QM0;
  bool modelPar_given_QM0=mod.given("QM0");
  AdmsSensFadType modelPar_PQM=mod.PQM;
  bool modelPar_given_PQM=mod.given("PQM");
  AdmsSensFadType modelPar_QM0ACC=mod.QM0ACC;
  bool modelPar_given_QM0ACC=mod.given("QM0ACC");
  AdmsSensFadType modelPar_PQMACC=mod.PQMACC;
  bool modelPar_given_PQMACC=mod.given("PQMACC");
  AdmsSensFadType modelPar_VSAT=mod.VSAT;
  bool modelPar_given_VSAT=mod.given("VSAT");
  AdmsSensFadType modelPar_VSATR=mod.VSATR;
  bool modelPar_given_VSATR=mod.given("VSATR");
  AdmsSensFadType modelPar_VSATN1=mod.VSATN1;
  bool modelPar_given_VSATN1=mod.given("VSATN1");
  AdmsSensFadType modelPar_VSATN2=mod.VSATN2;
  bool modelPar_given_VSATN2=mod.given("VSATN2");
  AdmsSensFadType modelPar_VSATRN1=mod.VSATRN1;
  bool modelPar_given_VSATRN1=mod.given("VSATRN1");
  AdmsSensFadType modelPar_VSATRN2=mod.VSATRN2;
  bool modelPar_given_VSATRN2=mod.given("VSATRN2");
  AdmsSensFadType modelPar_AVSAT=mod.AVSAT;
  bool modelPar_given_AVSAT=mod.given("AVSAT");
  AdmsSensFadType modelPar_BVSAT=mod.BVSAT;
  bool modelPar_given_BVSAT=mod.given("BVSAT");
  AdmsSensFadType modelPar_VSAT1=mod.VSAT1;
  bool modelPar_given_VSAT1=mod.given("VSAT1");
  AdmsSensFadType modelPar_VSAT1N1=mod.VSAT1N1;
  bool modelPar_given_VSAT1N1=mod.given("VSAT1N1");
  AdmsSensFadType modelPar_VSAT1N2=mod.VSAT1N2;
  bool modelPar_given_VSAT1N2=mod.given("VSAT1N2");
  AdmsSensFadType modelPar_VSAT1R=mod.VSAT1R;
  bool modelPar_given_VSAT1R=mod.given("VSAT1R");
  AdmsSensFadType modelPar_VSAT1RN1=mod.VSAT1RN1;
  bool modelPar_given_VSAT1RN1=mod.given("VSAT1RN1");
  AdmsSensFadType modelPar_VSAT1RN2=mod.VSAT1RN2;
  bool modelPar_given_VSAT1RN2=mod.given("VSAT1RN2");
  AdmsSensFadType modelPar_AVSAT1=mod.AVSAT1;
  bool modelPar_given_AVSAT1=mod.given("AVSAT1");
  AdmsSensFadType modelPar_BVSAT1=mod.BVSAT1;
  bool modelPar_given_BVSAT1=mod.given("BVSAT1");
  AdmsSensFadType modelPar_DELTAVSAT=mod.DELTAVSAT;
  bool modelPar_given_DELTAVSAT=mod.given("DELTAVSAT");
  AdmsSensFadType modelPar_PSAT=mod.PSAT;
  bool modelPar_given_PSAT=mod.given("PSAT");
  AdmsSensFadType modelPar_APSAT=mod.APSAT;
  bool modelPar_given_APSAT=mod.given("APSAT");
  AdmsSensFadType modelPar_BPSAT=mod.BPSAT;
  bool modelPar_given_BPSAT=mod.given("BPSAT");
  AdmsSensFadType modelPar_KSATIV=mod.KSATIV;
  bool modelPar_given_KSATIV=mod.given("KSATIV");
  AdmsSensFadType modelPar_KSATIVR=mod.KSATIVR;
  bool modelPar_given_KSATIVR=mod.given("KSATIVR");
  AdmsSensFadType modelPar_VSATCV=mod.VSATCV;
  bool modelPar_given_VSATCV=mod.given("VSATCV");
  AdmsSensFadType modelPar_AVSATCV=mod.AVSATCV;
  bool modelPar_given_AVSATCV=mod.given("AVSATCV");
  AdmsSensFadType modelPar_BVSATCV=mod.BVSATCV;
  bool modelPar_given_BVSATCV=mod.given("BVSATCV");
  AdmsSensFadType modelPar_DELTAVSATCV=mod.DELTAVSATCV;
  bool modelPar_given_DELTAVSATCV=mod.given("DELTAVSATCV");
  AdmsSensFadType modelPar_PSATCV=mod.PSATCV;
  bool modelPar_given_PSATCV=mod.given("PSATCV");
  AdmsSensFadType modelPar_APSATCV=mod.APSATCV;
  bool modelPar_given_APSATCV=mod.given("APSATCV");
  AdmsSensFadType modelPar_BPSATCV=mod.BPSATCV;
  bool modelPar_given_BPSATCV=mod.given("BPSATCV");
  AdmsSensFadType modelPar_MEXP=mod.MEXP;
  bool modelPar_given_MEXP=mod.given("MEXP");
  AdmsSensFadType modelPar_AMEXP=mod.AMEXP;
  bool modelPar_given_AMEXP=mod.given("AMEXP");
  AdmsSensFadType modelPar_BMEXP=mod.BMEXP;
  bool modelPar_given_BMEXP=mod.given("BMEXP");
  AdmsSensFadType modelPar_MEXPR=mod.MEXPR;
  bool modelPar_given_MEXPR=mod.given("MEXPR");
  AdmsSensFadType modelPar_AMEXPR=mod.AMEXPR;
  bool modelPar_given_AMEXPR=mod.given("AMEXPR");
  AdmsSensFadType modelPar_BMEXPR=mod.BMEXPR;
  bool modelPar_given_BMEXPR=mod.given("BMEXPR");
  AdmsSensFadType modelPar_PTWG=mod.PTWG;
  bool modelPar_given_PTWG=mod.given("PTWG");
  AdmsSensFadType modelPar_PTWGR=mod.PTWGR;
  bool modelPar_given_PTWGR=mod.given("PTWGR");
  AdmsSensFadType modelPar_APTWG=mod.APTWG;
  bool modelPar_given_APTWG=mod.given("APTWG");
  AdmsSensFadType modelPar_BPTWG=mod.BPTWG;
  bool modelPar_given_BPTWG=mod.given("BPTWG");
  AdmsSensFadType modelPar_AT=mod.AT;
  bool modelPar_given_AT=mod.given("AT");
  AdmsSensFadType modelPar_ATR=mod.ATR;
  bool modelPar_given_ATR=mod.given("ATR");
  AdmsSensFadType modelPar_ATCV=mod.ATCV;
  bool modelPar_given_ATCV=mod.given("ATCV");
  AdmsSensFadType modelPar_TMEXP=mod.TMEXP;
  bool modelPar_given_TMEXP=mod.given("TMEXP");
  AdmsSensFadType modelPar_TMEXPR=mod.TMEXPR;
  bool modelPar_given_TMEXPR=mod.given("TMEXPR");
  AdmsSensFadType modelPar_PTWGT=mod.PTWGT;
  bool modelPar_given_PTWGT=mod.given("PTWGT");
  AdmsSensFadType modelPar_U0=mod.U0;
  bool modelPar_given_U0=mod.given("U0");
  AdmsSensFadType modelPar_U0R=mod.U0R;
  bool modelPar_given_U0R=mod.given("U0R");
  AdmsSensFadType modelPar_U0N1=mod.U0N1;
  bool modelPar_given_U0N1=mod.given("U0N1");
  AdmsSensFadType modelPar_U0N1R=mod.U0N1R;
  bool modelPar_given_U0N1R=mod.given("U0N1R");
  AdmsSensFadType modelPar_U0N2=mod.U0N2;
  bool modelPar_given_U0N2=mod.given("U0N2");
  AdmsSensFadType modelPar_U0N2R=mod.U0N2R;
  bool modelPar_given_U0N2R=mod.given("U0N2R");
  AdmsSensFadType modelPar_U0LT=mod.U0LT;
  bool modelPar_given_U0LT=mod.given("U0LT");
  AdmsSensFadType modelPar_ETAMOB=mod.ETAMOB;
  bool modelPar_given_ETAMOB=mod.given("ETAMOB");
  AdmsSensFadType modelPar_UP=mod.UP;
  bool modelPar_given_UP=mod.given("UP");
  AdmsSensFadType modelPar_LPA=mod.LPA;
  bool modelPar_given_LPA=mod.given("LPA");
  AdmsSensFadType modelPar_UPR=mod.UPR;
  bool modelPar_given_UPR=mod.given("UPR");
  AdmsSensFadType modelPar_LPAR=mod.LPAR;
  bool modelPar_given_LPAR=mod.given("LPAR");
  AdmsSensFadType modelPar_UA=mod.UA;
  bool modelPar_given_UA=mod.given("UA");
  AdmsSensFadType modelPar_UAR=mod.UAR;
  bool modelPar_given_UAR=mod.given("UAR");
  AdmsSensFadType modelPar_AUA=mod.AUA;
  bool modelPar_given_AUA=mod.given("AUA");
  AdmsSensFadType modelPar_AUAR=mod.AUAR;
  bool modelPar_given_AUAR=mod.given("AUAR");
  AdmsSensFadType modelPar_BUA=mod.BUA;
  bool modelPar_given_BUA=mod.given("BUA");
  AdmsSensFadType modelPar_BUAR=mod.BUAR;
  bool modelPar_given_BUAR=mod.given("BUAR");
  AdmsSensFadType modelPar_UC=mod.UC;
  bool modelPar_given_UC=mod.given("UC");
  AdmsSensFadType modelPar_UCR=mod.UCR;
  bool modelPar_given_UCR=mod.given("UCR");
  AdmsSensFadType modelPar_EU=mod.EU;
  bool modelPar_given_EU=mod.given("EU");
  AdmsSensFadType modelPar_EUR=mod.EUR;
  bool modelPar_given_EUR=mod.given("EUR");
  AdmsSensFadType modelPar_AEU=mod.AEU;
  bool modelPar_given_AEU=mod.given("AEU");
  AdmsSensFadType modelPar_AEUR=mod.AEUR;
  bool modelPar_given_AEUR=mod.given("AEUR");
  AdmsSensFadType modelPar_BEU=mod.BEU;
  bool modelPar_given_BEU=mod.given("BEU");
  AdmsSensFadType modelPar_BEUR=mod.BEUR;
  bool modelPar_given_BEUR=mod.given("BEUR");
  AdmsSensFadType modelPar_UD=mod.UD;
  bool modelPar_given_UD=mod.given("UD");
  AdmsSensFadType modelPar_UDR=mod.UDR;
  bool modelPar_given_UDR=mod.given("UDR");
  AdmsSensFadType modelPar_AUD=mod.AUD;
  bool modelPar_given_AUD=mod.given("AUD");
  AdmsSensFadType modelPar_AUDR=mod.AUDR;
  bool modelPar_given_AUDR=mod.given("AUDR");
  AdmsSensFadType modelPar_BUD=mod.BUD;
  bool modelPar_given_BUD=mod.given("BUD");
  AdmsSensFadType modelPar_BUDR=mod.BUDR;
  bool modelPar_given_BUDR=mod.given("BUDR");
  AdmsSensFadType modelPar_UCS=mod.UCS;
  bool modelPar_given_UCS=mod.given("UCS");
  AdmsSensFadType modelPar_UTE=mod.UTE;
  bool modelPar_given_UTE=mod.given("UTE");
  AdmsSensFadType modelPar_UTER=mod.UTER;
  bool modelPar_given_UTER=mod.given("UTER");
  AdmsSensFadType modelPar_UTL=mod.UTL;
  bool modelPar_given_UTL=mod.given("UTL");
  AdmsSensFadType modelPar_UTLR=mod.UTLR;
  bool modelPar_given_UTLR=mod.given("UTLR");
  AdmsSensFadType modelPar_EMOBT=mod.EMOBT;
  bool modelPar_given_EMOBT=mod.given("EMOBT");
  AdmsSensFadType modelPar_UA1=mod.UA1;
  bool modelPar_given_UA1=mod.given("UA1");
  AdmsSensFadType modelPar_UA1R=mod.UA1R;
  bool modelPar_given_UA1R=mod.given("UA1R");
  AdmsSensFadType modelPar_UC1=mod.UC1;
  bool modelPar_given_UC1=mod.given("UC1");
  AdmsSensFadType modelPar_UC1R=mod.UC1R;
  bool modelPar_given_UC1R=mod.given("UC1R");
  AdmsSensFadType modelPar_UD1=mod.UD1;
  bool modelPar_given_UD1=mod.given("UD1");
  AdmsSensFadType modelPar_UD1R=mod.UD1R;
  bool modelPar_given_UD1R=mod.given("UD1R");
  AdmsSensFadType modelPar_UCSTE=mod.UCSTE;
  bool modelPar_given_UCSTE=mod.given("UCSTE");
  AdmsSensFadType modelPar_CHARGEWF=mod.CHARGEWF;
  bool modelPar_given_CHARGEWF=mod.given("CHARGEWF");
  AdmsSensFadType modelPar_RDSWMIN=mod.RDSWMIN;
  bool modelPar_given_RDSWMIN=mod.given("RDSWMIN");
  AdmsSensFadType modelPar_RDSW=mod.RDSW;
  bool modelPar_given_RDSW=mod.given("RDSW");
  AdmsSensFadType modelPar_ARDSW=mod.ARDSW;
  bool modelPar_given_ARDSW=mod.given("ARDSW");
  AdmsSensFadType modelPar_BRDSW=mod.BRDSW;
  bool modelPar_given_BRDSW=mod.given("BRDSW");
  AdmsSensFadType modelPar_RSWMIN=mod.RSWMIN;
  bool modelPar_given_RSWMIN=mod.given("RSWMIN");
  AdmsSensFadType modelPar_RSW=mod.RSW;
  bool modelPar_given_RSW=mod.given("RSW");
  AdmsSensFadType modelPar_ARSW=mod.ARSW;
  bool modelPar_given_ARSW=mod.given("ARSW");
  AdmsSensFadType modelPar_BRSW=mod.BRSW;
  bool modelPar_given_BRSW=mod.given("BRSW");
  AdmsSensFadType modelPar_RDWMIN=mod.RDWMIN;
  bool modelPar_given_RDWMIN=mod.given("RDWMIN");
  AdmsSensFadType modelPar_RDW=mod.RDW;
  bool modelPar_given_RDW=mod.given("RDW");
  AdmsSensFadType modelPar_ARDW=mod.ARDW;
  bool modelPar_given_ARDW=mod.given("ARDW");
  AdmsSensFadType modelPar_BRDW=mod.BRDW;
  bool modelPar_given_BRDW=mod.given("BRDW");
  AdmsSensFadType modelPar_RSDR=mod.RSDR;
  bool modelPar_given_RSDR=mod.given("RSDR");
  AdmsSensFadType modelPar_RSDRR=mod.RSDRR;
  bool modelPar_given_RSDRR=mod.given("RSDRR");
  AdmsSensFadType modelPar_RDDR=mod.RDDR;
  bool modelPar_given_RDDR=mod.given("RDDR");
  AdmsSensFadType modelPar_RDDRR=mod.RDDRR;
  bool modelPar_given_RDDRR=mod.given("RDDRR");
  AdmsSensFadType modelPar_PRSDR=mod.PRSDR;
  bool modelPar_given_PRSDR=mod.given("PRSDR");
  AdmsSensFadType modelPar_PRDDR=mod.PRDDR;
  bool modelPar_given_PRDDR=mod.given("PRDDR");
  AdmsSensFadType modelPar_PRWGS=mod.PRWGS;
  bool modelPar_given_PRWGS=mod.given("PRWGS");
  AdmsSensFadType modelPar_PRWGD=mod.PRWGD;
  bool modelPar_given_PRWGD=mod.given("PRWGD");
  AdmsSensFadType modelPar_WR=mod.WR;
  bool modelPar_given_WR=mod.given("WR");
  AdmsSensFadType modelPar_PRT=mod.PRT;
  bool modelPar_given_PRT=mod.given("PRT");
  AdmsSensFadType modelPar_TRSDR=mod.TRSDR;
  bool modelPar_given_TRSDR=mod.given("TRSDR");
  AdmsSensFadType modelPar_TRDDR=mod.TRDDR;
  bool modelPar_given_TRDDR=mod.given("TRDDR");
  AdmsSensFadType modelPar_PDIBL1=mod.PDIBL1;
  bool modelPar_given_PDIBL1=mod.given("PDIBL1");
  AdmsSensFadType modelPar_PDIBL1R=mod.PDIBL1R;
  bool modelPar_given_PDIBL1R=mod.given("PDIBL1R");
  AdmsSensFadType modelPar_PDIBL2=mod.PDIBL2;
  bool modelPar_given_PDIBL2=mod.given("PDIBL2");
  AdmsSensFadType modelPar_PDIBL2R=mod.PDIBL2R;
  bool modelPar_given_PDIBL2R=mod.given("PDIBL2R");
  AdmsSensFadType modelPar_DROUT=mod.DROUT;
  bool modelPar_given_DROUT=mod.given("DROUT");
  AdmsSensFadType modelPar_PVAG=mod.PVAG;
  bool modelPar_given_PVAG=mod.given("PVAG");
  AdmsSensFadType modelPar_PCLM=mod.PCLM;
  bool modelPar_given_PCLM=mod.given("PCLM");
  AdmsSensFadType modelPar_PCLMR=mod.PCLMR;
  bool modelPar_given_PCLMR=mod.given("PCLMR");
  AdmsSensFadType modelPar_APCLM=mod.APCLM;
  bool modelPar_given_APCLM=mod.given("APCLM");
  AdmsSensFadType modelPar_APCLMR=mod.APCLMR;
  bool modelPar_given_APCLMR=mod.given("APCLMR");
  AdmsSensFadType modelPar_BPCLM=mod.BPCLM;
  bool modelPar_given_BPCLM=mod.given("BPCLM");
  AdmsSensFadType modelPar_BPCLMR=mod.BPCLMR;
  bool modelPar_given_BPCLMR=mod.given("BPCLMR");
  AdmsSensFadType modelPar_PCLMG=mod.PCLMG;
  bool modelPar_given_PCLMG=mod.given("PCLMG");
  AdmsSensFadType modelPar_PCLMCV=mod.PCLMCV;
  bool modelPar_given_PCLMCV=mod.given("PCLMCV");
  AdmsSensFadType modelPar_A1=mod.A1;
  bool modelPar_given_A1=mod.given("A1");
  AdmsSensFadType modelPar_A11=mod.A11;
  bool modelPar_given_A11=mod.given("A11");
  AdmsSensFadType modelPar_A2=mod.A2;
  bool modelPar_given_A2=mod.given("A2");
  AdmsSensFadType modelPar_A21=mod.A21;
  bool modelPar_given_A21=mod.given("A21");
  AdmsSensFadType modelPar_RGEXT=mod.RGEXT;
  bool modelPar_given_RGEXT=mod.given("RGEXT");
  AdmsSensFadType modelPar_RGFIN=mod.RGFIN;
  bool modelPar_given_RGFIN=mod.given("RGFIN");
  AdmsSensFadType modelPar_RSHS=mod.RSHS;
  bool modelPar_given_RSHS=mod.given("RSHS");
  AdmsSensFadType modelPar_RSHD=mod.RSHD;
  bool modelPar_given_RSHD=mod.given("RSHD");
  AdmsSensFadType modelPar_HEPI=mod.HEPI;
  bool modelPar_given_HEPI=mod.given("HEPI");
  AdmsSensFadType modelPar_TSILI=mod.TSILI;
  bool modelPar_given_TSILI=mod.given("TSILI");
  AdmsSensFadType modelPar_RHOC=mod.RHOC;
  bool modelPar_given_RHOC=mod.given("RHOC");
  AdmsSensFadType modelPar_RHORSD=mod.RHORSD;
  bool modelPar_given_RHORSD=mod.given("RHORSD");
  AdmsSensFadType modelPar_CRATIO=mod.CRATIO;
  bool modelPar_given_CRATIO=mod.given("CRATIO");
  AdmsSensFadType modelPar_DELTAPRSD=mod.DELTAPRSD;
  bool modelPar_given_DELTAPRSD=mod.given("DELTAPRSD");
  AdmsSensFadType modelPar_LSP=mod.LSP;
  bool modelPar_given_LSP=mod.given("LSP");
  AdmsSensFadType modelPar_EPSRSP=mod.EPSRSP;
  bool modelPar_given_EPSRSP=mod.given("EPSRSP");
  AdmsSensFadType modelPar_TGATE=mod.TGATE;
  bool modelPar_given_TGATE=mod.given("TGATE");
  AdmsSensFadType modelPar_TMASK=mod.TMASK;
  bool modelPar_given_TMASK=mod.given("TMASK");
  AdmsSensFadType modelPar_ASILIEND=mod.ASILIEND;
  bool modelPar_given_ASILIEND=mod.given("ASILIEND");
  AdmsSensFadType modelPar_ARSDEND=mod.ARSDEND;
  bool modelPar_given_ARSDEND=mod.given("ARSDEND");
  AdmsSensFadType modelPar_PRSDEND=mod.PRSDEND;
  bool modelPar_given_PRSDEND=mod.given("PRSDEND");
  AdmsSensFadType modelPar_NSDE=mod.NSDE;
  bool modelPar_given_NSDE=mod.given("NSDE");
  AdmsSensFadType modelPar_RGEOA=mod.RGEOA;
  bool modelPar_given_RGEOA=mod.given("RGEOA");
  AdmsSensFadType modelPar_RGEOB=mod.RGEOB;
  bool modelPar_given_RGEOB=mod.given("RGEOB");
  AdmsSensFadType modelPar_RGEOC=mod.RGEOC;
  bool modelPar_given_RGEOC=mod.given("RGEOC");
  AdmsSensFadType modelPar_RGEOD=mod.RGEOD;
  bool modelPar_given_RGEOD=mod.given("RGEOD");
  AdmsSensFadType modelPar_RGEOE=mod.RGEOE;
  bool modelPar_given_RGEOE=mod.given("RGEOE");
  AdmsSensFadType modelPar_CGEOA=mod.CGEOA;
  bool modelPar_given_CGEOA=mod.given("CGEOA");
  AdmsSensFadType modelPar_CGEOB=mod.CGEOB;
  bool modelPar_given_CGEOB=mod.given("CGEOB");
  AdmsSensFadType modelPar_CGEOC=mod.CGEOC;
  bool modelPar_given_CGEOC=mod.given("CGEOC");
  AdmsSensFadType modelPar_CGEOD=mod.CGEOD;
  bool modelPar_given_CGEOD=mod.given("CGEOD");
  AdmsSensFadType modelPar_CGEOE=mod.CGEOE;
  bool modelPar_given_CGEOE=mod.given("CGEOE");
  AdmsSensFadType modelPar_AIGBINV=mod.AIGBINV;
  bool modelPar_given_AIGBINV=mod.given("AIGBINV");
  AdmsSensFadType modelPar_AIGBINV1=mod.AIGBINV1;
  bool modelPar_given_AIGBINV1=mod.given("AIGBINV1");
  AdmsSensFadType modelPar_BIGBINV=mod.BIGBINV;
  bool modelPar_given_BIGBINV=mod.given("BIGBINV");
  AdmsSensFadType modelPar_CIGBINV=mod.CIGBINV;
  bool modelPar_given_CIGBINV=mod.given("CIGBINV");
  AdmsSensFadType modelPar_EIGBINV=mod.EIGBINV;
  bool modelPar_given_EIGBINV=mod.given("EIGBINV");
  AdmsSensFadType modelPar_NIGBINV=mod.NIGBINV;
  bool modelPar_given_NIGBINV=mod.given("NIGBINV");
  AdmsSensFadType modelPar_AIGBACC=mod.AIGBACC;
  bool modelPar_given_AIGBACC=mod.given("AIGBACC");
  AdmsSensFadType modelPar_AIGBACC1=mod.AIGBACC1;
  bool modelPar_given_AIGBACC1=mod.given("AIGBACC1");
  AdmsSensFadType modelPar_BIGBACC=mod.BIGBACC;
  bool modelPar_given_BIGBACC=mod.given("BIGBACC");
  AdmsSensFadType modelPar_CIGBACC=mod.CIGBACC;
  bool modelPar_given_CIGBACC=mod.given("CIGBACC");
  AdmsSensFadType modelPar_NIGBACC=mod.NIGBACC;
  bool modelPar_given_NIGBACC=mod.given("NIGBACC");
  AdmsSensFadType modelPar_AIGC=mod.AIGC;
  bool modelPar_given_AIGC=mod.given("AIGC");
  AdmsSensFadType modelPar_AIGC1=mod.AIGC1;
  bool modelPar_given_AIGC1=mod.given("AIGC1");
  AdmsSensFadType modelPar_BIGC=mod.BIGC;
  bool modelPar_given_BIGC=mod.given("BIGC");
  AdmsSensFadType modelPar_CIGC=mod.CIGC;
  bool modelPar_given_CIGC=mod.given("CIGC");
  AdmsSensFadType modelPar_PIGCD=mod.PIGCD;
  bool modelPar_given_PIGCD=mod.given("PIGCD");
  AdmsSensFadType modelPar_DLCIGS=mod.DLCIGS;
  bool modelPar_given_DLCIGS=mod.given("DLCIGS");
  AdmsSensFadType modelPar_AIGS=mod.AIGS;
  bool modelPar_given_AIGS=mod.given("AIGS");
  AdmsSensFadType modelPar_AIGS1=mod.AIGS1;
  bool modelPar_given_AIGS1=mod.given("AIGS1");
  AdmsSensFadType modelPar_BIGS=mod.BIGS;
  bool modelPar_given_BIGS=mod.given("BIGS");
  AdmsSensFadType modelPar_CIGS=mod.CIGS;
  bool modelPar_given_CIGS=mod.given("CIGS");
  AdmsSensFadType modelPar_DLCIGD=mod.DLCIGD;
  bool modelPar_given_DLCIGD=mod.given("DLCIGD");
  AdmsSensFadType modelPar_AIGD=mod.AIGD;
  bool modelPar_given_AIGD=mod.given("AIGD");
  AdmsSensFadType modelPar_AIGD1=mod.AIGD1;
  bool modelPar_given_AIGD1=mod.given("AIGD1");
  AdmsSensFadType modelPar_BIGD=mod.BIGD;
  bool modelPar_given_BIGD=mod.given("BIGD");
  AdmsSensFadType modelPar_CIGD=mod.CIGD;
  bool modelPar_given_CIGD=mod.given("CIGD");
  AdmsSensFadType modelPar_VFBSD=mod.VFBSD;
  bool modelPar_given_VFBSD=mod.given("VFBSD");
  AdmsSensFadType modelPar_VFBSDCV=mod.VFBSDCV;
  bool modelPar_given_VFBSDCV=mod.given("VFBSDCV");
  AdmsSensFadType modelPar_TOXREF=mod.TOXREF;
  bool modelPar_given_TOXREF=mod.given("TOXREF");
  AdmsSensFadType modelPar_TOXG=mod.TOXG;
  bool modelPar_given_TOXG=mod.given("TOXG");
  AdmsSensFadType modelPar_NTOX=mod.NTOX;
  bool modelPar_given_NTOX=mod.given("NTOX");
  AdmsSensFadType modelPar_POXEDGE=mod.POXEDGE;
  bool modelPar_given_POXEDGE=mod.given("POXEDGE");
  AdmsSensFadType modelPar_AGISL=mod.AGISL;
  bool modelPar_given_AGISL=mod.given("AGISL");
  AdmsSensFadType modelPar_BGISL=mod.BGISL;
  bool modelPar_given_BGISL=mod.given("BGISL");
  AdmsSensFadType modelPar_CGISL=mod.CGISL;
  bool modelPar_given_CGISL=mod.given("CGISL");
  AdmsSensFadType modelPar_EGISL=mod.EGISL;
  bool modelPar_given_EGISL=mod.given("EGISL");
  AdmsSensFadType modelPar_PGISL=mod.PGISL;
  bool modelPar_given_PGISL=mod.given("PGISL");
  AdmsSensFadType modelPar_AGIDL=mod.AGIDL;
  bool modelPar_given_AGIDL=mod.given("AGIDL");
  AdmsSensFadType modelPar_BGIDL=mod.BGIDL;
  bool modelPar_given_BGIDL=mod.given("BGIDL");
  AdmsSensFadType modelPar_CGIDL=mod.CGIDL;
  bool modelPar_given_CGIDL=mod.given("CGIDL");
  AdmsSensFadType modelPar_EGIDL=mod.EGIDL;
  bool modelPar_given_EGIDL=mod.given("EGIDL");
  AdmsSensFadType modelPar_PGIDL=mod.PGIDL;
  bool modelPar_given_PGIDL=mod.given("PGIDL");
  AdmsSensFadType modelPar_ALPHA0=mod.ALPHA0;
  bool modelPar_given_ALPHA0=mod.given("ALPHA0");
  AdmsSensFadType modelPar_ALPHA01=mod.ALPHA01;
  bool modelPar_given_ALPHA01=mod.given("ALPHA01");
  AdmsSensFadType modelPar_ALPHA1=mod.ALPHA1;
  bool modelPar_given_ALPHA1=mod.given("ALPHA1");
  AdmsSensFadType modelPar_ALPHA11=mod.ALPHA11;
  bool modelPar_given_ALPHA11=mod.given("ALPHA11");
  AdmsSensFadType modelPar_BETA0=mod.BETA0;
  bool modelPar_given_BETA0=mod.given("BETA0");
  AdmsSensFadType modelPar_ALPHAII0=mod.ALPHAII0;
  bool modelPar_given_ALPHAII0=mod.given("ALPHAII0");
  AdmsSensFadType modelPar_ALPHAII01=mod.ALPHAII01;
  bool modelPar_given_ALPHAII01=mod.given("ALPHAII01");
  AdmsSensFadType modelPar_ALPHAII1=mod.ALPHAII1;
  bool modelPar_given_ALPHAII1=mod.given("ALPHAII1");
  AdmsSensFadType modelPar_ALPHAII11=mod.ALPHAII11;
  bool modelPar_given_ALPHAII11=mod.given("ALPHAII11");
  AdmsSensFadType modelPar_BETAII0=mod.BETAII0;
  bool modelPar_given_BETAII0=mod.given("BETAII0");
  AdmsSensFadType modelPar_BETAII1=mod.BETAII1;
  bool modelPar_given_BETAII1=mod.given("BETAII1");
  AdmsSensFadType modelPar_BETAII2=mod.BETAII2;
  bool modelPar_given_BETAII2=mod.given("BETAII2");
  AdmsSensFadType modelPar_ESATII=mod.ESATII;
  bool modelPar_given_ESATII=mod.given("ESATII");
  AdmsSensFadType modelPar_LII=mod.LII;
  bool modelPar_given_LII=mod.given("LII");
  AdmsSensFadType modelPar_SII0=mod.SII0;
  bool modelPar_given_SII0=mod.given("SII0");
  AdmsSensFadType modelPar_SII1=mod.SII1;
  bool modelPar_given_SII1=mod.given("SII1");
  AdmsSensFadType modelPar_SII2=mod.SII2;
  bool modelPar_given_SII2=mod.given("SII2");
  AdmsSensFadType modelPar_SIID=mod.SIID;
  bool modelPar_given_SIID=mod.given("SIID");
  AdmsSensFadType modelPar_IIMOD2CLAMP1=mod.IIMOD2CLAMP1;
  bool modelPar_given_IIMOD2CLAMP1=mod.given("IIMOD2CLAMP1");
  AdmsSensFadType modelPar_IIMOD2CLAMP2=mod.IIMOD2CLAMP2;
  bool modelPar_given_IIMOD2CLAMP2=mod.given("IIMOD2CLAMP2");
  AdmsSensFadType modelPar_IIMOD2CLAMP3=mod.IIMOD2CLAMP3;
  bool modelPar_given_IIMOD2CLAMP3=mod.given("IIMOD2CLAMP3");
  AdmsSensFadType modelPar_EOTACC=mod.EOTACC;
  bool modelPar_given_EOTACC=mod.given("EOTACC");
  AdmsSensFadType modelPar_DELVFBACC=mod.DELVFBACC;
  bool modelPar_given_DELVFBACC=mod.given("DELVFBACC");
  AdmsSensFadType modelPar_CFS=mod.CFS;
  bool modelPar_given_CFS=mod.given("CFS");
  AdmsSensFadType modelPar_CFD=mod.CFD;
  bool modelPar_given_CFD=mod.given("CFD");
  AdmsSensFadType modelPar_CGSO=mod.CGSO;
  bool modelPar_given_CGSO=mod.given("CGSO");
  AdmsSensFadType modelPar_CGDO=mod.CGDO;
  bool modelPar_given_CGDO=mod.given("CGDO");
  AdmsSensFadType modelPar_CGSL=mod.CGSL;
  bool modelPar_given_CGSL=mod.given("CGSL");
  AdmsSensFadType modelPar_CGDL=mod.CGDL;
  bool modelPar_given_CGDL=mod.given("CGDL");
  AdmsSensFadType modelPar_CKAPPAS=mod.CKAPPAS;
  bool modelPar_given_CKAPPAS=mod.given("CKAPPAS");
  AdmsSensFadType modelPar_CKAPPAD=mod.CKAPPAD;
  bool modelPar_given_CKAPPAD=mod.given("CKAPPAD");
  AdmsSensFadType modelPar_CGBO=mod.CGBO;
  bool modelPar_given_CGBO=mod.given("CGBO");
  AdmsSensFadType modelPar_CGBN=mod.CGBN;
  bool modelPar_given_CGBN=mod.given("CGBN");
  AdmsSensFadType modelPar_CGBL=mod.CGBL;
  bool modelPar_given_CGBL=mod.given("CGBL");
  AdmsSensFadType modelPar_CKAPPAB=mod.CKAPPAB;
  bool modelPar_given_CKAPPAB=mod.given("CKAPPAB");
  AdmsSensFadType modelPar_CSDESW=mod.CSDESW;
  bool modelPar_given_CSDESW=mod.given("CSDESW");
  AdmsSensFadType modelPar_CJS=mod.CJS;
  bool modelPar_given_CJS=mod.given("CJS");
  AdmsSensFadType modelPar_CJD=mod.CJD;
  bool modelPar_given_CJD=mod.given("CJD");
  AdmsSensFadType modelPar_CJSWS=mod.CJSWS;
  bool modelPar_given_CJSWS=mod.given("CJSWS");
  AdmsSensFadType modelPar_CJSWD=mod.CJSWD;
  bool modelPar_given_CJSWD=mod.given("CJSWD");
  AdmsSensFadType modelPar_CJSWGS=mod.CJSWGS;
  bool modelPar_given_CJSWGS=mod.given("CJSWGS");
  AdmsSensFadType modelPar_CJSWGD=mod.CJSWGD;
  bool modelPar_given_CJSWGD=mod.given("CJSWGD");
  AdmsSensFadType modelPar_PBS=mod.PBS;
  bool modelPar_given_PBS=mod.given("PBS");
  AdmsSensFadType modelPar_PBD=mod.PBD;
  bool modelPar_given_PBD=mod.given("PBD");
  AdmsSensFadType modelPar_PBSWS=mod.PBSWS;
  bool modelPar_given_PBSWS=mod.given("PBSWS");
  AdmsSensFadType modelPar_PBSWD=mod.PBSWD;
  bool modelPar_given_PBSWD=mod.given("PBSWD");
  AdmsSensFadType modelPar_PBSWGS=mod.PBSWGS;
  bool modelPar_given_PBSWGS=mod.given("PBSWGS");
  AdmsSensFadType modelPar_PBSWGD=mod.PBSWGD;
  bool modelPar_given_PBSWGD=mod.given("PBSWGD");
  AdmsSensFadType modelPar_MJS=mod.MJS;
  bool modelPar_given_MJS=mod.given("MJS");
  AdmsSensFadType modelPar_MJD=mod.MJD;
  bool modelPar_given_MJD=mod.given("MJD");
  AdmsSensFadType modelPar_MJSWS=mod.MJSWS;
  bool modelPar_given_MJSWS=mod.given("MJSWS");
  AdmsSensFadType modelPar_MJSWD=mod.MJSWD;
  bool modelPar_given_MJSWD=mod.given("MJSWD");
  AdmsSensFadType modelPar_MJSWGS=mod.MJSWGS;
  bool modelPar_given_MJSWGS=mod.given("MJSWGS");
  AdmsSensFadType modelPar_MJSWGD=mod.MJSWGD;
  bool modelPar_given_MJSWGD=mod.given("MJSWGD");
  AdmsSensFadType modelPar_SJS=mod.SJS;
  bool modelPar_given_SJS=mod.given("SJS");
  AdmsSensFadType modelPar_SJD=mod.SJD;
  bool modelPar_given_SJD=mod.given("SJD");
  AdmsSensFadType modelPar_SJSWS=mod.SJSWS;
  bool modelPar_given_SJSWS=mod.given("SJSWS");
  AdmsSensFadType modelPar_SJSWD=mod.SJSWD;
  bool modelPar_given_SJSWD=mod.given("SJSWD");
  AdmsSensFadType modelPar_SJSWGS=mod.SJSWGS;
  bool modelPar_given_SJSWGS=mod.given("SJSWGS");
  AdmsSensFadType modelPar_SJSWGD=mod.SJSWGD;
  bool modelPar_given_SJSWGD=mod.given("SJSWGD");
  AdmsSensFadType modelPar_MJS2=mod.MJS2;
  bool modelPar_given_MJS2=mod.given("MJS2");
  AdmsSensFadType modelPar_MJD2=mod.MJD2;
  bool modelPar_given_MJD2=mod.given("MJD2");
  AdmsSensFadType modelPar_MJSWS2=mod.MJSWS2;
  bool modelPar_given_MJSWS2=mod.given("MJSWS2");
  AdmsSensFadType modelPar_MJSWD2=mod.MJSWD2;
  bool modelPar_given_MJSWD2=mod.given("MJSWD2");
  AdmsSensFadType modelPar_MJSWGS2=mod.MJSWGS2;
  bool modelPar_given_MJSWGS2=mod.given("MJSWGS2");
  AdmsSensFadType modelPar_MJSWGD2=mod.MJSWGD2;
  bool modelPar_given_MJSWGD2=mod.given("MJSWGD2");
  AdmsSensFadType modelPar_JSS=mod.JSS;
  bool modelPar_given_JSS=mod.given("JSS");
  AdmsSensFadType modelPar_JSD=mod.JSD;
  bool modelPar_given_JSD=mod.given("JSD");
  AdmsSensFadType modelPar_JSWS=mod.JSWS;
  bool modelPar_given_JSWS=mod.given("JSWS");
  AdmsSensFadType modelPar_JSWD=mod.JSWD;
  bool modelPar_given_JSWD=mod.given("JSWD");
  AdmsSensFadType modelPar_JSWGS=mod.JSWGS;
  bool modelPar_given_JSWGS=mod.given("JSWGS");
  AdmsSensFadType modelPar_JSWGD=mod.JSWGD;
  bool modelPar_given_JSWGD=mod.given("JSWGD");
  AdmsSensFadType modelPar_NJS=mod.NJS;
  bool modelPar_given_NJS=mod.given("NJS");
  AdmsSensFadType modelPar_NJD=mod.NJD;
  bool modelPar_given_NJD=mod.given("NJD");
  AdmsSensFadType modelPar_IJTHSFWD=mod.IJTHSFWD;
  bool modelPar_given_IJTHSFWD=mod.given("IJTHSFWD");
  AdmsSensFadType modelPar_IJTHDFWD=mod.IJTHDFWD;
  bool modelPar_given_IJTHDFWD=mod.given("IJTHDFWD");
  AdmsSensFadType modelPar_IJTHSREV=mod.IJTHSREV;
  bool modelPar_given_IJTHSREV=mod.given("IJTHSREV");
  AdmsSensFadType modelPar_IJTHDREV=mod.IJTHDREV;
  bool modelPar_given_IJTHDREV=mod.given("IJTHDREV");
  AdmsSensFadType modelPar_BVS=mod.BVS;
  bool modelPar_given_BVS=mod.given("BVS");
  AdmsSensFadType modelPar_BVD=mod.BVD;
  bool modelPar_given_BVD=mod.given("BVD");
  AdmsSensFadType modelPar_XJBVS=mod.XJBVS;
  bool modelPar_given_XJBVS=mod.given("XJBVS");
  AdmsSensFadType modelPar_XJBVD=mod.XJBVD;
  bool modelPar_given_XJBVD=mod.given("XJBVD");
  AdmsSensFadType modelPar_JTSS=mod.JTSS;
  bool modelPar_given_JTSS=mod.given("JTSS");
  AdmsSensFadType modelPar_JTSD=mod.JTSD;
  bool modelPar_given_JTSD=mod.given("JTSD");
  AdmsSensFadType modelPar_JTSSWS=mod.JTSSWS;
  bool modelPar_given_JTSSWS=mod.given("JTSSWS");
  AdmsSensFadType modelPar_JTSSWD=mod.JTSSWD;
  bool modelPar_given_JTSSWD=mod.given("JTSSWD");
  AdmsSensFadType modelPar_JTSSWGS=mod.JTSSWGS;
  bool modelPar_given_JTSSWGS=mod.given("JTSSWGS");
  AdmsSensFadType modelPar_JTSSWGD=mod.JTSSWGD;
  bool modelPar_given_JTSSWGD=mod.given("JTSSWGD");
  AdmsSensFadType modelPar_JTWEFF=mod.JTWEFF;
  bool modelPar_given_JTWEFF=mod.given("JTWEFF");
  AdmsSensFadType modelPar_NJTS=mod.NJTS;
  bool modelPar_given_NJTS=mod.given("NJTS");
  AdmsSensFadType modelPar_NJTSD=mod.NJTSD;
  bool modelPar_given_NJTSD=mod.given("NJTSD");
  AdmsSensFadType modelPar_NJTSSW=mod.NJTSSW;
  bool modelPar_given_NJTSSW=mod.given("NJTSSW");
  AdmsSensFadType modelPar_NJTSSWD=mod.NJTSSWD;
  bool modelPar_given_NJTSSWD=mod.given("NJTSSWD");
  AdmsSensFadType modelPar_NJTSSWG=mod.NJTSSWG;
  bool modelPar_given_NJTSSWG=mod.given("NJTSSWG");
  AdmsSensFadType modelPar_NJTSSWGD=mod.NJTSSWGD;
  bool modelPar_given_NJTSSWGD=mod.given("NJTSSWGD");
  AdmsSensFadType modelPar_VTSS=mod.VTSS;
  bool modelPar_given_VTSS=mod.given("VTSS");
  AdmsSensFadType modelPar_VTSD=mod.VTSD;
  bool modelPar_given_VTSD=mod.given("VTSD");
  AdmsSensFadType modelPar_VTSSWS=mod.VTSSWS;
  bool modelPar_given_VTSSWS=mod.given("VTSSWS");
  AdmsSensFadType modelPar_VTSSWD=mod.VTSSWD;
  bool modelPar_given_VTSSWD=mod.given("VTSSWD");
  AdmsSensFadType modelPar_VTSSWGS=mod.VTSSWGS;
  bool modelPar_given_VTSSWGS=mod.given("VTSSWGS");
  AdmsSensFadType modelPar_VTSSWGD=mod.VTSSWGD;
  bool modelPar_given_VTSSWGD=mod.given("VTSSWGD");
  AdmsSensFadType modelPar_LINTIGEN=mod.LINTIGEN;
  bool modelPar_given_LINTIGEN=mod.given("LINTIGEN");
  AdmsSensFadType modelPar_NTGEN=mod.NTGEN;
  bool modelPar_given_NTGEN=mod.given("NTGEN");
  AdmsSensFadType modelPar_AIGEN=mod.AIGEN;
  bool modelPar_given_AIGEN=mod.given("AIGEN");
  AdmsSensFadType modelPar_BIGEN=mod.BIGEN;
  bool modelPar_given_BIGEN=mod.given("BIGEN");
  AdmsSensFadType modelPar_XRCRG1=mod.XRCRG1;
  bool modelPar_given_XRCRG1=mod.given("XRCRG1");
  AdmsSensFadType modelPar_XRCRG2=mod.XRCRG2;
  bool modelPar_given_XRCRG2=mod.given("XRCRG2");
  AdmsSensFadType modelPar_EF=mod.EF;
  bool modelPar_given_EF=mod.given("EF");
  AdmsSensFadType modelPar_EM=mod.EM;
  bool modelPar_given_EM=mod.given("EM");
  AdmsSensFadType modelPar_NOIA=mod.NOIA;
  bool modelPar_given_NOIA=mod.given("NOIA");
  AdmsSensFadType modelPar_NOIB=mod.NOIB;
  bool modelPar_given_NOIB=mod.given("NOIB");
  AdmsSensFadType modelPar_NOIC=mod.NOIC;
  bool modelPar_given_NOIC=mod.given("NOIC");
  AdmsSensFadType modelPar_LINTNOI=mod.LINTNOI;
  bool modelPar_given_LINTNOI=mod.given("LINTNOI");
  AdmsSensFadType modelPar_NTNOI=mod.NTNOI;
  bool modelPar_given_NTNOI=mod.given("NTNOI");
  AdmsSensFadType modelPar_TNOIA=mod.TNOIA;
  bool modelPar_given_TNOIA=mod.given("TNOIA");
  AdmsSensFadType modelPar_TNOIB=mod.TNOIB;
  bool modelPar_given_TNOIB=mod.given("TNOIB");
  AdmsSensFadType modelPar_RNOIA=mod.RNOIA;
  bool modelPar_given_RNOIA=mod.given("RNOIA");
  AdmsSensFadType modelPar_RNOIB=mod.RNOIB;
  bool modelPar_given_RNOIB=mod.given("RNOIB");
  AdmsSensFadType modelPar_TNOIC=mod.TNOIC;
  bool modelPar_given_TNOIC=mod.given("TNOIC");
  AdmsSensFadType modelPar_RNOIC=mod.RNOIC;
  bool modelPar_given_RNOIC=mod.given("RNOIC");
  AdmsSensFadType modelPar_SCALEN=mod.SCALEN;
  bool modelPar_given_SCALEN=mod.given("SCALEN");
  AdmsSensFadType modelPar_TNOM=mod.TNOM;
  bool modelPar_given_TNOM=mod.given("TNOM");
  AdmsSensFadType modelPar_TBGASUB=mod.TBGASUB;
  bool modelPar_given_TBGASUB=mod.given("TBGASUB");
  AdmsSensFadType modelPar_TBGBSUB=mod.TBGBSUB;
  bool modelPar_given_TBGBSUB=mod.given("TBGBSUB");
  AdmsSensFadType modelPar_KT1=mod.KT1;
  bool modelPar_given_KT1=mod.given("KT1");
  AdmsSensFadType modelPar_KT1L=mod.KT1L;
  bool modelPar_given_KT1L=mod.given("KT1L");
  AdmsSensFadType modelPar_TSS=mod.TSS;
  bool modelPar_given_TSS=mod.given("TSS");
  AdmsSensFadType modelPar_IIT=mod.IIT;
  bool modelPar_given_IIT=mod.given("IIT");
  AdmsSensFadType modelPar_TII=mod.TII;
  bool modelPar_given_TII=mod.given("TII");
  AdmsSensFadType modelPar_TGIDL=mod.TGIDL;
  bool modelPar_given_TGIDL=mod.given("TGIDL");
  AdmsSensFadType modelPar_IGT=mod.IGT;
  bool modelPar_given_IGT=mod.given("IGT");
  AdmsSensFadType modelPar_TCJ=mod.TCJ;
  bool modelPar_given_TCJ=mod.given("TCJ");
  AdmsSensFadType modelPar_TCJSW=mod.TCJSW;
  bool modelPar_given_TCJSW=mod.given("TCJSW");
  AdmsSensFadType modelPar_TCJSWG=mod.TCJSWG;
  bool modelPar_given_TCJSWG=mod.given("TCJSWG");
  AdmsSensFadType modelPar_TPB=mod.TPB;
  bool modelPar_given_TPB=mod.given("TPB");
  AdmsSensFadType modelPar_TPBSW=mod.TPBSW;
  bool modelPar_given_TPBSW=mod.given("TPBSW");
  AdmsSensFadType modelPar_TPBSWG=mod.TPBSWG;
  bool modelPar_given_TPBSWG=mod.given("TPBSWG");
  AdmsSensFadType modelPar_XTIS=mod.XTIS;
  bool modelPar_given_XTIS=mod.given("XTIS");
  AdmsSensFadType modelPar_XTID=mod.XTID;
  bool modelPar_given_XTID=mod.given("XTID");
  AdmsSensFadType modelPar_XTSS=mod.XTSS;
  bool modelPar_given_XTSS=mod.given("XTSS");
  AdmsSensFadType modelPar_XTSD=mod.XTSD;
  bool modelPar_given_XTSD=mod.given("XTSD");
  AdmsSensFadType modelPar_XTSSWS=mod.XTSSWS;
  bool modelPar_given_XTSSWS=mod.given("XTSSWS");
  AdmsSensFadType modelPar_XTSSWD=mod.XTSSWD;
  bool modelPar_given_XTSSWD=mod.given("XTSSWD");
  AdmsSensFadType modelPar_XTSSWGS=mod.XTSSWGS;
  bool modelPar_given_XTSSWGS=mod.given("XTSSWGS");
  AdmsSensFadType modelPar_XTSSWGD=mod.XTSSWGD;
  bool modelPar_given_XTSSWGD=mod.given("XTSSWGD");
  AdmsSensFadType modelPar_TNJTS=mod.TNJTS;
  bool modelPar_given_TNJTS=mod.given("TNJTS");
  AdmsSensFadType modelPar_TNJTSD=mod.TNJTSD;
  bool modelPar_given_TNJTSD=mod.given("TNJTSD");
  AdmsSensFadType modelPar_TNJTSSW=mod.TNJTSSW;
  bool modelPar_given_TNJTSSW=mod.given("TNJTSSW");
  AdmsSensFadType modelPar_TNJTSSWD=mod.TNJTSSWD;
  bool modelPar_given_TNJTSSWD=mod.given("TNJTSSWD");
  AdmsSensFadType modelPar_TNJTSSWG=mod.TNJTSSWG;
  bool modelPar_given_TNJTSSWG=mod.given("TNJTSSWG");
  AdmsSensFadType modelPar_TNJTSSWGD=mod.TNJTSSWGD;
  bool modelPar_given_TNJTSSWGD=mod.given("TNJTSSWGD");
  AdmsSensFadType modelPar_RTH0=mod.RTH0;
  bool modelPar_given_RTH0=mod.given("RTH0");
  AdmsSensFadType modelPar_CTH0=mod.CTH0;
  bool modelPar_given_CTH0=mod.given("CTH0");
  AdmsSensFadType modelPar_WTH0=mod.WTH0;
  bool modelPar_given_WTH0=mod.given("WTH0");
  AdmsSensFadType modelPar_ASHEXP=mod.ASHEXP;
  bool modelPar_given_ASHEXP=mod.given("ASHEXP");
  AdmsSensFadType modelPar_BSHEXP=mod.BSHEXP;
  bool modelPar_given_BSHEXP=mod.given("BSHEXP");
  AdmsSensFadType modelPar_ACH_UFCM=mod.ACH_UFCM;
  bool modelPar_given_ACH_UFCM=mod.given("ACH_UFCM");
  AdmsSensFadType modelPar_CINS_UFCM=mod.CINS_UFCM;
  bool modelPar_given_CINS_UFCM=mod.given("CINS_UFCM");
  AdmsSensFadType modelPar_W_UFCM=mod.W_UFCM;
  bool modelPar_given_W_UFCM=mod.given("W_UFCM");
  AdmsSensFadType modelPar_TFIN_TOP=mod.TFIN_TOP;
  bool modelPar_given_TFIN_TOP=mod.given("TFIN_TOP");
  AdmsSensFadType modelPar_TFIN_BASE=mod.TFIN_BASE;
  bool modelPar_given_TFIN_BASE=mod.given("TFIN_BASE");
  AdmsSensFadType modelPar_QMFACTORCV=mod.QMFACTORCV;
  bool modelPar_given_QMFACTORCV=mod.given("QMFACTORCV");
  AdmsSensFadType modelPar_ALPHA_UFCM=mod.ALPHA_UFCM;
  bool modelPar_given_ALPHA_UFCM=mod.given("ALPHA_UFCM");
  AdmsSensFadType modelPar_LNBODY=mod.LNBODY;
  bool modelPar_given_LNBODY=mod.given("LNBODY");
  AdmsSensFadType modelPar_NNBODY=mod.NNBODY;
  bool modelPar_given_NNBODY=mod.given("NNBODY");
  AdmsSensFadType modelPar_PNBODY=mod.PNBODY;
  bool modelPar_given_PNBODY=mod.given("PNBODY");
  AdmsSensFadType modelPar_LPHIG=mod.LPHIG;
  bool modelPar_given_LPHIG=mod.given("LPHIG");
  AdmsSensFadType modelPar_NPHIG=mod.NPHIG;
  bool modelPar_given_NPHIG=mod.given("NPHIG");
  AdmsSensFadType modelPar_PPHIG=mod.PPHIG;
  bool modelPar_given_PPHIG=mod.given("PPHIG");
  AdmsSensFadType modelPar_LNGATE=mod.LNGATE;
  bool modelPar_given_LNGATE=mod.given("LNGATE");
  AdmsSensFadType modelPar_NNGATE=mod.NNGATE;
  bool modelPar_given_NNGATE=mod.given("NNGATE");
  AdmsSensFadType modelPar_PNGATE=mod.PNGATE;
  bool modelPar_given_PNGATE=mod.given("PNGATE");
  AdmsSensFadType modelPar_LCIT=mod.LCIT;
  bool modelPar_given_LCIT=mod.given("LCIT");
  AdmsSensFadType modelPar_NCIT=mod.NCIT;
  bool modelPar_given_NCIT=mod.given("NCIT");
  AdmsSensFadType modelPar_PCIT=mod.PCIT;
  bool modelPar_given_PCIT=mod.given("PCIT");
  AdmsSensFadType modelPar_LCITR=mod.LCITR;
  bool modelPar_given_LCITR=mod.given("LCITR");
  AdmsSensFadType modelPar_NCITR=mod.NCITR;
  bool modelPar_given_NCITR=mod.given("NCITR");
  AdmsSensFadType modelPar_PCITR=mod.PCITR;
  bool modelPar_given_PCITR=mod.given("PCITR");
  AdmsSensFadType modelPar_LCDSC=mod.LCDSC;
  bool modelPar_given_LCDSC=mod.given("LCDSC");
  AdmsSensFadType modelPar_NCDSC=mod.NCDSC;
  bool modelPar_given_NCDSC=mod.given("NCDSC");
  AdmsSensFadType modelPar_PCDSC=mod.PCDSC;
  bool modelPar_given_PCDSC=mod.given("PCDSC");
  AdmsSensFadType modelPar_LCDSCD=mod.LCDSCD;
  bool modelPar_given_LCDSCD=mod.given("LCDSCD");
  AdmsSensFadType modelPar_NCDSCD=mod.NCDSCD;
  bool modelPar_given_NCDSCD=mod.given("NCDSCD");
  AdmsSensFadType modelPar_PCDSCD=mod.PCDSCD;
  bool modelPar_given_PCDSCD=mod.given("PCDSCD");
  AdmsSensFadType modelPar_LCDSCDR=mod.LCDSCDR;
  bool modelPar_given_LCDSCDR=mod.given("LCDSCDR");
  AdmsSensFadType modelPar_NCDSCDR=mod.NCDSCDR;
  bool modelPar_given_NCDSCDR=mod.given("NCDSCDR");
  AdmsSensFadType modelPar_PCDSCDR=mod.PCDSCDR;
  bool modelPar_given_PCDSCDR=mod.given("PCDSCDR");
  AdmsSensFadType modelPar_LDVT0=mod.LDVT0;
  bool modelPar_given_LDVT0=mod.given("LDVT0");
  AdmsSensFadType modelPar_NDVT0=mod.NDVT0;
  bool modelPar_given_NDVT0=mod.given("NDVT0");
  AdmsSensFadType modelPar_PDVT0=mod.PDVT0;
  bool modelPar_given_PDVT0=mod.given("PDVT0");
  AdmsSensFadType modelPar_LDVT1=mod.LDVT1;
  bool modelPar_given_LDVT1=mod.given("LDVT1");
  AdmsSensFadType modelPar_NDVT1=mod.NDVT1;
  bool modelPar_given_NDVT1=mod.given("NDVT1");
  AdmsSensFadType modelPar_PDVT1=mod.PDVT1;
  bool modelPar_given_PDVT1=mod.given("PDVT1");
  AdmsSensFadType modelPar_LDVT1SS=mod.LDVT1SS;
  bool modelPar_given_LDVT1SS=mod.given("LDVT1SS");
  AdmsSensFadType modelPar_NDVT1SS=mod.NDVT1SS;
  bool modelPar_given_NDVT1SS=mod.given("NDVT1SS");
  AdmsSensFadType modelPar_PDVT1SS=mod.PDVT1SS;
  bool modelPar_given_PDVT1SS=mod.given("PDVT1SS");
  AdmsSensFadType modelPar_LPHIN=mod.LPHIN;
  bool modelPar_given_LPHIN=mod.given("LPHIN");
  AdmsSensFadType modelPar_NPHIN=mod.NPHIN;
  bool modelPar_given_NPHIN=mod.given("NPHIN");
  AdmsSensFadType modelPar_PPHIN=mod.PPHIN;
  bool modelPar_given_PPHIN=mod.given("PPHIN");
  AdmsSensFadType modelPar_LETA0=mod.LETA0;
  bool modelPar_given_LETA0=mod.given("LETA0");
  AdmsSensFadType modelPar_NETA0=mod.NETA0;
  bool modelPar_given_NETA0=mod.given("NETA0");
  AdmsSensFadType modelPar_PETA0=mod.PETA0;
  bool modelPar_given_PETA0=mod.given("PETA0");
  AdmsSensFadType modelPar_LETA0R=mod.LETA0R;
  bool modelPar_given_LETA0R=mod.given("LETA0R");
  AdmsSensFadType modelPar_NETA0R=mod.NETA0R;
  bool modelPar_given_NETA0R=mod.given("NETA0R");
  AdmsSensFadType modelPar_PETA0R=mod.PETA0R;
  bool modelPar_given_PETA0R=mod.given("PETA0R");
  AdmsSensFadType modelPar_LDSUB=mod.LDSUB;
  bool modelPar_given_LDSUB=mod.given("LDSUB");
  AdmsSensFadType modelPar_NDSUB=mod.NDSUB;
  bool modelPar_given_NDSUB=mod.given("NDSUB");
  AdmsSensFadType modelPar_PDSUB=mod.PDSUB;
  bool modelPar_given_PDSUB=mod.given("PDSUB");
  AdmsSensFadType modelPar_LK1RSCE=mod.LK1RSCE;
  bool modelPar_given_LK1RSCE=mod.given("LK1RSCE");
  AdmsSensFadType modelPar_NK1RSCE=mod.NK1RSCE;
  bool modelPar_given_NK1RSCE=mod.given("NK1RSCE");
  AdmsSensFadType modelPar_PK1RSCE=mod.PK1RSCE;
  bool modelPar_given_PK1RSCE=mod.given("PK1RSCE");
  AdmsSensFadType modelPar_LLPE0=mod.LLPE0;
  bool modelPar_given_LLPE0=mod.given("LLPE0");
  AdmsSensFadType modelPar_NLPE0=mod.NLPE0;
  bool modelPar_given_NLPE0=mod.given("NLPE0");
  AdmsSensFadType modelPar_PLPE0=mod.PLPE0;
  bool modelPar_given_PLPE0=mod.given("PLPE0");
  AdmsSensFadType modelPar_LDVTSHIFT=mod.LDVTSHIFT;
  bool modelPar_given_LDVTSHIFT=mod.given("LDVTSHIFT");
  AdmsSensFadType modelPar_NDVTSHIFT=mod.NDVTSHIFT;
  bool modelPar_given_NDVTSHIFT=mod.given("NDVTSHIFT");
  AdmsSensFadType modelPar_PDVTSHIFT=mod.PDVTSHIFT;
  bool modelPar_given_PDVTSHIFT=mod.given("PDVTSHIFT");
  AdmsSensFadType modelPar_LDVTSHIFTR=mod.LDVTSHIFTR;
  bool modelPar_given_LDVTSHIFTR=mod.given("LDVTSHIFTR");
  AdmsSensFadType modelPar_NDVTSHIFTR=mod.NDVTSHIFTR;
  bool modelPar_given_NDVTSHIFTR=mod.given("NDVTSHIFTR");
  AdmsSensFadType modelPar_PDVTSHIFTR=mod.PDVTSHIFTR;
  bool modelPar_given_PDVTSHIFTR=mod.given("PDVTSHIFTR");
  AdmsSensFadType modelPar_LPHIBE=mod.LPHIBE;
  bool modelPar_given_LPHIBE=mod.given("LPHIBE");
  AdmsSensFadType modelPar_NPHIBE=mod.NPHIBE;
  bool modelPar_given_NPHIBE=mod.given("NPHIBE");
  AdmsSensFadType modelPar_PPHIBE=mod.PPHIBE;
  bool modelPar_given_PPHIBE=mod.given("PPHIBE");
  AdmsSensFadType modelPar_LK0=mod.LK0;
  bool modelPar_given_LK0=mod.given("LK0");
  AdmsSensFadType modelPar_NK0=mod.NK0;
  bool modelPar_given_NK0=mod.given("NK0");
  AdmsSensFadType modelPar_PK0=mod.PK0;
  bool modelPar_given_PK0=mod.given("PK0");
  AdmsSensFadType modelPar_LK01=mod.LK01;
  bool modelPar_given_LK01=mod.given("LK01");
  AdmsSensFadType modelPar_NK01=mod.NK01;
  bool modelPar_given_NK01=mod.given("NK01");
  AdmsSensFadType modelPar_PK01=mod.PK01;
  bool modelPar_given_PK01=mod.given("PK01");
  AdmsSensFadType modelPar_LK0SI=mod.LK0SI;
  bool modelPar_given_LK0SI=mod.given("LK0SI");
  AdmsSensFadType modelPar_NK0SI=mod.NK0SI;
  bool modelPar_given_NK0SI=mod.given("NK0SI");
  AdmsSensFadType modelPar_PK0SI=mod.PK0SI;
  bool modelPar_given_PK0SI=mod.given("PK0SI");
  AdmsSensFadType modelPar_LK0SI1=mod.LK0SI1;
  bool modelPar_given_LK0SI1=mod.given("LK0SI1");
  AdmsSensFadType modelPar_NK0SI1=mod.NK0SI1;
  bool modelPar_given_NK0SI1=mod.given("NK0SI1");
  AdmsSensFadType modelPar_PK0SI1=mod.PK0SI1;
  bool modelPar_given_PK0SI1=mod.given("PK0SI1");
  AdmsSensFadType modelPar_LK1=mod.LK1;
  bool modelPar_given_LK1=mod.given("LK1");
  AdmsSensFadType modelPar_NK1=mod.NK1;
  bool modelPar_given_NK1=mod.given("NK1");
  AdmsSensFadType modelPar_PK1=mod.PK1;
  bool modelPar_given_PK1=mod.given("PK1");
  AdmsSensFadType modelPar_LK11=mod.LK11;
  bool modelPar_given_LK11=mod.given("LK11");
  AdmsSensFadType modelPar_NK11=mod.NK11;
  bool modelPar_given_NK11=mod.given("NK11");
  AdmsSensFadType modelPar_PK11=mod.PK11;
  bool modelPar_given_PK11=mod.given("PK11");
  AdmsSensFadType modelPar_LK2SI=mod.LK2SI;
  bool modelPar_given_LK2SI=mod.given("LK2SI");
  AdmsSensFadType modelPar_NK2SI=mod.NK2SI;
  bool modelPar_given_NK2SI=mod.given("NK2SI");
  AdmsSensFadType modelPar_PK2SI=mod.PK2SI;
  bool modelPar_given_PK2SI=mod.given("PK2SI");
  AdmsSensFadType modelPar_LK2SI1=mod.LK2SI1;
  bool modelPar_given_LK2SI1=mod.given("LK2SI1");
  AdmsSensFadType modelPar_NK2SI1=mod.NK2SI1;
  bool modelPar_given_NK2SI1=mod.given("NK2SI1");
  AdmsSensFadType modelPar_PK2SI1=mod.PK2SI1;
  bool modelPar_given_PK2SI1=mod.given("PK2SI1");
  AdmsSensFadType modelPar_LK0SISAT=mod.LK0SISAT;
  bool modelPar_given_LK0SISAT=mod.given("LK0SISAT");
  AdmsSensFadType modelPar_NK0SISAT=mod.NK0SISAT;
  bool modelPar_given_NK0SISAT=mod.given("NK0SISAT");
  AdmsSensFadType modelPar_PK0SISAT=mod.PK0SISAT;
  bool modelPar_given_PK0SISAT=mod.given("PK0SISAT");
  AdmsSensFadType modelPar_LK0SISAT1=mod.LK0SISAT1;
  bool modelPar_given_LK0SISAT1=mod.given("LK0SISAT1");
  AdmsSensFadType modelPar_NK0SISAT1=mod.NK0SISAT1;
  bool modelPar_given_NK0SISAT1=mod.given("NK0SISAT1");
  AdmsSensFadType modelPar_PK0SISAT1=mod.PK0SISAT1;
  bool modelPar_given_PK0SISAT1=mod.given("PK0SISAT1");
  AdmsSensFadType modelPar_LK2SISAT=mod.LK2SISAT;
  bool modelPar_given_LK2SISAT=mod.given("LK2SISAT");
  AdmsSensFadType modelPar_NK2SISAT=mod.NK2SISAT;
  bool modelPar_given_NK2SISAT=mod.given("NK2SISAT");
  AdmsSensFadType modelPar_PK2SISAT=mod.PK2SISAT;
  bool modelPar_given_PK2SISAT=mod.given("PK2SISAT");
  AdmsSensFadType modelPar_LK2SISAT1=mod.LK2SISAT1;
  bool modelPar_given_LK2SISAT1=mod.given("LK2SISAT1");
  AdmsSensFadType modelPar_NK2SISAT1=mod.NK2SISAT1;
  bool modelPar_given_NK2SISAT1=mod.given("NK2SISAT1");
  AdmsSensFadType modelPar_PK2SISAT1=mod.PK2SISAT1;
  bool modelPar_given_PK2SISAT1=mod.given("PK2SISAT1");
  AdmsSensFadType modelPar_LK2SAT=mod.LK2SAT;
  bool modelPar_given_LK2SAT=mod.given("LK2SAT");
  AdmsSensFadType modelPar_NK2SAT=mod.NK2SAT;
  bool modelPar_given_NK2SAT=mod.given("NK2SAT");
  AdmsSensFadType modelPar_PK2SAT=mod.PK2SAT;
  bool modelPar_given_PK2SAT=mod.given("PK2SAT");
  AdmsSensFadType modelPar_LK2SAT1=mod.LK2SAT1;
  bool modelPar_given_LK2SAT1=mod.given("LK2SAT1");
  AdmsSensFadType modelPar_NK2SAT1=mod.NK2SAT1;
  bool modelPar_given_NK2SAT1=mod.given("NK2SAT1");
  AdmsSensFadType modelPar_PK2SAT1=mod.PK2SAT1;
  bool modelPar_given_PK2SAT1=mod.given("PK2SAT1");
  AdmsSensFadType modelPar_LK2=mod.LK2;
  bool modelPar_given_LK2=mod.given("LK2");
  AdmsSensFadType modelPar_NK2=mod.NK2;
  bool modelPar_given_NK2=mod.given("NK2");
  AdmsSensFadType modelPar_PK2=mod.PK2;
  bool modelPar_given_PK2=mod.given("PK2");
  AdmsSensFadType modelPar_LK21=mod.LK21;
  bool modelPar_given_LK21=mod.given("LK21");
  AdmsSensFadType modelPar_NK21=mod.NK21;
  bool modelPar_given_NK21=mod.given("NK21");
  AdmsSensFadType modelPar_PK21=mod.PK21;
  bool modelPar_given_PK21=mod.given("PK21");
  AdmsSensFadType modelPar_LDVTB=mod.LDVTB;
  bool modelPar_given_LDVTB=mod.given("LDVTB");
  AdmsSensFadType modelPar_NDVTB=mod.NDVTB;
  bool modelPar_given_NDVTB=mod.given("NDVTB");
  AdmsSensFadType modelPar_PDVTB=mod.PDVTB;
  bool modelPar_given_PDVTB=mod.given("PDVTB");
  AdmsSensFadType modelPar_LLPEB=mod.LLPEB;
  bool modelPar_given_LLPEB=mod.given("LLPEB");
  AdmsSensFadType modelPar_NLPEB=mod.NLPEB;
  bool modelPar_given_NLPEB=mod.given("NLPEB");
  AdmsSensFadType modelPar_PLPEB=mod.PLPEB;
  bool modelPar_given_PLPEB=mod.given("PLPEB");
  AdmsSensFadType modelPar_LQMFACTOR=mod.LQMFACTOR;
  bool modelPar_given_LQMFACTOR=mod.given("LQMFACTOR");
  AdmsSensFadType modelPar_NQMFACTOR=mod.NQMFACTOR;
  bool modelPar_given_NQMFACTOR=mod.given("NQMFACTOR");
  AdmsSensFadType modelPar_PQMFACTOR=mod.PQMFACTOR;
  bool modelPar_given_PQMFACTOR=mod.given("PQMFACTOR");
  AdmsSensFadType modelPar_LQMTCENCV=mod.LQMTCENCV;
  bool modelPar_given_LQMTCENCV=mod.given("LQMTCENCV");
  AdmsSensFadType modelPar_NQMTCENCV=mod.NQMTCENCV;
  bool modelPar_given_NQMTCENCV=mod.given("NQMTCENCV");
  AdmsSensFadType modelPar_PQMTCENCV=mod.PQMTCENCV;
  bool modelPar_given_PQMTCENCV=mod.given("PQMTCENCV");
  AdmsSensFadType modelPar_LQMTCENCVA=mod.LQMTCENCVA;
  bool modelPar_given_LQMTCENCVA=mod.given("LQMTCENCVA");
  AdmsSensFadType modelPar_NQMTCENCVA=mod.NQMTCENCVA;
  bool modelPar_given_NQMTCENCVA=mod.given("NQMTCENCVA");
  AdmsSensFadType modelPar_PQMTCENCVA=mod.PQMTCENCVA;
  bool modelPar_given_PQMTCENCVA=mod.given("PQMTCENCVA");
  AdmsSensFadType modelPar_LVSAT=mod.LVSAT;
  bool modelPar_given_LVSAT=mod.given("LVSAT");
  AdmsSensFadType modelPar_NVSAT=mod.NVSAT;
  bool modelPar_given_NVSAT=mod.given("NVSAT");
  AdmsSensFadType modelPar_PVSAT=mod.PVSAT;
  bool modelPar_given_PVSAT=mod.given("PVSAT");
  AdmsSensFadType modelPar_LVSATR=mod.LVSATR;
  bool modelPar_given_LVSATR=mod.given("LVSATR");
  AdmsSensFadType modelPar_NVSATR=mod.NVSATR;
  bool modelPar_given_NVSATR=mod.given("NVSATR");
  AdmsSensFadType modelPar_PVSATR=mod.PVSATR;
  bool modelPar_given_PVSATR=mod.given("PVSATR");
  AdmsSensFadType modelPar_LVSAT1=mod.LVSAT1;
  bool modelPar_given_LVSAT1=mod.given("LVSAT1");
  AdmsSensFadType modelPar_NVSAT1=mod.NVSAT1;
  bool modelPar_given_NVSAT1=mod.given("NVSAT1");
  AdmsSensFadType modelPar_PVSAT1=mod.PVSAT1;
  bool modelPar_given_PVSAT1=mod.given("PVSAT1");
  AdmsSensFadType modelPar_LVSAT1R=mod.LVSAT1R;
  bool modelPar_given_LVSAT1R=mod.given("LVSAT1R");
  AdmsSensFadType modelPar_NVSAT1R=mod.NVSAT1R;
  bool modelPar_given_NVSAT1R=mod.given("NVSAT1R");
  AdmsSensFadType modelPar_PVSAT1R=mod.PVSAT1R;
  bool modelPar_given_PVSAT1R=mod.given("PVSAT1R");
  AdmsSensFadType modelPar_LPSAT=mod.LPSAT;
  bool modelPar_given_LPSAT=mod.given("LPSAT");
  AdmsSensFadType modelPar_NPSAT=mod.NPSAT;
  bool modelPar_given_NPSAT=mod.given("NPSAT");
  AdmsSensFadType modelPar_PPSAT=mod.PPSAT;
  bool modelPar_given_PPSAT=mod.given("PPSAT");
  AdmsSensFadType modelPar_LDELTAVSAT=mod.LDELTAVSAT;
  bool modelPar_given_LDELTAVSAT=mod.given("LDELTAVSAT");
  AdmsSensFadType modelPar_NDELTAVSAT=mod.NDELTAVSAT;
  bool modelPar_given_NDELTAVSAT=mod.given("NDELTAVSAT");
  AdmsSensFadType modelPar_PDELTAVSAT=mod.PDELTAVSAT;
  bool modelPar_given_PDELTAVSAT=mod.given("PDELTAVSAT");
  AdmsSensFadType modelPar_LKSATIV=mod.LKSATIV;
  bool modelPar_given_LKSATIV=mod.given("LKSATIV");
  AdmsSensFadType modelPar_NKSATIV=mod.NKSATIV;
  bool modelPar_given_NKSATIV=mod.given("NKSATIV");
  AdmsSensFadType modelPar_PKSATIV=mod.PKSATIV;
  bool modelPar_given_PKSATIV=mod.given("PKSATIV");
  AdmsSensFadType modelPar_LKSATIVR=mod.LKSATIVR;
  bool modelPar_given_LKSATIVR=mod.given("LKSATIVR");
  AdmsSensFadType modelPar_NKSATIVR=mod.NKSATIVR;
  bool modelPar_given_NKSATIVR=mod.given("NKSATIVR");
  AdmsSensFadType modelPar_PKSATIVR=mod.PKSATIVR;
  bool modelPar_given_PKSATIVR=mod.given("PKSATIVR");
  AdmsSensFadType modelPar_LVSATCV=mod.LVSATCV;
  bool modelPar_given_LVSATCV=mod.given("LVSATCV");
  AdmsSensFadType modelPar_NVSATCV=mod.NVSATCV;
  bool modelPar_given_NVSATCV=mod.given("NVSATCV");
  AdmsSensFadType modelPar_PVSATCV=mod.PVSATCV;
  bool modelPar_given_PVSATCV=mod.given("PVSATCV");
  AdmsSensFadType modelPar_LPSATCV=mod.LPSATCV;
  bool modelPar_given_LPSATCV=mod.given("LPSATCV");
  AdmsSensFadType modelPar_NPSATCV=mod.NPSATCV;
  bool modelPar_given_NPSATCV=mod.given("NPSATCV");
  AdmsSensFadType modelPar_PPSATCV=mod.PPSATCV;
  bool modelPar_given_PPSATCV=mod.given("PPSATCV");
  AdmsSensFadType modelPar_LDELTAVSATCV=mod.LDELTAVSATCV;
  bool modelPar_given_LDELTAVSATCV=mod.given("LDELTAVSATCV");
  AdmsSensFadType modelPar_NDELTAVSATCV=mod.NDELTAVSATCV;
  bool modelPar_given_NDELTAVSATCV=mod.given("NDELTAVSATCV");
  AdmsSensFadType modelPar_PDELTAVSATCV=mod.PDELTAVSATCV;
  bool modelPar_given_PDELTAVSATCV=mod.given("PDELTAVSATCV");
  AdmsSensFadType modelPar_LMEXP=mod.LMEXP;
  bool modelPar_given_LMEXP=mod.given("LMEXP");
  AdmsSensFadType modelPar_NMEXP=mod.NMEXP;
  bool modelPar_given_NMEXP=mod.given("NMEXP");
  AdmsSensFadType modelPar_PMEXP=mod.PMEXP;
  bool modelPar_given_PMEXP=mod.given("PMEXP");
  AdmsSensFadType modelPar_LMEXPR=mod.LMEXPR;
  bool modelPar_given_LMEXPR=mod.given("LMEXPR");
  AdmsSensFadType modelPar_NMEXPR=mod.NMEXPR;
  bool modelPar_given_NMEXPR=mod.given("NMEXPR");
  AdmsSensFadType modelPar_PMEXPR=mod.PMEXPR;
  bool modelPar_given_PMEXPR=mod.given("PMEXPR");
  AdmsSensFadType modelPar_LPTWG=mod.LPTWG;
  bool modelPar_given_LPTWG=mod.given("LPTWG");
  AdmsSensFadType modelPar_NPTWG=mod.NPTWG;
  bool modelPar_given_NPTWG=mod.given("NPTWG");
  AdmsSensFadType modelPar_PPTWG=mod.PPTWG;
  bool modelPar_given_PPTWG=mod.given("PPTWG");
  AdmsSensFadType modelPar_LPTWGR=mod.LPTWGR;
  bool modelPar_given_LPTWGR=mod.given("LPTWGR");
  AdmsSensFadType modelPar_NPTWGR=mod.NPTWGR;
  bool modelPar_given_NPTWGR=mod.given("NPTWGR");
  AdmsSensFadType modelPar_PPTWGR=mod.PPTWGR;
  bool modelPar_given_PPTWGR=mod.given("PPTWGR");
  AdmsSensFadType modelPar_LU0=mod.LU0;
  bool modelPar_given_LU0=mod.given("LU0");
  AdmsSensFadType modelPar_NU0=mod.NU0;
  bool modelPar_given_NU0=mod.given("NU0");
  AdmsSensFadType modelPar_PU0=mod.PU0;
  bool modelPar_given_PU0=mod.given("PU0");
  AdmsSensFadType modelPar_LU0R=mod.LU0R;
  bool modelPar_given_LU0R=mod.given("LU0R");
  AdmsSensFadType modelPar_NU0R=mod.NU0R;
  bool modelPar_given_NU0R=mod.given("NU0R");
  AdmsSensFadType modelPar_PU0R=mod.PU0R;
  bool modelPar_given_PU0R=mod.given("PU0R");
  AdmsSensFadType modelPar_LETAMOB=mod.LETAMOB;
  bool modelPar_given_LETAMOB=mod.given("LETAMOB");
  AdmsSensFadType modelPar_NETAMOB=mod.NETAMOB;
  bool modelPar_given_NETAMOB=mod.given("NETAMOB");
  AdmsSensFadType modelPar_PETAMOB=mod.PETAMOB;
  bool modelPar_given_PETAMOB=mod.given("PETAMOB");
  AdmsSensFadType modelPar_LUP=mod.LUP;
  bool modelPar_given_LUP=mod.given("LUP");
  AdmsSensFadType modelPar_NUP=mod.NUP;
  bool modelPar_given_NUP=mod.given("NUP");
  AdmsSensFadType modelPar_PUP=mod.PUP;
  bool modelPar_given_PUP=mod.given("PUP");
  AdmsSensFadType modelPar_LUPR=mod.LUPR;
  bool modelPar_given_LUPR=mod.given("LUPR");
  AdmsSensFadType modelPar_NUPR=mod.NUPR;
  bool modelPar_given_NUPR=mod.given("NUPR");
  AdmsSensFadType modelPar_PUPR=mod.PUPR;
  bool modelPar_given_PUPR=mod.given("PUPR");
  AdmsSensFadType modelPar_LUA=mod.LUA;
  bool modelPar_given_LUA=mod.given("LUA");
  AdmsSensFadType modelPar_NUA=mod.NUA;
  bool modelPar_given_NUA=mod.given("NUA");
  AdmsSensFadType modelPar_PUA=mod.PUA;
  bool modelPar_given_PUA=mod.given("PUA");
  AdmsSensFadType modelPar_LUAR=mod.LUAR;
  bool modelPar_given_LUAR=mod.given("LUAR");
  AdmsSensFadType modelPar_NUAR=mod.NUAR;
  bool modelPar_given_NUAR=mod.given("NUAR");
  AdmsSensFadType modelPar_PUAR=mod.PUAR;
  bool modelPar_given_PUAR=mod.given("PUAR");
  AdmsSensFadType modelPar_LUC=mod.LUC;
  bool modelPar_given_LUC=mod.given("LUC");
  AdmsSensFadType modelPar_NUC=mod.NUC;
  bool modelPar_given_NUC=mod.given("NUC");
  AdmsSensFadType modelPar_PUC=mod.PUC;
  bool modelPar_given_PUC=mod.given("PUC");
  AdmsSensFadType modelPar_LUCR=mod.LUCR;
  bool modelPar_given_LUCR=mod.given("LUCR");
  AdmsSensFadType modelPar_NUCR=mod.NUCR;
  bool modelPar_given_NUCR=mod.given("NUCR");
  AdmsSensFadType modelPar_PUCR=mod.PUCR;
  bool modelPar_given_PUCR=mod.given("PUCR");
  AdmsSensFadType modelPar_LEU=mod.LEU;
  bool modelPar_given_LEU=mod.given("LEU");
  AdmsSensFadType modelPar_NEU=mod.NEU;
  bool modelPar_given_NEU=mod.given("NEU");
  AdmsSensFadType modelPar_PEU=mod.PEU;
  bool modelPar_given_PEU=mod.given("PEU");
  AdmsSensFadType modelPar_LEUR=mod.LEUR;
  bool modelPar_given_LEUR=mod.given("LEUR");
  AdmsSensFadType modelPar_NEUR=mod.NEUR;
  bool modelPar_given_NEUR=mod.given("NEUR");
  AdmsSensFadType modelPar_PEUR=mod.PEUR;
  bool modelPar_given_PEUR=mod.given("PEUR");
  AdmsSensFadType modelPar_LUD=mod.LUD;
  bool modelPar_given_LUD=mod.given("LUD");
  AdmsSensFadType modelPar_NUD=mod.NUD;
  bool modelPar_given_NUD=mod.given("NUD");
  AdmsSensFadType modelPar_PUD=mod.PUD;
  bool modelPar_given_PUD=mod.given("PUD");
  AdmsSensFadType modelPar_LUDR=mod.LUDR;
  bool modelPar_given_LUDR=mod.given("LUDR");
  AdmsSensFadType modelPar_NUDR=mod.NUDR;
  bool modelPar_given_NUDR=mod.given("NUDR");
  AdmsSensFadType modelPar_PUDR=mod.PUDR;
  bool modelPar_given_PUDR=mod.given("PUDR");
  AdmsSensFadType modelPar_LUCS=mod.LUCS;
  bool modelPar_given_LUCS=mod.given("LUCS");
  AdmsSensFadType modelPar_NUCS=mod.NUCS;
  bool modelPar_given_NUCS=mod.given("NUCS");
  AdmsSensFadType modelPar_PUCS=mod.PUCS;
  bool modelPar_given_PUCS=mod.given("PUCS");
  AdmsSensFadType modelPar_LPCLM=mod.LPCLM;
  bool modelPar_given_LPCLM=mod.given("LPCLM");
  AdmsSensFadType modelPar_NPCLM=mod.NPCLM;
  bool modelPar_given_NPCLM=mod.given("NPCLM");
  AdmsSensFadType modelPar_PPCLM=mod.PPCLM;
  bool modelPar_given_PPCLM=mod.given("PPCLM");
  AdmsSensFadType modelPar_LPCLMR=mod.LPCLMR;
  bool modelPar_given_LPCLMR=mod.given("LPCLMR");
  AdmsSensFadType modelPar_NPCLMR=mod.NPCLMR;
  bool modelPar_given_NPCLMR=mod.given("NPCLMR");
  AdmsSensFadType modelPar_PPCLMR=mod.PPCLMR;
  bool modelPar_given_PPCLMR=mod.given("PPCLMR");
  AdmsSensFadType modelPar_LPCLMG=mod.LPCLMG;
  bool modelPar_given_LPCLMG=mod.given("LPCLMG");
  AdmsSensFadType modelPar_NPCLMG=mod.NPCLMG;
  bool modelPar_given_NPCLMG=mod.given("NPCLMG");
  AdmsSensFadType modelPar_PPCLMG=mod.PPCLMG;
  bool modelPar_given_PPCLMG=mod.given("PPCLMG");
  AdmsSensFadType modelPar_LPCLMCV=mod.LPCLMCV;
  bool modelPar_given_LPCLMCV=mod.given("LPCLMCV");
  AdmsSensFadType modelPar_NPCLMCV=mod.NPCLMCV;
  bool modelPar_given_NPCLMCV=mod.given("NPCLMCV");
  AdmsSensFadType modelPar_PPCLMCV=mod.PPCLMCV;
  bool modelPar_given_PPCLMCV=mod.given("PPCLMCV");
  AdmsSensFadType modelPar_LA1=mod.LA1;
  bool modelPar_given_LA1=mod.given("LA1");
  AdmsSensFadType modelPar_NA1=mod.NA1;
  bool modelPar_given_NA1=mod.given("NA1");
  AdmsSensFadType modelPar_PA1=mod.PA1;
  bool modelPar_given_PA1=mod.given("PA1");
  AdmsSensFadType modelPar_LA11=mod.LA11;
  bool modelPar_given_LA11=mod.given("LA11");
  AdmsSensFadType modelPar_NA11=mod.NA11;
  bool modelPar_given_NA11=mod.given("NA11");
  AdmsSensFadType modelPar_PA11=mod.PA11;
  bool modelPar_given_PA11=mod.given("PA11");
  AdmsSensFadType modelPar_LA2=mod.LA2;
  bool modelPar_given_LA2=mod.given("LA2");
  AdmsSensFadType modelPar_NA2=mod.NA2;
  bool modelPar_given_NA2=mod.given("NA2");
  AdmsSensFadType modelPar_PA2=mod.PA2;
  bool modelPar_given_PA2=mod.given("PA2");
  AdmsSensFadType modelPar_LA21=mod.LA21;
  bool modelPar_given_LA21=mod.given("LA21");
  AdmsSensFadType modelPar_NA21=mod.NA21;
  bool modelPar_given_NA21=mod.given("NA21");
  AdmsSensFadType modelPar_PA21=mod.PA21;
  bool modelPar_given_PA21=mod.given("PA21");
  AdmsSensFadType modelPar_LRDSW=mod.LRDSW;
  bool modelPar_given_LRDSW=mod.given("LRDSW");
  AdmsSensFadType modelPar_NRDSW=mod.NRDSW;
  bool modelPar_given_NRDSW=mod.given("NRDSW");
  AdmsSensFadType modelPar_PRDSW=mod.PRDSW;
  bool modelPar_given_PRDSW=mod.given("PRDSW");
  AdmsSensFadType modelPar_LRSW=mod.LRSW;
  bool modelPar_given_LRSW=mod.given("LRSW");
  AdmsSensFadType modelPar_NRSW=mod.NRSW;
  bool modelPar_given_NRSW=mod.given("NRSW");
  AdmsSensFadType modelPar_PRSW=mod.PRSW;
  bool modelPar_given_PRSW=mod.given("PRSW");
  AdmsSensFadType modelPar_LRDW=mod.LRDW;
  bool modelPar_given_LRDW=mod.given("LRDW");
  AdmsSensFadType modelPar_NRDW=mod.NRDW;
  bool modelPar_given_NRDW=mod.given("NRDW");
  AdmsSensFadType modelPar_PRDW=mod.PRDW;
  bool modelPar_given_PRDW=mod.given("PRDW");
  AdmsSensFadType modelPar_LPRWGS=mod.LPRWGS;
  bool modelPar_given_LPRWGS=mod.given("LPRWGS");
  AdmsSensFadType modelPar_NPRWGS=mod.NPRWGS;
  bool modelPar_given_NPRWGS=mod.given("NPRWGS");
  AdmsSensFadType modelPar_PPRWGS=mod.PPRWGS;
  bool modelPar_given_PPRWGS=mod.given("PPRWGS");
  AdmsSensFadType modelPar_LPRWGD=mod.LPRWGD;
  bool modelPar_given_LPRWGD=mod.given("LPRWGD");
  AdmsSensFadType modelPar_NPRWGD=mod.NPRWGD;
  bool modelPar_given_NPRWGD=mod.given("NPRWGD");
  AdmsSensFadType modelPar_PPRWGD=mod.PPRWGD;
  bool modelPar_given_PPRWGD=mod.given("PPRWGD");
  AdmsSensFadType modelPar_LWR=mod.LWR;
  bool modelPar_given_LWR=mod.given("LWR");
  AdmsSensFadType modelPar_NWR=mod.NWR;
  bool modelPar_given_NWR=mod.given("NWR");
  AdmsSensFadType modelPar_PWR=mod.PWR;
  bool modelPar_given_PWR=mod.given("PWR");
  AdmsSensFadType modelPar_LPDIBL1=mod.LPDIBL1;
  bool modelPar_given_LPDIBL1=mod.given("LPDIBL1");
  AdmsSensFadType modelPar_NPDIBL1=mod.NPDIBL1;
  bool modelPar_given_NPDIBL1=mod.given("NPDIBL1");
  AdmsSensFadType modelPar_PPDIBL1=mod.PPDIBL1;
  bool modelPar_given_PPDIBL1=mod.given("PPDIBL1");
  AdmsSensFadType modelPar_LPDIBL1R=mod.LPDIBL1R;
  bool modelPar_given_LPDIBL1R=mod.given("LPDIBL1R");
  AdmsSensFadType modelPar_NPDIBL1R=mod.NPDIBL1R;
  bool modelPar_given_NPDIBL1R=mod.given("NPDIBL1R");
  AdmsSensFadType modelPar_PPDIBL1R=mod.PPDIBL1R;
  bool modelPar_given_PPDIBL1R=mod.given("PPDIBL1R");
  AdmsSensFadType modelPar_LPDIBL2=mod.LPDIBL2;
  bool modelPar_given_LPDIBL2=mod.given("LPDIBL2");
  AdmsSensFadType modelPar_NPDIBL2=mod.NPDIBL2;
  bool modelPar_given_NPDIBL2=mod.given("NPDIBL2");
  AdmsSensFadType modelPar_PPDIBL2=mod.PPDIBL2;
  bool modelPar_given_PPDIBL2=mod.given("PPDIBL2");
  AdmsSensFadType modelPar_LPDIBL2R=mod.LPDIBL2R;
  bool modelPar_given_LPDIBL2R=mod.given("LPDIBL2R");
  AdmsSensFadType modelPar_NPDIBL2R=mod.NPDIBL2R;
  bool modelPar_given_NPDIBL2R=mod.given("NPDIBL2R");
  AdmsSensFadType modelPar_PPDIBL2R=mod.PPDIBL2R;
  bool modelPar_given_PPDIBL2R=mod.given("PPDIBL2R");
  AdmsSensFadType modelPar_LDROUT=mod.LDROUT;
  bool modelPar_given_LDROUT=mod.given("LDROUT");
  AdmsSensFadType modelPar_NDROUT=mod.NDROUT;
  bool modelPar_given_NDROUT=mod.given("NDROUT");
  AdmsSensFadType modelPar_PDROUT=mod.PDROUT;
  bool modelPar_given_PDROUT=mod.given("PDROUT");
  AdmsSensFadType modelPar_LPVAG=mod.LPVAG;
  bool modelPar_given_LPVAG=mod.given("LPVAG");
  AdmsSensFadType modelPar_NPVAG=mod.NPVAG;
  bool modelPar_given_NPVAG=mod.given("NPVAG");
  AdmsSensFadType modelPar_PPVAG=mod.PPVAG;
  bool modelPar_given_PPVAG=mod.given("PPVAG");
  AdmsSensFadType modelPar_LAIGBINV=mod.LAIGBINV;
  bool modelPar_given_LAIGBINV=mod.given("LAIGBINV");
  AdmsSensFadType modelPar_NAIGBINV=mod.NAIGBINV;
  bool modelPar_given_NAIGBINV=mod.given("NAIGBINV");
  AdmsSensFadType modelPar_PAIGBINV=mod.PAIGBINV;
  bool modelPar_given_PAIGBINV=mod.given("PAIGBINV");
  AdmsSensFadType modelPar_LAIGBINV1=mod.LAIGBINV1;
  bool modelPar_given_LAIGBINV1=mod.given("LAIGBINV1");
  AdmsSensFadType modelPar_NAIGBINV1=mod.NAIGBINV1;
  bool modelPar_given_NAIGBINV1=mod.given("NAIGBINV1");
  AdmsSensFadType modelPar_PAIGBINV1=mod.PAIGBINV1;
  bool modelPar_given_PAIGBINV1=mod.given("PAIGBINV1");
  AdmsSensFadType modelPar_LBIGBINV=mod.LBIGBINV;
  bool modelPar_given_LBIGBINV=mod.given("LBIGBINV");
  AdmsSensFadType modelPar_NBIGBINV=mod.NBIGBINV;
  bool modelPar_given_NBIGBINV=mod.given("NBIGBINV");
  AdmsSensFadType modelPar_PBIGBINV=mod.PBIGBINV;
  bool modelPar_given_PBIGBINV=mod.given("PBIGBINV");
  AdmsSensFadType modelPar_LCIGBINV=mod.LCIGBINV;
  bool modelPar_given_LCIGBINV=mod.given("LCIGBINV");
  AdmsSensFadType modelPar_NCIGBINV=mod.NCIGBINV;
  bool modelPar_given_NCIGBINV=mod.given("NCIGBINV");
  AdmsSensFadType modelPar_PCIGBINV=mod.PCIGBINV;
  bool modelPar_given_PCIGBINV=mod.given("PCIGBINV");
  AdmsSensFadType modelPar_LEIGBINV=mod.LEIGBINV;
  bool modelPar_given_LEIGBINV=mod.given("LEIGBINV");
  AdmsSensFadType modelPar_NEIGBINV=mod.NEIGBINV;
  bool modelPar_given_NEIGBINV=mod.given("NEIGBINV");
  AdmsSensFadType modelPar_PEIGBINV=mod.PEIGBINV;
  bool modelPar_given_PEIGBINV=mod.given("PEIGBINV");
  AdmsSensFadType modelPar_LNIGBINV=mod.LNIGBINV;
  bool modelPar_given_LNIGBINV=mod.given("LNIGBINV");
  AdmsSensFadType modelPar_NNIGBINV=mod.NNIGBINV;
  bool modelPar_given_NNIGBINV=mod.given("NNIGBINV");
  AdmsSensFadType modelPar_PNIGBINV=mod.PNIGBINV;
  bool modelPar_given_PNIGBINV=mod.given("PNIGBINV");
  AdmsSensFadType modelPar_LAIGBACC=mod.LAIGBACC;
  bool modelPar_given_LAIGBACC=mod.given("LAIGBACC");
  AdmsSensFadType modelPar_NAIGBACC=mod.NAIGBACC;
  bool modelPar_given_NAIGBACC=mod.given("NAIGBACC");
  AdmsSensFadType modelPar_PAIGBACC=mod.PAIGBACC;
  bool modelPar_given_PAIGBACC=mod.given("PAIGBACC");
  AdmsSensFadType modelPar_LAIGBACC1=mod.LAIGBACC1;
  bool modelPar_given_LAIGBACC1=mod.given("LAIGBACC1");
  AdmsSensFadType modelPar_NAIGBACC1=mod.NAIGBACC1;
  bool modelPar_given_NAIGBACC1=mod.given("NAIGBACC1");
  AdmsSensFadType modelPar_PAIGBACC1=mod.PAIGBACC1;
  bool modelPar_given_PAIGBACC1=mod.given("PAIGBACC1");
  AdmsSensFadType modelPar_LBIGBACC=mod.LBIGBACC;
  bool modelPar_given_LBIGBACC=mod.given("LBIGBACC");
  AdmsSensFadType modelPar_NBIGBACC=mod.NBIGBACC;
  bool modelPar_given_NBIGBACC=mod.given("NBIGBACC");
  AdmsSensFadType modelPar_PBIGBACC=mod.PBIGBACC;
  bool modelPar_given_PBIGBACC=mod.given("PBIGBACC");
  AdmsSensFadType modelPar_LCIGBACC=mod.LCIGBACC;
  bool modelPar_given_LCIGBACC=mod.given("LCIGBACC");
  AdmsSensFadType modelPar_NCIGBACC=mod.NCIGBACC;
  bool modelPar_given_NCIGBACC=mod.given("NCIGBACC");
  AdmsSensFadType modelPar_PCIGBACC=mod.PCIGBACC;
  bool modelPar_given_PCIGBACC=mod.given("PCIGBACC");
  AdmsSensFadType modelPar_LNIGBACC=mod.LNIGBACC;
  bool modelPar_given_LNIGBACC=mod.given("LNIGBACC");
  AdmsSensFadType modelPar_NNIGBACC=mod.NNIGBACC;
  bool modelPar_given_NNIGBACC=mod.given("NNIGBACC");
  AdmsSensFadType modelPar_PNIGBACC=mod.PNIGBACC;
  bool modelPar_given_PNIGBACC=mod.given("PNIGBACC");
  AdmsSensFadType modelPar_LAIGC=mod.LAIGC;
  bool modelPar_given_LAIGC=mod.given("LAIGC");
  AdmsSensFadType modelPar_NAIGC=mod.NAIGC;
  bool modelPar_given_NAIGC=mod.given("NAIGC");
  AdmsSensFadType modelPar_PAIGC=mod.PAIGC;
  bool modelPar_given_PAIGC=mod.given("PAIGC");
  AdmsSensFadType modelPar_LAIGC1=mod.LAIGC1;
  bool modelPar_given_LAIGC1=mod.given("LAIGC1");
  AdmsSensFadType modelPar_NAIGC1=mod.NAIGC1;
  bool modelPar_given_NAIGC1=mod.given("NAIGC1");
  AdmsSensFadType modelPar_PAIGC1=mod.PAIGC1;
  bool modelPar_given_PAIGC1=mod.given("PAIGC1");
  AdmsSensFadType modelPar_LBIGC=mod.LBIGC;
  bool modelPar_given_LBIGC=mod.given("LBIGC");
  AdmsSensFadType modelPar_NBIGC=mod.NBIGC;
  bool modelPar_given_NBIGC=mod.given("NBIGC");
  AdmsSensFadType modelPar_PBIGC=mod.PBIGC;
  bool modelPar_given_PBIGC=mod.given("PBIGC");
  AdmsSensFadType modelPar_LCIGC=mod.LCIGC;
  bool modelPar_given_LCIGC=mod.given("LCIGC");
  AdmsSensFadType modelPar_NCIGC=mod.NCIGC;
  bool modelPar_given_NCIGC=mod.given("NCIGC");
  AdmsSensFadType modelPar_PCIGC=mod.PCIGC;
  bool modelPar_given_PCIGC=mod.given("PCIGC");
  AdmsSensFadType modelPar_LPIGCD=mod.LPIGCD;
  bool modelPar_given_LPIGCD=mod.given("LPIGCD");
  AdmsSensFadType modelPar_NPIGCD=mod.NPIGCD;
  bool modelPar_given_NPIGCD=mod.given("NPIGCD");
  AdmsSensFadType modelPar_PPIGCD=mod.PPIGCD;
  bool modelPar_given_PPIGCD=mod.given("PPIGCD");
  AdmsSensFadType modelPar_LAIGS=mod.LAIGS;
  bool modelPar_given_LAIGS=mod.given("LAIGS");
  AdmsSensFadType modelPar_NAIGS=mod.NAIGS;
  bool modelPar_given_NAIGS=mod.given("NAIGS");
  AdmsSensFadType modelPar_PAIGS=mod.PAIGS;
  bool modelPar_given_PAIGS=mod.given("PAIGS");
  AdmsSensFadType modelPar_LAIGS1=mod.LAIGS1;
  bool modelPar_given_LAIGS1=mod.given("LAIGS1");
  AdmsSensFadType modelPar_NAIGS1=mod.NAIGS1;
  bool modelPar_given_NAIGS1=mod.given("NAIGS1");
  AdmsSensFadType modelPar_PAIGS1=mod.PAIGS1;
  bool modelPar_given_PAIGS1=mod.given("PAIGS1");
  AdmsSensFadType modelPar_LBIGS=mod.LBIGS;
  bool modelPar_given_LBIGS=mod.given("LBIGS");
  AdmsSensFadType modelPar_NBIGS=mod.NBIGS;
  bool modelPar_given_NBIGS=mod.given("NBIGS");
  AdmsSensFadType modelPar_PBIGS=mod.PBIGS;
  bool modelPar_given_PBIGS=mod.given("PBIGS");
  AdmsSensFadType modelPar_LCIGS=mod.LCIGS;
  bool modelPar_given_LCIGS=mod.given("LCIGS");
  AdmsSensFadType modelPar_NCIGS=mod.NCIGS;
  bool modelPar_given_NCIGS=mod.given("NCIGS");
  AdmsSensFadType modelPar_PCIGS=mod.PCIGS;
  bool modelPar_given_PCIGS=mod.given("PCIGS");
  AdmsSensFadType modelPar_LAIGD=mod.LAIGD;
  bool modelPar_given_LAIGD=mod.given("LAIGD");
  AdmsSensFadType modelPar_NAIGD=mod.NAIGD;
  bool modelPar_given_NAIGD=mod.given("NAIGD");
  AdmsSensFadType modelPar_PAIGD=mod.PAIGD;
  bool modelPar_given_PAIGD=mod.given("PAIGD");
  AdmsSensFadType modelPar_LAIGD1=mod.LAIGD1;
  bool modelPar_given_LAIGD1=mod.given("LAIGD1");
  AdmsSensFadType modelPar_NAIGD1=mod.NAIGD1;
  bool modelPar_given_NAIGD1=mod.given("NAIGD1");
  AdmsSensFadType modelPar_PAIGD1=mod.PAIGD1;
  bool modelPar_given_PAIGD1=mod.given("PAIGD1");
  AdmsSensFadType modelPar_LBIGD=mod.LBIGD;
  bool modelPar_given_LBIGD=mod.given("LBIGD");
  AdmsSensFadType modelPar_NBIGD=mod.NBIGD;
  bool modelPar_given_NBIGD=mod.given("NBIGD");
  AdmsSensFadType modelPar_PBIGD=mod.PBIGD;
  bool modelPar_given_PBIGD=mod.given("PBIGD");
  AdmsSensFadType modelPar_LCIGD=mod.LCIGD;
  bool modelPar_given_LCIGD=mod.given("LCIGD");
  AdmsSensFadType modelPar_NCIGD=mod.NCIGD;
  bool modelPar_given_NCIGD=mod.given("NCIGD");
  AdmsSensFadType modelPar_PCIGD=mod.PCIGD;
  bool modelPar_given_PCIGD=mod.given("PCIGD");
  AdmsSensFadType modelPar_LNTOX=mod.LNTOX;
  bool modelPar_given_LNTOX=mod.given("LNTOX");
  AdmsSensFadType modelPar_NNTOX=mod.NNTOX;
  bool modelPar_given_NNTOX=mod.given("NNTOX");
  AdmsSensFadType modelPar_PNTOX=mod.PNTOX;
  bool modelPar_given_PNTOX=mod.given("PNTOX");
  AdmsSensFadType modelPar_LPOXEDGE=mod.LPOXEDGE;
  bool modelPar_given_LPOXEDGE=mod.given("LPOXEDGE");
  AdmsSensFadType modelPar_NPOXEDGE=mod.NPOXEDGE;
  bool modelPar_given_NPOXEDGE=mod.given("NPOXEDGE");
  AdmsSensFadType modelPar_PPOXEDGE=mod.PPOXEDGE;
  bool modelPar_given_PPOXEDGE=mod.given("PPOXEDGE");
  AdmsSensFadType modelPar_LAGISL=mod.LAGISL;
  bool modelPar_given_LAGISL=mod.given("LAGISL");
  AdmsSensFadType modelPar_NAGISL=mod.NAGISL;
  bool modelPar_given_NAGISL=mod.given("NAGISL");
  AdmsSensFadType modelPar_PAGISL=mod.PAGISL;
  bool modelPar_given_PAGISL=mod.given("PAGISL");
  AdmsSensFadType modelPar_LBGISL=mod.LBGISL;
  bool modelPar_given_LBGISL=mod.given("LBGISL");
  AdmsSensFadType modelPar_NBGISL=mod.NBGISL;
  bool modelPar_given_NBGISL=mod.given("NBGISL");
  AdmsSensFadType modelPar_PBGISL=mod.PBGISL;
  bool modelPar_given_PBGISL=mod.given("PBGISL");
  AdmsSensFadType modelPar_LCGISL=mod.LCGISL;
  bool modelPar_given_LCGISL=mod.given("LCGISL");
  AdmsSensFadType modelPar_NCGISL=mod.NCGISL;
  bool modelPar_given_NCGISL=mod.given("NCGISL");
  AdmsSensFadType modelPar_PCGISL=mod.PCGISL;
  bool modelPar_given_PCGISL=mod.given("PCGISL");
  AdmsSensFadType modelPar_LEGISL=mod.LEGISL;
  bool modelPar_given_LEGISL=mod.given("LEGISL");
  AdmsSensFadType modelPar_NEGISL=mod.NEGISL;
  bool modelPar_given_NEGISL=mod.given("NEGISL");
  AdmsSensFadType modelPar_PEGISL=mod.PEGISL;
  bool modelPar_given_PEGISL=mod.given("PEGISL");
  AdmsSensFadType modelPar_LPGISL=mod.LPGISL;
  bool modelPar_given_LPGISL=mod.given("LPGISL");
  AdmsSensFadType modelPar_NPGISL=mod.NPGISL;
  bool modelPar_given_NPGISL=mod.given("NPGISL");
  AdmsSensFadType modelPar_PPGISL=mod.PPGISL;
  bool modelPar_given_PPGISL=mod.given("PPGISL");
  AdmsSensFadType modelPar_LAGIDL=mod.LAGIDL;
  bool modelPar_given_LAGIDL=mod.given("LAGIDL");
  AdmsSensFadType modelPar_NAGIDL=mod.NAGIDL;
  bool modelPar_given_NAGIDL=mod.given("NAGIDL");
  AdmsSensFadType modelPar_PAGIDL=mod.PAGIDL;
  bool modelPar_given_PAGIDL=mod.given("PAGIDL");
  AdmsSensFadType modelPar_LBGIDL=mod.LBGIDL;
  bool modelPar_given_LBGIDL=mod.given("LBGIDL");
  AdmsSensFadType modelPar_NBGIDL=mod.NBGIDL;
  bool modelPar_given_NBGIDL=mod.given("NBGIDL");
  AdmsSensFadType modelPar_PBGIDL=mod.PBGIDL;
  bool modelPar_given_PBGIDL=mod.given("PBGIDL");
  AdmsSensFadType modelPar_LCGIDL=mod.LCGIDL;
  bool modelPar_given_LCGIDL=mod.given("LCGIDL");
  AdmsSensFadType modelPar_NCGIDL=mod.NCGIDL;
  bool modelPar_given_NCGIDL=mod.given("NCGIDL");
  AdmsSensFadType modelPar_PCGIDL=mod.PCGIDL;
  bool modelPar_given_PCGIDL=mod.given("PCGIDL");
  AdmsSensFadType modelPar_LEGIDL=mod.LEGIDL;
  bool modelPar_given_LEGIDL=mod.given("LEGIDL");
  AdmsSensFadType modelPar_NEGIDL=mod.NEGIDL;
  bool modelPar_given_NEGIDL=mod.given("NEGIDL");
  AdmsSensFadType modelPar_PEGIDL=mod.PEGIDL;
  bool modelPar_given_PEGIDL=mod.given("PEGIDL");
  AdmsSensFadType modelPar_LPGIDL=mod.LPGIDL;
  bool modelPar_given_LPGIDL=mod.given("LPGIDL");
  AdmsSensFadType modelPar_NPGIDL=mod.NPGIDL;
  bool modelPar_given_NPGIDL=mod.given("NPGIDL");
  AdmsSensFadType modelPar_PPGIDL=mod.PPGIDL;
  bool modelPar_given_PPGIDL=mod.given("PPGIDL");
  AdmsSensFadType modelPar_LALPHA0=mod.LALPHA0;
  bool modelPar_given_LALPHA0=mod.given("LALPHA0");
  AdmsSensFadType modelPar_NALPHA0=mod.NALPHA0;
  bool modelPar_given_NALPHA0=mod.given("NALPHA0");
  AdmsSensFadType modelPar_PALPHA0=mod.PALPHA0;
  bool modelPar_given_PALPHA0=mod.given("PALPHA0");
  AdmsSensFadType modelPar_LALPHA1=mod.LALPHA1;
  bool modelPar_given_LALPHA1=mod.given("LALPHA1");
  AdmsSensFadType modelPar_NALPHA1=mod.NALPHA1;
  bool modelPar_given_NALPHA1=mod.given("NALPHA1");
  AdmsSensFadType modelPar_PALPHA1=mod.PALPHA1;
  bool modelPar_given_PALPHA1=mod.given("PALPHA1");
  AdmsSensFadType modelPar_LALPHAII0=mod.LALPHAII0;
  bool modelPar_given_LALPHAII0=mod.given("LALPHAII0");
  AdmsSensFadType modelPar_NALPHAII0=mod.NALPHAII0;
  bool modelPar_given_NALPHAII0=mod.given("NALPHAII0");
  AdmsSensFadType modelPar_PALPHAII0=mod.PALPHAII0;
  bool modelPar_given_PALPHAII0=mod.given("PALPHAII0");
  AdmsSensFadType modelPar_LALPHAII1=mod.LALPHAII1;
  bool modelPar_given_LALPHAII1=mod.given("LALPHAII1");
  AdmsSensFadType modelPar_NALPHAII1=mod.NALPHAII1;
  bool modelPar_given_NALPHAII1=mod.given("NALPHAII1");
  AdmsSensFadType modelPar_PALPHAII1=mod.PALPHAII1;
  bool modelPar_given_PALPHAII1=mod.given("PALPHAII1");
  AdmsSensFadType modelPar_LBETA0=mod.LBETA0;
  bool modelPar_given_LBETA0=mod.given("LBETA0");
  AdmsSensFadType modelPar_NBETA0=mod.NBETA0;
  bool modelPar_given_NBETA0=mod.given("NBETA0");
  AdmsSensFadType modelPar_PBETA0=mod.PBETA0;
  bool modelPar_given_PBETA0=mod.given("PBETA0");
  AdmsSensFadType modelPar_LBETAII0=mod.LBETAII0;
  bool modelPar_given_LBETAII0=mod.given("LBETAII0");
  AdmsSensFadType modelPar_NBETAII0=mod.NBETAII0;
  bool modelPar_given_NBETAII0=mod.given("NBETAII0");
  AdmsSensFadType modelPar_PBETAII0=mod.PBETAII0;
  bool modelPar_given_PBETAII0=mod.given("PBETAII0");
  AdmsSensFadType modelPar_LBETAII1=mod.LBETAII1;
  bool modelPar_given_LBETAII1=mod.given("LBETAII1");
  AdmsSensFadType modelPar_NBETAII1=mod.NBETAII1;
  bool modelPar_given_NBETAII1=mod.given("NBETAII1");
  AdmsSensFadType modelPar_PBETAII1=mod.PBETAII1;
  bool modelPar_given_PBETAII1=mod.given("PBETAII1");
  AdmsSensFadType modelPar_LBETAII2=mod.LBETAII2;
  bool modelPar_given_LBETAII2=mod.given("LBETAII2");
  AdmsSensFadType modelPar_NBETAII2=mod.NBETAII2;
  bool modelPar_given_NBETAII2=mod.given("NBETAII2");
  AdmsSensFadType modelPar_PBETAII2=mod.PBETAII2;
  bool modelPar_given_PBETAII2=mod.given("PBETAII2");
  AdmsSensFadType modelPar_LESATII=mod.LESATII;
  bool modelPar_given_LESATII=mod.given("LESATII");
  AdmsSensFadType modelPar_NESATII=mod.NESATII;
  bool modelPar_given_NESATII=mod.given("NESATII");
  AdmsSensFadType modelPar_PESATII=mod.PESATII;
  bool modelPar_given_PESATII=mod.given("PESATII");
  AdmsSensFadType modelPar_LLII=mod.LLII;
  bool modelPar_given_LLII=mod.given("LLII");
  AdmsSensFadType modelPar_NLII=mod.NLII;
  bool modelPar_given_NLII=mod.given("NLII");
  AdmsSensFadType modelPar_PLII=mod.PLII;
  bool modelPar_given_PLII=mod.given("PLII");
  AdmsSensFadType modelPar_LSII0=mod.LSII0;
  bool modelPar_given_LSII0=mod.given("LSII0");
  AdmsSensFadType modelPar_NSII0=mod.NSII0;
  bool modelPar_given_NSII0=mod.given("NSII0");
  AdmsSensFadType modelPar_PSII0=mod.PSII0;
  bool modelPar_given_PSII0=mod.given("PSII0");
  AdmsSensFadType modelPar_LSII1=mod.LSII1;
  bool modelPar_given_LSII1=mod.given("LSII1");
  AdmsSensFadType modelPar_NSII1=mod.NSII1;
  bool modelPar_given_NSII1=mod.given("NSII1");
  AdmsSensFadType modelPar_PSII1=mod.PSII1;
  bool modelPar_given_PSII1=mod.given("PSII1");
  AdmsSensFadType modelPar_LSII2=mod.LSII2;
  bool modelPar_given_LSII2=mod.given("LSII2");
  AdmsSensFadType modelPar_NSII2=mod.NSII2;
  bool modelPar_given_NSII2=mod.given("NSII2");
  AdmsSensFadType modelPar_PSII2=mod.PSII2;
  bool modelPar_given_PSII2=mod.given("PSII2");
  AdmsSensFadType modelPar_LSIID=mod.LSIID;
  bool modelPar_given_LSIID=mod.given("LSIID");
  AdmsSensFadType modelPar_NSIID=mod.NSIID;
  bool modelPar_given_NSIID=mod.given("NSIID");
  AdmsSensFadType modelPar_PSIID=mod.PSIID;
  bool modelPar_given_PSIID=mod.given("PSIID");
  AdmsSensFadType modelPar_LCFS=mod.LCFS;
  bool modelPar_given_LCFS=mod.given("LCFS");
  AdmsSensFadType modelPar_NCFS=mod.NCFS;
  bool modelPar_given_NCFS=mod.given("NCFS");
  AdmsSensFadType modelPar_PCFS=mod.PCFS;
  bool modelPar_given_PCFS=mod.given("PCFS");
  AdmsSensFadType modelPar_LCFD=mod.LCFD;
  bool modelPar_given_LCFD=mod.given("LCFD");
  AdmsSensFadType modelPar_NCFD=mod.NCFD;
  bool modelPar_given_NCFD=mod.given("NCFD");
  AdmsSensFadType modelPar_PCFD=mod.PCFD;
  bool modelPar_given_PCFD=mod.given("PCFD");
  AdmsSensFadType modelPar_LCOVS=mod.LCOVS;
  bool modelPar_given_LCOVS=mod.given("LCOVS");
  AdmsSensFadType modelPar_NCOVS=mod.NCOVS;
  bool modelPar_given_NCOVS=mod.given("NCOVS");
  AdmsSensFadType modelPar_PCOVS=mod.PCOVS;
  bool modelPar_given_PCOVS=mod.given("PCOVS");
  AdmsSensFadType modelPar_LCOVD=mod.LCOVD;
  bool modelPar_given_LCOVD=mod.given("LCOVD");
  AdmsSensFadType modelPar_NCOVD=mod.NCOVD;
  bool modelPar_given_NCOVD=mod.given("NCOVD");
  AdmsSensFadType modelPar_PCOVD=mod.PCOVD;
  bool modelPar_given_PCOVD=mod.given("PCOVD");
  AdmsSensFadType modelPar_LCGSL=mod.LCGSL;
  bool modelPar_given_LCGSL=mod.given("LCGSL");
  AdmsSensFadType modelPar_NCGSL=mod.NCGSL;
  bool modelPar_given_NCGSL=mod.given("NCGSL");
  AdmsSensFadType modelPar_PCGSL=mod.PCGSL;
  bool modelPar_given_PCGSL=mod.given("PCGSL");
  AdmsSensFadType modelPar_LCGDL=mod.LCGDL;
  bool modelPar_given_LCGDL=mod.given("LCGDL");
  AdmsSensFadType modelPar_NCGDL=mod.NCGDL;
  bool modelPar_given_NCGDL=mod.given("NCGDL");
  AdmsSensFadType modelPar_PCGDL=mod.PCGDL;
  bool modelPar_given_PCGDL=mod.given("PCGDL");
  AdmsSensFadType modelPar_LCKAPPAS=mod.LCKAPPAS;
  bool modelPar_given_LCKAPPAS=mod.given("LCKAPPAS");
  AdmsSensFadType modelPar_NCKAPPAS=mod.NCKAPPAS;
  bool modelPar_given_NCKAPPAS=mod.given("NCKAPPAS");
  AdmsSensFadType modelPar_PCKAPPAS=mod.PCKAPPAS;
  bool modelPar_given_PCKAPPAS=mod.given("PCKAPPAS");
  AdmsSensFadType modelPar_LCKAPPAD=mod.LCKAPPAD;
  bool modelPar_given_LCKAPPAD=mod.given("LCKAPPAD");
  AdmsSensFadType modelPar_NCKAPPAD=mod.NCKAPPAD;
  bool modelPar_given_NCKAPPAD=mod.given("NCKAPPAD");
  AdmsSensFadType modelPar_PCKAPPAD=mod.PCKAPPAD;
  bool modelPar_given_PCKAPPAD=mod.given("PCKAPPAD");
  AdmsSensFadType modelPar_LCGBL=mod.LCGBL;
  bool modelPar_given_LCGBL=mod.given("LCGBL");
  AdmsSensFadType modelPar_NCGBL=mod.NCGBL;
  bool modelPar_given_NCGBL=mod.given("NCGBL");
  AdmsSensFadType modelPar_PCGBL=mod.PCGBL;
  bool modelPar_given_PCGBL=mod.given("PCGBL");
  AdmsSensFadType modelPar_LCKAPPAB=mod.LCKAPPAB;
  bool modelPar_given_LCKAPPAB=mod.given("LCKAPPAB");
  AdmsSensFadType modelPar_NCKAPPAB=mod.NCKAPPAB;
  bool modelPar_given_NCKAPPAB=mod.given("NCKAPPAB");
  AdmsSensFadType modelPar_PCKAPPAB=mod.PCKAPPAB;
  bool modelPar_given_PCKAPPAB=mod.given("PCKAPPAB");
  AdmsSensFadType modelPar_LNTGEN=mod.LNTGEN;
  bool modelPar_given_LNTGEN=mod.given("LNTGEN");
  AdmsSensFadType modelPar_NNTGEN=mod.NNTGEN;
  bool modelPar_given_NNTGEN=mod.given("NNTGEN");
  AdmsSensFadType modelPar_PNTGEN=mod.PNTGEN;
  bool modelPar_given_PNTGEN=mod.given("PNTGEN");
  AdmsSensFadType modelPar_LAIGEN=mod.LAIGEN;
  bool modelPar_given_LAIGEN=mod.given("LAIGEN");
  AdmsSensFadType modelPar_NAIGEN=mod.NAIGEN;
  bool modelPar_given_NAIGEN=mod.given("NAIGEN");
  AdmsSensFadType modelPar_PAIGEN=mod.PAIGEN;
  bool modelPar_given_PAIGEN=mod.given("PAIGEN");
  AdmsSensFadType modelPar_LBIGEN=mod.LBIGEN;
  bool modelPar_given_LBIGEN=mod.given("LBIGEN");
  AdmsSensFadType modelPar_NBIGEN=mod.NBIGEN;
  bool modelPar_given_NBIGEN=mod.given("NBIGEN");
  AdmsSensFadType modelPar_PBIGEN=mod.PBIGEN;
  bool modelPar_given_PBIGEN=mod.given("PBIGEN");
  AdmsSensFadType modelPar_LXRCRG1=mod.LXRCRG1;
  bool modelPar_given_LXRCRG1=mod.given("LXRCRG1");
  AdmsSensFadType modelPar_NXRCRG1=mod.NXRCRG1;
  bool modelPar_given_NXRCRG1=mod.given("NXRCRG1");
  AdmsSensFadType modelPar_PXRCRG1=mod.PXRCRG1;
  bool modelPar_given_PXRCRG1=mod.given("PXRCRG1");
  AdmsSensFadType modelPar_LXRCRG2=mod.LXRCRG2;
  bool modelPar_given_LXRCRG2=mod.given("LXRCRG2");
  AdmsSensFadType modelPar_NXRCRG2=mod.NXRCRG2;
  bool modelPar_given_NXRCRG2=mod.given("NXRCRG2");
  AdmsSensFadType modelPar_PXRCRG2=mod.PXRCRG2;
  bool modelPar_given_PXRCRG2=mod.given("PXRCRG2");
  AdmsSensFadType modelPar_LUTE=mod.LUTE;
  bool modelPar_given_LUTE=mod.given("LUTE");
  AdmsSensFadType modelPar_NUTE=mod.NUTE;
  bool modelPar_given_NUTE=mod.given("NUTE");
  AdmsSensFadType modelPar_PUTE=mod.PUTE;
  bool modelPar_given_PUTE=mod.given("PUTE");
  AdmsSensFadType modelPar_LUTER=mod.LUTER;
  bool modelPar_given_LUTER=mod.given("LUTER");
  AdmsSensFadType modelPar_NUTER=mod.NUTER;
  bool modelPar_given_NUTER=mod.given("NUTER");
  AdmsSensFadType modelPar_PUTER=mod.PUTER;
  bool modelPar_given_PUTER=mod.given("PUTER");
  AdmsSensFadType modelPar_LUTL=mod.LUTL;
  bool modelPar_given_LUTL=mod.given("LUTL");
  AdmsSensFadType modelPar_NUTL=mod.NUTL;
  bool modelPar_given_NUTL=mod.given("NUTL");
  AdmsSensFadType modelPar_PUTL=mod.PUTL;
  bool modelPar_given_PUTL=mod.given("PUTL");
  AdmsSensFadType modelPar_LUTLR=mod.LUTLR;
  bool modelPar_given_LUTLR=mod.given("LUTLR");
  AdmsSensFadType modelPar_NUTLR=mod.NUTLR;
  bool modelPar_given_NUTLR=mod.given("NUTLR");
  AdmsSensFadType modelPar_PUTLR=mod.PUTLR;
  bool modelPar_given_PUTLR=mod.given("PUTLR");
  AdmsSensFadType modelPar_LEMOBT=mod.LEMOBT;
  bool modelPar_given_LEMOBT=mod.given("LEMOBT");
  AdmsSensFadType modelPar_NEMOBT=mod.NEMOBT;
  bool modelPar_given_NEMOBT=mod.given("NEMOBT");
  AdmsSensFadType modelPar_PEMOBT=mod.PEMOBT;
  bool modelPar_given_PEMOBT=mod.given("PEMOBT");
  AdmsSensFadType modelPar_LUA1=mod.LUA1;
  bool modelPar_given_LUA1=mod.given("LUA1");
  AdmsSensFadType modelPar_NUA1=mod.NUA1;
  bool modelPar_given_NUA1=mod.given("NUA1");
  AdmsSensFadType modelPar_PUA1=mod.PUA1;
  bool modelPar_given_PUA1=mod.given("PUA1");
  AdmsSensFadType modelPar_LUA1R=mod.LUA1R;
  bool modelPar_given_LUA1R=mod.given("LUA1R");
  AdmsSensFadType modelPar_NUA1R=mod.NUA1R;
  bool modelPar_given_NUA1R=mod.given("NUA1R");
  AdmsSensFadType modelPar_PUA1R=mod.PUA1R;
  bool modelPar_given_PUA1R=mod.given("PUA1R");
  AdmsSensFadType modelPar_LUC1=mod.LUC1;
  bool modelPar_given_LUC1=mod.given("LUC1");
  AdmsSensFadType modelPar_NUC1=mod.NUC1;
  bool modelPar_given_NUC1=mod.given("NUC1");
  AdmsSensFadType modelPar_PUC1=mod.PUC1;
  bool modelPar_given_PUC1=mod.given("PUC1");
  AdmsSensFadType modelPar_LUC1R=mod.LUC1R;
  bool modelPar_given_LUC1R=mod.given("LUC1R");
  AdmsSensFadType modelPar_NUC1R=mod.NUC1R;
  bool modelPar_given_NUC1R=mod.given("NUC1R");
  AdmsSensFadType modelPar_PUC1R=mod.PUC1R;
  bool modelPar_given_PUC1R=mod.given("PUC1R");
  AdmsSensFadType modelPar_LUD1=mod.LUD1;
  bool modelPar_given_LUD1=mod.given("LUD1");
  AdmsSensFadType modelPar_NUD1=mod.NUD1;
  bool modelPar_given_NUD1=mod.given("NUD1");
  AdmsSensFadType modelPar_PUD1=mod.PUD1;
  bool modelPar_given_PUD1=mod.given("PUD1");
  AdmsSensFadType modelPar_LUD1R=mod.LUD1R;
  bool modelPar_given_LUD1R=mod.given("LUD1R");
  AdmsSensFadType modelPar_NUD1R=mod.NUD1R;
  bool modelPar_given_NUD1R=mod.given("NUD1R");
  AdmsSensFadType modelPar_PUD1R=mod.PUD1R;
  bool modelPar_given_PUD1R=mod.given("PUD1R");
  AdmsSensFadType modelPar_LUCSTE=mod.LUCSTE;
  bool modelPar_given_LUCSTE=mod.given("LUCSTE");
  AdmsSensFadType modelPar_NUCSTE=mod.NUCSTE;
  bool modelPar_given_NUCSTE=mod.given("NUCSTE");
  AdmsSensFadType modelPar_PUCSTE=mod.PUCSTE;
  bool modelPar_given_PUCSTE=mod.given("PUCSTE");
  AdmsSensFadType modelPar_LPTWGT=mod.LPTWGT;
  bool modelPar_given_LPTWGT=mod.given("LPTWGT");
  AdmsSensFadType modelPar_NPTWGT=mod.NPTWGT;
  bool modelPar_given_NPTWGT=mod.given("NPTWGT");
  AdmsSensFadType modelPar_PPTWGT=mod.PPTWGT;
  bool modelPar_given_PPTWGT=mod.given("PPTWGT");
  AdmsSensFadType modelPar_LAT=mod.LAT;
  bool modelPar_given_LAT=mod.given("LAT");
  AdmsSensFadType modelPar_NAT=mod.NAT;
  bool modelPar_given_NAT=mod.given("NAT");
  AdmsSensFadType modelPar_PAT=mod.PAT;
  bool modelPar_given_PAT=mod.given("PAT");
  AdmsSensFadType modelPar_LATR=mod.LATR;
  bool modelPar_given_LATR=mod.given("LATR");
  AdmsSensFadType modelPar_NATR=mod.NATR;
  bool modelPar_given_NATR=mod.given("NATR");
  AdmsSensFadType modelPar_PATR=mod.PATR;
  bool modelPar_given_PATR=mod.given("PATR");
  AdmsSensFadType modelPar_LATCV=mod.LATCV;
  bool modelPar_given_LATCV=mod.given("LATCV");
  AdmsSensFadType modelPar_NATCV=mod.NATCV;
  bool modelPar_given_NATCV=mod.given("NATCV");
  AdmsSensFadType modelPar_PATCV=mod.PATCV;
  bool modelPar_given_PATCV=mod.given("PATCV");
  AdmsSensFadType modelPar_LSTTHETASAT=mod.LSTTHETASAT;
  bool modelPar_given_LSTTHETASAT=mod.given("LSTTHETASAT");
  AdmsSensFadType modelPar_NSTTHETASAT=mod.NSTTHETASAT;
  bool modelPar_given_NSTTHETASAT=mod.given("NSTTHETASAT");
  AdmsSensFadType modelPar_PSTTHETASAT=mod.PSTTHETASAT;
  bool modelPar_given_PSTTHETASAT=mod.given("PSTTHETASAT");
  AdmsSensFadType modelPar_LPRT=mod.LPRT;
  bool modelPar_given_LPRT=mod.given("LPRT");
  AdmsSensFadType modelPar_NPRT=mod.NPRT;
  bool modelPar_given_NPRT=mod.given("NPRT");
  AdmsSensFadType modelPar_PPRT=mod.PPRT;
  bool modelPar_given_PPRT=mod.given("PPRT");
  AdmsSensFadType modelPar_LKT1=mod.LKT1;
  bool modelPar_given_LKT1=mod.given("LKT1");
  AdmsSensFadType modelPar_NKT1=mod.NKT1;
  bool modelPar_given_NKT1=mod.given("NKT1");
  AdmsSensFadType modelPar_PKT1=mod.PKT1;
  bool modelPar_given_PKT1=mod.given("PKT1");
  AdmsSensFadType modelPar_LTSS=mod.LTSS;
  bool modelPar_given_LTSS=mod.given("LTSS");
  AdmsSensFadType modelPar_NTSS=mod.NTSS;
  bool modelPar_given_NTSS=mod.given("NTSS");
  AdmsSensFadType modelPar_PTSS=mod.PTSS;
  bool modelPar_given_PTSS=mod.given("PTSS");
  AdmsSensFadType modelPar_LIIT=mod.LIIT;
  bool modelPar_given_LIIT=mod.given("LIIT");
  AdmsSensFadType modelPar_NIIT=mod.NIIT;
  bool modelPar_given_NIIT=mod.given("NIIT");
  AdmsSensFadType modelPar_PIIT=mod.PIIT;
  bool modelPar_given_PIIT=mod.given("PIIT");
  AdmsSensFadType modelPar_LTII=mod.LTII;
  bool modelPar_given_LTII=mod.given("LTII");
  AdmsSensFadType modelPar_NTII=mod.NTII;
  bool modelPar_given_NTII=mod.given("NTII");
  AdmsSensFadType modelPar_PTII=mod.PTII;
  bool modelPar_given_PTII=mod.given("PTII");
  AdmsSensFadType modelPar_LTGIDL=mod.LTGIDL;
  bool modelPar_given_LTGIDL=mod.given("LTGIDL");
  AdmsSensFadType modelPar_NTGIDL=mod.NTGIDL;
  bool modelPar_given_NTGIDL=mod.given("NTGIDL");
  AdmsSensFadType modelPar_PTGIDL=mod.PTGIDL;
  bool modelPar_given_PTGIDL=mod.given("PTGIDL");
  AdmsSensFadType modelPar_LIGT=mod.LIGT;
  bool modelPar_given_LIGT=mod.given("LIGT");
  AdmsSensFadType modelPar_NIGT=mod.NIGT;
  bool modelPar_given_NIGT=mod.given("NIGT");
  AdmsSensFadType modelPar_PIGT=mod.PIGT;
  bool modelPar_given_PIGT=mod.given("PIGT");


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_NF=mod.NF;
  bool modelPar_given_NF=mod.given("NF");
  int modelPar_NGCON=mod.NGCON;
  bool modelPar_given_NGCON=mod.given("NGCON");
  int modelPar_DEVTYPE=mod.DEVTYPE;
  bool modelPar_given_DEVTYPE=mod.given("DEVTYPE");
  int modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");
  int modelPar_BULKMOD=mod.BULKMOD;
  bool modelPar_given_BULKMOD=mod.given("BULKMOD");
  int modelPar_GEOMOD=mod.GEOMOD;
  bool modelPar_given_GEOMOD=mod.given("GEOMOD");
  int modelPar_CGEO1SW=mod.CGEO1SW;
  bool modelPar_given_CGEO1SW=mod.given("CGEO1SW");
  int modelPar_RDSMOD=mod.RDSMOD;
  bool modelPar_given_RDSMOD=mod.given("RDSMOD");
  int modelPar_ASYMMOD=mod.ASYMMOD;
  bool modelPar_given_ASYMMOD=mod.given("ASYMMOD");
  int modelPar_IGCMOD=mod.IGCMOD;
  bool modelPar_given_IGCMOD=mod.given("IGCMOD");
  int modelPar_IGBMOD=mod.IGBMOD;
  bool modelPar_given_IGBMOD=mod.given("IGBMOD");
  int modelPar_GIDLMOD=mod.GIDLMOD;
  bool modelPar_given_GIDLMOD=mod.given("GIDLMOD");
  int modelPar_IIMOD=mod.IIMOD;
  bool modelPar_given_IIMOD=mod.given("IIMOD");
  int modelPar_TNOIMOD=mod.TNOIMOD;
  bool modelPar_given_TNOIMOD=mod.given("TNOIMOD");
  int modelPar_NQSMOD=mod.NQSMOD;
  bool modelPar_given_NQSMOD=mod.given("NQSMOD");
  int modelPar_SHMOD=mod.SHMOD;
  bool modelPar_given_SHMOD=mod.given("SHMOD");
  int modelPar_TEMPMOD=mod.TEMPMOD;
  bool modelPar_given_TEMPMOD=mod.given("TEMPMOD");
  int modelPar_RGATEMOD=mod.RGATEMOD;
  bool modelPar_given_RGATEMOD=mod.given("RGATEMOD");
  int modelPar_RGEOMOD=mod.RGEOMOD;
  bool modelPar_given_RGEOMOD=mod.given("RGEOMOD");
  int modelPar_CGEOMOD=mod.CGEOMOD;
  bool modelPar_given_CGEOMOD=mod.given("CGEOMOD");
  int modelPar_SH_WARN=mod.SH_WARN;
  bool modelPar_given_SH_WARN=mod.given("SH_WARN");
  int modelPar_IGCLAMP=mod.IGCLAMP;
  bool modelPar_given_IGCLAMP=mod.given("IGCLAMP");
  int modelPar_SDTERM=mod.SDTERM;
  bool modelPar_given_SDTERM=mod.given("SDTERM");
  int modelPar_NSEG=mod.NSEG;
  bool modelPar_given_NSEG=mod.given("NSEG");



  // Copy out all the instance parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> inParamMap;

  // reals
  AdmsSensFadType instancePar_L=in.L;
  bool instancePar_given_L=in.given("L");
  inParamMap["L"] = &instancePar_L;
  AdmsSensFadType instancePar_D=in.D;
  bool instancePar_given_D=in.given("D");
  inParamMap["D"] = &instancePar_D;
  AdmsSensFadType instancePar_TFIN=in.TFIN;
  bool instancePar_given_TFIN=in.given("TFIN");
  inParamMap["TFIN"] = &instancePar_TFIN;
  AdmsSensFadType instancePar_FPITCH=in.FPITCH;
  bool instancePar_given_FPITCH=in.given("FPITCH");
  inParamMap["FPITCH"] = &instancePar_FPITCH;
  AdmsSensFadType instancePar_NFIN=in.NFIN;
  bool instancePar_given_NFIN=in.given("NFIN");
  inParamMap["NFIN"] = &instancePar_NFIN;
  AdmsSensFadType instancePar_ASEO=in.ASEO;
  bool instancePar_given_ASEO=in.given("ASEO");
  inParamMap["ASEO"] = &instancePar_ASEO;
  AdmsSensFadType instancePar_ADEO=in.ADEO;
  bool instancePar_given_ADEO=in.given("ADEO");
  inParamMap["ADEO"] = &instancePar_ADEO;
  AdmsSensFadType instancePar_PSEO=in.PSEO;
  bool instancePar_given_PSEO=in.given("PSEO");
  inParamMap["PSEO"] = &instancePar_PSEO;
  AdmsSensFadType instancePar_PDEO=in.PDEO;
  bool instancePar_given_PDEO=in.given("PDEO");
  inParamMap["PDEO"] = &instancePar_PDEO;
  AdmsSensFadType instancePar_ASEJ=in.ASEJ;
  bool instancePar_given_ASEJ=in.given("ASEJ");
  inParamMap["ASEJ"] = &instancePar_ASEJ;
  AdmsSensFadType instancePar_ADEJ=in.ADEJ;
  bool instancePar_given_ADEJ=in.given("ADEJ");
  inParamMap["ADEJ"] = &instancePar_ADEJ;
  AdmsSensFadType instancePar_PSEJ=in.PSEJ;
  bool instancePar_given_PSEJ=in.given("PSEJ");
  inParamMap["PSEJ"] = &instancePar_PSEJ;
  AdmsSensFadType instancePar_PDEJ=in.PDEJ;
  bool instancePar_given_PDEJ=in.given("PDEJ");
  inParamMap["PDEJ"] = &instancePar_PDEJ;
  AdmsSensFadType instancePar_COVS=in.COVS;
  bool instancePar_given_COVS=in.given("COVS");
  inParamMap["COVS"] = &instancePar_COVS;
  AdmsSensFadType instancePar_COVD=in.COVD;
  bool instancePar_given_COVD=in.given("COVD");
  inParamMap["COVD"] = &instancePar_COVD;
  AdmsSensFadType instancePar_CGSP=in.CGSP;
  bool instancePar_given_CGSP=in.given("CGSP");
  inParamMap["CGSP"] = &instancePar_CGSP;
  AdmsSensFadType instancePar_CGDP=in.CGDP;
  bool instancePar_given_CGDP=in.given("CGDP");
  inParamMap["CGDP"] = &instancePar_CGDP;
  AdmsSensFadType instancePar_CDSP=in.CDSP;
  bool instancePar_given_CDSP=in.given("CDSP");
  inParamMap["CDSP"] = &instancePar_CDSP;
  AdmsSensFadType instancePar_NRS=in.NRS;
  bool instancePar_given_NRS=in.given("NRS");
  inParamMap["NRS"] = &instancePar_NRS;
  AdmsSensFadType instancePar_NRD=in.NRD;
  bool instancePar_given_NRD=in.given("NRD");
  inParamMap["NRD"] = &instancePar_NRD;
  AdmsSensFadType instancePar_LRSD=in.LRSD;
  bool instancePar_given_LRSD=in.given("LRSD");
  inParamMap["LRSD"] = &instancePar_LRSD;
  AdmsSensFadType instancePar_NFINNOM=in.NFINNOM;
  bool instancePar_given_NFINNOM=in.given("NFINNOM");
  inParamMap["NFINNOM"] = &instancePar_NFINNOM;
  AdmsSensFadType instancePar_m=in.m;
  bool instancePar_given_m=in.given("m");
  inParamMap["m"] = &instancePar_m;


  // Copy all the real hidden instance params into fad types



  // Copy all the non-real instance params into vars of their appropriate type:
  int instancePar_NF=in.NF;
  bool instancePar_given_NF=in.given("NF");
  int instancePar_NGCON=in.NGCON;
  bool instancePar_given_NGCON=in.given("NGCON");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check the name first, otherwise segfault on invalid name!
  inParamMap[name]->diff(0,1);

  //make local copies of all instance vars
  //reals
  AdmsSensFadType instanceVar_NFINtotal=in.NFINtotal;
  AdmsSensFadType instanceVar_ids=in.ids;
  AdmsSensFadType instanceVar_sigvds=in.sigvds;
  AdmsSensFadType instanceVar_qd=in.qd;
  AdmsSensFadType instanceVar_qg=in.qg;
  AdmsSensFadType instanceVar_qs=in.qs;
  AdmsSensFadType instanceVar_qb=in.qb;
  AdmsSensFadType instanceVar_epssub=in.epssub;
  AdmsSensFadType instanceVar_epsratio=in.epsratio;
  AdmsSensFadType instanceVar_Leff=in.Leff;
  AdmsSensFadType instanceVar_LeffCV=in.LeffCV;
  AdmsSensFadType instanceVar_LeffCV_acc=in.LeffCV_acc;
  AdmsSensFadType instanceVar_Weff0=in.Weff0;
  AdmsSensFadType instanceVar_WeffCV0=in.WeffCV0;
  AdmsSensFadType instanceVar_cox=in.cox;
  AdmsSensFadType instanceVar_nbody=in.nbody;
  AdmsSensFadType instanceVar_T0=in.T0;
  AdmsSensFadType instanceVar_T1=in.T1;
  AdmsSensFadType instanceVar_T2=in.T2;
  AdmsSensFadType instanceVar_T3=in.T3;
  AdmsSensFadType instanceVar_Tnom=in.Tnom;
  AdmsSensFadType instanceVar_PTWGR_t=in.PTWGR_t;
  AdmsSensFadType instanceVar_CJS_t=in.CJS_t;
  AdmsSensFadType instanceVar_CJSWS_t=in.CJSWS_t;
  AdmsSensFadType instanceVar_CJSWGD_t=in.CJSWGD_t;
  AdmsSensFadType instanceVar_CJD_t=in.CJD_t;
  AdmsSensFadType instanceVar_CJSWD_t=in.CJSWD_t;
  AdmsSensFadType instanceVar_CJSWGS_t=in.CJSWGS_t;
  AdmsSensFadType instanceVar_PBS_t=in.PBS_t;
  AdmsSensFadType instanceVar_PBSWS_t=in.PBSWS_t;
  AdmsSensFadType instanceVar_PBSWGS_t=in.PBSWGS_t;
  AdmsSensFadType instanceVar_PBD_t=in.PBD_t;
  AdmsSensFadType instanceVar_PBSWD_t=in.PBSWD_t;
  AdmsSensFadType instanceVar_PBSWGD_t=in.PBSWGD_t;
  AdmsSensFadType instanceVar_JSS_t=in.JSS_t;
  AdmsSensFadType instanceVar_JSWS_t=in.JSWS_t;
  AdmsSensFadType instanceVar_JSWGS_t=in.JSWGS_t;
  AdmsSensFadType instanceVar_JSD_t=in.JSD_t;
  AdmsSensFadType instanceVar_JSWD_t=in.JSWD_t;
  AdmsSensFadType instanceVar_JSWGD_t=in.JSWGD_t;
  AdmsSensFadType instanceVar_JTSS_t=in.JTSS_t;
  AdmsSensFadType instanceVar_JTSD_t=in.JTSD_t;
  AdmsSensFadType instanceVar_JTSSWS_t=in.JTSSWS_t;
  AdmsSensFadType instanceVar_JTSSWD_t=in.JTSSWD_t;
  AdmsSensFadType instanceVar_JTSSWGS_t=in.JTSSWGS_t;
  AdmsSensFadType instanceVar_JTSSWGD_t=in.JTSSWGD_t;
  AdmsSensFadType instanceVar_NJTS_t=in.NJTS_t;
  AdmsSensFadType instanceVar_NJTSD_t=in.NJTSD_t;
  AdmsSensFadType instanceVar_NJTSSW_t=in.NJTSSW_t;
  AdmsSensFadType instanceVar_NJTSSWD_t=in.NJTSSWD_t;
  AdmsSensFadType instanceVar_NJTSSWG_t=in.NJTSSWG_t;
  AdmsSensFadType instanceVar_NJTSSWGD_t=in.NJTSSWGD_t;
  AdmsSensFadType instanceVar_q0=in.q0;
  AdmsSensFadType instanceVar_T11=in.T11;
  AdmsSensFadType instanceVar_T12=in.T12;
  AdmsSensFadType instanceVar_e0=in.e0;
  AdmsSensFadType instanceVar_e1=in.e1;
  AdmsSensFadType instanceVar_e2=in.e2;
  AdmsSensFadType instanceVar_scl=in.scl;
  AdmsSensFadType instanceVar_tmp=in.tmp;
  AdmsSensFadType instanceVar_Theta_SCE=in.Theta_SCE;
  AdmsSensFadType instanceVar_Theta_SW=in.Theta_SW;
  AdmsSensFadType instanceVar_Theta_DIBL=in.Theta_DIBL;
  AdmsSensFadType instanceVar_Theta_RSCE=in.Theta_RSCE;
  AdmsSensFadType instanceVar_Theta_DITS=in.Theta_DITS;
  AdmsSensFadType instanceVar_veseff=in.veseff;
  AdmsSensFadType instanceVar_Tcen0=in.Tcen0;
  AdmsSensFadType instanceVar_Tcen=in.Tcen;
  AdmsSensFadType instanceVar_mx=in.mx;
  AdmsSensFadType instanceVar_mxprime=in.mxprime;
  AdmsSensFadType instanceVar_md=in.md;
  AdmsSensFadType instanceVar_mdprime=in.mdprime;
  AdmsSensFadType instanceVar_gprime=in.gprime;
  AdmsSensFadType instanceVar_gfactor=in.gfactor;
  AdmsSensFadType instanceVar_qis=in.qis;
  AdmsSensFadType instanceVar_qid=in.qid;
  AdmsSensFadType instanceVar_qbs=in.qbs;
  AdmsSensFadType instanceVar_qba=in.qba;
  AdmsSensFadType instanceVar_u0r=in.u0r;
  AdmsSensFadType instanceVar_UAR_t=in.UAR_t;
  AdmsSensFadType instanceVar_UC_t=in.UC_t;
  AdmsSensFadType instanceVar_UCR_t=in.UCR_t;
  AdmsSensFadType instanceVar_UDR_t=in.UDR_t;
  AdmsSensFadType instanceVar_U0R_t=in.U0R_t;
  AdmsSensFadType instanceVar_EeffFactor=in.EeffFactor;
  AdmsSensFadType instanceVar_Dr=in.Dr;
  AdmsSensFadType instanceVar_WeffWRFactor=in.WeffWRFactor;
  AdmsSensFadType instanceVar_RSourceGeo=in.RSourceGeo;
  AdmsSensFadType instanceVar_RDrainGeo=in.RDrainGeo;
  AdmsSensFadType instanceVar_RDSWMIN_i=in.RDSWMIN_i;
  AdmsSensFadType instanceVar_RDWMIN_i=in.RDWMIN_i;
  AdmsSensFadType instanceVar_RSWMIN_i=in.RSWMIN_i;
  AdmsSensFadType instanceVar_Rdrain=in.Rdrain;
  AdmsSensFadType instanceVar_Rsource=in.Rsource;
  AdmsSensFadType instanceVar_Rdsi=in.Rdsi;
  AdmsSensFadType instanceVar_RSDRR_t=in.RSDRR_t;
  AdmsSensFadType instanceVar_RDDRR_t=in.RDDRR_t;
  AdmsSensFadType instanceVar_VSAT1R_t=in.VSAT1R_t;
  AdmsSensFadType instanceVar_MEXPR_t=in.MEXPR_t;
  AdmsSensFadType instanceVar_VSAT_a=in.VSAT_a;
  AdmsSensFadType instanceVar_Cfr_geo=in.Cfr_geo;
  AdmsSensFadType instanceVar_ggeltd=in.ggeltd;
  AdmsSensFadType instanceVar_igbinv=in.igbinv;
  AdmsSensFadType instanceVar_igsd_mult0=in.igsd_mult0;
  AdmsSensFadType instanceVar_igbs=in.igbs;
  AdmsSensFadType instanceVar_igbd=in.igbd;
  AdmsSensFadType instanceVar_igbacc=in.igbacc;
  AdmsSensFadType instanceVar_igcs=in.igcs;
  AdmsSensFadType instanceVar_igcd=in.igcd;
  AdmsSensFadType instanceVar_igisl=in.igisl;
  AdmsSensFadType instanceVar_igidl=in.igidl;
  AdmsSensFadType instanceVar_igs=in.igs;
  AdmsSensFadType instanceVar_igd=in.igd;
  AdmsSensFadType instanceVar_Aechvb=in.Aechvb;
  AdmsSensFadType instanceVar_Bechvb=in.Bechvb;
  AdmsSensFadType instanceVar_Toxratio=in.Toxratio;
  AdmsSensFadType instanceVar_Iii=in.Iii;
  AdmsSensFadType instanceVar_cox_acc=in.cox_acc;
  AdmsSensFadType instanceVar_qg_acc=in.qg_acc;
  AdmsSensFadType instanceVar_qb_acc=in.qb_acc;
  AdmsSensFadType instanceVar_qgs_fr=in.qgs_fr;
  AdmsSensFadType instanceVar_qgd_fr=in.qgd_fr;
  AdmsSensFadType instanceVar_qds_fr=in.qds_fr;
  AdmsSensFadType instanceVar_qgs_parasitic=in.qgs_parasitic;
  AdmsSensFadType instanceVar_qgd_parasitic=in.qgd_parasitic;
  AdmsSensFadType instanceVar_Qes=in.Qes;
  AdmsSensFadType instanceVar_Qed=in.Qed;
  AdmsSensFadType instanceVar_Qeg=in.Qeg;
  AdmsSensFadType instanceVar_csbox=in.csbox;
  AdmsSensFadType instanceVar_cdbox=in.cdbox;
  AdmsSensFadType instanceVar_cgbox=in.cgbox;
  AdmsSensFadType instanceVar_Ies=in.Ies;
  AdmsSensFadType instanceVar_Ied=in.Ied;
  AdmsSensFadType instanceVar_Czbs=in.Czbs;
  AdmsSensFadType instanceVar_Czbssw=in.Czbssw;
  AdmsSensFadType instanceVar_Czbsswg=in.Czbsswg;
  AdmsSensFadType instanceVar_Czbd=in.Czbd;
  AdmsSensFadType instanceVar_Czbdsw=in.Czbdsw;
  AdmsSensFadType instanceVar_Czbdswg=in.Czbdswg;
  AdmsSensFadType instanceVar_Isbs=in.Isbs;
  AdmsSensFadType instanceVar_Isbd=in.Isbd;
  AdmsSensFadType instanceVar_Nvtms=in.Nvtms;
  AdmsSensFadType instanceVar_Nvtmd=in.Nvtmd;
  AdmsSensFadType instanceVar_SslpRev=in.SslpRev;
  AdmsSensFadType instanceVar_IVjsmRev=in.IVjsmRev;
  AdmsSensFadType instanceVar_VjsmRev=in.VjsmRev;
  AdmsSensFadType instanceVar_SslpFwd=in.SslpFwd;
  AdmsSensFadType instanceVar_IVjsmFwd=in.IVjsmFwd;
  AdmsSensFadType instanceVar_VjsmFwd=in.VjsmFwd;
  AdmsSensFadType instanceVar_XExpBVS=in.XExpBVS;
  AdmsSensFadType instanceVar_DslpRev=in.DslpRev;
  AdmsSensFadType instanceVar_IVjdmRev=in.IVjdmRev;
  AdmsSensFadType instanceVar_VjdmRev=in.VjdmRev;
  AdmsSensFadType instanceVar_DslpFwd=in.DslpFwd;
  AdmsSensFadType instanceVar_IVjdmFwd=in.IVjdmFwd;
  AdmsSensFadType instanceVar_VjdmFwd=in.VjdmFwd;
  AdmsSensFadType instanceVar_XExpBVD=in.XExpBVD;
  AdmsSensFadType instanceVar_idsgen=in.idsgen;
  AdmsSensFadType instanceVar_LINTIGEN_i=in.LINTIGEN_i;
  AdmsSensFadType instanceVar_LINTNOI_i=in.LINTNOI_i;
  AdmsSensFadType instanceVar_litl=in.litl;
  AdmsSensFadType instanceVar_FNPowerAt1Hz=in.FNPowerAt1Hz;
  AdmsSensFadType instanceVar_NTNOI_i=in.NTNOI_i;
  AdmsSensFadType instanceVar_Gtnoi=in.Gtnoi;
  AdmsSensFadType instanceVar_sid=in.sid;
  AdmsSensFadType instanceVar_gspr=in.gspr;
  AdmsSensFadType instanceVar_gdpr=in.gdpr;
  AdmsSensFadType instanceVar_gamma=in.gamma;
  AdmsSensFadType instanceVar_delta=in.delta;
  AdmsSensFadType instanceVar_ctnoi=in.ctnoi;
  AdmsSensFadType instanceVar_C0=in.C0;
  AdmsSensFadType instanceVar_sf=in.sf;
  AdmsSensFadType instanceVar_gth=in.gth;
  AdmsSensFadType instanceVar_cth=in.cth;
  AdmsSensFadType instanceVar_PHIG_i=in.PHIG_i;
  AdmsSensFadType instanceVar_CFD_i=in.CFD_i;
  AdmsSensFadType instanceVar_CFS_i=in.CFS_i;
  AdmsSensFadType instanceVar_COVS_i=in.COVS_i;
  AdmsSensFadType instanceVar_COVD_i=in.COVD_i;
  AdmsSensFadType instanceVar_CGSO_i=in.CGSO_i;
  AdmsSensFadType instanceVar_CGDO_i=in.CGDO_i;
  AdmsSensFadType instanceVar_CGSL_i=in.CGSL_i;
  AdmsSensFadType instanceVar_CGDL_i=in.CGDL_i;
  AdmsSensFadType instanceVar_CGBL_i=in.CGBL_i;
  AdmsSensFadType instanceVar_CKAPPAS_i=in.CKAPPAS_i;
  AdmsSensFadType instanceVar_CKAPPAD_i=in.CKAPPAD_i;
  AdmsSensFadType instanceVar_CKAPPAB_i=in.CKAPPAB_i;
  AdmsSensFadType instanceVar_QMFACTOR_i=in.QMFACTOR_i;
  AdmsSensFadType instanceVar_QMTCENCV_i=in.QMTCENCV_i;
  AdmsSensFadType instanceVar_QMTCENCVA_i=in.QMTCENCVA_i;
  AdmsSensFadType instanceVar_KSATIV_i=in.KSATIV_i;
  AdmsSensFadType instanceVar_KSATIVR_i=in.KSATIVR_i;
  AdmsSensFadType instanceVar_CDSC_i=in.CDSC_i;
  AdmsSensFadType instanceVar_CDSCD_i=in.CDSCD_i;
  AdmsSensFadType instanceVar_CDSCDR_i=in.CDSCDR_i;
  AdmsSensFadType instanceVar_CIT_i=in.CIT_i;
  AdmsSensFadType instanceVar_DVT0_i=in.DVT0_i;
  AdmsSensFadType instanceVar_CITR_i=in.CITR_i;
  AdmsSensFadType instanceVar_PHIN_i=in.PHIN_i;
  AdmsSensFadType instanceVar_ETA0_i=in.ETA0_i;
  AdmsSensFadType instanceVar_ETA0R_i=in.ETA0R_i;
  AdmsSensFadType instanceVar_VSAT_i=in.VSAT_i;
  AdmsSensFadType instanceVar_VSATR_i=in.VSATR_i;
  AdmsSensFadType instanceVar_VSATR_t=in.VSATR_t;
  AdmsSensFadType instanceVar_DVTP0_i=in.DVTP0_i;
  AdmsSensFadType instanceVar_DVTP1_i=in.DVTP1_i;
  AdmsSensFadType instanceVar_K0_i=in.K0_i;
  AdmsSensFadType instanceVar_K01_i=in.K01_i;
  AdmsSensFadType instanceVar_K0SI_i=in.K0SI_i;
  AdmsSensFadType instanceVar_K0SI1_i=in.K0SI1_i;
  AdmsSensFadType instanceVar_K2SI_i=in.K2SI_i;
  AdmsSensFadType instanceVar_K2SI1_i=in.K2SI1_i;
  AdmsSensFadType instanceVar_PHIBE_i=in.PHIBE_i;
  AdmsSensFadType instanceVar_K1_i=in.K1_i;
  AdmsSensFadType instanceVar_K11_i=in.K11_i;
  AdmsSensFadType instanceVar_K2SAT_i=in.K2SAT_i;
  AdmsSensFadType instanceVar_K2SAT1_i=in.K2SAT1_i;
  AdmsSensFadType instanceVar_DELTAVSAT_i=in.DELTAVSAT_i;
  AdmsSensFadType instanceVar_PSAT_i=in.PSAT_i;
  AdmsSensFadType instanceVar_DELTAVSATCV_i=in.DELTAVSATCV_i;
  AdmsSensFadType instanceVar_PSATCV_i=in.PSATCV_i;
  AdmsSensFadType instanceVar_VSAT1_i=in.VSAT1_i;
  AdmsSensFadType instanceVar_VSAT1R_i=in.VSAT1R_i;
  AdmsSensFadType instanceVar_PTWG_i=in.PTWG_i;
  AdmsSensFadType instanceVar_PTWGR_i=in.PTWGR_i;
  AdmsSensFadType instanceVar_VSATCV_i=in.VSATCV_i;
  AdmsSensFadType instanceVar_U0_i=in.U0_i;
  AdmsSensFadType instanceVar_U0R_i=in.U0R_i;
  AdmsSensFadType instanceVar_ETAMOB_i=in.ETAMOB_i;
  AdmsSensFadType instanceVar_RDSW_i=in.RDSW_i;
  AdmsSensFadType instanceVar_PRWGS_i=in.PRWGS_i;
  AdmsSensFadType instanceVar_PRWGD_i=in.PRWGD_i;
  AdmsSensFadType instanceVar_PDIBL1_i=in.PDIBL1_i;
  AdmsSensFadType instanceVar_PDIBL1R_i=in.PDIBL1R_i;
  AdmsSensFadType instanceVar_PDIBL2_i=in.PDIBL2_i;
  AdmsSensFadType instanceVar_PDIBL2R_i=in.PDIBL2R_i;
  AdmsSensFadType instanceVar_DROUT_i=in.DROUT_i;
  AdmsSensFadType instanceVar_PVAG_i=in.PVAG_i;
  AdmsSensFadType instanceVar_AIGBINV_i=in.AIGBINV_i;
  AdmsSensFadType instanceVar_AIGBINV1_i=in.AIGBINV1_i;
  AdmsSensFadType instanceVar_BIGBINV_i=in.BIGBINV_i;
  AdmsSensFadType instanceVar_CIGBINV_i=in.CIGBINV_i;
  AdmsSensFadType instanceVar_EIGBINV_i=in.EIGBINV_i;
  AdmsSensFadType instanceVar_NIGBINV_i=in.NIGBINV_i;
  AdmsSensFadType instanceVar_AIGBACC_i=in.AIGBACC_i;
  AdmsSensFadType instanceVar_AIGBACC1_i=in.AIGBACC1_i;
  AdmsSensFadType instanceVar_BIGBACC_i=in.BIGBACC_i;
  AdmsSensFadType instanceVar_CIGBACC_i=in.CIGBACC_i;
  AdmsSensFadType instanceVar_NIGBACC_i=in.NIGBACC_i;
  AdmsSensFadType instanceVar_AIGC_i=in.AIGC_i;
  AdmsSensFadType instanceVar_AIGC1_i=in.AIGC1_i;
  AdmsSensFadType instanceVar_BIGC_i=in.BIGC_i;
  AdmsSensFadType instanceVar_CIGC_i=in.CIGC_i;
  AdmsSensFadType instanceVar_PIGCD_i=in.PIGCD_i;
  AdmsSensFadType instanceVar_AIGS_i=in.AIGS_i;
  AdmsSensFadType instanceVar_AIGS1_i=in.AIGS1_i;
  AdmsSensFadType instanceVar_BIGS_i=in.BIGS_i;
  AdmsSensFadType instanceVar_CIGS_i=in.CIGS_i;
  AdmsSensFadType instanceVar_POXEDGE_i=in.POXEDGE_i;
  AdmsSensFadType instanceVar_AIGD_i=in.AIGD_i;
  AdmsSensFadType instanceVar_AIGD1_i=in.AIGD1_i;
  AdmsSensFadType instanceVar_BIGD_i=in.BIGD_i;
  AdmsSensFadType instanceVar_CIGD_i=in.CIGD_i;
  AdmsSensFadType instanceVar_AGIDL_i=in.AGIDL_i;
  AdmsSensFadType instanceVar_BGIDL_i=in.BGIDL_i;
  AdmsSensFadType instanceVar_CGIDL_i=in.CGIDL_i;
  AdmsSensFadType instanceVar_EGIDL_i=in.EGIDL_i;
  AdmsSensFadType instanceVar_PGIDL_i=in.PGIDL_i;
  AdmsSensFadType instanceVar_AGISL_i=in.AGISL_i;
  AdmsSensFadType instanceVar_BGISL_i=in.BGISL_i;
  AdmsSensFadType instanceVar_CGISL_i=in.CGISL_i;
  AdmsSensFadType instanceVar_EGISL_i=in.EGISL_i;
  AdmsSensFadType instanceVar_PGISL_i=in.PGISL_i;
  AdmsSensFadType instanceVar_ALPHA0_i=in.ALPHA0_i;
  AdmsSensFadType instanceVar_ALPHA1_i=in.ALPHA1_i;
  AdmsSensFadType instanceVar_ALPHAII0_i=in.ALPHAII0_i;
  AdmsSensFadType instanceVar_ALPHAII1_i=in.ALPHAII1_i;
  AdmsSensFadType instanceVar_BETA0_i=in.BETA0_i;
  AdmsSensFadType instanceVar_BETAII0_i=in.BETAII0_i;
  AdmsSensFadType instanceVar_BETAII1_i=in.BETAII1_i;
  AdmsSensFadType instanceVar_BETAII2_i=in.BETAII2_i;
  AdmsSensFadType instanceVar_ESATII_i=in.ESATII_i;
  AdmsSensFadType instanceVar_LII_i=in.LII_i;
  AdmsSensFadType instanceVar_SII0_i=in.SII0_i;
  AdmsSensFadType instanceVar_SII1_i=in.SII1_i;
  AdmsSensFadType instanceVar_SII2_i=in.SII2_i;
  AdmsSensFadType instanceVar_SIID_i=in.SIID_i;
  AdmsSensFadType instanceVar_TII_i=in.TII_i;
  AdmsSensFadType instanceVar_MEXP_i=in.MEXP_i;
  AdmsSensFadType instanceVar_MEXPR_i=in.MEXPR_i;
  AdmsSensFadType instanceVar_PCLM_i=in.PCLM_i;
  AdmsSensFadType instanceVar_PCLMG_i=in.PCLMG_i;
  AdmsSensFadType instanceVar_PCLMCV_i=in.PCLMCV_i;
  AdmsSensFadType instanceVar_PCLMR_i=in.PCLMR_i;
  AdmsSensFadType instanceVar_A1_i=in.A1_i;
  AdmsSensFadType instanceVar_A2_i=in.A2_i;
  AdmsSensFadType instanceVar_A11_i=in.A11_i;
  AdmsSensFadType instanceVar_A21_i=in.A21_i;
  AdmsSensFadType instanceVar_K1RSCE_i=in.K1RSCE_i;
  AdmsSensFadType instanceVar_DVTSHIFT_i=in.DVTSHIFT_i;
  AdmsSensFadType instanceVar_DVTSHIFTR_i=in.DVTSHIFTR_i;
  AdmsSensFadType instanceVar_UA_i=in.UA_i;
  AdmsSensFadType instanceVar_UC_i=in.UC_i;
  AdmsSensFadType instanceVar_EU_i=in.EU_i;
  AdmsSensFadType instanceVar_UD_i=in.UD_i;
  AdmsSensFadType instanceVar_UCS_i=in.UCS_i;
  AdmsSensFadType instanceVar_UAR_i=in.UAR_i;
  AdmsSensFadType instanceVar_EUR_i=in.EUR_i;
  AdmsSensFadType instanceVar_UCR_i=in.UCR_i;
  AdmsSensFadType instanceVar_UDR_i=in.UDR_i;
  AdmsSensFadType instanceVar_UA1_i=in.UA1_i;
  AdmsSensFadType instanceVar_UA1R_i=in.UA1R_i;
  AdmsSensFadType instanceVar_UC1_i=in.UC1_i;
  AdmsSensFadType instanceVar_UD1_i=in.UD1_i;
  AdmsSensFadType instanceVar_UCSTE_i=in.UCSTE_i;
  AdmsSensFadType instanceVar_UTE_i=in.UTE_i;
  AdmsSensFadType instanceVar_UTL_i=in.UTL_i;
  AdmsSensFadType instanceVar_EMOBT_i=in.EMOBT_i;
  AdmsSensFadType instanceVar_UC1R_i=in.UC1R_i;
  AdmsSensFadType instanceVar_UD1R_i=in.UD1R_i;
  AdmsSensFadType instanceVar_UTER_i=in.UTER_i;
  AdmsSensFadType instanceVar_UTLR_i=in.UTLR_i;
  AdmsSensFadType instanceVar_PTWGT_i=in.PTWGT_i;
  AdmsSensFadType instanceVar_AT_i=in.AT_i;
  AdmsSensFadType instanceVar_ATCV_i=in.ATCV_i;
  AdmsSensFadType instanceVar_ATR_i=in.ATR_i;
  AdmsSensFadType instanceVar_RDW_i=in.RDW_i;
  AdmsSensFadType instanceVar_RSW_i=in.RSW_i;
  AdmsSensFadType instanceVar_PRT_i=in.PRT_i;
  AdmsSensFadType instanceVar_KT1_i=in.KT1_i;
  AdmsSensFadType instanceVar_TSS_i=in.TSS_i;
  AdmsSensFadType instanceVar_IIT_i=in.IIT_i;
  AdmsSensFadType instanceVar_IGT_i=in.IGT_i;
  AdmsSensFadType instanceVar_TGIDL_i=in.TGIDL_i;
  AdmsSensFadType instanceVar_NTGEN_i=in.NTGEN_i;
  AdmsSensFadType instanceVar_AIGEN_i=in.AIGEN_i;
  AdmsSensFadType instanceVar_BIGEN_i=in.BIGEN_i;
  AdmsSensFadType instanceVar_K0SISAT_i=in.K0SISAT_i;
  AdmsSensFadType instanceVar_K0SISAT1_i=in.K0SISAT1_i;
  AdmsSensFadType instanceVar_K2SISAT_i=in.K2SISAT_i;
  AdmsSensFadType instanceVar_K2SISAT1_i=in.K2SISAT1_i;
  AdmsSensFadType instanceVar_K2_i=in.K2_i;
  AdmsSensFadType instanceVar_K21_i=in.K21_i;
  AdmsSensFadType instanceVar_Cins=in.Cins;
  AdmsSensFadType instanceVar_Ach=in.Ach;
  AdmsSensFadType instanceVar_Weff_UFCM=in.Weff_UFCM;
  AdmsSensFadType instanceVar_qdep=in.qdep;
  AdmsSensFadType instanceVar_rc=in.rc;
  AdmsSensFadType instanceVar_vth_fixed_factor_Sub=in.vth_fixed_factor_Sub;
  AdmsSensFadType instanceVar_vth_fixed_factor_SI=in.vth_fixed_factor_SI;
  AdmsSensFadType instanceVar_qm=in.qm;
  AdmsSensFadType instanceVar_Qdep_ov_Cins=in.Qdep_ov_Cins;
  AdmsSensFadType instanceVar_qi_acc_for_QM=in.qi_acc_for_QM;
  AdmsSensFadType instanceVar_fieldnormalizationfactor=in.fieldnormalizationfactor;
  AdmsSensFadType instanceVar_auxQMfact=in.auxQMfact;
  AdmsSensFadType instanceVar_QMFACTORCVfinal=in.QMFACTORCVfinal;
  AdmsSensFadType instanceVar_psipclamp=in.psipclamp;
  AdmsSensFadType instanceVar_sqrtpsip=in.sqrtpsip;
  AdmsSensFadType instanceVar_nq=in.nq;
  AdmsSensFadType instanceVar_F0=in.F0;


  //non-reals
  int instanceVar_devsign=in.devsign;


  //make local copies of all model vars
  //reals


  // non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables and set as Fad independent variables.
  probeVars[in.admsProbeID_V_N_GND] = (in.collapseNode_N)?(0):((*solVectorPtr)[in.li_N]);
  probeVars[in.admsProbeID_V_g_ge] = (*solVectorPtr)[in.li_g]- (*solVectorPtr)[in.li_ge];
  probeVars[in.admsProbeID_V_s_si] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_si];
  probeVars[in.admsProbeID_V_d_di] = (*solVectorPtr)[in.li_d]- (*solVectorPtr)[in.li_di];
  probeVars[in.admsProbeID_V_e_ge] = (*solVectorPtr)[in.li_e]- (*solVectorPtr)[in.li_ge];
  probeVars[in.admsProbeID_V_ge_d] = (*solVectorPtr)[in.li_ge]- (*solVectorPtr)[in.li_d];
  probeVars[in.admsProbeID_V_ge_s] = (*solVectorPtr)[in.li_ge]- (*solVectorPtr)[in.li_s];
  probeVars[in.admsProbeID_V_di_d] = (*solVectorPtr)[in.li_di]- (*solVectorPtr)[in.li_d];
  probeVars[in.admsProbeID_V_si_s] = (*solVectorPtr)[in.li_si]- (*solVectorPtr)[in.li_s];
  probeVars[in.admsProbeID_V_e_s] = (*solVectorPtr)[in.li_e]- (*solVectorPtr)[in.li_s];
  probeVars[in.admsProbeID_V_d_s] = (*solVectorPtr)[in.li_d]- (*solVectorPtr)[in.li_s];
  probeVars[in.admsProbeID_V_g_s] = (*solVectorPtr)[in.li_g]- (*solVectorPtr)[in.li_s];
  probeVars[in.admsProbeID_V_ge_e] = (*solVectorPtr)[in.li_ge]- (*solVectorPtr)[in.li_e];
  probeVars[in.admsProbeID_V_e_di] = (*solVectorPtr)[in.li_e]- (*solVectorPtr)[in.li_di];
  probeVars[in.admsProbeID_V_e_si] = (*solVectorPtr)[in.li_e]- (*solVectorPtr)[in.li_si];
  probeVars[in.admsProbeID_V_ge_di] = (*solVectorPtr)[in.li_ge]- (*solVectorPtr)[in.li_di];
  probeVars[in.admsProbeID_V_di_si] = (*solVectorPtr)[in.li_di]- (*solVectorPtr)[in.li_si];
  probeVars[in.admsProbeID_V_ge_si] = (*solVectorPtr)[in.li_ge]- (*solVectorPtr)[in.li_si];
  probeVars[in.admsProbeID_Temp_t_GND] = (*solVectorPtr)[in.li_t];


  evaluateInitialInstance(
     // instance parameters
     // reals
     instancePar_L,
     instancePar_given_L,
     instancePar_D,
     instancePar_given_D,
     instancePar_TFIN,
     instancePar_given_TFIN,
     instancePar_FPITCH,
     instancePar_given_FPITCH,
     instancePar_NFIN,
     instancePar_given_NFIN,
     instancePar_ASEO,
     instancePar_given_ASEO,
     instancePar_ADEO,
     instancePar_given_ADEO,
     instancePar_PSEO,
     instancePar_given_PSEO,
     instancePar_PDEO,
     instancePar_given_PDEO,
     instancePar_ASEJ,
     instancePar_given_ASEJ,
     instancePar_ADEJ,
     instancePar_given_ADEJ,
     instancePar_PSEJ,
     instancePar_given_PSEJ,
     instancePar_PDEJ,
     instancePar_given_PDEJ,
     instancePar_COVS,
     instancePar_given_COVS,
     instancePar_COVD,
     instancePar_given_COVD,
     instancePar_CGSP,
     instancePar_given_CGSP,
     instancePar_CGDP,
     instancePar_given_CGDP,
     instancePar_CDSP,
     instancePar_given_CDSP,
     instancePar_NRS,
     instancePar_given_NRS,
     instancePar_NRD,
     instancePar_given_NRD,
     instancePar_LRSD,
     instancePar_given_LRSD,
     instancePar_NFINNOM,
     instancePar_given_NFINNOM,
     instancePar_m,
     instancePar_given_m,
     // non-reals(including hidden)
     instancePar_NF,
     instancePar_given_NF,
     instancePar_NGCON,
     instancePar_given_NGCON,
     // instance variables
     // reals
     instanceVar_NFINtotal,
     instanceVar_ids,
     instanceVar_sigvds,
     instanceVar_qd,
     instanceVar_qg,
     instanceVar_qs,
     instanceVar_qb,
     instanceVar_epssub,
     instanceVar_epsratio,
     instanceVar_Leff,
     instanceVar_LeffCV,
     instanceVar_LeffCV_acc,
     instanceVar_Weff0,
     instanceVar_WeffCV0,
     instanceVar_cox,
     instanceVar_nbody,
     instanceVar_T0,
     instanceVar_T1,
     instanceVar_T2,
     instanceVar_T3,
     instanceVar_Tnom,
     instanceVar_PTWGR_t,
     instanceVar_CJS_t,
     instanceVar_CJSWS_t,
     instanceVar_CJSWGD_t,
     instanceVar_CJD_t,
     instanceVar_CJSWD_t,
     instanceVar_CJSWGS_t,
     instanceVar_PBS_t,
     instanceVar_PBSWS_t,
     instanceVar_PBSWGS_t,
     instanceVar_PBD_t,
     instanceVar_PBSWD_t,
     instanceVar_PBSWGD_t,
     instanceVar_JSS_t,
     instanceVar_JSWS_t,
     instanceVar_JSWGS_t,
     instanceVar_JSD_t,
     instanceVar_JSWD_t,
     instanceVar_JSWGD_t,
     instanceVar_JTSS_t,
     instanceVar_JTSD_t,
     instanceVar_JTSSWS_t,
     instanceVar_JTSSWD_t,
     instanceVar_JTSSWGS_t,
     instanceVar_JTSSWGD_t,
     instanceVar_NJTS_t,
     instanceVar_NJTSD_t,
     instanceVar_NJTSSW_t,
     instanceVar_NJTSSWD_t,
     instanceVar_NJTSSWG_t,
     instanceVar_NJTSSWGD_t,
     instanceVar_q0,
     instanceVar_T11,
     instanceVar_T12,
     instanceVar_e0,
     instanceVar_e1,
     instanceVar_e2,
     instanceVar_scl,
     instanceVar_tmp,
     instanceVar_Theta_SCE,
     instanceVar_Theta_SW,
     instanceVar_Theta_DIBL,
     instanceVar_Theta_RSCE,
     instanceVar_Theta_DITS,
     instanceVar_veseff,
     instanceVar_Tcen0,
     instanceVar_Tcen,
     instanceVar_mx,
     instanceVar_mxprime,
     instanceVar_md,
     instanceVar_mdprime,
     instanceVar_gprime,
     instanceVar_gfactor,
     instanceVar_qis,
     instanceVar_qid,
     instanceVar_qbs,
     instanceVar_qba,
     instanceVar_u0r,
     instanceVar_UAR_t,
     instanceVar_UC_t,
     instanceVar_UCR_t,
     instanceVar_UDR_t,
     instanceVar_U0R_t,
     instanceVar_EeffFactor,
     instanceVar_Dr,
     instanceVar_WeffWRFactor,
     instanceVar_RSourceGeo,
     instanceVar_RDrainGeo,
     instanceVar_RDSWMIN_i,
     instanceVar_RDWMIN_i,
     instanceVar_RSWMIN_i,
     instanceVar_Rdrain,
     instanceVar_Rsource,
     instanceVar_Rdsi,
     instanceVar_RSDRR_t,
     instanceVar_RDDRR_t,
     instanceVar_VSAT1R_t,
     instanceVar_MEXPR_t,
     instanceVar_VSAT_a,
     instanceVar_Cfr_geo,
     instanceVar_ggeltd,
     instanceVar_igbinv,
     instanceVar_igsd_mult0,
     instanceVar_igbs,
     instanceVar_igbd,
     instanceVar_igbacc,
     instanceVar_igcs,
     instanceVar_igcd,
     instanceVar_igisl,
     instanceVar_igidl,
     instanceVar_igs,
     instanceVar_igd,
     instanceVar_Aechvb,
     instanceVar_Bechvb,
     instanceVar_Toxratio,
     instanceVar_Iii,
     instanceVar_cox_acc,
     instanceVar_qg_acc,
     instanceVar_qb_acc,
     instanceVar_qgs_fr,
     instanceVar_qgd_fr,
     instanceVar_qds_fr,
     instanceVar_qgs_parasitic,
     instanceVar_qgd_parasitic,
     instanceVar_Qes,
     instanceVar_Qed,
     instanceVar_Qeg,
     instanceVar_csbox,
     instanceVar_cdbox,
     instanceVar_cgbox,
     instanceVar_Ies,
     instanceVar_Ied,
     instanceVar_Czbs,
     instanceVar_Czbssw,
     instanceVar_Czbsswg,
     instanceVar_Czbd,
     instanceVar_Czbdsw,
     instanceVar_Czbdswg,
     instanceVar_Isbs,
     instanceVar_Isbd,
     instanceVar_Nvtms,
     instanceVar_Nvtmd,
     instanceVar_SslpRev,
     instanceVar_IVjsmRev,
     instanceVar_VjsmRev,
     instanceVar_SslpFwd,
     instanceVar_IVjsmFwd,
     instanceVar_VjsmFwd,
     instanceVar_XExpBVS,
     instanceVar_DslpRev,
     instanceVar_IVjdmRev,
     instanceVar_VjdmRev,
     instanceVar_DslpFwd,
     instanceVar_IVjdmFwd,
     instanceVar_VjdmFwd,
     instanceVar_XExpBVD,
     instanceVar_idsgen,
     instanceVar_LINTIGEN_i,
     instanceVar_LINTNOI_i,
     instanceVar_litl,
     instanceVar_FNPowerAt1Hz,
     instanceVar_NTNOI_i,
     instanceVar_Gtnoi,
     instanceVar_sid,
     instanceVar_gspr,
     instanceVar_gdpr,
     instanceVar_gamma,
     instanceVar_delta,
     instanceVar_ctnoi,
     instanceVar_C0,
     instanceVar_sf,
     instanceVar_gth,
     instanceVar_cth,
     instanceVar_PHIG_i,
     instanceVar_CFD_i,
     instanceVar_CFS_i,
     instanceVar_COVS_i,
     instanceVar_COVD_i,
     instanceVar_CGSO_i,
     instanceVar_CGDO_i,
     instanceVar_CGSL_i,
     instanceVar_CGDL_i,
     instanceVar_CGBL_i,
     instanceVar_CKAPPAS_i,
     instanceVar_CKAPPAD_i,
     instanceVar_CKAPPAB_i,
     instanceVar_QMFACTOR_i,
     instanceVar_QMTCENCV_i,
     instanceVar_QMTCENCVA_i,
     instanceVar_KSATIV_i,
     instanceVar_KSATIVR_i,
     instanceVar_CDSC_i,
     instanceVar_CDSCD_i,
     instanceVar_CDSCDR_i,
     instanceVar_CIT_i,
     instanceVar_DVT0_i,
     instanceVar_CITR_i,
     instanceVar_PHIN_i,
     instanceVar_ETA0_i,
     instanceVar_ETA0R_i,
     instanceVar_VSAT_i,
     instanceVar_VSATR_i,
     instanceVar_VSATR_t,
     instanceVar_DVTP0_i,
     instanceVar_DVTP1_i,
     instanceVar_K0_i,
     instanceVar_K01_i,
     instanceVar_K0SI_i,
     instanceVar_K0SI1_i,
     instanceVar_K2SI_i,
     instanceVar_K2SI1_i,
     instanceVar_PHIBE_i,
     instanceVar_K1_i,
     instanceVar_K11_i,
     instanceVar_K2SAT_i,
     instanceVar_K2SAT1_i,
     instanceVar_DELTAVSAT_i,
     instanceVar_PSAT_i,
     instanceVar_DELTAVSATCV_i,
     instanceVar_PSATCV_i,
     instanceVar_VSAT1_i,
     instanceVar_VSAT1R_i,
     instanceVar_PTWG_i,
     instanceVar_PTWGR_i,
     instanceVar_VSATCV_i,
     instanceVar_U0_i,
     instanceVar_U0R_i,
     instanceVar_ETAMOB_i,
     instanceVar_RDSW_i,
     instanceVar_PRWGS_i,
     instanceVar_PRWGD_i,
     instanceVar_PDIBL1_i,
     instanceVar_PDIBL1R_i,
     instanceVar_PDIBL2_i,
     instanceVar_PDIBL2R_i,
     instanceVar_DROUT_i,
     instanceVar_PVAG_i,
     instanceVar_AIGBINV_i,
     instanceVar_AIGBINV1_i,
     instanceVar_BIGBINV_i,
     instanceVar_CIGBINV_i,
     instanceVar_EIGBINV_i,
     instanceVar_NIGBINV_i,
     instanceVar_AIGBACC_i,
     instanceVar_AIGBACC1_i,
     instanceVar_BIGBACC_i,
     instanceVar_CIGBACC_i,
     instanceVar_NIGBACC_i,
     instanceVar_AIGC_i,
     instanceVar_AIGC1_i,
     instanceVar_BIGC_i,
     instanceVar_CIGC_i,
     instanceVar_PIGCD_i,
     instanceVar_AIGS_i,
     instanceVar_AIGS1_i,
     instanceVar_BIGS_i,
     instanceVar_CIGS_i,
     instanceVar_POXEDGE_i,
     instanceVar_AIGD_i,
     instanceVar_AIGD1_i,
     instanceVar_BIGD_i,
     instanceVar_CIGD_i,
     instanceVar_AGIDL_i,
     instanceVar_BGIDL_i,
     instanceVar_CGIDL_i,
     instanceVar_EGIDL_i,
     instanceVar_PGIDL_i,
     instanceVar_AGISL_i,
     instanceVar_BGISL_i,
     instanceVar_CGISL_i,
     instanceVar_EGISL_i,
     instanceVar_PGISL_i,
     instanceVar_ALPHA0_i,
     instanceVar_ALPHA1_i,
     instanceVar_ALPHAII0_i,
     instanceVar_ALPHAII1_i,
     instanceVar_BETA0_i,
     instanceVar_BETAII0_i,
     instanceVar_BETAII1_i,
     instanceVar_BETAII2_i,
     instanceVar_ESATII_i,
     instanceVar_LII_i,
     instanceVar_SII0_i,
     instanceVar_SII1_i,
     instanceVar_SII2_i,
     instanceVar_SIID_i,
     instanceVar_TII_i,
     instanceVar_MEXP_i,
     instanceVar_MEXPR_i,
     instanceVar_PCLM_i,
     instanceVar_PCLMG_i,
     instanceVar_PCLMCV_i,
     instanceVar_PCLMR_i,
     instanceVar_A1_i,
     instanceVar_A2_i,
     instanceVar_A11_i,
     instanceVar_A21_i,
     instanceVar_K1RSCE_i,
     instanceVar_DVTSHIFT_i,
     instanceVar_DVTSHIFTR_i,
     instanceVar_UA_i,
     instanceVar_UC_i,
     instanceVar_EU_i,
     instanceVar_UD_i,
     instanceVar_UCS_i,
     instanceVar_UAR_i,
     instanceVar_EUR_i,
     instanceVar_UCR_i,
     instanceVar_UDR_i,
     instanceVar_UA1_i,
     instanceVar_UA1R_i,
     instanceVar_UC1_i,
     instanceVar_UD1_i,
     instanceVar_UCSTE_i,
     instanceVar_UTE_i,
     instanceVar_UTL_i,
     instanceVar_EMOBT_i,
     instanceVar_UC1R_i,
     instanceVar_UD1R_i,
     instanceVar_UTER_i,
     instanceVar_UTLR_i,
     instanceVar_PTWGT_i,
     instanceVar_AT_i,
     instanceVar_ATCV_i,
     instanceVar_ATR_i,
     instanceVar_RDW_i,
     instanceVar_RSW_i,
     instanceVar_PRT_i,
     instanceVar_KT1_i,
     instanceVar_TSS_i,
     instanceVar_IIT_i,
     instanceVar_IGT_i,
     instanceVar_TGIDL_i,
     instanceVar_NTGEN_i,
     instanceVar_AIGEN_i,
     instanceVar_BIGEN_i,
     instanceVar_K0SISAT_i,
     instanceVar_K0SISAT1_i,
     instanceVar_K2SISAT_i,
     instanceVar_K2SISAT1_i,
     instanceVar_K2_i,
     instanceVar_K21_i,
     instanceVar_Cins,
     instanceVar_Ach,
     instanceVar_Weff_UFCM,
     instanceVar_qdep,
     instanceVar_rc,
     instanceVar_vth_fixed_factor_Sub,
     instanceVar_vth_fixed_factor_SI,
     instanceVar_qm,
     instanceVar_Qdep_ov_Cins,
     instanceVar_qi_acc_for_QM,
     instanceVar_fieldnormalizationfactor,
     instanceVar_auxQMfact,
     instanceVar_QMFACTORCVfinal,
     instanceVar_psipclamp,
     instanceVar_sqrtpsip,
     instanceVar_nq,
     instanceVar_F0,
     // non-reals
     instanceVar_devsign,
     // model parameters
     // reals
     modelPar_L,
     modelPar_given_L,
     modelPar_D,
     modelPar_given_D,
     modelPar_TFIN,
     modelPar_given_TFIN,
     modelPar_FPITCH,
     modelPar_given_FPITCH,
     modelPar_NFIN,
     modelPar_given_NFIN,
     modelPar_ASEO,
     modelPar_given_ASEO,
     modelPar_ADEO,
     modelPar_given_ADEO,
     modelPar_PSEO,
     modelPar_given_PSEO,
     modelPar_PDEO,
     modelPar_given_PDEO,
     modelPar_ASEJ,
     modelPar_given_ASEJ,
     modelPar_ADEJ,
     modelPar_given_ADEJ,
     modelPar_PSEJ,
     modelPar_given_PSEJ,
     modelPar_PDEJ,
     modelPar_given_PDEJ,
     modelPar_COVS,
     modelPar_given_COVS,
     modelPar_COVD,
     modelPar_given_COVD,
     modelPar_CGSP,
     modelPar_given_CGSP,
     modelPar_CGDP,
     modelPar_given_CGDP,
     modelPar_CDSP,
     modelPar_given_CDSP,
     modelPar_NRS,
     modelPar_given_NRS,
     modelPar_NRD,
     modelPar_given_NRD,
     modelPar_LRSD,
     modelPar_given_LRSD,
     modelPar_XL,
     modelPar_given_XL,
     modelPar_DTEMP,
     modelPar_given_DTEMP,
     modelPar_DELVTRAND,
     modelPar_given_DELVTRAND,
     modelPar_U0MULT,
     modelPar_given_U0MULT,
     modelPar_IDS0MULT,
     modelPar_given_IDS0MULT,
     modelPar_LINT,
     modelPar_given_LINT,
     modelPar_LL,
     modelPar_given_LL,
     modelPar_LLN,
     modelPar_given_LLN,
     modelPar_DLC,
     modelPar_given_DLC,
     modelPar_DLCACC,
     modelPar_given_DLCACC,
     modelPar_DLBIN,
     modelPar_given_DLBIN,
     modelPar_LLC,
     modelPar_given_LLC,
     modelPar_EOT,
     modelPar_given_EOT,
     modelPar_TOXP,
     modelPar_given_TOXP,
     modelPar_EOTBOX,
     modelPar_given_EOTBOX,
     modelPar_HFIN,
     modelPar_given_HFIN,
     modelPar_FECH,
     modelPar_given_FECH,
     modelPar_DELTAW,
     modelPar_given_DELTAW,
     modelPar_FECHCV,
     modelPar_given_FECHCV,
     modelPar_DELTAWCV,
     modelPar_given_DELTAWCV,
     modelPar_NBODY,
     modelPar_given_NBODY,
     modelPar_NBODYN1,
     modelPar_given_NBODYN1,
     modelPar_NBODYN2,
     modelPar_given_NBODYN2,
     modelPar_NSD,
     modelPar_given_NSD,
     modelPar_PHIG,
     modelPar_given_PHIG,
     modelPar_PHIGL,
     modelPar_given_PHIGL,
     modelPar_PHIGLT,
     modelPar_given_PHIGLT,
     modelPar_PHIGN1,
     modelPar_given_PHIGN1,
     modelPar_PHIGN2,
     modelPar_given_PHIGN2,
     modelPar_EPSROX,
     modelPar_given_EPSROX,
     modelPar_EPSRSUB,
     modelPar_given_EPSRSUB,
     modelPar_EASUB,
     modelPar_given_EASUB,
     modelPar_NI0SUB,
     modelPar_given_NI0SUB,
     modelPar_BG0SUB,
     modelPar_given_BG0SUB,
     modelPar_NC0SUB,
     modelPar_given_NC0SUB,
     modelPar_NGATE,
     modelPar_given_NGATE,
     modelPar_Imin,
     modelPar_given_Imin,
     modelPar_CIT,
     modelPar_given_CIT,
     modelPar_CITR,
     modelPar_given_CITR,
     modelPar_CDSC,
     modelPar_given_CDSC,
     modelPar_CDSCN1,
     modelPar_given_CDSCN1,
     modelPar_CDSCN2,
     modelPar_given_CDSCN2,
     modelPar_CDSCD,
     modelPar_given_CDSCD,
     modelPar_CDSCDN1,
     modelPar_given_CDSCDN1,
     modelPar_CDSCDN2,
     modelPar_given_CDSCDN2,
     modelPar_CDSCDR,
     modelPar_given_CDSCDR,
     modelPar_CDSCDRN1,
     modelPar_given_CDSCDRN1,
     modelPar_CDSCDRN2,
     modelPar_given_CDSCDRN2,
     modelPar_DVT0,
     modelPar_given_DVT0,
     modelPar_DVT1,
     modelPar_given_DVT1,
     modelPar_DVT1SS,
     modelPar_given_DVT1SS,
     modelPar_PHIN,
     modelPar_given_PHIN,
     modelPar_ETA0,
     modelPar_given_ETA0,
     modelPar_ETA0N1,
     modelPar_given_ETA0N1,
     modelPar_ETA0N2,
     modelPar_given_ETA0N2,
     modelPar_ETA0LT,
     modelPar_given_ETA0LT,
     modelPar_TETA0,
     modelPar_given_TETA0,
     modelPar_ETA0R,
     modelPar_given_ETA0R,
     modelPar_TETA0R,
     modelPar_given_TETA0R,
     modelPar_DSUB,
     modelPar_given_DSUB,
     modelPar_DVTP0,
     modelPar_given_DVTP0,
     modelPar_DVTP1,
     modelPar_given_DVTP1,
     modelPar_ADVTP0,
     modelPar_given_ADVTP0,
     modelPar_BDVTP0,
     modelPar_given_BDVTP0,
     modelPar_ADVTP1,
     modelPar_given_ADVTP1,
     modelPar_BDVTP1,
     modelPar_given_BDVTP1,
     modelPar_DVTP2,
     modelPar_given_DVTP2,
     modelPar_K1RSCE,
     modelPar_given_K1RSCE,
     modelPar_LPE0,
     modelPar_given_LPE0,
     modelPar_DVTSHIFT,
     modelPar_given_DVTSHIFT,
     modelPar_DVTSHIFTR,
     modelPar_given_DVTSHIFTR,
     modelPar_THETASCE,
     modelPar_given_THETASCE,
     modelPar_THETADIBL,
     modelPar_given_THETADIBL,
     modelPar_THETASW,
     modelPar_given_THETASW,
     modelPar_NVTM,
     modelPar_given_NVTM,
     modelPar_K0,
     modelPar_given_K0,
     modelPar_K01,
     modelPar_given_K01,
     modelPar_K0SI,
     modelPar_given_K0SI,
     modelPar_K0SI1,
     modelPar_given_K0SI1,
     modelPar_K2SI,
     modelPar_given_K2SI,
     modelPar_K2SI1,
     modelPar_given_K2SI1,
     modelPar_K0SISAT,
     modelPar_given_K0SISAT,
     modelPar_K0SISAT1,
     modelPar_given_K0SISAT1,
     modelPar_K2SISAT,
     modelPar_given_K2SISAT,
     modelPar_K2SISAT1,
     modelPar_given_K2SISAT1,
     modelPar_PHIBE,
     modelPar_given_PHIBE,
     modelPar_K1,
     modelPar_given_K1,
     modelPar_K11,
     modelPar_given_K11,
     modelPar_K2SAT,
     modelPar_given_K2SAT,
     modelPar_K2SAT1,
     modelPar_given_K2SAT1,
     modelPar_K2,
     modelPar_given_K2,
     modelPar_K21,
     modelPar_given_K21,
     modelPar_QMFACTOR,
     modelPar_given_QMFACTOR,
     modelPar_QMTCENCV,
     modelPar_given_QMTCENCV,
     modelPar_QMTCENCVA,
     modelPar_given_QMTCENCVA,
     modelPar_AQMTCEN,
     modelPar_given_AQMTCEN,
     modelPar_BQMTCEN,
     modelPar_given_BQMTCEN,
     modelPar_ETAQM,
     modelPar_given_ETAQM,
     modelPar_QM0,
     modelPar_given_QM0,
     modelPar_PQM,
     modelPar_given_PQM,
     modelPar_QM0ACC,
     modelPar_given_QM0ACC,
     modelPar_PQMACC,
     modelPar_given_PQMACC,
     modelPar_VSAT,
     modelPar_given_VSAT,
     modelPar_VSATR,
     modelPar_given_VSATR,
     modelPar_VSATN1,
     modelPar_given_VSATN1,
     modelPar_VSATN2,
     modelPar_given_VSATN2,
     modelPar_VSATRN1,
     modelPar_given_VSATRN1,
     modelPar_VSATRN2,
     modelPar_given_VSATRN2,
     modelPar_AVSAT,
     modelPar_given_AVSAT,
     modelPar_BVSAT,
     modelPar_given_BVSAT,
     modelPar_VSAT1,
     modelPar_given_VSAT1,
     modelPar_VSAT1N1,
     modelPar_given_VSAT1N1,
     modelPar_VSAT1N2,
     modelPar_given_VSAT1N2,
     modelPar_VSAT1R,
     modelPar_given_VSAT1R,
     modelPar_VSAT1RN1,
     modelPar_given_VSAT1RN1,
     modelPar_VSAT1RN2,
     modelPar_given_VSAT1RN2,
     modelPar_AVSAT1,
     modelPar_given_AVSAT1,
     modelPar_BVSAT1,
     modelPar_given_BVSAT1,
     modelPar_DELTAVSAT,
     modelPar_given_DELTAVSAT,
     modelPar_PSAT,
     modelPar_given_PSAT,
     modelPar_APSAT,
     modelPar_given_APSAT,
     modelPar_BPSAT,
     modelPar_given_BPSAT,
     modelPar_KSATIV,
     modelPar_given_KSATIV,
     modelPar_KSATIVR,
     modelPar_given_KSATIVR,
     modelPar_VSATCV,
     modelPar_given_VSATCV,
     modelPar_AVSATCV,
     modelPar_given_AVSATCV,
     modelPar_BVSATCV,
     modelPar_given_BVSATCV,
     modelPar_DELTAVSATCV,
     modelPar_given_DELTAVSATCV,
     modelPar_PSATCV,
     modelPar_given_PSATCV,
     modelPar_APSATCV,
     modelPar_given_APSATCV,
     modelPar_BPSATCV,
     modelPar_given_BPSATCV,
     modelPar_MEXP,
     modelPar_given_MEXP,
     modelPar_AMEXP,
     modelPar_given_AMEXP,
     modelPar_BMEXP,
     modelPar_given_BMEXP,
     modelPar_MEXPR,
     modelPar_given_MEXPR,
     modelPar_AMEXPR,
     modelPar_given_AMEXPR,
     modelPar_BMEXPR,
     modelPar_given_BMEXPR,
     modelPar_PTWG,
     modelPar_given_PTWG,
     modelPar_PTWGR,
     modelPar_given_PTWGR,
     modelPar_APTWG,
     modelPar_given_APTWG,
     modelPar_BPTWG,
     modelPar_given_BPTWG,
     modelPar_AT,
     modelPar_given_AT,
     modelPar_ATR,
     modelPar_given_ATR,
     modelPar_ATCV,
     modelPar_given_ATCV,
     modelPar_TMEXP,
     modelPar_given_TMEXP,
     modelPar_TMEXPR,
     modelPar_given_TMEXPR,
     modelPar_PTWGT,
     modelPar_given_PTWGT,
     modelPar_U0,
     modelPar_given_U0,
     modelPar_U0R,
     modelPar_given_U0R,
     modelPar_U0N1,
     modelPar_given_U0N1,
     modelPar_U0N1R,
     modelPar_given_U0N1R,
     modelPar_U0N2,
     modelPar_given_U0N2,
     modelPar_U0N2R,
     modelPar_given_U0N2R,
     modelPar_U0LT,
     modelPar_given_U0LT,
     modelPar_ETAMOB,
     modelPar_given_ETAMOB,
     modelPar_UP,
     modelPar_given_UP,
     modelPar_LPA,
     modelPar_given_LPA,
     modelPar_UPR,
     modelPar_given_UPR,
     modelPar_LPAR,
     modelPar_given_LPAR,
     modelPar_UA,
     modelPar_given_UA,
     modelPar_UAR,
     modelPar_given_UAR,
     modelPar_AUA,
     modelPar_given_AUA,
     modelPar_AUAR,
     modelPar_given_AUAR,
     modelPar_BUA,
     modelPar_given_BUA,
     modelPar_BUAR,
     modelPar_given_BUAR,
     modelPar_UC,
     modelPar_given_UC,
     modelPar_UCR,
     modelPar_given_UCR,
     modelPar_EU,
     modelPar_given_EU,
     modelPar_EUR,
     modelPar_given_EUR,
     modelPar_AEU,
     modelPar_given_AEU,
     modelPar_AEUR,
     modelPar_given_AEUR,
     modelPar_BEU,
     modelPar_given_BEU,
     modelPar_BEUR,
     modelPar_given_BEUR,
     modelPar_UD,
     modelPar_given_UD,
     modelPar_UDR,
     modelPar_given_UDR,
     modelPar_AUD,
     modelPar_given_AUD,
     modelPar_AUDR,
     modelPar_given_AUDR,
     modelPar_BUD,
     modelPar_given_BUD,
     modelPar_BUDR,
     modelPar_given_BUDR,
     modelPar_UCS,
     modelPar_given_UCS,
     modelPar_UTE,
     modelPar_given_UTE,
     modelPar_UTER,
     modelPar_given_UTER,
     modelPar_UTL,
     modelPar_given_UTL,
     modelPar_UTLR,
     modelPar_given_UTLR,
     modelPar_EMOBT,
     modelPar_given_EMOBT,
     modelPar_UA1,
     modelPar_given_UA1,
     modelPar_UA1R,
     modelPar_given_UA1R,
     modelPar_UC1,
     modelPar_given_UC1,
     modelPar_UC1R,
     modelPar_given_UC1R,
     modelPar_UD1,
     modelPar_given_UD1,
     modelPar_UD1R,
     modelPar_given_UD1R,
     modelPar_UCSTE,
     modelPar_given_UCSTE,
     modelPar_CHARGEWF,
     modelPar_given_CHARGEWF,
     modelPar_RDSWMIN,
     modelPar_given_RDSWMIN,
     modelPar_RDSW,
     modelPar_given_RDSW,
     modelPar_ARDSW,
     modelPar_given_ARDSW,
     modelPar_BRDSW,
     modelPar_given_BRDSW,
     modelPar_RSWMIN,
     modelPar_given_RSWMIN,
     modelPar_RSW,
     modelPar_given_RSW,
     modelPar_ARSW,
     modelPar_given_ARSW,
     modelPar_BRSW,
     modelPar_given_BRSW,
     modelPar_RDWMIN,
     modelPar_given_RDWMIN,
     modelPar_RDW,
     modelPar_given_RDW,
     modelPar_ARDW,
     modelPar_given_ARDW,
     modelPar_BRDW,
     modelPar_given_BRDW,
     modelPar_RSDR,
     modelPar_given_RSDR,
     modelPar_RSDRR,
     modelPar_given_RSDRR,
     modelPar_RDDR,
     modelPar_given_RDDR,
     modelPar_RDDRR,
     modelPar_given_RDDRR,
     modelPar_PRSDR,
     modelPar_given_PRSDR,
     modelPar_PRDDR,
     modelPar_given_PRDDR,
     modelPar_PRWGS,
     modelPar_given_PRWGS,
     modelPar_PRWGD,
     modelPar_given_PRWGD,
     modelPar_WR,
     modelPar_given_WR,
     modelPar_PRT,
     modelPar_given_PRT,
     modelPar_TRSDR,
     modelPar_given_TRSDR,
     modelPar_TRDDR,
     modelPar_given_TRDDR,
     modelPar_PDIBL1,
     modelPar_given_PDIBL1,
     modelPar_PDIBL1R,
     modelPar_given_PDIBL1R,
     modelPar_PDIBL2,
     modelPar_given_PDIBL2,
     modelPar_PDIBL2R,
     modelPar_given_PDIBL2R,
     modelPar_DROUT,
     modelPar_given_DROUT,
     modelPar_PVAG,
     modelPar_given_PVAG,
     modelPar_PCLM,
     modelPar_given_PCLM,
     modelPar_PCLMR,
     modelPar_given_PCLMR,
     modelPar_APCLM,
     modelPar_given_APCLM,
     modelPar_APCLMR,
     modelPar_given_APCLMR,
     modelPar_BPCLM,
     modelPar_given_BPCLM,
     modelPar_BPCLMR,
     modelPar_given_BPCLMR,
     modelPar_PCLMG,
     modelPar_given_PCLMG,
     modelPar_PCLMCV,
     modelPar_given_PCLMCV,
     modelPar_A1,
     modelPar_given_A1,
     modelPar_A11,
     modelPar_given_A11,
     modelPar_A2,
     modelPar_given_A2,
     modelPar_A21,
     modelPar_given_A21,
     modelPar_RGEXT,
     modelPar_given_RGEXT,
     modelPar_RGFIN,
     modelPar_given_RGFIN,
     modelPar_RSHS,
     modelPar_given_RSHS,
     modelPar_RSHD,
     modelPar_given_RSHD,
     modelPar_HEPI,
     modelPar_given_HEPI,
     modelPar_TSILI,
     modelPar_given_TSILI,
     modelPar_RHOC,
     modelPar_given_RHOC,
     modelPar_RHORSD,
     modelPar_given_RHORSD,
     modelPar_CRATIO,
     modelPar_given_CRATIO,
     modelPar_DELTAPRSD,
     modelPar_given_DELTAPRSD,
     modelPar_LSP,
     modelPar_given_LSP,
     modelPar_EPSRSP,
     modelPar_given_EPSRSP,
     modelPar_TGATE,
     modelPar_given_TGATE,
     modelPar_TMASK,
     modelPar_given_TMASK,
     modelPar_ASILIEND,
     modelPar_given_ASILIEND,
     modelPar_ARSDEND,
     modelPar_given_ARSDEND,
     modelPar_PRSDEND,
     modelPar_given_PRSDEND,
     modelPar_NSDE,
     modelPar_given_NSDE,
     modelPar_RGEOA,
     modelPar_given_RGEOA,
     modelPar_RGEOB,
     modelPar_given_RGEOB,
     modelPar_RGEOC,
     modelPar_given_RGEOC,
     modelPar_RGEOD,
     modelPar_given_RGEOD,
     modelPar_RGEOE,
     modelPar_given_RGEOE,
     modelPar_CGEOA,
     modelPar_given_CGEOA,
     modelPar_CGEOB,
     modelPar_given_CGEOB,
     modelPar_CGEOC,
     modelPar_given_CGEOC,
     modelPar_CGEOD,
     modelPar_given_CGEOD,
     modelPar_CGEOE,
     modelPar_given_CGEOE,
     modelPar_AIGBINV,
     modelPar_given_AIGBINV,
     modelPar_AIGBINV1,
     modelPar_given_AIGBINV1,
     modelPar_BIGBINV,
     modelPar_given_BIGBINV,
     modelPar_CIGBINV,
     modelPar_given_CIGBINV,
     modelPar_EIGBINV,
     modelPar_given_EIGBINV,
     modelPar_NIGBINV,
     modelPar_given_NIGBINV,
     modelPar_AIGBACC,
     modelPar_given_AIGBACC,
     modelPar_AIGBACC1,
     modelPar_given_AIGBACC1,
     modelPar_BIGBACC,
     modelPar_given_BIGBACC,
     modelPar_CIGBACC,
     modelPar_given_CIGBACC,
     modelPar_NIGBACC,
     modelPar_given_NIGBACC,
     modelPar_AIGC,
     modelPar_given_AIGC,
     modelPar_AIGC1,
     modelPar_given_AIGC1,
     modelPar_BIGC,
     modelPar_given_BIGC,
     modelPar_CIGC,
     modelPar_given_CIGC,
     modelPar_PIGCD,
     modelPar_given_PIGCD,
     modelPar_DLCIGS,
     modelPar_given_DLCIGS,
     modelPar_AIGS,
     modelPar_given_AIGS,
     modelPar_AIGS1,
     modelPar_given_AIGS1,
     modelPar_BIGS,
     modelPar_given_BIGS,
     modelPar_CIGS,
     modelPar_given_CIGS,
     modelPar_DLCIGD,
     modelPar_given_DLCIGD,
     modelPar_AIGD,
     modelPar_given_AIGD,
     modelPar_AIGD1,
     modelPar_given_AIGD1,
     modelPar_BIGD,
     modelPar_given_BIGD,
     modelPar_CIGD,
     modelPar_given_CIGD,
     modelPar_VFBSD,
     modelPar_given_VFBSD,
     modelPar_VFBSDCV,
     modelPar_given_VFBSDCV,
     modelPar_TOXREF,
     modelPar_given_TOXREF,
     modelPar_TOXG,
     modelPar_given_TOXG,
     modelPar_NTOX,
     modelPar_given_NTOX,
     modelPar_POXEDGE,
     modelPar_given_POXEDGE,
     modelPar_AGISL,
     modelPar_given_AGISL,
     modelPar_BGISL,
     modelPar_given_BGISL,
     modelPar_CGISL,
     modelPar_given_CGISL,
     modelPar_EGISL,
     modelPar_given_EGISL,
     modelPar_PGISL,
     modelPar_given_PGISL,
     modelPar_AGIDL,
     modelPar_given_AGIDL,
     modelPar_BGIDL,
     modelPar_given_BGIDL,
     modelPar_CGIDL,
     modelPar_given_CGIDL,
     modelPar_EGIDL,
     modelPar_given_EGIDL,
     modelPar_PGIDL,
     modelPar_given_PGIDL,
     modelPar_ALPHA0,
     modelPar_given_ALPHA0,
     modelPar_ALPHA01,
     modelPar_given_ALPHA01,
     modelPar_ALPHA1,
     modelPar_given_ALPHA1,
     modelPar_ALPHA11,
     modelPar_given_ALPHA11,
     modelPar_BETA0,
     modelPar_given_BETA0,
     modelPar_ALPHAII0,
     modelPar_given_ALPHAII0,
     modelPar_ALPHAII01,
     modelPar_given_ALPHAII01,
     modelPar_ALPHAII1,
     modelPar_given_ALPHAII1,
     modelPar_ALPHAII11,
     modelPar_given_ALPHAII11,
     modelPar_BETAII0,
     modelPar_given_BETAII0,
     modelPar_BETAII1,
     modelPar_given_BETAII1,
     modelPar_BETAII2,
     modelPar_given_BETAII2,
     modelPar_ESATII,
     modelPar_given_ESATII,
     modelPar_LII,
     modelPar_given_LII,
     modelPar_SII0,
     modelPar_given_SII0,
     modelPar_SII1,
     modelPar_given_SII1,
     modelPar_SII2,
     modelPar_given_SII2,
     modelPar_SIID,
     modelPar_given_SIID,
     modelPar_IIMOD2CLAMP1,
     modelPar_given_IIMOD2CLAMP1,
     modelPar_IIMOD2CLAMP2,
     modelPar_given_IIMOD2CLAMP2,
     modelPar_IIMOD2CLAMP3,
     modelPar_given_IIMOD2CLAMP3,
     modelPar_EOTACC,
     modelPar_given_EOTACC,
     modelPar_DELVFBACC,
     modelPar_given_DELVFBACC,
     modelPar_CFS,
     modelPar_given_CFS,
     modelPar_CFD,
     modelPar_given_CFD,
     modelPar_CGSO,
     modelPar_given_CGSO,
     modelPar_CGDO,
     modelPar_given_CGDO,
     modelPar_CGSL,
     modelPar_given_CGSL,
     modelPar_CGDL,
     modelPar_given_CGDL,
     modelPar_CKAPPAS,
     modelPar_given_CKAPPAS,
     modelPar_CKAPPAD,
     modelPar_given_CKAPPAD,
     modelPar_CGBO,
     modelPar_given_CGBO,
     modelPar_CGBN,
     modelPar_given_CGBN,
     modelPar_CGBL,
     modelPar_given_CGBL,
     modelPar_CKAPPAB,
     modelPar_given_CKAPPAB,
     modelPar_CSDESW,
     modelPar_given_CSDESW,
     modelPar_CJS,
     modelPar_given_CJS,
     modelPar_CJD,
     modelPar_given_CJD,
     modelPar_CJSWS,
     modelPar_given_CJSWS,
     modelPar_CJSWD,
     modelPar_given_CJSWD,
     modelPar_CJSWGS,
     modelPar_given_CJSWGS,
     modelPar_CJSWGD,
     modelPar_given_CJSWGD,
     modelPar_PBS,
     modelPar_given_PBS,
     modelPar_PBD,
     modelPar_given_PBD,
     modelPar_PBSWS,
     modelPar_given_PBSWS,
     modelPar_PBSWD,
     modelPar_given_PBSWD,
     modelPar_PBSWGS,
     modelPar_given_PBSWGS,
     modelPar_PBSWGD,
     modelPar_given_PBSWGD,
     modelPar_MJS,
     modelPar_given_MJS,
     modelPar_MJD,
     modelPar_given_MJD,
     modelPar_MJSWS,
     modelPar_given_MJSWS,
     modelPar_MJSWD,
     modelPar_given_MJSWD,
     modelPar_MJSWGS,
     modelPar_given_MJSWGS,
     modelPar_MJSWGD,
     modelPar_given_MJSWGD,
     modelPar_SJS,
     modelPar_given_SJS,
     modelPar_SJD,
     modelPar_given_SJD,
     modelPar_SJSWS,
     modelPar_given_SJSWS,
     modelPar_SJSWD,
     modelPar_given_SJSWD,
     modelPar_SJSWGS,
     modelPar_given_SJSWGS,
     modelPar_SJSWGD,
     modelPar_given_SJSWGD,
     modelPar_MJS2,
     modelPar_given_MJS2,
     modelPar_MJD2,
     modelPar_given_MJD2,
     modelPar_MJSWS2,
     modelPar_given_MJSWS2,
     modelPar_MJSWD2,
     modelPar_given_MJSWD2,
     modelPar_MJSWGS2,
     modelPar_given_MJSWGS2,
     modelPar_MJSWGD2,
     modelPar_given_MJSWGD2,
     modelPar_JSS,
     modelPar_given_JSS,
     modelPar_JSD,
     modelPar_given_JSD,
     modelPar_JSWS,
     modelPar_given_JSWS,
     modelPar_JSWD,
     modelPar_given_JSWD,
     modelPar_JSWGS,
     modelPar_given_JSWGS,
     modelPar_JSWGD,
     modelPar_given_JSWGD,
     modelPar_NJS,
     modelPar_given_NJS,
     modelPar_NJD,
     modelPar_given_NJD,
     modelPar_IJTHSFWD,
     modelPar_given_IJTHSFWD,
     modelPar_IJTHDFWD,
     modelPar_given_IJTHDFWD,
     modelPar_IJTHSREV,
     modelPar_given_IJTHSREV,
     modelPar_IJTHDREV,
     modelPar_given_IJTHDREV,
     modelPar_BVS,
     modelPar_given_BVS,
     modelPar_BVD,
     modelPar_given_BVD,
     modelPar_XJBVS,
     modelPar_given_XJBVS,
     modelPar_XJBVD,
     modelPar_given_XJBVD,
     modelPar_JTSS,
     modelPar_given_JTSS,
     modelPar_JTSD,
     modelPar_given_JTSD,
     modelPar_JTSSWS,
     modelPar_given_JTSSWS,
     modelPar_JTSSWD,
     modelPar_given_JTSSWD,
     modelPar_JTSSWGS,
     modelPar_given_JTSSWGS,
     modelPar_JTSSWGD,
     modelPar_given_JTSSWGD,
     modelPar_JTWEFF,
     modelPar_given_JTWEFF,
     modelPar_NJTS,
     modelPar_given_NJTS,
     modelPar_NJTSD,
     modelPar_given_NJTSD,
     modelPar_NJTSSW,
     modelPar_given_NJTSSW,
     modelPar_NJTSSWD,
     modelPar_given_NJTSSWD,
     modelPar_NJTSSWG,
     modelPar_given_NJTSSWG,
     modelPar_NJTSSWGD,
     modelPar_given_NJTSSWGD,
     modelPar_VTSS,
     modelPar_given_VTSS,
     modelPar_VTSD,
     modelPar_given_VTSD,
     modelPar_VTSSWS,
     modelPar_given_VTSSWS,
     modelPar_VTSSWD,
     modelPar_given_VTSSWD,
     modelPar_VTSSWGS,
     modelPar_given_VTSSWGS,
     modelPar_VTSSWGD,
     modelPar_given_VTSSWGD,
     modelPar_LINTIGEN,
     modelPar_given_LINTIGEN,
     modelPar_NTGEN,
     modelPar_given_NTGEN,
     modelPar_AIGEN,
     modelPar_given_AIGEN,
     modelPar_BIGEN,
     modelPar_given_BIGEN,
     modelPar_XRCRG1,
     modelPar_given_XRCRG1,
     modelPar_XRCRG2,
     modelPar_given_XRCRG2,
     modelPar_EF,
     modelPar_given_EF,
     modelPar_EM,
     modelPar_given_EM,
     modelPar_NOIA,
     modelPar_given_NOIA,
     modelPar_NOIB,
     modelPar_given_NOIB,
     modelPar_NOIC,
     modelPar_given_NOIC,
     modelPar_LINTNOI,
     modelPar_given_LINTNOI,
     modelPar_NTNOI,
     modelPar_given_NTNOI,
     modelPar_TNOIA,
     modelPar_given_TNOIA,
     modelPar_TNOIB,
     modelPar_given_TNOIB,
     modelPar_RNOIA,
     modelPar_given_RNOIA,
     modelPar_RNOIB,
     modelPar_given_RNOIB,
     modelPar_TNOIC,
     modelPar_given_TNOIC,
     modelPar_RNOIC,
     modelPar_given_RNOIC,
     modelPar_SCALEN,
     modelPar_given_SCALEN,
     modelPar_TNOM,
     modelPar_given_TNOM,
     modelPar_TBGASUB,
     modelPar_given_TBGASUB,
     modelPar_TBGBSUB,
     modelPar_given_TBGBSUB,
     modelPar_KT1,
     modelPar_given_KT1,
     modelPar_KT1L,
     modelPar_given_KT1L,
     modelPar_TSS,
     modelPar_given_TSS,
     modelPar_IIT,
     modelPar_given_IIT,
     modelPar_TII,
     modelPar_given_TII,
     modelPar_TGIDL,
     modelPar_given_TGIDL,
     modelPar_IGT,
     modelPar_given_IGT,
     modelPar_TCJ,
     modelPar_given_TCJ,
     modelPar_TCJSW,
     modelPar_given_TCJSW,
     modelPar_TCJSWG,
     modelPar_given_TCJSWG,
     modelPar_TPB,
     modelPar_given_TPB,
     modelPar_TPBSW,
     modelPar_given_TPBSW,
     modelPar_TPBSWG,
     modelPar_given_TPBSWG,
     modelPar_XTIS,
     modelPar_given_XTIS,
     modelPar_XTID,
     modelPar_given_XTID,
     modelPar_XTSS,
     modelPar_given_XTSS,
     modelPar_XTSD,
     modelPar_given_XTSD,
     modelPar_XTSSWS,
     modelPar_given_XTSSWS,
     modelPar_XTSSWD,
     modelPar_given_XTSSWD,
     modelPar_XTSSWGS,
     modelPar_given_XTSSWGS,
     modelPar_XTSSWGD,
     modelPar_given_XTSSWGD,
     modelPar_TNJTS,
     modelPar_given_TNJTS,
     modelPar_TNJTSD,
     modelPar_given_TNJTSD,
     modelPar_TNJTSSW,
     modelPar_given_TNJTSSW,
     modelPar_TNJTSSWD,
     modelPar_given_TNJTSSWD,
     modelPar_TNJTSSWG,
     modelPar_given_TNJTSSWG,
     modelPar_TNJTSSWGD,
     modelPar_given_TNJTSSWGD,
     modelPar_RTH0,
     modelPar_given_RTH0,
     modelPar_CTH0,
     modelPar_given_CTH0,
     modelPar_WTH0,
     modelPar_given_WTH0,
     modelPar_ASHEXP,
     modelPar_given_ASHEXP,
     modelPar_BSHEXP,
     modelPar_given_BSHEXP,
     modelPar_ACH_UFCM,
     modelPar_given_ACH_UFCM,
     modelPar_CINS_UFCM,
     modelPar_given_CINS_UFCM,
     modelPar_W_UFCM,
     modelPar_given_W_UFCM,
     modelPar_TFIN_TOP,
     modelPar_given_TFIN_TOP,
     modelPar_TFIN_BASE,
     modelPar_given_TFIN_BASE,
     modelPar_QMFACTORCV,
     modelPar_given_QMFACTORCV,
     modelPar_ALPHA_UFCM,
     modelPar_given_ALPHA_UFCM,
     modelPar_LNBODY,
     modelPar_given_LNBODY,
     modelPar_NNBODY,
     modelPar_given_NNBODY,
     modelPar_PNBODY,
     modelPar_given_PNBODY,
     modelPar_LPHIG,
     modelPar_given_LPHIG,
     modelPar_NPHIG,
     modelPar_given_NPHIG,
     modelPar_PPHIG,
     modelPar_given_PPHIG,
     modelPar_LNGATE,
     modelPar_given_LNGATE,
     modelPar_NNGATE,
     modelPar_given_NNGATE,
     modelPar_PNGATE,
     modelPar_given_PNGATE,
     modelPar_LCIT,
     modelPar_given_LCIT,
     modelPar_NCIT,
     modelPar_given_NCIT,
     modelPar_PCIT,
     modelPar_given_PCIT,
     modelPar_LCITR,
     modelPar_given_LCITR,
     modelPar_NCITR,
     modelPar_given_NCITR,
     modelPar_PCITR,
     modelPar_given_PCITR,
     modelPar_LCDSC,
     modelPar_given_LCDSC,
     modelPar_NCDSC,
     modelPar_given_NCDSC,
     modelPar_PCDSC,
     modelPar_given_PCDSC,
     modelPar_LCDSCD,
     modelPar_given_LCDSCD,
     modelPar_NCDSCD,
     modelPar_given_NCDSCD,
     modelPar_PCDSCD,
     modelPar_given_PCDSCD,
     modelPar_LCDSCDR,
     modelPar_given_LCDSCDR,
     modelPar_NCDSCDR,
     modelPar_given_NCDSCDR,
     modelPar_PCDSCDR,
     modelPar_given_PCDSCDR,
     modelPar_LDVT0,
     modelPar_given_LDVT0,
     modelPar_NDVT0,
     modelPar_given_NDVT0,
     modelPar_PDVT0,
     modelPar_given_PDVT0,
     modelPar_LDVT1,
     modelPar_given_LDVT1,
     modelPar_NDVT1,
     modelPar_given_NDVT1,
     modelPar_PDVT1,
     modelPar_given_PDVT1,
     modelPar_LDVT1SS,
     modelPar_given_LDVT1SS,
     modelPar_NDVT1SS,
     modelPar_given_NDVT1SS,
     modelPar_PDVT1SS,
     modelPar_given_PDVT1SS,
     modelPar_LPHIN,
     modelPar_given_LPHIN,
     modelPar_NPHIN,
     modelPar_given_NPHIN,
     modelPar_PPHIN,
     modelPar_given_PPHIN,
     modelPar_LETA0,
     modelPar_given_LETA0,
     modelPar_NETA0,
     modelPar_given_NETA0,
     modelPar_PETA0,
     modelPar_given_PETA0,
     modelPar_LETA0R,
     modelPar_given_LETA0R,
     modelPar_NETA0R,
     modelPar_given_NETA0R,
     modelPar_PETA0R,
     modelPar_given_PETA0R,
     modelPar_LDSUB,
     modelPar_given_LDSUB,
     modelPar_NDSUB,
     modelPar_given_NDSUB,
     modelPar_PDSUB,
     modelPar_given_PDSUB,
     modelPar_LK1RSCE,
     modelPar_given_LK1RSCE,
     modelPar_NK1RSCE,
     modelPar_given_NK1RSCE,
     modelPar_PK1RSCE,
     modelPar_given_PK1RSCE,
     modelPar_LLPE0,
     modelPar_given_LLPE0,
     modelPar_NLPE0,
     modelPar_given_NLPE0,
     modelPar_PLPE0,
     modelPar_given_PLPE0,
     modelPar_LDVTSHIFT,
     modelPar_given_LDVTSHIFT,
     modelPar_NDVTSHIFT,
     modelPar_given_NDVTSHIFT,
     modelPar_PDVTSHIFT,
     modelPar_given_PDVTSHIFT,
     modelPar_LDVTSHIFTR,
     modelPar_given_LDVTSHIFTR,
     modelPar_NDVTSHIFTR,
     modelPar_given_NDVTSHIFTR,
     modelPar_PDVTSHIFTR,
     modelPar_given_PDVTSHIFTR,
     modelPar_LPHIBE,
     modelPar_given_LPHIBE,
     modelPar_NPHIBE,
     modelPar_given_NPHIBE,
     modelPar_PPHIBE,
     modelPar_given_PPHIBE,
     modelPar_LK0,
     modelPar_given_LK0,
     modelPar_NK0,
     modelPar_given_NK0,
     modelPar_PK0,
     modelPar_given_PK0,
     modelPar_LK01,
     modelPar_given_LK01,
     modelPar_NK01,
     modelPar_given_NK01,
     modelPar_PK01,
     modelPar_given_PK01,
     modelPar_LK0SI,
     modelPar_given_LK0SI,
     modelPar_NK0SI,
     modelPar_given_NK0SI,
     modelPar_PK0SI,
     modelPar_given_PK0SI,
     modelPar_LK0SI1,
     modelPar_given_LK0SI1,
     modelPar_NK0SI1,
     modelPar_given_NK0SI1,
     modelPar_PK0SI1,
     modelPar_given_PK0SI1,
     modelPar_LK1,
     modelPar_given_LK1,
     modelPar_NK1,
     modelPar_given_NK1,
     modelPar_PK1,
     modelPar_given_PK1,
     modelPar_LK11,
     modelPar_given_LK11,
     modelPar_NK11,
     modelPar_given_NK11,
     modelPar_PK11,
     modelPar_given_PK11,
     modelPar_LK2SI,
     modelPar_given_LK2SI,
     modelPar_NK2SI,
     modelPar_given_NK2SI,
     modelPar_PK2SI,
     modelPar_given_PK2SI,
     modelPar_LK2SI1,
     modelPar_given_LK2SI1,
     modelPar_NK2SI1,
     modelPar_given_NK2SI1,
     modelPar_PK2SI1,
     modelPar_given_PK2SI1,
     modelPar_LK0SISAT,
     modelPar_given_LK0SISAT,
     modelPar_NK0SISAT,
     modelPar_given_NK0SISAT,
     modelPar_PK0SISAT,
     modelPar_given_PK0SISAT,
     modelPar_LK0SISAT1,
     modelPar_given_LK0SISAT1,
     modelPar_NK0SISAT1,
     modelPar_given_NK0SISAT1,
     modelPar_PK0SISAT1,
     modelPar_given_PK0SISAT1,
     modelPar_LK2SISAT,
     modelPar_given_LK2SISAT,
     modelPar_NK2SISAT,
     modelPar_given_NK2SISAT,
     modelPar_PK2SISAT,
     modelPar_given_PK2SISAT,
     modelPar_LK2SISAT1,
     modelPar_given_LK2SISAT1,
     modelPar_NK2SISAT1,
     modelPar_given_NK2SISAT1,
     modelPar_PK2SISAT1,
     modelPar_given_PK2SISAT1,
     modelPar_LK2SAT,
     modelPar_given_LK2SAT,
     modelPar_NK2SAT,
     modelPar_given_NK2SAT,
     modelPar_PK2SAT,
     modelPar_given_PK2SAT,
     modelPar_LK2SAT1,
     modelPar_given_LK2SAT1,
     modelPar_NK2SAT1,
     modelPar_given_NK2SAT1,
     modelPar_PK2SAT1,
     modelPar_given_PK2SAT1,
     modelPar_LK2,
     modelPar_given_LK2,
     modelPar_NK2,
     modelPar_given_NK2,
     modelPar_PK2,
     modelPar_given_PK2,
     modelPar_LK21,
     modelPar_given_LK21,
     modelPar_NK21,
     modelPar_given_NK21,
     modelPar_PK21,
     modelPar_given_PK21,
     modelPar_LDVTB,
     modelPar_given_LDVTB,
     modelPar_NDVTB,
     modelPar_given_NDVTB,
     modelPar_PDVTB,
     modelPar_given_PDVTB,
     modelPar_LLPEB,
     modelPar_given_LLPEB,
     modelPar_NLPEB,
     modelPar_given_NLPEB,
     modelPar_PLPEB,
     modelPar_given_PLPEB,
     modelPar_LQMFACTOR,
     modelPar_given_LQMFACTOR,
     modelPar_NQMFACTOR,
     modelPar_given_NQMFACTOR,
     modelPar_PQMFACTOR,
     modelPar_given_PQMFACTOR,
     modelPar_LQMTCENCV,
     modelPar_given_LQMTCENCV,
     modelPar_NQMTCENCV,
     modelPar_given_NQMTCENCV,
     modelPar_PQMTCENCV,
     modelPar_given_PQMTCENCV,
     modelPar_LQMTCENCVA,
     modelPar_given_LQMTCENCVA,
     modelPar_NQMTCENCVA,
     modelPar_given_NQMTCENCVA,
     modelPar_PQMTCENCVA,
     modelPar_given_PQMTCENCVA,
     modelPar_LVSAT,
     modelPar_given_LVSAT,
     modelPar_NVSAT,
     modelPar_given_NVSAT,
     modelPar_PVSAT,
     modelPar_given_PVSAT,
     modelPar_LVSATR,
     modelPar_given_LVSATR,
     modelPar_NVSATR,
     modelPar_given_NVSATR,
     modelPar_PVSATR,
     modelPar_given_PVSATR,
     modelPar_LVSAT1,
     modelPar_given_LVSAT1,
     modelPar_NVSAT1,
     modelPar_given_NVSAT1,
     modelPar_PVSAT1,
     modelPar_given_PVSAT1,
     modelPar_LVSAT1R,
     modelPar_given_LVSAT1R,
     modelPar_NVSAT1R,
     modelPar_given_NVSAT1R,
     modelPar_PVSAT1R,
     modelPar_given_PVSAT1R,
     modelPar_LPSAT,
     modelPar_given_LPSAT,
     modelPar_NPSAT,
     modelPar_given_NPSAT,
     modelPar_PPSAT,
     modelPar_given_PPSAT,
     modelPar_LDELTAVSAT,
     modelPar_given_LDELTAVSAT,
     modelPar_NDELTAVSAT,
     modelPar_given_NDELTAVSAT,
     modelPar_PDELTAVSAT,
     modelPar_given_PDELTAVSAT,
     modelPar_LKSATIV,
     modelPar_given_LKSATIV,
     modelPar_NKSATIV,
     modelPar_given_NKSATIV,
     modelPar_PKSATIV,
     modelPar_given_PKSATIV,
     modelPar_LKSATIVR,
     modelPar_given_LKSATIVR,
     modelPar_NKSATIVR,
     modelPar_given_NKSATIVR,
     modelPar_PKSATIVR,
     modelPar_given_PKSATIVR,
     modelPar_LVSATCV,
     modelPar_given_LVSATCV,
     modelPar_NVSATCV,
     modelPar_given_NVSATCV,
     modelPar_PVSATCV,
     modelPar_given_PVSATCV,
     modelPar_LPSATCV,
     modelPar_given_LPSATCV,
     modelPar_NPSATCV,
     modelPar_given_NPSATCV,
     modelPar_PPSATCV,
     modelPar_given_PPSATCV,
     modelPar_LDELTAVSATCV,
     modelPar_given_LDELTAVSATCV,
     modelPar_NDELTAVSATCV,
     modelPar_given_NDELTAVSATCV,
     modelPar_PDELTAVSATCV,
     modelPar_given_PDELTAVSATCV,
     modelPar_LMEXP,
     modelPar_given_LMEXP,
     modelPar_NMEXP,
     modelPar_given_NMEXP,
     modelPar_PMEXP,
     modelPar_given_PMEXP,
     modelPar_LMEXPR,
     modelPar_given_LMEXPR,
     modelPar_NMEXPR,
     modelPar_given_NMEXPR,
     modelPar_PMEXPR,
     modelPar_given_PMEXPR,
     modelPar_LPTWG,
     modelPar_given_LPTWG,
     modelPar_NPTWG,
     modelPar_given_NPTWG,
     modelPar_PPTWG,
     modelPar_given_PPTWG,
     modelPar_LPTWGR,
     modelPar_given_LPTWGR,
     modelPar_NPTWGR,
     modelPar_given_NPTWGR,
     modelPar_PPTWGR,
     modelPar_given_PPTWGR,
     modelPar_LU0,
     modelPar_given_LU0,
     modelPar_NU0,
     modelPar_given_NU0,
     modelPar_PU0,
     modelPar_given_PU0,
     modelPar_LU0R,
     modelPar_given_LU0R,
     modelPar_NU0R,
     modelPar_given_NU0R,
     modelPar_PU0R,
     modelPar_given_PU0R,
     modelPar_LETAMOB,
     modelPar_given_LETAMOB,
     modelPar_NETAMOB,
     modelPar_given_NETAMOB,
     modelPar_PETAMOB,
     modelPar_given_PETAMOB,
     modelPar_LUP,
     modelPar_given_LUP,
     modelPar_NUP,
     modelPar_given_NUP,
     modelPar_PUP,
     modelPar_given_PUP,
     modelPar_LUPR,
     modelPar_given_LUPR,
     modelPar_NUPR,
     modelPar_given_NUPR,
     modelPar_PUPR,
     modelPar_given_PUPR,
     modelPar_LUA,
     modelPar_given_LUA,
     modelPar_NUA,
     modelPar_given_NUA,
     modelPar_PUA,
     modelPar_given_PUA,
     modelPar_LUAR,
     modelPar_given_LUAR,
     modelPar_NUAR,
     modelPar_given_NUAR,
     modelPar_PUAR,
     modelPar_given_PUAR,
     modelPar_LUC,
     modelPar_given_LUC,
     modelPar_NUC,
     modelPar_given_NUC,
     modelPar_PUC,
     modelPar_given_PUC,
     modelPar_LUCR,
     modelPar_given_LUCR,
     modelPar_NUCR,
     modelPar_given_NUCR,
     modelPar_PUCR,
     modelPar_given_PUCR,
     modelPar_LEU,
     modelPar_given_LEU,
     modelPar_NEU,
     modelPar_given_NEU,
     modelPar_PEU,
     modelPar_given_PEU,
     modelPar_LEUR,
     modelPar_given_LEUR,
     modelPar_NEUR,
     modelPar_given_NEUR,
     modelPar_PEUR,
     modelPar_given_PEUR,
     modelPar_LUD,
     modelPar_given_LUD,
     modelPar_NUD,
     modelPar_given_NUD,
     modelPar_PUD,
     modelPar_given_PUD,
     modelPar_LUDR,
     modelPar_given_LUDR,
     modelPar_NUDR,
     modelPar_given_NUDR,
     modelPar_PUDR,
     modelPar_given_PUDR,
     modelPar_LUCS,
     modelPar_given_LUCS,
     modelPar_NUCS,
     modelPar_given_NUCS,
     modelPar_PUCS,
     modelPar_given_PUCS,
     modelPar_LPCLM,
     modelPar_given_LPCLM,
     modelPar_NPCLM,
     modelPar_given_NPCLM,
     modelPar_PPCLM,
     modelPar_given_PPCLM,
     modelPar_LPCLMR,
     modelPar_given_LPCLMR,
     modelPar_NPCLMR,
     modelPar_given_NPCLMR,
     modelPar_PPCLMR,
     modelPar_given_PPCLMR,
     modelPar_LPCLMG,
     modelPar_given_LPCLMG,
     modelPar_NPCLMG,
     modelPar_given_NPCLMG,
     modelPar_PPCLMG,
     modelPar_given_PPCLMG,
     modelPar_LPCLMCV,
     modelPar_given_LPCLMCV,
     modelPar_NPCLMCV,
     modelPar_given_NPCLMCV,
     modelPar_PPCLMCV,
     modelPar_given_PPCLMCV,
     modelPar_LA1,
     modelPar_given_LA1,
     modelPar_NA1,
     modelPar_given_NA1,
     modelPar_PA1,
     modelPar_given_PA1,
     modelPar_LA11,
     modelPar_given_LA11,
     modelPar_NA11,
     modelPar_given_NA11,
     modelPar_PA11,
     modelPar_given_PA11,
     modelPar_LA2,
     modelPar_given_LA2,
     modelPar_NA2,
     modelPar_given_NA2,
     modelPar_PA2,
     modelPar_given_PA2,
     modelPar_LA21,
     modelPar_given_LA21,
     modelPar_NA21,
     modelPar_given_NA21,
     modelPar_PA21,
     modelPar_given_PA21,
     modelPar_LRDSW,
     modelPar_given_LRDSW,
     modelPar_NRDSW,
     modelPar_given_NRDSW,
     modelPar_PRDSW,
     modelPar_given_PRDSW,
     modelPar_LRSW,
     modelPar_given_LRSW,
     modelPar_NRSW,
     modelPar_given_NRSW,
     modelPar_PRSW,
     modelPar_given_PRSW,
     modelPar_LRDW,
     modelPar_given_LRDW,
     modelPar_NRDW,
     modelPar_given_NRDW,
     modelPar_PRDW,
     modelPar_given_PRDW,
     modelPar_LPRWGS,
     modelPar_given_LPRWGS,
     modelPar_NPRWGS,
     modelPar_given_NPRWGS,
     modelPar_PPRWGS,
     modelPar_given_PPRWGS,
     modelPar_LPRWGD,
     modelPar_given_LPRWGD,
     modelPar_NPRWGD,
     modelPar_given_NPRWGD,
     modelPar_PPRWGD,
     modelPar_given_PPRWGD,
     modelPar_LWR,
     modelPar_given_LWR,
     modelPar_NWR,
     modelPar_given_NWR,
     modelPar_PWR,
     modelPar_given_PWR,
     modelPar_LPDIBL1,
     modelPar_given_LPDIBL1,
     modelPar_NPDIBL1,
     modelPar_given_NPDIBL1,
     modelPar_PPDIBL1,
     modelPar_given_PPDIBL1,
     modelPar_LPDIBL1R,
     modelPar_given_LPDIBL1R,
     modelPar_NPDIBL1R,
     modelPar_given_NPDIBL1R,
     modelPar_PPDIBL1R,
     modelPar_given_PPDIBL1R,
     modelPar_LPDIBL2,
     modelPar_given_LPDIBL2,
     modelPar_NPDIBL2,
     modelPar_given_NPDIBL2,
     modelPar_PPDIBL2,
     modelPar_given_PPDIBL2,
     modelPar_LPDIBL2R,
     modelPar_given_LPDIBL2R,
     modelPar_NPDIBL2R,
     modelPar_given_NPDIBL2R,
     modelPar_PPDIBL2R,
     modelPar_given_PPDIBL2R,
     modelPar_LDROUT,
     modelPar_given_LDROUT,
     modelPar_NDROUT,
     modelPar_given_NDROUT,
     modelPar_PDROUT,
     modelPar_given_PDROUT,
     modelPar_LPVAG,
     modelPar_given_LPVAG,
     modelPar_NPVAG,
     modelPar_given_NPVAG,
     modelPar_PPVAG,
     modelPar_given_PPVAG,
     modelPar_LAIGBINV,
     modelPar_given_LAIGBINV,
     modelPar_NAIGBINV,
     modelPar_given_NAIGBINV,
     modelPar_PAIGBINV,
     modelPar_given_PAIGBINV,
     modelPar_LAIGBINV1,
     modelPar_given_LAIGBINV1,
     modelPar_NAIGBINV1,
     modelPar_given_NAIGBINV1,
     modelPar_PAIGBINV1,
     modelPar_given_PAIGBINV1,
     modelPar_LBIGBINV,
     modelPar_given_LBIGBINV,
     modelPar_NBIGBINV,
     modelPar_given_NBIGBINV,
     modelPar_PBIGBINV,
     modelPar_given_PBIGBINV,
     modelPar_LCIGBINV,
     modelPar_given_LCIGBINV,
     modelPar_NCIGBINV,
     modelPar_given_NCIGBINV,
     modelPar_PCIGBINV,
     modelPar_given_PCIGBINV,
     modelPar_LEIGBINV,
     modelPar_given_LEIGBINV,
     modelPar_NEIGBINV,
     modelPar_given_NEIGBINV,
     modelPar_PEIGBINV,
     modelPar_given_PEIGBINV,
     modelPar_LNIGBINV,
     modelPar_given_LNIGBINV,
     modelPar_NNIGBINV,
     modelPar_given_NNIGBINV,
     modelPar_PNIGBINV,
     modelPar_given_PNIGBINV,
     modelPar_LAIGBACC,
     modelPar_given_LAIGBACC,
     modelPar_NAIGBACC,
     modelPar_given_NAIGBACC,
     modelPar_PAIGBACC,
     modelPar_given_PAIGBACC,
     modelPar_LAIGBACC1,
     modelPar_given_LAIGBACC1,
     modelPar_NAIGBACC1,
     modelPar_given_NAIGBACC1,
     modelPar_PAIGBACC1,
     modelPar_given_PAIGBACC1,
     modelPar_LBIGBACC,
     modelPar_given_LBIGBACC,
     modelPar_NBIGBACC,
     modelPar_given_NBIGBACC,
     modelPar_PBIGBACC,
     modelPar_given_PBIGBACC,
     modelPar_LCIGBACC,
     modelPar_given_LCIGBACC,
     modelPar_NCIGBACC,
     modelPar_given_NCIGBACC,
     modelPar_PCIGBACC,
     modelPar_given_PCIGBACC,
     modelPar_LNIGBACC,
     modelPar_given_LNIGBACC,
     modelPar_NNIGBACC,
     modelPar_given_NNIGBACC,
     modelPar_PNIGBACC,
     modelPar_given_PNIGBACC,
     modelPar_LAIGC,
     modelPar_given_LAIGC,
     modelPar_NAIGC,
     modelPar_given_NAIGC,
     modelPar_PAIGC,
     modelPar_given_PAIGC,
     modelPar_LAIGC1,
     modelPar_given_LAIGC1,
     modelPar_NAIGC1,
     modelPar_given_NAIGC1,
     modelPar_PAIGC1,
     modelPar_given_PAIGC1,
     modelPar_LBIGC,
     modelPar_given_LBIGC,
     modelPar_NBIGC,
     modelPar_given_NBIGC,
     modelPar_PBIGC,
     modelPar_given_PBIGC,
     modelPar_LCIGC,
     modelPar_given_LCIGC,
     modelPar_NCIGC,
     modelPar_given_NCIGC,
     modelPar_PCIGC,
     modelPar_given_PCIGC,
     modelPar_LPIGCD,
     modelPar_given_LPIGCD,
     modelPar_NPIGCD,
     modelPar_given_NPIGCD,
     modelPar_PPIGCD,
     modelPar_given_PPIGCD,
     modelPar_LAIGS,
     modelPar_given_LAIGS,
     modelPar_NAIGS,
     modelPar_given_NAIGS,
     modelPar_PAIGS,
     modelPar_given_PAIGS,
     modelPar_LAIGS1,
     modelPar_given_LAIGS1,
     modelPar_NAIGS1,
     modelPar_given_NAIGS1,
     modelPar_PAIGS1,
     modelPar_given_PAIGS1,
     modelPar_LBIGS,
     modelPar_given_LBIGS,
     modelPar_NBIGS,
     modelPar_given_NBIGS,
     modelPar_PBIGS,
     modelPar_given_PBIGS,
     modelPar_LCIGS,
     modelPar_given_LCIGS,
     modelPar_NCIGS,
     modelPar_given_NCIGS,
     modelPar_PCIGS,
     modelPar_given_PCIGS,
     modelPar_LAIGD,
     modelPar_given_LAIGD,
     modelPar_NAIGD,
     modelPar_given_NAIGD,
     modelPar_PAIGD,
     modelPar_given_PAIGD,
     modelPar_LAIGD1,
     modelPar_given_LAIGD1,
     modelPar_NAIGD1,
     modelPar_given_NAIGD1,
     modelPar_PAIGD1,
     modelPar_given_PAIGD1,
     modelPar_LBIGD,
     modelPar_given_LBIGD,
     modelPar_NBIGD,
     modelPar_given_NBIGD,
     modelPar_PBIGD,
     modelPar_given_PBIGD,
     modelPar_LCIGD,
     modelPar_given_LCIGD,
     modelPar_NCIGD,
     modelPar_given_NCIGD,
     modelPar_PCIGD,
     modelPar_given_PCIGD,
     modelPar_LNTOX,
     modelPar_given_LNTOX,
     modelPar_NNTOX,
     modelPar_given_NNTOX,
     modelPar_PNTOX,
     modelPar_given_PNTOX,
     modelPar_LPOXEDGE,
     modelPar_given_LPOXEDGE,
     modelPar_NPOXEDGE,
     modelPar_given_NPOXEDGE,
     modelPar_PPOXEDGE,
     modelPar_given_PPOXEDGE,
     modelPar_LAGISL,
     modelPar_given_LAGISL,
     modelPar_NAGISL,
     modelPar_given_NAGISL,
     modelPar_PAGISL,
     modelPar_given_PAGISL,
     modelPar_LBGISL,
     modelPar_given_LBGISL,
     modelPar_NBGISL,
     modelPar_given_NBGISL,
     modelPar_PBGISL,
     modelPar_given_PBGISL,
     modelPar_LCGISL,
     modelPar_given_LCGISL,
     modelPar_NCGISL,
     modelPar_given_NCGISL,
     modelPar_PCGISL,
     modelPar_given_PCGISL,
     modelPar_LEGISL,
     modelPar_given_LEGISL,
     modelPar_NEGISL,
     modelPar_given_NEGISL,
     modelPar_PEGISL,
     modelPar_given_PEGISL,
     modelPar_LPGISL,
     modelPar_given_LPGISL,
     modelPar_NPGISL,
     modelPar_given_NPGISL,
     modelPar_PPGISL,
     modelPar_given_PPGISL,
     modelPar_LAGIDL,
     modelPar_given_LAGIDL,
     modelPar_NAGIDL,
     modelPar_given_NAGIDL,
     modelPar_PAGIDL,
     modelPar_given_PAGIDL,
     modelPar_LBGIDL,
     modelPar_given_LBGIDL,
     modelPar_NBGIDL,
     modelPar_given_NBGIDL,
     modelPar_PBGIDL,
     modelPar_given_PBGIDL,
     modelPar_LCGIDL,
     modelPar_given_LCGIDL,
     modelPar_NCGIDL,
     modelPar_given_NCGIDL,
     modelPar_PCGIDL,
     modelPar_given_PCGIDL,
     modelPar_LEGIDL,
     modelPar_given_LEGIDL,
     modelPar_NEGIDL,
     modelPar_given_NEGIDL,
     modelPar_PEGIDL,
     modelPar_given_PEGIDL,
     modelPar_LPGIDL,
     modelPar_given_LPGIDL,
     modelPar_NPGIDL,
     modelPar_given_NPGIDL,
     modelPar_PPGIDL,
     modelPar_given_PPGIDL,
     modelPar_LALPHA0,
     modelPar_given_LALPHA0,
     modelPar_NALPHA0,
     modelPar_given_NALPHA0,
     modelPar_PALPHA0,
     modelPar_given_PALPHA0,
     modelPar_LALPHA1,
     modelPar_given_LALPHA1,
     modelPar_NALPHA1,
     modelPar_given_NALPHA1,
     modelPar_PALPHA1,
     modelPar_given_PALPHA1,
     modelPar_LALPHAII0,
     modelPar_given_LALPHAII0,
     modelPar_NALPHAII0,
     modelPar_given_NALPHAII0,
     modelPar_PALPHAII0,
     modelPar_given_PALPHAII0,
     modelPar_LALPHAII1,
     modelPar_given_LALPHAII1,
     modelPar_NALPHAII1,
     modelPar_given_NALPHAII1,
     modelPar_PALPHAII1,
     modelPar_given_PALPHAII1,
     modelPar_LBETA0,
     modelPar_given_LBETA0,
     modelPar_NBETA0,
     modelPar_given_NBETA0,
     modelPar_PBETA0,
     modelPar_given_PBETA0,
     modelPar_LBETAII0,
     modelPar_given_LBETAII0,
     modelPar_NBETAII0,
     modelPar_given_NBETAII0,
     modelPar_PBETAII0,
     modelPar_given_PBETAII0,
     modelPar_LBETAII1,
     modelPar_given_LBETAII1,
     modelPar_NBETAII1,
     modelPar_given_NBETAII1,
     modelPar_PBETAII1,
     modelPar_given_PBETAII1,
     modelPar_LBETAII2,
     modelPar_given_LBETAII2,
     modelPar_NBETAII2,
     modelPar_given_NBETAII2,
     modelPar_PBETAII2,
     modelPar_given_PBETAII2,
     modelPar_LESATII,
     modelPar_given_LESATII,
     modelPar_NESATII,
     modelPar_given_NESATII,
     modelPar_PESATII,
     modelPar_given_PESATII,
     modelPar_LLII,
     modelPar_given_LLII,
     modelPar_NLII,
     modelPar_given_NLII,
     modelPar_PLII,
     modelPar_given_PLII,
     modelPar_LSII0,
     modelPar_given_LSII0,
     modelPar_NSII0,
     modelPar_given_NSII0,
     modelPar_PSII0,
     modelPar_given_PSII0,
     modelPar_LSII1,
     modelPar_given_LSII1,
     modelPar_NSII1,
     modelPar_given_NSII1,
     modelPar_PSII1,
     modelPar_given_PSII1,
     modelPar_LSII2,
     modelPar_given_LSII2,
     modelPar_NSII2,
     modelPar_given_NSII2,
     modelPar_PSII2,
     modelPar_given_PSII2,
     modelPar_LSIID,
     modelPar_given_LSIID,
     modelPar_NSIID,
     modelPar_given_NSIID,
     modelPar_PSIID,
     modelPar_given_PSIID,
     modelPar_LCFS,
     modelPar_given_LCFS,
     modelPar_NCFS,
     modelPar_given_NCFS,
     modelPar_PCFS,
     modelPar_given_PCFS,
     modelPar_LCFD,
     modelPar_given_LCFD,
     modelPar_NCFD,
     modelPar_given_NCFD,
     modelPar_PCFD,
     modelPar_given_PCFD,
     modelPar_LCOVS,
     modelPar_given_LCOVS,
     modelPar_NCOVS,
     modelPar_given_NCOVS,
     modelPar_PCOVS,
     modelPar_given_PCOVS,
     modelPar_LCOVD,
     modelPar_given_LCOVD,
     modelPar_NCOVD,
     modelPar_given_NCOVD,
     modelPar_PCOVD,
     modelPar_given_PCOVD,
     modelPar_LCGSL,
     modelPar_given_LCGSL,
     modelPar_NCGSL,
     modelPar_given_NCGSL,
     modelPar_PCGSL,
     modelPar_given_PCGSL,
     modelPar_LCGDL,
     modelPar_given_LCGDL,
     modelPar_NCGDL,
     modelPar_given_NCGDL,
     modelPar_PCGDL,
     modelPar_given_PCGDL,
     modelPar_LCKAPPAS,
     modelPar_given_LCKAPPAS,
     modelPar_NCKAPPAS,
     modelPar_given_NCKAPPAS,
     modelPar_PCKAPPAS,
     modelPar_given_PCKAPPAS,
     modelPar_LCKAPPAD,
     modelPar_given_LCKAPPAD,
     modelPar_NCKAPPAD,
     modelPar_given_NCKAPPAD,
     modelPar_PCKAPPAD,
     modelPar_given_PCKAPPAD,
     modelPar_LCGBL,
     modelPar_given_LCGBL,
     modelPar_NCGBL,
     modelPar_given_NCGBL,
     modelPar_PCGBL,
     modelPar_given_PCGBL,
     modelPar_LCKAPPAB,
     modelPar_given_LCKAPPAB,
     modelPar_NCKAPPAB,
     modelPar_given_NCKAPPAB,
     modelPar_PCKAPPAB,
     modelPar_given_PCKAPPAB,
     modelPar_LNTGEN,
     modelPar_given_LNTGEN,
     modelPar_NNTGEN,
     modelPar_given_NNTGEN,
     modelPar_PNTGEN,
     modelPar_given_PNTGEN,
     modelPar_LAIGEN,
     modelPar_given_LAIGEN,
     modelPar_NAIGEN,
     modelPar_given_NAIGEN,
     modelPar_PAIGEN,
     modelPar_given_PAIGEN,
     modelPar_LBIGEN,
     modelPar_given_LBIGEN,
     modelPar_NBIGEN,
     modelPar_given_NBIGEN,
     modelPar_PBIGEN,
     modelPar_given_PBIGEN,
     modelPar_LXRCRG1,
     modelPar_given_LXRCRG1,
     modelPar_NXRCRG1,
     modelPar_given_NXRCRG1,
     modelPar_PXRCRG1,
     modelPar_given_PXRCRG1,
     modelPar_LXRCRG2,
     modelPar_given_LXRCRG2,
     modelPar_NXRCRG2,
     modelPar_given_NXRCRG2,
     modelPar_PXRCRG2,
     modelPar_given_PXRCRG2,
     modelPar_LUTE,
     modelPar_given_LUTE,
     modelPar_NUTE,
     modelPar_given_NUTE,
     modelPar_PUTE,
     modelPar_given_PUTE,
     modelPar_LUTER,
     modelPar_given_LUTER,
     modelPar_NUTER,
     modelPar_given_NUTER,
     modelPar_PUTER,
     modelPar_given_PUTER,
     modelPar_LUTL,
     modelPar_given_LUTL,
     modelPar_NUTL,
     modelPar_given_NUTL,
     modelPar_PUTL,
     modelPar_given_PUTL,
     modelPar_LUTLR,
     modelPar_given_LUTLR,
     modelPar_NUTLR,
     modelPar_given_NUTLR,
     modelPar_PUTLR,
     modelPar_given_PUTLR,
     modelPar_LEMOBT,
     modelPar_given_LEMOBT,
     modelPar_NEMOBT,
     modelPar_given_NEMOBT,
     modelPar_PEMOBT,
     modelPar_given_PEMOBT,
     modelPar_LUA1,
     modelPar_given_LUA1,
     modelPar_NUA1,
     modelPar_given_NUA1,
     modelPar_PUA1,
     modelPar_given_PUA1,
     modelPar_LUA1R,
     modelPar_given_LUA1R,
     modelPar_NUA1R,
     modelPar_given_NUA1R,
     modelPar_PUA1R,
     modelPar_given_PUA1R,
     modelPar_LUC1,
     modelPar_given_LUC1,
     modelPar_NUC1,
     modelPar_given_NUC1,
     modelPar_PUC1,
     modelPar_given_PUC1,
     modelPar_LUC1R,
     modelPar_given_LUC1R,
     modelPar_NUC1R,
     modelPar_given_NUC1R,
     modelPar_PUC1R,
     modelPar_given_PUC1R,
     modelPar_LUD1,
     modelPar_given_LUD1,
     modelPar_NUD1,
     modelPar_given_NUD1,
     modelPar_PUD1,
     modelPar_given_PUD1,
     modelPar_LUD1R,
     modelPar_given_LUD1R,
     modelPar_NUD1R,
     modelPar_given_NUD1R,
     modelPar_PUD1R,
     modelPar_given_PUD1R,
     modelPar_LUCSTE,
     modelPar_given_LUCSTE,
     modelPar_NUCSTE,
     modelPar_given_NUCSTE,
     modelPar_PUCSTE,
     modelPar_given_PUCSTE,
     modelPar_LPTWGT,
     modelPar_given_LPTWGT,
     modelPar_NPTWGT,
     modelPar_given_NPTWGT,
     modelPar_PPTWGT,
     modelPar_given_PPTWGT,
     modelPar_LAT,
     modelPar_given_LAT,
     modelPar_NAT,
     modelPar_given_NAT,
     modelPar_PAT,
     modelPar_given_PAT,
     modelPar_LATR,
     modelPar_given_LATR,
     modelPar_NATR,
     modelPar_given_NATR,
     modelPar_PATR,
     modelPar_given_PATR,
     modelPar_LATCV,
     modelPar_given_LATCV,
     modelPar_NATCV,
     modelPar_given_NATCV,
     modelPar_PATCV,
     modelPar_given_PATCV,
     modelPar_LSTTHETASAT,
     modelPar_given_LSTTHETASAT,
     modelPar_NSTTHETASAT,
     modelPar_given_NSTTHETASAT,
     modelPar_PSTTHETASAT,
     modelPar_given_PSTTHETASAT,
     modelPar_LPRT,
     modelPar_given_LPRT,
     modelPar_NPRT,
     modelPar_given_NPRT,
     modelPar_PPRT,
     modelPar_given_PPRT,
     modelPar_LKT1,
     modelPar_given_LKT1,
     modelPar_NKT1,
     modelPar_given_NKT1,
     modelPar_PKT1,
     modelPar_given_PKT1,
     modelPar_LTSS,
     modelPar_given_LTSS,
     modelPar_NTSS,
     modelPar_given_NTSS,
     modelPar_PTSS,
     modelPar_given_PTSS,
     modelPar_LIIT,
     modelPar_given_LIIT,
     modelPar_NIIT,
     modelPar_given_NIIT,
     modelPar_PIIT,
     modelPar_given_PIIT,
     modelPar_LTII,
     modelPar_given_LTII,
     modelPar_NTII,
     modelPar_given_NTII,
     modelPar_PTII,
     modelPar_given_PTII,
     modelPar_LTGIDL,
     modelPar_given_LTGIDL,
     modelPar_NTGIDL,
     modelPar_given_NTGIDL,
     modelPar_PTGIDL,
     modelPar_given_PTGIDL,
     modelPar_LIGT,
     modelPar_given_LIGT,
     modelPar_NIGT,
     modelPar_given_NIGT,
     modelPar_PIGT,
     modelPar_given_PIGT,
     // non-reals (including hidden)
     modelPar_NF,
     modelPar_given_NF,
     modelPar_NGCON,
     modelPar_given_NGCON,
     modelPar_DEVTYPE,
     modelPar_given_DEVTYPE,
     modelPar_TYPE,
     modelPar_given_TYPE,
     modelPar_BULKMOD,
     modelPar_given_BULKMOD,
     modelPar_GEOMOD,
     modelPar_given_GEOMOD,
     modelPar_CGEO1SW,
     modelPar_given_CGEO1SW,
     modelPar_RDSMOD,
     modelPar_given_RDSMOD,
     modelPar_ASYMMOD,
     modelPar_given_ASYMMOD,
     modelPar_IGCMOD,
     modelPar_given_IGCMOD,
     modelPar_IGBMOD,
     modelPar_given_IGBMOD,
     modelPar_GIDLMOD,
     modelPar_given_GIDLMOD,
     modelPar_IIMOD,
     modelPar_given_IIMOD,
     modelPar_TNOIMOD,
     modelPar_given_TNOIMOD,
     modelPar_NQSMOD,
     modelPar_given_NQSMOD,
     modelPar_SHMOD,
     modelPar_given_SHMOD,
     modelPar_TEMPMOD,
     modelPar_given_TEMPMOD,
     modelPar_RGATEMOD,
     modelPar_given_RGATEMOD,
     modelPar_RGEOMOD,
     modelPar_given_RGEOMOD,
     modelPar_CGEOMOD,
     modelPar_given_CGEOMOD,
     modelPar_SH_WARN,
     modelPar_given_SH_WARN,
     modelPar_IGCLAMP,
     modelPar_given_IGCLAMP,
     modelPar_SDTERM,
     modelPar_given_SDTERM,
     modelPar_NSEG,
     modelPar_given_NSEG,
     in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


  // Now call  the function that does the heavy lifting.
  evaluateModelEquations(
     probeVars,
     // probe constants
     in.admsProbeID_V_N_GND,
     in.admsProbeID_V_g_ge,
     in.admsProbeID_V_s_si,
     in.admsProbeID_V_d_di,
     in.admsProbeID_V_e_ge,
     in.admsProbeID_V_ge_d,
     in.admsProbeID_V_ge_s,
     in.admsProbeID_V_di_d,
     in.admsProbeID_V_si_s,
     in.admsProbeID_V_e_s,
     in.admsProbeID_V_d_s,
     in.admsProbeID_V_g_s,
     in.admsProbeID_V_ge_e,
     in.admsProbeID_V_e_di,
     in.admsProbeID_V_e_si,
     in.admsProbeID_V_ge_di,
     in.admsProbeID_V_di_si,
     in.admsProbeID_V_ge_si,
     in.admsProbeID_Temp_t_GND,

     // node constants
     in.admsNodeID_d,
     in.admsNodeID_g,
     in.admsNodeID_s,
     in.admsNodeID_e,
     in.admsNodeID_t,
     in.admsNodeID_si,
     in.admsNodeID_di,
     in.admsNodeID_ge,
     in.admsNodeID_N,
     // instance parameters
     // reals
     instancePar_L,
     instancePar_given_L,
     instancePar_D,
     instancePar_given_D,
     instancePar_TFIN,
     instancePar_given_TFIN,
     instancePar_FPITCH,
     instancePar_given_FPITCH,
     instancePar_NFIN,
     instancePar_given_NFIN,
     instancePar_ASEO,
     instancePar_given_ASEO,
     instancePar_ADEO,
     instancePar_given_ADEO,
     instancePar_PSEO,
     instancePar_given_PSEO,
     instancePar_PDEO,
     instancePar_given_PDEO,
     instancePar_ASEJ,
     instancePar_given_ASEJ,
     instancePar_ADEJ,
     instancePar_given_ADEJ,
     instancePar_PSEJ,
     instancePar_given_PSEJ,
     instancePar_PDEJ,
     instancePar_given_PDEJ,
     instancePar_COVS,
     instancePar_given_COVS,
     instancePar_COVD,
     instancePar_given_COVD,
     instancePar_CGSP,
     instancePar_given_CGSP,
     instancePar_CGDP,
     instancePar_given_CGDP,
     instancePar_CDSP,
     instancePar_given_CDSP,
     instancePar_NRS,
     instancePar_given_NRS,
     instancePar_NRD,
     instancePar_given_NRD,
     instancePar_LRSD,
     instancePar_given_LRSD,
     instancePar_NFINNOM,
     instancePar_given_NFINNOM,
     instancePar_m,
     instancePar_given_m,
     // non-reals(including hidden)
     instancePar_NF,
     instancePar_given_NF,
     instancePar_NGCON,
     instancePar_given_NGCON,
     // instance variables
     // reals
     instanceVar_NFINtotal,
     instanceVar_ids,
     instanceVar_sigvds,
     instanceVar_qd,
     instanceVar_qg,
     instanceVar_qs,
     instanceVar_qb,
     instanceVar_epssub,
     instanceVar_epsratio,
     instanceVar_Leff,
     instanceVar_LeffCV,
     instanceVar_LeffCV_acc,
     instanceVar_Weff0,
     instanceVar_WeffCV0,
     instanceVar_cox,
     instanceVar_nbody,
     instanceVar_T0,
     instanceVar_T1,
     instanceVar_T2,
     instanceVar_T3,
     instanceVar_Tnom,
     instanceVar_PTWGR_t,
     instanceVar_CJS_t,
     instanceVar_CJSWS_t,
     instanceVar_CJSWGD_t,
     instanceVar_CJD_t,
     instanceVar_CJSWD_t,
     instanceVar_CJSWGS_t,
     instanceVar_PBS_t,
     instanceVar_PBSWS_t,
     instanceVar_PBSWGS_t,
     instanceVar_PBD_t,
     instanceVar_PBSWD_t,
     instanceVar_PBSWGD_t,
     instanceVar_JSS_t,
     instanceVar_JSWS_t,
     instanceVar_JSWGS_t,
     instanceVar_JSD_t,
     instanceVar_JSWD_t,
     instanceVar_JSWGD_t,
     instanceVar_JTSS_t,
     instanceVar_JTSD_t,
     instanceVar_JTSSWS_t,
     instanceVar_JTSSWD_t,
     instanceVar_JTSSWGS_t,
     instanceVar_JTSSWGD_t,
     instanceVar_NJTS_t,
     instanceVar_NJTSD_t,
     instanceVar_NJTSSW_t,
     instanceVar_NJTSSWD_t,
     instanceVar_NJTSSWG_t,
     instanceVar_NJTSSWGD_t,
     instanceVar_q0,
     instanceVar_T11,
     instanceVar_T12,
     instanceVar_e0,
     instanceVar_e1,
     instanceVar_e2,
     instanceVar_scl,
     instanceVar_tmp,
     instanceVar_Theta_SCE,
     instanceVar_Theta_SW,
     instanceVar_Theta_DIBL,
     instanceVar_Theta_RSCE,
     instanceVar_Theta_DITS,
     instanceVar_veseff,
     instanceVar_Tcen0,
     instanceVar_Tcen,
     instanceVar_mx,
     instanceVar_mxprime,
     instanceVar_md,
     instanceVar_mdprime,
     instanceVar_gprime,
     instanceVar_gfactor,
     instanceVar_qis,
     instanceVar_qid,
     instanceVar_qbs,
     instanceVar_qba,
     instanceVar_u0r,
     instanceVar_UAR_t,
     instanceVar_UC_t,
     instanceVar_UCR_t,
     instanceVar_UDR_t,
     instanceVar_U0R_t,
     instanceVar_EeffFactor,
     instanceVar_Dr,
     instanceVar_WeffWRFactor,
     instanceVar_RSourceGeo,
     instanceVar_RDrainGeo,
     instanceVar_RDSWMIN_i,
     instanceVar_RDWMIN_i,
     instanceVar_RSWMIN_i,
     instanceVar_Rdrain,
     instanceVar_Rsource,
     instanceVar_Rdsi,
     instanceVar_RSDRR_t,
     instanceVar_RDDRR_t,
     instanceVar_VSAT1R_t,
     instanceVar_MEXPR_t,
     instanceVar_VSAT_a,
     instanceVar_Cfr_geo,
     instanceVar_ggeltd,
     instanceVar_igbinv,
     instanceVar_igsd_mult0,
     instanceVar_igbs,
     instanceVar_igbd,
     instanceVar_igbacc,
     instanceVar_igcs,
     instanceVar_igcd,
     instanceVar_igisl,
     instanceVar_igidl,
     instanceVar_igs,
     instanceVar_igd,
     instanceVar_Aechvb,
     instanceVar_Bechvb,
     instanceVar_Toxratio,
     instanceVar_Iii,
     instanceVar_cox_acc,
     instanceVar_qg_acc,
     instanceVar_qb_acc,
     instanceVar_qgs_fr,
     instanceVar_qgd_fr,
     instanceVar_qds_fr,
     instanceVar_qgs_parasitic,
     instanceVar_qgd_parasitic,
     instanceVar_Qes,
     instanceVar_Qed,
     instanceVar_Qeg,
     instanceVar_csbox,
     instanceVar_cdbox,
     instanceVar_cgbox,
     instanceVar_Ies,
     instanceVar_Ied,
     instanceVar_Czbs,
     instanceVar_Czbssw,
     instanceVar_Czbsswg,
     instanceVar_Czbd,
     instanceVar_Czbdsw,
     instanceVar_Czbdswg,
     instanceVar_Isbs,
     instanceVar_Isbd,
     instanceVar_Nvtms,
     instanceVar_Nvtmd,
     instanceVar_SslpRev,
     instanceVar_IVjsmRev,
     instanceVar_VjsmRev,
     instanceVar_SslpFwd,
     instanceVar_IVjsmFwd,
     instanceVar_VjsmFwd,
     instanceVar_XExpBVS,
     instanceVar_DslpRev,
     instanceVar_IVjdmRev,
     instanceVar_VjdmRev,
     instanceVar_DslpFwd,
     instanceVar_IVjdmFwd,
     instanceVar_VjdmFwd,
     instanceVar_XExpBVD,
     instanceVar_idsgen,
     instanceVar_LINTIGEN_i,
     instanceVar_LINTNOI_i,
     instanceVar_litl,
     instanceVar_FNPowerAt1Hz,
     instanceVar_NTNOI_i,
     instanceVar_Gtnoi,
     instanceVar_sid,
     instanceVar_gspr,
     instanceVar_gdpr,
     instanceVar_gamma,
     instanceVar_delta,
     instanceVar_ctnoi,
     instanceVar_C0,
     instanceVar_sf,
     instanceVar_gth,
     instanceVar_cth,
     instanceVar_PHIG_i,
     instanceVar_CFD_i,
     instanceVar_CFS_i,
     instanceVar_COVS_i,
     instanceVar_COVD_i,
     instanceVar_CGSO_i,
     instanceVar_CGDO_i,
     instanceVar_CGSL_i,
     instanceVar_CGDL_i,
     instanceVar_CGBL_i,
     instanceVar_CKAPPAS_i,
     instanceVar_CKAPPAD_i,
     instanceVar_CKAPPAB_i,
     instanceVar_QMFACTOR_i,
     instanceVar_QMTCENCV_i,
     instanceVar_QMTCENCVA_i,
     instanceVar_KSATIV_i,
     instanceVar_KSATIVR_i,
     instanceVar_CDSC_i,
     instanceVar_CDSCD_i,
     instanceVar_CDSCDR_i,
     instanceVar_CIT_i,
     instanceVar_DVT0_i,
     instanceVar_CITR_i,
     instanceVar_PHIN_i,
     instanceVar_ETA0_i,
     instanceVar_ETA0R_i,
     instanceVar_VSAT_i,
     instanceVar_VSATR_i,
     instanceVar_VSATR_t,
     instanceVar_DVTP0_i,
     instanceVar_DVTP1_i,
     instanceVar_K0_i,
     instanceVar_K01_i,
     instanceVar_K0SI_i,
     instanceVar_K0SI1_i,
     instanceVar_K2SI_i,
     instanceVar_K2SI1_i,
     instanceVar_PHIBE_i,
     instanceVar_K1_i,
     instanceVar_K11_i,
     instanceVar_K2SAT_i,
     instanceVar_K2SAT1_i,
     instanceVar_DELTAVSAT_i,
     instanceVar_PSAT_i,
     instanceVar_DELTAVSATCV_i,
     instanceVar_PSATCV_i,
     instanceVar_VSAT1_i,
     instanceVar_VSAT1R_i,
     instanceVar_PTWG_i,
     instanceVar_PTWGR_i,
     instanceVar_VSATCV_i,
     instanceVar_U0_i,
     instanceVar_U0R_i,
     instanceVar_ETAMOB_i,
     instanceVar_RDSW_i,
     instanceVar_PRWGS_i,
     instanceVar_PRWGD_i,
     instanceVar_PDIBL1_i,
     instanceVar_PDIBL1R_i,
     instanceVar_PDIBL2_i,
     instanceVar_PDIBL2R_i,
     instanceVar_DROUT_i,
     instanceVar_PVAG_i,
     instanceVar_AIGBINV_i,
     instanceVar_AIGBINV1_i,
     instanceVar_BIGBINV_i,
     instanceVar_CIGBINV_i,
     instanceVar_EIGBINV_i,
     instanceVar_NIGBINV_i,
     instanceVar_AIGBACC_i,
     instanceVar_AIGBACC1_i,
     instanceVar_BIGBACC_i,
     instanceVar_CIGBACC_i,
     instanceVar_NIGBACC_i,
     instanceVar_AIGC_i,
     instanceVar_AIGC1_i,
     instanceVar_BIGC_i,
     instanceVar_CIGC_i,
     instanceVar_PIGCD_i,
     instanceVar_AIGS_i,
     instanceVar_AIGS1_i,
     instanceVar_BIGS_i,
     instanceVar_CIGS_i,
     instanceVar_POXEDGE_i,
     instanceVar_AIGD_i,
     instanceVar_AIGD1_i,
     instanceVar_BIGD_i,
     instanceVar_CIGD_i,
     instanceVar_AGIDL_i,
     instanceVar_BGIDL_i,
     instanceVar_CGIDL_i,
     instanceVar_EGIDL_i,
     instanceVar_PGIDL_i,
     instanceVar_AGISL_i,
     instanceVar_BGISL_i,
     instanceVar_CGISL_i,
     instanceVar_EGISL_i,
     instanceVar_PGISL_i,
     instanceVar_ALPHA0_i,
     instanceVar_ALPHA1_i,
     instanceVar_ALPHAII0_i,
     instanceVar_ALPHAII1_i,
     instanceVar_BETA0_i,
     instanceVar_BETAII0_i,
     instanceVar_BETAII1_i,
     instanceVar_BETAII2_i,
     instanceVar_ESATII_i,
     instanceVar_LII_i,
     instanceVar_SII0_i,
     instanceVar_SII1_i,
     instanceVar_SII2_i,
     instanceVar_SIID_i,
     instanceVar_TII_i,
     instanceVar_MEXP_i,
     instanceVar_MEXPR_i,
     instanceVar_PCLM_i,
     instanceVar_PCLMG_i,
     instanceVar_PCLMCV_i,
     instanceVar_PCLMR_i,
     instanceVar_A1_i,
     instanceVar_A2_i,
     instanceVar_A11_i,
     instanceVar_A21_i,
     instanceVar_K1RSCE_i,
     instanceVar_DVTSHIFT_i,
     instanceVar_DVTSHIFTR_i,
     instanceVar_UA_i,
     instanceVar_UC_i,
     instanceVar_EU_i,
     instanceVar_UD_i,
     instanceVar_UCS_i,
     instanceVar_UAR_i,
     instanceVar_EUR_i,
     instanceVar_UCR_i,
     instanceVar_UDR_i,
     instanceVar_UA1_i,
     instanceVar_UA1R_i,
     instanceVar_UC1_i,
     instanceVar_UD1_i,
     instanceVar_UCSTE_i,
     instanceVar_UTE_i,
     instanceVar_UTL_i,
     instanceVar_EMOBT_i,
     instanceVar_UC1R_i,
     instanceVar_UD1R_i,
     instanceVar_UTER_i,
     instanceVar_UTLR_i,
     instanceVar_PTWGT_i,
     instanceVar_AT_i,
     instanceVar_ATCV_i,
     instanceVar_ATR_i,
     instanceVar_RDW_i,
     instanceVar_RSW_i,
     instanceVar_PRT_i,
     instanceVar_KT1_i,
     instanceVar_TSS_i,
     instanceVar_IIT_i,
     instanceVar_IGT_i,
     instanceVar_TGIDL_i,
     instanceVar_NTGEN_i,
     instanceVar_AIGEN_i,
     instanceVar_BIGEN_i,
     instanceVar_K0SISAT_i,
     instanceVar_K0SISAT1_i,
     instanceVar_K2SISAT_i,
     instanceVar_K2SISAT1_i,
     instanceVar_K2_i,
     instanceVar_K21_i,
     instanceVar_Cins,
     instanceVar_Ach,
     instanceVar_Weff_UFCM,
     instanceVar_qdep,
     instanceVar_rc,
     instanceVar_vth_fixed_factor_Sub,
     instanceVar_vth_fixed_factor_SI,
     instanceVar_qm,
     instanceVar_Qdep_ov_Cins,
     instanceVar_qi_acc_for_QM,
     instanceVar_fieldnormalizationfactor,
     instanceVar_auxQMfact,
     instanceVar_QMFACTORCVfinal,
     instanceVar_psipclamp,
     instanceVar_sqrtpsip,
     instanceVar_nq,
     instanceVar_F0,
     // non-reals
     instanceVar_devsign,
     // model parameters
     // reals
     modelPar_L,
     modelPar_given_L,
     modelPar_D,
     modelPar_given_D,
     modelPar_TFIN,
     modelPar_given_TFIN,
     modelPar_FPITCH,
     modelPar_given_FPITCH,
     modelPar_NFIN,
     modelPar_given_NFIN,
     modelPar_ASEO,
     modelPar_given_ASEO,
     modelPar_ADEO,
     modelPar_given_ADEO,
     modelPar_PSEO,
     modelPar_given_PSEO,
     modelPar_PDEO,
     modelPar_given_PDEO,
     modelPar_ASEJ,
     modelPar_given_ASEJ,
     modelPar_ADEJ,
     modelPar_given_ADEJ,
     modelPar_PSEJ,
     modelPar_given_PSEJ,
     modelPar_PDEJ,
     modelPar_given_PDEJ,
     modelPar_COVS,
     modelPar_given_COVS,
     modelPar_COVD,
     modelPar_given_COVD,
     modelPar_CGSP,
     modelPar_given_CGSP,
     modelPar_CGDP,
     modelPar_given_CGDP,
     modelPar_CDSP,
     modelPar_given_CDSP,
     modelPar_NRS,
     modelPar_given_NRS,
     modelPar_NRD,
     modelPar_given_NRD,
     modelPar_LRSD,
     modelPar_given_LRSD,
     modelPar_XL,
     modelPar_given_XL,
     modelPar_DTEMP,
     modelPar_given_DTEMP,
     modelPar_DELVTRAND,
     modelPar_given_DELVTRAND,
     modelPar_U0MULT,
     modelPar_given_U0MULT,
     modelPar_IDS0MULT,
     modelPar_given_IDS0MULT,
     modelPar_LINT,
     modelPar_given_LINT,
     modelPar_LL,
     modelPar_given_LL,
     modelPar_LLN,
     modelPar_given_LLN,
     modelPar_DLC,
     modelPar_given_DLC,
     modelPar_DLCACC,
     modelPar_given_DLCACC,
     modelPar_DLBIN,
     modelPar_given_DLBIN,
     modelPar_LLC,
     modelPar_given_LLC,
     modelPar_EOT,
     modelPar_given_EOT,
     modelPar_TOXP,
     modelPar_given_TOXP,
     modelPar_EOTBOX,
     modelPar_given_EOTBOX,
     modelPar_HFIN,
     modelPar_given_HFIN,
     modelPar_FECH,
     modelPar_given_FECH,
     modelPar_DELTAW,
     modelPar_given_DELTAW,
     modelPar_FECHCV,
     modelPar_given_FECHCV,
     modelPar_DELTAWCV,
     modelPar_given_DELTAWCV,
     modelPar_NBODY,
     modelPar_given_NBODY,
     modelPar_NBODYN1,
     modelPar_given_NBODYN1,
     modelPar_NBODYN2,
     modelPar_given_NBODYN2,
     modelPar_NSD,
     modelPar_given_NSD,
     modelPar_PHIG,
     modelPar_given_PHIG,
     modelPar_PHIGL,
     modelPar_given_PHIGL,
     modelPar_PHIGLT,
     modelPar_given_PHIGLT,
     modelPar_PHIGN1,
     modelPar_given_PHIGN1,
     modelPar_PHIGN2,
     modelPar_given_PHIGN2,
     modelPar_EPSROX,
     modelPar_given_EPSROX,
     modelPar_EPSRSUB,
     modelPar_given_EPSRSUB,
     modelPar_EASUB,
     modelPar_given_EASUB,
     modelPar_NI0SUB,
     modelPar_given_NI0SUB,
     modelPar_BG0SUB,
     modelPar_given_BG0SUB,
     modelPar_NC0SUB,
     modelPar_given_NC0SUB,
     modelPar_NGATE,
     modelPar_given_NGATE,
     modelPar_Imin,
     modelPar_given_Imin,
     modelPar_CIT,
     modelPar_given_CIT,
     modelPar_CITR,
     modelPar_given_CITR,
     modelPar_CDSC,
     modelPar_given_CDSC,
     modelPar_CDSCN1,
     modelPar_given_CDSCN1,
     modelPar_CDSCN2,
     modelPar_given_CDSCN2,
     modelPar_CDSCD,
     modelPar_given_CDSCD,
     modelPar_CDSCDN1,
     modelPar_given_CDSCDN1,
     modelPar_CDSCDN2,
     modelPar_given_CDSCDN2,
     modelPar_CDSCDR,
     modelPar_given_CDSCDR,
     modelPar_CDSCDRN1,
     modelPar_given_CDSCDRN1,
     modelPar_CDSCDRN2,
     modelPar_given_CDSCDRN2,
     modelPar_DVT0,
     modelPar_given_DVT0,
     modelPar_DVT1,
     modelPar_given_DVT1,
     modelPar_DVT1SS,
     modelPar_given_DVT1SS,
     modelPar_PHIN,
     modelPar_given_PHIN,
     modelPar_ETA0,
     modelPar_given_ETA0,
     modelPar_ETA0N1,
     modelPar_given_ETA0N1,
     modelPar_ETA0N2,
     modelPar_given_ETA0N2,
     modelPar_ETA0LT,
     modelPar_given_ETA0LT,
     modelPar_TETA0,
     modelPar_given_TETA0,
     modelPar_ETA0R,
     modelPar_given_ETA0R,
     modelPar_TETA0R,
     modelPar_given_TETA0R,
     modelPar_DSUB,
     modelPar_given_DSUB,
     modelPar_DVTP0,
     modelPar_given_DVTP0,
     modelPar_DVTP1,
     modelPar_given_DVTP1,
     modelPar_ADVTP0,
     modelPar_given_ADVTP0,
     modelPar_BDVTP0,
     modelPar_given_BDVTP0,
     modelPar_ADVTP1,
     modelPar_given_ADVTP1,
     modelPar_BDVTP1,
     modelPar_given_BDVTP1,
     modelPar_DVTP2,
     modelPar_given_DVTP2,
     modelPar_K1RSCE,
     modelPar_given_K1RSCE,
     modelPar_LPE0,
     modelPar_given_LPE0,
     modelPar_DVTSHIFT,
     modelPar_given_DVTSHIFT,
     modelPar_DVTSHIFTR,
     modelPar_given_DVTSHIFTR,
     modelPar_THETASCE,
     modelPar_given_THETASCE,
     modelPar_THETADIBL,
     modelPar_given_THETADIBL,
     modelPar_THETASW,
     modelPar_given_THETASW,
     modelPar_NVTM,
     modelPar_given_NVTM,
     modelPar_K0,
     modelPar_given_K0,
     modelPar_K01,
     modelPar_given_K01,
     modelPar_K0SI,
     modelPar_given_K0SI,
     modelPar_K0SI1,
     modelPar_given_K0SI1,
     modelPar_K2SI,
     modelPar_given_K2SI,
     modelPar_K2SI1,
     modelPar_given_K2SI1,
     modelPar_K0SISAT,
     modelPar_given_K0SISAT,
     modelPar_K0SISAT1,
     modelPar_given_K0SISAT1,
     modelPar_K2SISAT,
     modelPar_given_K2SISAT,
     modelPar_K2SISAT1,
     modelPar_given_K2SISAT1,
     modelPar_PHIBE,
     modelPar_given_PHIBE,
     modelPar_K1,
     modelPar_given_K1,
     modelPar_K11,
     modelPar_given_K11,
     modelPar_K2SAT,
     modelPar_given_K2SAT,
     modelPar_K2SAT1,
     modelPar_given_K2SAT1,
     modelPar_K2,
     modelPar_given_K2,
     modelPar_K21,
     modelPar_given_K21,
     modelPar_QMFACTOR,
     modelPar_given_QMFACTOR,
     modelPar_QMTCENCV,
     modelPar_given_QMTCENCV,
     modelPar_QMTCENCVA,
     modelPar_given_QMTCENCVA,
     modelPar_AQMTCEN,
     modelPar_given_AQMTCEN,
     modelPar_BQMTCEN,
     modelPar_given_BQMTCEN,
     modelPar_ETAQM,
     modelPar_given_ETAQM,
     modelPar_QM0,
     modelPar_given_QM0,
     modelPar_PQM,
     modelPar_given_PQM,
     modelPar_QM0ACC,
     modelPar_given_QM0ACC,
     modelPar_PQMACC,
     modelPar_given_PQMACC,
     modelPar_VSAT,
     modelPar_given_VSAT,
     modelPar_VSATR,
     modelPar_given_VSATR,
     modelPar_VSATN1,
     modelPar_given_VSATN1,
     modelPar_VSATN2,
     modelPar_given_VSATN2,
     modelPar_VSATRN1,
     modelPar_given_VSATRN1,
     modelPar_VSATRN2,
     modelPar_given_VSATRN2,
     modelPar_AVSAT,
     modelPar_given_AVSAT,
     modelPar_BVSAT,
     modelPar_given_BVSAT,
     modelPar_VSAT1,
     modelPar_given_VSAT1,
     modelPar_VSAT1N1,
     modelPar_given_VSAT1N1,
     modelPar_VSAT1N2,
     modelPar_given_VSAT1N2,
     modelPar_VSAT1R,
     modelPar_given_VSAT1R,
     modelPar_VSAT1RN1,
     modelPar_given_VSAT1RN1,
     modelPar_VSAT1RN2,
     modelPar_given_VSAT1RN2,
     modelPar_AVSAT1,
     modelPar_given_AVSAT1,
     modelPar_BVSAT1,
     modelPar_given_BVSAT1,
     modelPar_DELTAVSAT,
     modelPar_given_DELTAVSAT,
     modelPar_PSAT,
     modelPar_given_PSAT,
     modelPar_APSAT,
     modelPar_given_APSAT,
     modelPar_BPSAT,
     modelPar_given_BPSAT,
     modelPar_KSATIV,
     modelPar_given_KSATIV,
     modelPar_KSATIVR,
     modelPar_given_KSATIVR,
     modelPar_VSATCV,
     modelPar_given_VSATCV,
     modelPar_AVSATCV,
     modelPar_given_AVSATCV,
     modelPar_BVSATCV,
     modelPar_given_BVSATCV,
     modelPar_DELTAVSATCV,
     modelPar_given_DELTAVSATCV,
     modelPar_PSATCV,
     modelPar_given_PSATCV,
     modelPar_APSATCV,
     modelPar_given_APSATCV,
     modelPar_BPSATCV,
     modelPar_given_BPSATCV,
     modelPar_MEXP,
     modelPar_given_MEXP,
     modelPar_AMEXP,
     modelPar_given_AMEXP,
     modelPar_BMEXP,
     modelPar_given_BMEXP,
     modelPar_MEXPR,
     modelPar_given_MEXPR,
     modelPar_AMEXPR,
     modelPar_given_AMEXPR,
     modelPar_BMEXPR,
     modelPar_given_BMEXPR,
     modelPar_PTWG,
     modelPar_given_PTWG,
     modelPar_PTWGR,
     modelPar_given_PTWGR,
     modelPar_APTWG,
     modelPar_given_APTWG,
     modelPar_BPTWG,
     modelPar_given_BPTWG,
     modelPar_AT,
     modelPar_given_AT,
     modelPar_ATR,
     modelPar_given_ATR,
     modelPar_ATCV,
     modelPar_given_ATCV,
     modelPar_TMEXP,
     modelPar_given_TMEXP,
     modelPar_TMEXPR,
     modelPar_given_TMEXPR,
     modelPar_PTWGT,
     modelPar_given_PTWGT,
     modelPar_U0,
     modelPar_given_U0,
     modelPar_U0R,
     modelPar_given_U0R,
     modelPar_U0N1,
     modelPar_given_U0N1,
     modelPar_U0N1R,
     modelPar_given_U0N1R,
     modelPar_U0N2,
     modelPar_given_U0N2,
     modelPar_U0N2R,
     modelPar_given_U0N2R,
     modelPar_U0LT,
     modelPar_given_U0LT,
     modelPar_ETAMOB,
     modelPar_given_ETAMOB,
     modelPar_UP,
     modelPar_given_UP,
     modelPar_LPA,
     modelPar_given_LPA,
     modelPar_UPR,
     modelPar_given_UPR,
     modelPar_LPAR,
     modelPar_given_LPAR,
     modelPar_UA,
     modelPar_given_UA,
     modelPar_UAR,
     modelPar_given_UAR,
     modelPar_AUA,
     modelPar_given_AUA,
     modelPar_AUAR,
     modelPar_given_AUAR,
     modelPar_BUA,
     modelPar_given_BUA,
     modelPar_BUAR,
     modelPar_given_BUAR,
     modelPar_UC,
     modelPar_given_UC,
     modelPar_UCR,
     modelPar_given_UCR,
     modelPar_EU,
     modelPar_given_EU,
     modelPar_EUR,
     modelPar_given_EUR,
     modelPar_AEU,
     modelPar_given_AEU,
     modelPar_AEUR,
     modelPar_given_AEUR,
     modelPar_BEU,
     modelPar_given_BEU,
     modelPar_BEUR,
     modelPar_given_BEUR,
     modelPar_UD,
     modelPar_given_UD,
     modelPar_UDR,
     modelPar_given_UDR,
     modelPar_AUD,
     modelPar_given_AUD,
     modelPar_AUDR,
     modelPar_given_AUDR,
     modelPar_BUD,
     modelPar_given_BUD,
     modelPar_BUDR,
     modelPar_given_BUDR,
     modelPar_UCS,
     modelPar_given_UCS,
     modelPar_UTE,
     modelPar_given_UTE,
     modelPar_UTER,
     modelPar_given_UTER,
     modelPar_UTL,
     modelPar_given_UTL,
     modelPar_UTLR,
     modelPar_given_UTLR,
     modelPar_EMOBT,
     modelPar_given_EMOBT,
     modelPar_UA1,
     modelPar_given_UA1,
     modelPar_UA1R,
     modelPar_given_UA1R,
     modelPar_UC1,
     modelPar_given_UC1,
     modelPar_UC1R,
     modelPar_given_UC1R,
     modelPar_UD1,
     modelPar_given_UD1,
     modelPar_UD1R,
     modelPar_given_UD1R,
     modelPar_UCSTE,
     modelPar_given_UCSTE,
     modelPar_CHARGEWF,
     modelPar_given_CHARGEWF,
     modelPar_RDSWMIN,
     modelPar_given_RDSWMIN,
     modelPar_RDSW,
     modelPar_given_RDSW,
     modelPar_ARDSW,
     modelPar_given_ARDSW,
     modelPar_BRDSW,
     modelPar_given_BRDSW,
     modelPar_RSWMIN,
     modelPar_given_RSWMIN,
     modelPar_RSW,
     modelPar_given_RSW,
     modelPar_ARSW,
     modelPar_given_ARSW,
     modelPar_BRSW,
     modelPar_given_BRSW,
     modelPar_RDWMIN,
     modelPar_given_RDWMIN,
     modelPar_RDW,
     modelPar_given_RDW,
     modelPar_ARDW,
     modelPar_given_ARDW,
     modelPar_BRDW,
     modelPar_given_BRDW,
     modelPar_RSDR,
     modelPar_given_RSDR,
     modelPar_RSDRR,
     modelPar_given_RSDRR,
     modelPar_RDDR,
     modelPar_given_RDDR,
     modelPar_RDDRR,
     modelPar_given_RDDRR,
     modelPar_PRSDR,
     modelPar_given_PRSDR,
     modelPar_PRDDR,
     modelPar_given_PRDDR,
     modelPar_PRWGS,
     modelPar_given_PRWGS,
     modelPar_PRWGD,
     modelPar_given_PRWGD,
     modelPar_WR,
     modelPar_given_WR,
     modelPar_PRT,
     modelPar_given_PRT,
     modelPar_TRSDR,
     modelPar_given_TRSDR,
     modelPar_TRDDR,
     modelPar_given_TRDDR,
     modelPar_PDIBL1,
     modelPar_given_PDIBL1,
     modelPar_PDIBL1R,
     modelPar_given_PDIBL1R,
     modelPar_PDIBL2,
     modelPar_given_PDIBL2,
     modelPar_PDIBL2R,
     modelPar_given_PDIBL2R,
     modelPar_DROUT,
     modelPar_given_DROUT,
     modelPar_PVAG,
     modelPar_given_PVAG,
     modelPar_PCLM,
     modelPar_given_PCLM,
     modelPar_PCLMR,
     modelPar_given_PCLMR,
     modelPar_APCLM,
     modelPar_given_APCLM,
     modelPar_APCLMR,
     modelPar_given_APCLMR,
     modelPar_BPCLM,
     modelPar_given_BPCLM,
     modelPar_BPCLMR,
     modelPar_given_BPCLMR,
     modelPar_PCLMG,
     modelPar_given_PCLMG,
     modelPar_PCLMCV,
     modelPar_given_PCLMCV,
     modelPar_A1,
     modelPar_given_A1,
     modelPar_A11,
     modelPar_given_A11,
     modelPar_A2,
     modelPar_given_A2,
     modelPar_A21,
     modelPar_given_A21,
     modelPar_RGEXT,
     modelPar_given_RGEXT,
     modelPar_RGFIN,
     modelPar_given_RGFIN,
     modelPar_RSHS,
     modelPar_given_RSHS,
     modelPar_RSHD,
     modelPar_given_RSHD,
     modelPar_HEPI,
     modelPar_given_HEPI,
     modelPar_TSILI,
     modelPar_given_TSILI,
     modelPar_RHOC,
     modelPar_given_RHOC,
     modelPar_RHORSD,
     modelPar_given_RHORSD,
     modelPar_CRATIO,
     modelPar_given_CRATIO,
     modelPar_DELTAPRSD,
     modelPar_given_DELTAPRSD,
     modelPar_LSP,
     modelPar_given_LSP,
     modelPar_EPSRSP,
     modelPar_given_EPSRSP,
     modelPar_TGATE,
     modelPar_given_TGATE,
     modelPar_TMASK,
     modelPar_given_TMASK,
     modelPar_ASILIEND,
     modelPar_given_ASILIEND,
     modelPar_ARSDEND,
     modelPar_given_ARSDEND,
     modelPar_PRSDEND,
     modelPar_given_PRSDEND,
     modelPar_NSDE,
     modelPar_given_NSDE,
     modelPar_RGEOA,
     modelPar_given_RGEOA,
     modelPar_RGEOB,
     modelPar_given_RGEOB,
     modelPar_RGEOC,
     modelPar_given_RGEOC,
     modelPar_RGEOD,
     modelPar_given_RGEOD,
     modelPar_RGEOE,
     modelPar_given_RGEOE,
     modelPar_CGEOA,
     modelPar_given_CGEOA,
     modelPar_CGEOB,
     modelPar_given_CGEOB,
     modelPar_CGEOC,
     modelPar_given_CGEOC,
     modelPar_CGEOD,
     modelPar_given_CGEOD,
     modelPar_CGEOE,
     modelPar_given_CGEOE,
     modelPar_AIGBINV,
     modelPar_given_AIGBINV,
     modelPar_AIGBINV1,
     modelPar_given_AIGBINV1,
     modelPar_BIGBINV,
     modelPar_given_BIGBINV,
     modelPar_CIGBINV,
     modelPar_given_CIGBINV,
     modelPar_EIGBINV,
     modelPar_given_EIGBINV,
     modelPar_NIGBINV,
     modelPar_given_NIGBINV,
     modelPar_AIGBACC,
     modelPar_given_AIGBACC,
     modelPar_AIGBACC1,
     modelPar_given_AIGBACC1,
     modelPar_BIGBACC,
     modelPar_given_BIGBACC,
     modelPar_CIGBACC,
     modelPar_given_CIGBACC,
     modelPar_NIGBACC,
     modelPar_given_NIGBACC,
     modelPar_AIGC,
     modelPar_given_AIGC,
     modelPar_AIGC1,
     modelPar_given_AIGC1,
     modelPar_BIGC,
     modelPar_given_BIGC,
     modelPar_CIGC,
     modelPar_given_CIGC,
     modelPar_PIGCD,
     modelPar_given_PIGCD,
     modelPar_DLCIGS,
     modelPar_given_DLCIGS,
     modelPar_AIGS,
     modelPar_given_AIGS,
     modelPar_AIGS1,
     modelPar_given_AIGS1,
     modelPar_BIGS,
     modelPar_given_BIGS,
     modelPar_CIGS,
     modelPar_given_CIGS,
     modelPar_DLCIGD,
     modelPar_given_DLCIGD,
     modelPar_AIGD,
     modelPar_given_AIGD,
     modelPar_AIGD1,
     modelPar_given_AIGD1,
     modelPar_BIGD,
     modelPar_given_BIGD,
     modelPar_CIGD,
     modelPar_given_CIGD,
     modelPar_VFBSD,
     modelPar_given_VFBSD,
     modelPar_VFBSDCV,
     modelPar_given_VFBSDCV,
     modelPar_TOXREF,
     modelPar_given_TOXREF,
     modelPar_TOXG,
     modelPar_given_TOXG,
     modelPar_NTOX,
     modelPar_given_NTOX,
     modelPar_POXEDGE,
     modelPar_given_POXEDGE,
     modelPar_AGISL,
     modelPar_given_AGISL,
     modelPar_BGISL,
     modelPar_given_BGISL,
     modelPar_CGISL,
     modelPar_given_CGISL,
     modelPar_EGISL,
     modelPar_given_EGISL,
     modelPar_PGISL,
     modelPar_given_PGISL,
     modelPar_AGIDL,
     modelPar_given_AGIDL,
     modelPar_BGIDL,
     modelPar_given_BGIDL,
     modelPar_CGIDL,
     modelPar_given_CGIDL,
     modelPar_EGIDL,
     modelPar_given_EGIDL,
     modelPar_PGIDL,
     modelPar_given_PGIDL,
     modelPar_ALPHA0,
     modelPar_given_ALPHA0,
     modelPar_ALPHA01,
     modelPar_given_ALPHA01,
     modelPar_ALPHA1,
     modelPar_given_ALPHA1,
     modelPar_ALPHA11,
     modelPar_given_ALPHA11,
     modelPar_BETA0,
     modelPar_given_BETA0,
     modelPar_ALPHAII0,
     modelPar_given_ALPHAII0,
     modelPar_ALPHAII01,
     modelPar_given_ALPHAII01,
     modelPar_ALPHAII1,
     modelPar_given_ALPHAII1,
     modelPar_ALPHAII11,
     modelPar_given_ALPHAII11,
     modelPar_BETAII0,
     modelPar_given_BETAII0,
     modelPar_BETAII1,
     modelPar_given_BETAII1,
     modelPar_BETAII2,
     modelPar_given_BETAII2,
     modelPar_ESATII,
     modelPar_given_ESATII,
     modelPar_LII,
     modelPar_given_LII,
     modelPar_SII0,
     modelPar_given_SII0,
     modelPar_SII1,
     modelPar_given_SII1,
     modelPar_SII2,
     modelPar_given_SII2,
     modelPar_SIID,
     modelPar_given_SIID,
     modelPar_IIMOD2CLAMP1,
     modelPar_given_IIMOD2CLAMP1,
     modelPar_IIMOD2CLAMP2,
     modelPar_given_IIMOD2CLAMP2,
     modelPar_IIMOD2CLAMP3,
     modelPar_given_IIMOD2CLAMP3,
     modelPar_EOTACC,
     modelPar_given_EOTACC,
     modelPar_DELVFBACC,
     modelPar_given_DELVFBACC,
     modelPar_CFS,
     modelPar_given_CFS,
     modelPar_CFD,
     modelPar_given_CFD,
     modelPar_CGSO,
     modelPar_given_CGSO,
     modelPar_CGDO,
     modelPar_given_CGDO,
     modelPar_CGSL,
     modelPar_given_CGSL,
     modelPar_CGDL,
     modelPar_given_CGDL,
     modelPar_CKAPPAS,
     modelPar_given_CKAPPAS,
     modelPar_CKAPPAD,
     modelPar_given_CKAPPAD,
     modelPar_CGBO,
     modelPar_given_CGBO,
     modelPar_CGBN,
     modelPar_given_CGBN,
     modelPar_CGBL,
     modelPar_given_CGBL,
     modelPar_CKAPPAB,
     modelPar_given_CKAPPAB,
     modelPar_CSDESW,
     modelPar_given_CSDESW,
     modelPar_CJS,
     modelPar_given_CJS,
     modelPar_CJD,
     modelPar_given_CJD,
     modelPar_CJSWS,
     modelPar_given_CJSWS,
     modelPar_CJSWD,
     modelPar_given_CJSWD,
     modelPar_CJSWGS,
     modelPar_given_CJSWGS,
     modelPar_CJSWGD,
     modelPar_given_CJSWGD,
     modelPar_PBS,
     modelPar_given_PBS,
     modelPar_PBD,
     modelPar_given_PBD,
     modelPar_PBSWS,
     modelPar_given_PBSWS,
     modelPar_PBSWD,
     modelPar_given_PBSWD,
     modelPar_PBSWGS,
     modelPar_given_PBSWGS,
     modelPar_PBSWGD,
     modelPar_given_PBSWGD,
     modelPar_MJS,
     modelPar_given_MJS,
     modelPar_MJD,
     modelPar_given_MJD,
     modelPar_MJSWS,
     modelPar_given_MJSWS,
     modelPar_MJSWD,
     modelPar_given_MJSWD,
     modelPar_MJSWGS,
     modelPar_given_MJSWGS,
     modelPar_MJSWGD,
     modelPar_given_MJSWGD,
     modelPar_SJS,
     modelPar_given_SJS,
     modelPar_SJD,
     modelPar_given_SJD,
     modelPar_SJSWS,
     modelPar_given_SJSWS,
     modelPar_SJSWD,
     modelPar_given_SJSWD,
     modelPar_SJSWGS,
     modelPar_given_SJSWGS,
     modelPar_SJSWGD,
     modelPar_given_SJSWGD,
     modelPar_MJS2,
     modelPar_given_MJS2,
     modelPar_MJD2,
     modelPar_given_MJD2,
     modelPar_MJSWS2,
     modelPar_given_MJSWS2,
     modelPar_MJSWD2,
     modelPar_given_MJSWD2,
     modelPar_MJSWGS2,
     modelPar_given_MJSWGS2,
     modelPar_MJSWGD2,
     modelPar_given_MJSWGD2,
     modelPar_JSS,
     modelPar_given_JSS,
     modelPar_JSD,
     modelPar_given_JSD,
     modelPar_JSWS,
     modelPar_given_JSWS,
     modelPar_JSWD,
     modelPar_given_JSWD,
     modelPar_JSWGS,
     modelPar_given_JSWGS,
     modelPar_JSWGD,
     modelPar_given_JSWGD,
     modelPar_NJS,
     modelPar_given_NJS,
     modelPar_NJD,
     modelPar_given_NJD,
     modelPar_IJTHSFWD,
     modelPar_given_IJTHSFWD,
     modelPar_IJTHDFWD,
     modelPar_given_IJTHDFWD,
     modelPar_IJTHSREV,
     modelPar_given_IJTHSREV,
     modelPar_IJTHDREV,
     modelPar_given_IJTHDREV,
     modelPar_BVS,
     modelPar_given_BVS,
     modelPar_BVD,
     modelPar_given_BVD,
     modelPar_XJBVS,
     modelPar_given_XJBVS,
     modelPar_XJBVD,
     modelPar_given_XJBVD,
     modelPar_JTSS,
     modelPar_given_JTSS,
     modelPar_JTSD,
     modelPar_given_JTSD,
     modelPar_JTSSWS,
     modelPar_given_JTSSWS,
     modelPar_JTSSWD,
     modelPar_given_JTSSWD,
     modelPar_JTSSWGS,
     modelPar_given_JTSSWGS,
     modelPar_JTSSWGD,
     modelPar_given_JTSSWGD,
     modelPar_JTWEFF,
     modelPar_given_JTWEFF,
     modelPar_NJTS,
     modelPar_given_NJTS,
     modelPar_NJTSD,
     modelPar_given_NJTSD,
     modelPar_NJTSSW,
     modelPar_given_NJTSSW,
     modelPar_NJTSSWD,
     modelPar_given_NJTSSWD,
     modelPar_NJTSSWG,
     modelPar_given_NJTSSWG,
     modelPar_NJTSSWGD,
     modelPar_given_NJTSSWGD,
     modelPar_VTSS,
     modelPar_given_VTSS,
     modelPar_VTSD,
     modelPar_given_VTSD,
     modelPar_VTSSWS,
     modelPar_given_VTSSWS,
     modelPar_VTSSWD,
     modelPar_given_VTSSWD,
     modelPar_VTSSWGS,
     modelPar_given_VTSSWGS,
     modelPar_VTSSWGD,
     modelPar_given_VTSSWGD,
     modelPar_LINTIGEN,
     modelPar_given_LINTIGEN,
     modelPar_NTGEN,
     modelPar_given_NTGEN,
     modelPar_AIGEN,
     modelPar_given_AIGEN,
     modelPar_BIGEN,
     modelPar_given_BIGEN,
     modelPar_XRCRG1,
     modelPar_given_XRCRG1,
     modelPar_XRCRG2,
     modelPar_given_XRCRG2,
     modelPar_EF,
     modelPar_given_EF,
     modelPar_EM,
     modelPar_given_EM,
     modelPar_NOIA,
     modelPar_given_NOIA,
     modelPar_NOIB,
     modelPar_given_NOIB,
     modelPar_NOIC,
     modelPar_given_NOIC,
     modelPar_LINTNOI,
     modelPar_given_LINTNOI,
     modelPar_NTNOI,
     modelPar_given_NTNOI,
     modelPar_TNOIA,
     modelPar_given_TNOIA,
     modelPar_TNOIB,
     modelPar_given_TNOIB,
     modelPar_RNOIA,
     modelPar_given_RNOIA,
     modelPar_RNOIB,
     modelPar_given_RNOIB,
     modelPar_TNOIC,
     modelPar_given_TNOIC,
     modelPar_RNOIC,
     modelPar_given_RNOIC,
     modelPar_SCALEN,
     modelPar_given_SCALEN,
     modelPar_TNOM,
     modelPar_given_TNOM,
     modelPar_TBGASUB,
     modelPar_given_TBGASUB,
     modelPar_TBGBSUB,
     modelPar_given_TBGBSUB,
     modelPar_KT1,
     modelPar_given_KT1,
     modelPar_KT1L,
     modelPar_given_KT1L,
     modelPar_TSS,
     modelPar_given_TSS,
     modelPar_IIT,
     modelPar_given_IIT,
     modelPar_TII,
     modelPar_given_TII,
     modelPar_TGIDL,
     modelPar_given_TGIDL,
     modelPar_IGT,
     modelPar_given_IGT,
     modelPar_TCJ,
     modelPar_given_TCJ,
     modelPar_TCJSW,
     modelPar_given_TCJSW,
     modelPar_TCJSWG,
     modelPar_given_TCJSWG,
     modelPar_TPB,
     modelPar_given_TPB,
     modelPar_TPBSW,
     modelPar_given_TPBSW,
     modelPar_TPBSWG,
     modelPar_given_TPBSWG,
     modelPar_XTIS,
     modelPar_given_XTIS,
     modelPar_XTID,
     modelPar_given_XTID,
     modelPar_XTSS,
     modelPar_given_XTSS,
     modelPar_XTSD,
     modelPar_given_XTSD,
     modelPar_XTSSWS,
     modelPar_given_XTSSWS,
     modelPar_XTSSWD,
     modelPar_given_XTSSWD,
     modelPar_XTSSWGS,
     modelPar_given_XTSSWGS,
     modelPar_XTSSWGD,
     modelPar_given_XTSSWGD,
     modelPar_TNJTS,
     modelPar_given_TNJTS,
     modelPar_TNJTSD,
     modelPar_given_TNJTSD,
     modelPar_TNJTSSW,
     modelPar_given_TNJTSSW,
     modelPar_TNJTSSWD,
     modelPar_given_TNJTSSWD,
     modelPar_TNJTSSWG,
     modelPar_given_TNJTSSWG,
     modelPar_TNJTSSWGD,
     modelPar_given_TNJTSSWGD,
     modelPar_RTH0,
     modelPar_given_RTH0,
     modelPar_CTH0,
     modelPar_given_CTH0,
     modelPar_WTH0,
     modelPar_given_WTH0,
     modelPar_ASHEXP,
     modelPar_given_ASHEXP,
     modelPar_BSHEXP,
     modelPar_given_BSHEXP,
     modelPar_ACH_UFCM,
     modelPar_given_ACH_UFCM,
     modelPar_CINS_UFCM,
     modelPar_given_CINS_UFCM,
     modelPar_W_UFCM,
     modelPar_given_W_UFCM,
     modelPar_TFIN_TOP,
     modelPar_given_TFIN_TOP,
     modelPar_TFIN_BASE,
     modelPar_given_TFIN_BASE,
     modelPar_QMFACTORCV,
     modelPar_given_QMFACTORCV,
     modelPar_ALPHA_UFCM,
     modelPar_given_ALPHA_UFCM,
     modelPar_LNBODY,
     modelPar_given_LNBODY,
     modelPar_NNBODY,
     modelPar_given_NNBODY,
     modelPar_PNBODY,
     modelPar_given_PNBODY,
     modelPar_LPHIG,
     modelPar_given_LPHIG,
     modelPar_NPHIG,
     modelPar_given_NPHIG,
     modelPar_PPHIG,
     modelPar_given_PPHIG,
     modelPar_LNGATE,
     modelPar_given_LNGATE,
     modelPar_NNGATE,
     modelPar_given_NNGATE,
     modelPar_PNGATE,
     modelPar_given_PNGATE,
     modelPar_LCIT,
     modelPar_given_LCIT,
     modelPar_NCIT,
     modelPar_given_NCIT,
     modelPar_PCIT,
     modelPar_given_PCIT,
     modelPar_LCITR,
     modelPar_given_LCITR,
     modelPar_NCITR,
     modelPar_given_NCITR,
     modelPar_PCITR,
     modelPar_given_PCITR,
     modelPar_LCDSC,
     modelPar_given_LCDSC,
     modelPar_NCDSC,
     modelPar_given_NCDSC,
     modelPar_PCDSC,
     modelPar_given_PCDSC,
     modelPar_LCDSCD,
     modelPar_given_LCDSCD,
     modelPar_NCDSCD,
     modelPar_given_NCDSCD,
     modelPar_PCDSCD,
     modelPar_given_PCDSCD,
     modelPar_LCDSCDR,
     modelPar_given_LCDSCDR,
     modelPar_NCDSCDR,
     modelPar_given_NCDSCDR,
     modelPar_PCDSCDR,
     modelPar_given_PCDSCDR,
     modelPar_LDVT0,
     modelPar_given_LDVT0,
     modelPar_NDVT0,
     modelPar_given_NDVT0,
     modelPar_PDVT0,
     modelPar_given_PDVT0,
     modelPar_LDVT1,
     modelPar_given_LDVT1,
     modelPar_NDVT1,
     modelPar_given_NDVT1,
     modelPar_PDVT1,
     modelPar_given_PDVT1,
     modelPar_LDVT1SS,
     modelPar_given_LDVT1SS,
     modelPar_NDVT1SS,
     modelPar_given_NDVT1SS,
     modelPar_PDVT1SS,
     modelPar_given_PDVT1SS,
     modelPar_LPHIN,
     modelPar_given_LPHIN,
     modelPar_NPHIN,
     modelPar_given_NPHIN,
     modelPar_PPHIN,
     modelPar_given_PPHIN,
     modelPar_LETA0,
     modelPar_given_LETA0,
     modelPar_NETA0,
     modelPar_given_NETA0,
     modelPar_PETA0,
     modelPar_given_PETA0,
     modelPar_LETA0R,
     modelPar_given_LETA0R,
     modelPar_NETA0R,
     modelPar_given_NETA0R,
     modelPar_PETA0R,
     modelPar_given_PETA0R,
     modelPar_LDSUB,
     modelPar_given_LDSUB,
     modelPar_NDSUB,
     modelPar_given_NDSUB,
     modelPar_PDSUB,
     modelPar_given_PDSUB,
     modelPar_LK1RSCE,
     modelPar_given_LK1RSCE,
     modelPar_NK1RSCE,
     modelPar_given_NK1RSCE,
     modelPar_PK1RSCE,
     modelPar_given_PK1RSCE,
     modelPar_LLPE0,
     modelPar_given_LLPE0,
     modelPar_NLPE0,
     modelPar_given_NLPE0,
     modelPar_PLPE0,
     modelPar_given_PLPE0,
     modelPar_LDVTSHIFT,
     modelPar_given_LDVTSHIFT,
     modelPar_NDVTSHIFT,
     modelPar_given_NDVTSHIFT,
     modelPar_PDVTSHIFT,
     modelPar_given_PDVTSHIFT,
     modelPar_LDVTSHIFTR,
     modelPar_given_LDVTSHIFTR,
     modelPar_NDVTSHIFTR,
     modelPar_given_NDVTSHIFTR,
     modelPar_PDVTSHIFTR,
     modelPar_given_PDVTSHIFTR,
     modelPar_LPHIBE,
     modelPar_given_LPHIBE,
     modelPar_NPHIBE,
     modelPar_given_NPHIBE,
     modelPar_PPHIBE,
     modelPar_given_PPHIBE,
     modelPar_LK0,
     modelPar_given_LK0,
     modelPar_NK0,
     modelPar_given_NK0,
     modelPar_PK0,
     modelPar_given_PK0,
     modelPar_LK01,
     modelPar_given_LK01,
     modelPar_NK01,
     modelPar_given_NK01,
     modelPar_PK01,
     modelPar_given_PK01,
     modelPar_LK0SI,
     modelPar_given_LK0SI,
     modelPar_NK0SI,
     modelPar_given_NK0SI,
     modelPar_PK0SI,
     modelPar_given_PK0SI,
     modelPar_LK0SI1,
     modelPar_given_LK0SI1,
     modelPar_NK0SI1,
     modelPar_given_NK0SI1,
     modelPar_PK0SI1,
     modelPar_given_PK0SI1,
     modelPar_LK1,
     modelPar_given_LK1,
     modelPar_NK1,
     modelPar_given_NK1,
     modelPar_PK1,
     modelPar_given_PK1,
     modelPar_LK11,
     modelPar_given_LK11,
     modelPar_NK11,
     modelPar_given_NK11,
     modelPar_PK11,
     modelPar_given_PK11,
     modelPar_LK2SI,
     modelPar_given_LK2SI,
     modelPar_NK2SI,
     modelPar_given_NK2SI,
     modelPar_PK2SI,
     modelPar_given_PK2SI,
     modelPar_LK2SI1,
     modelPar_given_LK2SI1,
     modelPar_NK2SI1,
     modelPar_given_NK2SI1,
     modelPar_PK2SI1,
     modelPar_given_PK2SI1,
     modelPar_LK0SISAT,
     modelPar_given_LK0SISAT,
     modelPar_NK0SISAT,
     modelPar_given_NK0SISAT,
     modelPar_PK0SISAT,
     modelPar_given_PK0SISAT,
     modelPar_LK0SISAT1,
     modelPar_given_LK0SISAT1,
     modelPar_NK0SISAT1,
     modelPar_given_NK0SISAT1,
     modelPar_PK0SISAT1,
     modelPar_given_PK0SISAT1,
     modelPar_LK2SISAT,
     modelPar_given_LK2SISAT,
     modelPar_NK2SISAT,
     modelPar_given_NK2SISAT,
     modelPar_PK2SISAT,
     modelPar_given_PK2SISAT,
     modelPar_LK2SISAT1,
     modelPar_given_LK2SISAT1,
     modelPar_NK2SISAT1,
     modelPar_given_NK2SISAT1,
     modelPar_PK2SISAT1,
     modelPar_given_PK2SISAT1,
     modelPar_LK2SAT,
     modelPar_given_LK2SAT,
     modelPar_NK2SAT,
     modelPar_given_NK2SAT,
     modelPar_PK2SAT,
     modelPar_given_PK2SAT,
     modelPar_LK2SAT1,
     modelPar_given_LK2SAT1,
     modelPar_NK2SAT1,
     modelPar_given_NK2SAT1,
     modelPar_PK2SAT1,
     modelPar_given_PK2SAT1,
     modelPar_LK2,
     modelPar_given_LK2,
     modelPar_NK2,
     modelPar_given_NK2,
     modelPar_PK2,
     modelPar_given_PK2,
     modelPar_LK21,
     modelPar_given_LK21,
     modelPar_NK21,
     modelPar_given_NK21,
     modelPar_PK21,
     modelPar_given_PK21,
     modelPar_LDVTB,
     modelPar_given_LDVTB,
     modelPar_NDVTB,
     modelPar_given_NDVTB,
     modelPar_PDVTB,
     modelPar_given_PDVTB,
     modelPar_LLPEB,
     modelPar_given_LLPEB,
     modelPar_NLPEB,
     modelPar_given_NLPEB,
     modelPar_PLPEB,
     modelPar_given_PLPEB,
     modelPar_LQMFACTOR,
     modelPar_given_LQMFACTOR,
     modelPar_NQMFACTOR,
     modelPar_given_NQMFACTOR,
     modelPar_PQMFACTOR,
     modelPar_given_PQMFACTOR,
     modelPar_LQMTCENCV,
     modelPar_given_LQMTCENCV,
     modelPar_NQMTCENCV,
     modelPar_given_NQMTCENCV,
     modelPar_PQMTCENCV,
     modelPar_given_PQMTCENCV,
     modelPar_LQMTCENCVA,
     modelPar_given_LQMTCENCVA,
     modelPar_NQMTCENCVA,
     modelPar_given_NQMTCENCVA,
     modelPar_PQMTCENCVA,
     modelPar_given_PQMTCENCVA,
     modelPar_LVSAT,
     modelPar_given_LVSAT,
     modelPar_NVSAT,
     modelPar_given_NVSAT,
     modelPar_PVSAT,
     modelPar_given_PVSAT,
     modelPar_LVSATR,
     modelPar_given_LVSATR,
     modelPar_NVSATR,
     modelPar_given_NVSATR,
     modelPar_PVSATR,
     modelPar_given_PVSATR,
     modelPar_LVSAT1,
     modelPar_given_LVSAT1,
     modelPar_NVSAT1,
     modelPar_given_NVSAT1,
     modelPar_PVSAT1,
     modelPar_given_PVSAT1,
     modelPar_LVSAT1R,
     modelPar_given_LVSAT1R,
     modelPar_NVSAT1R,
     modelPar_given_NVSAT1R,
     modelPar_PVSAT1R,
     modelPar_given_PVSAT1R,
     modelPar_LPSAT,
     modelPar_given_LPSAT,
     modelPar_NPSAT,
     modelPar_given_NPSAT,
     modelPar_PPSAT,
     modelPar_given_PPSAT,
     modelPar_LDELTAVSAT,
     modelPar_given_LDELTAVSAT,
     modelPar_NDELTAVSAT,
     modelPar_given_NDELTAVSAT,
     modelPar_PDELTAVSAT,
     modelPar_given_PDELTAVSAT,
     modelPar_LKSATIV,
     modelPar_given_LKSATIV,
     modelPar_NKSATIV,
     modelPar_given_NKSATIV,
     modelPar_PKSATIV,
     modelPar_given_PKSATIV,
     modelPar_LKSATIVR,
     modelPar_given_LKSATIVR,
     modelPar_NKSATIVR,
     modelPar_given_NKSATIVR,
     modelPar_PKSATIVR,
     modelPar_given_PKSATIVR,
     modelPar_LVSATCV,
     modelPar_given_LVSATCV,
     modelPar_NVSATCV,
     modelPar_given_NVSATCV,
     modelPar_PVSATCV,
     modelPar_given_PVSATCV,
     modelPar_LPSATCV,
     modelPar_given_LPSATCV,
     modelPar_NPSATCV,
     modelPar_given_NPSATCV,
     modelPar_PPSATCV,
     modelPar_given_PPSATCV,
     modelPar_LDELTAVSATCV,
     modelPar_given_LDELTAVSATCV,
     modelPar_NDELTAVSATCV,
     modelPar_given_NDELTAVSATCV,
     modelPar_PDELTAVSATCV,
     modelPar_given_PDELTAVSATCV,
     modelPar_LMEXP,
     modelPar_given_LMEXP,
     modelPar_NMEXP,
     modelPar_given_NMEXP,
     modelPar_PMEXP,
     modelPar_given_PMEXP,
     modelPar_LMEXPR,
     modelPar_given_LMEXPR,
     modelPar_NMEXPR,
     modelPar_given_NMEXPR,
     modelPar_PMEXPR,
     modelPar_given_PMEXPR,
     modelPar_LPTWG,
     modelPar_given_LPTWG,
     modelPar_NPTWG,
     modelPar_given_NPTWG,
     modelPar_PPTWG,
     modelPar_given_PPTWG,
     modelPar_LPTWGR,
     modelPar_given_LPTWGR,
     modelPar_NPTWGR,
     modelPar_given_NPTWGR,
     modelPar_PPTWGR,
     modelPar_given_PPTWGR,
     modelPar_LU0,
     modelPar_given_LU0,
     modelPar_NU0,
     modelPar_given_NU0,
     modelPar_PU0,
     modelPar_given_PU0,
     modelPar_LU0R,
     modelPar_given_LU0R,
     modelPar_NU0R,
     modelPar_given_NU0R,
     modelPar_PU0R,
     modelPar_given_PU0R,
     modelPar_LETAMOB,
     modelPar_given_LETAMOB,
     modelPar_NETAMOB,
     modelPar_given_NETAMOB,
     modelPar_PETAMOB,
     modelPar_given_PETAMOB,
     modelPar_LUP,
     modelPar_given_LUP,
     modelPar_NUP,
     modelPar_given_NUP,
     modelPar_PUP,
     modelPar_given_PUP,
     modelPar_LUPR,
     modelPar_given_LUPR,
     modelPar_NUPR,
     modelPar_given_NUPR,
     modelPar_PUPR,
     modelPar_given_PUPR,
     modelPar_LUA,
     modelPar_given_LUA,
     modelPar_NUA,
     modelPar_given_NUA,
     modelPar_PUA,
     modelPar_given_PUA,
     modelPar_LUAR,
     modelPar_given_LUAR,
     modelPar_NUAR,
     modelPar_given_NUAR,
     modelPar_PUAR,
     modelPar_given_PUAR,
     modelPar_LUC,
     modelPar_given_LUC,
     modelPar_NUC,
     modelPar_given_NUC,
     modelPar_PUC,
     modelPar_given_PUC,
     modelPar_LUCR,
     modelPar_given_LUCR,
     modelPar_NUCR,
     modelPar_given_NUCR,
     modelPar_PUCR,
     modelPar_given_PUCR,
     modelPar_LEU,
     modelPar_given_LEU,
     modelPar_NEU,
     modelPar_given_NEU,
     modelPar_PEU,
     modelPar_given_PEU,
     modelPar_LEUR,
     modelPar_given_LEUR,
     modelPar_NEUR,
     modelPar_given_NEUR,
     modelPar_PEUR,
     modelPar_given_PEUR,
     modelPar_LUD,
     modelPar_given_LUD,
     modelPar_NUD,
     modelPar_given_NUD,
     modelPar_PUD,
     modelPar_given_PUD,
     modelPar_LUDR,
     modelPar_given_LUDR,
     modelPar_NUDR,
     modelPar_given_NUDR,
     modelPar_PUDR,
     modelPar_given_PUDR,
     modelPar_LUCS,
     modelPar_given_LUCS,
     modelPar_NUCS,
     modelPar_given_NUCS,
     modelPar_PUCS,
     modelPar_given_PUCS,
     modelPar_LPCLM,
     modelPar_given_LPCLM,
     modelPar_NPCLM,
     modelPar_given_NPCLM,
     modelPar_PPCLM,
     modelPar_given_PPCLM,
     modelPar_LPCLMR,
     modelPar_given_LPCLMR,
     modelPar_NPCLMR,
     modelPar_given_NPCLMR,
     modelPar_PPCLMR,
     modelPar_given_PPCLMR,
     modelPar_LPCLMG,
     modelPar_given_LPCLMG,
     modelPar_NPCLMG,
     modelPar_given_NPCLMG,
     modelPar_PPCLMG,
     modelPar_given_PPCLMG,
     modelPar_LPCLMCV,
     modelPar_given_LPCLMCV,
     modelPar_NPCLMCV,
     modelPar_given_NPCLMCV,
     modelPar_PPCLMCV,
     modelPar_given_PPCLMCV,
     modelPar_LA1,
     modelPar_given_LA1,
     modelPar_NA1,
     modelPar_given_NA1,
     modelPar_PA1,
     modelPar_given_PA1,
     modelPar_LA11,
     modelPar_given_LA11,
     modelPar_NA11,
     modelPar_given_NA11,
     modelPar_PA11,
     modelPar_given_PA11,
     modelPar_LA2,
     modelPar_given_LA2,
     modelPar_NA2,
     modelPar_given_NA2,
     modelPar_PA2,
     modelPar_given_PA2,
     modelPar_LA21,
     modelPar_given_LA21,
     modelPar_NA21,
     modelPar_given_NA21,
     modelPar_PA21,
     modelPar_given_PA21,
     modelPar_LRDSW,
     modelPar_given_LRDSW,
     modelPar_NRDSW,
     modelPar_given_NRDSW,
     modelPar_PRDSW,
     modelPar_given_PRDSW,
     modelPar_LRSW,
     modelPar_given_LRSW,
     modelPar_NRSW,
     modelPar_given_NRSW,
     modelPar_PRSW,
     modelPar_given_PRSW,
     modelPar_LRDW,
     modelPar_given_LRDW,
     modelPar_NRDW,
     modelPar_given_NRDW,
     modelPar_PRDW,
     modelPar_given_PRDW,
     modelPar_LPRWGS,
     modelPar_given_LPRWGS,
     modelPar_NPRWGS,
     modelPar_given_NPRWGS,
     modelPar_PPRWGS,
     modelPar_given_PPRWGS,
     modelPar_LPRWGD,
     modelPar_given_LPRWGD,
     modelPar_NPRWGD,
     modelPar_given_NPRWGD,
     modelPar_PPRWGD,
     modelPar_given_PPRWGD,
     modelPar_LWR,
     modelPar_given_LWR,
     modelPar_NWR,
     modelPar_given_NWR,
     modelPar_PWR,
     modelPar_given_PWR,
     modelPar_LPDIBL1,
     modelPar_given_LPDIBL1,
     modelPar_NPDIBL1,
     modelPar_given_NPDIBL1,
     modelPar_PPDIBL1,
     modelPar_given_PPDIBL1,
     modelPar_LPDIBL1R,
     modelPar_given_LPDIBL1R,
     modelPar_NPDIBL1R,
     modelPar_given_NPDIBL1R,
     modelPar_PPDIBL1R,
     modelPar_given_PPDIBL1R,
     modelPar_LPDIBL2,
     modelPar_given_LPDIBL2,
     modelPar_NPDIBL2,
     modelPar_given_NPDIBL2,
     modelPar_PPDIBL2,
     modelPar_given_PPDIBL2,
     modelPar_LPDIBL2R,
     modelPar_given_LPDIBL2R,
     modelPar_NPDIBL2R,
     modelPar_given_NPDIBL2R,
     modelPar_PPDIBL2R,
     modelPar_given_PPDIBL2R,
     modelPar_LDROUT,
     modelPar_given_LDROUT,
     modelPar_NDROUT,
     modelPar_given_NDROUT,
     modelPar_PDROUT,
     modelPar_given_PDROUT,
     modelPar_LPVAG,
     modelPar_given_LPVAG,
     modelPar_NPVAG,
     modelPar_given_NPVAG,
     modelPar_PPVAG,
     modelPar_given_PPVAG,
     modelPar_LAIGBINV,
     modelPar_given_LAIGBINV,
     modelPar_NAIGBINV,
     modelPar_given_NAIGBINV,
     modelPar_PAIGBINV,
     modelPar_given_PAIGBINV,
     modelPar_LAIGBINV1,
     modelPar_given_LAIGBINV1,
     modelPar_NAIGBINV1,
     modelPar_given_NAIGBINV1,
     modelPar_PAIGBINV1,
     modelPar_given_PAIGBINV1,
     modelPar_LBIGBINV,
     modelPar_given_LBIGBINV,
     modelPar_NBIGBINV,
     modelPar_given_NBIGBINV,
     modelPar_PBIGBINV,
     modelPar_given_PBIGBINV,
     modelPar_LCIGBINV,
     modelPar_given_LCIGBINV,
     modelPar_NCIGBINV,
     modelPar_given_NCIGBINV,
     modelPar_PCIGBINV,
     modelPar_given_PCIGBINV,
     modelPar_LEIGBINV,
     modelPar_given_LEIGBINV,
     modelPar_NEIGBINV,
     modelPar_given_NEIGBINV,
     modelPar_PEIGBINV,
     modelPar_given_PEIGBINV,
     modelPar_LNIGBINV,
     modelPar_given_LNIGBINV,
     modelPar_NNIGBINV,
     modelPar_given_NNIGBINV,
     modelPar_PNIGBINV,
     modelPar_given_PNIGBINV,
     modelPar_LAIGBACC,
     modelPar_given_LAIGBACC,
     modelPar_NAIGBACC,
     modelPar_given_NAIGBACC,
     modelPar_PAIGBACC,
     modelPar_given_PAIGBACC,
     modelPar_LAIGBACC1,
     modelPar_given_LAIGBACC1,
     modelPar_NAIGBACC1,
     modelPar_given_NAIGBACC1,
     modelPar_PAIGBACC1,
     modelPar_given_PAIGBACC1,
     modelPar_LBIGBACC,
     modelPar_given_LBIGBACC,
     modelPar_NBIGBACC,
     modelPar_given_NBIGBACC,
     modelPar_PBIGBACC,
     modelPar_given_PBIGBACC,
     modelPar_LCIGBACC,
     modelPar_given_LCIGBACC,
     modelPar_NCIGBACC,
     modelPar_given_NCIGBACC,
     modelPar_PCIGBACC,
     modelPar_given_PCIGBACC,
     modelPar_LNIGBACC,
     modelPar_given_LNIGBACC,
     modelPar_NNIGBACC,
     modelPar_given_NNIGBACC,
     modelPar_PNIGBACC,
     modelPar_given_PNIGBACC,
     modelPar_LAIGC,
     modelPar_given_LAIGC,
     modelPar_NAIGC,
     modelPar_given_NAIGC,
     modelPar_PAIGC,
     modelPar_given_PAIGC,
     modelPar_LAIGC1,
     modelPar_given_LAIGC1,
     modelPar_NAIGC1,
     modelPar_given_NAIGC1,
     modelPar_PAIGC1,
     modelPar_given_PAIGC1,
     modelPar_LBIGC,
     modelPar_given_LBIGC,
     modelPar_NBIGC,
     modelPar_given_NBIGC,
     modelPar_PBIGC,
     modelPar_given_PBIGC,
     modelPar_LCIGC,
     modelPar_given_LCIGC,
     modelPar_NCIGC,
     modelPar_given_NCIGC,
     modelPar_PCIGC,
     modelPar_given_PCIGC,
     modelPar_LPIGCD,
     modelPar_given_LPIGCD,
     modelPar_NPIGCD,
     modelPar_given_NPIGCD,
     modelPar_PPIGCD,
     modelPar_given_PPIGCD,
     modelPar_LAIGS,
     modelPar_given_LAIGS,
     modelPar_NAIGS,
     modelPar_given_NAIGS,
     modelPar_PAIGS,
     modelPar_given_PAIGS,
     modelPar_LAIGS1,
     modelPar_given_LAIGS1,
     modelPar_NAIGS1,
     modelPar_given_NAIGS1,
     modelPar_PAIGS1,
     modelPar_given_PAIGS1,
     modelPar_LBIGS,
     modelPar_given_LBIGS,
     modelPar_NBIGS,
     modelPar_given_NBIGS,
     modelPar_PBIGS,
     modelPar_given_PBIGS,
     modelPar_LCIGS,
     modelPar_given_LCIGS,
     modelPar_NCIGS,
     modelPar_given_NCIGS,
     modelPar_PCIGS,
     modelPar_given_PCIGS,
     modelPar_LAIGD,
     modelPar_given_LAIGD,
     modelPar_NAIGD,
     modelPar_given_NAIGD,
     modelPar_PAIGD,
     modelPar_given_PAIGD,
     modelPar_LAIGD1,
     modelPar_given_LAIGD1,
     modelPar_NAIGD1,
     modelPar_given_NAIGD1,
     modelPar_PAIGD1,
     modelPar_given_PAIGD1,
     modelPar_LBIGD,
     modelPar_given_LBIGD,
     modelPar_NBIGD,
     modelPar_given_NBIGD,
     modelPar_PBIGD,
     modelPar_given_PBIGD,
     modelPar_LCIGD,
     modelPar_given_LCIGD,
     modelPar_NCIGD,
     modelPar_given_NCIGD,
     modelPar_PCIGD,
     modelPar_given_PCIGD,
     modelPar_LNTOX,
     modelPar_given_LNTOX,
     modelPar_NNTOX,
     modelPar_given_NNTOX,
     modelPar_PNTOX,
     modelPar_given_PNTOX,
     modelPar_LPOXEDGE,
     modelPar_given_LPOXEDGE,
     modelPar_NPOXEDGE,
     modelPar_given_NPOXEDGE,
     modelPar_PPOXEDGE,
     modelPar_given_PPOXEDGE,
     modelPar_LAGISL,
     modelPar_given_LAGISL,
     modelPar_NAGISL,
     modelPar_given_NAGISL,
     modelPar_PAGISL,
     modelPar_given_PAGISL,
     modelPar_LBGISL,
     modelPar_given_LBGISL,
     modelPar_NBGISL,
     modelPar_given_NBGISL,
     modelPar_PBGISL,
     modelPar_given_PBGISL,
     modelPar_LCGISL,
     modelPar_given_LCGISL,
     modelPar_NCGISL,
     modelPar_given_NCGISL,
     modelPar_PCGISL,
     modelPar_given_PCGISL,
     modelPar_LEGISL,
     modelPar_given_LEGISL,
     modelPar_NEGISL,
     modelPar_given_NEGISL,
     modelPar_PEGISL,
     modelPar_given_PEGISL,
     modelPar_LPGISL,
     modelPar_given_LPGISL,
     modelPar_NPGISL,
     modelPar_given_NPGISL,
     modelPar_PPGISL,
     modelPar_given_PPGISL,
     modelPar_LAGIDL,
     modelPar_given_LAGIDL,
     modelPar_NAGIDL,
     modelPar_given_NAGIDL,
     modelPar_PAGIDL,
     modelPar_given_PAGIDL,
     modelPar_LBGIDL,
     modelPar_given_LBGIDL,
     modelPar_NBGIDL,
     modelPar_given_NBGIDL,
     modelPar_PBGIDL,
     modelPar_given_PBGIDL,
     modelPar_LCGIDL,
     modelPar_given_LCGIDL,
     modelPar_NCGIDL,
     modelPar_given_NCGIDL,
     modelPar_PCGIDL,
     modelPar_given_PCGIDL,
     modelPar_LEGIDL,
     modelPar_given_LEGIDL,
     modelPar_NEGIDL,
     modelPar_given_NEGIDL,
     modelPar_PEGIDL,
     modelPar_given_PEGIDL,
     modelPar_LPGIDL,
     modelPar_given_LPGIDL,
     modelPar_NPGIDL,
     modelPar_given_NPGIDL,
     modelPar_PPGIDL,
     modelPar_given_PPGIDL,
     modelPar_LALPHA0,
     modelPar_given_LALPHA0,
     modelPar_NALPHA0,
     modelPar_given_NALPHA0,
     modelPar_PALPHA0,
     modelPar_given_PALPHA0,
     modelPar_LALPHA1,
     modelPar_given_LALPHA1,
     modelPar_NALPHA1,
     modelPar_given_NALPHA1,
     modelPar_PALPHA1,
     modelPar_given_PALPHA1,
     modelPar_LALPHAII0,
     modelPar_given_LALPHAII0,
     modelPar_NALPHAII0,
     modelPar_given_NALPHAII0,
     modelPar_PALPHAII0,
     modelPar_given_PALPHAII0,
     modelPar_LALPHAII1,
     modelPar_given_LALPHAII1,
     modelPar_NALPHAII1,
     modelPar_given_NALPHAII1,
     modelPar_PALPHAII1,
     modelPar_given_PALPHAII1,
     modelPar_LBETA0,
     modelPar_given_LBETA0,
     modelPar_NBETA0,
     modelPar_given_NBETA0,
     modelPar_PBETA0,
     modelPar_given_PBETA0,
     modelPar_LBETAII0,
     modelPar_given_LBETAII0,
     modelPar_NBETAII0,
     modelPar_given_NBETAII0,
     modelPar_PBETAII0,
     modelPar_given_PBETAII0,
     modelPar_LBETAII1,
     modelPar_given_LBETAII1,
     modelPar_NBETAII1,
     modelPar_given_NBETAII1,
     modelPar_PBETAII1,
     modelPar_given_PBETAII1,
     modelPar_LBETAII2,
     modelPar_given_LBETAII2,
     modelPar_NBETAII2,
     modelPar_given_NBETAII2,
     modelPar_PBETAII2,
     modelPar_given_PBETAII2,
     modelPar_LESATII,
     modelPar_given_LESATII,
     modelPar_NESATII,
     modelPar_given_NESATII,
     modelPar_PESATII,
     modelPar_given_PESATII,
     modelPar_LLII,
     modelPar_given_LLII,
     modelPar_NLII,
     modelPar_given_NLII,
     modelPar_PLII,
     modelPar_given_PLII,
     modelPar_LSII0,
     modelPar_given_LSII0,
     modelPar_NSII0,
     modelPar_given_NSII0,
     modelPar_PSII0,
     modelPar_given_PSII0,
     modelPar_LSII1,
     modelPar_given_LSII1,
     modelPar_NSII1,
     modelPar_given_NSII1,
     modelPar_PSII1,
     modelPar_given_PSII1,
     modelPar_LSII2,
     modelPar_given_LSII2,
     modelPar_NSII2,
     modelPar_given_NSII2,
     modelPar_PSII2,
     modelPar_given_PSII2,
     modelPar_LSIID,
     modelPar_given_LSIID,
     modelPar_NSIID,
     modelPar_given_NSIID,
     modelPar_PSIID,
     modelPar_given_PSIID,
     modelPar_LCFS,
     modelPar_given_LCFS,
     modelPar_NCFS,
     modelPar_given_NCFS,
     modelPar_PCFS,
     modelPar_given_PCFS,
     modelPar_LCFD,
     modelPar_given_LCFD,
     modelPar_NCFD,
     modelPar_given_NCFD,
     modelPar_PCFD,
     modelPar_given_PCFD,
     modelPar_LCOVS,
     modelPar_given_LCOVS,
     modelPar_NCOVS,
     modelPar_given_NCOVS,
     modelPar_PCOVS,
     modelPar_given_PCOVS,
     modelPar_LCOVD,
     modelPar_given_LCOVD,
     modelPar_NCOVD,
     modelPar_given_NCOVD,
     modelPar_PCOVD,
     modelPar_given_PCOVD,
     modelPar_LCGSL,
     modelPar_given_LCGSL,
     modelPar_NCGSL,
     modelPar_given_NCGSL,
     modelPar_PCGSL,
     modelPar_given_PCGSL,
     modelPar_LCGDL,
     modelPar_given_LCGDL,
     modelPar_NCGDL,
     modelPar_given_NCGDL,
     modelPar_PCGDL,
     modelPar_given_PCGDL,
     modelPar_LCKAPPAS,
     modelPar_given_LCKAPPAS,
     modelPar_NCKAPPAS,
     modelPar_given_NCKAPPAS,
     modelPar_PCKAPPAS,
     modelPar_given_PCKAPPAS,
     modelPar_LCKAPPAD,
     modelPar_given_LCKAPPAD,
     modelPar_NCKAPPAD,
     modelPar_given_NCKAPPAD,
     modelPar_PCKAPPAD,
     modelPar_given_PCKAPPAD,
     modelPar_LCGBL,
     modelPar_given_LCGBL,
     modelPar_NCGBL,
     modelPar_given_NCGBL,
     modelPar_PCGBL,
     modelPar_given_PCGBL,
     modelPar_LCKAPPAB,
     modelPar_given_LCKAPPAB,
     modelPar_NCKAPPAB,
     modelPar_given_NCKAPPAB,
     modelPar_PCKAPPAB,
     modelPar_given_PCKAPPAB,
     modelPar_LNTGEN,
     modelPar_given_LNTGEN,
     modelPar_NNTGEN,
     modelPar_given_NNTGEN,
     modelPar_PNTGEN,
     modelPar_given_PNTGEN,
     modelPar_LAIGEN,
     modelPar_given_LAIGEN,
     modelPar_NAIGEN,
     modelPar_given_NAIGEN,
     modelPar_PAIGEN,
     modelPar_given_PAIGEN,
     modelPar_LBIGEN,
     modelPar_given_LBIGEN,
     modelPar_NBIGEN,
     modelPar_given_NBIGEN,
     modelPar_PBIGEN,
     modelPar_given_PBIGEN,
     modelPar_LXRCRG1,
     modelPar_given_LXRCRG1,
     modelPar_NXRCRG1,
     modelPar_given_NXRCRG1,
     modelPar_PXRCRG1,
     modelPar_given_PXRCRG1,
     modelPar_LXRCRG2,
     modelPar_given_LXRCRG2,
     modelPar_NXRCRG2,
     modelPar_given_NXRCRG2,
     modelPar_PXRCRG2,
     modelPar_given_PXRCRG2,
     modelPar_LUTE,
     modelPar_given_LUTE,
     modelPar_NUTE,
     modelPar_given_NUTE,
     modelPar_PUTE,
     modelPar_given_PUTE,
     modelPar_LUTER,
     modelPar_given_LUTER,
     modelPar_NUTER,
     modelPar_given_NUTER,
     modelPar_PUTER,
     modelPar_given_PUTER,
     modelPar_LUTL,
     modelPar_given_LUTL,
     modelPar_NUTL,
     modelPar_given_NUTL,
     modelPar_PUTL,
     modelPar_given_PUTL,
     modelPar_LUTLR,
     modelPar_given_LUTLR,
     modelPar_NUTLR,
     modelPar_given_NUTLR,
     modelPar_PUTLR,
     modelPar_given_PUTLR,
     modelPar_LEMOBT,
     modelPar_given_LEMOBT,
     modelPar_NEMOBT,
     modelPar_given_NEMOBT,
     modelPar_PEMOBT,
     modelPar_given_PEMOBT,
     modelPar_LUA1,
     modelPar_given_LUA1,
     modelPar_NUA1,
     modelPar_given_NUA1,
     modelPar_PUA1,
     modelPar_given_PUA1,
     modelPar_LUA1R,
     modelPar_given_LUA1R,
     modelPar_NUA1R,
     modelPar_given_NUA1R,
     modelPar_PUA1R,
     modelPar_given_PUA1R,
     modelPar_LUC1,
     modelPar_given_LUC1,
     modelPar_NUC1,
     modelPar_given_NUC1,
     modelPar_PUC1,
     modelPar_given_PUC1,
     modelPar_LUC1R,
     modelPar_given_LUC1R,
     modelPar_NUC1R,
     modelPar_given_NUC1R,
     modelPar_PUC1R,
     modelPar_given_PUC1R,
     modelPar_LUD1,
     modelPar_given_LUD1,
     modelPar_NUD1,
     modelPar_given_NUD1,
     modelPar_PUD1,
     modelPar_given_PUD1,
     modelPar_LUD1R,
     modelPar_given_LUD1R,
     modelPar_NUD1R,
     modelPar_given_NUD1R,
     modelPar_PUD1R,
     modelPar_given_PUD1R,
     modelPar_LUCSTE,
     modelPar_given_LUCSTE,
     modelPar_NUCSTE,
     modelPar_given_NUCSTE,
     modelPar_PUCSTE,
     modelPar_given_PUCSTE,
     modelPar_LPTWGT,
     modelPar_given_LPTWGT,
     modelPar_NPTWGT,
     modelPar_given_NPTWGT,
     modelPar_PPTWGT,
     modelPar_given_PPTWGT,
     modelPar_LAT,
     modelPar_given_LAT,
     modelPar_NAT,
     modelPar_given_NAT,
     modelPar_PAT,
     modelPar_given_PAT,
     modelPar_LATR,
     modelPar_given_LATR,
     modelPar_NATR,
     modelPar_given_NATR,
     modelPar_PATR,
     modelPar_given_PATR,
     modelPar_LATCV,
     modelPar_given_LATCV,
     modelPar_NATCV,
     modelPar_given_NATCV,
     modelPar_PATCV,
     modelPar_given_PATCV,
     modelPar_LSTTHETASAT,
     modelPar_given_LSTTHETASAT,
     modelPar_NSTTHETASAT,
     modelPar_given_NSTTHETASAT,
     modelPar_PSTTHETASAT,
     modelPar_given_PSTTHETASAT,
     modelPar_LPRT,
     modelPar_given_LPRT,
     modelPar_NPRT,
     modelPar_given_NPRT,
     modelPar_PPRT,
     modelPar_given_PPRT,
     modelPar_LKT1,
     modelPar_given_LKT1,
     modelPar_NKT1,
     modelPar_given_NKT1,
     modelPar_PKT1,
     modelPar_given_PKT1,
     modelPar_LTSS,
     modelPar_given_LTSS,
     modelPar_NTSS,
     modelPar_given_NTSS,
     modelPar_PTSS,
     modelPar_given_PTSS,
     modelPar_LIIT,
     modelPar_given_LIIT,
     modelPar_NIIT,
     modelPar_given_NIIT,
     modelPar_PIIT,
     modelPar_given_PIIT,
     modelPar_LTII,
     modelPar_given_LTII,
     modelPar_NTII,
     modelPar_given_NTII,
     modelPar_PTII,
     modelPar_given_PTII,
     modelPar_LTGIDL,
     modelPar_given_LTGIDL,
     modelPar_NTGIDL,
     modelPar_given_NTGIDL,
     modelPar_PTGIDL,
     modelPar_given_PTGIDL,
     modelPar_LIGT,
     modelPar_given_LIGT,
     modelPar_NIGT,
     modelPar_given_NIGT,
     modelPar_PIGT,
     modelPar_given_PIGT,
     // non-reals (including hidden)
     modelPar_NF,
     modelPar_given_NF,
     modelPar_NGCON,
     modelPar_given_NGCON,
     modelPar_DEVTYPE,
     modelPar_given_DEVTYPE,
     modelPar_TYPE,
     modelPar_given_TYPE,
     modelPar_BULKMOD,
     modelPar_given_BULKMOD,
     modelPar_GEOMOD,
     modelPar_given_GEOMOD,
     modelPar_CGEO1SW,
     modelPar_given_CGEO1SW,
     modelPar_RDSMOD,
     modelPar_given_RDSMOD,
     modelPar_ASYMMOD,
     modelPar_given_ASYMMOD,
     modelPar_IGCMOD,
     modelPar_given_IGCMOD,
     modelPar_IGBMOD,
     modelPar_given_IGBMOD,
     modelPar_GIDLMOD,
     modelPar_given_GIDLMOD,
     modelPar_IIMOD,
     modelPar_given_IIMOD,
     modelPar_TNOIMOD,
     modelPar_given_TNOIMOD,
     modelPar_NQSMOD,
     modelPar_given_NQSMOD,
     modelPar_SHMOD,
     modelPar_given_SHMOD,
     modelPar_TEMPMOD,
     modelPar_given_TEMPMOD,
     modelPar_RGATEMOD,
     modelPar_given_RGATEMOD,
     modelPar_RGEOMOD,
     modelPar_given_RGEOMOD,
     modelPar_CGEOMOD,
     modelPar_given_CGEOMOD,
     modelPar_SH_WARN,
     modelPar_given_SH_WARN,
     modelPar_IGCLAMP,
     modelPar_given_IGCLAMP,
     modelPar_SDTERM,
     modelPar_given_SDTERM,
     modelPar_NSEG,
     modelPar_given_NSEG,
     in.admsTemperature,
     in.adms_vt_nom,
     in.getDeviceOptions().gmin,
     staticContributions,
     dynamicContributions,
     in);


  // We now have the F and Q vector stuff, populate the dependencies:

  dfdp[in.admsNodeID_d] += staticContributions[in.admsNodeID_d].dx(0);
  dqdp[in.admsNodeID_d] += dynamicContributions[in.admsNodeID_d].dx(0);
  Findices[in.admsNodeID_d] = in.li_d;
  Qindices[in.admsNodeID_d] = in.li_d;
  dfdp[in.admsNodeID_g] += staticContributions[in.admsNodeID_g].dx(0);
  dqdp[in.admsNodeID_g] += dynamicContributions[in.admsNodeID_g].dx(0);
  Findices[in.admsNodeID_g] = in.li_g;
  Qindices[in.admsNodeID_g] = in.li_g;
  dfdp[in.admsNodeID_s] += staticContributions[in.admsNodeID_s].dx(0);
  dqdp[in.admsNodeID_s] += dynamicContributions[in.admsNodeID_s].dx(0);
  Findices[in.admsNodeID_s] = in.li_s;
  Qindices[in.admsNodeID_s] = in.li_s;
  dfdp[in.admsNodeID_e] += staticContributions[in.admsNodeID_e].dx(0);
  dqdp[in.admsNodeID_e] += dynamicContributions[in.admsNodeID_e].dx(0);
  Findices[in.admsNodeID_e] = in.li_e;
  Qindices[in.admsNodeID_e] = in.li_e;
  dfdp[in.admsNodeID_t] += staticContributions[in.admsNodeID_t].dx(0);
  dqdp[in.admsNodeID_t] += dynamicContributions[in.admsNodeID_t].dx(0);
  Findices[in.admsNodeID_t] = in.li_t;
  Qindices[in.admsNodeID_t] = in.li_t;
  dfdp[in.admsNodeID_si] += staticContributions[in.admsNodeID_si].dx(0);
  dqdp[in.admsNodeID_si] += dynamicContributions[in.admsNodeID_si].dx(0);
  Findices[in.admsNodeID_si] = in.li_si;
  Qindices[in.admsNodeID_si] = in.li_si;
  dfdp[in.admsNodeID_di] += staticContributions[in.admsNodeID_di].dx(0);
  dqdp[in.admsNodeID_di] += dynamicContributions[in.admsNodeID_di].dx(0);
  Findices[in.admsNodeID_di] = in.li_di;
  Qindices[in.admsNodeID_di] = in.li_di;
  dfdp[in.admsNodeID_ge] += staticContributions[in.admsNodeID_ge].dx(0);
  dqdp[in.admsNodeID_ge] += dynamicContributions[in.admsNodeID_ge].dx(0);
  Findices[in.admsNodeID_ge] = in.li_ge;
  Qindices[in.admsNodeID_ge] = in.li_ge;
  dfdp[in.admsNodeID_N] += staticContributions[in.admsNodeID_N].dx(0);
  dqdp[in.admsNodeID_N] += dynamicContributions[in.admsNodeID_N].dx(0);
  Findices[in.admsNodeID_N] = in.li_N;
  Qindices[in.admsNodeID_N] = in.li_N;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void ModelSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Model & mod = *(dynamic_cast<const Model *> (e1));
  int sizeInstance = mod.instanceContainer.size();

  dfdp.resize((9+0)*sizeInstance);
  dqdp.resize((9+0)*sizeInstance);
  Findices.resize((9+0)*sizeInstance);
  Qindices.resize((9+0)*sizeInstance);

  std::vector <double> probeVars(19);
  std::vector <AdmsSensFadType> staticContributions(9+0);
  std::vector <AdmsSensFadType> dynamicContributions(9+0);


  // Copy out all the model parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> modParamMap;

  // reals
  AdmsSensFadType modelPar_L=mod.L;
  bool modelPar_given_L=mod.given("L");
  modParamMap["L"] = &modelPar_L;
  AdmsSensFadType modelPar_D=mod.D;
  bool modelPar_given_D=mod.given("D");
  modParamMap["D"] = &modelPar_D;
  AdmsSensFadType modelPar_TFIN=mod.TFIN;
  bool modelPar_given_TFIN=mod.given("TFIN");
  modParamMap["TFIN"] = &modelPar_TFIN;
  AdmsSensFadType modelPar_FPITCH=mod.FPITCH;
  bool modelPar_given_FPITCH=mod.given("FPITCH");
  modParamMap["FPITCH"] = &modelPar_FPITCH;
  AdmsSensFadType modelPar_NFIN=mod.NFIN;
  bool modelPar_given_NFIN=mod.given("NFIN");
  modParamMap["NFIN"] = &modelPar_NFIN;
  AdmsSensFadType modelPar_ASEO=mod.ASEO;
  bool modelPar_given_ASEO=mod.given("ASEO");
  modParamMap["ASEO"] = &modelPar_ASEO;
  AdmsSensFadType modelPar_ADEO=mod.ADEO;
  bool modelPar_given_ADEO=mod.given("ADEO");
  modParamMap["ADEO"] = &modelPar_ADEO;
  AdmsSensFadType modelPar_PSEO=mod.PSEO;
  bool modelPar_given_PSEO=mod.given("PSEO");
  modParamMap["PSEO"] = &modelPar_PSEO;
  AdmsSensFadType modelPar_PDEO=mod.PDEO;
  bool modelPar_given_PDEO=mod.given("PDEO");
  modParamMap["PDEO"] = &modelPar_PDEO;
  AdmsSensFadType modelPar_ASEJ=mod.ASEJ;
  bool modelPar_given_ASEJ=mod.given("ASEJ");
  modParamMap["ASEJ"] = &modelPar_ASEJ;
  AdmsSensFadType modelPar_ADEJ=mod.ADEJ;
  bool modelPar_given_ADEJ=mod.given("ADEJ");
  modParamMap["ADEJ"] = &modelPar_ADEJ;
  AdmsSensFadType modelPar_PSEJ=mod.PSEJ;
  bool modelPar_given_PSEJ=mod.given("PSEJ");
  modParamMap["PSEJ"] = &modelPar_PSEJ;
  AdmsSensFadType modelPar_PDEJ=mod.PDEJ;
  bool modelPar_given_PDEJ=mod.given("PDEJ");
  modParamMap["PDEJ"] = &modelPar_PDEJ;
  AdmsSensFadType modelPar_COVS=mod.COVS;
  bool modelPar_given_COVS=mod.given("COVS");
  modParamMap["COVS"] = &modelPar_COVS;
  AdmsSensFadType modelPar_COVD=mod.COVD;
  bool modelPar_given_COVD=mod.given("COVD");
  modParamMap["COVD"] = &modelPar_COVD;
  AdmsSensFadType modelPar_CGSP=mod.CGSP;
  bool modelPar_given_CGSP=mod.given("CGSP");
  modParamMap["CGSP"] = &modelPar_CGSP;
  AdmsSensFadType modelPar_CGDP=mod.CGDP;
  bool modelPar_given_CGDP=mod.given("CGDP");
  modParamMap["CGDP"] = &modelPar_CGDP;
  AdmsSensFadType modelPar_CDSP=mod.CDSP;
  bool modelPar_given_CDSP=mod.given("CDSP");
  modParamMap["CDSP"] = &modelPar_CDSP;
  AdmsSensFadType modelPar_NRS=mod.NRS;
  bool modelPar_given_NRS=mod.given("NRS");
  modParamMap["NRS"] = &modelPar_NRS;
  AdmsSensFadType modelPar_NRD=mod.NRD;
  bool modelPar_given_NRD=mod.given("NRD");
  modParamMap["NRD"] = &modelPar_NRD;
  AdmsSensFadType modelPar_LRSD=mod.LRSD;
  bool modelPar_given_LRSD=mod.given("LRSD");
  modParamMap["LRSD"] = &modelPar_LRSD;
  AdmsSensFadType modelPar_XL=mod.XL;
  bool modelPar_given_XL=mod.given("XL");
  modParamMap["XL"] = &modelPar_XL;
  AdmsSensFadType modelPar_DTEMP=mod.DTEMP;
  bool modelPar_given_DTEMP=mod.given("DTEMP");
  modParamMap["DTEMP"] = &modelPar_DTEMP;
  AdmsSensFadType modelPar_DELVTRAND=mod.DELVTRAND;
  bool modelPar_given_DELVTRAND=mod.given("DELVTRAND");
  modParamMap["DELVTRAND"] = &modelPar_DELVTRAND;
  AdmsSensFadType modelPar_U0MULT=mod.U0MULT;
  bool modelPar_given_U0MULT=mod.given("U0MULT");
  modParamMap["U0MULT"] = &modelPar_U0MULT;
  AdmsSensFadType modelPar_IDS0MULT=mod.IDS0MULT;
  bool modelPar_given_IDS0MULT=mod.given("IDS0MULT");
  modParamMap["IDS0MULT"] = &modelPar_IDS0MULT;
  AdmsSensFadType modelPar_LINT=mod.LINT;
  bool modelPar_given_LINT=mod.given("LINT");
  modParamMap["LINT"] = &modelPar_LINT;
  AdmsSensFadType modelPar_LL=mod.LL;
  bool modelPar_given_LL=mod.given("LL");
  modParamMap["LL"] = &modelPar_LL;
  AdmsSensFadType modelPar_LLN=mod.LLN;
  bool modelPar_given_LLN=mod.given("LLN");
  modParamMap["LLN"] = &modelPar_LLN;
  AdmsSensFadType modelPar_DLC=mod.DLC;
  bool modelPar_given_DLC=mod.given("DLC");
  modParamMap["DLC"] = &modelPar_DLC;
  AdmsSensFadType modelPar_DLCACC=mod.DLCACC;
  bool modelPar_given_DLCACC=mod.given("DLCACC");
  modParamMap["DLCACC"] = &modelPar_DLCACC;
  AdmsSensFadType modelPar_DLBIN=mod.DLBIN;
  bool modelPar_given_DLBIN=mod.given("DLBIN");
  modParamMap["DLBIN"] = &modelPar_DLBIN;
  AdmsSensFadType modelPar_LLC=mod.LLC;
  bool modelPar_given_LLC=mod.given("LLC");
  modParamMap["LLC"] = &modelPar_LLC;
  AdmsSensFadType modelPar_EOT=mod.EOT;
  bool modelPar_given_EOT=mod.given("EOT");
  modParamMap["EOT"] = &modelPar_EOT;
  AdmsSensFadType modelPar_TOXP=mod.TOXP;
  bool modelPar_given_TOXP=mod.given("TOXP");
  modParamMap["TOXP"] = &modelPar_TOXP;
  AdmsSensFadType modelPar_EOTBOX=mod.EOTBOX;
  bool modelPar_given_EOTBOX=mod.given("EOTBOX");
  modParamMap["EOTBOX"] = &modelPar_EOTBOX;
  AdmsSensFadType modelPar_HFIN=mod.HFIN;
  bool modelPar_given_HFIN=mod.given("HFIN");
  modParamMap["HFIN"] = &modelPar_HFIN;
  AdmsSensFadType modelPar_FECH=mod.FECH;
  bool modelPar_given_FECH=mod.given("FECH");
  modParamMap["FECH"] = &modelPar_FECH;
  AdmsSensFadType modelPar_DELTAW=mod.DELTAW;
  bool modelPar_given_DELTAW=mod.given("DELTAW");
  modParamMap["DELTAW"] = &modelPar_DELTAW;
  AdmsSensFadType modelPar_FECHCV=mod.FECHCV;
  bool modelPar_given_FECHCV=mod.given("FECHCV");
  modParamMap["FECHCV"] = &modelPar_FECHCV;
  AdmsSensFadType modelPar_DELTAWCV=mod.DELTAWCV;
  bool modelPar_given_DELTAWCV=mod.given("DELTAWCV");
  modParamMap["DELTAWCV"] = &modelPar_DELTAWCV;
  AdmsSensFadType modelPar_NBODY=mod.NBODY;
  bool modelPar_given_NBODY=mod.given("NBODY");
  modParamMap["NBODY"] = &modelPar_NBODY;
  AdmsSensFadType modelPar_NBODYN1=mod.NBODYN1;
  bool modelPar_given_NBODYN1=mod.given("NBODYN1");
  modParamMap["NBODYN1"] = &modelPar_NBODYN1;
  AdmsSensFadType modelPar_NBODYN2=mod.NBODYN2;
  bool modelPar_given_NBODYN2=mod.given("NBODYN2");
  modParamMap["NBODYN2"] = &modelPar_NBODYN2;
  AdmsSensFadType modelPar_NSD=mod.NSD;
  bool modelPar_given_NSD=mod.given("NSD");
  modParamMap["NSD"] = &modelPar_NSD;
  AdmsSensFadType modelPar_PHIG=mod.PHIG;
  bool modelPar_given_PHIG=mod.given("PHIG");
  modParamMap["PHIG"] = &modelPar_PHIG;
  AdmsSensFadType modelPar_PHIGL=mod.PHIGL;
  bool modelPar_given_PHIGL=mod.given("PHIGL");
  modParamMap["PHIGL"] = &modelPar_PHIGL;
  AdmsSensFadType modelPar_PHIGLT=mod.PHIGLT;
  bool modelPar_given_PHIGLT=mod.given("PHIGLT");
  modParamMap["PHIGLT"] = &modelPar_PHIGLT;
  AdmsSensFadType modelPar_PHIGN1=mod.PHIGN1;
  bool modelPar_given_PHIGN1=mod.given("PHIGN1");
  modParamMap["PHIGN1"] = &modelPar_PHIGN1;
  AdmsSensFadType modelPar_PHIGN2=mod.PHIGN2;
  bool modelPar_given_PHIGN2=mod.given("PHIGN2");
  modParamMap["PHIGN2"] = &modelPar_PHIGN2;
  AdmsSensFadType modelPar_EPSROX=mod.EPSROX;
  bool modelPar_given_EPSROX=mod.given("EPSROX");
  modParamMap["EPSROX"] = &modelPar_EPSROX;
  AdmsSensFadType modelPar_EPSRSUB=mod.EPSRSUB;
  bool modelPar_given_EPSRSUB=mod.given("EPSRSUB");
  modParamMap["EPSRSUB"] = &modelPar_EPSRSUB;
  AdmsSensFadType modelPar_EASUB=mod.EASUB;
  bool modelPar_given_EASUB=mod.given("EASUB");
  modParamMap["EASUB"] = &modelPar_EASUB;
  AdmsSensFadType modelPar_NI0SUB=mod.NI0SUB;
  bool modelPar_given_NI0SUB=mod.given("NI0SUB");
  modParamMap["NI0SUB"] = &modelPar_NI0SUB;
  AdmsSensFadType modelPar_BG0SUB=mod.BG0SUB;
  bool modelPar_given_BG0SUB=mod.given("BG0SUB");
  modParamMap["BG0SUB"] = &modelPar_BG0SUB;
  AdmsSensFadType modelPar_NC0SUB=mod.NC0SUB;
  bool modelPar_given_NC0SUB=mod.given("NC0SUB");
  modParamMap["NC0SUB"] = &modelPar_NC0SUB;
  AdmsSensFadType modelPar_NGATE=mod.NGATE;
  bool modelPar_given_NGATE=mod.given("NGATE");
  modParamMap["NGATE"] = &modelPar_NGATE;
  AdmsSensFadType modelPar_Imin=mod.Imin;
  bool modelPar_given_Imin=mod.given("Imin");
  modParamMap["Imin"] = &modelPar_Imin;
  AdmsSensFadType modelPar_CIT=mod.CIT;
  bool modelPar_given_CIT=mod.given("CIT");
  modParamMap["CIT"] = &modelPar_CIT;
  AdmsSensFadType modelPar_CITR=mod.CITR;
  bool modelPar_given_CITR=mod.given("CITR");
  modParamMap["CITR"] = &modelPar_CITR;
  AdmsSensFadType modelPar_CDSC=mod.CDSC;
  bool modelPar_given_CDSC=mod.given("CDSC");
  modParamMap["CDSC"] = &modelPar_CDSC;
  AdmsSensFadType modelPar_CDSCN1=mod.CDSCN1;
  bool modelPar_given_CDSCN1=mod.given("CDSCN1");
  modParamMap["CDSCN1"] = &modelPar_CDSCN1;
  AdmsSensFadType modelPar_CDSCN2=mod.CDSCN2;
  bool modelPar_given_CDSCN2=mod.given("CDSCN2");
  modParamMap["CDSCN2"] = &modelPar_CDSCN2;
  AdmsSensFadType modelPar_CDSCD=mod.CDSCD;
  bool modelPar_given_CDSCD=mod.given("CDSCD");
  modParamMap["CDSCD"] = &modelPar_CDSCD;
  AdmsSensFadType modelPar_CDSCDN1=mod.CDSCDN1;
  bool modelPar_given_CDSCDN1=mod.given("CDSCDN1");
  modParamMap["CDSCDN1"] = &modelPar_CDSCDN1;
  AdmsSensFadType modelPar_CDSCDN2=mod.CDSCDN2;
  bool modelPar_given_CDSCDN2=mod.given("CDSCDN2");
  modParamMap["CDSCDN2"] = &modelPar_CDSCDN2;
  AdmsSensFadType modelPar_CDSCDR=mod.CDSCDR;
  bool modelPar_given_CDSCDR=mod.given("CDSCDR");
  modParamMap["CDSCDR"] = &modelPar_CDSCDR;
  AdmsSensFadType modelPar_CDSCDRN1=mod.CDSCDRN1;
  bool modelPar_given_CDSCDRN1=mod.given("CDSCDRN1");
  modParamMap["CDSCDRN1"] = &modelPar_CDSCDRN1;
  AdmsSensFadType modelPar_CDSCDRN2=mod.CDSCDRN2;
  bool modelPar_given_CDSCDRN2=mod.given("CDSCDRN2");
  modParamMap["CDSCDRN2"] = &modelPar_CDSCDRN2;
  AdmsSensFadType modelPar_DVT0=mod.DVT0;
  bool modelPar_given_DVT0=mod.given("DVT0");
  modParamMap["DVT0"] = &modelPar_DVT0;
  AdmsSensFadType modelPar_DVT1=mod.DVT1;
  bool modelPar_given_DVT1=mod.given("DVT1");
  modParamMap["DVT1"] = &modelPar_DVT1;
  AdmsSensFadType modelPar_DVT1SS=mod.DVT1SS;
  bool modelPar_given_DVT1SS=mod.given("DVT1SS");
  modParamMap["DVT1SS"] = &modelPar_DVT1SS;
  AdmsSensFadType modelPar_PHIN=mod.PHIN;
  bool modelPar_given_PHIN=mod.given("PHIN");
  modParamMap["PHIN"] = &modelPar_PHIN;
  AdmsSensFadType modelPar_ETA0=mod.ETA0;
  bool modelPar_given_ETA0=mod.given("ETA0");
  modParamMap["ETA0"] = &modelPar_ETA0;
  AdmsSensFadType modelPar_ETA0N1=mod.ETA0N1;
  bool modelPar_given_ETA0N1=mod.given("ETA0N1");
  modParamMap["ETA0N1"] = &modelPar_ETA0N1;
  AdmsSensFadType modelPar_ETA0N2=mod.ETA0N2;
  bool modelPar_given_ETA0N2=mod.given("ETA0N2");
  modParamMap["ETA0N2"] = &modelPar_ETA0N2;
  AdmsSensFadType modelPar_ETA0LT=mod.ETA0LT;
  bool modelPar_given_ETA0LT=mod.given("ETA0LT");
  modParamMap["ETA0LT"] = &modelPar_ETA0LT;
  AdmsSensFadType modelPar_TETA0=mod.TETA0;
  bool modelPar_given_TETA0=mod.given("TETA0");
  modParamMap["TETA0"] = &modelPar_TETA0;
  AdmsSensFadType modelPar_ETA0R=mod.ETA0R;
  bool modelPar_given_ETA0R=mod.given("ETA0R");
  modParamMap["ETA0R"] = &modelPar_ETA0R;
  AdmsSensFadType modelPar_TETA0R=mod.TETA0R;
  bool modelPar_given_TETA0R=mod.given("TETA0R");
  modParamMap["TETA0R"] = &modelPar_TETA0R;
  AdmsSensFadType modelPar_DSUB=mod.DSUB;
  bool modelPar_given_DSUB=mod.given("DSUB");
  modParamMap["DSUB"] = &modelPar_DSUB;
  AdmsSensFadType modelPar_DVTP0=mod.DVTP0;
  bool modelPar_given_DVTP0=mod.given("DVTP0");
  modParamMap["DVTP0"] = &modelPar_DVTP0;
  AdmsSensFadType modelPar_DVTP1=mod.DVTP1;
  bool modelPar_given_DVTP1=mod.given("DVTP1");
  modParamMap["DVTP1"] = &modelPar_DVTP1;
  AdmsSensFadType modelPar_ADVTP0=mod.ADVTP0;
  bool modelPar_given_ADVTP0=mod.given("ADVTP0");
  modParamMap["ADVTP0"] = &modelPar_ADVTP0;
  AdmsSensFadType modelPar_BDVTP0=mod.BDVTP0;
  bool modelPar_given_BDVTP0=mod.given("BDVTP0");
  modParamMap["BDVTP0"] = &modelPar_BDVTP0;
  AdmsSensFadType modelPar_ADVTP1=mod.ADVTP1;
  bool modelPar_given_ADVTP1=mod.given("ADVTP1");
  modParamMap["ADVTP1"] = &modelPar_ADVTP1;
  AdmsSensFadType modelPar_BDVTP1=mod.BDVTP1;
  bool modelPar_given_BDVTP1=mod.given("BDVTP1");
  modParamMap["BDVTP1"] = &modelPar_BDVTP1;
  AdmsSensFadType modelPar_DVTP2=mod.DVTP2;
  bool modelPar_given_DVTP2=mod.given("DVTP2");
  modParamMap["DVTP2"] = &modelPar_DVTP2;
  AdmsSensFadType modelPar_K1RSCE=mod.K1RSCE;
  bool modelPar_given_K1RSCE=mod.given("K1RSCE");
  modParamMap["K1RSCE"] = &modelPar_K1RSCE;
  AdmsSensFadType modelPar_LPE0=mod.LPE0;
  bool modelPar_given_LPE0=mod.given("LPE0");
  modParamMap["LPE0"] = &modelPar_LPE0;
  AdmsSensFadType modelPar_DVTSHIFT=mod.DVTSHIFT;
  bool modelPar_given_DVTSHIFT=mod.given("DVTSHIFT");
  modParamMap["DVTSHIFT"] = &modelPar_DVTSHIFT;
  AdmsSensFadType modelPar_DVTSHIFTR=mod.DVTSHIFTR;
  bool modelPar_given_DVTSHIFTR=mod.given("DVTSHIFTR");
  modParamMap["DVTSHIFTR"] = &modelPar_DVTSHIFTR;
  AdmsSensFadType modelPar_THETASCE=mod.THETASCE;
  bool modelPar_given_THETASCE=mod.given("THETASCE");
  modParamMap["THETASCE"] = &modelPar_THETASCE;
  AdmsSensFadType modelPar_THETADIBL=mod.THETADIBL;
  bool modelPar_given_THETADIBL=mod.given("THETADIBL");
  modParamMap["THETADIBL"] = &modelPar_THETADIBL;
  AdmsSensFadType modelPar_THETASW=mod.THETASW;
  bool modelPar_given_THETASW=mod.given("THETASW");
  modParamMap["THETASW"] = &modelPar_THETASW;
  AdmsSensFadType modelPar_NVTM=mod.NVTM;
  bool modelPar_given_NVTM=mod.given("NVTM");
  modParamMap["NVTM"] = &modelPar_NVTM;
  AdmsSensFadType modelPar_K0=mod.K0;
  bool modelPar_given_K0=mod.given("K0");
  modParamMap["K0"] = &modelPar_K0;
  AdmsSensFadType modelPar_K01=mod.K01;
  bool modelPar_given_K01=mod.given("K01");
  modParamMap["K01"] = &modelPar_K01;
  AdmsSensFadType modelPar_K0SI=mod.K0SI;
  bool modelPar_given_K0SI=mod.given("K0SI");
  modParamMap["K0SI"] = &modelPar_K0SI;
  AdmsSensFadType modelPar_K0SI1=mod.K0SI1;
  bool modelPar_given_K0SI1=mod.given("K0SI1");
  modParamMap["K0SI1"] = &modelPar_K0SI1;
  AdmsSensFadType modelPar_K2SI=mod.K2SI;
  bool modelPar_given_K2SI=mod.given("K2SI");
  modParamMap["K2SI"] = &modelPar_K2SI;
  AdmsSensFadType modelPar_K2SI1=mod.K2SI1;
  bool modelPar_given_K2SI1=mod.given("K2SI1");
  modParamMap["K2SI1"] = &modelPar_K2SI1;
  AdmsSensFadType modelPar_K0SISAT=mod.K0SISAT;
  bool modelPar_given_K0SISAT=mod.given("K0SISAT");
  modParamMap["K0SISAT"] = &modelPar_K0SISAT;
  AdmsSensFadType modelPar_K0SISAT1=mod.K0SISAT1;
  bool modelPar_given_K0SISAT1=mod.given("K0SISAT1");
  modParamMap["K0SISAT1"] = &modelPar_K0SISAT1;
  AdmsSensFadType modelPar_K2SISAT=mod.K2SISAT;
  bool modelPar_given_K2SISAT=mod.given("K2SISAT");
  modParamMap["K2SISAT"] = &modelPar_K2SISAT;
  AdmsSensFadType modelPar_K2SISAT1=mod.K2SISAT1;
  bool modelPar_given_K2SISAT1=mod.given("K2SISAT1");
  modParamMap["K2SISAT1"] = &modelPar_K2SISAT1;
  AdmsSensFadType modelPar_PHIBE=mod.PHIBE;
  bool modelPar_given_PHIBE=mod.given("PHIBE");
  modParamMap["PHIBE"] = &modelPar_PHIBE;
  AdmsSensFadType modelPar_K1=mod.K1;
  bool modelPar_given_K1=mod.given("K1");
  modParamMap["K1"] = &modelPar_K1;
  AdmsSensFadType modelPar_K11=mod.K11;
  bool modelPar_given_K11=mod.given("K11");
  modParamMap["K11"] = &modelPar_K11;
  AdmsSensFadType modelPar_K2SAT=mod.K2SAT;
  bool modelPar_given_K2SAT=mod.given("K2SAT");
  modParamMap["K2SAT"] = &modelPar_K2SAT;
  AdmsSensFadType modelPar_K2SAT1=mod.K2SAT1;
  bool modelPar_given_K2SAT1=mod.given("K2SAT1");
  modParamMap["K2SAT1"] = &modelPar_K2SAT1;
  AdmsSensFadType modelPar_K2=mod.K2;
  bool modelPar_given_K2=mod.given("K2");
  modParamMap["K2"] = &modelPar_K2;
  AdmsSensFadType modelPar_K21=mod.K21;
  bool modelPar_given_K21=mod.given("K21");
  modParamMap["K21"] = &modelPar_K21;
  AdmsSensFadType modelPar_QMFACTOR=mod.QMFACTOR;
  bool modelPar_given_QMFACTOR=mod.given("QMFACTOR");
  modParamMap["QMFACTOR"] = &modelPar_QMFACTOR;
  AdmsSensFadType modelPar_QMTCENCV=mod.QMTCENCV;
  bool modelPar_given_QMTCENCV=mod.given("QMTCENCV");
  modParamMap["QMTCENCV"] = &modelPar_QMTCENCV;
  AdmsSensFadType modelPar_QMTCENCVA=mod.QMTCENCVA;
  bool modelPar_given_QMTCENCVA=mod.given("QMTCENCVA");
  modParamMap["QMTCENCVA"] = &modelPar_QMTCENCVA;
  AdmsSensFadType modelPar_AQMTCEN=mod.AQMTCEN;
  bool modelPar_given_AQMTCEN=mod.given("AQMTCEN");
  modParamMap["AQMTCEN"] = &modelPar_AQMTCEN;
  AdmsSensFadType modelPar_BQMTCEN=mod.BQMTCEN;
  bool modelPar_given_BQMTCEN=mod.given("BQMTCEN");
  modParamMap["BQMTCEN"] = &modelPar_BQMTCEN;
  AdmsSensFadType modelPar_ETAQM=mod.ETAQM;
  bool modelPar_given_ETAQM=mod.given("ETAQM");
  modParamMap["ETAQM"] = &modelPar_ETAQM;
  AdmsSensFadType modelPar_QM0=mod.QM0;
  bool modelPar_given_QM0=mod.given("QM0");
  modParamMap["QM0"] = &modelPar_QM0;
  AdmsSensFadType modelPar_PQM=mod.PQM;
  bool modelPar_given_PQM=mod.given("PQM");
  modParamMap["PQM"] = &modelPar_PQM;
  AdmsSensFadType modelPar_QM0ACC=mod.QM0ACC;
  bool modelPar_given_QM0ACC=mod.given("QM0ACC");
  modParamMap["QM0ACC"] = &modelPar_QM0ACC;
  AdmsSensFadType modelPar_PQMACC=mod.PQMACC;
  bool modelPar_given_PQMACC=mod.given("PQMACC");
  modParamMap["PQMACC"] = &modelPar_PQMACC;
  AdmsSensFadType modelPar_VSAT=mod.VSAT;
  bool modelPar_given_VSAT=mod.given("VSAT");
  modParamMap["VSAT"] = &modelPar_VSAT;
  AdmsSensFadType modelPar_VSATR=mod.VSATR;
  bool modelPar_given_VSATR=mod.given("VSATR");
  modParamMap["VSATR"] = &modelPar_VSATR;
  AdmsSensFadType modelPar_VSATN1=mod.VSATN1;
  bool modelPar_given_VSATN1=mod.given("VSATN1");
  modParamMap["VSATN1"] = &modelPar_VSATN1;
  AdmsSensFadType modelPar_VSATN2=mod.VSATN2;
  bool modelPar_given_VSATN2=mod.given("VSATN2");
  modParamMap["VSATN2"] = &modelPar_VSATN2;
  AdmsSensFadType modelPar_VSATRN1=mod.VSATRN1;
  bool modelPar_given_VSATRN1=mod.given("VSATRN1");
  modParamMap["VSATRN1"] = &modelPar_VSATRN1;
  AdmsSensFadType modelPar_VSATRN2=mod.VSATRN2;
  bool modelPar_given_VSATRN2=mod.given("VSATRN2");
  modParamMap["VSATRN2"] = &modelPar_VSATRN2;
  AdmsSensFadType modelPar_AVSAT=mod.AVSAT;
  bool modelPar_given_AVSAT=mod.given("AVSAT");
  modParamMap["AVSAT"] = &modelPar_AVSAT;
  AdmsSensFadType modelPar_BVSAT=mod.BVSAT;
  bool modelPar_given_BVSAT=mod.given("BVSAT");
  modParamMap["BVSAT"] = &modelPar_BVSAT;
  AdmsSensFadType modelPar_VSAT1=mod.VSAT1;
  bool modelPar_given_VSAT1=mod.given("VSAT1");
  modParamMap["VSAT1"] = &modelPar_VSAT1;
  AdmsSensFadType modelPar_VSAT1N1=mod.VSAT1N1;
  bool modelPar_given_VSAT1N1=mod.given("VSAT1N1");
  modParamMap["VSAT1N1"] = &modelPar_VSAT1N1;
  AdmsSensFadType modelPar_VSAT1N2=mod.VSAT1N2;
  bool modelPar_given_VSAT1N2=mod.given("VSAT1N2");
  modParamMap["VSAT1N2"] = &modelPar_VSAT1N2;
  AdmsSensFadType modelPar_VSAT1R=mod.VSAT1R;
  bool modelPar_given_VSAT1R=mod.given("VSAT1R");
  modParamMap["VSAT1R"] = &modelPar_VSAT1R;
  AdmsSensFadType modelPar_VSAT1RN1=mod.VSAT1RN1;
  bool modelPar_given_VSAT1RN1=mod.given("VSAT1RN1");
  modParamMap["VSAT1RN1"] = &modelPar_VSAT1RN1;
  AdmsSensFadType modelPar_VSAT1RN2=mod.VSAT1RN2;
  bool modelPar_given_VSAT1RN2=mod.given("VSAT1RN2");
  modParamMap["VSAT1RN2"] = &modelPar_VSAT1RN2;
  AdmsSensFadType modelPar_AVSAT1=mod.AVSAT1;
  bool modelPar_given_AVSAT1=mod.given("AVSAT1");
  modParamMap["AVSAT1"] = &modelPar_AVSAT1;
  AdmsSensFadType modelPar_BVSAT1=mod.BVSAT1;
  bool modelPar_given_BVSAT1=mod.given("BVSAT1");
  modParamMap["BVSAT1"] = &modelPar_BVSAT1;
  AdmsSensFadType modelPar_DELTAVSAT=mod.DELTAVSAT;
  bool modelPar_given_DELTAVSAT=mod.given("DELTAVSAT");
  modParamMap["DELTAVSAT"] = &modelPar_DELTAVSAT;
  AdmsSensFadType modelPar_PSAT=mod.PSAT;
  bool modelPar_given_PSAT=mod.given("PSAT");
  modParamMap["PSAT"] = &modelPar_PSAT;
  AdmsSensFadType modelPar_APSAT=mod.APSAT;
  bool modelPar_given_APSAT=mod.given("APSAT");
  modParamMap["APSAT"] = &modelPar_APSAT;
  AdmsSensFadType modelPar_BPSAT=mod.BPSAT;
  bool modelPar_given_BPSAT=mod.given("BPSAT");
  modParamMap["BPSAT"] = &modelPar_BPSAT;
  AdmsSensFadType modelPar_KSATIV=mod.KSATIV;
  bool modelPar_given_KSATIV=mod.given("KSATIV");
  modParamMap["KSATIV"] = &modelPar_KSATIV;
  AdmsSensFadType modelPar_KSATIVR=mod.KSATIVR;
  bool modelPar_given_KSATIVR=mod.given("KSATIVR");
  modParamMap["KSATIVR"] = &modelPar_KSATIVR;
  AdmsSensFadType modelPar_VSATCV=mod.VSATCV;
  bool modelPar_given_VSATCV=mod.given("VSATCV");
  modParamMap["VSATCV"] = &modelPar_VSATCV;
  AdmsSensFadType modelPar_AVSATCV=mod.AVSATCV;
  bool modelPar_given_AVSATCV=mod.given("AVSATCV");
  modParamMap["AVSATCV"] = &modelPar_AVSATCV;
  AdmsSensFadType modelPar_BVSATCV=mod.BVSATCV;
  bool modelPar_given_BVSATCV=mod.given("BVSATCV");
  modParamMap["BVSATCV"] = &modelPar_BVSATCV;
  AdmsSensFadType modelPar_DELTAVSATCV=mod.DELTAVSATCV;
  bool modelPar_given_DELTAVSATCV=mod.given("DELTAVSATCV");
  modParamMap["DELTAVSATCV"] = &modelPar_DELTAVSATCV;
  AdmsSensFadType modelPar_PSATCV=mod.PSATCV;
  bool modelPar_given_PSATCV=mod.given("PSATCV");
  modParamMap["PSATCV"] = &modelPar_PSATCV;
  AdmsSensFadType modelPar_APSATCV=mod.APSATCV;
  bool modelPar_given_APSATCV=mod.given("APSATCV");
  modParamMap["APSATCV"] = &modelPar_APSATCV;
  AdmsSensFadType modelPar_BPSATCV=mod.BPSATCV;
  bool modelPar_given_BPSATCV=mod.given("BPSATCV");
  modParamMap["BPSATCV"] = &modelPar_BPSATCV;
  AdmsSensFadType modelPar_MEXP=mod.MEXP;
  bool modelPar_given_MEXP=mod.given("MEXP");
  modParamMap["MEXP"] = &modelPar_MEXP;
  AdmsSensFadType modelPar_AMEXP=mod.AMEXP;
  bool modelPar_given_AMEXP=mod.given("AMEXP");
  modParamMap["AMEXP"] = &modelPar_AMEXP;
  AdmsSensFadType modelPar_BMEXP=mod.BMEXP;
  bool modelPar_given_BMEXP=mod.given("BMEXP");
  modParamMap["BMEXP"] = &modelPar_BMEXP;
  AdmsSensFadType modelPar_MEXPR=mod.MEXPR;
  bool modelPar_given_MEXPR=mod.given("MEXPR");
  modParamMap["MEXPR"] = &modelPar_MEXPR;
  AdmsSensFadType modelPar_AMEXPR=mod.AMEXPR;
  bool modelPar_given_AMEXPR=mod.given("AMEXPR");
  modParamMap["AMEXPR"] = &modelPar_AMEXPR;
  AdmsSensFadType modelPar_BMEXPR=mod.BMEXPR;
  bool modelPar_given_BMEXPR=mod.given("BMEXPR");
  modParamMap["BMEXPR"] = &modelPar_BMEXPR;
  AdmsSensFadType modelPar_PTWG=mod.PTWG;
  bool modelPar_given_PTWG=mod.given("PTWG");
  modParamMap["PTWG"] = &modelPar_PTWG;
  AdmsSensFadType modelPar_PTWGR=mod.PTWGR;
  bool modelPar_given_PTWGR=mod.given("PTWGR");
  modParamMap["PTWGR"] = &modelPar_PTWGR;
  AdmsSensFadType modelPar_APTWG=mod.APTWG;
  bool modelPar_given_APTWG=mod.given("APTWG");
  modParamMap["APTWG"] = &modelPar_APTWG;
  AdmsSensFadType modelPar_BPTWG=mod.BPTWG;
  bool modelPar_given_BPTWG=mod.given("BPTWG");
  modParamMap["BPTWG"] = &modelPar_BPTWG;
  AdmsSensFadType modelPar_AT=mod.AT;
  bool modelPar_given_AT=mod.given("AT");
  modParamMap["AT"] = &modelPar_AT;
  AdmsSensFadType modelPar_ATR=mod.ATR;
  bool modelPar_given_ATR=mod.given("ATR");
  modParamMap["ATR"] = &modelPar_ATR;
  AdmsSensFadType modelPar_ATCV=mod.ATCV;
  bool modelPar_given_ATCV=mod.given("ATCV");
  modParamMap["ATCV"] = &modelPar_ATCV;
  AdmsSensFadType modelPar_TMEXP=mod.TMEXP;
  bool modelPar_given_TMEXP=mod.given("TMEXP");
  modParamMap["TMEXP"] = &modelPar_TMEXP;
  AdmsSensFadType modelPar_TMEXPR=mod.TMEXPR;
  bool modelPar_given_TMEXPR=mod.given("TMEXPR");
  modParamMap["TMEXPR"] = &modelPar_TMEXPR;
  AdmsSensFadType modelPar_PTWGT=mod.PTWGT;
  bool modelPar_given_PTWGT=mod.given("PTWGT");
  modParamMap["PTWGT"] = &modelPar_PTWGT;
  AdmsSensFadType modelPar_U0=mod.U0;
  bool modelPar_given_U0=mod.given("U0");
  modParamMap["U0"] = &modelPar_U0;
  AdmsSensFadType modelPar_U0R=mod.U0R;
  bool modelPar_given_U0R=mod.given("U0R");
  modParamMap["U0R"] = &modelPar_U0R;
  AdmsSensFadType modelPar_U0N1=mod.U0N1;
  bool modelPar_given_U0N1=mod.given("U0N1");
  modParamMap["U0N1"] = &modelPar_U0N1;
  AdmsSensFadType modelPar_U0N1R=mod.U0N1R;
  bool modelPar_given_U0N1R=mod.given("U0N1R");
  modParamMap["U0N1R"] = &modelPar_U0N1R;
  AdmsSensFadType modelPar_U0N2=mod.U0N2;
  bool modelPar_given_U0N2=mod.given("U0N2");
  modParamMap["U0N2"] = &modelPar_U0N2;
  AdmsSensFadType modelPar_U0N2R=mod.U0N2R;
  bool modelPar_given_U0N2R=mod.given("U0N2R");
  modParamMap["U0N2R"] = &modelPar_U0N2R;
  AdmsSensFadType modelPar_U0LT=mod.U0LT;
  bool modelPar_given_U0LT=mod.given("U0LT");
  modParamMap["U0LT"] = &modelPar_U0LT;
  AdmsSensFadType modelPar_ETAMOB=mod.ETAMOB;
  bool modelPar_given_ETAMOB=mod.given("ETAMOB");
  modParamMap["ETAMOB"] = &modelPar_ETAMOB;
  AdmsSensFadType modelPar_UP=mod.UP;
  bool modelPar_given_UP=mod.given("UP");
  modParamMap["UP"] = &modelPar_UP;
  AdmsSensFadType modelPar_LPA=mod.LPA;
  bool modelPar_given_LPA=mod.given("LPA");
  modParamMap["LPA"] = &modelPar_LPA;
  AdmsSensFadType modelPar_UPR=mod.UPR;
  bool modelPar_given_UPR=mod.given("UPR");
  modParamMap["UPR"] = &modelPar_UPR;
  AdmsSensFadType modelPar_LPAR=mod.LPAR;
  bool modelPar_given_LPAR=mod.given("LPAR");
  modParamMap["LPAR"] = &modelPar_LPAR;
  AdmsSensFadType modelPar_UA=mod.UA;
  bool modelPar_given_UA=mod.given("UA");
  modParamMap["UA"] = &modelPar_UA;
  AdmsSensFadType modelPar_UAR=mod.UAR;
  bool modelPar_given_UAR=mod.given("UAR");
  modParamMap["UAR"] = &modelPar_UAR;
  AdmsSensFadType modelPar_AUA=mod.AUA;
  bool modelPar_given_AUA=mod.given("AUA");
  modParamMap["AUA"] = &modelPar_AUA;
  AdmsSensFadType modelPar_AUAR=mod.AUAR;
  bool modelPar_given_AUAR=mod.given("AUAR");
  modParamMap["AUAR"] = &modelPar_AUAR;
  AdmsSensFadType modelPar_BUA=mod.BUA;
  bool modelPar_given_BUA=mod.given("BUA");
  modParamMap["BUA"] = &modelPar_BUA;
  AdmsSensFadType modelPar_BUAR=mod.BUAR;
  bool modelPar_given_BUAR=mod.given("BUAR");
  modParamMap["BUAR"] = &modelPar_BUAR;
  AdmsSensFadType modelPar_UC=mod.UC;
  bool modelPar_given_UC=mod.given("UC");
  modParamMap["UC"] = &modelPar_UC;
  AdmsSensFadType modelPar_UCR=mod.UCR;
  bool modelPar_given_UCR=mod.given("UCR");
  modParamMap["UCR"] = &modelPar_UCR;
  AdmsSensFadType modelPar_EU=mod.EU;
  bool modelPar_given_EU=mod.given("EU");
  modParamMap["EU"] = &modelPar_EU;
  AdmsSensFadType modelPar_EUR=mod.EUR;
  bool modelPar_given_EUR=mod.given("EUR");
  modParamMap["EUR"] = &modelPar_EUR;
  AdmsSensFadType modelPar_AEU=mod.AEU;
  bool modelPar_given_AEU=mod.given("AEU");
  modParamMap["AEU"] = &modelPar_AEU;
  AdmsSensFadType modelPar_AEUR=mod.AEUR;
  bool modelPar_given_AEUR=mod.given("AEUR");
  modParamMap["AEUR"] = &modelPar_AEUR;
  AdmsSensFadType modelPar_BEU=mod.BEU;
  bool modelPar_given_BEU=mod.given("BEU");
  modParamMap["BEU"] = &modelPar_BEU;
  AdmsSensFadType modelPar_BEUR=mod.BEUR;
  bool modelPar_given_BEUR=mod.given("BEUR");
  modParamMap["BEUR"] = &modelPar_BEUR;
  AdmsSensFadType modelPar_UD=mod.UD;
  bool modelPar_given_UD=mod.given("UD");
  modParamMap["UD"] = &modelPar_UD;
  AdmsSensFadType modelPar_UDR=mod.UDR;
  bool modelPar_given_UDR=mod.given("UDR");
  modParamMap["UDR"] = &modelPar_UDR;
  AdmsSensFadType modelPar_AUD=mod.AUD;
  bool modelPar_given_AUD=mod.given("AUD");
  modParamMap["AUD"] = &modelPar_AUD;
  AdmsSensFadType modelPar_AUDR=mod.AUDR;
  bool modelPar_given_AUDR=mod.given("AUDR");
  modParamMap["AUDR"] = &modelPar_AUDR;
  AdmsSensFadType modelPar_BUD=mod.BUD;
  bool modelPar_given_BUD=mod.given("BUD");
  modParamMap["BUD"] = &modelPar_BUD;
  AdmsSensFadType modelPar_BUDR=mod.BUDR;
  bool modelPar_given_BUDR=mod.given("BUDR");
  modParamMap["BUDR"] = &modelPar_BUDR;
  AdmsSensFadType modelPar_UCS=mod.UCS;
  bool modelPar_given_UCS=mod.given("UCS");
  modParamMap["UCS"] = &modelPar_UCS;
  AdmsSensFadType modelPar_UTE=mod.UTE;
  bool modelPar_given_UTE=mod.given("UTE");
  modParamMap["UTE"] = &modelPar_UTE;
  AdmsSensFadType modelPar_UTER=mod.UTER;
  bool modelPar_given_UTER=mod.given("UTER");
  modParamMap["UTER"] = &modelPar_UTER;
  AdmsSensFadType modelPar_UTL=mod.UTL;
  bool modelPar_given_UTL=mod.given("UTL");
  modParamMap["UTL"] = &modelPar_UTL;
  AdmsSensFadType modelPar_UTLR=mod.UTLR;
  bool modelPar_given_UTLR=mod.given("UTLR");
  modParamMap["UTLR"] = &modelPar_UTLR;
  AdmsSensFadType modelPar_EMOBT=mod.EMOBT;
  bool modelPar_given_EMOBT=mod.given("EMOBT");
  modParamMap["EMOBT"] = &modelPar_EMOBT;
  AdmsSensFadType modelPar_UA1=mod.UA1;
  bool modelPar_given_UA1=mod.given("UA1");
  modParamMap["UA1"] = &modelPar_UA1;
  AdmsSensFadType modelPar_UA1R=mod.UA1R;
  bool modelPar_given_UA1R=mod.given("UA1R");
  modParamMap["UA1R"] = &modelPar_UA1R;
  AdmsSensFadType modelPar_UC1=mod.UC1;
  bool modelPar_given_UC1=mod.given("UC1");
  modParamMap["UC1"] = &modelPar_UC1;
  AdmsSensFadType modelPar_UC1R=mod.UC1R;
  bool modelPar_given_UC1R=mod.given("UC1R");
  modParamMap["UC1R"] = &modelPar_UC1R;
  AdmsSensFadType modelPar_UD1=mod.UD1;
  bool modelPar_given_UD1=mod.given("UD1");
  modParamMap["UD1"] = &modelPar_UD1;
  AdmsSensFadType modelPar_UD1R=mod.UD1R;
  bool modelPar_given_UD1R=mod.given("UD1R");
  modParamMap["UD1R"] = &modelPar_UD1R;
  AdmsSensFadType modelPar_UCSTE=mod.UCSTE;
  bool modelPar_given_UCSTE=mod.given("UCSTE");
  modParamMap["UCSTE"] = &modelPar_UCSTE;
  AdmsSensFadType modelPar_CHARGEWF=mod.CHARGEWF;
  bool modelPar_given_CHARGEWF=mod.given("CHARGEWF");
  modParamMap["CHARGEWF"] = &modelPar_CHARGEWF;
  AdmsSensFadType modelPar_RDSWMIN=mod.RDSWMIN;
  bool modelPar_given_RDSWMIN=mod.given("RDSWMIN");
  modParamMap["RDSWMIN"] = &modelPar_RDSWMIN;
  AdmsSensFadType modelPar_RDSW=mod.RDSW;
  bool modelPar_given_RDSW=mod.given("RDSW");
  modParamMap["RDSW"] = &modelPar_RDSW;
  AdmsSensFadType modelPar_ARDSW=mod.ARDSW;
  bool modelPar_given_ARDSW=mod.given("ARDSW");
  modParamMap["ARDSW"] = &modelPar_ARDSW;
  AdmsSensFadType modelPar_BRDSW=mod.BRDSW;
  bool modelPar_given_BRDSW=mod.given("BRDSW");
  modParamMap["BRDSW"] = &modelPar_BRDSW;
  AdmsSensFadType modelPar_RSWMIN=mod.RSWMIN;
  bool modelPar_given_RSWMIN=mod.given("RSWMIN");
  modParamMap["RSWMIN"] = &modelPar_RSWMIN;
  AdmsSensFadType modelPar_RSW=mod.RSW;
  bool modelPar_given_RSW=mod.given("RSW");
  modParamMap["RSW"] = &modelPar_RSW;
  AdmsSensFadType modelPar_ARSW=mod.ARSW;
  bool modelPar_given_ARSW=mod.given("ARSW");
  modParamMap["ARSW"] = &modelPar_ARSW;
  AdmsSensFadType modelPar_BRSW=mod.BRSW;
  bool modelPar_given_BRSW=mod.given("BRSW");
  modParamMap["BRSW"] = &modelPar_BRSW;
  AdmsSensFadType modelPar_RDWMIN=mod.RDWMIN;
  bool modelPar_given_RDWMIN=mod.given("RDWMIN");
  modParamMap["RDWMIN"] = &modelPar_RDWMIN;
  AdmsSensFadType modelPar_RDW=mod.RDW;
  bool modelPar_given_RDW=mod.given("RDW");
  modParamMap["RDW"] = &modelPar_RDW;
  AdmsSensFadType modelPar_ARDW=mod.ARDW;
  bool modelPar_given_ARDW=mod.given("ARDW");
  modParamMap["ARDW"] = &modelPar_ARDW;
  AdmsSensFadType modelPar_BRDW=mod.BRDW;
  bool modelPar_given_BRDW=mod.given("BRDW");
  modParamMap["BRDW"] = &modelPar_BRDW;
  AdmsSensFadType modelPar_RSDR=mod.RSDR;
  bool modelPar_given_RSDR=mod.given("RSDR");
  modParamMap["RSDR"] = &modelPar_RSDR;
  AdmsSensFadType modelPar_RSDRR=mod.RSDRR;
  bool modelPar_given_RSDRR=mod.given("RSDRR");
  modParamMap["RSDRR"] = &modelPar_RSDRR;
  AdmsSensFadType modelPar_RDDR=mod.RDDR;
  bool modelPar_given_RDDR=mod.given("RDDR");
  modParamMap["RDDR"] = &modelPar_RDDR;
  AdmsSensFadType modelPar_RDDRR=mod.RDDRR;
  bool modelPar_given_RDDRR=mod.given("RDDRR");
  modParamMap["RDDRR"] = &modelPar_RDDRR;
  AdmsSensFadType modelPar_PRSDR=mod.PRSDR;
  bool modelPar_given_PRSDR=mod.given("PRSDR");
  modParamMap["PRSDR"] = &modelPar_PRSDR;
  AdmsSensFadType modelPar_PRDDR=mod.PRDDR;
  bool modelPar_given_PRDDR=mod.given("PRDDR");
  modParamMap["PRDDR"] = &modelPar_PRDDR;
  AdmsSensFadType modelPar_PRWGS=mod.PRWGS;
  bool modelPar_given_PRWGS=mod.given("PRWGS");
  modParamMap["PRWGS"] = &modelPar_PRWGS;
  AdmsSensFadType modelPar_PRWGD=mod.PRWGD;
  bool modelPar_given_PRWGD=mod.given("PRWGD");
  modParamMap["PRWGD"] = &modelPar_PRWGD;
  AdmsSensFadType modelPar_WR=mod.WR;
  bool modelPar_given_WR=mod.given("WR");
  modParamMap["WR"] = &modelPar_WR;
  AdmsSensFadType modelPar_PRT=mod.PRT;
  bool modelPar_given_PRT=mod.given("PRT");
  modParamMap["PRT"] = &modelPar_PRT;
  AdmsSensFadType modelPar_TRSDR=mod.TRSDR;
  bool modelPar_given_TRSDR=mod.given("TRSDR");
  modParamMap["TRSDR"] = &modelPar_TRSDR;
  AdmsSensFadType modelPar_TRDDR=mod.TRDDR;
  bool modelPar_given_TRDDR=mod.given("TRDDR");
  modParamMap["TRDDR"] = &modelPar_TRDDR;
  AdmsSensFadType modelPar_PDIBL1=mod.PDIBL1;
  bool modelPar_given_PDIBL1=mod.given("PDIBL1");
  modParamMap["PDIBL1"] = &modelPar_PDIBL1;
  AdmsSensFadType modelPar_PDIBL1R=mod.PDIBL1R;
  bool modelPar_given_PDIBL1R=mod.given("PDIBL1R");
  modParamMap["PDIBL1R"] = &modelPar_PDIBL1R;
  AdmsSensFadType modelPar_PDIBL2=mod.PDIBL2;
  bool modelPar_given_PDIBL2=mod.given("PDIBL2");
  modParamMap["PDIBL2"] = &modelPar_PDIBL2;
  AdmsSensFadType modelPar_PDIBL2R=mod.PDIBL2R;
  bool modelPar_given_PDIBL2R=mod.given("PDIBL2R");
  modParamMap["PDIBL2R"] = &modelPar_PDIBL2R;
  AdmsSensFadType modelPar_DROUT=mod.DROUT;
  bool modelPar_given_DROUT=mod.given("DROUT");
  modParamMap["DROUT"] = &modelPar_DROUT;
  AdmsSensFadType modelPar_PVAG=mod.PVAG;
  bool modelPar_given_PVAG=mod.given("PVAG");
  modParamMap["PVAG"] = &modelPar_PVAG;
  AdmsSensFadType modelPar_PCLM=mod.PCLM;
  bool modelPar_given_PCLM=mod.given("PCLM");
  modParamMap["PCLM"] = &modelPar_PCLM;
  AdmsSensFadType modelPar_PCLMR=mod.PCLMR;
  bool modelPar_given_PCLMR=mod.given("PCLMR");
  modParamMap["PCLMR"] = &modelPar_PCLMR;
  AdmsSensFadType modelPar_APCLM=mod.APCLM;
  bool modelPar_given_APCLM=mod.given("APCLM");
  modParamMap["APCLM"] = &modelPar_APCLM;
  AdmsSensFadType modelPar_APCLMR=mod.APCLMR;
  bool modelPar_given_APCLMR=mod.given("APCLMR");
  modParamMap["APCLMR"] = &modelPar_APCLMR;
  AdmsSensFadType modelPar_BPCLM=mod.BPCLM;
  bool modelPar_given_BPCLM=mod.given("BPCLM");
  modParamMap["BPCLM"] = &modelPar_BPCLM;
  AdmsSensFadType modelPar_BPCLMR=mod.BPCLMR;
  bool modelPar_given_BPCLMR=mod.given("BPCLMR");
  modParamMap["BPCLMR"] = &modelPar_BPCLMR;
  AdmsSensFadType modelPar_PCLMG=mod.PCLMG;
  bool modelPar_given_PCLMG=mod.given("PCLMG");
  modParamMap["PCLMG"] = &modelPar_PCLMG;
  AdmsSensFadType modelPar_PCLMCV=mod.PCLMCV;
  bool modelPar_given_PCLMCV=mod.given("PCLMCV");
  modParamMap["PCLMCV"] = &modelPar_PCLMCV;
  AdmsSensFadType modelPar_A1=mod.A1;
  bool modelPar_given_A1=mod.given("A1");
  modParamMap["A1"] = &modelPar_A1;
  AdmsSensFadType modelPar_A11=mod.A11;
  bool modelPar_given_A11=mod.given("A11");
  modParamMap["A11"] = &modelPar_A11;
  AdmsSensFadType modelPar_A2=mod.A2;
  bool modelPar_given_A2=mod.given("A2");
  modParamMap["A2"] = &modelPar_A2;
  AdmsSensFadType modelPar_A21=mod.A21;
  bool modelPar_given_A21=mod.given("A21");
  modParamMap["A21"] = &modelPar_A21;
  AdmsSensFadType modelPar_RGEXT=mod.RGEXT;
  bool modelPar_given_RGEXT=mod.given("RGEXT");
  modParamMap["RGEXT"] = &modelPar_RGEXT;
  AdmsSensFadType modelPar_RGFIN=mod.RGFIN;
  bool modelPar_given_RGFIN=mod.given("RGFIN");
  modParamMap["RGFIN"] = &modelPar_RGFIN;
  AdmsSensFadType modelPar_RSHS=mod.RSHS;
  bool modelPar_given_RSHS=mod.given("RSHS");
  modParamMap["RSHS"] = &modelPar_RSHS;
  AdmsSensFadType modelPar_RSHD=mod.RSHD;
  bool modelPar_given_RSHD=mod.given("RSHD");
  modParamMap["RSHD"] = &modelPar_RSHD;
  AdmsSensFadType modelPar_HEPI=mod.HEPI;
  bool modelPar_given_HEPI=mod.given("HEPI");
  modParamMap["HEPI"] = &modelPar_HEPI;
  AdmsSensFadType modelPar_TSILI=mod.TSILI;
  bool modelPar_given_TSILI=mod.given("TSILI");
  modParamMap["TSILI"] = &modelPar_TSILI;
  AdmsSensFadType modelPar_RHOC=mod.RHOC;
  bool modelPar_given_RHOC=mod.given("RHOC");
  modParamMap["RHOC"] = &modelPar_RHOC;
  AdmsSensFadType modelPar_RHORSD=mod.RHORSD;
  bool modelPar_given_RHORSD=mod.given("RHORSD");
  modParamMap["RHORSD"] = &modelPar_RHORSD;
  AdmsSensFadType modelPar_CRATIO=mod.CRATIO;
  bool modelPar_given_CRATIO=mod.given("CRATIO");
  modParamMap["CRATIO"] = &modelPar_CRATIO;
  AdmsSensFadType modelPar_DELTAPRSD=mod.DELTAPRSD;
  bool modelPar_given_DELTAPRSD=mod.given("DELTAPRSD");
  modParamMap["DELTAPRSD"] = &modelPar_DELTAPRSD;
  AdmsSensFadType modelPar_LSP=mod.LSP;
  bool modelPar_given_LSP=mod.given("LSP");
  modParamMap["LSP"] = &modelPar_LSP;
  AdmsSensFadType modelPar_EPSRSP=mod.EPSRSP;
  bool modelPar_given_EPSRSP=mod.given("EPSRSP");
  modParamMap["EPSRSP"] = &modelPar_EPSRSP;
  AdmsSensFadType modelPar_TGATE=mod.TGATE;
  bool modelPar_given_TGATE=mod.given("TGATE");
  modParamMap["TGATE"] = &modelPar_TGATE;
  AdmsSensFadType modelPar_TMASK=mod.TMASK;
  bool modelPar_given_TMASK=mod.given("TMASK");
  modParamMap["TMASK"] = &modelPar_TMASK;
  AdmsSensFadType modelPar_ASILIEND=mod.ASILIEND;
  bool modelPar_given_ASILIEND=mod.given("ASILIEND");
  modParamMap["ASILIEND"] = &modelPar_ASILIEND;
  AdmsSensFadType modelPar_ARSDEND=mod.ARSDEND;
  bool modelPar_given_ARSDEND=mod.given("ARSDEND");
  modParamMap["ARSDEND"] = &modelPar_ARSDEND;
  AdmsSensFadType modelPar_PRSDEND=mod.PRSDEND;
  bool modelPar_given_PRSDEND=mod.given("PRSDEND");
  modParamMap["PRSDEND"] = &modelPar_PRSDEND;
  AdmsSensFadType modelPar_NSDE=mod.NSDE;
  bool modelPar_given_NSDE=mod.given("NSDE");
  modParamMap["NSDE"] = &modelPar_NSDE;
  AdmsSensFadType modelPar_RGEOA=mod.RGEOA;
  bool modelPar_given_RGEOA=mod.given("RGEOA");
  modParamMap["RGEOA"] = &modelPar_RGEOA;
  AdmsSensFadType modelPar_RGEOB=mod.RGEOB;
  bool modelPar_given_RGEOB=mod.given("RGEOB");
  modParamMap["RGEOB"] = &modelPar_RGEOB;
  AdmsSensFadType modelPar_RGEOC=mod.RGEOC;
  bool modelPar_given_RGEOC=mod.given("RGEOC");
  modParamMap["RGEOC"] = &modelPar_RGEOC;
  AdmsSensFadType modelPar_RGEOD=mod.RGEOD;
  bool modelPar_given_RGEOD=mod.given("RGEOD");
  modParamMap["RGEOD"] = &modelPar_RGEOD;
  AdmsSensFadType modelPar_RGEOE=mod.RGEOE;
  bool modelPar_given_RGEOE=mod.given("RGEOE");
  modParamMap["RGEOE"] = &modelPar_RGEOE;
  AdmsSensFadType modelPar_CGEOA=mod.CGEOA;
  bool modelPar_given_CGEOA=mod.given("CGEOA");
  modParamMap["CGEOA"] = &modelPar_CGEOA;
  AdmsSensFadType modelPar_CGEOB=mod.CGEOB;
  bool modelPar_given_CGEOB=mod.given("CGEOB");
  modParamMap["CGEOB"] = &modelPar_CGEOB;
  AdmsSensFadType modelPar_CGEOC=mod.CGEOC;
  bool modelPar_given_CGEOC=mod.given("CGEOC");
  modParamMap["CGEOC"] = &modelPar_CGEOC;
  AdmsSensFadType modelPar_CGEOD=mod.CGEOD;
  bool modelPar_given_CGEOD=mod.given("CGEOD");
  modParamMap["CGEOD"] = &modelPar_CGEOD;
  AdmsSensFadType modelPar_CGEOE=mod.CGEOE;
  bool modelPar_given_CGEOE=mod.given("CGEOE");
  modParamMap["CGEOE"] = &modelPar_CGEOE;
  AdmsSensFadType modelPar_AIGBINV=mod.AIGBINV;
  bool modelPar_given_AIGBINV=mod.given("AIGBINV");
  modParamMap["AIGBINV"] = &modelPar_AIGBINV;
  AdmsSensFadType modelPar_AIGBINV1=mod.AIGBINV1;
  bool modelPar_given_AIGBINV1=mod.given("AIGBINV1");
  modParamMap["AIGBINV1"] = &modelPar_AIGBINV1;
  AdmsSensFadType modelPar_BIGBINV=mod.BIGBINV;
  bool modelPar_given_BIGBINV=mod.given("BIGBINV");
  modParamMap["BIGBINV"] = &modelPar_BIGBINV;
  AdmsSensFadType modelPar_CIGBINV=mod.CIGBINV;
  bool modelPar_given_CIGBINV=mod.given("CIGBINV");
  modParamMap["CIGBINV"] = &modelPar_CIGBINV;
  AdmsSensFadType modelPar_EIGBINV=mod.EIGBINV;
  bool modelPar_given_EIGBINV=mod.given("EIGBINV");
  modParamMap["EIGBINV"] = &modelPar_EIGBINV;
  AdmsSensFadType modelPar_NIGBINV=mod.NIGBINV;
  bool modelPar_given_NIGBINV=mod.given("NIGBINV");
  modParamMap["NIGBINV"] = &modelPar_NIGBINV;
  AdmsSensFadType modelPar_AIGBACC=mod.AIGBACC;
  bool modelPar_given_AIGBACC=mod.given("AIGBACC");
  modParamMap["AIGBACC"] = &modelPar_AIGBACC;
  AdmsSensFadType modelPar_AIGBACC1=mod.AIGBACC1;
  bool modelPar_given_AIGBACC1=mod.given("AIGBACC1");
  modParamMap["AIGBACC1"] = &modelPar_AIGBACC1;
  AdmsSensFadType modelPar_BIGBACC=mod.BIGBACC;
  bool modelPar_given_BIGBACC=mod.given("BIGBACC");
  modParamMap["BIGBACC"] = &modelPar_BIGBACC;
  AdmsSensFadType modelPar_CIGBACC=mod.CIGBACC;
  bool modelPar_given_CIGBACC=mod.given("CIGBACC");
  modParamMap["CIGBACC"] = &modelPar_CIGBACC;
  AdmsSensFadType modelPar_NIGBACC=mod.NIGBACC;
  bool modelPar_given_NIGBACC=mod.given("NIGBACC");
  modParamMap["NIGBACC"] = &modelPar_NIGBACC;
  AdmsSensFadType modelPar_AIGC=mod.AIGC;
  bool modelPar_given_AIGC=mod.given("AIGC");
  modParamMap["AIGC"] = &modelPar_AIGC;
  AdmsSensFadType modelPar_AIGC1=mod.AIGC1;
  bool modelPar_given_AIGC1=mod.given("AIGC1");
  modParamMap["AIGC1"] = &modelPar_AIGC1;
  AdmsSensFadType modelPar_BIGC=mod.BIGC;
  bool modelPar_given_BIGC=mod.given("BIGC");
  modParamMap["BIGC"] = &modelPar_BIGC;
  AdmsSensFadType modelPar_CIGC=mod.CIGC;
  bool modelPar_given_CIGC=mod.given("CIGC");
  modParamMap["CIGC"] = &modelPar_CIGC;
  AdmsSensFadType modelPar_PIGCD=mod.PIGCD;
  bool modelPar_given_PIGCD=mod.given("PIGCD");
  modParamMap["PIGCD"] = &modelPar_PIGCD;
  AdmsSensFadType modelPar_DLCIGS=mod.DLCIGS;
  bool modelPar_given_DLCIGS=mod.given("DLCIGS");
  modParamMap["DLCIGS"] = &modelPar_DLCIGS;
  AdmsSensFadType modelPar_AIGS=mod.AIGS;
  bool modelPar_given_AIGS=mod.given("AIGS");
  modParamMap["AIGS"] = &modelPar_AIGS;
  AdmsSensFadType modelPar_AIGS1=mod.AIGS1;
  bool modelPar_given_AIGS1=mod.given("AIGS1");
  modParamMap["AIGS1"] = &modelPar_AIGS1;
  AdmsSensFadType modelPar_BIGS=mod.BIGS;
  bool modelPar_given_BIGS=mod.given("BIGS");
  modParamMap["BIGS"] = &modelPar_BIGS;
  AdmsSensFadType modelPar_CIGS=mod.CIGS;
  bool modelPar_given_CIGS=mod.given("CIGS");
  modParamMap["CIGS"] = &modelPar_CIGS;
  AdmsSensFadType modelPar_DLCIGD=mod.DLCIGD;
  bool modelPar_given_DLCIGD=mod.given("DLCIGD");
  modParamMap["DLCIGD"] = &modelPar_DLCIGD;
  AdmsSensFadType modelPar_AIGD=mod.AIGD;
  bool modelPar_given_AIGD=mod.given("AIGD");
  modParamMap["AIGD"] = &modelPar_AIGD;
  AdmsSensFadType modelPar_AIGD1=mod.AIGD1;
  bool modelPar_given_AIGD1=mod.given("AIGD1");
  modParamMap["AIGD1"] = &modelPar_AIGD1;
  AdmsSensFadType modelPar_BIGD=mod.BIGD;
  bool modelPar_given_BIGD=mod.given("BIGD");
  modParamMap["BIGD"] = &modelPar_BIGD;
  AdmsSensFadType modelPar_CIGD=mod.CIGD;
  bool modelPar_given_CIGD=mod.given("CIGD");
  modParamMap["CIGD"] = &modelPar_CIGD;
  AdmsSensFadType modelPar_VFBSD=mod.VFBSD;
  bool modelPar_given_VFBSD=mod.given("VFBSD");
  modParamMap["VFBSD"] = &modelPar_VFBSD;
  AdmsSensFadType modelPar_VFBSDCV=mod.VFBSDCV;
  bool modelPar_given_VFBSDCV=mod.given("VFBSDCV");
  modParamMap["VFBSDCV"] = &modelPar_VFBSDCV;
  AdmsSensFadType modelPar_TOXREF=mod.TOXREF;
  bool modelPar_given_TOXREF=mod.given("TOXREF");
  modParamMap["TOXREF"] = &modelPar_TOXREF;
  AdmsSensFadType modelPar_TOXG=mod.TOXG;
  bool modelPar_given_TOXG=mod.given("TOXG");
  modParamMap["TOXG"] = &modelPar_TOXG;
  AdmsSensFadType modelPar_NTOX=mod.NTOX;
  bool modelPar_given_NTOX=mod.given("NTOX");
  modParamMap["NTOX"] = &modelPar_NTOX;
  AdmsSensFadType modelPar_POXEDGE=mod.POXEDGE;
  bool modelPar_given_POXEDGE=mod.given("POXEDGE");
  modParamMap["POXEDGE"] = &modelPar_POXEDGE;
  AdmsSensFadType modelPar_AGISL=mod.AGISL;
  bool modelPar_given_AGISL=mod.given("AGISL");
  modParamMap["AGISL"] = &modelPar_AGISL;
  AdmsSensFadType modelPar_BGISL=mod.BGISL;
  bool modelPar_given_BGISL=mod.given("BGISL");
  modParamMap["BGISL"] = &modelPar_BGISL;
  AdmsSensFadType modelPar_CGISL=mod.CGISL;
  bool modelPar_given_CGISL=mod.given("CGISL");
  modParamMap["CGISL"] = &modelPar_CGISL;
  AdmsSensFadType modelPar_EGISL=mod.EGISL;
  bool modelPar_given_EGISL=mod.given("EGISL");
  modParamMap["EGISL"] = &modelPar_EGISL;
  AdmsSensFadType modelPar_PGISL=mod.PGISL;
  bool modelPar_given_PGISL=mod.given("PGISL");
  modParamMap["PGISL"] = &modelPar_PGISL;
  AdmsSensFadType modelPar_AGIDL=mod.AGIDL;
  bool modelPar_given_AGIDL=mod.given("AGIDL");
  modParamMap["AGIDL"] = &modelPar_AGIDL;
  AdmsSensFadType modelPar_BGIDL=mod.BGIDL;
  bool modelPar_given_BGIDL=mod.given("BGIDL");
  modParamMap["BGIDL"] = &modelPar_BGIDL;
  AdmsSensFadType modelPar_CGIDL=mod.CGIDL;
  bool modelPar_given_CGIDL=mod.given("CGIDL");
  modParamMap["CGIDL"] = &modelPar_CGIDL;
  AdmsSensFadType modelPar_EGIDL=mod.EGIDL;
  bool modelPar_given_EGIDL=mod.given("EGIDL");
  modParamMap["EGIDL"] = &modelPar_EGIDL;
  AdmsSensFadType modelPar_PGIDL=mod.PGIDL;
  bool modelPar_given_PGIDL=mod.given("PGIDL");
  modParamMap["PGIDL"] = &modelPar_PGIDL;
  AdmsSensFadType modelPar_ALPHA0=mod.ALPHA0;
  bool modelPar_given_ALPHA0=mod.given("ALPHA0");
  modParamMap["ALPHA0"] = &modelPar_ALPHA0;
  AdmsSensFadType modelPar_ALPHA01=mod.ALPHA01;
  bool modelPar_given_ALPHA01=mod.given("ALPHA01");
  modParamMap["ALPHA01"] = &modelPar_ALPHA01;
  AdmsSensFadType modelPar_ALPHA1=mod.ALPHA1;
  bool modelPar_given_ALPHA1=mod.given("ALPHA1");
  modParamMap["ALPHA1"] = &modelPar_ALPHA1;
  AdmsSensFadType modelPar_ALPHA11=mod.ALPHA11;
  bool modelPar_given_ALPHA11=mod.given("ALPHA11");
  modParamMap["ALPHA11"] = &modelPar_ALPHA11;
  AdmsSensFadType modelPar_BETA0=mod.BETA0;
  bool modelPar_given_BETA0=mod.given("BETA0");
  modParamMap["BETA0"] = &modelPar_BETA0;
  AdmsSensFadType modelPar_ALPHAII0=mod.ALPHAII0;
  bool modelPar_given_ALPHAII0=mod.given("ALPHAII0");
  modParamMap["ALPHAII0"] = &modelPar_ALPHAII0;
  AdmsSensFadType modelPar_ALPHAII01=mod.ALPHAII01;
  bool modelPar_given_ALPHAII01=mod.given("ALPHAII01");
  modParamMap["ALPHAII01"] = &modelPar_ALPHAII01;
  AdmsSensFadType modelPar_ALPHAII1=mod.ALPHAII1;
  bool modelPar_given_ALPHAII1=mod.given("ALPHAII1");
  modParamMap["ALPHAII1"] = &modelPar_ALPHAII1;
  AdmsSensFadType modelPar_ALPHAII11=mod.ALPHAII11;
  bool modelPar_given_ALPHAII11=mod.given("ALPHAII11");
  modParamMap["ALPHAII11"] = &modelPar_ALPHAII11;
  AdmsSensFadType modelPar_BETAII0=mod.BETAII0;
  bool modelPar_given_BETAII0=mod.given("BETAII0");
  modParamMap["BETAII0"] = &modelPar_BETAII0;
  AdmsSensFadType modelPar_BETAII1=mod.BETAII1;
  bool modelPar_given_BETAII1=mod.given("BETAII1");
  modParamMap["BETAII1"] = &modelPar_BETAII1;
  AdmsSensFadType modelPar_BETAII2=mod.BETAII2;
  bool modelPar_given_BETAII2=mod.given("BETAII2");
  modParamMap["BETAII2"] = &modelPar_BETAII2;
  AdmsSensFadType modelPar_ESATII=mod.ESATII;
  bool modelPar_given_ESATII=mod.given("ESATII");
  modParamMap["ESATII"] = &modelPar_ESATII;
  AdmsSensFadType modelPar_LII=mod.LII;
  bool modelPar_given_LII=mod.given("LII");
  modParamMap["LII"] = &modelPar_LII;
  AdmsSensFadType modelPar_SII0=mod.SII0;
  bool modelPar_given_SII0=mod.given("SII0");
  modParamMap["SII0"] = &modelPar_SII0;
  AdmsSensFadType modelPar_SII1=mod.SII1;
  bool modelPar_given_SII1=mod.given("SII1");
  modParamMap["SII1"] = &modelPar_SII1;
  AdmsSensFadType modelPar_SII2=mod.SII2;
  bool modelPar_given_SII2=mod.given("SII2");
  modParamMap["SII2"] = &modelPar_SII2;
  AdmsSensFadType modelPar_SIID=mod.SIID;
  bool modelPar_given_SIID=mod.given("SIID");
  modParamMap["SIID"] = &modelPar_SIID;
  AdmsSensFadType modelPar_IIMOD2CLAMP1=mod.IIMOD2CLAMP1;
  bool modelPar_given_IIMOD2CLAMP1=mod.given("IIMOD2CLAMP1");
  modParamMap["IIMOD2CLAMP1"] = &modelPar_IIMOD2CLAMP1;
  AdmsSensFadType modelPar_IIMOD2CLAMP2=mod.IIMOD2CLAMP2;
  bool modelPar_given_IIMOD2CLAMP2=mod.given("IIMOD2CLAMP2");
  modParamMap["IIMOD2CLAMP2"] = &modelPar_IIMOD2CLAMP2;
  AdmsSensFadType modelPar_IIMOD2CLAMP3=mod.IIMOD2CLAMP3;
  bool modelPar_given_IIMOD2CLAMP3=mod.given("IIMOD2CLAMP3");
  modParamMap["IIMOD2CLAMP3"] = &modelPar_IIMOD2CLAMP3;
  AdmsSensFadType modelPar_EOTACC=mod.EOTACC;
  bool modelPar_given_EOTACC=mod.given("EOTACC");
  modParamMap["EOTACC"] = &modelPar_EOTACC;
  AdmsSensFadType modelPar_DELVFBACC=mod.DELVFBACC;
  bool modelPar_given_DELVFBACC=mod.given("DELVFBACC");
  modParamMap["DELVFBACC"] = &modelPar_DELVFBACC;
  AdmsSensFadType modelPar_CFS=mod.CFS;
  bool modelPar_given_CFS=mod.given("CFS");
  modParamMap["CFS"] = &modelPar_CFS;
  AdmsSensFadType modelPar_CFD=mod.CFD;
  bool modelPar_given_CFD=mod.given("CFD");
  modParamMap["CFD"] = &modelPar_CFD;
  AdmsSensFadType modelPar_CGSO=mod.CGSO;
  bool modelPar_given_CGSO=mod.given("CGSO");
  modParamMap["CGSO"] = &modelPar_CGSO;
  AdmsSensFadType modelPar_CGDO=mod.CGDO;
  bool modelPar_given_CGDO=mod.given("CGDO");
  modParamMap["CGDO"] = &modelPar_CGDO;
  AdmsSensFadType modelPar_CGSL=mod.CGSL;
  bool modelPar_given_CGSL=mod.given("CGSL");
  modParamMap["CGSL"] = &modelPar_CGSL;
  AdmsSensFadType modelPar_CGDL=mod.CGDL;
  bool modelPar_given_CGDL=mod.given("CGDL");
  modParamMap["CGDL"] = &modelPar_CGDL;
  AdmsSensFadType modelPar_CKAPPAS=mod.CKAPPAS;
  bool modelPar_given_CKAPPAS=mod.given("CKAPPAS");
  modParamMap["CKAPPAS"] = &modelPar_CKAPPAS;
  AdmsSensFadType modelPar_CKAPPAD=mod.CKAPPAD;
  bool modelPar_given_CKAPPAD=mod.given("CKAPPAD");
  modParamMap["CKAPPAD"] = &modelPar_CKAPPAD;
  AdmsSensFadType modelPar_CGBO=mod.CGBO;
  bool modelPar_given_CGBO=mod.given("CGBO");
  modParamMap["CGBO"] = &modelPar_CGBO;
  AdmsSensFadType modelPar_CGBN=mod.CGBN;
  bool modelPar_given_CGBN=mod.given("CGBN");
  modParamMap["CGBN"] = &modelPar_CGBN;
  AdmsSensFadType modelPar_CGBL=mod.CGBL;
  bool modelPar_given_CGBL=mod.given("CGBL");
  modParamMap["CGBL"] = &modelPar_CGBL;
  AdmsSensFadType modelPar_CKAPPAB=mod.CKAPPAB;
  bool modelPar_given_CKAPPAB=mod.given("CKAPPAB");
  modParamMap["CKAPPAB"] = &modelPar_CKAPPAB;
  AdmsSensFadType modelPar_CSDESW=mod.CSDESW;
  bool modelPar_given_CSDESW=mod.given("CSDESW");
  modParamMap["CSDESW"] = &modelPar_CSDESW;
  AdmsSensFadType modelPar_CJS=mod.CJS;
  bool modelPar_given_CJS=mod.given("CJS");
  modParamMap["CJS"] = &modelPar_CJS;
  AdmsSensFadType modelPar_CJD=mod.CJD;
  bool modelPar_given_CJD=mod.given("CJD");
  modParamMap["CJD"] = &modelPar_CJD;
  AdmsSensFadType modelPar_CJSWS=mod.CJSWS;
  bool modelPar_given_CJSWS=mod.given("CJSWS");
  modParamMap["CJSWS"] = &modelPar_CJSWS;
  AdmsSensFadType modelPar_CJSWD=mod.CJSWD;
  bool modelPar_given_CJSWD=mod.given("CJSWD");
  modParamMap["CJSWD"] = &modelPar_CJSWD;
  AdmsSensFadType modelPar_CJSWGS=mod.CJSWGS;
  bool modelPar_given_CJSWGS=mod.given("CJSWGS");
  modParamMap["CJSWGS"] = &modelPar_CJSWGS;
  AdmsSensFadType modelPar_CJSWGD=mod.CJSWGD;
  bool modelPar_given_CJSWGD=mod.given("CJSWGD");
  modParamMap["CJSWGD"] = &modelPar_CJSWGD;
  AdmsSensFadType modelPar_PBS=mod.PBS;
  bool modelPar_given_PBS=mod.given("PBS");
  modParamMap["PBS"] = &modelPar_PBS;
  AdmsSensFadType modelPar_PBD=mod.PBD;
  bool modelPar_given_PBD=mod.given("PBD");
  modParamMap["PBD"] = &modelPar_PBD;
  AdmsSensFadType modelPar_PBSWS=mod.PBSWS;
  bool modelPar_given_PBSWS=mod.given("PBSWS");
  modParamMap["PBSWS"] = &modelPar_PBSWS;
  AdmsSensFadType modelPar_PBSWD=mod.PBSWD;
  bool modelPar_given_PBSWD=mod.given("PBSWD");
  modParamMap["PBSWD"] = &modelPar_PBSWD;
  AdmsSensFadType modelPar_PBSWGS=mod.PBSWGS;
  bool modelPar_given_PBSWGS=mod.given("PBSWGS");
  modParamMap["PBSWGS"] = &modelPar_PBSWGS;
  AdmsSensFadType modelPar_PBSWGD=mod.PBSWGD;
  bool modelPar_given_PBSWGD=mod.given("PBSWGD");
  modParamMap["PBSWGD"] = &modelPar_PBSWGD;
  AdmsSensFadType modelPar_MJS=mod.MJS;
  bool modelPar_given_MJS=mod.given("MJS");
  modParamMap["MJS"] = &modelPar_MJS;
  AdmsSensFadType modelPar_MJD=mod.MJD;
  bool modelPar_given_MJD=mod.given("MJD");
  modParamMap["MJD"] = &modelPar_MJD;
  AdmsSensFadType modelPar_MJSWS=mod.MJSWS;
  bool modelPar_given_MJSWS=mod.given("MJSWS");
  modParamMap["MJSWS"] = &modelPar_MJSWS;
  AdmsSensFadType modelPar_MJSWD=mod.MJSWD;
  bool modelPar_given_MJSWD=mod.given("MJSWD");
  modParamMap["MJSWD"] = &modelPar_MJSWD;
  AdmsSensFadType modelPar_MJSWGS=mod.MJSWGS;
  bool modelPar_given_MJSWGS=mod.given("MJSWGS");
  modParamMap["MJSWGS"] = &modelPar_MJSWGS;
  AdmsSensFadType modelPar_MJSWGD=mod.MJSWGD;
  bool modelPar_given_MJSWGD=mod.given("MJSWGD");
  modParamMap["MJSWGD"] = &modelPar_MJSWGD;
  AdmsSensFadType modelPar_SJS=mod.SJS;
  bool modelPar_given_SJS=mod.given("SJS");
  modParamMap["SJS"] = &modelPar_SJS;
  AdmsSensFadType modelPar_SJD=mod.SJD;
  bool modelPar_given_SJD=mod.given("SJD");
  modParamMap["SJD"] = &modelPar_SJD;
  AdmsSensFadType modelPar_SJSWS=mod.SJSWS;
  bool modelPar_given_SJSWS=mod.given("SJSWS");
  modParamMap["SJSWS"] = &modelPar_SJSWS;
  AdmsSensFadType modelPar_SJSWD=mod.SJSWD;
  bool modelPar_given_SJSWD=mod.given("SJSWD");
  modParamMap["SJSWD"] = &modelPar_SJSWD;
  AdmsSensFadType modelPar_SJSWGS=mod.SJSWGS;
  bool modelPar_given_SJSWGS=mod.given("SJSWGS");
  modParamMap["SJSWGS"] = &modelPar_SJSWGS;
  AdmsSensFadType modelPar_SJSWGD=mod.SJSWGD;
  bool modelPar_given_SJSWGD=mod.given("SJSWGD");
  modParamMap["SJSWGD"] = &modelPar_SJSWGD;
  AdmsSensFadType modelPar_MJS2=mod.MJS2;
  bool modelPar_given_MJS2=mod.given("MJS2");
  modParamMap["MJS2"] = &modelPar_MJS2;
  AdmsSensFadType modelPar_MJD2=mod.MJD2;
  bool modelPar_given_MJD2=mod.given("MJD2");
  modParamMap["MJD2"] = &modelPar_MJD2;
  AdmsSensFadType modelPar_MJSWS2=mod.MJSWS2;
  bool modelPar_given_MJSWS2=mod.given("MJSWS2");
  modParamMap["MJSWS2"] = &modelPar_MJSWS2;
  AdmsSensFadType modelPar_MJSWD2=mod.MJSWD2;
  bool modelPar_given_MJSWD2=mod.given("MJSWD2");
  modParamMap["MJSWD2"] = &modelPar_MJSWD2;
  AdmsSensFadType modelPar_MJSWGS2=mod.MJSWGS2;
  bool modelPar_given_MJSWGS2=mod.given("MJSWGS2");
  modParamMap["MJSWGS2"] = &modelPar_MJSWGS2;
  AdmsSensFadType modelPar_MJSWGD2=mod.MJSWGD2;
  bool modelPar_given_MJSWGD2=mod.given("MJSWGD2");
  modParamMap["MJSWGD2"] = &modelPar_MJSWGD2;
  AdmsSensFadType modelPar_JSS=mod.JSS;
  bool modelPar_given_JSS=mod.given("JSS");
  modParamMap["JSS"] = &modelPar_JSS;
  AdmsSensFadType modelPar_JSD=mod.JSD;
  bool modelPar_given_JSD=mod.given("JSD");
  modParamMap["JSD"] = &modelPar_JSD;
  AdmsSensFadType modelPar_JSWS=mod.JSWS;
  bool modelPar_given_JSWS=mod.given("JSWS");
  modParamMap["JSWS"] = &modelPar_JSWS;
  AdmsSensFadType modelPar_JSWD=mod.JSWD;
  bool modelPar_given_JSWD=mod.given("JSWD");
  modParamMap["JSWD"] = &modelPar_JSWD;
  AdmsSensFadType modelPar_JSWGS=mod.JSWGS;
  bool modelPar_given_JSWGS=mod.given("JSWGS");
  modParamMap["JSWGS"] = &modelPar_JSWGS;
  AdmsSensFadType modelPar_JSWGD=mod.JSWGD;
  bool modelPar_given_JSWGD=mod.given("JSWGD");
  modParamMap["JSWGD"] = &modelPar_JSWGD;
  AdmsSensFadType modelPar_NJS=mod.NJS;
  bool modelPar_given_NJS=mod.given("NJS");
  modParamMap["NJS"] = &modelPar_NJS;
  AdmsSensFadType modelPar_NJD=mod.NJD;
  bool modelPar_given_NJD=mod.given("NJD");
  modParamMap["NJD"] = &modelPar_NJD;
  AdmsSensFadType modelPar_IJTHSFWD=mod.IJTHSFWD;
  bool modelPar_given_IJTHSFWD=mod.given("IJTHSFWD");
  modParamMap["IJTHSFWD"] = &modelPar_IJTHSFWD;
  AdmsSensFadType modelPar_IJTHDFWD=mod.IJTHDFWD;
  bool modelPar_given_IJTHDFWD=mod.given("IJTHDFWD");
  modParamMap["IJTHDFWD"] = &modelPar_IJTHDFWD;
  AdmsSensFadType modelPar_IJTHSREV=mod.IJTHSREV;
  bool modelPar_given_IJTHSREV=mod.given("IJTHSREV");
  modParamMap["IJTHSREV"] = &modelPar_IJTHSREV;
  AdmsSensFadType modelPar_IJTHDREV=mod.IJTHDREV;
  bool modelPar_given_IJTHDREV=mod.given("IJTHDREV");
  modParamMap["IJTHDREV"] = &modelPar_IJTHDREV;
  AdmsSensFadType modelPar_BVS=mod.BVS;
  bool modelPar_given_BVS=mod.given("BVS");
  modParamMap["BVS"] = &modelPar_BVS;
  AdmsSensFadType modelPar_BVD=mod.BVD;
  bool modelPar_given_BVD=mod.given("BVD");
  modParamMap["BVD"] = &modelPar_BVD;
  AdmsSensFadType modelPar_XJBVS=mod.XJBVS;
  bool modelPar_given_XJBVS=mod.given("XJBVS");
  modParamMap["XJBVS"] = &modelPar_XJBVS;
  AdmsSensFadType modelPar_XJBVD=mod.XJBVD;
  bool modelPar_given_XJBVD=mod.given("XJBVD");
  modParamMap["XJBVD"] = &modelPar_XJBVD;
  AdmsSensFadType modelPar_JTSS=mod.JTSS;
  bool modelPar_given_JTSS=mod.given("JTSS");
  modParamMap["JTSS"] = &modelPar_JTSS;
  AdmsSensFadType modelPar_JTSD=mod.JTSD;
  bool modelPar_given_JTSD=mod.given("JTSD");
  modParamMap["JTSD"] = &modelPar_JTSD;
  AdmsSensFadType modelPar_JTSSWS=mod.JTSSWS;
  bool modelPar_given_JTSSWS=mod.given("JTSSWS");
  modParamMap["JTSSWS"] = &modelPar_JTSSWS;
  AdmsSensFadType modelPar_JTSSWD=mod.JTSSWD;
  bool modelPar_given_JTSSWD=mod.given("JTSSWD");
  modParamMap["JTSSWD"] = &modelPar_JTSSWD;
  AdmsSensFadType modelPar_JTSSWGS=mod.JTSSWGS;
  bool modelPar_given_JTSSWGS=mod.given("JTSSWGS");
  modParamMap["JTSSWGS"] = &modelPar_JTSSWGS;
  AdmsSensFadType modelPar_JTSSWGD=mod.JTSSWGD;
  bool modelPar_given_JTSSWGD=mod.given("JTSSWGD");
  modParamMap["JTSSWGD"] = &modelPar_JTSSWGD;
  AdmsSensFadType modelPar_JTWEFF=mod.JTWEFF;
  bool modelPar_given_JTWEFF=mod.given("JTWEFF");
  modParamMap["JTWEFF"] = &modelPar_JTWEFF;
  AdmsSensFadType modelPar_NJTS=mod.NJTS;
  bool modelPar_given_NJTS=mod.given("NJTS");
  modParamMap["NJTS"] = &modelPar_NJTS;
  AdmsSensFadType modelPar_NJTSD=mod.NJTSD;
  bool modelPar_given_NJTSD=mod.given("NJTSD");
  modParamMap["NJTSD"] = &modelPar_NJTSD;
  AdmsSensFadType modelPar_NJTSSW=mod.NJTSSW;
  bool modelPar_given_NJTSSW=mod.given("NJTSSW");
  modParamMap["NJTSSW"] = &modelPar_NJTSSW;
  AdmsSensFadType modelPar_NJTSSWD=mod.NJTSSWD;
  bool modelPar_given_NJTSSWD=mod.given("NJTSSWD");
  modParamMap["NJTSSWD"] = &modelPar_NJTSSWD;
  AdmsSensFadType modelPar_NJTSSWG=mod.NJTSSWG;
  bool modelPar_given_NJTSSWG=mod.given("NJTSSWG");
  modParamMap["NJTSSWG"] = &modelPar_NJTSSWG;
  AdmsSensFadType modelPar_NJTSSWGD=mod.NJTSSWGD;
  bool modelPar_given_NJTSSWGD=mod.given("NJTSSWGD");
  modParamMap["NJTSSWGD"] = &modelPar_NJTSSWGD;
  AdmsSensFadType modelPar_VTSS=mod.VTSS;
  bool modelPar_given_VTSS=mod.given("VTSS");
  modParamMap["VTSS"] = &modelPar_VTSS;
  AdmsSensFadType modelPar_VTSD=mod.VTSD;
  bool modelPar_given_VTSD=mod.given("VTSD");
  modParamMap["VTSD"] = &modelPar_VTSD;
  AdmsSensFadType modelPar_VTSSWS=mod.VTSSWS;
  bool modelPar_given_VTSSWS=mod.given("VTSSWS");
  modParamMap["VTSSWS"] = &modelPar_VTSSWS;
  AdmsSensFadType modelPar_VTSSWD=mod.VTSSWD;
  bool modelPar_given_VTSSWD=mod.given("VTSSWD");
  modParamMap["VTSSWD"] = &modelPar_VTSSWD;
  AdmsSensFadType modelPar_VTSSWGS=mod.VTSSWGS;
  bool modelPar_given_VTSSWGS=mod.given("VTSSWGS");
  modParamMap["VTSSWGS"] = &modelPar_VTSSWGS;
  AdmsSensFadType modelPar_VTSSWGD=mod.VTSSWGD;
  bool modelPar_given_VTSSWGD=mod.given("VTSSWGD");
  modParamMap["VTSSWGD"] = &modelPar_VTSSWGD;
  AdmsSensFadType modelPar_LINTIGEN=mod.LINTIGEN;
  bool modelPar_given_LINTIGEN=mod.given("LINTIGEN");
  modParamMap["LINTIGEN"] = &modelPar_LINTIGEN;
  AdmsSensFadType modelPar_NTGEN=mod.NTGEN;
  bool modelPar_given_NTGEN=mod.given("NTGEN");
  modParamMap["NTGEN"] = &modelPar_NTGEN;
  AdmsSensFadType modelPar_AIGEN=mod.AIGEN;
  bool modelPar_given_AIGEN=mod.given("AIGEN");
  modParamMap["AIGEN"] = &modelPar_AIGEN;
  AdmsSensFadType modelPar_BIGEN=mod.BIGEN;
  bool modelPar_given_BIGEN=mod.given("BIGEN");
  modParamMap["BIGEN"] = &modelPar_BIGEN;
  AdmsSensFadType modelPar_XRCRG1=mod.XRCRG1;
  bool modelPar_given_XRCRG1=mod.given("XRCRG1");
  modParamMap["XRCRG1"] = &modelPar_XRCRG1;
  AdmsSensFadType modelPar_XRCRG2=mod.XRCRG2;
  bool modelPar_given_XRCRG2=mod.given("XRCRG2");
  modParamMap["XRCRG2"] = &modelPar_XRCRG2;
  AdmsSensFadType modelPar_EF=mod.EF;
  bool modelPar_given_EF=mod.given("EF");
  modParamMap["EF"] = &modelPar_EF;
  AdmsSensFadType modelPar_EM=mod.EM;
  bool modelPar_given_EM=mod.given("EM");
  modParamMap["EM"] = &modelPar_EM;
  AdmsSensFadType modelPar_NOIA=mod.NOIA;
  bool modelPar_given_NOIA=mod.given("NOIA");
  modParamMap["NOIA"] = &modelPar_NOIA;
  AdmsSensFadType modelPar_NOIB=mod.NOIB;
  bool modelPar_given_NOIB=mod.given("NOIB");
  modParamMap["NOIB"] = &modelPar_NOIB;
  AdmsSensFadType modelPar_NOIC=mod.NOIC;
  bool modelPar_given_NOIC=mod.given("NOIC");
  modParamMap["NOIC"] = &modelPar_NOIC;
  AdmsSensFadType modelPar_LINTNOI=mod.LINTNOI;
  bool modelPar_given_LINTNOI=mod.given("LINTNOI");
  modParamMap["LINTNOI"] = &modelPar_LINTNOI;
  AdmsSensFadType modelPar_NTNOI=mod.NTNOI;
  bool modelPar_given_NTNOI=mod.given("NTNOI");
  modParamMap["NTNOI"] = &modelPar_NTNOI;
  AdmsSensFadType modelPar_TNOIA=mod.TNOIA;
  bool modelPar_given_TNOIA=mod.given("TNOIA");
  modParamMap["TNOIA"] = &modelPar_TNOIA;
  AdmsSensFadType modelPar_TNOIB=mod.TNOIB;
  bool modelPar_given_TNOIB=mod.given("TNOIB");
  modParamMap["TNOIB"] = &modelPar_TNOIB;
  AdmsSensFadType modelPar_RNOIA=mod.RNOIA;
  bool modelPar_given_RNOIA=mod.given("RNOIA");
  modParamMap["RNOIA"] = &modelPar_RNOIA;
  AdmsSensFadType modelPar_RNOIB=mod.RNOIB;
  bool modelPar_given_RNOIB=mod.given("RNOIB");
  modParamMap["RNOIB"] = &modelPar_RNOIB;
  AdmsSensFadType modelPar_TNOIC=mod.TNOIC;
  bool modelPar_given_TNOIC=mod.given("TNOIC");
  modParamMap["TNOIC"] = &modelPar_TNOIC;
  AdmsSensFadType modelPar_RNOIC=mod.RNOIC;
  bool modelPar_given_RNOIC=mod.given("RNOIC");
  modParamMap["RNOIC"] = &modelPar_RNOIC;
  AdmsSensFadType modelPar_SCALEN=mod.SCALEN;
  bool modelPar_given_SCALEN=mod.given("SCALEN");
  modParamMap["SCALEN"] = &modelPar_SCALEN;
  AdmsSensFadType modelPar_TNOM=mod.TNOM;
  bool modelPar_given_TNOM=mod.given("TNOM");
  modParamMap["TNOM"] = &modelPar_TNOM;
  AdmsSensFadType modelPar_TBGASUB=mod.TBGASUB;
  bool modelPar_given_TBGASUB=mod.given("TBGASUB");
  modParamMap["TBGASUB"] = &modelPar_TBGASUB;
  AdmsSensFadType modelPar_TBGBSUB=mod.TBGBSUB;
  bool modelPar_given_TBGBSUB=mod.given("TBGBSUB");
  modParamMap["TBGBSUB"] = &modelPar_TBGBSUB;
  AdmsSensFadType modelPar_KT1=mod.KT1;
  bool modelPar_given_KT1=mod.given("KT1");
  modParamMap["KT1"] = &modelPar_KT1;
  AdmsSensFadType modelPar_KT1L=mod.KT1L;
  bool modelPar_given_KT1L=mod.given("KT1L");
  modParamMap["KT1L"] = &modelPar_KT1L;
  AdmsSensFadType modelPar_TSS=mod.TSS;
  bool modelPar_given_TSS=mod.given("TSS");
  modParamMap["TSS"] = &modelPar_TSS;
  AdmsSensFadType modelPar_IIT=mod.IIT;
  bool modelPar_given_IIT=mod.given("IIT");
  modParamMap["IIT"] = &modelPar_IIT;
  AdmsSensFadType modelPar_TII=mod.TII;
  bool modelPar_given_TII=mod.given("TII");
  modParamMap["TII"] = &modelPar_TII;
  AdmsSensFadType modelPar_TGIDL=mod.TGIDL;
  bool modelPar_given_TGIDL=mod.given("TGIDL");
  modParamMap["TGIDL"] = &modelPar_TGIDL;
  AdmsSensFadType modelPar_IGT=mod.IGT;
  bool modelPar_given_IGT=mod.given("IGT");
  modParamMap["IGT"] = &modelPar_IGT;
  AdmsSensFadType modelPar_TCJ=mod.TCJ;
  bool modelPar_given_TCJ=mod.given("TCJ");
  modParamMap["TCJ"] = &modelPar_TCJ;
  AdmsSensFadType modelPar_TCJSW=mod.TCJSW;
  bool modelPar_given_TCJSW=mod.given("TCJSW");
  modParamMap["TCJSW"] = &modelPar_TCJSW;
  AdmsSensFadType modelPar_TCJSWG=mod.TCJSWG;
  bool modelPar_given_TCJSWG=mod.given("TCJSWG");
  modParamMap["TCJSWG"] = &modelPar_TCJSWG;
  AdmsSensFadType modelPar_TPB=mod.TPB;
  bool modelPar_given_TPB=mod.given("TPB");
  modParamMap["TPB"] = &modelPar_TPB;
  AdmsSensFadType modelPar_TPBSW=mod.TPBSW;
  bool modelPar_given_TPBSW=mod.given("TPBSW");
  modParamMap["TPBSW"] = &modelPar_TPBSW;
  AdmsSensFadType modelPar_TPBSWG=mod.TPBSWG;
  bool modelPar_given_TPBSWG=mod.given("TPBSWG");
  modParamMap["TPBSWG"] = &modelPar_TPBSWG;
  AdmsSensFadType modelPar_XTIS=mod.XTIS;
  bool modelPar_given_XTIS=mod.given("XTIS");
  modParamMap["XTIS"] = &modelPar_XTIS;
  AdmsSensFadType modelPar_XTID=mod.XTID;
  bool modelPar_given_XTID=mod.given("XTID");
  modParamMap["XTID"] = &modelPar_XTID;
  AdmsSensFadType modelPar_XTSS=mod.XTSS;
  bool modelPar_given_XTSS=mod.given("XTSS");
  modParamMap["XTSS"] = &modelPar_XTSS;
  AdmsSensFadType modelPar_XTSD=mod.XTSD;
  bool modelPar_given_XTSD=mod.given("XTSD");
  modParamMap["XTSD"] = &modelPar_XTSD;
  AdmsSensFadType modelPar_XTSSWS=mod.XTSSWS;
  bool modelPar_given_XTSSWS=mod.given("XTSSWS");
  modParamMap["XTSSWS"] = &modelPar_XTSSWS;
  AdmsSensFadType modelPar_XTSSWD=mod.XTSSWD;
  bool modelPar_given_XTSSWD=mod.given("XTSSWD");
  modParamMap["XTSSWD"] = &modelPar_XTSSWD;
  AdmsSensFadType modelPar_XTSSWGS=mod.XTSSWGS;
  bool modelPar_given_XTSSWGS=mod.given("XTSSWGS");
  modParamMap["XTSSWGS"] = &modelPar_XTSSWGS;
  AdmsSensFadType modelPar_XTSSWGD=mod.XTSSWGD;
  bool modelPar_given_XTSSWGD=mod.given("XTSSWGD");
  modParamMap["XTSSWGD"] = &modelPar_XTSSWGD;
  AdmsSensFadType modelPar_TNJTS=mod.TNJTS;
  bool modelPar_given_TNJTS=mod.given("TNJTS");
  modParamMap["TNJTS"] = &modelPar_TNJTS;
  AdmsSensFadType modelPar_TNJTSD=mod.TNJTSD;
  bool modelPar_given_TNJTSD=mod.given("TNJTSD");
  modParamMap["TNJTSD"] = &modelPar_TNJTSD;
  AdmsSensFadType modelPar_TNJTSSW=mod.TNJTSSW;
  bool modelPar_given_TNJTSSW=mod.given("TNJTSSW");
  modParamMap["TNJTSSW"] = &modelPar_TNJTSSW;
  AdmsSensFadType modelPar_TNJTSSWD=mod.TNJTSSWD;
  bool modelPar_given_TNJTSSWD=mod.given("TNJTSSWD");
  modParamMap["TNJTSSWD"] = &modelPar_TNJTSSWD;
  AdmsSensFadType modelPar_TNJTSSWG=mod.TNJTSSWG;
  bool modelPar_given_TNJTSSWG=mod.given("TNJTSSWG");
  modParamMap["TNJTSSWG"] = &modelPar_TNJTSSWG;
  AdmsSensFadType modelPar_TNJTSSWGD=mod.TNJTSSWGD;
  bool modelPar_given_TNJTSSWGD=mod.given("TNJTSSWGD");
  modParamMap["TNJTSSWGD"] = &modelPar_TNJTSSWGD;
  AdmsSensFadType modelPar_RTH0=mod.RTH0;
  bool modelPar_given_RTH0=mod.given("RTH0");
  modParamMap["RTH0"] = &modelPar_RTH0;
  AdmsSensFadType modelPar_CTH0=mod.CTH0;
  bool modelPar_given_CTH0=mod.given("CTH0");
  modParamMap["CTH0"] = &modelPar_CTH0;
  AdmsSensFadType modelPar_WTH0=mod.WTH0;
  bool modelPar_given_WTH0=mod.given("WTH0");
  modParamMap["WTH0"] = &modelPar_WTH0;
  AdmsSensFadType modelPar_ASHEXP=mod.ASHEXP;
  bool modelPar_given_ASHEXP=mod.given("ASHEXP");
  modParamMap["ASHEXP"] = &modelPar_ASHEXP;
  AdmsSensFadType modelPar_BSHEXP=mod.BSHEXP;
  bool modelPar_given_BSHEXP=mod.given("BSHEXP");
  modParamMap["BSHEXP"] = &modelPar_BSHEXP;
  AdmsSensFadType modelPar_ACH_UFCM=mod.ACH_UFCM;
  bool modelPar_given_ACH_UFCM=mod.given("ACH_UFCM");
  modParamMap["ACH_UFCM"] = &modelPar_ACH_UFCM;
  AdmsSensFadType modelPar_CINS_UFCM=mod.CINS_UFCM;
  bool modelPar_given_CINS_UFCM=mod.given("CINS_UFCM");
  modParamMap["CINS_UFCM"] = &modelPar_CINS_UFCM;
  AdmsSensFadType modelPar_W_UFCM=mod.W_UFCM;
  bool modelPar_given_W_UFCM=mod.given("W_UFCM");
  modParamMap["W_UFCM"] = &modelPar_W_UFCM;
  AdmsSensFadType modelPar_TFIN_TOP=mod.TFIN_TOP;
  bool modelPar_given_TFIN_TOP=mod.given("TFIN_TOP");
  modParamMap["TFIN_TOP"] = &modelPar_TFIN_TOP;
  AdmsSensFadType modelPar_TFIN_BASE=mod.TFIN_BASE;
  bool modelPar_given_TFIN_BASE=mod.given("TFIN_BASE");
  modParamMap["TFIN_BASE"] = &modelPar_TFIN_BASE;
  AdmsSensFadType modelPar_QMFACTORCV=mod.QMFACTORCV;
  bool modelPar_given_QMFACTORCV=mod.given("QMFACTORCV");
  modParamMap["QMFACTORCV"] = &modelPar_QMFACTORCV;
  AdmsSensFadType modelPar_ALPHA_UFCM=mod.ALPHA_UFCM;
  bool modelPar_given_ALPHA_UFCM=mod.given("ALPHA_UFCM");
  modParamMap["ALPHA_UFCM"] = &modelPar_ALPHA_UFCM;
  AdmsSensFadType modelPar_LNBODY=mod.LNBODY;
  bool modelPar_given_LNBODY=mod.given("LNBODY");
  modParamMap["LNBODY"] = &modelPar_LNBODY;
  AdmsSensFadType modelPar_NNBODY=mod.NNBODY;
  bool modelPar_given_NNBODY=mod.given("NNBODY");
  modParamMap["NNBODY"] = &modelPar_NNBODY;
  AdmsSensFadType modelPar_PNBODY=mod.PNBODY;
  bool modelPar_given_PNBODY=mod.given("PNBODY");
  modParamMap["PNBODY"] = &modelPar_PNBODY;
  AdmsSensFadType modelPar_LPHIG=mod.LPHIG;
  bool modelPar_given_LPHIG=mod.given("LPHIG");
  modParamMap["LPHIG"] = &modelPar_LPHIG;
  AdmsSensFadType modelPar_NPHIG=mod.NPHIG;
  bool modelPar_given_NPHIG=mod.given("NPHIG");
  modParamMap["NPHIG"] = &modelPar_NPHIG;
  AdmsSensFadType modelPar_PPHIG=mod.PPHIG;
  bool modelPar_given_PPHIG=mod.given("PPHIG");
  modParamMap["PPHIG"] = &modelPar_PPHIG;
  AdmsSensFadType modelPar_LNGATE=mod.LNGATE;
  bool modelPar_given_LNGATE=mod.given("LNGATE");
  modParamMap["LNGATE"] = &modelPar_LNGATE;
  AdmsSensFadType modelPar_NNGATE=mod.NNGATE;
  bool modelPar_given_NNGATE=mod.given("NNGATE");
  modParamMap["NNGATE"] = &modelPar_NNGATE;
  AdmsSensFadType modelPar_PNGATE=mod.PNGATE;
  bool modelPar_given_PNGATE=mod.given("PNGATE");
  modParamMap["PNGATE"] = &modelPar_PNGATE;
  AdmsSensFadType modelPar_LCIT=mod.LCIT;
  bool modelPar_given_LCIT=mod.given("LCIT");
  modParamMap["LCIT"] = &modelPar_LCIT;
  AdmsSensFadType modelPar_NCIT=mod.NCIT;
  bool modelPar_given_NCIT=mod.given("NCIT");
  modParamMap["NCIT"] = &modelPar_NCIT;
  AdmsSensFadType modelPar_PCIT=mod.PCIT;
  bool modelPar_given_PCIT=mod.given("PCIT");
  modParamMap["PCIT"] = &modelPar_PCIT;
  AdmsSensFadType modelPar_LCITR=mod.LCITR;
  bool modelPar_given_LCITR=mod.given("LCITR");
  modParamMap["LCITR"] = &modelPar_LCITR;
  AdmsSensFadType modelPar_NCITR=mod.NCITR;
  bool modelPar_given_NCITR=mod.given("NCITR");
  modParamMap["NCITR"] = &modelPar_NCITR;
  AdmsSensFadType modelPar_PCITR=mod.PCITR;
  bool modelPar_given_PCITR=mod.given("PCITR");
  modParamMap["PCITR"] = &modelPar_PCITR;
  AdmsSensFadType modelPar_LCDSC=mod.LCDSC;
  bool modelPar_given_LCDSC=mod.given("LCDSC");
  modParamMap["LCDSC"] = &modelPar_LCDSC;
  AdmsSensFadType modelPar_NCDSC=mod.NCDSC;
  bool modelPar_given_NCDSC=mod.given("NCDSC");
  modParamMap["NCDSC"] = &modelPar_NCDSC;
  AdmsSensFadType modelPar_PCDSC=mod.PCDSC;
  bool modelPar_given_PCDSC=mod.given("PCDSC");
  modParamMap["PCDSC"] = &modelPar_PCDSC;
  AdmsSensFadType modelPar_LCDSCD=mod.LCDSCD;
  bool modelPar_given_LCDSCD=mod.given("LCDSCD");
  modParamMap["LCDSCD"] = &modelPar_LCDSCD;
  AdmsSensFadType modelPar_NCDSCD=mod.NCDSCD;
  bool modelPar_given_NCDSCD=mod.given("NCDSCD");
  modParamMap["NCDSCD"] = &modelPar_NCDSCD;
  AdmsSensFadType modelPar_PCDSCD=mod.PCDSCD;
  bool modelPar_given_PCDSCD=mod.given("PCDSCD");
  modParamMap["PCDSCD"] = &modelPar_PCDSCD;
  AdmsSensFadType modelPar_LCDSCDR=mod.LCDSCDR;
  bool modelPar_given_LCDSCDR=mod.given("LCDSCDR");
  modParamMap["LCDSCDR"] = &modelPar_LCDSCDR;
  AdmsSensFadType modelPar_NCDSCDR=mod.NCDSCDR;
  bool modelPar_given_NCDSCDR=mod.given("NCDSCDR");
  modParamMap["NCDSCDR"] = &modelPar_NCDSCDR;
  AdmsSensFadType modelPar_PCDSCDR=mod.PCDSCDR;
  bool modelPar_given_PCDSCDR=mod.given("PCDSCDR");
  modParamMap["PCDSCDR"] = &modelPar_PCDSCDR;
  AdmsSensFadType modelPar_LDVT0=mod.LDVT0;
  bool modelPar_given_LDVT0=mod.given("LDVT0");
  modParamMap["LDVT0"] = &modelPar_LDVT0;
  AdmsSensFadType modelPar_NDVT0=mod.NDVT0;
  bool modelPar_given_NDVT0=mod.given("NDVT0");
  modParamMap["NDVT0"] = &modelPar_NDVT0;
  AdmsSensFadType modelPar_PDVT0=mod.PDVT0;
  bool modelPar_given_PDVT0=mod.given("PDVT0");
  modParamMap["PDVT0"] = &modelPar_PDVT0;
  AdmsSensFadType modelPar_LDVT1=mod.LDVT1;
  bool modelPar_given_LDVT1=mod.given("LDVT1");
  modParamMap["LDVT1"] = &modelPar_LDVT1;
  AdmsSensFadType modelPar_NDVT1=mod.NDVT1;
  bool modelPar_given_NDVT1=mod.given("NDVT1");
  modParamMap["NDVT1"] = &modelPar_NDVT1;
  AdmsSensFadType modelPar_PDVT1=mod.PDVT1;
  bool modelPar_given_PDVT1=mod.given("PDVT1");
  modParamMap["PDVT1"] = &modelPar_PDVT1;
  AdmsSensFadType modelPar_LDVT1SS=mod.LDVT1SS;
  bool modelPar_given_LDVT1SS=mod.given("LDVT1SS");
  modParamMap["LDVT1SS"] = &modelPar_LDVT1SS;
  AdmsSensFadType modelPar_NDVT1SS=mod.NDVT1SS;
  bool modelPar_given_NDVT1SS=mod.given("NDVT1SS");
  modParamMap["NDVT1SS"] = &modelPar_NDVT1SS;
  AdmsSensFadType modelPar_PDVT1SS=mod.PDVT1SS;
  bool modelPar_given_PDVT1SS=mod.given("PDVT1SS");
  modParamMap["PDVT1SS"] = &modelPar_PDVT1SS;
  AdmsSensFadType modelPar_LPHIN=mod.LPHIN;
  bool modelPar_given_LPHIN=mod.given("LPHIN");
  modParamMap["LPHIN"] = &modelPar_LPHIN;
  AdmsSensFadType modelPar_NPHIN=mod.NPHIN;
  bool modelPar_given_NPHIN=mod.given("NPHIN");
  modParamMap["NPHIN"] = &modelPar_NPHIN;
  AdmsSensFadType modelPar_PPHIN=mod.PPHIN;
  bool modelPar_given_PPHIN=mod.given("PPHIN");
  modParamMap["PPHIN"] = &modelPar_PPHIN;
  AdmsSensFadType modelPar_LETA0=mod.LETA0;
  bool modelPar_given_LETA0=mod.given("LETA0");
  modParamMap["LETA0"] = &modelPar_LETA0;
  AdmsSensFadType modelPar_NETA0=mod.NETA0;
  bool modelPar_given_NETA0=mod.given("NETA0");
  modParamMap["NETA0"] = &modelPar_NETA0;
  AdmsSensFadType modelPar_PETA0=mod.PETA0;
  bool modelPar_given_PETA0=mod.given("PETA0");
  modParamMap["PETA0"] = &modelPar_PETA0;
  AdmsSensFadType modelPar_LETA0R=mod.LETA0R;
  bool modelPar_given_LETA0R=mod.given("LETA0R");
  modParamMap["LETA0R"] = &modelPar_LETA0R;
  AdmsSensFadType modelPar_NETA0R=mod.NETA0R;
  bool modelPar_given_NETA0R=mod.given("NETA0R");
  modParamMap["NETA0R"] = &modelPar_NETA0R;
  AdmsSensFadType modelPar_PETA0R=mod.PETA0R;
  bool modelPar_given_PETA0R=mod.given("PETA0R");
  modParamMap["PETA0R"] = &modelPar_PETA0R;
  AdmsSensFadType modelPar_LDSUB=mod.LDSUB;
  bool modelPar_given_LDSUB=mod.given("LDSUB");
  modParamMap["LDSUB"] = &modelPar_LDSUB;
  AdmsSensFadType modelPar_NDSUB=mod.NDSUB;
  bool modelPar_given_NDSUB=mod.given("NDSUB");
  modParamMap["NDSUB"] = &modelPar_NDSUB;
  AdmsSensFadType modelPar_PDSUB=mod.PDSUB;
  bool modelPar_given_PDSUB=mod.given("PDSUB");
  modParamMap["PDSUB"] = &modelPar_PDSUB;
  AdmsSensFadType modelPar_LK1RSCE=mod.LK1RSCE;
  bool modelPar_given_LK1RSCE=mod.given("LK1RSCE");
  modParamMap["LK1RSCE"] = &modelPar_LK1RSCE;
  AdmsSensFadType modelPar_NK1RSCE=mod.NK1RSCE;
  bool modelPar_given_NK1RSCE=mod.given("NK1RSCE");
  modParamMap["NK1RSCE"] = &modelPar_NK1RSCE;
  AdmsSensFadType modelPar_PK1RSCE=mod.PK1RSCE;
  bool modelPar_given_PK1RSCE=mod.given("PK1RSCE");
  modParamMap["PK1RSCE"] = &modelPar_PK1RSCE;
  AdmsSensFadType modelPar_LLPE0=mod.LLPE0;
  bool modelPar_given_LLPE0=mod.given("LLPE0");
  modParamMap["LLPE0"] = &modelPar_LLPE0;
  AdmsSensFadType modelPar_NLPE0=mod.NLPE0;
  bool modelPar_given_NLPE0=mod.given("NLPE0");
  modParamMap["NLPE0"] = &modelPar_NLPE0;
  AdmsSensFadType modelPar_PLPE0=mod.PLPE0;
  bool modelPar_given_PLPE0=mod.given("PLPE0");
  modParamMap["PLPE0"] = &modelPar_PLPE0;
  AdmsSensFadType modelPar_LDVTSHIFT=mod.LDVTSHIFT;
  bool modelPar_given_LDVTSHIFT=mod.given("LDVTSHIFT");
  modParamMap["LDVTSHIFT"] = &modelPar_LDVTSHIFT;
  AdmsSensFadType modelPar_NDVTSHIFT=mod.NDVTSHIFT;
  bool modelPar_given_NDVTSHIFT=mod.given("NDVTSHIFT");
  modParamMap["NDVTSHIFT"] = &modelPar_NDVTSHIFT;
  AdmsSensFadType modelPar_PDVTSHIFT=mod.PDVTSHIFT;
  bool modelPar_given_PDVTSHIFT=mod.given("PDVTSHIFT");
  modParamMap["PDVTSHIFT"] = &modelPar_PDVTSHIFT;
  AdmsSensFadType modelPar_LDVTSHIFTR=mod.LDVTSHIFTR;
  bool modelPar_given_LDVTSHIFTR=mod.given("LDVTSHIFTR");
  modParamMap["LDVTSHIFTR"] = &modelPar_LDVTSHIFTR;
  AdmsSensFadType modelPar_NDVTSHIFTR=mod.NDVTSHIFTR;
  bool modelPar_given_NDVTSHIFTR=mod.given("NDVTSHIFTR");
  modParamMap["NDVTSHIFTR"] = &modelPar_NDVTSHIFTR;
  AdmsSensFadType modelPar_PDVTSHIFTR=mod.PDVTSHIFTR;
  bool modelPar_given_PDVTSHIFTR=mod.given("PDVTSHIFTR");
  modParamMap["PDVTSHIFTR"] = &modelPar_PDVTSHIFTR;
  AdmsSensFadType modelPar_LPHIBE=mod.LPHIBE;
  bool modelPar_given_LPHIBE=mod.given("LPHIBE");
  modParamMap["LPHIBE"] = &modelPar_LPHIBE;
  AdmsSensFadType modelPar_NPHIBE=mod.NPHIBE;
  bool modelPar_given_NPHIBE=mod.given("NPHIBE");
  modParamMap["NPHIBE"] = &modelPar_NPHIBE;
  AdmsSensFadType modelPar_PPHIBE=mod.PPHIBE;
  bool modelPar_given_PPHIBE=mod.given("PPHIBE");
  modParamMap["PPHIBE"] = &modelPar_PPHIBE;
  AdmsSensFadType modelPar_LK0=mod.LK0;
  bool modelPar_given_LK0=mod.given("LK0");
  modParamMap["LK0"] = &modelPar_LK0;
  AdmsSensFadType modelPar_NK0=mod.NK0;
  bool modelPar_given_NK0=mod.given("NK0");
  modParamMap["NK0"] = &modelPar_NK0;
  AdmsSensFadType modelPar_PK0=mod.PK0;
  bool modelPar_given_PK0=mod.given("PK0");
  modParamMap["PK0"] = &modelPar_PK0;
  AdmsSensFadType modelPar_LK01=mod.LK01;
  bool modelPar_given_LK01=mod.given("LK01");
  modParamMap["LK01"] = &modelPar_LK01;
  AdmsSensFadType modelPar_NK01=mod.NK01;
  bool modelPar_given_NK01=mod.given("NK01");
  modParamMap["NK01"] = &modelPar_NK01;
  AdmsSensFadType modelPar_PK01=mod.PK01;
  bool modelPar_given_PK01=mod.given("PK01");
  modParamMap["PK01"] = &modelPar_PK01;
  AdmsSensFadType modelPar_LK0SI=mod.LK0SI;
  bool modelPar_given_LK0SI=mod.given("LK0SI");
  modParamMap["LK0SI"] = &modelPar_LK0SI;
  AdmsSensFadType modelPar_NK0SI=mod.NK0SI;
  bool modelPar_given_NK0SI=mod.given("NK0SI");
  modParamMap["NK0SI"] = &modelPar_NK0SI;
  AdmsSensFadType modelPar_PK0SI=mod.PK0SI;
  bool modelPar_given_PK0SI=mod.given("PK0SI");
  modParamMap["PK0SI"] = &modelPar_PK0SI;
  AdmsSensFadType modelPar_LK0SI1=mod.LK0SI1;
  bool modelPar_given_LK0SI1=mod.given("LK0SI1");
  modParamMap["LK0SI1"] = &modelPar_LK0SI1;
  AdmsSensFadType modelPar_NK0SI1=mod.NK0SI1;
  bool modelPar_given_NK0SI1=mod.given("NK0SI1");
  modParamMap["NK0SI1"] = &modelPar_NK0SI1;
  AdmsSensFadType modelPar_PK0SI1=mod.PK0SI1;
  bool modelPar_given_PK0SI1=mod.given("PK0SI1");
  modParamMap["PK0SI1"] = &modelPar_PK0SI1;
  AdmsSensFadType modelPar_LK1=mod.LK1;
  bool modelPar_given_LK1=mod.given("LK1");
  modParamMap["LK1"] = &modelPar_LK1;
  AdmsSensFadType modelPar_NK1=mod.NK1;
  bool modelPar_given_NK1=mod.given("NK1");
  modParamMap["NK1"] = &modelPar_NK1;
  AdmsSensFadType modelPar_PK1=mod.PK1;
  bool modelPar_given_PK1=mod.given("PK1");
  modParamMap["PK1"] = &modelPar_PK1;
  AdmsSensFadType modelPar_LK11=mod.LK11;
  bool modelPar_given_LK11=mod.given("LK11");
  modParamMap["LK11"] = &modelPar_LK11;
  AdmsSensFadType modelPar_NK11=mod.NK11;
  bool modelPar_given_NK11=mod.given("NK11");
  modParamMap["NK11"] = &modelPar_NK11;
  AdmsSensFadType modelPar_PK11=mod.PK11;
  bool modelPar_given_PK11=mod.given("PK11");
  modParamMap["PK11"] = &modelPar_PK11;
  AdmsSensFadType modelPar_LK2SI=mod.LK2SI;
  bool modelPar_given_LK2SI=mod.given("LK2SI");
  modParamMap["LK2SI"] = &modelPar_LK2SI;
  AdmsSensFadType modelPar_NK2SI=mod.NK2SI;
  bool modelPar_given_NK2SI=mod.given("NK2SI");
  modParamMap["NK2SI"] = &modelPar_NK2SI;
  AdmsSensFadType modelPar_PK2SI=mod.PK2SI;
  bool modelPar_given_PK2SI=mod.given("PK2SI");
  modParamMap["PK2SI"] = &modelPar_PK2SI;
  AdmsSensFadType modelPar_LK2SI1=mod.LK2SI1;
  bool modelPar_given_LK2SI1=mod.given("LK2SI1");
  modParamMap["LK2SI1"] = &modelPar_LK2SI1;
  AdmsSensFadType modelPar_NK2SI1=mod.NK2SI1;
  bool modelPar_given_NK2SI1=mod.given("NK2SI1");
  modParamMap["NK2SI1"] = &modelPar_NK2SI1;
  AdmsSensFadType modelPar_PK2SI1=mod.PK2SI1;
  bool modelPar_given_PK2SI1=mod.given("PK2SI1");
  modParamMap["PK2SI1"] = &modelPar_PK2SI1;
  AdmsSensFadType modelPar_LK0SISAT=mod.LK0SISAT;
  bool modelPar_given_LK0SISAT=mod.given("LK0SISAT");
  modParamMap["LK0SISAT"] = &modelPar_LK0SISAT;
  AdmsSensFadType modelPar_NK0SISAT=mod.NK0SISAT;
  bool modelPar_given_NK0SISAT=mod.given("NK0SISAT");
  modParamMap["NK0SISAT"] = &modelPar_NK0SISAT;
  AdmsSensFadType modelPar_PK0SISAT=mod.PK0SISAT;
  bool modelPar_given_PK0SISAT=mod.given("PK0SISAT");
  modParamMap["PK0SISAT"] = &modelPar_PK0SISAT;
  AdmsSensFadType modelPar_LK0SISAT1=mod.LK0SISAT1;
  bool modelPar_given_LK0SISAT1=mod.given("LK0SISAT1");
  modParamMap["LK0SISAT1"] = &modelPar_LK0SISAT1;
  AdmsSensFadType modelPar_NK0SISAT1=mod.NK0SISAT1;
  bool modelPar_given_NK0SISAT1=mod.given("NK0SISAT1");
  modParamMap["NK0SISAT1"] = &modelPar_NK0SISAT1;
  AdmsSensFadType modelPar_PK0SISAT1=mod.PK0SISAT1;
  bool modelPar_given_PK0SISAT1=mod.given("PK0SISAT1");
  modParamMap["PK0SISAT1"] = &modelPar_PK0SISAT1;
  AdmsSensFadType modelPar_LK2SISAT=mod.LK2SISAT;
  bool modelPar_given_LK2SISAT=mod.given("LK2SISAT");
  modParamMap["LK2SISAT"] = &modelPar_LK2SISAT;
  AdmsSensFadType modelPar_NK2SISAT=mod.NK2SISAT;
  bool modelPar_given_NK2SISAT=mod.given("NK2SISAT");
  modParamMap["NK2SISAT"] = &modelPar_NK2SISAT;
  AdmsSensFadType modelPar_PK2SISAT=mod.PK2SISAT;
  bool modelPar_given_PK2SISAT=mod.given("PK2SISAT");
  modParamMap["PK2SISAT"] = &modelPar_PK2SISAT;
  AdmsSensFadType modelPar_LK2SISAT1=mod.LK2SISAT1;
  bool modelPar_given_LK2SISAT1=mod.given("LK2SISAT1");
  modParamMap["LK2SISAT1"] = &modelPar_LK2SISAT1;
  AdmsSensFadType modelPar_NK2SISAT1=mod.NK2SISAT1;
  bool modelPar_given_NK2SISAT1=mod.given("NK2SISAT1");
  modParamMap["NK2SISAT1"] = &modelPar_NK2SISAT1;
  AdmsSensFadType modelPar_PK2SISAT1=mod.PK2SISAT1;
  bool modelPar_given_PK2SISAT1=mod.given("PK2SISAT1");
  modParamMap["PK2SISAT1"] = &modelPar_PK2SISAT1;
  AdmsSensFadType modelPar_LK2SAT=mod.LK2SAT;
  bool modelPar_given_LK2SAT=mod.given("LK2SAT");
  modParamMap["LK2SAT"] = &modelPar_LK2SAT;
  AdmsSensFadType modelPar_NK2SAT=mod.NK2SAT;
  bool modelPar_given_NK2SAT=mod.given("NK2SAT");
  modParamMap["NK2SAT"] = &modelPar_NK2SAT;
  AdmsSensFadType modelPar_PK2SAT=mod.PK2SAT;
  bool modelPar_given_PK2SAT=mod.given("PK2SAT");
  modParamMap["PK2SAT"] = &modelPar_PK2SAT;
  AdmsSensFadType modelPar_LK2SAT1=mod.LK2SAT1;
  bool modelPar_given_LK2SAT1=mod.given("LK2SAT1");
  modParamMap["LK2SAT1"] = &modelPar_LK2SAT1;
  AdmsSensFadType modelPar_NK2SAT1=mod.NK2SAT1;
  bool modelPar_given_NK2SAT1=mod.given("NK2SAT1");
  modParamMap["NK2SAT1"] = &modelPar_NK2SAT1;
  AdmsSensFadType modelPar_PK2SAT1=mod.PK2SAT1;
  bool modelPar_given_PK2SAT1=mod.given("PK2SAT1");
  modParamMap["PK2SAT1"] = &modelPar_PK2SAT1;
  AdmsSensFadType modelPar_LK2=mod.LK2;
  bool modelPar_given_LK2=mod.given("LK2");
  modParamMap["LK2"] = &modelPar_LK2;
  AdmsSensFadType modelPar_NK2=mod.NK2;
  bool modelPar_given_NK2=mod.given("NK2");
  modParamMap["NK2"] = &modelPar_NK2;
  AdmsSensFadType modelPar_PK2=mod.PK2;
  bool modelPar_given_PK2=mod.given("PK2");
  modParamMap["PK2"] = &modelPar_PK2;
  AdmsSensFadType modelPar_LK21=mod.LK21;
  bool modelPar_given_LK21=mod.given("LK21");
  modParamMap["LK21"] = &modelPar_LK21;
  AdmsSensFadType modelPar_NK21=mod.NK21;
  bool modelPar_given_NK21=mod.given("NK21");
  modParamMap["NK21"] = &modelPar_NK21;
  AdmsSensFadType modelPar_PK21=mod.PK21;
  bool modelPar_given_PK21=mod.given("PK21");
  modParamMap["PK21"] = &modelPar_PK21;
  AdmsSensFadType modelPar_LDVTB=mod.LDVTB;
  bool modelPar_given_LDVTB=mod.given("LDVTB");
  modParamMap["LDVTB"] = &modelPar_LDVTB;
  AdmsSensFadType modelPar_NDVTB=mod.NDVTB;
  bool modelPar_given_NDVTB=mod.given("NDVTB");
  modParamMap["NDVTB"] = &modelPar_NDVTB;
  AdmsSensFadType modelPar_PDVTB=mod.PDVTB;
  bool modelPar_given_PDVTB=mod.given("PDVTB");
  modParamMap["PDVTB"] = &modelPar_PDVTB;
  AdmsSensFadType modelPar_LLPEB=mod.LLPEB;
  bool modelPar_given_LLPEB=mod.given("LLPEB");
  modParamMap["LLPEB"] = &modelPar_LLPEB;
  AdmsSensFadType modelPar_NLPEB=mod.NLPEB;
  bool modelPar_given_NLPEB=mod.given("NLPEB");
  modParamMap["NLPEB"] = &modelPar_NLPEB;
  AdmsSensFadType modelPar_PLPEB=mod.PLPEB;
  bool modelPar_given_PLPEB=mod.given("PLPEB");
  modParamMap["PLPEB"] = &modelPar_PLPEB;
  AdmsSensFadType modelPar_LQMFACTOR=mod.LQMFACTOR;
  bool modelPar_given_LQMFACTOR=mod.given("LQMFACTOR");
  modParamMap["LQMFACTOR"] = &modelPar_LQMFACTOR;
  AdmsSensFadType modelPar_NQMFACTOR=mod.NQMFACTOR;
  bool modelPar_given_NQMFACTOR=mod.given("NQMFACTOR");
  modParamMap["NQMFACTOR"] = &modelPar_NQMFACTOR;
  AdmsSensFadType modelPar_PQMFACTOR=mod.PQMFACTOR;
  bool modelPar_given_PQMFACTOR=mod.given("PQMFACTOR");
  modParamMap["PQMFACTOR"] = &modelPar_PQMFACTOR;
  AdmsSensFadType modelPar_LQMTCENCV=mod.LQMTCENCV;
  bool modelPar_given_LQMTCENCV=mod.given("LQMTCENCV");
  modParamMap["LQMTCENCV"] = &modelPar_LQMTCENCV;
  AdmsSensFadType modelPar_NQMTCENCV=mod.NQMTCENCV;
  bool modelPar_given_NQMTCENCV=mod.given("NQMTCENCV");
  modParamMap["NQMTCENCV"] = &modelPar_NQMTCENCV;
  AdmsSensFadType modelPar_PQMTCENCV=mod.PQMTCENCV;
  bool modelPar_given_PQMTCENCV=mod.given("PQMTCENCV");
  modParamMap["PQMTCENCV"] = &modelPar_PQMTCENCV;
  AdmsSensFadType modelPar_LQMTCENCVA=mod.LQMTCENCVA;
  bool modelPar_given_LQMTCENCVA=mod.given("LQMTCENCVA");
  modParamMap["LQMTCENCVA"] = &modelPar_LQMTCENCVA;
  AdmsSensFadType modelPar_NQMTCENCVA=mod.NQMTCENCVA;
  bool modelPar_given_NQMTCENCVA=mod.given("NQMTCENCVA");
  modParamMap["NQMTCENCVA"] = &modelPar_NQMTCENCVA;
  AdmsSensFadType modelPar_PQMTCENCVA=mod.PQMTCENCVA;
  bool modelPar_given_PQMTCENCVA=mod.given("PQMTCENCVA");
  modParamMap["PQMTCENCVA"] = &modelPar_PQMTCENCVA;
  AdmsSensFadType modelPar_LVSAT=mod.LVSAT;
  bool modelPar_given_LVSAT=mod.given("LVSAT");
  modParamMap["LVSAT"] = &modelPar_LVSAT;
  AdmsSensFadType modelPar_NVSAT=mod.NVSAT;
  bool modelPar_given_NVSAT=mod.given("NVSAT");
  modParamMap["NVSAT"] = &modelPar_NVSAT;
  AdmsSensFadType modelPar_PVSAT=mod.PVSAT;
  bool modelPar_given_PVSAT=mod.given("PVSAT");
  modParamMap["PVSAT"] = &modelPar_PVSAT;
  AdmsSensFadType modelPar_LVSATR=mod.LVSATR;
  bool modelPar_given_LVSATR=mod.given("LVSATR");
  modParamMap["LVSATR"] = &modelPar_LVSATR;
  AdmsSensFadType modelPar_NVSATR=mod.NVSATR;
  bool modelPar_given_NVSATR=mod.given("NVSATR");
  modParamMap["NVSATR"] = &modelPar_NVSATR;
  AdmsSensFadType modelPar_PVSATR=mod.PVSATR;
  bool modelPar_given_PVSATR=mod.given("PVSATR");
  modParamMap["PVSATR"] = &modelPar_PVSATR;
  AdmsSensFadType modelPar_LVSAT1=mod.LVSAT1;
  bool modelPar_given_LVSAT1=mod.given("LVSAT1");
  modParamMap["LVSAT1"] = &modelPar_LVSAT1;
  AdmsSensFadType modelPar_NVSAT1=mod.NVSAT1;
  bool modelPar_given_NVSAT1=mod.given("NVSAT1");
  modParamMap["NVSAT1"] = &modelPar_NVSAT1;
  AdmsSensFadType modelPar_PVSAT1=mod.PVSAT1;
  bool modelPar_given_PVSAT1=mod.given("PVSAT1");
  modParamMap["PVSAT1"] = &modelPar_PVSAT1;
  AdmsSensFadType modelPar_LVSAT1R=mod.LVSAT1R;
  bool modelPar_given_LVSAT1R=mod.given("LVSAT1R");
  modParamMap["LVSAT1R"] = &modelPar_LVSAT1R;
  AdmsSensFadType modelPar_NVSAT1R=mod.NVSAT1R;
  bool modelPar_given_NVSAT1R=mod.given("NVSAT1R");
  modParamMap["NVSAT1R"] = &modelPar_NVSAT1R;
  AdmsSensFadType modelPar_PVSAT1R=mod.PVSAT1R;
  bool modelPar_given_PVSAT1R=mod.given("PVSAT1R");
  modParamMap["PVSAT1R"] = &modelPar_PVSAT1R;
  AdmsSensFadType modelPar_LPSAT=mod.LPSAT;
  bool modelPar_given_LPSAT=mod.given("LPSAT");
  modParamMap["LPSAT"] = &modelPar_LPSAT;
  AdmsSensFadType modelPar_NPSAT=mod.NPSAT;
  bool modelPar_given_NPSAT=mod.given("NPSAT");
  modParamMap["NPSAT"] = &modelPar_NPSAT;
  AdmsSensFadType modelPar_PPSAT=mod.PPSAT;
  bool modelPar_given_PPSAT=mod.given("PPSAT");
  modParamMap["PPSAT"] = &modelPar_PPSAT;
  AdmsSensFadType modelPar_LDELTAVSAT=mod.LDELTAVSAT;
  bool modelPar_given_LDELTAVSAT=mod.given("LDELTAVSAT");
  modParamMap["LDELTAVSAT"] = &modelPar_LDELTAVSAT;
  AdmsSensFadType modelPar_NDELTAVSAT=mod.NDELTAVSAT;
  bool modelPar_given_NDELTAVSAT=mod.given("NDELTAVSAT");
  modParamMap["NDELTAVSAT"] = &modelPar_NDELTAVSAT;
  AdmsSensFadType modelPar_PDELTAVSAT=mod.PDELTAVSAT;
  bool modelPar_given_PDELTAVSAT=mod.given("PDELTAVSAT");
  modParamMap["PDELTAVSAT"] = &modelPar_PDELTAVSAT;
  AdmsSensFadType modelPar_LKSATIV=mod.LKSATIV;
  bool modelPar_given_LKSATIV=mod.given("LKSATIV");
  modParamMap["LKSATIV"] = &modelPar_LKSATIV;
  AdmsSensFadType modelPar_NKSATIV=mod.NKSATIV;
  bool modelPar_given_NKSATIV=mod.given("NKSATIV");
  modParamMap["NKSATIV"] = &modelPar_NKSATIV;
  AdmsSensFadType modelPar_PKSATIV=mod.PKSATIV;
  bool modelPar_given_PKSATIV=mod.given("PKSATIV");
  modParamMap["PKSATIV"] = &modelPar_PKSATIV;
  AdmsSensFadType modelPar_LKSATIVR=mod.LKSATIVR;
  bool modelPar_given_LKSATIVR=mod.given("LKSATIVR");
  modParamMap["LKSATIVR"] = &modelPar_LKSATIVR;
  AdmsSensFadType modelPar_NKSATIVR=mod.NKSATIVR;
  bool modelPar_given_NKSATIVR=mod.given("NKSATIVR");
  modParamMap["NKSATIVR"] = &modelPar_NKSATIVR;
  AdmsSensFadType modelPar_PKSATIVR=mod.PKSATIVR;
  bool modelPar_given_PKSATIVR=mod.given("PKSATIVR");
  modParamMap["PKSATIVR"] = &modelPar_PKSATIVR;
  AdmsSensFadType modelPar_LVSATCV=mod.LVSATCV;
  bool modelPar_given_LVSATCV=mod.given("LVSATCV");
  modParamMap["LVSATCV"] = &modelPar_LVSATCV;
  AdmsSensFadType modelPar_NVSATCV=mod.NVSATCV;
  bool modelPar_given_NVSATCV=mod.given("NVSATCV");
  modParamMap["NVSATCV"] = &modelPar_NVSATCV;
  AdmsSensFadType modelPar_PVSATCV=mod.PVSATCV;
  bool modelPar_given_PVSATCV=mod.given("PVSATCV");
  modParamMap["PVSATCV"] = &modelPar_PVSATCV;
  AdmsSensFadType modelPar_LPSATCV=mod.LPSATCV;
  bool modelPar_given_LPSATCV=mod.given("LPSATCV");
  modParamMap["LPSATCV"] = &modelPar_LPSATCV;
  AdmsSensFadType modelPar_NPSATCV=mod.NPSATCV;
  bool modelPar_given_NPSATCV=mod.given("NPSATCV");
  modParamMap["NPSATCV"] = &modelPar_NPSATCV;
  AdmsSensFadType modelPar_PPSATCV=mod.PPSATCV;
  bool modelPar_given_PPSATCV=mod.given("PPSATCV");
  modParamMap["PPSATCV"] = &modelPar_PPSATCV;
  AdmsSensFadType modelPar_LDELTAVSATCV=mod.LDELTAVSATCV;
  bool modelPar_given_LDELTAVSATCV=mod.given("LDELTAVSATCV");
  modParamMap["LDELTAVSATCV"] = &modelPar_LDELTAVSATCV;
  AdmsSensFadType modelPar_NDELTAVSATCV=mod.NDELTAVSATCV;
  bool modelPar_given_NDELTAVSATCV=mod.given("NDELTAVSATCV");
  modParamMap["NDELTAVSATCV"] = &modelPar_NDELTAVSATCV;
  AdmsSensFadType modelPar_PDELTAVSATCV=mod.PDELTAVSATCV;
  bool modelPar_given_PDELTAVSATCV=mod.given("PDELTAVSATCV");
  modParamMap["PDELTAVSATCV"] = &modelPar_PDELTAVSATCV;
  AdmsSensFadType modelPar_LMEXP=mod.LMEXP;
  bool modelPar_given_LMEXP=mod.given("LMEXP");
  modParamMap["LMEXP"] = &modelPar_LMEXP;
  AdmsSensFadType modelPar_NMEXP=mod.NMEXP;
  bool modelPar_given_NMEXP=mod.given("NMEXP");
  modParamMap["NMEXP"] = &modelPar_NMEXP;
  AdmsSensFadType modelPar_PMEXP=mod.PMEXP;
  bool modelPar_given_PMEXP=mod.given("PMEXP");
  modParamMap["PMEXP"] = &modelPar_PMEXP;
  AdmsSensFadType modelPar_LMEXPR=mod.LMEXPR;
  bool modelPar_given_LMEXPR=mod.given("LMEXPR");
  modParamMap["LMEXPR"] = &modelPar_LMEXPR;
  AdmsSensFadType modelPar_NMEXPR=mod.NMEXPR;
  bool modelPar_given_NMEXPR=mod.given("NMEXPR");
  modParamMap["NMEXPR"] = &modelPar_NMEXPR;
  AdmsSensFadType modelPar_PMEXPR=mod.PMEXPR;
  bool modelPar_given_PMEXPR=mod.given("PMEXPR");
  modParamMap["PMEXPR"] = &modelPar_PMEXPR;
  AdmsSensFadType modelPar_LPTWG=mod.LPTWG;
  bool modelPar_given_LPTWG=mod.given("LPTWG");
  modParamMap["LPTWG"] = &modelPar_LPTWG;
  AdmsSensFadType modelPar_NPTWG=mod.NPTWG;
  bool modelPar_given_NPTWG=mod.given("NPTWG");
  modParamMap["NPTWG"] = &modelPar_NPTWG;
  AdmsSensFadType modelPar_PPTWG=mod.PPTWG;
  bool modelPar_given_PPTWG=mod.given("PPTWG");
  modParamMap["PPTWG"] = &modelPar_PPTWG;
  AdmsSensFadType modelPar_LPTWGR=mod.LPTWGR;
  bool modelPar_given_LPTWGR=mod.given("LPTWGR");
  modParamMap["LPTWGR"] = &modelPar_LPTWGR;
  AdmsSensFadType modelPar_NPTWGR=mod.NPTWGR;
  bool modelPar_given_NPTWGR=mod.given("NPTWGR");
  modParamMap["NPTWGR"] = &modelPar_NPTWGR;
  AdmsSensFadType modelPar_PPTWGR=mod.PPTWGR;
  bool modelPar_given_PPTWGR=mod.given("PPTWGR");
  modParamMap["PPTWGR"] = &modelPar_PPTWGR;
  AdmsSensFadType modelPar_LU0=mod.LU0;
  bool modelPar_given_LU0=mod.given("LU0");
  modParamMap["LU0"] = &modelPar_LU0;
  AdmsSensFadType modelPar_NU0=mod.NU0;
  bool modelPar_given_NU0=mod.given("NU0");
  modParamMap["NU0"] = &modelPar_NU0;
  AdmsSensFadType modelPar_PU0=mod.PU0;
  bool modelPar_given_PU0=mod.given("PU0");
  modParamMap["PU0"] = &modelPar_PU0;
  AdmsSensFadType modelPar_LU0R=mod.LU0R;
  bool modelPar_given_LU0R=mod.given("LU0R");
  modParamMap["LU0R"] = &modelPar_LU0R;
  AdmsSensFadType modelPar_NU0R=mod.NU0R;
  bool modelPar_given_NU0R=mod.given("NU0R");
  modParamMap["NU0R"] = &modelPar_NU0R;
  AdmsSensFadType modelPar_PU0R=mod.PU0R;
  bool modelPar_given_PU0R=mod.given("PU0R");
  modParamMap["PU0R"] = &modelPar_PU0R;
  AdmsSensFadType modelPar_LETAMOB=mod.LETAMOB;
  bool modelPar_given_LETAMOB=mod.given("LETAMOB");
  modParamMap["LETAMOB"] = &modelPar_LETAMOB;
  AdmsSensFadType modelPar_NETAMOB=mod.NETAMOB;
  bool modelPar_given_NETAMOB=mod.given("NETAMOB");
  modParamMap["NETAMOB"] = &modelPar_NETAMOB;
  AdmsSensFadType modelPar_PETAMOB=mod.PETAMOB;
  bool modelPar_given_PETAMOB=mod.given("PETAMOB");
  modParamMap["PETAMOB"] = &modelPar_PETAMOB;
  AdmsSensFadType modelPar_LUP=mod.LUP;
  bool modelPar_given_LUP=mod.given("LUP");
  modParamMap["LUP"] = &modelPar_LUP;
  AdmsSensFadType modelPar_NUP=mod.NUP;
  bool modelPar_given_NUP=mod.given("NUP");
  modParamMap["NUP"] = &modelPar_NUP;
  AdmsSensFadType modelPar_PUP=mod.PUP;
  bool modelPar_given_PUP=mod.given("PUP");
  modParamMap["PUP"] = &modelPar_PUP;
  AdmsSensFadType modelPar_LUPR=mod.LUPR;
  bool modelPar_given_LUPR=mod.given("LUPR");
  modParamMap["LUPR"] = &modelPar_LUPR;
  AdmsSensFadType modelPar_NUPR=mod.NUPR;
  bool modelPar_given_NUPR=mod.given("NUPR");
  modParamMap["NUPR"] = &modelPar_NUPR;
  AdmsSensFadType modelPar_PUPR=mod.PUPR;
  bool modelPar_given_PUPR=mod.given("PUPR");
  modParamMap["PUPR"] = &modelPar_PUPR;
  AdmsSensFadType modelPar_LUA=mod.LUA;
  bool modelPar_given_LUA=mod.given("LUA");
  modParamMap["LUA"] = &modelPar_LUA;
  AdmsSensFadType modelPar_NUA=mod.NUA;
  bool modelPar_given_NUA=mod.given("NUA");
  modParamMap["NUA"] = &modelPar_NUA;
  AdmsSensFadType modelPar_PUA=mod.PUA;
  bool modelPar_given_PUA=mod.given("PUA");
  modParamMap["PUA"] = &modelPar_PUA;
  AdmsSensFadType modelPar_LUAR=mod.LUAR;
  bool modelPar_given_LUAR=mod.given("LUAR");
  modParamMap["LUAR"] = &modelPar_LUAR;
  AdmsSensFadType modelPar_NUAR=mod.NUAR;
  bool modelPar_given_NUAR=mod.given("NUAR");
  modParamMap["NUAR"] = &modelPar_NUAR;
  AdmsSensFadType modelPar_PUAR=mod.PUAR;
  bool modelPar_given_PUAR=mod.given("PUAR");
  modParamMap["PUAR"] = &modelPar_PUAR;
  AdmsSensFadType modelPar_LUC=mod.LUC;
  bool modelPar_given_LUC=mod.given("LUC");
  modParamMap["LUC"] = &modelPar_LUC;
  AdmsSensFadType modelPar_NUC=mod.NUC;
  bool modelPar_given_NUC=mod.given("NUC");
  modParamMap["NUC"] = &modelPar_NUC;
  AdmsSensFadType modelPar_PUC=mod.PUC;
  bool modelPar_given_PUC=mod.given("PUC");
  modParamMap["PUC"] = &modelPar_PUC;
  AdmsSensFadType modelPar_LUCR=mod.LUCR;
  bool modelPar_given_LUCR=mod.given("LUCR");
  modParamMap["LUCR"] = &modelPar_LUCR;
  AdmsSensFadType modelPar_NUCR=mod.NUCR;
  bool modelPar_given_NUCR=mod.given("NUCR");
  modParamMap["NUCR"] = &modelPar_NUCR;
  AdmsSensFadType modelPar_PUCR=mod.PUCR;
  bool modelPar_given_PUCR=mod.given("PUCR");
  modParamMap["PUCR"] = &modelPar_PUCR;
  AdmsSensFadType modelPar_LEU=mod.LEU;
  bool modelPar_given_LEU=mod.given("LEU");
  modParamMap["LEU"] = &modelPar_LEU;
  AdmsSensFadType modelPar_NEU=mod.NEU;
  bool modelPar_given_NEU=mod.given("NEU");
  modParamMap["NEU"] = &modelPar_NEU;
  AdmsSensFadType modelPar_PEU=mod.PEU;
  bool modelPar_given_PEU=mod.given("PEU");
  modParamMap["PEU"] = &modelPar_PEU;
  AdmsSensFadType modelPar_LEUR=mod.LEUR;
  bool modelPar_given_LEUR=mod.given("LEUR");
  modParamMap["LEUR"] = &modelPar_LEUR;
  AdmsSensFadType modelPar_NEUR=mod.NEUR;
  bool modelPar_given_NEUR=mod.given("NEUR");
  modParamMap["NEUR"] = &modelPar_NEUR;
  AdmsSensFadType modelPar_PEUR=mod.PEUR;
  bool modelPar_given_PEUR=mod.given("PEUR");
  modParamMap["PEUR"] = &modelPar_PEUR;
  AdmsSensFadType modelPar_LUD=mod.LUD;
  bool modelPar_given_LUD=mod.given("LUD");
  modParamMap["LUD"] = &modelPar_LUD;
  AdmsSensFadType modelPar_NUD=mod.NUD;
  bool modelPar_given_NUD=mod.given("NUD");
  modParamMap["NUD"] = &modelPar_NUD;
  AdmsSensFadType modelPar_PUD=mod.PUD;
  bool modelPar_given_PUD=mod.given("PUD");
  modParamMap["PUD"] = &modelPar_PUD;
  AdmsSensFadType modelPar_LUDR=mod.LUDR;
  bool modelPar_given_LUDR=mod.given("LUDR");
  modParamMap["LUDR"] = &modelPar_LUDR;
  AdmsSensFadType modelPar_NUDR=mod.NUDR;
  bool modelPar_given_NUDR=mod.given("NUDR");
  modParamMap["NUDR"] = &modelPar_NUDR;
  AdmsSensFadType modelPar_PUDR=mod.PUDR;
  bool modelPar_given_PUDR=mod.given("PUDR");
  modParamMap["PUDR"] = &modelPar_PUDR;
  AdmsSensFadType modelPar_LUCS=mod.LUCS;
  bool modelPar_given_LUCS=mod.given("LUCS");
  modParamMap["LUCS"] = &modelPar_LUCS;
  AdmsSensFadType modelPar_NUCS=mod.NUCS;
  bool modelPar_given_NUCS=mod.given("NUCS");
  modParamMap["NUCS"] = &modelPar_NUCS;
  AdmsSensFadType modelPar_PUCS=mod.PUCS;
  bool modelPar_given_PUCS=mod.given("PUCS");
  modParamMap["PUCS"] = &modelPar_PUCS;
  AdmsSensFadType modelPar_LPCLM=mod.LPCLM;
  bool modelPar_given_LPCLM=mod.given("LPCLM");
  modParamMap["LPCLM"] = &modelPar_LPCLM;
  AdmsSensFadType modelPar_NPCLM=mod.NPCLM;
  bool modelPar_given_NPCLM=mod.given("NPCLM");
  modParamMap["NPCLM"] = &modelPar_NPCLM;
  AdmsSensFadType modelPar_PPCLM=mod.PPCLM;
  bool modelPar_given_PPCLM=mod.given("PPCLM");
  modParamMap["PPCLM"] = &modelPar_PPCLM;
  AdmsSensFadType modelPar_LPCLMR=mod.LPCLMR;
  bool modelPar_given_LPCLMR=mod.given("LPCLMR");
  modParamMap["LPCLMR"] = &modelPar_LPCLMR;
  AdmsSensFadType modelPar_NPCLMR=mod.NPCLMR;
  bool modelPar_given_NPCLMR=mod.given("NPCLMR");
  modParamMap["NPCLMR"] = &modelPar_NPCLMR;
  AdmsSensFadType modelPar_PPCLMR=mod.PPCLMR;
  bool modelPar_given_PPCLMR=mod.given("PPCLMR");
  modParamMap["PPCLMR"] = &modelPar_PPCLMR;
  AdmsSensFadType modelPar_LPCLMG=mod.LPCLMG;
  bool modelPar_given_LPCLMG=mod.given("LPCLMG");
  modParamMap["LPCLMG"] = &modelPar_LPCLMG;
  AdmsSensFadType modelPar_NPCLMG=mod.NPCLMG;
  bool modelPar_given_NPCLMG=mod.given("NPCLMG");
  modParamMap["NPCLMG"] = &modelPar_NPCLMG;
  AdmsSensFadType modelPar_PPCLMG=mod.PPCLMG;
  bool modelPar_given_PPCLMG=mod.given("PPCLMG");
  modParamMap["PPCLMG"] = &modelPar_PPCLMG;
  AdmsSensFadType modelPar_LPCLMCV=mod.LPCLMCV;
  bool modelPar_given_LPCLMCV=mod.given("LPCLMCV");
  modParamMap["LPCLMCV"] = &modelPar_LPCLMCV;
  AdmsSensFadType modelPar_NPCLMCV=mod.NPCLMCV;
  bool modelPar_given_NPCLMCV=mod.given("NPCLMCV");
  modParamMap["NPCLMCV"] = &modelPar_NPCLMCV;
  AdmsSensFadType modelPar_PPCLMCV=mod.PPCLMCV;
  bool modelPar_given_PPCLMCV=mod.given("PPCLMCV");
  modParamMap["PPCLMCV"] = &modelPar_PPCLMCV;
  AdmsSensFadType modelPar_LA1=mod.LA1;
  bool modelPar_given_LA1=mod.given("LA1");
  modParamMap["LA1"] = &modelPar_LA1;
  AdmsSensFadType modelPar_NA1=mod.NA1;
  bool modelPar_given_NA1=mod.given("NA1");
  modParamMap["NA1"] = &modelPar_NA1;
  AdmsSensFadType modelPar_PA1=mod.PA1;
  bool modelPar_given_PA1=mod.given("PA1");
  modParamMap["PA1"] = &modelPar_PA1;
  AdmsSensFadType modelPar_LA11=mod.LA11;
  bool modelPar_given_LA11=mod.given("LA11");
  modParamMap["LA11"] = &modelPar_LA11;
  AdmsSensFadType modelPar_NA11=mod.NA11;
  bool modelPar_given_NA11=mod.given("NA11");
  modParamMap["NA11"] = &modelPar_NA11;
  AdmsSensFadType modelPar_PA11=mod.PA11;
  bool modelPar_given_PA11=mod.given("PA11");
  modParamMap["PA11"] = &modelPar_PA11;
  AdmsSensFadType modelPar_LA2=mod.LA2;
  bool modelPar_given_LA2=mod.given("LA2");
  modParamMap["LA2"] = &modelPar_LA2;
  AdmsSensFadType modelPar_NA2=mod.NA2;
  bool modelPar_given_NA2=mod.given("NA2");
  modParamMap["NA2"] = &modelPar_NA2;
  AdmsSensFadType modelPar_PA2=mod.PA2;
  bool modelPar_given_PA2=mod.given("PA2");
  modParamMap["PA2"] = &modelPar_PA2;
  AdmsSensFadType modelPar_LA21=mod.LA21;
  bool modelPar_given_LA21=mod.given("LA21");
  modParamMap["LA21"] = &modelPar_LA21;
  AdmsSensFadType modelPar_NA21=mod.NA21;
  bool modelPar_given_NA21=mod.given("NA21");
  modParamMap["NA21"] = &modelPar_NA21;
  AdmsSensFadType modelPar_PA21=mod.PA21;
  bool modelPar_given_PA21=mod.given("PA21");
  modParamMap["PA21"] = &modelPar_PA21;
  AdmsSensFadType modelPar_LRDSW=mod.LRDSW;
  bool modelPar_given_LRDSW=mod.given("LRDSW");
  modParamMap["LRDSW"] = &modelPar_LRDSW;
  AdmsSensFadType modelPar_NRDSW=mod.NRDSW;
  bool modelPar_given_NRDSW=mod.given("NRDSW");
  modParamMap["NRDSW"] = &modelPar_NRDSW;
  AdmsSensFadType modelPar_PRDSW=mod.PRDSW;
  bool modelPar_given_PRDSW=mod.given("PRDSW");
  modParamMap["PRDSW"] = &modelPar_PRDSW;
  AdmsSensFadType modelPar_LRSW=mod.LRSW;
  bool modelPar_given_LRSW=mod.given("LRSW");
  modParamMap["LRSW"] = &modelPar_LRSW;
  AdmsSensFadType modelPar_NRSW=mod.NRSW;
  bool modelPar_given_NRSW=mod.given("NRSW");
  modParamMap["NRSW"] = &modelPar_NRSW;
  AdmsSensFadType modelPar_PRSW=mod.PRSW;
  bool modelPar_given_PRSW=mod.given("PRSW");
  modParamMap["PRSW"] = &modelPar_PRSW;
  AdmsSensFadType modelPar_LRDW=mod.LRDW;
  bool modelPar_given_LRDW=mod.given("LRDW");
  modParamMap["LRDW"] = &modelPar_LRDW;
  AdmsSensFadType modelPar_NRDW=mod.NRDW;
  bool modelPar_given_NRDW=mod.given("NRDW");
  modParamMap["NRDW"] = &modelPar_NRDW;
  AdmsSensFadType modelPar_PRDW=mod.PRDW;
  bool modelPar_given_PRDW=mod.given("PRDW");
  modParamMap["PRDW"] = &modelPar_PRDW;
  AdmsSensFadType modelPar_LPRWGS=mod.LPRWGS;
  bool modelPar_given_LPRWGS=mod.given("LPRWGS");
  modParamMap["LPRWGS"] = &modelPar_LPRWGS;
  AdmsSensFadType modelPar_NPRWGS=mod.NPRWGS;
  bool modelPar_given_NPRWGS=mod.given("NPRWGS");
  modParamMap["NPRWGS"] = &modelPar_NPRWGS;
  AdmsSensFadType modelPar_PPRWGS=mod.PPRWGS;
  bool modelPar_given_PPRWGS=mod.given("PPRWGS");
  modParamMap["PPRWGS"] = &modelPar_PPRWGS;
  AdmsSensFadType modelPar_LPRWGD=mod.LPRWGD;
  bool modelPar_given_LPRWGD=mod.given("LPRWGD");
  modParamMap["LPRWGD"] = &modelPar_LPRWGD;
  AdmsSensFadType modelPar_NPRWGD=mod.NPRWGD;
  bool modelPar_given_NPRWGD=mod.given("NPRWGD");
  modParamMap["NPRWGD"] = &modelPar_NPRWGD;
  AdmsSensFadType modelPar_PPRWGD=mod.PPRWGD;
  bool modelPar_given_PPRWGD=mod.given("PPRWGD");
  modParamMap["PPRWGD"] = &modelPar_PPRWGD;
  AdmsSensFadType modelPar_LWR=mod.LWR;
  bool modelPar_given_LWR=mod.given("LWR");
  modParamMap["LWR"] = &modelPar_LWR;
  AdmsSensFadType modelPar_NWR=mod.NWR;
  bool modelPar_given_NWR=mod.given("NWR");
  modParamMap["NWR"] = &modelPar_NWR;
  AdmsSensFadType modelPar_PWR=mod.PWR;
  bool modelPar_given_PWR=mod.given("PWR");
  modParamMap["PWR"] = &modelPar_PWR;
  AdmsSensFadType modelPar_LPDIBL1=mod.LPDIBL1;
  bool modelPar_given_LPDIBL1=mod.given("LPDIBL1");
  modParamMap["LPDIBL1"] = &modelPar_LPDIBL1;
  AdmsSensFadType modelPar_NPDIBL1=mod.NPDIBL1;
  bool modelPar_given_NPDIBL1=mod.given("NPDIBL1");
  modParamMap["NPDIBL1"] = &modelPar_NPDIBL1;
  AdmsSensFadType modelPar_PPDIBL1=mod.PPDIBL1;
  bool modelPar_given_PPDIBL1=mod.given("PPDIBL1");
  modParamMap["PPDIBL1"] = &modelPar_PPDIBL1;
  AdmsSensFadType modelPar_LPDIBL1R=mod.LPDIBL1R;
  bool modelPar_given_LPDIBL1R=mod.given("LPDIBL1R");
  modParamMap["LPDIBL1R"] = &modelPar_LPDIBL1R;
  AdmsSensFadType modelPar_NPDIBL1R=mod.NPDIBL1R;
  bool modelPar_given_NPDIBL1R=mod.given("NPDIBL1R");
  modParamMap["NPDIBL1R"] = &modelPar_NPDIBL1R;
  AdmsSensFadType modelPar_PPDIBL1R=mod.PPDIBL1R;
  bool modelPar_given_PPDIBL1R=mod.given("PPDIBL1R");
  modParamMap["PPDIBL1R"] = &modelPar_PPDIBL1R;
  AdmsSensFadType modelPar_LPDIBL2=mod.LPDIBL2;
  bool modelPar_given_LPDIBL2=mod.given("LPDIBL2");
  modParamMap["LPDIBL2"] = &modelPar_LPDIBL2;
  AdmsSensFadType modelPar_NPDIBL2=mod.NPDIBL2;
  bool modelPar_given_NPDIBL2=mod.given("NPDIBL2");
  modParamMap["NPDIBL2"] = &modelPar_NPDIBL2;
  AdmsSensFadType modelPar_PPDIBL2=mod.PPDIBL2;
  bool modelPar_given_PPDIBL2=mod.given("PPDIBL2");
  modParamMap["PPDIBL2"] = &modelPar_PPDIBL2;
  AdmsSensFadType modelPar_LPDIBL2R=mod.LPDIBL2R;
  bool modelPar_given_LPDIBL2R=mod.given("LPDIBL2R");
  modParamMap["LPDIBL2R"] = &modelPar_LPDIBL2R;
  AdmsSensFadType modelPar_NPDIBL2R=mod.NPDIBL2R;
  bool modelPar_given_NPDIBL2R=mod.given("NPDIBL2R");
  modParamMap["NPDIBL2R"] = &modelPar_NPDIBL2R;
  AdmsSensFadType modelPar_PPDIBL2R=mod.PPDIBL2R;
  bool modelPar_given_PPDIBL2R=mod.given("PPDIBL2R");
  modParamMap["PPDIBL2R"] = &modelPar_PPDIBL2R;
  AdmsSensFadType modelPar_LDROUT=mod.LDROUT;
  bool modelPar_given_LDROUT=mod.given("LDROUT");
  modParamMap["LDROUT"] = &modelPar_LDROUT;
  AdmsSensFadType modelPar_NDROUT=mod.NDROUT;
  bool modelPar_given_NDROUT=mod.given("NDROUT");
  modParamMap["NDROUT"] = &modelPar_NDROUT;
  AdmsSensFadType modelPar_PDROUT=mod.PDROUT;
  bool modelPar_given_PDROUT=mod.given("PDROUT");
  modParamMap["PDROUT"] = &modelPar_PDROUT;
  AdmsSensFadType modelPar_LPVAG=mod.LPVAG;
  bool modelPar_given_LPVAG=mod.given("LPVAG");
  modParamMap["LPVAG"] = &modelPar_LPVAG;
  AdmsSensFadType modelPar_NPVAG=mod.NPVAG;
  bool modelPar_given_NPVAG=mod.given("NPVAG");
  modParamMap["NPVAG"] = &modelPar_NPVAG;
  AdmsSensFadType modelPar_PPVAG=mod.PPVAG;
  bool modelPar_given_PPVAG=mod.given("PPVAG");
  modParamMap["PPVAG"] = &modelPar_PPVAG;
  AdmsSensFadType modelPar_LAIGBINV=mod.LAIGBINV;
  bool modelPar_given_LAIGBINV=mod.given("LAIGBINV");
  modParamMap["LAIGBINV"] = &modelPar_LAIGBINV;
  AdmsSensFadType modelPar_NAIGBINV=mod.NAIGBINV;
  bool modelPar_given_NAIGBINV=mod.given("NAIGBINV");
  modParamMap["NAIGBINV"] = &modelPar_NAIGBINV;
  AdmsSensFadType modelPar_PAIGBINV=mod.PAIGBINV;
  bool modelPar_given_PAIGBINV=mod.given("PAIGBINV");
  modParamMap["PAIGBINV"] = &modelPar_PAIGBINV;
  AdmsSensFadType modelPar_LAIGBINV1=mod.LAIGBINV1;
  bool modelPar_given_LAIGBINV1=mod.given("LAIGBINV1");
  modParamMap["LAIGBINV1"] = &modelPar_LAIGBINV1;
  AdmsSensFadType modelPar_NAIGBINV1=mod.NAIGBINV1;
  bool modelPar_given_NAIGBINV1=mod.given("NAIGBINV1");
  modParamMap["NAIGBINV1"] = &modelPar_NAIGBINV1;
  AdmsSensFadType modelPar_PAIGBINV1=mod.PAIGBINV1;
  bool modelPar_given_PAIGBINV1=mod.given("PAIGBINV1");
  modParamMap["PAIGBINV1"] = &modelPar_PAIGBINV1;
  AdmsSensFadType modelPar_LBIGBINV=mod.LBIGBINV;
  bool modelPar_given_LBIGBINV=mod.given("LBIGBINV");
  modParamMap["LBIGBINV"] = &modelPar_LBIGBINV;
  AdmsSensFadType modelPar_NBIGBINV=mod.NBIGBINV;
  bool modelPar_given_NBIGBINV=mod.given("NBIGBINV");
  modParamMap["NBIGBINV"] = &modelPar_NBIGBINV;
  AdmsSensFadType modelPar_PBIGBINV=mod.PBIGBINV;
  bool modelPar_given_PBIGBINV=mod.given("PBIGBINV");
  modParamMap["PBIGBINV"] = &modelPar_PBIGBINV;
  AdmsSensFadType modelPar_LCIGBINV=mod.LCIGBINV;
  bool modelPar_given_LCIGBINV=mod.given("LCIGBINV");
  modParamMap["LCIGBINV"] = &modelPar_LCIGBINV;
  AdmsSensFadType modelPar_NCIGBINV=mod.NCIGBINV;
  bool modelPar_given_NCIGBINV=mod.given("NCIGBINV");
  modParamMap["NCIGBINV"] = &modelPar_NCIGBINV;
  AdmsSensFadType modelPar_PCIGBINV=mod.PCIGBINV;
  bool modelPar_given_PCIGBINV=mod.given("PCIGBINV");
  modParamMap["PCIGBINV"] = &modelPar_PCIGBINV;
  AdmsSensFadType modelPar_LEIGBINV=mod.LEIGBINV;
  bool modelPar_given_LEIGBINV=mod.given("LEIGBINV");
  modParamMap["LEIGBINV"] = &modelPar_LEIGBINV;
  AdmsSensFadType modelPar_NEIGBINV=mod.NEIGBINV;
  bool modelPar_given_NEIGBINV=mod.given("NEIGBINV");
  modParamMap["NEIGBINV"] = &modelPar_NEIGBINV;
  AdmsSensFadType modelPar_PEIGBINV=mod.PEIGBINV;
  bool modelPar_given_PEIGBINV=mod.given("PEIGBINV");
  modParamMap["PEIGBINV"] = &modelPar_PEIGBINV;
  AdmsSensFadType modelPar_LNIGBINV=mod.LNIGBINV;
  bool modelPar_given_LNIGBINV=mod.given("LNIGBINV");
  modParamMap["LNIGBINV"] = &modelPar_LNIGBINV;
  AdmsSensFadType modelPar_NNIGBINV=mod.NNIGBINV;
  bool modelPar_given_NNIGBINV=mod.given("NNIGBINV");
  modParamMap["NNIGBINV"] = &modelPar_NNIGBINV;
  AdmsSensFadType modelPar_PNIGBINV=mod.PNIGBINV;
  bool modelPar_given_PNIGBINV=mod.given("PNIGBINV");
  modParamMap["PNIGBINV"] = &modelPar_PNIGBINV;
  AdmsSensFadType modelPar_LAIGBACC=mod.LAIGBACC;
  bool modelPar_given_LAIGBACC=mod.given("LAIGBACC");
  modParamMap["LAIGBACC"] = &modelPar_LAIGBACC;
  AdmsSensFadType modelPar_NAIGBACC=mod.NAIGBACC;
  bool modelPar_given_NAIGBACC=mod.given("NAIGBACC");
  modParamMap["NAIGBACC"] = &modelPar_NAIGBACC;
  AdmsSensFadType modelPar_PAIGBACC=mod.PAIGBACC;
  bool modelPar_given_PAIGBACC=mod.given("PAIGBACC");
  modParamMap["PAIGBACC"] = &modelPar_PAIGBACC;
  AdmsSensFadType modelPar_LAIGBACC1=mod.LAIGBACC1;
  bool modelPar_given_LAIGBACC1=mod.given("LAIGBACC1");
  modParamMap["LAIGBACC1"] = &modelPar_LAIGBACC1;
  AdmsSensFadType modelPar_NAIGBACC1=mod.NAIGBACC1;
  bool modelPar_given_NAIGBACC1=mod.given("NAIGBACC1");
  modParamMap["NAIGBACC1"] = &modelPar_NAIGBACC1;
  AdmsSensFadType modelPar_PAIGBACC1=mod.PAIGBACC1;
  bool modelPar_given_PAIGBACC1=mod.given("PAIGBACC1");
  modParamMap["PAIGBACC1"] = &modelPar_PAIGBACC1;
  AdmsSensFadType modelPar_LBIGBACC=mod.LBIGBACC;
  bool modelPar_given_LBIGBACC=mod.given("LBIGBACC");
  modParamMap["LBIGBACC"] = &modelPar_LBIGBACC;
  AdmsSensFadType modelPar_NBIGBACC=mod.NBIGBACC;
  bool modelPar_given_NBIGBACC=mod.given("NBIGBACC");
  modParamMap["NBIGBACC"] = &modelPar_NBIGBACC;
  AdmsSensFadType modelPar_PBIGBACC=mod.PBIGBACC;
  bool modelPar_given_PBIGBACC=mod.given("PBIGBACC");
  modParamMap["PBIGBACC"] = &modelPar_PBIGBACC;
  AdmsSensFadType modelPar_LCIGBACC=mod.LCIGBACC;
  bool modelPar_given_LCIGBACC=mod.given("LCIGBACC");
  modParamMap["LCIGBACC"] = &modelPar_LCIGBACC;
  AdmsSensFadType modelPar_NCIGBACC=mod.NCIGBACC;
  bool modelPar_given_NCIGBACC=mod.given("NCIGBACC");
  modParamMap["NCIGBACC"] = &modelPar_NCIGBACC;
  AdmsSensFadType modelPar_PCIGBACC=mod.PCIGBACC;
  bool modelPar_given_PCIGBACC=mod.given("PCIGBACC");
  modParamMap["PCIGBACC"] = &modelPar_PCIGBACC;
  AdmsSensFadType modelPar_LNIGBACC=mod.LNIGBACC;
  bool modelPar_given_LNIGBACC=mod.given("LNIGBACC");
  modParamMap["LNIGBACC"] = &modelPar_LNIGBACC;
  AdmsSensFadType modelPar_NNIGBACC=mod.NNIGBACC;
  bool modelPar_given_NNIGBACC=mod.given("NNIGBACC");
  modParamMap["NNIGBACC"] = &modelPar_NNIGBACC;
  AdmsSensFadType modelPar_PNIGBACC=mod.PNIGBACC;
  bool modelPar_given_PNIGBACC=mod.given("PNIGBACC");
  modParamMap["PNIGBACC"] = &modelPar_PNIGBACC;
  AdmsSensFadType modelPar_LAIGC=mod.LAIGC;
  bool modelPar_given_LAIGC=mod.given("LAIGC");
  modParamMap["LAIGC"] = &modelPar_LAIGC;
  AdmsSensFadType modelPar_NAIGC=mod.NAIGC;
  bool modelPar_given_NAIGC=mod.given("NAIGC");
  modParamMap["NAIGC"] = &modelPar_NAIGC;
  AdmsSensFadType modelPar_PAIGC=mod.PAIGC;
  bool modelPar_given_PAIGC=mod.given("PAIGC");
  modParamMap["PAIGC"] = &modelPar_PAIGC;
  AdmsSensFadType modelPar_LAIGC1=mod.LAIGC1;
  bool modelPar_given_LAIGC1=mod.given("LAIGC1");
  modParamMap["LAIGC1"] = &modelPar_LAIGC1;
  AdmsSensFadType modelPar_NAIGC1=mod.NAIGC1;
  bool modelPar_given_NAIGC1=mod.given("NAIGC1");
  modParamMap["NAIGC1"] = &modelPar_NAIGC1;
  AdmsSensFadType modelPar_PAIGC1=mod.PAIGC1;
  bool modelPar_given_PAIGC1=mod.given("PAIGC1");
  modParamMap["PAIGC1"] = &modelPar_PAIGC1;
  AdmsSensFadType modelPar_LBIGC=mod.LBIGC;
  bool modelPar_given_LBIGC=mod.given("LBIGC");
  modParamMap["LBIGC"] = &modelPar_LBIGC;
  AdmsSensFadType modelPar_NBIGC=mod.NBIGC;
  bool modelPar_given_NBIGC=mod.given("NBIGC");
  modParamMap["NBIGC"] = &modelPar_NBIGC;
  AdmsSensFadType modelPar_PBIGC=mod.PBIGC;
  bool modelPar_given_PBIGC=mod.given("PBIGC");
  modParamMap["PBIGC"] = &modelPar_PBIGC;
  AdmsSensFadType modelPar_LCIGC=mod.LCIGC;
  bool modelPar_given_LCIGC=mod.given("LCIGC");
  modParamMap["LCIGC"] = &modelPar_LCIGC;
  AdmsSensFadType modelPar_NCIGC=mod.NCIGC;
  bool modelPar_given_NCIGC=mod.given("NCIGC");
  modParamMap["NCIGC"] = &modelPar_NCIGC;
  AdmsSensFadType modelPar_PCIGC=mod.PCIGC;
  bool modelPar_given_PCIGC=mod.given("PCIGC");
  modParamMap["PCIGC"] = &modelPar_PCIGC;
  AdmsSensFadType modelPar_LPIGCD=mod.LPIGCD;
  bool modelPar_given_LPIGCD=mod.given("LPIGCD");
  modParamMap["LPIGCD"] = &modelPar_LPIGCD;
  AdmsSensFadType modelPar_NPIGCD=mod.NPIGCD;
  bool modelPar_given_NPIGCD=mod.given("NPIGCD");
  modParamMap["NPIGCD"] = &modelPar_NPIGCD;
  AdmsSensFadType modelPar_PPIGCD=mod.PPIGCD;
  bool modelPar_given_PPIGCD=mod.given("PPIGCD");
  modParamMap["PPIGCD"] = &modelPar_PPIGCD;
  AdmsSensFadType modelPar_LAIGS=mod.LAIGS;
  bool modelPar_given_LAIGS=mod.given("LAIGS");
  modParamMap["LAIGS"] = &modelPar_LAIGS;
  AdmsSensFadType modelPar_NAIGS=mod.NAIGS;
  bool modelPar_given_NAIGS=mod.given("NAIGS");
  modParamMap["NAIGS"] = &modelPar_NAIGS;
  AdmsSensFadType modelPar_PAIGS=mod.PAIGS;
  bool modelPar_given_PAIGS=mod.given("PAIGS");
  modParamMap["PAIGS"] = &modelPar_PAIGS;
  AdmsSensFadType modelPar_LAIGS1=mod.LAIGS1;
  bool modelPar_given_LAIGS1=mod.given("LAIGS1");
  modParamMap["LAIGS1"] = &modelPar_LAIGS1;
  AdmsSensFadType modelPar_NAIGS1=mod.NAIGS1;
  bool modelPar_given_NAIGS1=mod.given("NAIGS1");
  modParamMap["NAIGS1"] = &modelPar_NAIGS1;
  AdmsSensFadType modelPar_PAIGS1=mod.PAIGS1;
  bool modelPar_given_PAIGS1=mod.given("PAIGS1");
  modParamMap["PAIGS1"] = &modelPar_PAIGS1;
  AdmsSensFadType modelPar_LBIGS=mod.LBIGS;
  bool modelPar_given_LBIGS=mod.given("LBIGS");
  modParamMap["LBIGS"] = &modelPar_LBIGS;
  AdmsSensFadType modelPar_NBIGS=mod.NBIGS;
  bool modelPar_given_NBIGS=mod.given("NBIGS");
  modParamMap["NBIGS"] = &modelPar_NBIGS;
  AdmsSensFadType modelPar_PBIGS=mod.PBIGS;
  bool modelPar_given_PBIGS=mod.given("PBIGS");
  modParamMap["PBIGS"] = &modelPar_PBIGS;
  AdmsSensFadType modelPar_LCIGS=mod.LCIGS;
  bool modelPar_given_LCIGS=mod.given("LCIGS");
  modParamMap["LCIGS"] = &modelPar_LCIGS;
  AdmsSensFadType modelPar_NCIGS=mod.NCIGS;
  bool modelPar_given_NCIGS=mod.given("NCIGS");
  modParamMap["NCIGS"] = &modelPar_NCIGS;
  AdmsSensFadType modelPar_PCIGS=mod.PCIGS;
  bool modelPar_given_PCIGS=mod.given("PCIGS");
  modParamMap["PCIGS"] = &modelPar_PCIGS;
  AdmsSensFadType modelPar_LAIGD=mod.LAIGD;
  bool modelPar_given_LAIGD=mod.given("LAIGD");
  modParamMap["LAIGD"] = &modelPar_LAIGD;
  AdmsSensFadType modelPar_NAIGD=mod.NAIGD;
  bool modelPar_given_NAIGD=mod.given("NAIGD");
  modParamMap["NAIGD"] = &modelPar_NAIGD;
  AdmsSensFadType modelPar_PAIGD=mod.PAIGD;
  bool modelPar_given_PAIGD=mod.given("PAIGD");
  modParamMap["PAIGD"] = &modelPar_PAIGD;
  AdmsSensFadType modelPar_LAIGD1=mod.LAIGD1;
  bool modelPar_given_LAIGD1=mod.given("LAIGD1");
  modParamMap["LAIGD1"] = &modelPar_LAIGD1;
  AdmsSensFadType modelPar_NAIGD1=mod.NAIGD1;
  bool modelPar_given_NAIGD1=mod.given("NAIGD1");
  modParamMap["NAIGD1"] = &modelPar_NAIGD1;
  AdmsSensFadType modelPar_PAIGD1=mod.PAIGD1;
  bool modelPar_given_PAIGD1=mod.given("PAIGD1");
  modParamMap["PAIGD1"] = &modelPar_PAIGD1;
  AdmsSensFadType modelPar_LBIGD=mod.LBIGD;
  bool modelPar_given_LBIGD=mod.given("LBIGD");
  modParamMap["LBIGD"] = &modelPar_LBIGD;
  AdmsSensFadType modelPar_NBIGD=mod.NBIGD;
  bool modelPar_given_NBIGD=mod.given("NBIGD");
  modParamMap["NBIGD"] = &modelPar_NBIGD;
  AdmsSensFadType modelPar_PBIGD=mod.PBIGD;
  bool modelPar_given_PBIGD=mod.given("PBIGD");
  modParamMap["PBIGD"] = &modelPar_PBIGD;
  AdmsSensFadType modelPar_LCIGD=mod.LCIGD;
  bool modelPar_given_LCIGD=mod.given("LCIGD");
  modParamMap["LCIGD"] = &modelPar_LCIGD;
  AdmsSensFadType modelPar_NCIGD=mod.NCIGD;
  bool modelPar_given_NCIGD=mod.given("NCIGD");
  modParamMap["NCIGD"] = &modelPar_NCIGD;
  AdmsSensFadType modelPar_PCIGD=mod.PCIGD;
  bool modelPar_given_PCIGD=mod.given("PCIGD");
  modParamMap["PCIGD"] = &modelPar_PCIGD;
  AdmsSensFadType modelPar_LNTOX=mod.LNTOX;
  bool modelPar_given_LNTOX=mod.given("LNTOX");
  modParamMap["LNTOX"] = &modelPar_LNTOX;
  AdmsSensFadType modelPar_NNTOX=mod.NNTOX;
  bool modelPar_given_NNTOX=mod.given("NNTOX");
  modParamMap["NNTOX"] = &modelPar_NNTOX;
  AdmsSensFadType modelPar_PNTOX=mod.PNTOX;
  bool modelPar_given_PNTOX=mod.given("PNTOX");
  modParamMap["PNTOX"] = &modelPar_PNTOX;
  AdmsSensFadType modelPar_LPOXEDGE=mod.LPOXEDGE;
  bool modelPar_given_LPOXEDGE=mod.given("LPOXEDGE");
  modParamMap["LPOXEDGE"] = &modelPar_LPOXEDGE;
  AdmsSensFadType modelPar_NPOXEDGE=mod.NPOXEDGE;
  bool modelPar_given_NPOXEDGE=mod.given("NPOXEDGE");
  modParamMap["NPOXEDGE"] = &modelPar_NPOXEDGE;
  AdmsSensFadType modelPar_PPOXEDGE=mod.PPOXEDGE;
  bool modelPar_given_PPOXEDGE=mod.given("PPOXEDGE");
  modParamMap["PPOXEDGE"] = &modelPar_PPOXEDGE;
  AdmsSensFadType modelPar_LAGISL=mod.LAGISL;
  bool modelPar_given_LAGISL=mod.given("LAGISL");
  modParamMap["LAGISL"] = &modelPar_LAGISL;
  AdmsSensFadType modelPar_NAGISL=mod.NAGISL;
  bool modelPar_given_NAGISL=mod.given("NAGISL");
  modParamMap["NAGISL"] = &modelPar_NAGISL;
  AdmsSensFadType modelPar_PAGISL=mod.PAGISL;
  bool modelPar_given_PAGISL=mod.given("PAGISL");
  modParamMap["PAGISL"] = &modelPar_PAGISL;
  AdmsSensFadType modelPar_LBGISL=mod.LBGISL;
  bool modelPar_given_LBGISL=mod.given("LBGISL");
  modParamMap["LBGISL"] = &modelPar_LBGISL;
  AdmsSensFadType modelPar_NBGISL=mod.NBGISL;
  bool modelPar_given_NBGISL=mod.given("NBGISL");
  modParamMap["NBGISL"] = &modelPar_NBGISL;
  AdmsSensFadType modelPar_PBGISL=mod.PBGISL;
  bool modelPar_given_PBGISL=mod.given("PBGISL");
  modParamMap["PBGISL"] = &modelPar_PBGISL;
  AdmsSensFadType modelPar_LCGISL=mod.LCGISL;
  bool modelPar_given_LCGISL=mod.given("LCGISL");
  modParamMap["LCGISL"] = &modelPar_LCGISL;
  AdmsSensFadType modelPar_NCGISL=mod.NCGISL;
  bool modelPar_given_NCGISL=mod.given("NCGISL");
  modParamMap["NCGISL"] = &modelPar_NCGISL;
  AdmsSensFadType modelPar_PCGISL=mod.PCGISL;
  bool modelPar_given_PCGISL=mod.given("PCGISL");
  modParamMap["PCGISL"] = &modelPar_PCGISL;
  AdmsSensFadType modelPar_LEGISL=mod.LEGISL;
  bool modelPar_given_LEGISL=mod.given("LEGISL");
  modParamMap["LEGISL"] = &modelPar_LEGISL;
  AdmsSensFadType modelPar_NEGISL=mod.NEGISL;
  bool modelPar_given_NEGISL=mod.given("NEGISL");
  modParamMap["NEGISL"] = &modelPar_NEGISL;
  AdmsSensFadType modelPar_PEGISL=mod.PEGISL;
  bool modelPar_given_PEGISL=mod.given("PEGISL");
  modParamMap["PEGISL"] = &modelPar_PEGISL;
  AdmsSensFadType modelPar_LPGISL=mod.LPGISL;
  bool modelPar_given_LPGISL=mod.given("LPGISL");
  modParamMap["LPGISL"] = &modelPar_LPGISL;
  AdmsSensFadType modelPar_NPGISL=mod.NPGISL;
  bool modelPar_given_NPGISL=mod.given("NPGISL");
  modParamMap["NPGISL"] = &modelPar_NPGISL;
  AdmsSensFadType modelPar_PPGISL=mod.PPGISL;
  bool modelPar_given_PPGISL=mod.given("PPGISL");
  modParamMap["PPGISL"] = &modelPar_PPGISL;
  AdmsSensFadType modelPar_LAGIDL=mod.LAGIDL;
  bool modelPar_given_LAGIDL=mod.given("LAGIDL");
  modParamMap["LAGIDL"] = &modelPar_LAGIDL;
  AdmsSensFadType modelPar_NAGIDL=mod.NAGIDL;
  bool modelPar_given_NAGIDL=mod.given("NAGIDL");
  modParamMap["NAGIDL"] = &modelPar_NAGIDL;
  AdmsSensFadType modelPar_PAGIDL=mod.PAGIDL;
  bool modelPar_given_PAGIDL=mod.given("PAGIDL");
  modParamMap["PAGIDL"] = &modelPar_PAGIDL;
  AdmsSensFadType modelPar_LBGIDL=mod.LBGIDL;
  bool modelPar_given_LBGIDL=mod.given("LBGIDL");
  modParamMap["LBGIDL"] = &modelPar_LBGIDL;
  AdmsSensFadType modelPar_NBGIDL=mod.NBGIDL;
  bool modelPar_given_NBGIDL=mod.given("NBGIDL");
  modParamMap["NBGIDL"] = &modelPar_NBGIDL;
  AdmsSensFadType modelPar_PBGIDL=mod.PBGIDL;
  bool modelPar_given_PBGIDL=mod.given("PBGIDL");
  modParamMap["PBGIDL"] = &modelPar_PBGIDL;
  AdmsSensFadType modelPar_LCGIDL=mod.LCGIDL;
  bool modelPar_given_LCGIDL=mod.given("LCGIDL");
  modParamMap["LCGIDL"] = &modelPar_LCGIDL;
  AdmsSensFadType modelPar_NCGIDL=mod.NCGIDL;
  bool modelPar_given_NCGIDL=mod.given("NCGIDL");
  modParamMap["NCGIDL"] = &modelPar_NCGIDL;
  AdmsSensFadType modelPar_PCGIDL=mod.PCGIDL;
  bool modelPar_given_PCGIDL=mod.given("PCGIDL");
  modParamMap["PCGIDL"] = &modelPar_PCGIDL;
  AdmsSensFadType modelPar_LEGIDL=mod.LEGIDL;
  bool modelPar_given_LEGIDL=mod.given("LEGIDL");
  modParamMap["LEGIDL"] = &modelPar_LEGIDL;
  AdmsSensFadType modelPar_NEGIDL=mod.NEGIDL;
  bool modelPar_given_NEGIDL=mod.given("NEGIDL");
  modParamMap["NEGIDL"] = &modelPar_NEGIDL;
  AdmsSensFadType modelPar_PEGIDL=mod.PEGIDL;
  bool modelPar_given_PEGIDL=mod.given("PEGIDL");
  modParamMap["PEGIDL"] = &modelPar_PEGIDL;
  AdmsSensFadType modelPar_LPGIDL=mod.LPGIDL;
  bool modelPar_given_LPGIDL=mod.given("LPGIDL");
  modParamMap["LPGIDL"] = &modelPar_LPGIDL;
  AdmsSensFadType modelPar_NPGIDL=mod.NPGIDL;
  bool modelPar_given_NPGIDL=mod.given("NPGIDL");
  modParamMap["NPGIDL"] = &modelPar_NPGIDL;
  AdmsSensFadType modelPar_PPGIDL=mod.PPGIDL;
  bool modelPar_given_PPGIDL=mod.given("PPGIDL");
  modParamMap["PPGIDL"] = &modelPar_PPGIDL;
  AdmsSensFadType modelPar_LALPHA0=mod.LALPHA0;
  bool modelPar_given_LALPHA0=mod.given("LALPHA0");
  modParamMap["LALPHA0"] = &modelPar_LALPHA0;
  AdmsSensFadType modelPar_NALPHA0=mod.NALPHA0;
  bool modelPar_given_NALPHA0=mod.given("NALPHA0");
  modParamMap["NALPHA0"] = &modelPar_NALPHA0;
  AdmsSensFadType modelPar_PALPHA0=mod.PALPHA0;
  bool modelPar_given_PALPHA0=mod.given("PALPHA0");
  modParamMap["PALPHA0"] = &modelPar_PALPHA0;
  AdmsSensFadType modelPar_LALPHA1=mod.LALPHA1;
  bool modelPar_given_LALPHA1=mod.given("LALPHA1");
  modParamMap["LALPHA1"] = &modelPar_LALPHA1;
  AdmsSensFadType modelPar_NALPHA1=mod.NALPHA1;
  bool modelPar_given_NALPHA1=mod.given("NALPHA1");
  modParamMap["NALPHA1"] = &modelPar_NALPHA1;
  AdmsSensFadType modelPar_PALPHA1=mod.PALPHA1;
  bool modelPar_given_PALPHA1=mod.given("PALPHA1");
  modParamMap["PALPHA1"] = &modelPar_PALPHA1;
  AdmsSensFadType modelPar_LALPHAII0=mod.LALPHAII0;
  bool modelPar_given_LALPHAII0=mod.given("LALPHAII0");
  modParamMap["LALPHAII0"] = &modelPar_LALPHAII0;
  AdmsSensFadType modelPar_NALPHAII0=mod.NALPHAII0;
  bool modelPar_given_NALPHAII0=mod.given("NALPHAII0");
  modParamMap["NALPHAII0"] = &modelPar_NALPHAII0;
  AdmsSensFadType modelPar_PALPHAII0=mod.PALPHAII0;
  bool modelPar_given_PALPHAII0=mod.given("PALPHAII0");
  modParamMap["PALPHAII0"] = &modelPar_PALPHAII0;
  AdmsSensFadType modelPar_LALPHAII1=mod.LALPHAII1;
  bool modelPar_given_LALPHAII1=mod.given("LALPHAII1");
  modParamMap["LALPHAII1"] = &modelPar_LALPHAII1;
  AdmsSensFadType modelPar_NALPHAII1=mod.NALPHAII1;
  bool modelPar_given_NALPHAII1=mod.given("NALPHAII1");
  modParamMap["NALPHAII1"] = &modelPar_NALPHAII1;
  AdmsSensFadType modelPar_PALPHAII1=mod.PALPHAII1;
  bool modelPar_given_PALPHAII1=mod.given("PALPHAII1");
  modParamMap["PALPHAII1"] = &modelPar_PALPHAII1;
  AdmsSensFadType modelPar_LBETA0=mod.LBETA0;
  bool modelPar_given_LBETA0=mod.given("LBETA0");
  modParamMap["LBETA0"] = &modelPar_LBETA0;
  AdmsSensFadType modelPar_NBETA0=mod.NBETA0;
  bool modelPar_given_NBETA0=mod.given("NBETA0");
  modParamMap["NBETA0"] = &modelPar_NBETA0;
  AdmsSensFadType modelPar_PBETA0=mod.PBETA0;
  bool modelPar_given_PBETA0=mod.given("PBETA0");
  modParamMap["PBETA0"] = &modelPar_PBETA0;
  AdmsSensFadType modelPar_LBETAII0=mod.LBETAII0;
  bool modelPar_given_LBETAII0=mod.given("LBETAII0");
  modParamMap["LBETAII0"] = &modelPar_LBETAII0;
  AdmsSensFadType modelPar_NBETAII0=mod.NBETAII0;
  bool modelPar_given_NBETAII0=mod.given("NBETAII0");
  modParamMap["NBETAII0"] = &modelPar_NBETAII0;
  AdmsSensFadType modelPar_PBETAII0=mod.PBETAII0;
  bool modelPar_given_PBETAII0=mod.given("PBETAII0");
  modParamMap["PBETAII0"] = &modelPar_PBETAII0;
  AdmsSensFadType modelPar_LBETAII1=mod.LBETAII1;
  bool modelPar_given_LBETAII1=mod.given("LBETAII1");
  modParamMap["LBETAII1"] = &modelPar_LBETAII1;
  AdmsSensFadType modelPar_NBETAII1=mod.NBETAII1;
  bool modelPar_given_NBETAII1=mod.given("NBETAII1");
  modParamMap["NBETAII1"] = &modelPar_NBETAII1;
  AdmsSensFadType modelPar_PBETAII1=mod.PBETAII1;
  bool modelPar_given_PBETAII1=mod.given("PBETAII1");
  modParamMap["PBETAII1"] = &modelPar_PBETAII1;
  AdmsSensFadType modelPar_LBETAII2=mod.LBETAII2;
  bool modelPar_given_LBETAII2=mod.given("LBETAII2");
  modParamMap["LBETAII2"] = &modelPar_LBETAII2;
  AdmsSensFadType modelPar_NBETAII2=mod.NBETAII2;
  bool modelPar_given_NBETAII2=mod.given("NBETAII2");
  modParamMap["NBETAII2"] = &modelPar_NBETAII2;
  AdmsSensFadType modelPar_PBETAII2=mod.PBETAII2;
  bool modelPar_given_PBETAII2=mod.given("PBETAII2");
  modParamMap["PBETAII2"] = &modelPar_PBETAII2;
  AdmsSensFadType modelPar_LESATII=mod.LESATII;
  bool modelPar_given_LESATII=mod.given("LESATII");
  modParamMap["LESATII"] = &modelPar_LESATII;
  AdmsSensFadType modelPar_NESATII=mod.NESATII;
  bool modelPar_given_NESATII=mod.given("NESATII");
  modParamMap["NESATII"] = &modelPar_NESATII;
  AdmsSensFadType modelPar_PESATII=mod.PESATII;
  bool modelPar_given_PESATII=mod.given("PESATII");
  modParamMap["PESATII"] = &modelPar_PESATII;
  AdmsSensFadType modelPar_LLII=mod.LLII;
  bool modelPar_given_LLII=mod.given("LLII");
  modParamMap["LLII"] = &modelPar_LLII;
  AdmsSensFadType modelPar_NLII=mod.NLII;
  bool modelPar_given_NLII=mod.given("NLII");
  modParamMap["NLII"] = &modelPar_NLII;
  AdmsSensFadType modelPar_PLII=mod.PLII;
  bool modelPar_given_PLII=mod.given("PLII");
  modParamMap["PLII"] = &modelPar_PLII;
  AdmsSensFadType modelPar_LSII0=mod.LSII0;
  bool modelPar_given_LSII0=mod.given("LSII0");
  modParamMap["LSII0"] = &modelPar_LSII0;
  AdmsSensFadType modelPar_NSII0=mod.NSII0;
  bool modelPar_given_NSII0=mod.given("NSII0");
  modParamMap["NSII0"] = &modelPar_NSII0;
  AdmsSensFadType modelPar_PSII0=mod.PSII0;
  bool modelPar_given_PSII0=mod.given("PSII0");
  modParamMap["PSII0"] = &modelPar_PSII0;
  AdmsSensFadType modelPar_LSII1=mod.LSII1;
  bool modelPar_given_LSII1=mod.given("LSII1");
  modParamMap["LSII1"] = &modelPar_LSII1;
  AdmsSensFadType modelPar_NSII1=mod.NSII1;
  bool modelPar_given_NSII1=mod.given("NSII1");
  modParamMap["NSII1"] = &modelPar_NSII1;
  AdmsSensFadType modelPar_PSII1=mod.PSII1;
  bool modelPar_given_PSII1=mod.given("PSII1");
  modParamMap["PSII1"] = &modelPar_PSII1;
  AdmsSensFadType modelPar_LSII2=mod.LSII2;
  bool modelPar_given_LSII2=mod.given("LSII2");
  modParamMap["LSII2"] = &modelPar_LSII2;
  AdmsSensFadType modelPar_NSII2=mod.NSII2;
  bool modelPar_given_NSII2=mod.given("NSII2");
  modParamMap["NSII2"] = &modelPar_NSII2;
  AdmsSensFadType modelPar_PSII2=mod.PSII2;
  bool modelPar_given_PSII2=mod.given("PSII2");
  modParamMap["PSII2"] = &modelPar_PSII2;
  AdmsSensFadType modelPar_LSIID=mod.LSIID;
  bool modelPar_given_LSIID=mod.given("LSIID");
  modParamMap["LSIID"] = &modelPar_LSIID;
  AdmsSensFadType modelPar_NSIID=mod.NSIID;
  bool modelPar_given_NSIID=mod.given("NSIID");
  modParamMap["NSIID"] = &modelPar_NSIID;
  AdmsSensFadType modelPar_PSIID=mod.PSIID;
  bool modelPar_given_PSIID=mod.given("PSIID");
  modParamMap["PSIID"] = &modelPar_PSIID;
  AdmsSensFadType modelPar_LCFS=mod.LCFS;
  bool modelPar_given_LCFS=mod.given("LCFS");
  modParamMap["LCFS"] = &modelPar_LCFS;
  AdmsSensFadType modelPar_NCFS=mod.NCFS;
  bool modelPar_given_NCFS=mod.given("NCFS");
  modParamMap["NCFS"] = &modelPar_NCFS;
  AdmsSensFadType modelPar_PCFS=mod.PCFS;
  bool modelPar_given_PCFS=mod.given("PCFS");
  modParamMap["PCFS"] = &modelPar_PCFS;
  AdmsSensFadType modelPar_LCFD=mod.LCFD;
  bool modelPar_given_LCFD=mod.given("LCFD");
  modParamMap["LCFD"] = &modelPar_LCFD;
  AdmsSensFadType modelPar_NCFD=mod.NCFD;
  bool modelPar_given_NCFD=mod.given("NCFD");
  modParamMap["NCFD"] = &modelPar_NCFD;
  AdmsSensFadType modelPar_PCFD=mod.PCFD;
  bool modelPar_given_PCFD=mod.given("PCFD");
  modParamMap["PCFD"] = &modelPar_PCFD;
  AdmsSensFadType modelPar_LCOVS=mod.LCOVS;
  bool modelPar_given_LCOVS=mod.given("LCOVS");
  modParamMap["LCOVS"] = &modelPar_LCOVS;
  AdmsSensFadType modelPar_NCOVS=mod.NCOVS;
  bool modelPar_given_NCOVS=mod.given("NCOVS");
  modParamMap["NCOVS"] = &modelPar_NCOVS;
  AdmsSensFadType modelPar_PCOVS=mod.PCOVS;
  bool modelPar_given_PCOVS=mod.given("PCOVS");
  modParamMap["PCOVS"] = &modelPar_PCOVS;
  AdmsSensFadType modelPar_LCOVD=mod.LCOVD;
  bool modelPar_given_LCOVD=mod.given("LCOVD");
  modParamMap["LCOVD"] = &modelPar_LCOVD;
  AdmsSensFadType modelPar_NCOVD=mod.NCOVD;
  bool modelPar_given_NCOVD=mod.given("NCOVD");
  modParamMap["NCOVD"] = &modelPar_NCOVD;
  AdmsSensFadType modelPar_PCOVD=mod.PCOVD;
  bool modelPar_given_PCOVD=mod.given("PCOVD");
  modParamMap["PCOVD"] = &modelPar_PCOVD;
  AdmsSensFadType modelPar_LCGSL=mod.LCGSL;
  bool modelPar_given_LCGSL=mod.given("LCGSL");
  modParamMap["LCGSL"] = &modelPar_LCGSL;
  AdmsSensFadType modelPar_NCGSL=mod.NCGSL;
  bool modelPar_given_NCGSL=mod.given("NCGSL");
  modParamMap["NCGSL"] = &modelPar_NCGSL;
  AdmsSensFadType modelPar_PCGSL=mod.PCGSL;
  bool modelPar_given_PCGSL=mod.given("PCGSL");
  modParamMap["PCGSL"] = &modelPar_PCGSL;
  AdmsSensFadType modelPar_LCGDL=mod.LCGDL;
  bool modelPar_given_LCGDL=mod.given("LCGDL");
  modParamMap["LCGDL"] = &modelPar_LCGDL;
  AdmsSensFadType modelPar_NCGDL=mod.NCGDL;
  bool modelPar_given_NCGDL=mod.given("NCGDL");
  modParamMap["NCGDL"] = &modelPar_NCGDL;
  AdmsSensFadType modelPar_PCGDL=mod.PCGDL;
  bool modelPar_given_PCGDL=mod.given("PCGDL");
  modParamMap["PCGDL"] = &modelPar_PCGDL;
  AdmsSensFadType modelPar_LCKAPPAS=mod.LCKAPPAS;
  bool modelPar_given_LCKAPPAS=mod.given("LCKAPPAS");
  modParamMap["LCKAPPAS"] = &modelPar_LCKAPPAS;
  AdmsSensFadType modelPar_NCKAPPAS=mod.NCKAPPAS;
  bool modelPar_given_NCKAPPAS=mod.given("NCKAPPAS");
  modParamMap["NCKAPPAS"] = &modelPar_NCKAPPAS;
  AdmsSensFadType modelPar_PCKAPPAS=mod.PCKAPPAS;
  bool modelPar_given_PCKAPPAS=mod.given("PCKAPPAS");
  modParamMap["PCKAPPAS"] = &modelPar_PCKAPPAS;
  AdmsSensFadType modelPar_LCKAPPAD=mod.LCKAPPAD;
  bool modelPar_given_LCKAPPAD=mod.given("LCKAPPAD");
  modParamMap["LCKAPPAD"] = &modelPar_LCKAPPAD;
  AdmsSensFadType modelPar_NCKAPPAD=mod.NCKAPPAD;
  bool modelPar_given_NCKAPPAD=mod.given("NCKAPPAD");
  modParamMap["NCKAPPAD"] = &modelPar_NCKAPPAD;
  AdmsSensFadType modelPar_PCKAPPAD=mod.PCKAPPAD;
  bool modelPar_given_PCKAPPAD=mod.given("PCKAPPAD");
  modParamMap["PCKAPPAD"] = &modelPar_PCKAPPAD;
  AdmsSensFadType modelPar_LCGBL=mod.LCGBL;
  bool modelPar_given_LCGBL=mod.given("LCGBL");
  modParamMap["LCGBL"] = &modelPar_LCGBL;
  AdmsSensFadType modelPar_NCGBL=mod.NCGBL;
  bool modelPar_given_NCGBL=mod.given("NCGBL");
  modParamMap["NCGBL"] = &modelPar_NCGBL;
  AdmsSensFadType modelPar_PCGBL=mod.PCGBL;
  bool modelPar_given_PCGBL=mod.given("PCGBL");
  modParamMap["PCGBL"] = &modelPar_PCGBL;
  AdmsSensFadType modelPar_LCKAPPAB=mod.LCKAPPAB;
  bool modelPar_given_LCKAPPAB=mod.given("LCKAPPAB");
  modParamMap["LCKAPPAB"] = &modelPar_LCKAPPAB;
  AdmsSensFadType modelPar_NCKAPPAB=mod.NCKAPPAB;
  bool modelPar_given_NCKAPPAB=mod.given("NCKAPPAB");
  modParamMap["NCKAPPAB"] = &modelPar_NCKAPPAB;
  AdmsSensFadType modelPar_PCKAPPAB=mod.PCKAPPAB;
  bool modelPar_given_PCKAPPAB=mod.given("PCKAPPAB");
  modParamMap["PCKAPPAB"] = &modelPar_PCKAPPAB;
  AdmsSensFadType modelPar_LNTGEN=mod.LNTGEN;
  bool modelPar_given_LNTGEN=mod.given("LNTGEN");
  modParamMap["LNTGEN"] = &modelPar_LNTGEN;
  AdmsSensFadType modelPar_NNTGEN=mod.NNTGEN;
  bool modelPar_given_NNTGEN=mod.given("NNTGEN");
  modParamMap["NNTGEN"] = &modelPar_NNTGEN;
  AdmsSensFadType modelPar_PNTGEN=mod.PNTGEN;
  bool modelPar_given_PNTGEN=mod.given("PNTGEN");
  modParamMap["PNTGEN"] = &modelPar_PNTGEN;
  AdmsSensFadType modelPar_LAIGEN=mod.LAIGEN;
  bool modelPar_given_LAIGEN=mod.given("LAIGEN");
  modParamMap["LAIGEN"] = &modelPar_LAIGEN;
  AdmsSensFadType modelPar_NAIGEN=mod.NAIGEN;
  bool modelPar_given_NAIGEN=mod.given("NAIGEN");
  modParamMap["NAIGEN"] = &modelPar_NAIGEN;
  AdmsSensFadType modelPar_PAIGEN=mod.PAIGEN;
  bool modelPar_given_PAIGEN=mod.given("PAIGEN");
  modParamMap["PAIGEN"] = &modelPar_PAIGEN;
  AdmsSensFadType modelPar_LBIGEN=mod.LBIGEN;
  bool modelPar_given_LBIGEN=mod.given("LBIGEN");
  modParamMap["LBIGEN"] = &modelPar_LBIGEN;
  AdmsSensFadType modelPar_NBIGEN=mod.NBIGEN;
  bool modelPar_given_NBIGEN=mod.given("NBIGEN");
  modParamMap["NBIGEN"] = &modelPar_NBIGEN;
  AdmsSensFadType modelPar_PBIGEN=mod.PBIGEN;
  bool modelPar_given_PBIGEN=mod.given("PBIGEN");
  modParamMap["PBIGEN"] = &modelPar_PBIGEN;
  AdmsSensFadType modelPar_LXRCRG1=mod.LXRCRG1;
  bool modelPar_given_LXRCRG1=mod.given("LXRCRG1");
  modParamMap["LXRCRG1"] = &modelPar_LXRCRG1;
  AdmsSensFadType modelPar_NXRCRG1=mod.NXRCRG1;
  bool modelPar_given_NXRCRG1=mod.given("NXRCRG1");
  modParamMap["NXRCRG1"] = &modelPar_NXRCRG1;
  AdmsSensFadType modelPar_PXRCRG1=mod.PXRCRG1;
  bool modelPar_given_PXRCRG1=mod.given("PXRCRG1");
  modParamMap["PXRCRG1"] = &modelPar_PXRCRG1;
  AdmsSensFadType modelPar_LXRCRG2=mod.LXRCRG2;
  bool modelPar_given_LXRCRG2=mod.given("LXRCRG2");
  modParamMap["LXRCRG2"] = &modelPar_LXRCRG2;
  AdmsSensFadType modelPar_NXRCRG2=mod.NXRCRG2;
  bool modelPar_given_NXRCRG2=mod.given("NXRCRG2");
  modParamMap["NXRCRG2"] = &modelPar_NXRCRG2;
  AdmsSensFadType modelPar_PXRCRG2=mod.PXRCRG2;
  bool modelPar_given_PXRCRG2=mod.given("PXRCRG2");
  modParamMap["PXRCRG2"] = &modelPar_PXRCRG2;
  AdmsSensFadType modelPar_LUTE=mod.LUTE;
  bool modelPar_given_LUTE=mod.given("LUTE");
  modParamMap["LUTE"] = &modelPar_LUTE;
  AdmsSensFadType modelPar_NUTE=mod.NUTE;
  bool modelPar_given_NUTE=mod.given("NUTE");
  modParamMap["NUTE"] = &modelPar_NUTE;
  AdmsSensFadType modelPar_PUTE=mod.PUTE;
  bool modelPar_given_PUTE=mod.given("PUTE");
  modParamMap["PUTE"] = &modelPar_PUTE;
  AdmsSensFadType modelPar_LUTER=mod.LUTER;
  bool modelPar_given_LUTER=mod.given("LUTER");
  modParamMap["LUTER"] = &modelPar_LUTER;
  AdmsSensFadType modelPar_NUTER=mod.NUTER;
  bool modelPar_given_NUTER=mod.given("NUTER");
  modParamMap["NUTER"] = &modelPar_NUTER;
  AdmsSensFadType modelPar_PUTER=mod.PUTER;
  bool modelPar_given_PUTER=mod.given("PUTER");
  modParamMap["PUTER"] = &modelPar_PUTER;
  AdmsSensFadType modelPar_LUTL=mod.LUTL;
  bool modelPar_given_LUTL=mod.given("LUTL");
  modParamMap["LUTL"] = &modelPar_LUTL;
  AdmsSensFadType modelPar_NUTL=mod.NUTL;
  bool modelPar_given_NUTL=mod.given("NUTL");
  modParamMap["NUTL"] = &modelPar_NUTL;
  AdmsSensFadType modelPar_PUTL=mod.PUTL;
  bool modelPar_given_PUTL=mod.given("PUTL");
  modParamMap["PUTL"] = &modelPar_PUTL;
  AdmsSensFadType modelPar_LUTLR=mod.LUTLR;
  bool modelPar_given_LUTLR=mod.given("LUTLR");
  modParamMap["LUTLR"] = &modelPar_LUTLR;
  AdmsSensFadType modelPar_NUTLR=mod.NUTLR;
  bool modelPar_given_NUTLR=mod.given("NUTLR");
  modParamMap["NUTLR"] = &modelPar_NUTLR;
  AdmsSensFadType modelPar_PUTLR=mod.PUTLR;
  bool modelPar_given_PUTLR=mod.given("PUTLR");
  modParamMap["PUTLR"] = &modelPar_PUTLR;
  AdmsSensFadType modelPar_LEMOBT=mod.LEMOBT;
  bool modelPar_given_LEMOBT=mod.given("LEMOBT");
  modParamMap["LEMOBT"] = &modelPar_LEMOBT;
  AdmsSensFadType modelPar_NEMOBT=mod.NEMOBT;
  bool modelPar_given_NEMOBT=mod.given("NEMOBT");
  modParamMap["NEMOBT"] = &modelPar_NEMOBT;
  AdmsSensFadType modelPar_PEMOBT=mod.PEMOBT;
  bool modelPar_given_PEMOBT=mod.given("PEMOBT");
  modParamMap["PEMOBT"] = &modelPar_PEMOBT;
  AdmsSensFadType modelPar_LUA1=mod.LUA1;
  bool modelPar_given_LUA1=mod.given("LUA1");
  modParamMap["LUA1"] = &modelPar_LUA1;
  AdmsSensFadType modelPar_NUA1=mod.NUA1;
  bool modelPar_given_NUA1=mod.given("NUA1");
  modParamMap["NUA1"] = &modelPar_NUA1;
  AdmsSensFadType modelPar_PUA1=mod.PUA1;
  bool modelPar_given_PUA1=mod.given("PUA1");
  modParamMap["PUA1"] = &modelPar_PUA1;
  AdmsSensFadType modelPar_LUA1R=mod.LUA1R;
  bool modelPar_given_LUA1R=mod.given("LUA1R");
  modParamMap["LUA1R"] = &modelPar_LUA1R;
  AdmsSensFadType modelPar_NUA1R=mod.NUA1R;
  bool modelPar_given_NUA1R=mod.given("NUA1R");
  modParamMap["NUA1R"] = &modelPar_NUA1R;
  AdmsSensFadType modelPar_PUA1R=mod.PUA1R;
  bool modelPar_given_PUA1R=mod.given("PUA1R");
  modParamMap["PUA1R"] = &modelPar_PUA1R;
  AdmsSensFadType modelPar_LUC1=mod.LUC1;
  bool modelPar_given_LUC1=mod.given("LUC1");
  modParamMap["LUC1"] = &modelPar_LUC1;
  AdmsSensFadType modelPar_NUC1=mod.NUC1;
  bool modelPar_given_NUC1=mod.given("NUC1");
  modParamMap["NUC1"] = &modelPar_NUC1;
  AdmsSensFadType modelPar_PUC1=mod.PUC1;
  bool modelPar_given_PUC1=mod.given("PUC1");
  modParamMap["PUC1"] = &modelPar_PUC1;
  AdmsSensFadType modelPar_LUC1R=mod.LUC1R;
  bool modelPar_given_LUC1R=mod.given("LUC1R");
  modParamMap["LUC1R"] = &modelPar_LUC1R;
  AdmsSensFadType modelPar_NUC1R=mod.NUC1R;
  bool modelPar_given_NUC1R=mod.given("NUC1R");
  modParamMap["NUC1R"] = &modelPar_NUC1R;
  AdmsSensFadType modelPar_PUC1R=mod.PUC1R;
  bool modelPar_given_PUC1R=mod.given("PUC1R");
  modParamMap["PUC1R"] = &modelPar_PUC1R;
  AdmsSensFadType modelPar_LUD1=mod.LUD1;
  bool modelPar_given_LUD1=mod.given("LUD1");
  modParamMap["LUD1"] = &modelPar_LUD1;
  AdmsSensFadType modelPar_NUD1=mod.NUD1;
  bool modelPar_given_NUD1=mod.given("NUD1");
  modParamMap["NUD1"] = &modelPar_NUD1;
  AdmsSensFadType modelPar_PUD1=mod.PUD1;
  bool modelPar_given_PUD1=mod.given("PUD1");
  modParamMap["PUD1"] = &modelPar_PUD1;
  AdmsSensFadType modelPar_LUD1R=mod.LUD1R;
  bool modelPar_given_LUD1R=mod.given("LUD1R");
  modParamMap["LUD1R"] = &modelPar_LUD1R;
  AdmsSensFadType modelPar_NUD1R=mod.NUD1R;
  bool modelPar_given_NUD1R=mod.given("NUD1R");
  modParamMap["NUD1R"] = &modelPar_NUD1R;
  AdmsSensFadType modelPar_PUD1R=mod.PUD1R;
  bool modelPar_given_PUD1R=mod.given("PUD1R");
  modParamMap["PUD1R"] = &modelPar_PUD1R;
  AdmsSensFadType modelPar_LUCSTE=mod.LUCSTE;
  bool modelPar_given_LUCSTE=mod.given("LUCSTE");
  modParamMap["LUCSTE"] = &modelPar_LUCSTE;
  AdmsSensFadType modelPar_NUCSTE=mod.NUCSTE;
  bool modelPar_given_NUCSTE=mod.given("NUCSTE");
  modParamMap["NUCSTE"] = &modelPar_NUCSTE;
  AdmsSensFadType modelPar_PUCSTE=mod.PUCSTE;
  bool modelPar_given_PUCSTE=mod.given("PUCSTE");
  modParamMap["PUCSTE"] = &modelPar_PUCSTE;
  AdmsSensFadType modelPar_LPTWGT=mod.LPTWGT;
  bool modelPar_given_LPTWGT=mod.given("LPTWGT");
  modParamMap["LPTWGT"] = &modelPar_LPTWGT;
  AdmsSensFadType modelPar_NPTWGT=mod.NPTWGT;
  bool modelPar_given_NPTWGT=mod.given("NPTWGT");
  modParamMap["NPTWGT"] = &modelPar_NPTWGT;
  AdmsSensFadType modelPar_PPTWGT=mod.PPTWGT;
  bool modelPar_given_PPTWGT=mod.given("PPTWGT");
  modParamMap["PPTWGT"] = &modelPar_PPTWGT;
  AdmsSensFadType modelPar_LAT=mod.LAT;
  bool modelPar_given_LAT=mod.given("LAT");
  modParamMap["LAT"] = &modelPar_LAT;
  AdmsSensFadType modelPar_NAT=mod.NAT;
  bool modelPar_given_NAT=mod.given("NAT");
  modParamMap["NAT"] = &modelPar_NAT;
  AdmsSensFadType modelPar_PAT=mod.PAT;
  bool modelPar_given_PAT=mod.given("PAT");
  modParamMap["PAT"] = &modelPar_PAT;
  AdmsSensFadType modelPar_LATR=mod.LATR;
  bool modelPar_given_LATR=mod.given("LATR");
  modParamMap["LATR"] = &modelPar_LATR;
  AdmsSensFadType modelPar_NATR=mod.NATR;
  bool modelPar_given_NATR=mod.given("NATR");
  modParamMap["NATR"] = &modelPar_NATR;
  AdmsSensFadType modelPar_PATR=mod.PATR;
  bool modelPar_given_PATR=mod.given("PATR");
  modParamMap["PATR"] = &modelPar_PATR;
  AdmsSensFadType modelPar_LATCV=mod.LATCV;
  bool modelPar_given_LATCV=mod.given("LATCV");
  modParamMap["LATCV"] = &modelPar_LATCV;
  AdmsSensFadType modelPar_NATCV=mod.NATCV;
  bool modelPar_given_NATCV=mod.given("NATCV");
  modParamMap["NATCV"] = &modelPar_NATCV;
  AdmsSensFadType modelPar_PATCV=mod.PATCV;
  bool modelPar_given_PATCV=mod.given("PATCV");
  modParamMap["PATCV"] = &modelPar_PATCV;
  AdmsSensFadType modelPar_LSTTHETASAT=mod.LSTTHETASAT;
  bool modelPar_given_LSTTHETASAT=mod.given("LSTTHETASAT");
  modParamMap["LSTTHETASAT"] = &modelPar_LSTTHETASAT;
  AdmsSensFadType modelPar_NSTTHETASAT=mod.NSTTHETASAT;
  bool modelPar_given_NSTTHETASAT=mod.given("NSTTHETASAT");
  modParamMap["NSTTHETASAT"] = &modelPar_NSTTHETASAT;
  AdmsSensFadType modelPar_PSTTHETASAT=mod.PSTTHETASAT;
  bool modelPar_given_PSTTHETASAT=mod.given("PSTTHETASAT");
  modParamMap["PSTTHETASAT"] = &modelPar_PSTTHETASAT;
  AdmsSensFadType modelPar_LPRT=mod.LPRT;
  bool modelPar_given_LPRT=mod.given("LPRT");
  modParamMap["LPRT"] = &modelPar_LPRT;
  AdmsSensFadType modelPar_NPRT=mod.NPRT;
  bool modelPar_given_NPRT=mod.given("NPRT");
  modParamMap["NPRT"] = &modelPar_NPRT;
  AdmsSensFadType modelPar_PPRT=mod.PPRT;
  bool modelPar_given_PPRT=mod.given("PPRT");
  modParamMap["PPRT"] = &modelPar_PPRT;
  AdmsSensFadType modelPar_LKT1=mod.LKT1;
  bool modelPar_given_LKT1=mod.given("LKT1");
  modParamMap["LKT1"] = &modelPar_LKT1;
  AdmsSensFadType modelPar_NKT1=mod.NKT1;
  bool modelPar_given_NKT1=mod.given("NKT1");
  modParamMap["NKT1"] = &modelPar_NKT1;
  AdmsSensFadType modelPar_PKT1=mod.PKT1;
  bool modelPar_given_PKT1=mod.given("PKT1");
  modParamMap["PKT1"] = &modelPar_PKT1;
  AdmsSensFadType modelPar_LTSS=mod.LTSS;
  bool modelPar_given_LTSS=mod.given("LTSS");
  modParamMap["LTSS"] = &modelPar_LTSS;
  AdmsSensFadType modelPar_NTSS=mod.NTSS;
  bool modelPar_given_NTSS=mod.given("NTSS");
  modParamMap["NTSS"] = &modelPar_NTSS;
  AdmsSensFadType modelPar_PTSS=mod.PTSS;
  bool modelPar_given_PTSS=mod.given("PTSS");
  modParamMap["PTSS"] = &modelPar_PTSS;
  AdmsSensFadType modelPar_LIIT=mod.LIIT;
  bool modelPar_given_LIIT=mod.given("LIIT");
  modParamMap["LIIT"] = &modelPar_LIIT;
  AdmsSensFadType modelPar_NIIT=mod.NIIT;
  bool modelPar_given_NIIT=mod.given("NIIT");
  modParamMap["NIIT"] = &modelPar_NIIT;
  AdmsSensFadType modelPar_PIIT=mod.PIIT;
  bool modelPar_given_PIIT=mod.given("PIIT");
  modParamMap["PIIT"] = &modelPar_PIIT;
  AdmsSensFadType modelPar_LTII=mod.LTII;
  bool modelPar_given_LTII=mod.given("LTII");
  modParamMap["LTII"] = &modelPar_LTII;
  AdmsSensFadType modelPar_NTII=mod.NTII;
  bool modelPar_given_NTII=mod.given("NTII");
  modParamMap["NTII"] = &modelPar_NTII;
  AdmsSensFadType modelPar_PTII=mod.PTII;
  bool modelPar_given_PTII=mod.given("PTII");
  modParamMap["PTII"] = &modelPar_PTII;
  AdmsSensFadType modelPar_LTGIDL=mod.LTGIDL;
  bool modelPar_given_LTGIDL=mod.given("LTGIDL");
  modParamMap["LTGIDL"] = &modelPar_LTGIDL;
  AdmsSensFadType modelPar_NTGIDL=mod.NTGIDL;
  bool modelPar_given_NTGIDL=mod.given("NTGIDL");
  modParamMap["NTGIDL"] = &modelPar_NTGIDL;
  AdmsSensFadType modelPar_PTGIDL=mod.PTGIDL;
  bool modelPar_given_PTGIDL=mod.given("PTGIDL");
  modParamMap["PTGIDL"] = &modelPar_PTGIDL;
  AdmsSensFadType modelPar_LIGT=mod.LIGT;
  bool modelPar_given_LIGT=mod.given("LIGT");
  modParamMap["LIGT"] = &modelPar_LIGT;
  AdmsSensFadType modelPar_NIGT=mod.NIGT;
  bool modelPar_given_NIGT=mod.given("NIGT");
  modParamMap["NIGT"] = &modelPar_NIGT;
  AdmsSensFadType modelPar_PIGT=mod.PIGT;
  bool modelPar_given_PIGT=mod.given("PIGT");
  modParamMap["PIGT"] = &modelPar_PIGT;


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_NF=mod.NF;
  bool modelPar_given_NF=mod.given("NF");
  int modelPar_NGCON=mod.NGCON;
  bool modelPar_given_NGCON=mod.given("NGCON");
  int modelPar_DEVTYPE=mod.DEVTYPE;
  bool modelPar_given_DEVTYPE=mod.given("DEVTYPE");
  int modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");
  int modelPar_BULKMOD=mod.BULKMOD;
  bool modelPar_given_BULKMOD=mod.given("BULKMOD");
  int modelPar_GEOMOD=mod.GEOMOD;
  bool modelPar_given_GEOMOD=mod.given("GEOMOD");
  int modelPar_CGEO1SW=mod.CGEO1SW;
  bool modelPar_given_CGEO1SW=mod.given("CGEO1SW");
  int modelPar_RDSMOD=mod.RDSMOD;
  bool modelPar_given_RDSMOD=mod.given("RDSMOD");
  int modelPar_ASYMMOD=mod.ASYMMOD;
  bool modelPar_given_ASYMMOD=mod.given("ASYMMOD");
  int modelPar_IGCMOD=mod.IGCMOD;
  bool modelPar_given_IGCMOD=mod.given("IGCMOD");
  int modelPar_IGBMOD=mod.IGBMOD;
  bool modelPar_given_IGBMOD=mod.given("IGBMOD");
  int modelPar_GIDLMOD=mod.GIDLMOD;
  bool modelPar_given_GIDLMOD=mod.given("GIDLMOD");
  int modelPar_IIMOD=mod.IIMOD;
  bool modelPar_given_IIMOD=mod.given("IIMOD");
  int modelPar_TNOIMOD=mod.TNOIMOD;
  bool modelPar_given_TNOIMOD=mod.given("TNOIMOD");
  int modelPar_NQSMOD=mod.NQSMOD;
  bool modelPar_given_NQSMOD=mod.given("NQSMOD");
  int modelPar_SHMOD=mod.SHMOD;
  bool modelPar_given_SHMOD=mod.given("SHMOD");
  int modelPar_TEMPMOD=mod.TEMPMOD;
  bool modelPar_given_TEMPMOD=mod.given("TEMPMOD");
  int modelPar_RGATEMOD=mod.RGATEMOD;
  bool modelPar_given_RGATEMOD=mod.given("RGATEMOD");
  int modelPar_RGEOMOD=mod.RGEOMOD;
  bool modelPar_given_RGEOMOD=mod.given("RGEOMOD");
  int modelPar_CGEOMOD=mod.CGEOMOD;
  bool modelPar_given_CGEOMOD=mod.given("CGEOMOD");
  int modelPar_SH_WARN=mod.SH_WARN;
  bool modelPar_given_SH_WARN=mod.given("SH_WARN");
  int modelPar_IGCLAMP=mod.IGCLAMP;
  bool modelPar_given_IGCLAMP=mod.given("IGCLAMP");
  int modelPar_SDTERM=mod.SDTERM;
  bool modelPar_given_SDTERM=mod.given("SDTERM");
  int modelPar_NSEG=mod.NSEG;
  bool modelPar_given_NSEG=mod.given("NSEG");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check name for presence first!  Segfault on invalid.
  modParamMap[name]->diff(0,1);

  //make local copies of all model vars
  //reals


  // non-reals



  // Now loop over all instances and do the deed
  int inst=0;
  for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
  {

    Instance & in=*(*in_it);
    // initialize contributions to zero (automatically sets derivatives to zero)
    for (int i=0; i < 9+0 ; ++i)
    {
      staticContributions[i]=0;
      dynamicContributions[i]=0;
    }



    // Copy out all the instance parameters (doubles) into FAD types
    // reals
    AdmsSensFadType instancePar_L=in.L;
    bool instancePar_given_L=in.given("L");
    AdmsSensFadType instancePar_D=in.D;
    bool instancePar_given_D=in.given("D");
    AdmsSensFadType instancePar_TFIN=in.TFIN;
    bool instancePar_given_TFIN=in.given("TFIN");
    AdmsSensFadType instancePar_FPITCH=in.FPITCH;
    bool instancePar_given_FPITCH=in.given("FPITCH");
    AdmsSensFadType instancePar_NFIN=in.NFIN;
    bool instancePar_given_NFIN=in.given("NFIN");
    AdmsSensFadType instancePar_ASEO=in.ASEO;
    bool instancePar_given_ASEO=in.given("ASEO");
    AdmsSensFadType instancePar_ADEO=in.ADEO;
    bool instancePar_given_ADEO=in.given("ADEO");
    AdmsSensFadType instancePar_PSEO=in.PSEO;
    bool instancePar_given_PSEO=in.given("PSEO");
    AdmsSensFadType instancePar_PDEO=in.PDEO;
    bool instancePar_given_PDEO=in.given("PDEO");
    AdmsSensFadType instancePar_ASEJ=in.ASEJ;
    bool instancePar_given_ASEJ=in.given("ASEJ");
    AdmsSensFadType instancePar_ADEJ=in.ADEJ;
    bool instancePar_given_ADEJ=in.given("ADEJ");
    AdmsSensFadType instancePar_PSEJ=in.PSEJ;
    bool instancePar_given_PSEJ=in.given("PSEJ");
    AdmsSensFadType instancePar_PDEJ=in.PDEJ;
    bool instancePar_given_PDEJ=in.given("PDEJ");
    AdmsSensFadType instancePar_COVS=in.COVS;
    bool instancePar_given_COVS=in.given("COVS");
    AdmsSensFadType instancePar_COVD=in.COVD;
    bool instancePar_given_COVD=in.given("COVD");
    AdmsSensFadType instancePar_CGSP=in.CGSP;
    bool instancePar_given_CGSP=in.given("CGSP");
    AdmsSensFadType instancePar_CGDP=in.CGDP;
    bool instancePar_given_CGDP=in.given("CGDP");
    AdmsSensFadType instancePar_CDSP=in.CDSP;
    bool instancePar_given_CDSP=in.given("CDSP");
    AdmsSensFadType instancePar_NRS=in.NRS;
    bool instancePar_given_NRS=in.given("NRS");
    AdmsSensFadType instancePar_NRD=in.NRD;
    bool instancePar_given_NRD=in.given("NRD");
    AdmsSensFadType instancePar_LRSD=in.LRSD;
    bool instancePar_given_LRSD=in.given("LRSD");
    AdmsSensFadType instancePar_NFINNOM=in.NFINNOM;
    bool instancePar_given_NFINNOM=in.given("NFINNOM");
    AdmsSensFadType instancePar_m=in.m;
    bool instancePar_given_m=in.given("m");


    // real hidden instance


    // Copy all the non-real instance params into vars of their appropriate type:
    int instancePar_NF=in.NF;
    bool instancePar_given_NF=in.given("NF");
    int instancePar_NGCON=in.NGCON;
    bool instancePar_given_NGCON=in.given("NGCON");




    // If there are any instance parameters that were not given, and have
    // corresponding model params, copy the model param into the instance.
    // This was already done by the instance constructor, but we do it again
    // because now we're propagating derivatives, and the user could be trying
    // to get sensitivity to the model parameter.
    if (!(in.given("L")))
    {
      instancePar_L = modelPar_L;
    }
    if (!(in.given("D")))
    {
      instancePar_D = modelPar_D;
    }
    if (!(in.given("TFIN")))
    {
      instancePar_TFIN = modelPar_TFIN;
    }
    if (!(in.given("FPITCH")))
    {
      instancePar_FPITCH = modelPar_FPITCH;
    }
    if (!(in.given("NF")))
    {
      instancePar_NF = modelPar_NF;
    }
    if (!(in.given("NFIN")))
    {
      instancePar_NFIN = modelPar_NFIN;
    }
    if (!(in.given("NGCON")))
    {
      instancePar_NGCON = modelPar_NGCON;
    }
    if (!(in.given("ASEO")))
    {
      instancePar_ASEO = modelPar_ASEO;
    }
    if (!(in.given("ADEO")))
    {
      instancePar_ADEO = modelPar_ADEO;
    }
    if (!(in.given("PSEO")))
    {
      instancePar_PSEO = modelPar_PSEO;
    }
    if (!(in.given("PDEO")))
    {
      instancePar_PDEO = modelPar_PDEO;
    }
    if (!(in.given("ASEJ")))
    {
      instancePar_ASEJ = modelPar_ASEJ;
    }
    if (!(in.given("ADEJ")))
    {
      instancePar_ADEJ = modelPar_ADEJ;
    }
    if (!(in.given("PSEJ")))
    {
      instancePar_PSEJ = modelPar_PSEJ;
    }
    if (!(in.given("PDEJ")))
    {
      instancePar_PDEJ = modelPar_PDEJ;
    }
    if (!(in.given("COVS")))
    {
      instancePar_COVS = modelPar_COVS;
    }
    if (!(in.given("COVD")))
    {
      instancePar_COVD = modelPar_COVD;
    }
    if (!(in.given("CGSP")))
    {
      instancePar_CGSP = modelPar_CGSP;
    }
    if (!(in.given("CGDP")))
    {
      instancePar_CGDP = modelPar_CGDP;
    }
    if (!(in.given("CDSP")))
    {
      instancePar_CDSP = modelPar_CDSP;
    }
    if (!(in.given("NRS")))
    {
      instancePar_NRS = modelPar_NRS;
    }
    if (!(in.given("NRD")))
    {
      instancePar_NRD = modelPar_NRD;
    }
    if (!(in.given("LRSD")))
    {
      instancePar_LRSD = modelPar_LRSD;
    }


    //make local copies of all instance vars
    //reals
    AdmsSensFadType instanceVar_NFINtotal=in.NFINtotal;
    AdmsSensFadType instanceVar_ids=in.ids;
    AdmsSensFadType instanceVar_sigvds=in.sigvds;
    AdmsSensFadType instanceVar_qd=in.qd;
    AdmsSensFadType instanceVar_qg=in.qg;
    AdmsSensFadType instanceVar_qs=in.qs;
    AdmsSensFadType instanceVar_qb=in.qb;
    AdmsSensFadType instanceVar_epssub=in.epssub;
    AdmsSensFadType instanceVar_epsratio=in.epsratio;
    AdmsSensFadType instanceVar_Leff=in.Leff;
    AdmsSensFadType instanceVar_LeffCV=in.LeffCV;
    AdmsSensFadType instanceVar_LeffCV_acc=in.LeffCV_acc;
    AdmsSensFadType instanceVar_Weff0=in.Weff0;
    AdmsSensFadType instanceVar_WeffCV0=in.WeffCV0;
    AdmsSensFadType instanceVar_cox=in.cox;
    AdmsSensFadType instanceVar_nbody=in.nbody;
    AdmsSensFadType instanceVar_T0=in.T0;
    AdmsSensFadType instanceVar_T1=in.T1;
    AdmsSensFadType instanceVar_T2=in.T2;
    AdmsSensFadType instanceVar_T3=in.T3;
    AdmsSensFadType instanceVar_Tnom=in.Tnom;
    AdmsSensFadType instanceVar_PTWGR_t=in.PTWGR_t;
    AdmsSensFadType instanceVar_CJS_t=in.CJS_t;
    AdmsSensFadType instanceVar_CJSWS_t=in.CJSWS_t;
    AdmsSensFadType instanceVar_CJSWGD_t=in.CJSWGD_t;
    AdmsSensFadType instanceVar_CJD_t=in.CJD_t;
    AdmsSensFadType instanceVar_CJSWD_t=in.CJSWD_t;
    AdmsSensFadType instanceVar_CJSWGS_t=in.CJSWGS_t;
    AdmsSensFadType instanceVar_PBS_t=in.PBS_t;
    AdmsSensFadType instanceVar_PBSWS_t=in.PBSWS_t;
    AdmsSensFadType instanceVar_PBSWGS_t=in.PBSWGS_t;
    AdmsSensFadType instanceVar_PBD_t=in.PBD_t;
    AdmsSensFadType instanceVar_PBSWD_t=in.PBSWD_t;
    AdmsSensFadType instanceVar_PBSWGD_t=in.PBSWGD_t;
    AdmsSensFadType instanceVar_JSS_t=in.JSS_t;
    AdmsSensFadType instanceVar_JSWS_t=in.JSWS_t;
    AdmsSensFadType instanceVar_JSWGS_t=in.JSWGS_t;
    AdmsSensFadType instanceVar_JSD_t=in.JSD_t;
    AdmsSensFadType instanceVar_JSWD_t=in.JSWD_t;
    AdmsSensFadType instanceVar_JSWGD_t=in.JSWGD_t;
    AdmsSensFadType instanceVar_JTSS_t=in.JTSS_t;
    AdmsSensFadType instanceVar_JTSD_t=in.JTSD_t;
    AdmsSensFadType instanceVar_JTSSWS_t=in.JTSSWS_t;
    AdmsSensFadType instanceVar_JTSSWD_t=in.JTSSWD_t;
    AdmsSensFadType instanceVar_JTSSWGS_t=in.JTSSWGS_t;
    AdmsSensFadType instanceVar_JTSSWGD_t=in.JTSSWGD_t;
    AdmsSensFadType instanceVar_NJTS_t=in.NJTS_t;
    AdmsSensFadType instanceVar_NJTSD_t=in.NJTSD_t;
    AdmsSensFadType instanceVar_NJTSSW_t=in.NJTSSW_t;
    AdmsSensFadType instanceVar_NJTSSWD_t=in.NJTSSWD_t;
    AdmsSensFadType instanceVar_NJTSSWG_t=in.NJTSSWG_t;
    AdmsSensFadType instanceVar_NJTSSWGD_t=in.NJTSSWGD_t;
    AdmsSensFadType instanceVar_q0=in.q0;
    AdmsSensFadType instanceVar_T11=in.T11;
    AdmsSensFadType instanceVar_T12=in.T12;
    AdmsSensFadType instanceVar_e0=in.e0;
    AdmsSensFadType instanceVar_e1=in.e1;
    AdmsSensFadType instanceVar_e2=in.e2;
    AdmsSensFadType instanceVar_scl=in.scl;
    AdmsSensFadType instanceVar_tmp=in.tmp;
    AdmsSensFadType instanceVar_Theta_SCE=in.Theta_SCE;
    AdmsSensFadType instanceVar_Theta_SW=in.Theta_SW;
    AdmsSensFadType instanceVar_Theta_DIBL=in.Theta_DIBL;
    AdmsSensFadType instanceVar_Theta_RSCE=in.Theta_RSCE;
    AdmsSensFadType instanceVar_Theta_DITS=in.Theta_DITS;
    AdmsSensFadType instanceVar_veseff=in.veseff;
    AdmsSensFadType instanceVar_Tcen0=in.Tcen0;
    AdmsSensFadType instanceVar_Tcen=in.Tcen;
    AdmsSensFadType instanceVar_mx=in.mx;
    AdmsSensFadType instanceVar_mxprime=in.mxprime;
    AdmsSensFadType instanceVar_md=in.md;
    AdmsSensFadType instanceVar_mdprime=in.mdprime;
    AdmsSensFadType instanceVar_gprime=in.gprime;
    AdmsSensFadType instanceVar_gfactor=in.gfactor;
    AdmsSensFadType instanceVar_qis=in.qis;
    AdmsSensFadType instanceVar_qid=in.qid;
    AdmsSensFadType instanceVar_qbs=in.qbs;
    AdmsSensFadType instanceVar_qba=in.qba;
    AdmsSensFadType instanceVar_u0r=in.u0r;
    AdmsSensFadType instanceVar_UAR_t=in.UAR_t;
    AdmsSensFadType instanceVar_UC_t=in.UC_t;
    AdmsSensFadType instanceVar_UCR_t=in.UCR_t;
    AdmsSensFadType instanceVar_UDR_t=in.UDR_t;
    AdmsSensFadType instanceVar_U0R_t=in.U0R_t;
    AdmsSensFadType instanceVar_EeffFactor=in.EeffFactor;
    AdmsSensFadType instanceVar_Dr=in.Dr;
    AdmsSensFadType instanceVar_WeffWRFactor=in.WeffWRFactor;
    AdmsSensFadType instanceVar_RSourceGeo=in.RSourceGeo;
    AdmsSensFadType instanceVar_RDrainGeo=in.RDrainGeo;
    AdmsSensFadType instanceVar_RDSWMIN_i=in.RDSWMIN_i;
    AdmsSensFadType instanceVar_RDWMIN_i=in.RDWMIN_i;
    AdmsSensFadType instanceVar_RSWMIN_i=in.RSWMIN_i;
    AdmsSensFadType instanceVar_Rdrain=in.Rdrain;
    AdmsSensFadType instanceVar_Rsource=in.Rsource;
    AdmsSensFadType instanceVar_Rdsi=in.Rdsi;
    AdmsSensFadType instanceVar_RSDRR_t=in.RSDRR_t;
    AdmsSensFadType instanceVar_RDDRR_t=in.RDDRR_t;
    AdmsSensFadType instanceVar_VSAT1R_t=in.VSAT1R_t;
    AdmsSensFadType instanceVar_MEXPR_t=in.MEXPR_t;
    AdmsSensFadType instanceVar_VSAT_a=in.VSAT_a;
    AdmsSensFadType instanceVar_Cfr_geo=in.Cfr_geo;
    AdmsSensFadType instanceVar_ggeltd=in.ggeltd;
    AdmsSensFadType instanceVar_igbinv=in.igbinv;
    AdmsSensFadType instanceVar_igsd_mult0=in.igsd_mult0;
    AdmsSensFadType instanceVar_igbs=in.igbs;
    AdmsSensFadType instanceVar_igbd=in.igbd;
    AdmsSensFadType instanceVar_igbacc=in.igbacc;
    AdmsSensFadType instanceVar_igcs=in.igcs;
    AdmsSensFadType instanceVar_igcd=in.igcd;
    AdmsSensFadType instanceVar_igisl=in.igisl;
    AdmsSensFadType instanceVar_igidl=in.igidl;
    AdmsSensFadType instanceVar_igs=in.igs;
    AdmsSensFadType instanceVar_igd=in.igd;
    AdmsSensFadType instanceVar_Aechvb=in.Aechvb;
    AdmsSensFadType instanceVar_Bechvb=in.Bechvb;
    AdmsSensFadType instanceVar_Toxratio=in.Toxratio;
    AdmsSensFadType instanceVar_Iii=in.Iii;
    AdmsSensFadType instanceVar_cox_acc=in.cox_acc;
    AdmsSensFadType instanceVar_qg_acc=in.qg_acc;
    AdmsSensFadType instanceVar_qb_acc=in.qb_acc;
    AdmsSensFadType instanceVar_qgs_fr=in.qgs_fr;
    AdmsSensFadType instanceVar_qgd_fr=in.qgd_fr;
    AdmsSensFadType instanceVar_qds_fr=in.qds_fr;
    AdmsSensFadType instanceVar_qgs_parasitic=in.qgs_parasitic;
    AdmsSensFadType instanceVar_qgd_parasitic=in.qgd_parasitic;
    AdmsSensFadType instanceVar_Qes=in.Qes;
    AdmsSensFadType instanceVar_Qed=in.Qed;
    AdmsSensFadType instanceVar_Qeg=in.Qeg;
    AdmsSensFadType instanceVar_csbox=in.csbox;
    AdmsSensFadType instanceVar_cdbox=in.cdbox;
    AdmsSensFadType instanceVar_cgbox=in.cgbox;
    AdmsSensFadType instanceVar_Ies=in.Ies;
    AdmsSensFadType instanceVar_Ied=in.Ied;
    AdmsSensFadType instanceVar_Czbs=in.Czbs;
    AdmsSensFadType instanceVar_Czbssw=in.Czbssw;
    AdmsSensFadType instanceVar_Czbsswg=in.Czbsswg;
    AdmsSensFadType instanceVar_Czbd=in.Czbd;
    AdmsSensFadType instanceVar_Czbdsw=in.Czbdsw;
    AdmsSensFadType instanceVar_Czbdswg=in.Czbdswg;
    AdmsSensFadType instanceVar_Isbs=in.Isbs;
    AdmsSensFadType instanceVar_Isbd=in.Isbd;
    AdmsSensFadType instanceVar_Nvtms=in.Nvtms;
    AdmsSensFadType instanceVar_Nvtmd=in.Nvtmd;
    AdmsSensFadType instanceVar_SslpRev=in.SslpRev;
    AdmsSensFadType instanceVar_IVjsmRev=in.IVjsmRev;
    AdmsSensFadType instanceVar_VjsmRev=in.VjsmRev;
    AdmsSensFadType instanceVar_SslpFwd=in.SslpFwd;
    AdmsSensFadType instanceVar_IVjsmFwd=in.IVjsmFwd;
    AdmsSensFadType instanceVar_VjsmFwd=in.VjsmFwd;
    AdmsSensFadType instanceVar_XExpBVS=in.XExpBVS;
    AdmsSensFadType instanceVar_DslpRev=in.DslpRev;
    AdmsSensFadType instanceVar_IVjdmRev=in.IVjdmRev;
    AdmsSensFadType instanceVar_VjdmRev=in.VjdmRev;
    AdmsSensFadType instanceVar_DslpFwd=in.DslpFwd;
    AdmsSensFadType instanceVar_IVjdmFwd=in.IVjdmFwd;
    AdmsSensFadType instanceVar_VjdmFwd=in.VjdmFwd;
    AdmsSensFadType instanceVar_XExpBVD=in.XExpBVD;
    AdmsSensFadType instanceVar_idsgen=in.idsgen;
    AdmsSensFadType instanceVar_LINTIGEN_i=in.LINTIGEN_i;
    AdmsSensFadType instanceVar_LINTNOI_i=in.LINTNOI_i;
    AdmsSensFadType instanceVar_litl=in.litl;
    AdmsSensFadType instanceVar_FNPowerAt1Hz=in.FNPowerAt1Hz;
    AdmsSensFadType instanceVar_NTNOI_i=in.NTNOI_i;
    AdmsSensFadType instanceVar_Gtnoi=in.Gtnoi;
    AdmsSensFadType instanceVar_sid=in.sid;
    AdmsSensFadType instanceVar_gspr=in.gspr;
    AdmsSensFadType instanceVar_gdpr=in.gdpr;
    AdmsSensFadType instanceVar_gamma=in.gamma;
    AdmsSensFadType instanceVar_delta=in.delta;
    AdmsSensFadType instanceVar_ctnoi=in.ctnoi;
    AdmsSensFadType instanceVar_C0=in.C0;
    AdmsSensFadType instanceVar_sf=in.sf;
    AdmsSensFadType instanceVar_gth=in.gth;
    AdmsSensFadType instanceVar_cth=in.cth;
    AdmsSensFadType instanceVar_PHIG_i=in.PHIG_i;
    AdmsSensFadType instanceVar_CFD_i=in.CFD_i;
    AdmsSensFadType instanceVar_CFS_i=in.CFS_i;
    AdmsSensFadType instanceVar_COVS_i=in.COVS_i;
    AdmsSensFadType instanceVar_COVD_i=in.COVD_i;
    AdmsSensFadType instanceVar_CGSO_i=in.CGSO_i;
    AdmsSensFadType instanceVar_CGDO_i=in.CGDO_i;
    AdmsSensFadType instanceVar_CGSL_i=in.CGSL_i;
    AdmsSensFadType instanceVar_CGDL_i=in.CGDL_i;
    AdmsSensFadType instanceVar_CGBL_i=in.CGBL_i;
    AdmsSensFadType instanceVar_CKAPPAS_i=in.CKAPPAS_i;
    AdmsSensFadType instanceVar_CKAPPAD_i=in.CKAPPAD_i;
    AdmsSensFadType instanceVar_CKAPPAB_i=in.CKAPPAB_i;
    AdmsSensFadType instanceVar_QMFACTOR_i=in.QMFACTOR_i;
    AdmsSensFadType instanceVar_QMTCENCV_i=in.QMTCENCV_i;
    AdmsSensFadType instanceVar_QMTCENCVA_i=in.QMTCENCVA_i;
    AdmsSensFadType instanceVar_KSATIV_i=in.KSATIV_i;
    AdmsSensFadType instanceVar_KSATIVR_i=in.KSATIVR_i;
    AdmsSensFadType instanceVar_CDSC_i=in.CDSC_i;
    AdmsSensFadType instanceVar_CDSCD_i=in.CDSCD_i;
    AdmsSensFadType instanceVar_CDSCDR_i=in.CDSCDR_i;
    AdmsSensFadType instanceVar_CIT_i=in.CIT_i;
    AdmsSensFadType instanceVar_DVT0_i=in.DVT0_i;
    AdmsSensFadType instanceVar_CITR_i=in.CITR_i;
    AdmsSensFadType instanceVar_PHIN_i=in.PHIN_i;
    AdmsSensFadType instanceVar_ETA0_i=in.ETA0_i;
    AdmsSensFadType instanceVar_ETA0R_i=in.ETA0R_i;
    AdmsSensFadType instanceVar_VSAT_i=in.VSAT_i;
    AdmsSensFadType instanceVar_VSATR_i=in.VSATR_i;
    AdmsSensFadType instanceVar_VSATR_t=in.VSATR_t;
    AdmsSensFadType instanceVar_DVTP0_i=in.DVTP0_i;
    AdmsSensFadType instanceVar_DVTP1_i=in.DVTP1_i;
    AdmsSensFadType instanceVar_K0_i=in.K0_i;
    AdmsSensFadType instanceVar_K01_i=in.K01_i;
    AdmsSensFadType instanceVar_K0SI_i=in.K0SI_i;
    AdmsSensFadType instanceVar_K0SI1_i=in.K0SI1_i;
    AdmsSensFadType instanceVar_K2SI_i=in.K2SI_i;
    AdmsSensFadType instanceVar_K2SI1_i=in.K2SI1_i;
    AdmsSensFadType instanceVar_PHIBE_i=in.PHIBE_i;
    AdmsSensFadType instanceVar_K1_i=in.K1_i;
    AdmsSensFadType instanceVar_K11_i=in.K11_i;
    AdmsSensFadType instanceVar_K2SAT_i=in.K2SAT_i;
    AdmsSensFadType instanceVar_K2SAT1_i=in.K2SAT1_i;
    AdmsSensFadType instanceVar_DELTAVSAT_i=in.DELTAVSAT_i;
    AdmsSensFadType instanceVar_PSAT_i=in.PSAT_i;
    AdmsSensFadType instanceVar_DELTAVSATCV_i=in.DELTAVSATCV_i;
    AdmsSensFadType instanceVar_PSATCV_i=in.PSATCV_i;
    AdmsSensFadType instanceVar_VSAT1_i=in.VSAT1_i;
    AdmsSensFadType instanceVar_VSAT1R_i=in.VSAT1R_i;
    AdmsSensFadType instanceVar_PTWG_i=in.PTWG_i;
    AdmsSensFadType instanceVar_PTWGR_i=in.PTWGR_i;
    AdmsSensFadType instanceVar_VSATCV_i=in.VSATCV_i;
    AdmsSensFadType instanceVar_U0_i=in.U0_i;
    AdmsSensFadType instanceVar_U0R_i=in.U0R_i;
    AdmsSensFadType instanceVar_ETAMOB_i=in.ETAMOB_i;
    AdmsSensFadType instanceVar_RDSW_i=in.RDSW_i;
    AdmsSensFadType instanceVar_PRWGS_i=in.PRWGS_i;
    AdmsSensFadType instanceVar_PRWGD_i=in.PRWGD_i;
    AdmsSensFadType instanceVar_PDIBL1_i=in.PDIBL1_i;
    AdmsSensFadType instanceVar_PDIBL1R_i=in.PDIBL1R_i;
    AdmsSensFadType instanceVar_PDIBL2_i=in.PDIBL2_i;
    AdmsSensFadType instanceVar_PDIBL2R_i=in.PDIBL2R_i;
    AdmsSensFadType instanceVar_DROUT_i=in.DROUT_i;
    AdmsSensFadType instanceVar_PVAG_i=in.PVAG_i;
    AdmsSensFadType instanceVar_AIGBINV_i=in.AIGBINV_i;
    AdmsSensFadType instanceVar_AIGBINV1_i=in.AIGBINV1_i;
    AdmsSensFadType instanceVar_BIGBINV_i=in.BIGBINV_i;
    AdmsSensFadType instanceVar_CIGBINV_i=in.CIGBINV_i;
    AdmsSensFadType instanceVar_EIGBINV_i=in.EIGBINV_i;
    AdmsSensFadType instanceVar_NIGBINV_i=in.NIGBINV_i;
    AdmsSensFadType instanceVar_AIGBACC_i=in.AIGBACC_i;
    AdmsSensFadType instanceVar_AIGBACC1_i=in.AIGBACC1_i;
    AdmsSensFadType instanceVar_BIGBACC_i=in.BIGBACC_i;
    AdmsSensFadType instanceVar_CIGBACC_i=in.CIGBACC_i;
    AdmsSensFadType instanceVar_NIGBACC_i=in.NIGBACC_i;
    AdmsSensFadType instanceVar_AIGC_i=in.AIGC_i;
    AdmsSensFadType instanceVar_AIGC1_i=in.AIGC1_i;
    AdmsSensFadType instanceVar_BIGC_i=in.BIGC_i;
    AdmsSensFadType instanceVar_CIGC_i=in.CIGC_i;
    AdmsSensFadType instanceVar_PIGCD_i=in.PIGCD_i;
    AdmsSensFadType instanceVar_AIGS_i=in.AIGS_i;
    AdmsSensFadType instanceVar_AIGS1_i=in.AIGS1_i;
    AdmsSensFadType instanceVar_BIGS_i=in.BIGS_i;
    AdmsSensFadType instanceVar_CIGS_i=in.CIGS_i;
    AdmsSensFadType instanceVar_POXEDGE_i=in.POXEDGE_i;
    AdmsSensFadType instanceVar_AIGD_i=in.AIGD_i;
    AdmsSensFadType instanceVar_AIGD1_i=in.AIGD1_i;
    AdmsSensFadType instanceVar_BIGD_i=in.BIGD_i;
    AdmsSensFadType instanceVar_CIGD_i=in.CIGD_i;
    AdmsSensFadType instanceVar_AGIDL_i=in.AGIDL_i;
    AdmsSensFadType instanceVar_BGIDL_i=in.BGIDL_i;
    AdmsSensFadType instanceVar_CGIDL_i=in.CGIDL_i;
    AdmsSensFadType instanceVar_EGIDL_i=in.EGIDL_i;
    AdmsSensFadType instanceVar_PGIDL_i=in.PGIDL_i;
    AdmsSensFadType instanceVar_AGISL_i=in.AGISL_i;
    AdmsSensFadType instanceVar_BGISL_i=in.BGISL_i;
    AdmsSensFadType instanceVar_CGISL_i=in.CGISL_i;
    AdmsSensFadType instanceVar_EGISL_i=in.EGISL_i;
    AdmsSensFadType instanceVar_PGISL_i=in.PGISL_i;
    AdmsSensFadType instanceVar_ALPHA0_i=in.ALPHA0_i;
    AdmsSensFadType instanceVar_ALPHA1_i=in.ALPHA1_i;
    AdmsSensFadType instanceVar_ALPHAII0_i=in.ALPHAII0_i;
    AdmsSensFadType instanceVar_ALPHAII1_i=in.ALPHAII1_i;
    AdmsSensFadType instanceVar_BETA0_i=in.BETA0_i;
    AdmsSensFadType instanceVar_BETAII0_i=in.BETAII0_i;
    AdmsSensFadType instanceVar_BETAII1_i=in.BETAII1_i;
    AdmsSensFadType instanceVar_BETAII2_i=in.BETAII2_i;
    AdmsSensFadType instanceVar_ESATII_i=in.ESATII_i;
    AdmsSensFadType instanceVar_LII_i=in.LII_i;
    AdmsSensFadType instanceVar_SII0_i=in.SII0_i;
    AdmsSensFadType instanceVar_SII1_i=in.SII1_i;
    AdmsSensFadType instanceVar_SII2_i=in.SII2_i;
    AdmsSensFadType instanceVar_SIID_i=in.SIID_i;
    AdmsSensFadType instanceVar_TII_i=in.TII_i;
    AdmsSensFadType instanceVar_MEXP_i=in.MEXP_i;
    AdmsSensFadType instanceVar_MEXPR_i=in.MEXPR_i;
    AdmsSensFadType instanceVar_PCLM_i=in.PCLM_i;
    AdmsSensFadType instanceVar_PCLMG_i=in.PCLMG_i;
    AdmsSensFadType instanceVar_PCLMCV_i=in.PCLMCV_i;
    AdmsSensFadType instanceVar_PCLMR_i=in.PCLMR_i;
    AdmsSensFadType instanceVar_A1_i=in.A1_i;
    AdmsSensFadType instanceVar_A2_i=in.A2_i;
    AdmsSensFadType instanceVar_A11_i=in.A11_i;
    AdmsSensFadType instanceVar_A21_i=in.A21_i;
    AdmsSensFadType instanceVar_K1RSCE_i=in.K1RSCE_i;
    AdmsSensFadType instanceVar_DVTSHIFT_i=in.DVTSHIFT_i;
    AdmsSensFadType instanceVar_DVTSHIFTR_i=in.DVTSHIFTR_i;
    AdmsSensFadType instanceVar_UA_i=in.UA_i;
    AdmsSensFadType instanceVar_UC_i=in.UC_i;
    AdmsSensFadType instanceVar_EU_i=in.EU_i;
    AdmsSensFadType instanceVar_UD_i=in.UD_i;
    AdmsSensFadType instanceVar_UCS_i=in.UCS_i;
    AdmsSensFadType instanceVar_UAR_i=in.UAR_i;
    AdmsSensFadType instanceVar_EUR_i=in.EUR_i;
    AdmsSensFadType instanceVar_UCR_i=in.UCR_i;
    AdmsSensFadType instanceVar_UDR_i=in.UDR_i;
    AdmsSensFadType instanceVar_UA1_i=in.UA1_i;
    AdmsSensFadType instanceVar_UA1R_i=in.UA1R_i;
    AdmsSensFadType instanceVar_UC1_i=in.UC1_i;
    AdmsSensFadType instanceVar_UD1_i=in.UD1_i;
    AdmsSensFadType instanceVar_UCSTE_i=in.UCSTE_i;
    AdmsSensFadType instanceVar_UTE_i=in.UTE_i;
    AdmsSensFadType instanceVar_UTL_i=in.UTL_i;
    AdmsSensFadType instanceVar_EMOBT_i=in.EMOBT_i;
    AdmsSensFadType instanceVar_UC1R_i=in.UC1R_i;
    AdmsSensFadType instanceVar_UD1R_i=in.UD1R_i;
    AdmsSensFadType instanceVar_UTER_i=in.UTER_i;
    AdmsSensFadType instanceVar_UTLR_i=in.UTLR_i;
    AdmsSensFadType instanceVar_PTWGT_i=in.PTWGT_i;
    AdmsSensFadType instanceVar_AT_i=in.AT_i;
    AdmsSensFadType instanceVar_ATCV_i=in.ATCV_i;
    AdmsSensFadType instanceVar_ATR_i=in.ATR_i;
    AdmsSensFadType instanceVar_RDW_i=in.RDW_i;
    AdmsSensFadType instanceVar_RSW_i=in.RSW_i;
    AdmsSensFadType instanceVar_PRT_i=in.PRT_i;
    AdmsSensFadType instanceVar_KT1_i=in.KT1_i;
    AdmsSensFadType instanceVar_TSS_i=in.TSS_i;
    AdmsSensFadType instanceVar_IIT_i=in.IIT_i;
    AdmsSensFadType instanceVar_IGT_i=in.IGT_i;
    AdmsSensFadType instanceVar_TGIDL_i=in.TGIDL_i;
    AdmsSensFadType instanceVar_NTGEN_i=in.NTGEN_i;
    AdmsSensFadType instanceVar_AIGEN_i=in.AIGEN_i;
    AdmsSensFadType instanceVar_BIGEN_i=in.BIGEN_i;
    AdmsSensFadType instanceVar_K0SISAT_i=in.K0SISAT_i;
    AdmsSensFadType instanceVar_K0SISAT1_i=in.K0SISAT1_i;
    AdmsSensFadType instanceVar_K2SISAT_i=in.K2SISAT_i;
    AdmsSensFadType instanceVar_K2SISAT1_i=in.K2SISAT1_i;
    AdmsSensFadType instanceVar_K2_i=in.K2_i;
    AdmsSensFadType instanceVar_K21_i=in.K21_i;
    AdmsSensFadType instanceVar_Cins=in.Cins;
    AdmsSensFadType instanceVar_Ach=in.Ach;
    AdmsSensFadType instanceVar_Weff_UFCM=in.Weff_UFCM;
    AdmsSensFadType instanceVar_qdep=in.qdep;
    AdmsSensFadType instanceVar_rc=in.rc;
    AdmsSensFadType instanceVar_vth_fixed_factor_Sub=in.vth_fixed_factor_Sub;
    AdmsSensFadType instanceVar_vth_fixed_factor_SI=in.vth_fixed_factor_SI;
    AdmsSensFadType instanceVar_qm=in.qm;
    AdmsSensFadType instanceVar_Qdep_ov_Cins=in.Qdep_ov_Cins;
    AdmsSensFadType instanceVar_qi_acc_for_QM=in.qi_acc_for_QM;
    AdmsSensFadType instanceVar_fieldnormalizationfactor=in.fieldnormalizationfactor;
    AdmsSensFadType instanceVar_auxQMfact=in.auxQMfact;
    AdmsSensFadType instanceVar_QMFACTORCVfinal=in.QMFACTORCVfinal;
    AdmsSensFadType instanceVar_psipclamp=in.psipclamp;
    AdmsSensFadType instanceVar_sqrtpsip=in.sqrtpsip;
    AdmsSensFadType instanceVar_nq=in.nq;
    AdmsSensFadType instanceVar_F0=in.F0;

  
    //non-reals
    int instanceVar_devsign=in.devsign;

  
  
    Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

    // extract solution variables and set as Fad independent variables.
    probeVars[in.admsProbeID_V_N_GND] = (in.collapseNode_N)?(0):((*solVectorPtr)[in.li_N]);
    probeVars[in.admsProbeID_V_g_ge] = (*solVectorPtr)[in.li_g] - (*solVectorPtr)[in.li_ge];
    probeVars[in.admsProbeID_V_s_si] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_si];
    probeVars[in.admsProbeID_V_d_di] = (*solVectorPtr)[in.li_d] - (*solVectorPtr)[in.li_di];
    probeVars[in.admsProbeID_V_e_ge] = (*solVectorPtr)[in.li_e] - (*solVectorPtr)[in.li_ge];
    probeVars[in.admsProbeID_V_ge_d] = (*solVectorPtr)[in.li_ge] - (*solVectorPtr)[in.li_d];
    probeVars[in.admsProbeID_V_ge_s] = (*solVectorPtr)[in.li_ge] - (*solVectorPtr)[in.li_s];
    probeVars[in.admsProbeID_V_di_d] = (*solVectorPtr)[in.li_di] - (*solVectorPtr)[in.li_d];
    probeVars[in.admsProbeID_V_si_s] = (*solVectorPtr)[in.li_si] - (*solVectorPtr)[in.li_s];
    probeVars[in.admsProbeID_V_e_s] = (*solVectorPtr)[in.li_e] - (*solVectorPtr)[in.li_s];
    probeVars[in.admsProbeID_V_d_s] = (*solVectorPtr)[in.li_d] - (*solVectorPtr)[in.li_s];
    probeVars[in.admsProbeID_V_g_s] = (*solVectorPtr)[in.li_g] - (*solVectorPtr)[in.li_s];
    probeVars[in.admsProbeID_V_ge_e] = (*solVectorPtr)[in.li_ge] - (*solVectorPtr)[in.li_e];
    probeVars[in.admsProbeID_V_e_di] = (*solVectorPtr)[in.li_e] - (*solVectorPtr)[in.li_di];
    probeVars[in.admsProbeID_V_e_si] = (*solVectorPtr)[in.li_e] - (*solVectorPtr)[in.li_si];
    probeVars[in.admsProbeID_V_ge_di] = (*solVectorPtr)[in.li_ge] - (*solVectorPtr)[in.li_di];
    probeVars[in.admsProbeID_V_di_si] = (*solVectorPtr)[in.li_di] - (*solVectorPtr)[in.li_si];
    probeVars[in.admsProbeID_V_ge_si] = (*solVectorPtr)[in.li_ge] - (*solVectorPtr)[in.li_si];
    probeVars[in.admsProbeID_Temp_t_GND] = (*solVectorPtr)[in.li_t];


    evaluateInitialInstance(
       // instance parameters
       // reals
       instancePar_L,
       instancePar_given_L,
       instancePar_D,
       instancePar_given_D,
       instancePar_TFIN,
       instancePar_given_TFIN,
       instancePar_FPITCH,
       instancePar_given_FPITCH,
       instancePar_NFIN,
       instancePar_given_NFIN,
       instancePar_ASEO,
       instancePar_given_ASEO,
       instancePar_ADEO,
       instancePar_given_ADEO,
       instancePar_PSEO,
       instancePar_given_PSEO,
       instancePar_PDEO,
       instancePar_given_PDEO,
       instancePar_ASEJ,
       instancePar_given_ASEJ,
       instancePar_ADEJ,
       instancePar_given_ADEJ,
       instancePar_PSEJ,
       instancePar_given_PSEJ,
       instancePar_PDEJ,
       instancePar_given_PDEJ,
       instancePar_COVS,
       instancePar_given_COVS,
       instancePar_COVD,
       instancePar_given_COVD,
       instancePar_CGSP,
       instancePar_given_CGSP,
       instancePar_CGDP,
       instancePar_given_CGDP,
       instancePar_CDSP,
       instancePar_given_CDSP,
       instancePar_NRS,
       instancePar_given_NRS,
       instancePar_NRD,
       instancePar_given_NRD,
       instancePar_LRSD,
       instancePar_given_LRSD,
       instancePar_NFINNOM,
       instancePar_given_NFINNOM,
       instancePar_m,
       instancePar_given_m,
       // non-reals(including hidden)
       instancePar_NF,
       instancePar_given_NF,
       instancePar_NGCON,
       instancePar_given_NGCON,
       // instance variables
       // reals
       instanceVar_NFINtotal,
       instanceVar_ids,
       instanceVar_sigvds,
       instanceVar_qd,
       instanceVar_qg,
       instanceVar_qs,
       instanceVar_qb,
       instanceVar_epssub,
       instanceVar_epsratio,
       instanceVar_Leff,
       instanceVar_LeffCV,
       instanceVar_LeffCV_acc,
       instanceVar_Weff0,
       instanceVar_WeffCV0,
       instanceVar_cox,
       instanceVar_nbody,
       instanceVar_T0,
       instanceVar_T1,
       instanceVar_T2,
       instanceVar_T3,
       instanceVar_Tnom,
       instanceVar_PTWGR_t,
       instanceVar_CJS_t,
       instanceVar_CJSWS_t,
       instanceVar_CJSWGD_t,
       instanceVar_CJD_t,
       instanceVar_CJSWD_t,
       instanceVar_CJSWGS_t,
       instanceVar_PBS_t,
       instanceVar_PBSWS_t,
       instanceVar_PBSWGS_t,
       instanceVar_PBD_t,
       instanceVar_PBSWD_t,
       instanceVar_PBSWGD_t,
       instanceVar_JSS_t,
       instanceVar_JSWS_t,
       instanceVar_JSWGS_t,
       instanceVar_JSD_t,
       instanceVar_JSWD_t,
       instanceVar_JSWGD_t,
       instanceVar_JTSS_t,
       instanceVar_JTSD_t,
       instanceVar_JTSSWS_t,
       instanceVar_JTSSWD_t,
       instanceVar_JTSSWGS_t,
       instanceVar_JTSSWGD_t,
       instanceVar_NJTS_t,
       instanceVar_NJTSD_t,
       instanceVar_NJTSSW_t,
       instanceVar_NJTSSWD_t,
       instanceVar_NJTSSWG_t,
       instanceVar_NJTSSWGD_t,
       instanceVar_q0,
       instanceVar_T11,
       instanceVar_T12,
       instanceVar_e0,
       instanceVar_e1,
       instanceVar_e2,
       instanceVar_scl,
       instanceVar_tmp,
       instanceVar_Theta_SCE,
       instanceVar_Theta_SW,
       instanceVar_Theta_DIBL,
       instanceVar_Theta_RSCE,
       instanceVar_Theta_DITS,
       instanceVar_veseff,
       instanceVar_Tcen0,
       instanceVar_Tcen,
       instanceVar_mx,
       instanceVar_mxprime,
       instanceVar_md,
       instanceVar_mdprime,
       instanceVar_gprime,
       instanceVar_gfactor,
       instanceVar_qis,
       instanceVar_qid,
       instanceVar_qbs,
       instanceVar_qba,
       instanceVar_u0r,
       instanceVar_UAR_t,
       instanceVar_UC_t,
       instanceVar_UCR_t,
       instanceVar_UDR_t,
       instanceVar_U0R_t,
       instanceVar_EeffFactor,
       instanceVar_Dr,
       instanceVar_WeffWRFactor,
       instanceVar_RSourceGeo,
       instanceVar_RDrainGeo,
       instanceVar_RDSWMIN_i,
       instanceVar_RDWMIN_i,
       instanceVar_RSWMIN_i,
       instanceVar_Rdrain,
       instanceVar_Rsource,
       instanceVar_Rdsi,
       instanceVar_RSDRR_t,
       instanceVar_RDDRR_t,
       instanceVar_VSAT1R_t,
       instanceVar_MEXPR_t,
       instanceVar_VSAT_a,
       instanceVar_Cfr_geo,
       instanceVar_ggeltd,
       instanceVar_igbinv,
       instanceVar_igsd_mult0,
       instanceVar_igbs,
       instanceVar_igbd,
       instanceVar_igbacc,
       instanceVar_igcs,
       instanceVar_igcd,
       instanceVar_igisl,
       instanceVar_igidl,
       instanceVar_igs,
       instanceVar_igd,
       instanceVar_Aechvb,
       instanceVar_Bechvb,
       instanceVar_Toxratio,
       instanceVar_Iii,
       instanceVar_cox_acc,
       instanceVar_qg_acc,
       instanceVar_qb_acc,
       instanceVar_qgs_fr,
       instanceVar_qgd_fr,
       instanceVar_qds_fr,
       instanceVar_qgs_parasitic,
       instanceVar_qgd_parasitic,
       instanceVar_Qes,
       instanceVar_Qed,
       instanceVar_Qeg,
       instanceVar_csbox,
       instanceVar_cdbox,
       instanceVar_cgbox,
       instanceVar_Ies,
       instanceVar_Ied,
       instanceVar_Czbs,
       instanceVar_Czbssw,
       instanceVar_Czbsswg,
       instanceVar_Czbd,
       instanceVar_Czbdsw,
       instanceVar_Czbdswg,
       instanceVar_Isbs,
       instanceVar_Isbd,
       instanceVar_Nvtms,
       instanceVar_Nvtmd,
       instanceVar_SslpRev,
       instanceVar_IVjsmRev,
       instanceVar_VjsmRev,
       instanceVar_SslpFwd,
       instanceVar_IVjsmFwd,
       instanceVar_VjsmFwd,
       instanceVar_XExpBVS,
       instanceVar_DslpRev,
       instanceVar_IVjdmRev,
       instanceVar_VjdmRev,
       instanceVar_DslpFwd,
       instanceVar_IVjdmFwd,
       instanceVar_VjdmFwd,
       instanceVar_XExpBVD,
       instanceVar_idsgen,
       instanceVar_LINTIGEN_i,
       instanceVar_LINTNOI_i,
       instanceVar_litl,
       instanceVar_FNPowerAt1Hz,
       instanceVar_NTNOI_i,
       instanceVar_Gtnoi,
       instanceVar_sid,
       instanceVar_gspr,
       instanceVar_gdpr,
       instanceVar_gamma,
       instanceVar_delta,
       instanceVar_ctnoi,
       instanceVar_C0,
       instanceVar_sf,
       instanceVar_gth,
       instanceVar_cth,
       instanceVar_PHIG_i,
       instanceVar_CFD_i,
       instanceVar_CFS_i,
       instanceVar_COVS_i,
       instanceVar_COVD_i,
       instanceVar_CGSO_i,
       instanceVar_CGDO_i,
       instanceVar_CGSL_i,
       instanceVar_CGDL_i,
       instanceVar_CGBL_i,
       instanceVar_CKAPPAS_i,
       instanceVar_CKAPPAD_i,
       instanceVar_CKAPPAB_i,
       instanceVar_QMFACTOR_i,
       instanceVar_QMTCENCV_i,
       instanceVar_QMTCENCVA_i,
       instanceVar_KSATIV_i,
       instanceVar_KSATIVR_i,
       instanceVar_CDSC_i,
       instanceVar_CDSCD_i,
       instanceVar_CDSCDR_i,
       instanceVar_CIT_i,
       instanceVar_DVT0_i,
       instanceVar_CITR_i,
       instanceVar_PHIN_i,
       instanceVar_ETA0_i,
       instanceVar_ETA0R_i,
       instanceVar_VSAT_i,
       instanceVar_VSATR_i,
       instanceVar_VSATR_t,
       instanceVar_DVTP0_i,
       instanceVar_DVTP1_i,
       instanceVar_K0_i,
       instanceVar_K01_i,
       instanceVar_K0SI_i,
       instanceVar_K0SI1_i,
       instanceVar_K2SI_i,
       instanceVar_K2SI1_i,
       instanceVar_PHIBE_i,
       instanceVar_K1_i,
       instanceVar_K11_i,
       instanceVar_K2SAT_i,
       instanceVar_K2SAT1_i,
       instanceVar_DELTAVSAT_i,
       instanceVar_PSAT_i,
       instanceVar_DELTAVSATCV_i,
       instanceVar_PSATCV_i,
       instanceVar_VSAT1_i,
       instanceVar_VSAT1R_i,
       instanceVar_PTWG_i,
       instanceVar_PTWGR_i,
       instanceVar_VSATCV_i,
       instanceVar_U0_i,
       instanceVar_U0R_i,
       instanceVar_ETAMOB_i,
       instanceVar_RDSW_i,
       instanceVar_PRWGS_i,
       instanceVar_PRWGD_i,
       instanceVar_PDIBL1_i,
       instanceVar_PDIBL1R_i,
       instanceVar_PDIBL2_i,
       instanceVar_PDIBL2R_i,
       instanceVar_DROUT_i,
       instanceVar_PVAG_i,
       instanceVar_AIGBINV_i,
       instanceVar_AIGBINV1_i,
       instanceVar_BIGBINV_i,
       instanceVar_CIGBINV_i,
       instanceVar_EIGBINV_i,
       instanceVar_NIGBINV_i,
       instanceVar_AIGBACC_i,
       instanceVar_AIGBACC1_i,
       instanceVar_BIGBACC_i,
       instanceVar_CIGBACC_i,
       instanceVar_NIGBACC_i,
       instanceVar_AIGC_i,
       instanceVar_AIGC1_i,
       instanceVar_BIGC_i,
       instanceVar_CIGC_i,
       instanceVar_PIGCD_i,
       instanceVar_AIGS_i,
       instanceVar_AIGS1_i,
       instanceVar_BIGS_i,
       instanceVar_CIGS_i,
       instanceVar_POXEDGE_i,
       instanceVar_AIGD_i,
       instanceVar_AIGD1_i,
       instanceVar_BIGD_i,
       instanceVar_CIGD_i,
       instanceVar_AGIDL_i,
       instanceVar_BGIDL_i,
       instanceVar_CGIDL_i,
       instanceVar_EGIDL_i,
       instanceVar_PGIDL_i,
       instanceVar_AGISL_i,
       instanceVar_BGISL_i,
       instanceVar_CGISL_i,
       instanceVar_EGISL_i,
       instanceVar_PGISL_i,
       instanceVar_ALPHA0_i,
       instanceVar_ALPHA1_i,
       instanceVar_ALPHAII0_i,
       instanceVar_ALPHAII1_i,
       instanceVar_BETA0_i,
       instanceVar_BETAII0_i,
       instanceVar_BETAII1_i,
       instanceVar_BETAII2_i,
       instanceVar_ESATII_i,
       instanceVar_LII_i,
       instanceVar_SII0_i,
       instanceVar_SII1_i,
       instanceVar_SII2_i,
       instanceVar_SIID_i,
       instanceVar_TII_i,
       instanceVar_MEXP_i,
       instanceVar_MEXPR_i,
       instanceVar_PCLM_i,
       instanceVar_PCLMG_i,
       instanceVar_PCLMCV_i,
       instanceVar_PCLMR_i,
       instanceVar_A1_i,
       instanceVar_A2_i,
       instanceVar_A11_i,
       instanceVar_A21_i,
       instanceVar_K1RSCE_i,
       instanceVar_DVTSHIFT_i,
       instanceVar_DVTSHIFTR_i,
       instanceVar_UA_i,
       instanceVar_UC_i,
       instanceVar_EU_i,
       instanceVar_UD_i,
       instanceVar_UCS_i,
       instanceVar_UAR_i,
       instanceVar_EUR_i,
       instanceVar_UCR_i,
       instanceVar_UDR_i,
       instanceVar_UA1_i,
       instanceVar_UA1R_i,
       instanceVar_UC1_i,
       instanceVar_UD1_i,
       instanceVar_UCSTE_i,
       instanceVar_UTE_i,
       instanceVar_UTL_i,
       instanceVar_EMOBT_i,
       instanceVar_UC1R_i,
       instanceVar_UD1R_i,
       instanceVar_UTER_i,
       instanceVar_UTLR_i,
       instanceVar_PTWGT_i,
       instanceVar_AT_i,
       instanceVar_ATCV_i,
       instanceVar_ATR_i,
       instanceVar_RDW_i,
       instanceVar_RSW_i,
       instanceVar_PRT_i,
       instanceVar_KT1_i,
       instanceVar_TSS_i,
       instanceVar_IIT_i,
       instanceVar_IGT_i,
       instanceVar_TGIDL_i,
       instanceVar_NTGEN_i,
       instanceVar_AIGEN_i,
       instanceVar_BIGEN_i,
       instanceVar_K0SISAT_i,
       instanceVar_K0SISAT1_i,
       instanceVar_K2SISAT_i,
       instanceVar_K2SISAT1_i,
       instanceVar_K2_i,
       instanceVar_K21_i,
       instanceVar_Cins,
       instanceVar_Ach,
       instanceVar_Weff_UFCM,
       instanceVar_qdep,
       instanceVar_rc,
       instanceVar_vth_fixed_factor_Sub,
       instanceVar_vth_fixed_factor_SI,
       instanceVar_qm,
       instanceVar_Qdep_ov_Cins,
       instanceVar_qi_acc_for_QM,
       instanceVar_fieldnormalizationfactor,
       instanceVar_auxQMfact,
       instanceVar_QMFACTORCVfinal,
       instanceVar_psipclamp,
       instanceVar_sqrtpsip,
       instanceVar_nq,
       instanceVar_F0,
       // non-reals
       instanceVar_devsign,
       // model parameters
       // reals
       modelPar_L,
       modelPar_given_L,
       modelPar_D,
       modelPar_given_D,
       modelPar_TFIN,
       modelPar_given_TFIN,
       modelPar_FPITCH,
       modelPar_given_FPITCH,
       modelPar_NFIN,
       modelPar_given_NFIN,
       modelPar_ASEO,
       modelPar_given_ASEO,
       modelPar_ADEO,
       modelPar_given_ADEO,
       modelPar_PSEO,
       modelPar_given_PSEO,
       modelPar_PDEO,
       modelPar_given_PDEO,
       modelPar_ASEJ,
       modelPar_given_ASEJ,
       modelPar_ADEJ,
       modelPar_given_ADEJ,
       modelPar_PSEJ,
       modelPar_given_PSEJ,
       modelPar_PDEJ,
       modelPar_given_PDEJ,
       modelPar_COVS,
       modelPar_given_COVS,
       modelPar_COVD,
       modelPar_given_COVD,
       modelPar_CGSP,
       modelPar_given_CGSP,
       modelPar_CGDP,
       modelPar_given_CGDP,
       modelPar_CDSP,
       modelPar_given_CDSP,
       modelPar_NRS,
       modelPar_given_NRS,
       modelPar_NRD,
       modelPar_given_NRD,
       modelPar_LRSD,
       modelPar_given_LRSD,
       modelPar_XL,
       modelPar_given_XL,
       modelPar_DTEMP,
       modelPar_given_DTEMP,
       modelPar_DELVTRAND,
       modelPar_given_DELVTRAND,
       modelPar_U0MULT,
       modelPar_given_U0MULT,
       modelPar_IDS0MULT,
       modelPar_given_IDS0MULT,
       modelPar_LINT,
       modelPar_given_LINT,
       modelPar_LL,
       modelPar_given_LL,
       modelPar_LLN,
       modelPar_given_LLN,
       modelPar_DLC,
       modelPar_given_DLC,
       modelPar_DLCACC,
       modelPar_given_DLCACC,
       modelPar_DLBIN,
       modelPar_given_DLBIN,
       modelPar_LLC,
       modelPar_given_LLC,
       modelPar_EOT,
       modelPar_given_EOT,
       modelPar_TOXP,
       modelPar_given_TOXP,
       modelPar_EOTBOX,
       modelPar_given_EOTBOX,
       modelPar_HFIN,
       modelPar_given_HFIN,
       modelPar_FECH,
       modelPar_given_FECH,
       modelPar_DELTAW,
       modelPar_given_DELTAW,
       modelPar_FECHCV,
       modelPar_given_FECHCV,
       modelPar_DELTAWCV,
       modelPar_given_DELTAWCV,
       modelPar_NBODY,
       modelPar_given_NBODY,
       modelPar_NBODYN1,
       modelPar_given_NBODYN1,
       modelPar_NBODYN2,
       modelPar_given_NBODYN2,
       modelPar_NSD,
       modelPar_given_NSD,
       modelPar_PHIG,
       modelPar_given_PHIG,
       modelPar_PHIGL,
       modelPar_given_PHIGL,
       modelPar_PHIGLT,
       modelPar_given_PHIGLT,
       modelPar_PHIGN1,
       modelPar_given_PHIGN1,
       modelPar_PHIGN2,
       modelPar_given_PHIGN2,
       modelPar_EPSROX,
       modelPar_given_EPSROX,
       modelPar_EPSRSUB,
       modelPar_given_EPSRSUB,
       modelPar_EASUB,
       modelPar_given_EASUB,
       modelPar_NI0SUB,
       modelPar_given_NI0SUB,
       modelPar_BG0SUB,
       modelPar_given_BG0SUB,
       modelPar_NC0SUB,
       modelPar_given_NC0SUB,
       modelPar_NGATE,
       modelPar_given_NGATE,
       modelPar_Imin,
       modelPar_given_Imin,
       modelPar_CIT,
       modelPar_given_CIT,
       modelPar_CITR,
       modelPar_given_CITR,
       modelPar_CDSC,
       modelPar_given_CDSC,
       modelPar_CDSCN1,
       modelPar_given_CDSCN1,
       modelPar_CDSCN2,
       modelPar_given_CDSCN2,
       modelPar_CDSCD,
       modelPar_given_CDSCD,
       modelPar_CDSCDN1,
       modelPar_given_CDSCDN1,
       modelPar_CDSCDN2,
       modelPar_given_CDSCDN2,
       modelPar_CDSCDR,
       modelPar_given_CDSCDR,
       modelPar_CDSCDRN1,
       modelPar_given_CDSCDRN1,
       modelPar_CDSCDRN2,
       modelPar_given_CDSCDRN2,
       modelPar_DVT0,
       modelPar_given_DVT0,
       modelPar_DVT1,
       modelPar_given_DVT1,
       modelPar_DVT1SS,
       modelPar_given_DVT1SS,
       modelPar_PHIN,
       modelPar_given_PHIN,
       modelPar_ETA0,
       modelPar_given_ETA0,
       modelPar_ETA0N1,
       modelPar_given_ETA0N1,
       modelPar_ETA0N2,
       modelPar_given_ETA0N2,
       modelPar_ETA0LT,
       modelPar_given_ETA0LT,
       modelPar_TETA0,
       modelPar_given_TETA0,
       modelPar_ETA0R,
       modelPar_given_ETA0R,
       modelPar_TETA0R,
       modelPar_given_TETA0R,
       modelPar_DSUB,
       modelPar_given_DSUB,
       modelPar_DVTP0,
       modelPar_given_DVTP0,
       modelPar_DVTP1,
       modelPar_given_DVTP1,
       modelPar_ADVTP0,
       modelPar_given_ADVTP0,
       modelPar_BDVTP0,
       modelPar_given_BDVTP0,
       modelPar_ADVTP1,
       modelPar_given_ADVTP1,
       modelPar_BDVTP1,
       modelPar_given_BDVTP1,
       modelPar_DVTP2,
       modelPar_given_DVTP2,
       modelPar_K1RSCE,
       modelPar_given_K1RSCE,
       modelPar_LPE0,
       modelPar_given_LPE0,
       modelPar_DVTSHIFT,
       modelPar_given_DVTSHIFT,
       modelPar_DVTSHIFTR,
       modelPar_given_DVTSHIFTR,
       modelPar_THETASCE,
       modelPar_given_THETASCE,
       modelPar_THETADIBL,
       modelPar_given_THETADIBL,
       modelPar_THETASW,
       modelPar_given_THETASW,
       modelPar_NVTM,
       modelPar_given_NVTM,
       modelPar_K0,
       modelPar_given_K0,
       modelPar_K01,
       modelPar_given_K01,
       modelPar_K0SI,
       modelPar_given_K0SI,
       modelPar_K0SI1,
       modelPar_given_K0SI1,
       modelPar_K2SI,
       modelPar_given_K2SI,
       modelPar_K2SI1,
       modelPar_given_K2SI1,
       modelPar_K0SISAT,
       modelPar_given_K0SISAT,
       modelPar_K0SISAT1,
       modelPar_given_K0SISAT1,
       modelPar_K2SISAT,
       modelPar_given_K2SISAT,
       modelPar_K2SISAT1,
       modelPar_given_K2SISAT1,
       modelPar_PHIBE,
       modelPar_given_PHIBE,
       modelPar_K1,
       modelPar_given_K1,
       modelPar_K11,
       modelPar_given_K11,
       modelPar_K2SAT,
       modelPar_given_K2SAT,
       modelPar_K2SAT1,
       modelPar_given_K2SAT1,
       modelPar_K2,
       modelPar_given_K2,
       modelPar_K21,
       modelPar_given_K21,
       modelPar_QMFACTOR,
       modelPar_given_QMFACTOR,
       modelPar_QMTCENCV,
       modelPar_given_QMTCENCV,
       modelPar_QMTCENCVA,
       modelPar_given_QMTCENCVA,
       modelPar_AQMTCEN,
       modelPar_given_AQMTCEN,
       modelPar_BQMTCEN,
       modelPar_given_BQMTCEN,
       modelPar_ETAQM,
       modelPar_given_ETAQM,
       modelPar_QM0,
       modelPar_given_QM0,
       modelPar_PQM,
       modelPar_given_PQM,
       modelPar_QM0ACC,
       modelPar_given_QM0ACC,
       modelPar_PQMACC,
       modelPar_given_PQMACC,
       modelPar_VSAT,
       modelPar_given_VSAT,
       modelPar_VSATR,
       modelPar_given_VSATR,
       modelPar_VSATN1,
       modelPar_given_VSATN1,
       modelPar_VSATN2,
       modelPar_given_VSATN2,
       modelPar_VSATRN1,
       modelPar_given_VSATRN1,
       modelPar_VSATRN2,
       modelPar_given_VSATRN2,
       modelPar_AVSAT,
       modelPar_given_AVSAT,
       modelPar_BVSAT,
       modelPar_given_BVSAT,
       modelPar_VSAT1,
       modelPar_given_VSAT1,
       modelPar_VSAT1N1,
       modelPar_given_VSAT1N1,
       modelPar_VSAT1N2,
       modelPar_given_VSAT1N2,
       modelPar_VSAT1R,
       modelPar_given_VSAT1R,
       modelPar_VSAT1RN1,
       modelPar_given_VSAT1RN1,
       modelPar_VSAT1RN2,
       modelPar_given_VSAT1RN2,
       modelPar_AVSAT1,
       modelPar_given_AVSAT1,
       modelPar_BVSAT1,
       modelPar_given_BVSAT1,
       modelPar_DELTAVSAT,
       modelPar_given_DELTAVSAT,
       modelPar_PSAT,
       modelPar_given_PSAT,
       modelPar_APSAT,
       modelPar_given_APSAT,
       modelPar_BPSAT,
       modelPar_given_BPSAT,
       modelPar_KSATIV,
       modelPar_given_KSATIV,
       modelPar_KSATIVR,
       modelPar_given_KSATIVR,
       modelPar_VSATCV,
       modelPar_given_VSATCV,
       modelPar_AVSATCV,
       modelPar_given_AVSATCV,
       modelPar_BVSATCV,
       modelPar_given_BVSATCV,
       modelPar_DELTAVSATCV,
       modelPar_given_DELTAVSATCV,
       modelPar_PSATCV,
       modelPar_given_PSATCV,
       modelPar_APSATCV,
       modelPar_given_APSATCV,
       modelPar_BPSATCV,
       modelPar_given_BPSATCV,
       modelPar_MEXP,
       modelPar_given_MEXP,
       modelPar_AMEXP,
       modelPar_given_AMEXP,
       modelPar_BMEXP,
       modelPar_given_BMEXP,
       modelPar_MEXPR,
       modelPar_given_MEXPR,
       modelPar_AMEXPR,
       modelPar_given_AMEXPR,
       modelPar_BMEXPR,
       modelPar_given_BMEXPR,
       modelPar_PTWG,
       modelPar_given_PTWG,
       modelPar_PTWGR,
       modelPar_given_PTWGR,
       modelPar_APTWG,
       modelPar_given_APTWG,
       modelPar_BPTWG,
       modelPar_given_BPTWG,
       modelPar_AT,
       modelPar_given_AT,
       modelPar_ATR,
       modelPar_given_ATR,
       modelPar_ATCV,
       modelPar_given_ATCV,
       modelPar_TMEXP,
       modelPar_given_TMEXP,
       modelPar_TMEXPR,
       modelPar_given_TMEXPR,
       modelPar_PTWGT,
       modelPar_given_PTWGT,
       modelPar_U0,
       modelPar_given_U0,
       modelPar_U0R,
       modelPar_given_U0R,
       modelPar_U0N1,
       modelPar_given_U0N1,
       modelPar_U0N1R,
       modelPar_given_U0N1R,
       modelPar_U0N2,
       modelPar_given_U0N2,
       modelPar_U0N2R,
       modelPar_given_U0N2R,
       modelPar_U0LT,
       modelPar_given_U0LT,
       modelPar_ETAMOB,
       modelPar_given_ETAMOB,
       modelPar_UP,
       modelPar_given_UP,
       modelPar_LPA,
       modelPar_given_LPA,
       modelPar_UPR,
       modelPar_given_UPR,
       modelPar_LPAR,
       modelPar_given_LPAR,
       modelPar_UA,
       modelPar_given_UA,
       modelPar_UAR,
       modelPar_given_UAR,
       modelPar_AUA,
       modelPar_given_AUA,
       modelPar_AUAR,
       modelPar_given_AUAR,
       modelPar_BUA,
       modelPar_given_BUA,
       modelPar_BUAR,
       modelPar_given_BUAR,
       modelPar_UC,
       modelPar_given_UC,
       modelPar_UCR,
       modelPar_given_UCR,
       modelPar_EU,
       modelPar_given_EU,
       modelPar_EUR,
       modelPar_given_EUR,
       modelPar_AEU,
       modelPar_given_AEU,
       modelPar_AEUR,
       modelPar_given_AEUR,
       modelPar_BEU,
       modelPar_given_BEU,
       modelPar_BEUR,
       modelPar_given_BEUR,
       modelPar_UD,
       modelPar_given_UD,
       modelPar_UDR,
       modelPar_given_UDR,
       modelPar_AUD,
       modelPar_given_AUD,
       modelPar_AUDR,
       modelPar_given_AUDR,
       modelPar_BUD,
       modelPar_given_BUD,
       modelPar_BUDR,
       modelPar_given_BUDR,
       modelPar_UCS,
       modelPar_given_UCS,
       modelPar_UTE,
       modelPar_given_UTE,
       modelPar_UTER,
       modelPar_given_UTER,
       modelPar_UTL,
       modelPar_given_UTL,
       modelPar_UTLR,
       modelPar_given_UTLR,
       modelPar_EMOBT,
       modelPar_given_EMOBT,
       modelPar_UA1,
       modelPar_given_UA1,
       modelPar_UA1R,
       modelPar_given_UA1R,
       modelPar_UC1,
       modelPar_given_UC1,
       modelPar_UC1R,
       modelPar_given_UC1R,
       modelPar_UD1,
       modelPar_given_UD1,
       modelPar_UD1R,
       modelPar_given_UD1R,
       modelPar_UCSTE,
       modelPar_given_UCSTE,
       modelPar_CHARGEWF,
       modelPar_given_CHARGEWF,
       modelPar_RDSWMIN,
       modelPar_given_RDSWMIN,
       modelPar_RDSW,
       modelPar_given_RDSW,
       modelPar_ARDSW,
       modelPar_given_ARDSW,
       modelPar_BRDSW,
       modelPar_given_BRDSW,
       modelPar_RSWMIN,
       modelPar_given_RSWMIN,
       modelPar_RSW,
       modelPar_given_RSW,
       modelPar_ARSW,
       modelPar_given_ARSW,
       modelPar_BRSW,
       modelPar_given_BRSW,
       modelPar_RDWMIN,
       modelPar_given_RDWMIN,
       modelPar_RDW,
       modelPar_given_RDW,
       modelPar_ARDW,
       modelPar_given_ARDW,
       modelPar_BRDW,
       modelPar_given_BRDW,
       modelPar_RSDR,
       modelPar_given_RSDR,
       modelPar_RSDRR,
       modelPar_given_RSDRR,
       modelPar_RDDR,
       modelPar_given_RDDR,
       modelPar_RDDRR,
       modelPar_given_RDDRR,
       modelPar_PRSDR,
       modelPar_given_PRSDR,
       modelPar_PRDDR,
       modelPar_given_PRDDR,
       modelPar_PRWGS,
       modelPar_given_PRWGS,
       modelPar_PRWGD,
       modelPar_given_PRWGD,
       modelPar_WR,
       modelPar_given_WR,
       modelPar_PRT,
       modelPar_given_PRT,
       modelPar_TRSDR,
       modelPar_given_TRSDR,
       modelPar_TRDDR,
       modelPar_given_TRDDR,
       modelPar_PDIBL1,
       modelPar_given_PDIBL1,
       modelPar_PDIBL1R,
       modelPar_given_PDIBL1R,
       modelPar_PDIBL2,
       modelPar_given_PDIBL2,
       modelPar_PDIBL2R,
       modelPar_given_PDIBL2R,
       modelPar_DROUT,
       modelPar_given_DROUT,
       modelPar_PVAG,
       modelPar_given_PVAG,
       modelPar_PCLM,
       modelPar_given_PCLM,
       modelPar_PCLMR,
       modelPar_given_PCLMR,
       modelPar_APCLM,
       modelPar_given_APCLM,
       modelPar_APCLMR,
       modelPar_given_APCLMR,
       modelPar_BPCLM,
       modelPar_given_BPCLM,
       modelPar_BPCLMR,
       modelPar_given_BPCLMR,
       modelPar_PCLMG,
       modelPar_given_PCLMG,
       modelPar_PCLMCV,
       modelPar_given_PCLMCV,
       modelPar_A1,
       modelPar_given_A1,
       modelPar_A11,
       modelPar_given_A11,
       modelPar_A2,
       modelPar_given_A2,
       modelPar_A21,
       modelPar_given_A21,
       modelPar_RGEXT,
       modelPar_given_RGEXT,
       modelPar_RGFIN,
       modelPar_given_RGFIN,
       modelPar_RSHS,
       modelPar_given_RSHS,
       modelPar_RSHD,
       modelPar_given_RSHD,
       modelPar_HEPI,
       modelPar_given_HEPI,
       modelPar_TSILI,
       modelPar_given_TSILI,
       modelPar_RHOC,
       modelPar_given_RHOC,
       modelPar_RHORSD,
       modelPar_given_RHORSD,
       modelPar_CRATIO,
       modelPar_given_CRATIO,
       modelPar_DELTAPRSD,
       modelPar_given_DELTAPRSD,
       modelPar_LSP,
       modelPar_given_LSP,
       modelPar_EPSRSP,
       modelPar_given_EPSRSP,
       modelPar_TGATE,
       modelPar_given_TGATE,
       modelPar_TMASK,
       modelPar_given_TMASK,
       modelPar_ASILIEND,
       modelPar_given_ASILIEND,
       modelPar_ARSDEND,
       modelPar_given_ARSDEND,
       modelPar_PRSDEND,
       modelPar_given_PRSDEND,
       modelPar_NSDE,
       modelPar_given_NSDE,
       modelPar_RGEOA,
       modelPar_given_RGEOA,
       modelPar_RGEOB,
       modelPar_given_RGEOB,
       modelPar_RGEOC,
       modelPar_given_RGEOC,
       modelPar_RGEOD,
       modelPar_given_RGEOD,
       modelPar_RGEOE,
       modelPar_given_RGEOE,
       modelPar_CGEOA,
       modelPar_given_CGEOA,
       modelPar_CGEOB,
       modelPar_given_CGEOB,
       modelPar_CGEOC,
       modelPar_given_CGEOC,
       modelPar_CGEOD,
       modelPar_given_CGEOD,
       modelPar_CGEOE,
       modelPar_given_CGEOE,
       modelPar_AIGBINV,
       modelPar_given_AIGBINV,
       modelPar_AIGBINV1,
       modelPar_given_AIGBINV1,
       modelPar_BIGBINV,
       modelPar_given_BIGBINV,
       modelPar_CIGBINV,
       modelPar_given_CIGBINV,
       modelPar_EIGBINV,
       modelPar_given_EIGBINV,
       modelPar_NIGBINV,
       modelPar_given_NIGBINV,
       modelPar_AIGBACC,
       modelPar_given_AIGBACC,
       modelPar_AIGBACC1,
       modelPar_given_AIGBACC1,
       modelPar_BIGBACC,
       modelPar_given_BIGBACC,
       modelPar_CIGBACC,
       modelPar_given_CIGBACC,
       modelPar_NIGBACC,
       modelPar_given_NIGBACC,
       modelPar_AIGC,
       modelPar_given_AIGC,
       modelPar_AIGC1,
       modelPar_given_AIGC1,
       modelPar_BIGC,
       modelPar_given_BIGC,
       modelPar_CIGC,
       modelPar_given_CIGC,
       modelPar_PIGCD,
       modelPar_given_PIGCD,
       modelPar_DLCIGS,
       modelPar_given_DLCIGS,
       modelPar_AIGS,
       modelPar_given_AIGS,
       modelPar_AIGS1,
       modelPar_given_AIGS1,
       modelPar_BIGS,
       modelPar_given_BIGS,
       modelPar_CIGS,
       modelPar_given_CIGS,
       modelPar_DLCIGD,
       modelPar_given_DLCIGD,
       modelPar_AIGD,
       modelPar_given_AIGD,
       modelPar_AIGD1,
       modelPar_given_AIGD1,
       modelPar_BIGD,
       modelPar_given_BIGD,
       modelPar_CIGD,
       modelPar_given_CIGD,
       modelPar_VFBSD,
       modelPar_given_VFBSD,
       modelPar_VFBSDCV,
       modelPar_given_VFBSDCV,
       modelPar_TOXREF,
       modelPar_given_TOXREF,
       modelPar_TOXG,
       modelPar_given_TOXG,
       modelPar_NTOX,
       modelPar_given_NTOX,
       modelPar_POXEDGE,
       modelPar_given_POXEDGE,
       modelPar_AGISL,
       modelPar_given_AGISL,
       modelPar_BGISL,
       modelPar_given_BGISL,
       modelPar_CGISL,
       modelPar_given_CGISL,
       modelPar_EGISL,
       modelPar_given_EGISL,
       modelPar_PGISL,
       modelPar_given_PGISL,
       modelPar_AGIDL,
       modelPar_given_AGIDL,
       modelPar_BGIDL,
       modelPar_given_BGIDL,
       modelPar_CGIDL,
       modelPar_given_CGIDL,
       modelPar_EGIDL,
       modelPar_given_EGIDL,
       modelPar_PGIDL,
       modelPar_given_PGIDL,
       modelPar_ALPHA0,
       modelPar_given_ALPHA0,
       modelPar_ALPHA01,
       modelPar_given_ALPHA01,
       modelPar_ALPHA1,
       modelPar_given_ALPHA1,
       modelPar_ALPHA11,
       modelPar_given_ALPHA11,
       modelPar_BETA0,
       modelPar_given_BETA0,
       modelPar_ALPHAII0,
       modelPar_given_ALPHAII0,
       modelPar_ALPHAII01,
       modelPar_given_ALPHAII01,
       modelPar_ALPHAII1,
       modelPar_given_ALPHAII1,
       modelPar_ALPHAII11,
       modelPar_given_ALPHAII11,
       modelPar_BETAII0,
       modelPar_given_BETAII0,
       modelPar_BETAII1,
       modelPar_given_BETAII1,
       modelPar_BETAII2,
       modelPar_given_BETAII2,
       modelPar_ESATII,
       modelPar_given_ESATII,
       modelPar_LII,
       modelPar_given_LII,
       modelPar_SII0,
       modelPar_given_SII0,
       modelPar_SII1,
       modelPar_given_SII1,
       modelPar_SII2,
       modelPar_given_SII2,
       modelPar_SIID,
       modelPar_given_SIID,
       modelPar_IIMOD2CLAMP1,
       modelPar_given_IIMOD2CLAMP1,
       modelPar_IIMOD2CLAMP2,
       modelPar_given_IIMOD2CLAMP2,
       modelPar_IIMOD2CLAMP3,
       modelPar_given_IIMOD2CLAMP3,
       modelPar_EOTACC,
       modelPar_given_EOTACC,
       modelPar_DELVFBACC,
       modelPar_given_DELVFBACC,
       modelPar_CFS,
       modelPar_given_CFS,
       modelPar_CFD,
       modelPar_given_CFD,
       modelPar_CGSO,
       modelPar_given_CGSO,
       modelPar_CGDO,
       modelPar_given_CGDO,
       modelPar_CGSL,
       modelPar_given_CGSL,
       modelPar_CGDL,
       modelPar_given_CGDL,
       modelPar_CKAPPAS,
       modelPar_given_CKAPPAS,
       modelPar_CKAPPAD,
       modelPar_given_CKAPPAD,
       modelPar_CGBO,
       modelPar_given_CGBO,
       modelPar_CGBN,
       modelPar_given_CGBN,
       modelPar_CGBL,
       modelPar_given_CGBL,
       modelPar_CKAPPAB,
       modelPar_given_CKAPPAB,
       modelPar_CSDESW,
       modelPar_given_CSDESW,
       modelPar_CJS,
       modelPar_given_CJS,
       modelPar_CJD,
       modelPar_given_CJD,
       modelPar_CJSWS,
       modelPar_given_CJSWS,
       modelPar_CJSWD,
       modelPar_given_CJSWD,
       modelPar_CJSWGS,
       modelPar_given_CJSWGS,
       modelPar_CJSWGD,
       modelPar_given_CJSWGD,
       modelPar_PBS,
       modelPar_given_PBS,
       modelPar_PBD,
       modelPar_given_PBD,
       modelPar_PBSWS,
       modelPar_given_PBSWS,
       modelPar_PBSWD,
       modelPar_given_PBSWD,
       modelPar_PBSWGS,
       modelPar_given_PBSWGS,
       modelPar_PBSWGD,
       modelPar_given_PBSWGD,
       modelPar_MJS,
       modelPar_given_MJS,
       modelPar_MJD,
       modelPar_given_MJD,
       modelPar_MJSWS,
       modelPar_given_MJSWS,
       modelPar_MJSWD,
       modelPar_given_MJSWD,
       modelPar_MJSWGS,
       modelPar_given_MJSWGS,
       modelPar_MJSWGD,
       modelPar_given_MJSWGD,
       modelPar_SJS,
       modelPar_given_SJS,
       modelPar_SJD,
       modelPar_given_SJD,
       modelPar_SJSWS,
       modelPar_given_SJSWS,
       modelPar_SJSWD,
       modelPar_given_SJSWD,
       modelPar_SJSWGS,
       modelPar_given_SJSWGS,
       modelPar_SJSWGD,
       modelPar_given_SJSWGD,
       modelPar_MJS2,
       modelPar_given_MJS2,
       modelPar_MJD2,
       modelPar_given_MJD2,
       modelPar_MJSWS2,
       modelPar_given_MJSWS2,
       modelPar_MJSWD2,
       modelPar_given_MJSWD2,
       modelPar_MJSWGS2,
       modelPar_given_MJSWGS2,
       modelPar_MJSWGD2,
       modelPar_given_MJSWGD2,
       modelPar_JSS,
       modelPar_given_JSS,
       modelPar_JSD,
       modelPar_given_JSD,
       modelPar_JSWS,
       modelPar_given_JSWS,
       modelPar_JSWD,
       modelPar_given_JSWD,
       modelPar_JSWGS,
       modelPar_given_JSWGS,
       modelPar_JSWGD,
       modelPar_given_JSWGD,
       modelPar_NJS,
       modelPar_given_NJS,
       modelPar_NJD,
       modelPar_given_NJD,
       modelPar_IJTHSFWD,
       modelPar_given_IJTHSFWD,
       modelPar_IJTHDFWD,
       modelPar_given_IJTHDFWD,
       modelPar_IJTHSREV,
       modelPar_given_IJTHSREV,
       modelPar_IJTHDREV,
       modelPar_given_IJTHDREV,
       modelPar_BVS,
       modelPar_given_BVS,
       modelPar_BVD,
       modelPar_given_BVD,
       modelPar_XJBVS,
       modelPar_given_XJBVS,
       modelPar_XJBVD,
       modelPar_given_XJBVD,
       modelPar_JTSS,
       modelPar_given_JTSS,
       modelPar_JTSD,
       modelPar_given_JTSD,
       modelPar_JTSSWS,
       modelPar_given_JTSSWS,
       modelPar_JTSSWD,
       modelPar_given_JTSSWD,
       modelPar_JTSSWGS,
       modelPar_given_JTSSWGS,
       modelPar_JTSSWGD,
       modelPar_given_JTSSWGD,
       modelPar_JTWEFF,
       modelPar_given_JTWEFF,
       modelPar_NJTS,
       modelPar_given_NJTS,
       modelPar_NJTSD,
       modelPar_given_NJTSD,
       modelPar_NJTSSW,
       modelPar_given_NJTSSW,
       modelPar_NJTSSWD,
       modelPar_given_NJTSSWD,
       modelPar_NJTSSWG,
       modelPar_given_NJTSSWG,
       modelPar_NJTSSWGD,
       modelPar_given_NJTSSWGD,
       modelPar_VTSS,
       modelPar_given_VTSS,
       modelPar_VTSD,
       modelPar_given_VTSD,
       modelPar_VTSSWS,
       modelPar_given_VTSSWS,
       modelPar_VTSSWD,
       modelPar_given_VTSSWD,
       modelPar_VTSSWGS,
       modelPar_given_VTSSWGS,
       modelPar_VTSSWGD,
       modelPar_given_VTSSWGD,
       modelPar_LINTIGEN,
       modelPar_given_LINTIGEN,
       modelPar_NTGEN,
       modelPar_given_NTGEN,
       modelPar_AIGEN,
       modelPar_given_AIGEN,
       modelPar_BIGEN,
       modelPar_given_BIGEN,
       modelPar_XRCRG1,
       modelPar_given_XRCRG1,
       modelPar_XRCRG2,
       modelPar_given_XRCRG2,
       modelPar_EF,
       modelPar_given_EF,
       modelPar_EM,
       modelPar_given_EM,
       modelPar_NOIA,
       modelPar_given_NOIA,
       modelPar_NOIB,
       modelPar_given_NOIB,
       modelPar_NOIC,
       modelPar_given_NOIC,
       modelPar_LINTNOI,
       modelPar_given_LINTNOI,
       modelPar_NTNOI,
       modelPar_given_NTNOI,
       modelPar_TNOIA,
       modelPar_given_TNOIA,
       modelPar_TNOIB,
       modelPar_given_TNOIB,
       modelPar_RNOIA,
       modelPar_given_RNOIA,
       modelPar_RNOIB,
       modelPar_given_RNOIB,
       modelPar_TNOIC,
       modelPar_given_TNOIC,
       modelPar_RNOIC,
       modelPar_given_RNOIC,
       modelPar_SCALEN,
       modelPar_given_SCALEN,
       modelPar_TNOM,
       modelPar_given_TNOM,
       modelPar_TBGASUB,
       modelPar_given_TBGASUB,
       modelPar_TBGBSUB,
       modelPar_given_TBGBSUB,
       modelPar_KT1,
       modelPar_given_KT1,
       modelPar_KT1L,
       modelPar_given_KT1L,
       modelPar_TSS,
       modelPar_given_TSS,
       modelPar_IIT,
       modelPar_given_IIT,
       modelPar_TII,
       modelPar_given_TII,
       modelPar_TGIDL,
       modelPar_given_TGIDL,
       modelPar_IGT,
       modelPar_given_IGT,
       modelPar_TCJ,
       modelPar_given_TCJ,
       modelPar_TCJSW,
       modelPar_given_TCJSW,
       modelPar_TCJSWG,
       modelPar_given_TCJSWG,
       modelPar_TPB,
       modelPar_given_TPB,
       modelPar_TPBSW,
       modelPar_given_TPBSW,
       modelPar_TPBSWG,
       modelPar_given_TPBSWG,
       modelPar_XTIS,
       modelPar_given_XTIS,
       modelPar_XTID,
       modelPar_given_XTID,
       modelPar_XTSS,
       modelPar_given_XTSS,
       modelPar_XTSD,
       modelPar_given_XTSD,
       modelPar_XTSSWS,
       modelPar_given_XTSSWS,
       modelPar_XTSSWD,
       modelPar_given_XTSSWD,
       modelPar_XTSSWGS,
       modelPar_given_XTSSWGS,
       modelPar_XTSSWGD,
       modelPar_given_XTSSWGD,
       modelPar_TNJTS,
       modelPar_given_TNJTS,
       modelPar_TNJTSD,
       modelPar_given_TNJTSD,
       modelPar_TNJTSSW,
       modelPar_given_TNJTSSW,
       modelPar_TNJTSSWD,
       modelPar_given_TNJTSSWD,
       modelPar_TNJTSSWG,
       modelPar_given_TNJTSSWG,
       modelPar_TNJTSSWGD,
       modelPar_given_TNJTSSWGD,
       modelPar_RTH0,
       modelPar_given_RTH0,
       modelPar_CTH0,
       modelPar_given_CTH0,
       modelPar_WTH0,
       modelPar_given_WTH0,
       modelPar_ASHEXP,
       modelPar_given_ASHEXP,
       modelPar_BSHEXP,
       modelPar_given_BSHEXP,
       modelPar_ACH_UFCM,
       modelPar_given_ACH_UFCM,
       modelPar_CINS_UFCM,
       modelPar_given_CINS_UFCM,
       modelPar_W_UFCM,
       modelPar_given_W_UFCM,
       modelPar_TFIN_TOP,
       modelPar_given_TFIN_TOP,
       modelPar_TFIN_BASE,
       modelPar_given_TFIN_BASE,
       modelPar_QMFACTORCV,
       modelPar_given_QMFACTORCV,
       modelPar_ALPHA_UFCM,
       modelPar_given_ALPHA_UFCM,
       modelPar_LNBODY,
       modelPar_given_LNBODY,
       modelPar_NNBODY,
       modelPar_given_NNBODY,
       modelPar_PNBODY,
       modelPar_given_PNBODY,
       modelPar_LPHIG,
       modelPar_given_LPHIG,
       modelPar_NPHIG,
       modelPar_given_NPHIG,
       modelPar_PPHIG,
       modelPar_given_PPHIG,
       modelPar_LNGATE,
       modelPar_given_LNGATE,
       modelPar_NNGATE,
       modelPar_given_NNGATE,
       modelPar_PNGATE,
       modelPar_given_PNGATE,
       modelPar_LCIT,
       modelPar_given_LCIT,
       modelPar_NCIT,
       modelPar_given_NCIT,
       modelPar_PCIT,
       modelPar_given_PCIT,
       modelPar_LCITR,
       modelPar_given_LCITR,
       modelPar_NCITR,
       modelPar_given_NCITR,
       modelPar_PCITR,
       modelPar_given_PCITR,
       modelPar_LCDSC,
       modelPar_given_LCDSC,
       modelPar_NCDSC,
       modelPar_given_NCDSC,
       modelPar_PCDSC,
       modelPar_given_PCDSC,
       modelPar_LCDSCD,
       modelPar_given_LCDSCD,
       modelPar_NCDSCD,
       modelPar_given_NCDSCD,
       modelPar_PCDSCD,
       modelPar_given_PCDSCD,
       modelPar_LCDSCDR,
       modelPar_given_LCDSCDR,
       modelPar_NCDSCDR,
       modelPar_given_NCDSCDR,
       modelPar_PCDSCDR,
       modelPar_given_PCDSCDR,
       modelPar_LDVT0,
       modelPar_given_LDVT0,
       modelPar_NDVT0,
       modelPar_given_NDVT0,
       modelPar_PDVT0,
       modelPar_given_PDVT0,
       modelPar_LDVT1,
       modelPar_given_LDVT1,
       modelPar_NDVT1,
       modelPar_given_NDVT1,
       modelPar_PDVT1,
       modelPar_given_PDVT1,
       modelPar_LDVT1SS,
       modelPar_given_LDVT1SS,
       modelPar_NDVT1SS,
       modelPar_given_NDVT1SS,
       modelPar_PDVT1SS,
       modelPar_given_PDVT1SS,
       modelPar_LPHIN,
       modelPar_given_LPHIN,
       modelPar_NPHIN,
       modelPar_given_NPHIN,
       modelPar_PPHIN,
       modelPar_given_PPHIN,
       modelPar_LETA0,
       modelPar_given_LETA0,
       modelPar_NETA0,
       modelPar_given_NETA0,
       modelPar_PETA0,
       modelPar_given_PETA0,
       modelPar_LETA0R,
       modelPar_given_LETA0R,
       modelPar_NETA0R,
       modelPar_given_NETA0R,
       modelPar_PETA0R,
       modelPar_given_PETA0R,
       modelPar_LDSUB,
       modelPar_given_LDSUB,
       modelPar_NDSUB,
       modelPar_given_NDSUB,
       modelPar_PDSUB,
       modelPar_given_PDSUB,
       modelPar_LK1RSCE,
       modelPar_given_LK1RSCE,
       modelPar_NK1RSCE,
       modelPar_given_NK1RSCE,
       modelPar_PK1RSCE,
       modelPar_given_PK1RSCE,
       modelPar_LLPE0,
       modelPar_given_LLPE0,
       modelPar_NLPE0,
       modelPar_given_NLPE0,
       modelPar_PLPE0,
       modelPar_given_PLPE0,
       modelPar_LDVTSHIFT,
       modelPar_given_LDVTSHIFT,
       modelPar_NDVTSHIFT,
       modelPar_given_NDVTSHIFT,
       modelPar_PDVTSHIFT,
       modelPar_given_PDVTSHIFT,
       modelPar_LDVTSHIFTR,
       modelPar_given_LDVTSHIFTR,
       modelPar_NDVTSHIFTR,
       modelPar_given_NDVTSHIFTR,
       modelPar_PDVTSHIFTR,
       modelPar_given_PDVTSHIFTR,
       modelPar_LPHIBE,
       modelPar_given_LPHIBE,
       modelPar_NPHIBE,
       modelPar_given_NPHIBE,
       modelPar_PPHIBE,
       modelPar_given_PPHIBE,
       modelPar_LK0,
       modelPar_given_LK0,
       modelPar_NK0,
       modelPar_given_NK0,
       modelPar_PK0,
       modelPar_given_PK0,
       modelPar_LK01,
       modelPar_given_LK01,
       modelPar_NK01,
       modelPar_given_NK01,
       modelPar_PK01,
       modelPar_given_PK01,
       modelPar_LK0SI,
       modelPar_given_LK0SI,
       modelPar_NK0SI,
       modelPar_given_NK0SI,
       modelPar_PK0SI,
       modelPar_given_PK0SI,
       modelPar_LK0SI1,
       modelPar_given_LK0SI1,
       modelPar_NK0SI1,
       modelPar_given_NK0SI1,
       modelPar_PK0SI1,
       modelPar_given_PK0SI1,
       modelPar_LK1,
       modelPar_given_LK1,
       modelPar_NK1,
       modelPar_given_NK1,
       modelPar_PK1,
       modelPar_given_PK1,
       modelPar_LK11,
       modelPar_given_LK11,
       modelPar_NK11,
       modelPar_given_NK11,
       modelPar_PK11,
       modelPar_given_PK11,
       modelPar_LK2SI,
       modelPar_given_LK2SI,
       modelPar_NK2SI,
       modelPar_given_NK2SI,
       modelPar_PK2SI,
       modelPar_given_PK2SI,
       modelPar_LK2SI1,
       modelPar_given_LK2SI1,
       modelPar_NK2SI1,
       modelPar_given_NK2SI1,
       modelPar_PK2SI1,
       modelPar_given_PK2SI1,
       modelPar_LK0SISAT,
       modelPar_given_LK0SISAT,
       modelPar_NK0SISAT,
       modelPar_given_NK0SISAT,
       modelPar_PK0SISAT,
       modelPar_given_PK0SISAT,
       modelPar_LK0SISAT1,
       modelPar_given_LK0SISAT1,
       modelPar_NK0SISAT1,
       modelPar_given_NK0SISAT1,
       modelPar_PK0SISAT1,
       modelPar_given_PK0SISAT1,
       modelPar_LK2SISAT,
       modelPar_given_LK2SISAT,
       modelPar_NK2SISAT,
       modelPar_given_NK2SISAT,
       modelPar_PK2SISAT,
       modelPar_given_PK2SISAT,
       modelPar_LK2SISAT1,
       modelPar_given_LK2SISAT1,
       modelPar_NK2SISAT1,
       modelPar_given_NK2SISAT1,
       modelPar_PK2SISAT1,
       modelPar_given_PK2SISAT1,
       modelPar_LK2SAT,
       modelPar_given_LK2SAT,
       modelPar_NK2SAT,
       modelPar_given_NK2SAT,
       modelPar_PK2SAT,
       modelPar_given_PK2SAT,
       modelPar_LK2SAT1,
       modelPar_given_LK2SAT1,
       modelPar_NK2SAT1,
       modelPar_given_NK2SAT1,
       modelPar_PK2SAT1,
       modelPar_given_PK2SAT1,
       modelPar_LK2,
       modelPar_given_LK2,
       modelPar_NK2,
       modelPar_given_NK2,
       modelPar_PK2,
       modelPar_given_PK2,
       modelPar_LK21,
       modelPar_given_LK21,
       modelPar_NK21,
       modelPar_given_NK21,
       modelPar_PK21,
       modelPar_given_PK21,
       modelPar_LDVTB,
       modelPar_given_LDVTB,
       modelPar_NDVTB,
       modelPar_given_NDVTB,
       modelPar_PDVTB,
       modelPar_given_PDVTB,
       modelPar_LLPEB,
       modelPar_given_LLPEB,
       modelPar_NLPEB,
       modelPar_given_NLPEB,
       modelPar_PLPEB,
       modelPar_given_PLPEB,
       modelPar_LQMFACTOR,
       modelPar_given_LQMFACTOR,
       modelPar_NQMFACTOR,
       modelPar_given_NQMFACTOR,
       modelPar_PQMFACTOR,
       modelPar_given_PQMFACTOR,
       modelPar_LQMTCENCV,
       modelPar_given_LQMTCENCV,
       modelPar_NQMTCENCV,
       modelPar_given_NQMTCENCV,
       modelPar_PQMTCENCV,
       modelPar_given_PQMTCENCV,
       modelPar_LQMTCENCVA,
       modelPar_given_LQMTCENCVA,
       modelPar_NQMTCENCVA,
       modelPar_given_NQMTCENCVA,
       modelPar_PQMTCENCVA,
       modelPar_given_PQMTCENCVA,
       modelPar_LVSAT,
       modelPar_given_LVSAT,
       modelPar_NVSAT,
       modelPar_given_NVSAT,
       modelPar_PVSAT,
       modelPar_given_PVSAT,
       modelPar_LVSATR,
       modelPar_given_LVSATR,
       modelPar_NVSATR,
       modelPar_given_NVSATR,
       modelPar_PVSATR,
       modelPar_given_PVSATR,
       modelPar_LVSAT1,
       modelPar_given_LVSAT1,
       modelPar_NVSAT1,
       modelPar_given_NVSAT1,
       modelPar_PVSAT1,
       modelPar_given_PVSAT1,
       modelPar_LVSAT1R,
       modelPar_given_LVSAT1R,
       modelPar_NVSAT1R,
       modelPar_given_NVSAT1R,
       modelPar_PVSAT1R,
       modelPar_given_PVSAT1R,
       modelPar_LPSAT,
       modelPar_given_LPSAT,
       modelPar_NPSAT,
       modelPar_given_NPSAT,
       modelPar_PPSAT,
       modelPar_given_PPSAT,
       modelPar_LDELTAVSAT,
       modelPar_given_LDELTAVSAT,
       modelPar_NDELTAVSAT,
       modelPar_given_NDELTAVSAT,
       modelPar_PDELTAVSAT,
       modelPar_given_PDELTAVSAT,
       modelPar_LKSATIV,
       modelPar_given_LKSATIV,
       modelPar_NKSATIV,
       modelPar_given_NKSATIV,
       modelPar_PKSATIV,
       modelPar_given_PKSATIV,
       modelPar_LKSATIVR,
       modelPar_given_LKSATIVR,
       modelPar_NKSATIVR,
       modelPar_given_NKSATIVR,
       modelPar_PKSATIVR,
       modelPar_given_PKSATIVR,
       modelPar_LVSATCV,
       modelPar_given_LVSATCV,
       modelPar_NVSATCV,
       modelPar_given_NVSATCV,
       modelPar_PVSATCV,
       modelPar_given_PVSATCV,
       modelPar_LPSATCV,
       modelPar_given_LPSATCV,
       modelPar_NPSATCV,
       modelPar_given_NPSATCV,
       modelPar_PPSATCV,
       modelPar_given_PPSATCV,
       modelPar_LDELTAVSATCV,
       modelPar_given_LDELTAVSATCV,
       modelPar_NDELTAVSATCV,
       modelPar_given_NDELTAVSATCV,
       modelPar_PDELTAVSATCV,
       modelPar_given_PDELTAVSATCV,
       modelPar_LMEXP,
       modelPar_given_LMEXP,
       modelPar_NMEXP,
       modelPar_given_NMEXP,
       modelPar_PMEXP,
       modelPar_given_PMEXP,
       modelPar_LMEXPR,
       modelPar_given_LMEXPR,
       modelPar_NMEXPR,
       modelPar_given_NMEXPR,
       modelPar_PMEXPR,
       modelPar_given_PMEXPR,
       modelPar_LPTWG,
       modelPar_given_LPTWG,
       modelPar_NPTWG,
       modelPar_given_NPTWG,
       modelPar_PPTWG,
       modelPar_given_PPTWG,
       modelPar_LPTWGR,
       modelPar_given_LPTWGR,
       modelPar_NPTWGR,
       modelPar_given_NPTWGR,
       modelPar_PPTWGR,
       modelPar_given_PPTWGR,
       modelPar_LU0,
       modelPar_given_LU0,
       modelPar_NU0,
       modelPar_given_NU0,
       modelPar_PU0,
       modelPar_given_PU0,
       modelPar_LU0R,
       modelPar_given_LU0R,
       modelPar_NU0R,
       modelPar_given_NU0R,
       modelPar_PU0R,
       modelPar_given_PU0R,
       modelPar_LETAMOB,
       modelPar_given_LETAMOB,
       modelPar_NETAMOB,
       modelPar_given_NETAMOB,
       modelPar_PETAMOB,
       modelPar_given_PETAMOB,
       modelPar_LUP,
       modelPar_given_LUP,
       modelPar_NUP,
       modelPar_given_NUP,
       modelPar_PUP,
       modelPar_given_PUP,
       modelPar_LUPR,
       modelPar_given_LUPR,
       modelPar_NUPR,
       modelPar_given_NUPR,
       modelPar_PUPR,
       modelPar_given_PUPR,
       modelPar_LUA,
       modelPar_given_LUA,
       modelPar_NUA,
       modelPar_given_NUA,
       modelPar_PUA,
       modelPar_given_PUA,
       modelPar_LUAR,
       modelPar_given_LUAR,
       modelPar_NUAR,
       modelPar_given_NUAR,
       modelPar_PUAR,
       modelPar_given_PUAR,
       modelPar_LUC,
       modelPar_given_LUC,
       modelPar_NUC,
       modelPar_given_NUC,
       modelPar_PUC,
       modelPar_given_PUC,
       modelPar_LUCR,
       modelPar_given_LUCR,
       modelPar_NUCR,
       modelPar_given_NUCR,
       modelPar_PUCR,
       modelPar_given_PUCR,
       modelPar_LEU,
       modelPar_given_LEU,
       modelPar_NEU,
       modelPar_given_NEU,
       modelPar_PEU,
       modelPar_given_PEU,
       modelPar_LEUR,
       modelPar_given_LEUR,
       modelPar_NEUR,
       modelPar_given_NEUR,
       modelPar_PEUR,
       modelPar_given_PEUR,
       modelPar_LUD,
       modelPar_given_LUD,
       modelPar_NUD,
       modelPar_given_NUD,
       modelPar_PUD,
       modelPar_given_PUD,
       modelPar_LUDR,
       modelPar_given_LUDR,
       modelPar_NUDR,
       modelPar_given_NUDR,
       modelPar_PUDR,
       modelPar_given_PUDR,
       modelPar_LUCS,
       modelPar_given_LUCS,
       modelPar_NUCS,
       modelPar_given_NUCS,
       modelPar_PUCS,
       modelPar_given_PUCS,
       modelPar_LPCLM,
       modelPar_given_LPCLM,
       modelPar_NPCLM,
       modelPar_given_NPCLM,
       modelPar_PPCLM,
       modelPar_given_PPCLM,
       modelPar_LPCLMR,
       modelPar_given_LPCLMR,
       modelPar_NPCLMR,
       modelPar_given_NPCLMR,
       modelPar_PPCLMR,
       modelPar_given_PPCLMR,
       modelPar_LPCLMG,
       modelPar_given_LPCLMG,
       modelPar_NPCLMG,
       modelPar_given_NPCLMG,
       modelPar_PPCLMG,
       modelPar_given_PPCLMG,
       modelPar_LPCLMCV,
       modelPar_given_LPCLMCV,
       modelPar_NPCLMCV,
       modelPar_given_NPCLMCV,
       modelPar_PPCLMCV,
       modelPar_given_PPCLMCV,
       modelPar_LA1,
       modelPar_given_LA1,
       modelPar_NA1,
       modelPar_given_NA1,
       modelPar_PA1,
       modelPar_given_PA1,
       modelPar_LA11,
       modelPar_given_LA11,
       modelPar_NA11,
       modelPar_given_NA11,
       modelPar_PA11,
       modelPar_given_PA11,
       modelPar_LA2,
       modelPar_given_LA2,
       modelPar_NA2,
       modelPar_given_NA2,
       modelPar_PA2,
       modelPar_given_PA2,
       modelPar_LA21,
       modelPar_given_LA21,
       modelPar_NA21,
       modelPar_given_NA21,
       modelPar_PA21,
       modelPar_given_PA21,
       modelPar_LRDSW,
       modelPar_given_LRDSW,
       modelPar_NRDSW,
       modelPar_given_NRDSW,
       modelPar_PRDSW,
       modelPar_given_PRDSW,
       modelPar_LRSW,
       modelPar_given_LRSW,
       modelPar_NRSW,
       modelPar_given_NRSW,
       modelPar_PRSW,
       modelPar_given_PRSW,
       modelPar_LRDW,
       modelPar_given_LRDW,
       modelPar_NRDW,
       modelPar_given_NRDW,
       modelPar_PRDW,
       modelPar_given_PRDW,
       modelPar_LPRWGS,
       modelPar_given_LPRWGS,
       modelPar_NPRWGS,
       modelPar_given_NPRWGS,
       modelPar_PPRWGS,
       modelPar_given_PPRWGS,
       modelPar_LPRWGD,
       modelPar_given_LPRWGD,
       modelPar_NPRWGD,
       modelPar_given_NPRWGD,
       modelPar_PPRWGD,
       modelPar_given_PPRWGD,
       modelPar_LWR,
       modelPar_given_LWR,
       modelPar_NWR,
       modelPar_given_NWR,
       modelPar_PWR,
       modelPar_given_PWR,
       modelPar_LPDIBL1,
       modelPar_given_LPDIBL1,
       modelPar_NPDIBL1,
       modelPar_given_NPDIBL1,
       modelPar_PPDIBL1,
       modelPar_given_PPDIBL1,
       modelPar_LPDIBL1R,
       modelPar_given_LPDIBL1R,
       modelPar_NPDIBL1R,
       modelPar_given_NPDIBL1R,
       modelPar_PPDIBL1R,
       modelPar_given_PPDIBL1R,
       modelPar_LPDIBL2,
       modelPar_given_LPDIBL2,
       modelPar_NPDIBL2,
       modelPar_given_NPDIBL2,
       modelPar_PPDIBL2,
       modelPar_given_PPDIBL2,
       modelPar_LPDIBL2R,
       modelPar_given_LPDIBL2R,
       modelPar_NPDIBL2R,
       modelPar_given_NPDIBL2R,
       modelPar_PPDIBL2R,
       modelPar_given_PPDIBL2R,
       modelPar_LDROUT,
       modelPar_given_LDROUT,
       modelPar_NDROUT,
       modelPar_given_NDROUT,
       modelPar_PDROUT,
       modelPar_given_PDROUT,
       modelPar_LPVAG,
       modelPar_given_LPVAG,
       modelPar_NPVAG,
       modelPar_given_NPVAG,
       modelPar_PPVAG,
       modelPar_given_PPVAG,
       modelPar_LAIGBINV,
       modelPar_given_LAIGBINV,
       modelPar_NAIGBINV,
       modelPar_given_NAIGBINV,
       modelPar_PAIGBINV,
       modelPar_given_PAIGBINV,
       modelPar_LAIGBINV1,
       modelPar_given_LAIGBINV1,
       modelPar_NAIGBINV1,
       modelPar_given_NAIGBINV1,
       modelPar_PAIGBINV1,
       modelPar_given_PAIGBINV1,
       modelPar_LBIGBINV,
       modelPar_given_LBIGBINV,
       modelPar_NBIGBINV,
       modelPar_given_NBIGBINV,
       modelPar_PBIGBINV,
       modelPar_given_PBIGBINV,
       modelPar_LCIGBINV,
       modelPar_given_LCIGBINV,
       modelPar_NCIGBINV,
       modelPar_given_NCIGBINV,
       modelPar_PCIGBINV,
       modelPar_given_PCIGBINV,
       modelPar_LEIGBINV,
       modelPar_given_LEIGBINV,
       modelPar_NEIGBINV,
       modelPar_given_NEIGBINV,
       modelPar_PEIGBINV,
       modelPar_given_PEIGBINV,
       modelPar_LNIGBINV,
       modelPar_given_LNIGBINV,
       modelPar_NNIGBINV,
       modelPar_given_NNIGBINV,
       modelPar_PNIGBINV,
       modelPar_given_PNIGBINV,
       modelPar_LAIGBACC,
       modelPar_given_LAIGBACC,
       modelPar_NAIGBACC,
       modelPar_given_NAIGBACC,
       modelPar_PAIGBACC,
       modelPar_given_PAIGBACC,
       modelPar_LAIGBACC1,
       modelPar_given_LAIGBACC1,
       modelPar_NAIGBACC1,
       modelPar_given_NAIGBACC1,
       modelPar_PAIGBACC1,
       modelPar_given_PAIGBACC1,
       modelPar_LBIGBACC,
       modelPar_given_LBIGBACC,
       modelPar_NBIGBACC,
       modelPar_given_NBIGBACC,
       modelPar_PBIGBACC,
       modelPar_given_PBIGBACC,
       modelPar_LCIGBACC,
       modelPar_given_LCIGBACC,
       modelPar_NCIGBACC,
       modelPar_given_NCIGBACC,
       modelPar_PCIGBACC,
       modelPar_given_PCIGBACC,
       modelPar_LNIGBACC,
       modelPar_given_LNIGBACC,
       modelPar_NNIGBACC,
       modelPar_given_NNIGBACC,
       modelPar_PNIGBACC,
       modelPar_given_PNIGBACC,
       modelPar_LAIGC,
       modelPar_given_LAIGC,
       modelPar_NAIGC,
       modelPar_given_NAIGC,
       modelPar_PAIGC,
       modelPar_given_PAIGC,
       modelPar_LAIGC1,
       modelPar_given_LAIGC1,
       modelPar_NAIGC1,
       modelPar_given_NAIGC1,
       modelPar_PAIGC1,
       modelPar_given_PAIGC1,
       modelPar_LBIGC,
       modelPar_given_LBIGC,
       modelPar_NBIGC,
       modelPar_given_NBIGC,
       modelPar_PBIGC,
       modelPar_given_PBIGC,
       modelPar_LCIGC,
       modelPar_given_LCIGC,
       modelPar_NCIGC,
       modelPar_given_NCIGC,
       modelPar_PCIGC,
       modelPar_given_PCIGC,
       modelPar_LPIGCD,
       modelPar_given_LPIGCD,
       modelPar_NPIGCD,
       modelPar_given_NPIGCD,
       modelPar_PPIGCD,
       modelPar_given_PPIGCD,
       modelPar_LAIGS,
       modelPar_given_LAIGS,
       modelPar_NAIGS,
       modelPar_given_NAIGS,
       modelPar_PAIGS,
       modelPar_given_PAIGS,
       modelPar_LAIGS1,
       modelPar_given_LAIGS1,
       modelPar_NAIGS1,
       modelPar_given_NAIGS1,
       modelPar_PAIGS1,
       modelPar_given_PAIGS1,
       modelPar_LBIGS,
       modelPar_given_LBIGS,
       modelPar_NBIGS,
       modelPar_given_NBIGS,
       modelPar_PBIGS,
       modelPar_given_PBIGS,
       modelPar_LCIGS,
       modelPar_given_LCIGS,
       modelPar_NCIGS,
       modelPar_given_NCIGS,
       modelPar_PCIGS,
       modelPar_given_PCIGS,
       modelPar_LAIGD,
       modelPar_given_LAIGD,
       modelPar_NAIGD,
       modelPar_given_NAIGD,
       modelPar_PAIGD,
       modelPar_given_PAIGD,
       modelPar_LAIGD1,
       modelPar_given_LAIGD1,
       modelPar_NAIGD1,
       modelPar_given_NAIGD1,
       modelPar_PAIGD1,
       modelPar_given_PAIGD1,
       modelPar_LBIGD,
       modelPar_given_LBIGD,
       modelPar_NBIGD,
       modelPar_given_NBIGD,
       modelPar_PBIGD,
       modelPar_given_PBIGD,
       modelPar_LCIGD,
       modelPar_given_LCIGD,
       modelPar_NCIGD,
       modelPar_given_NCIGD,
       modelPar_PCIGD,
       modelPar_given_PCIGD,
       modelPar_LNTOX,
       modelPar_given_LNTOX,
       modelPar_NNTOX,
       modelPar_given_NNTOX,
       modelPar_PNTOX,
       modelPar_given_PNTOX,
       modelPar_LPOXEDGE,
       modelPar_given_LPOXEDGE,
       modelPar_NPOXEDGE,
       modelPar_given_NPOXEDGE,
       modelPar_PPOXEDGE,
       modelPar_given_PPOXEDGE,
       modelPar_LAGISL,
       modelPar_given_LAGISL,
       modelPar_NAGISL,
       modelPar_given_NAGISL,
       modelPar_PAGISL,
       modelPar_given_PAGISL,
       modelPar_LBGISL,
       modelPar_given_LBGISL,
       modelPar_NBGISL,
       modelPar_given_NBGISL,
       modelPar_PBGISL,
       modelPar_given_PBGISL,
       modelPar_LCGISL,
       modelPar_given_LCGISL,
       modelPar_NCGISL,
       modelPar_given_NCGISL,
       modelPar_PCGISL,
       modelPar_given_PCGISL,
       modelPar_LEGISL,
       modelPar_given_LEGISL,
       modelPar_NEGISL,
       modelPar_given_NEGISL,
       modelPar_PEGISL,
       modelPar_given_PEGISL,
       modelPar_LPGISL,
       modelPar_given_LPGISL,
       modelPar_NPGISL,
       modelPar_given_NPGISL,
       modelPar_PPGISL,
       modelPar_given_PPGISL,
       modelPar_LAGIDL,
       modelPar_given_LAGIDL,
       modelPar_NAGIDL,
       modelPar_given_NAGIDL,
       modelPar_PAGIDL,
       modelPar_given_PAGIDL,
       modelPar_LBGIDL,
       modelPar_given_LBGIDL,
       modelPar_NBGIDL,
       modelPar_given_NBGIDL,
       modelPar_PBGIDL,
       modelPar_given_PBGIDL,
       modelPar_LCGIDL,
       modelPar_given_LCGIDL,
       modelPar_NCGIDL,
       modelPar_given_NCGIDL,
       modelPar_PCGIDL,
       modelPar_given_PCGIDL,
       modelPar_LEGIDL,
       modelPar_given_LEGIDL,
       modelPar_NEGIDL,
       modelPar_given_NEGIDL,
       modelPar_PEGIDL,
       modelPar_given_PEGIDL,
       modelPar_LPGIDL,
       modelPar_given_LPGIDL,
       modelPar_NPGIDL,
       modelPar_given_NPGIDL,
       modelPar_PPGIDL,
       modelPar_given_PPGIDL,
       modelPar_LALPHA0,
       modelPar_given_LALPHA0,
       modelPar_NALPHA0,
       modelPar_given_NALPHA0,
       modelPar_PALPHA0,
       modelPar_given_PALPHA0,
       modelPar_LALPHA1,
       modelPar_given_LALPHA1,
       modelPar_NALPHA1,
       modelPar_given_NALPHA1,
       modelPar_PALPHA1,
       modelPar_given_PALPHA1,
       modelPar_LALPHAII0,
       modelPar_given_LALPHAII0,
       modelPar_NALPHAII0,
       modelPar_given_NALPHAII0,
       modelPar_PALPHAII0,
       modelPar_given_PALPHAII0,
       modelPar_LALPHAII1,
       modelPar_given_LALPHAII1,
       modelPar_NALPHAII1,
       modelPar_given_NALPHAII1,
       modelPar_PALPHAII1,
       modelPar_given_PALPHAII1,
       modelPar_LBETA0,
       modelPar_given_LBETA0,
       modelPar_NBETA0,
       modelPar_given_NBETA0,
       modelPar_PBETA0,
       modelPar_given_PBETA0,
       modelPar_LBETAII0,
       modelPar_given_LBETAII0,
       modelPar_NBETAII0,
       modelPar_given_NBETAII0,
       modelPar_PBETAII0,
       modelPar_given_PBETAII0,
       modelPar_LBETAII1,
       modelPar_given_LBETAII1,
       modelPar_NBETAII1,
       modelPar_given_NBETAII1,
       modelPar_PBETAII1,
       modelPar_given_PBETAII1,
       modelPar_LBETAII2,
       modelPar_given_LBETAII2,
       modelPar_NBETAII2,
       modelPar_given_NBETAII2,
       modelPar_PBETAII2,
       modelPar_given_PBETAII2,
       modelPar_LESATII,
       modelPar_given_LESATII,
       modelPar_NESATII,
       modelPar_given_NESATII,
       modelPar_PESATII,
       modelPar_given_PESATII,
       modelPar_LLII,
       modelPar_given_LLII,
       modelPar_NLII,
       modelPar_given_NLII,
       modelPar_PLII,
       modelPar_given_PLII,
       modelPar_LSII0,
       modelPar_given_LSII0,
       modelPar_NSII0,
       modelPar_given_NSII0,
       modelPar_PSII0,
       modelPar_given_PSII0,
       modelPar_LSII1,
       modelPar_given_LSII1,
       modelPar_NSII1,
       modelPar_given_NSII1,
       modelPar_PSII1,
       modelPar_given_PSII1,
       modelPar_LSII2,
       modelPar_given_LSII2,
       modelPar_NSII2,
       modelPar_given_NSII2,
       modelPar_PSII2,
       modelPar_given_PSII2,
       modelPar_LSIID,
       modelPar_given_LSIID,
       modelPar_NSIID,
       modelPar_given_NSIID,
       modelPar_PSIID,
       modelPar_given_PSIID,
       modelPar_LCFS,
       modelPar_given_LCFS,
       modelPar_NCFS,
       modelPar_given_NCFS,
       modelPar_PCFS,
       modelPar_given_PCFS,
       modelPar_LCFD,
       modelPar_given_LCFD,
       modelPar_NCFD,
       modelPar_given_NCFD,
       modelPar_PCFD,
       modelPar_given_PCFD,
       modelPar_LCOVS,
       modelPar_given_LCOVS,
       modelPar_NCOVS,
       modelPar_given_NCOVS,
       modelPar_PCOVS,
       modelPar_given_PCOVS,
       modelPar_LCOVD,
       modelPar_given_LCOVD,
       modelPar_NCOVD,
       modelPar_given_NCOVD,
       modelPar_PCOVD,
       modelPar_given_PCOVD,
       modelPar_LCGSL,
       modelPar_given_LCGSL,
       modelPar_NCGSL,
       modelPar_given_NCGSL,
       modelPar_PCGSL,
       modelPar_given_PCGSL,
       modelPar_LCGDL,
       modelPar_given_LCGDL,
       modelPar_NCGDL,
       modelPar_given_NCGDL,
       modelPar_PCGDL,
       modelPar_given_PCGDL,
       modelPar_LCKAPPAS,
       modelPar_given_LCKAPPAS,
       modelPar_NCKAPPAS,
       modelPar_given_NCKAPPAS,
       modelPar_PCKAPPAS,
       modelPar_given_PCKAPPAS,
       modelPar_LCKAPPAD,
       modelPar_given_LCKAPPAD,
       modelPar_NCKAPPAD,
       modelPar_given_NCKAPPAD,
       modelPar_PCKAPPAD,
       modelPar_given_PCKAPPAD,
       modelPar_LCGBL,
       modelPar_given_LCGBL,
       modelPar_NCGBL,
       modelPar_given_NCGBL,
       modelPar_PCGBL,
       modelPar_given_PCGBL,
       modelPar_LCKAPPAB,
       modelPar_given_LCKAPPAB,
       modelPar_NCKAPPAB,
       modelPar_given_NCKAPPAB,
       modelPar_PCKAPPAB,
       modelPar_given_PCKAPPAB,
       modelPar_LNTGEN,
       modelPar_given_LNTGEN,
       modelPar_NNTGEN,
       modelPar_given_NNTGEN,
       modelPar_PNTGEN,
       modelPar_given_PNTGEN,
       modelPar_LAIGEN,
       modelPar_given_LAIGEN,
       modelPar_NAIGEN,
       modelPar_given_NAIGEN,
       modelPar_PAIGEN,
       modelPar_given_PAIGEN,
       modelPar_LBIGEN,
       modelPar_given_LBIGEN,
       modelPar_NBIGEN,
       modelPar_given_NBIGEN,
       modelPar_PBIGEN,
       modelPar_given_PBIGEN,
       modelPar_LXRCRG1,
       modelPar_given_LXRCRG1,
       modelPar_NXRCRG1,
       modelPar_given_NXRCRG1,
       modelPar_PXRCRG1,
       modelPar_given_PXRCRG1,
       modelPar_LXRCRG2,
       modelPar_given_LXRCRG2,
       modelPar_NXRCRG2,
       modelPar_given_NXRCRG2,
       modelPar_PXRCRG2,
       modelPar_given_PXRCRG2,
       modelPar_LUTE,
       modelPar_given_LUTE,
       modelPar_NUTE,
       modelPar_given_NUTE,
       modelPar_PUTE,
       modelPar_given_PUTE,
       modelPar_LUTER,
       modelPar_given_LUTER,
       modelPar_NUTER,
       modelPar_given_NUTER,
       modelPar_PUTER,
       modelPar_given_PUTER,
       modelPar_LUTL,
       modelPar_given_LUTL,
       modelPar_NUTL,
       modelPar_given_NUTL,
       modelPar_PUTL,
       modelPar_given_PUTL,
       modelPar_LUTLR,
       modelPar_given_LUTLR,
       modelPar_NUTLR,
       modelPar_given_NUTLR,
       modelPar_PUTLR,
       modelPar_given_PUTLR,
       modelPar_LEMOBT,
       modelPar_given_LEMOBT,
       modelPar_NEMOBT,
       modelPar_given_NEMOBT,
       modelPar_PEMOBT,
       modelPar_given_PEMOBT,
       modelPar_LUA1,
       modelPar_given_LUA1,
       modelPar_NUA1,
       modelPar_given_NUA1,
       modelPar_PUA1,
       modelPar_given_PUA1,
       modelPar_LUA1R,
       modelPar_given_LUA1R,
       modelPar_NUA1R,
       modelPar_given_NUA1R,
       modelPar_PUA1R,
       modelPar_given_PUA1R,
       modelPar_LUC1,
       modelPar_given_LUC1,
       modelPar_NUC1,
       modelPar_given_NUC1,
       modelPar_PUC1,
       modelPar_given_PUC1,
       modelPar_LUC1R,
       modelPar_given_LUC1R,
       modelPar_NUC1R,
       modelPar_given_NUC1R,
       modelPar_PUC1R,
       modelPar_given_PUC1R,
       modelPar_LUD1,
       modelPar_given_LUD1,
       modelPar_NUD1,
       modelPar_given_NUD1,
       modelPar_PUD1,
       modelPar_given_PUD1,
       modelPar_LUD1R,
       modelPar_given_LUD1R,
       modelPar_NUD1R,
       modelPar_given_NUD1R,
       modelPar_PUD1R,
       modelPar_given_PUD1R,
       modelPar_LUCSTE,
       modelPar_given_LUCSTE,
       modelPar_NUCSTE,
       modelPar_given_NUCSTE,
       modelPar_PUCSTE,
       modelPar_given_PUCSTE,
       modelPar_LPTWGT,
       modelPar_given_LPTWGT,
       modelPar_NPTWGT,
       modelPar_given_NPTWGT,
       modelPar_PPTWGT,
       modelPar_given_PPTWGT,
       modelPar_LAT,
       modelPar_given_LAT,
       modelPar_NAT,
       modelPar_given_NAT,
       modelPar_PAT,
       modelPar_given_PAT,
       modelPar_LATR,
       modelPar_given_LATR,
       modelPar_NATR,
       modelPar_given_NATR,
       modelPar_PATR,
       modelPar_given_PATR,
       modelPar_LATCV,
       modelPar_given_LATCV,
       modelPar_NATCV,
       modelPar_given_NATCV,
       modelPar_PATCV,
       modelPar_given_PATCV,
       modelPar_LSTTHETASAT,
       modelPar_given_LSTTHETASAT,
       modelPar_NSTTHETASAT,
       modelPar_given_NSTTHETASAT,
       modelPar_PSTTHETASAT,
       modelPar_given_PSTTHETASAT,
       modelPar_LPRT,
       modelPar_given_LPRT,
       modelPar_NPRT,
       modelPar_given_NPRT,
       modelPar_PPRT,
       modelPar_given_PPRT,
       modelPar_LKT1,
       modelPar_given_LKT1,
       modelPar_NKT1,
       modelPar_given_NKT1,
       modelPar_PKT1,
       modelPar_given_PKT1,
       modelPar_LTSS,
       modelPar_given_LTSS,
       modelPar_NTSS,
       modelPar_given_NTSS,
       modelPar_PTSS,
       modelPar_given_PTSS,
       modelPar_LIIT,
       modelPar_given_LIIT,
       modelPar_NIIT,
       modelPar_given_NIIT,
       modelPar_PIIT,
       modelPar_given_PIIT,
       modelPar_LTII,
       modelPar_given_LTII,
       modelPar_NTII,
       modelPar_given_NTII,
       modelPar_PTII,
       modelPar_given_PTII,
       modelPar_LTGIDL,
       modelPar_given_LTGIDL,
       modelPar_NTGIDL,
       modelPar_given_NTGIDL,
       modelPar_PTGIDL,
       modelPar_given_PTGIDL,
       modelPar_LIGT,
       modelPar_given_LIGT,
       modelPar_NIGT,
       modelPar_given_NIGT,
       modelPar_PIGT,
       modelPar_given_PIGT,
       // non-reals (including hidden)
       modelPar_NF,
       modelPar_given_NF,
       modelPar_NGCON,
       modelPar_given_NGCON,
       modelPar_DEVTYPE,
       modelPar_given_DEVTYPE,
       modelPar_TYPE,
       modelPar_given_TYPE,
       modelPar_BULKMOD,
       modelPar_given_BULKMOD,
       modelPar_GEOMOD,
       modelPar_given_GEOMOD,
       modelPar_CGEO1SW,
       modelPar_given_CGEO1SW,
       modelPar_RDSMOD,
       modelPar_given_RDSMOD,
       modelPar_ASYMMOD,
       modelPar_given_ASYMMOD,
       modelPar_IGCMOD,
       modelPar_given_IGCMOD,
       modelPar_IGBMOD,
       modelPar_given_IGBMOD,
       modelPar_GIDLMOD,
       modelPar_given_GIDLMOD,
       modelPar_IIMOD,
       modelPar_given_IIMOD,
       modelPar_TNOIMOD,
       modelPar_given_TNOIMOD,
       modelPar_NQSMOD,
       modelPar_given_NQSMOD,
       modelPar_SHMOD,
       modelPar_given_SHMOD,
       modelPar_TEMPMOD,
       modelPar_given_TEMPMOD,
       modelPar_RGATEMOD,
       modelPar_given_RGATEMOD,
       modelPar_RGEOMOD,
       modelPar_given_RGEOMOD,
       modelPar_CGEOMOD,
       modelPar_given_CGEOMOD,
       modelPar_SH_WARN,
       modelPar_given_SH_WARN,
       modelPar_IGCLAMP,
       modelPar_given_IGCLAMP,
       modelPar_SDTERM,
       modelPar_given_SDTERM,
       modelPar_NSEG,
       modelPar_given_NSEG,
       in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


    // Now call  the function that does the heavy lifting.

    evaluateModelEquations(
       probeVars,
       // probe constants
       in.admsProbeID_V_N_GND,
       in.admsProbeID_V_g_ge,
       in.admsProbeID_V_s_si,
       in.admsProbeID_V_d_di,
       in.admsProbeID_V_e_ge,
       in.admsProbeID_V_ge_d,
       in.admsProbeID_V_ge_s,
       in.admsProbeID_V_di_d,
       in.admsProbeID_V_si_s,
       in.admsProbeID_V_e_s,
       in.admsProbeID_V_d_s,
       in.admsProbeID_V_g_s,
       in.admsProbeID_V_ge_e,
       in.admsProbeID_V_e_di,
       in.admsProbeID_V_e_si,
       in.admsProbeID_V_ge_di,
       in.admsProbeID_V_di_si,
       in.admsProbeID_V_ge_si,
       in.admsProbeID_Temp_t_GND,

       // node constants
       in.admsNodeID_d,
       in.admsNodeID_g,
       in.admsNodeID_s,
       in.admsNodeID_e,
       in.admsNodeID_t,
       in.admsNodeID_si,
       in.admsNodeID_di,
       in.admsNodeID_ge,
       in.admsNodeID_N,
       // instance parameters
       // reals
       instancePar_L,
       instancePar_given_L,
       instancePar_D,
       instancePar_given_D,
       instancePar_TFIN,
       instancePar_given_TFIN,
       instancePar_FPITCH,
       instancePar_given_FPITCH,
       instancePar_NFIN,
       instancePar_given_NFIN,
       instancePar_ASEO,
       instancePar_given_ASEO,
       instancePar_ADEO,
       instancePar_given_ADEO,
       instancePar_PSEO,
       instancePar_given_PSEO,
       instancePar_PDEO,
       instancePar_given_PDEO,
       instancePar_ASEJ,
       instancePar_given_ASEJ,
       instancePar_ADEJ,
       instancePar_given_ADEJ,
       instancePar_PSEJ,
       instancePar_given_PSEJ,
       instancePar_PDEJ,
       instancePar_given_PDEJ,
       instancePar_COVS,
       instancePar_given_COVS,
       instancePar_COVD,
       instancePar_given_COVD,
       instancePar_CGSP,
       instancePar_given_CGSP,
       instancePar_CGDP,
       instancePar_given_CGDP,
       instancePar_CDSP,
       instancePar_given_CDSP,
       instancePar_NRS,
       instancePar_given_NRS,
       instancePar_NRD,
       instancePar_given_NRD,
       instancePar_LRSD,
       instancePar_given_LRSD,
       instancePar_NFINNOM,
       instancePar_given_NFINNOM,
       instancePar_m,
       instancePar_given_m,
       // non-reals(including hidden)
       instancePar_NF,
       instancePar_given_NF,
       instancePar_NGCON,
       instancePar_given_NGCON,
       // instance variables
       // reals
       instanceVar_NFINtotal,
       instanceVar_ids,
       instanceVar_sigvds,
       instanceVar_qd,
       instanceVar_qg,
       instanceVar_qs,
       instanceVar_qb,
       instanceVar_epssub,
       instanceVar_epsratio,
       instanceVar_Leff,
       instanceVar_LeffCV,
       instanceVar_LeffCV_acc,
       instanceVar_Weff0,
       instanceVar_WeffCV0,
       instanceVar_cox,
       instanceVar_nbody,
       instanceVar_T0,
       instanceVar_T1,
       instanceVar_T2,
       instanceVar_T3,
       instanceVar_Tnom,
       instanceVar_PTWGR_t,
       instanceVar_CJS_t,
       instanceVar_CJSWS_t,
       instanceVar_CJSWGD_t,
       instanceVar_CJD_t,
       instanceVar_CJSWD_t,
       instanceVar_CJSWGS_t,
       instanceVar_PBS_t,
       instanceVar_PBSWS_t,
       instanceVar_PBSWGS_t,
       instanceVar_PBD_t,
       instanceVar_PBSWD_t,
       instanceVar_PBSWGD_t,
       instanceVar_JSS_t,
       instanceVar_JSWS_t,
       instanceVar_JSWGS_t,
       instanceVar_JSD_t,
       instanceVar_JSWD_t,
       instanceVar_JSWGD_t,
       instanceVar_JTSS_t,
       instanceVar_JTSD_t,
       instanceVar_JTSSWS_t,
       instanceVar_JTSSWD_t,
       instanceVar_JTSSWGS_t,
       instanceVar_JTSSWGD_t,
       instanceVar_NJTS_t,
       instanceVar_NJTSD_t,
       instanceVar_NJTSSW_t,
       instanceVar_NJTSSWD_t,
       instanceVar_NJTSSWG_t,
       instanceVar_NJTSSWGD_t,
       instanceVar_q0,
       instanceVar_T11,
       instanceVar_T12,
       instanceVar_e0,
       instanceVar_e1,
       instanceVar_e2,
       instanceVar_scl,
       instanceVar_tmp,
       instanceVar_Theta_SCE,
       instanceVar_Theta_SW,
       instanceVar_Theta_DIBL,
       instanceVar_Theta_RSCE,
       instanceVar_Theta_DITS,
       instanceVar_veseff,
       instanceVar_Tcen0,
       instanceVar_Tcen,
       instanceVar_mx,
       instanceVar_mxprime,
       instanceVar_md,
       instanceVar_mdprime,
       instanceVar_gprime,
       instanceVar_gfactor,
       instanceVar_qis,
       instanceVar_qid,
       instanceVar_qbs,
       instanceVar_qba,
       instanceVar_u0r,
       instanceVar_UAR_t,
       instanceVar_UC_t,
       instanceVar_UCR_t,
       instanceVar_UDR_t,
       instanceVar_U0R_t,
       instanceVar_EeffFactor,
       instanceVar_Dr,
       instanceVar_WeffWRFactor,
       instanceVar_RSourceGeo,
       instanceVar_RDrainGeo,
       instanceVar_RDSWMIN_i,
       instanceVar_RDWMIN_i,
       instanceVar_RSWMIN_i,
       instanceVar_Rdrain,
       instanceVar_Rsource,
       instanceVar_Rdsi,
       instanceVar_RSDRR_t,
       instanceVar_RDDRR_t,
       instanceVar_VSAT1R_t,
       instanceVar_MEXPR_t,
       instanceVar_VSAT_a,
       instanceVar_Cfr_geo,
       instanceVar_ggeltd,
       instanceVar_igbinv,
       instanceVar_igsd_mult0,
       instanceVar_igbs,
       instanceVar_igbd,
       instanceVar_igbacc,
       instanceVar_igcs,
       instanceVar_igcd,
       instanceVar_igisl,
       instanceVar_igidl,
       instanceVar_igs,
       instanceVar_igd,
       instanceVar_Aechvb,
       instanceVar_Bechvb,
       instanceVar_Toxratio,
       instanceVar_Iii,
       instanceVar_cox_acc,
       instanceVar_qg_acc,
       instanceVar_qb_acc,
       instanceVar_qgs_fr,
       instanceVar_qgd_fr,
       instanceVar_qds_fr,
       instanceVar_qgs_parasitic,
       instanceVar_qgd_parasitic,
       instanceVar_Qes,
       instanceVar_Qed,
       instanceVar_Qeg,
       instanceVar_csbox,
       instanceVar_cdbox,
       instanceVar_cgbox,
       instanceVar_Ies,
       instanceVar_Ied,
       instanceVar_Czbs,
       instanceVar_Czbssw,
       instanceVar_Czbsswg,
       instanceVar_Czbd,
       instanceVar_Czbdsw,
       instanceVar_Czbdswg,
       instanceVar_Isbs,
       instanceVar_Isbd,
       instanceVar_Nvtms,
       instanceVar_Nvtmd,
       instanceVar_SslpRev,
       instanceVar_IVjsmRev,
       instanceVar_VjsmRev,
       instanceVar_SslpFwd,
       instanceVar_IVjsmFwd,
       instanceVar_VjsmFwd,
       instanceVar_XExpBVS,
       instanceVar_DslpRev,
       instanceVar_IVjdmRev,
       instanceVar_VjdmRev,
       instanceVar_DslpFwd,
       instanceVar_IVjdmFwd,
       instanceVar_VjdmFwd,
       instanceVar_XExpBVD,
       instanceVar_idsgen,
       instanceVar_LINTIGEN_i,
       instanceVar_LINTNOI_i,
       instanceVar_litl,
       instanceVar_FNPowerAt1Hz,
       instanceVar_NTNOI_i,
       instanceVar_Gtnoi,
       instanceVar_sid,
       instanceVar_gspr,
       instanceVar_gdpr,
       instanceVar_gamma,
       instanceVar_delta,
       instanceVar_ctnoi,
       instanceVar_C0,
       instanceVar_sf,
       instanceVar_gth,
       instanceVar_cth,
       instanceVar_PHIG_i,
       instanceVar_CFD_i,
       instanceVar_CFS_i,
       instanceVar_COVS_i,
       instanceVar_COVD_i,
       instanceVar_CGSO_i,
       instanceVar_CGDO_i,
       instanceVar_CGSL_i,
       instanceVar_CGDL_i,
       instanceVar_CGBL_i,
       instanceVar_CKAPPAS_i,
       instanceVar_CKAPPAD_i,
       instanceVar_CKAPPAB_i,
       instanceVar_QMFACTOR_i,
       instanceVar_QMTCENCV_i,
       instanceVar_QMTCENCVA_i,
       instanceVar_KSATIV_i,
       instanceVar_KSATIVR_i,
       instanceVar_CDSC_i,
       instanceVar_CDSCD_i,
       instanceVar_CDSCDR_i,
       instanceVar_CIT_i,
       instanceVar_DVT0_i,
       instanceVar_CITR_i,
       instanceVar_PHIN_i,
       instanceVar_ETA0_i,
       instanceVar_ETA0R_i,
       instanceVar_VSAT_i,
       instanceVar_VSATR_i,
       instanceVar_VSATR_t,
       instanceVar_DVTP0_i,
       instanceVar_DVTP1_i,
       instanceVar_K0_i,
       instanceVar_K01_i,
       instanceVar_K0SI_i,
       instanceVar_K0SI1_i,
       instanceVar_K2SI_i,
       instanceVar_K2SI1_i,
       instanceVar_PHIBE_i,
       instanceVar_K1_i,
       instanceVar_K11_i,
       instanceVar_K2SAT_i,
       instanceVar_K2SAT1_i,
       instanceVar_DELTAVSAT_i,
       instanceVar_PSAT_i,
       instanceVar_DELTAVSATCV_i,
       instanceVar_PSATCV_i,
       instanceVar_VSAT1_i,
       instanceVar_VSAT1R_i,
       instanceVar_PTWG_i,
       instanceVar_PTWGR_i,
       instanceVar_VSATCV_i,
       instanceVar_U0_i,
       instanceVar_U0R_i,
       instanceVar_ETAMOB_i,
       instanceVar_RDSW_i,
       instanceVar_PRWGS_i,
       instanceVar_PRWGD_i,
       instanceVar_PDIBL1_i,
       instanceVar_PDIBL1R_i,
       instanceVar_PDIBL2_i,
       instanceVar_PDIBL2R_i,
       instanceVar_DROUT_i,
       instanceVar_PVAG_i,
       instanceVar_AIGBINV_i,
       instanceVar_AIGBINV1_i,
       instanceVar_BIGBINV_i,
       instanceVar_CIGBINV_i,
       instanceVar_EIGBINV_i,
       instanceVar_NIGBINV_i,
       instanceVar_AIGBACC_i,
       instanceVar_AIGBACC1_i,
       instanceVar_BIGBACC_i,
       instanceVar_CIGBACC_i,
       instanceVar_NIGBACC_i,
       instanceVar_AIGC_i,
       instanceVar_AIGC1_i,
       instanceVar_BIGC_i,
       instanceVar_CIGC_i,
       instanceVar_PIGCD_i,
       instanceVar_AIGS_i,
       instanceVar_AIGS1_i,
       instanceVar_BIGS_i,
       instanceVar_CIGS_i,
       instanceVar_POXEDGE_i,
       instanceVar_AIGD_i,
       instanceVar_AIGD1_i,
       instanceVar_BIGD_i,
       instanceVar_CIGD_i,
       instanceVar_AGIDL_i,
       instanceVar_BGIDL_i,
       instanceVar_CGIDL_i,
       instanceVar_EGIDL_i,
       instanceVar_PGIDL_i,
       instanceVar_AGISL_i,
       instanceVar_BGISL_i,
       instanceVar_CGISL_i,
       instanceVar_EGISL_i,
       instanceVar_PGISL_i,
       instanceVar_ALPHA0_i,
       instanceVar_ALPHA1_i,
       instanceVar_ALPHAII0_i,
       instanceVar_ALPHAII1_i,
       instanceVar_BETA0_i,
       instanceVar_BETAII0_i,
       instanceVar_BETAII1_i,
       instanceVar_BETAII2_i,
       instanceVar_ESATII_i,
       instanceVar_LII_i,
       instanceVar_SII0_i,
       instanceVar_SII1_i,
       instanceVar_SII2_i,
       instanceVar_SIID_i,
       instanceVar_TII_i,
       instanceVar_MEXP_i,
       instanceVar_MEXPR_i,
       instanceVar_PCLM_i,
       instanceVar_PCLMG_i,
       instanceVar_PCLMCV_i,
       instanceVar_PCLMR_i,
       instanceVar_A1_i,
       instanceVar_A2_i,
       instanceVar_A11_i,
       instanceVar_A21_i,
       instanceVar_K1RSCE_i,
       instanceVar_DVTSHIFT_i,
       instanceVar_DVTSHIFTR_i,
       instanceVar_UA_i,
       instanceVar_UC_i,
       instanceVar_EU_i,
       instanceVar_UD_i,
       instanceVar_UCS_i,
       instanceVar_UAR_i,
       instanceVar_EUR_i,
       instanceVar_UCR_i,
       instanceVar_UDR_i,
       instanceVar_UA1_i,
       instanceVar_UA1R_i,
       instanceVar_UC1_i,
       instanceVar_UD1_i,
       instanceVar_UCSTE_i,
       instanceVar_UTE_i,
       instanceVar_UTL_i,
       instanceVar_EMOBT_i,
       instanceVar_UC1R_i,
       instanceVar_UD1R_i,
       instanceVar_UTER_i,
       instanceVar_UTLR_i,
       instanceVar_PTWGT_i,
       instanceVar_AT_i,
       instanceVar_ATCV_i,
       instanceVar_ATR_i,
       instanceVar_RDW_i,
       instanceVar_RSW_i,
       instanceVar_PRT_i,
       instanceVar_KT1_i,
       instanceVar_TSS_i,
       instanceVar_IIT_i,
       instanceVar_IGT_i,
       instanceVar_TGIDL_i,
       instanceVar_NTGEN_i,
       instanceVar_AIGEN_i,
       instanceVar_BIGEN_i,
       instanceVar_K0SISAT_i,
       instanceVar_K0SISAT1_i,
       instanceVar_K2SISAT_i,
       instanceVar_K2SISAT1_i,
       instanceVar_K2_i,
       instanceVar_K21_i,
       instanceVar_Cins,
       instanceVar_Ach,
       instanceVar_Weff_UFCM,
       instanceVar_qdep,
       instanceVar_rc,
       instanceVar_vth_fixed_factor_Sub,
       instanceVar_vth_fixed_factor_SI,
       instanceVar_qm,
       instanceVar_Qdep_ov_Cins,
       instanceVar_qi_acc_for_QM,
       instanceVar_fieldnormalizationfactor,
       instanceVar_auxQMfact,
       instanceVar_QMFACTORCVfinal,
       instanceVar_psipclamp,
       instanceVar_sqrtpsip,
       instanceVar_nq,
       instanceVar_F0,
       // non-reals
       instanceVar_devsign,
       // model parameters
       // reals
       modelPar_L,
       modelPar_given_L,
       modelPar_D,
       modelPar_given_D,
       modelPar_TFIN,
       modelPar_given_TFIN,
       modelPar_FPITCH,
       modelPar_given_FPITCH,
       modelPar_NFIN,
       modelPar_given_NFIN,
       modelPar_ASEO,
       modelPar_given_ASEO,
       modelPar_ADEO,
       modelPar_given_ADEO,
       modelPar_PSEO,
       modelPar_given_PSEO,
       modelPar_PDEO,
       modelPar_given_PDEO,
       modelPar_ASEJ,
       modelPar_given_ASEJ,
       modelPar_ADEJ,
       modelPar_given_ADEJ,
       modelPar_PSEJ,
       modelPar_given_PSEJ,
       modelPar_PDEJ,
       modelPar_given_PDEJ,
       modelPar_COVS,
       modelPar_given_COVS,
       modelPar_COVD,
       modelPar_given_COVD,
       modelPar_CGSP,
       modelPar_given_CGSP,
       modelPar_CGDP,
       modelPar_given_CGDP,
       modelPar_CDSP,
       modelPar_given_CDSP,
       modelPar_NRS,
       modelPar_given_NRS,
       modelPar_NRD,
       modelPar_given_NRD,
       modelPar_LRSD,
       modelPar_given_LRSD,
       modelPar_XL,
       modelPar_given_XL,
       modelPar_DTEMP,
       modelPar_given_DTEMP,
       modelPar_DELVTRAND,
       modelPar_given_DELVTRAND,
       modelPar_U0MULT,
       modelPar_given_U0MULT,
       modelPar_IDS0MULT,
       modelPar_given_IDS0MULT,
       modelPar_LINT,
       modelPar_given_LINT,
       modelPar_LL,
       modelPar_given_LL,
       modelPar_LLN,
       modelPar_given_LLN,
       modelPar_DLC,
       modelPar_given_DLC,
       modelPar_DLCACC,
       modelPar_given_DLCACC,
       modelPar_DLBIN,
       modelPar_given_DLBIN,
       modelPar_LLC,
       modelPar_given_LLC,
       modelPar_EOT,
       modelPar_given_EOT,
       modelPar_TOXP,
       modelPar_given_TOXP,
       modelPar_EOTBOX,
       modelPar_given_EOTBOX,
       modelPar_HFIN,
       modelPar_given_HFIN,
       modelPar_FECH,
       modelPar_given_FECH,
       modelPar_DELTAW,
       modelPar_given_DELTAW,
       modelPar_FECHCV,
       modelPar_given_FECHCV,
       modelPar_DELTAWCV,
       modelPar_given_DELTAWCV,
       modelPar_NBODY,
       modelPar_given_NBODY,
       modelPar_NBODYN1,
       modelPar_given_NBODYN1,
       modelPar_NBODYN2,
       modelPar_given_NBODYN2,
       modelPar_NSD,
       modelPar_given_NSD,
       modelPar_PHIG,
       modelPar_given_PHIG,
       modelPar_PHIGL,
       modelPar_given_PHIGL,
       modelPar_PHIGLT,
       modelPar_given_PHIGLT,
       modelPar_PHIGN1,
       modelPar_given_PHIGN1,
       modelPar_PHIGN2,
       modelPar_given_PHIGN2,
       modelPar_EPSROX,
       modelPar_given_EPSROX,
       modelPar_EPSRSUB,
       modelPar_given_EPSRSUB,
       modelPar_EASUB,
       modelPar_given_EASUB,
       modelPar_NI0SUB,
       modelPar_given_NI0SUB,
       modelPar_BG0SUB,
       modelPar_given_BG0SUB,
       modelPar_NC0SUB,
       modelPar_given_NC0SUB,
       modelPar_NGATE,
       modelPar_given_NGATE,
       modelPar_Imin,
       modelPar_given_Imin,
       modelPar_CIT,
       modelPar_given_CIT,
       modelPar_CITR,
       modelPar_given_CITR,
       modelPar_CDSC,
       modelPar_given_CDSC,
       modelPar_CDSCN1,
       modelPar_given_CDSCN1,
       modelPar_CDSCN2,
       modelPar_given_CDSCN2,
       modelPar_CDSCD,
       modelPar_given_CDSCD,
       modelPar_CDSCDN1,
       modelPar_given_CDSCDN1,
       modelPar_CDSCDN2,
       modelPar_given_CDSCDN2,
       modelPar_CDSCDR,
       modelPar_given_CDSCDR,
       modelPar_CDSCDRN1,
       modelPar_given_CDSCDRN1,
       modelPar_CDSCDRN2,
       modelPar_given_CDSCDRN2,
       modelPar_DVT0,
       modelPar_given_DVT0,
       modelPar_DVT1,
       modelPar_given_DVT1,
       modelPar_DVT1SS,
       modelPar_given_DVT1SS,
       modelPar_PHIN,
       modelPar_given_PHIN,
       modelPar_ETA0,
       modelPar_given_ETA0,
       modelPar_ETA0N1,
       modelPar_given_ETA0N1,
       modelPar_ETA0N2,
       modelPar_given_ETA0N2,
       modelPar_ETA0LT,
       modelPar_given_ETA0LT,
       modelPar_TETA0,
       modelPar_given_TETA0,
       modelPar_ETA0R,
       modelPar_given_ETA0R,
       modelPar_TETA0R,
       modelPar_given_TETA0R,
       modelPar_DSUB,
       modelPar_given_DSUB,
       modelPar_DVTP0,
       modelPar_given_DVTP0,
       modelPar_DVTP1,
       modelPar_given_DVTP1,
       modelPar_ADVTP0,
       modelPar_given_ADVTP0,
       modelPar_BDVTP0,
       modelPar_given_BDVTP0,
       modelPar_ADVTP1,
       modelPar_given_ADVTP1,
       modelPar_BDVTP1,
       modelPar_given_BDVTP1,
       modelPar_DVTP2,
       modelPar_given_DVTP2,
       modelPar_K1RSCE,
       modelPar_given_K1RSCE,
       modelPar_LPE0,
       modelPar_given_LPE0,
       modelPar_DVTSHIFT,
       modelPar_given_DVTSHIFT,
       modelPar_DVTSHIFTR,
       modelPar_given_DVTSHIFTR,
       modelPar_THETASCE,
       modelPar_given_THETASCE,
       modelPar_THETADIBL,
       modelPar_given_THETADIBL,
       modelPar_THETASW,
       modelPar_given_THETASW,
       modelPar_NVTM,
       modelPar_given_NVTM,
       modelPar_K0,
       modelPar_given_K0,
       modelPar_K01,
       modelPar_given_K01,
       modelPar_K0SI,
       modelPar_given_K0SI,
       modelPar_K0SI1,
       modelPar_given_K0SI1,
       modelPar_K2SI,
       modelPar_given_K2SI,
       modelPar_K2SI1,
       modelPar_given_K2SI1,
       modelPar_K0SISAT,
       modelPar_given_K0SISAT,
       modelPar_K0SISAT1,
       modelPar_given_K0SISAT1,
       modelPar_K2SISAT,
       modelPar_given_K2SISAT,
       modelPar_K2SISAT1,
       modelPar_given_K2SISAT1,
       modelPar_PHIBE,
       modelPar_given_PHIBE,
       modelPar_K1,
       modelPar_given_K1,
       modelPar_K11,
       modelPar_given_K11,
       modelPar_K2SAT,
       modelPar_given_K2SAT,
       modelPar_K2SAT1,
       modelPar_given_K2SAT1,
       modelPar_K2,
       modelPar_given_K2,
       modelPar_K21,
       modelPar_given_K21,
       modelPar_QMFACTOR,
       modelPar_given_QMFACTOR,
       modelPar_QMTCENCV,
       modelPar_given_QMTCENCV,
       modelPar_QMTCENCVA,
       modelPar_given_QMTCENCVA,
       modelPar_AQMTCEN,
       modelPar_given_AQMTCEN,
       modelPar_BQMTCEN,
       modelPar_given_BQMTCEN,
       modelPar_ETAQM,
       modelPar_given_ETAQM,
       modelPar_QM0,
       modelPar_given_QM0,
       modelPar_PQM,
       modelPar_given_PQM,
       modelPar_QM0ACC,
       modelPar_given_QM0ACC,
       modelPar_PQMACC,
       modelPar_given_PQMACC,
       modelPar_VSAT,
       modelPar_given_VSAT,
       modelPar_VSATR,
       modelPar_given_VSATR,
       modelPar_VSATN1,
       modelPar_given_VSATN1,
       modelPar_VSATN2,
       modelPar_given_VSATN2,
       modelPar_VSATRN1,
       modelPar_given_VSATRN1,
       modelPar_VSATRN2,
       modelPar_given_VSATRN2,
       modelPar_AVSAT,
       modelPar_given_AVSAT,
       modelPar_BVSAT,
       modelPar_given_BVSAT,
       modelPar_VSAT1,
       modelPar_given_VSAT1,
       modelPar_VSAT1N1,
       modelPar_given_VSAT1N1,
       modelPar_VSAT1N2,
       modelPar_given_VSAT1N2,
       modelPar_VSAT1R,
       modelPar_given_VSAT1R,
       modelPar_VSAT1RN1,
       modelPar_given_VSAT1RN1,
       modelPar_VSAT1RN2,
       modelPar_given_VSAT1RN2,
       modelPar_AVSAT1,
       modelPar_given_AVSAT1,
       modelPar_BVSAT1,
       modelPar_given_BVSAT1,
       modelPar_DELTAVSAT,
       modelPar_given_DELTAVSAT,
       modelPar_PSAT,
       modelPar_given_PSAT,
       modelPar_APSAT,
       modelPar_given_APSAT,
       modelPar_BPSAT,
       modelPar_given_BPSAT,
       modelPar_KSATIV,
       modelPar_given_KSATIV,
       modelPar_KSATIVR,
       modelPar_given_KSATIVR,
       modelPar_VSATCV,
       modelPar_given_VSATCV,
       modelPar_AVSATCV,
       modelPar_given_AVSATCV,
       modelPar_BVSATCV,
       modelPar_given_BVSATCV,
       modelPar_DELTAVSATCV,
       modelPar_given_DELTAVSATCV,
       modelPar_PSATCV,
       modelPar_given_PSATCV,
       modelPar_APSATCV,
       modelPar_given_APSATCV,
       modelPar_BPSATCV,
       modelPar_given_BPSATCV,
       modelPar_MEXP,
       modelPar_given_MEXP,
       modelPar_AMEXP,
       modelPar_given_AMEXP,
       modelPar_BMEXP,
       modelPar_given_BMEXP,
       modelPar_MEXPR,
       modelPar_given_MEXPR,
       modelPar_AMEXPR,
       modelPar_given_AMEXPR,
       modelPar_BMEXPR,
       modelPar_given_BMEXPR,
       modelPar_PTWG,
       modelPar_given_PTWG,
       modelPar_PTWGR,
       modelPar_given_PTWGR,
       modelPar_APTWG,
       modelPar_given_APTWG,
       modelPar_BPTWG,
       modelPar_given_BPTWG,
       modelPar_AT,
       modelPar_given_AT,
       modelPar_ATR,
       modelPar_given_ATR,
       modelPar_ATCV,
       modelPar_given_ATCV,
       modelPar_TMEXP,
       modelPar_given_TMEXP,
       modelPar_TMEXPR,
       modelPar_given_TMEXPR,
       modelPar_PTWGT,
       modelPar_given_PTWGT,
       modelPar_U0,
       modelPar_given_U0,
       modelPar_U0R,
       modelPar_given_U0R,
       modelPar_U0N1,
       modelPar_given_U0N1,
       modelPar_U0N1R,
       modelPar_given_U0N1R,
       modelPar_U0N2,
       modelPar_given_U0N2,
       modelPar_U0N2R,
       modelPar_given_U0N2R,
       modelPar_U0LT,
       modelPar_given_U0LT,
       modelPar_ETAMOB,
       modelPar_given_ETAMOB,
       modelPar_UP,
       modelPar_given_UP,
       modelPar_LPA,
       modelPar_given_LPA,
       modelPar_UPR,
       modelPar_given_UPR,
       modelPar_LPAR,
       modelPar_given_LPAR,
       modelPar_UA,
       modelPar_given_UA,
       modelPar_UAR,
       modelPar_given_UAR,
       modelPar_AUA,
       modelPar_given_AUA,
       modelPar_AUAR,
       modelPar_given_AUAR,
       modelPar_BUA,
       modelPar_given_BUA,
       modelPar_BUAR,
       modelPar_given_BUAR,
       modelPar_UC,
       modelPar_given_UC,
       modelPar_UCR,
       modelPar_given_UCR,
       modelPar_EU,
       modelPar_given_EU,
       modelPar_EUR,
       modelPar_given_EUR,
       modelPar_AEU,
       modelPar_given_AEU,
       modelPar_AEUR,
       modelPar_given_AEUR,
       modelPar_BEU,
       modelPar_given_BEU,
       modelPar_BEUR,
       modelPar_given_BEUR,
       modelPar_UD,
       modelPar_given_UD,
       modelPar_UDR,
       modelPar_given_UDR,
       modelPar_AUD,
       modelPar_given_AUD,
       modelPar_AUDR,
       modelPar_given_AUDR,
       modelPar_BUD,
       modelPar_given_BUD,
       modelPar_BUDR,
       modelPar_given_BUDR,
       modelPar_UCS,
       modelPar_given_UCS,
       modelPar_UTE,
       modelPar_given_UTE,
       modelPar_UTER,
       modelPar_given_UTER,
       modelPar_UTL,
       modelPar_given_UTL,
       modelPar_UTLR,
       modelPar_given_UTLR,
       modelPar_EMOBT,
       modelPar_given_EMOBT,
       modelPar_UA1,
       modelPar_given_UA1,
       modelPar_UA1R,
       modelPar_given_UA1R,
       modelPar_UC1,
       modelPar_given_UC1,
       modelPar_UC1R,
       modelPar_given_UC1R,
       modelPar_UD1,
       modelPar_given_UD1,
       modelPar_UD1R,
       modelPar_given_UD1R,
       modelPar_UCSTE,
       modelPar_given_UCSTE,
       modelPar_CHARGEWF,
       modelPar_given_CHARGEWF,
       modelPar_RDSWMIN,
       modelPar_given_RDSWMIN,
       modelPar_RDSW,
       modelPar_given_RDSW,
       modelPar_ARDSW,
       modelPar_given_ARDSW,
       modelPar_BRDSW,
       modelPar_given_BRDSW,
       modelPar_RSWMIN,
       modelPar_given_RSWMIN,
       modelPar_RSW,
       modelPar_given_RSW,
       modelPar_ARSW,
       modelPar_given_ARSW,
       modelPar_BRSW,
       modelPar_given_BRSW,
       modelPar_RDWMIN,
       modelPar_given_RDWMIN,
       modelPar_RDW,
       modelPar_given_RDW,
       modelPar_ARDW,
       modelPar_given_ARDW,
       modelPar_BRDW,
       modelPar_given_BRDW,
       modelPar_RSDR,
       modelPar_given_RSDR,
       modelPar_RSDRR,
       modelPar_given_RSDRR,
       modelPar_RDDR,
       modelPar_given_RDDR,
       modelPar_RDDRR,
       modelPar_given_RDDRR,
       modelPar_PRSDR,
       modelPar_given_PRSDR,
       modelPar_PRDDR,
       modelPar_given_PRDDR,
       modelPar_PRWGS,
       modelPar_given_PRWGS,
       modelPar_PRWGD,
       modelPar_given_PRWGD,
       modelPar_WR,
       modelPar_given_WR,
       modelPar_PRT,
       modelPar_given_PRT,
       modelPar_TRSDR,
       modelPar_given_TRSDR,
       modelPar_TRDDR,
       modelPar_given_TRDDR,
       modelPar_PDIBL1,
       modelPar_given_PDIBL1,
       modelPar_PDIBL1R,
       modelPar_given_PDIBL1R,
       modelPar_PDIBL2,
       modelPar_given_PDIBL2,
       modelPar_PDIBL2R,
       modelPar_given_PDIBL2R,
       modelPar_DROUT,
       modelPar_given_DROUT,
       modelPar_PVAG,
       modelPar_given_PVAG,
       modelPar_PCLM,
       modelPar_given_PCLM,
       modelPar_PCLMR,
       modelPar_given_PCLMR,
       modelPar_APCLM,
       modelPar_given_APCLM,
       modelPar_APCLMR,
       modelPar_given_APCLMR,
       modelPar_BPCLM,
       modelPar_given_BPCLM,
       modelPar_BPCLMR,
       modelPar_given_BPCLMR,
       modelPar_PCLMG,
       modelPar_given_PCLMG,
       modelPar_PCLMCV,
       modelPar_given_PCLMCV,
       modelPar_A1,
       modelPar_given_A1,
       modelPar_A11,
       modelPar_given_A11,
       modelPar_A2,
       modelPar_given_A2,
       modelPar_A21,
       modelPar_given_A21,
       modelPar_RGEXT,
       modelPar_given_RGEXT,
       modelPar_RGFIN,
       modelPar_given_RGFIN,
       modelPar_RSHS,
       modelPar_given_RSHS,
       modelPar_RSHD,
       modelPar_given_RSHD,
       modelPar_HEPI,
       modelPar_given_HEPI,
       modelPar_TSILI,
       modelPar_given_TSILI,
       modelPar_RHOC,
       modelPar_given_RHOC,
       modelPar_RHORSD,
       modelPar_given_RHORSD,
       modelPar_CRATIO,
       modelPar_given_CRATIO,
       modelPar_DELTAPRSD,
       modelPar_given_DELTAPRSD,
       modelPar_LSP,
       modelPar_given_LSP,
       modelPar_EPSRSP,
       modelPar_given_EPSRSP,
       modelPar_TGATE,
       modelPar_given_TGATE,
       modelPar_TMASK,
       modelPar_given_TMASK,
       modelPar_ASILIEND,
       modelPar_given_ASILIEND,
       modelPar_ARSDEND,
       modelPar_given_ARSDEND,
       modelPar_PRSDEND,
       modelPar_given_PRSDEND,
       modelPar_NSDE,
       modelPar_given_NSDE,
       modelPar_RGEOA,
       modelPar_given_RGEOA,
       modelPar_RGEOB,
       modelPar_given_RGEOB,
       modelPar_RGEOC,
       modelPar_given_RGEOC,
       modelPar_RGEOD,
       modelPar_given_RGEOD,
       modelPar_RGEOE,
       modelPar_given_RGEOE,
       modelPar_CGEOA,
       modelPar_given_CGEOA,
       modelPar_CGEOB,
       modelPar_given_CGEOB,
       modelPar_CGEOC,
       modelPar_given_CGEOC,
       modelPar_CGEOD,
       modelPar_given_CGEOD,
       modelPar_CGEOE,
       modelPar_given_CGEOE,
       modelPar_AIGBINV,
       modelPar_given_AIGBINV,
       modelPar_AIGBINV1,
       modelPar_given_AIGBINV1,
       modelPar_BIGBINV,
       modelPar_given_BIGBINV,
       modelPar_CIGBINV,
       modelPar_given_CIGBINV,
       modelPar_EIGBINV,
       modelPar_given_EIGBINV,
       modelPar_NIGBINV,
       modelPar_given_NIGBINV,
       modelPar_AIGBACC,
       modelPar_given_AIGBACC,
       modelPar_AIGBACC1,
       modelPar_given_AIGBACC1,
       modelPar_BIGBACC,
       modelPar_given_BIGBACC,
       modelPar_CIGBACC,
       modelPar_given_CIGBACC,
       modelPar_NIGBACC,
       modelPar_given_NIGBACC,
       modelPar_AIGC,
       modelPar_given_AIGC,
       modelPar_AIGC1,
       modelPar_given_AIGC1,
       modelPar_BIGC,
       modelPar_given_BIGC,
       modelPar_CIGC,
       modelPar_given_CIGC,
       modelPar_PIGCD,
       modelPar_given_PIGCD,
       modelPar_DLCIGS,
       modelPar_given_DLCIGS,
       modelPar_AIGS,
       modelPar_given_AIGS,
       modelPar_AIGS1,
       modelPar_given_AIGS1,
       modelPar_BIGS,
       modelPar_given_BIGS,
       modelPar_CIGS,
       modelPar_given_CIGS,
       modelPar_DLCIGD,
       modelPar_given_DLCIGD,
       modelPar_AIGD,
       modelPar_given_AIGD,
       modelPar_AIGD1,
       modelPar_given_AIGD1,
       modelPar_BIGD,
       modelPar_given_BIGD,
       modelPar_CIGD,
       modelPar_given_CIGD,
       modelPar_VFBSD,
       modelPar_given_VFBSD,
       modelPar_VFBSDCV,
       modelPar_given_VFBSDCV,
       modelPar_TOXREF,
       modelPar_given_TOXREF,
       modelPar_TOXG,
       modelPar_given_TOXG,
       modelPar_NTOX,
       modelPar_given_NTOX,
       modelPar_POXEDGE,
       modelPar_given_POXEDGE,
       modelPar_AGISL,
       modelPar_given_AGISL,
       modelPar_BGISL,
       modelPar_given_BGISL,
       modelPar_CGISL,
       modelPar_given_CGISL,
       modelPar_EGISL,
       modelPar_given_EGISL,
       modelPar_PGISL,
       modelPar_given_PGISL,
       modelPar_AGIDL,
       modelPar_given_AGIDL,
       modelPar_BGIDL,
       modelPar_given_BGIDL,
       modelPar_CGIDL,
       modelPar_given_CGIDL,
       modelPar_EGIDL,
       modelPar_given_EGIDL,
       modelPar_PGIDL,
       modelPar_given_PGIDL,
       modelPar_ALPHA0,
       modelPar_given_ALPHA0,
       modelPar_ALPHA01,
       modelPar_given_ALPHA01,
       modelPar_ALPHA1,
       modelPar_given_ALPHA1,
       modelPar_ALPHA11,
       modelPar_given_ALPHA11,
       modelPar_BETA0,
       modelPar_given_BETA0,
       modelPar_ALPHAII0,
       modelPar_given_ALPHAII0,
       modelPar_ALPHAII01,
       modelPar_given_ALPHAII01,
       modelPar_ALPHAII1,
       modelPar_given_ALPHAII1,
       modelPar_ALPHAII11,
       modelPar_given_ALPHAII11,
       modelPar_BETAII0,
       modelPar_given_BETAII0,
       modelPar_BETAII1,
       modelPar_given_BETAII1,
       modelPar_BETAII2,
       modelPar_given_BETAII2,
       modelPar_ESATII,
       modelPar_given_ESATII,
       modelPar_LII,
       modelPar_given_LII,
       modelPar_SII0,
       modelPar_given_SII0,
       modelPar_SII1,
       modelPar_given_SII1,
       modelPar_SII2,
       modelPar_given_SII2,
       modelPar_SIID,
       modelPar_given_SIID,
       modelPar_IIMOD2CLAMP1,
       modelPar_given_IIMOD2CLAMP1,
       modelPar_IIMOD2CLAMP2,
       modelPar_given_IIMOD2CLAMP2,
       modelPar_IIMOD2CLAMP3,
       modelPar_given_IIMOD2CLAMP3,
       modelPar_EOTACC,
       modelPar_given_EOTACC,
       modelPar_DELVFBACC,
       modelPar_given_DELVFBACC,
       modelPar_CFS,
       modelPar_given_CFS,
       modelPar_CFD,
       modelPar_given_CFD,
       modelPar_CGSO,
       modelPar_given_CGSO,
       modelPar_CGDO,
       modelPar_given_CGDO,
       modelPar_CGSL,
       modelPar_given_CGSL,
       modelPar_CGDL,
       modelPar_given_CGDL,
       modelPar_CKAPPAS,
       modelPar_given_CKAPPAS,
       modelPar_CKAPPAD,
       modelPar_given_CKAPPAD,
       modelPar_CGBO,
       modelPar_given_CGBO,
       modelPar_CGBN,
       modelPar_given_CGBN,
       modelPar_CGBL,
       modelPar_given_CGBL,
       modelPar_CKAPPAB,
       modelPar_given_CKAPPAB,
       modelPar_CSDESW,
       modelPar_given_CSDESW,
       modelPar_CJS,
       modelPar_given_CJS,
       modelPar_CJD,
       modelPar_given_CJD,
       modelPar_CJSWS,
       modelPar_given_CJSWS,
       modelPar_CJSWD,
       modelPar_given_CJSWD,
       modelPar_CJSWGS,
       modelPar_given_CJSWGS,
       modelPar_CJSWGD,
       modelPar_given_CJSWGD,
       modelPar_PBS,
       modelPar_given_PBS,
       modelPar_PBD,
       modelPar_given_PBD,
       modelPar_PBSWS,
       modelPar_given_PBSWS,
       modelPar_PBSWD,
       modelPar_given_PBSWD,
       modelPar_PBSWGS,
       modelPar_given_PBSWGS,
       modelPar_PBSWGD,
       modelPar_given_PBSWGD,
       modelPar_MJS,
       modelPar_given_MJS,
       modelPar_MJD,
       modelPar_given_MJD,
       modelPar_MJSWS,
       modelPar_given_MJSWS,
       modelPar_MJSWD,
       modelPar_given_MJSWD,
       modelPar_MJSWGS,
       modelPar_given_MJSWGS,
       modelPar_MJSWGD,
       modelPar_given_MJSWGD,
       modelPar_SJS,
       modelPar_given_SJS,
       modelPar_SJD,
       modelPar_given_SJD,
       modelPar_SJSWS,
       modelPar_given_SJSWS,
       modelPar_SJSWD,
       modelPar_given_SJSWD,
       modelPar_SJSWGS,
       modelPar_given_SJSWGS,
       modelPar_SJSWGD,
       modelPar_given_SJSWGD,
       modelPar_MJS2,
       modelPar_given_MJS2,
       modelPar_MJD2,
       modelPar_given_MJD2,
       modelPar_MJSWS2,
       modelPar_given_MJSWS2,
       modelPar_MJSWD2,
       modelPar_given_MJSWD2,
       modelPar_MJSWGS2,
       modelPar_given_MJSWGS2,
       modelPar_MJSWGD2,
       modelPar_given_MJSWGD2,
       modelPar_JSS,
       modelPar_given_JSS,
       modelPar_JSD,
       modelPar_given_JSD,
       modelPar_JSWS,
       modelPar_given_JSWS,
       modelPar_JSWD,
       modelPar_given_JSWD,
       modelPar_JSWGS,
       modelPar_given_JSWGS,
       modelPar_JSWGD,
       modelPar_given_JSWGD,
       modelPar_NJS,
       modelPar_given_NJS,
       modelPar_NJD,
       modelPar_given_NJD,
       modelPar_IJTHSFWD,
       modelPar_given_IJTHSFWD,
       modelPar_IJTHDFWD,
       modelPar_given_IJTHDFWD,
       modelPar_IJTHSREV,
       modelPar_given_IJTHSREV,
       modelPar_IJTHDREV,
       modelPar_given_IJTHDREV,
       modelPar_BVS,
       modelPar_given_BVS,
       modelPar_BVD,
       modelPar_given_BVD,
       modelPar_XJBVS,
       modelPar_given_XJBVS,
       modelPar_XJBVD,
       modelPar_given_XJBVD,
       modelPar_JTSS,
       modelPar_given_JTSS,
       modelPar_JTSD,
       modelPar_given_JTSD,
       modelPar_JTSSWS,
       modelPar_given_JTSSWS,
       modelPar_JTSSWD,
       modelPar_given_JTSSWD,
       modelPar_JTSSWGS,
       modelPar_given_JTSSWGS,
       modelPar_JTSSWGD,
       modelPar_given_JTSSWGD,
       modelPar_JTWEFF,
       modelPar_given_JTWEFF,
       modelPar_NJTS,
       modelPar_given_NJTS,
       modelPar_NJTSD,
       modelPar_given_NJTSD,
       modelPar_NJTSSW,
       modelPar_given_NJTSSW,
       modelPar_NJTSSWD,
       modelPar_given_NJTSSWD,
       modelPar_NJTSSWG,
       modelPar_given_NJTSSWG,
       modelPar_NJTSSWGD,
       modelPar_given_NJTSSWGD,
       modelPar_VTSS,
       modelPar_given_VTSS,
       modelPar_VTSD,
       modelPar_given_VTSD,
       modelPar_VTSSWS,
       modelPar_given_VTSSWS,
       modelPar_VTSSWD,
       modelPar_given_VTSSWD,
       modelPar_VTSSWGS,
       modelPar_given_VTSSWGS,
       modelPar_VTSSWGD,
       modelPar_given_VTSSWGD,
       modelPar_LINTIGEN,
       modelPar_given_LINTIGEN,
       modelPar_NTGEN,
       modelPar_given_NTGEN,
       modelPar_AIGEN,
       modelPar_given_AIGEN,
       modelPar_BIGEN,
       modelPar_given_BIGEN,
       modelPar_XRCRG1,
       modelPar_given_XRCRG1,
       modelPar_XRCRG2,
       modelPar_given_XRCRG2,
       modelPar_EF,
       modelPar_given_EF,
       modelPar_EM,
       modelPar_given_EM,
       modelPar_NOIA,
       modelPar_given_NOIA,
       modelPar_NOIB,
       modelPar_given_NOIB,
       modelPar_NOIC,
       modelPar_given_NOIC,
       modelPar_LINTNOI,
       modelPar_given_LINTNOI,
       modelPar_NTNOI,
       modelPar_given_NTNOI,
       modelPar_TNOIA,
       modelPar_given_TNOIA,
       modelPar_TNOIB,
       modelPar_given_TNOIB,
       modelPar_RNOIA,
       modelPar_given_RNOIA,
       modelPar_RNOIB,
       modelPar_given_RNOIB,
       modelPar_TNOIC,
       modelPar_given_TNOIC,
       modelPar_RNOIC,
       modelPar_given_RNOIC,
       modelPar_SCALEN,
       modelPar_given_SCALEN,
       modelPar_TNOM,
       modelPar_given_TNOM,
       modelPar_TBGASUB,
       modelPar_given_TBGASUB,
       modelPar_TBGBSUB,
       modelPar_given_TBGBSUB,
       modelPar_KT1,
       modelPar_given_KT1,
       modelPar_KT1L,
       modelPar_given_KT1L,
       modelPar_TSS,
       modelPar_given_TSS,
       modelPar_IIT,
       modelPar_given_IIT,
       modelPar_TII,
       modelPar_given_TII,
       modelPar_TGIDL,
       modelPar_given_TGIDL,
       modelPar_IGT,
       modelPar_given_IGT,
       modelPar_TCJ,
       modelPar_given_TCJ,
       modelPar_TCJSW,
       modelPar_given_TCJSW,
       modelPar_TCJSWG,
       modelPar_given_TCJSWG,
       modelPar_TPB,
       modelPar_given_TPB,
       modelPar_TPBSW,
       modelPar_given_TPBSW,
       modelPar_TPBSWG,
       modelPar_given_TPBSWG,
       modelPar_XTIS,
       modelPar_given_XTIS,
       modelPar_XTID,
       modelPar_given_XTID,
       modelPar_XTSS,
       modelPar_given_XTSS,
       modelPar_XTSD,
       modelPar_given_XTSD,
       modelPar_XTSSWS,
       modelPar_given_XTSSWS,
       modelPar_XTSSWD,
       modelPar_given_XTSSWD,
       modelPar_XTSSWGS,
       modelPar_given_XTSSWGS,
       modelPar_XTSSWGD,
       modelPar_given_XTSSWGD,
       modelPar_TNJTS,
       modelPar_given_TNJTS,
       modelPar_TNJTSD,
       modelPar_given_TNJTSD,
       modelPar_TNJTSSW,
       modelPar_given_TNJTSSW,
       modelPar_TNJTSSWD,
       modelPar_given_TNJTSSWD,
       modelPar_TNJTSSWG,
       modelPar_given_TNJTSSWG,
       modelPar_TNJTSSWGD,
       modelPar_given_TNJTSSWGD,
       modelPar_RTH0,
       modelPar_given_RTH0,
       modelPar_CTH0,
       modelPar_given_CTH0,
       modelPar_WTH0,
       modelPar_given_WTH0,
       modelPar_ASHEXP,
       modelPar_given_ASHEXP,
       modelPar_BSHEXP,
       modelPar_given_BSHEXP,
       modelPar_ACH_UFCM,
       modelPar_given_ACH_UFCM,
       modelPar_CINS_UFCM,
       modelPar_given_CINS_UFCM,
       modelPar_W_UFCM,
       modelPar_given_W_UFCM,
       modelPar_TFIN_TOP,
       modelPar_given_TFIN_TOP,
       modelPar_TFIN_BASE,
       modelPar_given_TFIN_BASE,
       modelPar_QMFACTORCV,
       modelPar_given_QMFACTORCV,
       modelPar_ALPHA_UFCM,
       modelPar_given_ALPHA_UFCM,
       modelPar_LNBODY,
       modelPar_given_LNBODY,
       modelPar_NNBODY,
       modelPar_given_NNBODY,
       modelPar_PNBODY,
       modelPar_given_PNBODY,
       modelPar_LPHIG,
       modelPar_given_LPHIG,
       modelPar_NPHIG,
       modelPar_given_NPHIG,
       modelPar_PPHIG,
       modelPar_given_PPHIG,
       modelPar_LNGATE,
       modelPar_given_LNGATE,
       modelPar_NNGATE,
       modelPar_given_NNGATE,
       modelPar_PNGATE,
       modelPar_given_PNGATE,
       modelPar_LCIT,
       modelPar_given_LCIT,
       modelPar_NCIT,
       modelPar_given_NCIT,
       modelPar_PCIT,
       modelPar_given_PCIT,
       modelPar_LCITR,
       modelPar_given_LCITR,
       modelPar_NCITR,
       modelPar_given_NCITR,
       modelPar_PCITR,
       modelPar_given_PCITR,
       modelPar_LCDSC,
       modelPar_given_LCDSC,
       modelPar_NCDSC,
       modelPar_given_NCDSC,
       modelPar_PCDSC,
       modelPar_given_PCDSC,
       modelPar_LCDSCD,
       modelPar_given_LCDSCD,
       modelPar_NCDSCD,
       modelPar_given_NCDSCD,
       modelPar_PCDSCD,
       modelPar_given_PCDSCD,
       modelPar_LCDSCDR,
       modelPar_given_LCDSCDR,
       modelPar_NCDSCDR,
       modelPar_given_NCDSCDR,
       modelPar_PCDSCDR,
       modelPar_given_PCDSCDR,
       modelPar_LDVT0,
       modelPar_given_LDVT0,
       modelPar_NDVT0,
       modelPar_given_NDVT0,
       modelPar_PDVT0,
       modelPar_given_PDVT0,
       modelPar_LDVT1,
       modelPar_given_LDVT1,
       modelPar_NDVT1,
       modelPar_given_NDVT1,
       modelPar_PDVT1,
       modelPar_given_PDVT1,
       modelPar_LDVT1SS,
       modelPar_given_LDVT1SS,
       modelPar_NDVT1SS,
       modelPar_given_NDVT1SS,
       modelPar_PDVT1SS,
       modelPar_given_PDVT1SS,
       modelPar_LPHIN,
       modelPar_given_LPHIN,
       modelPar_NPHIN,
       modelPar_given_NPHIN,
       modelPar_PPHIN,
       modelPar_given_PPHIN,
       modelPar_LETA0,
       modelPar_given_LETA0,
       modelPar_NETA0,
       modelPar_given_NETA0,
       modelPar_PETA0,
       modelPar_given_PETA0,
       modelPar_LETA0R,
       modelPar_given_LETA0R,
       modelPar_NETA0R,
       modelPar_given_NETA0R,
       modelPar_PETA0R,
       modelPar_given_PETA0R,
       modelPar_LDSUB,
       modelPar_given_LDSUB,
       modelPar_NDSUB,
       modelPar_given_NDSUB,
       modelPar_PDSUB,
       modelPar_given_PDSUB,
       modelPar_LK1RSCE,
       modelPar_given_LK1RSCE,
       modelPar_NK1RSCE,
       modelPar_given_NK1RSCE,
       modelPar_PK1RSCE,
       modelPar_given_PK1RSCE,
       modelPar_LLPE0,
       modelPar_given_LLPE0,
       modelPar_NLPE0,
       modelPar_given_NLPE0,
       modelPar_PLPE0,
       modelPar_given_PLPE0,
       modelPar_LDVTSHIFT,
       modelPar_given_LDVTSHIFT,
       modelPar_NDVTSHIFT,
       modelPar_given_NDVTSHIFT,
       modelPar_PDVTSHIFT,
       modelPar_given_PDVTSHIFT,
       modelPar_LDVTSHIFTR,
       modelPar_given_LDVTSHIFTR,
       modelPar_NDVTSHIFTR,
       modelPar_given_NDVTSHIFTR,
       modelPar_PDVTSHIFTR,
       modelPar_given_PDVTSHIFTR,
       modelPar_LPHIBE,
       modelPar_given_LPHIBE,
       modelPar_NPHIBE,
       modelPar_given_NPHIBE,
       modelPar_PPHIBE,
       modelPar_given_PPHIBE,
       modelPar_LK0,
       modelPar_given_LK0,
       modelPar_NK0,
       modelPar_given_NK0,
       modelPar_PK0,
       modelPar_given_PK0,
       modelPar_LK01,
       modelPar_given_LK01,
       modelPar_NK01,
       modelPar_given_NK01,
       modelPar_PK01,
       modelPar_given_PK01,
       modelPar_LK0SI,
       modelPar_given_LK0SI,
       modelPar_NK0SI,
       modelPar_given_NK0SI,
       modelPar_PK0SI,
       modelPar_given_PK0SI,
       modelPar_LK0SI1,
       modelPar_given_LK0SI1,
       modelPar_NK0SI1,
       modelPar_given_NK0SI1,
       modelPar_PK0SI1,
       modelPar_given_PK0SI1,
       modelPar_LK1,
       modelPar_given_LK1,
       modelPar_NK1,
       modelPar_given_NK1,
       modelPar_PK1,
       modelPar_given_PK1,
       modelPar_LK11,
       modelPar_given_LK11,
       modelPar_NK11,
       modelPar_given_NK11,
       modelPar_PK11,
       modelPar_given_PK11,
       modelPar_LK2SI,
       modelPar_given_LK2SI,
       modelPar_NK2SI,
       modelPar_given_NK2SI,
       modelPar_PK2SI,
       modelPar_given_PK2SI,
       modelPar_LK2SI1,
       modelPar_given_LK2SI1,
       modelPar_NK2SI1,
       modelPar_given_NK2SI1,
       modelPar_PK2SI1,
       modelPar_given_PK2SI1,
       modelPar_LK0SISAT,
       modelPar_given_LK0SISAT,
       modelPar_NK0SISAT,
       modelPar_given_NK0SISAT,
       modelPar_PK0SISAT,
       modelPar_given_PK0SISAT,
       modelPar_LK0SISAT1,
       modelPar_given_LK0SISAT1,
       modelPar_NK0SISAT1,
       modelPar_given_NK0SISAT1,
       modelPar_PK0SISAT1,
       modelPar_given_PK0SISAT1,
       modelPar_LK2SISAT,
       modelPar_given_LK2SISAT,
       modelPar_NK2SISAT,
       modelPar_given_NK2SISAT,
       modelPar_PK2SISAT,
       modelPar_given_PK2SISAT,
       modelPar_LK2SISAT1,
       modelPar_given_LK2SISAT1,
       modelPar_NK2SISAT1,
       modelPar_given_NK2SISAT1,
       modelPar_PK2SISAT1,
       modelPar_given_PK2SISAT1,
       modelPar_LK2SAT,
       modelPar_given_LK2SAT,
       modelPar_NK2SAT,
       modelPar_given_NK2SAT,
       modelPar_PK2SAT,
       modelPar_given_PK2SAT,
       modelPar_LK2SAT1,
       modelPar_given_LK2SAT1,
       modelPar_NK2SAT1,
       modelPar_given_NK2SAT1,
       modelPar_PK2SAT1,
       modelPar_given_PK2SAT1,
       modelPar_LK2,
       modelPar_given_LK2,
       modelPar_NK2,
       modelPar_given_NK2,
       modelPar_PK2,
       modelPar_given_PK2,
       modelPar_LK21,
       modelPar_given_LK21,
       modelPar_NK21,
       modelPar_given_NK21,
       modelPar_PK21,
       modelPar_given_PK21,
       modelPar_LDVTB,
       modelPar_given_LDVTB,
       modelPar_NDVTB,
       modelPar_given_NDVTB,
       modelPar_PDVTB,
       modelPar_given_PDVTB,
       modelPar_LLPEB,
       modelPar_given_LLPEB,
       modelPar_NLPEB,
       modelPar_given_NLPEB,
       modelPar_PLPEB,
       modelPar_given_PLPEB,
       modelPar_LQMFACTOR,
       modelPar_given_LQMFACTOR,
       modelPar_NQMFACTOR,
       modelPar_given_NQMFACTOR,
       modelPar_PQMFACTOR,
       modelPar_given_PQMFACTOR,
       modelPar_LQMTCENCV,
       modelPar_given_LQMTCENCV,
       modelPar_NQMTCENCV,
       modelPar_given_NQMTCENCV,
       modelPar_PQMTCENCV,
       modelPar_given_PQMTCENCV,
       modelPar_LQMTCENCVA,
       modelPar_given_LQMTCENCVA,
       modelPar_NQMTCENCVA,
       modelPar_given_NQMTCENCVA,
       modelPar_PQMTCENCVA,
       modelPar_given_PQMTCENCVA,
       modelPar_LVSAT,
       modelPar_given_LVSAT,
       modelPar_NVSAT,
       modelPar_given_NVSAT,
       modelPar_PVSAT,
       modelPar_given_PVSAT,
       modelPar_LVSATR,
       modelPar_given_LVSATR,
       modelPar_NVSATR,
       modelPar_given_NVSATR,
       modelPar_PVSATR,
       modelPar_given_PVSATR,
       modelPar_LVSAT1,
       modelPar_given_LVSAT1,
       modelPar_NVSAT1,
       modelPar_given_NVSAT1,
       modelPar_PVSAT1,
       modelPar_given_PVSAT1,
       modelPar_LVSAT1R,
       modelPar_given_LVSAT1R,
       modelPar_NVSAT1R,
       modelPar_given_NVSAT1R,
       modelPar_PVSAT1R,
       modelPar_given_PVSAT1R,
       modelPar_LPSAT,
       modelPar_given_LPSAT,
       modelPar_NPSAT,
       modelPar_given_NPSAT,
       modelPar_PPSAT,
       modelPar_given_PPSAT,
       modelPar_LDELTAVSAT,
       modelPar_given_LDELTAVSAT,
       modelPar_NDELTAVSAT,
       modelPar_given_NDELTAVSAT,
       modelPar_PDELTAVSAT,
       modelPar_given_PDELTAVSAT,
       modelPar_LKSATIV,
       modelPar_given_LKSATIV,
       modelPar_NKSATIV,
       modelPar_given_NKSATIV,
       modelPar_PKSATIV,
       modelPar_given_PKSATIV,
       modelPar_LKSATIVR,
       modelPar_given_LKSATIVR,
       modelPar_NKSATIVR,
       modelPar_given_NKSATIVR,
       modelPar_PKSATIVR,
       modelPar_given_PKSATIVR,
       modelPar_LVSATCV,
       modelPar_given_LVSATCV,
       modelPar_NVSATCV,
       modelPar_given_NVSATCV,
       modelPar_PVSATCV,
       modelPar_given_PVSATCV,
       modelPar_LPSATCV,
       modelPar_given_LPSATCV,
       modelPar_NPSATCV,
       modelPar_given_NPSATCV,
       modelPar_PPSATCV,
       modelPar_given_PPSATCV,
       modelPar_LDELTAVSATCV,
       modelPar_given_LDELTAVSATCV,
       modelPar_NDELTAVSATCV,
       modelPar_given_NDELTAVSATCV,
       modelPar_PDELTAVSATCV,
       modelPar_given_PDELTAVSATCV,
       modelPar_LMEXP,
       modelPar_given_LMEXP,
       modelPar_NMEXP,
       modelPar_given_NMEXP,
       modelPar_PMEXP,
       modelPar_given_PMEXP,
       modelPar_LMEXPR,
       modelPar_given_LMEXPR,
       modelPar_NMEXPR,
       modelPar_given_NMEXPR,
       modelPar_PMEXPR,
       modelPar_given_PMEXPR,
       modelPar_LPTWG,
       modelPar_given_LPTWG,
       modelPar_NPTWG,
       modelPar_given_NPTWG,
       modelPar_PPTWG,
       modelPar_given_PPTWG,
       modelPar_LPTWGR,
       modelPar_given_LPTWGR,
       modelPar_NPTWGR,
       modelPar_given_NPTWGR,
       modelPar_PPTWGR,
       modelPar_given_PPTWGR,
       modelPar_LU0,
       modelPar_given_LU0,
       modelPar_NU0,
       modelPar_given_NU0,
       modelPar_PU0,
       modelPar_given_PU0,
       modelPar_LU0R,
       modelPar_given_LU0R,
       modelPar_NU0R,
       modelPar_given_NU0R,
       modelPar_PU0R,
       modelPar_given_PU0R,
       modelPar_LETAMOB,
       modelPar_given_LETAMOB,
       modelPar_NETAMOB,
       modelPar_given_NETAMOB,
       modelPar_PETAMOB,
       modelPar_given_PETAMOB,
       modelPar_LUP,
       modelPar_given_LUP,
       modelPar_NUP,
       modelPar_given_NUP,
       modelPar_PUP,
       modelPar_given_PUP,
       modelPar_LUPR,
       modelPar_given_LUPR,
       modelPar_NUPR,
       modelPar_given_NUPR,
       modelPar_PUPR,
       modelPar_given_PUPR,
       modelPar_LUA,
       modelPar_given_LUA,
       modelPar_NUA,
       modelPar_given_NUA,
       modelPar_PUA,
       modelPar_given_PUA,
       modelPar_LUAR,
       modelPar_given_LUAR,
       modelPar_NUAR,
       modelPar_given_NUAR,
       modelPar_PUAR,
       modelPar_given_PUAR,
       modelPar_LUC,
       modelPar_given_LUC,
       modelPar_NUC,
       modelPar_given_NUC,
       modelPar_PUC,
       modelPar_given_PUC,
       modelPar_LUCR,
       modelPar_given_LUCR,
       modelPar_NUCR,
       modelPar_given_NUCR,
       modelPar_PUCR,
       modelPar_given_PUCR,
       modelPar_LEU,
       modelPar_given_LEU,
       modelPar_NEU,
       modelPar_given_NEU,
       modelPar_PEU,
       modelPar_given_PEU,
       modelPar_LEUR,
       modelPar_given_LEUR,
       modelPar_NEUR,
       modelPar_given_NEUR,
       modelPar_PEUR,
       modelPar_given_PEUR,
       modelPar_LUD,
       modelPar_given_LUD,
       modelPar_NUD,
       modelPar_given_NUD,
       modelPar_PUD,
       modelPar_given_PUD,
       modelPar_LUDR,
       modelPar_given_LUDR,
       modelPar_NUDR,
       modelPar_given_NUDR,
       modelPar_PUDR,
       modelPar_given_PUDR,
       modelPar_LUCS,
       modelPar_given_LUCS,
       modelPar_NUCS,
       modelPar_given_NUCS,
       modelPar_PUCS,
       modelPar_given_PUCS,
       modelPar_LPCLM,
       modelPar_given_LPCLM,
       modelPar_NPCLM,
       modelPar_given_NPCLM,
       modelPar_PPCLM,
       modelPar_given_PPCLM,
       modelPar_LPCLMR,
       modelPar_given_LPCLMR,
       modelPar_NPCLMR,
       modelPar_given_NPCLMR,
       modelPar_PPCLMR,
       modelPar_given_PPCLMR,
       modelPar_LPCLMG,
       modelPar_given_LPCLMG,
       modelPar_NPCLMG,
       modelPar_given_NPCLMG,
       modelPar_PPCLMG,
       modelPar_given_PPCLMG,
       modelPar_LPCLMCV,
       modelPar_given_LPCLMCV,
       modelPar_NPCLMCV,
       modelPar_given_NPCLMCV,
       modelPar_PPCLMCV,
       modelPar_given_PPCLMCV,
       modelPar_LA1,
       modelPar_given_LA1,
       modelPar_NA1,
       modelPar_given_NA1,
       modelPar_PA1,
       modelPar_given_PA1,
       modelPar_LA11,
       modelPar_given_LA11,
       modelPar_NA11,
       modelPar_given_NA11,
       modelPar_PA11,
       modelPar_given_PA11,
       modelPar_LA2,
       modelPar_given_LA2,
       modelPar_NA2,
       modelPar_given_NA2,
       modelPar_PA2,
       modelPar_given_PA2,
       modelPar_LA21,
       modelPar_given_LA21,
       modelPar_NA21,
       modelPar_given_NA21,
       modelPar_PA21,
       modelPar_given_PA21,
       modelPar_LRDSW,
       modelPar_given_LRDSW,
       modelPar_NRDSW,
       modelPar_given_NRDSW,
       modelPar_PRDSW,
       modelPar_given_PRDSW,
       modelPar_LRSW,
       modelPar_given_LRSW,
       modelPar_NRSW,
       modelPar_given_NRSW,
       modelPar_PRSW,
       modelPar_given_PRSW,
       modelPar_LRDW,
       modelPar_given_LRDW,
       modelPar_NRDW,
       modelPar_given_NRDW,
       modelPar_PRDW,
       modelPar_given_PRDW,
       modelPar_LPRWGS,
       modelPar_given_LPRWGS,
       modelPar_NPRWGS,
       modelPar_given_NPRWGS,
       modelPar_PPRWGS,
       modelPar_given_PPRWGS,
       modelPar_LPRWGD,
       modelPar_given_LPRWGD,
       modelPar_NPRWGD,
       modelPar_given_NPRWGD,
       modelPar_PPRWGD,
       modelPar_given_PPRWGD,
       modelPar_LWR,
       modelPar_given_LWR,
       modelPar_NWR,
       modelPar_given_NWR,
       modelPar_PWR,
       modelPar_given_PWR,
       modelPar_LPDIBL1,
       modelPar_given_LPDIBL1,
       modelPar_NPDIBL1,
       modelPar_given_NPDIBL1,
       modelPar_PPDIBL1,
       modelPar_given_PPDIBL1,
       modelPar_LPDIBL1R,
       modelPar_given_LPDIBL1R,
       modelPar_NPDIBL1R,
       modelPar_given_NPDIBL1R,
       modelPar_PPDIBL1R,
       modelPar_given_PPDIBL1R,
       modelPar_LPDIBL2,
       modelPar_given_LPDIBL2,
       modelPar_NPDIBL2,
       modelPar_given_NPDIBL2,
       modelPar_PPDIBL2,
       modelPar_given_PPDIBL2,
       modelPar_LPDIBL2R,
       modelPar_given_LPDIBL2R,
       modelPar_NPDIBL2R,
       modelPar_given_NPDIBL2R,
       modelPar_PPDIBL2R,
       modelPar_given_PPDIBL2R,
       modelPar_LDROUT,
       modelPar_given_LDROUT,
       modelPar_NDROUT,
       modelPar_given_NDROUT,
       modelPar_PDROUT,
       modelPar_given_PDROUT,
       modelPar_LPVAG,
       modelPar_given_LPVAG,
       modelPar_NPVAG,
       modelPar_given_NPVAG,
       modelPar_PPVAG,
       modelPar_given_PPVAG,
       modelPar_LAIGBINV,
       modelPar_given_LAIGBINV,
       modelPar_NAIGBINV,
       modelPar_given_NAIGBINV,
       modelPar_PAIGBINV,
       modelPar_given_PAIGBINV,
       modelPar_LAIGBINV1,
       modelPar_given_LAIGBINV1,
       modelPar_NAIGBINV1,
       modelPar_given_NAIGBINV1,
       modelPar_PAIGBINV1,
       modelPar_given_PAIGBINV1,
       modelPar_LBIGBINV,
       modelPar_given_LBIGBINV,
       modelPar_NBIGBINV,
       modelPar_given_NBIGBINV,
       modelPar_PBIGBINV,
       modelPar_given_PBIGBINV,
       modelPar_LCIGBINV,
       modelPar_given_LCIGBINV,
       modelPar_NCIGBINV,
       modelPar_given_NCIGBINV,
       modelPar_PCIGBINV,
       modelPar_given_PCIGBINV,
       modelPar_LEIGBINV,
       modelPar_given_LEIGBINV,
       modelPar_NEIGBINV,
       modelPar_given_NEIGBINV,
       modelPar_PEIGBINV,
       modelPar_given_PEIGBINV,
       modelPar_LNIGBINV,
       modelPar_given_LNIGBINV,
       modelPar_NNIGBINV,
       modelPar_given_NNIGBINV,
       modelPar_PNIGBINV,
       modelPar_given_PNIGBINV,
       modelPar_LAIGBACC,
       modelPar_given_LAIGBACC,
       modelPar_NAIGBACC,
       modelPar_given_NAIGBACC,
       modelPar_PAIGBACC,
       modelPar_given_PAIGBACC,
       modelPar_LAIGBACC1,
       modelPar_given_LAIGBACC1,
       modelPar_NAIGBACC1,
       modelPar_given_NAIGBACC1,
       modelPar_PAIGBACC1,
       modelPar_given_PAIGBACC1,
       modelPar_LBIGBACC,
       modelPar_given_LBIGBACC,
       modelPar_NBIGBACC,
       modelPar_given_NBIGBACC,
       modelPar_PBIGBACC,
       modelPar_given_PBIGBACC,
       modelPar_LCIGBACC,
       modelPar_given_LCIGBACC,
       modelPar_NCIGBACC,
       modelPar_given_NCIGBACC,
       modelPar_PCIGBACC,
       modelPar_given_PCIGBACC,
       modelPar_LNIGBACC,
       modelPar_given_LNIGBACC,
       modelPar_NNIGBACC,
       modelPar_given_NNIGBACC,
       modelPar_PNIGBACC,
       modelPar_given_PNIGBACC,
       modelPar_LAIGC,
       modelPar_given_LAIGC,
       modelPar_NAIGC,
       modelPar_given_NAIGC,
       modelPar_PAIGC,
       modelPar_given_PAIGC,
       modelPar_LAIGC1,
       modelPar_given_LAIGC1,
       modelPar_NAIGC1,
       modelPar_given_NAIGC1,
       modelPar_PAIGC1,
       modelPar_given_PAIGC1,
       modelPar_LBIGC,
       modelPar_given_LBIGC,
       modelPar_NBIGC,
       modelPar_given_NBIGC,
       modelPar_PBIGC,
       modelPar_given_PBIGC,
       modelPar_LCIGC,
       modelPar_given_LCIGC,
       modelPar_NCIGC,
       modelPar_given_NCIGC,
       modelPar_PCIGC,
       modelPar_given_PCIGC,
       modelPar_LPIGCD,
       modelPar_given_LPIGCD,
       modelPar_NPIGCD,
       modelPar_given_NPIGCD,
       modelPar_PPIGCD,
       modelPar_given_PPIGCD,
       modelPar_LAIGS,
       modelPar_given_LAIGS,
       modelPar_NAIGS,
       modelPar_given_NAIGS,
       modelPar_PAIGS,
       modelPar_given_PAIGS,
       modelPar_LAIGS1,
       modelPar_given_LAIGS1,
       modelPar_NAIGS1,
       modelPar_given_NAIGS1,
       modelPar_PAIGS1,
       modelPar_given_PAIGS1,
       modelPar_LBIGS,
       modelPar_given_LBIGS,
       modelPar_NBIGS,
       modelPar_given_NBIGS,
       modelPar_PBIGS,
       modelPar_given_PBIGS,
       modelPar_LCIGS,
       modelPar_given_LCIGS,
       modelPar_NCIGS,
       modelPar_given_NCIGS,
       modelPar_PCIGS,
       modelPar_given_PCIGS,
       modelPar_LAIGD,
       modelPar_given_LAIGD,
       modelPar_NAIGD,
       modelPar_given_NAIGD,
       modelPar_PAIGD,
       modelPar_given_PAIGD,
       modelPar_LAIGD1,
       modelPar_given_LAIGD1,
       modelPar_NAIGD1,
       modelPar_given_NAIGD1,
       modelPar_PAIGD1,
       modelPar_given_PAIGD1,
       modelPar_LBIGD,
       modelPar_given_LBIGD,
       modelPar_NBIGD,
       modelPar_given_NBIGD,
       modelPar_PBIGD,
       modelPar_given_PBIGD,
       modelPar_LCIGD,
       modelPar_given_LCIGD,
       modelPar_NCIGD,
       modelPar_given_NCIGD,
       modelPar_PCIGD,
       modelPar_given_PCIGD,
       modelPar_LNTOX,
       modelPar_given_LNTOX,
       modelPar_NNTOX,
       modelPar_given_NNTOX,
       modelPar_PNTOX,
       modelPar_given_PNTOX,
       modelPar_LPOXEDGE,
       modelPar_given_LPOXEDGE,
       modelPar_NPOXEDGE,
       modelPar_given_NPOXEDGE,
       modelPar_PPOXEDGE,
       modelPar_given_PPOXEDGE,
       modelPar_LAGISL,
       modelPar_given_LAGISL,
       modelPar_NAGISL,
       modelPar_given_NAGISL,
       modelPar_PAGISL,
       modelPar_given_PAGISL,
       modelPar_LBGISL,
       modelPar_given_LBGISL,
       modelPar_NBGISL,
       modelPar_given_NBGISL,
       modelPar_PBGISL,
       modelPar_given_PBGISL,
       modelPar_LCGISL,
       modelPar_given_LCGISL,
       modelPar_NCGISL,
       modelPar_given_NCGISL,
       modelPar_PCGISL,
       modelPar_given_PCGISL,
       modelPar_LEGISL,
       modelPar_given_LEGISL,
       modelPar_NEGISL,
       modelPar_given_NEGISL,
       modelPar_PEGISL,
       modelPar_given_PEGISL,
       modelPar_LPGISL,
       modelPar_given_LPGISL,
       modelPar_NPGISL,
       modelPar_given_NPGISL,
       modelPar_PPGISL,
       modelPar_given_PPGISL,
       modelPar_LAGIDL,
       modelPar_given_LAGIDL,
       modelPar_NAGIDL,
       modelPar_given_NAGIDL,
       modelPar_PAGIDL,
       modelPar_given_PAGIDL,
       modelPar_LBGIDL,
       modelPar_given_LBGIDL,
       modelPar_NBGIDL,
       modelPar_given_NBGIDL,
       modelPar_PBGIDL,
       modelPar_given_PBGIDL,
       modelPar_LCGIDL,
       modelPar_given_LCGIDL,
       modelPar_NCGIDL,
       modelPar_given_NCGIDL,
       modelPar_PCGIDL,
       modelPar_given_PCGIDL,
       modelPar_LEGIDL,
       modelPar_given_LEGIDL,
       modelPar_NEGIDL,
       modelPar_given_NEGIDL,
       modelPar_PEGIDL,
       modelPar_given_PEGIDL,
       modelPar_LPGIDL,
       modelPar_given_LPGIDL,
       modelPar_NPGIDL,
       modelPar_given_NPGIDL,
       modelPar_PPGIDL,
       modelPar_given_PPGIDL,
       modelPar_LALPHA0,
       modelPar_given_LALPHA0,
       modelPar_NALPHA0,
       modelPar_given_NALPHA0,
       modelPar_PALPHA0,
       modelPar_given_PALPHA0,
       modelPar_LALPHA1,
       modelPar_given_LALPHA1,
       modelPar_NALPHA1,
       modelPar_given_NALPHA1,
       modelPar_PALPHA1,
       modelPar_given_PALPHA1,
       modelPar_LALPHAII0,
       modelPar_given_LALPHAII0,
       modelPar_NALPHAII0,
       modelPar_given_NALPHAII0,
       modelPar_PALPHAII0,
       modelPar_given_PALPHAII0,
       modelPar_LALPHAII1,
       modelPar_given_LALPHAII1,
       modelPar_NALPHAII1,
       modelPar_given_NALPHAII1,
       modelPar_PALPHAII1,
       modelPar_given_PALPHAII1,
       modelPar_LBETA0,
       modelPar_given_LBETA0,
       modelPar_NBETA0,
       modelPar_given_NBETA0,
       modelPar_PBETA0,
       modelPar_given_PBETA0,
       modelPar_LBETAII0,
       modelPar_given_LBETAII0,
       modelPar_NBETAII0,
       modelPar_given_NBETAII0,
       modelPar_PBETAII0,
       modelPar_given_PBETAII0,
       modelPar_LBETAII1,
       modelPar_given_LBETAII1,
       modelPar_NBETAII1,
       modelPar_given_NBETAII1,
       modelPar_PBETAII1,
       modelPar_given_PBETAII1,
       modelPar_LBETAII2,
       modelPar_given_LBETAII2,
       modelPar_NBETAII2,
       modelPar_given_NBETAII2,
       modelPar_PBETAII2,
       modelPar_given_PBETAII2,
       modelPar_LESATII,
       modelPar_given_LESATII,
       modelPar_NESATII,
       modelPar_given_NESATII,
       modelPar_PESATII,
       modelPar_given_PESATII,
       modelPar_LLII,
       modelPar_given_LLII,
       modelPar_NLII,
       modelPar_given_NLII,
       modelPar_PLII,
       modelPar_given_PLII,
       modelPar_LSII0,
       modelPar_given_LSII0,
       modelPar_NSII0,
       modelPar_given_NSII0,
       modelPar_PSII0,
       modelPar_given_PSII0,
       modelPar_LSII1,
       modelPar_given_LSII1,
       modelPar_NSII1,
       modelPar_given_NSII1,
       modelPar_PSII1,
       modelPar_given_PSII1,
       modelPar_LSII2,
       modelPar_given_LSII2,
       modelPar_NSII2,
       modelPar_given_NSII2,
       modelPar_PSII2,
       modelPar_given_PSII2,
       modelPar_LSIID,
       modelPar_given_LSIID,
       modelPar_NSIID,
       modelPar_given_NSIID,
       modelPar_PSIID,
       modelPar_given_PSIID,
       modelPar_LCFS,
       modelPar_given_LCFS,
       modelPar_NCFS,
       modelPar_given_NCFS,
       modelPar_PCFS,
       modelPar_given_PCFS,
       modelPar_LCFD,
       modelPar_given_LCFD,
       modelPar_NCFD,
       modelPar_given_NCFD,
       modelPar_PCFD,
       modelPar_given_PCFD,
       modelPar_LCOVS,
       modelPar_given_LCOVS,
       modelPar_NCOVS,
       modelPar_given_NCOVS,
       modelPar_PCOVS,
       modelPar_given_PCOVS,
       modelPar_LCOVD,
       modelPar_given_LCOVD,
       modelPar_NCOVD,
       modelPar_given_NCOVD,
       modelPar_PCOVD,
       modelPar_given_PCOVD,
       modelPar_LCGSL,
       modelPar_given_LCGSL,
       modelPar_NCGSL,
       modelPar_given_NCGSL,
       modelPar_PCGSL,
       modelPar_given_PCGSL,
       modelPar_LCGDL,
       modelPar_given_LCGDL,
       modelPar_NCGDL,
       modelPar_given_NCGDL,
       modelPar_PCGDL,
       modelPar_given_PCGDL,
       modelPar_LCKAPPAS,
       modelPar_given_LCKAPPAS,
       modelPar_NCKAPPAS,
       modelPar_given_NCKAPPAS,
       modelPar_PCKAPPAS,
       modelPar_given_PCKAPPAS,
       modelPar_LCKAPPAD,
       modelPar_given_LCKAPPAD,
       modelPar_NCKAPPAD,
       modelPar_given_NCKAPPAD,
       modelPar_PCKAPPAD,
       modelPar_given_PCKAPPAD,
       modelPar_LCGBL,
       modelPar_given_LCGBL,
       modelPar_NCGBL,
       modelPar_given_NCGBL,
       modelPar_PCGBL,
       modelPar_given_PCGBL,
       modelPar_LCKAPPAB,
       modelPar_given_LCKAPPAB,
       modelPar_NCKAPPAB,
       modelPar_given_NCKAPPAB,
       modelPar_PCKAPPAB,
       modelPar_given_PCKAPPAB,
       modelPar_LNTGEN,
       modelPar_given_LNTGEN,
       modelPar_NNTGEN,
       modelPar_given_NNTGEN,
       modelPar_PNTGEN,
       modelPar_given_PNTGEN,
       modelPar_LAIGEN,
       modelPar_given_LAIGEN,
       modelPar_NAIGEN,
       modelPar_given_NAIGEN,
       modelPar_PAIGEN,
       modelPar_given_PAIGEN,
       modelPar_LBIGEN,
       modelPar_given_LBIGEN,
       modelPar_NBIGEN,
       modelPar_given_NBIGEN,
       modelPar_PBIGEN,
       modelPar_given_PBIGEN,
       modelPar_LXRCRG1,
       modelPar_given_LXRCRG1,
       modelPar_NXRCRG1,
       modelPar_given_NXRCRG1,
       modelPar_PXRCRG1,
       modelPar_given_PXRCRG1,
       modelPar_LXRCRG2,
       modelPar_given_LXRCRG2,
       modelPar_NXRCRG2,
       modelPar_given_NXRCRG2,
       modelPar_PXRCRG2,
       modelPar_given_PXRCRG2,
       modelPar_LUTE,
       modelPar_given_LUTE,
       modelPar_NUTE,
       modelPar_given_NUTE,
       modelPar_PUTE,
       modelPar_given_PUTE,
       modelPar_LUTER,
       modelPar_given_LUTER,
       modelPar_NUTER,
       modelPar_given_NUTER,
       modelPar_PUTER,
       modelPar_given_PUTER,
       modelPar_LUTL,
       modelPar_given_LUTL,
       modelPar_NUTL,
       modelPar_given_NUTL,
       modelPar_PUTL,
       modelPar_given_PUTL,
       modelPar_LUTLR,
       modelPar_given_LUTLR,
       modelPar_NUTLR,
       modelPar_given_NUTLR,
       modelPar_PUTLR,
       modelPar_given_PUTLR,
       modelPar_LEMOBT,
       modelPar_given_LEMOBT,
       modelPar_NEMOBT,
       modelPar_given_NEMOBT,
       modelPar_PEMOBT,
       modelPar_given_PEMOBT,
       modelPar_LUA1,
       modelPar_given_LUA1,
       modelPar_NUA1,
       modelPar_given_NUA1,
       modelPar_PUA1,
       modelPar_given_PUA1,
       modelPar_LUA1R,
       modelPar_given_LUA1R,
       modelPar_NUA1R,
       modelPar_given_NUA1R,
       modelPar_PUA1R,
       modelPar_given_PUA1R,
       modelPar_LUC1,
       modelPar_given_LUC1,
       modelPar_NUC1,
       modelPar_given_NUC1,
       modelPar_PUC1,
       modelPar_given_PUC1,
       modelPar_LUC1R,
       modelPar_given_LUC1R,
       modelPar_NUC1R,
       modelPar_given_NUC1R,
       modelPar_PUC1R,
       modelPar_given_PUC1R,
       modelPar_LUD1,
       modelPar_given_LUD1,
       modelPar_NUD1,
       modelPar_given_NUD1,
       modelPar_PUD1,
       modelPar_given_PUD1,
       modelPar_LUD1R,
       modelPar_given_LUD1R,
       modelPar_NUD1R,
       modelPar_given_NUD1R,
       modelPar_PUD1R,
       modelPar_given_PUD1R,
       modelPar_LUCSTE,
       modelPar_given_LUCSTE,
       modelPar_NUCSTE,
       modelPar_given_NUCSTE,
       modelPar_PUCSTE,
       modelPar_given_PUCSTE,
       modelPar_LPTWGT,
       modelPar_given_LPTWGT,
       modelPar_NPTWGT,
       modelPar_given_NPTWGT,
       modelPar_PPTWGT,
       modelPar_given_PPTWGT,
       modelPar_LAT,
       modelPar_given_LAT,
       modelPar_NAT,
       modelPar_given_NAT,
       modelPar_PAT,
       modelPar_given_PAT,
       modelPar_LATR,
       modelPar_given_LATR,
       modelPar_NATR,
       modelPar_given_NATR,
       modelPar_PATR,
       modelPar_given_PATR,
       modelPar_LATCV,
       modelPar_given_LATCV,
       modelPar_NATCV,
       modelPar_given_NATCV,
       modelPar_PATCV,
       modelPar_given_PATCV,
       modelPar_LSTTHETASAT,
       modelPar_given_LSTTHETASAT,
       modelPar_NSTTHETASAT,
       modelPar_given_NSTTHETASAT,
       modelPar_PSTTHETASAT,
       modelPar_given_PSTTHETASAT,
       modelPar_LPRT,
       modelPar_given_LPRT,
       modelPar_NPRT,
       modelPar_given_NPRT,
       modelPar_PPRT,
       modelPar_given_PPRT,
       modelPar_LKT1,
       modelPar_given_LKT1,
       modelPar_NKT1,
       modelPar_given_NKT1,
       modelPar_PKT1,
       modelPar_given_PKT1,
       modelPar_LTSS,
       modelPar_given_LTSS,
       modelPar_NTSS,
       modelPar_given_NTSS,
       modelPar_PTSS,
       modelPar_given_PTSS,
       modelPar_LIIT,
       modelPar_given_LIIT,
       modelPar_NIIT,
       modelPar_given_NIIT,
       modelPar_PIIT,
       modelPar_given_PIIT,
       modelPar_LTII,
       modelPar_given_LTII,
       modelPar_NTII,
       modelPar_given_NTII,
       modelPar_PTII,
       modelPar_given_PTII,
       modelPar_LTGIDL,
       modelPar_given_LTGIDL,
       modelPar_NTGIDL,
       modelPar_given_NTGIDL,
       modelPar_PTGIDL,
       modelPar_given_PTGIDL,
       modelPar_LIGT,
       modelPar_given_LIGT,
       modelPar_NIGT,
       modelPar_given_NIGT,
       modelPar_PIGT,
       modelPar_given_PIGT,
       // non-reals (including hidden)
       modelPar_NF,
       modelPar_given_NF,
       modelPar_NGCON,
       modelPar_given_NGCON,
       modelPar_DEVTYPE,
       modelPar_given_DEVTYPE,
       modelPar_TYPE,
       modelPar_given_TYPE,
       modelPar_BULKMOD,
       modelPar_given_BULKMOD,
       modelPar_GEOMOD,
       modelPar_given_GEOMOD,
       modelPar_CGEO1SW,
       modelPar_given_CGEO1SW,
       modelPar_RDSMOD,
       modelPar_given_RDSMOD,
       modelPar_ASYMMOD,
       modelPar_given_ASYMMOD,
       modelPar_IGCMOD,
       modelPar_given_IGCMOD,
       modelPar_IGBMOD,
       modelPar_given_IGBMOD,
       modelPar_GIDLMOD,
       modelPar_given_GIDLMOD,
       modelPar_IIMOD,
       modelPar_given_IIMOD,
       modelPar_TNOIMOD,
       modelPar_given_TNOIMOD,
       modelPar_NQSMOD,
       modelPar_given_NQSMOD,
       modelPar_SHMOD,
       modelPar_given_SHMOD,
       modelPar_TEMPMOD,
       modelPar_given_TEMPMOD,
       modelPar_RGATEMOD,
       modelPar_given_RGATEMOD,
       modelPar_RGEOMOD,
       modelPar_given_RGEOMOD,
       modelPar_CGEOMOD,
       modelPar_given_CGEOMOD,
       modelPar_SH_WARN,
       modelPar_given_SH_WARN,
       modelPar_IGCLAMP,
       modelPar_given_IGCLAMP,
       modelPar_SDTERM,
       modelPar_given_SDTERM,
       modelPar_NSEG,
       modelPar_given_NSEG,
       in.admsTemperature,
       in.adms_vt_nom,
       in.getDeviceOptions().gmin,
       staticContributions,
       dynamicContributions,
       in);

  
    // We now have the F and Q vector stuff, populate the dependencies:
  
    dfdp[in.admsNodeID_d+inst*(9+0)] += staticContributions[in.admsNodeID_d].dx(0);
    dqdp[in.admsNodeID_d+inst*(9+0)] += dynamicContributions[in.admsNodeID_d].dx(0);
    Findices[in.admsNodeID_d+inst*(9+0)] = in.li_d;
    Qindices[in.admsNodeID_d+inst*(9+0)] = in.li_d;
    dfdp[in.admsNodeID_g+inst*(9+0)] += staticContributions[in.admsNodeID_g].dx(0);
    dqdp[in.admsNodeID_g+inst*(9+0)] += dynamicContributions[in.admsNodeID_g].dx(0);
    Findices[in.admsNodeID_g+inst*(9+0)] = in.li_g;
    Qindices[in.admsNodeID_g+inst*(9+0)] = in.li_g;
    dfdp[in.admsNodeID_s+inst*(9+0)] += staticContributions[in.admsNodeID_s].dx(0);
    dqdp[in.admsNodeID_s+inst*(9+0)] += dynamicContributions[in.admsNodeID_s].dx(0);
    Findices[in.admsNodeID_s+inst*(9+0)] = in.li_s;
    Qindices[in.admsNodeID_s+inst*(9+0)] = in.li_s;
    dfdp[in.admsNodeID_e+inst*(9+0)] += staticContributions[in.admsNodeID_e].dx(0);
    dqdp[in.admsNodeID_e+inst*(9+0)] += dynamicContributions[in.admsNodeID_e].dx(0);
    Findices[in.admsNodeID_e+inst*(9+0)] = in.li_e;
    Qindices[in.admsNodeID_e+inst*(9+0)] = in.li_e;
    dfdp[in.admsNodeID_t+inst*(9+0)] += staticContributions[in.admsNodeID_t].dx(0);
    dqdp[in.admsNodeID_t+inst*(9+0)] += dynamicContributions[in.admsNodeID_t].dx(0);
    Findices[in.admsNodeID_t+inst*(9+0)] = in.li_t;
    Qindices[in.admsNodeID_t+inst*(9+0)] = in.li_t;
    dfdp[in.admsNodeID_si+inst*(9+0)] += staticContributions[in.admsNodeID_si].dx(0);
    dqdp[in.admsNodeID_si+inst*(9+0)] += dynamicContributions[in.admsNodeID_si].dx(0);
    Findices[in.admsNodeID_si+inst*(9+0)] = in.li_si;
    Qindices[in.admsNodeID_si+inst*(9+0)] = in.li_si;
    dfdp[in.admsNodeID_di+inst*(9+0)] += staticContributions[in.admsNodeID_di].dx(0);
    dqdp[in.admsNodeID_di+inst*(9+0)] += dynamicContributions[in.admsNodeID_di].dx(0);
    Findices[in.admsNodeID_di+inst*(9+0)] = in.li_di;
    Qindices[in.admsNodeID_di+inst*(9+0)] = in.li_di;
    dfdp[in.admsNodeID_ge+inst*(9+0)] += staticContributions[in.admsNodeID_ge].dx(0);
    dqdp[in.admsNodeID_ge+inst*(9+0)] += dynamicContributions[in.admsNodeID_ge].dx(0);
    Findices[in.admsNodeID_ge+inst*(9+0)] = in.li_ge;
    Qindices[in.admsNodeID_ge+inst*(9+0)] = in.li_ge;
    dfdp[in.admsNodeID_N+inst*(9+0)] += staticContributions[in.admsNodeID_N].dx(0);
    dqdp[in.admsNodeID_N+inst*(9+0)] += dynamicContributions[in.admsNodeID_N].dx(0);
    Findices[in.admsNodeID_N+inst*(9+0)] = in.li_N;
    Qindices[in.admsNodeID_N+inst*(9+0)] = in.li_N;
  }

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSbsimcmg_110
} // namespace Device
} // namespace Xyce
