
//-----------------------------------------------------------------------------
// Copyright Notice
//
//   Copyright 2002 Sandia Corporation. Under the terms
//   of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
//   Government retains certain rights in this software.
//
//    Xyce(TM) Parallel Electrical Simulator
//    Copyright (C) 2002-2017 Sandia Corporation
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------------------------

//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file vbic_3T_et_cf_Xyce_typed.vla with ADMS
//                  interface for Xyce 6.6.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.6
//
// Creation Date  : Tue, 07 Mar 2017 09:52:40
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSvbic.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>


#include <N_UTL_FeatureTest.h>
#if defined(HAVE_UNORDERED_MAP)
#include <unordered_map>
using std::unordered_map;
#elif defined(HAVE_TR1_UNORDERED_MAP)
#include <tr1/unordered_map>
using std::tr1::unordered_map;
#else
#error neither unordered_map or tr1/unordered_map found
#endif

namespace Xyce {
namespace Device {
namespace ADMSvbic {


//This is necessary because the IntPair usage can trip undefined references
const int Instance::admsNodeID_c;
const int Instance::admsNodeID_b;
const int Instance::admsNodeID_e;
const int Instance::admsNodeID_dt;
const int Instance::admsNodeID_cx;
const int Instance::admsNodeID_ci;
const int Instance::admsNodeID_bx;
const int Instance::admsNodeID_bi;
const int Instance::admsNodeID_ei;
const int Instance::admsNodeID_bp;
const int Instance::admsNodeID_GND;
// Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSvbic::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSvbic::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("DTEMP", static_cast<double>(0.0), &ADMSvbic::Instance::DTEMP)
    .setUnit(U_NONE)
    .setDescription("Device temperature (use 0.0 for ambient)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("M", static_cast<int>(1), &ADMSvbic::Instance::M)
    .setUnit(U_NONE)
    .setDescription("Number of devices in parallel");


}

void Traits::loadModelParameters(ParametricData<ADMSvbic::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSvbic::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("TNOM", static_cast<double>(27.0), &ADMSvbic::Model::TNOM)
    .setUnit(U_DEGC)
    .setDescription("Nominal temperature")
    .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCX", static_cast<double>(0.0), &ADMSvbic::Model::RCX)
    .setExpressionAccess(ParameterType::MIN_RES)
    .setUnit(U_OHM)
    .setDescription("Extrinsic Collector resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCI", static_cast<double>(0.0), &ADMSvbic::Model::RCI)
    .setExpressionAccess(ParameterType::MIN_RES)
    .setUnit(U_OHM)
    .setDescription("Intrinsic Collector resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VO", static_cast<double>(0.0), &ADMSvbic::Model::VO)
    .setUnit(U_VOLT)
    .setDescription("Epi drift saturation voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GAMM", static_cast<double>(0.0), &ADMSvbic::Model::GAMM)
    .setUnit(U_NONE)
    .setDescription("Epi doping parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("HRCF", static_cast<double>(0.0), &ADMSvbic::Model::HRCF)
    .setUnit(U_NONE)
    .setDescription("High current RC factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBX", static_cast<double>(0.0), &ADMSvbic::Model::RBX)
    .setExpressionAccess(ParameterType::MIN_RES)
    .setUnit(U_OHM)
    .setDescription("Extrinsic base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBI", static_cast<double>(0.0), &ADMSvbic::Model::RBI)
    .setExpressionAccess(ParameterType::MIN_RES)
    .setUnit(U_OHM)
    .setDescription("Intrinsic base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RE", static_cast<double>(0.0), &ADMSvbic::Model::RE)
    .setExpressionAccess(ParameterType::MIN_RES)
    .setUnit(U_OHM)
    .setDescription("Emitter resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RS", static_cast<double>(0.0), &ADMSvbic::Model::RS)
    .setExpressionAccess(ParameterType::MIN_RES)
    .setUnit(U_OHM)
    .setDescription("Substrate resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBP", static_cast<double>(0.0), &ADMSvbic::Model::RBP)
    .setExpressionAccess(ParameterType::MIN_RES)
    .setUnit(U_OHM)
    .setDescription("Parasitic base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IS", static_cast<double>(1.0e-16), &ADMSvbic::Model::IS)
    .setUnit(U_AMP)
    .setDescription("Transport saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NF", static_cast<double>(1.0), &ADMSvbic::Model::NF)
    .setUnit(U_NONE)
    .setDescription("Forward emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NR", static_cast<double>(1.0), &ADMSvbic::Model::NR)
    .setUnit(U_NONE)
    .setDescription("Reverse emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FC", static_cast<double>(0.9), &ADMSvbic::Model::FC)
    .setUnit(U_NONE)
    .setDescription("Forward-bias depletion capacitance limit")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBEO", static_cast<double>(0.0), &ADMSvbic::Model::CBEO)
    .setExpressionAccess(ParameterType::MIN_CAP)
    .setUnit(U_FARAD)
    .setDescription("Extrinsic B-E overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJE", static_cast<double>(0.0), &ADMSvbic::Model::CJE)
    .setExpressionAccess(ParameterType::MIN_CAP)
    .setUnit(U_FARAD)
    .setDescription("B-E zero-bias capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PE", static_cast<double>(0.75), &ADMSvbic::Model::PE)
    .setUnit(U_NONE)
    .setDescription("B-E built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ME", static_cast<double>(0.33), &ADMSvbic::Model::ME)
    .setUnit(U_NONE)
    .setDescription("B-E grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AJE", static_cast<double>((-0.5)), &ADMSvbic::Model::AJE)
    .setUnit(U_NONE)
    .setDescription("Base-Emitter capacitor smoothing factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBCO", static_cast<double>(0.0), &ADMSvbic::Model::CBCO)
    .setExpressionAccess(ParameterType::MIN_CAP)
    .setUnit(U_FARAD)
    .setDescription("Extrinsic B-C overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJC", static_cast<double>(0.0), &ADMSvbic::Model::CJC)
    .setExpressionAccess(ParameterType::MIN_CAP)
    .setUnit(U_FARAD)
    .setDescription("B-C zero-bias capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QCO", static_cast<double>(0.0), &ADMSvbic::Model::QCO)
    .setUnit(U_COULOMB)
    .setDescription("Epi charge parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJEP", static_cast<double>(0.0), &ADMSvbic::Model::CJEP)
    .setExpressionAccess(ParameterType::MIN_CAP)
    .setUnit(U_FARAD)
    .setDescription("S-E zero-bias capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PC", static_cast<double>(0.75), &ADMSvbic::Model::PC)
    .setUnit(U_NONE)
    .setDescription("B-C built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MC", static_cast<double>(0.33), &ADMSvbic::Model::MC)
    .setUnit(U_NONE)
    .setDescription("B-C grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AJC", static_cast<double>((-0.5)), &ADMSvbic::Model::AJC)
    .setUnit(U_NONE)
    .setDescription("Base-Collector capacitor smoothing factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJCP", static_cast<double>(0.0), &ADMSvbic::Model::CJCP)
    .setExpressionAccess(ParameterType::MIN_CAP)
    .setUnit(U_FARAD)
    .setDescription("S-C zero-bias capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PS", static_cast<double>(0.75), &ADMSvbic::Model::PS)
    .setUnit(U_NONE)
    .setDescription("S-C built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MS", static_cast<double>(0.33), &ADMSvbic::Model::MS)
    .setUnit(U_NONE)
    .setDescription("S-C grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AJS", static_cast<double>((-0.5)), &ADMSvbic::Model::AJS)
    .setUnit(U_NONE)
    .setDescription("Substrate-collector capacitor smoothing factor (unused)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBEI", static_cast<double>(1.0e-18), &ADMSvbic::Model::IBEI)
    .setUnit(U_AMP)
    .setDescription("Ideal B-E saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WBE", static_cast<double>(1.0), &ADMSvbic::Model::WBE)
    .setUnit(U_NONE)
    .setDescription("Portion of Ibei from Vbei")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NEI", static_cast<double>(1.0), &ADMSvbic::Model::NEI)
    .setUnit(U_NONE)
    .setDescription("Ideal B-E emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBEN", static_cast<double>(0.0), &ADMSvbic::Model::IBEN)
    .setUnit(U_AMP)
    .setDescription("Nonideal B-E saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NEN", static_cast<double>(2.0), &ADMSvbic::Model::NEN)
    .setUnit(U_NONE)
    .setDescription("Non-ideal B-E emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBCI", static_cast<double>(1.0e-16), &ADMSvbic::Model::IBCI)
    .setUnit(U_AMP)
    .setDescription("Ideal B-C saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCI", static_cast<double>(1.0), &ADMSvbic::Model::NCI)
    .setUnit(U_NONE)
    .setDescription("Ideal B-C emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBCN", static_cast<double>(0.0), &ADMSvbic::Model::IBCN)
    .setUnit(U_AMP)
    .setDescription("Nonideal B-C saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCN", static_cast<double>(2.0), &ADMSvbic::Model::NCN)
    .setUnit(U_NONE)
    .setDescription("Non-ideal B-C emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AVC1", static_cast<double>(0.0), &ADMSvbic::Model::AVC1)
    .setUnit(U_VOLTM1)
    .setDescription("B-C weak avalanche parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AVC2", static_cast<double>(0.0), &ADMSvbic::Model::AVC2)
    .setUnit(U_VOLTM1)
    .setDescription("B-C weak avalanche parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ISP", static_cast<double>(0.0), &ADMSvbic::Model::ISP)
    .setUnit(U_AMP)
    .setDescription("Parasitic transport saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WSP", static_cast<double>(1.0), &ADMSvbic::Model::WSP)
    .setUnit(U_NONE)
    .setDescription("Portion of Iccp from Vbep")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFP", static_cast<double>(1.0), &ADMSvbic::Model::NFP)
    .setUnit(U_NONE)
    .setDescription("Parasitic forward emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBEIP", static_cast<double>(0.0), &ADMSvbic::Model::IBEIP)
    .setUnit(U_AMP)
    .setDescription("Ideal parasitic B-E saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBENP", static_cast<double>(0.0), &ADMSvbic::Model::IBENP)
    .setUnit(U_AMP)
    .setDescription("Nonideal parasitic B-E saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBCIP", static_cast<double>(0.0), &ADMSvbic::Model::IBCIP)
    .setUnit(U_AMP)
    .setDescription("Ideal parasitic B-C saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCIP", static_cast<double>(1.0), &ADMSvbic::Model::NCIP)
    .setUnit(U_NONE)
    .setDescription("Ideal parasitic B-C emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBCNP", static_cast<double>(0.0), &ADMSvbic::Model::IBCNP)
    .setUnit(U_AMP)
    .setDescription("Nonideal parasitic B-C saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCNP", static_cast<double>(2.0), &ADMSvbic::Model::NCNP)
    .setUnit(U_NONE)
    .setDescription("Non-ideal parasitic B-C emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VEF", static_cast<double>(0.0), &ADMSvbic::Model::VEF)
    .setUnit(U_VOLT)
    .setDescription("Forward Early voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VER", static_cast<double>(0.0), &ADMSvbic::Model::VER)
    .setUnit(U_VOLT)
    .setDescription("Reverse Early voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IKF", static_cast<double>(0.0), &ADMSvbic::Model::IKF)
    .setUnit(U_AMP)
    .setDescription("Forward knee current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IKR", static_cast<double>(0.0), &ADMSvbic::Model::IKR)
    .setUnit(U_AMP)
    .setDescription("Reverse knee current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IKP", static_cast<double>(0.0), &ADMSvbic::Model::IKP)
    .setUnit(U_AMP)
    .setDescription("Parasitic knee current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TF", static_cast<double>(0.0), &ADMSvbic::Model::TF)
    .setUnit(U_SECOND)
    .setDescription("Forward transit time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QTF", static_cast<double>(0.0), &ADMSvbic::Model::QTF)
    .setUnit(U_NONE)
    .setDescription("Variation of tf with base width modulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTF", static_cast<double>(0.0), &ADMSvbic::Model::XTF)
    .setUnit(U_NONE)
    .setDescription("Coefficient of tf with bias dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTF", static_cast<double>(0.0), &ADMSvbic::Model::VTF)
    .setUnit(U_NONE)
    .setDescription("Coefficient of tf dependence on Vbc")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ITF", static_cast<double>(0.0), &ADMSvbic::Model::ITF)
    .setUnit(U_NONE)
    .setDescription("Coefficient of tf dependence on Ic")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TR", static_cast<double>(0.0), &ADMSvbic::Model::TR)
    .setUnit(U_NONE)
    .setDescription("Reverse transit time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TD", static_cast<double>(0.0), &ADMSvbic::Model::TD)
    .setUnit(U_NONE)
    .setDescription("Forward excess-phase delay time (unused in this version)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KFN", static_cast<double>(0.0), &ADMSvbic::Model::KFN)
    .setUnit(U_NONE)
    .setDescription("B-E flicker (1/f) noise coefficient (unused)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AFN", static_cast<double>(1.0), &ADMSvbic::Model::AFN)
    .setUnit(U_NONE)
    .setDescription("Base-Emitter Flicker Noise coefficient (unused)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BFN", static_cast<double>(1.0), &ADMSvbic::Model::BFN)
    .setUnit(U_NONE)
    .setDescription("B-E flicker noise dependence (unused)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRE", static_cast<double>(0), &ADMSvbic::Model::XRE)
    .setUnit(U_NONE)
    .setDescription("Temperature exponent of re")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRBI", static_cast<double>(0), &ADMSvbic::Model::XRBI)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRCI", static_cast<double>(0), &ADMSvbic::Model::XRCI)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRS", static_cast<double>(0), &ADMSvbic::Model::XRS)
    .setUnit(U_NONE)
    .setDescription("Temperature exponent of rs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XVO", static_cast<double>(0), &ADMSvbic::Model::XVO)
    .setUnit(U_NONE)
    .setDescription("Temperature exponent of vo")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EA", static_cast<double>(1.12), &ADMSvbic::Model::EA)
    .setUnit(U_EV)
    .setDescription("Activation energy for IS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EAIE", static_cast<double>(1.12), &ADMSvbic::Model::EAIE)
    .setUnit(U_EV)
    .setDescription("Activation energy for IBEI")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EAIC", static_cast<double>(1.12), &ADMSvbic::Model::EAIC)
    .setUnit(U_EV)
    .setDescription("Activation energy for IBCI")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EAIS", static_cast<double>(1.12), &ADMSvbic::Model::EAIS)
    .setUnit(U_EV)
    .setDescription("Activation energy for IBCIP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EANE", static_cast<double>(1.12), &ADMSvbic::Model::EANE)
    .setUnit(U_EV)
    .setDescription("Activation energy for IBEN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EANC", static_cast<double>(1.12), &ADMSvbic::Model::EANC)
    .setUnit(U_EV)
    .setDescription("Activation energy for IBCN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EANS", static_cast<double>(1.12), &ADMSvbic::Model::EANS)
    .setUnit(U_EV)
    .setDescription("Activation energy for IBCNP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XIS", static_cast<double>(3.0), &ADMSvbic::Model::XIS)
    .setUnit(U_NONE)
    .setDescription("Temperature exponent of IS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XII", static_cast<double>(3.0), &ADMSvbic::Model::XII)
    .setUnit(U_NONE)
    .setDescription("Temperature exponent of Ibei, Ibci, Ibeip, and Ibcip")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XIN", static_cast<double>(3.0), &ADMSvbic::Model::XIN)
    .setUnit(U_NONE)
    .setDescription("Temperature exponent of Iben, Ibcn, Ibenp, and Ibcnp")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNF", static_cast<double>(0.0), &ADMSvbic::Model::TNF)
    .setUnit(U_NONE)
    .setDescription("Temperature coefficient of Nf")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TAVC", static_cast<double>(0.0), &ADMSvbic::Model::TAVC)
    .setUnit(U_NONE)
    .setDescription("Temperature coefficient of Avc2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RTH", static_cast<double>(0.0), &ADMSvbic::Model::RTH)
    .setUnit(U_OHM)
    .setDescription("Thermal resistance, must be given for self-heating")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTH", static_cast<double>(0.0), &ADMSvbic::Model::CTH)
    .setUnit(U_FARAD)
    .setDescription("Thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VRT", static_cast<double>(0.0), &ADMSvbic::Model::VRT)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ART", static_cast<double>(0.1), &ADMSvbic::Model::ART)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CCSO", static_cast<double>(0.0), &ADMSvbic::Model::CCSO)
    .setUnit(U_NONE)
    .setDescription("(unused)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QBM", static_cast<double>(0.0), &ADMSvbic::Model::QBM)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NKF", static_cast<double>(0.5), &ADMSvbic::Model::NKF)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XIKF", static_cast<double>(0), &ADMSvbic::Model::XIKF)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRCX", static_cast<double>(0), &ADMSvbic::Model::XRCX)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRBX", static_cast<double>(0), &ADMSvbic::Model::XRBX)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRBP", static_cast<double>(0), &ADMSvbic::Model::XRBP)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ISRR", static_cast<double>(1.0), &ADMSvbic::Model::ISRR)
    .setUnit(U_NONE)
    .setDescription("Saturation current for reverse operation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XISR", static_cast<double>(0.0), &ADMSvbic::Model::XISR)
    .setUnit(U_NONE)
    .setDescription("Temperature exponent of ISRR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DEAR", static_cast<double>(0.0), &ADMSvbic::Model::DEAR)
    .setUnit(U_NONE)
    .setDescription("Activation energy for ISRR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EAP", static_cast<double>(1.12), &ADMSvbic::Model::EAP)
    .setUnit(U_NONE)
    .setDescription("Activation energy for ISP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBBE", static_cast<double>(0.0), &ADMSvbic::Model::VBBE)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBBE", static_cast<double>(1.0), &ADMSvbic::Model::NBBE)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBBE", static_cast<double>(1.0e-6), &ADMSvbic::Model::IBBE)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TVBBE1", static_cast<double>(0.0), &ADMSvbic::Model::TVBBE1)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TVBBE2", static_cast<double>(0.0), &ADMSvbic::Model::TVBBE2)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNBBE", static_cast<double>(0.0), &ADMSvbic::Model::TNBBE)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EBBE", static_cast<double>(0.0), &ADMSvbic::Model::EBBE)
    .setUnit(U_NONE)
    .setDescription("(unused)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DTEMP", static_cast<double>(0.0), &ADMSvbic::Model::DTEMP)
    .setUnit(U_NONE)
    .setDescription("Device temperature (use 0.0 for ambient)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VERS", static_cast<double>(1.2), &ADMSvbic::Model::VERS)
    .setUnit(U_NONE)
    .setDescription("Version of this VBIC model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VREV", static_cast<double>(0.0), &ADMSvbic::Model::VREV)
    .setUnit(U_NONE)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  //Hidden parameter dtype

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:
  if (!(given("DTEMP")))
  {
    DTEMP = model_.DTEMP;
  }



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter M : [ 1,  (+inf) [
  if ( (!((M >=1))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter M value " << M << " out of range [ 1,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
   const Configuration & configuration,
   const InstanceBlock & instance_block,
   Model &               model,
   const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    DTEMP(0.0),
    M(1),
    li_c(-1),
    li_b(-1),
    li_e(-1),
    li_dt(-1),
    li_cx(-1),
    li_ci(-1),
    li_bx(-1),
    li_bi(-1),
    li_ei(-1),
    li_bp(-1),
    li_branch_ic(-1),
    li_branch_ib(-1),
    li_branch_ie(-1),
    li_branch_idt(-1),
    f_bi_Equ_bi_Node_Ptr(0),
    f_bi_Equ_ei_Node_Ptr(0),
    f_ei_Equ_bi_Node_Ptr(0),
    f_ei_Equ_ei_Node_Ptr(0),
    f_bi_Equ_dt_Node_Ptr(0),
    f_ei_Equ_dt_Node_Ptr(0),
    f_bx_Equ_bx_Node_Ptr(0),
    f_bx_Equ_ei_Node_Ptr(0),
    f_ei_Equ_bx_Node_Ptr(0),
    f_bx_Equ_dt_Node_Ptr(0),
    f_ci_Equ_bi_Node_Ptr(0),
    f_ci_Equ_ci_Node_Ptr(0),
    f_ei_Equ_ci_Node_Ptr(0),
    f_ci_Equ_ei_Node_Ptr(0),
    f_ci_Equ_dt_Node_Ptr(0),
    f_bi_Equ_ci_Node_Ptr(0),
    f_bx_Equ_bp_Node_Ptr(0),
    f_bp_Equ_bx_Node_Ptr(0),
    f_bp_Equ_bp_Node_Ptr(0),
    f_bp_Equ_dt_Node_Ptr(0),
    f_c_Equ_dt_Node_Ptr(0),
    f_cx_Equ_dt_Node_Ptr(0),
    f_c_Equ_c_Node_Ptr(0),
    f_c_Equ_cx_Node_Ptr(0),
    f_cx_Equ_c_Node_Ptr(0),
    f_cx_Equ_cx_Node_Ptr(0),
    f_cx_Equ_bi_Node_Ptr(0),
    f_ci_Equ_cx_Node_Ptr(0),
    f_cx_Equ_ci_Node_Ptr(0),
    f_b_Equ_dt_Node_Ptr(0),
    f_b_Equ_b_Node_Ptr(0),
    f_b_Equ_bx_Node_Ptr(0),
    f_bx_Equ_b_Node_Ptr(0),
    f_bx_Equ_bi_Node_Ptr(0),
    f_bx_Equ_ci_Node_Ptr(0),
    f_bi_Equ_bx_Node_Ptr(0),
    f_e_Equ_dt_Node_Ptr(0),
    f_e_Equ_e_Node_Ptr(0),
    f_e_Equ_ei_Node_Ptr(0),
    f_ei_Equ_e_Node_Ptr(0),
    f_bp_Equ_bi_Node_Ptr(0),
    f_bp_Equ_ci_Node_Ptr(0),
    f_cx_Equ_bx_Node_Ptr(0),
    f_cx_Equ_bp_Node_Ptr(0),
    f_bp_Equ_cx_Node_Ptr(0),
    f_bi_Equ_cx_Node_Ptr(0),
    f_b_Equ_e_Node_Ptr(0),
    f_e_Equ_b_Node_Ptr(0),
    f_b_Equ_c_Node_Ptr(0),
    f_c_Equ_b_Node_Ptr(0),
    f_dt_Equ_dt_Node_Ptr(0),
    f_dt_Equ_bp_Node_Ptr(0),
    f_dt_Equ_cx_Node_Ptr(0),
    f_dt_Equ_e_Node_Ptr(0),
    f_dt_Equ_ei_Node_Ptr(0),
    f_dt_Equ_bx_Node_Ptr(0),
    f_dt_Equ_bi_Node_Ptr(0),
    f_dt_Equ_b_Node_Ptr(0),
    f_dt_Equ_ci_Node_Ptr(0),
    f_dt_Equ_c_Node_Ptr(0),
    q_bi_Equ_bi_Node_Ptr(0),
    q_bi_Equ_ei_Node_Ptr(0),
    q_ei_Equ_bi_Node_Ptr(0),
    q_ei_Equ_ei_Node_Ptr(0),
    q_bi_Equ_dt_Node_Ptr(0),
    q_ei_Equ_dt_Node_Ptr(0),
    q_bx_Equ_bx_Node_Ptr(0),
    q_bx_Equ_ei_Node_Ptr(0),
    q_ei_Equ_bx_Node_Ptr(0),
    q_bx_Equ_dt_Node_Ptr(0),
    q_ci_Equ_bi_Node_Ptr(0),
    q_ci_Equ_ci_Node_Ptr(0),
    q_ei_Equ_ci_Node_Ptr(0),
    q_ci_Equ_ei_Node_Ptr(0),
    q_ci_Equ_dt_Node_Ptr(0),
    q_bi_Equ_ci_Node_Ptr(0),
    q_bx_Equ_bp_Node_Ptr(0),
    q_bp_Equ_bx_Node_Ptr(0),
    q_bp_Equ_bp_Node_Ptr(0),
    q_bp_Equ_dt_Node_Ptr(0),
    q_c_Equ_dt_Node_Ptr(0),
    q_cx_Equ_dt_Node_Ptr(0),
    q_c_Equ_c_Node_Ptr(0),
    q_c_Equ_cx_Node_Ptr(0),
    q_cx_Equ_c_Node_Ptr(0),
    q_cx_Equ_cx_Node_Ptr(0),
    q_cx_Equ_bi_Node_Ptr(0),
    q_ci_Equ_cx_Node_Ptr(0),
    q_cx_Equ_ci_Node_Ptr(0),
    q_b_Equ_dt_Node_Ptr(0),
    q_b_Equ_b_Node_Ptr(0),
    q_b_Equ_bx_Node_Ptr(0),
    q_bx_Equ_b_Node_Ptr(0),
    q_bx_Equ_bi_Node_Ptr(0),
    q_bx_Equ_ci_Node_Ptr(0),
    q_bi_Equ_bx_Node_Ptr(0),
    q_e_Equ_dt_Node_Ptr(0),
    q_e_Equ_e_Node_Ptr(0),
    q_e_Equ_ei_Node_Ptr(0),
    q_ei_Equ_e_Node_Ptr(0),
    q_bp_Equ_bi_Node_Ptr(0),
    q_bp_Equ_ci_Node_Ptr(0),
    q_cx_Equ_bx_Node_Ptr(0),
    q_cx_Equ_bp_Node_Ptr(0),
    q_bp_Equ_cx_Node_Ptr(0),
    q_bi_Equ_cx_Node_Ptr(0),
    q_b_Equ_e_Node_Ptr(0),
    q_e_Equ_b_Node_Ptr(0),
    q_b_Equ_c_Node_Ptr(0),
    q_c_Equ_b_Node_Ptr(0),
    q_dt_Equ_dt_Node_Ptr(0),
    q_dt_Equ_bp_Node_Ptr(0),
    q_dt_Equ_cx_Node_Ptr(0),
    q_dt_Equ_e_Node_Ptr(0),
    q_dt_Equ_ei_Node_Ptr(0),
    q_dt_Equ_bx_Node_Ptr(0),
    q_dt_Equ_bi_Node_Ptr(0),
    q_dt_Equ_b_Node_Ptr(0),
    q_dt_Equ_ci_Node_Ptr(0),
    q_dt_Equ_c_Node_Ptr(0),
    A_bi_Equ_bi_NodeOffset(-1),
    A_bi_Equ_ei_NodeOffset(-1),
    A_ei_Equ_bi_NodeOffset(-1),
    A_ei_Equ_ei_NodeOffset(-1),
    A_bi_Equ_dt_NodeOffset(-1),
    A_ei_Equ_dt_NodeOffset(-1),
    A_bx_Equ_bx_NodeOffset(-1),
    A_bx_Equ_ei_NodeOffset(-1),
    A_ei_Equ_bx_NodeOffset(-1),
    A_bx_Equ_dt_NodeOffset(-1),
    A_ci_Equ_bi_NodeOffset(-1),
    A_ci_Equ_ci_NodeOffset(-1),
    A_ei_Equ_ci_NodeOffset(-1),
    A_ci_Equ_ei_NodeOffset(-1),
    A_ci_Equ_dt_NodeOffset(-1),
    A_bi_Equ_ci_NodeOffset(-1),
    A_bx_Equ_bp_NodeOffset(-1),
    A_bp_Equ_bx_NodeOffset(-1),
    A_bp_Equ_bp_NodeOffset(-1),
    A_bp_Equ_dt_NodeOffset(-1),
    A_c_Equ_dt_NodeOffset(-1),
    A_cx_Equ_dt_NodeOffset(-1),
    A_c_Equ_c_NodeOffset(-1),
    A_c_Equ_cx_NodeOffset(-1),
    A_cx_Equ_c_NodeOffset(-1),
    A_cx_Equ_cx_NodeOffset(-1),
    A_cx_Equ_bi_NodeOffset(-1),
    A_ci_Equ_cx_NodeOffset(-1),
    A_cx_Equ_ci_NodeOffset(-1),
    A_b_Equ_dt_NodeOffset(-1),
    A_b_Equ_b_NodeOffset(-1),
    A_b_Equ_bx_NodeOffset(-1),
    A_bx_Equ_b_NodeOffset(-1),
    A_bx_Equ_bi_NodeOffset(-1),
    A_bx_Equ_ci_NodeOffset(-1),
    A_bi_Equ_bx_NodeOffset(-1),
    A_e_Equ_dt_NodeOffset(-1),
    A_e_Equ_e_NodeOffset(-1),
    A_e_Equ_ei_NodeOffset(-1),
    A_ei_Equ_e_NodeOffset(-1),
    A_bp_Equ_bi_NodeOffset(-1),
    A_bp_Equ_ci_NodeOffset(-1),
    A_cx_Equ_bx_NodeOffset(-1),
    A_cx_Equ_bp_NodeOffset(-1),
    A_bp_Equ_cx_NodeOffset(-1),
    A_bi_Equ_cx_NodeOffset(-1),
    A_b_Equ_e_NodeOffset(-1),
    A_e_Equ_b_NodeOffset(-1),
    A_b_Equ_c_NodeOffset(-1),
    A_c_Equ_b_NodeOffset(-1),
    A_dt_Equ_dt_NodeOffset(-1),
    A_dt_Equ_bp_NodeOffset(-1),
    A_dt_Equ_cx_NodeOffset(-1),
    A_dt_Equ_e_NodeOffset(-1),
    A_dt_Equ_ei_NodeOffset(-1),
    A_dt_Equ_bx_NodeOffset(-1),
    A_dt_Equ_bi_NodeOffset(-1),
    A_dt_Equ_b_NodeOffset(-1),
    A_dt_Equ_ci_NodeOffset(-1),
    A_dt_Equ_c_NodeOffset(-1),
                                                           admsTemperature(getDeviceOptions().temp.getImmutableValue<double>()),
                                                           externalNodeMode(false)

{
  numIntVars = 6 + 0;
  numExtVars = 4;

  // Manually inserted code:
  devConMap.resize(4);
  devConMap[0] = 1;
  devConMap[1] = 1;
  devConMap[2] = 1;
  devConMap[3] = 2;

  if ( instance_block.numExtVars > 4)
  {
    numExtVars = instance_block.numExtVars;
    externalNodeMode = true;
    numIntVars -= numExtVars-4;
    devConMap.resize(numExtVars);
    for (int i1=4; i1<numExtVars; ++i1)
      devConMap[i1]=1;
  }
  // End manually inserted code

  // Right now, we only have store for limited probes...
  setNumStoreVars(7);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 4;

  leadCurrentF.resize(4);
  leadCurrentQ.resize(4);
  
  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
  PairVector jacobianElements;
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_cx));

  

  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  // Manually added code
  // there are always ci and bi, but the others could be mapped away.
  int numExist = ((collapseNode_cx)?0:1) + ((collapseNode_bx)?0:1) + ((collapseNode_ei)?0:1) + 2;

  if (externalNodeMode && (numExtVars != 4+numExist))
  {
    UserFatal(*this) << "Instance " << getName() << " has wrong number of external nodes!"
                       << " If you specify any internal nodes as external, you must set all that exist. ";
  }
  // End manually added code

  if (collapseNode_cx)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_cx,admsNodeID_c));
  }
  if (collapseNode_bx)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_bx,admsNodeID_b));
  }
  if (collapseNode_ei)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_ei,admsNodeID_e));
  }

  // Now generate the jacstamp from what we already have.
  // This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
  // node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
  // (for devices that have no collapsibles, this will be static, so check that it hasn't already
  // been filled in)
  if (jacStamp.empty())
  {
    int originalSize = 10+0;
    computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
  }

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
  collapseNode_cx = false;
  collapseNode_bx = false;
  collapseNode_ei = false;
  if (!(((model_.RCX)>0)))
  {
    collapseNode_cx = true;

  }

  if (!(((model_.RBX)>0)))
  {
    collapseNode_bx = true;

  }

  if (!(((model_.RE)>0)))
  {
    collapseNode_ei = true;

  }


  if (collapseNode_cx)
  {
    numIntVars--;
  }
  if (collapseNode_bx)
  {
    numIntVars--;
  }
  if (collapseNode_ei)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local ID's.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;
  
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSvbic::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
  }
    
  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_c = localLIDVec[nodeMap[admsNodeID_c]];
  li_b = localLIDVec[nodeMap[admsNodeID_b]];
  li_e = localLIDVec[nodeMap[admsNodeID_e]];
  li_dt = localLIDVec[nodeMap[admsNodeID_dt]];
  li_cx = localLIDVec[nodeMap[admsNodeID_cx]];
  li_ci = localLIDVec[nodeMap[admsNodeID_ci]];
  li_bx = localLIDVec[nodeMap[admsNodeID_bx]];
  li_bi = localLIDVec[nodeMap[admsNodeID_bi]];
  li_ei = localLIDVec[nodeMap[admsNodeID_ei]];
  li_bp = localLIDVec[nodeMap[admsNodeID_bp]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
    Xyce::dout() << "\nli_c = " << li_c << std::endl;
    Xyce::dout() << "\nli_b = " << li_b << std::endl;
    Xyce::dout() << "\nli_e = " << li_e << std::endl;
    Xyce::dout() << "\nli_dt = " << li_dt << std::endl;
    Xyce::dout() << "\nli_cx = " << li_cx << std::endl;
    Xyce::dout() << "\nli_ci = " << li_ci << std::endl;
    Xyce::dout() << "\nli_bx = " << li_bx << std::endl;
    Xyce::dout() << "\nli_bi = " << li_bi << std::endl;
    Xyce::dout() << "\nli_ei = " << li_ei << std::endl;
    Xyce::dout() << "\nli_bp = " << li_bp << std::endl;

    Xyce::dout() << "\nEnd of ADMSvbic::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
  if (!collapseNode_cx)
  {
    addInternalNode(symbol_table, li_cx, getName(), "cx");
  }
  addInternalNode(symbol_table, li_ci, getName(), "ci");
  if (!collapseNode_bx)
  {
    addInternalNode(symbol_table, li_bx, getName(), "bx");
  }
  addInternalNode(symbol_table, li_bi, getName(), "bi");
  if (!collapseNode_ei)
  {
    addInternalNode(symbol_table, li_ei, getName(), "ei");
  }
  addInternalNode(symbol_table, li_bp, getName(), "bp");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_ic, getName(), "BRANCH_DC");
    addBranchDataNode( symbol_table, li_branch_ib, getName(), "BRANCH_DB");
    addBranchDataNode( symbol_table, li_branch_ie, getName(), "BRANCH_DE");
    addBranchDataNode( symbol_table, li_branch_idt, getName(), "BRANCH_D4");
  }
}
 
//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());

  int numSto = stoLIDVecRef.size();
  if (numSto > 0)
  {
    int i=0;
    stoLIDVec = stoLIDVecRef;

    li_store_admsProbeID_V_bi_ei = stoLIDVec[i++];
    li_store_admsProbeID_V_bi_ci = stoLIDVec[i++];
    li_store_admsProbeID_V_bx_ei = stoLIDVec[i++];
    li_store_admsProbeID_V_bi_cx = stoLIDVec[i++];
    li_store_admsProbeID_V_bx_bp = stoLIDVec[i++];
    li_store_admsProbeID_V_dt_GND = stoLIDVec[i++];
    li_store_admsProbeID_V_b_e = stoLIDVec[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {    
    int i = 0;
    li_branch_ic = branchLIDVecRef[i++];
    li_branch_ib = branchLIDVecRef[i++];
    li_branch_ie = branchLIDVecRef[i++];
    li_branch_idt = branchLIDVecRef[i++];
  }
}
  
//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes : In initial version, we won't support mapping away nodes
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
  return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_dt)];
  A_c_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c)];
  A_c_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_cx)];
  A_c_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_b)];
  A_c_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_dt)];
  A_b_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b)];
  A_b_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_bx)];
  A_b_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_e)];
  A_b_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c)];
  A_b_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_dt)];
  A_e_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_e)];
  A_e_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_ei)];
  A_e_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_b)];
  A_e_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_dt)];
  A_dt_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_bp)];
  A_dt_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_cx)];
  A_dt_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_e)];
  A_dt_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_ei)];
  A_dt_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_bx)];
  A_dt_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_bi)];
  A_dt_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_b)];
  A_dt_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_ci)];
  A_dt_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_c)];
  A_dt_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_dt)];
  A_cx_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_c)];
  A_cx_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_cx)];
  A_cx_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_bi)];
  A_cx_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_ci)];
  A_cx_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_bx)];
  A_cx_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_bp)];
  A_cx_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_bi)];
  A_ci_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_ci)];
  A_ci_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_ei)];
  A_ci_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_dt)];
  A_ci_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_cx)];
  A_ci_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_bx)];
  A_bx_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_ei)];
  A_bx_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_dt)];
  A_bx_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_bp)];
  A_bx_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_b)];
  A_bx_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_bi)];
  A_bx_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_ci)];
  A_bx_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_bi)];
  A_bi_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_ei)];
  A_bi_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_dt)];
  A_bi_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_ci)];
  A_bi_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_bx)];
  A_bi_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_cx)];
  A_bi_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_bi)];
  A_ei_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_ei)];
  A_ei_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_dt)];
  A_ei_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_bx)];
  A_ei_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_ci)];
  A_ei_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_e)];
  A_ei_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_bx)];
  A_bp_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_bp)];
  A_bp_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_dt)];
  A_bp_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_bi)];
  A_bp_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_ci)];
  A_bp_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_cx)];
  A_bp_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix * dFdxMatPtr = extData.dFdxMatrixPtr;
  Linear::Matrix * dQdxMatPtr = extData.dQdxMatrixPtr;
  f_c_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_dt);
  q_c_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_dt);
  f_c_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_c);
  q_c_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_c);
  f_c_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_cx);
  q_c_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_cx);
  f_c_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_b);
  q_c_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_b);
  f_b_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_dt);
  q_b_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_dt);
  f_b_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_b);
  q_b_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_b);
  f_b_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_bx);
  q_b_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_bx);
  f_b_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_e);
  q_b_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_e);
  f_b_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_c);
  q_b_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_c);
  f_e_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_dt);
  q_e_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_dt);
  f_e_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_e);
  q_e_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_e);
  f_e_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_ei);
  q_e_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_ei);
  f_e_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_b);
  q_e_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_b);
  f_dt_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_dt);
  q_dt_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_dt);
  f_dt_Equ_bp_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_bp);
  q_dt_Equ_bp_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_bp);
  f_dt_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_cx);
  q_dt_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_cx);
  f_dt_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_e);
  q_dt_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_e);
  f_dt_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_ei);
  q_dt_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_ei);
  f_dt_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_bx);
  q_dt_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_bx);
  f_dt_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_bi);
  q_dt_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_bi);
  f_dt_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_b);
  q_dt_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_b);
  f_dt_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_ci);
  q_dt_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_ci);
  f_dt_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_c);
  q_dt_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_c);
  f_cx_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_dt);
  q_cx_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_dt);
  f_cx_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_c);
  q_cx_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_c);
  f_cx_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_cx);
  q_cx_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_cx);
  f_cx_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_bi);
  q_cx_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_bi);
  f_cx_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_ci);
  q_cx_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_ci);
  f_cx_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_bx);
  q_cx_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_bx);
  f_cx_Equ_bp_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_bp);
  q_cx_Equ_bp_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_bp);
  f_ci_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_bi);
  q_ci_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_bi);
  f_ci_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_ci);
  q_ci_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_ci);
  f_ci_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_ei);
  q_ci_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_ei);
  f_ci_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_dt);
  q_ci_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_dt);
  f_ci_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_cx);
  q_ci_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_cx);
  f_bx_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_bx);
  q_bx_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_bx);
  f_bx_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_ei);
  q_bx_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_ei);
  f_bx_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_dt);
  q_bx_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_dt);
  f_bx_Equ_bp_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_bp);
  q_bx_Equ_bp_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_bp);
  f_bx_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_b);
  q_bx_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_b);
  f_bx_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_bi);
  q_bx_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_bi);
  f_bx_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_ci);
  q_bx_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_ci);
  f_bi_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_bi);
  q_bi_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_bi);
  f_bi_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_ei);
  q_bi_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_ei);
  f_bi_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_dt);
  q_bi_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_dt);
  f_bi_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_ci);
  q_bi_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_ci);
  f_bi_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_bx);
  q_bi_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_bx);
  f_bi_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_cx);
  q_bi_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_cx);
  f_ei_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_bi);
  q_ei_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_bi);
  f_ei_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_ei);
  q_ei_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_ei);
  f_ei_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_dt);
  q_ei_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_dt);
  f_ei_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_bx);
  q_ei_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_bx);
  f_ei_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_ci);
  q_ei_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_ci);
  f_ei_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_e);
  q_ei_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_e);
  f_bp_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bp,li_bx);
  q_bp_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bp,li_bx);
  f_bp_Equ_bp_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bp,li_bp);
  q_bp_Equ_bp_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bp,li_bp);
  f_bp_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bp,li_dt);
  q_bp_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bp,li_dt);
  f_bp_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bp,li_bi);
  q_bp_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bp,li_bi);
  f_bp_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bp,li_ci);
  q_bp_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bp,li_ci);
  f_bp_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bp,li_cx);
  q_bp_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bp,li_cx);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
  (*extData.daeFVectorPtr)[li_c] += staticContributions[admsNodeID_c].val();
  (*extData.daeFVectorPtr)[li_b] += staticContributions[admsNodeID_b].val();
  (*extData.daeFVectorPtr)[li_e] += staticContributions[admsNodeID_e].val();
  (*extData.daeFVectorPtr)[li_dt] += staticContributions[admsNodeID_dt].val();
  (*extData.daeFVectorPtr)[li_cx] += staticContributions[admsNodeID_cx].val();
  (*extData.daeFVectorPtr)[li_ci] += staticContributions[admsNodeID_ci].val();
  (*extData.daeFVectorPtr)[li_bx] += staticContributions[admsNodeID_bx].val();
  (*extData.daeFVectorPtr)[li_bi] += staticContributions[admsNodeID_bi].val();
  (*extData.daeFVectorPtr)[li_ei] += staticContributions[admsNodeID_ei].val();
  (*extData.daeFVectorPtr)[li_bp] += staticContributions[admsNodeID_bp].val();

  if (getDeviceOptions().voltageLimiterFlag && !origFlag)
  {
    double *dFdxdVp = extData.dFdxdVpVectorRawPtr;
    dFdxdVp[li_c] += Jdxp_static[admsNodeID_c];
    dFdxdVp[li_b] += Jdxp_static[admsNodeID_b];
    dFdxdVp[li_e] += Jdxp_static[admsNodeID_e];
    dFdxdVp[li_dt] += Jdxp_static[admsNodeID_dt];
    dFdxdVp[li_cx] += Jdxp_static[admsNodeID_cx];
    dFdxdVp[li_ci] += Jdxp_static[admsNodeID_ci];
    dFdxdVp[li_bx] += Jdxp_static[admsNodeID_bx];
    dFdxdVp[li_bi] += Jdxp_static[admsNodeID_bi];
    dFdxdVp[li_ei] += Jdxp_static[admsNodeID_ei];
    dFdxdVp[li_bp] += Jdxp_static[admsNodeID_bp];


  }

  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;

    leadF[li_branch_ic] = leadCurrentF[admsNodeID_c];
    leadF[li_branch_ib] = leadCurrentF[admsNodeID_b];
    leadF[li_branch_ie] = leadCurrentF[admsNodeID_e];
    leadF[li_branch_idt] = leadCurrentF[admsNodeID_dt];

    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.
    
    double * solVec = extData.nextSolVectorRawPtr;
    double * junctionV = extData.nextJunctionVCompRawPtr;
    junctionV[li_branch_ic] = solVec[li_c] - solVec[li_e];
    junctionV[li_branch_ib] = solVec[li_b] - solVec[li_e];
          
  }  
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
  (*extData.daeQVectorPtr)[li_c] += dynamicContributions[admsNodeID_c].val();
  (*extData.daeQVectorPtr)[li_b] += dynamicContributions[admsNodeID_b].val();
  (*extData.daeQVectorPtr)[li_e] += dynamicContributions[admsNodeID_e].val();
  (*extData.daeQVectorPtr)[li_dt] += dynamicContributions[admsNodeID_dt].val();
  (*extData.daeQVectorPtr)[li_cx] += dynamicContributions[admsNodeID_cx].val();
  (*extData.daeQVectorPtr)[li_ci] += dynamicContributions[admsNodeID_ci].val();
  (*extData.daeQVectorPtr)[li_bx] += dynamicContributions[admsNodeID_bx].val();
  (*extData.daeQVectorPtr)[li_bi] += dynamicContributions[admsNodeID_bi].val();
  (*extData.daeQVectorPtr)[li_ei] += dynamicContributions[admsNodeID_ei].val();
  (*extData.daeQVectorPtr)[li_bp] += dynamicContributions[admsNodeID_bp].val();

  if (getDeviceOptions().voltageLimiterFlag && !origFlag)
  {
    double *dQdxdVp = extData.dQdxdVpVectorRawPtr;
    dQdxdVp[li_c] += Jdxp_dynamic[admsNodeID_c];
    dQdxdVp[li_b] += Jdxp_dynamic[admsNodeID_b];
    dQdxdVp[li_e] += Jdxp_dynamic[admsNodeID_e];
    dQdxdVp[li_dt] += Jdxp_dynamic[admsNodeID_dt];
    dQdxdVp[li_cx] += Jdxp_dynamic[admsNodeID_cx];
    dQdxdVp[li_ci] += Jdxp_dynamic[admsNodeID_ci];
    dQdxdVp[li_bx] += Jdxp_dynamic[admsNodeID_bx];
    dQdxdVp[li_bi] += Jdxp_dynamic[admsNodeID_bi];
    dQdxdVp[li_ei] += Jdxp_dynamic[admsNodeID_ei];
    dQdxdVp[li_bp] += Jdxp_dynamic[admsNodeID_bp];

  }

  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;

    leadQ[li_branch_ic] = leadCurrentQ[admsNodeID_c];
    leadQ[li_branch_ib] = leadCurrentQ[admsNodeID_b];
    leadQ[li_branch_ie] = leadCurrentQ[admsNodeID_e];
    leadQ[li_branch_idt] = leadCurrentQ[admsNodeID_dt];
  }  
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.

  double * stoVec = extData.nextStoVectorRawPtr;
  // Also need to save limited voltage drops
  // This formulation assumes that we have *always* written the
  // limited voltages back into the probeVars[] array.

  stoVec[li_store_admsProbeID_V_bi_ei] = probeVars[admsProbeID_V_bi_ei].val();
  stoVec[li_store_admsProbeID_V_bi_ci] = probeVars[admsProbeID_V_bi_ci].val();
  stoVec[li_store_admsProbeID_V_bx_ei] = probeVars[admsProbeID_V_bx_ei].val();
  stoVec[li_store_admsProbeID_V_bi_cx] = probeVars[admsProbeID_V_bi_cx].val();
  stoVec[li_store_admsProbeID_V_bx_bp] = probeVars[admsProbeID_V_bx_bp].val();
  stoVec[li_store_admsProbeID_V_dt_GND] = probeVars[admsProbeID_V_dt_GND].val();
  stoVec[li_store_admsProbeID_V_b_e] = probeVars[admsProbeID_V_b_e].val();

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one vbic instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSvbic::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  AdmsFadType Qcth;
  AdmsFadType Irth;
  AdmsFadType Ith;
  AdmsFadType Qbco;
  AdmsFadType Qbeo;
  AdmsFadType Qbep;
  AdmsFadType Qbcx;
  AdmsFadType Qbc;
  AdmsFadType Qbex;
  AdmsFadType Qbe;
  AdmsFadType tff;
  AdmsFadType tff_exparg;
  AdmsFadType mIf;
  AdmsFadType rIf;
  AdmsFadType sgIf;
  AdmsFadType Irbp;
  AdmsFadType Ire;
  AdmsFadType Irbi;
  AdmsFadType Irbx;
  AdmsFadType Irci;
  AdmsFadType derf;
  AdmsFadType Iohm;
  AdmsFadType rKp1;
  AdmsFadType Kbcx;
  AdmsFadType Kbci;
  AdmsFadType expx_vbcx;
  AdmsFadType argx_vbcx;
  AdmsFadType Ircx;
  AdmsFadType Ibc;
  AdmsFadType Igc;
  AdmsFadType avalf;
  AdmsFadType avalf_exparg;
  AdmsFadType Ibep;
  AdmsFadType expn_vbep;
  AdmsFadType argn_vbep;
  AdmsFadType Ibcj;
  AdmsFadType expn_vbci;
  AdmsFadType argn_vbci;
  AdmsFadType Ibex;
  AdmsFadType Ibe;
  AdmsFadType expx_vbei;
  AdmsFadType argx_vbei;
  AdmsFadType expn_vbei;
  AdmsFadType argn_vbei;
  AdmsFadType argi_vbex;
  AdmsFadType expi_vbex;
  AdmsFadType argn_vbex;
  AdmsFadType expn_vbex;
  AdmsFadType argx_vbex;
  AdmsFadType expx_vbex;
  AdmsFadType qbp;
  AdmsFadType q2p;
  AdmsFadType Ifp;
  AdmsFadType expx_vbci;
  AdmsFadType argx_vbci;
  AdmsFadType expi_vbep;
  AdmsFadType argi_vbep;
  AdmsFadType Itzf;
  AdmsFadType Itzr;
  AdmsFadType qb;
  AdmsFadType q2;
  AdmsFadType q1;
  AdmsFadType q1z;
  AdmsFadType Iri;
  AdmsFadType expi_vbci;
  AdmsFadType argi_vbci;
  AdmsFadType Ifi;
  AdmsFadType expi_vbei;
  AdmsFadType argi_vbei;
  AdmsFadType qdbep;
  AdmsFadType qhi_vbep;
  AdmsFadType qlo_vbep;
  AdmsFadType dvh_vbep;
  AdmsFadType ql_vbep;
  AdmsFadType cl_vbep;
  AdmsFadType sel_vbep;
  AdmsFadType vl_vbep;
  AdmsFadType vnl_vbep;
  AdmsFadType vn_vbep;
  AdmsFadType mv_vbep;
  AdmsFadType dv_vbep;
  AdmsFadType qdbc;
  AdmsFadType qhi_vbci;
  AdmsFadType qlo_vbci;
  AdmsFadType dvh_vbci;
  AdmsFadType ql_vbci;
  AdmsFadType cl_vbci;
  AdmsFadType cmx;
  AdmsFadType crt;
  AdmsFadType sel_vbci;
  AdmsFadType vl_vbci;
  AdmsFadType vnl_vbci;
  AdmsFadType vn_vbci;
  AdmsFadType qlo0;
  AdmsFadType vnl0;
  AdmsFadType vn0;
  AdmsFadType mv_vbci;
  AdmsFadType dv_vbci;
  AdmsFadType qdbex;
  AdmsFadType qhi_vbex;
  AdmsFadType qlo_vbex;
  AdmsFadType dvh_vbex;
  AdmsFadType vl_vbex;
  AdmsFadType mv_vbex;
  AdmsFadType dv_vbex;
  AdmsFadType qdbe;
  AdmsFadType qhi_vbei;
  AdmsFadType qlo_vbei;
  double pwq;
  AdmsFadType dvh_vbei;
  AdmsFadType vl_vbei;
  AdmsFadType mv_vbei;
  AdmsFadType dv_vbei;
  AdmsFadType q0;
  AdmsFadType vl0;
  AdmsFadType mv0;
  AdmsFadType dv0;
  double slTF;
  double IITF;
  double IVTF;
  double IHRCF;
  AdmsFadType IVO;
  double IIKP;
  double IIKR;
  AdmsFadType IIKF;
  double IVER;
  double IVEF;
  AdmsFadType EBBEatT;
  AdmsFadType VOatT;
  AdmsFadType GAMMatT;
  AdmsFadType CJCPatT;
  AdmsFadType CJEPatT;
  AdmsFadType CJCatT;
  AdmsFadType CJEatT;
  AdmsFadType PSatT;
  AdmsFadType PCatT;
  AdmsFadType PEatT;
  AdmsFadType psiin;
  AdmsFadType psiio;
  AdmsFadType NBBEatT;
  AdmsFadType VBBEatT;
  AdmsFadType AVC2atT;
  AdmsFadType NRatT;
  AdmsFadType NFatT;
  AdmsFadType IBCNPatT;
  AdmsFadType IBCIPatT;
  AdmsFadType IBENPatT;
  AdmsFadType IBEIPatT;
  AdmsFadType IBCNatT;
  AdmsFadType IBCIatT;
  AdmsFadType IBENatT;
  AdmsFadType IBEIatT;
  AdmsFadType ISPatT;
  AdmsFadType ISRRatT;
  AdmsFadType ISatT;
  AdmsFadType RBPatT;
  AdmsFadType RSatT;
  AdmsFadType REatT;
  AdmsFadType RBIatT;
  AdmsFadType RBXatT;
  AdmsFadType RCIatT;
  AdmsFadType RCXatT;
  AdmsFadType IKFatT;
  AdmsFadType dT;
  AdmsFadType rT;
  AdmsFadType Vtv;
  AdmsFadType Tdev;
  double Tini;
  AdmsFadType Vcei;
  AdmsFadType Vbc;
  AdmsFadType Vrbp;
  AdmsFadType Vre;
  AdmsFadType Vrbx;
  AdmsFadType Vrbi;
  AdmsFadType Vrci;
  AdmsFadType Vrcx;
  AdmsFadType Vbe;
  AdmsFadType Vrth;
  AdmsFadType Vbep;
  AdmsFadType Vbcx;
  AdmsFadType Vbex;
  AdmsFadType Vbci;
  AdmsFadType Vbei;
  double tVCrit;
  // temporary variables for limiting
  double Vbe_orig,Vbe_limited,Vbe_old;
  double Vrth_orig,Vrth_limited,Vrth_old;
  double Vbep_orig,Vbep_limited,Vbep_old;
  double Vbcx_orig,Vbcx_limited,Vbcx_old;
  double Vbex_orig,Vbex_limited,Vbex_old;
  double Vbci_orig,Vbci_limited,Vbci_old;
  double Vbei_orig,Vbei_limited,Vbei_old;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (15))
  {
    probeVars.resize(15);
    staticContributions.resize(10+0);
    dynamicContributions.resize(10+0);
    probeDiffs.resize(15,0.0);
    Jdxp_static.resize(10+0);
    Jdxp_dynamic.resize(10+0);
  }

  
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 10+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
    Jdxp_static[i]=0;
    Jdxp_dynamic[i]=0;
  }

  for (int i=0; i < 15 ; ++i)
  {
    probeDiffs[i] = 0.0;
  }
  // extract solution variables and set as Fad independent variables.
  probeVars[admsProbeID_V_ci_ei] = (*solVectorPtr)[li_ci] - (*solVectorPtr)[li_ei];
  probeVars[admsProbeID_V_ci_ei].diff(admsProbeID_V_ci_ei,15);
  probeVars[admsProbeID_V_b_c] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_c];
  probeVars[admsProbeID_V_b_c].diff(admsProbeID_V_b_c,15);
  probeVars[admsProbeID_V_bp_cx] = (*solVectorPtr)[li_bp] - (*solVectorPtr)[li_cx];
  probeVars[admsProbeID_V_bp_cx].diff(admsProbeID_V_bp_cx,15);
  probeVars[admsProbeID_V_e_ei] = (*solVectorPtr)[li_e] - (*solVectorPtr)[li_ei];
  probeVars[admsProbeID_V_e_ei].diff(admsProbeID_V_e_ei,15);
  probeVars[admsProbeID_V_b_bx] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_bx];
  probeVars[admsProbeID_V_b_bx].diff(admsProbeID_V_b_bx,15);
  probeVars[admsProbeID_V_bx_bi] = (*solVectorPtr)[li_bx] - (*solVectorPtr)[li_bi];
  probeVars[admsProbeID_V_bx_bi].diff(admsProbeID_V_bx_bi,15);
  probeVars[admsProbeID_V_cx_ci] = (*solVectorPtr)[li_cx] - (*solVectorPtr)[li_ci];
  probeVars[admsProbeID_V_cx_ci].diff(admsProbeID_V_cx_ci,15);
  probeVars[admsProbeID_V_c_cx] = (*solVectorPtr)[li_c] - (*solVectorPtr)[li_cx];
  probeVars[admsProbeID_V_c_cx].diff(admsProbeID_V_c_cx,15);
  probeVars[admsProbeID_V_b_e] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_e];
  probeVars[admsProbeID_V_b_e].diff(admsProbeID_V_b_e,15);
  probeVars[admsProbeID_V_dt_GND] = (*solVectorPtr)[li_dt];
  probeVars[admsProbeID_V_dt_GND].diff(admsProbeID_V_dt_GND,15);
  probeVars[admsProbeID_V_bx_bp] = (*solVectorPtr)[li_bx] - (*solVectorPtr)[li_bp];
  probeVars[admsProbeID_V_bx_bp].diff(admsProbeID_V_bx_bp,15);
  probeVars[admsProbeID_V_bi_cx] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_cx];
  probeVars[admsProbeID_V_bi_cx].diff(admsProbeID_V_bi_cx,15);
  probeVars[admsProbeID_V_bx_ei] = (*solVectorPtr)[li_bx] - (*solVectorPtr)[li_ei];
  probeVars[admsProbeID_V_bx_ei].diff(admsProbeID_V_bx_ei,15);
  probeVars[admsProbeID_V_bi_ci] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_ci];
  probeVars[admsProbeID_V_bi_ci].diff(admsProbeID_V_bi_ci,15);
  probeVars[admsProbeID_V_bi_ei] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_ei];
  probeVars[admsProbeID_V_bi_ei].diff(admsProbeID_V_bi_ei,15);


  // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
  probeVars[admsProbeID_V_b_e] *= (model_.dtype);
  probeVars[admsProbeID_V_bx_bp] *= (model_.dtype);
  probeVars[admsProbeID_V_bi_cx] *= (model_.dtype);
  probeVars[admsProbeID_V_bx_ei] *= (model_.dtype);
  probeVars[admsProbeID_V_bi_ci] *= (model_.dtype);
  probeVars[admsProbeID_V_bi_ei] *= (model_.dtype);

  // Copy probes into limiting vars

  Vbe_orig = Vbe_limited = probeVars[admsProbeID_V_b_e].val();
  probeDiffs[admsProbeID_V_b_e] = 0.0;
  Vrth_orig = Vrth_limited = probeVars[admsProbeID_V_dt_GND].val();
  probeDiffs[admsProbeID_V_dt_GND] = 0.0;
  Vbep_orig = Vbep_limited = probeVars[admsProbeID_V_bx_bp].val();
  probeDiffs[admsProbeID_V_bx_bp] = 0.0;
  Vbcx_orig = Vbcx_limited = probeVars[admsProbeID_V_bi_cx].val();
  probeDiffs[admsProbeID_V_bi_cx] = 0.0;
  Vbex_orig = Vbex_limited = probeVars[admsProbeID_V_bx_ei].val();
  probeDiffs[admsProbeID_V_bx_ei] = 0.0;
  Vbci_orig = Vbci_limited = probeVars[admsProbeID_V_bi_ci].val();
  probeDiffs[admsProbeID_V_bi_ci] = 0.0;
  Vbei_orig = Vbei_limited = probeVars[admsProbeID_V_bi_ei].val();
  probeDiffs[admsProbeID_V_bi_ei] = 0.0;

  origFlag = true;

  // code manually moved from below, because we need it earlier than predicted by adms
  tVCrit = (adms_vt(admsTemperature)*log((adms_vt(admsTemperature)/(1.41421356237309504880*(model_.IS)))));

  if (getSolverState().newtonIter == 0)
  {

    if (getSolverState().initJctFlag_ && getDeviceOptions().voltageLimiterFlag)
    {
      // manually inserted code:
      if (getSolverState().inputOPFlag)
      {
        Linear::Vector * flagSolVectorPtr = (extData.flagSolVectorPtr);
        if ((*flagSolVectorPtr)[li_e] == 0 ||
            (*flagSolVectorPtr)[li_ei] == 0 ||
            (*flagSolVectorPtr)[li_b] == 0 ||
            (*flagSolVectorPtr)[li_bi] == 0 ||
            (*flagSolVectorPtr)[li_bx] == 0 ||
            (*flagSolVectorPtr)[li_bp] == 0 ||
            (*flagSolVectorPtr)[li_c] == 0 ||
            (*flagSolVectorPtr)[li_ci] == 0 ||
            (*flagSolVectorPtr)[li_cx] == 0 ||
            (*flagSolVectorPtr)[li_dt] == 0 )
        {
          Vbci_limited = Vbcx_limited = Vbep_limited = 0;
          Vbe_limited = Vbei_limited = Vbex_limited = tVCrit;
          Vrth_limited = 0;
          origFlag = false;
        }
      }
      else
      {
        Vbci_limited = Vbcx_limited = Vbep_limited = 0;
        Vbe_limited = Vbei_limited = Vbex_limited = tVCrit;
        Vrth_limited = 0;
        origFlag = false;
        if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) > 0 && getSolverState().debugTimeFlag)
        {
          Xyce::dout() << " Setting device initial condition to Base-Emitter drop=tVCrit (" << tVCrit << ")"<<std::endl;
        }
      }
    }
    // end manually inserted code

    if (!(getSolverState().dcopFlag)||(getSolverState().locaEnabledFlag && getSolverState().dcopFlag))
    {
      Vbe_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_b_e];
      Vrth_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_dt_GND];
      Vbep_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_bx_bp];
      Vbcx_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_bi_cx];
      Vbex_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_bx_ei];
      Vbci_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_bi_ci];
      Vbei_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_bi_ei];
    }
    else
    {
      Vbe_old = Vbe_limited;
      Vrth_old = Vrth_limited;
      Vbep_old = Vbep_limited;
      Vbcx_old = Vbcx_limited;
      Vbex_old = Vbex_limited;
      Vbci_old = Vbci_limited;
      Vbei_old = Vbei_limited;
    }
  }
  else
  {
    Vbe_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_b_e];
    Vrth_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_dt_GND];
    Vbep_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_bx_bp];
    Vbcx_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_bi_cx];
    Vbex_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_bx_ei];
    Vbci_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_bi_ci];
    Vbei_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_bi_ei];
  }
  // -- code converted from analog/code block
  // manually moved to above, we need it earlier than this:
  //tVCrit = (adms_vt(admsTemperature)*log((adms_vt(admsTemperature)/(1.41421356237309504880*(model_.IS)))));


  //Vbei = ($limit(V(bi,ei),"typedpnjlim_new",$vt(),tVCrit,dtype));
  if (getDeviceOptions().voltageLimiterFlag)
  {
    int icheck=0;
    Vbei_limited = devSupport.pnjlim_new(Vbei_limited,Vbei_old,adms_vt_nom,tVCrit,&icheck);
    if (icheck == 1)
      origFlag = false;
    if (!origFlag)
    {
      probeDiffs[admsProbeID_V_bi_ei] = Vbei_limited - Vbei_orig;
      probeVars[admsProbeID_V_bi_ei] += probeDiffs[admsProbeID_V_bi_ei];
    }
  }
  Vbei = probeVars[admsProbeID_V_bi_ei];



  //Vbci = ($limit(V(bi,ci),"typedpnjlim_new",$vt(),tVCrit,dtype));
  if (getDeviceOptions().voltageLimiterFlag)
  {
    int icheck=0;
    Vbci_limited = devSupport.pnjlim_new(Vbci_limited,Vbci_old,adms_vt_nom,tVCrit,&icheck);
    if (icheck == 1)
      origFlag = false;
    if (!origFlag)
    {
      probeDiffs[admsProbeID_V_bi_ci] = Vbci_limited - Vbci_orig;
      probeVars[admsProbeID_V_bi_ci] += probeDiffs[admsProbeID_V_bi_ci];
    }
  }
  Vbci = probeVars[admsProbeID_V_bi_ci];



  //Vbex = ($limit(V(bx,ei),"typedpnjlim_new",$vt(),tVCrit,dtype));
  if (getDeviceOptions().voltageLimiterFlag)
  {
    int icheck=0;
    Vbex_limited = devSupport.pnjlim_new(Vbex_limited,Vbex_old,adms_vt_nom,tVCrit,&icheck);
    if (icheck == 1)
      origFlag = false;
    if (!origFlag)
    {
      probeDiffs[admsProbeID_V_bx_ei] = Vbex_limited - Vbex_orig;
      probeVars[admsProbeID_V_bx_ei] += probeDiffs[admsProbeID_V_bx_ei];
    }
  }
  Vbex = probeVars[admsProbeID_V_bx_ei];



  //Vbcx = ($limit(V(bi,cx),"typedpnjlim_new",$vt(),tVCrit,dtype));
  if (getDeviceOptions().voltageLimiterFlag)
  {
    int icheck=0;
    Vbcx_limited = devSupport.pnjlim_new(Vbcx_limited,Vbcx_old,adms_vt_nom,tVCrit,&icheck);
    if (icheck == 1)
      origFlag = false;
    if (!origFlag)
    {
      probeDiffs[admsProbeID_V_bi_cx] = Vbcx_limited - Vbcx_orig;
      probeVars[admsProbeID_V_bi_cx] += probeDiffs[admsProbeID_V_bi_cx];
    }
  }
  Vbcx = probeVars[admsProbeID_V_bi_cx];



  //Vbep = ($limit(V(bx,bp),"typedpnjlim_new",$vt(),tVCrit,dtype));
  if (getDeviceOptions().voltageLimiterFlag)
  {
    int icheck=0;
    Vbep_limited = devSupport.pnjlim_new(Vbep_limited,Vbep_old,adms_vt_nom,tVCrit,&icheck);
    if (icheck == 1)
      origFlag = false;
    if (!origFlag)
    {
      probeDiffs[admsProbeID_V_bx_bp] = Vbep_limited - Vbep_orig;
      probeVars[admsProbeID_V_bx_bp] += probeDiffs[admsProbeID_V_bx_bp];
    }
  }
  Vbep = probeVars[admsProbeID_V_bx_bp];



  //Vrth = ($limit(V(dt,GND),"limRTH"));
  if (getDeviceOptions().voltageLimiterFlag)
  {
    int icheck=0;
    Vrth_limited = AnalogFunctions::limRTH(Vrth_limited,Vrth_old);
    if (Vrth_limited != Vrth_orig)
    {
      icheck=1;
    }
    if (icheck == 1)
      origFlag = false;
    if (!origFlag)
    {
      probeDiffs[admsProbeID_V_dt_GND] = Vrth_limited - Vrth_orig;
      probeVars[admsProbeID_V_dt_GND] += probeDiffs[admsProbeID_V_dt_GND];
    }
  }
  Vrth = probeVars[admsProbeID_V_dt_GND];



  //Vbe = ($limit(V(b,e),"typeddummy",$vt(),tVCrit,dtype));
  if (getDeviceOptions().voltageLimiterFlag)
  {
    int icheck=0;
    // dummy limiting for initialization purposes
    if (icheck == 1)
      origFlag = false;
    if (!origFlag)
    {
      probeDiffs[admsProbeID_V_b_e] = Vbe_limited - Vbe_orig;
      probeVars[admsProbeID_V_b_e] += probeDiffs[admsProbeID_V_b_e];
    }
  }
  Vbe = probeVars[admsProbeID_V_b_e];

  Vrcx = ((model_.dtype)*(probeVars[admsProbeID_V_c_cx]));
  Vrci = ((model_.dtype)*(probeVars[admsProbeID_V_cx_ci]));
  Vrbi = ((model_.dtype)*(probeVars[admsProbeID_V_bx_bi]));
  Vrbx = ((model_.dtype)*(probeVars[admsProbeID_V_b_bx]));
  Vre = ((model_.dtype)*(probeVars[admsProbeID_V_e_ei]));
  Vrbp = ((model_.dtype)*(probeVars[admsProbeID_V_bp_cx]));
  Vbc = ((model_.dtype)*(probeVars[admsProbeID_V_b_c]));
  Vcei = ((model_.dtype)*(probeVars[admsProbeID_V_ci_ei]));
  Tini = (2.731500e+02+(model_.TNOM));
  Tdev = ((admsTemperature+DTEMP)+Vrth);
  Vtv = ((1.380662e-23*Tdev)/1.602189e-19);
  rT = (Tdev/Tini);
  dT = (Tdev-Tini);
  IKFatT = ((model_.IKF)*pow(rT,(model_.XIKF)));
  RCXatT = ((model_.RCX)*pow(rT,(model_.XRCX)));
  RCIatT = ((model_.RCI)*pow(rT,(model_.XRCI)));
  RBXatT = ((model_.RBX)*pow(rT,(model_.XRBX)));
  RBIatT = ((model_.RBI)*pow(rT,(model_.XRBI)));
  REatT = ((model_.RE)*pow(rT,(model_.XRE)));
  RSatT = ((model_.RS)*pow(rT,(model_.XRS)));
  RBPatT = ((model_.RBP)*pow(rT,(model_.XRBP)));
  ISatT = ((model_.IS)*pow((pow(rT,(model_.XIS))*exp((((-(model_.EA))*(1.0-rT))/Vtv))),(1.0/(model_.NF))));
  ISRRatT = ((model_.ISRR)*pow((pow(rT,(model_.XISR))*exp((((-(model_.DEAR))*(1.0-rT))/Vtv))),(1.0/(model_.NR))));
  ISPatT = ((model_.ISP)*pow((pow(rT,(model_.XIS))*exp((((-(model_.EAP))*(1.0-rT))/Vtv))),(1.0/(model_.NFP))));
  IBEIatT = ((model_.IBEI)*pow((pow(rT,(model_.XII))*exp((((-(model_.EAIE))*(1.0-rT))/Vtv))),(1.0/(model_.NEI))));
  IBENatT = ((model_.IBEN)*pow((pow(rT,(model_.XIN))*exp((((-(model_.EANE))*(1.0-rT))/Vtv))),(1.0/(model_.NEN))));
  IBCIatT = ((model_.IBCI)*pow((pow(rT,(model_.XII))*exp((((-(model_.EAIC))*(1.0-rT))/Vtv))),(1.0/(model_.NCI))));
  IBCNatT = ((model_.IBCN)*pow((pow(rT,(model_.XIN))*exp((((-(model_.EANC))*(1.0-rT))/Vtv))),(1.0/(model_.NCN))));
  IBEIPatT = ((model_.IBEIP)*pow((pow(rT,(model_.XII))*exp((((-(model_.EAIC))*(1.0-rT))/Vtv))),(1.0/(model_.NCI))));
  IBENPatT = ((model_.IBENP)*pow((pow(rT,(model_.XIN))*exp((((-(model_.EANC))*(1.0-rT))/Vtv))),(1.0/(model_.NCN))));
  IBCIPatT = ((model_.IBCIP)*pow((pow(rT,(model_.XII))*exp((((-(model_.EAIS))*(1.0-rT))/Vtv))),(1.0/(model_.NCIP))));
  IBCNPatT = ((model_.IBCNP)*pow((pow(rT,(model_.XIN))*exp((((-(model_.EANS))*(1.0-rT))/Vtv))),(1.0/(model_.NCNP))));
  NFatT = ((model_.NF)*(1.0+(dT*(model_.TNF))));
  NRatT = ((model_.NR)*(1.0+(dT*(model_.TNF))));
  AVC2atT = ((model_.AVC2)*(1.0+(dT*(model_.TAVC))));
  VBBEatT = ((model_.VBBE)*(1.0+(dT*((model_.TVBBE1)+(dT*(model_.TVBBE2))))));
  NBBEatT = ((model_.NBBE)*(1.0+(dT*(model_.TNBBE))));
  psiio = ((2.0*(Vtv/rT))*log((exp((((0.5*(model_.PE))*rT)/Vtv))-exp(((((-0.5)*(model_.PE))*rT)/Vtv)))));
  psiin = (((psiio*rT)-((3.0*Vtv)*log(rT)))-((model_.EAIE)*(rT-1.0)));
  PEatT = (psiin+((2.0*Vtv)*log((0.5*(1.0+sqrt((1.0+(4.0*exp(((-psiin)/Vtv))))))))));
  psiio = ((2.0*(Vtv/rT))*log((exp((((0.5*(model_.PC))*rT)/Vtv))-exp(((((-0.5)*(model_.PC))*rT)/Vtv)))));
  psiin = (((psiio*rT)-((3.0*Vtv)*log(rT)))-((model_.EAIC)*(rT-1.0)));
  PCatT = (psiin+((2.0*Vtv)*log((0.5*(1.0+sqrt((1.0+(4.0*exp(((-psiin)/Vtv))))))))));
  psiio = ((2.0*(Vtv/rT))*log((exp((((0.5*(model_.PS))*rT)/Vtv))-exp(((((-0.5)*(model_.PS))*rT)/Vtv)))));
  psiin = (((psiio*rT)-((3.0*Vtv)*log(rT)))-((model_.EAIS)*(rT-1.0)));
  PSatT = (psiin+((2.0*Vtv)*log((0.5*(1.0+sqrt((1.0+(4.0*exp(((-psiin)/Vtv))))))))));
  CJEatT = ((model_.CJE)*pow(((model_.PE)/PEatT),(model_.ME)));
  CJCatT = ((model_.CJC)*pow(((model_.PC)/PCatT),(model_.MC)));
  CJEPatT = ((model_.CJEP)*pow(((model_.PC)/PCatT),(model_.MC)));
  CJCPatT = ((model_.CJCP)*pow(((model_.PS)/PSatT),(model_.MS)));
  GAMMatT = (((model_.GAMM)*pow(rT,(model_.XIS)))*exp((((-(model_.EA))*(1.0-rT))/Vtv)));
  VOatT = ((model_.VO)*pow(rT,(model_.XVO)));
  EBBEatT = exp(((-VBBEatT)/(NBBEatT*Vtv)));
  IVEF = (((model_.VEF)>0.0)?(1.0/(model_.VEF)):0.0);
  IVER = (((model_.VER)>0.0)?(1.0/(model_.VER)):0.0);
  IIKF = 0.0;
  if (((model_.IKF)>0.0))
  {
    IIKF = (1.0/IKFatT);
  }
  IIKR = (((model_.IKR)>0.0)?(1.0/(model_.IKR)):0.0);
  IIKP = (((model_.IKP)>0.0)?(1.0/(model_.IKP)):0.0);
  IVO = 0.0;
  if (((model_.VO)>0.0))
  {
    IVO = (1.0/VOatT);
  }
  IHRCF = (((model_.HRCF)>0.0)?(1.0/(model_.HRCF)):0.0);
  IVTF = (((model_.VTF)>0.0)?(1.0/(model_.VTF)):0.0);
  IITF = (((model_.ITF)>0.0)?(1.0/(model_.ITF)):0.0);
  slTF = (((model_.ITF)>0.0)?0.0:1.0);
  dv0 = ((-PEatT)*(model_.FC));
  if (((model_.AJE)<=0.0))
  {
    dvh_vbei = (Vbei+dv0);
    if ((dvh_vbei>0.0))
    {
      pwq = pow((1.0-(model_.FC)),((-1.0)-(model_.ME)));
      qlo_vbei = ((PEatT*(1.0-((pwq*(1.0-(model_.FC)))*(1.0-(model_.FC)))))/(1.0-(model_.ME)));
      qhi_vbei = ((dvh_vbei*((1.0-(model_.FC))+(((0.5*(model_.ME))*dvh_vbei)/PEatT)))*pwq);
    }
    else
    {
      qlo_vbei = ((PEatT*(1.0-pow((1.0-(Vbei/PEatT)),(1.0-(model_.ME)))))/(1.0-(model_.ME)));
      qhi_vbei = 0.0;
    }
    qdbe = (qlo_vbei+qhi_vbei);
  }
  else
  {
    mv0 = sqrt(((dv0*dv0)+((4*(model_.AJE))*(model_.AJE))));
    vl0 = ((-0.5)*(dv0+mv0));
    q0 = (((-PEatT)*pow((1.0-(vl0/PEatT)),(1.0-(model_.ME))))/(1.0-(model_.ME)));
    dv_vbei = (Vbei+dv0);
    mv_vbei = sqrt(((dv_vbei*dv_vbei)+((4*(model_.AJE))*(model_.AJE))));
    vl_vbei = ((0.5*(dv_vbei-mv_vbei))-dv0);
    qlo_vbei = (((-PEatT)*pow((1.0-(vl_vbei/PEatT)),(1.0-(model_.ME))))/(1.0-(model_.ME)));
    qdbe = ((qlo_vbei+(pow((1.0-(model_.FC)),(-(model_.ME)))*((Vbei-vl_vbei)+vl0)))-q0);
  }
  dv0 = ((-PEatT)*(model_.FC));
  if (((model_.AJE)<=0.0))
  {
    dvh_vbex = (Vbex+dv0);
    if ((dvh_vbex>0.0))
    {
      pwq = pow((1.0-(model_.FC)),((-1.0)-(model_.ME)));
      qlo_vbex = ((PEatT*(1.0-((pwq*(1.0-(model_.FC)))*(1.0-(model_.FC)))))/(1.0-(model_.ME)));
      qhi_vbex = ((dvh_vbex*((1.0-(model_.FC))+(((0.5*(model_.ME))*dvh_vbex)/PEatT)))*pwq);
    }
    else
    {
      qlo_vbex = ((PEatT*(1.0-pow((1.0-(Vbex/PEatT)),(1.0-(model_.ME)))))/(1.0-(model_.ME)));
      qhi_vbex = 0.0;
    }
    qdbex = (qlo_vbex+qhi_vbex);
  }
  else
  {
    mv0 = sqrt(((dv0*dv0)+((4*(model_.AJE))*(model_.AJE))));
    vl0 = ((-0.5)*(dv0+mv0));
    q0 = (((-PEatT)*pow((1.0-(vl0/PEatT)),(1.0-(model_.ME))))/(1.0-(model_.ME)));
    dv_vbex = (Vbex+dv0);
    mv_vbex = sqrt(((dv_vbex*dv_vbex)+((4*(model_.AJE))*(model_.AJE))));
    vl_vbex = ((0.5*(dv_vbex-mv_vbex))-dv0);
    qlo_vbex = (((-PEatT)*pow((1.0-(vl_vbex/PEatT)),(1.0-(model_.ME))))/(1.0-(model_.ME)));
    qdbex = ((qlo_vbex+(pow((1.0-(model_.FC)),(-(model_.ME)))*((Vbex-vl_vbex)+vl0)))-q0);
  }
  dv0 = ((-PCatT)*(model_.FC));
  if (((model_.AJC)<=0.0))
  {
    dvh_vbci = (Vbci+dv0);
    if ((dvh_vbci>0.0))
    {
      pwq = pow((1.0-(model_.FC)),((-1.0)-(model_.MC)));
      qlo_vbci = ((PCatT*(1.0-((pwq*(1.0-(model_.FC)))*(1.0-(model_.FC)))))/(1.0-(model_.MC)));
      qhi_vbci = ((dvh_vbci*((1.0-(model_.FC))+(((0.5*(model_.MC))*dvh_vbci)/PCatT)))*pwq);
    }
    else
    {
      if ((((model_.VRT)>0.0)&&(Vbci<(-(model_.VRT)))))
      {
        qlo_vbci = ((PCatT*(1.0-(pow((1.0+((model_.VRT)/PCatT)),(1.0-(model_.MC)))*(1.0-(((1.0-(model_.MC))*(Vbci+(model_.VRT)))/(PCatT+(model_.VRT)))))))/(1.0-(model_.MC)));
      }
      else
      {
        qlo_vbci = ((PCatT*(1.0-pow((1.0-(Vbci/PCatT)),(1.0-(model_.MC)))))/(1.0-(model_.MC)));
      }
      qhi_vbci = 0.0;
    }
    qdbc = (qlo_vbci+qhi_vbci);
  }
  else
  {
    if ((((model_.VRT)>0.0)&&((model_.ART)>0.0)))
    {
      vn0 = (((model_.VRT)+dv0)/((model_.VRT)-dv0));
      vnl0 = ((2.0*vn0)/(sqrt((((vn0-1.0)*(vn0-1))+((4*(model_.AJC))*(model_.AJC))))+sqrt((((vn0+1.0)*(vn0+1))+((4*(model_.ART))*(model_.ART))))));
      vl0 = (0.5*(((vnl0*((model_.VRT)-dv0))-(model_.VRT))-dv0));
      qlo0 = ((PCatT*(1.0-pow((1.0-(vl0/PCatT)),(1.0-(model_.MC)))))/(1.0-(model_.MC)));
      vn_vbci = ((((2*Vbci)+(model_.VRT))+dv0)/((model_.VRT)-dv0));
      vnl_vbci = ((2.0*vn_vbci)/(sqrt((((vn_vbci-1.0)*(vn_vbci-1))+((4*(model_.AJC))*(model_.AJC))))+sqrt((((vn_vbci+1.0)*(vn_vbci+1))+((4*(model_.ART))*(model_.ART))))));
      vl_vbci = (0.5*(((vnl_vbci*((model_.VRT)-dv0))-(model_.VRT))-dv0));
      qlo_vbci = ((PCatT*(1.0-pow((1.0-(vl_vbci/PCatT)),(1.0-(model_.MC)))))/(1.0-(model_.MC)));
      sel_vbci = (0.5*(vnl_vbci+1.0));
      crt = pow((1.0+((model_.VRT)/PCatT)),(-(model_.MC)));
      cmx = pow((1.0+(dv0/PCatT)),(-(model_.MC)));
      cl_vbci = (((1.0-sel_vbci)*crt)+(sel_vbci*cmx));
      ql_vbci = (((Vbci-vl_vbci)+vl0)*cl_vbci);
      qdbc = ((ql_vbci+qlo_vbci)-qlo0);
    }
    else
    {
      mv0 = sqrt(((dv0*dv0)+((4*(model_.AJC))*(model_.AJC))));
      vl0 = ((-0.5)*(dv0+mv0));
      q0 = (((-PCatT)*pow((1.0-(vl0/PCatT)),(1.0-(model_.MC))))/(1.0-(model_.MC)));
      dv_vbci = (Vbci+dv0);
      mv_vbci = sqrt(((dv_vbci*dv_vbci)+((4*(model_.AJC))*(model_.AJC))));
      vl_vbci = ((0.5*(dv_vbci-mv_vbci))-dv0);
      qlo_vbci = (((-PCatT)*pow((1.0-(vl_vbci/PCatT)),(1.0-(model_.MC))))/(1.0-(model_.MC)));
      qdbc = ((qlo_vbci+(pow((1.0-(model_.FC)),(-(model_.MC)))*((Vbci-vl_vbci)+vl0)))-q0);
    }
  }
  dv0 = ((-PCatT)*(model_.FC));
  if (((model_.AJC)<=0.0))
  {
    dvh_vbep = (Vbep+dv0);
    if ((dvh_vbep>0.0))
    {
      pwq = pow((1.0-(model_.FC)),((-1.0)-(model_.MC)));
      qlo_vbep = ((PCatT*(1.0-((pwq*(1.0-(model_.FC)))*(1.0-(model_.FC)))))/(1.0-(model_.MC)));
      qhi_vbep = ((dvh_vbep*((1.0-(model_.FC))+(((0.5*(model_.MC))*dvh_vbep)/PCatT)))*pwq);
    }
    else
    {
      if ((((model_.VRT)>0.0)&&(Vbep<(-(model_.VRT)))))
      {
        qlo_vbep = ((PCatT*(1.0-(pow((1.0+((model_.VRT)/PCatT)),(1.0-(model_.MC)))*(1.0-(((1.0-(model_.MC))*(Vbep+(model_.VRT)))/(PCatT+(model_.VRT)))))))/(1.0-(model_.MC)));
      }
      else
      {
        qlo_vbep = ((PCatT*(1.0-pow((1.0-(Vbep/PCatT)),(1.0-(model_.MC)))))/(1.0-(model_.MC)));
      }
      qhi_vbep = 0.0;
    }
    qdbep = (qlo_vbep+qhi_vbep);
  }
  else
  {
    if ((((model_.VRT)>0.0)&&((model_.ART)>0.0)))
    {
      vn0 = (((model_.VRT)+dv0)/((model_.VRT)-dv0));
      vnl0 = ((2.0*vn0)/(sqrt((((vn0-1.0)*(vn0-1))+((4*(model_.AJC))*(model_.AJC))))+sqrt((((vn0+1.0)*(vn0+1))+((4*(model_.ART))*(model_.ART))))));
      vl0 = (0.5*(((vnl0*((model_.VRT)-dv0))-(model_.VRT))-dv0));
      qlo0 = ((PCatT*(1.0-pow((1.0-(vl0/PCatT)),(1.0-(model_.MC)))))/(1.0-(model_.MC)));
      vn_vbep = ((((2*Vbep)+(model_.VRT))+dv0)/((model_.VRT)-dv0));
      vnl_vbep = ((2.0*vn_vbep)/(sqrt((((vn_vbep-1.0)*(vn_vbep-1))+((4*(model_.AJC))*(model_.AJC))))+sqrt((((vn_vbep+1.0)*(vn_vbep+1))+((4*(model_.ART))*(model_.ART))))));
      vl_vbep = (0.5*(((vnl_vbep*((model_.VRT)-dv0))-(model_.VRT))-dv0));
      qlo_vbep = ((PCatT*(1.0-pow((1.0-(vl_vbep/PCatT)),(1.0-(model_.MC)))))/(1.0-(model_.MC)));
      sel_vbep = (0.5*(vnl_vbep+1.0));
      crt = pow((1.0+((model_.VRT)/PCatT)),(-(model_.MC)));
      cmx = pow((1.0+(dv0/PCatT)),(-(model_.MC)));
      cl_vbep = (((1.0-sel_vbep)*crt)+(sel_vbep*cmx));
      ql_vbep = (((Vbep-vl_vbep)+vl0)*cl_vbep);
      qdbep = ((ql_vbep+qlo_vbep)-qlo0);
    }
    else
    {
      mv0 = sqrt(((dv0*dv0)+((4*(model_.AJC))*(model_.AJC))));
      vl0 = ((-0.5)*(dv0+mv0));
      q0 = (((-PCatT)*pow((1.0-(vl0/PCatT)),(1.0-(model_.MC))))/(1.0-(model_.MC)));
      dv_vbep = (Vbep+dv0);
      mv_vbep = sqrt(((dv_vbep*dv_vbep)+((4*(model_.AJC))*(model_.AJC))));
      vl_vbep = ((0.5*(dv_vbep-mv_vbep))-dv0);
      qlo_vbep = (((-PCatT)*pow((1.0-(vl_vbep/PCatT)),(1.0-(model_.MC))))/(1.0-(model_.MC)));
      qdbep = ((qlo_vbep+(pow((1.0-(model_.FC)),(-(model_.MC)))*((Vbep-vl_vbep)+vl0)))-q0);
    }
  }
  argi_vbei = (Vbei/(NFatT*Vtv));
  expi_vbei = limexp<AdmsFadType>(argi_vbei);
  Ifi = (ISatT*(expi_vbei-1.0));
  argi_vbci = (Vbci/(NRatT*Vtv));
  expi_vbci = limexp<AdmsFadType>(argi_vbci);
  Iri = ((ISatT*ISRRatT)*(expi_vbci-1.0));
  q1z = ((1.0+(qdbe*IVER))+(qdbc*IVEF));
  q1 = ((0.5*((sqrt((((q1z-1.0e-4)*(q1z-1.0e-4))+1.0e-8))+q1z)-1.0e-4))+1.0e-4);
  q2 = ((Ifi*IIKF)+(Iri*IIKR));
  if ((q2>0))
  {
    if (((model_.QBM)<0.5))
    {
      qb = (0.5*(q1+pow((pow(q1,(1.0/(model_.NKF)))+(4.0*q2)),(model_.NKF))));
    }
    else
    {
      qb = ((0.5*q1)*(1.0+pow((1.0+(4.0*q2)),(model_.NKF))));
    }
  }
  else
  {
    qb = q1;
  }
  Itzr = (Iri/qb);
  Itzf = (Ifi/qb);
  if (((model_.ISP)>0.0))
  {
    argi_vbep = (Vbep/((model_.NFP)*Vtv));
    expi_vbep = limexp<AdmsFadType>(argi_vbep);
    argx_vbci = (Vbci/((model_.NFP)*Vtv));
    expx_vbci = limexp<AdmsFadType>(argx_vbci);
    Ifp = (ISPatT*((((model_.WSP)*expi_vbep)+((1.0-(model_.WSP))*expx_vbci))-1.0));
    q2p = (Ifp*IIKP);
    qbp = (0.5*(1.0+sqrt((1.0+(4.0*q2p)))));
  }
  else
  {
    Ifp = 0.0;
    qbp = 1.0;
  }
  if (((model_.WBE)==1.0))
  {
    argi_vbei = (Vbei/((model_.NEI)*Vtv));
    expi_vbei = limexp<AdmsFadType>(argi_vbei);
    argn_vbei = (Vbei/((model_.NEN)*Vtv));
    expn_vbei = limexp<AdmsFadType>(argn_vbei);
    if (((model_.VBBE)>0.0))
    {
      argx_vbei = (((-VBBEatT)-Vbei)/(NBBEatT*Vtv));
      expx_vbei = limexp<AdmsFadType>(argx_vbei);
      Ibe = (((IBEIatT*(expi_vbei-1.0))+(IBENatT*(expn_vbei-1.0)))-((model_.IBBE)*(expx_vbei-EBBEatT)));
    }
    else
    {
      Ibe = ((IBEIatT*(expi_vbei-1.0))+(IBENatT*(expn_vbei-1.0)));
    }
    Ibex = 0.0;
  }
  else
  {
    if (((model_.WBE)==0.0))
    {
      Ibe = 0.0;
      argi_vbex = (Vbex/((model_.NEI)*Vtv));
      expi_vbex = limexp<AdmsFadType>(argi_vbex);
      argn_vbex = (Vbex/((model_.NEN)*Vtv));
      expn_vbex = limexp<AdmsFadType>(argn_vbex);
      if (((model_.VBBE)>0.0))
      {
        argx_vbex = (((-VBBEatT)-Vbex)/(NBBEatT*Vtv));
        expx_vbex = limexp<AdmsFadType>(argx_vbex);
        Ibex = (((IBEIatT*(expi_vbex-1.0))+(IBENatT*(expn_vbex-1.0)))-((model_.IBBE)*(expx_vbex-EBBEatT)));
      }
      else
      {
        Ibex = ((IBEIatT*(expi_vbex-1.0))+(IBENatT*(expn_vbex-1.0)));
      }
    }
    else
    {
      argi_vbei = (Vbei/((model_.NEI)*Vtv));
      expi_vbei = limexp<AdmsFadType>(argi_vbei);
      argn_vbei = (Vbei/((model_.NEN)*Vtv));
      expn_vbei = limexp<AdmsFadType>(argn_vbei);
      if (((model_.VBBE)>0.0))
      {
        argx_vbei = (((-VBBEatT)-Vbei)/(NBBEatT*Vtv));
        expx_vbei = limexp<AdmsFadType>(argx_vbei);
        Ibe = ((model_.WBE)*(((IBEIatT*(expi_vbei-1.0))+(IBENatT*(expn_vbei-1.0)))-((model_.IBBE)*(expx_vbei-EBBEatT))));
      }
      else
      {
        Ibe = ((model_.WBE)*((IBEIatT*(expi_vbei-1.0))+(IBENatT*(expn_vbei-1.0))));
      }
      argi_vbex = (Vbex/((model_.NEI)*Vtv));
      expi_vbex = limexp<AdmsFadType>(argi_vbex);
      argn_vbex = (Vbex/((model_.NEN)*Vtv));
      expn_vbex = limexp<AdmsFadType>(argn_vbex);
      if (((model_.VBBE)>0.0))
      {
        argx_vbex = (((-VBBEatT)-Vbex)/(NBBEatT*Vtv));
        expx_vbex = limexp<AdmsFadType>(argx_vbex);
        Ibex = ((1.0-(model_.WBE))*(((IBEIatT*(expi_vbex-1.0))+(IBENatT*(expn_vbex-1.0)))-((model_.IBBE)*(expx_vbex-EBBEatT))));
      }
      else
      {
        Ibex = ((1.0-(model_.WBE))*((IBEIatT*(expi_vbex-1.0))+(IBENatT*(expn_vbex-1.0))));
      }
    }
  }
  argi_vbci = (Vbci/((model_.NCI)*Vtv));
  expi_vbci = limexp<AdmsFadType>(argi_vbci);
  argn_vbci = (Vbci/((model_.NCN)*Vtv));
  expn_vbci = limexp<AdmsFadType>(argn_vbci);
  Ibcj = ((IBCIatT*(expi_vbci-1.0))+(IBCNatT*(expn_vbci-1.0)));
  if ((((model_.IBEIP)>0.0)||((model_.IBENP)>0.0)))
  {
    argi_vbep = (Vbep/((model_.NCI)*Vtv));
    expi_vbep = limexp<AdmsFadType>(argi_vbep);
    argn_vbep = (Vbep/((model_.NCN)*Vtv));
    expn_vbep = limexp<AdmsFadType>(argn_vbep);
    Ibep = ((IBEIPatT*(expi_vbep-1.0))+(IBENPatT*(expn_vbep-1.0)));
  }
  else
  {
    Ibep = 0.0;
  }
  if (((model_.AVC1)>0.0))
  {
    vl_vbci = (0.5*(sqrt((((PCatT-Vbci)*(PCatT-Vbci))+0.01))+(PCatT-Vbci)));
    avalf_exparg = ((-AVC2atT)*pow(vl_vbci,((model_.MC)-1.0)));
    avalf = (((model_.AVC1)*vl_vbci)*limexp<AdmsFadType>(avalf_exparg));
    Igc = (((Itzf-Itzr)-Ibcj)*avalf);
  }
  else
  {
    Igc = 0.0;
  }
  Ibc = (Ibcj-Igc);
  if (((model_.RCX)>0.0))
  {
    Ircx = (Vrcx/RCXatT);
  }
  else
  {
    Ircx = 0.0;
  }
  argi_vbci = (Vbci/Vtv);
  expi_vbci = limexp<AdmsFadType>(argi_vbci);
  argx_vbcx = (Vbcx/Vtv);
  expx_vbcx = limexp<AdmsFadType>(argx_vbcx);
  Kbci = sqrt((1.0+(GAMMatT*expi_vbci)));
  Kbcx = sqrt((1.0+(GAMMatT*expx_vbcx)));
  if (((model_.RCI)>0.0))
  {
    rKp1 = ((Kbci+1.0)/(Kbcx+1.0));
    Iohm = ((Vrci+(Vtv*((Kbci-Kbcx)-log(rKp1))))/RCIatT);
    derf = (((IVO*RCIatT)*Iohm)/(1.0+(((0.5*IVO)*IHRCF)*sqrt(((Vrci*Vrci)+0.01)))));
    Irci = (Iohm/sqrt((1+(derf*derf))));
  }
  else
  {
    Irci = 0.0;
  }
  if (((model_.RBX)>0.0))
  {
    Irbx = (Vrbx/RBXatT);
  }
  else
  {
    Irbx = 0.0;
  }
  if (((model_.RBI)>0.0))
  {
    Irbi = ((Vrbi*qb)/RBIatT);
  }
  else
  {
    Irbi = 0.0;
  }
  if (((model_.RE)>0.0))
  {
    Ire = (Vre/REatT);
  }
  else
  {
    Ire = 0.0;
  }
  if (((model_.RBP)>0.0))
  {
    Irbp = ((Vrbp*qbp)/RBPatT);
  }
  else
  {
    Irbp = 0.0;
  }
  sgIf = ((Ifi>0.0)?1.0:0.0);
  rIf = ((Ifi*sgIf)*IITF);
  mIf = (rIf/(rIf+1.0));
  tff_exparg = ((Vbci*IVTF)/1.44);
  tff = (((model_.TF)*(1.0+((model_.QTF)*q1)))*(1.0+((((model_.XTF)*limexp<AdmsFadType>(tff_exparg))*(slTF+(mIf*mIf)))*sgIf)));
  Qbe = (((CJEatT*qdbe)*(model_.WBE))+((tff*Ifi)/qb));
  Qbex = ((CJEatT*qdbex)*(1.0-(model_.WBE)));
  Qbc = (((CJCatT*qdbc)+((model_.TR)*Iri))+((model_.QCO)*Kbci));
  Qbcx = ((model_.QCO)*Kbcx);
  Qbep = ((CJEPatT*qdbep)+((model_.TR)*Ifp));
  Qbeo = (Vbe*(model_.CBEO));
  Qbco = (Vbc*(model_.CBCO));
  Ith = (-(((((((((((Ibe*Vbei)+(Ibc*Vbci))+((Itzf-Itzr)*Vcei))+(Ibex*Vbex))+(Ibep*Vbep))+(Ircx*Vrcx))+(Irci*Vrci))+(Irbx*Vrbx))+(Irbi*Vrbi))+(Ire*Vre))+(Irbp*Vrbp)));
  if (((model_.RTH)>0.0))
  {
    Irth = (Vrth/(model_.RTH));
  }
  else
  {
    Irth = 0.0;
  }
  Qcth = (Vrth*(model_.CTH));
  // I(bi,ei) <+ (((M*dtype)*(Ibe+($simparam("gmin")*Vbei))))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*(Ibe+(getDeviceOptions().gmin*Vbei)));
    staticContributions[admsNodeID_bi] += contribTemp;
    staticContributions[admsNodeID_ei] -= contribTemp;

    Jdxp_static[admsNodeID_bi] += contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    Jdxp_static[admsNodeID_ei] -= contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  // I(bx,ei) <+ (((M*dtype)*(Ibex+($simparam("gmin")*Vbex))))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*(Ibex+(getDeviceOptions().gmin*Vbex)));
    staticContributions[admsNodeID_bx] += contribTemp;
    staticContributions[admsNodeID_ei] -= contribTemp;

    Jdxp_static[admsNodeID_bx] += contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    Jdxp_static[admsNodeID_ei] -= contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  // I(ci,ei) <+ (((M*dtype)*Itzf))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*Itzf);
    staticContributions[admsNodeID_ci] += contribTemp;
    staticContributions[admsNodeID_ei] -= contribTemp;

    Jdxp_static[admsNodeID_ci] += contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    Jdxp_static[admsNodeID_ei] -= contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  // I(ei,ci) <+ (((M*dtype)*Itzr))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*Itzr);
    staticContributions[admsNodeID_ei] += contribTemp;
    staticContributions[admsNodeID_ci] -= contribTemp;

    Jdxp_static[admsNodeID_ei] += contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    Jdxp_static[admsNodeID_ci] -= contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  // I(bi,ci) <+ (((M*dtype)*(Ibc+($simparam("gmin")*Vbci))))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*(Ibc+(getDeviceOptions().gmin*Vbci)));
    staticContributions[admsNodeID_bi] += contribTemp;
    staticContributions[admsNodeID_ci] -= contribTemp;

    Jdxp_static[admsNodeID_bi] += contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    Jdxp_static[admsNodeID_ci] -= contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  // I(bx,bp) <+ (((M*dtype)*(Ibep+($simparam("gmin")*Vbep))))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*(Ibep+(getDeviceOptions().gmin*Vbep)));
    staticContributions[admsNodeID_bx] += contribTemp;
    staticContributions[admsNodeID_bp] -= contribTemp;

    Jdxp_static[admsNodeID_bx] += contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    Jdxp_static[admsNodeID_bp] -= contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  if (((model_.RCX)>0))
  {
    // I(c,cx) <+ (((M*dtype)*Ircx))
    {
      AdmsFadType contribTemp;
      contribTemp= ((M*(model_.dtype))*Ircx);
      staticContributions[admsNodeID_c] += contribTemp;
      staticContributions[admsNodeID_cx] -= contribTemp;

      Jdxp_static[admsNodeID_c] += contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
      Jdxp_static[admsNodeID_cx] -= contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    }
  }
  else
  {
    // V(c,cx) <+ (0.0)
    // do nothing at all
  }
  // I(cx,ci) <+ (((M*dtype)*(Irci+($simparam("gmin")*Vrci))))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*(Irci+(getDeviceOptions().gmin*Vrci)));
    staticContributions[admsNodeID_cx] += contribTemp;
    staticContributions[admsNodeID_ci] -= contribTemp;

    Jdxp_static[admsNodeID_cx] += contribTemp.dx(admsProbeID_V_bi_cx)*probeDiffs[admsProbeID_V_bi_cx]*probeVars[admsProbeID_V_bi_cx].dx(admsProbeID_V_bi_cx)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    Jdxp_static[admsNodeID_ci] -= contribTemp.dx(admsProbeID_V_bi_cx)*probeDiffs[admsProbeID_V_bi_cx]*probeVars[admsProbeID_V_bi_cx].dx(admsProbeID_V_bi_cx)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  if (((model_.RBX)>0))
  {
    // I(b,bx) <+ (((M*dtype)*Irbx))
    {
      AdmsFadType contribTemp;
      contribTemp= ((M*(model_.dtype))*Irbx);
      staticContributions[admsNodeID_b] += contribTemp;
      staticContributions[admsNodeID_bx] -= contribTemp;

      Jdxp_static[admsNodeID_b] += contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
      Jdxp_static[admsNodeID_bx] -= contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    }
  }
  else
  {
    // V(b,bx) <+ (0.0)
    // do nothing at all
  }
  // I(bx,bi) <+ (((M*dtype)*Irbi))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*Irbi);
    staticContributions[admsNodeID_bx] += contribTemp;
    staticContributions[admsNodeID_bi] -= contribTemp;

    Jdxp_static[admsNodeID_bx] += contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei);
    Jdxp_static[admsNodeID_bi] -= contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei);
  }
  if (((model_.RE)>0))
  {
    // I(e,ei) <+ (((M*dtype)*Ire))
    {
      AdmsFadType contribTemp;
      contribTemp= ((M*(model_.dtype))*Ire);
      staticContributions[admsNodeID_e] += contribTemp;
      staticContributions[admsNodeID_ei] -= contribTemp;

      Jdxp_static[admsNodeID_e] += contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
      Jdxp_static[admsNodeID_ei] -= contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    }
  }
  else
  {
    // V(e,ei) <+ (0.0)
    // do nothing at all
  }
  // I(bp,cx) <+ (((M*dtype)*Irbp))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*Irbp);
    staticContributions[admsNodeID_bp] += contribTemp;
    staticContributions[admsNodeID_cx] -= contribTemp;

    Jdxp_static[admsNodeID_bp] += contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    Jdxp_static[admsNodeID_cx] -= contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  // I(bi,ei) <+ (((M*dtype)*ddt(Qbe)))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*(Qbe));
    dynamicContributions[admsNodeID_bi] += contribTemp;
    dynamicContributions[admsNodeID_ei] -= contribTemp;

    Jdxp_dynamic[admsNodeID_bi] += contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    Jdxp_dynamic[admsNodeID_ei] -= contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  // I(bx,ei) <+ (((M*dtype)*ddt(Qbex)))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*(Qbex));
    dynamicContributions[admsNodeID_bx] += contribTemp;
    dynamicContributions[admsNodeID_ei] -= contribTemp;

    Jdxp_dynamic[admsNodeID_bx] += contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    Jdxp_dynamic[admsNodeID_ei] -= contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  // I(bi,ci) <+ (((M*dtype)*ddt(Qbc)))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*(Qbc));
    dynamicContributions[admsNodeID_bi] += contribTemp;
    dynamicContributions[admsNodeID_ci] -= contribTemp;

    Jdxp_dynamic[admsNodeID_bi] += contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    Jdxp_dynamic[admsNodeID_ci] -= contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  // I(bi,cx) <+ (((M*dtype)*ddt(Qbcx)))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*(Qbcx));
    dynamicContributions[admsNodeID_bi] += contribTemp;
    dynamicContributions[admsNodeID_cx] -= contribTemp;

    Jdxp_dynamic[admsNodeID_bi] += contribTemp.dx(admsProbeID_V_bi_cx)*probeDiffs[admsProbeID_V_bi_cx]*probeVars[admsProbeID_V_bi_cx].dx(admsProbeID_V_bi_cx)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    Jdxp_dynamic[admsNodeID_cx] -= contribTemp.dx(admsProbeID_V_bi_cx)*probeDiffs[admsProbeID_V_bi_cx]*probeVars[admsProbeID_V_bi_cx].dx(admsProbeID_V_bi_cx)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  // I(bx,bp) <+ (((M*dtype)*ddt(Qbep)))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*(Qbep));
    dynamicContributions[admsNodeID_bx] += contribTemp;
    dynamicContributions[admsNodeID_bp] -= contribTemp;

    Jdxp_dynamic[admsNodeID_bx] += contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
    Jdxp_dynamic[admsNodeID_bp] -= contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  // I(b,e) <+ (((M*dtype)*ddt(Qbeo)))
  {
    AdmsFadType contribTemp;
    contribTemp= ((M*(model_.dtype))*(Qbeo));
    dynamicContributions[admsNodeID_b] += contribTemp;
    dynamicContributions[admsNodeID_e] -= contribTemp;

    Jdxp_dynamic[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b_e)*probeDiffs[admsProbeID_V_b_e]*probeVars[admsProbeID_V_b_e].dx(admsProbeID_V_b_e);
    Jdxp_dynamic[admsNodeID_e] -= contribTemp.dx(admsProbeID_V_b_e)*probeDiffs[admsProbeID_V_b_e]*probeVars[admsProbeID_V_b_e].dx(admsProbeID_V_b_e);
  }
  // I(b,c) <+ (((M*dtype)*ddt(Qbco)))
  dynamicContributions[admsNodeID_b] += ((M*(model_.dtype))*(Qbco));
  dynamicContributions[admsNodeID_c] -= ((M*(model_.dtype))*(Qbco));
  // I(dt,GND) <+ (Irth)
  {
    AdmsFadType contribTemp;
    contribTemp= Irth;
    staticContributions[admsNodeID_dt] += contribTemp;

    Jdxp_static[admsNodeID_dt] += contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  // I(dt,GND) <+ (Ith)
  {
    AdmsFadType contribTemp;
    contribTemp= Ith;
    staticContributions[admsNodeID_dt] += contribTemp;

    Jdxp_static[admsNodeID_dt] += contribTemp.dx(admsProbeID_V_bi_cx)*probeDiffs[admsProbeID_V_bi_cx]*probeVars[admsProbeID_V_bi_cx].dx(admsProbeID_V_bi_cx)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }
  // I(dt,GND) <+ (ddt(Qcth))
  {
    AdmsFadType contribTemp;
    contribTemp= (Qcth);
    dynamicContributions[admsNodeID_dt] += contribTemp;

    Jdxp_dynamic[admsNodeID_dt] += contribTemp.dx(admsProbeID_V_dt_GND)*probeDiffs[admsProbeID_V_dt_GND]*probeVars[admsProbeID_V_dt_GND].dx(admsProbeID_V_dt_GND);
  }


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_ci_ei] =  "
                 <<probeVars[admsProbeID_V_ci_ei].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_c] =  "
                 <<probeVars[admsProbeID_V_b_c].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bp_cx] =  "
                 <<probeVars[admsProbeID_V_bp_cx].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_e_ei] =  "
                 <<probeVars[admsProbeID_V_e_ei].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_bx] =  "
                 <<probeVars[admsProbeID_V_b_bx].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bx_bi] =  "
                 <<probeVars[admsProbeID_V_bx_bi].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_cx_ci] =  "
                 <<probeVars[admsProbeID_V_cx_ci].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c_cx] =  "
                 <<probeVars[admsProbeID_V_c_cx].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_e] =  "
                 <<probeVars[admsProbeID_V_b_e].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_dt_GND] =  "
                 <<probeVars[admsProbeID_V_dt_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bx_bp] =  "
                 <<probeVars[admsProbeID_V_bx_bp].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_cx] =  "
                 <<probeVars[admsProbeID_V_bi_cx].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bx_ei] =  "
                 <<probeVars[admsProbeID_V_bx_ei].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_ci] =  "
                 <<probeVars[admsProbeID_V_bi_ci].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_ei] =  "
                 <<probeVars[admsProbeID_V_bi_ei].val() << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c] =  "
                 <<staticContributions[admsNodeID_c].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c] =  "
                 <<dynamicContributions[admsNodeID_c].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c] =  "
                 <<Jdxp_static[admsNodeID_c] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c] =  "
                 <<Jdxp_dynamic[admsNodeID_c] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b] =  "
                 <<staticContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b] =  "
                 <<dynamicContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_b] =  "
                 <<Jdxp_static[admsNodeID_b] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_b] =  "
                 <<Jdxp_dynamic[admsNodeID_b] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_e] =  "
                 <<staticContributions[admsNodeID_e].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_e] =  "
                 <<dynamicContributions[admsNodeID_e].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_e] =  "
                 <<Jdxp_static[admsNodeID_e] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_e] =  "
                 <<Jdxp_dynamic[admsNodeID_e] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_dt] =  "
                 <<staticContributions[admsNodeID_dt].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_dt] =  "
                 <<dynamicContributions[admsNodeID_dt].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_dt] =  "
                 <<Jdxp_static[admsNodeID_dt] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_dt] =  "
                 <<Jdxp_dynamic[admsNodeID_dt] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_cx] =  "
                 <<staticContributions[admsNodeID_cx].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_cx] =  "
                 <<dynamicContributions[admsNodeID_cx].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_cx] =  "
                 <<Jdxp_static[admsNodeID_cx] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_cx] =  "
                 <<Jdxp_dynamic[admsNodeID_cx] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ci] =  "
                 <<staticContributions[admsNodeID_ci].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ci] =  "
                 <<dynamicContributions[admsNodeID_ci].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_ci] =  "
                 <<Jdxp_static[admsNodeID_ci] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_ci] =  "
                 <<Jdxp_dynamic[admsNodeID_ci] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bx] =  "
                 <<staticContributions[admsNodeID_bx].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bx] =  "
                 <<dynamicContributions[admsNodeID_bx].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_bx] =  "
                 <<Jdxp_static[admsNodeID_bx] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_bx] =  "
                 <<Jdxp_dynamic[admsNodeID_bx] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bi] =  "
                 <<staticContributions[admsNodeID_bi].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bi] =  "
                 <<dynamicContributions[admsNodeID_bi].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_bi] =  "
                 <<Jdxp_static[admsNodeID_bi] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_bi] =  "
                 <<Jdxp_dynamic[admsNodeID_bi] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ei] =  "
                 <<staticContributions[admsNodeID_ei].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ei] =  "
                 <<dynamicContributions[admsNodeID_ei].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_ei] =  "
                 <<Jdxp_static[admsNodeID_ei] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_ei] =  "
                 <<Jdxp_dynamic[admsNodeID_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bp] =  "
                 <<staticContributions[admsNodeID_bp].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_dt_GND) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bp] =  "
                 <<dynamicContributions[admsNodeID_bp].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_dt_GND) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_bp] =  "
                 <<Jdxp_static[admsNodeID_bp] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_bp] =  "
                 <<Jdxp_dynamic[admsNodeID_bp] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 4 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 10; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 4 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode].val();
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode].val();
      }
    }
  }  
  return true;
}
  

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_bi_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei);
  (*f_bi_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei);
  (*f_ei_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei);
  (*f_ei_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei);
  (*f_bi_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_dt_GND);
  (*f_ei_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_dt_GND);
  (*f_bx_Equ_bx_Node_Ptr) +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) -staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei);
  (*f_bx_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei);
  (*f_ei_Equ_bx_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei);
  (*f_bx_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_V_dt_GND);
  (*f_ci_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  (*f_ci_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  (*f_ei_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci);
  (*f_ci_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei);
  (*f_ci_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_dt_GND);
  (*f_bi_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  (*f_bx_Equ_bp_Node_Ptr) +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp);
  (*f_bp_Equ_bx_Node_Ptr) +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  (*f_bp_Equ_bp_Node_Ptr) +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx) -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  (*f_bp_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_dt_GND);
  (*f_c_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_dt_GND);
  (*f_cx_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_dt_GND);
  (*f_c_Equ_c_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c_cx);
  (*f_c_Equ_cx_Node_Ptr) +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_c_cx);
  (*f_cx_Equ_c_Node_Ptr) +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx);
  (*f_cx_Equ_cx_Node_Ptr) +=  -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx);
  (*f_cx_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx);
  (*f_ci_Equ_cx_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx);
  (*f_cx_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci);
  (*f_b_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND);
  (*f_b_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bx);
  (*f_b_Equ_bx_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bx);
  (*f_bx_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx);
  (*f_bx_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci);
  (*f_bx_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci);
  (*f_bi_Equ_bx_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi);
  (*f_e_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_dt_GND);
  (*f_e_Equ_e_Node_Ptr) +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_e_ei);
  (*f_e_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_e_ei);
  (*f_ei_Equ_e_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei);
  (*f_bp_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci);
  (*f_bp_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci);
  (*f_cx_Equ_bx_Node_Ptr) +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp);
  (*f_cx_Equ_bp_Node_Ptr) +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp);
  (*f_bp_Equ_cx_Node_Ptr) +=  -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx);
  (*f_dt_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND);
  (*f_dt_Equ_bp_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx);
  (*f_dt_Equ_cx_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx);
  (*f_dt_Equ_e_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei);
  (*f_dt_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei);
  (*f_dt_Equ_bx_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi);
  (*f_dt_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi);
  (*f_dt_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx);
  (*f_dt_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci);
  (*f_dt_Equ_c_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx);

#else
  //use the offsets instead of pointers
  dFdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei);
  dFdx[li_bi][A_bi_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei);
  dFdx[li_ei][A_ei_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei);
  dFdx[li_ei][A_ei_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei);
  dFdx[li_bi][A_bi_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_dt_GND);
  dFdx[li_ei][A_ei_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_dt_GND);
  dFdx[li_bx][A_bx_Equ_bx_NodeOffset] +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) -staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei);
  dFdx[li_bx][A_bx_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei);
  dFdx[li_ei][A_ei_Equ_bx_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei);
  dFdx[li_bx][A_bx_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_V_dt_GND);
  dFdx[li_ci][A_ci_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  dFdx[li_ci][A_ci_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  dFdx[li_ei][A_ei_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci);
  dFdx[li_ci][A_ci_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei);
  dFdx[li_ci][A_ci_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_dt_GND);
  dFdx[li_bi][A_bi_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  dFdx[li_bx][A_bx_Equ_bp_NodeOffset] +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp);
  dFdx[li_bp][A_bp_Equ_bx_NodeOffset] +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  dFdx[li_bp][A_bp_Equ_bp_NodeOffset] +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx) -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  dFdx[li_bp][A_bp_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_dt_GND);
  dFdx[li_c][A_c_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_dt_GND);
  dFdx[li_cx][A_cx_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_dt_GND);
  dFdx[li_c][A_c_Equ_c_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c_cx);
  dFdx[li_c][A_c_Equ_cx_NodeOffset] +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_c_cx);
  dFdx[li_cx][A_cx_Equ_c_NodeOffset] +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx);
  dFdx[li_cx][A_cx_Equ_cx_NodeOffset] +=  -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx);
  dFdx[li_cx][A_cx_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx);
  dFdx[li_ci][A_ci_Equ_cx_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx);
  dFdx[li_cx][A_cx_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci);
  dFdx[li_b][A_b_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND);
  dFdx[li_b][A_b_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bx);
  dFdx[li_b][A_b_Equ_bx_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bx);
  dFdx[li_bx][A_bx_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx);
  dFdx[li_bx][A_bx_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci);
  dFdx[li_bx][A_bx_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci);
  dFdx[li_bi][A_bi_Equ_bx_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi);
  dFdx[li_e][A_e_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_dt_GND);
  dFdx[li_e][A_e_Equ_e_NodeOffset] +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_e_ei);
  dFdx[li_e][A_e_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_e_ei);
  dFdx[li_ei][A_ei_Equ_e_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei);
  dFdx[li_bp][A_bp_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci);
  dFdx[li_bp][A_bp_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci);
  dFdx[li_cx][A_cx_Equ_bx_NodeOffset] +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp);
  dFdx[li_cx][A_cx_Equ_bp_NodeOffset] +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp);
  dFdx[li_bp][A_bp_Equ_cx_NodeOffset] +=  -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx);
  dFdx[li_dt][A_dt_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND);
  dFdx[li_dt][A_dt_Equ_bp_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx);
  dFdx[li_dt][A_dt_Equ_cx_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx);
  dFdx[li_dt][A_dt_Equ_e_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei);
  dFdx[li_dt][A_dt_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei);
  dFdx[li_dt][A_dt_Equ_bx_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi);
  dFdx[li_dt][A_dt_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi);
  dFdx[li_dt][A_dt_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx);
  dFdx[li_dt][A_dt_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci);
  dFdx[li_dt][A_dt_Equ_c_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx);

#endif
  
  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_bi_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  (*q_bi_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei);
  (*q_ei_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci);
  (*q_ei_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei);
  (*q_bi_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_dt_GND);
  (*q_ei_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_dt_GND);
  (*q_bx_Equ_bx_Node_Ptr) +=  +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp) +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei);
  (*q_bx_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei);
  (*q_ei_Equ_bx_Node_Ptr) +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei);
  (*q_bx_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_dt_GND);
  (*q_ci_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  (*q_ci_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  (*q_ei_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci);
  (*q_ci_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_dt_GND);
  (*q_bi_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  (*q_bx_Equ_bp_Node_Ptr) +=  -dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp);
  (*q_bp_Equ_bx_Node_Ptr) +=  +dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  (*q_bp_Equ_bp_Node_Ptr) +=  -dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  (*q_bp_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_dt_GND);
  (*q_cx_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_dt_GND);
  (*q_c_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  (*q_cx_Equ_cx_Node_Ptr) +=  -dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx);
  (*q_cx_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx);
  (*q_b_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  (*q_bx_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci);
  (*q_bx_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci);
  (*q_e_Equ_e_Node_Ptr) +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  (*q_bp_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci);
  (*q_bp_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci);
  (*q_bi_Equ_cx_Node_Ptr) +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx);
  (*q_b_Equ_e_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  (*q_e_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  (*q_b_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c);
  (*q_c_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  (*q_dt_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND);

#else
  //use the offsets instead of pointers
  dQdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  dQdx[li_bi][A_bi_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei);
  dQdx[li_ei][A_ei_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci);
  dQdx[li_ei][A_ei_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei);
  dQdx[li_bi][A_bi_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_dt_GND);
  dQdx[li_ei][A_ei_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_dt_GND);
  dQdx[li_bx][A_bx_Equ_bx_NodeOffset] +=  +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp) +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei);
  dQdx[li_bx][A_bx_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei);
  dQdx[li_ei][A_ei_Equ_bx_NodeOffset] +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei);
  dQdx[li_bx][A_bx_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_dt_GND);
  dQdx[li_ci][A_ci_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  dQdx[li_ci][A_ci_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  dQdx[li_ei][A_ei_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci);
  dQdx[li_ci][A_ci_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_dt_GND);
  dQdx[li_bi][A_bi_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  dQdx[li_bx][A_bx_Equ_bp_NodeOffset] +=  -dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp);
  dQdx[li_bp][A_bp_Equ_bx_NodeOffset] +=  +dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  dQdx[li_bp][A_bp_Equ_bp_NodeOffset] +=  -dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  dQdx[li_bp][A_bp_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_dt_GND);
  dQdx[li_cx][A_cx_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_dt_GND);
  dQdx[li_c][A_c_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  dQdx[li_cx][A_cx_Equ_cx_NodeOffset] +=  -dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx);
  dQdx[li_cx][A_cx_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx);
  dQdx[li_b][A_b_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  dQdx[li_bx][A_bx_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci);
  dQdx[li_bx][A_bx_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci);
  dQdx[li_e][A_e_Equ_e_NodeOffset] +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  dQdx[li_bp][A_bp_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci);
  dQdx[li_bp][A_bp_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci);
  dQdx[li_bi][A_bi_Equ_cx_NodeOffset] +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx);
  dQdx[li_b][A_b_Equ_e_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  dQdx[li_e][A_e_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  dQdx[li_b][A_b_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c);
  dQdx[li_c][A_c_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  dQdx[li_dt][A_dt_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND);

  
#endif
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

  // set internal model type based on model card type
  if (getType() == "pnp" || getType() == "PNP")
    dtype = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter RCX : [ 0.0,  (+inf) [
  if ( (!((RCX >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter RCX value " << RCX << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RCI : [ 0.0,  (+inf) [
  if ( (!((RCI >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter RCI value " << RCI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VO : [ 0.0,  (+inf) [
  if ( (!((VO >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter VO value " << VO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter GAMM : [ 0.0,  (+inf) [
  if ( (!((GAMM >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter GAMM value " << GAMM << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter HRCF : [ 0.0,  (+inf) [
  if ( (!((HRCF >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter HRCF value " << HRCF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RBX : [ 0.0,  (+inf) [
  if ( (!((RBX >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter RBX value " << RBX << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RBI : [ 0.0,  (+inf) [
  if ( (!((RBI >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter RBI value " << RBI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RE : [ 0.0,  (+inf) [
  if ( (!((RE >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter RE value " << RE << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RS : [ 0.0,  (+inf) [
  if ( (!((RS >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter RS value " << RS << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RBP : [ 0.0,  (+inf) [
  if ( (!((RBP >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter RBP value " << RBP << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IS : ] 0.0,  (+inf) [
  if ( (!((IS >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter IS value " << IS << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter NF : ] 0.0,  (+inf) [
  if ( (!((NF >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter NF value " << NF << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter NR : ] 0.0,  (+inf) [
  if ( (!((NR >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter NR value " << NR << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter FC : [ 0.0, 1.0 [
  if ( (!((FC >=0.0 && FC <1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter FC value " << FC << " out of range [ 0.0, 1.0 [";
  }

  //    Parameter CBEO : [ 0.0,  (+inf) [
  if ( (!((CBEO >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter CBEO value " << CBEO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CJE : [ 0.0,  (+inf) [
  if ( (!((CJE >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter CJE value " << CJE << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter PE : ] 0.0,  (+inf) [
  if ( (!((PE >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter PE value " << PE << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter ME : ] 0.0, 1.0 ]
  if ( (!((ME >0.0 && ME <=1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter ME value " << ME << " out of range ] 0.0, 1.0 ]";
  }

  //    Parameter CBCO : [ 0.0,  (+inf) [
  if ( (!((CBCO >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter CBCO value " << CBCO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CJC : [ 0.0,  (+inf) [
  if ( (!((CJC >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter CJC value " << CJC << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter QCO : [ 0.0,  (+inf) [
  if ( (!((QCO >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter QCO value " << QCO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CJEP : [ 0.0,  (+inf) [
  if ( (!((CJEP >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter CJEP value " << CJEP << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter PC : ] 0.0,  (+inf) [
  if ( (!((PC >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter PC value " << PC << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter MC : ] 0.0, 1.0 ]
  if ( (!((MC >0.0 && MC <=1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter MC value " << MC << " out of range ] 0.0, 1.0 ]";
  }

  //    Parameter CJCP : [ 0.0,  (+inf) [
  if ( (!((CJCP >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter CJCP value " << CJCP << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter PS : ] 0.0,  (+inf) [
  if ( (!((PS >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter PS value " << PS << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter MS : ] 0.0, 1.0 ]
  if ( (!((MS >0.0 && MS <=1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter MS value " << MS << " out of range ] 0.0, 1.0 ]";
  }

  //    Parameter IBEI : ] 0.0,  (+inf) [
  if ( (!((IBEI >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter IBEI value " << IBEI << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter WBE : [ 0.0, 1.0 ]
  if ( (!((WBE >=0.0 && WBE <=1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter WBE value " << WBE << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter NEI : ] 0.0,  (+inf) [
  if ( (!((NEI >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter NEI value " << NEI << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter IBEN : [ 0.0,  (+inf) [
  if ( (!((IBEN >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter IBEN value " << IBEN << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter NEN : ] 0.0,  (+inf) [
  if ( (!((NEN >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter NEN value " << NEN << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter IBCI : ] 0.0,  (+inf) [
  if ( (!((IBCI >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter IBCI value " << IBCI << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter NCI : ] 0.0,  (+inf) [
  if ( (!((NCI >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter NCI value " << NCI << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter IBCN : [ 0.0,  (+inf) [
  if ( (!((IBCN >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter IBCN value " << IBCN << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter NCN : ] 0.0,  (+inf) [
  if ( (!((NCN >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter NCN value " << NCN << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter AVC1 : [ 0.0,  (+inf) [
  if ( (!((AVC1 >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter AVC1 value " << AVC1 << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter AVC2 : [ 0.0,  (+inf) [
  if ( (!((AVC2 >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter AVC2 value " << AVC2 << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ISP : [ 0.0,  (+inf) [
  if ( (!((ISP >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter ISP value " << ISP << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter WSP : [ 0.0, 1.0 ]
  if ( (!((WSP >=0.0 && WSP <=1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter WSP value " << WSP << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter NFP : ] 0.0,  (+inf) [
  if ( (!((NFP >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter NFP value " << NFP << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter IBEIP : [ 0.0,  (+inf) [
  if ( (!((IBEIP >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter IBEIP value " << IBEIP << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IBENP : [ 0.0,  (+inf) [
  if ( (!((IBENP >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter IBENP value " << IBENP << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IBCIP : [ 0.0,  (+inf) [
  if ( (!((IBCIP >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter IBCIP value " << IBCIP << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter NCIP : ] 0.0,  (+inf) [
  if ( (!((NCIP >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter NCIP value " << NCIP << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter IBCNP : [ 0.0,  (+inf) [
  if ( (!((IBCNP >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter IBCNP value " << IBCNP << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter NCNP : ] 0.0,  (+inf) [
  if ( (!((NCNP >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter NCNP value " << NCNP << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter VEF : [ 0.0,  (+inf) [
  if ( (!((VEF >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter VEF value " << VEF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VER : [ 0.0,  (+inf) [
  if ( (!((VER >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter VER value " << VER << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IKF : [ 0.0,  (+inf) [
  if ( (!((IKF >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter IKF value " << IKF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IKR : [ 0.0,  (+inf) [
  if ( (!((IKR >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter IKR value " << IKR << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IKP : [ 0.0,  (+inf) [
  if ( (!((IKP >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter IKP value " << IKP << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter TF : [ 0.0,  (+inf) [
  if ( (!((TF >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter TF value " << TF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter QTF : [ 0.0,  (+inf) [
  if ( (!((QTF >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter QTF value " << QTF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter XTF : [ 0.0,  (+inf) [
  if ( (!((XTF >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter XTF value " << XTF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VTF : [ 0.0,  (+inf) [
  if ( (!((VTF >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter VTF value " << VTF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ITF : [ 0.0,  (+inf) [
  if ( (!((ITF >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter ITF value " << ITF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter TR : [ 0.0,  (+inf) [
  if ( (!((TR >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter TR value " << TR << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter TD : [ 0.0,  (+inf) [
  if ( (!((TD >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter TD value " << TD << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter KFN : [ 0.0,  (+inf) [
  if ( (!((KFN >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter KFN value " << KFN << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter AFN : ] 0.0,  (+inf) [
  if ( (!((AFN >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter AFN value " << AFN << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter BFN : ] 0.0,  (+inf) [
  if ( (!((BFN >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter BFN value " << BFN << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter RTH : [ 0.0,  (+inf) [
  if ( (!((RTH >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter RTH value " << RTH << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CTH : [ 0.0,  (+inf) [
  if ( (!((CTH >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter CTH value " << CTH << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VRT : [ 0.0,  (+inf) [
  if ( (!((VRT >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter VRT value " << VRT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ART : ] 0.0,  (+inf) [
  if ( (!((ART >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter ART value " << ART << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter CCSO : [ 0.0,  (+inf) [
  if ( (!((CCSO >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter CCSO value " << CCSO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter NKF : ] 0.0,  (+inf) [
  if ( (!((NKF >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter NKF value " << NKF << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter ISRR : ] 0.0,  (+inf) [
  if ( (!((ISRR >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter ISRR value " << ISRR << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter NBBE : ] 0.0,  (+inf) [
  if ( (!((NBBE >0.0))) )
  {
    UserError0(*this) << "ADMSvbic: Parameter NBBE value " << NBBE << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter dtype : [ (-1), 1 ][ 0, 0 ]
  if ( (!((dtype >=(-1) && dtype <=1 )) || (dtype >=0 && dtype <=0 )) )
  {
    UserError0(*this) << "ADMSvbic: Parameter dtype value " << dtype << " out of range [ (-1), 1 ] or in excluded range [ 0, 0 ]";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
   const Configuration & configuration,
   const ModelBlock &    model_block,
   const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    TNOM(27.0),
    RCX(0.0),
    RCI(0.0),
    VO(0.0),
    GAMM(0.0),
    HRCF(0.0),
    RBX(0.0),
    RBI(0.0),
    RE(0.0),
    RS(0.0),
    RBP(0.0),
    IS(1.0e-16),
    NF(1.0),
    NR(1.0),
    FC(0.9),
    CBEO(0.0),
    CJE(0.0),
    PE(0.75),
    ME(0.33),
    AJE((-0.5)),
    CBCO(0.0),
    CJC(0.0),
    QCO(0.0),
    CJEP(0.0),
    PC(0.75),
    MC(0.33),
    AJC((-0.5)),
    CJCP(0.0),
    PS(0.75),
    MS(0.33),
    AJS((-0.5)),
    IBEI(1.0e-18),
    WBE(1.0),
    NEI(1.0),
    IBEN(0.0),
    NEN(2.0),
    IBCI(1.0e-16),
    NCI(1.0),
    IBCN(0.0),
    NCN(2.0),
    AVC1(0.0),
    AVC2(0.0),
    ISP(0.0),
    WSP(1.0),
    NFP(1.0),
    IBEIP(0.0),
    IBENP(0.0),
    IBCIP(0.0),
    NCIP(1.0),
    IBCNP(0.0),
    NCNP(2.0),
    VEF(0.0),
    VER(0.0),
    IKF(0.0),
    IKR(0.0),
    IKP(0.0),
    TF(0.0),
    QTF(0.0),
    XTF(0.0),
    VTF(0.0),
    ITF(0.0),
    TR(0.0),
    TD(0.0),
    KFN(0.0),
    AFN(1.0),
    BFN(1.0),
    XRE(0),
    XRBI(0),
    XRCI(0),
    XRS(0),
    XVO(0),
    EA(1.12),
    EAIE(1.12),
    EAIC(1.12),
    EAIS(1.12),
    EANE(1.12),
    EANC(1.12),
    EANS(1.12),
    XIS(3.0),
    XII(3.0),
    XIN(3.0),
    TNF(0.0),
    TAVC(0.0),
    RTH(0.0),
    CTH(0.0),
    VRT(0.0),
    ART(0.1),
    CCSO(0.0),
    QBM(0.0),
    NKF(0.5),
    XIKF(0),
    XRCX(0),
    XRBX(0),
    XRBP(0),
    ISRR(1.0),
    XISR(0.0),
    DEAR(0.0),
    EAP(1.12),
    VBBE(0.0),
    NBBE(1.0),
    IBBE(1.0e-6),
    TVBBE1(0.0),
    TVBBE2(0.0),
    TNBBE(0.0),
    EBBE(0.0),
    DTEMP(0.0),
    VERS(1.2),
    VREV(0.0),
    dtype(1)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << "DTEMP  =  " << (*iter)->DTEMP << std::endl;
    os << "M  =  " << (*iter)->M << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       : 
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
/// 
/// @param[in] op Operator to apply to all instances.
/// 
/// 
void Model::forEachInstance(DeviceInstanceOp &op) const /* override */ 
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void registerDevice()
{
  Config<Traits>::addConfiguration()
    .registerDevice("q", 10)
    .registerModelType("npn", 10)
    .registerModelType("pnp", 10);
}



#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_DTEMP,
   bool instancePar_given_DTEMP,
   // non-reals(including hidden)
   int instancePar_M,
   bool instancePar_given_M,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_RCX,
   bool modelPar_given_RCX,
   AdmsSensFadType & modelPar_RCI,
   bool modelPar_given_RCI,
   AdmsSensFadType & modelPar_VO,
   bool modelPar_given_VO,
   AdmsSensFadType & modelPar_GAMM,
   bool modelPar_given_GAMM,
   AdmsSensFadType & modelPar_HRCF,
   bool modelPar_given_HRCF,
   AdmsSensFadType & modelPar_RBX,
   bool modelPar_given_RBX,
   AdmsSensFadType & modelPar_RBI,
   bool modelPar_given_RBI,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RS,
   bool modelPar_given_RS,
   AdmsSensFadType & modelPar_RBP,
   bool modelPar_given_RBP,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_NF,
   bool modelPar_given_NF,
   AdmsSensFadType & modelPar_NR,
   bool modelPar_given_NR,
   AdmsSensFadType & modelPar_FC,
   bool modelPar_given_FC,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_ME,
   bool modelPar_given_ME,
   AdmsSensFadType & modelPar_AJE,
   bool modelPar_given_AJE,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_QCO,
   bool modelPar_given_QCO,
   AdmsSensFadType & modelPar_CJEP,
   bool modelPar_given_CJEP,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_AJC,
   bool modelPar_given_AJC,
   AdmsSensFadType & modelPar_CJCP,
   bool modelPar_given_CJCP,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_MS,
   bool modelPar_given_MS,
   AdmsSensFadType & modelPar_AJS,
   bool modelPar_given_AJS,
   AdmsSensFadType & modelPar_IBEI,
   bool modelPar_given_IBEI,
   AdmsSensFadType & modelPar_WBE,
   bool modelPar_given_WBE,
   AdmsSensFadType & modelPar_NEI,
   bool modelPar_given_NEI,
   AdmsSensFadType & modelPar_IBEN,
   bool modelPar_given_IBEN,
   AdmsSensFadType & modelPar_NEN,
   bool modelPar_given_NEN,
   AdmsSensFadType & modelPar_IBCI,
   bool modelPar_given_IBCI,
   AdmsSensFadType & modelPar_NCI,
   bool modelPar_given_NCI,
   AdmsSensFadType & modelPar_IBCN,
   bool modelPar_given_IBCN,
   AdmsSensFadType & modelPar_NCN,
   bool modelPar_given_NCN,
   AdmsSensFadType & modelPar_AVC1,
   bool modelPar_given_AVC1,
   AdmsSensFadType & modelPar_AVC2,
   bool modelPar_given_AVC2,
   AdmsSensFadType & modelPar_ISP,
   bool modelPar_given_ISP,
   AdmsSensFadType & modelPar_WSP,
   bool modelPar_given_WSP,
   AdmsSensFadType & modelPar_NFP,
   bool modelPar_given_NFP,
   AdmsSensFadType & modelPar_IBEIP,
   bool modelPar_given_IBEIP,
   AdmsSensFadType & modelPar_IBENP,
   bool modelPar_given_IBENP,
   AdmsSensFadType & modelPar_IBCIP,
   bool modelPar_given_IBCIP,
   AdmsSensFadType & modelPar_NCIP,
   bool modelPar_given_NCIP,
   AdmsSensFadType & modelPar_IBCNP,
   bool modelPar_given_IBCNP,
   AdmsSensFadType & modelPar_NCNP,
   bool modelPar_given_NCNP,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_IKF,
   bool modelPar_given_IKF,
   AdmsSensFadType & modelPar_IKR,
   bool modelPar_given_IKR,
   AdmsSensFadType & modelPar_IKP,
   bool modelPar_given_IKP,
   AdmsSensFadType & modelPar_TF,
   bool modelPar_given_TF,
   AdmsSensFadType & modelPar_QTF,
   bool modelPar_given_QTF,
   AdmsSensFadType & modelPar_XTF,
   bool modelPar_given_XTF,
   AdmsSensFadType & modelPar_VTF,
   bool modelPar_given_VTF,
   AdmsSensFadType & modelPar_ITF,
   bool modelPar_given_ITF,
   AdmsSensFadType & modelPar_TR,
   bool modelPar_given_TR,
   AdmsSensFadType & modelPar_TD,
   bool modelPar_given_TD,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_AFN,
   bool modelPar_given_AFN,
   AdmsSensFadType & modelPar_BFN,
   bool modelPar_given_BFN,
   AdmsSensFadType & modelPar_XRE,
   bool modelPar_given_XRE,
   AdmsSensFadType & modelPar_XRBI,
   bool modelPar_given_XRBI,
   AdmsSensFadType & modelPar_XRCI,
   bool modelPar_given_XRCI,
   AdmsSensFadType & modelPar_XRS,
   bool modelPar_given_XRS,
   AdmsSensFadType & modelPar_XVO,
   bool modelPar_given_XVO,
   AdmsSensFadType & modelPar_EA,
   bool modelPar_given_EA,
   AdmsSensFadType & modelPar_EAIE,
   bool modelPar_given_EAIE,
   AdmsSensFadType & modelPar_EAIC,
   bool modelPar_given_EAIC,
   AdmsSensFadType & modelPar_EAIS,
   bool modelPar_given_EAIS,
   AdmsSensFadType & modelPar_EANE,
   bool modelPar_given_EANE,
   AdmsSensFadType & modelPar_EANC,
   bool modelPar_given_EANC,
   AdmsSensFadType & modelPar_EANS,
   bool modelPar_given_EANS,
   AdmsSensFadType & modelPar_XIS,
   bool modelPar_given_XIS,
   AdmsSensFadType & modelPar_XII,
   bool modelPar_given_XII,
   AdmsSensFadType & modelPar_XIN,
   bool modelPar_given_XIN,
   AdmsSensFadType & modelPar_TNF,
   bool modelPar_given_TNF,
   AdmsSensFadType & modelPar_TAVC,
   bool modelPar_given_TAVC,
   AdmsSensFadType & modelPar_RTH,
   bool modelPar_given_RTH,
   AdmsSensFadType & modelPar_CTH,
   bool modelPar_given_CTH,
   AdmsSensFadType & modelPar_VRT,
   bool modelPar_given_VRT,
   AdmsSensFadType & modelPar_ART,
   bool modelPar_given_ART,
   AdmsSensFadType & modelPar_CCSO,
   bool modelPar_given_CCSO,
   AdmsSensFadType & modelPar_QBM,
   bool modelPar_given_QBM,
   AdmsSensFadType & modelPar_NKF,
   bool modelPar_given_NKF,
   AdmsSensFadType & modelPar_XIKF,
   bool modelPar_given_XIKF,
   AdmsSensFadType & modelPar_XRCX,
   bool modelPar_given_XRCX,
   AdmsSensFadType & modelPar_XRBX,
   bool modelPar_given_XRBX,
   AdmsSensFadType & modelPar_XRBP,
   bool modelPar_given_XRBP,
   AdmsSensFadType & modelPar_ISRR,
   bool modelPar_given_ISRR,
   AdmsSensFadType & modelPar_XISR,
   bool modelPar_given_XISR,
   AdmsSensFadType & modelPar_DEAR,
   bool modelPar_given_DEAR,
   AdmsSensFadType & modelPar_EAP,
   bool modelPar_given_EAP,
   AdmsSensFadType & modelPar_VBBE,
   bool modelPar_given_VBBE,
   AdmsSensFadType & modelPar_NBBE,
   bool modelPar_given_NBBE,
   AdmsSensFadType & modelPar_IBBE,
   bool modelPar_given_IBBE,
   AdmsSensFadType & modelPar_TVBBE1,
   bool modelPar_given_TVBBE1,
   AdmsSensFadType & modelPar_TVBBE2,
   bool modelPar_given_TVBBE2,
   AdmsSensFadType & modelPar_TNBBE,
   bool modelPar_given_TNBBE,
   AdmsSensFadType & modelPar_EBBE,
   bool modelPar_given_EBBE,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_VERS,
   bool modelPar_given_VERS,
   AdmsSensFadType & modelPar_VREV,
   bool modelPar_given_VREV,
   // non-reals (including hidden)
   int modelPar_dtype,
   double admsTemperature, double adms_vt_nom, double gmin, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_RCX,
   bool modelPar_given_RCX,
   AdmsSensFadType & modelPar_RCI,
   bool modelPar_given_RCI,
   AdmsSensFadType & modelPar_VO,
   bool modelPar_given_VO,
   AdmsSensFadType & modelPar_GAMM,
   bool modelPar_given_GAMM,
   AdmsSensFadType & modelPar_HRCF,
   bool modelPar_given_HRCF,
   AdmsSensFadType & modelPar_RBX,
   bool modelPar_given_RBX,
   AdmsSensFadType & modelPar_RBI,
   bool modelPar_given_RBI,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RS,
   bool modelPar_given_RS,
   AdmsSensFadType & modelPar_RBP,
   bool modelPar_given_RBP,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_NF,
   bool modelPar_given_NF,
   AdmsSensFadType & modelPar_NR,
   bool modelPar_given_NR,
   AdmsSensFadType & modelPar_FC,
   bool modelPar_given_FC,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_ME,
   bool modelPar_given_ME,
   AdmsSensFadType & modelPar_AJE,
   bool modelPar_given_AJE,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_QCO,
   bool modelPar_given_QCO,
   AdmsSensFadType & modelPar_CJEP,
   bool modelPar_given_CJEP,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_AJC,
   bool modelPar_given_AJC,
   AdmsSensFadType & modelPar_CJCP,
   bool modelPar_given_CJCP,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_MS,
   bool modelPar_given_MS,
   AdmsSensFadType & modelPar_AJS,
   bool modelPar_given_AJS,
   AdmsSensFadType & modelPar_IBEI,
   bool modelPar_given_IBEI,
   AdmsSensFadType & modelPar_WBE,
   bool modelPar_given_WBE,
   AdmsSensFadType & modelPar_NEI,
   bool modelPar_given_NEI,
   AdmsSensFadType & modelPar_IBEN,
   bool modelPar_given_IBEN,
   AdmsSensFadType & modelPar_NEN,
   bool modelPar_given_NEN,
   AdmsSensFadType & modelPar_IBCI,
   bool modelPar_given_IBCI,
   AdmsSensFadType & modelPar_NCI,
   bool modelPar_given_NCI,
   AdmsSensFadType & modelPar_IBCN,
   bool modelPar_given_IBCN,
   AdmsSensFadType & modelPar_NCN,
   bool modelPar_given_NCN,
   AdmsSensFadType & modelPar_AVC1,
   bool modelPar_given_AVC1,
   AdmsSensFadType & modelPar_AVC2,
   bool modelPar_given_AVC2,
   AdmsSensFadType & modelPar_ISP,
   bool modelPar_given_ISP,
   AdmsSensFadType & modelPar_WSP,
   bool modelPar_given_WSP,
   AdmsSensFadType & modelPar_NFP,
   bool modelPar_given_NFP,
   AdmsSensFadType & modelPar_IBEIP,
   bool modelPar_given_IBEIP,
   AdmsSensFadType & modelPar_IBENP,
   bool modelPar_given_IBENP,
   AdmsSensFadType & modelPar_IBCIP,
   bool modelPar_given_IBCIP,
   AdmsSensFadType & modelPar_NCIP,
   bool modelPar_given_NCIP,
   AdmsSensFadType & modelPar_IBCNP,
   bool modelPar_given_IBCNP,
   AdmsSensFadType & modelPar_NCNP,
   bool modelPar_given_NCNP,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_IKF,
   bool modelPar_given_IKF,
   AdmsSensFadType & modelPar_IKR,
   bool modelPar_given_IKR,
   AdmsSensFadType & modelPar_IKP,
   bool modelPar_given_IKP,
   AdmsSensFadType & modelPar_TF,
   bool modelPar_given_TF,
   AdmsSensFadType & modelPar_QTF,
   bool modelPar_given_QTF,
   AdmsSensFadType & modelPar_XTF,
   bool modelPar_given_XTF,
   AdmsSensFadType & modelPar_VTF,
   bool modelPar_given_VTF,
   AdmsSensFadType & modelPar_ITF,
   bool modelPar_given_ITF,
   AdmsSensFadType & modelPar_TR,
   bool modelPar_given_TR,
   AdmsSensFadType & modelPar_TD,
   bool modelPar_given_TD,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_AFN,
   bool modelPar_given_AFN,
   AdmsSensFadType & modelPar_BFN,
   bool modelPar_given_BFN,
   AdmsSensFadType & modelPar_XRE,
   bool modelPar_given_XRE,
   AdmsSensFadType & modelPar_XRBI,
   bool modelPar_given_XRBI,
   AdmsSensFadType & modelPar_XRCI,
   bool modelPar_given_XRCI,
   AdmsSensFadType & modelPar_XRS,
   bool modelPar_given_XRS,
   AdmsSensFadType & modelPar_XVO,
   bool modelPar_given_XVO,
   AdmsSensFadType & modelPar_EA,
   bool modelPar_given_EA,
   AdmsSensFadType & modelPar_EAIE,
   bool modelPar_given_EAIE,
   AdmsSensFadType & modelPar_EAIC,
   bool modelPar_given_EAIC,
   AdmsSensFadType & modelPar_EAIS,
   bool modelPar_given_EAIS,
   AdmsSensFadType & modelPar_EANE,
   bool modelPar_given_EANE,
   AdmsSensFadType & modelPar_EANC,
   bool modelPar_given_EANC,
   AdmsSensFadType & modelPar_EANS,
   bool modelPar_given_EANS,
   AdmsSensFadType & modelPar_XIS,
   bool modelPar_given_XIS,
   AdmsSensFadType & modelPar_XII,
   bool modelPar_given_XII,
   AdmsSensFadType & modelPar_XIN,
   bool modelPar_given_XIN,
   AdmsSensFadType & modelPar_TNF,
   bool modelPar_given_TNF,
   AdmsSensFadType & modelPar_TAVC,
   bool modelPar_given_TAVC,
   AdmsSensFadType & modelPar_RTH,
   bool modelPar_given_RTH,
   AdmsSensFadType & modelPar_CTH,
   bool modelPar_given_CTH,
   AdmsSensFadType & modelPar_VRT,
   bool modelPar_given_VRT,
   AdmsSensFadType & modelPar_ART,
   bool modelPar_given_ART,
   AdmsSensFadType & modelPar_CCSO,
   bool modelPar_given_CCSO,
   AdmsSensFadType & modelPar_QBM,
   bool modelPar_given_QBM,
   AdmsSensFadType & modelPar_NKF,
   bool modelPar_given_NKF,
   AdmsSensFadType & modelPar_XIKF,
   bool modelPar_given_XIKF,
   AdmsSensFadType & modelPar_XRCX,
   bool modelPar_given_XRCX,
   AdmsSensFadType & modelPar_XRBX,
   bool modelPar_given_XRBX,
   AdmsSensFadType & modelPar_XRBP,
   bool modelPar_given_XRBP,
   AdmsSensFadType & modelPar_ISRR,
   bool modelPar_given_ISRR,
   AdmsSensFadType & modelPar_XISR,
   bool modelPar_given_XISR,
   AdmsSensFadType & modelPar_DEAR,
   bool modelPar_given_DEAR,
   AdmsSensFadType & modelPar_EAP,
   bool modelPar_given_EAP,
   AdmsSensFadType & modelPar_VBBE,
   bool modelPar_given_VBBE,
   AdmsSensFadType & modelPar_NBBE,
   bool modelPar_given_NBBE,
   AdmsSensFadType & modelPar_IBBE,
   bool modelPar_given_IBBE,
   AdmsSensFadType & modelPar_TVBBE1,
   bool modelPar_given_TVBBE1,
   AdmsSensFadType & modelPar_TVBBE2,
   bool modelPar_given_TVBBE2,
   AdmsSensFadType & modelPar_TNBBE,
   bool modelPar_given_TNBBE,
   AdmsSensFadType & modelPar_EBBE,
   bool modelPar_given_EBBE,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_VERS,
   bool modelPar_given_VERS,
   AdmsSensFadType & modelPar_VREV,
   bool modelPar_given_VREV,
   // non-reals (including hidden)
   int modelPar_dtype,
   double admsTemperature, double gmin, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_ci_ei,
   const int admsProbeID_V_b_c,
   const int admsProbeID_V_bp_cx,
   const int admsProbeID_V_e_ei,
   const int admsProbeID_V_b_bx,
   const int admsProbeID_V_bx_bi,
   const int admsProbeID_V_cx_ci,
   const int admsProbeID_V_c_cx,
   const int admsProbeID_V_b_e,
   const int admsProbeID_V_dt_GND,
   const int admsProbeID_V_bx_bp,
   const int admsProbeID_V_bi_cx,
   const int admsProbeID_V_bx_ei,
   const int admsProbeID_V_bi_ci,
   const int admsProbeID_V_bi_ei,
   // node constants
   const int admsNodeID_c,
   const int admsNodeID_b,
   const int admsNodeID_e,
   const int admsNodeID_dt,
   const int admsNodeID_cx,
   const int admsNodeID_ci,
   const int admsNodeID_bx,
   const int admsNodeID_bi,
   const int admsNodeID_ei,
   const int admsNodeID_bp,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_DTEMP,
   bool instancePar_given_DTEMP,
   // non-reals(including hidden)
   int instancePar_M,
   bool instancePar_given_M,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_RCX,
   bool modelPar_given_RCX,
   AdmsSensFadType & modelPar_RCI,
   bool modelPar_given_RCI,
   AdmsSensFadType & modelPar_VO,
   bool modelPar_given_VO,
   AdmsSensFadType & modelPar_GAMM,
   bool modelPar_given_GAMM,
   AdmsSensFadType & modelPar_HRCF,
   bool modelPar_given_HRCF,
   AdmsSensFadType & modelPar_RBX,
   bool modelPar_given_RBX,
   AdmsSensFadType & modelPar_RBI,
   bool modelPar_given_RBI,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RS,
   bool modelPar_given_RS,
   AdmsSensFadType & modelPar_RBP,
   bool modelPar_given_RBP,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_NF,
   bool modelPar_given_NF,
   AdmsSensFadType & modelPar_NR,
   bool modelPar_given_NR,
   AdmsSensFadType & modelPar_FC,
   bool modelPar_given_FC,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_ME,
   bool modelPar_given_ME,
   AdmsSensFadType & modelPar_AJE,
   bool modelPar_given_AJE,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_QCO,
   bool modelPar_given_QCO,
   AdmsSensFadType & modelPar_CJEP,
   bool modelPar_given_CJEP,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_AJC,
   bool modelPar_given_AJC,
   AdmsSensFadType & modelPar_CJCP,
   bool modelPar_given_CJCP,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_MS,
   bool modelPar_given_MS,
   AdmsSensFadType & modelPar_AJS,
   bool modelPar_given_AJS,
   AdmsSensFadType & modelPar_IBEI,
   bool modelPar_given_IBEI,
   AdmsSensFadType & modelPar_WBE,
   bool modelPar_given_WBE,
   AdmsSensFadType & modelPar_NEI,
   bool modelPar_given_NEI,
   AdmsSensFadType & modelPar_IBEN,
   bool modelPar_given_IBEN,
   AdmsSensFadType & modelPar_NEN,
   bool modelPar_given_NEN,
   AdmsSensFadType & modelPar_IBCI,
   bool modelPar_given_IBCI,
   AdmsSensFadType & modelPar_NCI,
   bool modelPar_given_NCI,
   AdmsSensFadType & modelPar_IBCN,
   bool modelPar_given_IBCN,
   AdmsSensFadType & modelPar_NCN,
   bool modelPar_given_NCN,
   AdmsSensFadType & modelPar_AVC1,
   bool modelPar_given_AVC1,
   AdmsSensFadType & modelPar_AVC2,
   bool modelPar_given_AVC2,
   AdmsSensFadType & modelPar_ISP,
   bool modelPar_given_ISP,
   AdmsSensFadType & modelPar_WSP,
   bool modelPar_given_WSP,
   AdmsSensFadType & modelPar_NFP,
   bool modelPar_given_NFP,
   AdmsSensFadType & modelPar_IBEIP,
   bool modelPar_given_IBEIP,
   AdmsSensFadType & modelPar_IBENP,
   bool modelPar_given_IBENP,
   AdmsSensFadType & modelPar_IBCIP,
   bool modelPar_given_IBCIP,
   AdmsSensFadType & modelPar_NCIP,
   bool modelPar_given_NCIP,
   AdmsSensFadType & modelPar_IBCNP,
   bool modelPar_given_IBCNP,
   AdmsSensFadType & modelPar_NCNP,
   bool modelPar_given_NCNP,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_IKF,
   bool modelPar_given_IKF,
   AdmsSensFadType & modelPar_IKR,
   bool modelPar_given_IKR,
   AdmsSensFadType & modelPar_IKP,
   bool modelPar_given_IKP,
   AdmsSensFadType & modelPar_TF,
   bool modelPar_given_TF,
   AdmsSensFadType & modelPar_QTF,
   bool modelPar_given_QTF,
   AdmsSensFadType & modelPar_XTF,
   bool modelPar_given_XTF,
   AdmsSensFadType & modelPar_VTF,
   bool modelPar_given_VTF,
   AdmsSensFadType & modelPar_ITF,
   bool modelPar_given_ITF,
   AdmsSensFadType & modelPar_TR,
   bool modelPar_given_TR,
   AdmsSensFadType & modelPar_TD,
   bool modelPar_given_TD,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_AFN,
   bool modelPar_given_AFN,
   AdmsSensFadType & modelPar_BFN,
   bool modelPar_given_BFN,
   AdmsSensFadType & modelPar_XRE,
   bool modelPar_given_XRE,
   AdmsSensFadType & modelPar_XRBI,
   bool modelPar_given_XRBI,
   AdmsSensFadType & modelPar_XRCI,
   bool modelPar_given_XRCI,
   AdmsSensFadType & modelPar_XRS,
   bool modelPar_given_XRS,
   AdmsSensFadType & modelPar_XVO,
   bool modelPar_given_XVO,
   AdmsSensFadType & modelPar_EA,
   bool modelPar_given_EA,
   AdmsSensFadType & modelPar_EAIE,
   bool modelPar_given_EAIE,
   AdmsSensFadType & modelPar_EAIC,
   bool modelPar_given_EAIC,
   AdmsSensFadType & modelPar_EAIS,
   bool modelPar_given_EAIS,
   AdmsSensFadType & modelPar_EANE,
   bool modelPar_given_EANE,
   AdmsSensFadType & modelPar_EANC,
   bool modelPar_given_EANC,
   AdmsSensFadType & modelPar_EANS,
   bool modelPar_given_EANS,
   AdmsSensFadType & modelPar_XIS,
   bool modelPar_given_XIS,
   AdmsSensFadType & modelPar_XII,
   bool modelPar_given_XII,
   AdmsSensFadType & modelPar_XIN,
   bool modelPar_given_XIN,
   AdmsSensFadType & modelPar_TNF,
   bool modelPar_given_TNF,
   AdmsSensFadType & modelPar_TAVC,
   bool modelPar_given_TAVC,
   AdmsSensFadType & modelPar_RTH,
   bool modelPar_given_RTH,
   AdmsSensFadType & modelPar_CTH,
   bool modelPar_given_CTH,
   AdmsSensFadType & modelPar_VRT,
   bool modelPar_given_VRT,
   AdmsSensFadType & modelPar_ART,
   bool modelPar_given_ART,
   AdmsSensFadType & modelPar_CCSO,
   bool modelPar_given_CCSO,
   AdmsSensFadType & modelPar_QBM,
   bool modelPar_given_QBM,
   AdmsSensFadType & modelPar_NKF,
   bool modelPar_given_NKF,
   AdmsSensFadType & modelPar_XIKF,
   bool modelPar_given_XIKF,
   AdmsSensFadType & modelPar_XRCX,
   bool modelPar_given_XRCX,
   AdmsSensFadType & modelPar_XRBX,
   bool modelPar_given_XRBX,
   AdmsSensFadType & modelPar_XRBP,
   bool modelPar_given_XRBP,
   AdmsSensFadType & modelPar_ISRR,
   bool modelPar_given_ISRR,
   AdmsSensFadType & modelPar_XISR,
   bool modelPar_given_XISR,
   AdmsSensFadType & modelPar_DEAR,
   bool modelPar_given_DEAR,
   AdmsSensFadType & modelPar_EAP,
   bool modelPar_given_EAP,
   AdmsSensFadType & modelPar_VBBE,
   bool modelPar_given_VBBE,
   AdmsSensFadType & modelPar_NBBE,
   bool modelPar_given_NBBE,
   AdmsSensFadType & modelPar_IBBE,
   bool modelPar_given_IBBE,
   AdmsSensFadType & modelPar_TVBBE1,
   bool modelPar_given_TVBBE1,
   AdmsSensFadType & modelPar_TVBBE2,
   bool modelPar_given_TVBBE2,
   AdmsSensFadType & modelPar_TNBBE,
   bool modelPar_given_TNBBE,
   AdmsSensFadType & modelPar_EBBE,
   bool modelPar_given_EBBE,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_VERS,
   bool modelPar_given_VERS,
   AdmsSensFadType & modelPar_VREV,
   bool modelPar_given_VREV,
   // non-reals (including hidden)
   int modelPar_dtype,
   // basic variables
   double admsTemperature, double adms_vt_nom, double gmin, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance)
{

  // Local variables
  AdmsSensFadType Qcth;
  AdmsSensFadType Irth;
  AdmsSensFadType Ith;
  AdmsSensFadType Qbco;
  AdmsSensFadType Qbeo;
  AdmsSensFadType Qbep;
  AdmsSensFadType Qbcx;
  AdmsSensFadType Qbc;
  AdmsSensFadType Qbex;
  AdmsSensFadType Qbe;
  AdmsSensFadType tff;
  AdmsSensFadType tff_exparg;
  AdmsSensFadType mIf;
  AdmsSensFadType rIf;
  AdmsSensFadType sgIf;
  AdmsSensFadType Irbp;
  AdmsSensFadType Ire;
  AdmsSensFadType Irbi;
  AdmsSensFadType Irbx;
  AdmsSensFadType Irci;
  AdmsSensFadType derf;
  AdmsSensFadType Iohm;
  AdmsSensFadType rKp1;
  AdmsSensFadType Kbcx;
  AdmsSensFadType Kbci;
  AdmsSensFadType expx_vbcx;
  AdmsSensFadType argx_vbcx;
  AdmsSensFadType Ircx;
  AdmsSensFadType Ibc;
  AdmsSensFadType Igc;
  AdmsSensFadType avalf;
  AdmsSensFadType avalf_exparg;
  AdmsSensFadType Ibep;
  AdmsSensFadType expn_vbep;
  AdmsSensFadType argn_vbep;
  AdmsSensFadType Ibcj;
  AdmsSensFadType expn_vbci;
  AdmsSensFadType argn_vbci;
  AdmsSensFadType Ibex;
  AdmsSensFadType Ibe;
  AdmsSensFadType expx_vbei;
  AdmsSensFadType argx_vbei;
  AdmsSensFadType expn_vbei;
  AdmsSensFadType argn_vbei;
  AdmsSensFadType argi_vbex;
  AdmsSensFadType expi_vbex;
  AdmsSensFadType argn_vbex;
  AdmsSensFadType expn_vbex;
  AdmsSensFadType argx_vbex;
  AdmsSensFadType expx_vbex;
  AdmsSensFadType qbp;
  AdmsSensFadType q2p;
  AdmsSensFadType Ifp;
  AdmsSensFadType expx_vbci;
  AdmsSensFadType argx_vbci;
  AdmsSensFadType expi_vbep;
  AdmsSensFadType argi_vbep;
  AdmsSensFadType Itzf;
  AdmsSensFadType Itzr;
  AdmsSensFadType qb;
  AdmsSensFadType q2;
  AdmsSensFadType q1;
  AdmsSensFadType q1z;
  AdmsSensFadType Iri;
  AdmsSensFadType expi_vbci;
  AdmsSensFadType argi_vbci;
  AdmsSensFadType Ifi;
  AdmsSensFadType expi_vbei;
  AdmsSensFadType argi_vbei;
  AdmsSensFadType qdbep;
  AdmsSensFadType qhi_vbep;
  AdmsSensFadType qlo_vbep;
  AdmsSensFadType dvh_vbep;
  AdmsSensFadType ql_vbep;
  AdmsSensFadType cl_vbep;
  AdmsSensFadType sel_vbep;
  AdmsSensFadType vl_vbep;
  AdmsSensFadType vnl_vbep;
  AdmsSensFadType vn_vbep;
  AdmsSensFadType mv_vbep;
  AdmsSensFadType dv_vbep;
  AdmsSensFadType qdbc;
  AdmsSensFadType qhi_vbci;
  AdmsSensFadType qlo_vbci;
  AdmsSensFadType dvh_vbci;
  AdmsSensFadType ql_vbci;
  AdmsSensFadType cl_vbci;
  AdmsSensFadType cmx;
  AdmsSensFadType crt;
  AdmsSensFadType sel_vbci;
  AdmsSensFadType vl_vbci;
  AdmsSensFadType vnl_vbci;
  AdmsSensFadType vn_vbci;
  AdmsSensFadType qlo0;
  AdmsSensFadType vnl0;
  AdmsSensFadType vn0;
  AdmsSensFadType mv_vbci;
  AdmsSensFadType dv_vbci;
  AdmsSensFadType qdbex;
  AdmsSensFadType qhi_vbex;
  AdmsSensFadType qlo_vbex;
  AdmsSensFadType dvh_vbex;
  AdmsSensFadType vl_vbex;
  AdmsSensFadType mv_vbex;
  AdmsSensFadType dv_vbex;
  AdmsSensFadType qdbe;
  AdmsSensFadType qhi_vbei;
  AdmsSensFadType qlo_vbei;
  AdmsSensFadType pwq;
  AdmsSensFadType dvh_vbei;
  AdmsSensFadType vl_vbei;
  AdmsSensFadType mv_vbei;
  AdmsSensFadType dv_vbei;
  AdmsSensFadType q0;
  AdmsSensFadType vl0;
  AdmsSensFadType mv0;
  AdmsSensFadType dv0;
  AdmsSensFadType slTF;
  AdmsSensFadType IITF;
  AdmsSensFadType IVTF;
  AdmsSensFadType IHRCF;
  AdmsSensFadType IVO;
  AdmsSensFadType IIKP;
  AdmsSensFadType IIKR;
  AdmsSensFadType IIKF;
  AdmsSensFadType IVER;
  AdmsSensFadType IVEF;
  AdmsSensFadType EBBEatT;
  AdmsSensFadType VOatT;
  AdmsSensFadType GAMMatT;
  AdmsSensFadType CJCPatT;
  AdmsSensFadType CJEPatT;
  AdmsSensFadType CJCatT;
  AdmsSensFadType CJEatT;
  AdmsSensFadType PSatT;
  AdmsSensFadType PCatT;
  AdmsSensFadType PEatT;
  AdmsSensFadType psiin;
  AdmsSensFadType psiio;
  AdmsSensFadType NBBEatT;
  AdmsSensFadType VBBEatT;
  AdmsSensFadType AVC2atT;
  AdmsSensFadType NRatT;
  AdmsSensFadType NFatT;
  AdmsSensFadType IBCNPatT;
  AdmsSensFadType IBCIPatT;
  AdmsSensFadType IBENPatT;
  AdmsSensFadType IBEIPatT;
  AdmsSensFadType IBCNatT;
  AdmsSensFadType IBCIatT;
  AdmsSensFadType IBENatT;
  AdmsSensFadType IBEIatT;
  AdmsSensFadType ISPatT;
  AdmsSensFadType ISRRatT;
  AdmsSensFadType ISatT;
  AdmsSensFadType RBPatT;
  AdmsSensFadType RSatT;
  AdmsSensFadType REatT;
  AdmsSensFadType RBIatT;
  AdmsSensFadType RBXatT;
  AdmsSensFadType RCIatT;
  AdmsSensFadType RCXatT;
  AdmsSensFadType IKFatT;
  AdmsSensFadType dT;
  AdmsSensFadType rT;
  AdmsSensFadType Vtv;
  AdmsSensFadType Tdev;
  AdmsSensFadType Tini;
  AdmsSensFadType Vcei;
  AdmsSensFadType Vbc;
  AdmsSensFadType Vrbp;
  AdmsSensFadType Vre;
  AdmsSensFadType Vrbx;
  AdmsSensFadType Vrbi;
  AdmsSensFadType Vrci;
  AdmsSensFadType Vrcx;
  AdmsSensFadType Vbe;
  double Vrth;
  AdmsSensFadType Vbep;
  AdmsSensFadType Vbcx;
  AdmsSensFadType Vbex;
  AdmsSensFadType Vbci;
  AdmsSensFadType Vbei;
  AdmsSensFadType tVCrit;


  // -- code converted from analog/code block
  tVCrit = (adms_vt(admsTemperature)*log((adms_vt(admsTemperature)/(1.41421356237309504880*modelPar_IS))));
  Vbei = probeVars[admsProbeID_V_bi_ei];

  Vbci = probeVars[admsProbeID_V_bi_ci];

  Vbex = probeVars[admsProbeID_V_bx_ei];

  Vbcx = probeVars[admsProbeID_V_bi_cx];

  Vbep = probeVars[admsProbeID_V_bx_bp];

  Vrth = probeVars[admsProbeID_V_dt_GND];

  Vbe = probeVars[admsProbeID_V_b_e];

  Vrcx = (modelPar_dtype*(probeVars[admsProbeID_V_c_cx]));
  Vrci = (modelPar_dtype*(probeVars[admsProbeID_V_cx_ci]));
  Vrbi = (modelPar_dtype*(probeVars[admsProbeID_V_bx_bi]));
  Vrbx = (modelPar_dtype*(probeVars[admsProbeID_V_b_bx]));
  Vre = (modelPar_dtype*(probeVars[admsProbeID_V_e_ei]));
  Vrbp = (modelPar_dtype*(probeVars[admsProbeID_V_bp_cx]));
  Vbc = (modelPar_dtype*(probeVars[admsProbeID_V_b_c]));
  Vcei = (modelPar_dtype*(probeVars[admsProbeID_V_ci_ei]));
  Tini = (2.731500e+02+modelPar_TNOM);
  Tdev = ((admsTemperature+instancePar_DTEMP)+Vrth);
  Vtv = ((1.380662e-23*Tdev)/1.602189e-19);
  rT = (Tdev/Tini);
  dT = (Tdev-Tini);
  IKFatT = (modelPar_IKF*pow(rT,modelPar_XIKF));
  RCXatT = (modelPar_RCX*pow(rT,modelPar_XRCX));
  RCIatT = (modelPar_RCI*pow(rT,modelPar_XRCI));
  RBXatT = (modelPar_RBX*pow(rT,modelPar_XRBX));
  RBIatT = (modelPar_RBI*pow(rT,modelPar_XRBI));
  REatT = (modelPar_RE*pow(rT,modelPar_XRE));
  RSatT = (modelPar_RS*pow(rT,modelPar_XRS));
  RBPatT = (modelPar_RBP*pow(rT,modelPar_XRBP));
  ISatT = (modelPar_IS*pow((pow(rT,modelPar_XIS)*exp((((-modelPar_EA)*(1.0-rT))/Vtv))),(1.0/modelPar_NF)));
  ISRRatT = (modelPar_ISRR*pow((pow(rT,modelPar_XISR)*exp((((-modelPar_DEAR)*(1.0-rT))/Vtv))),(1.0/modelPar_NR)));
  ISPatT = (modelPar_ISP*pow((pow(rT,modelPar_XIS)*exp((((-modelPar_EAP)*(1.0-rT))/Vtv))),(1.0/modelPar_NFP)));
  IBEIatT = (modelPar_IBEI*pow((pow(rT,modelPar_XII)*exp((((-modelPar_EAIE)*(1.0-rT))/Vtv))),(1.0/modelPar_NEI)));
  IBENatT = (modelPar_IBEN*pow((pow(rT,modelPar_XIN)*exp((((-modelPar_EANE)*(1.0-rT))/Vtv))),(1.0/modelPar_NEN)));
  IBCIatT = (modelPar_IBCI*pow((pow(rT,modelPar_XII)*exp((((-modelPar_EAIC)*(1.0-rT))/Vtv))),(1.0/modelPar_NCI)));
  IBCNatT = (modelPar_IBCN*pow((pow(rT,modelPar_XIN)*exp((((-modelPar_EANC)*(1.0-rT))/Vtv))),(1.0/modelPar_NCN)));
  IBEIPatT = (modelPar_IBEIP*pow((pow(rT,modelPar_XII)*exp((((-modelPar_EAIC)*(1.0-rT))/Vtv))),(1.0/modelPar_NCI)));
  IBENPatT = (modelPar_IBENP*pow((pow(rT,modelPar_XIN)*exp((((-modelPar_EANC)*(1.0-rT))/Vtv))),(1.0/modelPar_NCN)));
  IBCIPatT = (modelPar_IBCIP*pow((pow(rT,modelPar_XII)*exp((((-modelPar_EAIS)*(1.0-rT))/Vtv))),(1.0/modelPar_NCIP)));
  IBCNPatT = (modelPar_IBCNP*pow((pow(rT,modelPar_XIN)*exp((((-modelPar_EANS)*(1.0-rT))/Vtv))),(1.0/modelPar_NCNP)));
  NFatT = (modelPar_NF*(1.0+(dT*modelPar_TNF)));
  NRatT = (modelPar_NR*(1.0+(dT*modelPar_TNF)));
  AVC2atT = (modelPar_AVC2*(1.0+(dT*modelPar_TAVC)));
  VBBEatT = (modelPar_VBBE*(1.0+(dT*(modelPar_TVBBE1+(dT*modelPar_TVBBE2)))));
  NBBEatT = (modelPar_NBBE*(1.0+(dT*modelPar_TNBBE)));
  psiio = ((2.0*(Vtv/rT))*log((exp((((0.5*modelPar_PE)*rT)/Vtv))-exp(((((-0.5)*modelPar_PE)*rT)/Vtv)))));
  psiin = (((psiio*rT)-((3.0*Vtv)*log(rT)))-(modelPar_EAIE*(rT-1.0)));
  PEatT = (psiin+((2.0*Vtv)*log((0.5*(1.0+sqrt((1.0+(4.0*exp(((-psiin)/Vtv))))))))));
  psiio = ((2.0*(Vtv/rT))*log((exp((((0.5*modelPar_PC)*rT)/Vtv))-exp(((((-0.5)*modelPar_PC)*rT)/Vtv)))));
  psiin = (((psiio*rT)-((3.0*Vtv)*log(rT)))-(modelPar_EAIC*(rT-1.0)));
  PCatT = (psiin+((2.0*Vtv)*log((0.5*(1.0+sqrt((1.0+(4.0*exp(((-psiin)/Vtv))))))))));
  psiio = ((2.0*(Vtv/rT))*log((exp((((0.5*modelPar_PS)*rT)/Vtv))-exp(((((-0.5)*modelPar_PS)*rT)/Vtv)))));
  psiin = (((psiio*rT)-((3.0*Vtv)*log(rT)))-(modelPar_EAIS*(rT-1.0)));
  PSatT = (psiin+((2.0*Vtv)*log((0.5*(1.0+sqrt((1.0+(4.0*exp(((-psiin)/Vtv))))))))));
  CJEatT = (modelPar_CJE*pow((modelPar_PE/PEatT),modelPar_ME));
  CJCatT = (modelPar_CJC*pow((modelPar_PC/PCatT),modelPar_MC));
  CJEPatT = (modelPar_CJEP*pow((modelPar_PC/PCatT),modelPar_MC));
  CJCPatT = (modelPar_CJCP*pow((modelPar_PS/PSatT),modelPar_MS));
  GAMMatT = ((modelPar_GAMM*pow(rT,modelPar_XIS))*exp((((-modelPar_EA)*(1.0-rT))/Vtv)));
  VOatT = (modelPar_VO*pow(rT,modelPar_XVO));
  EBBEatT = exp(((-VBBEatT)/(NBBEatT*Vtv)));
  IVEF = adms_ternary_op<AdmsSensFadType>((modelPar_VEF>0.0),(1.0/modelPar_VEF),0.0);
  IVER = adms_ternary_op<AdmsSensFadType>((modelPar_VER>0.0),(1.0/modelPar_VER),0.0);
  IIKF = 0.0;
  if ((modelPar_IKF>0.0))
  {
    IIKF = (1.0/IKFatT);
  }
  IIKR = adms_ternary_op<AdmsSensFadType>((modelPar_IKR>0.0),(1.0/modelPar_IKR),0.0);
  IIKP = adms_ternary_op<AdmsSensFadType>((modelPar_IKP>0.0),(1.0/modelPar_IKP),0.0);
  IVO = 0.0;
  if ((modelPar_VO>0.0))
  {
    IVO = (1.0/VOatT);
  }
  IHRCF = adms_ternary_op<AdmsSensFadType>((modelPar_HRCF>0.0),(1.0/modelPar_HRCF),0.0);
  IVTF = adms_ternary_op<AdmsSensFadType>((modelPar_VTF>0.0),(1.0/modelPar_VTF),0.0);
  IITF = adms_ternary_op<AdmsSensFadType>((modelPar_ITF>0.0),(1.0/modelPar_ITF),0.0);
  slTF = ((modelPar_ITF>0.0)?0.0:1.0);
  dv0 = ((-PEatT)*modelPar_FC);
  if ((modelPar_AJE<=0.0))
  {
    dvh_vbei = (Vbei+dv0);
    if ((dvh_vbei>0.0))
    {
      pwq = pow((1.0-modelPar_FC),((-1.0)-modelPar_ME));
      qlo_vbei = ((PEatT*(1.0-((pwq*(1.0-modelPar_FC))*(1.0-modelPar_FC))))/(1.0-modelPar_ME));
      qhi_vbei = ((dvh_vbei*((1.0-modelPar_FC)+(((0.5*modelPar_ME)*dvh_vbei)/PEatT)))*pwq);
    }
    else
    {
      qlo_vbei = ((PEatT*(1.0-pow((1.0-(Vbei/PEatT)),(1.0-modelPar_ME))))/(1.0-modelPar_ME));
      qhi_vbei = 0.0;
    }
    qdbe = (qlo_vbei+qhi_vbei);
  }
  else
  {
    mv0 = sqrt(((dv0*dv0)+((4*modelPar_AJE)*modelPar_AJE)));
    vl0 = ((-0.5)*(dv0+mv0));
    q0 = (((-PEatT)*pow((1.0-(vl0/PEatT)),(1.0-modelPar_ME)))/(1.0-modelPar_ME));
    dv_vbei = (Vbei+dv0);
    mv_vbei = sqrt(((dv_vbei*dv_vbei)+((4*modelPar_AJE)*modelPar_AJE)));
    vl_vbei = ((0.5*(dv_vbei-mv_vbei))-dv0);
    qlo_vbei = (((-PEatT)*pow((1.0-(vl_vbei/PEatT)),(1.0-modelPar_ME)))/(1.0-modelPar_ME));
    qdbe = ((qlo_vbei+(pow((1.0-modelPar_FC),(-modelPar_ME))*((Vbei-vl_vbei)+vl0)))-q0);
  }
  dv0 = ((-PEatT)*modelPar_FC);
  if ((modelPar_AJE<=0.0))
  {
    dvh_vbex = (Vbex+dv0);
    if ((dvh_vbex>0.0))
    {
      pwq = pow((1.0-modelPar_FC),((-1.0)-modelPar_ME));
      qlo_vbex = ((PEatT*(1.0-((pwq*(1.0-modelPar_FC))*(1.0-modelPar_FC))))/(1.0-modelPar_ME));
      qhi_vbex = ((dvh_vbex*((1.0-modelPar_FC)+(((0.5*modelPar_ME)*dvh_vbex)/PEatT)))*pwq);
    }
    else
    {
      qlo_vbex = ((PEatT*(1.0-pow((1.0-(Vbex/PEatT)),(1.0-modelPar_ME))))/(1.0-modelPar_ME));
      qhi_vbex = 0.0;
    }
    qdbex = (qlo_vbex+qhi_vbex);
  }
  else
  {
    mv0 = sqrt(((dv0*dv0)+((4*modelPar_AJE)*modelPar_AJE)));
    vl0 = ((-0.5)*(dv0+mv0));
    q0 = (((-PEatT)*pow((1.0-(vl0/PEatT)),(1.0-modelPar_ME)))/(1.0-modelPar_ME));
    dv_vbex = (Vbex+dv0);
    mv_vbex = sqrt(((dv_vbex*dv_vbex)+((4*modelPar_AJE)*modelPar_AJE)));
    vl_vbex = ((0.5*(dv_vbex-mv_vbex))-dv0);
    qlo_vbex = (((-PEatT)*pow((1.0-(vl_vbex/PEatT)),(1.0-modelPar_ME)))/(1.0-modelPar_ME));
    qdbex = ((qlo_vbex+(pow((1.0-modelPar_FC),(-modelPar_ME))*((Vbex-vl_vbex)+vl0)))-q0);
  }
  dv0 = ((-PCatT)*modelPar_FC);
  if ((modelPar_AJC<=0.0))
  {
    dvh_vbci = (Vbci+dv0);
    if ((dvh_vbci>0.0))
    {
      pwq = pow((1.0-modelPar_FC),((-1.0)-modelPar_MC));
      qlo_vbci = ((PCatT*(1.0-((pwq*(1.0-modelPar_FC))*(1.0-modelPar_FC))))/(1.0-modelPar_MC));
      qhi_vbci = ((dvh_vbci*((1.0-modelPar_FC)+(((0.5*modelPar_MC)*dvh_vbci)/PCatT)))*pwq);
    }
    else
    {
      if (((modelPar_VRT>0.0)&&(Vbci<(-modelPar_VRT))))
      {
        qlo_vbci = ((PCatT*(1.0-(pow((1.0+(modelPar_VRT/PCatT)),(1.0-modelPar_MC))*(1.0-(((1.0-modelPar_MC)*(Vbci+modelPar_VRT))/(PCatT+modelPar_VRT))))))/(1.0-modelPar_MC));
      }
      else
      {
        qlo_vbci = ((PCatT*(1.0-pow((1.0-(Vbci/PCatT)),(1.0-modelPar_MC))))/(1.0-modelPar_MC));
      }
      qhi_vbci = 0.0;
    }
    qdbc = (qlo_vbci+qhi_vbci);
  }
  else
  {
    if (((modelPar_VRT>0.0)&&(modelPar_ART>0.0)))
    {
      vn0 = ((modelPar_VRT+dv0)/(modelPar_VRT-dv0));
      vnl0 = ((2.0*vn0)/(sqrt((((vn0-1.0)*(vn0-1))+((4*modelPar_AJC)*modelPar_AJC)))+sqrt((((vn0+1.0)*(vn0+1))+((4*modelPar_ART)*modelPar_ART)))));
      vl0 = (0.5*(((vnl0*(modelPar_VRT-dv0))-modelPar_VRT)-dv0));
      qlo0 = ((PCatT*(1.0-pow((1.0-(vl0/PCatT)),(1.0-modelPar_MC))))/(1.0-modelPar_MC));
      vn_vbci = ((((2*Vbci)+modelPar_VRT)+dv0)/(modelPar_VRT-dv0));
      vnl_vbci = ((2.0*vn_vbci)/(sqrt((((vn_vbci-1.0)*(vn_vbci-1))+((4*modelPar_AJC)*modelPar_AJC)))+sqrt((((vn_vbci+1.0)*(vn_vbci+1))+((4*modelPar_ART)*modelPar_ART)))));
      vl_vbci = (0.5*(((vnl_vbci*(modelPar_VRT-dv0))-modelPar_VRT)-dv0));
      qlo_vbci = ((PCatT*(1.0-pow((1.0-(vl_vbci/PCatT)),(1.0-modelPar_MC))))/(1.0-modelPar_MC));
      sel_vbci = (0.5*(vnl_vbci+1.0));
      crt = pow((1.0+(modelPar_VRT/PCatT)),(-modelPar_MC));
      cmx = pow((1.0+(dv0/PCatT)),(-modelPar_MC));
      cl_vbci = (((1.0-sel_vbci)*crt)+(sel_vbci*cmx));
      ql_vbci = (((Vbci-vl_vbci)+vl0)*cl_vbci);
      qdbc = ((ql_vbci+qlo_vbci)-qlo0);
    }
    else
    {
      mv0 = sqrt(((dv0*dv0)+((4*modelPar_AJC)*modelPar_AJC)));
      vl0 = ((-0.5)*(dv0+mv0));
      q0 = (((-PCatT)*pow((1.0-(vl0/PCatT)),(1.0-modelPar_MC)))/(1.0-modelPar_MC));
      dv_vbci = (Vbci+dv0);
      mv_vbci = sqrt(((dv_vbci*dv_vbci)+((4*modelPar_AJC)*modelPar_AJC)));
      vl_vbci = ((0.5*(dv_vbci-mv_vbci))-dv0);
      qlo_vbci = (((-PCatT)*pow((1.0-(vl_vbci/PCatT)),(1.0-modelPar_MC)))/(1.0-modelPar_MC));
      qdbc = ((qlo_vbci+(pow((1.0-modelPar_FC),(-modelPar_MC))*((Vbci-vl_vbci)+vl0)))-q0);
    }
  }
  dv0 = ((-PCatT)*modelPar_FC);
  if ((modelPar_AJC<=0.0))
  {
    dvh_vbep = (Vbep+dv0);
    if ((dvh_vbep>0.0))
    {
      pwq = pow((1.0-modelPar_FC),((-1.0)-modelPar_MC));
      qlo_vbep = ((PCatT*(1.0-((pwq*(1.0-modelPar_FC))*(1.0-modelPar_FC))))/(1.0-modelPar_MC));
      qhi_vbep = ((dvh_vbep*((1.0-modelPar_FC)+(((0.5*modelPar_MC)*dvh_vbep)/PCatT)))*pwq);
    }
    else
    {
      if (((modelPar_VRT>0.0)&&(Vbep<(-modelPar_VRT))))
      {
        qlo_vbep = ((PCatT*(1.0-(pow((1.0+(modelPar_VRT/PCatT)),(1.0-modelPar_MC))*(1.0-(((1.0-modelPar_MC)*(Vbep+modelPar_VRT))/(PCatT+modelPar_VRT))))))/(1.0-modelPar_MC));
      }
      else
      {
        qlo_vbep = ((PCatT*(1.0-pow((1.0-(Vbep/PCatT)),(1.0-modelPar_MC))))/(1.0-modelPar_MC));
      }
      qhi_vbep = 0.0;
    }
    qdbep = (qlo_vbep+qhi_vbep);
  }
  else
  {
    if (((modelPar_VRT>0.0)&&(modelPar_ART>0.0)))
    {
      vn0 = ((modelPar_VRT+dv0)/(modelPar_VRT-dv0));
      vnl0 = ((2.0*vn0)/(sqrt((((vn0-1.0)*(vn0-1))+((4*modelPar_AJC)*modelPar_AJC)))+sqrt((((vn0+1.0)*(vn0+1))+((4*modelPar_ART)*modelPar_ART)))));
      vl0 = (0.5*(((vnl0*(modelPar_VRT-dv0))-modelPar_VRT)-dv0));
      qlo0 = ((PCatT*(1.0-pow((1.0-(vl0/PCatT)),(1.0-modelPar_MC))))/(1.0-modelPar_MC));
      vn_vbep = ((((2*Vbep)+modelPar_VRT)+dv0)/(modelPar_VRT-dv0));
      vnl_vbep = ((2.0*vn_vbep)/(sqrt((((vn_vbep-1.0)*(vn_vbep-1))+((4*modelPar_AJC)*modelPar_AJC)))+sqrt((((vn_vbep+1.0)*(vn_vbep+1))+((4*modelPar_ART)*modelPar_ART)))));
      vl_vbep = (0.5*(((vnl_vbep*(modelPar_VRT-dv0))-modelPar_VRT)-dv0));
      qlo_vbep = ((PCatT*(1.0-pow((1.0-(vl_vbep/PCatT)),(1.0-modelPar_MC))))/(1.0-modelPar_MC));
      sel_vbep = (0.5*(vnl_vbep+1.0));
      crt = pow((1.0+(modelPar_VRT/PCatT)),(-modelPar_MC));
      cmx = pow((1.0+(dv0/PCatT)),(-modelPar_MC));
      cl_vbep = (((1.0-sel_vbep)*crt)+(sel_vbep*cmx));
      ql_vbep = (((Vbep-vl_vbep)+vl0)*cl_vbep);
      qdbep = ((ql_vbep+qlo_vbep)-qlo0);
    }
    else
    {
      mv0 = sqrt(((dv0*dv0)+((4*modelPar_AJC)*modelPar_AJC)));
      vl0 = ((-0.5)*(dv0+mv0));
      q0 = (((-PCatT)*pow((1.0-(vl0/PCatT)),(1.0-modelPar_MC)))/(1.0-modelPar_MC));
      dv_vbep = (Vbep+dv0);
      mv_vbep = sqrt(((dv_vbep*dv_vbep)+((4*modelPar_AJC)*modelPar_AJC)));
      vl_vbep = ((0.5*(dv_vbep-mv_vbep))-dv0);
      qlo_vbep = (((-PCatT)*pow((1.0-(vl_vbep/PCatT)),(1.0-modelPar_MC)))/(1.0-modelPar_MC));
      qdbep = ((qlo_vbep+(pow((1.0-modelPar_FC),(-modelPar_MC))*((Vbep-vl_vbep)+vl0)))-q0);
    }
  }
  argi_vbei = (Vbei/(NFatT*Vtv));
  expi_vbei = limexp<AdmsSensFadType>(argi_vbei);
  Ifi = (ISatT*(expi_vbei-1.0));
  argi_vbci = (Vbci/(NRatT*Vtv));
  expi_vbci = limexp<AdmsSensFadType>(argi_vbci);
  Iri = ((ISatT*ISRRatT)*(expi_vbci-1.0));
  q1z = ((1.0+(qdbe*IVER))+(qdbc*IVEF));
  q1 = ((0.5*((sqrt((((q1z-1.0e-4)*(q1z-1.0e-4))+1.0e-8))+q1z)-1.0e-4))+1.0e-4);
  q2 = ((Ifi*IIKF)+(Iri*IIKR));
  if ((q2>0))
  {
    if ((modelPar_QBM<0.5))
    {
      qb = (0.5*(q1+pow((pow(q1,(1.0/modelPar_NKF))+(4.0*q2)),modelPar_NKF)));
    }
    else
    {
      qb = ((0.5*q1)*(1.0+pow((1.0+(4.0*q2)),modelPar_NKF)));
    }
  }
  else
  {
    qb = q1;
  }
  Itzr = (Iri/qb);
  Itzf = (Ifi/qb);
  if ((modelPar_ISP>0.0))
  {
    argi_vbep = (Vbep/(modelPar_NFP*Vtv));
    expi_vbep = limexp<AdmsSensFadType>(argi_vbep);
    argx_vbci = (Vbci/(modelPar_NFP*Vtv));
    expx_vbci = limexp<AdmsSensFadType>(argx_vbci);
    Ifp = (ISPatT*(((modelPar_WSP*expi_vbep)+((1.0-modelPar_WSP)*expx_vbci))-1.0));
    q2p = (Ifp*IIKP);
    qbp = (0.5*(1.0+sqrt((1.0+(4.0*q2p)))));
  }
  else
  {
    Ifp = 0.0;
    qbp = 1.0;
  }
  if ((modelPar_WBE==1.0))
  {
    argi_vbei = (Vbei/(modelPar_NEI*Vtv));
    expi_vbei = limexp<AdmsSensFadType>(argi_vbei);
    argn_vbei = (Vbei/(modelPar_NEN*Vtv));
    expn_vbei = limexp<AdmsSensFadType>(argn_vbei);
    if ((modelPar_VBBE>0.0))
    {
      argx_vbei = (((-VBBEatT)-Vbei)/(NBBEatT*Vtv));
      expx_vbei = limexp<AdmsSensFadType>(argx_vbei);
      Ibe = (((IBEIatT*(expi_vbei-1.0))+(IBENatT*(expn_vbei-1.0)))-(modelPar_IBBE*(expx_vbei-EBBEatT)));
    }
    else
    {
      Ibe = ((IBEIatT*(expi_vbei-1.0))+(IBENatT*(expn_vbei-1.0)));
    }
    Ibex = 0.0;
  }
  else
  {
    if ((modelPar_WBE==0.0))
    {
      Ibe = 0.0;
      argi_vbex = (Vbex/(modelPar_NEI*Vtv));
      expi_vbex = limexp<AdmsSensFadType>(argi_vbex);
      argn_vbex = (Vbex/(modelPar_NEN*Vtv));
      expn_vbex = limexp<AdmsSensFadType>(argn_vbex);
      if ((modelPar_VBBE>0.0))
      {
        argx_vbex = (((-VBBEatT)-Vbex)/(NBBEatT*Vtv));
        expx_vbex = limexp<AdmsSensFadType>(argx_vbex);
        Ibex = (((IBEIatT*(expi_vbex-1.0))+(IBENatT*(expn_vbex-1.0)))-(modelPar_IBBE*(expx_vbex-EBBEatT)));
      }
      else
      {
        Ibex = ((IBEIatT*(expi_vbex-1.0))+(IBENatT*(expn_vbex-1.0)));
      }
    }
    else
    {
      argi_vbei = (Vbei/(modelPar_NEI*Vtv));
      expi_vbei = limexp<AdmsSensFadType>(argi_vbei);
      argn_vbei = (Vbei/(modelPar_NEN*Vtv));
      expn_vbei = limexp<AdmsSensFadType>(argn_vbei);
      if ((modelPar_VBBE>0.0))
      {
        argx_vbei = (((-VBBEatT)-Vbei)/(NBBEatT*Vtv));
        expx_vbei = limexp<AdmsSensFadType>(argx_vbei);
        Ibe = (modelPar_WBE*(((IBEIatT*(expi_vbei-1.0))+(IBENatT*(expn_vbei-1.0)))-(modelPar_IBBE*(expx_vbei-EBBEatT))));
      }
      else
      {
        Ibe = (modelPar_WBE*((IBEIatT*(expi_vbei-1.0))+(IBENatT*(expn_vbei-1.0))));
      }
      argi_vbex = (Vbex/(modelPar_NEI*Vtv));
      expi_vbex = limexp<AdmsSensFadType>(argi_vbex);
      argn_vbex = (Vbex/(modelPar_NEN*Vtv));
      expn_vbex = limexp<AdmsSensFadType>(argn_vbex);
      if ((modelPar_VBBE>0.0))
      {
        argx_vbex = (((-VBBEatT)-Vbex)/(NBBEatT*Vtv));
        expx_vbex = limexp<AdmsSensFadType>(argx_vbex);
        Ibex = ((1.0-modelPar_WBE)*(((IBEIatT*(expi_vbex-1.0))+(IBENatT*(expn_vbex-1.0)))-(modelPar_IBBE*(expx_vbex-EBBEatT))));
      }
      else
      {
        Ibex = ((1.0-modelPar_WBE)*((IBEIatT*(expi_vbex-1.0))+(IBENatT*(expn_vbex-1.0))));
      }
    }
  }
  argi_vbci = (Vbci/(modelPar_NCI*Vtv));
  expi_vbci = limexp<AdmsSensFadType>(argi_vbci);
  argn_vbci = (Vbci/(modelPar_NCN*Vtv));
  expn_vbci = limexp<AdmsSensFadType>(argn_vbci);
  Ibcj = ((IBCIatT*(expi_vbci-1.0))+(IBCNatT*(expn_vbci-1.0)));
  if (((modelPar_IBEIP>0.0)||(modelPar_IBENP>0.0)))
  {
    argi_vbep = (Vbep/(modelPar_NCI*Vtv));
    expi_vbep = limexp<AdmsSensFadType>(argi_vbep);
    argn_vbep = (Vbep/(modelPar_NCN*Vtv));
    expn_vbep = limexp<AdmsSensFadType>(argn_vbep);
    Ibep = ((IBEIPatT*(expi_vbep-1.0))+(IBENPatT*(expn_vbep-1.0)));
  }
  else
  {
    Ibep = 0.0;
  }
  if ((modelPar_AVC1>0.0))
  {
    vl_vbci = (0.5*(sqrt((((PCatT-Vbci)*(PCatT-Vbci))+0.01))+(PCatT-Vbci)));
    avalf_exparg = ((-AVC2atT)*pow(vl_vbci,(modelPar_MC-1.0)));
    avalf = ((modelPar_AVC1*vl_vbci)*limexp<AdmsSensFadType>(avalf_exparg));
    Igc = (((Itzf-Itzr)-Ibcj)*avalf);
  }
  else
  {
    Igc = 0.0;
  }
  Ibc = (Ibcj-Igc);
  if ((modelPar_RCX>0.0))
  {
    Ircx = (Vrcx/RCXatT);
  }
  else
  {
    Ircx = 0.0;
  }
  argi_vbci = (Vbci/Vtv);
  expi_vbci = limexp<AdmsSensFadType>(argi_vbci);
  argx_vbcx = (Vbcx/Vtv);
  expx_vbcx = limexp<AdmsSensFadType>(argx_vbcx);
  Kbci = sqrt((1.0+(GAMMatT*expi_vbci)));
  Kbcx = sqrt((1.0+(GAMMatT*expx_vbcx)));
  if ((modelPar_RCI>0.0))
  {
    rKp1 = ((Kbci+1.0)/(Kbcx+1.0));
    Iohm = ((Vrci+(Vtv*((Kbci-Kbcx)-log(rKp1))))/RCIatT);
    derf = (((IVO*RCIatT)*Iohm)/(1.0+(((0.5*IVO)*IHRCF)*sqrt(((Vrci*Vrci)+0.01)))));
    Irci = (Iohm/sqrt((1+(derf*derf))));
  }
  else
  {
    Irci = 0.0;
  }
  if ((modelPar_RBX>0.0))
  {
    Irbx = (Vrbx/RBXatT);
  }
  else
  {
    Irbx = 0.0;
  }
  if ((modelPar_RBI>0.0))
  {
    Irbi = ((Vrbi*qb)/RBIatT);
  }
  else
  {
    Irbi = 0.0;
  }
  if ((modelPar_RE>0.0))
  {
    Ire = (Vre/REatT);
  }
  else
  {
    Ire = 0.0;
  }
  if ((modelPar_RBP>0.0))
  {
    Irbp = ((Vrbp*qbp)/RBPatT);
  }
  else
  {
    Irbp = 0.0;
  }
  sgIf = ((Ifi>0.0)?1.0:0.0);
  rIf = ((Ifi*sgIf)*IITF);
  mIf = (rIf/(rIf+1.0));
  tff_exparg = ((Vbci*IVTF)/1.44);
  tff = ((modelPar_TF*(1.0+(modelPar_QTF*q1)))*(1.0+(((modelPar_XTF*limexp<AdmsSensFadType>(tff_exparg))*(slTF+(mIf*mIf)))*sgIf)));
  Qbe = (((CJEatT*qdbe)*modelPar_WBE)+((tff*Ifi)/qb));
  Qbex = ((CJEatT*qdbex)*(1.0-modelPar_WBE));
  Qbc = (((CJCatT*qdbc)+(modelPar_TR*Iri))+(modelPar_QCO*Kbci));
  Qbcx = (modelPar_QCO*Kbcx);
  Qbep = ((CJEPatT*qdbep)+(modelPar_TR*Ifp));
  Qbeo = (Vbe*modelPar_CBEO);
  Qbco = (Vbc*modelPar_CBCO);
  Ith = (-(((((((((((Ibe*Vbei)+(Ibc*Vbci))+((Itzf-Itzr)*Vcei))+(Ibex*Vbex))+(Ibep*Vbep))+(Ircx*Vrcx))+(Irci*Vrci))+(Irbx*Vrbx))+(Irbi*Vrbi))+(Ire*Vre))+(Irbp*Vrbp)));
  if ((modelPar_RTH>0.0))
  {
    Irth = (Vrth/modelPar_RTH);
  }
  else
  {
    Irth = 0.0;
  }
  Qcth = (Vrth*modelPar_CTH);
  // I(bi,ei) <+ (((M*dtype)*(Ibe+($simparam("gmin")*Vbei))))
  staticContributions[admsNodeID_bi] += ((instancePar_M*modelPar_dtype)*(Ibe+(gmin*Vbei)));
  staticContributions[admsNodeID_ei] -= ((instancePar_M*modelPar_dtype)*(Ibe+(gmin*Vbei)));
  // I(bx,ei) <+ (((M*dtype)*(Ibex+($simparam("gmin")*Vbex))))
  staticContributions[admsNodeID_bx] += ((instancePar_M*modelPar_dtype)*(Ibex+(gmin*Vbex)));
  staticContributions[admsNodeID_ei] -= ((instancePar_M*modelPar_dtype)*(Ibex+(gmin*Vbex)));
  // I(ci,ei) <+ (((M*dtype)*Itzf))
  staticContributions[admsNodeID_ci] += ((instancePar_M*modelPar_dtype)*Itzf);
  staticContributions[admsNodeID_ei] -= ((instancePar_M*modelPar_dtype)*Itzf);
  // I(ei,ci) <+ (((M*dtype)*Itzr))
  staticContributions[admsNodeID_ei] += ((instancePar_M*modelPar_dtype)*Itzr);
  staticContributions[admsNodeID_ci] -= ((instancePar_M*modelPar_dtype)*Itzr);
  // I(bi,ci) <+ (((M*dtype)*(Ibc+($simparam("gmin")*Vbci))))
  staticContributions[admsNodeID_bi] += ((instancePar_M*modelPar_dtype)*(Ibc+(gmin*Vbci)));
  staticContributions[admsNodeID_ci] -= ((instancePar_M*modelPar_dtype)*(Ibc+(gmin*Vbci)));
  // I(bx,bp) <+ (((M*dtype)*(Ibep+($simparam("gmin")*Vbep))))
  staticContributions[admsNodeID_bx] += ((instancePar_M*modelPar_dtype)*(Ibep+(gmin*Vbep)));
  staticContributions[admsNodeID_bp] -= ((instancePar_M*modelPar_dtype)*(Ibep+(gmin*Vbep)));
  if ((modelPar_RCX>0))
  {
    // I(c,cx) <+ (((M*dtype)*Ircx))
    staticContributions[admsNodeID_c] += ((instancePar_M*modelPar_dtype)*Ircx);
    staticContributions[admsNodeID_cx] -= ((instancePar_M*modelPar_dtype)*Ircx);
  }
  else
  {
    // V(c,cx) <+ (0.0)
    // do nothing at all
  }
  // I(cx,ci) <+ (((M*dtype)*(Irci+($simparam("gmin")*Vrci))))
  staticContributions[admsNodeID_cx] += ((instancePar_M*modelPar_dtype)*(Irci+(gmin*Vrci)));
  staticContributions[admsNodeID_ci] -= ((instancePar_M*modelPar_dtype)*(Irci+(gmin*Vrci)));
  if ((modelPar_RBX>0))
  {
    // I(b,bx) <+ (((M*dtype)*Irbx))
    staticContributions[admsNodeID_b] += ((instancePar_M*modelPar_dtype)*Irbx);
    staticContributions[admsNodeID_bx] -= ((instancePar_M*modelPar_dtype)*Irbx);
  }
  else
  {
    // V(b,bx) <+ (0.0)
    // do nothing at all
  }
  // I(bx,bi) <+ (((M*dtype)*Irbi))
  staticContributions[admsNodeID_bx] += ((instancePar_M*modelPar_dtype)*Irbi);
  staticContributions[admsNodeID_bi] -= ((instancePar_M*modelPar_dtype)*Irbi);
  if ((modelPar_RE>0))
  {
    // I(e,ei) <+ (((M*dtype)*Ire))
    staticContributions[admsNodeID_e] += ((instancePar_M*modelPar_dtype)*Ire);
    staticContributions[admsNodeID_ei] -= ((instancePar_M*modelPar_dtype)*Ire);
  }
  else
  {
    // V(e,ei) <+ (0.0)
    // do nothing at all
  }
  // I(bp,cx) <+ (((M*dtype)*Irbp))
  staticContributions[admsNodeID_bp] += ((instancePar_M*modelPar_dtype)*Irbp);
  staticContributions[admsNodeID_cx] -= ((instancePar_M*modelPar_dtype)*Irbp);
  // I(bi,ei) <+ (((M*dtype)*ddt(Qbe)))
  dynamicContributions[admsNodeID_bi] += ((instancePar_M*modelPar_dtype)*(Qbe));
  dynamicContributions[admsNodeID_ei] -= ((instancePar_M*modelPar_dtype)*(Qbe));
  // I(bx,ei) <+ (((M*dtype)*ddt(Qbex)))
  dynamicContributions[admsNodeID_bx] += ((instancePar_M*modelPar_dtype)*(Qbex));
  dynamicContributions[admsNodeID_ei] -= ((instancePar_M*modelPar_dtype)*(Qbex));
  // I(bi,ci) <+ (((M*dtype)*ddt(Qbc)))
  dynamicContributions[admsNodeID_bi] += ((instancePar_M*modelPar_dtype)*(Qbc));
  dynamicContributions[admsNodeID_ci] -= ((instancePar_M*modelPar_dtype)*(Qbc));
  // I(bi,cx) <+ (((M*dtype)*ddt(Qbcx)))
  dynamicContributions[admsNodeID_bi] += ((instancePar_M*modelPar_dtype)*(Qbcx));
  dynamicContributions[admsNodeID_cx] -= ((instancePar_M*modelPar_dtype)*(Qbcx));
  // I(bx,bp) <+ (((M*dtype)*ddt(Qbep)))
  dynamicContributions[admsNodeID_bx] += ((instancePar_M*modelPar_dtype)*(Qbep));
  dynamicContributions[admsNodeID_bp] -= ((instancePar_M*modelPar_dtype)*(Qbep));
  // I(b,e) <+ (((M*dtype)*ddt(Qbeo)))
  dynamicContributions[admsNodeID_b] += ((instancePar_M*modelPar_dtype)*(Qbeo));
  dynamicContributions[admsNodeID_e] -= ((instancePar_M*modelPar_dtype)*(Qbeo));
  // I(b,c) <+ (((M*dtype)*ddt(Qbco)))
  dynamicContributions[admsNodeID_b] += ((instancePar_M*modelPar_dtype)*(Qbco));
  dynamicContributions[admsNodeID_c] -= ((instancePar_M*modelPar_dtype)*(Qbco));
  // I(dt,GND) <+ (Irth)
  staticContributions[admsNodeID_dt] += Irth;
  // I(dt,GND) <+ (Ith)
  staticContributions[admsNodeID_dt] += Ith;
  // I(dt,GND) <+ (ddt(Qcth))
  dynamicContributions[admsNodeID_dt] += (Qcth);
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void InstanceSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Instance & in = *(dynamic_cast<const Instance *> (e1));
  const Model & mod =in.model_;

  dfdp.resize(10+0);
  dqdp.resize(10+0);
  Findices.resize(10+0);
  Qindices.resize(10+0);

  std::vector <double> probeVars(15);
  std::vector <AdmsSensFadType> staticContributions(10+0);
  std::vector <AdmsSensFadType> dynamicContributions(10+0);


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 10+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // Copy out all the model parameters (doubles) into FAD types
  //reals
  AdmsSensFadType modelPar_TNOM=mod.TNOM;
  bool modelPar_given_TNOM=mod.given("TNOM");
  AdmsSensFadType modelPar_RCX=mod.RCX;
  bool modelPar_given_RCX=mod.given("RCX");
  AdmsSensFadType modelPar_RCI=mod.RCI;
  bool modelPar_given_RCI=mod.given("RCI");
  AdmsSensFadType modelPar_VO=mod.VO;
  bool modelPar_given_VO=mod.given("VO");
  AdmsSensFadType modelPar_GAMM=mod.GAMM;
  bool modelPar_given_GAMM=mod.given("GAMM");
  AdmsSensFadType modelPar_HRCF=mod.HRCF;
  bool modelPar_given_HRCF=mod.given("HRCF");
  AdmsSensFadType modelPar_RBX=mod.RBX;
  bool modelPar_given_RBX=mod.given("RBX");
  AdmsSensFadType modelPar_RBI=mod.RBI;
  bool modelPar_given_RBI=mod.given("RBI");
  AdmsSensFadType modelPar_RE=mod.RE;
  bool modelPar_given_RE=mod.given("RE");
  AdmsSensFadType modelPar_RS=mod.RS;
  bool modelPar_given_RS=mod.given("RS");
  AdmsSensFadType modelPar_RBP=mod.RBP;
  bool modelPar_given_RBP=mod.given("RBP");
  AdmsSensFadType modelPar_IS=mod.IS;
  bool modelPar_given_IS=mod.given("IS");
  AdmsSensFadType modelPar_NF=mod.NF;
  bool modelPar_given_NF=mod.given("NF");
  AdmsSensFadType modelPar_NR=mod.NR;
  bool modelPar_given_NR=mod.given("NR");
  AdmsSensFadType modelPar_FC=mod.FC;
  bool modelPar_given_FC=mod.given("FC");
  AdmsSensFadType modelPar_CBEO=mod.CBEO;
  bool modelPar_given_CBEO=mod.given("CBEO");
  AdmsSensFadType modelPar_CJE=mod.CJE;
  bool modelPar_given_CJE=mod.given("CJE");
  AdmsSensFadType modelPar_PE=mod.PE;
  bool modelPar_given_PE=mod.given("PE");
  AdmsSensFadType modelPar_ME=mod.ME;
  bool modelPar_given_ME=mod.given("ME");
  AdmsSensFadType modelPar_AJE=mod.AJE;
  bool modelPar_given_AJE=mod.given("AJE");
  AdmsSensFadType modelPar_CBCO=mod.CBCO;
  bool modelPar_given_CBCO=mod.given("CBCO");
  AdmsSensFadType modelPar_CJC=mod.CJC;
  bool modelPar_given_CJC=mod.given("CJC");
  AdmsSensFadType modelPar_QCO=mod.QCO;
  bool modelPar_given_QCO=mod.given("QCO");
  AdmsSensFadType modelPar_CJEP=mod.CJEP;
  bool modelPar_given_CJEP=mod.given("CJEP");
  AdmsSensFadType modelPar_PC=mod.PC;
  bool modelPar_given_PC=mod.given("PC");
  AdmsSensFadType modelPar_MC=mod.MC;
  bool modelPar_given_MC=mod.given("MC");
  AdmsSensFadType modelPar_AJC=mod.AJC;
  bool modelPar_given_AJC=mod.given("AJC");
  AdmsSensFadType modelPar_CJCP=mod.CJCP;
  bool modelPar_given_CJCP=mod.given("CJCP");
  AdmsSensFadType modelPar_PS=mod.PS;
  bool modelPar_given_PS=mod.given("PS");
  AdmsSensFadType modelPar_MS=mod.MS;
  bool modelPar_given_MS=mod.given("MS");
  AdmsSensFadType modelPar_AJS=mod.AJS;
  bool modelPar_given_AJS=mod.given("AJS");
  AdmsSensFadType modelPar_IBEI=mod.IBEI;
  bool modelPar_given_IBEI=mod.given("IBEI");
  AdmsSensFadType modelPar_WBE=mod.WBE;
  bool modelPar_given_WBE=mod.given("WBE");
  AdmsSensFadType modelPar_NEI=mod.NEI;
  bool modelPar_given_NEI=mod.given("NEI");
  AdmsSensFadType modelPar_IBEN=mod.IBEN;
  bool modelPar_given_IBEN=mod.given("IBEN");
  AdmsSensFadType modelPar_NEN=mod.NEN;
  bool modelPar_given_NEN=mod.given("NEN");
  AdmsSensFadType modelPar_IBCI=mod.IBCI;
  bool modelPar_given_IBCI=mod.given("IBCI");
  AdmsSensFadType modelPar_NCI=mod.NCI;
  bool modelPar_given_NCI=mod.given("NCI");
  AdmsSensFadType modelPar_IBCN=mod.IBCN;
  bool modelPar_given_IBCN=mod.given("IBCN");
  AdmsSensFadType modelPar_NCN=mod.NCN;
  bool modelPar_given_NCN=mod.given("NCN");
  AdmsSensFadType modelPar_AVC1=mod.AVC1;
  bool modelPar_given_AVC1=mod.given("AVC1");
  AdmsSensFadType modelPar_AVC2=mod.AVC2;
  bool modelPar_given_AVC2=mod.given("AVC2");
  AdmsSensFadType modelPar_ISP=mod.ISP;
  bool modelPar_given_ISP=mod.given("ISP");
  AdmsSensFadType modelPar_WSP=mod.WSP;
  bool modelPar_given_WSP=mod.given("WSP");
  AdmsSensFadType modelPar_NFP=mod.NFP;
  bool modelPar_given_NFP=mod.given("NFP");
  AdmsSensFadType modelPar_IBEIP=mod.IBEIP;
  bool modelPar_given_IBEIP=mod.given("IBEIP");
  AdmsSensFadType modelPar_IBENP=mod.IBENP;
  bool modelPar_given_IBENP=mod.given("IBENP");
  AdmsSensFadType modelPar_IBCIP=mod.IBCIP;
  bool modelPar_given_IBCIP=mod.given("IBCIP");
  AdmsSensFadType modelPar_NCIP=mod.NCIP;
  bool modelPar_given_NCIP=mod.given("NCIP");
  AdmsSensFadType modelPar_IBCNP=mod.IBCNP;
  bool modelPar_given_IBCNP=mod.given("IBCNP");
  AdmsSensFadType modelPar_NCNP=mod.NCNP;
  bool modelPar_given_NCNP=mod.given("NCNP");
  AdmsSensFadType modelPar_VEF=mod.VEF;
  bool modelPar_given_VEF=mod.given("VEF");
  AdmsSensFadType modelPar_VER=mod.VER;
  bool modelPar_given_VER=mod.given("VER");
  AdmsSensFadType modelPar_IKF=mod.IKF;
  bool modelPar_given_IKF=mod.given("IKF");
  AdmsSensFadType modelPar_IKR=mod.IKR;
  bool modelPar_given_IKR=mod.given("IKR");
  AdmsSensFadType modelPar_IKP=mod.IKP;
  bool modelPar_given_IKP=mod.given("IKP");
  AdmsSensFadType modelPar_TF=mod.TF;
  bool modelPar_given_TF=mod.given("TF");
  AdmsSensFadType modelPar_QTF=mod.QTF;
  bool modelPar_given_QTF=mod.given("QTF");
  AdmsSensFadType modelPar_XTF=mod.XTF;
  bool modelPar_given_XTF=mod.given("XTF");
  AdmsSensFadType modelPar_VTF=mod.VTF;
  bool modelPar_given_VTF=mod.given("VTF");
  AdmsSensFadType modelPar_ITF=mod.ITF;
  bool modelPar_given_ITF=mod.given("ITF");
  AdmsSensFadType modelPar_TR=mod.TR;
  bool modelPar_given_TR=mod.given("TR");
  AdmsSensFadType modelPar_TD=mod.TD;
  bool modelPar_given_TD=mod.given("TD");
  AdmsSensFadType modelPar_KFN=mod.KFN;
  bool modelPar_given_KFN=mod.given("KFN");
  AdmsSensFadType modelPar_AFN=mod.AFN;
  bool modelPar_given_AFN=mod.given("AFN");
  AdmsSensFadType modelPar_BFN=mod.BFN;
  bool modelPar_given_BFN=mod.given("BFN");
  AdmsSensFadType modelPar_XRE=mod.XRE;
  bool modelPar_given_XRE=mod.given("XRE");
  AdmsSensFadType modelPar_XRBI=mod.XRBI;
  bool modelPar_given_XRBI=mod.given("XRBI");
  AdmsSensFadType modelPar_XRCI=mod.XRCI;
  bool modelPar_given_XRCI=mod.given("XRCI");
  AdmsSensFadType modelPar_XRS=mod.XRS;
  bool modelPar_given_XRS=mod.given("XRS");
  AdmsSensFadType modelPar_XVO=mod.XVO;
  bool modelPar_given_XVO=mod.given("XVO");
  AdmsSensFadType modelPar_EA=mod.EA;
  bool modelPar_given_EA=mod.given("EA");
  AdmsSensFadType modelPar_EAIE=mod.EAIE;
  bool modelPar_given_EAIE=mod.given("EAIE");
  AdmsSensFadType modelPar_EAIC=mod.EAIC;
  bool modelPar_given_EAIC=mod.given("EAIC");
  AdmsSensFadType modelPar_EAIS=mod.EAIS;
  bool modelPar_given_EAIS=mod.given("EAIS");
  AdmsSensFadType modelPar_EANE=mod.EANE;
  bool modelPar_given_EANE=mod.given("EANE");
  AdmsSensFadType modelPar_EANC=mod.EANC;
  bool modelPar_given_EANC=mod.given("EANC");
  AdmsSensFadType modelPar_EANS=mod.EANS;
  bool modelPar_given_EANS=mod.given("EANS");
  AdmsSensFadType modelPar_XIS=mod.XIS;
  bool modelPar_given_XIS=mod.given("XIS");
  AdmsSensFadType modelPar_XII=mod.XII;
  bool modelPar_given_XII=mod.given("XII");
  AdmsSensFadType modelPar_XIN=mod.XIN;
  bool modelPar_given_XIN=mod.given("XIN");
  AdmsSensFadType modelPar_TNF=mod.TNF;
  bool modelPar_given_TNF=mod.given("TNF");
  AdmsSensFadType modelPar_TAVC=mod.TAVC;
  bool modelPar_given_TAVC=mod.given("TAVC");
  AdmsSensFadType modelPar_RTH=mod.RTH;
  bool modelPar_given_RTH=mod.given("RTH");
  AdmsSensFadType modelPar_CTH=mod.CTH;
  bool modelPar_given_CTH=mod.given("CTH");
  AdmsSensFadType modelPar_VRT=mod.VRT;
  bool modelPar_given_VRT=mod.given("VRT");
  AdmsSensFadType modelPar_ART=mod.ART;
  bool modelPar_given_ART=mod.given("ART");
  AdmsSensFadType modelPar_CCSO=mod.CCSO;
  bool modelPar_given_CCSO=mod.given("CCSO");
  AdmsSensFadType modelPar_QBM=mod.QBM;
  bool modelPar_given_QBM=mod.given("QBM");
  AdmsSensFadType modelPar_NKF=mod.NKF;
  bool modelPar_given_NKF=mod.given("NKF");
  AdmsSensFadType modelPar_XIKF=mod.XIKF;
  bool modelPar_given_XIKF=mod.given("XIKF");
  AdmsSensFadType modelPar_XRCX=mod.XRCX;
  bool modelPar_given_XRCX=mod.given("XRCX");
  AdmsSensFadType modelPar_XRBX=mod.XRBX;
  bool modelPar_given_XRBX=mod.given("XRBX");
  AdmsSensFadType modelPar_XRBP=mod.XRBP;
  bool modelPar_given_XRBP=mod.given("XRBP");
  AdmsSensFadType modelPar_ISRR=mod.ISRR;
  bool modelPar_given_ISRR=mod.given("ISRR");
  AdmsSensFadType modelPar_XISR=mod.XISR;
  bool modelPar_given_XISR=mod.given("XISR");
  AdmsSensFadType modelPar_DEAR=mod.DEAR;
  bool modelPar_given_DEAR=mod.given("DEAR");
  AdmsSensFadType modelPar_EAP=mod.EAP;
  bool modelPar_given_EAP=mod.given("EAP");
  AdmsSensFadType modelPar_VBBE=mod.VBBE;
  bool modelPar_given_VBBE=mod.given("VBBE");
  AdmsSensFadType modelPar_NBBE=mod.NBBE;
  bool modelPar_given_NBBE=mod.given("NBBE");
  AdmsSensFadType modelPar_IBBE=mod.IBBE;
  bool modelPar_given_IBBE=mod.given("IBBE");
  AdmsSensFadType modelPar_TVBBE1=mod.TVBBE1;
  bool modelPar_given_TVBBE1=mod.given("TVBBE1");
  AdmsSensFadType modelPar_TVBBE2=mod.TVBBE2;
  bool modelPar_given_TVBBE2=mod.given("TVBBE2");
  AdmsSensFadType modelPar_TNBBE=mod.TNBBE;
  bool modelPar_given_TNBBE=mod.given("TNBBE");
  AdmsSensFadType modelPar_EBBE=mod.EBBE;
  bool modelPar_given_EBBE=mod.given("EBBE");
  AdmsSensFadType modelPar_DTEMP=mod.DTEMP;
  bool modelPar_given_DTEMP=mod.given("DTEMP");
  AdmsSensFadType modelPar_VERS=mod.VERS;
  bool modelPar_given_VERS=mod.given("VERS");
  AdmsSensFadType modelPar_VREV=mod.VREV;
  bool modelPar_given_VREV=mod.given("VREV");


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_dtype=mod.dtype;



  // Copy out all the instance parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> inParamMap;

  // reals
  AdmsSensFadType instancePar_DTEMP=in.DTEMP;
  bool instancePar_given_DTEMP=in.given("DTEMP");
  inParamMap["DTEMP"] = &instancePar_DTEMP;


  // Copy all the real hidden instance params into fad types



  // Copy all the non-real instance params into vars of their appropriate type:
  int instancePar_M=in.M;
  bool instancePar_given_M=in.given("M");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check the name first, otherwise segfault on invalid name!
  inParamMap[name]->diff(0,1);

  //make local copies of all instance vars
  //reals


  //non-reals


  //make local copies of all model vars
  //reals


  // non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables and set as Fad independent variables.
  probeVars[in.admsProbeID_V_ci_ei] = (*solVectorPtr)[in.li_ci]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_V_b_c] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_c];
  probeVars[in.admsProbeID_V_bp_cx] = (*solVectorPtr)[in.li_bp]- (*solVectorPtr)[in.li_cx];
  probeVars[in.admsProbeID_V_e_ei] = (*solVectorPtr)[in.li_e]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_V_b_bx] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_bx];
  probeVars[in.admsProbeID_V_bx_bi] = (*solVectorPtr)[in.li_bx]- (*solVectorPtr)[in.li_bi];
  probeVars[in.admsProbeID_V_cx_ci] = (*solVectorPtr)[in.li_cx]- (*solVectorPtr)[in.li_ci];
  probeVars[in.admsProbeID_V_c_cx] = (*solVectorPtr)[in.li_c]- (*solVectorPtr)[in.li_cx];
  probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_e];
  probeVars[in.admsProbeID_V_dt_GND] = (*solVectorPtr)[in.li_dt];
  probeVars[in.admsProbeID_V_bx_bp] = (*solVectorPtr)[in.li_bx]- (*solVectorPtr)[in.li_bp];
  probeVars[in.admsProbeID_V_bi_cx] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_cx];
  probeVars[in.admsProbeID_V_bx_ei] = (*solVectorPtr)[in.li_bx]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_V_bi_ci] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_ci];
  probeVars[in.admsProbeID_V_bi_ei] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_ei];


  // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
    
  probeVars[in.admsProbeID_V_b_e] *= modelPar_dtype;
  probeVars[in.admsProbeID_V_bx_bp] *= modelPar_dtype;
  probeVars[in.admsProbeID_V_bi_cx] *= modelPar_dtype;
  probeVars[in.admsProbeID_V_bx_ei] *= modelPar_dtype;
  probeVars[in.admsProbeID_V_bi_ci] *= modelPar_dtype;
  probeVars[in.admsProbeID_V_bi_ei] *= modelPar_dtype;



  // Now call  the function that does the heavy lifting.
  evaluateModelEquations(
     probeVars,
     // probe constants
     in.admsProbeID_V_ci_ei,
     in.admsProbeID_V_b_c,
     in.admsProbeID_V_bp_cx,
     in.admsProbeID_V_e_ei,
     in.admsProbeID_V_b_bx,
     in.admsProbeID_V_bx_bi,
     in.admsProbeID_V_cx_ci,
     in.admsProbeID_V_c_cx,
     in.admsProbeID_V_b_e,
     in.admsProbeID_V_dt_GND,
     in.admsProbeID_V_bx_bp,
     in.admsProbeID_V_bi_cx,
     in.admsProbeID_V_bx_ei,
     in.admsProbeID_V_bi_ci,
     in.admsProbeID_V_bi_ei,

     // node constants
     in.admsNodeID_c,
     in.admsNodeID_b,
     in.admsNodeID_e,
     in.admsNodeID_dt,
     in.admsNodeID_cx,
     in.admsNodeID_ci,
     in.admsNodeID_bx,
     in.admsNodeID_bi,
     in.admsNodeID_ei,
     in.admsNodeID_bp,
     // instance parameters
     // reals
     instancePar_DTEMP,
     instancePar_given_DTEMP,
     // non-reals(including hidden)
     instancePar_M,
     instancePar_given_M,
     // model parameters
     // reals
     modelPar_TNOM,
     modelPar_given_TNOM,
     modelPar_RCX,
     modelPar_given_RCX,
     modelPar_RCI,
     modelPar_given_RCI,
     modelPar_VO,
     modelPar_given_VO,
     modelPar_GAMM,
     modelPar_given_GAMM,
     modelPar_HRCF,
     modelPar_given_HRCF,
     modelPar_RBX,
     modelPar_given_RBX,
     modelPar_RBI,
     modelPar_given_RBI,
     modelPar_RE,
     modelPar_given_RE,
     modelPar_RS,
     modelPar_given_RS,
     modelPar_RBP,
     modelPar_given_RBP,
     modelPar_IS,
     modelPar_given_IS,
     modelPar_NF,
     modelPar_given_NF,
     modelPar_NR,
     modelPar_given_NR,
     modelPar_FC,
     modelPar_given_FC,
     modelPar_CBEO,
     modelPar_given_CBEO,
     modelPar_CJE,
     modelPar_given_CJE,
     modelPar_PE,
     modelPar_given_PE,
     modelPar_ME,
     modelPar_given_ME,
     modelPar_AJE,
     modelPar_given_AJE,
     modelPar_CBCO,
     modelPar_given_CBCO,
     modelPar_CJC,
     modelPar_given_CJC,
     modelPar_QCO,
     modelPar_given_QCO,
     modelPar_CJEP,
     modelPar_given_CJEP,
     modelPar_PC,
     modelPar_given_PC,
     modelPar_MC,
     modelPar_given_MC,
     modelPar_AJC,
     modelPar_given_AJC,
     modelPar_CJCP,
     modelPar_given_CJCP,
     modelPar_PS,
     modelPar_given_PS,
     modelPar_MS,
     modelPar_given_MS,
     modelPar_AJS,
     modelPar_given_AJS,
     modelPar_IBEI,
     modelPar_given_IBEI,
     modelPar_WBE,
     modelPar_given_WBE,
     modelPar_NEI,
     modelPar_given_NEI,
     modelPar_IBEN,
     modelPar_given_IBEN,
     modelPar_NEN,
     modelPar_given_NEN,
     modelPar_IBCI,
     modelPar_given_IBCI,
     modelPar_NCI,
     modelPar_given_NCI,
     modelPar_IBCN,
     modelPar_given_IBCN,
     modelPar_NCN,
     modelPar_given_NCN,
     modelPar_AVC1,
     modelPar_given_AVC1,
     modelPar_AVC2,
     modelPar_given_AVC2,
     modelPar_ISP,
     modelPar_given_ISP,
     modelPar_WSP,
     modelPar_given_WSP,
     modelPar_NFP,
     modelPar_given_NFP,
     modelPar_IBEIP,
     modelPar_given_IBEIP,
     modelPar_IBENP,
     modelPar_given_IBENP,
     modelPar_IBCIP,
     modelPar_given_IBCIP,
     modelPar_NCIP,
     modelPar_given_NCIP,
     modelPar_IBCNP,
     modelPar_given_IBCNP,
     modelPar_NCNP,
     modelPar_given_NCNP,
     modelPar_VEF,
     modelPar_given_VEF,
     modelPar_VER,
     modelPar_given_VER,
     modelPar_IKF,
     modelPar_given_IKF,
     modelPar_IKR,
     modelPar_given_IKR,
     modelPar_IKP,
     modelPar_given_IKP,
     modelPar_TF,
     modelPar_given_TF,
     modelPar_QTF,
     modelPar_given_QTF,
     modelPar_XTF,
     modelPar_given_XTF,
     modelPar_VTF,
     modelPar_given_VTF,
     modelPar_ITF,
     modelPar_given_ITF,
     modelPar_TR,
     modelPar_given_TR,
     modelPar_TD,
     modelPar_given_TD,
     modelPar_KFN,
     modelPar_given_KFN,
     modelPar_AFN,
     modelPar_given_AFN,
     modelPar_BFN,
     modelPar_given_BFN,
     modelPar_XRE,
     modelPar_given_XRE,
     modelPar_XRBI,
     modelPar_given_XRBI,
     modelPar_XRCI,
     modelPar_given_XRCI,
     modelPar_XRS,
     modelPar_given_XRS,
     modelPar_XVO,
     modelPar_given_XVO,
     modelPar_EA,
     modelPar_given_EA,
     modelPar_EAIE,
     modelPar_given_EAIE,
     modelPar_EAIC,
     modelPar_given_EAIC,
     modelPar_EAIS,
     modelPar_given_EAIS,
     modelPar_EANE,
     modelPar_given_EANE,
     modelPar_EANC,
     modelPar_given_EANC,
     modelPar_EANS,
     modelPar_given_EANS,
     modelPar_XIS,
     modelPar_given_XIS,
     modelPar_XII,
     modelPar_given_XII,
     modelPar_XIN,
     modelPar_given_XIN,
     modelPar_TNF,
     modelPar_given_TNF,
     modelPar_TAVC,
     modelPar_given_TAVC,
     modelPar_RTH,
     modelPar_given_RTH,
     modelPar_CTH,
     modelPar_given_CTH,
     modelPar_VRT,
     modelPar_given_VRT,
     modelPar_ART,
     modelPar_given_ART,
     modelPar_CCSO,
     modelPar_given_CCSO,
     modelPar_QBM,
     modelPar_given_QBM,
     modelPar_NKF,
     modelPar_given_NKF,
     modelPar_XIKF,
     modelPar_given_XIKF,
     modelPar_XRCX,
     modelPar_given_XRCX,
     modelPar_XRBX,
     modelPar_given_XRBX,
     modelPar_XRBP,
     modelPar_given_XRBP,
     modelPar_ISRR,
     modelPar_given_ISRR,
     modelPar_XISR,
     modelPar_given_XISR,
     modelPar_DEAR,
     modelPar_given_DEAR,
     modelPar_EAP,
     modelPar_given_EAP,
     modelPar_VBBE,
     modelPar_given_VBBE,
     modelPar_NBBE,
     modelPar_given_NBBE,
     modelPar_IBBE,
     modelPar_given_IBBE,
     modelPar_TVBBE1,
     modelPar_given_TVBBE1,
     modelPar_TVBBE2,
     modelPar_given_TVBBE2,
     modelPar_TNBBE,
     modelPar_given_TNBBE,
     modelPar_EBBE,
     modelPar_given_EBBE,
     modelPar_DTEMP,
     modelPar_given_DTEMP,
     modelPar_VERS,
     modelPar_given_VERS,
     modelPar_VREV,
     modelPar_given_VREV,
     // non-reals (including hidden)
     modelPar_dtype,
     in.admsTemperature,
     in.adms_vt_nom,
     in.getDeviceOptions().gmin,
     staticContributions,
     dynamicContributions,
     in);


  // We now have the F and Q vector stuff, populate the dependencies:

  dfdp[in.admsNodeID_c] += staticContributions[in.admsNodeID_c].dx(0);
  dqdp[in.admsNodeID_c] += dynamicContributions[in.admsNodeID_c].dx(0);
  Findices[in.admsNodeID_c] = in.li_c;
  Qindices[in.admsNodeID_c] = in.li_c;
  dfdp[in.admsNodeID_b] += staticContributions[in.admsNodeID_b].dx(0);
  dqdp[in.admsNodeID_b] += dynamicContributions[in.admsNodeID_b].dx(0);
  Findices[in.admsNodeID_b] = in.li_b;
  Qindices[in.admsNodeID_b] = in.li_b;
  dfdp[in.admsNodeID_e] += staticContributions[in.admsNodeID_e].dx(0);
  dqdp[in.admsNodeID_e] += dynamicContributions[in.admsNodeID_e].dx(0);
  Findices[in.admsNodeID_e] = in.li_e;
  Qindices[in.admsNodeID_e] = in.li_e;
  dfdp[in.admsNodeID_dt] += staticContributions[in.admsNodeID_dt].dx(0);
  dqdp[in.admsNodeID_dt] += dynamicContributions[in.admsNodeID_dt].dx(0);
  Findices[in.admsNodeID_dt] = in.li_dt;
  Qindices[in.admsNodeID_dt] = in.li_dt;
  dfdp[in.admsNodeID_cx] += staticContributions[in.admsNodeID_cx].dx(0);
  dqdp[in.admsNodeID_cx] += dynamicContributions[in.admsNodeID_cx].dx(0);
  Findices[in.admsNodeID_cx] = in.li_cx;
  Qindices[in.admsNodeID_cx] = in.li_cx;
  dfdp[in.admsNodeID_ci] += staticContributions[in.admsNodeID_ci].dx(0);
  dqdp[in.admsNodeID_ci] += dynamicContributions[in.admsNodeID_ci].dx(0);
  Findices[in.admsNodeID_ci] = in.li_ci;
  Qindices[in.admsNodeID_ci] = in.li_ci;
  dfdp[in.admsNodeID_bx] += staticContributions[in.admsNodeID_bx].dx(0);
  dqdp[in.admsNodeID_bx] += dynamicContributions[in.admsNodeID_bx].dx(0);
  Findices[in.admsNodeID_bx] = in.li_bx;
  Qindices[in.admsNodeID_bx] = in.li_bx;
  dfdp[in.admsNodeID_bi] += staticContributions[in.admsNodeID_bi].dx(0);
  dqdp[in.admsNodeID_bi] += dynamicContributions[in.admsNodeID_bi].dx(0);
  Findices[in.admsNodeID_bi] = in.li_bi;
  Qindices[in.admsNodeID_bi] = in.li_bi;
  dfdp[in.admsNodeID_ei] += staticContributions[in.admsNodeID_ei].dx(0);
  dqdp[in.admsNodeID_ei] += dynamicContributions[in.admsNodeID_ei].dx(0);
  Findices[in.admsNodeID_ei] = in.li_ei;
  Qindices[in.admsNodeID_ei] = in.li_ei;
  dfdp[in.admsNodeID_bp] += staticContributions[in.admsNodeID_bp].dx(0);
  dqdp[in.admsNodeID_bp] += dynamicContributions[in.admsNodeID_bp].dx(0);
  Findices[in.admsNodeID_bp] = in.li_bp;
  Qindices[in.admsNodeID_bp] = in.li_bp;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void ModelSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Model & mod = *(dynamic_cast<const Model *> (e1));
  int sizeInstance = mod.instanceContainer.size();

  dfdp.resize((10+0)*sizeInstance);
  dqdp.resize((10+0)*sizeInstance);
  Findices.resize((10+0)*sizeInstance);
  Qindices.resize((10+0)*sizeInstance);

  std::vector <double> probeVars(15);
  std::vector <AdmsSensFadType> staticContributions(10+0);
  std::vector <AdmsSensFadType> dynamicContributions(10+0);


  // Copy out all the model parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> modParamMap;

  // reals
  AdmsSensFadType modelPar_TNOM=mod.TNOM;
  bool modelPar_given_TNOM=mod.given("TNOM");
  modParamMap["TNOM"] = &modelPar_TNOM;
  AdmsSensFadType modelPar_RCX=mod.RCX;
  bool modelPar_given_RCX=mod.given("RCX");
  modParamMap["RCX"] = &modelPar_RCX;
  AdmsSensFadType modelPar_RCI=mod.RCI;
  bool modelPar_given_RCI=mod.given("RCI");
  modParamMap["RCI"] = &modelPar_RCI;
  AdmsSensFadType modelPar_VO=mod.VO;
  bool modelPar_given_VO=mod.given("VO");
  modParamMap["VO"] = &modelPar_VO;
  AdmsSensFadType modelPar_GAMM=mod.GAMM;
  bool modelPar_given_GAMM=mod.given("GAMM");
  modParamMap["GAMM"] = &modelPar_GAMM;
  AdmsSensFadType modelPar_HRCF=mod.HRCF;
  bool modelPar_given_HRCF=mod.given("HRCF");
  modParamMap["HRCF"] = &modelPar_HRCF;
  AdmsSensFadType modelPar_RBX=mod.RBX;
  bool modelPar_given_RBX=mod.given("RBX");
  modParamMap["RBX"] = &modelPar_RBX;
  AdmsSensFadType modelPar_RBI=mod.RBI;
  bool modelPar_given_RBI=mod.given("RBI");
  modParamMap["RBI"] = &modelPar_RBI;
  AdmsSensFadType modelPar_RE=mod.RE;
  bool modelPar_given_RE=mod.given("RE");
  modParamMap["RE"] = &modelPar_RE;
  AdmsSensFadType modelPar_RS=mod.RS;
  bool modelPar_given_RS=mod.given("RS");
  modParamMap["RS"] = &modelPar_RS;
  AdmsSensFadType modelPar_RBP=mod.RBP;
  bool modelPar_given_RBP=mod.given("RBP");
  modParamMap["RBP"] = &modelPar_RBP;
  AdmsSensFadType modelPar_IS=mod.IS;
  bool modelPar_given_IS=mod.given("IS");
  modParamMap["IS"] = &modelPar_IS;
  AdmsSensFadType modelPar_NF=mod.NF;
  bool modelPar_given_NF=mod.given("NF");
  modParamMap["NF"] = &modelPar_NF;
  AdmsSensFadType modelPar_NR=mod.NR;
  bool modelPar_given_NR=mod.given("NR");
  modParamMap["NR"] = &modelPar_NR;
  AdmsSensFadType modelPar_FC=mod.FC;
  bool modelPar_given_FC=mod.given("FC");
  modParamMap["FC"] = &modelPar_FC;
  AdmsSensFadType modelPar_CBEO=mod.CBEO;
  bool modelPar_given_CBEO=mod.given("CBEO");
  modParamMap["CBEO"] = &modelPar_CBEO;
  AdmsSensFadType modelPar_CJE=mod.CJE;
  bool modelPar_given_CJE=mod.given("CJE");
  modParamMap["CJE"] = &modelPar_CJE;
  AdmsSensFadType modelPar_PE=mod.PE;
  bool modelPar_given_PE=mod.given("PE");
  modParamMap["PE"] = &modelPar_PE;
  AdmsSensFadType modelPar_ME=mod.ME;
  bool modelPar_given_ME=mod.given("ME");
  modParamMap["ME"] = &modelPar_ME;
  AdmsSensFadType modelPar_AJE=mod.AJE;
  bool modelPar_given_AJE=mod.given("AJE");
  modParamMap["AJE"] = &modelPar_AJE;
  AdmsSensFadType modelPar_CBCO=mod.CBCO;
  bool modelPar_given_CBCO=mod.given("CBCO");
  modParamMap["CBCO"] = &modelPar_CBCO;
  AdmsSensFadType modelPar_CJC=mod.CJC;
  bool modelPar_given_CJC=mod.given("CJC");
  modParamMap["CJC"] = &modelPar_CJC;
  AdmsSensFadType modelPar_QCO=mod.QCO;
  bool modelPar_given_QCO=mod.given("QCO");
  modParamMap["QCO"] = &modelPar_QCO;
  AdmsSensFadType modelPar_CJEP=mod.CJEP;
  bool modelPar_given_CJEP=mod.given("CJEP");
  modParamMap["CJEP"] = &modelPar_CJEP;
  AdmsSensFadType modelPar_PC=mod.PC;
  bool modelPar_given_PC=mod.given("PC");
  modParamMap["PC"] = &modelPar_PC;
  AdmsSensFadType modelPar_MC=mod.MC;
  bool modelPar_given_MC=mod.given("MC");
  modParamMap["MC"] = &modelPar_MC;
  AdmsSensFadType modelPar_AJC=mod.AJC;
  bool modelPar_given_AJC=mod.given("AJC");
  modParamMap["AJC"] = &modelPar_AJC;
  AdmsSensFadType modelPar_CJCP=mod.CJCP;
  bool modelPar_given_CJCP=mod.given("CJCP");
  modParamMap["CJCP"] = &modelPar_CJCP;
  AdmsSensFadType modelPar_PS=mod.PS;
  bool modelPar_given_PS=mod.given("PS");
  modParamMap["PS"] = &modelPar_PS;
  AdmsSensFadType modelPar_MS=mod.MS;
  bool modelPar_given_MS=mod.given("MS");
  modParamMap["MS"] = &modelPar_MS;
  AdmsSensFadType modelPar_AJS=mod.AJS;
  bool modelPar_given_AJS=mod.given("AJS");
  modParamMap["AJS"] = &modelPar_AJS;
  AdmsSensFadType modelPar_IBEI=mod.IBEI;
  bool modelPar_given_IBEI=mod.given("IBEI");
  modParamMap["IBEI"] = &modelPar_IBEI;
  AdmsSensFadType modelPar_WBE=mod.WBE;
  bool modelPar_given_WBE=mod.given("WBE");
  modParamMap["WBE"] = &modelPar_WBE;
  AdmsSensFadType modelPar_NEI=mod.NEI;
  bool modelPar_given_NEI=mod.given("NEI");
  modParamMap["NEI"] = &modelPar_NEI;
  AdmsSensFadType modelPar_IBEN=mod.IBEN;
  bool modelPar_given_IBEN=mod.given("IBEN");
  modParamMap["IBEN"] = &modelPar_IBEN;
  AdmsSensFadType modelPar_NEN=mod.NEN;
  bool modelPar_given_NEN=mod.given("NEN");
  modParamMap["NEN"] = &modelPar_NEN;
  AdmsSensFadType modelPar_IBCI=mod.IBCI;
  bool modelPar_given_IBCI=mod.given("IBCI");
  modParamMap["IBCI"] = &modelPar_IBCI;
  AdmsSensFadType modelPar_NCI=mod.NCI;
  bool modelPar_given_NCI=mod.given("NCI");
  modParamMap["NCI"] = &modelPar_NCI;
  AdmsSensFadType modelPar_IBCN=mod.IBCN;
  bool modelPar_given_IBCN=mod.given("IBCN");
  modParamMap["IBCN"] = &modelPar_IBCN;
  AdmsSensFadType modelPar_NCN=mod.NCN;
  bool modelPar_given_NCN=mod.given("NCN");
  modParamMap["NCN"] = &modelPar_NCN;
  AdmsSensFadType modelPar_AVC1=mod.AVC1;
  bool modelPar_given_AVC1=mod.given("AVC1");
  modParamMap["AVC1"] = &modelPar_AVC1;
  AdmsSensFadType modelPar_AVC2=mod.AVC2;
  bool modelPar_given_AVC2=mod.given("AVC2");
  modParamMap["AVC2"] = &modelPar_AVC2;
  AdmsSensFadType modelPar_ISP=mod.ISP;
  bool modelPar_given_ISP=mod.given("ISP");
  modParamMap["ISP"] = &modelPar_ISP;
  AdmsSensFadType modelPar_WSP=mod.WSP;
  bool modelPar_given_WSP=mod.given("WSP");
  modParamMap["WSP"] = &modelPar_WSP;
  AdmsSensFadType modelPar_NFP=mod.NFP;
  bool modelPar_given_NFP=mod.given("NFP");
  modParamMap["NFP"] = &modelPar_NFP;
  AdmsSensFadType modelPar_IBEIP=mod.IBEIP;
  bool modelPar_given_IBEIP=mod.given("IBEIP");
  modParamMap["IBEIP"] = &modelPar_IBEIP;
  AdmsSensFadType modelPar_IBENP=mod.IBENP;
  bool modelPar_given_IBENP=mod.given("IBENP");
  modParamMap["IBENP"] = &modelPar_IBENP;
  AdmsSensFadType modelPar_IBCIP=mod.IBCIP;
  bool modelPar_given_IBCIP=mod.given("IBCIP");
  modParamMap["IBCIP"] = &modelPar_IBCIP;
  AdmsSensFadType modelPar_NCIP=mod.NCIP;
  bool modelPar_given_NCIP=mod.given("NCIP");
  modParamMap["NCIP"] = &modelPar_NCIP;
  AdmsSensFadType modelPar_IBCNP=mod.IBCNP;
  bool modelPar_given_IBCNP=mod.given("IBCNP");
  modParamMap["IBCNP"] = &modelPar_IBCNP;
  AdmsSensFadType modelPar_NCNP=mod.NCNP;
  bool modelPar_given_NCNP=mod.given("NCNP");
  modParamMap["NCNP"] = &modelPar_NCNP;
  AdmsSensFadType modelPar_VEF=mod.VEF;
  bool modelPar_given_VEF=mod.given("VEF");
  modParamMap["VEF"] = &modelPar_VEF;
  AdmsSensFadType modelPar_VER=mod.VER;
  bool modelPar_given_VER=mod.given("VER");
  modParamMap["VER"] = &modelPar_VER;
  AdmsSensFadType modelPar_IKF=mod.IKF;
  bool modelPar_given_IKF=mod.given("IKF");
  modParamMap["IKF"] = &modelPar_IKF;
  AdmsSensFadType modelPar_IKR=mod.IKR;
  bool modelPar_given_IKR=mod.given("IKR");
  modParamMap["IKR"] = &modelPar_IKR;
  AdmsSensFadType modelPar_IKP=mod.IKP;
  bool modelPar_given_IKP=mod.given("IKP");
  modParamMap["IKP"] = &modelPar_IKP;
  AdmsSensFadType modelPar_TF=mod.TF;
  bool modelPar_given_TF=mod.given("TF");
  modParamMap["TF"] = &modelPar_TF;
  AdmsSensFadType modelPar_QTF=mod.QTF;
  bool modelPar_given_QTF=mod.given("QTF");
  modParamMap["QTF"] = &modelPar_QTF;
  AdmsSensFadType modelPar_XTF=mod.XTF;
  bool modelPar_given_XTF=mod.given("XTF");
  modParamMap["XTF"] = &modelPar_XTF;
  AdmsSensFadType modelPar_VTF=mod.VTF;
  bool modelPar_given_VTF=mod.given("VTF");
  modParamMap["VTF"] = &modelPar_VTF;
  AdmsSensFadType modelPar_ITF=mod.ITF;
  bool modelPar_given_ITF=mod.given("ITF");
  modParamMap["ITF"] = &modelPar_ITF;
  AdmsSensFadType modelPar_TR=mod.TR;
  bool modelPar_given_TR=mod.given("TR");
  modParamMap["TR"] = &modelPar_TR;
  AdmsSensFadType modelPar_TD=mod.TD;
  bool modelPar_given_TD=mod.given("TD");
  modParamMap["TD"] = &modelPar_TD;
  AdmsSensFadType modelPar_KFN=mod.KFN;
  bool modelPar_given_KFN=mod.given("KFN");
  modParamMap["KFN"] = &modelPar_KFN;
  AdmsSensFadType modelPar_AFN=mod.AFN;
  bool modelPar_given_AFN=mod.given("AFN");
  modParamMap["AFN"] = &modelPar_AFN;
  AdmsSensFadType modelPar_BFN=mod.BFN;
  bool modelPar_given_BFN=mod.given("BFN");
  modParamMap["BFN"] = &modelPar_BFN;
  AdmsSensFadType modelPar_XRE=mod.XRE;
  bool modelPar_given_XRE=mod.given("XRE");
  modParamMap["XRE"] = &modelPar_XRE;
  AdmsSensFadType modelPar_XRBI=mod.XRBI;
  bool modelPar_given_XRBI=mod.given("XRBI");
  modParamMap["XRBI"] = &modelPar_XRBI;
  AdmsSensFadType modelPar_XRCI=mod.XRCI;
  bool modelPar_given_XRCI=mod.given("XRCI");
  modParamMap["XRCI"] = &modelPar_XRCI;
  AdmsSensFadType modelPar_XRS=mod.XRS;
  bool modelPar_given_XRS=mod.given("XRS");
  modParamMap["XRS"] = &modelPar_XRS;
  AdmsSensFadType modelPar_XVO=mod.XVO;
  bool modelPar_given_XVO=mod.given("XVO");
  modParamMap["XVO"] = &modelPar_XVO;
  AdmsSensFadType modelPar_EA=mod.EA;
  bool modelPar_given_EA=mod.given("EA");
  modParamMap["EA"] = &modelPar_EA;
  AdmsSensFadType modelPar_EAIE=mod.EAIE;
  bool modelPar_given_EAIE=mod.given("EAIE");
  modParamMap["EAIE"] = &modelPar_EAIE;
  AdmsSensFadType modelPar_EAIC=mod.EAIC;
  bool modelPar_given_EAIC=mod.given("EAIC");
  modParamMap["EAIC"] = &modelPar_EAIC;
  AdmsSensFadType modelPar_EAIS=mod.EAIS;
  bool modelPar_given_EAIS=mod.given("EAIS");
  modParamMap["EAIS"] = &modelPar_EAIS;
  AdmsSensFadType modelPar_EANE=mod.EANE;
  bool modelPar_given_EANE=mod.given("EANE");
  modParamMap["EANE"] = &modelPar_EANE;
  AdmsSensFadType modelPar_EANC=mod.EANC;
  bool modelPar_given_EANC=mod.given("EANC");
  modParamMap["EANC"] = &modelPar_EANC;
  AdmsSensFadType modelPar_EANS=mod.EANS;
  bool modelPar_given_EANS=mod.given("EANS");
  modParamMap["EANS"] = &modelPar_EANS;
  AdmsSensFadType modelPar_XIS=mod.XIS;
  bool modelPar_given_XIS=mod.given("XIS");
  modParamMap["XIS"] = &modelPar_XIS;
  AdmsSensFadType modelPar_XII=mod.XII;
  bool modelPar_given_XII=mod.given("XII");
  modParamMap["XII"] = &modelPar_XII;
  AdmsSensFadType modelPar_XIN=mod.XIN;
  bool modelPar_given_XIN=mod.given("XIN");
  modParamMap["XIN"] = &modelPar_XIN;
  AdmsSensFadType modelPar_TNF=mod.TNF;
  bool modelPar_given_TNF=mod.given("TNF");
  modParamMap["TNF"] = &modelPar_TNF;
  AdmsSensFadType modelPar_TAVC=mod.TAVC;
  bool modelPar_given_TAVC=mod.given("TAVC");
  modParamMap["TAVC"] = &modelPar_TAVC;
  AdmsSensFadType modelPar_RTH=mod.RTH;
  bool modelPar_given_RTH=mod.given("RTH");
  modParamMap["RTH"] = &modelPar_RTH;
  AdmsSensFadType modelPar_CTH=mod.CTH;
  bool modelPar_given_CTH=mod.given("CTH");
  modParamMap["CTH"] = &modelPar_CTH;
  AdmsSensFadType modelPar_VRT=mod.VRT;
  bool modelPar_given_VRT=mod.given("VRT");
  modParamMap["VRT"] = &modelPar_VRT;
  AdmsSensFadType modelPar_ART=mod.ART;
  bool modelPar_given_ART=mod.given("ART");
  modParamMap["ART"] = &modelPar_ART;
  AdmsSensFadType modelPar_CCSO=mod.CCSO;
  bool modelPar_given_CCSO=mod.given("CCSO");
  modParamMap["CCSO"] = &modelPar_CCSO;
  AdmsSensFadType modelPar_QBM=mod.QBM;
  bool modelPar_given_QBM=mod.given("QBM");
  modParamMap["QBM"] = &modelPar_QBM;
  AdmsSensFadType modelPar_NKF=mod.NKF;
  bool modelPar_given_NKF=mod.given("NKF");
  modParamMap["NKF"] = &modelPar_NKF;
  AdmsSensFadType modelPar_XIKF=mod.XIKF;
  bool modelPar_given_XIKF=mod.given("XIKF");
  modParamMap["XIKF"] = &modelPar_XIKF;
  AdmsSensFadType modelPar_XRCX=mod.XRCX;
  bool modelPar_given_XRCX=mod.given("XRCX");
  modParamMap["XRCX"] = &modelPar_XRCX;
  AdmsSensFadType modelPar_XRBX=mod.XRBX;
  bool modelPar_given_XRBX=mod.given("XRBX");
  modParamMap["XRBX"] = &modelPar_XRBX;
  AdmsSensFadType modelPar_XRBP=mod.XRBP;
  bool modelPar_given_XRBP=mod.given("XRBP");
  modParamMap["XRBP"] = &modelPar_XRBP;
  AdmsSensFadType modelPar_ISRR=mod.ISRR;
  bool modelPar_given_ISRR=mod.given("ISRR");
  modParamMap["ISRR"] = &modelPar_ISRR;
  AdmsSensFadType modelPar_XISR=mod.XISR;
  bool modelPar_given_XISR=mod.given("XISR");
  modParamMap["XISR"] = &modelPar_XISR;
  AdmsSensFadType modelPar_DEAR=mod.DEAR;
  bool modelPar_given_DEAR=mod.given("DEAR");
  modParamMap["DEAR"] = &modelPar_DEAR;
  AdmsSensFadType modelPar_EAP=mod.EAP;
  bool modelPar_given_EAP=mod.given("EAP");
  modParamMap["EAP"] = &modelPar_EAP;
  AdmsSensFadType modelPar_VBBE=mod.VBBE;
  bool modelPar_given_VBBE=mod.given("VBBE");
  modParamMap["VBBE"] = &modelPar_VBBE;
  AdmsSensFadType modelPar_NBBE=mod.NBBE;
  bool modelPar_given_NBBE=mod.given("NBBE");
  modParamMap["NBBE"] = &modelPar_NBBE;
  AdmsSensFadType modelPar_IBBE=mod.IBBE;
  bool modelPar_given_IBBE=mod.given("IBBE");
  modParamMap["IBBE"] = &modelPar_IBBE;
  AdmsSensFadType modelPar_TVBBE1=mod.TVBBE1;
  bool modelPar_given_TVBBE1=mod.given("TVBBE1");
  modParamMap["TVBBE1"] = &modelPar_TVBBE1;
  AdmsSensFadType modelPar_TVBBE2=mod.TVBBE2;
  bool modelPar_given_TVBBE2=mod.given("TVBBE2");
  modParamMap["TVBBE2"] = &modelPar_TVBBE2;
  AdmsSensFadType modelPar_TNBBE=mod.TNBBE;
  bool modelPar_given_TNBBE=mod.given("TNBBE");
  modParamMap["TNBBE"] = &modelPar_TNBBE;
  AdmsSensFadType modelPar_EBBE=mod.EBBE;
  bool modelPar_given_EBBE=mod.given("EBBE");
  modParamMap["EBBE"] = &modelPar_EBBE;
  AdmsSensFadType modelPar_DTEMP=mod.DTEMP;
  bool modelPar_given_DTEMP=mod.given("DTEMP");
  modParamMap["DTEMP"] = &modelPar_DTEMP;
  AdmsSensFadType modelPar_VERS=mod.VERS;
  bool modelPar_given_VERS=mod.given("VERS");
  modParamMap["VERS"] = &modelPar_VERS;
  AdmsSensFadType modelPar_VREV=mod.VREV;
  bool modelPar_given_VREV=mod.given("VREV");
  modParamMap["VREV"] = &modelPar_VREV;


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_dtype=mod.dtype;


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check name for presence first!  Segfault on invalid.
  modParamMap[name]->diff(0,1);

  //make local copies of all model vars
  //reals


  // non-reals



  // Now loop over all instances and do the deed
  int inst=0;
  for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
  {

    Instance & in=*(*in_it);
    // initialize contributions to zero (automatically sets derivatives to zero)
    for (int i=0; i < 10+0 ; ++i)
    {
      staticContributions[i]=0;
      dynamicContributions[i]=0;
    }



    // Copy out all the instance parameters (doubles) into FAD types
    // reals
    AdmsSensFadType instancePar_DTEMP=in.DTEMP;
    bool instancePar_given_DTEMP=in.given("DTEMP");


    // real hidden instance


    // Copy all the non-real instance params into vars of their appropriate type:
    int instancePar_M=in.M;
    bool instancePar_given_M=in.given("M");




    // If there are any instance parameters that were not given, and have
    // corresponding model params, copy the model param into the instance.
    // This was already done by the instance constructor, but we do it again
    // because now we're propagating derivatives, and the user could be trying
    // to get sensitivity to the model parameter.
    if (!(in.given("DTEMP")))
    {
      instancePar_DTEMP = modelPar_DTEMP;
    }


    //make local copies of all instance vars
    //reals
  
  
    //non-reals
  
  
  
    Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

    // extract solution variables and set as Fad independent variables.
    probeVars[in.admsProbeID_V_ci_ei] = (*solVectorPtr)[in.li_ci] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_V_b_c] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_c];
    probeVars[in.admsProbeID_V_bp_cx] = (*solVectorPtr)[in.li_bp] - (*solVectorPtr)[in.li_cx];
    probeVars[in.admsProbeID_V_e_ei] = (*solVectorPtr)[in.li_e] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_V_b_bx] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_bx];
    probeVars[in.admsProbeID_V_bx_bi] = (*solVectorPtr)[in.li_bx] - (*solVectorPtr)[in.li_bi];
    probeVars[in.admsProbeID_V_cx_ci] = (*solVectorPtr)[in.li_cx] - (*solVectorPtr)[in.li_ci];
    probeVars[in.admsProbeID_V_c_cx] = (*solVectorPtr)[in.li_c] - (*solVectorPtr)[in.li_cx];
    probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_e];
    probeVars[in.admsProbeID_V_dt_GND] = (*solVectorPtr)[in.li_dt];
    probeVars[in.admsProbeID_V_bx_bp] = (*solVectorPtr)[in.li_bx] - (*solVectorPtr)[in.li_bp];
    probeVars[in.admsProbeID_V_bi_cx] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_cx];
    probeVars[in.admsProbeID_V_bx_ei] = (*solVectorPtr)[in.li_bx] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_V_bi_ci] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_ci];
    probeVars[in.admsProbeID_V_bi_ei] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_ei];

    
    // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
    probeVars[in.admsProbeID_V_b_e] *= modelPar_dtype;
    probeVars[in.admsProbeID_V_bx_bp] *= modelPar_dtype;
    probeVars[in.admsProbeID_V_bi_cx] *= modelPar_dtype;
    probeVars[in.admsProbeID_V_bx_ei] *= modelPar_dtype;
    probeVars[in.admsProbeID_V_bi_ci] *= modelPar_dtype;
    probeVars[in.admsProbeID_V_bi_ei] *= modelPar_dtype;




    // Now call  the function that does the heavy lifting.

    evaluateModelEquations(
       probeVars,
       // probe constants
       in.admsProbeID_V_ci_ei,
       in.admsProbeID_V_b_c,
       in.admsProbeID_V_bp_cx,
       in.admsProbeID_V_e_ei,
       in.admsProbeID_V_b_bx,
       in.admsProbeID_V_bx_bi,
       in.admsProbeID_V_cx_ci,
       in.admsProbeID_V_c_cx,
       in.admsProbeID_V_b_e,
       in.admsProbeID_V_dt_GND,
       in.admsProbeID_V_bx_bp,
       in.admsProbeID_V_bi_cx,
       in.admsProbeID_V_bx_ei,
       in.admsProbeID_V_bi_ci,
       in.admsProbeID_V_bi_ei,

       // node constants
       in.admsNodeID_c,
       in.admsNodeID_b,
       in.admsNodeID_e,
       in.admsNodeID_dt,
       in.admsNodeID_cx,
       in.admsNodeID_ci,
       in.admsNodeID_bx,
       in.admsNodeID_bi,
       in.admsNodeID_ei,
       in.admsNodeID_bp,
       // instance parameters
       // reals
       instancePar_DTEMP,
       instancePar_given_DTEMP,
       // non-reals(including hidden)
       instancePar_M,
       instancePar_given_M,
       // model parameters
       // reals
       modelPar_TNOM,
       modelPar_given_TNOM,
       modelPar_RCX,
       modelPar_given_RCX,
       modelPar_RCI,
       modelPar_given_RCI,
       modelPar_VO,
       modelPar_given_VO,
       modelPar_GAMM,
       modelPar_given_GAMM,
       modelPar_HRCF,
       modelPar_given_HRCF,
       modelPar_RBX,
       modelPar_given_RBX,
       modelPar_RBI,
       modelPar_given_RBI,
       modelPar_RE,
       modelPar_given_RE,
       modelPar_RS,
       modelPar_given_RS,
       modelPar_RBP,
       modelPar_given_RBP,
       modelPar_IS,
       modelPar_given_IS,
       modelPar_NF,
       modelPar_given_NF,
       modelPar_NR,
       modelPar_given_NR,
       modelPar_FC,
       modelPar_given_FC,
       modelPar_CBEO,
       modelPar_given_CBEO,
       modelPar_CJE,
       modelPar_given_CJE,
       modelPar_PE,
       modelPar_given_PE,
       modelPar_ME,
       modelPar_given_ME,
       modelPar_AJE,
       modelPar_given_AJE,
       modelPar_CBCO,
       modelPar_given_CBCO,
       modelPar_CJC,
       modelPar_given_CJC,
       modelPar_QCO,
       modelPar_given_QCO,
       modelPar_CJEP,
       modelPar_given_CJEP,
       modelPar_PC,
       modelPar_given_PC,
       modelPar_MC,
       modelPar_given_MC,
       modelPar_AJC,
       modelPar_given_AJC,
       modelPar_CJCP,
       modelPar_given_CJCP,
       modelPar_PS,
       modelPar_given_PS,
       modelPar_MS,
       modelPar_given_MS,
       modelPar_AJS,
       modelPar_given_AJS,
       modelPar_IBEI,
       modelPar_given_IBEI,
       modelPar_WBE,
       modelPar_given_WBE,
       modelPar_NEI,
       modelPar_given_NEI,
       modelPar_IBEN,
       modelPar_given_IBEN,
       modelPar_NEN,
       modelPar_given_NEN,
       modelPar_IBCI,
       modelPar_given_IBCI,
       modelPar_NCI,
       modelPar_given_NCI,
       modelPar_IBCN,
       modelPar_given_IBCN,
       modelPar_NCN,
       modelPar_given_NCN,
       modelPar_AVC1,
       modelPar_given_AVC1,
       modelPar_AVC2,
       modelPar_given_AVC2,
       modelPar_ISP,
       modelPar_given_ISP,
       modelPar_WSP,
       modelPar_given_WSP,
       modelPar_NFP,
       modelPar_given_NFP,
       modelPar_IBEIP,
       modelPar_given_IBEIP,
       modelPar_IBENP,
       modelPar_given_IBENP,
       modelPar_IBCIP,
       modelPar_given_IBCIP,
       modelPar_NCIP,
       modelPar_given_NCIP,
       modelPar_IBCNP,
       modelPar_given_IBCNP,
       modelPar_NCNP,
       modelPar_given_NCNP,
       modelPar_VEF,
       modelPar_given_VEF,
       modelPar_VER,
       modelPar_given_VER,
       modelPar_IKF,
       modelPar_given_IKF,
       modelPar_IKR,
       modelPar_given_IKR,
       modelPar_IKP,
       modelPar_given_IKP,
       modelPar_TF,
       modelPar_given_TF,
       modelPar_QTF,
       modelPar_given_QTF,
       modelPar_XTF,
       modelPar_given_XTF,
       modelPar_VTF,
       modelPar_given_VTF,
       modelPar_ITF,
       modelPar_given_ITF,
       modelPar_TR,
       modelPar_given_TR,
       modelPar_TD,
       modelPar_given_TD,
       modelPar_KFN,
       modelPar_given_KFN,
       modelPar_AFN,
       modelPar_given_AFN,
       modelPar_BFN,
       modelPar_given_BFN,
       modelPar_XRE,
       modelPar_given_XRE,
       modelPar_XRBI,
       modelPar_given_XRBI,
       modelPar_XRCI,
       modelPar_given_XRCI,
       modelPar_XRS,
       modelPar_given_XRS,
       modelPar_XVO,
       modelPar_given_XVO,
       modelPar_EA,
       modelPar_given_EA,
       modelPar_EAIE,
       modelPar_given_EAIE,
       modelPar_EAIC,
       modelPar_given_EAIC,
       modelPar_EAIS,
       modelPar_given_EAIS,
       modelPar_EANE,
       modelPar_given_EANE,
       modelPar_EANC,
       modelPar_given_EANC,
       modelPar_EANS,
       modelPar_given_EANS,
       modelPar_XIS,
       modelPar_given_XIS,
       modelPar_XII,
       modelPar_given_XII,
       modelPar_XIN,
       modelPar_given_XIN,
       modelPar_TNF,
       modelPar_given_TNF,
       modelPar_TAVC,
       modelPar_given_TAVC,
       modelPar_RTH,
       modelPar_given_RTH,
       modelPar_CTH,
       modelPar_given_CTH,
       modelPar_VRT,
       modelPar_given_VRT,
       modelPar_ART,
       modelPar_given_ART,
       modelPar_CCSO,
       modelPar_given_CCSO,
       modelPar_QBM,
       modelPar_given_QBM,
       modelPar_NKF,
       modelPar_given_NKF,
       modelPar_XIKF,
       modelPar_given_XIKF,
       modelPar_XRCX,
       modelPar_given_XRCX,
       modelPar_XRBX,
       modelPar_given_XRBX,
       modelPar_XRBP,
       modelPar_given_XRBP,
       modelPar_ISRR,
       modelPar_given_ISRR,
       modelPar_XISR,
       modelPar_given_XISR,
       modelPar_DEAR,
       modelPar_given_DEAR,
       modelPar_EAP,
       modelPar_given_EAP,
       modelPar_VBBE,
       modelPar_given_VBBE,
       modelPar_NBBE,
       modelPar_given_NBBE,
       modelPar_IBBE,
       modelPar_given_IBBE,
       modelPar_TVBBE1,
       modelPar_given_TVBBE1,
       modelPar_TVBBE2,
       modelPar_given_TVBBE2,
       modelPar_TNBBE,
       modelPar_given_TNBBE,
       modelPar_EBBE,
       modelPar_given_EBBE,
       modelPar_DTEMP,
       modelPar_given_DTEMP,
       modelPar_VERS,
       modelPar_given_VERS,
       modelPar_VREV,
       modelPar_given_VREV,
       // non-reals (including hidden)
       modelPar_dtype,
       in.admsTemperature,
       in.adms_vt_nom,
       in.getDeviceOptions().gmin,
       staticContributions,
       dynamicContributions,
       in);

  
    // We now have the F and Q vector stuff, populate the dependencies:
  
    dfdp[in.admsNodeID_c+inst*(10+0)] += staticContributions[in.admsNodeID_c].dx(0);
    dqdp[in.admsNodeID_c+inst*(10+0)] += dynamicContributions[in.admsNodeID_c].dx(0);
    Findices[in.admsNodeID_c+inst*(10+0)] = in.li_c;
    Qindices[in.admsNodeID_c+inst*(10+0)] = in.li_c;
    dfdp[in.admsNodeID_b+inst*(10+0)] += staticContributions[in.admsNodeID_b].dx(0);
    dqdp[in.admsNodeID_b+inst*(10+0)] += dynamicContributions[in.admsNodeID_b].dx(0);
    Findices[in.admsNodeID_b+inst*(10+0)] = in.li_b;
    Qindices[in.admsNodeID_b+inst*(10+0)] = in.li_b;
    dfdp[in.admsNodeID_e+inst*(10+0)] += staticContributions[in.admsNodeID_e].dx(0);
    dqdp[in.admsNodeID_e+inst*(10+0)] += dynamicContributions[in.admsNodeID_e].dx(0);
    Findices[in.admsNodeID_e+inst*(10+0)] = in.li_e;
    Qindices[in.admsNodeID_e+inst*(10+0)] = in.li_e;
    dfdp[in.admsNodeID_dt+inst*(10+0)] += staticContributions[in.admsNodeID_dt].dx(0);
    dqdp[in.admsNodeID_dt+inst*(10+0)] += dynamicContributions[in.admsNodeID_dt].dx(0);
    Findices[in.admsNodeID_dt+inst*(10+0)] = in.li_dt;
    Qindices[in.admsNodeID_dt+inst*(10+0)] = in.li_dt;
    dfdp[in.admsNodeID_cx+inst*(10+0)] += staticContributions[in.admsNodeID_cx].dx(0);
    dqdp[in.admsNodeID_cx+inst*(10+0)] += dynamicContributions[in.admsNodeID_cx].dx(0);
    Findices[in.admsNodeID_cx+inst*(10+0)] = in.li_cx;
    Qindices[in.admsNodeID_cx+inst*(10+0)] = in.li_cx;
    dfdp[in.admsNodeID_ci+inst*(10+0)] += staticContributions[in.admsNodeID_ci].dx(0);
    dqdp[in.admsNodeID_ci+inst*(10+0)] += dynamicContributions[in.admsNodeID_ci].dx(0);
    Findices[in.admsNodeID_ci+inst*(10+0)] = in.li_ci;
    Qindices[in.admsNodeID_ci+inst*(10+0)] = in.li_ci;
    dfdp[in.admsNodeID_bx+inst*(10+0)] += staticContributions[in.admsNodeID_bx].dx(0);
    dqdp[in.admsNodeID_bx+inst*(10+0)] += dynamicContributions[in.admsNodeID_bx].dx(0);
    Findices[in.admsNodeID_bx+inst*(10+0)] = in.li_bx;
    Qindices[in.admsNodeID_bx+inst*(10+0)] = in.li_bx;
    dfdp[in.admsNodeID_bi+inst*(10+0)] += staticContributions[in.admsNodeID_bi].dx(0);
    dqdp[in.admsNodeID_bi+inst*(10+0)] += dynamicContributions[in.admsNodeID_bi].dx(0);
    Findices[in.admsNodeID_bi+inst*(10+0)] = in.li_bi;
    Qindices[in.admsNodeID_bi+inst*(10+0)] = in.li_bi;
    dfdp[in.admsNodeID_ei+inst*(10+0)] += staticContributions[in.admsNodeID_ei].dx(0);
    dqdp[in.admsNodeID_ei+inst*(10+0)] += dynamicContributions[in.admsNodeID_ei].dx(0);
    Findices[in.admsNodeID_ei+inst*(10+0)] = in.li_ei;
    Qindices[in.admsNodeID_ei+inst*(10+0)] = in.li_ei;
    dfdp[in.admsNodeID_bp+inst*(10+0)] += staticContributions[in.admsNodeID_bp].dx(0);
    dqdp[in.admsNodeID_bp+inst*(10+0)] += dynamicContributions[in.admsNodeID_bp].dx(0);
    Findices[in.admsNodeID_bp+inst*(10+0)] = in.li_bp;
    Qindices[in.admsNodeID_bp+inst*(10+0)] = in.li_bp;
  }

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSvbic
} // namespace Device
} // namespace Xyce
